(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.igv_webapp = {}));
})(this, (function (exports) { 'use strict';

  /*!
   * jQuery JavaScript Library v3.3.1 -ajax,-ajax/jsonp,-ajax/load,-ajax/parseXML,-ajax/script,-ajax/var/location,-ajax/var/nonce,-ajax/var/rquery,-ajax/xhr,-manipulation/_evalUrl,-event/ajax,-effects,-effects/Tween,-effects/animatedSelector
   * https://jquery.com/
   *
   * Includes Sizzle.js
   * https://sizzlejs.com/
   *
   * Copyright JS Foundation and other contributors
   * Released under the MIT license
   * https://jquery.org/license
   *
   * Date: 2018-01-20T17:24Z
   */

  var arr = [];

  var document$1 = window.document;

  var getProto = Object.getPrototypeOf;

  var slice = arr.slice;

  var concat = arr.concat;

  var push = arr.push;

  var indexOf = arr.indexOf;

  var class2type = {};

  var toString$3 = class2type.toString;

  var hasOwn = class2type.hasOwnProperty;

  var fnToString = hasOwn.toString;

  var ObjectFunctionString = fnToString.call(Object);

  var support = {};

  var isFunction = function isFunction(obj) {

      // Support: Chrome <=57, Firefox <=52
      // In some browsers, typeof returns "function" for HTML <object> elements
      // (i.e., `typeof document.createElement( "object" ) === "function"`).
      // We don't want to classify *any* DOM node as a function.
      return typeof obj === "function" && typeof obj.nodeType !== "number";
  };


  var isWindow = function isWindow(obj) {
      return obj != null && obj === obj.window;
  };


  var preservedScriptAttributes = {
      type: true,
      src: true,
      noModule: true
  };

  function DOMEval(code, doc, node) {
      doc = doc || document$1;

      var i,
          script = doc.createElement("script");

      script.text = code;
      if (node) {
          for (i in preservedScriptAttributes) {
              if (node[i]) {
                  script[i] = node[i];
              }
          }
      }
      doc.head.appendChild(script).parentNode.removeChild(script);
  }


  function toType(obj) {
      if (obj == null) {
          return obj + "";
      }

      // Support: Android <=2.3 only (functionish RegExp)
      return typeof obj === "object" || typeof obj === "function" ?
          class2type[toString$3.call(obj)] || "object" :
          typeof obj;
  }

  // global Symbol
  // Defining this global in .eslintrc.json would create a danger of using the global
  // unguarded in another place, it seems safer to define global only for this module


  var
      version$1 = "3.3.1 -ajax,-ajax/jsonp,-ajax/load,-ajax/parseXML,-ajax/script,-ajax/var/location,-ajax/var/nonce,-ajax/var/rquery,-ajax/xhr,-manipulation/_evalUrl,-event/ajax,-effects,-effects/Tween,-effects/animatedSelector",

      // Define a local copy of jQuery
      jQuery = function (selector, context) {

          // The jQuery object is actually just the init constructor 'enhanced'
          // Need init if jQuery is called (just allow error to be thrown if not included)
          return new jQuery.fn.init(selector, context);
      },

      // Support: Android <=4.0 only
      // Make sure we trim BOM and NBSP
      rtrim = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g;

  jQuery.fn = jQuery.prototype = {

      // The current version of jQuery being used
      jquery: version$1,

      constructor: jQuery,

      // The default length of a jQuery object is 0
      length: 0,

      toArray: function () {
          return slice.call(this);
      },

      // Get the Nth element in the matched element set OR
      // Get the whole matched element set as a clean array
      get: function (num) {

          // Return all the elements in a clean array
          if (num == null) {
              return slice.call(this);
          }

          // Return just the one element from the set
          return num < 0 ? this[num + this.length] : this[num];
      },

      // Take an array of elements and push it onto the stack
      // (returning the new matched element set)
      pushStack: function (elems) {

          // Build a new jQuery matched element set
          var ret = jQuery.merge(this.constructor(), elems);

          // Add the old object onto the stack (as a reference)
          ret.prevObject = this;

          // Return the newly-formed element set
          return ret;
      },

      // Execute a callback for every element in the matched set.
      each: function (callback) {
          return jQuery.each(this, callback);
      },

      map: function (callback) {
          return this.pushStack(jQuery.map(this, function (elem, i) {
              return callback.call(elem, i, elem);
          }));
      },

      slice: function () {
          return this.pushStack(slice.apply(this, arguments));
      },

      first: function () {
          return this.eq(0);
      },

      last: function () {
          return this.eq(-1);
      },

      eq: function (i) {
          var len = this.length,
              j = +i + (i < 0 ? len : 0);
          return this.pushStack(j >= 0 && j < len ? [this[j]] : []);
      },

      end: function () {
          return this.prevObject || this.constructor();
      },

      // For internal use only.
      // Behaves like an Array's method, not like a jQuery method.
      push: push,
      sort: arr.sort,
      splice: arr.splice
  };

  jQuery.extend = jQuery.fn.extend = function () {
      var options, name, src, copy, copyIsArray, clone,
          target = arguments[0] || {},
          i = 1,
          length = arguments.length,
          deep = false;

      // Handle a deep copy situation
      if (typeof target === "boolean") {
          deep = target;

          // Skip the boolean and the target
          target = arguments[i] || {};
          i++;
      }

      // Handle case when target is a string or something (possible in deep copy)
      if (typeof target !== "object" && !isFunction(target)) {
          target = {};
      }

      // Extend jQuery itself if only one argument is passed
      if (i === length) {
          target = this;
          i--;
      }

      for (; i < length; i++) {

          // Only deal with non-null/undefined values
          if ((options = arguments[i]) != null) {

              // Extend the base object
              for (name in options) {
                  src = target[name];
                  copy = options[name];

                  // Prevent never-ending loop
                  if (target === copy) {
                      continue;
                  }

                  // Recurse if we're merging plain objects or arrays
                  if (deep && copy && (jQuery.isPlainObject(copy) ||
                      (copyIsArray = Array.isArray(copy)))) {

                      if (copyIsArray) {
                          copyIsArray = false;
                          clone = src && Array.isArray(src) ? src : [];

                      } else {
                          clone = src && jQuery.isPlainObject(src) ? src : {};
                      }

                      // Never move original objects, clone them
                      target[name] = jQuery.extend(deep, clone, copy);

                      // Don't bring in undefined values
                  } else if (copy !== undefined) {
                      target[name] = copy;
                  }
              }
          }
      }

      // Return the modified object
      return target;
  };

  jQuery.extend({

      // Unique for each copy of jQuery on the page
      expando: "jQuery" + (version$1 + Math.random()).replace(/\D/g, ""),

      // Assume jQuery is ready without the ready module
      isReady: true,

      error: function (msg) {
          throw new Error(msg);
      },

      noop: function () {
      },

      isPlainObject: function (obj) {
          var proto, Ctor;

          // Detect obvious negatives
          // Use toString instead of jQuery.type to catch host objects
          if (!obj || toString$3.call(obj) !== "[object Object]") {
              return false;
          }

          proto = getProto(obj);

          // Objects with no prototype (e.g., `Object.create( null )`) are plain
          if (!proto) {
              return true;
          }

          // Objects with prototype are plain iff they were constructed by a global Object function
          Ctor = hasOwn.call(proto, "constructor") && proto.constructor;
          return typeof Ctor === "function" && fnToString.call(Ctor) === ObjectFunctionString;
      },

      isEmptyObject: function (obj) {

          /* eslint-disable no-unused-vars */
          // See https://github.com/eslint/eslint/issues/6125
          var name;

          for (name in obj) {
              return false;
          }
          return true;
      },

      // Evaluates a script in a global context
      globalEval: function (code) {
          DOMEval(code);
      },

      each: function (obj, callback) {
          var length, i = 0;

          if (isArrayLike(obj)) {
              length = obj.length;
              for (; i < length; i++) {
                  if (callback.call(obj[i], i, obj[i]) === false) {
                      break;
                  }
              }
          } else {
              for (i in obj) {
                  if (callback.call(obj[i], i, obj[i]) === false) {
                      break;
                  }
              }
          }

          return obj;
      },

      // Support: Android <=4.0 only
      trim: function (text) {
          return text == null ?
              "" :
              (text + "").replace(rtrim, "");
      },

      // results is for internal usage only
      makeArray: function (arr, results) {
          var ret = results || [];

          if (arr != null) {
              if (isArrayLike(Object(arr))) {
                  jQuery.merge(ret,
                      typeof arr === "string" ?
                          [arr] : arr
                  );
              } else {
                  push.call(ret, arr);
              }
          }

          return ret;
      },

      inArray: function (elem, arr, i) {
          return arr == null ? -1 : indexOf.call(arr, elem, i);
      },

      // Support: Android <=4.0 only, PhantomJS 1 only
      // push.apply(_, arraylike) throws on ancient WebKit
      merge: function (first, second) {
          var len = +second.length,
              j = 0,
              i = first.length;

          for (; j < len; j++) {
              first[i++] = second[j];
          }

          first.length = i;

          return first;
      },

      grep: function (elems, callback, invert) {
          var callbackInverse,
              matches = [],
              i = 0,
              length = elems.length,
              callbackExpect = !invert;

          // Go through the array, only saving the items
          // that pass the validator function
          for (; i < length; i++) {
              callbackInverse = !callback(elems[i], i);
              if (callbackInverse !== callbackExpect) {
                  matches.push(elems[i]);
              }
          }

          return matches;
      },

      // arg is for internal usage only
      map: function (elems, callback, arg) {
          var length, value,
              i = 0,
              ret = [];

          // Go through the array, translating each of the items to their new values
          if (isArrayLike(elems)) {
              length = elems.length;
              for (; i < length; i++) {
                  value = callback(elems[i], i, arg);

                  if (value != null) {
                      ret.push(value);
                  }
              }

              // Go through every key on the object,
          } else {
              for (i in elems) {
                  value = callback(elems[i], i, arg);

                  if (value != null) {
                      ret.push(value);
                  }
              }
          }

          // Flatten any nested arrays
          return concat.apply([], ret);
      },

      // A global GUID counter for objects
      guid: 1,

      // jQuery.support is not used in Core but other projects attach their
      // properties to it so it needs to exist.
      support: support
  });

  if (typeof Symbol === "function") {
      jQuery.fn[Symbol.iterator] = arr[Symbol.iterator];
  }

  // Populate the class2type map
  jQuery.each("Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "),
      function (i, name) {
          class2type["[object " + name + "]"] = name.toLowerCase();
      });

  function isArrayLike(obj) {

      // Support: real iOS 8.2 only (not reproducible in simulator)
      // `in` check used to prevent JIT error (gh-2145)
      // hasOwn isn't used here due to false negatives
      // regarding Nodelist length in IE
      var length = !!obj && "length" in obj && obj.length,
          type = toType(obj);

      if (isFunction(obj) || isWindow(obj)) {
          return false;
      }

      return type === "array" || length === 0 ||
          typeof length === "number" && length > 0 && (length - 1) in obj;
  }

  var Sizzle =
      /*!
   * Sizzle CSS Selector Engine v2.3.3
   * https://sizzlejs.com/
   *
   * Copyright jQuery Foundation and other contributors
   * Released under the MIT license
   * http://jquery.org/license
   *
   * Date: 2016-08-08
   */
      (function (window) {

          var i,
              support,
              Expr,
              getText,
              isXML,
              tokenize,
              compile,
              select,
              outermostContext,
              sortInput,
              hasDuplicate,

              // Local document vars
              setDocument,
              document,
              docElem,
              documentIsHTML,
              rbuggyQSA,
              rbuggyMatches,
              matches,
              contains,

              // Instance-specific data
              expando = "sizzle" + 1 * new Date(),
              preferredDoc = window.document,
              dirruns = 0,
              done = 0,
              classCache = createCache(),
              tokenCache = createCache(),
              compilerCache = createCache(),
              sortOrder = function (a, b) {
                  if (a === b) {
                      hasDuplicate = true;
                  }
                  return 0;
              },

              // Instance methods
              hasOwn = ({}).hasOwnProperty,
              arr = [],
              pop = arr.pop,
              push_native = arr.push,
              push = arr.push,
              slice = arr.slice,
              // Use a stripped-down indexOf as it's faster than native
              // https://jsperf.com/thor-indexof-vs-for/5
              indexOf = function (list, elem) {
                  var i = 0,
                      len = list.length;
                  for (; i < len; i++) {
                      if (list[i] === elem) {
                          return i;
                      }
                  }
                  return -1;
              },

              booleans = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",

              // Regular expressions

              // http://www.w3.org/TR/css3-selectors/#whitespace
              whitespace = "[\\x20\\t\\r\\n\\f]",

              // http://www.w3.org/TR/CSS21/syndata.html#value-def-identifier
              identifier = "(?:\\\\.|[\\w-]|[^\0-\\xa0])+",

              // Attribute selectors: http://www.w3.org/TR/selectors/#attribute-selectors
              attributes = "\\[" + whitespace + "*(" + identifier + ")(?:" + whitespace +
                  // Operator (capture 2)
                  "*([*^$|!~]?=)" + whitespace +
                  // "Attribute values must be CSS identifiers [capture 5] or strings [capture 3 or capture 4]"
                  "*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|(" + identifier + "))|)" + whitespace +
                  "*\\]",

              pseudos = ":(" + identifier + ")(?:\\((" +
                  // To reduce the number of selectors needing tokenize in the preFilter, prefer arguments:
                  // 1. quoted (capture 3; capture 4 or capture 5)
                  "('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|" +
                  // 2. simple (capture 6)
                  "((?:\\\\.|[^\\\\()[\\]]|" + attributes + ")*)|" +
                  // 3. anything else (capture 2)
                  ".*" +
                  ")\\)|)",

              // Leading and non-escaped trailing whitespace, capturing some non-whitespace characters preceding the latter
              rwhitespace = new RegExp(whitespace + "+", "g"),
              rtrim = new RegExp("^" + whitespace + "+|((?:^|[^\\\\])(?:\\\\.)*)" + whitespace + "+$", "g"),

              rcomma = new RegExp("^" + whitespace + "*," + whitespace + "*"),
              rcombinators = new RegExp("^" + whitespace + "*([>+~]|" + whitespace + ")" + whitespace + "*"),

              rattributeQuotes = new RegExp("=" + whitespace + "*([^\\]'\"]*?)" + whitespace + "*\\]", "g"),

              rpseudo = new RegExp(pseudos),
              ridentifier = new RegExp("^" + identifier + "$"),

              matchExpr = {
                  "ID": new RegExp("^#(" + identifier + ")"),
                  "CLASS": new RegExp("^\\.(" + identifier + ")"),
                  "TAG": new RegExp("^(" + identifier + "|[*])"),
                  "ATTR": new RegExp("^" + attributes),
                  "PSEUDO": new RegExp("^" + pseudos),
                  "CHILD": new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + whitespace +
                      "*(even|odd|(([+-]|)(\\d*)n|)" + whitespace + "*(?:([+-]|)" + whitespace +
                      "*(\\d+)|))" + whitespace + "*\\)|)", "i"),
                  "bool": new RegExp("^(?:" + booleans + ")$", "i"),
                  // For use in libraries implementing .is()
                  // We use this for POS matching in `select`
                  "needsContext": new RegExp("^" + whitespace + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" +
                      whitespace + "*((?:-\\d)?\\d*)" + whitespace + "*\\)|)(?=[^-]|$)", "i")
              },

              rinputs = /^(?:input|select|textarea|button)$/i,
              rheader = /^h\d$/i,

              rnative = /^[^{]+\{\s*\[native \w/,

              // Easily-parseable/retrievable ID or TAG or CLASS selectors
              rquickExpr = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,

              rsibling = /[+~]/,

              // CSS escapes
              // http://www.w3.org/TR/CSS21/syndata.html#escaped-characters
              runescape = new RegExp("\\\\([\\da-f]{1,6}" + whitespace + "?|(" + whitespace + ")|.)", "ig"),
              funescape = function (_, escaped, escapedWhitespace) {
                  var high = "0x" + escaped - 0x10000;
                  // NaN means non-codepoint
                  // Support: Firefox<24
                  // Workaround erroneous numeric interpretation of +"0x"
                  return high !== high || escapedWhitespace ?
                      escaped :
                      high < 0 ?
                          // BMP codepoint
                          String.fromCharCode(high + 0x10000) :
                          // Supplemental Plane codepoint (surrogate pair)
                          String.fromCharCode(high >> 10 | 0xD800, high & 0x3FF | 0xDC00);
              },

              // CSS string/identifier serialization
              // https://drafts.csswg.org/cssom/#common-serializing-idioms
              // eslint-disable-next-line no-control-regex
              rcssescape = /([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g,
              fcssescape = function (ch, asCodePoint) {
                  if (asCodePoint) {

                      // U+0000 NULL becomes U+FFFD REPLACEMENT CHARACTER
                      if (ch === "\0") {
                          return "\uFFFD";
                      }

                      // Control characters and (dependent upon position) numbers get escaped as code points
                      return ch.slice(0, -1) + "\\" + ch.charCodeAt(ch.length - 1).toString(16) + " ";
                  }

                  // Other potentially-special ASCII characters get backslash-escaped
                  return "\\" + ch;
              },

              // Used for iframes
              // See setDocument()
              // Removing the function wrapper causes a "Permission Denied"
              // error in IE
              unloadHandler = function () {
                  setDocument();
              },

              disabledAncestor = addCombinator(
                  function (elem) {
                      return elem.disabled === true && ("form" in elem || "label" in elem);
                  },
                  {dir: "parentNode", next: "legend"}
              );

  // Optimize for push.apply( _, NodeList )
          try {
              push.apply(
                  (arr = slice.call(preferredDoc.childNodes)),
                  preferredDoc.childNodes
              );
              // Support: Android<4.0
              // Detect silently failing push.apply
              arr[preferredDoc.childNodes.length].nodeType;
          } catch (e) {
              push = {
                  apply: arr.length ?

                      // Leverage slice if possible
                      function (target, els) {
                          push_native.apply(target, slice.call(els));
                      } :

                      // Support: IE<9
                      // Otherwise append directly
                      function (target, els) {
                          var j = target.length,
                              i = 0;
                          // Can't trust NodeList.length
                          while ((target[j++] = els[i++])) {
                          }
                          target.length = j - 1;
                      }
              };
          }

          function Sizzle(selector, context, results, seed) {
              var m, i, elem, nid, match, groups, newSelector,
                  newContext = context && context.ownerDocument,

                  // nodeType defaults to 9, since context defaults to document
                  nodeType = context ? context.nodeType : 9;

              results = results || [];

              // Return early from calls with invalid selector or context
              if (typeof selector !== "string" || !selector ||
                  nodeType !== 1 && nodeType !== 9 && nodeType !== 11) {

                  return results;
              }

              // Try to shortcut find operations (as opposed to filters) in HTML documents
              if (!seed) {

                  if ((context ? context.ownerDocument || context : preferredDoc) !== document) {
                      setDocument(context);
                  }
                  context = context || document;

                  if (documentIsHTML) {

                      // If the selector is sufficiently simple, try using a "get*By*" DOM method
                      // (excepting DocumentFragment context, where the methods don't exist)
                      if (nodeType !== 11 && (match = rquickExpr.exec(selector))) {

                          // ID selector
                          if ((m = match[1])) {

                              // Document context
                              if (nodeType === 9) {
                                  if ((elem = context.getElementById(m))) {

                                      // Support: IE, Opera, Webkit
                                      // TODO: identify versions
                                      // getElementById can match elements by name instead of ID
                                      if (elem.id === m) {
                                          results.push(elem);
                                          return results;
                                      }
                                  } else {
                                      return results;
                                  }

                                  // Element context
                              } else {

                                  // Support: IE, Opera, Webkit
                                  // TODO: identify versions
                                  // getElementById can match elements by name instead of ID
                                  if (newContext && (elem = newContext.getElementById(m)) &&
                                      contains(context, elem) &&
                                      elem.id === m) {

                                      results.push(elem);
                                      return results;
                                  }
                              }

                              // Type selector
                          } else if (match[2]) {
                              push.apply(results, context.getElementsByTagName(selector));
                              return results;

                              // Class selector
                          } else if ((m = match[3]) && support.getElementsByClassName &&
                              context.getElementsByClassName) {

                              push.apply(results, context.getElementsByClassName(m));
                              return results;
                          }
                      }

                      // Take advantage of querySelectorAll
                      if (support.qsa &&
                          !compilerCache[selector + " "] &&
                          (!rbuggyQSA || !rbuggyQSA.test(selector))) {

                          if (nodeType !== 1) {
                              newContext = context;
                              newSelector = selector;

                              // qSA looks outside Element context, which is not what we want
                              // Thanks to Andrew Dupont for this workaround technique
                              // Support: IE <=8
                              // Exclude object elements
                          } else if (context.nodeName.toLowerCase() !== "object") {

                              // Capture the context ID, setting it first if necessary
                              if ((nid = context.getAttribute("id"))) {
                                  nid = nid.replace(rcssescape, fcssescape);
                              } else {
                                  context.setAttribute("id", (nid = expando));
                              }

                              // Prefix every selector in the list
                              groups = tokenize(selector);
                              i = groups.length;
                              while (i--) {
                                  groups[i] = "#" + nid + " " + toSelector(groups[i]);
                              }
                              newSelector = groups.join(",");

                              // Expand context for sibling selectors
                              newContext = rsibling.test(selector) && testContext(context.parentNode) ||
                                  context;
                          }

                          if (newSelector) {
                              try {
                                  push.apply(results,
                                      newContext.querySelectorAll(newSelector)
                                  );
                                  return results;
                              } catch (qsaError) {
                              } finally {
                                  if (nid === expando) {
                                      context.removeAttribute("id");
                                  }
                              }
                          }
                      }
                  }
              }

              // All others
              return select(selector.replace(rtrim, "$1"), context, results, seed);
          }

          /**
           * Create key-value caches of limited size
           * @returns {function(string, object)} Returns the Object data after storing it on itself with
           *    property name the (space-suffixed) string and (if the cache is larger than Expr.cacheLength)
           *    deleting the oldest entry
           */
          function createCache() {
              var keys = [];

              function cache(key, value) {
                  // Use (key + " ") to avoid collision with native prototype properties (see Issue #157)
                  if (keys.push(key + " ") > Expr.cacheLength) {
                      // Only keep the most recent entries
                      delete cache[keys.shift()];
                  }
                  return (cache[key + " "] = value);
              }

              return cache;
          }

          /**
           * Mark a function for special use by Sizzle
           * @param {Function} fn The function to mark
           */
          function markFunction(fn) {
              fn[expando] = true;
              return fn;
          }

          /**
           * Support testing using an element
           * @param {Function} fn Passed the created element and returns a boolean result
           */
          function assert(fn) {
              var el = document.createElement("fieldset");

              try {
                  return !!fn(el);
              } catch (e) {
                  return false;
              } finally {
                  // Remove from its parent by default
                  if (el.parentNode) {
                      el.parentNode.removeChild(el);
                  }
                  // release memory in IE
                  el = null;
              }
          }

          /**
           * Checks document order of two siblings
           * @param {Element} a
           * @param {Element} b
           * @returns {Number} Returns less than 0 if a precedes b, greater than 0 if a follows b
           */
          function siblingCheck(a, b) {
              var cur = b && a,
                  diff = cur && a.nodeType === 1 && b.nodeType === 1 &&
                      a.sourceIndex - b.sourceIndex;

              // Use IE sourceIndex if available on both nodes
              if (diff) {
                  return diff;
              }

              // Check if b follows a
              if (cur) {
                  while ((cur = cur.nextSibling)) {
                      if (cur === b) {
                          return -1;
                      }
                  }
              }

              return a ? 1 : -1;
          }

          /**
           * Returns a function to use in pseudos for input types
           * @param {String} type
           */
          function createInputPseudo(type) {
              return function (elem) {
                  var name = elem.nodeName.toLowerCase();
                  return name === "input" && elem.type === type;
              };
          }

          /**
           * Returns a function to use in pseudos for buttons
           * @param {String} type
           */
          function createButtonPseudo(type) {
              return function (elem) {
                  var name = elem.nodeName.toLowerCase();
                  return (name === "input" || name === "button") && elem.type === type;
              };
          }

          /**
           * Returns a function to use in pseudos for :enabled/:disabled
           * @param {Boolean} disabled true for :disabled; false for :enabled
           */
          function createDisabledPseudo(disabled) {

              // Known :disabled false positives: fieldset[disabled] > legend:nth-of-type(n+2) :can-disable
              return function (elem) {

                  // Only certain elements can match :enabled or :disabled
                  // https://html.spec.whatwg.org/multipage/scripting.html#selector-enabled
                  // https://html.spec.whatwg.org/multipage/scripting.html#selector-disabled
                  if ("form" in elem) {

                      // Check for inherited disabledness on relevant non-disabled elements:
                      // * listed form-associated elements in a disabled fieldset
                      //   https://html.spec.whatwg.org/multipage/forms.html#category-listed
                      //   https://html.spec.whatwg.org/multipage/forms.html#concept-fe-disabled
                      // * option elements in a disabled optgroup
                      //   https://html.spec.whatwg.org/multipage/forms.html#concept-option-disabled
                      // All such elements have a "form" property.
                      if (elem.parentNode && elem.disabled === false) {

                          // Option elements defer to a parent optgroup if present
                          if ("label" in elem) {
                              if ("label" in elem.parentNode) {
                                  return elem.parentNode.disabled === disabled;
                              } else {
                                  return elem.disabled === disabled;
                              }
                          }

                          // Support: IE 6 - 11
                          // Use the isDisabled shortcut property to check for disabled fieldset ancestors
                          return elem.isDisabled === disabled ||

                              // Where there is no isDisabled, check manually
                              /* jshint -W018 */
                              elem.isDisabled !== !disabled &&
                              disabledAncestor(elem) === disabled;
                      }

                      return elem.disabled === disabled;

                      // Try to winnow out elements that can't be disabled before trusting the disabled property.
                      // Some victims get caught in our net (label, legend, menu, track), but it shouldn't
                      // even exist on them, let alone have a boolean value.
                  } else if ("label" in elem) {
                      return elem.disabled === disabled;
                  }

                  // Remaining elements are neither :enabled nor :disabled
                  return false;
              };
          }

          /**
           * Returns a function to use in pseudos for positionals
           * @param {Function} fn
           */
          function createPositionalPseudo(fn) {
              return markFunction(function (argument) {
                  argument = +argument;
                  return markFunction(function (seed, matches) {
                      var j,
                          matchIndexes = fn([], seed.length, argument),
                          i = matchIndexes.length;

                      // Match elements found at the specified indexes
                      while (i--) {
                          if (seed[(j = matchIndexes[i])]) {
                              seed[j] = !(matches[j] = seed[j]);
                          }
                      }
                  });
              });
          }

          /**
           * Checks a node for validity as a Sizzle context
           * @param {Element|Object=} context
           * @returns {Element|Object|Boolean} The input node if acceptable, otherwise a falsy value
           */
          function testContext(context) {
              return context && typeof context.getElementsByTagName !== "undefined" && context;
          }

  // Expose support vars for convenience
          support = Sizzle.support = {};

          /**
           * Detects XML nodes
           * @param {Element|Object} elem An element or a document
           * @returns {Boolean} True iff elem is a non-HTML XML node
           */
          isXML = Sizzle.isXML = function (elem) {
              // documentElement is verified for cases where it doesn't yet exist
              // (such as loading iframes in IE - #4833)
              var documentElement = elem && (elem.ownerDocument || elem).documentElement;
              return documentElement ? documentElement.nodeName !== "HTML" : false;
          };

          /**
           * Sets document-related variables once based on the current document
           * @param {Element|Object} [doc] An element or document object to use to set the document
           * @returns {Object} Returns the current document
           */
          setDocument = Sizzle.setDocument = function (node) {
              var hasCompare, subWindow,
                  doc = node ? node.ownerDocument || node : preferredDoc;

              // Return early if doc is invalid or already selected
              if (doc === document || doc.nodeType !== 9 || !doc.documentElement) {
                  return document;
              }

              // Update global variables
              document = doc;
              docElem = document.documentElement;
              documentIsHTML = !isXML(document);

              // Support: IE 9-11, Edge
              // Accessing iframe documents after unload throws "permission denied" errors (jQuery #13936)
              if (preferredDoc !== document &&
                  (subWindow = document.defaultView) && subWindow.top !== subWindow) {

                  // Support: IE 11, Edge
                  if (subWindow.addEventListener) {
                      subWindow.addEventListener("unload", unloadHandler, false);

                      // Support: IE 9 - 10 only
                  } else if (subWindow.attachEvent) {
                      subWindow.attachEvent("onunload", unloadHandler);
                  }
              }

              /* Attributes
  	---------------------------------------------------------------------- */

              // Support: IE<8
              // Verify that getAttribute really returns attributes and not properties
              // (excepting IE8 booleans)
              support.attributes = assert(function (el) {
                  el.className = "i";
                  return !el.getAttribute("className");
              });

              /* getElement(s)By*
  	---------------------------------------------------------------------- */

              // Check if getElementsByTagName("*") returns only elements
              support.getElementsByTagName = assert(function (el) {
                  el.appendChild(document.createComment(""));
                  return !el.getElementsByTagName("*").length;
              });

              // Support: IE<9
              support.getElementsByClassName = rnative.test(document.getElementsByClassName);

              // Support: IE<10
              // Check if getElementById returns elements by name
              // The broken getElementById methods don't pick up programmatically-set names,
              // so use a roundabout getElementsByName test
              support.getById = assert(function (el) {
                  docElem.appendChild(el).id = expando;
                  return !document.getElementsByName || !document.getElementsByName(expando).length;
              });

              // ID filter and find
              if (support.getById) {
                  Expr.filter["ID"] = function (id) {
                      var attrId = id.replace(runescape, funescape);
                      return function (elem) {
                          return elem.getAttribute("id") === attrId;
                      };
                  };
                  Expr.find["ID"] = function (id, context) {
                      if (typeof context.getElementById !== "undefined" && documentIsHTML) {
                          var elem = context.getElementById(id);
                          return elem ? [elem] : [];
                      }
                  };
              } else {
                  Expr.filter["ID"] = function (id) {
                      var attrId = id.replace(runescape, funescape);
                      return function (elem) {
                          var node = typeof elem.getAttributeNode !== "undefined" &&
                              elem.getAttributeNode("id");
                          return node && node.value === attrId;
                      };
                  };

                  // Support: IE 6 - 7 only
                  // getElementById is not reliable as a find shortcut
                  Expr.find["ID"] = function (id, context) {
                      if (typeof context.getElementById !== "undefined" && documentIsHTML) {
                          var node, i, elems,
                              elem = context.getElementById(id);

                          if (elem) {

                              // Verify the id attribute
                              node = elem.getAttributeNode("id");
                              if (node && node.value === id) {
                                  return [elem];
                              }

                              // Fall back on getElementsByName
                              elems = context.getElementsByName(id);
                              i = 0;
                              while ((elem = elems[i++])) {
                                  node = elem.getAttributeNode("id");
                                  if (node && node.value === id) {
                                      return [elem];
                                  }
                              }
                          }

                          return [];
                      }
                  };
              }

              // Tag
              Expr.find["TAG"] = support.getElementsByTagName ?
                  function (tag, context) {
                      if (typeof context.getElementsByTagName !== "undefined") {
                          return context.getElementsByTagName(tag);

                          // DocumentFragment nodes don't have gEBTN
                      } else if (support.qsa) {
                          return context.querySelectorAll(tag);
                      }
                  } :

                  function (tag, context) {
                      var elem,
                          tmp = [],
                          i = 0,
                          // By happy coincidence, a (broken) gEBTN appears on DocumentFragment nodes too
                          results = context.getElementsByTagName(tag);

                      // Filter out possible comments
                      if (tag === "*") {
                          while ((elem = results[i++])) {
                              if (elem.nodeType === 1) {
                                  tmp.push(elem);
                              }
                          }

                          return tmp;
                      }
                      return results;
                  };

              // Class
              Expr.find["CLASS"] = support.getElementsByClassName && function (className, context) {
                  if (typeof context.getElementsByClassName !== "undefined" && documentIsHTML) {
                      return context.getElementsByClassName(className);
                  }
              };

              /* QSA/matchesSelector
  	---------------------------------------------------------------------- */

              // QSA and matchesSelector support

              // matchesSelector(:active) reports false when true (IE9/Opera 11.5)
              rbuggyMatches = [];

              // qSa(:focus) reports false when true (Chrome 21)
              // We allow this because of a bug in IE8/9 that throws an error
              // whenever `document.activeElement` is accessed on an iframe
              // So, we allow :focus to pass through QSA all the time to avoid the IE error
              // See https://bugs.jquery.com/ticket/13378
              rbuggyQSA = [];

              if ((support.qsa = rnative.test(document.querySelectorAll))) {
                  // Build QSA regex
                  // Regex strategy adopted from Diego Perini
                  assert(function (el) {
                      // Select is set to empty string on purpose
                      // This is to test IE's treatment of not explicitly
                      // setting a boolean content attribute,
                      // since its presence should be enough
                      // https://bugs.jquery.com/ticket/12359
                      docElem.appendChild(el).innerHTML = "<a id='" + expando + "'></a>" +
                          "<select id='" + expando + "-\r\\' msallowcapture=''>" +
                          "<option selected=''></option></select>";

                      // Support: IE8, Opera 11-12.16
                      // Nothing should be selected when empty strings follow ^= or $= or *=
                      // The test attribute must be unknown in Opera but "safe" for WinRT
                      // https://msdn.microsoft.com/en-us/library/ie/hh465388.aspx#attribute_section
                      if (el.querySelectorAll("[msallowcapture^='']").length) {
                          rbuggyQSA.push("[*^$]=" + whitespace + "*(?:''|\"\")");
                      }

                      // Support: IE8
                      // Boolean attributes and "value" are not treated correctly
                      if (!el.querySelectorAll("[selected]").length) {
                          rbuggyQSA.push("\\[" + whitespace + "*(?:value|" + booleans + ")");
                      }

                      // Support: Chrome<29, Android<4.4, Safari<7.0+, iOS<7.0+, PhantomJS<1.9.8+
                      if (!el.querySelectorAll("[id~=" + expando + "-]").length) {
                          rbuggyQSA.push("~=");
                      }

                      // Webkit/Opera - :checked should return selected option elements
                      // http://www.w3.org/TR/2011/REC-css3-selectors-20110929/#checked
                      // IE8 throws error here and will not see later tests
                      if (!el.querySelectorAll(":checked").length) {
                          rbuggyQSA.push(":checked");
                      }

                      // Support: Safari 8+, iOS 8+
                      // https://bugs.webkit.org/show_bug.cgi?id=136851
                      // In-page `selector#id sibling-combinator selector` fails
                      if (!el.querySelectorAll("a#" + expando + "+*").length) {
                          rbuggyQSA.push(".#.+[+~]");
                      }
                  });

                  assert(function (el) {
                      el.innerHTML = "<a href='' disabled='disabled'></a>" +
                          "<select disabled='disabled'><option/></select>";

                      // Support: Windows 8 Native Apps
                      // The type and name attributes are restricted during .innerHTML assignment
                      var input = document.createElement("input");
                      input.setAttribute("type", "hidden");
                      el.appendChild(input).setAttribute("name", "D");

                      // Support: IE8
                      // Enforce case-sensitivity of name attribute
                      if (el.querySelectorAll("[name=d]").length) {
                          rbuggyQSA.push("name" + whitespace + "*[*^$|!~]?=");
                      }

                      // FF 3.5 - :enabled/:disabled and hidden elements (hidden elements are still enabled)
                      // IE8 throws error here and will not see later tests
                      if (el.querySelectorAll(":enabled").length !== 2) {
                          rbuggyQSA.push(":enabled", ":disabled");
                      }

                      // Support: IE9-11+
                      // IE's :disabled selector does not pick up the children of disabled fieldsets
                      docElem.appendChild(el).disabled = true;
                      if (el.querySelectorAll(":disabled").length !== 2) {
                          rbuggyQSA.push(":enabled", ":disabled");
                      }

                      // Opera 10-11 does not throw on post-comma invalid pseudos
                      el.querySelectorAll("*,:x");
                      rbuggyQSA.push(",.*:");
                  });
              }

              if ((support.matchesSelector = rnative.test((matches = docElem.matches ||
                  docElem.webkitMatchesSelector ||
                  docElem.mozMatchesSelector ||
                  docElem.oMatchesSelector ||
                  docElem.msMatchesSelector)))) {

                  assert(function (el) {
                      // Check to see if it's possible to do matchesSelector
                      // on a disconnected node (IE 9)
                      support.disconnectedMatch = matches.call(el, "*");

                      // This should fail with an exception
                      // Gecko does not error, returns false instead
                      matches.call(el, "[s!='']:x");
                      rbuggyMatches.push("!=", pseudos);
                  });
              }

              rbuggyQSA = rbuggyQSA.length && new RegExp(rbuggyQSA.join("|"));
              rbuggyMatches = rbuggyMatches.length && new RegExp(rbuggyMatches.join("|"));

              /* Contains
  	---------------------------------------------------------------------- */
              hasCompare = rnative.test(docElem.compareDocumentPosition);

              // Element contains another
              // Purposefully self-exclusive
              // As in, an element does not contain itself
              contains = hasCompare || rnative.test(docElem.contains) ?
                  function (a, b) {
                      var adown = a.nodeType === 9 ? a.documentElement : a,
                          bup = b && b.parentNode;
                      return a === bup || !!(bup && bup.nodeType === 1 && (
                          adown.contains ?
                              adown.contains(bup) :
                              a.compareDocumentPosition && a.compareDocumentPosition(bup) & 16
                      ));
                  } :
                  function (a, b) {
                      if (b) {
                          while ((b = b.parentNode)) {
                              if (b === a) {
                                  return true;
                              }
                          }
                      }
                      return false;
                  };

              /* Sorting
  	---------------------------------------------------------------------- */

              // Document order sorting
              sortOrder = hasCompare ?
                  function (a, b) {

                      // Flag for duplicate removal
                      if (a === b) {
                          hasDuplicate = true;
                          return 0;
                      }

                      // Sort on method existence if only one input has compareDocumentPosition
                      var compare = !a.compareDocumentPosition - !b.compareDocumentPosition;
                      if (compare) {
                          return compare;
                      }

                      // Calculate position if both inputs belong to the same document
                      compare = (a.ownerDocument || a) === (b.ownerDocument || b) ?
                          a.compareDocumentPosition(b) :

                          // Otherwise we know they are disconnected
                          1;

                      // Disconnected nodes
                      if (compare & 1 ||
                          (!support.sortDetached && b.compareDocumentPosition(a) === compare)) {

                          // Choose the first element that is related to our preferred document
                          if (a === document || a.ownerDocument === preferredDoc && contains(preferredDoc, a)) {
                              return -1;
                          }
                          if (b === document || b.ownerDocument === preferredDoc && contains(preferredDoc, b)) {
                              return 1;
                          }

                          // Maintain original order
                          return sortInput ?
                              (indexOf(sortInput, a) - indexOf(sortInput, b)) :
                              0;
                      }

                      return compare & 4 ? -1 : 1;
                  } :
                  function (a, b) {
                      // Exit early if the nodes are identical
                      if (a === b) {
                          hasDuplicate = true;
                          return 0;
                      }

                      var cur,
                          i = 0,
                          aup = a.parentNode,
                          bup = b.parentNode,
                          ap = [a],
                          bp = [b];

                      // Parentless nodes are either documents or disconnected
                      if (!aup || !bup) {
                          return a === document ? -1 :
                              b === document ? 1 :
                                  aup ? -1 :
                                      bup ? 1 :
                                          sortInput ?
                                              (indexOf(sortInput, a) - indexOf(sortInput, b)) :
                                              0;

                          // If the nodes are siblings, we can do a quick check
                      } else if (aup === bup) {
                          return siblingCheck(a, b);
                      }

                      // Otherwise we need full lists of their ancestors for comparison
                      cur = a;
                      while ((cur = cur.parentNode)) {
                          ap.unshift(cur);
                      }
                      cur = b;
                      while ((cur = cur.parentNode)) {
                          bp.unshift(cur);
                      }

                      // Walk down the tree looking for a discrepancy
                      while (ap[i] === bp[i]) {
                          i++;
                      }

                      return i ?
                          // Do a sibling check if the nodes have a common ancestor
                          siblingCheck(ap[i], bp[i]) :

                          // Otherwise nodes in our document sort first
                          ap[i] === preferredDoc ? -1 :
                              bp[i] === preferredDoc ? 1 :
                                  0;
                  };

              return document;
          };

          Sizzle.matches = function (expr, elements) {
              return Sizzle(expr, null, null, elements);
          };

          Sizzle.matchesSelector = function (elem, expr) {
              // Set document vars if needed
              if ((elem.ownerDocument || elem) !== document) {
                  setDocument(elem);
              }

              // Make sure that attribute selectors are quoted
              expr = expr.replace(rattributeQuotes, "='$1']");

              if (support.matchesSelector && documentIsHTML &&
                  !compilerCache[expr + " "] &&
                  (!rbuggyMatches || !rbuggyMatches.test(expr)) &&
                  (!rbuggyQSA || !rbuggyQSA.test(expr))) {

                  try {
                      var ret = matches.call(elem, expr);

                      // IE 9's matchesSelector returns false on disconnected nodes
                      if (ret || support.disconnectedMatch ||
                          // As well, disconnected nodes are said to be in a document
                          // fragment in IE 9
                          elem.document && elem.document.nodeType !== 11) {
                          return ret;
                      }
                  } catch (e) {
                  }
              }

              return Sizzle(expr, document, null, [elem]).length > 0;
          };

          Sizzle.contains = function (context, elem) {
              // Set document vars if needed
              if ((context.ownerDocument || context) !== document) {
                  setDocument(context);
              }
              return contains(context, elem);
          };

          Sizzle.attr = function (elem, name) {
              // Set document vars if needed
              if ((elem.ownerDocument || elem) !== document) {
                  setDocument(elem);
              }

              var fn = Expr.attrHandle[name.toLowerCase()],
                  // Don't get fooled by Object.prototype properties (jQuery #13807)
                  val = fn && hasOwn.call(Expr.attrHandle, name.toLowerCase()) ?
                      fn(elem, name, !documentIsHTML) :
                      undefined;

              return val !== undefined ?
                  val :
                  support.attributes || !documentIsHTML ?
                      elem.getAttribute(name) :
                      (val = elem.getAttributeNode(name)) && val.specified ?
                          val.value :
                          null;
          };

          Sizzle.escape = function (sel) {
              return (sel + "").replace(rcssescape, fcssescape);
          };

          Sizzle.error = function (msg) {
              throw new Error("Syntax error, unrecognized expression: " + msg);
          };

          /**
           * Document sorting and removing duplicates
           * @param {ArrayLike} results
           */
          Sizzle.uniqueSort = function (results) {
              var elem,
                  duplicates = [],
                  j = 0,
                  i = 0;

              // Unless we *know* we can detect duplicates, assume their presence
              hasDuplicate = !support.detectDuplicates;
              sortInput = !support.sortStable && results.slice(0);
              results.sort(sortOrder);

              if (hasDuplicate) {
                  while ((elem = results[i++])) {
                      if (elem === results[i]) {
                          j = duplicates.push(i);
                      }
                  }
                  while (j--) {
                      results.splice(duplicates[j], 1);
                  }
              }

              // Clear input after sorting to release objects
              // See https://github.com/jquery/sizzle/pull/225
              sortInput = null;

              return results;
          };

          /**
           * Utility function for retrieving the text value of an array of DOM nodes
           * @param {Array|Element} elem
           */
          getText = Sizzle.getText = function (elem) {
              var node,
                  ret = "",
                  i = 0,
                  nodeType = elem.nodeType;

              if (!nodeType) {
                  // If no nodeType, this is expected to be an array
                  while ((node = elem[i++])) {
                      // Do not traverse comment nodes
                      ret += getText(node);
                  }
              } else if (nodeType === 1 || nodeType === 9 || nodeType === 11) {
                  // Use textContent for elements
                  // innerText usage removed for consistency of new lines (jQuery #11153)
                  if (typeof elem.textContent === "string") {
                      return elem.textContent;
                  } else {
                      // Traverse its children
                      for (elem = elem.firstChild; elem; elem = elem.nextSibling) {
                          ret += getText(elem);
                      }
                  }
              } else if (nodeType === 3 || nodeType === 4) {
                  return elem.nodeValue;
              }
              // Do not include comment or processing instruction nodes

              return ret;
          };

          Expr = Sizzle.selectors = {

              // Can be adjusted by the user
              cacheLength: 50,

              createPseudo: markFunction,

              match: matchExpr,

              attrHandle: {},

              find: {},

              relative: {
                  ">": {dir: "parentNode", first: true},
                  " ": {dir: "parentNode"},
                  "+": {dir: "previousSibling", first: true},
                  "~": {dir: "previousSibling"}
              },

              preFilter: {
                  "ATTR": function (match) {
                      match[1] = match[1].replace(runescape, funescape);

                      // Move the given value to match[3] whether quoted or unquoted
                      match[3] = (match[3] || match[4] || match[5] || "").replace(runescape, funescape);

                      if (match[2] === "~=") {
                          match[3] = " " + match[3] + " ";
                      }

                      return match.slice(0, 4);
                  },

                  "CHILD": function (match) {
                      /* matches from matchExpr["CHILD"]
  				1 type (only|nth|...)
  				2 what (child|of-type)
  				3 argument (even|odd|\d*|\d*n([+-]\d+)?|...)
  				4 xn-component of xn+y argument ([+-]?\d*n|)
  				5 sign of xn-component
  				6 x of xn-component
  				7 sign of y-component
  				8 y of y-component
  			*/
                      match[1] = match[1].toLowerCase();

                      if (match[1].slice(0, 3) === "nth") {
                          // nth-* requires argument
                          if (!match[3]) {
                              Sizzle.error(match[0]);
                          }

                          // numeric x and y parameters for Expr.filter.CHILD
                          // remember that false/true cast respectively to 0/1
                          match[4] = +(match[4] ? match[5] + (match[6] || 1) : 2 * (match[3] === "even" || match[3] === "odd"));
                          match[5] = +((match[7] + match[8]) || match[3] === "odd");

                          // other types prohibit arguments
                      } else if (match[3]) {
                          Sizzle.error(match[0]);
                      }

                      return match;
                  },

                  "PSEUDO": function (match) {
                      var excess,
                          unquoted = !match[6] && match[2];

                      if (matchExpr["CHILD"].test(match[0])) {
                          return null;
                      }

                      // Accept quoted arguments as-is
                      if (match[3]) {
                          match[2] = match[4] || match[5] || "";

                          // Strip excess characters from unquoted arguments
                      } else if (unquoted && rpseudo.test(unquoted) &&
                          // Get excess from tokenize (recursively)
                          (excess = tokenize(unquoted, true)) &&
                          // advance to the next closing parenthesis
                          (excess = unquoted.indexOf(")", unquoted.length - excess) - unquoted.length)) {

                          // excess is a negative index
                          match[0] = match[0].slice(0, excess);
                          match[2] = unquoted.slice(0, excess);
                      }

                      // Return only captures needed by the pseudo filter method (type and argument)
                      return match.slice(0, 3);
                  }
              },

              filter: {

                  "TAG": function (nodeNameSelector) {
                      var nodeName = nodeNameSelector.replace(runescape, funescape).toLowerCase();
                      return nodeNameSelector === "*" ?
                          function () {
                              return true;
                          } :
                          function (elem) {
                              return elem.nodeName && elem.nodeName.toLowerCase() === nodeName;
                          };
                  },

                  "CLASS": function (className) {
                      var pattern = classCache[className + " "];

                      return pattern ||
                          (pattern = new RegExp("(^|" + whitespace + ")" + className + "(" + whitespace + "|$)")) &&
                          classCache(className, function (elem) {
                              return pattern.test(typeof elem.className === "string" && elem.className || typeof elem.getAttribute !== "undefined" && elem.getAttribute("class") || "");
                          });
                  },

                  "ATTR": function (name, operator, check) {
                      return function (elem) {
                          var result = Sizzle.attr(elem, name);

                          if (result == null) {
                              return operator === "!=";
                          }
                          if (!operator) {
                              return true;
                          }

                          result += "";

                          return operator === "=" ? result === check :
                              operator === "!=" ? result !== check :
                                  operator === "^=" ? check && result.indexOf(check) === 0 :
                                      operator === "*=" ? check && result.indexOf(check) > -1 :
                                          operator === "$=" ? check && result.slice(-check.length) === check :
                                              operator === "~=" ? (" " + result.replace(rwhitespace, " ") + " ").indexOf(check) > -1 :
                                                  operator === "|=" ? result === check || result.slice(0, check.length + 1) === check + "-" :
                                                      false;
                      };
                  },

                  "CHILD": function (type, what, argument, first, last) {
                      var simple = type.slice(0, 3) !== "nth",
                          forward = type.slice(-4) !== "last",
                          ofType = what === "of-type";

                      return first === 1 && last === 0 ?

                          // Shortcut for :nth-*(n)
                          function (elem) {
                              return !!elem.parentNode;
                          } :

                          function (elem, context, xml) {
                              var cache, uniqueCache, outerCache, node, nodeIndex, start,
                                  dir = simple !== forward ? "nextSibling" : "previousSibling",
                                  parent = elem.parentNode,
                                  name = ofType && elem.nodeName.toLowerCase(),
                                  useCache = !xml && !ofType,
                                  diff = false;

                              if (parent) {

                                  // :(first|last|only)-(child|of-type)
                                  if (simple) {
                                      while (dir) {
                                          node = elem;
                                          while ((node = node[dir])) {
                                              if (ofType ?
                                                  node.nodeName.toLowerCase() === name :
                                                  node.nodeType === 1) {

                                                  return false;
                                              }
                                          }
                                          // Reverse direction for :only-* (if we haven't yet done so)
                                          start = dir = type === "only" && !start && "nextSibling";
                                      }
                                      return true;
                                  }

                                  start = [forward ? parent.firstChild : parent.lastChild];

                                  // non-xml :nth-child(...) stores cache data on `parent`
                                  if (forward && useCache) {

                                      // Seek `elem` from a previously-cached index

                                      // ...in a gzip-friendly way
                                      node = parent;
                                      outerCache = node[expando] || (node[expando] = {});

                                      // Support: IE <9 only
                                      // Defend against cloned attroperties (jQuery gh-1709)
                                      uniqueCache = outerCache[node.uniqueID] ||
                                          (outerCache[node.uniqueID] = {});

                                      cache = uniqueCache[type] || [];
                                      nodeIndex = cache[0] === dirruns && cache[1];
                                      diff = nodeIndex && cache[2];
                                      node = nodeIndex && parent.childNodes[nodeIndex];

                                      while ((node = ++nodeIndex && node && node[dir] ||

                                          // Fallback to seeking `elem` from the start
                                          (diff = nodeIndex = 0) || start.pop())) {

                                          // When found, cache indexes on `parent` and break
                                          if (node.nodeType === 1 && ++diff && node === elem) {
                                              uniqueCache[type] = [dirruns, nodeIndex, diff];
                                              break;
                                          }
                                      }

                                  } else {
                                      // Use previously-cached element index if available
                                      if (useCache) {
                                          // ...in a gzip-friendly way
                                          node = elem;
                                          outerCache = node[expando] || (node[expando] = {});

                                          // Support: IE <9 only
                                          // Defend against cloned attroperties (jQuery gh-1709)
                                          uniqueCache = outerCache[node.uniqueID] ||
                                              (outerCache[node.uniqueID] = {});

                                          cache = uniqueCache[type] || [];
                                          nodeIndex = cache[0] === dirruns && cache[1];
                                          diff = nodeIndex;
                                      }

                                      // xml :nth-child(...)
                                      // or :nth-last-child(...) or :nth(-last)?-of-type(...)
                                      if (diff === false) {
                                          // Use the same loop as above to seek `elem` from the start
                                          while ((node = ++nodeIndex && node && node[dir] ||
                                              (diff = nodeIndex = 0) || start.pop())) {

                                              if ((ofType ?
                                                  node.nodeName.toLowerCase() === name :
                                                  node.nodeType === 1) &&
                                                  ++diff) {

                                                  // Cache the index of each encountered element
                                                  if (useCache) {
                                                      outerCache = node[expando] || (node[expando] = {});

                                                      // Support: IE <9 only
                                                      // Defend against cloned attroperties (jQuery gh-1709)
                                                      uniqueCache = outerCache[node.uniqueID] ||
                                                          (outerCache[node.uniqueID] = {});

                                                      uniqueCache[type] = [dirruns, diff];
                                                  }

                                                  if (node === elem) {
                                                      break;
                                                  }
                                              }
                                          }
                                      }
                                  }

                                  // Incorporate the offset, then check against cycle size
                                  diff -= last;
                                  return diff === first || (diff % first === 0 && diff / first >= 0);
                              }
                          };
                  },

                  "PSEUDO": function (pseudo, argument) {
                      // pseudo-class names are case-insensitive
                      // http://www.w3.org/TR/selectors/#pseudo-classes
                      // Prioritize by case sensitivity in case custom pseudos are added with uppercase letters
                      // Remember that setFilters inherits from pseudos
                      var args,
                          fn = Expr.pseudos[pseudo] || Expr.setFilters[pseudo.toLowerCase()] ||
                              Sizzle.error("unsupported pseudo: " + pseudo);

                      // The user may use createPseudo to indicate that
                      // arguments are needed to create the filter function
                      // just as Sizzle does
                      if (fn[expando]) {
                          return fn(argument);
                      }

                      // But maintain support for old signatures
                      if (fn.length > 1) {
                          args = [pseudo, pseudo, "", argument];
                          return Expr.setFilters.hasOwnProperty(pseudo.toLowerCase()) ?
                              markFunction(function (seed, matches) {
                                  var idx,
                                      matched = fn(seed, argument),
                                      i = matched.length;
                                  while (i--) {
                                      idx = indexOf(seed, matched[i]);
                                      seed[idx] = !(matches[idx] = matched[i]);
                                  }
                              }) :
                              function (elem) {
                                  return fn(elem, 0, args);
                              };
                      }

                      return fn;
                  }
              },

              pseudos: {
                  // Potentially complex pseudos
                  "not": markFunction(function (selector) {
                      // Trim the selector passed to compile
                      // to avoid treating leading and trailing
                      // spaces as combinators
                      var input = [],
                          results = [],
                          matcher = compile(selector.replace(rtrim, "$1"));

                      return matcher[expando] ?
                          markFunction(function (seed, matches, context, xml) {
                              var elem,
                                  unmatched = matcher(seed, null, xml, []),
                                  i = seed.length;

                              // Match elements unmatched by `matcher`
                              while (i--) {
                                  if ((elem = unmatched[i])) {
                                      seed[i] = !(matches[i] = elem);
                                  }
                              }
                          }) :
                          function (elem, context, xml) {
                              input[0] = elem;
                              matcher(input, null, xml, results);
                              // Don't keep the element (issue #299)
                              input[0] = null;
                              return !results.pop();
                          };
                  }),

                  "has": markFunction(function (selector) {
                      return function (elem) {
                          return Sizzle(selector, elem).length > 0;
                      };
                  }),

                  "contains": markFunction(function (text) {
                      text = text.replace(runescape, funescape);
                      return function (elem) {
                          return (elem.textContent || elem.innerText || getText(elem)).indexOf(text) > -1;
                      };
                  }),

                  // "Whether an element is represented by a :lang() selector
                  // is based solely on the element's language value
                  // being equal to the identifier C,
                  // or beginning with the identifier C immediately followed by "-".
                  // The matching of C against the element's language value is performed case-insensitively.
                  // The identifier C does not have to be a valid language name."
                  // http://www.w3.org/TR/selectors/#lang-pseudo
                  "lang": markFunction(function (lang) {
                      // lang value must be a valid identifier
                      if (!ridentifier.test(lang || "")) {
                          Sizzle.error("unsupported lang: " + lang);
                      }
                      lang = lang.replace(runescape, funescape).toLowerCase();
                      return function (elem) {
                          var elemLang;
                          do {
                              if ((elemLang = documentIsHTML ?
                                  elem.lang :
                                  elem.getAttribute("xml:lang") || elem.getAttribute("lang"))) {

                                  elemLang = elemLang.toLowerCase();
                                  return elemLang === lang || elemLang.indexOf(lang + "-") === 0;
                              }
                          } while ((elem = elem.parentNode) && elem.nodeType === 1);
                          return false;
                      };
                  }),

                  // Miscellaneous
                  "target": function (elem) {
                      var hash = window.location && window.location.hash;
                      return hash && hash.slice(1) === elem.id;
                  },

                  "root": function (elem) {
                      return elem === docElem;
                  },

                  "focus": function (elem) {
                      return elem === document.activeElement && (!document.hasFocus || document.hasFocus()) && !!(elem.type || elem.href || ~elem.tabIndex);
                  },

                  // Boolean properties
                  "enabled": createDisabledPseudo(false),
                  "disabled": createDisabledPseudo(true),

                  "checked": function (elem) {
                      // In CSS3, :checked should return both checked and selected elements
                      // http://www.w3.org/TR/2011/REC-css3-selectors-20110929/#checked
                      var nodeName = elem.nodeName.toLowerCase();
                      return (nodeName === "input" && !!elem.checked) || (nodeName === "option" && !!elem.selected);
                  },

                  "selected": function (elem) {
                      // Accessing this property makes selected-by-default
                      // options in Safari work properly
                      if (elem.parentNode) {
                          elem.parentNode.selectedIndex;
                      }

                      return elem.selected === true;
                  },

                  // Contents
                  "empty": function (elem) {
                      // http://www.w3.org/TR/selectors/#empty-pseudo
                      // :empty is negated by element (1) or content nodes (text: 3; cdata: 4; entity ref: 5),
                      //   but not by others (comment: 8; processing instruction: 7; etc.)
                      // nodeType < 6 works because attributes (2) do not appear as children
                      for (elem = elem.firstChild; elem; elem = elem.nextSibling) {
                          if (elem.nodeType < 6) {
                              return false;
                          }
                      }
                      return true;
                  },

                  "parent": function (elem) {
                      return !Expr.pseudos["empty"](elem);
                  },

                  // Element/input types
                  "header": function (elem) {
                      return rheader.test(elem.nodeName);
                  },

                  "input": function (elem) {
                      return rinputs.test(elem.nodeName);
                  },

                  "button": function (elem) {
                      var name = elem.nodeName.toLowerCase();
                      return name === "input" && elem.type === "button" || name === "button";
                  },

                  "text": function (elem) {
                      var attr;
                      return elem.nodeName.toLowerCase() === "input" &&
                          elem.type === "text" &&

                          // Support: IE<8
                          // New HTML5 attribute values (e.g., "search") appear with elem.type === "text"
                          ((attr = elem.getAttribute("type")) == null || attr.toLowerCase() === "text");
                  },

                  // Position-in-collection
                  "first": createPositionalPseudo(function () {
                      return [0];
                  }),

                  "last": createPositionalPseudo(function (matchIndexes, length) {
                      return [length - 1];
                  }),

                  "eq": createPositionalPseudo(function (matchIndexes, length, argument) {
                      return [argument < 0 ? argument + length : argument];
                  }),

                  "even": createPositionalPseudo(function (matchIndexes, length) {
                      var i = 0;
                      for (; i < length; i += 2) {
                          matchIndexes.push(i);
                      }
                      return matchIndexes;
                  }),

                  "odd": createPositionalPseudo(function (matchIndexes, length) {
                      var i = 1;
                      for (; i < length; i += 2) {
                          matchIndexes.push(i);
                      }
                      return matchIndexes;
                  }),

                  "lt": createPositionalPseudo(function (matchIndexes, length, argument) {
                      var i = argument < 0 ? argument + length : argument;
                      for (; --i >= 0;) {
                          matchIndexes.push(i);
                      }
                      return matchIndexes;
                  }),

                  "gt": createPositionalPseudo(function (matchIndexes, length, argument) {
                      var i = argument < 0 ? argument + length : argument;
                      for (; ++i < length;) {
                          matchIndexes.push(i);
                      }
                      return matchIndexes;
                  })
              }
          };

          Expr.pseudos["nth"] = Expr.pseudos["eq"];

  // Add button/input type pseudos
          for (i in {radio: true, checkbox: true, file: true, password: true, image: true}) {
              Expr.pseudos[i] = createInputPseudo(i);
          }
          for (i in {submit: true, reset: true}) {
              Expr.pseudos[i] = createButtonPseudo(i);
          }

  // Easy API for creating new setFilters
          function setFilters() {
          }

          setFilters.prototype = Expr.filters = Expr.pseudos;
          Expr.setFilters = new setFilters();

          tokenize = Sizzle.tokenize = function (selector, parseOnly) {
              var matched, match, tokens, type,
                  soFar, groups, preFilters,
                  cached = tokenCache[selector + " "];

              if (cached) {
                  return parseOnly ? 0 : cached.slice(0);
              }

              soFar = selector;
              groups = [];
              preFilters = Expr.preFilter;

              while (soFar) {

                  // Comma and first run
                  if (!matched || (match = rcomma.exec(soFar))) {
                      if (match) {
                          // Don't consume trailing commas as valid
                          soFar = soFar.slice(match[0].length) || soFar;
                      }
                      groups.push((tokens = []));
                  }

                  matched = false;

                  // Combinators
                  if ((match = rcombinators.exec(soFar))) {
                      matched = match.shift();
                      tokens.push({
                          value: matched,
                          // Cast descendant combinators to space
                          type: match[0].replace(rtrim, " ")
                      });
                      soFar = soFar.slice(matched.length);
                  }

                  // Filters
                  for (type in Expr.filter) {
                      if ((match = matchExpr[type].exec(soFar)) && (!preFilters[type] ||
                          (match = preFilters[type](match)))) {
                          matched = match.shift();
                          tokens.push({
                              value: matched,
                              type: type,
                              matches: match
                          });
                          soFar = soFar.slice(matched.length);
                      }
                  }

                  if (!matched) {
                      break;
                  }
              }

              // Return the length of the invalid excess
              // if we're just parsing
              // Otherwise, throw an error or return tokens
              return parseOnly ?
                  soFar.length :
                  soFar ?
                      Sizzle.error(selector) :
                      // Cache the tokens
                      tokenCache(selector, groups).slice(0);
          };

          function toSelector(tokens) {
              var i = 0,
                  len = tokens.length,
                  selector = "";
              for (; i < len; i++) {
                  selector += tokens[i].value;
              }
              return selector;
          }

          function addCombinator(matcher, combinator, base) {
              var dir = combinator.dir,
                  skip = combinator.next,
                  key = skip || dir,
                  checkNonElements = base && key === "parentNode",
                  doneName = done++;

              return combinator.first ?
                  // Check against closest ancestor/preceding element
                  function (elem, context, xml) {
                      while ((elem = elem[dir])) {
                          if (elem.nodeType === 1 || checkNonElements) {
                              return matcher(elem, context, xml);
                          }
                      }
                      return false;
                  } :

                  // Check against all ancestor/preceding elements
                  function (elem, context, xml) {
                      var oldCache, uniqueCache, outerCache,
                          newCache = [dirruns, doneName];

                      // We can't set arbitrary data on XML nodes, so they don't benefit from combinator caching
                      if (xml) {
                          while ((elem = elem[dir])) {
                              if (elem.nodeType === 1 || checkNonElements) {
                                  if (matcher(elem, context, xml)) {
                                      return true;
                                  }
                              }
                          }
                      } else {
                          while ((elem = elem[dir])) {
                              if (elem.nodeType === 1 || checkNonElements) {
                                  outerCache = elem[expando] || (elem[expando] = {});

                                  // Support: IE <9 only
                                  // Defend against cloned attroperties (jQuery gh-1709)
                                  uniqueCache = outerCache[elem.uniqueID] || (outerCache[elem.uniqueID] = {});

                                  if (skip && skip === elem.nodeName.toLowerCase()) {
                                      elem = elem[dir] || elem;
                                  } else if ((oldCache = uniqueCache[key]) &&
                                      oldCache[0] === dirruns && oldCache[1] === doneName) {

                                      // Assign to newCache so results back-propagate to previous elements
                                      return (newCache[2] = oldCache[2]);
                                  } else {
                                      // Reuse newcache so results back-propagate to previous elements
                                      uniqueCache[key] = newCache;

                                      // A match means we're done; a fail means we have to keep checking
                                      if ((newCache[2] = matcher(elem, context, xml))) {
                                          return true;
                                      }
                                  }
                              }
                          }
                      }
                      return false;
                  };
          }

          function elementMatcher(matchers) {
              return matchers.length > 1 ?
                  function (elem, context, xml) {
                      var i = matchers.length;
                      while (i--) {
                          if (!matchers[i](elem, context, xml)) {
                              return false;
                          }
                      }
                      return true;
                  } :
                  matchers[0];
          }

          function multipleContexts(selector, contexts, results) {
              var i = 0,
                  len = contexts.length;
              for (; i < len; i++) {
                  Sizzle(selector, contexts[i], results);
              }
              return results;
          }

          function condense(unmatched, map, filter, context, xml) {
              var elem,
                  newUnmatched = [],
                  i = 0,
                  len = unmatched.length,
                  mapped = map != null;

              for (; i < len; i++) {
                  if ((elem = unmatched[i])) {
                      if (!filter || filter(elem, context, xml)) {
                          newUnmatched.push(elem);
                          if (mapped) {
                              map.push(i);
                          }
                      }
                  }
              }

              return newUnmatched;
          }

          function setMatcher(preFilter, selector, matcher, postFilter, postFinder, postSelector) {
              if (postFilter && !postFilter[expando]) {
                  postFilter = setMatcher(postFilter);
              }
              if (postFinder && !postFinder[expando]) {
                  postFinder = setMatcher(postFinder, postSelector);
              }
              return markFunction(function (seed, results, context, xml) {
                  var temp, i, elem,
                      preMap = [],
                      postMap = [],
                      preexisting = results.length,

                      // Get initial elements from seed or context
                      elems = seed || multipleContexts(selector || "*", context.nodeType ? [context] : context, []),

                      // Prefilter to get matcher input, preserving a map for seed-results synchronization
                      matcherIn = preFilter && (seed || !selector) ?
                          condense(elems, preMap, preFilter, context, xml) :
                          elems,

                      matcherOut = matcher ?
                          // If we have a postFinder, or filtered seed, or non-seed postFilter or preexisting results,
                          postFinder || (seed ? preFilter : preexisting || postFilter) ?

                              // ...intermediate processing is necessary
                              [] :

                              // ...otherwise use results directly
                              results :
                          matcherIn;

                  // Find primary matches
                  if (matcher) {
                      matcher(matcherIn, matcherOut, context, xml);
                  }

                  // Apply postFilter
                  if (postFilter) {
                      temp = condense(matcherOut, postMap);
                      postFilter(temp, [], context, xml);

                      // Un-match failing elements by moving them back to matcherIn
                      i = temp.length;
                      while (i--) {
                          if ((elem = temp[i])) {
                              matcherOut[postMap[i]] = !(matcherIn[postMap[i]] = elem);
                          }
                      }
                  }

                  if (seed) {
                      if (postFinder || preFilter) {
                          if (postFinder) {
                              // Get the final matcherOut by condensing this intermediate into postFinder contexts
                              temp = [];
                              i = matcherOut.length;
                              while (i--) {
                                  if ((elem = matcherOut[i])) {
                                      // Restore matcherIn since elem is not yet a final match
                                      temp.push((matcherIn[i] = elem));
                                  }
                              }
                              postFinder(null, (matcherOut = []), temp, xml);
                          }

                          // Move matched elements from seed to results to keep them synchronized
                          i = matcherOut.length;
                          while (i--) {
                              if ((elem = matcherOut[i]) &&
                                  (temp = postFinder ? indexOf(seed, elem) : preMap[i]) > -1) {

                                  seed[temp] = !(results[temp] = elem);
                              }
                          }
                      }

                      // Add elements to results, through postFinder if defined
                  } else {
                      matcherOut = condense(
                          matcherOut === results ?
                              matcherOut.splice(preexisting, matcherOut.length) :
                              matcherOut
                      );
                      if (postFinder) {
                          postFinder(null, results, matcherOut, xml);
                      } else {
                          push.apply(results, matcherOut);
                      }
                  }
              });
          }

          function matcherFromTokens(tokens) {
              var checkContext, matcher, j,
                  len = tokens.length,
                  leadingRelative = Expr.relative[tokens[0].type],
                  implicitRelative = leadingRelative || Expr.relative[" "],
                  i = leadingRelative ? 1 : 0,

                  // The foundational matcher ensures that elements are reachable from top-level context(s)
                  matchContext = addCombinator(function (elem) {
                      return elem === checkContext;
                  }, implicitRelative, true),
                  matchAnyContext = addCombinator(function (elem) {
                      return indexOf(checkContext, elem) > -1;
                  }, implicitRelative, true),
                  matchers = [function (elem, context, xml) {
                      var ret = (!leadingRelative && (xml || context !== outermostContext)) || (
                          (checkContext = context).nodeType ?
                              matchContext(elem, context, xml) :
                              matchAnyContext(elem, context, xml));
                      // Avoid hanging onto element (issue #299)
                      checkContext = null;
                      return ret;
                  }];

              for (; i < len; i++) {
                  if ((matcher = Expr.relative[tokens[i].type])) {
                      matchers = [addCombinator(elementMatcher(matchers), matcher)];
                  } else {
                      matcher = Expr.filter[tokens[i].type].apply(null, tokens[i].matches);

                      // Return special upon seeing a positional matcher
                      if (matcher[expando]) {
                          // Find the next relative operator (if any) for proper handling
                          j = ++i;
                          for (; j < len; j++) {
                              if (Expr.relative[tokens[j].type]) {
                                  break;
                              }
                          }
                          return setMatcher(
                              i > 1 && elementMatcher(matchers),
                              i > 1 && toSelector(
                              // If the preceding token was a descendant combinator, insert an implicit any-element `*`
                              tokens.slice(0, i - 1).concat({value: tokens[i - 2].type === " " ? "*" : ""})
                              ).replace(rtrim, "$1"),
                              matcher,
                              i < j && matcherFromTokens(tokens.slice(i, j)),
                              j < len && matcherFromTokens((tokens = tokens.slice(j))),
                              j < len && toSelector(tokens)
                          );
                      }
                      matchers.push(matcher);
                  }
              }

              return elementMatcher(matchers);
          }

          function matcherFromGroupMatchers(elementMatchers, setMatchers) {
              var bySet = setMatchers.length > 0,
                  byElement = elementMatchers.length > 0,
                  superMatcher = function (seed, context, xml, results, outermost) {
                      var elem, j, matcher,
                          matchedCount = 0,
                          i = "0",
                          unmatched = seed && [],
                          setMatched = [],
                          contextBackup = outermostContext,
                          // We must always have either seed elements or outermost context
                          elems = seed || byElement && Expr.find["TAG"]("*", outermost),
                          // Use integer dirruns iff this is the outermost matcher
                          dirrunsUnique = (dirruns += contextBackup == null ? 1 : Math.random() || 0.1),
                          len = elems.length;

                      if (outermost) {
                          outermostContext = context === document || context || outermost;
                      }

                      // Add elements passing elementMatchers directly to results
                      // Support: IE<9, Safari
                      // Tolerate NodeList properties (IE: "length"; Safari: <number>) matching elements by id
                      for (; i !== len && (elem = elems[i]) != null; i++) {
                          if (byElement && elem) {
                              j = 0;
                              if (!context && elem.ownerDocument !== document) {
                                  setDocument(elem);
                                  xml = !documentIsHTML;
                              }
                              while ((matcher = elementMatchers[j++])) {
                                  if (matcher(elem, context || document, xml)) {
                                      results.push(elem);
                                      break;
                                  }
                              }
                              if (outermost) {
                                  dirruns = dirrunsUnique;
                              }
                          }

                          // Track unmatched elements for set filters
                          if (bySet) {
                              // They will have gone through all possible matchers
                              if ((elem = !matcher && elem)) {
                                  matchedCount--;
                              }

                              // Lengthen the array for every element, matched or not
                              if (seed) {
                                  unmatched.push(elem);
                              }
                          }
                      }

                      // `i` is now the count of elements visited above, and adding it to `matchedCount`
                      // makes the latter nonnegative.
                      matchedCount += i;

                      // Apply set filters to unmatched elements
                      // NOTE: This can be skipped if there are no unmatched elements (i.e., `matchedCount`
                      // equals `i`), unless we didn't visit _any_ elements in the above loop because we have
                      // no element matchers and no seed.
                      // Incrementing an initially-string "0" `i` allows `i` to remain a string only in that
                      // case, which will result in a "00" `matchedCount` that differs from `i` but is also
                      // numerically zero.
                      if (bySet && i !== matchedCount) {
                          j = 0;
                          while ((matcher = setMatchers[j++])) {
                              matcher(unmatched, setMatched, context, xml);
                          }

                          if (seed) {
                              // Reintegrate element matches to eliminate the need for sorting
                              if (matchedCount > 0) {
                                  while (i--) {
                                      if (!(unmatched[i] || setMatched[i])) {
                                          setMatched[i] = pop.call(results);
                                      }
                                  }
                              }

                              // Discard index placeholder values to get only actual matches
                              setMatched = condense(setMatched);
                          }

                          // Add matches to results
                          push.apply(results, setMatched);

                          // Seedless set matches succeeding multiple successful matchers stipulate sorting
                          if (outermost && !seed && setMatched.length > 0 &&
                              (matchedCount + setMatchers.length) > 1) {

                              Sizzle.uniqueSort(results);
                          }
                      }

                      // Override manipulation of globals by nested matchers
                      if (outermost) {
                          dirruns = dirrunsUnique;
                          outermostContext = contextBackup;
                      }

                      return unmatched;
                  };

              return bySet ?
                  markFunction(superMatcher) :
                  superMatcher;
          }

          compile = Sizzle.compile = function (selector, match /* Internal Use Only */) {
              var i,
                  setMatchers = [],
                  elementMatchers = [],
                  cached = compilerCache[selector + " "];

              if (!cached) {
                  // Generate a function of recursive functions that can be used to check each element
                  if (!match) {
                      match = tokenize(selector);
                  }
                  i = match.length;
                  while (i--) {
                      cached = matcherFromTokens(match[i]);
                      if (cached[expando]) {
                          setMatchers.push(cached);
                      } else {
                          elementMatchers.push(cached);
                      }
                  }

                  // Cache the compiled function
                  cached = compilerCache(selector, matcherFromGroupMatchers(elementMatchers, setMatchers));

                  // Save selector and tokenization
                  cached.selector = selector;
              }
              return cached;
          };

          /**
           * A low-level selection function that works with Sizzle's compiled
           *  selector functions
           * @param {String|Function} selector A selector or a pre-compiled
           *  selector function built with Sizzle.compile
           * @param {Element} context
           * @param {Array} [results]
           * @param {Array} [seed] A set of elements to match against
           */
          select = Sizzle.select = function (selector, context, results, seed) {
              var i, tokens, token, type, find,
                  compiled = typeof selector === "function" && selector,
                  match = !seed && tokenize((selector = compiled.selector || selector));

              results = results || [];

              // Try to minimize operations if there is only one selector in the list and no seed
              // (the latter of which guarantees us context)
              if (match.length === 1) {

                  // Reduce context if the leading compound selector is an ID
                  tokens = match[0] = match[0].slice(0);
                  if (tokens.length > 2 && (token = tokens[0]).type === "ID" &&
                      context.nodeType === 9 && documentIsHTML && Expr.relative[tokens[1].type]) {

                      context = (Expr.find["ID"](token.matches[0].replace(runescape, funescape), context) || [])[0];
                      if (!context) {
                          return results;

                          // Precompiled matchers will still verify ancestry, so step up a level
                      } else if (compiled) {
                          context = context.parentNode;
                      }

                      selector = selector.slice(tokens.shift().value.length);
                  }

                  // Fetch a seed set for right-to-left matching
                  i = matchExpr["needsContext"].test(selector) ? 0 : tokens.length;
                  while (i--) {
                      token = tokens[i];

                      // Abort if we hit a combinator
                      if (Expr.relative[(type = token.type)]) {
                          break;
                      }
                      if ((find = Expr.find[type])) {
                          // Search, expanding context for leading sibling combinators
                          if ((seed = find(
                              token.matches[0].replace(runescape, funescape),
                              rsibling.test(tokens[0].type) && testContext(context.parentNode) || context
                          ))) {

                              // If seed is empty or no tokens remain, we can return early
                              tokens.splice(i, 1);
                              selector = seed.length && toSelector(tokens);
                              if (!selector) {
                                  push.apply(results, seed);
                                  return results;
                              }

                              break;
                          }
                      }
                  }
              }

              // Compile and execute a filtering function if one is not provided
              // Provide `match` to avoid retokenization if we modified the selector above
              (compiled || compile(selector, match))(
                  seed,
                  context,
                  !documentIsHTML,
                  results,
                  !context || rsibling.test(selector) && testContext(context.parentNode) || context
              );
              return results;
          };

  // One-time assignments

  // Sort stability
          support.sortStable = expando.split("").sort(sortOrder).join("") === expando;

  // Support: Chrome 14-35+
  // Always assume duplicates if they aren't passed to the comparison function
          support.detectDuplicates = !!hasDuplicate;

  // Initialize against the default document
          setDocument();
          
          return Sizzle;

      })(window);


  jQuery.find = Sizzle;
  jQuery.expr = Sizzle.selectors;

  // Deprecated
  jQuery.expr[":"] = jQuery.expr.pseudos;
  jQuery.uniqueSort = jQuery.unique = Sizzle.uniqueSort;
  jQuery.text = Sizzle.getText;
  jQuery.isXMLDoc = Sizzle.isXML;
  jQuery.contains = Sizzle.contains;
  jQuery.escapeSelector = Sizzle.escape;


  var dir = function (elem, dir, until) {
      var matched = [],
          truncate = until !== undefined;

      while ((elem = elem[dir]) && elem.nodeType !== 9) {
          if (elem.nodeType === 1) {
              if (truncate && jQuery(elem).is(until)) {
                  break;
              }
              matched.push(elem);
          }
      }
      return matched;
  };


  var siblings = function (n, elem) {
      var matched = [];

      for (; n; n = n.nextSibling) {
          if (n.nodeType === 1 && n !== elem) {
              matched.push(n);
          }
      }

      return matched;
  };


  var rneedsContext = jQuery.expr.match.needsContext;


  function nodeName(elem, name) {

      return elem.nodeName && elem.nodeName.toLowerCase() === name.toLowerCase();

  }
  var rsingleTag = (/^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i);


  // Implement the identical functionality for filter and not
  function winnow(elements, qualifier, not) {
      if (isFunction(qualifier)) {
          return jQuery.grep(elements, function (elem, i) {
              return !!qualifier.call(elem, i, elem) !== not;
          });
      }

      // Single element
      if (qualifier.nodeType) {
          return jQuery.grep(elements, function (elem) {
              return (elem === qualifier) !== not;
          });
      }

      // Arraylike of elements (jQuery, arguments, Array)
      if (typeof qualifier !== "string") {
          return jQuery.grep(elements, function (elem) {
              return (indexOf.call(qualifier, elem) > -1) !== not;
          });
      }

      // Filtered directly for both simple and complex selectors
      return jQuery.filter(qualifier, elements, not);
  }

  jQuery.filter = function (expr, elems, not) {
      var elem = elems[0];

      if (not) {
          expr = ":not(" + expr + ")";
      }

      if (elems.length === 1 && elem.nodeType === 1) {
          return jQuery.find.matchesSelector(elem, expr) ? [elem] : [];
      }

      return jQuery.find.matches(expr, jQuery.grep(elems, function (elem) {
          return elem.nodeType === 1;
      }));
  };

  jQuery.fn.extend({
      find: function (selector) {
          var i, ret,
              len = this.length,
              self = this;

          if (typeof selector !== "string") {
              return this.pushStack(jQuery(selector).filter(function () {
                  for (i = 0; i < len; i++) {
                      if (jQuery.contains(self[i], this)) {
                          return true;
                      }
                  }
              }));
          }

          ret = this.pushStack([]);

          for (i = 0; i < len; i++) {
              jQuery.find(selector, self[i], ret);
          }

          return len > 1 ? jQuery.uniqueSort(ret) : ret;
      },
      filter: function (selector) {
          return this.pushStack(winnow(this, selector || [], false));
      },
      not: function (selector) {
          return this.pushStack(winnow(this, selector || [], true));
      },
      is: function (selector) {
          return !!winnow(
              this,

              // If this is a positional/relative selector, check membership in the returned set
              // so $("p:first").is("p:last") won't return true for a doc with two "p".
              typeof selector === "string" && rneedsContext.test(selector) ?
                  jQuery(selector) :
                  selector || [],
              false
          ).length;
      }
  });


  // Initialize a jQuery object


  // A central reference to the root jQuery(document)
  var rootjQuery,

      // A simple way to check for HTML strings
      // Prioritize #id over <tag> to avoid XSS via location.hash (#9521)
      // Strict HTML recognition (#11290: must start with <)
      // Shortcut simple #id case for speed
      rquickExpr = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/,

      init$2$1 = jQuery.fn.init = function (selector, context, root) {
          var match, elem;

          // HANDLE: $(""), $(null), $(undefined), $(false)
          if (!selector) {
              return this;
          }

          // Method init() accepts an alternate rootjQuery
          // so migrate can support jQuery.sub (gh-2101)
          root = root || rootjQuery;

          // Handle HTML strings
          if (typeof selector === "string") {
              if (selector[0] === "<" &&
                  selector[selector.length - 1] === ">" &&
                  selector.length >= 3) {

                  // Assume that strings that start and end with <> are HTML and skip the regex check
                  match = [null, selector, null];

              } else {
                  match = rquickExpr.exec(selector);
              }

              // Match html or make sure no context is specified for #id
              if (match && (match[1] || !context)) {

                  // HANDLE: $(html) -> $(array)
                  if (match[1]) {
                      context = context instanceof jQuery ? context[0] : context;

                      // Option to run scripts is true for back-compat
                      // Intentionally let the error be thrown if parseHTML is not present
                      jQuery.merge(this, jQuery.parseHTML(
                          match[1],
                          context && context.nodeType ? context.ownerDocument || context : document$1,
                          true
                      ));

                      // HANDLE: $(html, props)
                      if (rsingleTag.test(match[1]) && jQuery.isPlainObject(context)) {
                          for (match in context) {

                              // Properties of context are called as methods if possible
                              if (isFunction(this[match])) {
                                  this[match](context[match]);

                                  // ...and otherwise set as attributes
                              } else {
                                  this.attr(match, context[match]);
                              }
                          }
                      }

                      return this;

                      // HANDLE: $(#id)
                  } else {
                      elem = document$1.getElementById(match[2]);

                      if (elem) {

                          // Inject the element directly into the jQuery object
                          this[0] = elem;
                          this.length = 1;
                      }
                      return this;
                  }

                  // HANDLE: $(expr, $(...))
              } else if (!context || context.jquery) {
                  return (context || root).find(selector);

                  // HANDLE: $(expr, context)
                  // (which is just equivalent to: $(context).find(expr)
              } else {
                  return this.constructor(context).find(selector);
              }

              // HANDLE: $(DOMElement)
          } else if (selector.nodeType) {
              this[0] = selector;
              this.length = 1;
              return this;

              // HANDLE: $(function)
              // Shortcut for document ready
          } else if (isFunction(selector)) {
              return root.ready !== undefined ?
                  root.ready(selector) :

                  // Execute immediately if ready is not present
                  selector(jQuery);
          }

          return jQuery.makeArray(selector, this);
      };

  // Give the init function the jQuery prototype for later instantiation
  init$2$1.prototype = jQuery.fn;

  // Initialize central reference
  rootjQuery = jQuery(document$1);


  var rparentsprev = /^(?:parents|prev(?:Until|All))/,

      // Methods guaranteed to produce a unique set when starting from a unique set
      guaranteedUnique = {
          children: true,
          contents: true,
          next: true,
          prev: true
      };

  jQuery.fn.extend({
      has: function (target) {
          var targets = jQuery(target, this),
              l = targets.length;

          return this.filter(function () {
              var i = 0;
              for (; i < l; i++) {
                  if (jQuery.contains(this, targets[i])) {
                      return true;
                  }
              }
          });
      },

      closest: function (selectors, context) {
          var cur,
              i = 0,
              l = this.length,
              matched = [],
              targets = typeof selectors !== "string" && jQuery(selectors);

          // Positional selectors never match, since there's no _selection_ context
          if (!rneedsContext.test(selectors)) {
              for (; i < l; i++) {
                  for (cur = this[i]; cur && cur !== context; cur = cur.parentNode) {

                      // Always skip document fragments
                      if (cur.nodeType < 11 && (targets ?
                          targets.index(cur) > -1 :

                          // Don't pass non-elements to Sizzle
                          cur.nodeType === 1 &&
                          jQuery.find.matchesSelector(cur, selectors))) {

                          matched.push(cur);
                          break;
                      }
                  }
              }
          }

          return this.pushStack(matched.length > 1 ? jQuery.uniqueSort(matched) : matched);
      },

      // Determine the position of an element within the set
      index: function (elem) {

          // No argument, return index in parent
          if (!elem) {
              return (this[0] && this[0].parentNode) ? this.first().prevAll().length : -1;
          }

          // Index in selector
          if (typeof elem === "string") {
              return indexOf.call(jQuery(elem), this[0]);
          }

          // Locate the position of the desired element
          return indexOf.call(this,

              // If it receives a jQuery object, the first element is used
              elem.jquery ? elem[0] : elem
          );
      },

      add: function (selector, context) {
          return this.pushStack(
              jQuery.uniqueSort(
                  jQuery.merge(this.get(), jQuery(selector, context))
              )
          );
      },

      addBack: function (selector) {
          return this.add(selector == null ?
              this.prevObject : this.prevObject.filter(selector)
          );
      }
  });

  function sibling(cur, dir) {
      while ((cur = cur[dir]) && cur.nodeType !== 1) {
      }
      return cur;
  }

  jQuery.each({
      parent: function (elem) {
          var parent = elem.parentNode;
          return parent && parent.nodeType !== 11 ? parent : null;
      },
      parents: function (elem) {
          return dir(elem, "parentNode");
      },
      parentsUntil: function (elem, i, until) {
          return dir(elem, "parentNode", until);
      },
      next: function (elem) {
          return sibling(elem, "nextSibling");
      },
      prev: function (elem) {
          return sibling(elem, "previousSibling");
      },
      nextAll: function (elem) {
          return dir(elem, "nextSibling");
      },
      prevAll: function (elem) {
          return dir(elem, "previousSibling");
      },
      nextUntil: function (elem, i, until) {
          return dir(elem, "nextSibling", until);
      },
      prevUntil: function (elem, i, until) {
          return dir(elem, "previousSibling", until);
      },
      siblings: function (elem) {
          return siblings((elem.parentNode || {}).firstChild, elem);
      },
      children: function (elem) {
          return siblings(elem.firstChild);
      },
      contents: function (elem) {
          if (nodeName(elem, "iframe")) {
              return elem.contentDocument;
          }

          // Support: IE 9 - 11 only, iOS 7 only, Android Browser <=4.3 only
          // Treat the template element as a regular one in browsers that
          // don't support it.
          if (nodeName(elem, "template")) {
              elem = elem.content || elem;
          }

          return jQuery.merge([], elem.childNodes);
      }
  }, function (name, fn) {
      jQuery.fn[name] = function (until, selector) {
          var matched = jQuery.map(this, fn, until);

          if (name.slice(-5) !== "Until") {
              selector = until;
          }

          if (selector && typeof selector === "string") {
              matched = jQuery.filter(selector, matched);
          }

          if (this.length > 1) {

              // Remove duplicates
              if (!guaranteedUnique[name]) {
                  jQuery.uniqueSort(matched);
              }

              // Reverse order for parents* and prev-derivatives
              if (rparentsprev.test(name)) {
                  matched.reverse();
              }
          }

          return this.pushStack(matched);
      };
  });
  var rnothtmlwhite = (/[^\x20\t\r\n\f]+/g);


  // Convert String-formatted options into Object-formatted ones
  function createOptions(options) {
      var object = {};
      jQuery.each(options.match(rnothtmlwhite) || [], function (_, flag) {
          object[flag] = true;
      });
      return object;
  }

  /*
   * Create a callback list using the following parameters:
   *
   *	options: an optional list of space-separated options that will change how
   *			the callback list behaves or a more traditional option object
   *
   * By default a callback list will act like an event callback list and can be
   * "fired" multiple times.
   *
   * Possible options:
   *
   *	once:			will ensure the callback list can only be fired once (like a Deferred)
   *
   *	memory:			will keep track of previous values and will call any callback added
   *					after the list has been fired right away with the latest "memorized"
   *					values (like a Deferred)
   *
   *	unique:			will ensure a callback can only be added once (no duplicate in the list)
   *
   *	stopOnFalse:	interrupt callings when a callback returns false
   *
   */
  jQuery.Callbacks = function (options) {

      // Convert options from String-formatted to Object-formatted if needed
      // (we check in cache first)
      options = typeof options === "string" ?
          createOptions(options) :
          jQuery.extend({}, options);

      var // Flag to know if list is currently firing
          firing,

          // Last fire value for non-forgettable lists
          memory,

          // Flag to know if list was already fired
          fired,

          // Flag to prevent firing
          locked,

          // Actual callback list
          list = [],

          // Queue of execution data for repeatable lists
          queue = [],

          // Index of currently firing callback (modified by add/remove as needed)
          firingIndex = -1,

          // Fire callbacks
          fire = function () {

              // Enforce single-firing
              locked = locked || options.once;

              // Execute callbacks for all pending executions,
              // respecting firingIndex overrides and runtime changes
              fired = firing = true;
              for (; queue.length; firingIndex = -1) {
                  memory = queue.shift();
                  while (++firingIndex < list.length) {

                      // Run callback and check for early termination
                      if (list[firingIndex].apply(memory[0], memory[1]) === false &&
                          options.stopOnFalse) {

                          // Jump to end and forget the data so .add doesn't re-fire
                          firingIndex = list.length;
                          memory = false;
                      }
                  }
              }

              // Forget the data if we're done with it
              if (!options.memory) {
                  memory = false;
              }

              firing = false;

              // Clean up if we're done firing for good
              if (locked) {

                  // Keep an empty list if we have data for future add calls
                  if (memory) {
                      list = [];

                      // Otherwise, this object is spent
                  } else {
                      list = "";
                  }
              }
          },

          // Actual Callbacks object
          self = {

              // Add a callback or a collection of callbacks to the list
              add: function () {
                  if (list) {

                      // If we have memory from a past run, we should fire after adding
                      if (memory && !firing) {
                          firingIndex = list.length - 1;
                          queue.push(memory);
                      }

                      (function add(args) {
                          jQuery.each(args, function (_, arg) {
                              if (isFunction(arg)) {
                                  if (!options.unique || !self.has(arg)) {
                                      list.push(arg);
                                  }
                              } else if (arg && arg.length && toType(arg) !== "string") {

                                  // Inspect recursively
                                  add(arg);
                              }
                          });
                      })(arguments);

                      if (memory && !firing) {
                          fire();
                      }
                  }
                  return this;
              },

              // Remove a callback from the list
              remove: function () {
                  jQuery.each(arguments, function (_, arg) {
                      var index;
                      while ((index = jQuery.inArray(arg, list, index)) > -1) {
                          list.splice(index, 1);

                          // Handle firing indexes
                          if (index <= firingIndex) {
                              firingIndex--;
                          }
                      }
                  });
                  return this;
              },

              // Check if a given callback is in the list.
              // If no argument is given, return whether or not list has callbacks attached.
              has: function (fn) {
                  return fn ?
                      jQuery.inArray(fn, list) > -1 :
                      list.length > 0;
              },

              // Remove all callbacks from the list
              empty: function () {
                  if (list) {
                      list = [];
                  }
                  return this;
              },

              // Disable .fire and .add
              // Abort any current/pending executions
              // Clear all callbacks and values
              disable: function () {
                  locked = queue = [];
                  list = memory = "";
                  return this;
              },
              disabled: function () {
                  return !list;
              },

              // Disable .fire
              // Also disable .add unless we have memory (since it would have no effect)
              // Abort any pending executions
              lock: function () {
                  locked = queue = [];
                  if (!memory && !firing) {
                      list = memory = "";
                  }
                  return this;
              },
              locked: function () {
                  return !!locked;
              },

              // Call all callbacks with the given context and arguments
              fireWith: function (context, args) {
                  if (!locked) {
                      args = args || [];
                      args = [context, args.slice ? args.slice() : args];
                      queue.push(args);
                      if (!firing) {
                          fire();
                      }
                  }
                  return this;
              },

              // Call all the callbacks with the given arguments
              fire: function () {
                  self.fireWith(this, arguments);
                  return this;
              },

              // To know if the callbacks have already been called at least once
              fired: function () {
                  return !!fired;
              }
          };

      return self;
  };


  function Identity(v) {
      return v;
  }

  function Thrower(ex) {
      throw ex;
  }

  function adoptValue(value, resolve, reject, noValue) {
      var method;

      try {

          // Check for promise aspect first to privilege synchronous behavior
          if (value && isFunction((method = value.promise))) {
              method.call(value).done(resolve).fail(reject);

              // Other thenables
          } else if (value && isFunction((method = value.then))) {
              method.call(value, resolve, reject);

              // Other non-thenables
          } else {

              // Control `resolve` arguments by letting Array#slice cast boolean `noValue` to integer:
              // * false: [ value ].slice( 0 ) => resolve( value )
              // * true: [ value ].slice( 1 ) => resolve()
              resolve.apply(undefined, [value].slice(noValue));
          }

          // For Promises/A+, convert exceptions into rejections
          // Since jQuery.when doesn't unwrap thenables, we can skip the extra checks appearing in
          // Deferred#then to conditionally suppress rejection.
      } catch (value) {

          // Support: Android 4.0 only
          // Strict mode functions invoked without .call/.apply get global-object context
          reject.apply(undefined, [value]);
      }
  }

  jQuery.extend({

      Deferred: function (func) {
          var tuples = [

                  // action, add listener, callbacks,
                  // ... .then handlers, argument index, [final state]
                  ["notify", "progress", jQuery.Callbacks("memory"),
                      jQuery.Callbacks("memory"), 2],
                  ["resolve", "done", jQuery.Callbacks("once memory"),
                      jQuery.Callbacks("once memory"), 0, "resolved"],
                  ["reject", "fail", jQuery.Callbacks("once memory"),
                      jQuery.Callbacks("once memory"), 1, "rejected"]
              ],
              state = "pending",
              promise = {
                  state: function () {
                      return state;
                  },
                  always: function () {
                      deferred.done(arguments).fail(arguments);
                      return this;
                  },
                  "catch": function (fn) {
                      return promise.then(null, fn);
                  },

                  // Keep pipe for back-compat
                  pipe: function ( /* fnDone, fnFail, fnProgress */) {
                      var fns = arguments;

                      return jQuery.Deferred(function (newDefer) {
                          jQuery.each(tuples, function (i, tuple) {

                              // Map tuples (progress, done, fail) to arguments (done, fail, progress)
                              var fn = isFunction(fns[tuple[4]]) && fns[tuple[4]];

                              // deferred.progress(function() { bind to newDefer or newDefer.notify })
                              // deferred.done(function() { bind to newDefer or newDefer.resolve })
                              // deferred.fail(function() { bind to newDefer or newDefer.reject })
                              deferred[tuple[1]](function () {
                                  var returned = fn && fn.apply(this, arguments);
                                  if (returned && isFunction(returned.promise)) {
                                      returned.promise()
                                          .progress(newDefer.notify)
                                          .done(newDefer.resolve)
                                          .fail(newDefer.reject);
                                  } else {
                                      newDefer[tuple[0] + "With"](
                                          this,
                                          fn ? [returned] : arguments
                                      );
                                  }
                              });
                          });
                          fns = null;
                      }).promise();
                  },
                  then: function (onFulfilled, onRejected, onProgress) {
                      var maxDepth = 0;

                      function resolve(depth, deferred, handler, special) {
                          return function () {
                              var that = this,
                                  args = arguments,
                                  mightThrow = function () {
                                      var returned, then;

                                      // Support: Promises/A+ section 2.3.3.3.3
                                      // https://promisesaplus.com/#point-59
                                      // Ignore double-resolution attempts
                                      if (depth < maxDepth) {
                                          return;
                                      }

                                      returned = handler.apply(that, args);

                                      // Support: Promises/A+ section 2.3.1
                                      // https://promisesaplus.com/#point-48
                                      if (returned === deferred.promise()) {
                                          throw new TypeError("Thenable self-resolution");
                                      }

                                      // Support: Promises/A+ sections 2.3.3.1, 3.5
                                      // https://promisesaplus.com/#point-54
                                      // https://promisesaplus.com/#point-75
                                      // Retrieve `then` only once
                                      then = returned &&

                                          // Support: Promises/A+ section 2.3.4
                                          // https://promisesaplus.com/#point-64
                                          // Only check objects and functions for thenability
                                          (typeof returned === "object" ||
                                              typeof returned === "function") &&
                                          returned.then;

                                      // Handle a returned thenable
                                      if (isFunction(then)) {

                                          // Special processors (notify) just wait for resolution
                                          if (special) {
                                              then.call(
                                                  returned,
                                                  resolve(maxDepth, deferred, Identity, special),
                                                  resolve(maxDepth, deferred, Thrower, special)
                                              );

                                              // Normal processors (resolve) also hook into progress
                                          } else {

                                              // ...and disregard older resolution values
                                              maxDepth++;

                                              then.call(
                                                  returned,
                                                  resolve(maxDepth, deferred, Identity, special),
                                                  resolve(maxDepth, deferred, Thrower, special),
                                                  resolve(maxDepth, deferred, Identity,
                                                      deferred.notifyWith)
                                              );
                                          }

                                          // Handle all other returned values
                                      } else {

                                          // Only substitute handlers pass on context
                                          // and multiple values (non-spec behavior)
                                          if (handler !== Identity) {
                                              that = undefined;
                                              args = [returned];
                                          }

                                          // Process the value(s)
                                          // Default process is resolve
                                          (special || deferred.resolveWith)(that, args);
                                      }
                                  },

                                  // Only normal processors (resolve) catch and reject exceptions
                                  process = special ?
                                      mightThrow :
                                      function () {
                                          try {
                                              mightThrow();
                                          } catch (e) {

                                              if (jQuery.Deferred.exceptionHook) {
                                                  jQuery.Deferred.exceptionHook(e,
                                                      process.stackTrace);
                                              }

                                              // Support: Promises/A+ section 2.3.3.3.4.1
                                              // https://promisesaplus.com/#point-61
                                              // Ignore post-resolution exceptions
                                              if (depth + 1 >= maxDepth) {

                                                  // Only substitute handlers pass on context
                                                  // and multiple values (non-spec behavior)
                                                  if (handler !== Thrower) {
                                                      that = undefined;
                                                      args = [e];
                                                  }

                                                  deferred.rejectWith(that, args);
                                              }
                                          }
                                      };

                              // Support: Promises/A+ section 2.3.3.3.1
                              // https://promisesaplus.com/#point-57
                              // Re-resolve promises immediately to dodge false rejection from
                              // subsequent errors
                              if (depth) {
                                  process();
                              } else {

                                  // Call an optional hook to record the stack, in case of exception
                                  // since it's otherwise lost when execution goes async
                                  if (jQuery.Deferred.getStackHook) {
                                      process.stackTrace = jQuery.Deferred.getStackHook();
                                  }
                                  window.setTimeout(process);
                              }
                          };
                      }

                      return jQuery.Deferred(function (newDefer) {

                          // progress_handlers.add( ... )
                          tuples[0][3].add(
                              resolve(
                                  0,
                                  newDefer,
                                  isFunction(onProgress) ?
                                      onProgress :
                                      Identity,
                                  newDefer.notifyWith
                              )
                          );

                          // fulfilled_handlers.add( ... )
                          tuples[1][3].add(
                              resolve(
                                  0,
                                  newDefer,
                                  isFunction(onFulfilled) ?
                                      onFulfilled :
                                      Identity
                              )
                          );

                          // rejected_handlers.add( ... )
                          tuples[2][3].add(
                              resolve(
                                  0,
                                  newDefer,
                                  isFunction(onRejected) ?
                                      onRejected :
                                      Thrower
                              )
                          );
                      }).promise();
                  },

                  // Get a promise for this deferred
                  // If obj is provided, the promise aspect is added to the object
                  promise: function (obj) {
                      return obj != null ? jQuery.extend(obj, promise) : promise;
                  }
              },
              deferred = {};

          // Add list-specific methods
          jQuery.each(tuples, function (i, tuple) {
              var list = tuple[2],
                  stateString = tuple[5];

              // promise.progress = list.add
              // promise.done = list.add
              // promise.fail = list.add
              promise[tuple[1]] = list.add;

              // Handle state
              if (stateString) {
                  list.add(
                      function () {

                          // state = "resolved" (i.e., fulfilled)
                          // state = "rejected"
                          state = stateString;
                      },

                      // rejected_callbacks.disable
                      // fulfilled_callbacks.disable
                      tuples[3 - i][2].disable,

                      // rejected_handlers.disable
                      // fulfilled_handlers.disable
                      tuples[3 - i][3].disable,

                      // progress_callbacks.lock
                      tuples[0][2].lock,

                      // progress_handlers.lock
                      tuples[0][3].lock
                  );
              }

              // progress_handlers.fire
              // fulfilled_handlers.fire
              // rejected_handlers.fire
              list.add(tuple[3].fire);

              // deferred.notify = function() { deferred.notifyWith(...) }
              // deferred.resolve = function() { deferred.resolveWith(...) }
              // deferred.reject = function() { deferred.rejectWith(...) }
              deferred[tuple[0]] = function () {
                  deferred[tuple[0] + "With"](this === deferred ? undefined : this, arguments);
                  return this;
              };

              // deferred.notifyWith = list.fireWith
              // deferred.resolveWith = list.fireWith
              // deferred.rejectWith = list.fireWith
              deferred[tuple[0] + "With"] = list.fireWith;
          });

          // Make the deferred a promise
          promise.promise(deferred);

          // Call given func if any
          if (func) {
              func.call(deferred, deferred);
          }

          // All done!
          return deferred;
      },

      // Deferred helper
      when: function (singleValue) {
          var

              // count of uncompleted subordinates
              remaining = arguments.length,

              // count of unprocessed arguments
              i = remaining,

              // subordinate fulfillment data
              resolveContexts = Array(i),
              resolveValues = slice.call(arguments),

              // the master Deferred
              master = jQuery.Deferred(),

              // subordinate callback factory
              updateFunc = function (i) {
                  return function (value) {
                      resolveContexts[i] = this;
                      resolveValues[i] = arguments.length > 1 ? slice.call(arguments) : value;
                      if (!(--remaining)) {
                          master.resolveWith(resolveContexts, resolveValues);
                      }
                  };
              };

          // Single- and empty arguments are adopted like Promise.resolve
          if (remaining <= 1) {
              adoptValue(singleValue, master.done(updateFunc(i)).resolve, master.reject,
                  !remaining);

              // Use .then() to unwrap secondary thenables (cf. gh-3000)
              if (master.state() === "pending" ||
                  isFunction(resolveValues[i] && resolveValues[i].then)) {

                  return master.then();
              }
          }

          // Multiple arguments are aggregated like Promise.all array elements
          while (i--) {
              adoptValue(resolveValues[i], updateFunc(i), master.reject);
          }

          return master.promise();
      }
  });


  // These usually indicate a programmer mistake during development,
  // warn about them ASAP rather than swallowing them by default.
  var rerrorNames = /^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;

  jQuery.Deferred.exceptionHook = function (error, stack) {

      // Support: IE 8 - 9 only
      // Console exists when dev tools are open, which can happen at any time
      if (window.console && window.console.warn && error && rerrorNames.test(error.name)) {
          window.console.warn("jQuery.Deferred exception: " + error.message, error.stack, stack);
      }
  };


  jQuery.readyException = function (error) {
      window.setTimeout(function () {
          throw error;
      });
  };


  // The deferred used on DOM ready
  var readyList = jQuery.Deferred();

  jQuery.fn.ready = function (fn) {

      readyList
          .then(fn)

          // Wrap jQuery.readyException in a function so that the lookup
          // happens at the time of error handling instead of callback
          // registration.
          .catch(function (error) {
              jQuery.readyException(error);
          });

      return this;
  };

  jQuery.extend({

      // Is the DOM ready to be used? Set to true once it occurs.
      isReady: false,

      // A counter to track how many items to wait for before
      // the ready event fires. See #6781
      readyWait: 1,

      // Handle when the DOM is ready
      ready: function (wait) {

          // Abort if there are pending holds or we're already ready
          if (wait === true ? --jQuery.readyWait : jQuery.isReady) {
              return;
          }

          // Remember that the DOM is ready
          jQuery.isReady = true;

          // If a normal DOM Ready event fired, decrement, and wait if need be
          if (wait !== true && --jQuery.readyWait > 0) {
              return;
          }

          // If there are functions bound, to execute
          readyList.resolveWith(document$1, [jQuery]);
      }
  });

  jQuery.ready.then = readyList.then;

  // The ready event handler and self cleanup method
  function completed() {
      document$1.removeEventListener("DOMContentLoaded", completed);
      window.removeEventListener("load", completed);
      jQuery.ready();
  }

  // Catch cases where $(document).ready() is called
  // after the browser event has already occurred.
  // Support: IE <=9 - 10 only
  // Older IE sometimes signals "interactive" too soon
  if (document$1.readyState === "complete" ||
      (document$1.readyState !== "loading" && !document$1.documentElement.doScroll)) {

      // Handle it asynchronously to allow scripts the opportunity to delay ready
      window.setTimeout(jQuery.ready);

  } else {

      // Use the handy event callback
      document$1.addEventListener("DOMContentLoaded", completed);

      // A fallback to window.onload, that will always work
      window.addEventListener("load", completed);
  }


  // Multifunctional method to get and set values of a collection
  // The value/s can optionally be executed if it's a function
  var access = function (elems, fn, key, value, chainable, emptyGet, raw) {
      var i = 0,
          len = elems.length,
          bulk = key == null;

      // Sets many values
      if (toType(key) === "object") {
          chainable = true;
          for (i in key) {
              access(elems, fn, i, key[i], true, emptyGet, raw);
          }

          // Sets one value
      } else if (value !== undefined) {
          chainable = true;

          if (!isFunction(value)) {
              raw = true;
          }

          if (bulk) {

              // Bulk operations run against the entire set
              if (raw) {
                  fn.call(elems, value);
                  fn = null;

                  // ...except when executing function values
              } else {
                  bulk = fn;
                  fn = function (elem, key, value) {
                      return bulk.call(jQuery(elem), value);
                  };
              }
          }

          if (fn) {
              for (; i < len; i++) {
                  fn(
                      elems[i], key, raw ?
                          value :
                          value.call(elems[i], i, fn(elems[i], key))
                  );
              }
          }
      }

      if (chainable) {
          return elems;
      }

      // Gets
      if (bulk) {
          return fn.call(elems);
      }

      return len ? fn(elems[0], key) : emptyGet;
  };


  // Matches dashed string for camelizing
  var rmsPrefix = /^-ms-/,
      rdashAlpha = /-([a-z])/g;

  // Used by camelCase as callback to replace()
  function fcamelCase(all, letter) {
      return letter.toUpperCase();
  }

  // Convert dashed to camelCase; used by the css and data modules
  // Support: IE <=9 - 11, Edge 12 - 15
  // Microsoft forgot to hump their vendor prefix (#9572)
  function camelCase(string) {
      return string.replace(rmsPrefix, "ms-").replace(rdashAlpha, fcamelCase);
  }

  var acceptData = function (owner) {

      // Accepts only:
      //  - Node
      //    - Node.ELEMENT_NODE
      //    - Node.DOCUMENT_NODE
      //  - Object
      //    - Any
      return owner.nodeType === 1 || owner.nodeType === 9 || !(+owner.nodeType);
  };


  function Data() {
      this.expando = jQuery.expando + Data.uid++;
  }

  Data.uid = 1;

  Data.prototype = {

      cache: function (owner) {

          // Check if the owner object already has a cache
          var value = owner[this.expando];

          // If not, create one
          if (!value) {
              value = {};

              // We can accept data for non-element nodes in modern browsers,
              // but we should not, see #8335.
              // Always return an empty object.
              if (acceptData(owner)) {

                  // If it is a node unlikely to be stringify-ed or looped over
                  // use plain assignment
                  if (owner.nodeType) {
                      owner[this.expando] = value;

                      // Otherwise secure it in a non-enumerable property
                      // configurable must be true to allow the property to be
                      // deleted when data is removed
                  } else {
                      Object.defineProperty(owner, this.expando, {
                          value: value,
                          configurable: true
                      });
                  }
              }
          }

          return value;
      },
      set: function (owner, data, value) {
          var prop,
              cache = this.cache(owner);

          // Handle: [ owner, key, value ] args
          // Always use camelCase key (gh-2257)
          if (typeof data === "string") {
              cache[camelCase(data)] = value;

              // Handle: [ owner, { properties } ] args
          } else {

              // Copy the properties one-by-one to the cache object
              for (prop in data) {
                  cache[camelCase(prop)] = data[prop];
              }
          }
          return cache;
      },
      get: function (owner, key) {
          return key === undefined ?
              this.cache(owner) :

              // Always use camelCase key (gh-2257)
              owner[this.expando] && owner[this.expando][camelCase(key)];
      },
      access: function (owner, key, value) {

          // In cases where either:
          //
          //   1. No key was specified
          //   2. A string key was specified, but no value provided
          //
          // Take the "read" path and allow the get method to determine
          // which value to return, respectively either:
          //
          //   1. The entire cache object
          //   2. The data stored at the key
          //
          if (key === undefined ||
              ((key && typeof key === "string") && value === undefined)) {

              return this.get(owner, key);
          }

          // When the key is not a string, or both a key and value
          // are specified, set or extend (existing objects) with either:
          //
          //   1. An object of properties
          //   2. A key and value
          //
          this.set(owner, key, value);

          // Since the "set" path can have two possible entry points
          // return the expected data based on which path was taken[*]
          return value !== undefined ? value : key;
      },
      remove: function (owner, key) {
          var i,
              cache = owner[this.expando];

          if (cache === undefined) {
              return;
          }

          if (key !== undefined) {

              // Support array or space separated string of keys
              if (Array.isArray(key)) {

                  // If key is an array of keys...
                  // We always set camelCase keys, so remove that.
                  key = key.map(camelCase);
              } else {
                  key = camelCase(key);

                  // If a key with the spaces exists, use it.
                  // Otherwise, create an array by matching non-whitespace
                  key = key in cache ?
                      [key] :
                      (key.match(rnothtmlwhite) || []);
              }

              i = key.length;

              while (i--) {
                  delete cache[key[i]];
              }
          }

          // Remove the expando if there's no more data
          if (key === undefined || jQuery.isEmptyObject(cache)) {

              // Support: Chrome <=35 - 45
              // Webkit & Blink performance suffers when deleting properties
              // from DOM nodes, so set to undefined instead
              // https://bugs.chromium.org/p/chromium/issues/detail?id=378607 (bug restricted)
              if (owner.nodeType) {
                  owner[this.expando] = undefined;
              } else {
                  delete owner[this.expando];
              }
          }
      },
      hasData: function (owner) {
          var cache = owner[this.expando];
          return cache !== undefined && !jQuery.isEmptyObject(cache);
      }
  };
  var dataPriv = new Data();

  var dataUser = new Data();


  //	Implementation Summary
  //
  //	1. Enforce API surface and semantic compatibility with 1.9.x branch
  //	2. Improve the module's maintainability by reducing the storage
  //		paths to a single mechanism.
  //	3. Use the same single mechanism to support "private" and "user" data.
  //	4. _Never_ expose "private" data to user code (TODO: Drop _data, _removeData)
  //	5. Avoid exposing implementation details on user objects (eg. expando properties)
  //	6. Provide a clear path for implementation upgrade to WeakMap in 2014

  var rbrace = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,
      rmultiDash = /[A-Z]/g;

  function getData(data) {
      if (data === "true") {
          return true;
      }

      if (data === "false") {
          return false;
      }

      if (data === "null") {
          return null;
      }

      // Only convert to a number if it doesn't change the string
      if (data === +data + "") {
          return +data;
      }

      if (rbrace.test(data)) {
          return JSON.parse(data);
      }

      return data;
  }

  function dataAttr(elem, key, data) {
      var name;

      // If nothing was found internally, try to fetch any
      // data from the HTML5 data-* attribute
      if (data === undefined && elem.nodeType === 1) {
          name = "data-" + key.replace(rmultiDash, "-$&").toLowerCase();
          data = elem.getAttribute(name);

          if (typeof data === "string") {
              try {
                  data = getData(data);
              } catch (e) {
              }

              // Make sure we set the data so it isn't changed later
              dataUser.set(elem, key, data);
          } else {
              data = undefined;
          }
      }
      return data;
  }

  jQuery.extend({
      hasData: function (elem) {
          return dataUser.hasData(elem) || dataPriv.hasData(elem);
      },

      data: function (elem, name, data) {
          return dataUser.access(elem, name, data);
      },

      removeData: function (elem, name) {
          dataUser.remove(elem, name);
      },

      // TODO: Now that all calls to _data and _removeData have been replaced
      // with direct calls to dataPriv methods, these can be deprecated.
      _data: function (elem, name, data) {
          return dataPriv.access(elem, name, data);
      },

      _removeData: function (elem, name) {
          dataPriv.remove(elem, name);
      }
  });

  jQuery.fn.extend({
      data: function (key, value) {
          var i, name, data,
              elem = this[0],
              attrs = elem && elem.attributes;

          // Gets all values
          if (key === undefined) {
              if (this.length) {
                  data = dataUser.get(elem);

                  if (elem.nodeType === 1 && !dataPriv.get(elem, "hasDataAttrs")) {
                      i = attrs.length;
                      while (i--) {

                          // Support: IE 11 only
                          // The attrs elements can be null (#14894)
                          if (attrs[i]) {
                              name = attrs[i].name;
                              if (name.indexOf("data-") === 0) {
                                  name = camelCase(name.slice(5));
                                  dataAttr(elem, name, data[name]);
                              }
                          }
                      }
                      dataPriv.set(elem, "hasDataAttrs", true);
                  }
              }

              return data;
          }

          // Sets multiple values
          if (typeof key === "object") {
              return this.each(function () {
                  dataUser.set(this, key);
              });
          }

          return access(this, function (value) {
              var data;

              // The calling jQuery object (element matches) is not empty
              // (and therefore has an element appears at this[ 0 ]) and the
              // `value` parameter was not undefined. An empty jQuery object
              // will result in `undefined` for elem = this[ 0 ] which will
              // throw an exception if an attempt to read a data cache is made.
              if (elem && value === undefined) {

                  // Attempt to get data from the cache
                  // The key will always be camelCased in Data
                  data = dataUser.get(elem, key);
                  if (data !== undefined) {
                      return data;
                  }

                  // Attempt to "discover" the data in
                  // HTML5 custom data-* attrs
                  data = dataAttr(elem, key);
                  if (data !== undefined) {
                      return data;
                  }

                  // We tried really hard, but the data doesn't exist.
                  return;
              }

              // Set the data...
              this.each(function () {

                  // We always store the camelCased key
                  dataUser.set(this, key, value);
              });
          }, null, value, arguments.length > 1, null, true);
      },

      removeData: function (key) {
          return this.each(function () {
              dataUser.remove(this, key);
          });
      }
  });


  jQuery.extend({
      queue: function (elem, type, data) {
          var queue;

          if (elem) {
              type = (type || "fx") + "queue";
              queue = dataPriv.get(elem, type);

              // Speed up dequeue by getting out quickly if this is just a lookup
              if (data) {
                  if (!queue || Array.isArray(data)) {
                      queue = dataPriv.access(elem, type, jQuery.makeArray(data));
                  } else {
                      queue.push(data);
                  }
              }
              return queue || [];
          }
      },

      dequeue: function (elem, type) {
          type = type || "fx";

          var queue = jQuery.queue(elem, type),
              startLength = queue.length,
              fn = queue.shift(),
              hooks = jQuery._queueHooks(elem, type),
              next = function () {
                  jQuery.dequeue(elem, type);
              };

          // If the fx queue is dequeued, always remove the progress sentinel
          if (fn === "inprogress") {
              fn = queue.shift();
              startLength--;
          }

          if (fn) {

              // Add a progress sentinel to prevent the fx queue from being
              // automatically dequeued
              if (type === "fx") {
                  queue.unshift("inprogress");
              }

              // Clear up the last queue stop function
              delete hooks.stop;
              fn.call(elem, next, hooks);
          }

          if (!startLength && hooks) {
              hooks.empty.fire();
          }
      },

      // Not public - generate a queueHooks object, or return the current one
      _queueHooks: function (elem, type) {
          var key = type + "queueHooks";
          return dataPriv.get(elem, key) || dataPriv.access(elem, key, {
              empty: jQuery.Callbacks("once memory").add(function () {
                  dataPriv.remove(elem, [type + "queue", key]);
              })
          });
      }
  });

  jQuery.fn.extend({
      queue: function (type, data) {
          var setter = 2;

          if (typeof type !== "string") {
              data = type;
              type = "fx";
              setter--;
          }

          if (arguments.length < setter) {
              return jQuery.queue(this[0], type);
          }

          return data === undefined ?
              this :
              this.each(function () {
                  var queue = jQuery.queue(this, type, data);

                  // Ensure a hooks for this queue
                  jQuery._queueHooks(this, type);

                  if (type === "fx" && queue[0] !== "inprogress") {
                      jQuery.dequeue(this, type);
                  }
              });
      },
      dequeue: function (type) {
          return this.each(function () {
              jQuery.dequeue(this, type);
          });
      },
      clearQueue: function (type) {
          return this.queue(type || "fx", []);
      },

      // Get a promise resolved when queues of a certain type
      // are emptied (fx is the type by default)
      promise: function (type, obj) {
          var tmp,
              count = 1,
              defer = jQuery.Deferred(),
              elements = this,
              i = this.length,
              resolve = function () {
                  if (!(--count)) {
                      defer.resolveWith(elements, [elements]);
                  }
              };

          if (typeof type !== "string") {
              obj = type;
              type = undefined;
          }
          type = type || "fx";

          while (i--) {
              tmp = dataPriv.get(elements[i], type + "queueHooks");
              if (tmp && tmp.empty) {
                  count++;
                  tmp.empty.add(resolve);
              }
          }
          resolve();
          return defer.promise(obj);
      }
  });
  var pnum = (/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/).source;

  var rcssNum = new RegExp("^(?:([+-])=|)(" + pnum + ")([a-z%]*)$", "i");


  var cssExpand = ["Top", "Right", "Bottom", "Left"];

  var isHiddenWithinTree = function (elem, el) {

      // isHiddenWithinTree might be called from jQuery#filter function;
      // in that case, element will be second argument
      elem = el || elem;

      // Inline style trumps all
      return elem.style.display === "none" ||
          elem.style.display === "" &&

          // Otherwise, check computed style
          // Support: Firefox <=43 - 45
          // Disconnected elements can have computed display: none, so first confirm that elem is
          // in the document.
          jQuery.contains(elem.ownerDocument, elem) &&

          jQuery.css(elem, "display") === "none";
  };

  var swap = function (elem, options, callback, args) {
      var ret, name,
          old = {};

      // Remember the old values, and insert the new ones
      for (name in options) {
          old[name] = elem.style[name];
          elem.style[name] = options[name];
      }

      ret = callback.apply(elem, args || []);

      // Revert the old values
      for (name in options) {
          elem.style[name] = old[name];
      }

      return ret;
  };


  function adjustCSS(elem, prop, valueParts, tween) {
      var adjusted, scale,
          maxIterations = 20,
          currentValue = tween ?
              function () {
                  return tween.cur();
              } :
              function () {
                  return jQuery.css(elem, prop, "");
              },
          initial = currentValue(),
          unit = valueParts && valueParts[3] || (jQuery.cssNumber[prop] ? "" : "px"),

          // Starting value computation is required for potential unit mismatches
          initialInUnit = (jQuery.cssNumber[prop] || unit !== "px" && +initial) &&
              rcssNum.exec(jQuery.css(elem, prop));

      if (initialInUnit && initialInUnit[3] !== unit) {

          // Support: Firefox <=54
          // Halve the iteration target value to prevent interference from CSS upper bounds (gh-2144)
          initial = initial / 2;

          // Trust units reported by jQuery.css
          unit = unit || initialInUnit[3];

          // Iteratively approximate from a nonzero starting point
          initialInUnit = +initial || 1;

          while (maxIterations--) {

              // Evaluate and update our best guess (doubling guesses that zero out).
              // Finish if the scale equals or crosses 1 (making the old*new product non-positive).
              jQuery.style(elem, prop, initialInUnit + unit);
              if ((1 - scale) * (1 - (scale = currentValue() / initial || 0.5)) <= 0) {
                  maxIterations = 0;
              }
              initialInUnit = initialInUnit / scale;

          }

          initialInUnit = initialInUnit * 2;
          jQuery.style(elem, prop, initialInUnit + unit);

          // Make sure we update the tween properties later on
          valueParts = valueParts || [];
      }

      if (valueParts) {
          initialInUnit = +initialInUnit || +initial || 0;

          // Apply relative offset (+=/-=) if specified
          adjusted = valueParts[1] ?
              initialInUnit + (valueParts[1] + 1) * valueParts[2] :
              +valueParts[2];
          if (tween) {
              tween.unit = unit;
              tween.start = initialInUnit;
              tween.end = adjusted;
          }
      }
      return adjusted;
  }


  var defaultDisplayMap = {};

  function getDefaultDisplay(elem) {
      var temp,
          doc = elem.ownerDocument,
          nodeName = elem.nodeName,
          display = defaultDisplayMap[nodeName];

      if (display) {
          return display;
      }

      temp = doc.body.appendChild(doc.createElement(nodeName));
      display = jQuery.css(temp, "display");

      temp.parentNode.removeChild(temp);

      if (display === "none") {
          display = "block";
      }
      defaultDisplayMap[nodeName] = display;

      return display;
  }

  function showHide(elements, show) {
      var display, elem,
          values = [],
          index = 0,
          length = elements.length;

      // Determine new display value for elements that need to change
      for (; index < length; index++) {
          elem = elements[index];
          if (!elem.style) {
              continue;
          }

          display = elem.style.display;
          if (show) {

              // Since we force visibility upon cascade-hidden elements, an immediate (and slow)
              // check is required in this first loop unless we have a nonempty display value (either
              // inline or about-to-be-restored)
              if (display === "none") {
                  values[index] = dataPriv.get(elem, "display") || null;
                  if (!values[index]) {
                      elem.style.display = "";
                  }
              }
              if (elem.style.display === "" && isHiddenWithinTree(elem)) {
                  values[index] = getDefaultDisplay(elem);
              }
          } else {
              if (display !== "none") {
                  values[index] = "none";

                  // Remember what we're overwriting
                  dataPriv.set(elem, "display", display);
              }
          }
      }

      // Set the display of the elements in a second loop to avoid constant reflow
      for (index = 0; index < length; index++) {
          if (values[index] != null) {
              elements[index].style.display = values[index];
          }
      }

      return elements;
  }

  jQuery.fn.extend({
      show: function () {
          return showHide(this, true);
      },
      hide: function () {
          return showHide(this);
      },
      toggle: function (state) {
          if (typeof state === "boolean") {
              return state ? this.show() : this.hide();
          }

          return this.each(function () {
              if (isHiddenWithinTree(this)) {
                  jQuery(this).show();
              } else {
                  jQuery(this).hide();
              }
          });
      }
  });
  var rcheckableType = (/^(?:checkbox|radio)$/i);

  var rtagName = (/<([a-z][^\/\0>\x20\t\r\n\f]+)/i);

  var rscriptType = (/^$|^module$|\/(?:java|ecma)script/i);


  // We have to close these tags to support XHTML (#13200)
  var wrapMap = {

      // Support: IE <=9 only
      option: [1, "<select multiple='multiple'>", "</select>"],

      // XHTML parsers do not magically insert elements in the
      // same way that tag soup parsers do. So we cannot shorten
      // this by omitting <tbody> or other required elements.
      thead: [1, "<table>", "</table>"],
      col: [2, "<table><colgroup>", "</colgroup></table>"],
      tr: [2, "<table><tbody>", "</tbody></table>"],
      td: [3, "<table><tbody><tr>", "</tr></tbody></table>"],

      _default: [0, "", ""]
  };

  // Support: IE <=9 only
  wrapMap.optgroup = wrapMap.option;

  wrapMap.tbody = wrapMap.tfoot = wrapMap.colgroup = wrapMap.caption = wrapMap.thead;
  wrapMap.th = wrapMap.td;


  function getAll(context, tag) {

      // Support: IE <=9 - 11 only
      // Use typeof to avoid zero-argument method invocation on host objects (#15151)
      var ret;

      if (typeof context.getElementsByTagName !== "undefined") {
          ret = context.getElementsByTagName(tag || "*");

      } else if (typeof context.querySelectorAll !== "undefined") {
          ret = context.querySelectorAll(tag || "*");

      } else {
          ret = [];
      }

      if (tag === undefined || tag && nodeName(context, tag)) {
          return jQuery.merge([context], ret);
      }

      return ret;
  }


  // Mark scripts as having already been evaluated
  function setGlobalEval(elems, refElements) {
      var i = 0,
          l = elems.length;

      for (; i < l; i++) {
          dataPriv.set(
              elems[i],
              "globalEval",
              !refElements || dataPriv.get(refElements[i], "globalEval")
          );
      }
  }


  var rhtml = /<|&#?\w+;/;

  function buildFragment(elems, context, scripts, selection, ignored) {
      var elem, tmp, tag, wrap, contains, j,
          fragment = context.createDocumentFragment(),
          nodes = [],
          i = 0,
          l = elems.length;

      for (; i < l; i++) {
          elem = elems[i];

          if (elem || elem === 0) {

              // Add nodes directly
              if (toType(elem) === "object") {

                  // Support: Android <=4.0 only, PhantomJS 1 only
                  // push.apply(_, arraylike) throws on ancient WebKit
                  jQuery.merge(nodes, elem.nodeType ? [elem] : elem);

                  // Convert non-html into a text node
              } else if (!rhtml.test(elem)) {
                  nodes.push(context.createTextNode(elem));

                  // Convert html into DOM nodes
              } else {
                  tmp = tmp || fragment.appendChild(context.createElement("div"));

                  // Deserialize a standard representation
                  tag = (rtagName.exec(elem) || ["", ""])[1].toLowerCase();
                  wrap = wrapMap[tag] || wrapMap._default;
                  tmp.innerHTML = wrap[1] + jQuery.htmlPrefilter(elem) + wrap[2];

                  // Descend through wrappers to the right content
                  j = wrap[0];
                  while (j--) {
                      tmp = tmp.lastChild;
                  }

                  // Support: Android <=4.0 only, PhantomJS 1 only
                  // push.apply(_, arraylike) throws on ancient WebKit
                  jQuery.merge(nodes, tmp.childNodes);

                  // Remember the top-level container
                  tmp = fragment.firstChild;

                  // Ensure the created nodes are orphaned (#12392)
                  tmp.textContent = "";
              }
          }
      }

      // Remove wrapper from fragment
      fragment.textContent = "";

      i = 0;
      while ((elem = nodes[i++])) {

          // Skip elements already in the context collection (trac-4087)
          if (selection && jQuery.inArray(elem, selection) > -1) {
              if (ignored) {
                  ignored.push(elem);
              }
              continue;
          }

          contains = jQuery.contains(elem.ownerDocument, elem);

          // Append to fragment
          tmp = getAll(fragment.appendChild(elem), "script");

          // Preserve script evaluation history
          if (contains) {
              setGlobalEval(tmp);
          }

          // Capture executables
          if (scripts) {
              j = 0;
              while ((elem = tmp[j++])) {
                  if (rscriptType.test(elem.type || "")) {
                      scripts.push(elem);
                  }
              }
          }
      }

      return fragment;
  }


  (function () {
      var fragment = document$1.createDocumentFragment(),
          div = fragment.appendChild(document$1.createElement("div")),
          input = document$1.createElement("input");

      // Support: Android 4.0 - 4.3 only
      // Check state lost if the name is set (#11217)
      // Support: Windows Web Apps (WWA)
      // `name` and `type` must use .setAttribute for WWA (#14901)
      input.setAttribute("type", "radio");
      input.setAttribute("checked", "checked");
      input.setAttribute("name", "t");

      div.appendChild(input);

      // Support: Android <=4.1 only
      // Older WebKit doesn't clone checked state correctly in fragments
      support.checkClone = div.cloneNode(true).cloneNode(true).lastChild.checked;

      // Support: IE <=11 only
      // Make sure textarea (and checkbox) defaultValue is properly cloned
      div.innerHTML = "<textarea>x</textarea>";
      support.noCloneChecked = !!div.cloneNode(true).lastChild.defaultValue;
  })();
  var documentElement = document$1.documentElement;


  var
      rkeyEvent = /^key/,
      rmouseEvent = /^(?:mouse|pointer|contextmenu|drag|drop)|click/,
      rtypenamespace = /^([^.]*)(?:\.(.+)|)/;

  function returnTrue() {
      return true;
  }

  function returnFalse() {
      return false;
  }

  // Support: IE <=9 only
  // See #13393 for more info
  function safeActiveElement() {
      try {
          return document$1.activeElement;
      } catch (err) {
      }
  }

  function on(elem, types, selector, data, fn, one) {
      var origFn, type;

      // Types can be a map of types/handlers
      if (typeof types === "object") {

          // ( types-Object, selector, data )
          if (typeof selector !== "string") {

              // ( types-Object, data )
              data = data || selector;
              selector = undefined;
          }
          for (type in types) {
              on(elem, type, selector, data, types[type], one);
          }
          return elem;
      }

      if (data == null && fn == null) {

          // ( types, fn )
          fn = selector;
          data = selector = undefined;
      } else if (fn == null) {
          if (typeof selector === "string") {

              // ( types, selector, fn )
              fn = data;
              data = undefined;
          } else {

              // ( types, data, fn )
              fn = data;
              data = selector;
              selector = undefined;
          }
      }
      if (fn === false) {
          fn = returnFalse;
      } else if (!fn) {
          return elem;
      }

      if (one === 1) {
          origFn = fn;
          fn = function (event) {

              // Can use an empty set, since event contains the info
              jQuery().off(event);
              return origFn.apply(this, arguments);
          };

          // Use same guid so caller can remove using origFn
          fn.guid = origFn.guid || (origFn.guid = jQuery.guid++);
      }
      return elem.each(function () {
          jQuery.event.add(this, types, fn, data, selector);
      });
  }

  /*
   * Helper functions for managing events -- not part of the public interface.
   * Props to Dean Edwards' addEvent library for many of the ideas.
   */
  jQuery.event = {

      global: {},

      add: function (elem, types, handler, data, selector) {

          var handleObjIn, eventHandle, tmp,
              events, t, handleObj,
              special, handlers, type, namespaces, origType,
              elemData = dataPriv.get(elem);

          // Don't attach events to noData or text/comment nodes (but allow plain objects)
          if (!elemData) {
              return;
          }

          // Caller can pass in an object of custom data in lieu of the handler
          if (handler.handler) {
              handleObjIn = handler;
              handler = handleObjIn.handler;
              selector = handleObjIn.selector;
          }

          // Ensure that invalid selectors throw exceptions at attach time
          // Evaluate against documentElement in case elem is a non-element node (e.g., document)
          if (selector) {
              jQuery.find.matchesSelector(documentElement, selector);
          }

          // Make sure that the handler has a unique ID, used to find/remove it later
          if (!handler.guid) {
              handler.guid = jQuery.guid++;
          }

          // Init the element's event structure and main handler, if this is the first
          if (!(events = elemData.events)) {
              events = elemData.events = {};
          }
          if (!(eventHandle = elemData.handle)) {
              eventHandle = elemData.handle = function (e) {

                  // Discard the second event of a jQuery.event.trigger() and
                  // when an event is called after a page has unloaded
                  return typeof jQuery !== "undefined" && jQuery.event.triggered !== e.type ?
                      jQuery.event.dispatch.apply(elem, arguments) : undefined;
              };
          }

          // Handle multiple events separated by a space
          types = (types || "").match(rnothtmlwhite) || [""];
          t = types.length;
          while (t--) {
              tmp = rtypenamespace.exec(types[t]) || [];
              type = origType = tmp[1];
              namespaces = (tmp[2] || "").split(".").sort();

              // There *must* be a type, no attaching namespace-only handlers
              if (!type) {
                  continue;
              }

              // If event changes its type, use the special event handlers for the changed type
              special = jQuery.event.special[type] || {};

              // If selector defined, determine special event api type, otherwise given type
              type = (selector ? special.delegateType : special.bindType) || type;

              // Update special based on newly reset type
              special = jQuery.event.special[type] || {};

              // handleObj is passed to all event handlers
              handleObj = jQuery.extend({
                  type: type,
                  origType: origType,
                  data: data,
                  handler: handler,
                  guid: handler.guid,
                  selector: selector,
                  needsContext: selector && jQuery.expr.match.needsContext.test(selector),
                  namespace: namespaces.join(".")
              }, handleObjIn);

              // Init the event handler queue if we're the first
              if (!(handlers = events[type])) {
                  handlers = events[type] = [];
                  handlers.delegateCount = 0;

                  // Only use addEventListener if the special events handler returns false
                  if (!special.setup ||
                      special.setup.call(elem, data, namespaces, eventHandle) === false) {

                      if (elem.addEventListener) {
                          elem.addEventListener(type, eventHandle);
                      }
                  }
              }

              if (special.add) {
                  special.add.call(elem, handleObj);

                  if (!handleObj.handler.guid) {
                      handleObj.handler.guid = handler.guid;
                  }
              }

              // Add to the element's handler list, delegates in front
              if (selector) {
                  handlers.splice(handlers.delegateCount++, 0, handleObj);
              } else {
                  handlers.push(handleObj);
              }

              // Keep track of which events have ever been used, for event optimization
              jQuery.event.global[type] = true;
          }

      },

      // Detach an event or set of events from an element
      remove: function (elem, types, handler, selector, mappedTypes) {

          var j, origCount, tmp,
              events, t, handleObj,
              special, handlers, type, namespaces, origType,
              elemData = dataPriv.hasData(elem) && dataPriv.get(elem);

          if (!elemData || !(events = elemData.events)) {
              return;
          }

          // Once for each type.namespace in types; type may be omitted
          types = (types || "").match(rnothtmlwhite) || [""];
          t = types.length;
          while (t--) {
              tmp = rtypenamespace.exec(types[t]) || [];
              type = origType = tmp[1];
              namespaces = (tmp[2] || "").split(".").sort();

              // Unbind all events (on this namespace, if provided) for the element
              if (!type) {
                  for (type in events) {
                      jQuery.event.remove(elem, type + types[t], handler, selector, true);
                  }
                  continue;
              }

              special = jQuery.event.special[type] || {};
              type = (selector ? special.delegateType : special.bindType) || type;
              handlers = events[type] || [];
              tmp = tmp[2] &&
                  new RegExp("(^|\\.)" + namespaces.join("\\.(?:.*\\.|)") + "(\\.|$)");

              // Remove matching events
              origCount = j = handlers.length;
              while (j--) {
                  handleObj = handlers[j];

                  if ((mappedTypes || origType === handleObj.origType) &&
                      (!handler || handler.guid === handleObj.guid) &&
                      (!tmp || tmp.test(handleObj.namespace)) &&
                      (!selector || selector === handleObj.selector ||
                          selector === "**" && handleObj.selector)) {
                      handlers.splice(j, 1);

                      if (handleObj.selector) {
                          handlers.delegateCount--;
                      }
                      if (special.remove) {
                          special.remove.call(elem, handleObj);
                      }
                  }
              }

              // Remove generic event handler if we removed something and no more handlers exist
              // (avoids potential for endless recursion during removal of special event handlers)
              if (origCount && !handlers.length) {
                  if (!special.teardown ||
                      special.teardown.call(elem, namespaces, elemData.handle) === false) {

                      jQuery.removeEvent(elem, type, elemData.handle);
                  }

                  delete events[type];
              }
          }

          // Remove data and the expando if it's no longer used
          if (jQuery.isEmptyObject(events)) {
              dataPriv.remove(elem, "handle events");
          }
      },

      dispatch: function (nativeEvent) {

          // Make a writable jQuery.Event from the native event object
          var event = jQuery.event.fix(nativeEvent);

          var i, j, ret, matched, handleObj, handlerQueue,
              args = new Array(arguments.length),
              handlers = (dataPriv.get(this, "events") || {})[event.type] || [],
              special = jQuery.event.special[event.type] || {};

          // Use the fix-ed jQuery.Event rather than the (read-only) native event
          args[0] = event;

          for (i = 1; i < arguments.length; i++) {
              args[i] = arguments[i];
          }

          event.delegateTarget = this;

          // Call the preDispatch hook for the mapped type, and let it bail if desired
          if (special.preDispatch && special.preDispatch.call(this, event) === false) {
              return;
          }

          // Determine handlers
          handlerQueue = jQuery.event.handlers.call(this, event, handlers);

          // Run delegates first; they may want to stop propagation beneath us
          i = 0;
          while ((matched = handlerQueue[i++]) && !event.isPropagationStopped()) {
              event.currentTarget = matched.elem;

              j = 0;
              while ((handleObj = matched.handlers[j++]) &&
              !event.isImmediatePropagationStopped()) {

                  // Triggered event must either 1) have no namespace, or 2) have namespace(s)
                  // a subset or equal to those in the bound event (both can have no namespace).
                  if (!event.rnamespace || event.rnamespace.test(handleObj.namespace)) {

                      event.handleObj = handleObj;
                      event.data = handleObj.data;

                      ret = ((jQuery.event.special[handleObj.origType] || {}).handle ||
                          handleObj.handler).apply(matched.elem, args);

                      if (ret !== undefined) {
                          if ((event.result = ret) === false) {
                              event.preventDefault();
                              event.stopPropagation();
                          }
                      }
                  }
              }
          }

          // Call the postDispatch hook for the mapped type
          if (special.postDispatch) {
              special.postDispatch.call(this, event);
          }

          return event.result;
      },

      handlers: function (event, handlers) {
          var i, handleObj, sel, matchedHandlers, matchedSelectors,
              handlerQueue = [],
              delegateCount = handlers.delegateCount,
              cur = event.target;

          // Find delegate handlers
          if (delegateCount &&

              // Support: IE <=9
              // Black-hole SVG <use> instance trees (trac-13180)
              cur.nodeType &&

              // Support: Firefox <=42
              // Suppress spec-violating clicks indicating a non-primary pointer button (trac-3861)
              // https://www.w3.org/TR/DOM-Level-3-Events/#event-type-click
              // Support: IE 11 only
              // ...but not arrow key "clicks" of radio inputs, which can have `button` -1 (gh-2343)
              !(event.type === "click" && event.button >= 1)) {

              for (; cur !== this; cur = cur.parentNode || this) {

                  // Don't check non-elements (#13208)
                  // Don't process clicks on disabled elements (#6911, #8165, #11382, #11764)
                  if (cur.nodeType === 1 && !(event.type === "click" && cur.disabled === true)) {
                      matchedHandlers = [];
                      matchedSelectors = {};
                      for (i = 0; i < delegateCount; i++) {
                          handleObj = handlers[i];

                          // Don't conflict with Object.prototype properties (#13203)
                          sel = handleObj.selector + " ";

                          if (matchedSelectors[sel] === undefined) {
                              matchedSelectors[sel] = handleObj.needsContext ?
                                  jQuery(sel, this).index(cur) > -1 :
                                  jQuery.find(sel, this, null, [cur]).length;
                          }
                          if (matchedSelectors[sel]) {
                              matchedHandlers.push(handleObj);
                          }
                      }
                      if (matchedHandlers.length) {
                          handlerQueue.push({elem: cur, handlers: matchedHandlers});
                      }
                  }
              }
          }

          // Add the remaining (directly-bound) handlers
          cur = this;
          if (delegateCount < handlers.length) {
              handlerQueue.push({elem: cur, handlers: handlers.slice(delegateCount)});
          }

          return handlerQueue;
      },

      addProp: function (name, hook) {
          Object.defineProperty(jQuery.Event.prototype, name, {
              enumerable: true,
              configurable: true,

              get: isFunction(hook) ?
                  function () {
                      if (this.originalEvent) {
                          return hook(this.originalEvent);
                      }
                  } :
                  function () {
                      if (this.originalEvent) {
                          return this.originalEvent[name];
                      }
                  },

              set: function (value) {
                  Object.defineProperty(this, name, {
                      enumerable: true,
                      configurable: true,
                      writable: true,
                      value: value
                  });
              }
          });
      },

      fix: function (originalEvent) {
          return originalEvent[jQuery.expando] ?
              originalEvent :
              new jQuery.Event(originalEvent);
      },

      special: {
          load: {

              // Prevent triggered image.load events from bubbling to window.load
              noBubble: true
          },
          focus: {

              // Fire native event if possible so blur/focus sequence is correct
              trigger: function () {
                  if (this !== safeActiveElement() && this.focus) {
                      this.focus();
                      return false;
                  }
              },
              delegateType: "focusin"
          },
          blur: {
              trigger: function () {
                  if (this === safeActiveElement() && this.blur) {
                      this.blur();
                      return false;
                  }
              },
              delegateType: "focusout"
          },
          click: {

              // For checkbox, fire native event so checked state will be right
              trigger: function () {
                  if (this.type === "checkbox" && this.click && nodeName(this, "input")) {
                      this.click();
                      return false;
                  }
              },

              // For cross-browser consistency, don't fire native .click() on links
              _default: function (event) {
                  return nodeName(event.target, "a");
              }
          },

          beforeunload: {
              postDispatch: function (event) {

                  // Support: Firefox 20+
                  // Firefox doesn't alert if the returnValue field is not set.
                  if (event.result !== undefined && event.originalEvent) {
                      event.originalEvent.returnValue = event.result;
                  }
              }
          }
      }
  };

  jQuery.removeEvent = function (elem, type, handle) {

      // This "if" is needed for plain objects
      if (elem.removeEventListener) {
          elem.removeEventListener(type, handle);
      }
  };

  jQuery.Event = function (src, props) {

      // Allow instantiation without the 'new' keyword
      if (!(this instanceof jQuery.Event)) {
          return new jQuery.Event(src, props);
      }

      // Event object
      if (src && src.type) {
          this.originalEvent = src;
          this.type = src.type;

          // Events bubbling up the document may have been marked as prevented
          // by a handler lower down the tree; reflect the correct value.
          this.isDefaultPrevented = src.defaultPrevented ||
          src.defaultPrevented === undefined &&

          // Support: Android <=2.3 only
          src.returnValue === false ?
              returnTrue :
              returnFalse;

          // Create target properties
          // Support: Safari <=6 - 7 only
          // Target should not be a text node (#504, #13143)
          this.target = (src.target && src.target.nodeType === 3) ?
              src.target.parentNode :
              src.target;

          this.currentTarget = src.currentTarget;
          this.relatedTarget = src.relatedTarget;

          // Event type
      } else {
          this.type = src;
      }

      // Put explicitly provided properties onto the event object
      if (props) {
          jQuery.extend(this, props);
      }

      // Create a timestamp if incoming event doesn't have one
      this.timeStamp = src && src.timeStamp || Date.now();

      // Mark it as fixed
      this[jQuery.expando] = true;
  };

  // jQuery.Event is based on DOM3 Events as specified by the ECMAScript Language Binding
  // https://www.w3.org/TR/2003/WD-DOM-Level-3-Events-20030331/ecma-script-binding.html
  jQuery.Event.prototype = {
      constructor: jQuery.Event,
      isDefaultPrevented: returnFalse,
      isPropagationStopped: returnFalse,
      isImmediatePropagationStopped: returnFalse,
      isSimulated: false,

      preventDefault: function () {
          var e = this.originalEvent;

          this.isDefaultPrevented = returnTrue;

          if (e && !this.isSimulated) {
              e.preventDefault();
          }
      },
      stopPropagation: function () {
          var e = this.originalEvent;

          this.isPropagationStopped = returnTrue;

          if (e && !this.isSimulated) {
              e.stopPropagation();
          }
      },
      stopImmediatePropagation: function () {
          var e = this.originalEvent;

          this.isImmediatePropagationStopped = returnTrue;

          if (e && !this.isSimulated) {
              e.stopImmediatePropagation();
          }

          this.stopPropagation();
      }
  };

  // Includes all common event props including KeyEvent and MouseEvent specific props
  jQuery.each({
      altKey: true,
      bubbles: true,
      cancelable: true,
      changedTouches: true,
      ctrlKey: true,
      detail: true,
      eventPhase: true,
      metaKey: true,
      pageX: true,
      pageY: true,
      shiftKey: true,
      view: true,
      "char": true,
      charCode: true,
      key: true,
      keyCode: true,
      button: true,
      buttons: true,
      clientX: true,
      clientY: true,
      offsetX: true,
      offsetY: true,
      pointerId: true,
      pointerType: true,
      screenX: true,
      screenY: true,
      targetTouches: true,
      toElement: true,
      touches: true,

      which: function (event) {
          var button = event.button;

          // Add which for key events
          if (event.which == null && rkeyEvent.test(event.type)) {
              return event.charCode != null ? event.charCode : event.keyCode;
          }

          // Add which for click: 1 === left; 2 === middle; 3 === right
          if (!event.which && button !== undefined && rmouseEvent.test(event.type)) {
              if (button & 1) {
                  return 1;
              }

              if (button & 2) {
                  return 3;
              }

              if (button & 4) {
                  return 2;
              }

              return 0;
          }

          return event.which;
      }
  }, jQuery.event.addProp);

  // Create mouseenter/leave events using mouseover/out and event-time checks
  // so that event delegation works in jQuery.
  // Do the same for pointerenter/pointerleave and pointerover/pointerout
  //
  // Support: Safari 7 only
  // Safari sends mouseenter too often; see:
  // https://bugs.chromium.org/p/chromium/issues/detail?id=470258
  // for the description of the bug (it existed in older Chrome versions as well).
  jQuery.each({
      mouseenter: "mouseover",
      mouseleave: "mouseout",
      pointerenter: "pointerover",
      pointerleave: "pointerout"
  }, function (orig, fix) {
      jQuery.event.special[orig] = {
          delegateType: fix,
          bindType: fix,

          handle: function (event) {
              var ret,
                  target = this,
                  related = event.relatedTarget,
                  handleObj = event.handleObj;

              // For mouseenter/leave call the handler if related is outside the target.
              // NB: No relatedTarget if the mouse left/entered the browser window
              if (!related || (related !== target && !jQuery.contains(target, related))) {
                  event.type = handleObj.origType;
                  ret = handleObj.handler.apply(this, arguments);
                  event.type = fix;
              }
              return ret;
          }
      };
  });

  jQuery.fn.extend({

      on: function (types, selector, data, fn) {
          return on(this, types, selector, data, fn);
      },
      one: function (types, selector, data, fn) {
          return on(this, types, selector, data, fn, 1);
      },
      off: function (types, selector, fn) {
          var handleObj, type;
          if (types && types.preventDefault && types.handleObj) {

              // ( event )  dispatched jQuery.Event
              handleObj = types.handleObj;
              jQuery(types.delegateTarget).off(
                  handleObj.namespace ?
                      handleObj.origType + "." + handleObj.namespace :
                      handleObj.origType,
                  handleObj.selector,
                  handleObj.handler
              );
              return this;
          }
          if (typeof types === "object") {

              // ( types-object [, selector] )
              for (type in types) {
                  this.off(type, selector, types[type]);
              }
              return this;
          }
          if (selector === false || typeof selector === "function") {

              // ( types [, fn] )
              fn = selector;
              selector = undefined;
          }
          if (fn === false) {
              fn = returnFalse;
          }
          return this.each(function () {
              jQuery.event.remove(this, types, fn, selector);
          });
      }
  });


  var

      /* eslint-disable max-len */

      // See https://github.com/eslint/eslint/issues/3229
      rxhtmlTag = /<(?!area|br|col|embed|hr|img|input|link|meta|param)(([a-z][^\/\0>\x20\t\r\n\f]*)[^>]*)\/>/gi,

      /* eslint-enable */

      // Support: IE <=10 - 11, Edge 12 - 13 only
      // In IE/Edge using regex groups here causes severe slowdowns.
      // See https://connect.microsoft.com/IE/feedback/details/1736512/
      rnoInnerhtml = /<script|<style|<link/i,

      // checked="checked" or checked
      rchecked = /checked\s*(?:[^=]|=\s*.checked.)/i,
      rcleanScript = /^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g;

  // Prefer a tbody over its parent table for containing new rows
  function manipulationTarget(elem, content) {
      if (nodeName(elem, "table") &&
          nodeName(content.nodeType !== 11 ? content : content.firstChild, "tr")) {

          return jQuery(elem).children("tbody")[0] || elem;
      }

      return elem;
  }

  // Replace/restore the type attribute of script elements for safe DOM manipulation
  function disableScript(elem) {
      elem.type = (elem.getAttribute("type") !== null) + "/" + elem.type;
      return elem;
  }

  function restoreScript(elem) {
      if ((elem.type || "").slice(0, 5) === "true/") {
          elem.type = elem.type.slice(5);
      } else {
          elem.removeAttribute("type");
      }

      return elem;
  }

  function cloneCopyEvent(src, dest) {
      var i, l, type, pdataOld, pdataCur, udataOld, udataCur, events;

      if (dest.nodeType !== 1) {
          return;
      }

      // 1. Copy private data: events, handlers, etc.
      if (dataPriv.hasData(src)) {
          pdataOld = dataPriv.access(src);
          pdataCur = dataPriv.set(dest, pdataOld);
          events = pdataOld.events;

          if (events) {
              delete pdataCur.handle;
              pdataCur.events = {};

              for (type in events) {
                  for (i = 0, l = events[type].length; i < l; i++) {
                      jQuery.event.add(dest, type, events[type][i]);
                  }
              }
          }
      }

      // 2. Copy user data
      if (dataUser.hasData(src)) {
          udataOld = dataUser.access(src);
          udataCur = jQuery.extend({}, udataOld);

          dataUser.set(dest, udataCur);
      }
  }

  // Fix IE bugs, see support tests
  function fixInput(src, dest) {
      var nodeName = dest.nodeName.toLowerCase();

      // Fails to persist the checked state of a cloned checkbox or radio button.
      if (nodeName === "input" && rcheckableType.test(src.type)) {
          dest.checked = src.checked;

          // Fails to return the selected option to the default selected state when cloning options
      } else if (nodeName === "input" || nodeName === "textarea") {
          dest.defaultValue = src.defaultValue;
      }
  }

  function domManip(collection, args, callback, ignored) {

      // Flatten any nested arrays
      args = concat.apply([], args);

      var fragment, first, scripts, hasScripts, node, doc,
          i = 0,
          l = collection.length,
          iNoClone = l - 1,
          value = args[0],
          valueIsFunction = isFunction(value);

      // We can't cloneNode fragments that contain checked, in WebKit
      if (valueIsFunction ||
          (l > 1 && typeof value === "string" &&
              !support.checkClone && rchecked.test(value))) {
          return collection.each(function (index) {
              var self = collection.eq(index);
              if (valueIsFunction) {
                  args[0] = value.call(this, index, self.html());
              }
              domManip(self, args, callback, ignored);
          });
      }

      if (l) {
          fragment = buildFragment(args, collection[0].ownerDocument, false, collection, ignored);
          first = fragment.firstChild;

          if (fragment.childNodes.length === 1) {
              fragment = first;
          }

          // Require either new content or an interest in ignored elements to invoke the callback
          if (first || ignored) {
              scripts = jQuery.map(getAll(fragment, "script"), disableScript);
              hasScripts = scripts.length;

              // Use the original fragment for the last item
              // instead of the first because it can end up
              // being emptied incorrectly in certain situations (#8070).
              for (; i < l; i++) {
                  node = fragment;

                  if (i !== iNoClone) {
                      node = jQuery.clone(node, true, true);

                      // Keep references to cloned scripts for later restoration
                      if (hasScripts) {

                          // Support: Android <=4.0 only, PhantomJS 1 only
                          // push.apply(_, arraylike) throws on ancient WebKit
                          jQuery.merge(scripts, getAll(node, "script"));
                      }
                  }

                  callback.call(collection[i], node, i);
              }

              if (hasScripts) {
                  doc = scripts[scripts.length - 1].ownerDocument;

                  // Reenable scripts
                  jQuery.map(scripts, restoreScript);

                  // Evaluate executable scripts on first document insertion
                  for (i = 0; i < hasScripts; i++) {
                      node = scripts[i];
                      if (rscriptType.test(node.type || "") &&
                          !dataPriv.access(node, "globalEval") &&
                          jQuery.contains(doc, node)) {

                          if (node.src && (node.type || "").toLowerCase() !== "module") {

                              // Optional AJAX dependency, but won't run scripts if not present
                              if (jQuery._evalUrl) {
                                  jQuery._evalUrl(node.src);
                              }
                          } else {
                              DOMEval(node.textContent.replace(rcleanScript, ""), doc, node);
                          }
                      }
                  }
              }
          }
      }

      return collection;
  }

  function remove(elem, selector, keepData) {
      var node,
          nodes = selector ? jQuery.filter(selector, elem) : elem,
          i = 0;

      for (; (node = nodes[i]) != null; i++) {
          if (!keepData && node.nodeType === 1) {
              jQuery.cleanData(getAll(node));
          }

          if (node.parentNode) {
              if (keepData && jQuery.contains(node.ownerDocument, node)) {
                  setGlobalEval(getAll(node, "script"));
              }
              node.parentNode.removeChild(node);
          }
      }

      return elem;
  }

  jQuery.extend({
      htmlPrefilter: function (html) {
          return html.replace(rxhtmlTag, "<$1></$2>");
      },

      clone: function (elem, dataAndEvents, deepDataAndEvents) {
          var i, l, srcElements, destElements,
              clone = elem.cloneNode(true),
              inPage = jQuery.contains(elem.ownerDocument, elem);

          // Fix IE cloning issues
          if (!support.noCloneChecked && (elem.nodeType === 1 || elem.nodeType === 11) &&
              !jQuery.isXMLDoc(elem)) {

              // We eschew Sizzle here for performance reasons: https://jsperf.com/getall-vs-sizzle/2
              destElements = getAll(clone);
              srcElements = getAll(elem);

              for (i = 0, l = srcElements.length; i < l; i++) {
                  fixInput(srcElements[i], destElements[i]);
              }
          }

          // Copy the events from the original to the clone
          if (dataAndEvents) {
              if (deepDataAndEvents) {
                  srcElements = srcElements || getAll(elem);
                  destElements = destElements || getAll(clone);

                  for (i = 0, l = srcElements.length; i < l; i++) {
                      cloneCopyEvent(srcElements[i], destElements[i]);
                  }
              } else {
                  cloneCopyEvent(elem, clone);
              }
          }

          // Preserve script evaluation history
          destElements = getAll(clone, "script");
          if (destElements.length > 0) {
              setGlobalEval(destElements, !inPage && getAll(elem, "script"));
          }

          // Return the cloned set
          return clone;
      },

      cleanData: function (elems) {
          var data, elem, type,
              special = jQuery.event.special,
              i = 0;

          for (; (elem = elems[i]) !== undefined; i++) {
              if (acceptData(elem)) {
                  if ((data = elem[dataPriv.expando])) {
                      if (data.events) {
                          for (type in data.events) {
                              if (special[type]) {
                                  jQuery.event.remove(elem, type);

                                  // This is a shortcut to avoid jQuery.event.remove's overhead
                              } else {
                                  jQuery.removeEvent(elem, type, data.handle);
                              }
                          }
                      }

                      // Support: Chrome <=35 - 45+
                      // Assign undefined instead of using delete, see Data#remove
                      elem[dataPriv.expando] = undefined;
                  }
                  if (elem[dataUser.expando]) {

                      // Support: Chrome <=35 - 45+
                      // Assign undefined instead of using delete, see Data#remove
                      elem[dataUser.expando] = undefined;
                  }
              }
          }
      }
  });

  jQuery.fn.extend({
      detach: function (selector) {
          return remove(this, selector, true);
      },

      remove: function (selector) {
          return remove(this, selector);
      },

      text: function (value) {
          return access(this, function (value) {
              return value === undefined ?
                  jQuery.text(this) :
                  this.empty().each(function () {
                      if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
                          this.textContent = value;
                      }
                  });
          }, null, value, arguments.length);
      },

      append: function () {
          return domManip(this, arguments, function (elem) {
              if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
                  var target = manipulationTarget(this, elem);
                  target.appendChild(elem);
              }
          });
      },

      prepend: function () {
          return domManip(this, arguments, function (elem) {
              if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
                  var target = manipulationTarget(this, elem);
                  target.insertBefore(elem, target.firstChild);
              }
          });
      },

      before: function () {
          return domManip(this, arguments, function (elem) {
              if (this.parentNode) {
                  this.parentNode.insertBefore(elem, this);
              }
          });
      },

      after: function () {
          return domManip(this, arguments, function (elem) {
              if (this.parentNode) {
                  this.parentNode.insertBefore(elem, this.nextSibling);
              }
          });
      },

      empty: function () {
          var elem,
              i = 0;

          for (; (elem = this[i]) != null; i++) {
              if (elem.nodeType === 1) {

                  // Prevent memory leaks
                  jQuery.cleanData(getAll(elem, false));

                  // Remove any remaining nodes
                  elem.textContent = "";
              }
          }

          return this;
      },

      clone: function (dataAndEvents, deepDataAndEvents) {
          dataAndEvents = dataAndEvents == null ? false : dataAndEvents;
          deepDataAndEvents = deepDataAndEvents == null ? dataAndEvents : deepDataAndEvents;

          return this.map(function () {
              return jQuery.clone(this, dataAndEvents, deepDataAndEvents);
          });
      },

      html: function (value) {
          return access(this, function (value) {
              var elem = this[0] || {},
                  i = 0,
                  l = this.length;

              if (value === undefined && elem.nodeType === 1) {
                  return elem.innerHTML;
              }

              // See if we can take a shortcut and just use innerHTML
              if (typeof value === "string" && !rnoInnerhtml.test(value) &&
                  !wrapMap[(rtagName.exec(value) || ["", ""])[1].toLowerCase()]) {

                  value = jQuery.htmlPrefilter(value);

                  try {
                      for (; i < l; i++) {
                          elem = this[i] || {};

                          // Remove element nodes and prevent memory leaks
                          if (elem.nodeType === 1) {
                              jQuery.cleanData(getAll(elem, false));
                              elem.innerHTML = value;
                          }
                      }

                      elem = 0;

                      // If using innerHTML throws an exception, use the fallback method
                  } catch (e) {
                  }
              }

              if (elem) {
                  this.empty().append(value);
              }
          }, null, value, arguments.length);
      },

      replaceWith: function () {
          var ignored = [];

          // Make the changes, replacing each non-ignored context element with the new content
          return domManip(this, arguments, function (elem) {
              var parent = this.parentNode;

              if (jQuery.inArray(this, ignored) < 0) {
                  jQuery.cleanData(getAll(this));
                  if (parent) {
                      parent.replaceChild(elem, this);
                  }
              }

              // Force callback invocation
          }, ignored);
      }
  });

  jQuery.each({
      appendTo: "append",
      prependTo: "prepend",
      insertBefore: "before",
      insertAfter: "after",
      replaceAll: "replaceWith"
  }, function (name, original) {
      jQuery.fn[name] = function (selector) {
          var elems,
              ret = [],
              insert = jQuery(selector),
              last = insert.length - 1,
              i = 0;

          for (; i <= last; i++) {
              elems = i === last ? this : this.clone(true);
              jQuery(insert[i])[original](elems);

              // Support: Android <=4.0 only, PhantomJS 1 only
              // .get() because push.apply(_, arraylike) throws on ancient WebKit
              push.apply(ret, elems.get());
          }

          return this.pushStack(ret);
      };
  });
  var rnumnonpx = new RegExp("^(" + pnum + ")(?!px)[a-z%]+$", "i");

  var getStyles = function (elem) {

      // Support: IE <=11 only, Firefox <=30 (#15098, #14150)
      // IE throws on elements created in popups
      // FF meanwhile throws on frame elements through "defaultView.getComputedStyle"
      var view = elem.ownerDocument.defaultView;

      if (!view || !view.opener) {
          view = window;
      }

      return view.getComputedStyle(elem);
  };

  var rboxStyle = new RegExp(cssExpand.join("|"), "i");


  (function () {

      // Executing both pixelPosition & boxSizingReliable tests require only one layout
      // so they're executed at the same time to save the second computation.
      function computeStyleTests() {

          // This is a singleton, we need to execute it only once
          if (!div) {
              return;
          }

          container.style.cssText = "position:absolute;left:-11111px;width:60px;" +
              "margin-top:1px;padding:0;border:0";
          div.style.cssText =
              "position:relative;display:block;box-sizing:border-box;overflow:scroll;" +
              "margin:auto;border:1px;padding:1px;" +
              "width:60%;top:1%";
          documentElement.appendChild(container).appendChild(div);

          var divStyle = window.getComputedStyle(div);
          pixelPositionVal = divStyle.top !== "1%";

          // Support: Android 4.0 - 4.3 only, Firefox <=3 - 44
          reliableMarginLeftVal = roundPixelMeasures(divStyle.marginLeft) === 12;

          // Support: Android 4.0 - 4.3 only, Safari <=9.1 - 10.1, iOS <=7.0 - 9.3
          // Some styles come back with percentage values, even though they shouldn't
          div.style.right = "60%";
          pixelBoxStylesVal = roundPixelMeasures(divStyle.right) === 36;

          // Support: IE 9 - 11 only
          // Detect misreporting of content dimensions for box-sizing:border-box elements
          boxSizingReliableVal = roundPixelMeasures(divStyle.width) === 36;

          // Support: IE 9 only
          // Detect overflow:scroll screwiness (gh-3699)
          div.style.position = "absolute";
          scrollboxSizeVal = div.offsetWidth === 36 || "absolute";

          documentElement.removeChild(container);

          // Nullify the div so it wouldn't be stored in the memory and
          // it will also be a sign that checks already performed
          div = null;
      }

      function roundPixelMeasures(measure) {
          return Math.round(parseFloat(measure));
      }

      var pixelPositionVal, boxSizingReliableVal, scrollboxSizeVal, pixelBoxStylesVal,
          reliableMarginLeftVal,
          container = document$1.createElement("div"),
          div = document$1.createElement("div");

      // Finish early in limited (non-browser) environments
      if (!div.style) {
          return;
      }

      // Support: IE <=9 - 11 only
      // Style of cloned element affects source element cloned (#8908)
      div.style.backgroundClip = "content-box";
      div.cloneNode(true).style.backgroundClip = "";
      support.clearCloneStyle = div.style.backgroundClip === "content-box";

      jQuery.extend(support, {
          boxSizingReliable: function () {
              computeStyleTests();
              return boxSizingReliableVal;
          },
          pixelBoxStyles: function () {
              computeStyleTests();
              return pixelBoxStylesVal;
          },
          pixelPosition: function () {
              computeStyleTests();
              return pixelPositionVal;
          },
          reliableMarginLeft: function () {
              computeStyleTests();
              return reliableMarginLeftVal;
          },
          scrollboxSize: function () {
              computeStyleTests();
              return scrollboxSizeVal;
          }
      });
  })();


  function curCSS(elem, name, computed) {
      var width, minWidth, maxWidth, ret,

          // Support: Firefox 51+
          // Retrieving style before computed somehow
          // fixes an issue with getting wrong values
          // on detached elements
          style = elem.style;

      computed = computed || getStyles(elem);

      // getPropertyValue is needed for:
      //   .css('filter') (IE 9 only, #12537)
      //   .css('--customProperty) (#3144)
      if (computed) {
          ret = computed.getPropertyValue(name) || computed[name];

          if (ret === "" && !jQuery.contains(elem.ownerDocument, elem)) {
              ret = jQuery.style(elem, name);
          }

          // A tribute to the "awesome hack by Dean Edwards"
          // Android Browser returns percentage for some values,
          // but width seems to be reliably pixels.
          // This is against the CSSOM draft spec:
          // https://drafts.csswg.org/cssom/#resolved-values
          if (!support.pixelBoxStyles() && rnumnonpx.test(ret) && rboxStyle.test(name)) {

              // Remember the original values
              width = style.width;
              minWidth = style.minWidth;
              maxWidth = style.maxWidth;

              // Put in the new values to get a computed value out
              style.minWidth = style.maxWidth = style.width = ret;
              ret = computed.width;

              // Revert the changed values
              style.width = width;
              style.minWidth = minWidth;
              style.maxWidth = maxWidth;
          }
      }

      return ret !== undefined ?

          // Support: IE <=9 - 11 only
          // IE returns zIndex value as an integer.
          ret + "" :
          ret;
  }


  function addGetHookIf(conditionFn, hookFn) {

      // Define the hook, we'll check on the first run if it's really needed.
      return {
          get: function () {
              if (conditionFn()) {

                  // Hook not needed (or it's not possible to use it due
                  // to missing dependency), remove it.
                  delete this.get;
                  return;
              }

              // Hook needed; redefine it so that the support test is not executed again.
              return (this.get = hookFn).apply(this, arguments);
          }
      };
  }


  var

      // Swappable if display is none or starts with table
      // except "table", "table-cell", or "table-caption"
      // See here for display values: https://developer.mozilla.org/en-US/docs/CSS/display
      rdisplayswap = /^(none|table(?!-c[ea]).+)/,
      rcustomProp = /^--/,
      cssShow = {position: "absolute", visibility: "hidden", display: "block"},
      cssNormalTransform = {
          letterSpacing: "0",
          fontWeight: "400"
      },

      cssPrefixes = ["Webkit", "Moz", "ms"],
      emptyStyle = document$1.createElement("div").style;

  // Return a css property mapped to a potentially vendor prefixed property
  function vendorPropName(name) {

      // Shortcut for names that are not vendor prefixed
      if (name in emptyStyle) {
          return name;
      }

      // Check for vendor prefixed names
      var capName = name[0].toUpperCase() + name.slice(1),
          i = cssPrefixes.length;

      while (i--) {
          name = cssPrefixes[i] + capName;
          if (name in emptyStyle) {
              return name;
          }
      }
  }

  // Return a property mapped along what jQuery.cssProps suggests or to
  // a vendor prefixed property.
  function finalPropName(name) {
      var ret = jQuery.cssProps[name];
      if (!ret) {
          ret = jQuery.cssProps[name] = vendorPropName(name) || name;
      }
      return ret;
  }

  function setPositiveNumber(elem, value, subtract) {

      // Any relative (+/-) values have already been
      // normalized at this point
      var matches = rcssNum.exec(value);
      return matches ?

          // Guard against undefined "subtract", e.g., when used as in cssHooks
          Math.max(0, matches[2] - (subtract || 0)) + (matches[3] || "px") :
          value;
  }

  function boxModelAdjustment(elem, dimension, box, isBorderBox, styles, computedVal) {
      var i = dimension === "width" ? 1 : 0,
          extra = 0,
          delta = 0;

      // Adjustment may not be necessary
      if (box === (isBorderBox ? "border" : "content")) {
          return 0;
      }

      for (; i < 4; i += 2) {

          // Both box models exclude margin
          if (box === "margin") {
              delta += jQuery.css(elem, box + cssExpand[i], true, styles);
          }

          // If we get here with a content-box, we're seeking "padding" or "border" or "margin"
          if (!isBorderBox) {

              // Add padding
              delta += jQuery.css(elem, "padding" + cssExpand[i], true, styles);

              // For "border" or "margin", add border
              if (box !== "padding") {
                  delta += jQuery.css(elem, "border" + cssExpand[i] + "Width", true, styles);

                  // But still keep track of it otherwise
              } else {
                  extra += jQuery.css(elem, "border" + cssExpand[i] + "Width", true, styles);
              }

              // If we get here with a border-box (content + padding + border), we're seeking "content" or
              // "padding" or "margin"
          } else {

              // For "content", subtract padding
              if (box === "content") {
                  delta -= jQuery.css(elem, "padding" + cssExpand[i], true, styles);
              }

              // For "content" or "padding", subtract border
              if (box !== "margin") {
                  delta -= jQuery.css(elem, "border" + cssExpand[i] + "Width", true, styles);
              }
          }
      }

      // Account for positive content-box scroll gutter when requested by providing computedVal
      if (!isBorderBox && computedVal >= 0) {

          // offsetWidth/offsetHeight is a rounded sum of content, padding, scroll gutter, and border
          // Assuming integer scroll gutter, subtract the rest and round down
          delta += Math.max(0, Math.ceil(
              elem["offset" + dimension[0].toUpperCase() + dimension.slice(1)] -
              computedVal -
              delta -
              extra -
              0.5
          ));
      }

      return delta;
  }

  function getWidthOrHeight(elem, dimension, extra) {

      // Start with computed style
      var styles = getStyles(elem),
          val = curCSS(elem, dimension, styles),
          isBorderBox = jQuery.css(elem, "boxSizing", false, styles) === "border-box",
          valueIsBorderBox = isBorderBox;

      // Support: Firefox <=54
      // Return a confounding non-pixel value or feign ignorance, as appropriate.
      if (rnumnonpx.test(val)) {
          if (!extra) {
              return val;
          }
          val = "auto";
      }

      // Check for style in case a browser which returns unreliable values
      // for getComputedStyle silently falls back to the reliable elem.style
      valueIsBorderBox = valueIsBorderBox &&
          (support.boxSizingReliable() || val === elem.style[dimension]);

      // Fall back to offsetWidth/offsetHeight when value is "auto"
      // This happens for inline elements with no explicit setting (gh-3571)
      // Support: Android <=4.1 - 4.3 only
      // Also use offsetWidth/offsetHeight for misreported inline dimensions (gh-3602)
      if (val === "auto" ||
          !parseFloat(val) && jQuery.css(elem, "display", false, styles) === "inline") {

          val = elem["offset" + dimension[0].toUpperCase() + dimension.slice(1)];

          // offsetWidth/offsetHeight provide border-box values
          valueIsBorderBox = true;
      }

      // Normalize "" and auto
      val = parseFloat(val) || 0;

      // Adjust for the element's box model
      return (val +
          boxModelAdjustment(
              elem,
              dimension,
              extra || (isBorderBox ? "border" : "content"),
              valueIsBorderBox,
              styles,

              // Provide the current computed size to request scroll gutter calculation (gh-3589)
              val
          )
      ) + "px";
  }

  jQuery.extend({

      // Add in style property hooks for overriding the default
      // behavior of getting and setting a style property
      cssHooks: {
          opacity: {
              get: function (elem, computed) {
                  if (computed) {

                      // We should always get a number back from opacity
                      var ret = curCSS(elem, "opacity");
                      return ret === "" ? "1" : ret;
                  }
              }
          }
      },

      // Don't automatically add "px" to these possibly-unitless properties
      cssNumber: {
          "animationIterationCount": true,
          "columnCount": true,
          "fillOpacity": true,
          "flexGrow": true,
          "flexShrink": true,
          "fontWeight": true,
          "lineHeight": true,
          "opacity": true,
          "order": true,
          "orphans": true,
          "widows": true,
          "zIndex": true,
          "zoom": true
      },

      // Add in properties whose names you wish to fix before
      // setting or getting the value
      cssProps: {},

      // Get and set the style property on a DOM Node
      style: function (elem, name, value, extra) {

          // Don't set styles on text and comment nodes
          if (!elem || elem.nodeType === 3 || elem.nodeType === 8 || !elem.style) {
              return;
          }

          // Make sure that we're working with the right name
          var ret, type, hooks,
              origName = camelCase(name),
              isCustomProp = rcustomProp.test(name),
              style = elem.style;

          // Make sure that we're working with the right name. We don't
          // want to query the value if it is a CSS custom property
          // since they are user-defined.
          if (!isCustomProp) {
              name = finalPropName(origName);
          }

          // Gets hook for the prefixed version, then unprefixed version
          hooks = jQuery.cssHooks[name] || jQuery.cssHooks[origName];

          // Check if we're setting a value
          if (value !== undefined) {
              type = typeof value;

              // Convert "+=" or "-=" to relative numbers (#7345)
              if (type === "string" && (ret = rcssNum.exec(value)) && ret[1]) {
                  value = adjustCSS(elem, name, ret);

                  // Fixes bug #9237
                  type = "number";
              }

              // Make sure that null and NaN values aren't set (#7116)
              if (value == null || value !== value) {
                  return;
              }

              // If a number was passed in, add the unit (except for certain CSS properties)
              if (type === "number") {
                  value += ret && ret[3] || (jQuery.cssNumber[origName] ? "" : "px");
              }

              // background-* props affect original clone's values
              if (!support.clearCloneStyle && value === "" && name.indexOf("background") === 0) {
                  style[name] = "inherit";
              }

              // If a hook was provided, use that value, otherwise just set the specified value
              if (!hooks || !("set" in hooks) ||
                  (value = hooks.set(elem, value, extra)) !== undefined) {

                  if (isCustomProp) {
                      style.setProperty(name, value);
                  } else {
                      style[name] = value;
                  }
              }

          } else {

              // If a hook was provided get the non-computed value from there
              if (hooks && "get" in hooks &&
                  (ret = hooks.get(elem, false, extra)) !== undefined) {

                  return ret;
              }

              // Otherwise just get the value from the style object
              return style[name];
          }
      },

      css: function (elem, name, extra, styles) {
          var val, num, hooks,
              origName = camelCase(name),
              isCustomProp = rcustomProp.test(name);

          // Make sure that we're working with the right name. We don't
          // want to modify the value if it is a CSS custom property
          // since they are user-defined.
          if (!isCustomProp) {
              name = finalPropName(origName);
          }

          // Try prefixed name followed by the unprefixed name
          hooks = jQuery.cssHooks[name] || jQuery.cssHooks[origName];

          // If a hook was provided get the computed value from there
          if (hooks && "get" in hooks) {
              val = hooks.get(elem, true, extra);
          }

          // Otherwise, if a way to get the computed value exists, use that
          if (val === undefined) {
              val = curCSS(elem, name, styles);
          }

          // Convert "normal" to computed value
          if (val === "normal" && name in cssNormalTransform) {
              val = cssNormalTransform[name];
          }

          // Make numeric if forced or a qualifier was provided and val looks numeric
          if (extra === "" || extra) {
              num = parseFloat(val);
              return extra === true || isFinite(num) ? num || 0 : val;
          }

          return val;
      }
  });

  jQuery.each(["height", "width"], function (i, dimension) {
      jQuery.cssHooks[dimension] = {
          get: function (elem, computed, extra) {
              if (computed) {

                  // Certain elements can have dimension info if we invisibly show them
                  // but it must have a current display style that would benefit
                  return rdisplayswap.test(jQuery.css(elem, "display")) &&

                  // Support: Safari 8+
                  // Table columns in Safari have non-zero offsetWidth & zero
                  // getBoundingClientRect().width unless display is changed.
                  // Support: IE <=11 only
                  // Running getBoundingClientRect on a disconnected node
                  // in IE throws an error.
                  (!elem.getClientRects().length || !elem.getBoundingClientRect().width) ?
                      swap(elem, cssShow, function () {
                          return getWidthOrHeight(elem, dimension, extra);
                      }) :
                      getWidthOrHeight(elem, dimension, extra);
              }
          },

          set: function (elem, value, extra) {
              var matches,
                  styles = getStyles(elem),
                  isBorderBox = jQuery.css(elem, "boxSizing", false, styles) === "border-box",
                  subtract = extra && boxModelAdjustment(
                      elem,
                      dimension,
                      extra,
                      isBorderBox,
                      styles
                  );

              // Account for unreliable border-box dimensions by comparing offset* to computed and
              // faking a content-box to get border and padding (gh-3699)
              if (isBorderBox && support.scrollboxSize() === styles.position) {
                  subtract -= Math.ceil(
                      elem["offset" + dimension[0].toUpperCase() + dimension.slice(1)] -
                      parseFloat(styles[dimension]) -
                      boxModelAdjustment(elem, dimension, "border", false, styles) -
                      0.5
                  );
              }

              // Convert to pixels if value adjustment is needed
              if (subtract && (matches = rcssNum.exec(value)) &&
                  (matches[3] || "px") !== "px") {

                  elem.style[dimension] = value;
                  value = jQuery.css(elem, dimension);
              }

              return setPositiveNumber(elem, value, subtract);
          }
      };
  });

  jQuery.cssHooks.marginLeft = addGetHookIf(support.reliableMarginLeft,
      function (elem, computed) {
          if (computed) {
              return (parseFloat(curCSS(elem, "marginLeft")) ||
                  elem.getBoundingClientRect().left -
                  swap(elem, {marginLeft: 0}, function () {
                      return elem.getBoundingClientRect().left;
                  })
              ) + "px";
          }
      }
  );

  // These hooks are used by animate to expand properties
  jQuery.each({
      margin: "",
      padding: "",
      border: "Width"
  }, function (prefix, suffix) {
      jQuery.cssHooks[prefix + suffix] = {
          expand: function (value) {
              var i = 0,
                  expanded = {},

                  // Assumes a single number if not a string
                  parts = typeof value === "string" ? value.split(" ") : [value];

              for (; i < 4; i++) {
                  expanded[prefix + cssExpand[i] + suffix] =
                      parts[i] || parts[i - 2] || parts[0];
              }

              return expanded;
          }
      };

      if (prefix !== "margin") {
          jQuery.cssHooks[prefix + suffix].set = setPositiveNumber;
      }
  });

  jQuery.fn.extend({
      css: function (name, value) {
          return access(this, function (elem, name, value) {
              var styles, len,
                  map = {},
                  i = 0;

              if (Array.isArray(name)) {
                  styles = getStyles(elem);
                  len = name.length;

                  for (; i < len; i++) {
                      map[name[i]] = jQuery.css(elem, name[i], false, styles);
                  }

                  return map;
              }

              return value !== undefined ?
                  jQuery.style(elem, name, value) :
                  jQuery.css(elem, name);
          }, name, value, arguments.length > 1);
      }
  });


  // Based off of the plugin by Clint Helfers, with permission.
  // https://web.archive.org/web/20100324014747/http://blindsignals.com/index.php/2009/07/jquery-delay/
  jQuery.fn.delay = function (time, type) {
      time = jQuery.fx ? jQuery.fx.speeds[time] || time : time;
      type = type || "fx";

      return this.queue(type, function (next, hooks) {
          var timeout = window.setTimeout(next, time);
          hooks.stop = function () {
              window.clearTimeout(timeout);
          };
      });
  };


  (function () {
      var input = document$1.createElement("input"),
          select = document$1.createElement("select"),
          opt = select.appendChild(document$1.createElement("option"));

      input.type = "checkbox";

      // Support: Android <=4.3 only
      // Default value for a checkbox should be "on"
      support.checkOn = input.value !== "";

      // Support: IE <=11 only
      // Must access selectedIndex to make default options select
      support.optSelected = opt.selected;

      // Support: IE <=11 only
      // An input loses its value after becoming a radio
      input = document$1.createElement("input");
      input.value = "t";
      input.type = "radio";
      support.radioValue = input.value === "t";
  })();


  var boolHook,
      attrHandle = jQuery.expr.attrHandle;

  jQuery.fn.extend({
      attr: function (name, value) {
          return access(this, jQuery.attr, name, value, arguments.length > 1);
      },

      removeAttr: function (name) {
          return this.each(function () {
              jQuery.removeAttr(this, name);
          });
      }
  });

  jQuery.extend({
      attr: function (elem, name, value) {
          var ret, hooks,
              nType = elem.nodeType;

          // Don't get/set attributes on text, comment and attribute nodes
          if (nType === 3 || nType === 8 || nType === 2) {
              return;
          }

          // Fallback to prop when attributes are not supported
          if (typeof elem.getAttribute === "undefined") {
              return jQuery.prop(elem, name, value);
          }

          // Attribute hooks are determined by the lowercase version
          // Grab necessary hook if one is defined
          if (nType !== 1 || !jQuery.isXMLDoc(elem)) {
              hooks = jQuery.attrHooks[name.toLowerCase()] ||
                  (jQuery.expr.match.bool.test(name) ? boolHook : undefined);
          }

          if (value !== undefined) {
              if (value === null) {
                  jQuery.removeAttr(elem, name);
                  return;
              }

              if (hooks && "set" in hooks &&
                  (ret = hooks.set(elem, value, name)) !== undefined) {
                  return ret;
              }

              elem.setAttribute(name, value + "");
              return value;
          }

          if (hooks && "get" in hooks && (ret = hooks.get(elem, name)) !== null) {
              return ret;
          }

          ret = jQuery.find.attr(elem, name);

          // Non-existent attributes return null, we normalize to undefined
          return ret == null ? undefined : ret;
      },

      attrHooks: {
          type: {
              set: function (elem, value) {
                  if (!support.radioValue && value === "radio" &&
                      nodeName(elem, "input")) {
                      var val = elem.value;
                      elem.setAttribute("type", value);
                      if (val) {
                          elem.value = val;
                      }
                      return value;
                  }
              }
          }
      },

      removeAttr: function (elem, value) {
          var name,
              i = 0,

              // Attribute names can contain non-HTML whitespace characters
              // https://html.spec.whatwg.org/multipage/syntax.html#attributes-2
              attrNames = value && value.match(rnothtmlwhite);

          if (attrNames && elem.nodeType === 1) {
              while ((name = attrNames[i++])) {
                  elem.removeAttribute(name);
              }
          }
      }
  });

  // Hooks for boolean attributes
  boolHook = {
      set: function (elem, value, name) {
          if (value === false) {

              // Remove boolean attributes when set to false
              jQuery.removeAttr(elem, name);
          } else {
              elem.setAttribute(name, name);
          }
          return name;
      }
  };

  jQuery.each(jQuery.expr.match.bool.source.match(/\w+/g), function (i, name) {
      var getter = attrHandle[name] || jQuery.find.attr;

      attrHandle[name] = function (elem, name, isXML) {
          var ret, handle,
              lowercaseName = name.toLowerCase();

          if (!isXML) {

              // Avoid an infinite loop by temporarily removing this function from the getter
              handle = attrHandle[lowercaseName];
              attrHandle[lowercaseName] = ret;
              ret = getter(elem, name, isXML) != null ?
                  lowercaseName :
                  null;
              attrHandle[lowercaseName] = handle;
          }
          return ret;
      };
  });


  var rfocusable = /^(?:input|select|textarea|button)$/i,
      rclickable = /^(?:a|area)$/i;

  jQuery.fn.extend({
      prop: function (name, value) {
          return access(this, jQuery.prop, name, value, arguments.length > 1);
      },

      removeProp: function (name) {
          return this.each(function () {
              delete this[jQuery.propFix[name] || name];
          });
      }
  });

  jQuery.extend({
      prop: function (elem, name, value) {
          var ret, hooks,
              nType = elem.nodeType;

          // Don't get/set properties on text, comment and attribute nodes
          if (nType === 3 || nType === 8 || nType === 2) {
              return;
          }

          if (nType !== 1 || !jQuery.isXMLDoc(elem)) {

              // Fix name and attach hooks
              name = jQuery.propFix[name] || name;
              hooks = jQuery.propHooks[name];
          }

          if (value !== undefined) {
              if (hooks && "set" in hooks &&
                  (ret = hooks.set(elem, value, name)) !== undefined) {
                  return ret;
              }

              return (elem[name] = value);
          }

          if (hooks && "get" in hooks && (ret = hooks.get(elem, name)) !== null) {
              return ret;
          }

          return elem[name];
      },

      propHooks: {
          tabIndex: {
              get: function (elem) {

                  // Support: IE <=9 - 11 only
                  // elem.tabIndex doesn't always return the
                  // correct value when it hasn't been explicitly set
                  // https://web.archive.org/web/20141116233347/http://fluidproject.org/blog/2008/01/09/getting-setting-and-removing-tabindex-values-with-javascript/
                  // Use proper attribute retrieval(#12072)
                  var tabindex = jQuery.find.attr(elem, "tabindex");

                  if (tabindex) {
                      return parseInt(tabindex, 10);
                  }

                  if (
                      rfocusable.test(elem.nodeName) ||
                      rclickable.test(elem.nodeName) &&
                      elem.href
                  ) {
                      return 0;
                  }

                  return -1;
              }
          }
      },

      propFix: {
          "for": "htmlFor",
          "class": "className"
      }
  });

  // Support: IE <=11 only
  // Accessing the selectedIndex property
  // forces the browser to respect setting selected
  // on the option
  // The getter ensures a default option is selected
  // when in an optgroup
  // eslint rule "no-unused-expressions" is disabled for this code
  // since it considers such accessions noop
  if (!support.optSelected) {
      jQuery.propHooks.selected = {
          get: function (elem) {

              /* eslint no-unused-expressions: "off" */

              var parent = elem.parentNode;
              if (parent && parent.parentNode) {
                  parent.parentNode.selectedIndex;
              }
              return null;
          },
          set: function (elem) {

              /* eslint no-unused-expressions: "off" */

              var parent = elem.parentNode;
              if (parent) {
                  parent.selectedIndex;

                  if (parent.parentNode) {
                      parent.parentNode.selectedIndex;
                  }
              }
          }
      };
  }

  jQuery.each([
      "tabIndex",
      "readOnly",
      "maxLength",
      "cellSpacing",
      "cellPadding",
      "rowSpan",
      "colSpan",
      "useMap",
      "frameBorder",
      "contentEditable"
  ], function () {
      jQuery.propFix[this.toLowerCase()] = this;
  });


  // Strip and collapse whitespace according to HTML spec
  // https://infra.spec.whatwg.org/#strip-and-collapse-ascii-whitespace
  function stripAndCollapse(value) {
      var tokens = value.match(rnothtmlwhite) || [];
      return tokens.join(" ");
  }


  function getClass(elem) {
      return elem.getAttribute && elem.getAttribute("class") || "";
  }

  function classesToArray(value) {
      if (Array.isArray(value)) {
          return value;
      }
      if (typeof value === "string") {
          return value.match(rnothtmlwhite) || [];
      }
      return [];
  }

  jQuery.fn.extend({
      addClass: function (value) {
          var classes, elem, cur, curValue, clazz, j, finalValue,
              i = 0;

          if (isFunction(value)) {
              return this.each(function (j) {
                  jQuery(this).addClass(value.call(this, j, getClass(this)));
              });
          }

          classes = classesToArray(value);

          if (classes.length) {
              while ((elem = this[i++])) {
                  curValue = getClass(elem);
                  cur = elem.nodeType === 1 && (" " + stripAndCollapse(curValue) + " ");

                  if (cur) {
                      j = 0;
                      while ((clazz = classes[j++])) {
                          if (cur.indexOf(" " + clazz + " ") < 0) {
                              cur += clazz + " ";
                          }
                      }

                      // Only assign if different to avoid unneeded rendering.
                      finalValue = stripAndCollapse(cur);
                      if (curValue !== finalValue) {
                          elem.setAttribute("class", finalValue);
                      }
                  }
              }
          }

          return this;
      },

      removeClass: function (value) {
          var classes, elem, cur, curValue, clazz, j, finalValue,
              i = 0;

          if (isFunction(value)) {
              return this.each(function (j) {
                  jQuery(this).removeClass(value.call(this, j, getClass(this)));
              });
          }

          if (!arguments.length) {
              return this.attr("class", "");
          }

          classes = classesToArray(value);

          if (classes.length) {
              while ((elem = this[i++])) {
                  curValue = getClass(elem);

                  // This expression is here for better compressibility (see addClass)
                  cur = elem.nodeType === 1 && (" " + stripAndCollapse(curValue) + " ");

                  if (cur) {
                      j = 0;
                      while ((clazz = classes[j++])) {

                          // Remove *all* instances
                          while (cur.indexOf(" " + clazz + " ") > -1) {
                              cur = cur.replace(" " + clazz + " ", " ");
                          }
                      }

                      // Only assign if different to avoid unneeded rendering.
                      finalValue = stripAndCollapse(cur);
                      if (curValue !== finalValue) {
                          elem.setAttribute("class", finalValue);
                      }
                  }
              }
          }

          return this;
      },

      toggleClass: function (value, stateVal) {
          var type = typeof value,
              isValidValue = type === "string" || Array.isArray(value);

          if (typeof stateVal === "boolean" && isValidValue) {
              return stateVal ? this.addClass(value) : this.removeClass(value);
          }

          if (isFunction(value)) {
              return this.each(function (i) {
                  jQuery(this).toggleClass(
                      value.call(this, i, getClass(this), stateVal),
                      stateVal
                  );
              });
          }

          return this.each(function () {
              var className, i, self, classNames;

              if (isValidValue) {

                  // Toggle individual class names
                  i = 0;
                  self = jQuery(this);
                  classNames = classesToArray(value);

                  while ((className = classNames[i++])) {

                      // Check each className given, space separated list
                      if (self.hasClass(className)) {
                          self.removeClass(className);
                      } else {
                          self.addClass(className);
                      }
                  }

                  // Toggle whole class name
              } else if (value === undefined || type === "boolean") {
                  className = getClass(this);
                  if (className) {

                      // Store className if set
                      dataPriv.set(this, "__className__", className);
                  }

                  // If the element has a class name or if we're passed `false`,
                  // then remove the whole classname (if there was one, the above saved it).
                  // Otherwise bring back whatever was previously saved (if anything),
                  // falling back to the empty string if nothing was stored.
                  if (this.setAttribute) {
                      this.setAttribute("class",
                          className || value === false ?
                              "" :
                              dataPriv.get(this, "__className__") || ""
                      );
                  }
              }
          });
      },

      hasClass: function (selector) {
          var className, elem,
              i = 0;

          className = " " + selector + " ";
          while ((elem = this[i++])) {
              if (elem.nodeType === 1 &&
                  (" " + stripAndCollapse(getClass(elem)) + " ").indexOf(className) > -1) {
                  return true;
              }
          }

          return false;
      }
  });


  var rreturn = /\r/g;

  jQuery.fn.extend({
      val: function (value) {
          var hooks, ret, valueIsFunction,
              elem = this[0];

          if (!arguments.length) {
              if (elem) {
                  hooks = jQuery.valHooks[elem.type] ||
                      jQuery.valHooks[elem.nodeName.toLowerCase()];

                  if (hooks &&
                      "get" in hooks &&
                      (ret = hooks.get(elem, "value")) !== undefined
                  ) {
                      return ret;
                  }

                  ret = elem.value;

                  // Handle most common string cases
                  if (typeof ret === "string") {
                      return ret.replace(rreturn, "");
                  }

                  // Handle cases where value is null/undef or number
                  return ret == null ? "" : ret;
              }

              return;
          }

          valueIsFunction = isFunction(value);

          return this.each(function (i) {
              var val;

              if (this.nodeType !== 1) {
                  return;
              }

              if (valueIsFunction) {
                  val = value.call(this, i, jQuery(this).val());
              } else {
                  val = value;
              }

              // Treat null/undefined as ""; convert numbers to string
              if (val == null) {
                  val = "";

              } else if (typeof val === "number") {
                  val += "";

              } else if (Array.isArray(val)) {
                  val = jQuery.map(val, function (value) {
                      return value == null ? "" : value + "";
                  });
              }

              hooks = jQuery.valHooks[this.type] || jQuery.valHooks[this.nodeName.toLowerCase()];

              // If set returns undefined, fall back to normal setting
              if (!hooks || !("set" in hooks) || hooks.set(this, val, "value") === undefined) {
                  this.value = val;
              }
          });
      }
  });

  jQuery.extend({
      valHooks: {
          option: {
              get: function (elem) {

                  var val = jQuery.find.attr(elem, "value");
                  return val != null ?
                      val :

                      // Support: IE <=10 - 11 only
                      // option.text throws exceptions (#14686, #14858)
                      // Strip and collapse whitespace
                      // https://html.spec.whatwg.org/#strip-and-collapse-whitespace
                      stripAndCollapse(jQuery.text(elem));
              }
          },
          select: {
              get: function (elem) {
                  var value, option, i,
                      options = elem.options,
                      index = elem.selectedIndex,
                      one = elem.type === "select-one",
                      values = one ? null : [],
                      max = one ? index + 1 : options.length;

                  if (index < 0) {
                      i = max;

                  } else {
                      i = one ? index : 0;
                  }

                  // Loop through all the selected options
                  for (; i < max; i++) {
                      option = options[i];

                      // Support: IE <=9 only
                      // IE8-9 doesn't update selected after form reset (#2551)
                      if ((option.selected || i === index) &&

                          // Don't return options that are disabled or in a disabled optgroup
                          !option.disabled &&
                          (!option.parentNode.disabled ||
                              !nodeName(option.parentNode, "optgroup"))) {

                          // Get the specific value for the option
                          value = jQuery(option).val();

                          // We don't need an array for one selects
                          if (one) {
                              return value;
                          }

                          // Multi-Selects return an array
                          values.push(value);
                      }
                  }

                  return values;
              },

              set: function (elem, value) {
                  var optionSet, option,
                      options = elem.options,
                      values = jQuery.makeArray(value),
                      i = options.length;

                  while (i--) {
                      option = options[i];

                      /* eslint-disable no-cond-assign */

                      if (option.selected =
                          jQuery.inArray(jQuery.valHooks.option.get(option), values) > -1
                      ) {
                          optionSet = true;
                      }

                      /* eslint-enable no-cond-assign */
                  }

                  // Force browsers to behave consistently when non-matching value is set
                  if (!optionSet) {
                      elem.selectedIndex = -1;
                  }
                  return values;
              }
          }
      }
  });

  // Radios and checkboxes getter/setter
  jQuery.each(["radio", "checkbox"], function () {
      jQuery.valHooks[this] = {
          set: function (elem, value) {
              if (Array.isArray(value)) {
                  return (elem.checked = jQuery.inArray(jQuery(elem).val(), value) > -1);
              }
          }
      };
      if (!support.checkOn) {
          jQuery.valHooks[this].get = function (elem) {
              return elem.getAttribute("value") === null ? "on" : elem.value;
          };
      }
  });


  // Return jQuery for attributes-only inclusion


  support.focusin = "onfocusin" in window;


  var rfocusMorph = /^(?:focusinfocus|focusoutblur)$/,
      stopPropagationCallback = function (e) {
          e.stopPropagation();
      };

  jQuery.extend(jQuery.event, {

      trigger: function (event, data, elem, onlyHandlers) {

          var i, cur, tmp, bubbleType, ontype, handle, special, lastElement,
              eventPath = [elem || document$1],
              type = hasOwn.call(event, "type") ? event.type : event,
              namespaces = hasOwn.call(event, "namespace") ? event.namespace.split(".") : [];

          cur = lastElement = tmp = elem = elem || document$1;

          // Don't do events on text and comment nodes
          if (elem.nodeType === 3 || elem.nodeType === 8) {
              return;
          }

          // focus/blur morphs to focusin/out; ensure we're not firing them right now
          if (rfocusMorph.test(type + jQuery.event.triggered)) {
              return;
          }

          if (type.indexOf(".") > -1) {

              // Namespaced trigger; create a regexp to match event type in handle()
              namespaces = type.split(".");
              type = namespaces.shift();
              namespaces.sort();
          }
          ontype = type.indexOf(":") < 0 && "on" + type;

          // Caller can pass in a jQuery.Event object, Object, or just an event type string
          event = event[jQuery.expando] ?
              event :
              new jQuery.Event(type, typeof event === "object" && event);

          // Trigger bitmask: & 1 for native handlers; & 2 for jQuery (always true)
          event.isTrigger = onlyHandlers ? 2 : 3;
          event.namespace = namespaces.join(".");
          event.rnamespace = event.namespace ?
              new RegExp("(^|\\.)" + namespaces.join("\\.(?:.*\\.|)") + "(\\.|$)") :
              null;

          // Clean up the event in case it is being reused
          event.result = undefined;
          if (!event.target) {
              event.target = elem;
          }

          // Clone any incoming data and prepend the event, creating the handler arg list
          data = data == null ?
              [event] :
              jQuery.makeArray(data, [event]);

          // Allow special events to draw outside the lines
          special = jQuery.event.special[type] || {};
          if (!onlyHandlers && special.trigger && special.trigger.apply(elem, data) === false) {
              return;
          }

          // Determine event propagation path in advance, per W3C events spec (#9951)
          // Bubble up to document, then to window; watch for a global ownerDocument var (#9724)
          if (!onlyHandlers && !special.noBubble && !isWindow(elem)) {

              bubbleType = special.delegateType || type;
              if (!rfocusMorph.test(bubbleType + type)) {
                  cur = cur.parentNode;
              }
              for (; cur; cur = cur.parentNode) {
                  eventPath.push(cur);
                  tmp = cur;
              }

              // Only add window if we got to document (e.g., not plain obj or detached DOM)
              if (tmp === (elem.ownerDocument || document$1)) {
                  eventPath.push(tmp.defaultView || tmp.parentWindow || window);
              }
          }

          // Fire handlers on the event path
          i = 0;
          while ((cur = eventPath[i++]) && !event.isPropagationStopped()) {
              lastElement = cur;
              event.type = i > 1 ?
                  bubbleType :
                  special.bindType || type;

              // jQuery handler
              handle = (dataPriv.get(cur, "events") || {})[event.type] &&
                  dataPriv.get(cur, "handle");
              if (handle) {
                  handle.apply(cur, data);
              }

              // Native handler
              handle = ontype && cur[ontype];
              if (handle && handle.apply && acceptData(cur)) {
                  event.result = handle.apply(cur, data);
                  if (event.result === false) {
                      event.preventDefault();
                  }
              }
          }
          event.type = type;

          // If nobody prevented the default action, do it now
          if (!onlyHandlers && !event.isDefaultPrevented()) {

              if ((!special._default ||
                  special._default.apply(eventPath.pop(), data) === false) &&
                  acceptData(elem)) {

                  // Call a native DOM method on the target with the same name as the event.
                  // Don't do default actions on window, that's where global variables be (#6170)
                  if (ontype && isFunction(elem[type]) && !isWindow(elem)) {

                      // Don't re-trigger an onFOO event when we call its FOO() method
                      tmp = elem[ontype];

                      if (tmp) {
                          elem[ontype] = null;
                      }

                      // Prevent re-triggering of the same event, since we already bubbled it above
                      jQuery.event.triggered = type;

                      if (event.isPropagationStopped()) {
                          lastElement.addEventListener(type, stopPropagationCallback);
                      }

                      elem[type]();

                      if (event.isPropagationStopped()) {
                          lastElement.removeEventListener(type, stopPropagationCallback);
                      }

                      jQuery.event.triggered = undefined;

                      if (tmp) {
                          elem[ontype] = tmp;
                      }
                  }
              }
          }

          return event.result;
      },

      // Piggyback on a donor event to simulate a different one
      // Used only for `focus(in | out)` events
      simulate: function (type, elem, event) {
          var e = jQuery.extend(
              new jQuery.Event(),
              event,
              {
                  type: type,
                  isSimulated: true
              }
          );

          jQuery.event.trigger(e, null, elem);
      }

  });

  jQuery.fn.extend({

      trigger: function (type, data) {
          return this.each(function () {
              jQuery.event.trigger(type, data, this);
          });
      },
      triggerHandler: function (type, data) {
          var elem = this[0];
          if (elem) {
              return jQuery.event.trigger(type, data, elem, true);
          }
      }
  });


  // Support: Firefox <=44
  // Firefox doesn't have focus(in | out) events
  // Related ticket - https://bugzilla.mozilla.org/show_bug.cgi?id=687787
  //
  // Support: Chrome <=48 - 49, Safari <=9.0 - 9.1
  // focus(in | out) events fire after focus & blur events,
  // which is spec violation - http://www.w3.org/TR/DOM-Level-3-Events/#events-focusevent-event-order
  // Related ticket - https://bugs.chromium.org/p/chromium/issues/detail?id=449857
  if (!support.focusin) {
      jQuery.each({focus: "focusin", blur: "focusout"}, function (orig, fix) {

          // Attach a single capturing handler on the document while someone wants focusin/focusout
          var handler = function (event) {
              jQuery.event.simulate(fix, event.target, jQuery.event.fix(event));
          };

          jQuery.event.special[fix] = {
              setup: function () {
                  var doc = this.ownerDocument || this,
                      attaches = dataPriv.access(doc, fix);

                  if (!attaches) {
                      doc.addEventListener(orig, handler, true);
                  }
                  dataPriv.access(doc, fix, (attaches || 0) + 1);
              },
              teardown: function () {
                  var doc = this.ownerDocument || this,
                      attaches = dataPriv.access(doc, fix) - 1;

                  if (!attaches) {
                      doc.removeEventListener(orig, handler, true);
                      dataPriv.remove(doc, fix);

                  } else {
                      dataPriv.access(doc, fix, attaches);
                  }
              }
          };
      });
  }


  var
      rbracket = /\[\]$/,
      rCRLF = /\r?\n/g,
      rsubmitterTypes = /^(?:submit|button|image|reset|file)$/i,
      rsubmittable = /^(?:input|select|textarea|keygen)/i;

  function buildParams(prefix, obj, traditional, add) {
      var name;

      if (Array.isArray(obj)) {

          // Serialize array item.
          jQuery.each(obj, function (i, v) {
              if (traditional || rbracket.test(prefix)) {

                  // Treat each array item as a scalar.
                  add(prefix, v);

              } else {

                  // Item is non-scalar (array or object), encode its numeric index.
                  buildParams(
                      prefix + "[" + (typeof v === "object" && v != null ? i : "") + "]",
                      v,
                      traditional,
                      add
                  );
              }
          });

      } else if (!traditional && toType(obj) === "object") {

          // Serialize object item.
          for (name in obj) {
              buildParams(prefix + "[" + name + "]", obj[name], traditional, add);
          }

      } else {

          // Serialize scalar item.
          add(prefix, obj);
      }
  }

  // Serialize an array of form elements or a set of
  // key/values into a query string
  jQuery.param = function (a, traditional) {
      var prefix,
          s = [],
          add = function (key, valueOrFunction) {

              // If value is a function, invoke it and use its return value
              var value = isFunction(valueOrFunction) ?
                  valueOrFunction() :
                  valueOrFunction;

              s[s.length] = encodeURIComponent(key) + "=" +
                  encodeURIComponent(value == null ? "" : value);
          };

      // If an array was passed in, assume that it is an array of form elements.
      if (Array.isArray(a) || (a.jquery && !jQuery.isPlainObject(a))) {

          // Serialize the form elements
          jQuery.each(a, function () {
              add(this.name, this.value);
          });

      } else {

          // If traditional, encode the "old" way (the way 1.3.2 or older
          // did it), otherwise encode params recursively.
          for (prefix in a) {
              buildParams(prefix, a[prefix], traditional, add);
          }
      }

      // Return the resulting serialization
      return s.join("&");
  };

  jQuery.fn.extend({
      serialize: function () {
          return jQuery.param(this.serializeArray());
      },
      serializeArray: function () {
          return this.map(function () {

              // Can add propHook for "elements" to filter or add form elements
              var elements = jQuery.prop(this, "elements");
              return elements ? jQuery.makeArray(elements) : this;
          })
              .filter(function () {
                  var type = this.type;

                  // Use .is( ":disabled" ) so that fieldset[disabled] works
                  return this.name && !jQuery(this).is(":disabled") &&
                      rsubmittable.test(this.nodeName) && !rsubmitterTypes.test(type) &&
                      (this.checked || !rcheckableType.test(type));
              })
              .map(function (i, elem) {
                  var val = jQuery(this).val();

                  if (val == null) {
                      return null;
                  }

                  if (Array.isArray(val)) {
                      return jQuery.map(val, function (val) {
                          return {name: elem.name, value: val.replace(rCRLF, "\r\n")};
                      });
                  }

                  return {name: elem.name, value: val.replace(rCRLF, "\r\n")};
              }).get();
      }
  });


  jQuery.fn.extend({
      wrapAll: function (html) {
          var wrap;

          if (this[0]) {
              if (isFunction(html)) {
                  html = html.call(this[0]);
              }

              // The elements to wrap the target around
              wrap = jQuery(html, this[0].ownerDocument).eq(0).clone(true);

              if (this[0].parentNode) {
                  wrap.insertBefore(this[0]);
              }

              wrap.map(function () {
                  var elem = this;

                  while (elem.firstElementChild) {
                      elem = elem.firstElementChild;
                  }

                  return elem;
              }).append(this);
          }

          return this;
      },

      wrapInner: function (html) {
          if (isFunction(html)) {
              return this.each(function (i) {
                  jQuery(this).wrapInner(html.call(this, i));
              });
          }

          return this.each(function () {
              var self = jQuery(this),
                  contents = self.contents();

              if (contents.length) {
                  contents.wrapAll(html);

              } else {
                  self.append(html);
              }
          });
      },

      wrap: function (html) {
          var htmlIsFunction = isFunction(html);

          return this.each(function (i) {
              jQuery(this).wrapAll(htmlIsFunction ? html.call(this, i) : html);
          });
      },

      unwrap: function (selector) {
          this.parent(selector).not("body").each(function () {
              jQuery(this).replaceWith(this.childNodes);
          });
          return this;
      }
  });


  jQuery.expr.pseudos.hidden = function (elem) {
      return !jQuery.expr.pseudos.visible(elem);
  };
  jQuery.expr.pseudos.visible = function (elem) {
      return !!(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);
  };


  // Support: Safari 8 only
  // In Safari 8 documents created via document.implementation.createHTMLDocument
  // collapse sibling forms: the second one becomes a child of the first one.
  // Because of that, this security measure has to be disabled in Safari 8.
  // https://bugs.webkit.org/show_bug.cgi?id=137337
  support.createHTMLDocument = (function () {
      var body = document$1.implementation.createHTMLDocument("").body;
      body.innerHTML = "<form></form><form></form>";
      return body.childNodes.length === 2;
  })();


  // Argument "data" should be string of html
  // context (optional): If specified, the fragment will be created in this context,
  // defaults to document
  // keepScripts (optional): If true, will include scripts passed in the html string
  jQuery.parseHTML = function (data, context, keepScripts) {
      if (typeof data !== "string") {
          return [];
      }
      if (typeof context === "boolean") {
          keepScripts = context;
          context = false;
      }

      var base, parsed, scripts;

      if (!context) {

          // Stop scripts or inline event handlers from being executed immediately
          // by using document.implementation
          if (support.createHTMLDocument) {
              context = document$1.implementation.createHTMLDocument("");

              // Set the base href for the created document
              // so any parsed elements with URLs
              // are based on the document's URL (gh-2965)
              base = context.createElement("base");
              base.href = document$1.location.href;
              context.head.appendChild(base);
          } else {
              context = document$1;
          }
      }

      parsed = rsingleTag.exec(data);
      scripts = !keepScripts && [];

      // Single tag
      if (parsed) {
          return [context.createElement(parsed[1])];
      }

      parsed = buildFragment([data], context, scripts);

      if (scripts && scripts.length) {
          jQuery(scripts).remove();
      }

      return jQuery.merge([], parsed.childNodes);
  };


  jQuery.offset = {
      setOffset: function (elem, options, i) {
          var curPosition, curLeft, curCSSTop, curTop, curOffset, curCSSLeft, calculatePosition,
              position = jQuery.css(elem, "position"),
              curElem = jQuery(elem),
              props = {};

          // Set position first, in-case top/left are set even on static elem
          if (position === "static") {
              elem.style.position = "relative";
          }

          curOffset = curElem.offset();
          curCSSTop = jQuery.css(elem, "top");
          curCSSLeft = jQuery.css(elem, "left");
          calculatePosition = (position === "absolute" || position === "fixed") &&
              (curCSSTop + curCSSLeft).indexOf("auto") > -1;

          // Need to be able to calculate position if either
          // top or left is auto and position is either absolute or fixed
          if (calculatePosition) {
              curPosition = curElem.position();
              curTop = curPosition.top;
              curLeft = curPosition.left;

          } else {
              curTop = parseFloat(curCSSTop) || 0;
              curLeft = parseFloat(curCSSLeft) || 0;
          }

          if (isFunction(options)) {

              // Use jQuery.extend here to allow modification of coordinates argument (gh-1848)
              options = options.call(elem, i, jQuery.extend({}, curOffset));
          }

          if (options.top != null) {
              props.top = (options.top - curOffset.top) + curTop;
          }
          if (options.left != null) {
              props.left = (options.left - curOffset.left) + curLeft;
          }

          if ("using" in options) {
              options.using.call(elem, props);

          } else {
              curElem.css(props);
          }
      }
  };

  jQuery.fn.extend({

      // offset() relates an element's border box to the document origin
      offset: function (options) {

          // Preserve chaining for setter
          if (arguments.length) {
              return options === undefined ?
                  this :
                  this.each(function (i) {
                      jQuery.offset.setOffset(this, options, i);
                  });
          }

          var rect, win,
              elem = this[0];

          if (!elem) {
              return;
          }

          // Return zeros for disconnected and hidden (display: none) elements (gh-2310)
          // Support: IE <=11 only
          // Running getBoundingClientRect on a
          // disconnected node in IE throws an error
          if (!elem.getClientRects().length) {
              return {top: 0, left: 0};
          }

          // Get document-relative position by adding viewport scroll to viewport-relative gBCR
          rect = elem.getBoundingClientRect();
          win = elem.ownerDocument.defaultView;
          return {
              top: rect.top + win.pageYOffset,
              left: rect.left + win.pageXOffset
          };
      },

      // position() relates an element's margin box to its offset parent's padding box
      // This corresponds to the behavior of CSS absolute positioning
      position: function () {
          if (!this[0]) {
              return;
          }

          var offsetParent, offset, doc,
              elem = this[0],
              parentOffset = {top: 0, left: 0};

          // position:fixed elements are offset from the viewport, which itself always has zero offset
          if (jQuery.css(elem, "position") === "fixed") {

              // Assume position:fixed implies availability of getBoundingClientRect
              offset = elem.getBoundingClientRect();

          } else {
              offset = this.offset();

              // Account for the *real* offset parent, which can be the document or its root element
              // when a statically positioned element is identified
              doc = elem.ownerDocument;
              offsetParent = elem.offsetParent || doc.documentElement;
              while (offsetParent &&
              (offsetParent === doc.body || offsetParent === doc.documentElement) &&
              jQuery.css(offsetParent, "position") === "static") {

                  offsetParent = offsetParent.parentNode;
              }
              if (offsetParent && offsetParent !== elem && offsetParent.nodeType === 1) {

                  // Incorporate borders into its offset, since they are outside its content origin
                  parentOffset = jQuery(offsetParent).offset();
                  parentOffset.top += jQuery.css(offsetParent, "borderTopWidth", true);
                  parentOffset.left += jQuery.css(offsetParent, "borderLeftWidth", true);
              }
          }

          // Subtract parent offsets and element margins
          return {
              top: offset.top - parentOffset.top - jQuery.css(elem, "marginTop", true),
              left: offset.left - parentOffset.left - jQuery.css(elem, "marginLeft", true)
          };
      },

      // This method will return documentElement in the following cases:
      // 1) For the element inside the iframe without offsetParent, this method will return
      //    documentElement of the parent window
      // 2) For the hidden or detached element
      // 3) For body or html element, i.e. in case of the html node - it will return itself
      //
      // but those exceptions were never presented as a real life use-cases
      // and might be considered as more preferable results.
      //
      // This logic, however, is not guaranteed and can change at any point in the future
      offsetParent: function () {
          return this.map(function () {
              var offsetParent = this.offsetParent;

              while (offsetParent && jQuery.css(offsetParent, "position") === "static") {
                  offsetParent = offsetParent.offsetParent;
              }

              return offsetParent || documentElement;
          });
      }
  });

  // Create scrollLeft and scrollTop methods
  jQuery.each({scrollLeft: "pageXOffset", scrollTop: "pageYOffset"}, function (method, prop) {
      var top = "pageYOffset" === prop;

      jQuery.fn[method] = function (val) {
          return access(this, function (elem, method, val) {

              // Coalesce documents and windows
              var win;
              if (isWindow(elem)) {
                  win = elem;
              } else if (elem.nodeType === 9) {
                  win = elem.defaultView;
              }

              if (val === undefined) {
                  return win ? win[prop] : elem[method];
              }

              if (win) {
                  win.scrollTo(
                      !top ? val : win.pageXOffset,
                      top ? val : win.pageYOffset
                  );

              } else {
                  elem[method] = val;
              }
          }, method, val, arguments.length);
      };
  });

  // Support: Safari <=7 - 9.1, Chrome <=37 - 49
  // Add the top/left cssHooks using jQuery.fn.position
  // Webkit bug: https://bugs.webkit.org/show_bug.cgi?id=29084
  // Blink bug: https://bugs.chromium.org/p/chromium/issues/detail?id=589347
  // getComputedStyle returns percent when specified for top/left/bottom/right;
  // rather than make the css module depend on the offset module, just check for it here
  jQuery.each(["top", "left"], function (i, prop) {
      jQuery.cssHooks[prop] = addGetHookIf(support.pixelPosition,
          function (elem, computed) {
              if (computed) {
                  computed = curCSS(elem, prop);

                  // If curCSS returns percentage, fallback to offset
                  return rnumnonpx.test(computed) ?
                      jQuery(elem).position()[prop] + "px" :
                      computed;
              }
          }
      );
  });


  // Create innerHeight, innerWidth, height, width, outerHeight and outerWidth methods
  jQuery.each({Height: "height", Width: "width"}, function (name, type) {
      jQuery.each({padding: "inner" + name, content: type, "": "outer" + name},
          function (defaultExtra, funcName) {

              // Margin is only for outerHeight, outerWidth
              jQuery.fn[funcName] = function (margin, value) {
                  var chainable = arguments.length && (defaultExtra || typeof margin !== "boolean"),
                      extra = defaultExtra || (margin === true || value === true ? "margin" : "border");

                  return access(this, function (elem, type, value) {
                      var doc;

                      if (isWindow(elem)) {

                          // $( window ).outerWidth/Height return w/h including scrollbars (gh-1729)
                          return funcName.indexOf("outer") === 0 ?
                              elem["inner" + name] :
                              elem.document.documentElement["client" + name];
                      }

                      // Get document width or height
                      if (elem.nodeType === 9) {
                          doc = elem.documentElement;

                          // Either scroll[Width/Height] or offset[Width/Height] or client[Width/Height],
                          // whichever is greatest
                          return Math.max(
                              elem.body["scroll" + name], doc["scroll" + name],
                              elem.body["offset" + name], doc["offset" + name],
                              doc["client" + name]
                          );
                      }

                      return value === undefined ?

                          // Get width or height on the element, requesting but not forcing parseFloat
                          jQuery.css(elem, type, extra) :

                          // Set width or height on the element
                          jQuery.style(elem, type, value, extra);
                  }, type, chainable ? margin : undefined, chainable);
              };
          });
  });


  jQuery.each(("blur focus focusin focusout resize scroll click dblclick " +
      "mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave " +
      "change select submit keydown keypress keyup contextmenu").split(" "),
      function (i, name) {

          // Handle event binding
          jQuery.fn[name] = function (data, fn) {
              return arguments.length > 0 ?
                  this.on(name, null, data, fn) :
                  this.trigger(name);
          };
      });

  jQuery.fn.extend({
      hover: function (fnOver, fnOut) {
          return this.mouseenter(fnOver).mouseleave(fnOut || fnOver);
      }
  });


  jQuery.fn.extend({

      bind: function (types, data, fn) {
          return this.on(types, null, data, fn);
      },
      unbind: function (types, fn) {
          return this.off(types, null, fn);
      },

      delegate: function (selector, types, data, fn) {
          return this.on(types, selector, data, fn);
      },
      undelegate: function (selector, types, fn) {

          // ( namespace ) or ( selector, types [, fn] )
          return arguments.length === 1 ?
              this.off(selector, "**") :
              this.off(types, selector || "**", fn);
      }
  });

  // Bind a function to a context, optionally partially applying any
  // arguments.
  // jQuery.proxy is deprecated to promote standards (specifically Function#bind)
  // However, it is not slated for removal any time soon
  jQuery.proxy = function (fn, context) {
      var tmp, args, proxy;

      if (typeof context === "string") {
          tmp = fn[context];
          context = fn;
          fn = tmp;
      }

      // Quick check to determine if target is callable, in the spec
      // this throws a TypeError, but we will just return undefined.
      if (!isFunction(fn)) {
          return undefined;
      }

      // Simulated bind
      args = slice.call(arguments, 2);
      proxy = function () {
          return fn.apply(context || this, args.concat(slice.call(arguments)));
      };

      // Set the guid of unique handler to the same of original handler, so it can be removed
      proxy.guid = fn.guid = fn.guid || jQuery.guid++;

      return proxy;
  };

  jQuery.holdReady = function (hold) {
      if (hold) {
          jQuery.readyWait++;
      } else {
          jQuery.ready(true);
      }
  };
  jQuery.isArray = Array.isArray;
  jQuery.parseJSON = JSON.parse;
  jQuery.nodeName = nodeName;
  jQuery.isFunction = isFunction;
  jQuery.isWindow = isWindow;
  jQuery.camelCase = camelCase;
  jQuery.type = toType;

  jQuery.now = Date.now;

  jQuery.isNumeric = function (obj) {

      // As of jQuery 3.0, isNumeric is limited to
      // strings and numbers (primitives or objects)
      // that can be coerced to finite numbers (gh-2662)
      var type = jQuery.type(obj);
      return (type === "number" || type === "string") &&

          // parseFloat NaNs numeric-cast false positives ("")
          // ...but misinterprets leading-number strings, particularly hex literals ("0x...")
          // subtraction forces infinities to NaN
          !isNaN(obj - parseFloat(obj));
  };

  const $$1 = jQuery;

  function div$1(options) {
      return create$1("div", options);
  }

  function create$1(tag, options) {
      const elem = document.createElement(tag);
      if (options) {
          if (options.class) {
              elem.classList.add(options.class);
          }
          if (options.id) {
              elem.id = options.id;
          }
          if(options.style) {
              applyStyle$1(elem, options.style);
          }
      }
      return elem;
  }

  function hide$1(elem) {
      const cssStyle = getComputedStyle(elem);
      if(cssStyle.display !== "none") {
          elem._initialDisplay = cssStyle.display;
      }
      elem.style.display = "none";
  }

  function show$1(elem) {
      const currentDisplay = getComputedStyle(elem).display;
      if (currentDisplay === "none") {
          const d = elem._initialDisplay || "block";
          elem.style.display = d;
      }
  }

  function hideAll(selector) {
      document.querySelectorAll(selector).forEach(elem => { hide$1(elem); });
  }

  function empty(elem) {
      while(elem.firstChild){
          elem.removeChild(elem.firstChild);
      }
  }

  function offset(elem) {
      // Return zeros for disconnected and hidden (display: none) elements (gh-2310)
      // Support: IE <=11 only
      // Running getBoundingClientRect on a
      // disconnected node in IE throws an error
      if (!elem.getClientRects().length) {
          return {top: 0, left: 0};
      }

      // Get document-relative position by adding viewport scroll to viewport-relative gBCR
      const rect = elem.getBoundingClientRect();
      const win = elem.ownerDocument.defaultView;
      return {
          top: rect.top + win.pageYOffset,
          left: rect.left + win.pageXOffset
      };
  }

  function pageCoordinates(e) {

      if (e.type.startsWith("touch")) {
          const touch = e.touches[0];
          return {x: touch.pageX, y: touch.pageY};
      } else {
          return {x: e.pageX, y: e.pageY}
      }
  }

  const relativeDOMBBox = (parentElement, childElement) => {
      const { x: x_p, y: y_p, width: width_p, height: height_p } = parentElement.getBoundingClientRect();
      const { x: x_c, y: y_c, width: width_c, height: height_c } = childElement.getBoundingClientRect();
      return { x: (x_c - x_p), y: (y_c - y_p), width: width_c, height:height_c };
  };

  function applyStyle$1(elem, style) {
      for (let key of Object.keys(style)) {
          elem.style[key] = style[key];
      }
  }

  function guid$2  () {
      return ("0000" + (Math.random() * Math.pow(36, 4) << 0).toString(36)).slice(-4);
  }

  let getMouseXY = (domElement, { clientX, clientY }) => {

      // DOMRect object with eight properties: left, top, right, bottom, x, y, width, height
      const { left, top, width, height } = domElement.getBoundingClientRect();

      const x = clientX - left;
      const y = clientY - top;
      return { x, y, xNormalized: x/width, yNormalized: y/height, width, height };

  };

  /**
   * Translate the mouse coordinates for the event to the coordinates for the given target element
   * @param event
   * @param domElement
   * @returns {{x: number, y: number}}
   */
  function translateMouseCoordinates(event, domElement) {

      const { clientX, clientY } = event;
      return getMouseXY(domElement, { clientX, clientY });

  }

  var domUtils = /*#__PURE__*/Object.freeze({
      __proto__: null,
      applyStyle: applyStyle$1,
      create: create$1,
      div: div$1,
      empty: empty,
      guid: guid$2,
      hide: hide$1,
      hideAll: hideAll,
      offset: offset,
      pageCoordinates: pageCoordinates,
      relativeDOMBBox: relativeDOMBBox,
      show: show$1,
      translateMouseCoordinates: translateMouseCoordinates
  });

  function createCheckbox$1(name, initialState) {
      const container = div$1({class: 'igv-ui-trackgear-popover-check-container'});
      const svg = iconMarkup$1('check', (true === initialState ? '#444' : 'transparent'));
      svg.style.borderColor = 'gray';
      svg.style.borderWidth = '1px';
      svg.style.borderStyle = 'solid';

      container.appendChild(svg);
      let label = div$1(); //{ class: 'igv-some-label-class' });
      label.textContent = name;
      container.appendChild(label);

      return container;
  }

  function createIcon$1(name, color) {
      return iconMarkup$1(name, color);
  }

  function iconMarkup$1(name, color) {
      color = color || "currentColor";
      let icon = icons$1[name];
      if (!icon) {
          console.error(`No icon named: ${name}`);
          icon = icons$1["question"];
      }

      const svg = document.createElementNS("http://www.w3.org/2000/svg", "svg");
      svg.setAttributeNS(null,'viewBox', '0 0 ' + icon[0] + ' ' + icon[1]);
      const path = document.createElementNS("http://www.w3.org/2000/svg", "path");
      path.setAttributeNS(null,'fill',  color );
      path.setAttributeNS(null,'d', icon[4]);
      svg.appendChild(path);
      return svg;
  }

  const icons$1 = {
      "check": [512, 512, [], "f00c", "M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"],
      "cog": [512, 512, [], "f013", "M444.788 291.1l42.616 24.599c4.867 2.809 7.126 8.618 5.459 13.985-11.07 35.642-29.97 67.842-54.689 94.586a12.016 12.016 0 0 1-14.832 2.254l-42.584-24.595a191.577 191.577 0 0 1-60.759 35.13v49.182a12.01 12.01 0 0 1-9.377 11.718c-34.956 7.85-72.499 8.256-109.219.007-5.49-1.233-9.403-6.096-9.403-11.723v-49.184a191.555 191.555 0 0 1-60.759-35.13l-42.584 24.595a12.016 12.016 0 0 1-14.832-2.254c-24.718-26.744-43.619-58.944-54.689-94.586-1.667-5.366.592-11.175 5.459-13.985L67.212 291.1a193.48 193.48 0 0 1 0-70.199l-42.616-24.599c-4.867-2.809-7.126-8.618-5.459-13.985 11.07-35.642 29.97-67.842 54.689-94.586a12.016 12.016 0 0 1 14.832-2.254l42.584 24.595a191.577 191.577 0 0 1 60.759-35.13V25.759a12.01 12.01 0 0 1 9.377-11.718c34.956-7.85 72.499-8.256 109.219-.007 5.49 1.233 9.403 6.096 9.403 11.723v49.184a191.555 191.555 0 0 1 60.759 35.13l42.584-24.595a12.016 12.016 0 0 1 14.832 2.254c24.718 26.744 43.619 58.944 54.689 94.586 1.667 5.366-.592 11.175-5.459 13.985L444.788 220.9a193.485 193.485 0 0 1 0 70.2zM336 256c0-44.112-35.888-80-80-80s-80 35.888-80 80 35.888 80 80 80 80-35.888 80-80z"],
      "exclamation": [192, 512, [], "f12a", "M176 432c0 44.112-35.888 80-80 80s-80-35.888-80-80 35.888-80 80-80 80 35.888 80 80zM25.26 25.199l13.6 272C39.499 309.972 50.041 320 62.83 320h66.34c12.789 0 23.331-10.028 23.97-22.801l13.6-272C167.425 11.49 156.496 0 142.77 0H49.23C35.504 0 24.575 11.49 25.26 25.199z"],
      "exclamation-circle": [512, 512, [], "f06a", "M504 256c0 136.997-111.043 248-248 248S8 392.997 8 256C8 119.083 119.043 8 256 8s248 111.083 248 248zm-248 50c-25.405 0-46 20.595-46 46s20.595 46 46 46 46-20.595 46-46-20.595-46-46-46zm-43.673-165.346l7.418 136c.347 6.364 5.609 11.346 11.982 11.346h48.546c6.373 0 11.635-4.982 11.982-11.346l7.418-136c.375-6.874-5.098-12.654-11.982-12.654h-63.383c-6.884 0-12.356 5.78-11.981 12.654z"],
      "exclamation-triangle": [576, 512, [], "f071", "M569.517 440.013C587.975 472.007 564.806 512 527.94 512H48.054c-36.937 0-59.999-40.055-41.577-71.987L246.423 23.985c18.467-32.009 64.72-31.951 83.154 0l239.94 416.028zM288 354c-25.405 0-46 20.595-46 46s20.595 46 46 46 46-20.595 46-46-20.595-46-46-46zm-43.673-165.346l7.418 136c.347 6.364 5.609 11.346 11.982 11.346h48.546c6.373 0 11.635-4.982 11.982-11.346l7.418-136c.375-6.874-5.098-12.654-11.982-12.654h-63.383c-6.884 0-12.356 5.78-11.981 12.654z"],
      "minus": [448, 512, [], "f068", "M424 318.2c13.3 0 24-10.7 24-24v-76.4c0-13.3-10.7-24-24-24H24c-13.3 0-24 10.7-24 24v76.4c0 13.3 10.7 24 24 24h400z"],
      "minus-circle": [512, 512, [], "f056", "M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zM124 296c-6.6 0-12-5.4-12-12v-56c0-6.6 5.4-12 12-12h264c6.6 0 12 5.4 12 12v56c0 6.6-5.4 12-12 12H124z"],
      "minus-square": [448, 512, [], "f146", "M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48zM92 296c-6.6 0-12-5.4-12-12v-56c0-6.6 5.4-12 12-12h264c6.6 0 12 5.4 12 12v56c0 6.6-5.4 12-12 12H92z"],
      "plus": [448, 512, [], "f067", "M448 294.2v-76.4c0-13.3-10.7-24-24-24H286.2V56c0-13.3-10.7-24-24-24h-76.4c-13.3 0-24 10.7-24 24v137.8H24c-13.3 0-24 10.7-24 24v76.4c0 13.3 10.7 24 24 24h137.8V456c0 13.3 10.7 24 24 24h76.4c13.3 0 24-10.7 24-24V318.2H424c13.3 0 24-10.7 24-24z"],
      "plus-circle": [512, 512, [], "f055", "M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zm144 276c0 6.6-5.4 12-12 12h-92v92c0 6.6-5.4 12-12 12h-56c-6.6 0-12-5.4-12-12v-92h-92c-6.6 0-12-5.4-12-12v-56c0-6.6 5.4-12 12-12h92v-92c0-6.6 5.4-12 12-12h56c6.6 0 12 5.4 12 12v92h92c6.6 0 12 5.4 12 12v56z"],
      "plus-square": [448, 512, [], "f0fe", "M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48zm-32 252c0 6.6-5.4 12-12 12h-92v92c0 6.6-5.4 12-12 12h-56c-6.6 0-12-5.4-12-12v-92H92c-6.6 0-12-5.4-12-12v-56c0-6.6 5.4-12 12-12h92v-92c0-6.6 5.4-12 12-12h56c6.6 0 12 5.4 12 12v92h92c6.6 0 12 5.4 12 12v56z"],
      "question": [384, 512, [], "f128", "M202.021 0C122.202 0 70.503 32.703 29.914 91.026c-7.363 10.58-5.093 25.086 5.178 32.874l43.138 32.709c10.373 7.865 25.132 6.026 33.253-4.148 25.049-31.381 43.63-49.449 82.757-49.449 30.764 0 68.816 19.799 68.816 49.631 0 22.552-18.617 34.134-48.993 51.164-35.423 19.86-82.299 44.576-82.299 106.405V320c0 13.255 10.745 24 24 24h72.471c13.255 0 24-10.745 24-24v-5.773c0-42.86 125.268-44.645 125.268-160.627C377.504 66.256 286.902 0 202.021 0zM192 373.459c-38.196 0-69.271 31.075-69.271 69.271 0 38.195 31.075 69.27 69.271 69.27s69.271-31.075 69.271-69.271-31.075-69.27-69.271-69.27z"],
      "save": [448, 512, [], "f0c7", "M433.941 129.941l-83.882-83.882A48 48 0 0 0 316.118 32H48C21.49 32 0 53.49 0 80v352c0 26.51 21.49 48 48 48h352c26.51 0 48-21.49 48-48V163.882a48 48 0 0 0-14.059-33.941zM224 416c-35.346 0-64-28.654-64-64 0-35.346 28.654-64 64-64s64 28.654 64 64c0 35.346-28.654 64-64 64zm96-304.52V212c0 6.627-5.373 12-12 12H76c-6.627 0-12-5.373-12-12V108c0-6.627 5.373-12 12-12h228.52c3.183 0 6.235 1.264 8.485 3.515l3.48 3.48A11.996 11.996 0 0 1 320 111.48z"],
      "search": [512, 512, [], "f002", "M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z"],
      "share": [512, 512, [], "f064", "M503.691 189.836L327.687 37.851C312.281 24.546 288 35.347 288 56.015v80.053C127.371 137.907 0 170.1 0 322.326c0 61.441 39.581 122.309 83.333 154.132 13.653 9.931 33.111-2.533 28.077-18.631C66.066 312.814 132.917 274.316 288 272.085V360c0 20.7 24.3 31.453 39.687 18.164l176.004-152c11.071-9.562 11.086-26.753 0-36.328z"],
      "spinner": [512, 512, [], "f110", "M304 48c0 26.51-21.49 48-48 48s-48-21.49-48-48 21.49-48 48-48 48 21.49 48 48zm-48 368c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.49-48-48-48zm208-208c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.49-48-48-48zM96 256c0-26.51-21.49-48-48-48S0 229.49 0 256s21.49 48 48 48 48-21.49 48-48zm12.922 99.078c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48c0-26.509-21.491-48-48-48zm294.156 0c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48c0-26.509-21.49-48-48-48zM108.922 60.922c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.491-48-48-48z"],
      "square": [448, 512, [], "f0c8", "M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48z"],
      "square-full": [512, 512, [], "f45c", "M512 512H0V0h512v512z"],
      "times": [384, 512, [], "f00d", "M323.1 441l53.9-53.9c9.4-9.4 9.4-24.5 0-33.9L279.8 256l97.2-97.2c9.4-9.4 9.4-24.5 0-33.9L323.1 71c-9.4-9.4-24.5-9.4-33.9 0L192 168.2 94.8 71c-9.4-9.4-24.5-9.4-33.9 0L7 124.9c-9.4 9.4-9.4 24.5 0 33.9l97.2 97.2L7 353.2c-9.4 9.4-9.4 24.5 0 33.9L60.9 441c9.4 9.4 24.5 9.4 33.9 0l97.2-97.2 97.2 97.2c9.3 9.3 24.5 9.3 33.9 0z"],
      "times-circle": [512, 512, [], "f057", "M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zm121.6 313.1c4.7 4.7 4.7 12.3 0 17L338 377.6c-4.7 4.7-12.3 4.7-17 0L256 312l-65.1 65.6c-4.7 4.7-12.3 4.7-17 0L134.4 338c-4.7-4.7-4.7-12.3 0-17l65.6-65-65.6-65.1c-4.7-4.7-4.7-12.3 0-17l39.6-39.6c4.7-4.7 12.3-4.7 17 0l65 65.7 65.1-65.6c4.7-4.7 12.3-4.7 17 0l39.6 39.6c4.7 4.7 4.7 12.3 0 17L312 256l65.6 65.1z"],
      "wrench": [512, 512, [], "f0ad", "M481.156 200c9.3 0 15.12 10.155 10.325 18.124C466.295 259.992 420.419 288 368 288c-79.222 0-143.501-63.974-143.997-143.079C223.505 65.469 288.548-.001 368.002 0c52.362.001 98.196 27.949 123.4 69.743C496.24 77.766 490.523 88 481.154 88H376l-40 56 40 56h105.156zm-171.649 93.003L109.255 493.255c-24.994 24.993-65.515 24.994-90.51 0-24.993-24.994-24.993-65.516 0-90.51L218.991 202.5c16.16 41.197 49.303 74.335 90.516 90.503zM104 432c0-13.255-10.745-24-24-24s-24 10.745-24 24 10.745 24 24 24 24-10.745 24-24z"],
  };

  var icons$1$1 = /*#__PURE__*/Object.freeze({
      __proto__: null,
      createCheckbox: createCheckbox$1,
      createIcon: createIcon$1
  });

  function attachDialogCloseHandlerWithParent$1(parent, closeHandler) {

      var container = document.createElement("div");
      parent.appendChild(container);
      container.appendChild(createIcon$1("times"));
      container.addEventListener('click', function (e) {
          e.preventDefault();
          e.stopPropagation();
          closeHandler();
      });
  }

  var uiUtils = /*#__PURE__*/Object.freeze({
      __proto__: null,
      attachDialogCloseHandlerWithParent: attachDialogCloseHandlerWithParent$1
  });

  /**
   * Make the target element movable by clicking and dragging on the handle.  This is not a general purprose function,
   * it makes several options specific to igv dialogs, the primary one being that the
   * target is absolutely positioned in pixel coordinates

   */

  let dragData$1;  // Its assumed we are only dragging one element at a time.

  function makeDraggable$2(target, handle, constraint) {

      handle.addEventListener('mousedown', dragStart.bind(target));

      function dragStart(event) {

          event.stopPropagation();
          event.preventDefault();

          const dragFunction = drag$2.bind(this);
          const dragEndFunction = dragEnd$2.bind(this);
          const computedStyle = getComputedStyle(this);

          dragData$1 =
              {
                  constraint,
                  dragFunction,
                  dragEndFunction,
                  screenX: event.screenX,
                  screenY: event.screenY,
                  top: parseInt(computedStyle.top.replace("px", "")),
                  left: parseInt(computedStyle.left.replace("px", ""))
              };

          document.addEventListener('mousemove', dragFunction);
          document.addEventListener('mouseup', dragEndFunction);
          document.addEventListener('mouseleave', dragEndFunction);
          document.addEventListener('mouseexit', dragEndFunction);
      }
  }

  function drag$2(event) {

      if (!dragData$1) {
          console.error("No drag data!");
          return;
      }
      event.stopPropagation();
      event.preventDefault();
      const dx = event.screenX - dragData$1.screenX;
      const dy = event.screenY - dragData$1.screenY;

      const left = dragData$1.left + dx;
      const  top = dragData$1.constraint ? Math.max(dragData$1.constraint.minY, dragData$1.top  + dy) : dragData$1.top  + dy;

      this.style.left = `${ left }px`;
      this.style.top  = `${  top }px`;
  }

  function dragEnd$2(event) {

      if (!dragData$1) {
          console.error("No drag data!");
          return;
      }
      event.stopPropagation();
      event.preventDefault();

      const dragFunction = dragData$1.dragFunction;
      const dragEndFunction = dragData$1.dragEndFunction;
      document.removeEventListener('mousemove', dragFunction);
      document.removeEventListener('mouseup', dragEndFunction);
      document.removeEventListener('mouseleave', dragEndFunction);
      document.removeEventListener('mouseexit', dragEndFunction);
      dragData$1 = undefined;
  }

  const httpMessages$1 =
      {
          "401": "Access unauthorized",
          "403": "Access forbidden",
          "404": "Not found"
      };


  class AlertDialog$1 {
      /**
       * Initialize a new alert dialog
       * @param parent
       * @param alertProps - Optional - properties such as scroll to error
       */
      constructor(parent, alertProps) {
          this.alertProps = Object.assign({
              /** When an alert is presented - focus occur */
              shouldFocus: true,
              /** When focus occur - scroll into that element in the view */
              preventScroll: false
          }, alertProps);

          // container
          this.container = div$1({class: "igv-ui-alert-dialog-container"});
          parent.appendChild(this.container);
          this.container.setAttribute('tabIndex', '-1');

          // header
          const header = div$1();
          this.container.appendChild(header);

          this.errorHeadline = div$1();
          header.appendChild(this.errorHeadline);
          this.errorHeadline.textContent = '';

          // body container
          let bodyContainer = div$1({class: 'igv-ui-alert-dialog-body'});
          this.container.appendChild(bodyContainer);

          // body copy
          this.body = div$1({class: 'igv-ui-alert-dialog-body-copy'});
          bodyContainer.appendChild(this.body);

          // ok container
          let ok_container = div$1();
          this.container.appendChild(ok_container);

          // ok
          this.ok = div$1();
          ok_container.appendChild(this.ok);
          this.ok.textContent = 'OK';

          const okHandler = () => {

              if (typeof this.callback === 'function') {
                  this.callback("OK");
                  this.callback = undefined;
              }
              this.body.innerHTML = '';
              hide$1(this.container);
          };

          this.ok.addEventListener('click', event => {

              event.stopPropagation();

              okHandler();
          });

          this.container.addEventListener('keypress', event => {

              event.stopPropagation();

              if ('Enter' === event.key) {
                  okHandler();
              }
          });

          makeDraggable$2(this.container, header);

          hide$1(this.container);
      }

      present(alert, callback) {

          this.errorHeadline.textContent = alert.message ? 'ERROR' : '';
          let string = alert.message || alert;

          if (httpMessages$1.hasOwnProperty(string)) {
              string = httpMessages$1[string];
          }

          this.body.innerHTML = string;
          this.callback = callback;
          show$1(this.container);
          if (this.alertProps.shouldFocus) {
              this.container.focus(
                  { preventScroll: this.alertProps.preventScroll }
              );
          }
      }
  }

  class InputDialog {

      constructor(parent) {

          this.parent = parent;

          // dialog container
          this.container = div$1({class: 'igv-ui-generic-dialog-container'});
          parent.appendChild(this.container);

          // const { x, y, width, height } = this.container.getBoundingClientRect();
          // console.log(`InputDialog - x ${ x } y ${ y } width ${ width } height ${ height }`)

          // dialog header
          const header = div$1({class: 'igv-ui-generic-dialog-header'});
          this.container.appendChild(header);

          // dialog label
          this.label = div$1({class: 'igv-ui-generic-dialog-one-liner'});
          this.container.appendChild(this.label);
          this.label.text = 'Unlabeled';

          // input container
          this.input_container = div$1({class: 'igv-ui-generic-dialog-input'});
          this.container.appendChild(this.input_container);
          //
          this.input = document.createElement("input");
          this.input_container.appendChild(this.input);


          // ok | cancel
          const buttons = div$1({class: 'igv-ui-generic-dialog-ok-cancel'});
          this.container.appendChild(buttons);

          // ok
          this.ok = div$1();
          buttons.appendChild(this.ok);
          this.ok.textContent = 'OK';

          // cancel
          this.cancel = div$1();
          buttons.appendChild(this.cancel);
          this.cancel.textContent = 'Cancel';

          hide$1(this.container);

          this.input.addEventListener('keyup', e => {
              if (13 === e.keyCode) {
                  if (typeof this.callback === 'function') {
                      this.callback(this.input.value);
                      this.callback = undefined;
                  }
                  this.input.value = undefined;
                  hide$1(this.container);
              }
          });

          this.ok.addEventListener('click', () => {
              if (typeof this.callback === 'function') {
                  this.callback(this.input.value);
                  this.callback = undefined;
              }
              this.input.value = undefined;
              hide$1(this.container);
          });

          const cancel = () => {
              this.input.value = '';
              hide$1(this.container);
          };

          this.cancel.addEventListener('click', cancel);

          attachDialogCloseHandlerWithParent$1(header, cancel);
          makeDraggable$2(this.container, header);

      }

      present(options, e) {

          this.label.textContent = options.label;
          this.input.value = options.value;
          this.callback = options.callback || options.click;

          show$1(this.container);
          this.clampLocation(e.clientX, e.clientY);

      }

      clampLocation(clientX, clientY) {

          const { width:w, height:h } = this.container.getBoundingClientRect();
          const wh = window.innerHeight;
          const ww = window.innerWidth;

          const y = Math.min(wh - h, clientY);
          const x = Math.min(ww - w, clientX);
          this.container.style.left = `${ x }px`;
          this.container.style.top  = `${ y }px`;

      }
  }

  const appleCrayonPalette =
      {
          licorice: "#000000",
          lead: "#1e1e1e",
          tungsten: "#3a3a3a",
          iron: "#545453",
          steel: "#6e6e6e",
          tin: "#878687",
          nickel: "#888787",
          aluminum: "#a09fa0",
          magnesium: "#b8b8b8",
          silver: "#d0d0d0",
          mercury: "#e8e8e8",
          snow: "#ffffff",
          //
          cayenne: "#891100",
          mocha: "#894800",
          aspargus: "#888501",
          fern: "#458401",
          clover: "#028401",
          moss: "#018448",
          teal: "#008688",
          ocean: "#004a88",
          midnight: "#001888",
          eggplant: "#491a88",
          plum: "#891e88",
          maroon: "#891648",
          //
          maraschino: "#ff2101",
          tangerine: "#ff8802",
          lemon: "#fffa03",
          lime: "#83f902",
          spring: "#05f802",
          seam_foam: "#03f987",
          turquoise: "#00fdff",
          aqua: "#008cff",
          blueberry: "#002eff",
          grape: "#8931ff",
          magenta: "#ff39ff",
          strawberry: "#ff2987",
          //
          salmon: "#ff726e",
          cantaloupe: "#ffce6e",
          banana: "#fffb6d",
          honeydew: "#cefa6e",
          flora: "#68f96e",
          spindrift: "#68fbd0",
          ice: "#68fdff",
          sky: "#6acfff",
          orchid: "#6e76ff",
          lavender: "#d278ff",
          bubblegum: "#ff7aff",
          carnation: "#ff7fd3"
      };

  class GenericContainer {

      constructor({parent,  top, left, width, height, border, closeHandler}) {

          let container = div$1({class: 'igv-ui-generic-container'});
          parent.appendChild(container);
          hide$1(container);
          this.container = container;

          if(top !== undefined) {
              this.container.style.top = `${ top }px`;
          }
          if(left !== undefined) {
              this.container.style.left = `${ left }px`;
          }
          if (width !== undefined) {
              this.container.style.width = `${ width }px`;
          }
          if (height !== undefined) {
              this.container.style.height = `${ height }px`;
          }
          if(border) {
              this.container.style.border = border;
          }
          //
          // let bbox = parent.getBoundingClientRect();
          // this.origin = {x: bbox.x, y: bbox.y};
          // this.container.offset({left: this.origin.x, top: this.origin.y});

          // header
          const header = div$1();
          this.container.appendChild(header);

          // close button
          attachDialogCloseHandlerWithParent$1(header, (e) => {
              hide$1(this.container);
              if(typeof closeHandler === "function") {
                  closeHandler(e);
              }
          });

          makeDraggable$2(this.container, header);
      }

      show() {
          show$1(this.container);
      }

      hide() {
          hide$1(this.container);
      }

      dispose() {
          if(this.container.parent)  {
              this.container.parent.removeChild(this.container);
          }
      }
  }

  class ColorPicker extends GenericContainer {

      constructor({parent, top, left, width, height, defaultColors, colorHandler}) {

          super({ parent, top, left, width, height, border: '1px solid gray'});

          createColorSwatchSelector(this.container, colorHandler, defaultColors);
      }

  }

  const createColorSwatchSelector = (container, colorHandler, defaultColors) => {

      const hexColorStrings = Object.values(appleCrayonPalette);

      for (let hexColorString of hexColorStrings) {
          const swatch = div$1({ class: 'igv-ui-color-swatch' });
          container.appendChild(swatch);
          decorateSwatch(swatch, hexColorString, colorHandler);
      }

      if (defaultColors) {
          for (let hexColorString of defaultColors) {
              const swatch = div$1({ class: 'igv-ui-color-swatch' });
              container.appendChild(swatch);
              decorateSwatch(swatch, hexColorString, colorHandler);
          }
      }

  };

  const decorateSwatch = (swatch, hexColorString, colorHandler) => {

      swatch.style.backgroundColor = hexColorString;

      swatch.addEventListener('mouseenter', e => swatch.style.borderColor = hexColorString);

      swatch.addEventListener('mouseleave', e => swatch.style.borderColor = 'white');

      swatch.addEventListener('click', event => {
          event.stopPropagation();
          colorHandler(hexColorString);
      });

      swatch.addEventListener('touchend', event => {
          event.stopPropagation();
          colorHandler(hexColorString);
      });

  };

  class Popover {

      constructor(parent, title) {

          this.parent = parent;

          // popover
          this.popover = div$1({ class: "igv-ui-popover" });
          parent.appendChild(this.popover);

          // header
          const popoverHeader = div$1();
          this.popover.appendChild(popoverHeader);

          const titleElement = div$1();
          popoverHeader.appendChild(titleElement);
          if (title) {
              titleElement.textContent = title;
          }

          attachDialogCloseHandlerWithParent$1(popoverHeader,  () => this.hide());
          makeDraggable$2(this.popover, popoverHeader);

          // content
          this.popoverContent = div$1();
          this.popover.appendChild(this.popoverContent);

          this.popover.style.display = 'none';


      }

      presentContentWithEvent(e, content) {

          this.popover.style.display = 'block';

          this.popoverContent.innerHTML = content;

          present$1(e, this.popover, this.popoverContent);

      }

      presentMenu(e, menuItems) {

          if (0 === menuItems.length) {
              return
          }

          this.popover.style.display = 'block';

          const menuElements = createMenuElements$1(menuItems, this.popover);
          for (let item of menuElements) {
              this.popoverContent.appendChild(item.object);
          }

          present$1(e, this.popover, this.popoverContent);
      }

      hide() {
          this.popover.style.display = 'none';
          this.dispose();
      }

      dispose() {

          if (this.popover) {
              this.popover.parentNode.removeChild(this.popover);
          }

          const keys = Object.keys(this);
          for (let key of keys) {
              this[ key ] = undefined;
          }
      }

  }

  function present$1(e, popover, popoverContent) {

      const { x, y, width } = translateMouseCoordinates(e, popover.parentNode);
      popover.style.top  = `${ y }px`;

      const { width: w } = popover.getBoundingClientRect();

      const xmax = x + w;
      const delta = xmax - width;

      popover.style.left = `${ xmax > width ? (x - delta) : x }px`;
      popoverContent.style.maxWidth = `${ Math.min(w, width) }px`;


  }

  function createMenuElements$1(itemList, popover) {

      const list  = itemList.map(function (item, i) {
          let elem;

          if (typeof item === 'string') {
              elem = div$1();
              elem.innerHTML = item;
          } else if (typeof item === 'Node') {
              elem = item;
          } else {
              if (typeof item.init === 'function') {
                  item.init();
              }

              if ("checkbox" === item.type) {
                  elem = createCheckbox$1("Show all bases", item.value);
              } else if("color" === item.type) {
                  const colorPicker = new ColorPicker({
                      parent: popover.parentElement,
                      width: 364,
                      //defaultColor: 'aqua',
                      colorHandler: (color) => item.click(color)
                  });
                  elem = div$1();
                  if (typeof item.label === 'string') {
                      elem.innerHTML = item.label;
                  }
                  const clickHandler =  e => {
                      colorPicker.show();
                      hide$1(popover);
                      e.preventDefault();
                      e.stopPropagation();
                  };
                  elem.addEventListener('click', clickHandler);
                  elem.addEventListener('touchend', clickHandler);
                  elem.addEventListener('mouseup', function (e) {
                      e.preventDefault();
                      e.stopPropagation();
                  });
              }

              else {
                  elem = div$1();
                  if (typeof item.label === 'string') {
                      elem.innerHTML = item.label;
                  }
              }

              if (item.click && "color" !== item.type) {
                  elem.addEventListener('click', handleClick);
                  elem.addEventListener('touchend', handleClick);
                  elem.addEventListener('mouseup', function (e) {
                      e.preventDefault();
                      e.stopPropagation();
                  });

                  // eslint-disable-next-line no-inner-declarations
                  function handleClick(e) {
                      item.click();
                      hide$1(popover);
                      e.preventDefault();
                      e.stopPropagation();
                  }
              }
          }


          return { object: elem, init: item.init };
      });

      return list;
  }

  class GenericColorPicker extends GenericContainer {

      constructor({parent, width}) {
          super({parent, width, border: '1px solid gray'});
      }

      configure(defaultColors, colorHandlers) {

          this.colorHandlers = colorHandlers;

          // active color handler defaults to handler with 'color' as key
          this.setActiveColorHandler('color');

          this.createSwatches(defaultColors);

      }

      setActiveColorHandler(option) {
          this.activeColorHandler = this.colorHandlers[option];
      }

      createSwatches(defaultColors) {

          this.container.querySelectorAll('.igv-ui-color-swatch').forEach(swatch => swatch.remove());

          const hexColorStrings = Object.values(appleCrayonPalette);

          for (let hexColorString of hexColorStrings) {
              const swatch = div$1({class: 'igv-ui-color-swatch'});
              this.container.appendChild(swatch);
              this.decorateSwatch(swatch, hexColorString);
          }

          if (defaultColors) {
              for (let hexColorString of defaultColors) {
                  const swatch = div$1({class: 'igv-ui-color-swatch'});
                  this.container.appendChild(swatch);
                  this.decorateSwatch(swatch, hexColorString);
              }
          }

      }

      decorateSwatch(swatch, hexColorString) {

          swatch.style.backgroundColor = hexColorString;

          swatch.addEventListener('mouseenter', () => swatch.style.borderColor = hexColorString);

          swatch.addEventListener('mouseleave', () => swatch.style.borderColor = 'white');

          swatch.addEventListener('click', event => {
              event.stopPropagation();
              this.activeColorHandler(hexColorString);
          });

          swatch.addEventListener('touchend', event => {
              event.stopPropagation();
              this.activeColorHandler(hexColorString);
          });

      }

  }

  function embedCSS$2() {
      const style = document.createElement('style');
      style.setAttribute('type', 'text/css');
      style.setAttribute('title', 'igv-ui.css');
      style.innerHTML = `.igv-ui-popover {
  cursor: default;
  position: absolute;
  z-index: 2048;
  border-color: #7F7F7F;
  border-radius: 4px;
  border-style: solid;
  border-width: 1px;
  font-family: "Open Sans", sans-serif;
  font-size: small;
  background-color: white;
}
.igv-ui-popover > div:first-child {
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  justify-content: space-between;
  align-items: center;
  width: 100%;
  height: 24px;
  cursor: move;
  border-top-left-radius: 4px;
  border-top-right-radius: 4px;
  border-bottom-color: #7F7F7F;
  border-bottom-style: solid;
  border-bottom-width: thin;
  background-color: #eee;
}
.igv-ui-popover > div:first-child > div:first-child {
  margin-left: 4px;
}
.igv-ui-popover > div:first-child > div:last-child {
  margin-right: 4px;
  height: 12px;
  width: 12px;
  color: #7F7F7F;
}
.igv-ui-popover > div:first-child > div:last-child:hover {
  cursor: pointer;
  color: #444;
}
.igv-ui-popover > div:last-child {
  overflow-y: auto;
  overflow-x: hidden;
  max-height: 400px;
  max-width: 800px;
  background-color: white;
}
.igv-ui-popover > div:last-child > div {
  -webkit-user-select: text;
  -moz-user-select: text;
  -ms-user-select: text;
  user-select: text;
  margin-left: 4px;
  margin-right: 4px;
  min-width: 220px;
  overflow-x: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}
.igv-ui-popover > div:last-child > div > span {
  font-weight: bolder;
}
.igv-ui-popover > div:last-child hr {
  width: 100%;
}

.igv-ui-alert-dialog-container {
  box-sizing: content-box;
  position: absolute;
  z-index: 2048;
  top: 50%;
  left: 50%;
  width: 400px;
  height: 200px;
  border-color: #7F7F7F;
  border-radius: 4px;
  border-style: solid;
  border-width: thin;
  outline: none;
  font-family: "Open Sans", sans-serif;
  font-size: 15px;
  font-weight: 400;
  background-color: white;
  display: flex;
  flex-flow: column;
  flex-wrap: nowrap;
  justify-content: space-between;
  align-items: center;
}
.igv-ui-alert-dialog-container > div:first-child {
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: flex-start;
  align-items: center;
  width: 100%;
  height: 24px;
  cursor: move;
  border-top-left-radius: 4px;
  border-top-right-radius: 4px;
  border-bottom-color: #7F7F7F;
  border-bottom-style: solid;
  border-bottom-width: thin;
  background-color: #eee;
}
.igv-ui-alert-dialog-container > div:first-child div:first-child {
  padding-left: 8px;
}
.igv-ui-alert-dialog-container .igv-ui-alert-dialog-body {
  -webkit-user-select: text;
  -moz-user-select: text;
  -ms-user-select: text;
  user-select: text;
  color: #373737;
  width: 100%;
  height: calc(100% - 24px - 64px);
  overflow-y: scroll;
}
.igv-ui-alert-dialog-container .igv-ui-alert-dialog-body .igv-ui-alert-dialog-body-copy {
  margin: 16px;
  width: auto;
  height: auto;
  overflow-wrap: break-word;
  word-break: break-word;
  background-color: white;
  border: unset;
}
.igv-ui-alert-dialog-container > div:last-child {
  width: 100%;
  margin-bottom: 10px;
  background-color: white;
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: center;
  align-items: center;
}
.igv-ui-alert-dialog-container > div:last-child div {
  margin: unset;
  width: 40px;
  height: 30px;
  line-height: 30px;
  text-align: center;
  color: white;
  font-family: "Open Sans", sans-serif;
  font-size: small;
  font-weight: 400;
  border-color: #2B81AF;
  border-style: solid;
  border-width: thin;
  border-radius: 4px;
  background-color: #2B81AF;
}
.igv-ui-alert-dialog-container > div:last-child div:hover {
  cursor: pointer;
  border-color: #25597f;
  background-color: #25597f;
}

.igv-ui-color-swatch {
  position: relative;
  box-sizing: content-box;
  display: flex;
  flex-flow: row;
  flex-wrap: wrap;
  justify-content: center;
  align-items: center;
  width: 32px;
  height: 32px;
  border-style: solid;
  border-width: 2px;
  border-color: white;
  border-radius: 4px;
}

.igv-ui-color-swatch:hover {
  border-color: dimgray;
}

.igv-ui-colorpicker-menu-close-button {
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: flex-end;
  align-items: center;
  width: 100%;
  height: 32px;
  margin-top: 4px;
  margin-bottom: 4px;
  padding-right: 8px;
}
.igv-ui-colorpicker-menu-close-button i.fa {
  display: block;
  margin-left: 4px;
  margin-right: 4px;
  color: #5f5f5f;
}
.igv-ui-colorpicker-menu-close-button i.fa:hover,
.igv-ui-colorpicker-menu-close-button i.fa:focus,
.igv-ui-colorpicker-menu-close-button i.fa:active {
  cursor: pointer;
  color: #0f0f0f;
}

.igv-ui-generic-dialog-container {
  box-sizing: content-box;
  position: fixed;
  top: 0;
  left: 0;
  width: 300px;
  height: 200px;
  border-color: #7F7F7F;
  border-radius: 4px;
  border-style: solid;
  border-width: thin;
  font-family: "Open Sans", sans-serif;
  font-size: medium;
  font-weight: 400;
  z-index: 2048;
  background-color: white;
  display: flex;
  flex-flow: column;
  flex-wrap: nowrap;
  justify-content: flex-start;
  align-items: center;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-header {
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: flex-end;
  align-items: center;
  width: 100%;
  height: 24px;
  cursor: move;
  border-top-left-radius: 4px;
  border-top-right-radius: 4px;
  border-bottom-color: #7F7F7F;
  border-bottom-style: solid;
  border-bottom-width: thin;
  background-color: #eee;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-header div {
  margin-right: 4px;
  margin-bottom: 2px;
  height: 12px;
  width: 12px;
  color: #7F7F7F;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-header div:hover {
  cursor: pointer;
  color: #444;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-one-liner {
  color: #373737;
  width: 95%;
  height: 24px;
  line-height: 24px;
  text-align: left;
  margin-top: 8px;
  padding-left: 8px;
  overflow-wrap: break-word;
  background-color: white;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-label-input {
  margin-top: 8px;
  width: 95%;
  height: 24px;
  color: #373737;
  line-height: 24px;
  padding-left: 8px;
  background-color: white;
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: flex-start;
  align-items: center;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-label-input div {
  width: 30%;
  height: 100%;
  font-size: 16px;
  text-align: right;
  padding-right: 8px;
  background-color: white;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-label-input input {
  display: block;
  height: 100%;
  width: 100%;
  padding-left: 4px;
  font-family: "Open Sans", sans-serif;
  font-weight: 400;
  color: #373737;
  text-align: left;
  outline: none;
  border-style: solid;
  border-width: thin;
  border-color: #7F7F7F;
  background-color: white;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-label-input input {
  width: 50%;
  font-size: 16px;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-input {
  margin-top: 8px;
  width: calc(100% - 16px);
  height: 24px;
  color: #373737;
  line-height: 24px;
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: space-around;
  align-items: center;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-input input {
  display: block;
  height: 100%;
  width: 100%;
  padding-left: 4px;
  font-family: "Open Sans", sans-serif;
  font-weight: 400;
  color: #373737;
  text-align: left;
  outline: none;
  border-style: solid;
  border-width: thin;
  border-color: #7F7F7F;
  background-color: white;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-input input {
  font-size: 16px;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok-cancel {
  width: 100%;
  height: 28px;
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: space-around;
  align-items: center;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok-cancel div {
  margin-top: 32px;
  color: white;
  font-family: "Open Sans", sans-serif;
  font-size: 14px;
  font-weight: 400;
  width: 75px;
  height: 28px;
  line-height: 28px;
  text-align: center;
  border-color: transparent;
  border-style: solid;
  border-width: thin;
  border-radius: 2px;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok-cancel div:first-child {
  margin-left: 32px;
  margin-right: 0;
  background-color: #5ea4e0;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok-cancel div:last-child {
  margin-left: 0;
  margin-right: 32px;
  background-color: #c4c4c4;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok-cancel div:first-child:hover {
  cursor: pointer;
  background-color: #3b5c7f;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok-cancel div:last-child:hover {
  cursor: pointer;
  background-color: #7f7f7f;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok {
  width: 100%;
  height: 36px;
  margin-top: 32px;
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: space-around;
  align-items: center;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok div {
  width: 98px;
  height: 36px;
  line-height: 36px;
  text-align: center;
  color: white;
  font-family: "Open Sans", sans-serif;
  font-size: medium;
  font-weight: 400;
  border-color: white;
  border-style: solid;
  border-width: thin;
  border-radius: 4px;
  background-color: #2B81AF;
}
.igv-ui-generic-dialog-container .igv-ui-generic-dialog-ok div:hover {
  cursor: pointer;
  background-color: #25597f;
}

.igv-ui-generic-container {
  box-sizing: content-box;
  position: absolute;
  z-index: 2048;
  background-color: white;
  cursor: pointer;
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: flex-start;
  align-items: center;
}
.igv-ui-generic-container > div:first-child {
  cursor: move;
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: flex-end;
  align-items: center;
  height: 24px;
  width: 100%;
  background-color: #dddddd;
}
.igv-ui-generic-container > div:first-child > div {
  display: block;
  color: #5f5f5f;
  cursor: pointer;
  width: 14px;
  height: 14px;
  margin-right: 8px;
  margin-bottom: 4px;
}

.igv-ui-dialog {
  z-index: 2048;
  position: fixed;
  width: fit-content;
  height: fit-content;
  display: flex;
  flex-flow: column;
  flex-wrap: nowrap;
  justify-content: flex-start;
  background-color: white;
  border-color: #7F7F7F;
  border-radius: 4px;
  border-style: solid;
  border-width: thin;
  font-family: "Open Sans", sans-serif;
  font-size: medium;
  font-weight: 400;
}
.igv-ui-dialog .igv-ui-dialog-header {
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: flex-end;
  align-items: center;
  width: 100%;
  height: 24px;
  cursor: move;
  border-top-left-radius: 4px;
  border-top-right-radius: 4px;
  border-bottom-color: #7F7F7F;
  border-bottom-style: solid;
  border-bottom-width: thin;
  background-color: #eee;
}
.igv-ui-dialog .igv-ui-dialog-header div {
  margin-right: 4px;
  margin-bottom: 2px;
  height: 12px;
  width: 12px;
  color: #7F7F7F;
}
.igv-ui-dialog .igv-ui-dialog-header div:hover {
  cursor: pointer;
  color: #444;
}
.igv-ui-dialog .igv-ui-dialog-one-liner {
  width: 95%;
  height: 24px;
  line-height: 24px;
  text-align: left;
  margin: 8px;
  overflow-wrap: break-word;
  background-color: white;
  font-weight: bold;
}
.igv-ui-dialog .igv-ui-dialog-ok-cancel {
  width: 100%;
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: space-around;
  align-items: center;
}
.igv-ui-dialog .igv-ui-dialog-ok-cancel div {
  margin: 16px;
  margin-top: 32px;
  color: white;
  font-family: "Open Sans", sans-serif;
  font-size: 14px;
  font-weight: 400;
  width: 75px;
  height: 28px;
  line-height: 28px;
  text-align: center;
  border-color: transparent;
  border-style: solid;
  border-width: thin;
  border-radius: 2px;
}
.igv-ui-dialog .igv-ui-dialog-ok-cancel div:first-child {
  background-color: #5ea4e0;
}
.igv-ui-dialog .igv-ui-dialog-ok-cancel div:last-child {
  background-color: #c4c4c4;
}
.igv-ui-dialog .igv-ui-dialog-ok-cancel div:first-child:hover {
  cursor: pointer;
  background-color: #3b5c7f;
}
.igv-ui-dialog .igv-ui-dialog-ok-cancel div:last-child:hover {
  cursor: pointer;
  background-color: #7f7f7f;
}
.igv-ui-dialog .igv-ui-dialog-ok {
  width: 100%;
  height: 36px;
  margin-top: 32px;
  display: flex;
  flex-flow: row;
  flex-wrap: nowrap;
  justify-content: space-around;
  align-items: center;
}
.igv-ui-dialog .igv-ui-dialog-ok div {
  width: 98px;
  height: 36px;
  line-height: 36px;
  text-align: center;
  color: white;
  font-family: "Open Sans", sans-serif;
  font-size: medium;
  font-weight: 400;
  border-color: white;
  border-style: solid;
  border-width: thin;
  border-radius: 4px;
  background-color: #2B81AF;
}
.igv-ui-dialog .igv-ui-dialog-ok div:hover {
  cursor: pointer;
  background-color: #25597f;
}

.igv-ui-panel, .igv-ui-panel-row, .igv-ui-panel-column {
  z-index: 2048;
  background-color: white;
  font-family: "Open Sans", sans-serif;
  font-size: medium;
  font-weight: 400;
  display: flex;
  justify-content: flex-start;
  align-items: flex-start;
}

.igv-ui-panel-column {
  display: flex;
  flex-direction: column;
}

.igv-ui-panel-row {
  display: flex;
  flex-direction: row;
}

.igv-ui-textbox {
  background-color: white;
  font-family: "Open Sans", sans-serif;
  font-size: medium;
  font-weight: 400;
  display: flex;
  justify-content: flex-start;
  align-items: flex-start;
}

.igv-ui-table {
  background-color: white;
}

.igv-ui-table thead {
  position: sticky;
  top: 0;
}

.igv-ui-table th {
  text-align: left;
}

.igv-ui-table td {
  padding-right: 20px;
}

.igv-ui-table tr:hover {
  background-color: lightblue;
}

/*# sourceMappingURL=igv-ui.css.map */
`;
      document.head.append(style);
  }

  if (typeof document !== 'undefined') {

      if (!stylesheetExists("igv-ui.css")) {
          embedCSS$2();
      }

      function stylesheetExists(stylesheetName) {
          for (let ss of document.styleSheets) {
              ss = ss.href ? ss.href.replace(/^.*[\\\/]/, '') : '';
              if (ss === stylesheetName) {
                  return true
              }
          }
          return false
      }
  }

  function createCheckbox(name, initialState) {

      const container = domUtils.div({class: 'igv-menu-popup-check-container'});

      const div = domUtils.div();
      container.appendChild(div);

      const svg = icons$1$1.createIcon('check', (true === initialState ? '#444' : 'transparent'));
      div.appendChild(svg);

      const label = domUtils.div();
      label.innerText = name;
      container.appendChild(label);

      return container
  }

  /**
   * Configure item list for track "gear" menu.
   * @param trackView
   */
  const MenuUtils = {

      trackMenuItemList: function (trackView) {

          const vizWindowTypes = new Set(['alignment', 'annotation', 'variant', 'eqtl', 'snp']);

          const hasVizWindow = trackView.track.config && trackView.track.config.visibilityWindow !== undefined;

          let menuItems = [];

          if (trackView.track.config.type !== 'sequence') {
              menuItems.push(trackRenameMenuItem(trackView));
              menuItems.push(trackHeightMenuItem(trackView));
          }

          if (this.showColorPicker(trackView.track)) {
              menuItems.push('<hr/>');
              menuItems.push(colorPickerMenuItem({trackView, label: "Set track color", option: "color"}));
              menuItems.push(unsetColorMenuItem({trackView, label: "Unset track color"}));
             if(trackView.track.config.type === 'wig' || trackView.track.config.type === 'annotation') {
                 menuItems.push(colorPickerMenuItem({trackView, label: "Set alt color", option: "altColor"}));
             }
          }

          if (trackView.track.menuItemList) {
              menuItems = menuItems.concat(trackView.track.menuItemList());
          }

          if (hasVizWindow || vizWindowTypes.has(trackView.track.type)) {
              menuItems.push('<hr/>');
              menuItems.push(visibilityWindowMenuItem(trackView));
          }

          if (trackView.track.removable !== false) {
              menuItems.push('<hr/>');
              menuItems.push(trackRemovalMenuItem(trackView));
          }

          return menuItems
      },

      numericDataMenuItems: function (trackView) {

          const menuItems = [];

          menuItems.push('<hr/>');

          // Data range
          const object = $$1('<div>');
          object.text('Set data range');

          const click = () => {
              trackView.browser.dataRangeDialog.configure(trackView);
              trackView.browser.dataRangeDialog.present($$1(trackView.browser.columnContainer));
          };
          menuItems.push({object, click});

          if (trackView.track.logScale !== undefined) {
              menuItems.push({
                      object: $$1(createCheckbox("Log scale", trackView.track.logScale)),
                      click: () => {
                          trackView.track.logScale = !trackView.track.logScale;
                          trackView.repaintViews();
                      }
                  }
              );
          }

          menuItems.push({
                  object: $$1(createCheckbox("Autoscale", trackView.track.autoscale)),
                  click: () => {
                      trackView.track.autoscale = !trackView.track.autoscale;
                      trackView.updateViews();
                  }
              }
          );


          return menuItems
      },

      trackMenuItemListHelper: function (itemList, menuPopup) {

          var list = [];

          if (itemList.length > 0) {

              list = itemList.map(function (item, i) {
                  var $e;

                  // name and object fields checked for backward compatibility
                  if (item.name) {
                      $e = $$1('<div>');
                      $e.text(item.name);
                  } else if (item.object) {
                      $e = item.object;
                  } else if (typeof item.label === 'string') {
                      $e = $$1('<div>');
                      $e.html(item.label);
                  } else if (typeof item === 'string') {

                      if (item.startsWith("<")) {
                          $e = $$1(item);
                      } else {
                          $e = $$1("<div>" + item + "</div>");
                      }
                  }

                  if (0 === i) {
                      $e.addClass('igv-track-menu-border-top');
                  }

                  if (item.click) {
                      $e.on('click', handleClick);
                      $e.on('touchend', function (e) {
                          handleClick(e);
                      });
                      $e.on('mouseup', function (e) {
                          e.preventDefault();
                          e.stopPropagation();
                      });

                      // eslint-disable-next-line no-inner-declarations
                      function handleClick(e) {
                          item.click(e);
                          menuPopup.hide();
                          e.preventDefault();
                          e.stopPropagation();
                      }
                  }

                  return {object: $e, init: (item.init || undefined)}
              });
          }

          return list
      },

      showColorPicker(track) {
          return (
              undefined === track.type ||
              "bedtype" === track.type ||
              "alignment" === track.type ||
              "annotation" === track.type ||
              "variant" === track.type ||
              "wig" === track.type) ||
              'interact' === track.type
      },

      createMenuItem(label, action) {
          const object = $$1('<div>');
          object.text(label);
          return {object, click: action}
      }
  };


  function visibilityWindowMenuItem(trackView) {

      const click = e => {

          const callback = () => {

              let value = trackView.browser.inputDialog.input.value;
              value = '' === value || undefined === value ? -1 : value.trim();

              trackView.track.visibilityWindow = Number.parseInt(value);
              trackView.track.config.visibilityWindow = Number.parseInt(value);

              trackView.updateViews();
          };

          const config =
              {
                  label: 'Visibility Window',
                  value: (trackView.track.visibilityWindow),
                  callback
              };
          trackView.browser.inputDialog.present(config, e);

      };

      const object = $$1('<div>');
      object.text('Set visibility window');
      return {object, click}

  }

  function trackRemovalMenuItem(trackView) {

      const object = $$1('<div>');
      object.text('Remove track');

      return {object, click: () => trackView.browser.removeTrack(trackView.track)}

  }

  function colorPickerMenuItem({trackView, label, option}) {

      const $e = $$1('<div>');
      $e.text(label);

      return {
          object: $e,
          click: () => trackView.presentColorPicker(option)
      }
  }

  function unsetColorMenuItem({trackView, label}) {

      const $e = $$1('<div>');
      $e.text(label);

      return {
          object: $e,
          click: () => {
              trackView.track.color = undefined;
              trackView.repaintViews();
          }
      }
  }

  function trackRenameMenuItem(trackView) {

      const click = e => {

          const callback = function () {
              let value = trackView.browser.inputDialog.input.value;
              value = ('' === value || undefined === value) ? 'untitled' : value.trim();
              trackView.track.name = value;
          };

          const config =
              {
                  label: 'Track Name',
                  value: (getTrackLabelText(trackView.track) || 'unnamed'),
                  callback
              };

          trackView.browser.inputDialog.present(config, e);

      };

      const object = $$1('<div>');
      object.text('Set track name');
      return {object, click}


  }

  function trackHeightMenuItem(trackView) {

      const click = e => {

          const callback = () => {

              const number = Number(trackView.browser.inputDialog.input.value, 10);

              if (undefined !== number) {

                  // If explicitly setting the height adust min or max, if neccessary.
                  if (trackView.track.minHeight !== undefined && trackView.track.minHeight > number) {
                      trackView.track.minHeight = number;
                  }
                  if (trackView.track.maxHeight !== undefined && trackView.track.maxHeight < number) {
                      trackView.track.minHeight = number;
                  }
                  trackView.setTrackHeight(number, true);

                  trackView.checkContentHeight();
                  trackView.repaintViews();


                  // Explicitly setting track height turns off autoHeight
                  trackView.track.autoHeight = false;
              }

          };

          const config =
              {
                  label: 'Track Height',
                  value: trackView.track.height,
                  callback
              };

          trackView.browser.inputDialog.present(config, e);

      };

      const object = $$1('<div>');
      object.text('Set track height');
      return {object, click}


  }

  function getTrackLabelText(track) {
      var vp,
          txt;

      vp = track.trackView.viewports[0];
      txt = vp.$trackLabel.text();

      return txt
  }

  class DataRangeDialog {

      constructor(browser, $parent, alert) {

          this.browser = browser;

          // dialog container
          this.$container = $$1("<div>", {class: 'igv-generic-dialog-container'});
          $parent.append(this.$container);
          this.$container.offset({left: 0, top: 0});

          // dialog header
          const $header = $$1("<div>", {class: 'igv-generic-dialog-header'});
          this.$container.append($header);
          uiUtils.attachDialogCloseHandlerWithParent($header[0], () => {
              this.$minimum_input.val(undefined);
              this.$maximum_input.val(undefined);
              this.$container.offset({left: 0, top: 0});
              this.$container.hide();
          });


          // minimun
          this.$minimum = $$1("<div>", {class: 'igv-generic-dialog-label-input'});
          this.$container.append(this.$minimum);
          const $mindiv = $$1('<div>');
          $mindiv.text('Minimum');
          this.$minimum.append($mindiv);
          this.$minimum_input = $$1("<input>");
          this.$minimum.append(this.$minimum_input);


          // maximum
          this.$maximum = $$1("<div>", {class: 'igv-generic-dialog-label-input'});
          this.$container.append(this.$maximum);
          const $maxdiv = $$1('<div>');
          $maxdiv.text('Maximum');
          this.$maximum.append($maxdiv);
          this.$maximum_input = $$1("<input>");
          this.$maximum.append(this.$maximum_input);

          // ok | cancel
          const $buttons = $$1("<div>", {class: 'igv-generic-dialog-ok-cancel'});
          this.$container.append($buttons);

          // ok
          this.$ok = $$1("<div>");
          $buttons.append(this.$ok);
          this.$ok.text('OK');

          // cancel
          this.$cancel = $$1("<div>");
          $buttons.append(this.$cancel);
          this.$cancel.text('Cancel');

          this.$cancel.on('click', () => {
              this.$minimum_input.val(undefined);
              this.$maximum_input.val(undefined);
              this.$container.offset({left: 0, top: 0});
              this.$container.hide();
          });

          //this.$container.draggable({ handle:$header.get(0) });
          makeDraggable$2(this.$container.get(0), $header.get(0));

          this.$container.hide();
      }

      configure(trackView) {

          const dataRange = trackView.dataRange();
          let min;
          let max;
          if (dataRange) {
              min = dataRange.min;
              max = dataRange.max;
          } else {
              min = 0;
              max = 100;
          }

          this.$minimum_input.val(min);
          this.$maximum_input.val(max);

          this.$minimum_input.unbind();
          this.$minimum_input.on('keyup', (e) => {
              if (13 === e.keyCode) {
                  this.processResults(trackView);
              }
          });

          this.$maximum_input.unbind();
          this.$maximum_input.on('keyup', (e) => {
              if (13 === e.keyCode) {
                  this.processResults(trackView);
              }
          });

          this.$ok.unbind();
          this.$ok.on('click', (e) => {
              this.processResults(trackView);
          });
      }


      processResults(trackView) {

          const min = Number(this.$minimum_input.val());
          const max = Number(this.$maximum_input.val());
          if (isNaN(min) || isNaN(max)) {
              this.browser.alert.present(new Error('Must input numeric values'), undefined);
          } else {
              trackView.setDataRange(min, max);
          }

          this.$minimum_input.val(undefined);
          this.$maximum_input.val(undefined);
          this.$container.offset({left: 0, top: 0});
          this.$container.hide();
      }

      present($parent) {

          const offset_top = $parent.offset().top;
          const scroll_top = $$1('body').scrollTop();

          this.$container.offset({left: $parent.width() - this.$container.width(), top: (offset_top + scroll_top)});
          this.$container.show();
      }
  }

  /**
   * Covers string literals and String objects
   * @param x
   * @returns {boolean}
   */
  function isString$2(x) {
      return typeof x === "string" || x instanceof String
  }


  // StackOverflow: http://stackoverflow.com/a/10810674/116169
  function numberFormatter$1(rawNumber) {

      var dec = String(rawNumber).split(/[.,]/),
          sep = ',',
          decsep = '.';

      return dec[0].split('').reverse().reduce(function (prev, now, i) {
          return i % 3 === 0 ? prev + sep + now : prev + now;
      }).split('').reverse().join('') + (dec[1] ? decsep + dec[1] : '');
  }

  const splitLines$5 = function (string) {
      return string.split(/\n|\r\n|\r/g);
  };


  function splitStringRespectingQuotes(string, delim) {

      var tokens = [],
          len = string.length,
          i,
          n = 0,
          quote = false,
          c;

      if (len > 0) {

          tokens[n] = string.charAt(0);
          for (i = 1; i < len; i++) {
              c = string.charAt(i);
              if (c === '"') {
                  quote = !quote;
              } else if (!quote && c === delim) {
                  n++;
                  tokens[n] = "";
              } else {
                  tokens[n] += c;
              }
          }
      }
      return tokens;
  }

  function stripQuotes$1(str) {
      if(str === undefined) {
          return str;
      }
      if(str.startsWith("'") || str.startsWith('"')) {
          str = str.substring(1);
      }
      if (str.endsWith("'") || str.endsWith('"')) {
          str = str.substring(0, str.length - 1);
      }
      return str;
  }

  function capitalize(str) {
      return str.length > 0 ? str.charAt(0).toUpperCase() + str.slice(1) : str;
  }


  /**
   * Parse a locus string and return a range object.  Locus string is of the form chr:start-end.  End is optional
   *
   */
  function parseLocusString$1(string) {

      const t1 = string.split(":");
      const t2 = t1[1].split("-");

      const range = {
          chr: t1[0],
          start: Number.parseInt(t2[0].replace(/,/g, '')) - 1
      };

      if (t2.length > 1) {
          range.end = Number.parseInt(t2[1].replace(/,/g, ''));
      } else {
          range.end = range.start + 1;
      }

      return range;
  }

  /**
   * Return the filename from the path.   Example
   *   https://foo.com/bar.bed?param=2   => bar.bed
   * @param urlOrFile
   */

  function getFilename$2(urlOrFile) {

      if (urlOrFile.name !== undefined) {
          return urlOrFile.name
      } else if (isString$2(urlOrFile)) {

          let index = urlOrFile.lastIndexOf("/");
          let filename = index < 0 ? urlOrFile : urlOrFile.substr(index + 1);

          //Strip parameters -- handle local files later
          index = filename.indexOf("?");
          if (index > 0) {
              filename = filename.substr(0, index);
          }
          return filename
      } else {
          throw Error(`Expected File or string, got ${typeof urlOrFile}`)
      }
  }


  /**
   * Test if object is a File or File-like object.
   *
   * @param object
   */
  function isFile$2(object) {
      if(!object) {
          return false;
      }
      return typeof object !== 'function' &&
          (object instanceof File ||
              (object.hasOwnProperty("name") && typeof object.slice === 'function' && typeof object.arrayBuffer === 'function'))
  }

  function download$1(filename, data) {

      const element = document.createElement('a');
      element.setAttribute('href', data);
      element.setAttribute('download', filename);
      element.style.display = 'none';
      document.body.appendChild(element);
      element.click();
      document.body.removeChild(element);
  }

  if (typeof process === 'object' && typeof window === 'undefined') {
      global.atob = function (str) {
          return Buffer.from(str, 'base64').toString('binary');
      };
  }


  function parseUri$1(str) {

      var o = options$1,
          m = o.parser["loose"].exec(str),
          uri = {},
          i = 14;

      while (i--) uri[o.key[i]] = m[i] || "";

      uri[o.q.name] = {};
      uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
          if ($1) uri[o.q.name][$1] = $2;
      });

      return uri;
  }

  const options$1 = {
      strictMode: false,
      key: ["source", "protocol", "authority", "userInfo", "user", "password", "host", "port", "relative", "path", "directory", "file", "query", "anchor"],
      q: {
          name: "queryKey",
          parser: /(?:^|&)([^&=]*)=?([^&]*)/g
      },
      parser: {
          strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
          loose: /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
      }
  };

  /**
   * Resolve a url, which might be a string, function (that returns a string or Promse), or Promise (that resolves to a string)
   *
   * @param url
   * @returns {Promise<*>}
   */
  async function resolveURL(url) {
      return (typeof url === 'function')  ?  url() :  url;
  }

  /*! pako 2.1.0 https://github.com/nodeca/pako @license (MIT AND Zlib) */
  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  /* eslint-disable space-unary-ops */

  /* Public constants ==========================================================*/
  /* ===========================================================================*/


  //const Z_FILTERED          = 1;
  //const Z_HUFFMAN_ONLY      = 2;
  //const Z_RLE               = 3;
  const Z_FIXED$1               = 4;
  //const Z_DEFAULT_STRATEGY  = 0;

  /* Possible values of the data_type field (though see inflate()) */
  const Z_BINARY              = 0;
  const Z_TEXT                = 1;
  //const Z_ASCII             = 1; // = Z_TEXT
  const Z_UNKNOWN$1             = 2;

  /*============================================================================*/


  function zero$1$1(buf) { let len = buf.length; while (--len >= 0) { buf[len] = 0; } }

  // From zutil.h

  const STORED_BLOCK = 0;
  const STATIC_TREES = 1;
  const DYN_TREES    = 2;
  /* The three kinds of block type */

  const MIN_MATCH$1$1    = 3;
  const MAX_MATCH$1$1    = 258;
  /* The minimum and maximum match lengths */

  // From deflate.h
  /* ===========================================================================
   * Internal compression state.
   */

  const LENGTH_CODES$1$1  = 29;
  /* number of length codes, not counting the special END_BLOCK code */

  const LITERALS$1$1      = 256;
  /* number of literal bytes 0..255 */

  const L_CODES$1$1       = LITERALS$1$1 + 1 + LENGTH_CODES$1$1;
  /* number of Literal or Length codes, including the END_BLOCK code */

  const D_CODES$1$1       = 30;
  /* number of distance codes */

  const BL_CODES$1      = 19;
  /* number of codes used to transfer the bit lengths */

  const HEAP_SIZE$1     = 2 * L_CODES$1$1 + 1;
  /* maximum heap size */

  const MAX_BITS$1      = 15;
  /* All codes must not exceed MAX_BITS bits */

  const Buf_size      = 16;
  /* size of bit buffer in bi_buf */


  /* ===========================================================================
   * Constants
   */

  const MAX_BL_BITS = 7;
  /* Bit length codes must not exceed MAX_BL_BITS bits */

  const END_BLOCK   = 256;
  /* end of block literal code */

  const REP_3_6     = 16;
  /* repeat previous bit length 3-6 times (2 bits of repeat count) */

  const REPZ_3_10   = 17;
  /* repeat a zero length 3-10 times  (3 bits of repeat count) */

  const REPZ_11_138 = 18;
  /* repeat a zero length 11-138 times  (7 bits of repeat count) */

  /* eslint-disable comma-spacing,array-bracket-spacing */
  const extra_lbits =   /* extra bits for each length code */
    new Uint8Array([0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0]);

  const extra_dbits =   /* extra bits for each distance code */
    new Uint8Array([0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13]);

  const extra_blbits =  /* extra bits for each bit length code */
    new Uint8Array([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7]);

  const bl_order =
    new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]);
  /* eslint-enable comma-spacing,array-bracket-spacing */

  /* The lengths of the bit length codes are sent in order of decreasing
   * probability, to avoid transmitting the lengths for unused bit length codes.
   */

  /* ===========================================================================
   * Local data. These are initialized only once.
   */

  // We pre-fill arrays with 0 to avoid uninitialized gaps

  const DIST_CODE_LEN$1 = 512; /* see definition of array dist_code below */

  // !!!! Use flat array instead of structure, Freq = i*2, Len = i*2+1
  const static_ltree$1  = new Array((L_CODES$1$1 + 2) * 2);
  zero$1$1(static_ltree$1);
  /* The static literal tree. Since the bit lengths are imposed, there is no
   * need for the L_CODES extra codes used during heap construction. However
   * The codes 286 and 287 are needed to build a canonical tree (see _tr_init
   * below).
   */

  const static_dtree$1  = new Array(D_CODES$1$1 * 2);
  zero$1$1(static_dtree$1);
  /* The static distance tree. (Actually a trivial tree since all codes use
   * 5 bits.)
   */

  const _dist_code$1    = new Array(DIST_CODE_LEN$1);
  zero$1$1(_dist_code$1);
  /* Distance codes. The first 256 values correspond to the distances
   * 3 .. 258, the last 256 values correspond to the top 8 bits of
   * the 15 bit distances.
   */

  const _length_code$1  = new Array(MAX_MATCH$1$1 - MIN_MATCH$1$1 + 1);
  zero$1$1(_length_code$1);
  /* length code for each normalized match length (0 == MIN_MATCH) */

  const base_length$1   = new Array(LENGTH_CODES$1$1);
  zero$1$1(base_length$1);
  /* First normalized length for each code (0 = MIN_MATCH) */

  const base_dist$1     = new Array(D_CODES$1$1);
  zero$1$1(base_dist$1);
  /* First normalized distance for each code (0 = distance of 1) */


  function StaticTreeDesc(static_tree, extra_bits, extra_base, elems, max_length) {

    this.static_tree  = static_tree;  /* static tree or NULL */
    this.extra_bits   = extra_bits;   /* extra bits for each code or NULL */
    this.extra_base   = extra_base;   /* base index for extra_bits */
    this.elems        = elems;        /* max number of elements in the tree */
    this.max_length   = max_length;   /* max bit length for the codes */

    // show if `static_tree` has data or dummy - needed for monomorphic objects
    this.has_stree    = static_tree && static_tree.length;
  }


  let static_l_desc;
  let static_d_desc;
  let static_bl_desc;


  function TreeDesc(dyn_tree, stat_desc) {
    this.dyn_tree = dyn_tree;     /* the dynamic tree */
    this.max_code = 0;            /* largest code with non zero frequency */
    this.stat_desc = stat_desc;   /* the corresponding static tree */
  }



  const d_code = (dist) => {

    return dist < 256 ? _dist_code$1[dist] : _dist_code$1[256 + (dist >>> 7)];
  };


  /* ===========================================================================
   * Output a short LSB first on the stream.
   * IN assertion: there is enough room in pendingBuf.
   */
  const put_short = (s, w) => {
  //    put_byte(s, (uch)((w) & 0xff));
  //    put_byte(s, (uch)((ush)(w) >> 8));
    s.pending_buf[s.pending++] = (w) & 0xff;
    s.pending_buf[s.pending++] = (w >>> 8) & 0xff;
  };


  /* ===========================================================================
   * Send a value on a given number of bits.
   * IN assertion: length <= 16 and value fits in length bits.
   */
  const send_bits = (s, value, length) => {

    if (s.bi_valid > (Buf_size - length)) {
      s.bi_buf |= (value << s.bi_valid) & 0xffff;
      put_short(s, s.bi_buf);
      s.bi_buf = value >> (Buf_size - s.bi_valid);
      s.bi_valid += length - Buf_size;
    } else {
      s.bi_buf |= (value << s.bi_valid) & 0xffff;
      s.bi_valid += length;
    }
  };


  const send_code = (s, c, tree) => {

    send_bits(s, tree[c * 2]/*.Code*/, tree[c * 2 + 1]/*.Len*/);
  };


  /* ===========================================================================
   * Reverse the first len bits of a code, using straightforward code (a faster
   * method would use a table)
   * IN assertion: 1 <= len <= 15
   */
  const bi_reverse = (code, len) => {

    let res = 0;
    do {
      res |= code & 1;
      code >>>= 1;
      res <<= 1;
    } while (--len > 0);
    return res >>> 1;
  };


  /* ===========================================================================
   * Flush the bit buffer, keeping at most 7 bits in it.
   */
  const bi_flush = (s) => {

    if (s.bi_valid === 16) {
      put_short(s, s.bi_buf);
      s.bi_buf = 0;
      s.bi_valid = 0;

    } else if (s.bi_valid >= 8) {
      s.pending_buf[s.pending++] = s.bi_buf & 0xff;
      s.bi_buf >>= 8;
      s.bi_valid -= 8;
    }
  };


  /* ===========================================================================
   * Compute the optimal bit lengths for a tree and update the total bit length
   * for the current block.
   * IN assertion: the fields freq and dad are set, heap[heap_max] and
   *    above are the tree nodes sorted by increasing frequency.
   * OUT assertions: the field len is set to the optimal bit length, the
   *     array bl_count contains the frequencies for each bit length.
   *     The length opt_len is updated; static_len is also updated if stree is
   *     not null.
   */
  const gen_bitlen = (s, desc) => {
  //    deflate_state *s;
  //    tree_desc *desc;    /* the tree descriptor */

    const tree            = desc.dyn_tree;
    const max_code        = desc.max_code;
    const stree           = desc.stat_desc.static_tree;
    const has_stree       = desc.stat_desc.has_stree;
    const extra           = desc.stat_desc.extra_bits;
    const base            = desc.stat_desc.extra_base;
    const max_length      = desc.stat_desc.max_length;
    let h;              /* heap index */
    let n, m;           /* iterate over the tree elements */
    let bits;           /* bit length */
    let xbits;          /* extra bits */
    let f;              /* frequency */
    let overflow = 0;   /* number of elements with bit length too large */

    for (bits = 0; bits <= MAX_BITS$1; bits++) {
      s.bl_count[bits] = 0;
    }

    /* In a first pass, compute the optimal bit lengths (which may
     * overflow in the case of the bit length tree).
     */
    tree[s.heap[s.heap_max] * 2 + 1]/*.Len*/ = 0; /* root of the heap */

    for (h = s.heap_max + 1; h < HEAP_SIZE$1; h++) {
      n = s.heap[h];
      bits = tree[tree[n * 2 + 1]/*.Dad*/ * 2 + 1]/*.Len*/ + 1;
      if (bits > max_length) {
        bits = max_length;
        overflow++;
      }
      tree[n * 2 + 1]/*.Len*/ = bits;
      /* We overwrite tree[n].Dad which is no longer needed */

      if (n > max_code) { continue; } /* not a leaf node */

      s.bl_count[bits]++;
      xbits = 0;
      if (n >= base) {
        xbits = extra[n - base];
      }
      f = tree[n * 2]/*.Freq*/;
      s.opt_len += f * (bits + xbits);
      if (has_stree) {
        s.static_len += f * (stree[n * 2 + 1]/*.Len*/ + xbits);
      }
    }
    if (overflow === 0) { return; }

    // Tracev((stderr,"\nbit length overflow\n"));
    /* This happens for example on obj2 and pic of the Calgary corpus */

    /* Find the first bit length which could increase: */
    do {
      bits = max_length - 1;
      while (s.bl_count[bits] === 0) { bits--; }
      s.bl_count[bits]--;      /* move one leaf down the tree */
      s.bl_count[bits + 1] += 2; /* move one overflow item as its brother */
      s.bl_count[max_length]--;
      /* The brother of the overflow item also moves one step up,
       * but this does not affect bl_count[max_length]
       */
      overflow -= 2;
    } while (overflow > 0);

    /* Now recompute all bit lengths, scanning in increasing frequency.
     * h is still equal to HEAP_SIZE. (It is simpler to reconstruct all
     * lengths instead of fixing only the wrong ones. This idea is taken
     * from 'ar' written by Haruhiko Okumura.)
     */
    for (bits = max_length; bits !== 0; bits--) {
      n = s.bl_count[bits];
      while (n !== 0) {
        m = s.heap[--h];
        if (m > max_code) { continue; }
        if (tree[m * 2 + 1]/*.Len*/ !== bits) {
          // Tracev((stderr,"code %d bits %d->%d\n", m, tree[m].Len, bits));
          s.opt_len += (bits - tree[m * 2 + 1]/*.Len*/) * tree[m * 2]/*.Freq*/;
          tree[m * 2 + 1]/*.Len*/ = bits;
        }
        n--;
      }
    }
  };


  /* ===========================================================================
   * Generate the codes for a given tree and bit counts (which need not be
   * optimal).
   * IN assertion: the array bl_count contains the bit length statistics for
   * the given tree and the field len is set for all tree elements.
   * OUT assertion: the field code is set for all tree elements of non
   *     zero code length.
   */
  const gen_codes = (tree, max_code, bl_count) => {
  //    ct_data *tree;             /* the tree to decorate */
  //    int max_code;              /* largest code with non zero frequency */
  //    ushf *bl_count;            /* number of codes at each bit length */

    const next_code = new Array(MAX_BITS$1 + 1); /* next code value for each bit length */
    let code = 0;              /* running code value */
    let bits;                  /* bit index */
    let n;                     /* code index */

    /* The distribution counts are first used to generate the code values
     * without bit reversal.
     */
    for (bits = 1; bits <= MAX_BITS$1; bits++) {
      code = (code + bl_count[bits - 1]) << 1;
      next_code[bits] = code;
    }
    /* Check that the bit counts in bl_count are consistent. The last code
     * must be all ones.
     */
    //Assert (code + bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
    //        "inconsistent bit counts");
    //Tracev((stderr,"\ngen_codes: max_code %d ", max_code));

    for (n = 0;  n <= max_code; n++) {
      let len = tree[n * 2 + 1]/*.Len*/;
      if (len === 0) { continue; }
      /* Now reverse the bits */
      tree[n * 2]/*.Code*/ = bi_reverse(next_code[len]++, len);

      //Tracecv(tree != static_ltree, (stderr,"\nn %3d %c l %2d c %4x (%x) ",
      //     n, (isgraph(n) ? n : ' '), len, tree[n].Code, next_code[len]-1));
    }
  };


  /* ===========================================================================
   * Initialize the various 'constant' tables.
   */
  const tr_static_init = () => {

    let n;        /* iterates over tree elements */
    let bits;     /* bit counter */
    let length;   /* length value */
    let code;     /* code value */
    let dist;     /* distance index */
    const bl_count = new Array(MAX_BITS$1 + 1);
    /* number of codes at each bit length for an optimal tree */

    // do check in _tr_init()
    //if (static_init_done) return;

    /* For some embedded targets, global variables are not initialized: */
  /*#ifdef NO_INIT_GLOBAL_POINTERS
    static_l_desc.static_tree = static_ltree;
    static_l_desc.extra_bits = extra_lbits;
    static_d_desc.static_tree = static_dtree;
    static_d_desc.extra_bits = extra_dbits;
    static_bl_desc.extra_bits = extra_blbits;
  #endif*/

    /* Initialize the mapping length (0..255) -> length code (0..28) */
    length = 0;
    for (code = 0; code < LENGTH_CODES$1$1 - 1; code++) {
      base_length$1[code] = length;
      for (n = 0; n < (1 << extra_lbits[code]); n++) {
        _length_code$1[length++] = code;
      }
    }
    //Assert (length == 256, "tr_static_init: length != 256");
    /* Note that the length 255 (match length 258) can be represented
     * in two different ways: code 284 + 5 bits or code 285, so we
     * overwrite length_code[255] to use the best encoding:
     */
    _length_code$1[length - 1] = code;

    /* Initialize the mapping dist (0..32K) -> dist code (0..29) */
    dist = 0;
    for (code = 0; code < 16; code++) {
      base_dist$1[code] = dist;
      for (n = 0; n < (1 << extra_dbits[code]); n++) {
        _dist_code$1[dist++] = code;
      }
    }
    //Assert (dist == 256, "tr_static_init: dist != 256");
    dist >>= 7; /* from now on, all distances are divided by 128 */
    for (; code < D_CODES$1$1; code++) {
      base_dist$1[code] = dist << 7;
      for (n = 0; n < (1 << (extra_dbits[code] - 7)); n++) {
        _dist_code$1[256 + dist++] = code;
      }
    }
    //Assert (dist == 256, "tr_static_init: 256+dist != 512");

    /* Construct the codes of the static literal tree */
    for (bits = 0; bits <= MAX_BITS$1; bits++) {
      bl_count[bits] = 0;
    }

    n = 0;
    while (n <= 143) {
      static_ltree$1[n * 2 + 1]/*.Len*/ = 8;
      n++;
      bl_count[8]++;
    }
    while (n <= 255) {
      static_ltree$1[n * 2 + 1]/*.Len*/ = 9;
      n++;
      bl_count[9]++;
    }
    while (n <= 279) {
      static_ltree$1[n * 2 + 1]/*.Len*/ = 7;
      n++;
      bl_count[7]++;
    }
    while (n <= 287) {
      static_ltree$1[n * 2 + 1]/*.Len*/ = 8;
      n++;
      bl_count[8]++;
    }
    /* Codes 286 and 287 do not exist, but we must include them in the
     * tree construction to get a canonical Huffman tree (longest code
     * all ones)
     */
    gen_codes(static_ltree$1, L_CODES$1$1 + 1, bl_count);

    /* The static distance tree is trivial: */
    for (n = 0; n < D_CODES$1$1; n++) {
      static_dtree$1[n * 2 + 1]/*.Len*/ = 5;
      static_dtree$1[n * 2]/*.Code*/ = bi_reverse(n, 5);
    }

    // Now data ready and we can init static trees
    static_l_desc = new StaticTreeDesc(static_ltree$1, extra_lbits, LITERALS$1$1 + 1, L_CODES$1$1, MAX_BITS$1);
    static_d_desc = new StaticTreeDesc(static_dtree$1, extra_dbits, 0,          D_CODES$1$1, MAX_BITS$1);
    static_bl_desc = new StaticTreeDesc(new Array(0), extra_blbits, 0,         BL_CODES$1, MAX_BL_BITS);

    //static_init_done = true;
  };


  /* ===========================================================================
   * Initialize a new block.
   */
  const init_block = (s) => {

    let n; /* iterates over tree elements */

    /* Initialize the trees. */
    for (n = 0; n < L_CODES$1$1;  n++) { s.dyn_ltree[n * 2]/*.Freq*/ = 0; }
    for (n = 0; n < D_CODES$1$1;  n++) { s.dyn_dtree[n * 2]/*.Freq*/ = 0; }
    for (n = 0; n < BL_CODES$1; n++) { s.bl_tree[n * 2]/*.Freq*/ = 0; }

    s.dyn_ltree[END_BLOCK * 2]/*.Freq*/ = 1;
    s.opt_len = s.static_len = 0;
    s.sym_next = s.matches = 0;
  };


  /* ===========================================================================
   * Flush the bit buffer and align the output on a byte boundary
   */
  const bi_windup = (s) =>
  {
    if (s.bi_valid > 8) {
      put_short(s, s.bi_buf);
    } else if (s.bi_valid > 0) {
      //put_byte(s, (Byte)s->bi_buf);
      s.pending_buf[s.pending++] = s.bi_buf;
    }
    s.bi_buf = 0;
    s.bi_valid = 0;
  };

  /* ===========================================================================
   * Compares to subtrees, using the tree depth as tie breaker when
   * the subtrees have equal frequency. This minimizes the worst case length.
   */
  const smaller = (tree, n, m, depth) => {

    const _n2 = n * 2;
    const _m2 = m * 2;
    return (tree[_n2]/*.Freq*/ < tree[_m2]/*.Freq*/ ||
           (tree[_n2]/*.Freq*/ === tree[_m2]/*.Freq*/ && depth[n] <= depth[m]));
  };

  /* ===========================================================================
   * Restore the heap property by moving down the tree starting at node k,
   * exchanging a node with the smallest of its two sons if necessary, stopping
   * when the heap property is re-established (each father smaller than its
   * two sons).
   */
  const pqdownheap = (s, tree, k) => {
  //    deflate_state *s;
  //    ct_data *tree;  /* the tree to restore */
  //    int k;               /* node to move down */

    const v = s.heap[k];
    let j = k << 1;  /* left son of k */
    while (j <= s.heap_len) {
      /* Set j to the smallest of the two sons: */
      if (j < s.heap_len &&
        smaller(tree, s.heap[j + 1], s.heap[j], s.depth)) {
        j++;
      }
      /* Exit if v is smaller than both sons */
      if (smaller(tree, v, s.heap[j], s.depth)) { break; }

      /* Exchange v with the smallest son */
      s.heap[k] = s.heap[j];
      k = j;

      /* And continue down the tree, setting j to the left son of k */
      j <<= 1;
    }
    s.heap[k] = v;
  };


  // inlined manually
  // const SMALLEST = 1;

  /* ===========================================================================
   * Send the block data compressed using the given Huffman trees
   */
  const compress_block = (s, ltree, dtree) => {
  //    deflate_state *s;
  //    const ct_data *ltree; /* literal tree */
  //    const ct_data *dtree; /* distance tree */

    let dist;           /* distance of matched string */
    let lc;             /* match length or unmatched char (if dist == 0) */
    let sx = 0;         /* running index in sym_buf */
    let code;           /* the code to send */
    let extra;          /* number of extra bits to send */

    if (s.sym_next !== 0) {
      do {
        dist = s.pending_buf[s.sym_buf + sx++] & 0xff;
        dist += (s.pending_buf[s.sym_buf + sx++] & 0xff) << 8;
        lc = s.pending_buf[s.sym_buf + sx++];
        if (dist === 0) {
          send_code(s, lc, ltree); /* send a literal byte */
          //Tracecv(isgraph(lc), (stderr," '%c' ", lc));
        } else {
          /* Here, lc is the match length - MIN_MATCH */
          code = _length_code$1[lc];
          send_code(s, code + LITERALS$1$1 + 1, ltree); /* send the length code */
          extra = extra_lbits[code];
          if (extra !== 0) {
            lc -= base_length$1[code];
            send_bits(s, lc, extra);       /* send the extra length bits */
          }
          dist--; /* dist is now the match distance - 1 */
          code = d_code(dist);
          //Assert (code < D_CODES, "bad d_code");

          send_code(s, code, dtree);       /* send the distance code */
          extra = extra_dbits[code];
          if (extra !== 0) {
            dist -= base_dist$1[code];
            send_bits(s, dist, extra);   /* send the extra distance bits */
          }
        } /* literal or match pair ? */

        /* Check that the overlay between pending_buf and sym_buf is ok: */
        //Assert(s->pending < s->lit_bufsize + sx, "pendingBuf overflow");

      } while (sx < s.sym_next);
    }

    send_code(s, END_BLOCK, ltree);
  };


  /* ===========================================================================
   * Construct one Huffman tree and assigns the code bit strings and lengths.
   * Update the total bit length for the current block.
   * IN assertion: the field freq is set for all tree elements.
   * OUT assertions: the fields len and code are set to the optimal bit length
   *     and corresponding code. The length opt_len is updated; static_len is
   *     also updated if stree is not null. The field max_code is set.
   */
  const build_tree = (s, desc) => {
  //    deflate_state *s;
  //    tree_desc *desc; /* the tree descriptor */

    const tree     = desc.dyn_tree;
    const stree    = desc.stat_desc.static_tree;
    const has_stree = desc.stat_desc.has_stree;
    const elems    = desc.stat_desc.elems;
    let n, m;          /* iterate over heap elements */
    let max_code = -1; /* largest code with non zero frequency */
    let node;          /* new node being created */

    /* Construct the initial heap, with least frequent element in
     * heap[SMALLEST]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
     * heap[0] is not used.
     */
    s.heap_len = 0;
    s.heap_max = HEAP_SIZE$1;

    for (n = 0; n < elems; n++) {
      if (tree[n * 2]/*.Freq*/ !== 0) {
        s.heap[++s.heap_len] = max_code = n;
        s.depth[n] = 0;

      } else {
        tree[n * 2 + 1]/*.Len*/ = 0;
      }
    }

    /* The pkzip format requires that at least one distance code exists,
     * and that at least one bit should be sent even if there is only one
     * possible code. So to avoid special checks later on we force at least
     * two codes of non zero frequency.
     */
    while (s.heap_len < 2) {
      node = s.heap[++s.heap_len] = (max_code < 2 ? ++max_code : 0);
      tree[node * 2]/*.Freq*/ = 1;
      s.depth[node] = 0;
      s.opt_len--;

      if (has_stree) {
        s.static_len -= stree[node * 2 + 1]/*.Len*/;
      }
      /* node is 0 or 1 so it does not have extra bits */
    }
    desc.max_code = max_code;

    /* The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
     * establish sub-heaps of increasing lengths:
     */
    for (n = (s.heap_len >> 1/*int /2*/); n >= 1; n--) { pqdownheap(s, tree, n); }

    /* Construct the Huffman tree by repeatedly combining the least two
     * frequent nodes.
     */
    node = elems;              /* next internal node of the tree */
    do {
      //pqremove(s, tree, n);  /* n = node of least frequency */
      /*** pqremove ***/
      n = s.heap[1/*SMALLEST*/];
      s.heap[1/*SMALLEST*/] = s.heap[s.heap_len--];
      pqdownheap(s, tree, 1/*SMALLEST*/);
      /***/

      m = s.heap[1/*SMALLEST*/]; /* m = node of next least frequency */

      s.heap[--s.heap_max] = n; /* keep the nodes sorted by frequency */
      s.heap[--s.heap_max] = m;

      /* Create a new node father of n and m */
      tree[node * 2]/*.Freq*/ = tree[n * 2]/*.Freq*/ + tree[m * 2]/*.Freq*/;
      s.depth[node] = (s.depth[n] >= s.depth[m] ? s.depth[n] : s.depth[m]) + 1;
      tree[n * 2 + 1]/*.Dad*/ = tree[m * 2 + 1]/*.Dad*/ = node;

      /* and insert the new node in the heap */
      s.heap[1/*SMALLEST*/] = node++;
      pqdownheap(s, tree, 1/*SMALLEST*/);

    } while (s.heap_len >= 2);

    s.heap[--s.heap_max] = s.heap[1/*SMALLEST*/];

    /* At this point, the fields freq and dad are set. We can now
     * generate the bit lengths.
     */
    gen_bitlen(s, desc);

    /* The field len is now set, we can generate the bit codes */
    gen_codes(tree, max_code, s.bl_count);
  };


  /* ===========================================================================
   * Scan a literal or distance tree to determine the frequencies of the codes
   * in the bit length tree.
   */
  const scan_tree = (s, tree, max_code) => {
  //    deflate_state *s;
  //    ct_data *tree;   /* the tree to be scanned */
  //    int max_code;    /* and its largest code of non zero frequency */

    let n;                     /* iterates over all tree elements */
    let prevlen = -1;          /* last emitted length */
    let curlen;                /* length of current code */

    let nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

    let count = 0;             /* repeat count of the current code */
    let max_count = 7;         /* max repeat count */
    let min_count = 4;         /* min repeat count */

    if (nextlen === 0) {
      max_count = 138;
      min_count = 3;
    }
    tree[(max_code + 1) * 2 + 1]/*.Len*/ = 0xffff; /* guard */

    for (n = 0; n <= max_code; n++) {
      curlen = nextlen;
      nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

      if (++count < max_count && curlen === nextlen) {
        continue;

      } else if (count < min_count) {
        s.bl_tree[curlen * 2]/*.Freq*/ += count;

      } else if (curlen !== 0) {

        if (curlen !== prevlen) { s.bl_tree[curlen * 2]/*.Freq*/++; }
        s.bl_tree[REP_3_6 * 2]/*.Freq*/++;

      } else if (count <= 10) {
        s.bl_tree[REPZ_3_10 * 2]/*.Freq*/++;

      } else {
        s.bl_tree[REPZ_11_138 * 2]/*.Freq*/++;
      }

      count = 0;
      prevlen = curlen;

      if (nextlen === 0) {
        max_count = 138;
        min_count = 3;

      } else if (curlen === nextlen) {
        max_count = 6;
        min_count = 3;

      } else {
        max_count = 7;
        min_count = 4;
      }
    }
  };


  /* ===========================================================================
   * Send a literal or distance tree in compressed form, using the codes in
   * bl_tree.
   */
  const send_tree = (s, tree, max_code) => {
  //    deflate_state *s;
  //    ct_data *tree; /* the tree to be scanned */
  //    int max_code;       /* and its largest code of non zero frequency */

    let n;                     /* iterates over all tree elements */
    let prevlen = -1;          /* last emitted length */
    let curlen;                /* length of current code */

    let nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

    let count = 0;             /* repeat count of the current code */
    let max_count = 7;         /* max repeat count */
    let min_count = 4;         /* min repeat count */

    /* tree[max_code+1].Len = -1; */  /* guard already set */
    if (nextlen === 0) {
      max_count = 138;
      min_count = 3;
    }

    for (n = 0; n <= max_code; n++) {
      curlen = nextlen;
      nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

      if (++count < max_count && curlen === nextlen) {
        continue;

      } else if (count < min_count) {
        do { send_code(s, curlen, s.bl_tree); } while (--count !== 0);

      } else if (curlen !== 0) {
        if (curlen !== prevlen) {
          send_code(s, curlen, s.bl_tree);
          count--;
        }
        //Assert(count >= 3 && count <= 6, " 3_6?");
        send_code(s, REP_3_6, s.bl_tree);
        send_bits(s, count - 3, 2);

      } else if (count <= 10) {
        send_code(s, REPZ_3_10, s.bl_tree);
        send_bits(s, count - 3, 3);

      } else {
        send_code(s, REPZ_11_138, s.bl_tree);
        send_bits(s, count - 11, 7);
      }

      count = 0;
      prevlen = curlen;
      if (nextlen === 0) {
        max_count = 138;
        min_count = 3;

      } else if (curlen === nextlen) {
        max_count = 6;
        min_count = 3;

      } else {
        max_count = 7;
        min_count = 4;
      }
    }
  };


  /* ===========================================================================
   * Construct the Huffman tree for the bit lengths and return the index in
   * bl_order of the last bit length code to send.
   */
  const build_bl_tree = (s) => {

    let max_blindex;  /* index of last bit length code of non zero freq */

    /* Determine the bit length frequencies for literal and distance trees */
    scan_tree(s, s.dyn_ltree, s.l_desc.max_code);
    scan_tree(s, s.dyn_dtree, s.d_desc.max_code);

    /* Build the bit length tree: */
    build_tree(s, s.bl_desc);
    /* opt_len now includes the length of the tree representations, except
     * the lengths of the bit lengths codes and the 5+5+4 bits for the counts.
     */

    /* Determine the number of bit length codes to send. The pkzip format
     * requires that at least 4 bit length codes be sent. (appnote.txt says
     * 3 but the actual value used is 4.)
     */
    for (max_blindex = BL_CODES$1 - 1; max_blindex >= 3; max_blindex--) {
      if (s.bl_tree[bl_order[max_blindex] * 2 + 1]/*.Len*/ !== 0) {
        break;
      }
    }
    /* Update opt_len to include the bit length tree and counts */
    s.opt_len += 3 * (max_blindex + 1) + 5 + 5 + 4;
    //Tracev((stderr, "\ndyn trees: dyn %ld, stat %ld",
    //        s->opt_len, s->static_len));

    return max_blindex;
  };


  /* ===========================================================================
   * Send the header for a block using dynamic Huffman trees: the counts, the
   * lengths of the bit length codes, the literal tree and the distance tree.
   * IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
   */
  const send_all_trees = (s, lcodes, dcodes, blcodes) => {
  //    deflate_state *s;
  //    int lcodes, dcodes, blcodes; /* number of codes for each tree */

    let rank;                    /* index in bl_order */

    //Assert (lcodes >= 257 && dcodes >= 1 && blcodes >= 4, "not enough codes");
    //Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
    //        "too many codes");
    //Tracev((stderr, "\nbl counts: "));
    send_bits(s, lcodes - 257, 5); /* not +255 as stated in appnote.txt */
    send_bits(s, dcodes - 1,   5);
    send_bits(s, blcodes - 4,  4); /* not -3 as stated in appnote.txt */
    for (rank = 0; rank < blcodes; rank++) {
      //Tracev((stderr, "\nbl code %2d ", bl_order[rank]));
      send_bits(s, s.bl_tree[bl_order[rank] * 2 + 1]/*.Len*/, 3);
    }
    //Tracev((stderr, "\nbl tree: sent %ld", s->bits_sent));

    send_tree(s, s.dyn_ltree, lcodes - 1); /* literal tree */
    //Tracev((stderr, "\nlit tree: sent %ld", s->bits_sent));

    send_tree(s, s.dyn_dtree, dcodes - 1); /* distance tree */
    //Tracev((stderr, "\ndist tree: sent %ld", s->bits_sent));
  };


  /* ===========================================================================
   * Check if the data type is TEXT or BINARY, using the following algorithm:
   * - TEXT if the two conditions below are satisfied:
   *    a) There are no non-portable control characters belonging to the
   *       "block list" (0..6, 14..25, 28..31).
   *    b) There is at least one printable character belonging to the
   *       "allow list" (9 {TAB}, 10 {LF}, 13 {CR}, 32..255).
   * - BINARY otherwise.
   * - The following partially-portable control characters form a
   *   "gray list" that is ignored in this detection algorithm:
   *   (7 {BEL}, 8 {BS}, 11 {VT}, 12 {FF}, 26 {SUB}, 27 {ESC}).
   * IN assertion: the fields Freq of dyn_ltree are set.
   */
  const detect_data_type = (s) => {
    /* block_mask is the bit mask of block-listed bytes
     * set bits 0..6, 14..25, and 28..31
     * 0xf3ffc07f = binary 11110011111111111100000001111111
     */
    let block_mask = 0xf3ffc07f;
    let n;

    /* Check for non-textual ("block-listed") bytes. */
    for (n = 0; n <= 31; n++, block_mask >>>= 1) {
      if ((block_mask & 1) && (s.dyn_ltree[n * 2]/*.Freq*/ !== 0)) {
        return Z_BINARY;
      }
    }

    /* Check for textual ("allow-listed") bytes. */
    if (s.dyn_ltree[9 * 2]/*.Freq*/ !== 0 || s.dyn_ltree[10 * 2]/*.Freq*/ !== 0 ||
        s.dyn_ltree[13 * 2]/*.Freq*/ !== 0) {
      return Z_TEXT;
    }
    for (n = 32; n < LITERALS$1$1; n++) {
      if (s.dyn_ltree[n * 2]/*.Freq*/ !== 0) {
        return Z_TEXT;
      }
    }

    /* There are no "block-listed" or "allow-listed" bytes:
     * this stream either is empty or has tolerated ("gray-listed") bytes only.
     */
    return Z_BINARY;
  };


  let static_init_done = false;

  /* ===========================================================================
   * Initialize the tree data structures for a new zlib stream.
   */
  const _tr_init$1 = (s) =>
  {

    if (!static_init_done) {
      tr_static_init();
      static_init_done = true;
    }

    s.l_desc  = new TreeDesc(s.dyn_ltree, static_l_desc);
    s.d_desc  = new TreeDesc(s.dyn_dtree, static_d_desc);
    s.bl_desc = new TreeDesc(s.bl_tree, static_bl_desc);

    s.bi_buf = 0;
    s.bi_valid = 0;

    /* Initialize the first block of the first file: */
    init_block(s);
  };


  /* ===========================================================================
   * Send a stored block
   */
  const _tr_stored_block$1 = (s, buf, stored_len, last) => {
  //DeflateState *s;
  //charf *buf;       /* input block */
  //ulg stored_len;   /* length of input block */
  //int last;         /* one if this is the last block for a file */

    send_bits(s, (STORED_BLOCK << 1) + (last ? 1 : 0), 3);    /* send block type */
    bi_windup(s);        /* align on byte boundary */
    put_short(s, stored_len);
    put_short(s, ~stored_len);
    if (stored_len) {
      s.pending_buf.set(s.window.subarray(buf, buf + stored_len), s.pending);
    }
    s.pending += stored_len;
  };


  /* ===========================================================================
   * Send one empty static block to give enough lookahead for inflate.
   * This takes 10 bits, of which 7 may remain in the bit buffer.
   */
  const _tr_align$1 = (s) => {
    send_bits(s, STATIC_TREES << 1, 3);
    send_code(s, END_BLOCK, static_ltree$1);
    bi_flush(s);
  };


  /* ===========================================================================
   * Determine the best encoding for the current block: dynamic trees, static
   * trees or store, and write out the encoded block.
   */
  const _tr_flush_block$1 = (s, buf, stored_len, last) => {
  //DeflateState *s;
  //charf *buf;       /* input block, or NULL if too old */
  //ulg stored_len;   /* length of input block */
  //int last;         /* one if this is the last block for a file */

    let opt_lenb, static_lenb;  /* opt_len and static_len in bytes */
    let max_blindex = 0;        /* index of last bit length code of non zero freq */

    /* Build the Huffman trees unless a stored block is forced */
    if (s.level > 0) {

      /* Check if the file is binary or text */
      if (s.strm.data_type === Z_UNKNOWN$1) {
        s.strm.data_type = detect_data_type(s);
      }

      /* Construct the literal and distance trees */
      build_tree(s, s.l_desc);
      // Tracev((stderr, "\nlit data: dyn %ld, stat %ld", s->opt_len,
      //        s->static_len));

      build_tree(s, s.d_desc);
      // Tracev((stderr, "\ndist data: dyn %ld, stat %ld", s->opt_len,
      //        s->static_len));
      /* At this point, opt_len and static_len are the total bit lengths of
       * the compressed block data, excluding the tree representations.
       */

      /* Build the bit length tree for the above two trees, and get the index
       * in bl_order of the last bit length code to send.
       */
      max_blindex = build_bl_tree(s);

      /* Determine the best encoding. Compute the block lengths in bytes. */
      opt_lenb = (s.opt_len + 3 + 7) >>> 3;
      static_lenb = (s.static_len + 3 + 7) >>> 3;

      // Tracev((stderr, "\nopt %lu(%lu) stat %lu(%lu) stored %lu lit %u ",
      //        opt_lenb, s->opt_len, static_lenb, s->static_len, stored_len,
      //        s->sym_next / 3));

      if (static_lenb <= opt_lenb) { opt_lenb = static_lenb; }

    } else {
      // Assert(buf != (char*)0, "lost buf");
      opt_lenb = static_lenb = stored_len + 5; /* force a stored block */
    }

    if ((stored_len + 4 <= opt_lenb) && (buf !== -1)) {
      /* 4: two words for the lengths */

      /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
       * Otherwise we can't have processed more than WSIZE input bytes since
       * the last block flush, because compression would have been
       * successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
       * transform a block into a stored block.
       */
      _tr_stored_block$1(s, buf, stored_len, last);

    } else if (s.strategy === Z_FIXED$1 || static_lenb === opt_lenb) {

      send_bits(s, (STATIC_TREES << 1) + (last ? 1 : 0), 3);
      compress_block(s, static_ltree$1, static_dtree$1);

    } else {
      send_bits(s, (DYN_TREES << 1) + (last ? 1 : 0), 3);
      send_all_trees(s, s.l_desc.max_code + 1, s.d_desc.max_code + 1, max_blindex + 1);
      compress_block(s, s.dyn_ltree, s.dyn_dtree);
    }
    // Assert (s->compressed_len == s->bits_sent, "bad compressed size");
    /* The above check is made mod 2^32, for files larger than 512 MB
     * and uLong implemented on 32 bits.
     */
    init_block(s);

    if (last) {
      bi_windup(s);
    }
    // Tracev((stderr,"\ncomprlen %lu(%lu) ", s->compressed_len>>3,
    //       s->compressed_len-7*last));
  };

  /* ===========================================================================
   * Save the match info and tally the frequency counts. Return true if
   * the current block must be flushed.
   */
  const _tr_tally$1 = (s, dist, lc) => {
  //    deflate_state *s;
  //    unsigned dist;  /* distance of matched string */
  //    unsigned lc;    /* match length-MIN_MATCH or unmatched char (if dist==0) */

    s.pending_buf[s.sym_buf + s.sym_next++] = dist;
    s.pending_buf[s.sym_buf + s.sym_next++] = dist >> 8;
    s.pending_buf[s.sym_buf + s.sym_next++] = lc;
    if (dist === 0) {
      /* lc is the unmatched char */
      s.dyn_ltree[lc * 2]/*.Freq*/++;
    } else {
      s.matches++;
      /* Here, lc is the match length - MIN_MATCH */
      dist--;             /* dist = match distance - 1 */
      //Assert((ush)dist < (ush)MAX_DIST(s) &&
      //       (ush)lc <= (ush)(MAX_MATCH-MIN_MATCH) &&
      //       (ush)d_code(dist) < (ush)D_CODES,  "_tr_tally: bad match");

      s.dyn_ltree[(_length_code$1[lc] + LITERALS$1$1 + 1) * 2]/*.Freq*/++;
      s.dyn_dtree[d_code(dist) * 2]/*.Freq*/++;
    }

    return (s.sym_next === s.sym_end);
  };

  var _tr_init_1  = _tr_init$1;
  var _tr_stored_block_1 = _tr_stored_block$1;
  var _tr_flush_block_1  = _tr_flush_block$1;
  var _tr_tally_1 = _tr_tally$1;
  var _tr_align_1 = _tr_align$1;

  var trees = {
  	_tr_init: _tr_init_1,
  	_tr_stored_block: _tr_stored_block_1,
  	_tr_flush_block: _tr_flush_block_1,
  	_tr_tally: _tr_tally_1,
  	_tr_align: _tr_align_1
  };

  // Note: adler32 takes 12% for level 0 and 2% for level 6.
  // It isn't worth it to make additional optimizations as in original.
  // Small size is preferable.

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  const adler32$1 = (adler, buf, len, pos) => {
    let s1 = (adler & 0xffff) |0,
        s2 = ((adler >>> 16) & 0xffff) |0,
        n = 0;

    while (len !== 0) {
      // Set limit ~ twice less than 5552, to keep
      // s2 in 31-bits, because we force signed ints.
      // in other case %= will fail.
      n = len > 2000 ? 2000 : len;
      len -= n;

      do {
        s1 = (s1 + buf[pos++]) |0;
        s2 = (s2 + s1) |0;
      } while (--n);

      s1 %= 65521;
      s2 %= 65521;
    }

    return (s1 | (s2 << 16)) |0;
  };


  var adler32_1$1 = adler32$1;

  // Note: we can't get significant speed boost here.
  // So write code to minimize size - no pregenerated tables
  // and array tools dependencies.

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  // Use ordinary array, since untyped makes no boost here
  const makeTable$1 = () => {
    let c, table = [];

    for (var n = 0; n < 256; n++) {
      c = n;
      for (var k = 0; k < 8; k++) {
        c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
      }
      table[n] = c;
    }

    return table;
  };

  // Create table on load. Just 255 signed longs. Not a problem.
  const crcTable$1 = new Uint32Array(makeTable$1());


  const crc32$1 = (crc, buf, len, pos) => {
    const t = crcTable$1;
    const end = pos + len;

    crc ^= -1;

    for (let i = pos; i < end; i++) {
      crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
    }

    return (crc ^ (-1)); // >>> 0;
  };


  var crc32_1$1 = crc32$1;

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  var messages$1 = {
    2:      'need dictionary',     /* Z_NEED_DICT       2  */
    1:      'stream end',          /* Z_STREAM_END      1  */
    0:      '',                    /* Z_OK              0  */
    '-1':   'file error',          /* Z_ERRNO         (-1) */
    '-2':   'stream error',        /* Z_STREAM_ERROR  (-2) */
    '-3':   'data error',          /* Z_DATA_ERROR    (-3) */
    '-4':   'insufficient memory', /* Z_MEM_ERROR     (-4) */
    '-5':   'buffer error',        /* Z_BUF_ERROR     (-5) */
    '-6':   'incompatible version' /* Z_VERSION_ERROR (-6) */
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  var constants$2$1 = {

    /* Allowed flush values; see deflate() and inflate() below for details */
    Z_NO_FLUSH:         0,
    Z_PARTIAL_FLUSH:    1,
    Z_SYNC_FLUSH:       2,
    Z_FULL_FLUSH:       3,
    Z_FINISH:           4,
    Z_BLOCK:            5,
    Z_TREES:            6,

    /* Return codes for the compression/decompression functions. Negative values
    * are errors, positive values are used for special but normal events.
    */
    Z_OK:               0,
    Z_STREAM_END:       1,
    Z_NEED_DICT:        2,
    Z_ERRNO:           -1,
    Z_STREAM_ERROR:    -2,
    Z_DATA_ERROR:      -3,
    Z_MEM_ERROR:       -4,
    Z_BUF_ERROR:       -5,
    //Z_VERSION_ERROR: -6,

    /* compression levels */
    Z_NO_COMPRESSION:         0,
    Z_BEST_SPEED:             1,
    Z_BEST_COMPRESSION:       9,
    Z_DEFAULT_COMPRESSION:   -1,


    Z_FILTERED:               1,
    Z_HUFFMAN_ONLY:           2,
    Z_RLE:                    3,
    Z_FIXED:                  4,
    Z_DEFAULT_STRATEGY:       0,

    /* Possible values of the data_type field (though see inflate()) */
    Z_BINARY:                 0,
    Z_TEXT:                   1,
    //Z_ASCII:                1, // = Z_TEXT (deprecated)
    Z_UNKNOWN:                2,

    /* The deflate compression method */
    Z_DEFLATED:               8
    //Z_NULL:                 null // Use -1 or null inline, depending on var type
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  const { _tr_init, _tr_stored_block, _tr_flush_block, _tr_tally, _tr_align } = trees;




  /* Public constants ==========================================================*/
  /* ===========================================================================*/

  const {
    Z_NO_FLUSH: Z_NO_FLUSH$2, Z_PARTIAL_FLUSH, Z_FULL_FLUSH: Z_FULL_FLUSH$1, Z_FINISH: Z_FINISH$3, Z_BLOCK: Z_BLOCK$1,
    Z_OK: Z_OK$3, Z_STREAM_END: Z_STREAM_END$3, Z_STREAM_ERROR: Z_STREAM_ERROR$2, Z_DATA_ERROR: Z_DATA_ERROR$2, Z_BUF_ERROR: Z_BUF_ERROR$1,
    Z_DEFAULT_COMPRESSION: Z_DEFAULT_COMPRESSION$1,
    Z_FILTERED, Z_HUFFMAN_ONLY, Z_RLE, Z_FIXED, Z_DEFAULT_STRATEGY: Z_DEFAULT_STRATEGY$1,
    Z_UNKNOWN,
    Z_DEFLATED: Z_DEFLATED$2
  } = constants$2$1;

  /*============================================================================*/


  const MAX_MEM_LEVEL = 9;
  /* Maximum value for memLevel in deflateInit2 */
  const MAX_WBITS$1 = 15;
  /* 32K LZ77 window */
  const DEF_MEM_LEVEL = 8;


  const LENGTH_CODES  = 29;
  /* number of length codes, not counting the special END_BLOCK code */
  const LITERALS      = 256;
  /* number of literal bytes 0..255 */
  const L_CODES       = LITERALS + 1 + LENGTH_CODES;
  /* number of Literal or Length codes, including the END_BLOCK code */
  const D_CODES       = 30;
  /* number of distance codes */
  const BL_CODES      = 19;
  /* number of codes used to transfer the bit lengths */
  const HEAP_SIZE     = 2 * L_CODES + 1;
  /* maximum heap size */
  const MAX_BITS  = 15;
  /* All codes must not exceed MAX_BITS bits */

  const MIN_MATCH = 3;
  const MAX_MATCH = 258;
  const MIN_LOOKAHEAD = (MAX_MATCH + MIN_MATCH + 1);

  const PRESET_DICT = 0x20;

  const INIT_STATE    =  42;    /* zlib header -> BUSY_STATE */
  //#ifdef GZIP
  const GZIP_STATE    =  57;    /* gzip header -> BUSY_STATE | EXTRA_STATE */
  //#endif
  const EXTRA_STATE   =  69;    /* gzip extra block -> NAME_STATE */
  const NAME_STATE    =  73;    /* gzip file name -> COMMENT_STATE */
  const COMMENT_STATE =  91;    /* gzip comment -> HCRC_STATE */
  const HCRC_STATE    = 103;    /* gzip header CRC -> BUSY_STATE */
  const BUSY_STATE    = 113;    /* deflate -> FINISH_STATE */
  const FINISH_STATE  = 666;    /* stream complete */

  const BS_NEED_MORE      = 1; /* block not completed, need more input or more output */
  const BS_BLOCK_DONE     = 2; /* block flush performed */
  const BS_FINISH_STARTED = 3; /* finish started, need only more output at next deflate */
  const BS_FINISH_DONE    = 4; /* finish done, accept no more input or output */

  const OS_CODE = 0x03; // Unix :) . Don't detect, use this default.

  const err = (strm, errorCode) => {
    strm.msg = messages$1[errorCode];
    return errorCode;
  };

  const rank = (f) => {
    return ((f) * 2) - ((f) > 4 ? 9 : 0);
  };

  const zero = (buf) => {
    let len = buf.length; while (--len >= 0) { buf[len] = 0; }
  };

  /* ===========================================================================
   * Slide the hash table when sliding the window down (could be avoided with 32
   * bit values at the expense of memory usage). We slide even when level == 0 to
   * keep the hash table consistent if we switch back to level > 0 later.
   */
  const slide_hash = (s) => {
    let n, m;
    let p;
    let wsize = s.w_size;

    n = s.hash_size;
    p = n;
    do {
      m = s.head[--p];
      s.head[p] = (m >= wsize ? m - wsize : 0);
    } while (--n);
    n = wsize;
  //#ifndef FASTEST
    p = n;
    do {
      m = s.prev[--p];
      s.prev[p] = (m >= wsize ? m - wsize : 0);
      /* If n is not on any hash chain, prev[n] is garbage but
       * its value will never be used.
       */
    } while (--n);
  //#endif
  };

  /* eslint-disable new-cap */
  let HASH_ZLIB = (s, prev, data) => ((prev << s.hash_shift) ^ data) & s.hash_mask;
  // This hash causes less collisions, https://github.com/nodeca/pako/issues/135
  // But breaks binary compatibility
  //let HASH_FAST = (s, prev, data) => ((prev << 8) + (prev >> 8) + (data << 4)) & s.hash_mask;
  let HASH = HASH_ZLIB;


  /* =========================================================================
   * Flush as much pending output as possible. All deflate() output, except for
   * some deflate_stored() output, goes through this function so some
   * applications may wish to modify it to avoid allocating a large
   * strm->next_out buffer and copying into it. (See also read_buf()).
   */
  const flush_pending = (strm) => {
    const s = strm.state;

    //_tr_flush_bits(s);
    let len = s.pending;
    if (len > strm.avail_out) {
      len = strm.avail_out;
    }
    if (len === 0) { return; }

    strm.output.set(s.pending_buf.subarray(s.pending_out, s.pending_out + len), strm.next_out);
    strm.next_out  += len;
    s.pending_out  += len;
    strm.total_out += len;
    strm.avail_out -= len;
    s.pending      -= len;
    if (s.pending === 0) {
      s.pending_out = 0;
    }
  };


  const flush_block_only = (s, last) => {
    _tr_flush_block(s, (s.block_start >= 0 ? s.block_start : -1), s.strstart - s.block_start, last);
    s.block_start = s.strstart;
    flush_pending(s.strm);
  };


  const put_byte = (s, b) => {
    s.pending_buf[s.pending++] = b;
  };


  /* =========================================================================
   * Put a short in the pending buffer. The 16-bit value is put in MSB order.
   * IN assertion: the stream state is correct and there is enough room in
   * pending_buf.
   */
  const putShortMSB = (s, b) => {

    //  put_byte(s, (Byte)(b >> 8));
  //  put_byte(s, (Byte)(b & 0xff));
    s.pending_buf[s.pending++] = (b >>> 8) & 0xff;
    s.pending_buf[s.pending++] = b & 0xff;
  };


  /* ===========================================================================
   * Read a new buffer from the current input stream, update the adler32
   * and total number of bytes read.  All deflate() input goes through
   * this function so some applications may wish to modify it to avoid
   * allocating a large strm->input buffer and copying from it.
   * (See also flush_pending()).
   */
  const read_buf = (strm, buf, start, size) => {

    let len = strm.avail_in;

    if (len > size) { len = size; }
    if (len === 0) { return 0; }

    strm.avail_in -= len;

    // zmemcpy(buf, strm->next_in, len);
    buf.set(strm.input.subarray(strm.next_in, strm.next_in + len), start);
    if (strm.state.wrap === 1) {
      strm.adler = adler32_1$1(strm.adler, buf, len, start);
    }

    else if (strm.state.wrap === 2) {
      strm.adler = crc32_1$1(strm.adler, buf, len, start);
    }

    strm.next_in += len;
    strm.total_in += len;

    return len;
  };


  /* ===========================================================================
   * Set match_start to the longest match starting at the given string and
   * return its length. Matches shorter or equal to prev_length are discarded,
   * in which case the result is equal to prev_length and match_start is
   * garbage.
   * IN assertions: cur_match is the head of the hash chain for the current
   *   string (strstart) and its distance is <= MAX_DIST, and prev_length >= 1
   * OUT assertion: the match length is not greater than s->lookahead.
   */
  const longest_match = (s, cur_match) => {

    let chain_length = s.max_chain_length;      /* max hash chain length */
    let scan = s.strstart; /* current string */
    let match;                       /* matched string */
    let len;                           /* length of current match */
    let best_len = s.prev_length;              /* best match length so far */
    let nice_match = s.nice_match;             /* stop if match long enough */
    const limit = (s.strstart > (s.w_size - MIN_LOOKAHEAD)) ?
        s.strstart - (s.w_size - MIN_LOOKAHEAD) : 0/*NIL*/;

    const _win = s.window; // shortcut

    const wmask = s.w_mask;
    const prev  = s.prev;

    /* Stop when cur_match becomes <= limit. To simplify the code,
     * we prevent matches with the string of window index 0.
     */

    const strend = s.strstart + MAX_MATCH;
    let scan_end1  = _win[scan + best_len - 1];
    let scan_end   = _win[scan + best_len];

    /* The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of 16.
     * It is easy to get rid of this optimization if necessary.
     */
    // Assert(s->hash_bits >= 8 && MAX_MATCH == 258, "Code too clever");

    /* Do not waste too much time if we already have a good match: */
    if (s.prev_length >= s.good_match) {
      chain_length >>= 2;
    }
    /* Do not look for matches beyond the end of the input. This is necessary
     * to make deflate deterministic.
     */
    if (nice_match > s.lookahead) { nice_match = s.lookahead; }

    // Assert((ulg)s->strstart <= s->window_size-MIN_LOOKAHEAD, "need lookahead");

    do {
      // Assert(cur_match < s->strstart, "no future");
      match = cur_match;

      /* Skip to next match if the match length cannot increase
       * or if the match length is less than 2.  Note that the checks below
       * for insufficient lookahead only occur occasionally for performance
       * reasons.  Therefore uninitialized memory will be accessed, and
       * conditional jumps will be made that depend on those values.
       * However the length of the match is limited to the lookahead, so
       * the output of deflate is not affected by the uninitialized values.
       */

      if (_win[match + best_len]     !== scan_end  ||
          _win[match + best_len - 1] !== scan_end1 ||
          _win[match]                !== _win[scan] ||
          _win[++match]              !== _win[scan + 1]) {
        continue;
      }

      /* The check at best_len-1 can be removed because it will be made
       * again later. (This heuristic is not always a win.)
       * It is not necessary to compare scan[2] and match[2] since they
       * are always equal when the other bytes match, given that
       * the hash keys are equal and that HASH_BITS >= 8.
       */
      scan += 2;
      match++;
      // Assert(*scan == *match, "match[2]?");

      /* We check for insufficient lookahead only every 8th comparison;
       * the 256th check will be made at strstart+258.
       */
      do {
        /*jshint noempty:false*/
      } while (_win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
               _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
               _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
               _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
               scan < strend);

      // Assert(scan <= s->window+(unsigned)(s->window_size-1), "wild scan");

      len = MAX_MATCH - (strend - scan);
      scan = strend - MAX_MATCH;

      if (len > best_len) {
        s.match_start = cur_match;
        best_len = len;
        if (len >= nice_match) {
          break;
        }
        scan_end1  = _win[scan + best_len - 1];
        scan_end   = _win[scan + best_len];
      }
    } while ((cur_match = prev[cur_match & wmask]) > limit && --chain_length !== 0);

    if (best_len <= s.lookahead) {
      return best_len;
    }
    return s.lookahead;
  };


  /* ===========================================================================
   * Fill the window when the lookahead becomes insufficient.
   * Updates strstart and lookahead.
   *
   * IN assertion: lookahead < MIN_LOOKAHEAD
   * OUT assertions: strstart <= window_size-MIN_LOOKAHEAD
   *    At least one byte has been read, or avail_in == 0; reads are
   *    performed for at least two bytes (required for the zip translate_eol
   *    option -- not supported here).
   */
  const fill_window = (s) => {

    const _w_size = s.w_size;
    let n, more, str;

    //Assert(s->lookahead < MIN_LOOKAHEAD, "already enough lookahead");

    do {
      more = s.window_size - s.lookahead - s.strstart;

      // JS ints have 32 bit, block below not needed
      /* Deal with !@#$% 64K limit: */
      //if (sizeof(int) <= 2) {
      //    if (more == 0 && s->strstart == 0 && s->lookahead == 0) {
      //        more = wsize;
      //
      //  } else if (more == (unsigned)(-1)) {
      //        /* Very unlikely, but possible on 16 bit machine if
      //         * strstart == 0 && lookahead == 1 (input done a byte at time)
      //         */
      //        more--;
      //    }
      //}


      /* If the window is almost full and there is insufficient lookahead,
       * move the upper half to the lower one to make room in the upper half.
       */
      if (s.strstart >= _w_size + (_w_size - MIN_LOOKAHEAD)) {

        s.window.set(s.window.subarray(_w_size, _w_size + _w_size - more), 0);
        s.match_start -= _w_size;
        s.strstart -= _w_size;
        /* we now have strstart >= MAX_DIST */
        s.block_start -= _w_size;
        if (s.insert > s.strstart) {
          s.insert = s.strstart;
        }
        slide_hash(s);
        more += _w_size;
      }
      if (s.strm.avail_in === 0) {
        break;
      }

      /* If there was no sliding:
       *    strstart <= WSIZE+MAX_DIST-1 && lookahead <= MIN_LOOKAHEAD - 1 &&
       *    more == window_size - lookahead - strstart
       * => more >= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
       * => more >= window_size - 2*WSIZE + 2
       * In the BIG_MEM or MMAP case (not yet supported),
       *   window_size == input_size + MIN_LOOKAHEAD  &&
       *   strstart + s->lookahead <= input_size => more >= MIN_LOOKAHEAD.
       * Otherwise, window_size == 2*WSIZE so more >= 2.
       * If there was sliding, more >= WSIZE. So in all cases, more >= 2.
       */
      //Assert(more >= 2, "more < 2");
      n = read_buf(s.strm, s.window, s.strstart + s.lookahead, more);
      s.lookahead += n;

      /* Initialize the hash value now that we have some input: */
      if (s.lookahead + s.insert >= MIN_MATCH) {
        str = s.strstart - s.insert;
        s.ins_h = s.window[str];

        /* UPDATE_HASH(s, s->ins_h, s->window[str + 1]); */
        s.ins_h = HASH(s, s.ins_h, s.window[str + 1]);
  //#if MIN_MATCH != 3
  //        Call update_hash() MIN_MATCH-3 more times
  //#endif
        while (s.insert) {
          /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
          s.ins_h = HASH(s, s.ins_h, s.window[str + MIN_MATCH - 1]);

          s.prev[str & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = str;
          str++;
          s.insert--;
          if (s.lookahead + s.insert < MIN_MATCH) {
            break;
          }
        }
      }
      /* If the whole input has less than MIN_MATCH bytes, ins_h is garbage,
       * but this is not important since only literal bytes will be emitted.
       */

    } while (s.lookahead < MIN_LOOKAHEAD && s.strm.avail_in !== 0);

    /* If the WIN_INIT bytes after the end of the current data have never been
     * written, then zero those bytes in order to avoid memory check reports of
     * the use of uninitialized (or uninitialised as Julian writes) bytes by
     * the longest match routines.  Update the high water mark for the next
     * time through here.  WIN_INIT is set to MAX_MATCH since the longest match
     * routines allow scanning to strstart + MAX_MATCH, ignoring lookahead.
     */
  //  if (s.high_water < s.window_size) {
  //    const curr = s.strstart + s.lookahead;
  //    let init = 0;
  //
  //    if (s.high_water < curr) {
  //      /* Previous high water mark below current data -- zero WIN_INIT
  //       * bytes or up to end of window, whichever is less.
  //       */
  //      init = s.window_size - curr;
  //      if (init > WIN_INIT)
  //        init = WIN_INIT;
  //      zmemzero(s->window + curr, (unsigned)init);
  //      s->high_water = curr + init;
  //    }
  //    else if (s->high_water < (ulg)curr + WIN_INIT) {
  //      /* High water mark at or above current data, but below current data
  //       * plus WIN_INIT -- zero out to current data plus WIN_INIT, or up
  //       * to end of window, whichever is less.
  //       */
  //      init = (ulg)curr + WIN_INIT - s->high_water;
  //      if (init > s->window_size - s->high_water)
  //        init = s->window_size - s->high_water;
  //      zmemzero(s->window + s->high_water, (unsigned)init);
  //      s->high_water += init;
  //    }
  //  }
  //
  //  Assert((ulg)s->strstart <= s->window_size - MIN_LOOKAHEAD,
  //    "not enough room for search");
  };

  /* ===========================================================================
   * Copy without compression as much as possible from the input stream, return
   * the current block state.
   *
   * In case deflateParams() is used to later switch to a non-zero compression
   * level, s->matches (otherwise unused when storing) keeps track of the number
   * of hash table slides to perform. If s->matches is 1, then one hash table
   * slide will be done when switching. If s->matches is 2, the maximum value
   * allowed here, then the hash table will be cleared, since two or more slides
   * is the same as a clear.
   *
   * deflate_stored() is written to minimize the number of times an input byte is
   * copied. It is most efficient with large input and output buffers, which
   * maximizes the opportunites to have a single copy from next_in to next_out.
   */
  const deflate_stored = (s, flush) => {

    /* Smallest worthy block size when not flushing or finishing. By default
     * this is 32K. This can be as small as 507 bytes for memLevel == 1. For
     * large input and output buffers, the stored block size will be larger.
     */
    let min_block = s.pending_buf_size - 5 > s.w_size ? s.w_size : s.pending_buf_size - 5;

    /* Copy as many min_block or larger stored blocks directly to next_out as
     * possible. If flushing, copy the remaining available input to next_out as
     * stored blocks, if there is enough space.
     */
    let len, left, have, last = 0;
    let used = s.strm.avail_in;
    do {
      /* Set len to the maximum size block that we can copy directly with the
       * available input data and output space. Set left to how much of that
       * would be copied from what's left in the window.
       */
      len = 65535/* MAX_STORED */;     /* maximum deflate stored block length */
      have = (s.bi_valid + 42) >> 3;     /* number of header bytes */
      if (s.strm.avail_out < have) {         /* need room for header */
        break;
      }
        /* maximum stored block length that will fit in avail_out: */
      have = s.strm.avail_out - have;
      left = s.strstart - s.block_start;  /* bytes left in window */
      if (len > left + s.strm.avail_in) {
        len = left + s.strm.avail_in;   /* limit len to the input */
      }
      if (len > have) {
        len = have;             /* limit len to the output */
      }

      /* If the stored block would be less than min_block in length, or if
       * unable to copy all of the available input when flushing, then try
       * copying to the window and the pending buffer instead. Also don't
       * write an empty block when flushing -- deflate() does that.
       */
      if (len < min_block && ((len === 0 && flush !== Z_FINISH$3) ||
                          flush === Z_NO_FLUSH$2 ||
                          len !== left + s.strm.avail_in)) {
        break;
      }

      /* Make a dummy stored block in pending to get the header bytes,
       * including any pending bits. This also updates the debugging counts.
       */
      last = flush === Z_FINISH$3 && len === left + s.strm.avail_in ? 1 : 0;
      _tr_stored_block(s, 0, 0, last);

      /* Replace the lengths in the dummy stored block with len. */
      s.pending_buf[s.pending - 4] = len;
      s.pending_buf[s.pending - 3] = len >> 8;
      s.pending_buf[s.pending - 2] = ~len;
      s.pending_buf[s.pending - 1] = ~len >> 8;

      /* Write the stored block header bytes. */
      flush_pending(s.strm);

  //#ifdef ZLIB_DEBUG
  //    /* Update debugging counts for the data about to be copied. */
  //    s->compressed_len += len << 3;
  //    s->bits_sent += len << 3;
  //#endif

      /* Copy uncompressed bytes from the window to next_out. */
      if (left) {
        if (left > len) {
          left = len;
        }
        //zmemcpy(s->strm->next_out, s->window + s->block_start, left);
        s.strm.output.set(s.window.subarray(s.block_start, s.block_start + left), s.strm.next_out);
        s.strm.next_out += left;
        s.strm.avail_out -= left;
        s.strm.total_out += left;
        s.block_start += left;
        len -= left;
      }

      /* Copy uncompressed bytes directly from next_in to next_out, updating
       * the check value.
       */
      if (len) {
        read_buf(s.strm, s.strm.output, s.strm.next_out, len);
        s.strm.next_out += len;
        s.strm.avail_out -= len;
        s.strm.total_out += len;
      }
    } while (last === 0);

    /* Update the sliding window with the last s->w_size bytes of the copied
     * data, or append all of the copied data to the existing window if less
     * than s->w_size bytes were copied. Also update the number of bytes to
     * insert in the hash tables, in the event that deflateParams() switches to
     * a non-zero compression level.
     */
    used -= s.strm.avail_in;    /* number of input bytes directly copied */
    if (used) {
      /* If any input was used, then no unused input remains in the window,
       * therefore s->block_start == s->strstart.
       */
      if (used >= s.w_size) {  /* supplant the previous history */
        s.matches = 2;     /* clear hash */
        //zmemcpy(s->window, s->strm->next_in - s->w_size, s->w_size);
        s.window.set(s.strm.input.subarray(s.strm.next_in - s.w_size, s.strm.next_in), 0);
        s.strstart = s.w_size;
        s.insert = s.strstart;
      }
      else {
        if (s.window_size - s.strstart <= used) {
          /* Slide the window down. */
          s.strstart -= s.w_size;
          //zmemcpy(s->window, s->window + s->w_size, s->strstart);
          s.window.set(s.window.subarray(s.w_size, s.w_size + s.strstart), 0);
          if (s.matches < 2) {
            s.matches++;   /* add a pending slide_hash() */
          }
          if (s.insert > s.strstart) {
            s.insert = s.strstart;
          }
        }
        //zmemcpy(s->window + s->strstart, s->strm->next_in - used, used);
        s.window.set(s.strm.input.subarray(s.strm.next_in - used, s.strm.next_in), s.strstart);
        s.strstart += used;
        s.insert += used > s.w_size - s.insert ? s.w_size - s.insert : used;
      }
      s.block_start = s.strstart;
    }
    if (s.high_water < s.strstart) {
      s.high_water = s.strstart;
    }

    /* If the last block was written to next_out, then done. */
    if (last) {
      return BS_FINISH_DONE;
    }

    /* If flushing and all input has been consumed, then done. */
    if (flush !== Z_NO_FLUSH$2 && flush !== Z_FINISH$3 &&
      s.strm.avail_in === 0 && s.strstart === s.block_start) {
      return BS_BLOCK_DONE;
    }

    /* Fill the window with any remaining input. */
    have = s.window_size - s.strstart;
    if (s.strm.avail_in > have && s.block_start >= s.w_size) {
      /* Slide the window down. */
      s.block_start -= s.w_size;
      s.strstart -= s.w_size;
      //zmemcpy(s->window, s->window + s->w_size, s->strstart);
      s.window.set(s.window.subarray(s.w_size, s.w_size + s.strstart), 0);
      if (s.matches < 2) {
        s.matches++;       /* add a pending slide_hash() */
      }
      have += s.w_size;      /* more space now */
      if (s.insert > s.strstart) {
        s.insert = s.strstart;
      }
    }
    if (have > s.strm.avail_in) {
      have = s.strm.avail_in;
    }
    if (have) {
      read_buf(s.strm, s.window, s.strstart, have);
      s.strstart += have;
      s.insert += have > s.w_size - s.insert ? s.w_size - s.insert : have;
    }
    if (s.high_water < s.strstart) {
      s.high_water = s.strstart;
    }

    /* There was not enough avail_out to write a complete worthy or flushed
     * stored block to next_out. Write a stored block to pending instead, if we
     * have enough input for a worthy block, or if flushing and there is enough
     * room for the remaining input as a stored block in the pending buffer.
     */
    have = (s.bi_valid + 42) >> 3;     /* number of header bytes */
      /* maximum stored block length that will fit in pending: */
    have = s.pending_buf_size - have > 65535/* MAX_STORED */ ? 65535/* MAX_STORED */ : s.pending_buf_size - have;
    min_block = have > s.w_size ? s.w_size : have;
    left = s.strstart - s.block_start;
    if (left >= min_block ||
       ((left || flush === Z_FINISH$3) && flush !== Z_NO_FLUSH$2 &&
       s.strm.avail_in === 0 && left <= have)) {
      len = left > have ? have : left;
      last = flush === Z_FINISH$3 && s.strm.avail_in === 0 &&
           len === left ? 1 : 0;
      _tr_stored_block(s, s.block_start, len, last);
      s.block_start += len;
      flush_pending(s.strm);
    }

    /* We've done all we can with the available input and output. */
    return last ? BS_FINISH_STARTED : BS_NEED_MORE;
  };


  /* ===========================================================================
   * Compress as much as possible from the input stream, return the current
   * block state.
   * This function does not perform lazy evaluation of matches and inserts
   * new strings in the dictionary only for unmatched strings or for short
   * matches. It is used only for the fast compression options.
   */
  const deflate_fast = (s, flush) => {

    let hash_head;        /* head of the hash chain */
    let bflush;           /* set if current block must be flushed */

    for (;;) {
      /* Make sure that we always have enough lookahead, except
       * at the end of the input file. We need MAX_MATCH bytes
       * for the next match, plus MIN_MATCH bytes to insert the
       * string following the next match.
       */
      if (s.lookahead < MIN_LOOKAHEAD) {
        fill_window(s);
        if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$2) {
          return BS_NEED_MORE;
        }
        if (s.lookahead === 0) {
          break; /* flush the current block */
        }
      }

      /* Insert the string window[strstart .. strstart+2] in the
       * dictionary, and set hash_head to the head of the hash chain:
       */
      hash_head = 0/*NIL*/;
      if (s.lookahead >= MIN_MATCH) {
        /*** INSERT_STRING(s, s.strstart, hash_head); ***/
        s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + MIN_MATCH - 1]);
        hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
        s.head[s.ins_h] = s.strstart;
        /***/
      }

      /* Find the longest match, discarding those <= prev_length.
       * At this point we have always match_length < MIN_MATCH
       */
      if (hash_head !== 0/*NIL*/ && ((s.strstart - hash_head) <= (s.w_size - MIN_LOOKAHEAD))) {
        /* To simplify the code, we prevent matches with the string
         * of window index 0 (in particular we have to avoid a match
         * of the string with itself at the start of the input file).
         */
        s.match_length = longest_match(s, hash_head);
        /* longest_match() sets match_start */
      }
      if (s.match_length >= MIN_MATCH) {
        // check_match(s, s.strstart, s.match_start, s.match_length); // for debug only

        /*** _tr_tally_dist(s, s.strstart - s.match_start,
                       s.match_length - MIN_MATCH, bflush); ***/
        bflush = _tr_tally(s, s.strstart - s.match_start, s.match_length - MIN_MATCH);

        s.lookahead -= s.match_length;

        /* Insert new strings in the hash table only if the match length
         * is not too large. This saves time but degrades compression.
         */
        if (s.match_length <= s.max_lazy_match/*max_insert_length*/ && s.lookahead >= MIN_MATCH) {
          s.match_length--; /* string at strstart already in table */
          do {
            s.strstart++;
            /*** INSERT_STRING(s, s.strstart, hash_head); ***/
            s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + MIN_MATCH - 1]);
            hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
            s.head[s.ins_h] = s.strstart;
            /***/
            /* strstart never exceeds WSIZE-MAX_MATCH, so there are
             * always MIN_MATCH bytes ahead.
             */
          } while (--s.match_length !== 0);
          s.strstart++;
        } else
        {
          s.strstart += s.match_length;
          s.match_length = 0;
          s.ins_h = s.window[s.strstart];
          /* UPDATE_HASH(s, s.ins_h, s.window[s.strstart+1]); */
          s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + 1]);

  //#if MIN_MATCH != 3
  //                Call UPDATE_HASH() MIN_MATCH-3 more times
  //#endif
          /* If lookahead < MIN_MATCH, ins_h is garbage, but it does not
           * matter since it will be recomputed at next deflate call.
           */
        }
      } else {
        /* No match, output a literal byte */
        //Tracevv((stderr,"%c", s.window[s.strstart]));
        /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
        bflush = _tr_tally(s, 0, s.window[s.strstart]);

        s.lookahead--;
        s.strstart++;
      }
      if (bflush) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
    }
    s.insert = ((s.strstart < (MIN_MATCH - 1)) ? s.strstart : MIN_MATCH - 1);
    if (flush === Z_FINISH$3) {
      /*** FLUSH_BLOCK(s, 1); ***/
      flush_block_only(s, true);
      if (s.strm.avail_out === 0) {
        return BS_FINISH_STARTED;
      }
      /***/
      return BS_FINISH_DONE;
    }
    if (s.sym_next) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
    return BS_BLOCK_DONE;
  };

  /* ===========================================================================
   * Same as above, but achieves better compression. We use a lazy
   * evaluation for matches: a match is finally adopted only if there is
   * no better match at the next window position.
   */
  const deflate_slow = (s, flush) => {

    let hash_head;          /* head of hash chain */
    let bflush;              /* set if current block must be flushed */

    let max_insert;

    /* Process the input block. */
    for (;;) {
      /* Make sure that we always have enough lookahead, except
       * at the end of the input file. We need MAX_MATCH bytes
       * for the next match, plus MIN_MATCH bytes to insert the
       * string following the next match.
       */
      if (s.lookahead < MIN_LOOKAHEAD) {
        fill_window(s);
        if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$2) {
          return BS_NEED_MORE;
        }
        if (s.lookahead === 0) { break; } /* flush the current block */
      }

      /* Insert the string window[strstart .. strstart+2] in the
       * dictionary, and set hash_head to the head of the hash chain:
       */
      hash_head = 0/*NIL*/;
      if (s.lookahead >= MIN_MATCH) {
        /*** INSERT_STRING(s, s.strstart, hash_head); ***/
        s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + MIN_MATCH - 1]);
        hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
        s.head[s.ins_h] = s.strstart;
        /***/
      }

      /* Find the longest match, discarding those <= prev_length.
       */
      s.prev_length = s.match_length;
      s.prev_match = s.match_start;
      s.match_length = MIN_MATCH - 1;

      if (hash_head !== 0/*NIL*/ && s.prev_length < s.max_lazy_match &&
          s.strstart - hash_head <= (s.w_size - MIN_LOOKAHEAD)/*MAX_DIST(s)*/) {
        /* To simplify the code, we prevent matches with the string
         * of window index 0 (in particular we have to avoid a match
         * of the string with itself at the start of the input file).
         */
        s.match_length = longest_match(s, hash_head);
        /* longest_match() sets match_start */

        if (s.match_length <= 5 &&
           (s.strategy === Z_FILTERED || (s.match_length === MIN_MATCH && s.strstart - s.match_start > 4096/*TOO_FAR*/))) {

          /* If prev_match is also MIN_MATCH, match_start is garbage
           * but we will ignore the current match anyway.
           */
          s.match_length = MIN_MATCH - 1;
        }
      }
      /* If there was a match at the previous step and the current
       * match is not better, output the previous match:
       */
      if (s.prev_length >= MIN_MATCH && s.match_length <= s.prev_length) {
        max_insert = s.strstart + s.lookahead - MIN_MATCH;
        /* Do not insert strings in hash table beyond this. */

        //check_match(s, s.strstart-1, s.prev_match, s.prev_length);

        /***_tr_tally_dist(s, s.strstart - 1 - s.prev_match,
                       s.prev_length - MIN_MATCH, bflush);***/
        bflush = _tr_tally(s, s.strstart - 1 - s.prev_match, s.prev_length - MIN_MATCH);
        /* Insert in hash table all strings up to the end of the match.
         * strstart-1 and strstart are already inserted. If there is not
         * enough lookahead, the last two strings are not inserted in
         * the hash table.
         */
        s.lookahead -= s.prev_length - 1;
        s.prev_length -= 2;
        do {
          if (++s.strstart <= max_insert) {
            /*** INSERT_STRING(s, s.strstart, hash_head); ***/
            s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + MIN_MATCH - 1]);
            hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
            s.head[s.ins_h] = s.strstart;
            /***/
          }
        } while (--s.prev_length !== 0);
        s.match_available = 0;
        s.match_length = MIN_MATCH - 1;
        s.strstart++;

        if (bflush) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }

      } else if (s.match_available) {
        /* If there was no match at the previous position, output a
         * single literal. If there was a match but the current match
         * is longer, truncate the previous match to a single literal.
         */
        //Tracevv((stderr,"%c", s->window[s->strstart-1]));
        /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
        bflush = _tr_tally(s, 0, s.window[s.strstart - 1]);

        if (bflush) {
          /*** FLUSH_BLOCK_ONLY(s, 0) ***/
          flush_block_only(s, false);
          /***/
        }
        s.strstart++;
        s.lookahead--;
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
      } else {
        /* There is no previous match to compare with, wait for
         * the next step to decide.
         */
        s.match_available = 1;
        s.strstart++;
        s.lookahead--;
      }
    }
    //Assert (flush != Z_NO_FLUSH, "no flush?");
    if (s.match_available) {
      //Tracevv((stderr,"%c", s->window[s->strstart-1]));
      /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
      bflush = _tr_tally(s, 0, s.window[s.strstart - 1]);

      s.match_available = 0;
    }
    s.insert = s.strstart < MIN_MATCH - 1 ? s.strstart : MIN_MATCH - 1;
    if (flush === Z_FINISH$3) {
      /*** FLUSH_BLOCK(s, 1); ***/
      flush_block_only(s, true);
      if (s.strm.avail_out === 0) {
        return BS_FINISH_STARTED;
      }
      /***/
      return BS_FINISH_DONE;
    }
    if (s.sym_next) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }

    return BS_BLOCK_DONE;
  };


  /* ===========================================================================
   * For Z_RLE, simply look for runs of bytes, generate matches only of distance
   * one.  Do not maintain a hash table.  (It will be regenerated if this run of
   * deflate switches away from Z_RLE.)
   */
  const deflate_rle = (s, flush) => {

    let bflush;            /* set if current block must be flushed */
    let prev;              /* byte at distance one to match */
    let scan, strend;      /* scan goes up to strend for length of run */

    const _win = s.window;

    for (;;) {
      /* Make sure that we always have enough lookahead, except
       * at the end of the input file. We need MAX_MATCH bytes
       * for the longest run, plus one for the unrolled loop.
       */
      if (s.lookahead <= MAX_MATCH) {
        fill_window(s);
        if (s.lookahead <= MAX_MATCH && flush === Z_NO_FLUSH$2) {
          return BS_NEED_MORE;
        }
        if (s.lookahead === 0) { break; } /* flush the current block */
      }

      /* See how many times the previous byte repeats */
      s.match_length = 0;
      if (s.lookahead >= MIN_MATCH && s.strstart > 0) {
        scan = s.strstart - 1;
        prev = _win[scan];
        if (prev === _win[++scan] && prev === _win[++scan] && prev === _win[++scan]) {
          strend = s.strstart + MAX_MATCH;
          do {
            /*jshint noempty:false*/
          } while (prev === _win[++scan] && prev === _win[++scan] &&
                   prev === _win[++scan] && prev === _win[++scan] &&
                   prev === _win[++scan] && prev === _win[++scan] &&
                   prev === _win[++scan] && prev === _win[++scan] &&
                   scan < strend);
          s.match_length = MAX_MATCH - (strend - scan);
          if (s.match_length > s.lookahead) {
            s.match_length = s.lookahead;
          }
        }
        //Assert(scan <= s->window+(uInt)(s->window_size-1), "wild scan");
      }

      /* Emit match if have run of MIN_MATCH or longer, else emit literal */
      if (s.match_length >= MIN_MATCH) {
        //check_match(s, s.strstart, s.strstart - 1, s.match_length);

        /*** _tr_tally_dist(s, 1, s.match_length - MIN_MATCH, bflush); ***/
        bflush = _tr_tally(s, 1, s.match_length - MIN_MATCH);

        s.lookahead -= s.match_length;
        s.strstart += s.match_length;
        s.match_length = 0;
      } else {
        /* No match, output a literal byte */
        //Tracevv((stderr,"%c", s->window[s->strstart]));
        /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
        bflush = _tr_tally(s, 0, s.window[s.strstart]);

        s.lookahead--;
        s.strstart++;
      }
      if (bflush) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
    }
    s.insert = 0;
    if (flush === Z_FINISH$3) {
      /*** FLUSH_BLOCK(s, 1); ***/
      flush_block_only(s, true);
      if (s.strm.avail_out === 0) {
        return BS_FINISH_STARTED;
      }
      /***/
      return BS_FINISH_DONE;
    }
    if (s.sym_next) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
    return BS_BLOCK_DONE;
  };

  /* ===========================================================================
   * For Z_HUFFMAN_ONLY, do not look for matches.  Do not maintain a hash table.
   * (It will be regenerated if this run of deflate switches away from Huffman.)
   */
  const deflate_huff = (s, flush) => {

    let bflush;             /* set if current block must be flushed */

    for (;;) {
      /* Make sure that we have a literal to write. */
      if (s.lookahead === 0) {
        fill_window(s);
        if (s.lookahead === 0) {
          if (flush === Z_NO_FLUSH$2) {
            return BS_NEED_MORE;
          }
          break;      /* flush the current block */
        }
      }

      /* Output a literal byte */
      s.match_length = 0;
      //Tracevv((stderr,"%c", s->window[s->strstart]));
      /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
      bflush = _tr_tally(s, 0, s.window[s.strstart]);
      s.lookahead--;
      s.strstart++;
      if (bflush) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
    }
    s.insert = 0;
    if (flush === Z_FINISH$3) {
      /*** FLUSH_BLOCK(s, 1); ***/
      flush_block_only(s, true);
      if (s.strm.avail_out === 0) {
        return BS_FINISH_STARTED;
      }
      /***/
      return BS_FINISH_DONE;
    }
    if (s.sym_next) {
      /*** FLUSH_BLOCK(s, 0); ***/
      flush_block_only(s, false);
      if (s.strm.avail_out === 0) {
        return BS_NEED_MORE;
      }
      /***/
    }
    return BS_BLOCK_DONE;
  };

  /* Values for max_lazy_match, good_match and max_chain_length, depending on
   * the desired pack level (0..9). The values given below have been tuned to
   * exclude worst case performance for pathological files. Better values may be
   * found for specific files.
   */
  function Config(good_length, max_lazy, nice_length, max_chain, func) {

    this.good_length = good_length;
    this.max_lazy = max_lazy;
    this.nice_length = nice_length;
    this.max_chain = max_chain;
    this.func = func;
  }

  const configuration_table = [
    /*      good lazy nice chain */
    new Config(0, 0, 0, 0, deflate_stored),          /* 0 store only */
    new Config(4, 4, 8, 4, deflate_fast),            /* 1 max speed, no lazy matches */
    new Config(4, 5, 16, 8, deflate_fast),           /* 2 */
    new Config(4, 6, 32, 32, deflate_fast),          /* 3 */

    new Config(4, 4, 16, 16, deflate_slow),          /* 4 lazy matches */
    new Config(8, 16, 32, 32, deflate_slow),         /* 5 */
    new Config(8, 16, 128, 128, deflate_slow),       /* 6 */
    new Config(8, 32, 128, 256, deflate_slow),       /* 7 */
    new Config(32, 128, 258, 1024, deflate_slow),    /* 8 */
    new Config(32, 258, 258, 4096, deflate_slow)     /* 9 max compression */
  ];


  /* ===========================================================================
   * Initialize the "longest match" routines for a new zlib stream
   */
  const lm_init = (s) => {

    s.window_size = 2 * s.w_size;

    /*** CLEAR_HASH(s); ***/
    zero(s.head); // Fill with NIL (= 0);

    /* Set the default configuration parameters:
     */
    s.max_lazy_match = configuration_table[s.level].max_lazy;
    s.good_match = configuration_table[s.level].good_length;
    s.nice_match = configuration_table[s.level].nice_length;
    s.max_chain_length = configuration_table[s.level].max_chain;

    s.strstart = 0;
    s.block_start = 0;
    s.lookahead = 0;
    s.insert = 0;
    s.match_length = s.prev_length = MIN_MATCH - 1;
    s.match_available = 0;
    s.ins_h = 0;
  };


  function DeflateState() {
    this.strm = null;            /* pointer back to this zlib stream */
    this.status = 0;            /* as the name implies */
    this.pending_buf = null;      /* output still pending */
    this.pending_buf_size = 0;  /* size of pending_buf */
    this.pending_out = 0;       /* next pending byte to output to the stream */
    this.pending = 0;           /* nb of bytes in the pending buffer */
    this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
    this.gzhead = null;         /* gzip header information to write */
    this.gzindex = 0;           /* where in extra, name, or comment */
    this.method = Z_DEFLATED$2; /* can only be DEFLATED */
    this.last_flush = -1;   /* value of flush param for previous deflate call */

    this.w_size = 0;  /* LZ77 window size (32K by default) */
    this.w_bits = 0;  /* log2(w_size)  (8..16) */
    this.w_mask = 0;  /* w_size - 1 */

    this.window = null;
    /* Sliding window. Input bytes are read into the second half of the window,
     * and move to the first half later to keep a dictionary of at least wSize
     * bytes. With this organization, matches are limited to a distance of
     * wSize-MAX_MATCH bytes, but this ensures that IO is always
     * performed with a length multiple of the block size.
     */

    this.window_size = 0;
    /* Actual size of window: 2*wSize, except when the user input buffer
     * is directly used as sliding window.
     */

    this.prev = null;
    /* Link to older string with same hash index. To limit the size of this
     * array to 64K, this link is maintained only for the last 32K strings.
     * An index in this array is thus a window index modulo 32K.
     */

    this.head = null;   /* Heads of the hash chains or NIL. */

    this.ins_h = 0;       /* hash index of string to be inserted */
    this.hash_size = 0;   /* number of elements in hash table */
    this.hash_bits = 0;   /* log2(hash_size) */
    this.hash_mask = 0;   /* hash_size-1 */

    this.hash_shift = 0;
    /* Number of bits by which ins_h must be shifted at each input
     * step. It must be such that after MIN_MATCH steps, the oldest
     * byte no longer takes part in the hash key, that is:
     *   hash_shift * MIN_MATCH >= hash_bits
     */

    this.block_start = 0;
    /* Window position at the beginning of the current output block. Gets
     * negative when the window is moved backwards.
     */

    this.match_length = 0;      /* length of best match */
    this.prev_match = 0;        /* previous match */
    this.match_available = 0;   /* set if previous match exists */
    this.strstart = 0;          /* start of string to insert */
    this.match_start = 0;       /* start of matching string */
    this.lookahead = 0;         /* number of valid bytes ahead in window */

    this.prev_length = 0;
    /* Length of the best match at previous step. Matches not greater than this
     * are discarded. This is used in the lazy match evaluation.
     */

    this.max_chain_length = 0;
    /* To speed up deflation, hash chains are never searched beyond this
     * length.  A higher limit improves compression ratio but degrades the
     * speed.
     */

    this.max_lazy_match = 0;
    /* Attempt to find a better match only when the current match is strictly
     * smaller than this value. This mechanism is used only for compression
     * levels >= 4.
     */
    // That's alias to max_lazy_match, don't use directly
    //this.max_insert_length = 0;
    /* Insert new strings in the hash table only if the match length is not
     * greater than this length. This saves time but degrades compression.
     * max_insert_length is used only for compression levels <= 3.
     */

    this.level = 0;     /* compression level (1..9) */
    this.strategy = 0;  /* favor or force Huffman coding*/

    this.good_match = 0;
    /* Use a faster search when the previous match is longer than this */

    this.nice_match = 0; /* Stop searching when current match exceeds this */

                /* used by trees.c: */

    /* Didn't use ct_data typedef below to suppress compiler warning */

    // struct ct_data_s dyn_ltree[HEAP_SIZE];   /* literal and length tree */
    // struct ct_data_s dyn_dtree[2*D_CODES+1]; /* distance tree */
    // struct ct_data_s bl_tree[2*BL_CODES+1];  /* Huffman tree for bit lengths */

    // Use flat array of DOUBLE size, with interleaved fata,
    // because JS does not support effective
    this.dyn_ltree  = new Uint16Array(HEAP_SIZE * 2);
    this.dyn_dtree  = new Uint16Array((2 * D_CODES + 1) * 2);
    this.bl_tree    = new Uint16Array((2 * BL_CODES + 1) * 2);
    zero(this.dyn_ltree);
    zero(this.dyn_dtree);
    zero(this.bl_tree);

    this.l_desc   = null;         /* desc. for literal tree */
    this.d_desc   = null;         /* desc. for distance tree */
    this.bl_desc  = null;         /* desc. for bit length tree */

    //ush bl_count[MAX_BITS+1];
    this.bl_count = new Uint16Array(MAX_BITS + 1);
    /* number of codes at each bit length for an optimal tree */

    //int heap[2*L_CODES+1];      /* heap used to build the Huffman trees */
    this.heap = new Uint16Array(2 * L_CODES + 1);  /* heap used to build the Huffman trees */
    zero(this.heap);

    this.heap_len = 0;               /* number of elements in the heap */
    this.heap_max = 0;               /* element of largest frequency */
    /* The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
     * The same heap array is used to build all trees.
     */

    this.depth = new Uint16Array(2 * L_CODES + 1); //uch depth[2*L_CODES+1];
    zero(this.depth);
    /* Depth of each subtree used as tie breaker for trees of equal frequency
     */

    this.sym_buf = 0;        /* buffer for distances and literals/lengths */

    this.lit_bufsize = 0;
    /* Size of match buffer for literals/lengths.  There are 4 reasons for
     * limiting lit_bufsize to 64K:
     *   - frequencies can be kept in 16 bit counters
     *   - if compression is not successful for the first block, all input
     *     data is still in the window so we can still emit a stored block even
     *     when input comes from standard input.  (This can also be done for
     *     all blocks if lit_bufsize is not greater than 32K.)
     *   - if compression is not successful for a file smaller than 64K, we can
     *     even emit a stored file instead of a stored block (saving 5 bytes).
     *     This is applicable only for zip (not gzip or zlib).
     *   - creating new Huffman trees less frequently may not provide fast
     *     adaptation to changes in the input data statistics. (Take for
     *     example a binary file with poorly compressible code followed by
     *     a highly compressible string table.) Smaller buffer sizes give
     *     fast adaptation but have of course the overhead of transmitting
     *     trees more frequently.
     *   - I can't count above 4
     */

    this.sym_next = 0;      /* running index in sym_buf */
    this.sym_end = 0;       /* symbol table full when sym_next reaches this */

    this.opt_len = 0;       /* bit length of current block with optimal trees */
    this.static_len = 0;    /* bit length of current block with static trees */
    this.matches = 0;       /* number of string matches in current block */
    this.insert = 0;        /* bytes at end of window left to insert */


    this.bi_buf = 0;
    /* Output buffer. bits are inserted starting at the bottom (least
     * significant bits).
     */
    this.bi_valid = 0;
    /* Number of valid bits in bi_buf.  All bits above the last valid bit
     * are always zero.
     */

    // Used for window memory init. We safely ignore it for JS. That makes
    // sense only for pointers and memory check tools.
    //this.high_water = 0;
    /* High water mark offset in window for initialized bytes -- bytes above
     * this are set to zero in order to avoid memory check warnings when
     * longest match routines access bytes past the input.  This is then
     * updated to the new high water mark.
     */
  }


  /* =========================================================================
   * Check for a valid deflate stream state. Return 0 if ok, 1 if not.
   */
  const deflateStateCheck = (strm) => {

    if (!strm) {
      return 1;
    }
    const s = strm.state;
    if (!s || s.strm !== strm || (s.status !== INIT_STATE &&
  //#ifdef GZIP
                                  s.status !== GZIP_STATE &&
  //#endif
                                  s.status !== EXTRA_STATE &&
                                  s.status !== NAME_STATE &&
                                  s.status !== COMMENT_STATE &&
                                  s.status !== HCRC_STATE &&
                                  s.status !== BUSY_STATE &&
                                  s.status !== FINISH_STATE)) {
      return 1;
    }
    return 0;
  };


  const deflateResetKeep = (strm) => {

    if (deflateStateCheck(strm)) {
      return err(strm, Z_STREAM_ERROR$2);
    }

    strm.total_in = strm.total_out = 0;
    strm.data_type = Z_UNKNOWN;

    const s = strm.state;
    s.pending = 0;
    s.pending_out = 0;

    if (s.wrap < 0) {
      s.wrap = -s.wrap;
      /* was made negative by deflate(..., Z_FINISH); */
    }
    s.status =
  //#ifdef GZIP
      s.wrap === 2 ? GZIP_STATE :
  //#endif
      s.wrap ? INIT_STATE : BUSY_STATE;
    strm.adler = (s.wrap === 2) ?
      0  // crc32(0, Z_NULL, 0)
    :
      1; // adler32(0, Z_NULL, 0)
    s.last_flush = -2;
    _tr_init(s);
    return Z_OK$3;
  };


  const deflateReset = (strm) => {

    const ret = deflateResetKeep(strm);
    if (ret === Z_OK$3) {
      lm_init(strm.state);
    }
    return ret;
  };


  const deflateSetHeader = (strm, head) => {

    if (deflateStateCheck(strm) || strm.state.wrap !== 2) {
      return Z_STREAM_ERROR$2;
    }
    strm.state.gzhead = head;
    return Z_OK$3;
  };


  const deflateInit2 = (strm, level, method, windowBits, memLevel, strategy) => {

    if (!strm) { // === Z_NULL
      return Z_STREAM_ERROR$2;
    }
    let wrap = 1;

    if (level === Z_DEFAULT_COMPRESSION$1) {
      level = 6;
    }

    if (windowBits < 0) { /* suppress zlib wrapper */
      wrap = 0;
      windowBits = -windowBits;
    }

    else if (windowBits > 15) {
      wrap = 2;           /* write gzip wrapper instead */
      windowBits -= 16;
    }


    if (memLevel < 1 || memLevel > MAX_MEM_LEVEL || method !== Z_DEFLATED$2 ||
      windowBits < 8 || windowBits > 15 || level < 0 || level > 9 ||
      strategy < 0 || strategy > Z_FIXED || (windowBits === 8 && wrap !== 1)) {
      return err(strm, Z_STREAM_ERROR$2);
    }


    if (windowBits === 8) {
      windowBits = 9;
    }
    /* until 256-byte window bug fixed */

    const s = new DeflateState();

    strm.state = s;
    s.strm = strm;
    s.status = INIT_STATE;     /* to pass state test in deflateReset() */

    s.wrap = wrap;
    s.gzhead = null;
    s.w_bits = windowBits;
    s.w_size = 1 << s.w_bits;
    s.w_mask = s.w_size - 1;

    s.hash_bits = memLevel + 7;
    s.hash_size = 1 << s.hash_bits;
    s.hash_mask = s.hash_size - 1;
    s.hash_shift = ~~((s.hash_bits + MIN_MATCH - 1) / MIN_MATCH);

    s.window = new Uint8Array(s.w_size * 2);
    s.head = new Uint16Array(s.hash_size);
    s.prev = new Uint16Array(s.w_size);

    // Don't need mem init magic for JS.
    //s.high_water = 0;  /* nothing written to s->window yet */

    s.lit_bufsize = 1 << (memLevel + 6); /* 16K elements by default */

    /* We overlay pending_buf and sym_buf. This works since the average size
     * for length/distance pairs over any compressed block is assured to be 31
     * bits or less.
     *
     * Analysis: The longest fixed codes are a length code of 8 bits plus 5
     * extra bits, for lengths 131 to 257. The longest fixed distance codes are
     * 5 bits plus 13 extra bits, for distances 16385 to 32768. The longest
     * possible fixed-codes length/distance pair is then 31 bits total.
     *
     * sym_buf starts one-fourth of the way into pending_buf. So there are
     * three bytes in sym_buf for every four bytes in pending_buf. Each symbol
     * in sym_buf is three bytes -- two for the distance and one for the
     * literal/length. As each symbol is consumed, the pointer to the next
     * sym_buf value to read moves forward three bytes. From that symbol, up to
     * 31 bits are written to pending_buf. The closest the written pending_buf
     * bits gets to the next sym_buf symbol to read is just before the last
     * code is written. At that time, 31*(n-2) bits have been written, just
     * after 24*(n-2) bits have been consumed from sym_buf. sym_buf starts at
     * 8*n bits into pending_buf. (Note that the symbol buffer fills when n-1
     * symbols are written.) The closest the writing gets to what is unread is
     * then n+14 bits. Here n is lit_bufsize, which is 16384 by default, and
     * can range from 128 to 32768.
     *
     * Therefore, at a minimum, there are 142 bits of space between what is
     * written and what is read in the overlain buffers, so the symbols cannot
     * be overwritten by the compressed data. That space is actually 139 bits,
     * due to the three-bit fixed-code block header.
     *
     * That covers the case where either Z_FIXED is specified, forcing fixed
     * codes, or when the use of fixed codes is chosen, because that choice
     * results in a smaller compressed block than dynamic codes. That latter
     * condition then assures that the above analysis also covers all dynamic
     * blocks. A dynamic-code block will only be chosen to be emitted if it has
     * fewer bits than a fixed-code block would for the same set of symbols.
     * Therefore its average symbol length is assured to be less than 31. So
     * the compressed data for a dynamic block also cannot overwrite the
     * symbols from which it is being constructed.
     */

    s.pending_buf_size = s.lit_bufsize * 4;
    s.pending_buf = new Uint8Array(s.pending_buf_size);

    // It is offset from `s.pending_buf` (size is `s.lit_bufsize * 2`)
    //s->sym_buf = s->pending_buf + s->lit_bufsize;
    s.sym_buf = s.lit_bufsize;

    //s->sym_end = (s->lit_bufsize - 1) * 3;
    s.sym_end = (s.lit_bufsize - 1) * 3;
    /* We avoid equality with lit_bufsize*3 because of wraparound at 64K
     * on 16 bit machines and because stored blocks are restricted to
     * 64K-1 bytes.
     */

    s.level = level;
    s.strategy = strategy;
    s.method = method;

    return deflateReset(strm);
  };

  const deflateInit = (strm, level) => {

    return deflateInit2(strm, level, Z_DEFLATED$2, MAX_WBITS$1, DEF_MEM_LEVEL, Z_DEFAULT_STRATEGY$1);
  };


  /* ========================================================================= */
  const deflate$2 = (strm, flush) => {

    if (deflateStateCheck(strm) || flush > Z_BLOCK$1 || flush < 0) {
      return strm ? err(strm, Z_STREAM_ERROR$2) : Z_STREAM_ERROR$2;
    }

    const s = strm.state;

    if (!strm.output ||
        (strm.avail_in !== 0 && !strm.input) ||
        (s.status === FINISH_STATE && flush !== Z_FINISH$3)) {
      return err(strm, (strm.avail_out === 0) ? Z_BUF_ERROR$1 : Z_STREAM_ERROR$2);
    }

    const old_flush = s.last_flush;
    s.last_flush = flush;

    /* Flush as much pending output as possible */
    if (s.pending !== 0) {
      flush_pending(strm);
      if (strm.avail_out === 0) {
        /* Since avail_out is 0, deflate will be called again with
         * more output space, but possibly with both pending and
         * avail_in equal to zero. There won't be anything to do,
         * but this is not an error situation so make sure we
         * return OK instead of BUF_ERROR at next call of deflate:
         */
        s.last_flush = -1;
        return Z_OK$3;
      }

      /* Make sure there is something to do and avoid duplicate consecutive
       * flushes. For repeated and useless calls with Z_FINISH, we keep
       * returning Z_STREAM_END instead of Z_BUF_ERROR.
       */
    } else if (strm.avail_in === 0 && rank(flush) <= rank(old_flush) &&
      flush !== Z_FINISH$3) {
      return err(strm, Z_BUF_ERROR$1);
    }

    /* User must not provide more input after the first FINISH: */
    if (s.status === FINISH_STATE && strm.avail_in !== 0) {
      return err(strm, Z_BUF_ERROR$1);
    }

    /* Write the header */
    if (s.status === INIT_STATE && s.wrap === 0) {
      s.status = BUSY_STATE;
    }
    if (s.status === INIT_STATE) {
      /* zlib header */
      let header = (Z_DEFLATED$2 + ((s.w_bits - 8) << 4)) << 8;
      let level_flags = -1;

      if (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2) {
        level_flags = 0;
      } else if (s.level < 6) {
        level_flags = 1;
      } else if (s.level === 6) {
        level_flags = 2;
      } else {
        level_flags = 3;
      }
      header |= (level_flags << 6);
      if (s.strstart !== 0) { header |= PRESET_DICT; }
      header += 31 - (header % 31);

      putShortMSB(s, header);

      /* Save the adler32 of the preset dictionary: */
      if (s.strstart !== 0) {
        putShortMSB(s, strm.adler >>> 16);
        putShortMSB(s, strm.adler & 0xffff);
      }
      strm.adler = 1; // adler32(0L, Z_NULL, 0);
      s.status = BUSY_STATE;

      /* Compression must start with an empty pending buffer */
      flush_pending(strm);
      if (s.pending !== 0) {
        s.last_flush = -1;
        return Z_OK$3;
      }
    }
  //#ifdef GZIP
    if (s.status === GZIP_STATE) {
      /* gzip header */
      strm.adler = 0;  //crc32(0L, Z_NULL, 0);
      put_byte(s, 31);
      put_byte(s, 139);
      put_byte(s, 8);
      if (!s.gzhead) { // s->gzhead == Z_NULL
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, 0);
        put_byte(s, s.level === 9 ? 2 :
                    (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
                     4 : 0));
        put_byte(s, OS_CODE);
        s.status = BUSY_STATE;

        /* Compression must start with an empty pending buffer */
        flush_pending(strm);
        if (s.pending !== 0) {
          s.last_flush = -1;
          return Z_OK$3;
        }
      }
      else {
        put_byte(s, (s.gzhead.text ? 1 : 0) +
                    (s.gzhead.hcrc ? 2 : 0) +
                    (!s.gzhead.extra ? 0 : 4) +
                    (!s.gzhead.name ? 0 : 8) +
                    (!s.gzhead.comment ? 0 : 16)
        );
        put_byte(s, s.gzhead.time & 0xff);
        put_byte(s, (s.gzhead.time >> 8) & 0xff);
        put_byte(s, (s.gzhead.time >> 16) & 0xff);
        put_byte(s, (s.gzhead.time >> 24) & 0xff);
        put_byte(s, s.level === 9 ? 2 :
                    (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
                     4 : 0));
        put_byte(s, s.gzhead.os & 0xff);
        if (s.gzhead.extra && s.gzhead.extra.length) {
          put_byte(s, s.gzhead.extra.length & 0xff);
          put_byte(s, (s.gzhead.extra.length >> 8) & 0xff);
        }
        if (s.gzhead.hcrc) {
          strm.adler = crc32_1$1(strm.adler, s.pending_buf, s.pending, 0);
        }
        s.gzindex = 0;
        s.status = EXTRA_STATE;
      }
    }
    if (s.status === EXTRA_STATE) {
      if (s.gzhead.extra/* != Z_NULL*/) {
        let beg = s.pending;   /* start of bytes to update crc */
        let left = (s.gzhead.extra.length & 0xffff) - s.gzindex;
        while (s.pending + left > s.pending_buf_size) {
          let copy = s.pending_buf_size - s.pending;
          // zmemcpy(s.pending_buf + s.pending,
          //    s.gzhead.extra + s.gzindex, copy);
          s.pending_buf.set(s.gzhead.extra.subarray(s.gzindex, s.gzindex + copy), s.pending);
          s.pending = s.pending_buf_size;
          //--- HCRC_UPDATE(beg) ---//
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32_1$1(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          //---//
          s.gzindex += copy;
          flush_pending(strm);
          if (s.pending !== 0) {
            s.last_flush = -1;
            return Z_OK$3;
          }
          beg = 0;
          left -= copy;
        }
        // JS specific: s.gzhead.extra may be TypedArray or Array for backward compatibility
        //              TypedArray.slice and TypedArray.from don't exist in IE10-IE11
        let gzhead_extra = new Uint8Array(s.gzhead.extra);
        // zmemcpy(s->pending_buf + s->pending,
        //     s->gzhead->extra + s->gzindex, left);
        s.pending_buf.set(gzhead_extra.subarray(s.gzindex, s.gzindex + left), s.pending);
        s.pending += left;
        //--- HCRC_UPDATE(beg) ---//
        if (s.gzhead.hcrc && s.pending > beg) {
          strm.adler = crc32_1$1(strm.adler, s.pending_buf, s.pending - beg, beg);
        }
        //---//
        s.gzindex = 0;
      }
      s.status = NAME_STATE;
    }
    if (s.status === NAME_STATE) {
      if (s.gzhead.name/* != Z_NULL*/) {
        let beg = s.pending;   /* start of bytes to update crc */
        let val;
        do {
          if (s.pending === s.pending_buf_size) {
            //--- HCRC_UPDATE(beg) ---//
            if (s.gzhead.hcrc && s.pending > beg) {
              strm.adler = crc32_1$1(strm.adler, s.pending_buf, s.pending - beg, beg);
            }
            //---//
            flush_pending(strm);
            if (s.pending !== 0) {
              s.last_flush = -1;
              return Z_OK$3;
            }
            beg = 0;
          }
          // JS specific: little magic to add zero terminator to end of string
          if (s.gzindex < s.gzhead.name.length) {
            val = s.gzhead.name.charCodeAt(s.gzindex++) & 0xff;
          } else {
            val = 0;
          }
          put_byte(s, val);
        } while (val !== 0);
        //--- HCRC_UPDATE(beg) ---//
        if (s.gzhead.hcrc && s.pending > beg) {
          strm.adler = crc32_1$1(strm.adler, s.pending_buf, s.pending - beg, beg);
        }
        //---//
        s.gzindex = 0;
      }
      s.status = COMMENT_STATE;
    }
    if (s.status === COMMENT_STATE) {
      if (s.gzhead.comment/* != Z_NULL*/) {
        let beg = s.pending;   /* start of bytes to update crc */
        let val;
        do {
          if (s.pending === s.pending_buf_size) {
            //--- HCRC_UPDATE(beg) ---//
            if (s.gzhead.hcrc && s.pending > beg) {
              strm.adler = crc32_1$1(strm.adler, s.pending_buf, s.pending - beg, beg);
            }
            //---//
            flush_pending(strm);
            if (s.pending !== 0) {
              s.last_flush = -1;
              return Z_OK$3;
            }
            beg = 0;
          }
          // JS specific: little magic to add zero terminator to end of string
          if (s.gzindex < s.gzhead.comment.length) {
            val = s.gzhead.comment.charCodeAt(s.gzindex++) & 0xff;
          } else {
            val = 0;
          }
          put_byte(s, val);
        } while (val !== 0);
        //--- HCRC_UPDATE(beg) ---//
        if (s.gzhead.hcrc && s.pending > beg) {
          strm.adler = crc32_1$1(strm.adler, s.pending_buf, s.pending - beg, beg);
        }
        //---//
      }
      s.status = HCRC_STATE;
    }
    if (s.status === HCRC_STATE) {
      if (s.gzhead.hcrc) {
        if (s.pending + 2 > s.pending_buf_size) {
          flush_pending(strm);
          if (s.pending !== 0) {
            s.last_flush = -1;
            return Z_OK$3;
          }
        }
        put_byte(s, strm.adler & 0xff);
        put_byte(s, (strm.adler >> 8) & 0xff);
        strm.adler = 0; //crc32(0L, Z_NULL, 0);
      }
      s.status = BUSY_STATE;

      /* Compression must start with an empty pending buffer */
      flush_pending(strm);
      if (s.pending !== 0) {
        s.last_flush = -1;
        return Z_OK$3;
      }
    }
  //#endif

    /* Start a new block or continue the current one.
     */
    if (strm.avail_in !== 0 || s.lookahead !== 0 ||
      (flush !== Z_NO_FLUSH$2 && s.status !== FINISH_STATE)) {
      let bstate = s.level === 0 ? deflate_stored(s, flush) :
                   s.strategy === Z_HUFFMAN_ONLY ? deflate_huff(s, flush) :
                   s.strategy === Z_RLE ? deflate_rle(s, flush) :
                   configuration_table[s.level].func(s, flush);

      if (bstate === BS_FINISH_STARTED || bstate === BS_FINISH_DONE) {
        s.status = FINISH_STATE;
      }
      if (bstate === BS_NEED_MORE || bstate === BS_FINISH_STARTED) {
        if (strm.avail_out === 0) {
          s.last_flush = -1;
          /* avoid BUF_ERROR next call, see above */
        }
        return Z_OK$3;
        /* If flush != Z_NO_FLUSH && avail_out == 0, the next call
         * of deflate should use the same flush parameter to make sure
         * that the flush is complete. So we don't have to output an
         * empty block here, this will be done at next call. This also
         * ensures that for a very small output buffer, we emit at most
         * one empty block.
         */
      }
      if (bstate === BS_BLOCK_DONE) {
        if (flush === Z_PARTIAL_FLUSH) {
          _tr_align(s);
        }
        else if (flush !== Z_BLOCK$1) { /* FULL_FLUSH or SYNC_FLUSH */

          _tr_stored_block(s, 0, 0, false);
          /* For a full flush, this empty block will be recognized
           * as a special marker by inflate_sync().
           */
          if (flush === Z_FULL_FLUSH$1) {
            /*** CLEAR_HASH(s); ***/             /* forget history */
            zero(s.head); // Fill with NIL (= 0);

            if (s.lookahead === 0) {
              s.strstart = 0;
              s.block_start = 0;
              s.insert = 0;
            }
          }
        }
        flush_pending(strm);
        if (strm.avail_out === 0) {
          s.last_flush = -1; /* avoid BUF_ERROR at next call, see above */
          return Z_OK$3;
        }
      }
    }

    if (flush !== Z_FINISH$3) { return Z_OK$3; }
    if (s.wrap <= 0) { return Z_STREAM_END$3; }

    /* Write the trailer */
    if (s.wrap === 2) {
      put_byte(s, strm.adler & 0xff);
      put_byte(s, (strm.adler >> 8) & 0xff);
      put_byte(s, (strm.adler >> 16) & 0xff);
      put_byte(s, (strm.adler >> 24) & 0xff);
      put_byte(s, strm.total_in & 0xff);
      put_byte(s, (strm.total_in >> 8) & 0xff);
      put_byte(s, (strm.total_in >> 16) & 0xff);
      put_byte(s, (strm.total_in >> 24) & 0xff);
    }
    else
    {
      putShortMSB(s, strm.adler >>> 16);
      putShortMSB(s, strm.adler & 0xffff);
    }

    flush_pending(strm);
    /* If avail_out is zero, the application will call deflate again
     * to flush the rest.
     */
    if (s.wrap > 0) { s.wrap = -s.wrap; }
    /* write the trailer only once! */
    return s.pending !== 0 ? Z_OK$3 : Z_STREAM_END$3;
  };


  const deflateEnd = (strm) => {

    if (deflateStateCheck(strm)) {
      return Z_STREAM_ERROR$2;
    }

    const status = strm.state.status;

    strm.state = null;

    return status === BUSY_STATE ? err(strm, Z_DATA_ERROR$2) : Z_OK$3;
  };


  /* =========================================================================
   * Initializes the compression dictionary from the given byte
   * sequence without producing any compressed output.
   */
  const deflateSetDictionary = (strm, dictionary) => {

    let dictLength = dictionary.length;

    if (deflateStateCheck(strm)) {
      return Z_STREAM_ERROR$2;
    }

    const s = strm.state;
    const wrap = s.wrap;

    if (wrap === 2 || (wrap === 1 && s.status !== INIT_STATE) || s.lookahead) {
      return Z_STREAM_ERROR$2;
    }

    /* when using zlib wrappers, compute Adler-32 for provided dictionary */
    if (wrap === 1) {
      /* adler32(strm->adler, dictionary, dictLength); */
      strm.adler = adler32_1$1(strm.adler, dictionary, dictLength, 0);
    }

    s.wrap = 0;   /* avoid computing Adler-32 in read_buf */

    /* if dictionary would fill window, just replace the history */
    if (dictLength >= s.w_size) {
      if (wrap === 0) {            /* already empty otherwise */
        /*** CLEAR_HASH(s); ***/
        zero(s.head); // Fill with NIL (= 0);
        s.strstart = 0;
        s.block_start = 0;
        s.insert = 0;
      }
      /* use the tail */
      // dictionary = dictionary.slice(dictLength - s.w_size);
      let tmpDict = new Uint8Array(s.w_size);
      tmpDict.set(dictionary.subarray(dictLength - s.w_size, dictLength), 0);
      dictionary = tmpDict;
      dictLength = s.w_size;
    }
    /* insert dictionary into window and hash */
    const avail = strm.avail_in;
    const next = strm.next_in;
    const input = strm.input;
    strm.avail_in = dictLength;
    strm.next_in = 0;
    strm.input = dictionary;
    fill_window(s);
    while (s.lookahead >= MIN_MATCH) {
      let str = s.strstart;
      let n = s.lookahead - (MIN_MATCH - 1);
      do {
        /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
        s.ins_h = HASH(s, s.ins_h, s.window[str + MIN_MATCH - 1]);

        s.prev[str & s.w_mask] = s.head[s.ins_h];

        s.head[s.ins_h] = str;
        str++;
      } while (--n);
      s.strstart = str;
      s.lookahead = MIN_MATCH - 1;
      fill_window(s);
    }
    s.strstart += s.lookahead;
    s.block_start = s.strstart;
    s.insert = s.lookahead;
    s.lookahead = 0;
    s.match_length = s.prev_length = MIN_MATCH - 1;
    s.match_available = 0;
    strm.next_in = next;
    strm.input = input;
    strm.avail_in = avail;
    s.wrap = wrap;
    return Z_OK$3;
  };


  var deflateInit_1 = deflateInit;
  var deflateInit2_1 = deflateInit2;
  var deflateReset_1 = deflateReset;
  var deflateResetKeep_1 = deflateResetKeep;
  var deflateSetHeader_1 = deflateSetHeader;
  var deflate_2$1 = deflate$2;
  var deflateEnd_1 = deflateEnd;
  var deflateSetDictionary_1 = deflateSetDictionary;
  var deflateInfo = 'pako deflate (from Nodeca project)';

  /* Not implemented
  module.exports.deflateBound = deflateBound;
  module.exports.deflateCopy = deflateCopy;
  module.exports.deflateGetDictionary = deflateGetDictionary;
  module.exports.deflateParams = deflateParams;
  module.exports.deflatePending = deflatePending;
  module.exports.deflatePrime = deflatePrime;
  module.exports.deflateTune = deflateTune;
  */

  var deflate_1$2 = {
  	deflateInit: deflateInit_1,
  	deflateInit2: deflateInit2_1,
  	deflateReset: deflateReset_1,
  	deflateResetKeep: deflateResetKeep_1,
  	deflateSetHeader: deflateSetHeader_1,
  	deflate: deflate_2$1,
  	deflateEnd: deflateEnd_1,
  	deflateSetDictionary: deflateSetDictionary_1,
  	deflateInfo: deflateInfo
  };

  const _has$1 = (obj, key) => {
    return Object.prototype.hasOwnProperty.call(obj, key);
  };

  var assign$1 = function (obj /*from1, from2, from3, ...*/) {
    const sources = Array.prototype.slice.call(arguments, 1);
    while (sources.length) {
      const source = sources.shift();
      if (!source) { continue; }

      if (typeof source !== 'object') {
        throw new TypeError(source + 'must be non-object');
      }

      for (const p in source) {
        if (_has$1(source, p)) {
          obj[p] = source[p];
        }
      }
    }

    return obj;
  };


  // Join array of chunks to single array.
  var flattenChunks$1 = (chunks) => {
    // calculate data length
    let len = 0;

    for (let i = 0, l = chunks.length; i < l; i++) {
      len += chunks[i].length;
    }

    // join chunks
    const result = new Uint8Array(len);

    for (let i = 0, pos = 0, l = chunks.length; i < l; i++) {
      let chunk = chunks[i];
      result.set(chunk, pos);
      pos += chunk.length;
    }

    return result;
  };

  var common$1 = {
  	assign: assign$1,
  	flattenChunks: flattenChunks$1
  };

  // String encode/decode helpers


  // Quick check if we can use fast array to bin string conversion
  //
  // - apply(Array) can fail on Android 2.2
  // - apply(Uint8Array) can fail on iOS 5.1 Safari
  //
  let STR_APPLY_UIA_OK$1 = true;

  try { String.fromCharCode.apply(null, new Uint8Array(1)); } catch (__) { STR_APPLY_UIA_OK$1 = false; }


  // Table with utf8 lengths (calculated by first byte of sequence)
  // Note, that 5 & 6-byte values and some 4-byte values can not be represented in JS,
  // because max possible codepoint is 0x10ffff
  const _utf8len$1 = new Uint8Array(256);
  for (let q = 0; q < 256; q++) {
    _utf8len$1[q] = (q >= 252 ? 6 : q >= 248 ? 5 : q >= 240 ? 4 : q >= 224 ? 3 : q >= 192 ? 2 : 1);
  }
  _utf8len$1[254] = _utf8len$1[254] = 1; // Invalid sequence start


  // convert string to array (typed, when possible)
  var string2buf$1 = (str) => {
    if (typeof TextEncoder === 'function' && TextEncoder.prototype.encode) {
      return new TextEncoder().encode(str);
    }

    let buf, c, c2, m_pos, i, str_len = str.length, buf_len = 0;

    // count binary size
    for (m_pos = 0; m_pos < str_len; m_pos++) {
      c = str.charCodeAt(m_pos);
      if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
        c2 = str.charCodeAt(m_pos + 1);
        if ((c2 & 0xfc00) === 0xdc00) {
          c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
          m_pos++;
        }
      }
      buf_len += c < 0x80 ? 1 : c < 0x800 ? 2 : c < 0x10000 ? 3 : 4;
    }

    // allocate buffer
    buf = new Uint8Array(buf_len);

    // convert
    for (i = 0, m_pos = 0; i < buf_len; m_pos++) {
      c = str.charCodeAt(m_pos);
      if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
        c2 = str.charCodeAt(m_pos + 1);
        if ((c2 & 0xfc00) === 0xdc00) {
          c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
          m_pos++;
        }
      }
      if (c < 0x80) {
        /* one byte */
        buf[i++] = c;
      } else if (c < 0x800) {
        /* two bytes */
        buf[i++] = 0xC0 | (c >>> 6);
        buf[i++] = 0x80 | (c & 0x3f);
      } else if (c < 0x10000) {
        /* three bytes */
        buf[i++] = 0xE0 | (c >>> 12);
        buf[i++] = 0x80 | (c >>> 6 & 0x3f);
        buf[i++] = 0x80 | (c & 0x3f);
      } else {
        /* four bytes */
        buf[i++] = 0xf0 | (c >>> 18);
        buf[i++] = 0x80 | (c >>> 12 & 0x3f);
        buf[i++] = 0x80 | (c >>> 6 & 0x3f);
        buf[i++] = 0x80 | (c & 0x3f);
      }
    }

    return buf;
  };

  // Helper
  const buf2binstring$1 = (buf, len) => {
    // On Chrome, the arguments in a function call that are allowed is `65534`.
    // If the length of the buffer is smaller than that, we can use this optimization,
    // otherwise we will take a slower path.
    if (len < 65534) {
      if (buf.subarray && STR_APPLY_UIA_OK$1) {
        return String.fromCharCode.apply(null, buf.length === len ? buf : buf.subarray(0, len));
      }
    }

    let result = '';
    for (let i = 0; i < len; i++) {
      result += String.fromCharCode(buf[i]);
    }
    return result;
  };


  // convert array to string
  var buf2string$1 = (buf, max) => {
    const len = max || buf.length;

    if (typeof TextDecoder === 'function' && TextDecoder.prototype.decode) {
      return new TextDecoder().decode(buf.subarray(0, max));
    }

    let i, out;

    // Reserve max possible length (2 words per char)
    // NB: by unknown reasons, Array is significantly faster for
    //     String.fromCharCode.apply than Uint16Array.
    const utf16buf = new Array(len * 2);

    for (out = 0, i = 0; i < len;) {
      let c = buf[i++];
      // quick process ascii
      if (c < 0x80) { utf16buf[out++] = c; continue; }

      let c_len = _utf8len$1[c];
      // skip 5 & 6 byte codes
      if (c_len > 4) { utf16buf[out++] = 0xfffd; i += c_len - 1; continue; }

      // apply mask on first byte
      c &= c_len === 2 ? 0x1f : c_len === 3 ? 0x0f : 0x07;
      // join the rest
      while (c_len > 1 && i < len) {
        c = (c << 6) | (buf[i++] & 0x3f);
        c_len--;
      }

      // terminated by end of string?
      if (c_len > 1) { utf16buf[out++] = 0xfffd; continue; }

      if (c < 0x10000) {
        utf16buf[out++] = c;
      } else {
        c -= 0x10000;
        utf16buf[out++] = 0xd800 | ((c >> 10) & 0x3ff);
        utf16buf[out++] = 0xdc00 | (c & 0x3ff);
      }
    }

    return buf2binstring$1(utf16buf, out);
  };


  // Calculate max possible position in utf8 buffer,
  // that will not break sequence. If that's not possible
  // - (very small limits) return max size as is.
  //
  // buf[] - utf8 bytes array
  // max   - length limit (mandatory);
  var utf8border$1 = (buf, max) => {

    max = max || buf.length;
    if (max > buf.length) { max = buf.length; }

    // go back from last position, until start of sequence found
    let pos = max - 1;
    while (pos >= 0 && (buf[pos] & 0xC0) === 0x80) { pos--; }

    // Very small and broken sequence,
    // return max, because we should return something anyway.
    if (pos < 0) { return max; }

    // If we came to start of buffer - that means buffer is too small,
    // return max too.
    if (pos === 0) { return max; }

    return (pos + _utf8len$1[buf[pos]] > max) ? pos : max;
  };

  var strings$1 = {
  	string2buf: string2buf$1,
  	buf2string: buf2string$1,
  	utf8border: utf8border$1
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  function ZStream$1() {
    /* next input byte */
    this.input = null; // JS specific, because we have no pointers
    this.next_in = 0;
    /* number of bytes available at input */
    this.avail_in = 0;
    /* total number of input bytes read so far */
    this.total_in = 0;
    /* next output byte should be put there */
    this.output = null; // JS specific, because we have no pointers
    this.next_out = 0;
    /* remaining free space at output */
    this.avail_out = 0;
    /* total number of bytes output so far */
    this.total_out = 0;
    /* last error message, NULL if no error */
    this.msg = ''/*Z_NULL*/;
    /* not visible by applications */
    this.state = null;
    /* best guess about the data type: binary or text */
    this.data_type = 2/*Z_UNKNOWN*/;
    /* adler32 value of the uncompressed data */
    this.adler = 0;
  }

  var zstream$1 = ZStream$1;

  const toString$1 = Object.prototype.toString;

  /* Public constants ==========================================================*/
  /* ===========================================================================*/

  const {
    Z_NO_FLUSH: Z_NO_FLUSH$1, Z_SYNC_FLUSH, Z_FULL_FLUSH, Z_FINISH: Z_FINISH$2,
    Z_OK: Z_OK$2, Z_STREAM_END: Z_STREAM_END$2,
    Z_DEFAULT_COMPRESSION,
    Z_DEFAULT_STRATEGY,
    Z_DEFLATED: Z_DEFLATED$1
  } = constants$2$1;

  /* ===========================================================================*/


  /**
   * class Deflate
   *
   * Generic JS-style wrapper for zlib calls. If you don't need
   * streaming behaviour - use more simple functions: [[deflate]],
   * [[deflateRaw]] and [[gzip]].
   **/

  /* internal
   * Deflate.chunks -> Array
   *
   * Chunks of output data, if [[Deflate#onData]] not overridden.
   **/

  /**
   * Deflate.result -> Uint8Array
   *
   * Compressed result, generated by default [[Deflate#onData]]
   * and [[Deflate#onEnd]] handlers. Filled after you push last chunk
   * (call [[Deflate#push]] with `Z_FINISH` / `true` param).
   **/

  /**
   * Deflate.err -> Number
   *
   * Error code after deflate finished. 0 (Z_OK) on success.
   * You will not need it in real life, because deflate errors
   * are possible only on wrong options or bad `onData` / `onEnd`
   * custom handlers.
   **/

  /**
   * Deflate.msg -> String
   *
   * Error message, if [[Deflate.err]] != 0
   **/


  /**
   * new Deflate(options)
   * - options (Object): zlib deflate options.
   *
   * Creates new deflator instance with specified params. Throws exception
   * on bad params. Supported options:
   *
   * - `level`
   * - `windowBits`
   * - `memLevel`
   * - `strategy`
   * - `dictionary`
   *
   * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
   * for more information on these.
   *
   * Additional options, for internal needs:
   *
   * - `chunkSize` - size of generated data chunks (16K by default)
   * - `raw` (Boolean) - do raw deflate
   * - `gzip` (Boolean) - create gzip wrapper
   * - `header` (Object) - custom header for gzip
   *   - `text` (Boolean) - true if compressed data believed to be text
   *   - `time` (Number) - modification time, unix timestamp
   *   - `os` (Number) - operation system code
   *   - `extra` (Array) - array of bytes with extra data (max 65536)
   *   - `name` (String) - file name (binary string)
   *   - `comment` (String) - comment (binary string)
   *   - `hcrc` (Boolean) - true if header crc should be added
   *
   * ##### Example:
   *
   * ```javascript
   * const pako = require('pako')
   *   , chunk1 = new Uint8Array([1,2,3,4,5,6,7,8,9])
   *   , chunk2 = new Uint8Array([10,11,12,13,14,15,16,17,18,19]);
   *
   * const deflate = new pako.Deflate({ level: 3});
   *
   * deflate.push(chunk1, false);
   * deflate.push(chunk2, true);  // true -> last chunk
   *
   * if (deflate.err) { throw new Error(deflate.err); }
   *
   * console.log(deflate.result);
   * ```
   **/
  function Deflate$1(options) {
    this.options = common$1.assign({
      level: Z_DEFAULT_COMPRESSION,
      method: Z_DEFLATED$1,
      chunkSize: 16384,
      windowBits: 15,
      memLevel: 8,
      strategy: Z_DEFAULT_STRATEGY
    }, options || {});

    let opt = this.options;

    if (opt.raw && (opt.windowBits > 0)) {
      opt.windowBits = -opt.windowBits;
    }

    else if (opt.gzip && (opt.windowBits > 0) && (opt.windowBits < 16)) {
      opt.windowBits += 16;
    }

    this.err    = 0;      // error code, if happens (0 = Z_OK)
    this.msg    = '';     // error message
    this.ended  = false;  // used to avoid multiple onEnd() calls
    this.chunks = [];     // chunks of compressed data

    this.strm = new zstream$1();
    this.strm.avail_out = 0;

    let status = deflate_1$2.deflateInit2(
      this.strm,
      opt.level,
      opt.method,
      opt.windowBits,
      opt.memLevel,
      opt.strategy
    );

    if (status !== Z_OK$2) {
      throw new Error(messages$1[status]);
    }

    if (opt.header) {
      deflate_1$2.deflateSetHeader(this.strm, opt.header);
    }

    if (opt.dictionary) {
      let dict;
      // Convert data if needed
      if (typeof opt.dictionary === 'string') {
        // If we need to compress text, change encoding to utf8.
        dict = strings$1.string2buf(opt.dictionary);
      } else if (toString$1.call(opt.dictionary) === '[object ArrayBuffer]') {
        dict = new Uint8Array(opt.dictionary);
      } else {
        dict = opt.dictionary;
      }

      status = deflate_1$2.deflateSetDictionary(this.strm, dict);

      if (status !== Z_OK$2) {
        throw new Error(messages$1[status]);
      }

      this._dict_set = true;
    }
  }

  /**
   * Deflate#push(data[, flush_mode]) -> Boolean
   * - data (Uint8Array|ArrayBuffer|String): input data. Strings will be
   *   converted to utf8 byte sequence.
   * - flush_mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE modes.
   *   See constants. Skipped or `false` means Z_NO_FLUSH, `true` means Z_FINISH.
   *
   * Sends input data to deflate pipe, generating [[Deflate#onData]] calls with
   * new compressed chunks. Returns `true` on success. The last data block must
   * have `flush_mode` Z_FINISH (or `true`). That will flush internal pending
   * buffers and call [[Deflate#onEnd]].
   *
   * On fail call [[Deflate#onEnd]] with error code and return false.
   *
   * ##### Example
   *
   * ```javascript
   * push(chunk, false); // push one of data chunks
   * ...
   * push(chunk, true);  // push last chunk
   * ```
   **/
  Deflate$1.prototype.push = function (data, flush_mode) {
    const strm = this.strm;
    const chunkSize = this.options.chunkSize;
    let status, _flush_mode;

    if (this.ended) { return false; }

    if (flush_mode === ~~flush_mode) _flush_mode = flush_mode;
    else _flush_mode = flush_mode === true ? Z_FINISH$2 : Z_NO_FLUSH$1;

    // Convert data if needed
    if (typeof data === 'string') {
      // If we need to compress text, change encoding to utf8.
      strm.input = strings$1.string2buf(data);
    } else if (toString$1.call(data) === '[object ArrayBuffer]') {
      strm.input = new Uint8Array(data);
    } else {
      strm.input = data;
    }

    strm.next_in = 0;
    strm.avail_in = strm.input.length;

    for (;;) {
      if (strm.avail_out === 0) {
        strm.output = new Uint8Array(chunkSize);
        strm.next_out = 0;
        strm.avail_out = chunkSize;
      }

      // Make sure avail_out > 6 to avoid repeating markers
      if ((_flush_mode === Z_SYNC_FLUSH || _flush_mode === Z_FULL_FLUSH) && strm.avail_out <= 6) {
        this.onData(strm.output.subarray(0, strm.next_out));
        strm.avail_out = 0;
        continue;
      }

      status = deflate_1$2.deflate(strm, _flush_mode);

      // Ended => flush and finish
      if (status === Z_STREAM_END$2) {
        if (strm.next_out > 0) {
          this.onData(strm.output.subarray(0, strm.next_out));
        }
        status = deflate_1$2.deflateEnd(this.strm);
        this.onEnd(status);
        this.ended = true;
        return status === Z_OK$2;
      }

      // Flush if out buffer full
      if (strm.avail_out === 0) {
        this.onData(strm.output);
        continue;
      }

      // Flush if requested and has data
      if (_flush_mode > 0 && strm.next_out > 0) {
        this.onData(strm.output.subarray(0, strm.next_out));
        strm.avail_out = 0;
        continue;
      }

      if (strm.avail_in === 0) break;
    }

    return true;
  };


  /**
   * Deflate#onData(chunk) -> Void
   * - chunk (Uint8Array): output data.
   *
   * By default, stores data blocks in `chunks[]` property and glue
   * those in `onEnd`. Override this handler, if you need another behaviour.
   **/
  Deflate$1.prototype.onData = function (chunk) {
    this.chunks.push(chunk);
  };


  /**
   * Deflate#onEnd(status) -> Void
   * - status (Number): deflate status. 0 (Z_OK) on success,
   *   other if not.
   *
   * Called once after you tell deflate that the input stream is
   * complete (Z_FINISH). By default - join collected chunks,
   * free memory and fill `results` / `err` properties.
   **/
  Deflate$1.prototype.onEnd = function (status) {
    // On success - join
    if (status === Z_OK$2) {
      this.result = common$1.flattenChunks(this.chunks);
    }
    this.chunks = [];
    this.err = status;
    this.msg = this.strm.msg;
  };


  /**
   * deflate(data[, options]) -> Uint8Array
   * - data (Uint8Array|ArrayBuffer|String): input data to compress.
   * - options (Object): zlib deflate options.
   *
   * Compress `data` with deflate algorithm and `options`.
   *
   * Supported options are:
   *
   * - level
   * - windowBits
   * - memLevel
   * - strategy
   * - dictionary
   *
   * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
   * for more information on these.
   *
   * Sugar (options):
   *
   * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
   *   negative windowBits implicitly.
   *
   * ##### Example:
   *
   * ```javascript
   * const pako = require('pako')
   * const data = new Uint8Array([1,2,3,4,5,6,7,8,9]);
   *
   * console.log(pako.deflate(data));
   * ```
   **/
  function deflate$1(input, options) {
    const deflator = new Deflate$1(options);

    deflator.push(input, true);

    // That will never happens, if you don't cheat with options :)
    if (deflator.err) { throw deflator.msg || messages$1[deflator.err]; }

    return deflator.result;
  }


  /**
   * deflateRaw(data[, options]) -> Uint8Array
   * - data (Uint8Array|ArrayBuffer|String): input data to compress.
   * - options (Object): zlib deflate options.
   *
   * The same as [[deflate]], but creates raw data, without wrapper
   * (header and adler32 crc).
   **/
  function deflateRaw$1(input, options) {
    options = options || {};
    options.raw = true;
    return deflate$1(input, options);
  }


  /**
   * gzip(data[, options]) -> Uint8Array
   * - data (Uint8Array|ArrayBuffer|String): input data to compress.
   * - options (Object): zlib deflate options.
   *
   * The same as [[deflate]], but create gzip wrapper instead of
   * deflate one.
   **/
  function gzip$1(input, options) {
    options = options || {};
    options.gzip = true;
    return deflate$1(input, options);
  }


  var Deflate_1$1 = Deflate$1;
  var deflate_2 = deflate$1;
  var deflateRaw_1$1 = deflateRaw$1;
  var gzip_1$1 = gzip$1;
  var constants$1 = constants$2$1;

  var deflate_1$1 = {
  	Deflate: Deflate_1$1,
  	deflate: deflate_2,
  	deflateRaw: deflateRaw_1$1,
  	gzip: gzip_1$1,
  	constants: constants$1
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  // See state defs from inflate.js
  const BAD$1$1 = 16209;       /* got a data error -- remain here until reset */
  const TYPE$1$1 = 16191;      /* i: waiting for type bits, including last-flag bit */

  /*
     Decode literal, length, and distance codes and write out the resulting
     literal and match bytes until either not enough input or output is
     available, an end-of-block is encountered, or a data error is encountered.
     When large enough input and output buffers are supplied to inflate(), for
     example, a 16K input buffer and a 64K output buffer, more than 95% of the
     inflate execution time is spent in this routine.

     Entry assumptions:

          state.mode === LEN
          strm.avail_in >= 6
          strm.avail_out >= 258
          start >= strm.avail_out
          state.bits < 8

     On return, state.mode is one of:

          LEN -- ran out of enough output space or enough available input
          TYPE -- reached end of block code, inflate() to interpret next block
          BAD -- error in block data

     Notes:

      - The maximum input bits used by a length/distance pair is 15 bits for the
        length code, 5 bits for the length extra, 15 bits for the distance code,
        and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
        Therefore if strm.avail_in >= 6, then there is enough input to avoid
        checking for available input while decoding.

      - The maximum bytes that a single length/distance pair can output is 258
        bytes, which is the maximum length that can be coded.  inflate_fast()
        requires strm.avail_out >= 258 for each loop to avoid checking for
        output space.
   */
  var inffast$1 = function inflate_fast(strm, start) {
    let _in;                    /* local strm.input */
    let last;                   /* have enough input while in < last */
    let _out;                   /* local strm.output */
    let beg;                    /* inflate()'s initial strm.output */
    let end;                    /* while out < end, enough space available */
  //#ifdef INFLATE_STRICT
    let dmax;                   /* maximum distance from zlib header */
  //#endif
    let wsize;                  /* window size or zero if not using window */
    let whave;                  /* valid bytes in the window */
    let wnext;                  /* window write index */
    // Use `s_window` instead `window`, avoid conflict with instrumentation tools
    let s_window;               /* allocated sliding window, if wsize != 0 */
    let hold;                   /* local strm.hold */
    let bits;                   /* local strm.bits */
    let lcode;                  /* local strm.lencode */
    let dcode;                  /* local strm.distcode */
    let lmask;                  /* mask for first level of length codes */
    let dmask;                  /* mask for first level of distance codes */
    let here;                   /* retrieved table entry */
    let op;                     /* code bits, operation, extra bits, or */
                                /*  window position, window bytes to copy */
    let len;                    /* match length, unused bytes */
    let dist;                   /* match distance */
    let from;                   /* where to copy match from */
    let from_source;


    let input, output; // JS specific, because we have no pointers

    /* copy state to local variables */
    const state = strm.state;
    //here = state.here;
    _in = strm.next_in;
    input = strm.input;
    last = _in + (strm.avail_in - 5);
    _out = strm.next_out;
    output = strm.output;
    beg = _out - (start - strm.avail_out);
    end = _out + (strm.avail_out - 257);
  //#ifdef INFLATE_STRICT
    dmax = state.dmax;
  //#endif
    wsize = state.wsize;
    whave = state.whave;
    wnext = state.wnext;
    s_window = state.window;
    hold = state.hold;
    bits = state.bits;
    lcode = state.lencode;
    dcode = state.distcode;
    lmask = (1 << state.lenbits) - 1;
    dmask = (1 << state.distbits) - 1;


    /* decode literals and length/distances until end-of-block or not enough
       input data or output space */

    top:
    do {
      if (bits < 15) {
        hold += input[_in++] << bits;
        bits += 8;
        hold += input[_in++] << bits;
        bits += 8;
      }

      here = lcode[hold & lmask];

      dolen:
      for (;;) { // Goto emulation
        op = here >>> 24/*here.bits*/;
        hold >>>= op;
        bits -= op;
        op = (here >>> 16) & 0xff/*here.op*/;
        if (op === 0) {                          /* literal */
          //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
          //        "inflate:         literal '%c'\n" :
          //        "inflate:         literal 0x%02x\n", here.val));
          output[_out++] = here & 0xffff/*here.val*/;
        }
        else if (op & 16) {                     /* length base */
          len = here & 0xffff/*here.val*/;
          op &= 15;                           /* number of extra bits */
          if (op) {
            if (bits < op) {
              hold += input[_in++] << bits;
              bits += 8;
            }
            len += hold & ((1 << op) - 1);
            hold >>>= op;
            bits -= op;
          }
          //Tracevv((stderr, "inflate:         length %u\n", len));
          if (bits < 15) {
            hold += input[_in++] << bits;
            bits += 8;
            hold += input[_in++] << bits;
            bits += 8;
          }
          here = dcode[hold & dmask];

          dodist:
          for (;;) { // goto emulation
            op = here >>> 24/*here.bits*/;
            hold >>>= op;
            bits -= op;
            op = (here >>> 16) & 0xff/*here.op*/;

            if (op & 16) {                      /* distance base */
              dist = here & 0xffff/*here.val*/;
              op &= 15;                       /* number of extra bits */
              if (bits < op) {
                hold += input[_in++] << bits;
                bits += 8;
                if (bits < op) {
                  hold += input[_in++] << bits;
                  bits += 8;
                }
              }
              dist += hold & ((1 << op) - 1);
  //#ifdef INFLATE_STRICT
              if (dist > dmax) {
                strm.msg = 'invalid distance too far back';
                state.mode = BAD$1$1;
                break top;
              }
  //#endif
              hold >>>= op;
              bits -= op;
              //Tracevv((stderr, "inflate:         distance %u\n", dist));
              op = _out - beg;                /* max distance in output */
              if (dist > op) {                /* see if copy from window */
                op = dist - op;               /* distance back in window */
                if (op > whave) {
                  if (state.sane) {
                    strm.msg = 'invalid distance too far back';
                    state.mode = BAD$1$1;
                    break top;
                  }

  // (!) This block is disabled in zlib defaults,
  // don't enable it for binary compatibility
  //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
  //                if (len <= op - whave) {
  //                  do {
  //                    output[_out++] = 0;
  //                  } while (--len);
  //                  continue top;
  //                }
  //                len -= op - whave;
  //                do {
  //                  output[_out++] = 0;
  //                } while (--op > whave);
  //                if (op === 0) {
  //                  from = _out - dist;
  //                  do {
  //                    output[_out++] = output[from++];
  //                  } while (--len);
  //                  continue top;
  //                }
  //#endif
                }
                from = 0; // window index
                from_source = s_window;
                if (wnext === 0) {           /* very common case */
                  from += wsize - op;
                  if (op < len) {         /* some from window */
                    len -= op;
                    do {
                      output[_out++] = s_window[from++];
                    } while (--op);
                    from = _out - dist;  /* rest from output */
                    from_source = output;
                  }
                }
                else if (wnext < op) {      /* wrap around window */
                  from += wsize + wnext - op;
                  op -= wnext;
                  if (op < len) {         /* some from end of window */
                    len -= op;
                    do {
                      output[_out++] = s_window[from++];
                    } while (--op);
                    from = 0;
                    if (wnext < len) {  /* some from start of window */
                      op = wnext;
                      len -= op;
                      do {
                        output[_out++] = s_window[from++];
                      } while (--op);
                      from = _out - dist;      /* rest from output */
                      from_source = output;
                    }
                  }
                }
                else {                      /* contiguous in window */
                  from += wnext - op;
                  if (op < len) {         /* some from window */
                    len -= op;
                    do {
                      output[_out++] = s_window[from++];
                    } while (--op);
                    from = _out - dist;  /* rest from output */
                    from_source = output;
                  }
                }
                while (len > 2) {
                  output[_out++] = from_source[from++];
                  output[_out++] = from_source[from++];
                  output[_out++] = from_source[from++];
                  len -= 3;
                }
                if (len) {
                  output[_out++] = from_source[from++];
                  if (len > 1) {
                    output[_out++] = from_source[from++];
                  }
                }
              }
              else {
                from = _out - dist;          /* copy direct from output */
                do {                        /* minimum length is three */
                  output[_out++] = output[from++];
                  output[_out++] = output[from++];
                  output[_out++] = output[from++];
                  len -= 3;
                } while (len > 2);
                if (len) {
                  output[_out++] = output[from++];
                  if (len > 1) {
                    output[_out++] = output[from++];
                  }
                }
              }
            }
            else if ((op & 64) === 0) {          /* 2nd level distance code */
              here = dcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
              continue dodist;
            }
            else {
              strm.msg = 'invalid distance code';
              state.mode = BAD$1$1;
              break top;
            }

            break; // need to emulate goto via "continue"
          }
        }
        else if ((op & 64) === 0) {              /* 2nd level length code */
          here = lcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
          continue dolen;
        }
        else if (op & 32) {                     /* end-of-block */
          //Tracevv((stderr, "inflate:         end of block\n"));
          state.mode = TYPE$1$1;
          break top;
        }
        else {
          strm.msg = 'invalid literal/length code';
          state.mode = BAD$1$1;
          break top;
        }

        break; // need to emulate goto via "continue"
      }
    } while (_in < last && _out < end);

    /* return unused bytes (on entry, bits < 8, so in won't go too far back) */
    len = bits >> 3;
    _in -= len;
    bits -= len << 3;
    hold &= (1 << bits) - 1;

    /* update state and return */
    strm.next_in = _in;
    strm.next_out = _out;
    strm.avail_in = (_in < last ? 5 + (last - _in) : 5 - (_in - last));
    strm.avail_out = (_out < end ? 257 + (end - _out) : 257 - (_out - end));
    state.hold = hold;
    state.bits = bits;
    return;
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  const MAXBITS$1 = 15;
  const ENOUGH_LENS$1$1 = 852;
  const ENOUGH_DISTS$1$1 = 592;
  //const ENOUGH = (ENOUGH_LENS+ENOUGH_DISTS);

  const CODES$1$1 = 0;
  const LENS$1$1 = 1;
  const DISTS$1$1 = 2;

  const lbase$1 = new Uint16Array([ /* Length codes 257..285 base */
    3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
    35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0
  ]);

  const lext$1 = new Uint8Array([ /* Length codes 257..285 extra */
    16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
    19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78
  ]);

  const dbase$1 = new Uint16Array([ /* Distance codes 0..29 base */
    1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
    257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
    8193, 12289, 16385, 24577, 0, 0
  ]);

  const dext$1 = new Uint8Array([ /* Distance codes 0..29 extra */
    16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
    23, 23, 24, 24, 25, 25, 26, 26, 27, 27,
    28, 28, 29, 29, 64, 64
  ]);

  const inflate_table$1 = (type, lens, lens_index, codes, table, table_index, work, opts) =>
  {
    const bits = opts.bits;
        //here = opts.here; /* table entry for duplication */

    let len = 0;               /* a code's length in bits */
    let sym = 0;               /* index of code symbols */
    let min = 0, max = 0;          /* minimum and maximum code lengths */
    let root = 0;              /* number of index bits for root table */
    let curr = 0;              /* number of index bits for current table */
    let drop = 0;              /* code bits to drop for sub-table */
    let left = 0;                   /* number of prefix codes available */
    let used = 0;              /* code entries in table used */
    let huff = 0;              /* Huffman code */
    let incr;              /* for incrementing code, index */
    let fill;              /* index for replicating entries */
    let low;               /* low bits for current root entry */
    let mask;              /* mask for low root bits */
    let next;             /* next available space in table */
    let base = null;     /* base value table to use */
  //  let shoextra;    /* extra bits table to use */
    let match;                  /* use base and extra for symbol >= match */
    const count = new Uint16Array(MAXBITS$1 + 1); //[MAXBITS+1];    /* number of codes of each length */
    const offs = new Uint16Array(MAXBITS$1 + 1); //[MAXBITS+1];     /* offsets in table for each length */
    let extra = null;

    let here_bits, here_op, here_val;

    /*
     Process a set of code lengths to create a canonical Huffman code.  The
     code lengths are lens[0..codes-1].  Each length corresponds to the
     symbols 0..codes-1.  The Huffman code is generated by first sorting the
     symbols by length from short to long, and retaining the symbol order
     for codes with equal lengths.  Then the code starts with all zero bits
     for the first code of the shortest length, and the codes are integer
     increments for the same length, and zeros are appended as the length
     increases.  For the deflate format, these bits are stored backwards
     from their more natural integer increment ordering, and so when the
     decoding tables are built in the large loop below, the integer codes
     are incremented backwards.

     This routine assumes, but does not check, that all of the entries in
     lens[] are in the range 0..MAXBITS.  The caller must assure this.
     1..MAXBITS is interpreted as that code length.  zero means that that
     symbol does not occur in this code.

     The codes are sorted by computing a count of codes for each length,
     creating from that a table of starting indices for each length in the
     sorted table, and then entering the symbols in order in the sorted
     table.  The sorted table is work[], with that space being provided by
     the caller.

     The length counts are used for other purposes as well, i.e. finding
     the minimum and maximum length codes, determining if there are any
     codes at all, checking for a valid set of lengths, and looking ahead
     at length counts to determine sub-table sizes when building the
     decoding tables.
     */

    /* accumulate lengths for codes (assumes lens[] all in 0..MAXBITS) */
    for (len = 0; len <= MAXBITS$1; len++) {
      count[len] = 0;
    }
    for (sym = 0; sym < codes; sym++) {
      count[lens[lens_index + sym]]++;
    }

    /* bound code lengths, force root to be within code lengths */
    root = bits;
    for (max = MAXBITS$1; max >= 1; max--) {
      if (count[max] !== 0) { break; }
    }
    if (root > max) {
      root = max;
    }
    if (max === 0) {                     /* no symbols to code at all */
      //table.op[opts.table_index] = 64;  //here.op = (var char)64;    /* invalid code marker */
      //table.bits[opts.table_index] = 1;   //here.bits = (var char)1;
      //table.val[opts.table_index++] = 0;   //here.val = (var short)0;
      table[table_index++] = (1 << 24) | (64 << 16) | 0;


      //table.op[opts.table_index] = 64;
      //table.bits[opts.table_index] = 1;
      //table.val[opts.table_index++] = 0;
      table[table_index++] = (1 << 24) | (64 << 16) | 0;

      opts.bits = 1;
      return 0;     /* no symbols, but wait for decoding to report error */
    }
    for (min = 1; min < max; min++) {
      if (count[min] !== 0) { break; }
    }
    if (root < min) {
      root = min;
    }

    /* check for an over-subscribed or incomplete set of lengths */
    left = 1;
    for (len = 1; len <= MAXBITS$1; len++) {
      left <<= 1;
      left -= count[len];
      if (left < 0) {
        return -1;
      }        /* over-subscribed */
    }
    if (left > 0 && (type === CODES$1$1 || max !== 1)) {
      return -1;                      /* incomplete set */
    }

    /* generate offsets into symbol table for each length for sorting */
    offs[1] = 0;
    for (len = 1; len < MAXBITS$1; len++) {
      offs[len + 1] = offs[len] + count[len];
    }

    /* sort symbols by length, by symbol order within each length */
    for (sym = 0; sym < codes; sym++) {
      if (lens[lens_index + sym] !== 0) {
        work[offs[lens[lens_index + sym]]++] = sym;
      }
    }

    /*
     Create and fill in decoding tables.  In this loop, the table being
     filled is at next and has curr index bits.  The code being used is huff
     with length len.  That code is converted to an index by dropping drop
     bits off of the bottom.  For codes where len is less than drop + curr,
     those top drop + curr - len bits are incremented through all values to
     fill the table with replicated entries.

     root is the number of index bits for the root table.  When len exceeds
     root, sub-tables are created pointed to by the root entry with an index
     of the low root bits of huff.  This is saved in low to check for when a
     new sub-table should be started.  drop is zero when the root table is
     being filled, and drop is root when sub-tables are being filled.

     When a new sub-table is needed, it is necessary to look ahead in the
     code lengths to determine what size sub-table is needed.  The length
     counts are used for this, and so count[] is decremented as codes are
     entered in the tables.

     used keeps track of how many table entries have been allocated from the
     provided *table space.  It is checked for LENS and DIST tables against
     the constants ENOUGH_LENS and ENOUGH_DISTS to guard against changes in
     the initial root table size constants.  See the comments in inftrees.h
     for more information.

     sym increments through all symbols, and the loop terminates when
     all codes of length max, i.e. all codes, have been processed.  This
     routine permits incomplete codes, so another loop after this one fills
     in the rest of the decoding tables with invalid code markers.
     */

    /* set up for code type */
    // poor man optimization - use if-else instead of switch,
    // to avoid deopts in old v8
    if (type === CODES$1$1) {
      base = extra = work;    /* dummy value--not used */
      match = 20;

    } else if (type === LENS$1$1) {
      base = lbase$1;
      extra = lext$1;
      match = 257;

    } else {                    /* DISTS */
      base = dbase$1;
      extra = dext$1;
      match = 0;
    }

    /* initialize opts for loop */
    huff = 0;                   /* starting code */
    sym = 0;                    /* starting code symbol */
    len = min;                  /* starting code length */
    next = table_index;              /* current table to fill in */
    curr = root;                /* current table index bits */
    drop = 0;                   /* current bits to drop from code for index */
    low = -1;                   /* trigger new sub-table when len > root */
    used = 1 << root;          /* use root table entries */
    mask = used - 1;            /* mask for comparing low */

    /* check available table space */
    if ((type === LENS$1$1 && used > ENOUGH_LENS$1$1) ||
      (type === DISTS$1$1 && used > ENOUGH_DISTS$1$1)) {
      return 1;
    }

    /* process all codes and make table entries */
    for (;;) {
      /* create table entry */
      here_bits = len - drop;
      if (work[sym] + 1 < match) {
        here_op = 0;
        here_val = work[sym];
      }
      else if (work[sym] >= match) {
        here_op = extra[work[sym] - match];
        here_val = base[work[sym] - match];
      }
      else {
        here_op = 32 + 64;         /* end of block */
        here_val = 0;
      }

      /* replicate for those indices with low len bits equal to huff */
      incr = 1 << (len - drop);
      fill = 1 << curr;
      min = fill;                 /* save offset to next table */
      do {
        fill -= incr;
        table[next + (huff >> drop) + fill] = (here_bits << 24) | (here_op << 16) | here_val |0;
      } while (fill !== 0);

      /* backwards increment the len-bit code huff */
      incr = 1 << (len - 1);
      while (huff & incr) {
        incr >>= 1;
      }
      if (incr !== 0) {
        huff &= incr - 1;
        huff += incr;
      } else {
        huff = 0;
      }

      /* go to next symbol, update count, len */
      sym++;
      if (--count[len] === 0) {
        if (len === max) { break; }
        len = lens[lens_index + work[sym]];
      }

      /* create new sub-table if needed */
      if (len > root && (huff & mask) !== low) {
        /* if first time, transition to sub-tables */
        if (drop === 0) {
          drop = root;
        }

        /* increment past last table */
        next += min;            /* here min is 1 << curr */

        /* determine length of next table */
        curr = len - drop;
        left = 1 << curr;
        while (curr + drop < max) {
          left -= count[curr + drop];
          if (left <= 0) { break; }
          curr++;
          left <<= 1;
        }

        /* check for enough space */
        used += 1 << curr;
        if ((type === LENS$1$1 && used > ENOUGH_LENS$1$1) ||
          (type === DISTS$1$1 && used > ENOUGH_DISTS$1$1)) {
          return 1;
        }

        /* point entry in root table to sub-table */
        low = huff & mask;
        /*table.op[low] = curr;
        table.bits[low] = root;
        table.val[low] = next - opts.table_index;*/
        table[low] = (root << 24) | (curr << 16) | (next - table_index) |0;
      }
    }

    /* fill in remaining table entry if code is incomplete (guaranteed to have
     at most one remaining entry, since if the code is incomplete, the
     maximum code length that was allowed to get this far is one bit) */
    if (huff !== 0) {
      //table.op[next + huff] = 64;            /* invalid code marker */
      //table.bits[next + huff] = len - drop;
      //table.val[next + huff] = 0;
      table[next + huff] = ((len - drop) << 24) | (64 << 16) |0;
    }

    /* set return parameters */
    //opts.table_index += used;
    opts.bits = root;
    return 0;
  };


  var inftrees$1 = inflate_table$1;

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.






  const CODES$2 = 0;
  const LENS$2 = 1;
  const DISTS$2 = 2;

  /* Public constants ==========================================================*/
  /* ===========================================================================*/

  const {
    Z_FINISH: Z_FINISH$1$1, Z_BLOCK: Z_BLOCK$2, Z_TREES: Z_TREES$1,
    Z_OK: Z_OK$1$1, Z_STREAM_END: Z_STREAM_END$1$1, Z_NEED_DICT: Z_NEED_DICT$1$1, Z_STREAM_ERROR: Z_STREAM_ERROR$1$1, Z_DATA_ERROR: Z_DATA_ERROR$1$1, Z_MEM_ERROR: Z_MEM_ERROR$1$1, Z_BUF_ERROR: Z_BUF_ERROR$2,
    Z_DEFLATED: Z_DEFLATED$3
  } = constants$2$1;


  /* STATES ====================================================================*/
  /* ===========================================================================*/


  const    HEAD$1 = 16180;       /* i: waiting for magic header */
  const    FLAGS$1 = 16181;      /* i: waiting for method and flags (gzip) */
  const    TIME$1 = 16182;       /* i: waiting for modification time (gzip) */
  const    OS$1 = 16183;         /* i: waiting for extra flags and operating system (gzip) */
  const    EXLEN$1 = 16184;      /* i: waiting for extra length (gzip) */
  const    EXTRA$1 = 16185;      /* i: waiting for extra bytes (gzip) */
  const    NAME$1 = 16186;       /* i: waiting for end of file name (gzip) */
  const    COMMENT$1 = 16187;    /* i: waiting for end of comment (gzip) */
  const    HCRC$1 = 16188;       /* i: waiting for header crc (gzip) */
  const    DICTID$1 = 16189;    /* i: waiting for dictionary check value */
  const    DICT$1 = 16190;      /* waiting for inflateSetDictionary() call */
  const        TYPE$2 = 16191;      /* i: waiting for type bits, including last-flag bit */
  const        TYPEDO$1 = 16192;    /* i: same, but skip check to exit inflate on new block */
  const        STORED$1 = 16193;    /* i: waiting for stored size (length and complement) */
  const        COPY_$1 = 16194;     /* i/o: same as COPY below, but only first time in */
  const        COPY$1 = 16195;      /* i/o: waiting for input or output to copy stored block */
  const        TABLE$1 = 16196;     /* i: waiting for dynamic block table lengths */
  const        LENLENS$1 = 16197;   /* i: waiting for code length code lengths */
  const        CODELENS$1 = 16198;  /* i: waiting for length/lit and distance code lengths */
  const            LEN_$1 = 16199;      /* i: same as LEN below, but only first time in */
  const            LEN$1 = 16200;       /* i: waiting for length/lit/eob code */
  const            LENEXT$1 = 16201;    /* i: waiting for length extra bits */
  const            DIST$1 = 16202;      /* i: waiting for distance code */
  const            DISTEXT$1 = 16203;   /* i: waiting for distance extra bits */
  const            MATCH$1 = 16204;     /* o: waiting for output space to copy string */
  const            LIT$1 = 16205;       /* o: waiting for output space to write literal */
  const    CHECK$1 = 16206;     /* i: waiting for 32-bit check value */
  const    LENGTH$1 = 16207;    /* i: waiting for 32-bit length (gzip) */
  const    DONE$1 = 16208;      /* finished check, done -- remain here until reset */
  const    BAD$2 = 16209;       /* got a data error -- remain here until reset */
  const    MEM$1 = 16210;       /* got an inflate() memory error -- remain here until reset */
  const    SYNC$1 = 16211;      /* looking for synchronization bytes to restart inflate() */

  /* ===========================================================================*/



  const ENOUGH_LENS$2 = 852;
  const ENOUGH_DISTS$2 = 592;
  //const ENOUGH =  (ENOUGH_LENS+ENOUGH_DISTS);

  const MAX_WBITS$2 = 15;
  /* 32K LZ77 window */
  const DEF_WBITS$1 = MAX_WBITS$2;


  const zswap32$1 = (q) => {

    return  (((q >>> 24) & 0xff) +
            ((q >>> 8) & 0xff00) +
            ((q & 0xff00) << 8) +
            ((q & 0xff) << 24));
  };


  function InflateState$1() {
    this.strm = null;           /* pointer back to this zlib stream */
    this.mode = 0;              /* current inflate mode */
    this.last = false;          /* true if processing last block */
    this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip,
                                   bit 2 true to validate check value */
    this.havedict = false;      /* true if dictionary provided */
    this.flags = 0;             /* gzip header method and flags (0 if zlib), or
                                   -1 if raw or no header yet */
    this.dmax = 0;              /* zlib header max distance (INFLATE_STRICT) */
    this.check = 0;             /* protected copy of check value */
    this.total = 0;             /* protected copy of output count */
    // TODO: may be {}
    this.head = null;           /* where to save gzip header information */

    /* sliding window */
    this.wbits = 0;             /* log base 2 of requested window size */
    this.wsize = 0;             /* window size or zero if not using window */
    this.whave = 0;             /* valid bytes in the window */
    this.wnext = 0;             /* window write index */
    this.window = null;         /* allocated sliding window, if needed */

    /* bit accumulator */
    this.hold = 0;              /* input bit accumulator */
    this.bits = 0;              /* number of bits in "in" */

    /* for string and stored block copying */
    this.length = 0;            /* literal or length of data to copy */
    this.offset = 0;            /* distance back to copy string from */

    /* for table and code decoding */
    this.extra = 0;             /* extra bits needed */

    /* fixed and dynamic code tables */
    this.lencode = null;          /* starting table for length/literal codes */
    this.distcode = null;         /* starting table for distance codes */
    this.lenbits = 0;           /* index bits for lencode */
    this.distbits = 0;          /* index bits for distcode */

    /* dynamic table building */
    this.ncode = 0;             /* number of code length code lengths */
    this.nlen = 0;              /* number of length code lengths */
    this.ndist = 0;             /* number of distance code lengths */
    this.have = 0;              /* number of code lengths in lens[] */
    this.next = null;              /* next available space in codes[] */

    this.lens = new Uint16Array(320); /* temporary storage for code lengths */
    this.work = new Uint16Array(288); /* work area for code table building */

    /*
     because we don't have pointers in js, we use lencode and distcode directly
     as buffers so we don't need codes
    */
    //this.codes = new Int32Array(ENOUGH);       /* space for code tables */
    this.lendyn = null;              /* dynamic table for length/literal codes (JS specific) */
    this.distdyn = null;             /* dynamic table for distance codes (JS specific) */
    this.sane = 0;                   /* if false, allow invalid distance too far */
    this.back = 0;                   /* bits back of last unprocessed length/lit */
    this.was = 0;                    /* initial length of match */
  }


  const inflateStateCheck$1 = (strm) => {

    if (!strm) {
      return 1;
    }
    const state = strm.state;
    if (!state || state.strm !== strm ||
      state.mode < HEAD$1 || state.mode > SYNC$1) {
      return 1;
    }
    return 0;
  };


  const inflateResetKeep$1 = (strm) => {

    if (inflateStateCheck$1(strm)) { return Z_STREAM_ERROR$1$1; }
    const state = strm.state;
    strm.total_in = strm.total_out = state.total = 0;
    strm.msg = ''; /*Z_NULL*/
    if (state.wrap) {       /* to support ill-conceived Java test suite */
      strm.adler = state.wrap & 1;
    }
    state.mode = HEAD$1;
    state.last = 0;
    state.havedict = 0;
    state.flags = -1;
    state.dmax = 32768;
    state.head = null/*Z_NULL*/;
    state.hold = 0;
    state.bits = 0;
    //state.lencode = state.distcode = state.next = state.codes;
    state.lencode = state.lendyn = new Int32Array(ENOUGH_LENS$2);
    state.distcode = state.distdyn = new Int32Array(ENOUGH_DISTS$2);

    state.sane = 1;
    state.back = -1;
    //Tracev((stderr, "inflate: reset\n"));
    return Z_OK$1$1;
  };


  const inflateReset$1 = (strm) => {

    if (inflateStateCheck$1(strm)) { return Z_STREAM_ERROR$1$1; }
    const state = strm.state;
    state.wsize = 0;
    state.whave = 0;
    state.wnext = 0;
    return inflateResetKeep$1(strm);

  };


  const inflateReset2$1 = (strm, windowBits) => {
    let wrap;

    /* get the state */
    if (inflateStateCheck$1(strm)) { return Z_STREAM_ERROR$1$1; }
    const state = strm.state;

    /* extract wrap request from windowBits parameter */
    if (windowBits < 0) {
      wrap = 0;
      windowBits = -windowBits;
    }
    else {
      wrap = (windowBits >> 4) + 5;
      if (windowBits < 48) {
        windowBits &= 15;
      }
    }

    /* set number of window bits, free window if different */
    if (windowBits && (windowBits < 8 || windowBits > 15)) {
      return Z_STREAM_ERROR$1$1;
    }
    if (state.window !== null && state.wbits !== windowBits) {
      state.window = null;
    }

    /* update state and reset the rest of it */
    state.wrap = wrap;
    state.wbits = windowBits;
    return inflateReset$1(strm);
  };


  const inflateInit2$1 = (strm, windowBits) => {

    if (!strm) { return Z_STREAM_ERROR$1$1; }
    //strm.msg = Z_NULL;                 /* in case we return an error */

    const state = new InflateState$1();

    //if (state === Z_NULL) return Z_MEM_ERROR;
    //Tracev((stderr, "inflate: allocated\n"));
    strm.state = state;
    state.strm = strm;
    state.window = null/*Z_NULL*/;
    state.mode = HEAD$1;     /* to pass state test in inflateReset2() */
    const ret = inflateReset2$1(strm, windowBits);
    if (ret !== Z_OK$1$1) {
      strm.state = null/*Z_NULL*/;
    }
    return ret;
  };


  const inflateInit$1 = (strm) => {

    return inflateInit2$1(strm, DEF_WBITS$1);
  };


  /*
   Return state with length and distance decoding tables and index sizes set to
   fixed code decoding.  Normally this returns fixed tables from inffixed.h.
   If BUILDFIXED is defined, then instead this routine builds the tables the
   first time it's called, and returns those tables the first time and
   thereafter.  This reduces the size of the code by about 2K bytes, in
   exchange for a little execution time.  However, BUILDFIXED should not be
   used for threaded applications, since the rewriting of the tables and virgin
   may not be thread-safe.
   */
  let virgin$1 = true;

  let lenfix$1, distfix$1; // We have no pointers in JS, so keep tables separate


  const fixedtables$1 = (state) => {

    /* build fixed huffman tables if first call (may not be thread safe) */
    if (virgin$1) {
      lenfix$1 = new Int32Array(512);
      distfix$1 = new Int32Array(32);

      /* literal/length table */
      let sym = 0;
      while (sym < 144) { state.lens[sym++] = 8; }
      while (sym < 256) { state.lens[sym++] = 9; }
      while (sym < 280) { state.lens[sym++] = 7; }
      while (sym < 288) { state.lens[sym++] = 8; }

      inftrees$1(LENS$2,  state.lens, 0, 288, lenfix$1,   0, state.work, { bits: 9 });

      /* distance table */
      sym = 0;
      while (sym < 32) { state.lens[sym++] = 5; }

      inftrees$1(DISTS$2, state.lens, 0, 32,   distfix$1, 0, state.work, { bits: 5 });

      /* do this just once */
      virgin$1 = false;
    }

    state.lencode = lenfix$1;
    state.lenbits = 9;
    state.distcode = distfix$1;
    state.distbits = 5;
  };


  /*
   Update the window with the last wsize (normally 32K) bytes written before
   returning.  If window does not exist yet, create it.  This is only called
   when a window is already in use, or when output has been written during this
   inflate call, but the end of the deflate stream has not been reached yet.
   It is also called to create a window for dictionary data when a dictionary
   is loaded.

   Providing output buffers larger than 32K to inflate() should provide a speed
   advantage, since only the last 32K of output is copied to the sliding window
   upon return from inflate(), and since all distances after the first 32K of
   output will fall in the output data, making match copies simpler and faster.
   The advantage may be dependent on the size of the processor's data caches.
   */
  const updatewindow$1 = (strm, src, end, copy) => {

    let dist;
    const state = strm.state;

    /* if it hasn't been done already, allocate space for the window */
    if (state.window === null) {
      state.wsize = 1 << state.wbits;
      state.wnext = 0;
      state.whave = 0;

      state.window = new Uint8Array(state.wsize);
    }

    /* copy state->wsize or less output bytes into the circular window */
    if (copy >= state.wsize) {
      state.window.set(src.subarray(end - state.wsize, end), 0);
      state.wnext = 0;
      state.whave = state.wsize;
    }
    else {
      dist = state.wsize - state.wnext;
      if (dist > copy) {
        dist = copy;
      }
      //zmemcpy(state->window + state->wnext, end - copy, dist);
      state.window.set(src.subarray(end - copy, end - copy + dist), state.wnext);
      copy -= dist;
      if (copy) {
        //zmemcpy(state->window, end - copy, copy);
        state.window.set(src.subarray(end - copy, end), 0);
        state.wnext = copy;
        state.whave = state.wsize;
      }
      else {
        state.wnext += dist;
        if (state.wnext === state.wsize) { state.wnext = 0; }
        if (state.whave < state.wsize) { state.whave += dist; }
      }
    }
    return 0;
  };


  const inflate$2$1 = (strm, flush) => {

    let state;
    let input, output;          // input/output buffers
    let next;                   /* next input INDEX */
    let put;                    /* next output INDEX */
    let have, left;             /* available input and output */
    let hold;                   /* bit buffer */
    let bits;                   /* bits in bit buffer */
    let _in, _out;              /* save starting available input and output */
    let copy;                   /* number of stored or match bytes to copy */
    let from;                   /* where to copy match bytes from */
    let from_source;
    let here = 0;               /* current decoding table entry */
    let here_bits, here_op, here_val; // paked "here" denormalized (JS specific)
    //let last;                   /* parent table entry */
    let last_bits, last_op, last_val; // paked "last" denormalized (JS specific)
    let len;                    /* length to copy for repeats, bits to drop */
    let ret;                    /* return code */
    const hbuf = new Uint8Array(4);    /* buffer for gzip header crc calculation */
    let opts;

    let n; // temporary variable for NEED_BITS

    const order = /* permutation of code lengths */
      new Uint8Array([ 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15 ]);


    if (inflateStateCheck$1(strm) || !strm.output ||
        (!strm.input && strm.avail_in !== 0)) {
      return Z_STREAM_ERROR$1$1;
    }

    state = strm.state;
    if (state.mode === TYPE$2) { state.mode = TYPEDO$1; }    /* skip check */


    //--- LOAD() ---
    put = strm.next_out;
    output = strm.output;
    left = strm.avail_out;
    next = strm.next_in;
    input = strm.input;
    have = strm.avail_in;
    hold = state.hold;
    bits = state.bits;
    //---

    _in = have;
    _out = left;
    ret = Z_OK$1$1;

    inf_leave: // goto emulation
    for (;;) {
      switch (state.mode) {
        case HEAD$1:
          if (state.wrap === 0) {
            state.mode = TYPEDO$1;
            break;
          }
          //=== NEEDBITS(16);
          while (bits < 16) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if ((state.wrap & 2) && hold === 0x8b1f) {  /* gzip header */
            if (state.wbits === 0) {
              state.wbits = 15;
            }
            state.check = 0/*crc32(0L, Z_NULL, 0)*/;
            //=== CRC2(state.check, hold);
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            state.check = crc32_1$1(state.check, hbuf, 2, 0);
            //===//

            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = FLAGS$1;
            break;
          }
          if (state.head) {
            state.head.done = false;
          }
          if (!(state.wrap & 1) ||   /* check if zlib header allowed */
            (((hold & 0xff)/*BITS(8)*/ << 8) + (hold >> 8)) % 31) {
            strm.msg = 'incorrect header check';
            state.mode = BAD$2;
            break;
          }
          if ((hold & 0x0f)/*BITS(4)*/ !== Z_DEFLATED$3) {
            strm.msg = 'unknown compression method';
            state.mode = BAD$2;
            break;
          }
          //--- DROPBITS(4) ---//
          hold >>>= 4;
          bits -= 4;
          //---//
          len = (hold & 0x0f)/*BITS(4)*/ + 8;
          if (state.wbits === 0) {
            state.wbits = len;
          }
          if (len > 15 || len > state.wbits) {
            strm.msg = 'invalid window size';
            state.mode = BAD$2;
            break;
          }

          // !!! pako patch. Force use `options.windowBits` if passed.
          // Required to always use max window size by default.
          state.dmax = 1 << state.wbits;
          //state.dmax = 1 << len;

          state.flags = 0;               /* indicate zlib header */
          //Tracev((stderr, "inflate:   zlib header ok\n"));
          strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
          state.mode = hold & 0x200 ? DICTID$1 : TYPE$2;
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          break;
        case FLAGS$1:
          //=== NEEDBITS(16); */
          while (bits < 16) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.flags = hold;
          if ((state.flags & 0xff) !== Z_DEFLATED$3) {
            strm.msg = 'unknown compression method';
            state.mode = BAD$2;
            break;
          }
          if (state.flags & 0xe000) {
            strm.msg = 'unknown header flags set';
            state.mode = BAD$2;
            break;
          }
          if (state.head) {
            state.head.text = ((hold >> 8) & 1);
          }
          if ((state.flags & 0x0200) && (state.wrap & 4)) {
            //=== CRC2(state.check, hold);
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            state.check = crc32_1$1(state.check, hbuf, 2, 0);
            //===//
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = TIME$1;
          /* falls through */
        case TIME$1:
          //=== NEEDBITS(32); */
          while (bits < 32) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if (state.head) {
            state.head.time = hold;
          }
          if ((state.flags & 0x0200) && (state.wrap & 4)) {
            //=== CRC4(state.check, hold)
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            hbuf[2] = (hold >>> 16) & 0xff;
            hbuf[3] = (hold >>> 24) & 0xff;
            state.check = crc32_1$1(state.check, hbuf, 4, 0);
            //===
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = OS$1;
          /* falls through */
        case OS$1:
          //=== NEEDBITS(16); */
          while (bits < 16) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if (state.head) {
            state.head.xflags = (hold & 0xff);
            state.head.os = (hold >> 8);
          }
          if ((state.flags & 0x0200) && (state.wrap & 4)) {
            //=== CRC2(state.check, hold);
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            state.check = crc32_1$1(state.check, hbuf, 2, 0);
            //===//
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = EXLEN$1;
          /* falls through */
        case EXLEN$1:
          if (state.flags & 0x0400) {
            //=== NEEDBITS(16); */
            while (bits < 16) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.length = hold;
            if (state.head) {
              state.head.extra_len = hold;
            }
            if ((state.flags & 0x0200) && (state.wrap & 4)) {
              //=== CRC2(state.check, hold);
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              state.check = crc32_1$1(state.check, hbuf, 2, 0);
              //===//
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
          }
          else if (state.head) {
            state.head.extra = null/*Z_NULL*/;
          }
          state.mode = EXTRA$1;
          /* falls through */
        case EXTRA$1:
          if (state.flags & 0x0400) {
            copy = state.length;
            if (copy > have) { copy = have; }
            if (copy) {
              if (state.head) {
                len = state.head.extra_len - state.length;
                if (!state.head.extra) {
                  // Use untyped array for more convenient processing later
                  state.head.extra = new Uint8Array(state.head.extra_len);
                }
                state.head.extra.set(
                  input.subarray(
                    next,
                    // extra field is limited to 65536 bytes
                    // - no need for additional size check
                    next + copy
                  ),
                  /*len + copy > state.head.extra_max - len ? state.head.extra_max : copy,*/
                  len
                );
                //zmemcpy(state.head.extra + len, next,
                //        len + copy > state.head.extra_max ?
                //        state.head.extra_max - len : copy);
              }
              if ((state.flags & 0x0200) && (state.wrap & 4)) {
                state.check = crc32_1$1(state.check, input, copy, next);
              }
              have -= copy;
              next += copy;
              state.length -= copy;
            }
            if (state.length) { break inf_leave; }
          }
          state.length = 0;
          state.mode = NAME$1;
          /* falls through */
        case NAME$1:
          if (state.flags & 0x0800) {
            if (have === 0) { break inf_leave; }
            copy = 0;
            do {
              // TODO: 2 or 1 bytes?
              len = input[next + copy++];
              /* use constant limit because in js we should not preallocate memory */
              if (state.head && len &&
                  (state.length < 65536 /*state.head.name_max*/)) {
                state.head.name += String.fromCharCode(len);
              }
            } while (len && copy < have);

            if ((state.flags & 0x0200) && (state.wrap & 4)) {
              state.check = crc32_1$1(state.check, input, copy, next);
            }
            have -= copy;
            next += copy;
            if (len) { break inf_leave; }
          }
          else if (state.head) {
            state.head.name = null;
          }
          state.length = 0;
          state.mode = COMMENT$1;
          /* falls through */
        case COMMENT$1:
          if (state.flags & 0x1000) {
            if (have === 0) { break inf_leave; }
            copy = 0;
            do {
              len = input[next + copy++];
              /* use constant limit because in js we should not preallocate memory */
              if (state.head && len &&
                  (state.length < 65536 /*state.head.comm_max*/)) {
                state.head.comment += String.fromCharCode(len);
              }
            } while (len && copy < have);
            if ((state.flags & 0x0200) && (state.wrap & 4)) {
              state.check = crc32_1$1(state.check, input, copy, next);
            }
            have -= copy;
            next += copy;
            if (len) { break inf_leave; }
          }
          else if (state.head) {
            state.head.comment = null;
          }
          state.mode = HCRC$1;
          /* falls through */
        case HCRC$1:
          if (state.flags & 0x0200) {
            //=== NEEDBITS(16); */
            while (bits < 16) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if ((state.wrap & 4) && hold !== (state.check & 0xffff)) {
              strm.msg = 'header crc mismatch';
              state.mode = BAD$2;
              break;
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
          }
          if (state.head) {
            state.head.hcrc = ((state.flags >> 9) & 1);
            state.head.done = true;
          }
          strm.adler = state.check = 0;
          state.mode = TYPE$2;
          break;
        case DICTID$1:
          //=== NEEDBITS(32); */
          while (bits < 32) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          strm.adler = state.check = zswap32$1(hold);
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = DICT$1;
          /* falls through */
        case DICT$1:
          if (state.havedict === 0) {
            //--- RESTORE() ---
            strm.next_out = put;
            strm.avail_out = left;
            strm.next_in = next;
            strm.avail_in = have;
            state.hold = hold;
            state.bits = bits;
            //---
            return Z_NEED_DICT$1$1;
          }
          strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
          state.mode = TYPE$2;
          /* falls through */
        case TYPE$2:
          if (flush === Z_BLOCK$2 || flush === Z_TREES$1) { break inf_leave; }
          /* falls through */
        case TYPEDO$1:
          if (state.last) {
            //--- BYTEBITS() ---//
            hold >>>= bits & 7;
            bits -= bits & 7;
            //---//
            state.mode = CHECK$1;
            break;
          }
          //=== NEEDBITS(3); */
          while (bits < 3) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.last = (hold & 0x01)/*BITS(1)*/;
          //--- DROPBITS(1) ---//
          hold >>>= 1;
          bits -= 1;
          //---//

          switch ((hold & 0x03)/*BITS(2)*/) {
            case 0:                             /* stored block */
              //Tracev((stderr, "inflate:     stored block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = STORED$1;
              break;
            case 1:                             /* fixed block */
              fixedtables$1(state);
              //Tracev((stderr, "inflate:     fixed codes block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = LEN_$1;             /* decode codes */
              if (flush === Z_TREES$1) {
                //--- DROPBITS(2) ---//
                hold >>>= 2;
                bits -= 2;
                //---//
                break inf_leave;
              }
              break;
            case 2:                             /* dynamic block */
              //Tracev((stderr, "inflate:     dynamic codes block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = TABLE$1;
              break;
            case 3:
              strm.msg = 'invalid block type';
              state.mode = BAD$2;
          }
          //--- DROPBITS(2) ---//
          hold >>>= 2;
          bits -= 2;
          //---//
          break;
        case STORED$1:
          //--- BYTEBITS() ---// /* go to byte boundary */
          hold >>>= bits & 7;
          bits -= bits & 7;
          //---//
          //=== NEEDBITS(32); */
          while (bits < 32) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if ((hold & 0xffff) !== ((hold >>> 16) ^ 0xffff)) {
            strm.msg = 'invalid stored block lengths';
            state.mode = BAD$2;
            break;
          }
          state.length = hold & 0xffff;
          //Tracev((stderr, "inflate:       stored length %u\n",
          //        state.length));
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = COPY_$1;
          if (flush === Z_TREES$1) { break inf_leave; }
          /* falls through */
        case COPY_$1:
          state.mode = COPY$1;
          /* falls through */
        case COPY$1:
          copy = state.length;
          if (copy) {
            if (copy > have) { copy = have; }
            if (copy > left) { copy = left; }
            if (copy === 0) { break inf_leave; }
            //--- zmemcpy(put, next, copy); ---
            output.set(input.subarray(next, next + copy), put);
            //---//
            have -= copy;
            next += copy;
            left -= copy;
            put += copy;
            state.length -= copy;
            break;
          }
          //Tracev((stderr, "inflate:       stored end\n"));
          state.mode = TYPE$2;
          break;
        case TABLE$1:
          //=== NEEDBITS(14); */
          while (bits < 14) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.nlen = (hold & 0x1f)/*BITS(5)*/ + 257;
          //--- DROPBITS(5) ---//
          hold >>>= 5;
          bits -= 5;
          //---//
          state.ndist = (hold & 0x1f)/*BITS(5)*/ + 1;
          //--- DROPBITS(5) ---//
          hold >>>= 5;
          bits -= 5;
          //---//
          state.ncode = (hold & 0x0f)/*BITS(4)*/ + 4;
          //--- DROPBITS(4) ---//
          hold >>>= 4;
          bits -= 4;
          //---//
  //#ifndef PKZIP_BUG_WORKAROUND
          if (state.nlen > 286 || state.ndist > 30) {
            strm.msg = 'too many length or distance symbols';
            state.mode = BAD$2;
            break;
          }
  //#endif
          //Tracev((stderr, "inflate:       table sizes ok\n"));
          state.have = 0;
          state.mode = LENLENS$1;
          /* falls through */
        case LENLENS$1:
          while (state.have < state.ncode) {
            //=== NEEDBITS(3);
            while (bits < 3) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.lens[order[state.have++]] = (hold & 0x07);//BITS(3);
            //--- DROPBITS(3) ---//
            hold >>>= 3;
            bits -= 3;
            //---//
          }
          while (state.have < 19) {
            state.lens[order[state.have++]] = 0;
          }
          // We have separate tables & no pointers. 2 commented lines below not needed.
          //state.next = state.codes;
          //state.lencode = state.next;
          // Switch to use dynamic table
          state.lencode = state.lendyn;
          state.lenbits = 7;

          opts = { bits: state.lenbits };
          ret = inftrees$1(CODES$2, state.lens, 0, 19, state.lencode, 0, state.work, opts);
          state.lenbits = opts.bits;

          if (ret) {
            strm.msg = 'invalid code lengths set';
            state.mode = BAD$2;
            break;
          }
          //Tracev((stderr, "inflate:       code lengths ok\n"));
          state.have = 0;
          state.mode = CODELENS$1;
          /* falls through */
        case CODELENS$1:
          while (state.have < state.nlen + state.ndist) {
            for (;;) {
              here = state.lencode[hold & ((1 << state.lenbits) - 1)];/*BITS(state.lenbits)*/
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if ((here_bits) <= bits) { break; }
              //--- PULLBYTE() ---//
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            if (here_val < 16) {
              //--- DROPBITS(here.bits) ---//
              hold >>>= here_bits;
              bits -= here_bits;
              //---//
              state.lens[state.have++] = here_val;
            }
            else {
              if (here_val === 16) {
                //=== NEEDBITS(here.bits + 2);
                n = here_bits + 2;
                while (bits < n) {
                  if (have === 0) { break inf_leave; }
                  have--;
                  hold += input[next++] << bits;
                  bits += 8;
                }
                //===//
                //--- DROPBITS(here.bits) ---//
                hold >>>= here_bits;
                bits -= here_bits;
                //---//
                if (state.have === 0) {
                  strm.msg = 'invalid bit length repeat';
                  state.mode = BAD$2;
                  break;
                }
                len = state.lens[state.have - 1];
                copy = 3 + (hold & 0x03);//BITS(2);
                //--- DROPBITS(2) ---//
                hold >>>= 2;
                bits -= 2;
                //---//
              }
              else if (here_val === 17) {
                //=== NEEDBITS(here.bits + 3);
                n = here_bits + 3;
                while (bits < n) {
                  if (have === 0) { break inf_leave; }
                  have--;
                  hold += input[next++] << bits;
                  bits += 8;
                }
                //===//
                //--- DROPBITS(here.bits) ---//
                hold >>>= here_bits;
                bits -= here_bits;
                //---//
                len = 0;
                copy = 3 + (hold & 0x07);//BITS(3);
                //--- DROPBITS(3) ---//
                hold >>>= 3;
                bits -= 3;
                //---//
              }
              else {
                //=== NEEDBITS(here.bits + 7);
                n = here_bits + 7;
                while (bits < n) {
                  if (have === 0) { break inf_leave; }
                  have--;
                  hold += input[next++] << bits;
                  bits += 8;
                }
                //===//
                //--- DROPBITS(here.bits) ---//
                hold >>>= here_bits;
                bits -= here_bits;
                //---//
                len = 0;
                copy = 11 + (hold & 0x7f);//BITS(7);
                //--- DROPBITS(7) ---//
                hold >>>= 7;
                bits -= 7;
                //---//
              }
              if (state.have + copy > state.nlen + state.ndist) {
                strm.msg = 'invalid bit length repeat';
                state.mode = BAD$2;
                break;
              }
              while (copy--) {
                state.lens[state.have++] = len;
              }
            }
          }

          /* handle error breaks in while */
          if (state.mode === BAD$2) { break; }

          /* check for end-of-block code (better have one) */
          if (state.lens[256] === 0) {
            strm.msg = 'invalid code -- missing end-of-block';
            state.mode = BAD$2;
            break;
          }

          /* build code tables -- note: do not change the lenbits or distbits
             values here (9 and 6) without reading the comments in inftrees.h
             concerning the ENOUGH constants, which depend on those values */
          state.lenbits = 9;

          opts = { bits: state.lenbits };
          ret = inftrees$1(LENS$2, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
          // We have separate tables & no pointers. 2 commented lines below not needed.
          // state.next_index = opts.table_index;
          state.lenbits = opts.bits;
          // state.lencode = state.next;

          if (ret) {
            strm.msg = 'invalid literal/lengths set';
            state.mode = BAD$2;
            break;
          }

          state.distbits = 6;
          //state.distcode.copy(state.codes);
          // Switch to use dynamic table
          state.distcode = state.distdyn;
          opts = { bits: state.distbits };
          ret = inftrees$1(DISTS$2, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
          // We have separate tables & no pointers. 2 commented lines below not needed.
          // state.next_index = opts.table_index;
          state.distbits = opts.bits;
          // state.distcode = state.next;

          if (ret) {
            strm.msg = 'invalid distances set';
            state.mode = BAD$2;
            break;
          }
          //Tracev((stderr, 'inflate:       codes ok\n'));
          state.mode = LEN_$1;
          if (flush === Z_TREES$1) { break inf_leave; }
          /* falls through */
        case LEN_$1:
          state.mode = LEN$1;
          /* falls through */
        case LEN$1:
          if (have >= 6 && left >= 258) {
            //--- RESTORE() ---
            strm.next_out = put;
            strm.avail_out = left;
            strm.next_in = next;
            strm.avail_in = have;
            state.hold = hold;
            state.bits = bits;
            //---
            inffast$1(strm, _out);
            //--- LOAD() ---
            put = strm.next_out;
            output = strm.output;
            left = strm.avail_out;
            next = strm.next_in;
            input = strm.input;
            have = strm.avail_in;
            hold = state.hold;
            bits = state.bits;
            //---

            if (state.mode === TYPE$2) {
              state.back = -1;
            }
            break;
          }
          state.back = 0;
          for (;;) {
            here = state.lencode[hold & ((1 << state.lenbits) - 1)];  /*BITS(state.lenbits)*/
            here_bits = here >>> 24;
            here_op = (here >>> 16) & 0xff;
            here_val = here & 0xffff;

            if (here_bits <= bits) { break; }
            //--- PULLBYTE() ---//
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
            //---//
          }
          if (here_op && (here_op & 0xf0) === 0) {
            last_bits = here_bits;
            last_op = here_op;
            last_val = here_val;
            for (;;) {
              here = state.lencode[last_val +
                      ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if ((last_bits + here_bits) <= bits) { break; }
              //--- PULLBYTE() ---//
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            //--- DROPBITS(last.bits) ---//
            hold >>>= last_bits;
            bits -= last_bits;
            //---//
            state.back += last_bits;
          }
          //--- DROPBITS(here.bits) ---//
          hold >>>= here_bits;
          bits -= here_bits;
          //---//
          state.back += here_bits;
          state.length = here_val;
          if (here_op === 0) {
            //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
            //        "inflate:         literal '%c'\n" :
            //        "inflate:         literal 0x%02x\n", here.val));
            state.mode = LIT$1;
            break;
          }
          if (here_op & 32) {
            //Tracevv((stderr, "inflate:         end of block\n"));
            state.back = -1;
            state.mode = TYPE$2;
            break;
          }
          if (here_op & 64) {
            strm.msg = 'invalid literal/length code';
            state.mode = BAD$2;
            break;
          }
          state.extra = here_op & 15;
          state.mode = LENEXT$1;
          /* falls through */
        case LENEXT$1:
          if (state.extra) {
            //=== NEEDBITS(state.extra);
            n = state.extra;
            while (bits < n) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.length += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
            //--- DROPBITS(state.extra) ---//
            hold >>>= state.extra;
            bits -= state.extra;
            //---//
            state.back += state.extra;
          }
          //Tracevv((stderr, "inflate:         length %u\n", state.length));
          state.was = state.length;
          state.mode = DIST$1;
          /* falls through */
        case DIST$1:
          for (;;) {
            here = state.distcode[hold & ((1 << state.distbits) - 1)];/*BITS(state.distbits)*/
            here_bits = here >>> 24;
            here_op = (here >>> 16) & 0xff;
            here_val = here & 0xffff;

            if ((here_bits) <= bits) { break; }
            //--- PULLBYTE() ---//
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
            //---//
          }
          if ((here_op & 0xf0) === 0) {
            last_bits = here_bits;
            last_op = here_op;
            last_val = here_val;
            for (;;) {
              here = state.distcode[last_val +
                      ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if ((last_bits + here_bits) <= bits) { break; }
              //--- PULLBYTE() ---//
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            //--- DROPBITS(last.bits) ---//
            hold >>>= last_bits;
            bits -= last_bits;
            //---//
            state.back += last_bits;
          }
          //--- DROPBITS(here.bits) ---//
          hold >>>= here_bits;
          bits -= here_bits;
          //---//
          state.back += here_bits;
          if (here_op & 64) {
            strm.msg = 'invalid distance code';
            state.mode = BAD$2;
            break;
          }
          state.offset = here_val;
          state.extra = (here_op) & 15;
          state.mode = DISTEXT$1;
          /* falls through */
        case DISTEXT$1:
          if (state.extra) {
            //=== NEEDBITS(state.extra);
            n = state.extra;
            while (bits < n) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.offset += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
            //--- DROPBITS(state.extra) ---//
            hold >>>= state.extra;
            bits -= state.extra;
            //---//
            state.back += state.extra;
          }
  //#ifdef INFLATE_STRICT
          if (state.offset > state.dmax) {
            strm.msg = 'invalid distance too far back';
            state.mode = BAD$2;
            break;
          }
  //#endif
          //Tracevv((stderr, "inflate:         distance %u\n", state.offset));
          state.mode = MATCH$1;
          /* falls through */
        case MATCH$1:
          if (left === 0) { break inf_leave; }
          copy = _out - left;
          if (state.offset > copy) {         /* copy from window */
            copy = state.offset - copy;
            if (copy > state.whave) {
              if (state.sane) {
                strm.msg = 'invalid distance too far back';
                state.mode = BAD$2;
                break;
              }
  // (!) This block is disabled in zlib defaults,
  // don't enable it for binary compatibility
  //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
  //          Trace((stderr, "inflate.c too far\n"));
  //          copy -= state.whave;
  //          if (copy > state.length) { copy = state.length; }
  //          if (copy > left) { copy = left; }
  //          left -= copy;
  //          state.length -= copy;
  //          do {
  //            output[put++] = 0;
  //          } while (--copy);
  //          if (state.length === 0) { state.mode = LEN; }
  //          break;
  //#endif
            }
            if (copy > state.wnext) {
              copy -= state.wnext;
              from = state.wsize - copy;
            }
            else {
              from = state.wnext - copy;
            }
            if (copy > state.length) { copy = state.length; }
            from_source = state.window;
          }
          else {                              /* copy from output */
            from_source = output;
            from = put - state.offset;
            copy = state.length;
          }
          if (copy > left) { copy = left; }
          left -= copy;
          state.length -= copy;
          do {
            output[put++] = from_source[from++];
          } while (--copy);
          if (state.length === 0) { state.mode = LEN$1; }
          break;
        case LIT$1:
          if (left === 0) { break inf_leave; }
          output[put++] = state.length;
          left--;
          state.mode = LEN$1;
          break;
        case CHECK$1:
          if (state.wrap) {
            //=== NEEDBITS(32);
            while (bits < 32) {
              if (have === 0) { break inf_leave; }
              have--;
              // Use '|' instead of '+' to make sure that result is signed
              hold |= input[next++] << bits;
              bits += 8;
            }
            //===//
            _out -= left;
            strm.total_out += _out;
            state.total += _out;
            if ((state.wrap & 4) && _out) {
              strm.adler = state.check =
                  /*UPDATE_CHECK(state.check, put - _out, _out);*/
                  (state.flags ? crc32_1$1(state.check, output, _out, put - _out) : adler32_1$1(state.check, output, _out, put - _out));

            }
            _out = left;
            // NB: crc32 stored as signed 32-bit int, zswap32 returns signed too
            if ((state.wrap & 4) && (state.flags ? hold : zswap32$1(hold)) !== state.check) {
              strm.msg = 'incorrect data check';
              state.mode = BAD$2;
              break;
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            //Tracev((stderr, "inflate:   check matches trailer\n"));
          }
          state.mode = LENGTH$1;
          /* falls through */
        case LENGTH$1:
          if (state.wrap && state.flags) {
            //=== NEEDBITS(32);
            while (bits < 32) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if ((state.wrap & 4) && hold !== (state.total & 0xffffffff)) {
              strm.msg = 'incorrect length check';
              state.mode = BAD$2;
              break;
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            //Tracev((stderr, "inflate:   length matches trailer\n"));
          }
          state.mode = DONE$1;
          /* falls through */
        case DONE$1:
          ret = Z_STREAM_END$1$1;
          break inf_leave;
        case BAD$2:
          ret = Z_DATA_ERROR$1$1;
          break inf_leave;
        case MEM$1:
          return Z_MEM_ERROR$1$1;
        case SYNC$1:
          /* falls through */
        default:
          return Z_STREAM_ERROR$1$1;
      }
    }

    // inf_leave <- here is real place for "goto inf_leave", emulated via "break inf_leave"

    /*
       Return from inflate(), updating the total counts and the check value.
       If there was no progress during the inflate() call, return a buffer
       error.  Call updatewindow() to create and/or update the window state.
       Note: a memory error from inflate() is non-recoverable.
     */

    //--- RESTORE() ---
    strm.next_out = put;
    strm.avail_out = left;
    strm.next_in = next;
    strm.avail_in = have;
    state.hold = hold;
    state.bits = bits;
    //---

    if (state.wsize || (_out !== strm.avail_out && state.mode < BAD$2 &&
                        (state.mode < CHECK$1 || flush !== Z_FINISH$1$1))) {
      if (updatewindow$1(strm, strm.output, strm.next_out, _out - strm.avail_out)) ;
    }
    _in -= strm.avail_in;
    _out -= strm.avail_out;
    strm.total_in += _in;
    strm.total_out += _out;
    state.total += _out;
    if ((state.wrap & 4) && _out) {
      strm.adler = state.check = /*UPDATE_CHECK(state.check, strm.next_out - _out, _out);*/
        (state.flags ? crc32_1$1(state.check, output, _out, strm.next_out - _out) : adler32_1$1(state.check, output, _out, strm.next_out - _out));
    }
    strm.data_type = state.bits + (state.last ? 64 : 0) +
                      (state.mode === TYPE$2 ? 128 : 0) +
                      (state.mode === LEN_$1 || state.mode === COPY_$1 ? 256 : 0);
    if (((_in === 0 && _out === 0) || flush === Z_FINISH$1$1) && ret === Z_OK$1$1) {
      ret = Z_BUF_ERROR$2;
    }
    return ret;
  };


  const inflateEnd$1 = (strm) => {

    if (inflateStateCheck$1(strm)) {
      return Z_STREAM_ERROR$1$1;
    }

    let state = strm.state;
    if (state.window) {
      state.window = null;
    }
    strm.state = null;
    return Z_OK$1$1;
  };


  const inflateGetHeader$1 = (strm, head) => {

    /* check state */
    if (inflateStateCheck$1(strm)) { return Z_STREAM_ERROR$1$1; }
    const state = strm.state;
    if ((state.wrap & 2) === 0) { return Z_STREAM_ERROR$1$1; }

    /* save header structure */
    state.head = head;
    head.done = false;
    return Z_OK$1$1;
  };


  const inflateSetDictionary$1 = (strm, dictionary) => {
    const dictLength = dictionary.length;

    let state;
    let dictid;
    let ret;

    /* check state */
    if (inflateStateCheck$1(strm)) { return Z_STREAM_ERROR$1$1; }
    state = strm.state;

    if (state.wrap !== 0 && state.mode !== DICT$1) {
      return Z_STREAM_ERROR$1$1;
    }

    /* check for correct dictionary identifier */
    if (state.mode === DICT$1) {
      dictid = 1; /* adler32(0, null, 0)*/
      /* dictid = adler32(dictid, dictionary, dictLength); */
      dictid = adler32_1$1(dictid, dictionary, dictLength, 0);
      if (dictid !== state.check) {
        return Z_DATA_ERROR$1$1;
      }
    }
    /* copy dictionary to window using updatewindow(), which will amend the
     existing dictionary if appropriate */
    ret = updatewindow$1(strm, dictionary, dictLength, dictLength);
    if (ret) {
      state.mode = MEM$1;
      return Z_MEM_ERROR$1$1;
    }
    state.havedict = 1;
    // Tracev((stderr, "inflate:   dictionary set\n"));
    return Z_OK$1$1;
  };


  var inflateReset_1$1 = inflateReset$1;
  var inflateReset2_1$1 = inflateReset2$1;
  var inflateResetKeep_1$1 = inflateResetKeep$1;
  var inflateInit_1$1 = inflateInit$1;
  var inflateInit2_1$1 = inflateInit2$1;
  var inflate_2$1$1 = inflate$2$1;
  var inflateEnd_1$1 = inflateEnd$1;
  var inflateGetHeader_1$1 = inflateGetHeader$1;
  var inflateSetDictionary_1$1 = inflateSetDictionary$1;
  var inflateInfo$1 = 'pako inflate (from Nodeca project)';

  /* Not implemented
  module.exports.inflateCodesUsed = inflateCodesUsed;
  module.exports.inflateCopy = inflateCopy;
  module.exports.inflateGetDictionary = inflateGetDictionary;
  module.exports.inflateMark = inflateMark;
  module.exports.inflatePrime = inflatePrime;
  module.exports.inflateSync = inflateSync;
  module.exports.inflateSyncPoint = inflateSyncPoint;
  module.exports.inflateUndermine = inflateUndermine;
  module.exports.inflateValidate = inflateValidate;
  */

  var inflate_1$2$1 = {
  	inflateReset: inflateReset_1$1,
  	inflateReset2: inflateReset2_1$1,
  	inflateResetKeep: inflateResetKeep_1$1,
  	inflateInit: inflateInit_1$1,
  	inflateInit2: inflateInit2_1$1,
  	inflate: inflate_2$1$1,
  	inflateEnd: inflateEnd_1$1,
  	inflateGetHeader: inflateGetHeader_1$1,
  	inflateSetDictionary: inflateSetDictionary_1$1,
  	inflateInfo: inflateInfo$1
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  function GZheader$1() {
    /* true if compressed data believed to be text */
    this.text       = 0;
    /* modification time */
    this.time       = 0;
    /* extra flags (not used when writing a gzip file) */
    this.xflags     = 0;
    /* operating system */
    this.os         = 0;
    /* pointer to extra field or Z_NULL if none */
    this.extra      = null;
    /* extra field length (valid if extra != Z_NULL) */
    this.extra_len  = 0; // Actually, we don't need it in JS,
                         // but leave for few code modifications

    //
    // Setup limits is not necessary because in js we should not preallocate memory
    // for inflate use constant limit in 65536 bytes
    //

    /* space at extra (only when reading header) */
    // this.extra_max  = 0;
    /* pointer to zero-terminated file name or Z_NULL */
    this.name       = '';
    /* space at name (only when reading header) */
    // this.name_max   = 0;
    /* pointer to zero-terminated comment or Z_NULL */
    this.comment    = '';
    /* space at comment (only when reading header) */
    // this.comm_max   = 0;
    /* true if there was or will be a header crc */
    this.hcrc       = 0;
    /* true when done reading gzip header (not used when writing a gzip file) */
    this.done       = false;
  }

  var gzheader$1 = GZheader$1;

  const toString$2 = Object.prototype.toString;

  /* Public constants ==========================================================*/
  /* ===========================================================================*/

  const {
    Z_NO_FLUSH: Z_NO_FLUSH$3, Z_FINISH: Z_FINISH$4,
    Z_OK: Z_OK$4, Z_STREAM_END: Z_STREAM_END$4, Z_NEED_DICT: Z_NEED_DICT$2, Z_STREAM_ERROR: Z_STREAM_ERROR$3, Z_DATA_ERROR: Z_DATA_ERROR$3, Z_MEM_ERROR: Z_MEM_ERROR$2
  } = constants$2$1;

  /* ===========================================================================*/


  /**
   * class Inflate
   *
   * Generic JS-style wrapper for zlib calls. If you don't need
   * streaming behaviour - use more simple functions: [[inflate]]
   * and [[inflateRaw]].
   **/

  /* internal
   * inflate.chunks -> Array
   *
   * Chunks of output data, if [[Inflate#onData]] not overridden.
   **/

  /**
   * Inflate.result -> Uint8Array|String
   *
   * Uncompressed result, generated by default [[Inflate#onData]]
   * and [[Inflate#onEnd]] handlers. Filled after you push last chunk
   * (call [[Inflate#push]] with `Z_FINISH` / `true` param).
   **/

  /**
   * Inflate.err -> Number
   *
   * Error code after inflate finished. 0 (Z_OK) on success.
   * Should be checked if broken data possible.
   **/

  /**
   * Inflate.msg -> String
   *
   * Error message, if [[Inflate.err]] != 0
   **/


  /**
   * new Inflate(options)
   * - options (Object): zlib inflate options.
   *
   * Creates new inflator instance with specified params. Throws exception
   * on bad params. Supported options:
   *
   * - `windowBits`
   * - `dictionary`
   *
   * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
   * for more information on these.
   *
   * Additional options, for internal needs:
   *
   * - `chunkSize` - size of generated data chunks (16K by default)
   * - `raw` (Boolean) - do raw inflate
   * - `to` (String) - if equal to 'string', then result will be converted
   *   from utf8 to utf16 (javascript) string. When string output requested,
   *   chunk length can differ from `chunkSize`, depending on content.
   *
   * By default, when no options set, autodetect deflate/gzip data format via
   * wrapper header.
   *
   * ##### Example:
   *
   * ```javascript
   * const pako = require('pako')
   * const chunk1 = new Uint8Array([1,2,3,4,5,6,7,8,9])
   * const chunk2 = new Uint8Array([10,11,12,13,14,15,16,17,18,19]);
   *
   * const inflate = new pako.Inflate({ level: 3});
   *
   * inflate.push(chunk1, false);
   * inflate.push(chunk2, true);  // true -> last chunk
   *
   * if (inflate.err) { throw new Error(inflate.err); }
   *
   * console.log(inflate.result);
   * ```
   **/
  function Inflate$1$1(options) {
    this.options = common$1.assign({
      chunkSize: 1024 * 64,
      windowBits: 15,
      to: ''
    }, options || {});

    const opt = this.options;

    // Force window size for `raw` data, if not set directly,
    // because we have no header for autodetect.
    if (opt.raw && (opt.windowBits >= 0) && (opt.windowBits < 16)) {
      opt.windowBits = -opt.windowBits;
      if (opt.windowBits === 0) { opt.windowBits = -15; }
    }

    // If `windowBits` not defined (and mode not raw) - set autodetect flag for gzip/deflate
    if ((opt.windowBits >= 0) && (opt.windowBits < 16) &&
        !(options && options.windowBits)) {
      opt.windowBits += 32;
    }

    // Gzip header has no info about windows size, we can do autodetect only
    // for deflate. So, if window size not set, force it to max when gzip possible
    if ((opt.windowBits > 15) && (opt.windowBits < 48)) {
      // bit 3 (16) -> gzipped data
      // bit 4 (32) -> autodetect gzip/deflate
      if ((opt.windowBits & 15) === 0) {
        opt.windowBits |= 15;
      }
    }

    this.err    = 0;      // error code, if happens (0 = Z_OK)
    this.msg    = '';     // error message
    this.ended  = false;  // used to avoid multiple onEnd() calls
    this.chunks = [];     // chunks of compressed data

    this.strm   = new zstream$1();
    this.strm.avail_out = 0;

    let status  = inflate_1$2$1.inflateInit2(
      this.strm,
      opt.windowBits
    );

    if (status !== Z_OK$4) {
      throw new Error(messages$1[status]);
    }

    this.header = new gzheader$1();

    inflate_1$2$1.inflateGetHeader(this.strm, this.header);

    // Setup dictionary
    if (opt.dictionary) {
      // Convert data if needed
      if (typeof opt.dictionary === 'string') {
        opt.dictionary = strings$1.string2buf(opt.dictionary);
      } else if (toString$2.call(opt.dictionary) === '[object ArrayBuffer]') {
        opt.dictionary = new Uint8Array(opt.dictionary);
      }
      if (opt.raw) { //In raw mode we need to set the dictionary early
        status = inflate_1$2$1.inflateSetDictionary(this.strm, opt.dictionary);
        if (status !== Z_OK$4) {
          throw new Error(messages$1[status]);
        }
      }
    }
  }

  /**
   * Inflate#push(data[, flush_mode]) -> Boolean
   * - data (Uint8Array|ArrayBuffer): input data
   * - flush_mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE
   *   flush modes. See constants. Skipped or `false` means Z_NO_FLUSH,
   *   `true` means Z_FINISH.
   *
   * Sends input data to inflate pipe, generating [[Inflate#onData]] calls with
   * new output chunks. Returns `true` on success. If end of stream detected,
   * [[Inflate#onEnd]] will be called.
   *
   * `flush_mode` is not needed for normal operation, because end of stream
   * detected automatically. You may try to use it for advanced things, but
   * this functionality was not tested.
   *
   * On fail call [[Inflate#onEnd]] with error code and return false.
   *
   * ##### Example
   *
   * ```javascript
   * push(chunk, false); // push one of data chunks
   * ...
   * push(chunk, true);  // push last chunk
   * ```
   **/
  Inflate$1$1.prototype.push = function (data, flush_mode) {
    const strm = this.strm;
    const chunkSize = this.options.chunkSize;
    const dictionary = this.options.dictionary;
    let status, _flush_mode, last_avail_out;

    if (this.ended) return false;

    if (flush_mode === ~~flush_mode) _flush_mode = flush_mode;
    else _flush_mode = flush_mode === true ? Z_FINISH$4 : Z_NO_FLUSH$3;

    // Convert data if needed
    if (toString$2.call(data) === '[object ArrayBuffer]') {
      strm.input = new Uint8Array(data);
    } else {
      strm.input = data;
    }

    strm.next_in = 0;
    strm.avail_in = strm.input.length;

    for (;;) {
      if (strm.avail_out === 0) {
        strm.output = new Uint8Array(chunkSize);
        strm.next_out = 0;
        strm.avail_out = chunkSize;
      }

      status = inflate_1$2$1.inflate(strm, _flush_mode);

      if (status === Z_NEED_DICT$2 && dictionary) {
        status = inflate_1$2$1.inflateSetDictionary(strm, dictionary);

        if (status === Z_OK$4) {
          status = inflate_1$2$1.inflate(strm, _flush_mode);
        } else if (status === Z_DATA_ERROR$3) {
          // Replace code with more verbose
          status = Z_NEED_DICT$2;
        }
      }

      // Skip snyc markers if more data follows and not raw mode
      while (strm.avail_in > 0 &&
             status === Z_STREAM_END$4 &&
             strm.state.wrap > 0 &&
             data[strm.next_in] !== 0)
      {
        inflate_1$2$1.inflateReset(strm);
        status = inflate_1$2$1.inflate(strm, _flush_mode);
      }

      switch (status) {
        case Z_STREAM_ERROR$3:
        case Z_DATA_ERROR$3:
        case Z_NEED_DICT$2:
        case Z_MEM_ERROR$2:
          this.onEnd(status);
          this.ended = true;
          return false;
      }

      // Remember real `avail_out` value, because we may patch out buffer content
      // to align utf8 strings boundaries.
      last_avail_out = strm.avail_out;

      if (strm.next_out) {
        if (strm.avail_out === 0 || status === Z_STREAM_END$4) {

          if (this.options.to === 'string') {

            let next_out_utf8 = strings$1.utf8border(strm.output, strm.next_out);

            let tail = strm.next_out - next_out_utf8;
            let utf8str = strings$1.buf2string(strm.output, next_out_utf8);

            // move tail & realign counters
            strm.next_out = tail;
            strm.avail_out = chunkSize - tail;
            if (tail) strm.output.set(strm.output.subarray(next_out_utf8, next_out_utf8 + tail), 0);

            this.onData(utf8str);

          } else {
            this.onData(strm.output.length === strm.next_out ? strm.output : strm.output.subarray(0, strm.next_out));
          }
        }
      }

      // Must repeat iteration if out buffer is full
      if (status === Z_OK$4 && last_avail_out === 0) continue;

      // Finalize if end of stream reached.
      if (status === Z_STREAM_END$4) {
        status = inflate_1$2$1.inflateEnd(this.strm);
        this.onEnd(status);
        this.ended = true;
        return true;
      }

      if (strm.avail_in === 0) break;
    }

    return true;
  };


  /**
   * Inflate#onData(chunk) -> Void
   * - chunk (Uint8Array|String): output data. When string output requested,
   *   each chunk will be string.
   *
   * By default, stores data blocks in `chunks[]` property and glue
   * those in `onEnd`. Override this handler, if you need another behaviour.
   **/
  Inflate$1$1.prototype.onData = function (chunk) {
    this.chunks.push(chunk);
  };


  /**
   * Inflate#onEnd(status) -> Void
   * - status (Number): inflate status. 0 (Z_OK) on success,
   *   other if not.
   *
   * Called either after you tell inflate that the input stream is
   * complete (Z_FINISH). By default - join collected chunks,
   * free memory and fill `results` / `err` properties.
   **/
  Inflate$1$1.prototype.onEnd = function (status) {
    // On success - join
    if (status === Z_OK$4) {
      if (this.options.to === 'string') {
        this.result = this.chunks.join('');
      } else {
        this.result = common$1.flattenChunks(this.chunks);
      }
    }
    this.chunks = [];
    this.err = status;
    this.msg = this.strm.msg;
  };


  /**
   * inflate(data[, options]) -> Uint8Array|String
   * - data (Uint8Array|ArrayBuffer): input data to decompress.
   * - options (Object): zlib inflate options.
   *
   * Decompress `data` with inflate/ungzip and `options`. Autodetect
   * format via wrapper header by default. That's why we don't provide
   * separate `ungzip` method.
   *
   * Supported options are:
   *
   * - windowBits
   *
   * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
   * for more information.
   *
   * Sugar (options):
   *
   * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
   *   negative windowBits implicitly.
   * - `to` (String) - if equal to 'string', then result will be converted
   *   from utf8 to utf16 (javascript) string. When string output requested,
   *   chunk length can differ from `chunkSize`, depending on content.
   *
   *
   * ##### Example:
   *
   * ```javascript
   * const pako = require('pako');
   * const input = pako.deflate(new Uint8Array([1,2,3,4,5,6,7,8,9]));
   * let output;
   *
   * try {
   *   output = pako.inflate(input);
   * } catch (err) {
   *   console.log(err);
   * }
   * ```
   **/
  function inflate$1$1(input, options) {
    const inflator = new Inflate$1$1(options);

    inflator.push(input);

    // That will never happens, if you don't cheat with options :)
    if (inflator.err) throw inflator.msg || messages$1[inflator.err];

    return inflator.result;
  }


  /**
   * inflateRaw(data[, options]) -> Uint8Array|String
   * - data (Uint8Array|ArrayBuffer): input data to decompress.
   * - options (Object): zlib inflate options.
   *
   * The same as [[inflate]], but creates raw data, without wrapper
   * (header and adler32 crc).
   **/
  function inflateRaw$1$1(input, options) {
    options = options || {};
    options.raw = true;
    return inflate$1$1(input, options);
  }


  /**
   * ungzip(data[, options]) -> Uint8Array|String
   * - data (Uint8Array|ArrayBuffer): input data to decompress.
   * - options (Object): zlib inflate options.
   *
   * Just shortcut to [[inflate]], because it autodetects format
   * by header.content. Done for convenience.
   **/


  var Inflate_1$1$1 = Inflate$1$1;
  var inflate_2$2 = inflate$1$1;
  var inflateRaw_1$1$1 = inflateRaw$1$1;
  var ungzip$1$1 = inflate$1$1;
  var constants$3 = constants$2$1;

  var inflate_1$1$1 = {
  	Inflate: Inflate_1$1$1,
  	inflate: inflate_2$2,
  	inflateRaw: inflateRaw_1$1$1,
  	ungzip: ungzip$1$1,
  	constants: constants$3
  };

  const { Deflate, deflate, deflateRaw, gzip } = deflate_1$1;

  const { Inflate: Inflate$2, inflate: inflate$3, inflateRaw: inflateRaw$2, ungzip: ungzip$2 } = inflate_1$1$1;
  var deflateRaw_1 = deflateRaw;
  var inflate_1$3 = inflate$3;
  var inflateRaw_1$2 = inflateRaw$2;
  var ungzip_1$1 = ungzip$2;

  const FEXTRA$1 = 4;  // gzip spec F.EXTRA flag

  function isgzipped$1(data) {
      const b = ArrayBuffer.isView(data) ? data : new Uint8Array(data);
      return b[0] ===31 && b[1] === 139;
  }

  /**
   * Pako does not properly ungzip block compressed files if > 1 block is present.  Test for bgzip and use wrapper.
   */
  function ungzip_blocks$1(data) {
      const ba = ArrayBuffer.isView(data) ? data : new Uint8Array(data);
      const b = ba[3] & FEXTRA$1;
      if (b !== 0 && ba[12] === 66 && ba[13] === 67) {
          return unbgzf$1(ba.buffer);
      } else {
          return ungzip_1$1(ba);
      }
  }

  // Uncompress data,  assumed to be series of bgzipped blocks
  function unbgzf$1(data, lim) {

      const oBlockList = [];
      let ptr = 0;
      let totalSize = 0;

      lim = lim || data.byteLength - 18;

      while (ptr < lim) {
          try {
              const ba = ArrayBuffer.isView(data) ? data : new Uint8Array(data, ptr, 18);
              const xlen = (ba[11] << 8) | (ba[10]);
              const flg = ba[3];
              const fextra = flg & FEXTRA$1;
              const si1 = ba[12];
              const si2 = ba[13];
              const slen = (ba[15] << 8) | (ba[14]);
              const bsize = ((ba[17] << 8) | (ba[16])) + 1;
              const start = 12 + xlen + ptr;    // Start of CDATA
              const bytesLeft = data.byteLength - start;
              const cDataSize = bsize - xlen - 19;
              if (bytesLeft < cDataSize || cDataSize <= 0) break;

              const a = new Uint8Array(data, start, cDataSize);
              const unc = inflateRaw_1$2(a);

              // const inflate = new Zlib.RawInflate(a);
              // const unc = inflate.decompress();

              ptr += (cDataSize - 1) + 26; //inflate.ip + 26
              totalSize += unc.byteLength;
              oBlockList.push(unc);
          } catch (e) {
              console.error(e);
              break;
          }
      }

      // Concatenate decompressed blocks
      if (oBlockList.length === 1) {
          return oBlockList[0];
      } else {
          const out = new Uint8Array(totalSize);
          let cursor = 0;
          for (let i = 0; i < oBlockList.length; ++i) {
              var b = new Uint8Array(oBlockList[i]);
              arrayCopy$1(b, 0, out, cursor, b.length);
              cursor += b.length;
          }
          return out;
      }
  }

  function bgzBlockSize$1(data) {
      const ba = ArrayBuffer.isView(data) ? data : new Uint8Array(data);
      const bsize = (ba[17] << 8 | ba[16]) + 1;
      return bsize;
  }

  // From Thomas Down's zlib implementation

  const testArray$1 = new Uint8Array(1);
  const hasSubarray$1 = (typeof testArray$1.subarray === 'function');

  function arrayCopy$1(src, srcOffset, dest, destOffset, count) {
      if (count === 0) {
          return;
      }
      if (!src) {
          throw "Undef src";
      } else if (!dest) {
          throw "Undef dest";
      }
      if (srcOffset === 0 && count === src.length) {
          arrayCopy_fast$1(src, dest, destOffset);
      } else if (hasSubarray$1) {
          arrayCopy_fast$1(src.subarray(srcOffset, srcOffset + count), dest, destOffset);
      } else if (src.BYTES_PER_ELEMENT === 1 && count > 100) {
          arrayCopy_fast$1(new Uint8Array(src.buffer, src.byteOffset + srcOffset, count), dest, destOffset);
      } else {
          arrayCopy_slow$1(src, srcOffset, dest, destOffset, count);
      }
  }

  function arrayCopy_slow$1(src, srcOffset, dest, destOffset, count) {
      for (let i = 0; i < count; ++i) {
          dest[destOffset + i] = src[srcOffset + i];
      }
  }

  function arrayCopy_fast$1(src, dest, destOffset) {
      dest.set(src, destOffset);
  }


  /**
   * Compress string and encode in a url safe form
   * @param s
   */
  function compressString(str) {

      const bytes = new Uint8Array(str.length);
      for (var i = 0; i < str.length; i++) {
          bytes[i] = str.charCodeAt(i);
      }
      const compressedBytes = new deflateRaw_1(bytes);            // UInt8Arry
      const compressedString = String.fromCharCode.apply(null, compressedBytes);      // Convert to string
      let enc = btoa(compressedString);
      return enc.replace(/\+/g, '.').replace(/\//g, '_').replace(/=/g, '-');   // URL safe
  }

  /**
   * Uncompress the url-safe encoded compressed string, presumably created by compressString above
   *
   * @param enc
   * @returns {string}
   */
  function uncompressString(enc) {

      enc = enc.replace(/\./g, '+').replace(/_/g, '/').replace(/-/g, '=');

      const compressedString = atob(enc);
      const compressedBytes = [];
      for (let i = 0; i < compressedString.length; i++) {
          compressedBytes.push(compressedString.charCodeAt(i));
      }
      //const bytes = new Zlib.RawInflate(compressedBytes).decompress();
      const bytes = inflateRaw_1$2(compressedBytes);

      let str = '';
      for (let b of bytes) {
          str += String.fromCharCode(b);
      }
      return str;
  }


  /**
   * @param dataURI
   * @returns {Array<number>|Uint8Array}
   */
  function decodeDataURI$1(dataURI, gzip) {

      const split = dataURI.split(',');
      const info = split[0].split(':')[1];
      let dataString = split[1];

      if (info.indexOf('base64') >= 0) {
          dataString = atob(dataString);

          const bytes = new Uint8Array(dataString.length);
          for (let i = 0; i < dataString.length; i++) {
              bytes[i] = dataString.charCodeAt(i);
          }

          let plain;
          if (gzip || info.indexOf('gzip') > 0) {
              plain = ungzip_1$1(bytes);
          } else {
              plain = bytes;
          }
          return plain
      } else {
          return decodeURIComponent(dataString);      // URL encoded string -- not currently used or tested
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */
  const IGVMath = {

      lerp: (v0, v1, t) => {
          return (1 - t) * v0 + t * v1;
      },

      mean: function (array) {

          var t = 0, n = 0,
              i;
          for (i = 0; i < array.length; i++) {
              if (!isNaN(array[i])) {
                  t += array[i];
                  n++;
              }
          }
          return n > 0 ? t / n : 0;
      },

      meanAndStdev: function (array) {

          var v, t = 0, t2 = 0, n = 0, i;

          for (i = 0; i < array.length; i++) {

              v = array[i];

              if (!isNaN(v)) {
                  t += v;
                  t2 += v * v;
                  n++;
              }
          }
          return n > 0 ? {mean: t / n, stdev: Math.sqrt(t2 - t * t / n)} : {mean: 0, stdev: 0};
      },

      median: function (numbers) {
          // median of [3, 5, 4, 4, 1, 1, 2, 3] = 3
          var median = 0, numsLen = numbers.length;
          numbers.sort();

          if (
              numsLen % 2 === 0 // is even
          ) {
              // average of two middle numbers
              median = (numbers[numsLen / 2 - 1] + numbers[numsLen / 2]) / 2;
          } else { // is odd
              // middle number only
              median = numbers[(numsLen - 1) / 2];
          }

          return median;
      },

      // Fast percentile function for "p" near edges.  This needs profiled for p in middle (e.g. median)
      percentile: function (array, p) {

          if (array.length === 0) return undefined;

          var k = Math.floor(array.length * ((100 - p) / 100));
          if (k === 0) {
              array.sort(function (a, b) {
                  return b - a
              });
              return array[k];
          } else {
              return selectElement(array, k);
          }

      },


      clamp: function (value, min, max) {
          return Math.min(Math.max(value, min), max);
      },

      log2: function (x) {
          return Math.log(x) / Math.LN2;
      }

  };

  function selectElement(array, k) {

      // Credit Steve Hanov http://stevehanov.ca/blog/index.php?id=122
      var heap = new BinaryHeap(),
          i;

      for (i = 0; i < array.length; i++) {

          var item = array[i];

          // If we have not yet found k items, or the current item is larger than
          // the smallest item on the heap, add current item
          if (heap.content.length < k || item > heap.content[0]) {
              // If the heap is full, remove the smallest element on the heap.
              if (heap.content.length === k) {
                  heap.pop();
              }
              heap.push(item);
          }
      }

      return heap.content[0];
  }


  function BinaryHeap() {
      this.content = [];
  }

  BinaryHeap.prototype = {
      push: function (element) {
          // Add the new element to the end of the array.
          this.content.push(element);
          // Allow it to bubble up.
          this.bubbleUp(this.content.length - 1);
      },

      pop: function () {
          // Store the first element so we can return it later.
          var result = this.content[0];
          // Get the element at the end of the array.
          var end = this.content.pop();
          // If there are any elements left, put the end element at the
          // start, and let it sink down.
          if (this.content.length > 0) {
              this.content[0] = end;
              this.sinkDown(0);
          }
          return result;
      },

      remove: function (node) {
          var length = this.content.length;
          // To remove a value, we must search through the array to find
          // it.
          for (var i = 0; i < length; i++) {
              if (this.content[i] !== node) continue;
              // When it is found, the process seen in 'pop' is repeated
              // to fill up the hole.
              var end = this.content.pop();
              // If the element we popped was the one we needed to remove,
              // we're done.
              if (i === length - 1) break;
              // Otherwise, we replace the removed element with the popped
              // one, and allow it to float up or sink down as appropriate.
              this.content[i] = end;
              this.bubbleUp(i);
              this.sinkDown(i);
              break;
          }
      },

      size: function () {
          return this.content.length;
      },

      bubbleUp: function (n) {
          // Fetch the element that has to be moved.
          var element = this.content[n], score = element;
          // When at 0, an element can not go up any further.
          while (n > 0) {
              // Compute the parent element's index, and fetch it.
              var parentN = Math.floor((n + 1) / 2) - 1,
                  parent = this.content[parentN];
              // If the parent has a lesser score, things are in order and we
              // are done.
              if (score >= parent)
                  break;

              // Otherwise, swap the parent with the current element and
              // continue.
              this.content[parentN] = element;
              this.content[n] = parent;
              n = parentN;
          }
      },

      sinkDown: function (n) {
          // Look up the target element and its score.
          var length = this.content.length,
              element = this.content[n],
              elemScore = element;

          while (true) {
              // Compute the indices of the child elements.
              var child2N = (n + 1) * 2, child1N = child2N - 1;
              // This is used to store the new position of the element,
              // if any.
              var swap = null;
              // If the first child exists (is inside the array)...
              if (child1N < length) {
                  // Look it up and compute its score.
                  var child1 = this.content[child1N],
                      child1Score = child1;
                  // If the score is less than our element's, we need to swap.
                  if (child1Score < elemScore)
                      swap = child1N;
              }
              // Do the same checks for the other child.
              if (child2N < length) {
                  var child2 = this.content[child2N],
                      child2Score = child2;
                  if (child2Score < (swap == null ? elemScore : child1Score))
                      swap = child2N;
              }

              // No need to swap further, we are done.
              if (swap == null) break;

              // Otherwise, swap and continue.
              this.content[n] = this.content[swap];
              this.content[swap] = element;
              n = swap;
          }
      }
  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  function _random(min, max) {
      return Math.random() * (max - min) + min;
  }

  const IGVColor = {

      rgbListFromHSV: () => {

          let s = 1;
          let accumulation = [];
          for (let v = 1; v >= 0.5; v -= .1) {
              for (let h = 0; h < 1; h += 1 / 28) {
                  const r = "rgb(" + IGVColor.hsvToRgb(h, s, v).join(",") + ")";
                  accumulation.push(r);
              }
          }

          // add black
          accumulation.pop();
          accumulation.push(IGVColor.rgbColor(16, 16, 16));

          return accumulation;
      },

      rgbToHex: function (rgb) {
          rgb = rgb.match(/^rgba?[\s+]?\([\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?/i);
          return (rgb && rgb.length === 4) ? "#" +
              ("0" + parseInt(rgb[1], 10).toString(16)).slice(-2) +
              ("0" + parseInt(rgb[2], 10).toString(16)).slice(-2) +
              ("0" + parseInt(rgb[3], 10).toString(16)).slice(-2) : '';
      },

      hexToRgb: function (hex) {

          var cooked = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);

          if (null === cooked) {
              return undefined;
          }

          return "rgb(" + parseInt(cooked[1], 16) + "," + parseInt(cooked[2], 16) + "," + parseInt(cooked[3], 16) + ")";
      },

      /**
       * Converts an HSV color value to RGB. Conversion formula
       * adapted from http://en.wikipedia.org/wiki/HSV_color_space.
       * Assumes h, s, and v are contained in the set [0, 1] and
       * returns r, g, and b in the set [0, 255].
       *
       * Credit: https://gist.githubusercontent.com/mjackson/5311256
       *
       * @param   h       The hue
       * @param   s       The saturation
       * @param   v       The value
       * @return  Array   The RGB representation
       */
      hsvToRgb: function (h, s, v) {
          var r, g, b;

          var i = Math.floor(h * 6);
          var f = h * 6 - i;
          var p = v * (1 - s);
          var q = v * (1 - f * s);
          var t = v * (1 - (1 - f) * s);

          switch (i % 6) {
              case 0:
                  r = v, g = t, b = p;
                  break;
              case 1:
                  r = q, g = v, b = p;
                  break;
              case 2:
                  r = p, g = v, b = t;
                  break;
              case 3:
                  r = p, g = q, b = v;
                  break;
              case 4:
                  r = t, g = p, b = v;
                  break;
              case 5:
                  r = v, g = p, b = q;
                  break;
          }

          return [Math.floor(r * 255), Math.floor(g * 255), Math.floor(b * 255)];
      },

      /**
       * Converts an HSL color value to RGB. Conversion formula
       * adapted from http://en.wikipedia.org/wiki/HSL_color_space.
       * Assumes h, s, and l are contained in the set [0, 1] and
       * returns r, g, and b in the set [0, 255].
       *
       * Credit: https://gist.githubusercontent.com/mjackson/5311256
       *
       * @param   h       The hue
       * @param   s       The saturation
       * @param   l       The lightness
       * @return  Array   The RGB representation
       */
      hslToRgb: function (h, s, l) {
          var r, g, b;

          if (s === 0) {
              r = g = b = l; // achromatic
          } else {


              var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
              var p = 2 * l - q;

              r = IGVColor.hue2rgb(p, q, h + 1 / 3);
              g = IGVColor.hue2rgb(p, q, h);
              b = IGVColor.hue2rgb(p, q, h - 1 / 3);
          }

          return [r * 255, g * 255, b * 255];
      },

      hue2rgb: (p, q, t) => {
          if (t < 0) t += 1;
          if (t > 1) t -= 1;
          if (t < 1 / 6) return p + (q - p) * 6 * t;
          if (t < 1 / 2) return q;
          if (t < 2 / 3) return p + (q - p) * (2 / 3 - t) * 6;
          return p;
      },

      rgbaColor: function (r, g, b, a) {

          r = IGVMath.clamp(r, 0, 255);
          g = IGVMath.clamp(g, 0, 255);
          b = IGVMath.clamp(b, 0, 255);
          a = IGVMath.clamp(a, 0.0, 1.0);

          return "rgba(" + r + "," + g + "," + b + "," + a + ")";
      },

      rgbColor: function (r, g, b) {

          r = IGVMath.clamp(r, 0, 255);
          g = IGVMath.clamp(g, 0, 255);
          b = IGVMath.clamp(b, 0, 255);

          return "rgb(" + r + "," + g + "," + b + ")";
      },

      greyScale: function (value) {

          var grey = IGVMath.clamp(value, 0, 255);

          return "rgb(" + grey + "," + grey + "," + grey + ")";
      },

      randomGrey: function (min, max) {

          min = IGVMath.clamp(min, 0, 255);
          max = IGVMath.clamp(max, 0, 255);

          var g = Math.round(_random(min, max)).toString(10);

          return "rgb(" + g + "," + g + "," + g + ")";
      },

      randomRGB: function (min, max) {

          min = IGVMath.clamp(min, 0, 255);
          max = IGVMath.clamp(max, 0, 255);

          var r = Math.round(_random(min, max)).toString(10);
          var g = Math.round(_random(min, max)).toString(10);
          var b = Math.round(_random(min, max)).toString(10);

          return "rgb(" + r + "," + g + "," + b + ")";
      },

      randomRGBConstantAlpha: function (min, max, alpha) {

          min = IGVMath.clamp(min, 0, 255);
          max = IGVMath.clamp(max, 0, 255);

          var r = Math.round(_random(min, max)).toString(10);
          var g = Math.round(_random(min, max)).toString(10);
          var b = Math.round(_random(min, max)).toString(10);

          return "rgba(" + r + "," + g + "," + b + "," + alpha + ")";
      },

      addAlpha: function (color, alpha) {

          if(color === "0" || color === ".") {
              color = "rgb(0,0,0)";
          } else {
              const c = this.colorNameToHex(color);
              if (c) {
                  color = c;
              }
          }

          var isHex = /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(color);

          if (color.startsWith("rgba")) {
              const idx = color.lastIndexOf(",");
              return color.substring(0, idx+1) + alpha.toString() + ")";
          }

          if (isHex) {
              color = IGVColor.hexToRgb(color);
          }

          if (color.startsWith("rgb")) {
              return color.replace("rgb", "rgba").replace(")", ", " + alpha + ")");
          } else {
              return color;
          }
      },

      rgbComponents: function (color) {

          if(color === "0" || color === ".") {
              return [0,0,0];
          }
          const isHex = /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(color);
          if (isHex) {
              color = IGVColor.hexToRgb(color);
          } else {
              if(!color.startsWith("rgb")) {
                  const hex = this.colorNameToHex(color);
                  color = this.hexToRgb(hex);
              }
          }

          if (color.startsWith("rgb(")) {
              return color.substring(4, color.length-1).split(",").map(s => Number.parseInt(s.trim()));
           } else if (color.startsWith("rgba(")) {
              return color.substring(5, color.length-1).split(",").map((s, i) => {
                  s = s.trim();
                  return i === 3 ? Number.parseFloat(s) : Number.parseInt(s)
              });
          }
          else {
              throw Error("Unrecognized color string: color");
          }
      },

      /**
       *
       * @param dest  RGB components as an array
       * @param src  RGB components as an array
       * @param alpha   alpha transparancy in the range 0-1
       * @returns {}
       */
      getCompositeColor: function (dest, src, alpha) {

          var r = Math.floor(alpha * src[0] + (1 - alpha) * dest[0]),
              g = Math.floor(alpha * src[1] + (1 - alpha) * dest[1]),
              b = Math.floor(alpha * src[2] + (1 - alpha) * dest[2]);

          return "rgb(" + r + "," + g + "," + b + ")";

      },


      createColorString: function (str) {
          // Excel will quote color strings, strip all quotes
          str = stripQuotes$1(str);

          if (str.includes(",")) {
              return str.startsWith("rgb") ? str : "rgb(" + str + ")";
          } else {
              return str;
          }
      },

      darkenLighten: function (color, amt) {

          let src;
          let hexColor = this.colorNameToHex(color);
          if(hexColor) {
              src  = IGVColor.hexToRgb(hexColor);
          } else {
              src = color.startsWith('rgb(') ? color : IGVColor.hexToRgb(color);
          }

          const components = src.replace(")", "").substring(4).split(",");

          const r = Math.max(0, Math.min(255, Number.parseInt(components[0].trim()) + amt));
          const g = Math.max(0, Math.min(255, Number.parseInt(components[1].trim()) + amt));
          const b = Math.max(0, Math.min(255, Number.parseInt(components[2].trim()) + amt));

          return 'rgb(' + r.toString() + ',' + g.toString() + ',' + b.toString() + ')';

      },

      /**
       * Convert html/css color name to hex value.  Adapted from https://gist.github.com/mxfh/4719348
       * @param colorName
       * @returns {*}
       */
      colorNameToHex: function (colorName) { // color list from http://stackoverflow.com/q/1573053/731179  with added gray/gray
          const definedColorNames = {
              "aliceblue": "#f0f8ff",
              "antiquewhite": "#faebd7",
              "aqua": "#00ffff",
              "aquamarine": "#7fffd4",
              "azure": "#f0ffff",
              "beige": "#f5f5dc",
              "bisque": "#ffe4c4",
              "black": "#000000",
              "blanchedalmond": "#ffebcd",
              "blue": "#0000ff",
              "blueviolet": "#8a2be2",
              "brown": "#a52a2a",
              "burlywood": "#deb887",
              "cadetblue": "#5f9ea0",
              "chartreuse": "#7fff00",
              "chocolate": "#d2691e",
              "coral": "#ff7f50",
              "cornflowerblue": "#6495ed",
              "cornsilk": "#fff8dc",
              "crimson": "#dc143c",
              "cyan": "#00ffff",
              "darkblue": "#00008b",
              "darkcyan": "#008b8b",
              "darkgoldenrod": "#b8860b",
              "darkgray": "#a9a9a9",
              "darkgreen": "#006400",
              "darkkhaki": "#bdb76b",
              "darkmagenta": "#8b008b",
              "darkolivegreen": "#556b2f",
              "darkorange": "#ff8c00",
              "darkorchid": "#9932cc",
              "darkred": "#8b0000",
              "darksalmon": "#e9967a",
              "darkseagreen": "#8fbc8f",
              "darkslateblue": "#483d8b",
              "darkslategray": "#2f4f4f",
              "darkturquoise": "#00ced1",
              "darkviolet": "#9400d3",
              "deeppink": "#ff1493",
              "deepskyblue": "#00bfff",
              "dimgray": "#696969",
              "dodgerblue": "#1e90ff",
              "firebrick": "#b22222",
              "floralwhite": "#fffaf0",
              "forestgreen": "#228b22",
              "fuchsia": "#ff00ff",
              "gainsboro": "#dcdcdc",
              "ghostwhite": "#f8f8ff",
              "gold": "#ffd700",
              "goldenrod": "#daa520",
              "gray": "#808080",
              "green": "#008000",
              "greenyellow": "#adff2f",
              "honeydew": "#f0fff0",
              "hotpink": "#ff69b4",
              "indianred ": "#cd5c5c",
              "indigo ": "#4b0082",
              "ivory": "#fffff0",
              "khaki": "#f0e68c",
              "lavender": "#e6e6fa",
              "lavenderblush": "#fff0f5",
              "lawngreen": "#7cfc00",
              "lemonchiffon": "#fffacd",
              "lightblue": "#add8e6",
              "lightcoral": "#f08080",
              "lightcyan": "#e0ffff",
              "lightgoldenrodyellow": "#fafad2",
              "lightgrey": "#d3d3d3",
              "lightgreen": "#90ee90",
              "lightpink": "#ffb6c1",
              "lightsalmon": "#ffa07a",
              "lightseagreen": "#20b2aa",
              "lightskyblue": "#87cefa",
              "lightslategray": "#778899",
              "lightsteelblue": "#b0c4de",
              "lightyellow": "#ffffe0",
              "lime": "#00ff00",
              "limegreen": "#32cd32",
              "linen": "#faf0e6",
              "magenta": "#ff00ff",
              "maroon": "#800000",
              "mediumaquamarine": "#66cdaa",
              "mediumblue": "#0000cd",
              "mediumorchid": "#ba55d3",
              "mediumpurple": "#9370d8",
              "mediumseagreen": "#3cb371",
              "mediumslateblue": "#7b68ee",
              "mediumspringgreen": "#00fa9a",
              "mediumturquoise": "#48d1cc",
              "mediumvioletred": "#c71585",
              "midnightblue": "#191970",
              "mintcream": "#f5fffa",
              "mistyrose": "#ffe4e1",
              "moccasin": "#ffe4b5",
              "navajowhite": "#ffdead",
              "navy": "#000080",
              "oldlace": "#fdf5e6",
              "olive": "#808000",
              "olivedrab": "#6b8e23",
              "orange": "#ffa500",
              "orangered": "#ff4500",
              "orchid": "#da70d6",
              "palegoldenrod": "#eee8aa",
              "palegreen": "#98fb98",
              "paleturquoise": "#afeeee",
              "palevioletred": "#d87093",
              "papayawhip": "#ffefd5",
              "peachpuff": "#ffdab9",
              "peru": "#cd853f",
              "pink": "#ffc0cb",
              "plum": "#dda0dd",
              "powderblue": "#b0e0e6",
              "purple": "#800080",
              "red": "#ff0000",
              "rosybrown": "#bc8f8f",
              "royalblue": "#4169e1",
              "saddlebrown": "#8b4513",
              "salmon": "#fa8072",
              "sandybrown": "#f4a460",
              "seagreen": "#2e8b57",
              "seashell": "#fff5ee",
              "sienna": "#a0522d",
              "silver": "#c0c0c0",
              "skyblue": "#87ceeb",
              "slateblue": "#6a5acd",
              "slategray": "#708090",
              "snow": "#fffafa",
              "springgreen": "#00ff7f",
              "steelblue": "#4682b4",
              "tan": "#d2b48c",
              "teal": "#008080",
              "thistle": "#d8bfd8",
              "tomato": "#ff6347",
              "turquoise": "#40e0d0",
              "violet": "#ee82ee",
              "wheat": "#f5deb3",
              "white": "#ffffff",
              "whitesmoke": "#f5f5f5",
              "yellow": "#ffff00",
              "yellowgreen": "#9acd32",
              "darkgrey": "#a9a9a9",
              "darkslategrey": "#2f4f4f",
              "dimgrey": "#696969",
              "grey": "#808080",
              "lightgray": "#d3d3d3",
              "lightslategrey": "#778899",
              "slategrey": "#708090"
          };
          return definedColorNames[colorName];
      }
  };

  // Support for oauth token based authorization
  // This class supports explicit setting of an oauth token either globally or for specific hosts.
  //
  // The variable oauth.google.access_token, which becomes igv.oauth.google.access_token on ES5 conversion is
  // supported for backward compatibility

  const DEFAULT_HOST$1 = "googleapis";

  class Oauth$1 {

      constructor() {
          this.oauthTokens = {};
      }


      setToken(token, host) {
          host = host || DEFAULT_HOST$1;
          this.oauthTokens[host] = token;
      }

      getToken(host) {
          host = host || DEFAULT_HOST$1;
          let token;
          for (let key of Object.keys(this.oauthTokens)) {
              const regex = wildcardToRegExp$1(key);
              if (regex.test(host)) {
                  token = this.oauthTokens[key];
                  break
              }
          }
          return token
      }

      removeToken(host) {
          host = host || DEFAULT_HOST$1;
          for (let key of Object.keys(this.oauthTokens)) {
              const regex = wildcardToRegExp$1(key);
              if (regex.test(host)) {
                  this.oauthTokens[key] = undefined;
              }
          }
      }

      // Special object for google -- legacy support
      // google: {
      //     setToken: function (token) {
      //         oauth.setToken(token);
      //     }
      // }
  }


  /**
   * Creates a RegExp from the given string, converting asterisks to .* expressions,
   * and escaping all other characters.
   *
   * credit https://gist.github.com/donmccurdy/6d073ce2c6f3951312dfa45da14a420f
   */
  function wildcardToRegExp$1(s) {
      return new RegExp('^' + s.split(/\*+/).map(regExpEscape$1).join('.*') + '$')
  }

  /**
   * RegExp-escapes all characters in the given string.
   *
   * credit https://gist.github.com/donmccurdy/6d073ce2c6f3951312dfa45da14a420f
   */
  function regExpEscape$1(s) {
      return s.replace(/[|\\{}()[\]^$+*?.]/g, '\\$&')
  }

  function isGoogleURL$1(url) {
      return (url.includes("googleapis") && !url.includes("urlshortener")) ||
          isGoogleStorageURL$1(url) ||
          isGoogleDriveURL$1(url)
  }

  function isGoogleStorageURL$1(url) {
      return url.startsWith("gs://") ||
          url.startsWith("https://www.googleapis.com/storage") ||
          url.startsWith("https://storage.cloud.google.com") ||
          url.startsWith("https://storage.googleapis.com");
  }

  function isGoogleDriveURL$1(url) {
      return url.indexOf("drive.google.com") >= 0 || url.indexOf("www.googleapis.com/drive") > 0
  }

  /**
   * Translate gs:// urls to https
   * See https://cloud.google.com/storage/docs/json_api/v1
   * @param gsUrl
   * @returns {string|*}
   */
  function translateGoogleCloudURL$1(gsUrl) {

      let {bucket, object} = parseBucketName$1(gsUrl);
      object = encode$1(object);

      const qIdx = gsUrl.indexOf('?');
      const paramString = (qIdx > 0) ? gsUrl.substring(qIdx) + "&alt=media" : "?alt=media";

      return `https://storage.googleapis.com/storage/v1/b/${bucket}/o/${object}${paramString}`
  }

  /**
   * Parse a google bucket and object name from a google storage URL.  Known forms include
   *
   * gs://BUCKET_NAME/OBJECT_NAME
   * https://storage.googleapis.com/BUCKET_NAME/OBJECT_NAME
   * https://storage.googleapis.com/storage/v1/b/BUCKET_NAME/o/OBJECT_NAME
   * https://www.googleapis.com/storage/v1/b/BUCKET_NAME/o/OBJECT_NAME"
   * https://storage.googleapis.com/download/storage/v1/b/BUCKET_NAME/o/OBJECT_NAME
   *
   * @param url
   */
  function parseBucketName$1(url) {

      let bucket;
      let object;

      if (url.startsWith("gs://")) {
          const i = url.indexOf('/', 5);
          if (i >= 0) {
              bucket = url.substring(5, i);
              const qIdx = url.indexOf('?');
              object = (qIdx < 0) ? url.substring(i + 1) : url.substring(i + 1, qIdx);
          }

      } else if (url.startsWith("https://storage.googleapis.com") || url.startsWith("https://storage.cloud.google.com")) {
          const bucketIdx = url.indexOf("/v1/b/", 8);
          if (bucketIdx > 0) {
              const objIdx = url.indexOf("/o/", bucketIdx);
              if (objIdx > 0) {
                  const queryIdx = url.indexOf("?", objIdx);
                  bucket = url.substring(bucketIdx + 6, objIdx);
                  object = queryIdx > 0 ? url.substring(objIdx + 3, queryIdx) : url.substring(objIdx + 3);
              }

          } else {
              const idx1 = url.indexOf("/", 8);
              const idx2 = url.indexOf("/", idx1+1);
              const idx3 = url.indexOf("?", idx2);
              if (idx2 > 0) {
                  bucket = url.substring(idx1+1, idx2);
                  object = idx3 < 0 ? url.substring(idx2+1) : url.substring(idx2+1, idx3);
              }
          }

      } else if (url.startsWith("https://www.googleapis.com/storage/v1/b")) {
          const bucketIdx = url.indexOf("/v1/b/", 8);
          const objIdx = url.indexOf("/o/", bucketIdx);
          if (objIdx > 0) {
              const queryIdx = url.indexOf("?", objIdx);
              bucket = url.substring(bucketIdx + 6, objIdx);
              object = queryIdx > 0 ? url.substring(objIdx + 3, queryIdx) : url.substring(objIdx + 3);
          }
      }

      if (bucket && object) {
          return {
              bucket, object
          }
      } else {
          throw Error(`Unrecognized Google Storage URI: ${url}`)
      }

  }

  /**
   * Percent a GCS object name.  See https://cloud.google.com/storage/docs/request-endpoints
   * Specific characters to encode:
   *   !, #, $, &, ', (, ), *, +, ,, /, :, ;, =, ?, @, [, ], and space characters.
   * @param obj
   */

  function encode$1(objectName) {

      let result = '';
      objectName.split('').forEach(function(letter) {
          if(encodings$1$1.has(letter)) {
              result += encodings$1$1.get(letter);
          } else {
              result += letter;
          }
      });
      return result;
  }

  //	%23	%24	%25	%26	%27	%28	%29	%2A	%2B	%2C	%2F	%3A	%3B	%3D	%3F	%40	%5B	%5D
  const encodings$1$1 = new Map();
  encodings$1$1.set("!", "%21");
  encodings$1$1.set("#", "%23");
  encodings$1$1.set("$", "%24");
  encodings$1$1.set("%", "%25");
  encodings$1$1.set("&", "%26");
  encodings$1$1.set("'", "%27");
  encodings$1$1.set("(", "%28");
  encodings$1$1.set(")", "%29");
  encodings$1$1.set("*", "%2A");
  encodings$1$1.set("+", "%2B");
  encodings$1$1.set(",", "%2C");
  encodings$1$1.set("/", "%2F");
  encodings$1$1.set(":", "%3A");
  encodings$1$1.set(";", "%3B");
  encodings$1$1.set("=", "%3D");
  encodings$1$1.set("?", "%3F");
  encodings$1$1.set("@", "%40");
  encodings$1$1.set("[", "%5B");
  encodings$1$1.set("]", "%5D");
  encodings$1$1.set(" ", "%20");

  // Convenience functions for the gapi oAuth library.

  async function init$1$1(config) {

      if (!(google.accounts.oauth2.initTokenClient)) {
          throw new Error("Google accounts token client not loaded (https://accounts.google.com/gsi/client)")
      }

      if (isInitialized$2()) {
          throw new Error("Google client is already initialized")
      }

      // Note: callback is added when accessToken is requested
      const codeClientConfig = {
          client_id: config.client_id,
          scope: config.scope || 'https://www.googleapis.com/auth/userinfo.profile',
          state: config.state || 'igv',
          error: (err) => {
              throw new Error(err.type)
          },
          hint: config.hint,     // Optional
          hosted_domain: config.hosted_domain  // Optional
      };

      const tokenClient = google.accounts.oauth2.initTokenClient(codeClientConfig);

      // Attach an object to keep igv state
      google.igv = {
          tokenClient: tokenClient,
          apiKey: config.apiKey
      };
  }

  function isInitialized$2() {
      return window.google && window.google.igv
  }

  /**
   * Return the current access token if the user is signed in, or undefined otherwise.  This function does not
   * attempt a signIn or request any specfic scopes.
   *
   * @returns access_token || undefined
   */
  function getCurrentAccessToken$2() {
      return (isInitialized$2() && google.igv.tokenResponse && Date.now() < google.igv.tokenExpiresAt) ?
          google.igv.tokenResponse.access_token :
          undefined
  }


  /**
   * Return a promise for an access token for the given scope.  If the user hasn't authorized the scope request it
   *
   * @param scope
   * @returns {Promise<unknown>}
   */
  async function getAccessToken$2(scope) {

      if (!isInitialized$2()) {
          throw Error("Google oAuth has not been initialized")
      }

      if (google.igv.tokenResponse &&
          Date.now() < google.igv.tokenExpiresAt &&
          google.accounts.oauth2.hasGrantedAllScopes(google.igv.tokenResponse, scope)) {
          return google.igv.tokenResponse.access_token
      } else {
          const tokenClient = google.igv.tokenClient;
          return new Promise((resolve, reject) => {
              try {
                  // Settle this promise in the response callback for requestAccessToken()
                  tokenClient.callback = (tokenResponse) => {
                      if (tokenResponse.error !== undefined) {
                          reject(tokenResponse);
                      }
                      google.igv.tokenResponse = tokenResponse;
                      google.igv.tokenExpiresAt = Date.now() + tokenResponse.expires_in * 1000;
                      resolve(tokenResponse.access_token);
                  };
                  tokenClient.requestAccessToken({scope});
              } catch (err) {
              }
          })
      }
  }

  // gapi.auth2.getAuthInstance().isSignedIn.listen(status => {
  //     const user = gapi.auth2.getAuthInstance().currentUser.get()
  //     queryGoogleAuthenticationStatus(user, status)
  // })

  function getScopeForURL$1(url) {
      if (isGoogleDriveURL$1(url)) {
          return "https://www.googleapis.com/auth/drive.readonly"
      } else if (isGoogleStorageURL$1(url)) {
          return "https://www.googleapis.com/auth/devstorage.read_only"
      } else {
          return 'https://www.googleapis.com/auth/userinfo.profile'
      }
  }

  function getApiKey$1() {
      return google.igv.apiKey
  }

  /**
   * Return information about a specific google drive URL
   *
   * @param googleDriveURL
   * @returns {Promise<any>}
   */
  async function getDriveFileInfo$1(googleDriveURL) {

      const id = getGoogleDriveFileID$1(googleDriveURL);
      let endPoint = "https://www.googleapis.com/drive/v3/files/" + id + "?supportsTeamDrives=true";
      const apiKey = getApiKey$1();
      if (apiKey) {
          endPoint += "&key=" + apiKey;
      }
      const response = await fetch(endPoint);
      let json = await response.json();
      if (json.error && json.error.code === 404) {
          let scope = "https://www.googleapis.com/auth/drive.readonly";
          const access_token = await getAccessToken$2(scope);
          if (access_token) {
              const response = await fetch(endPoint, {
                  headers: {
                      'Authorization': `Bearer ${access_token}`
                  }
              });
              json = await response.json();
              if (json.error) {
                  throw Error(json.error);
              }
          } else {
              throw Error(json.error);
          }
      }
      return json;
  }


  function getDriveDownloadURL$1(link) {
      // Return a google drive download url for the sharable link
      //https://drive.google.com/open?id=0B-lleX9c2pZFbDJ4VVRxakJzVGM
      //https://drive.google.com/file/d/1_FC4kCeO8E3V4dJ1yIW7A0sn1yURKIX-/view?usp=sharing
      var id = getGoogleDriveFileID$1(link);
      return id ? "https://www.googleapis.com/drive/v3/files/" + id + "?alt=media&supportsTeamDrives=true" : link;
  }

  function getGoogleDriveFileID$1(link) {

      //https://drive.google.com/file/d/1_FC4kCeO8E3V4dJ1yIW7A0sn1yURKIX-/view?usp=sharing
      //https://www.googleapis.com/drive/v3/files/1w-tvo6p1SH4p1OaQSVxpkV_EJgGIstWF?alt=media&supportsTeamDrives=true"

      if (link.includes("/open?id=")) {
          const i1 = link.indexOf("/open?id=") + 9;
          const i2 = link.indexOf("&");
          if (i1 > 0 && i2 > i1) {
              return link.substring(i1, i2)
          } else if (i1 > 0) {
              return link.substring(i1);
          }

      } else if (link.includes("/file/d/")) {
          const i1 = link.indexOf("/file/d/") + 8;
          const i2 = link.lastIndexOf("/");
          return link.substring(i1, i2);

      } else if (link.startsWith("https://www.googleapis.com/drive")) {
          let i1 = link.indexOf("/files/");
          const i2 = link.indexOf("?");
          if (i1 > 0) {
              i1 += 7;
              return i2 > 0 ?
                  link.substring(i1, i2) :
                  link.substring(i1)
          }
      }

      throw Error("Unknown Google Drive url format: " + link);


  }

  // The MIT License (MIT)

  /**
   * @constructor
   * @param {Object} options A set op options to pass to the throttle function
   *        @param {number} requestsPerSecond The amount of requests per second
   *                                          the library will limit to
   */
  class Throttle$1 {
      constructor(options) {
          this.requestsPerSecond = options.requestsPerSecond || 10;
          this.lastStartTime = 0;
          this.queued = [];
      }

      /**
       * Adds a promise
       * @param {Function} async function to be executed
       * @param {Object} options A set of options.
       * @return {Promise} A promise
       */
      add(asyncFunction, options) {

          var self = this;
          return new Promise(function (resolve, reject) {
              self.queued.push({
                  resolve: resolve,
                  reject: reject,
                  asyncFunction: asyncFunction,
              });
              self.dequeue();
          });
      }

      /**
       * Adds all the promises passed as parameters
       * @param {Function} promises An array of functions that return a promise
       * @param {Object} options A set of options.
       * @param {number} options.signal An AbortSignal object that can be used to abort the returned promise
       * @param {number} options.weight A "weight" of each operation resolving by array of promises
       * @return {Promise} A promise that succeeds when all the promises passed as options do
       */
      addAll(promises, options) {
          var addedPromises = promises.map(function (promise) {
              return this.add(promise, options);
          }.bind(this));

          return Promise.all(addedPromises);
      };

      /**
       * Dequeues a promise
       * @return {void}
       */
      dequeue() {
          if (this.queued.length > 0) {
              var now = new Date(),
                  inc = (1000 / this.requestsPerSecond) + 1,
                  elapsed = now - this.lastStartTime;

              if (elapsed >= inc) {
                  this._execute();
              } else {
                  // we have reached the limit, schedule a dequeue operation
                  setTimeout(function () {
                      this.dequeue();
                  }.bind(this), inc - elapsed);
              }
          }
      }

      /**
       * Executes the promise
       * @private
       * @return {void}
       */
      async _execute() {
          this.lastStartTime = new Date();
          var candidate = this.queued.shift();
          const f = candidate.asyncFunction;
          try {
              const r = await f();
              candidate.resolve(r);
          } catch (e) {
              candidate.reject(e);
          }

      }


  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class IGVXhr$1 {

      constructor() {
          this.apiKey = undefined;
          this.googleThrottle = new Throttle$1({
              requestsPerSecond: 8
          });
          this.RANGE_WARNING_GIVEN = false;
          this.oauth = new Oauth$1();
      }

      setApiKey(key) {
          this.apiKey = key;
      }

      async loadArrayBuffer(url, options) {
          options = options || {};
          if (!options.responseType) {
              options.responseType = "arraybuffer";
          }
          if (isFile$2(url)) {
              return this._loadFileSlice(url, options)
          } else {
              return this.load(url, options)
          }
      }

      async loadJson(url, options) {
          options = options || {};
          const method = options.method || (options.sendData ? "POST" : "GET");
          if (method === "POST") {
              options.contentType = "application/json";
          }
          const result = await this.loadString(url, options);
          if (result) {
              return JSON.parse(result)
          } else {
              return result
          }
      }

      async loadString(path, options) {
          options = options || {};
          if (path instanceof File) {
              return this._loadStringFromFile(path, options)
          } else {
              return this._loadStringFromUrl(path, options)
          }
      }

      async load(url, options) {

          options = options || {};
          const urlType = typeof url;

          // Resolve functions, promises, and functions that return promises
          url = await (typeof url === 'function' ? url() : url);

          if (isFile$2(url)) {
              return this._loadFileSlice(url, options)
          } else if (typeof url.startsWith === 'function') {   // Test for string
              if (url.startsWith("data:")) {
                  const buffer = decodeDataURI$1(url).buffer;
                  if (options.range) {
                      const rangeEnd = options.range.size ? options.range.start + options.range.size : buffer.byteLength;
                      return buffer.slice(options.range.start, rangeEnd)
                  } else {
                      return buffer
                  }
              } else {
                  if (url.startsWith("https://drive.google.com")) {
                      url = getDriveDownloadURL$1(url);
                  }
                  if (isGoogleDriveURL$1(url) || url.startsWith("https://www.dropbox.com")) {
                      return this.googleThrottle.add(async () => {
                          return this._loadURL(url, options)
                      })
                  } else {
                      return this._loadURL(url, options)
                  }
              }
          } else {
              throw Error(`url must be either a 'File', 'string', 'function', or 'Promise'.  Actual type: ${urlType}`)
          }
      }

      async _loadURL(url, options) {

          const self = this;

          //console.log(`${Date.now()}   ${url}`)
          url = mapUrl$1(url);

          options = options || {};

          let oauthToken = options.oauthToken || this.getOauthToken(url);
          if (oauthToken) {
              oauthToken = await (typeof oauthToken === 'function' ? oauthToken() : oauthToken);
          }

          return new Promise(function (resolve, reject) {

              // Various Google tansformations
              if (isGoogleURL$1(url) && !isGoogleStorageSigned$1(url)) {
                  if (isGoogleStorageURL$1(url)) {
                      url = translateGoogleCloudURL$1(url);
                  }
                  url = addApiKey$1(url);

                  if (isGoogleDriveURL$1(url)) {
                      addTeamDrive$1(url);
                  }

                  // If we have an access token try it, but don't force a signIn or request for scopes yet
                  if (!oauthToken) {
                      oauthToken = getCurrentGoogleAccessToken$1();
                  }
              }

              const headers = options.headers || {};
              if (oauthToken) {
                  addOauthHeaders$1(headers, oauthToken);
              }
              const range = options.range;

              // const isChrome = navigator.userAgent.indexOf('Chrome') > -1
              // const isSafari = navigator.vendor.indexOf("Apple") === 0 && /\sSafari\//.test(navigator.userAgent)
              // if (range && isChrome && !isAmazonV4Signed(url) && !isGoogleStorageSigned(url)) {
              //     // Hack to prevent caching for byte-ranges. Attempt to fix net:err-cache errors in Chrome
              //     url += url.includes("?") ? "&" : "?"
              //     url += "someRandomSeed=" + Math.random().toString(36)
              // }

              const xhr = new XMLHttpRequest();
              const sendData = options.sendData || options.body;
              const method = options.method || (sendData ? "POST" : "GET");
              const responseType = options.responseType;
              const contentType = options.contentType;
              const mimeType = options.mimeType;

              xhr.open(method, url);

              if (options.timeout) {
                  xhr.timeout = options.timeout;
              }

              if (range) {
                  var rangeEnd = range.size ? range.start + range.size - 1 : "";
                  xhr.setRequestHeader("Range", "bytes=" + range.start + "-" + rangeEnd);
                  //      xhr.setRequestHeader("Cache-Control", "no-cache");    <= This can cause CORS issues, disabled for now
              }
              if (contentType) {
                  xhr.setRequestHeader("Content-Type", contentType);
              }
              if (mimeType) {
                  xhr.overrideMimeType(mimeType);
              }
              if (responseType) {
                  xhr.responseType = responseType;
              }
              if (headers) {
                  for (let key of Object.keys(headers)) {
                      const value = headers[key];
                      xhr.setRequestHeader(key, value);
                  }
              }

              // NOTE: using withCredentials with servers that return "*" for access-allowed-origin will fail
              if (options.withCredentials === true) {
                  xhr.withCredentials = true;
              }

              xhr.onload = async function (event) {
                  // when the url points to a local file, the status is 0 but that is not an error
                  if (xhr.status === 0 || (xhr.status >= 200 && xhr.status <= 300)) {
                      if (range && xhr.status !== 206 && range.start !== 0) {
                          // For small files a range starting at 0 can return the whole file => 200
                          // Provide just the slice we asked for, throw out the rest quietly
                          // If file is large warn user
                          if (xhr.response.length > 100000 && !self.RANGE_WARNING_GIVEN) {
                              alert(`Warning: Range header ignored for URL: ${url}.  This can have severe performance impacts.`);
                          }
                          resolve(xhr.response.slice(range.start, range.start + range.size));

                      } else {
                          resolve(xhr.response);
                      }
                  } else if ((typeof gapi !== "undefined") &&
                      ((xhr.status === 404 || xhr.status === 401 || xhr.status === 403) &&
                          isGoogleURL$1(url)) &&
                      !options.retries) {
                      tryGoogleAuth();

                  } else {
                      if (xhr.status === 403) {
                          handleError("Access forbidden: " + url);
                      } else if (xhr.status === 416) {
                          //  Tried to read off the end of the file.   This shouldn't happen, but if it does return an
                          handleError("Unsatisfiable range");
                      } else {
                          handleError(xhr.status);
                      }
                  }
              };

              xhr.onerror = function (event) {
                  if (isGoogleURL$1(url) && !options.retries) {
                      tryGoogleAuth();
                  } else {
                      handleError("Error accessing resource: " + url + " Status: " + xhr.status);
                  }
              };

              xhr.ontimeout = function (event) {
                  handleError("Timed out");
              };

              xhr.onabort = function (event) {
                  reject(event);
              };

              try {
                  xhr.send(sendData);
              } catch (e) {
                  if (isGoogleURL$1(url) && !options.retries) {
                      tryGoogleAuth();
                  } else {
                      handleError(e);
                  }
              }


              function handleError(error) {
                  if (reject) {
                      reject(error);
                  } else {
                      throw error
                  }
              }

              async function tryGoogleAuth() {
                  try {
                      const accessToken = await fetchGoogleAccessToken$1(url);
                      options.retries = 1;
                      options.oauthToken = accessToken;
                      const response = await self.load(url, options);
                      resolve(response);
                  } catch (e) {
                      if (e.error) {
                          const msg = e.error.startsWith("popup_blocked") ?
                              "Google login popup blocked by browser." :
                              e.error;
                          alert(msg);
                      } else {
                          handleError(e);
                      }
                  }
              }
          })

      }

      async _loadFileSlice(localfile, options) {

          let blob = (options && options.range) ?
              localfile.slice(options.range.start, options.range.start + options.range.size) :
              localfile;

          const arrayBuffer = await blob.arrayBuffer();

          if ("arraybuffer" === options.responseType) {
              return arrayBuffer
          } else {
              return arrayBufferToString$1(arrayBuffer)
          }
      }

      async _loadStringFromFile(localfile, options) {

          const blob = options.range ? localfile.slice(options.range.start, options.range.start + options.range.size) : localfile;
          const arrayBuffer = await blob.arrayBuffer();
          return arrayBufferToString$1(arrayBuffer)
      }

      async _loadStringFromUrl(url, options) {

          options = options || {};
          options.responseType = "arraybuffer";
          const data = await this.load(url, options);
          return arrayBufferToString$1(data)
      }

      /**
       * Explicity set an oAuth token for use with given host.  If host is undefined token is used for google api access*
       * @param token
       * @param host
       */
      setOauthToken(token, host) {
          this.oauth.setToken(token, host);
      }

      /**
       * Return an oauth token for the URL if we have one.  This method does not force sign-in, and the token may
       * or may not be valid.  Sign-in is triggered on request failure.
       * *
       * @param url
       * @returns {*}
       */
      getOauthToken(url) {

          // Google is the default provider, don't try to parse host for google URLs
          const host = isGoogleURL$1(url) ?
              undefined :
              parseUri$1(url).host;

          // First check the explicit settings (i.e. token set through the API)
          let token = this.oauth.getToken(host);
          if (token) {
              return token
          } else if (host === undefined) {
              // Now try Google oauth tokens previously obtained.  This will return undefined if google oauth is not
              // configured.
              const googleToken = getCurrentGoogleAccessToken$1();
              if (googleToken && googleToken.expires_at > Date.now()) {
                  return googleToken.access_token
              }
          }
      }
  }

  function isGoogleStorageSigned$1(url) {
      return url.indexOf("X-Goog-Signature") > -1
  }



  /**
   * Return a Google oAuth token, triggering a sign in if required.   This method should not be called until we know
   * a token is required, that is until we've tried the url and received a 401, 403, or 404.
   *
   * @param url
   * @returns the oauth token
   */
  async function fetchGoogleAccessToken$1(url) {
      if (isInitialized$2()) {
          const scope = getScopeForURL$1(url);
          const access_token = await getAccessToken$2(scope);
          return access_token
      } else {
          throw Error(
              `Authorization is required, but Google oAuth has not been initalized. Contact your site administrator for assistance.`)
      }
  }

  /**
   * Return the current google access token, if one exists.  Do not triger signOn or request additional scopes.
   * @returns {undefined|access_token}
   */
  function getCurrentGoogleAccessToken$1() {
      if (isInitialized$2()) {
          const access_token = getCurrentAccessToken$2();
          return access_token
      } else {
          return undefined
      }
  }

  function addOauthHeaders$1(headers, acToken) {
      if (acToken) {
          headers["Cache-Control"] = "no-cache";
          headers["Authorization"] = "Bearer " + acToken;
      }
      return headers
  }


  function addApiKey$1(url) {
      let apiKey = igvxhr$1.apiKey;
      if (!apiKey && typeof gapi !== "undefined") {
          apiKey = gapi.apiKey;
      }
      if (apiKey !== undefined && !url.includes("key=")) {
          const paramSeparator = url.includes("?") ? "&" : "?";
          url = url + paramSeparator + "key=" + apiKey;
      }
      return url
  }

  function addTeamDrive$1(url) {
      if (url.includes("supportsTeamDrive")) {
          return url
      } else {
          const paramSeparator = url.includes("?") ? "&" : "?";
          url = url + paramSeparator + "supportsTeamDrive=true";
      }
  }

  /**
   * Perform some well-known url mappings.
   * @param url
   */
  function mapUrl$1(url) {

      if (url.startsWith("https://www.dropbox.com")) {
          return url.replace("//www.dropbox.com", "//dl.dropboxusercontent.com")
      } else if (url.startsWith("https://drive.google.com")) {
          return getDriveDownloadURL$1(url)
      } else if (url.includes("//www.broadinstitute.org/igvdata")) {
          return url.replace("//www.broadinstitute.org/igvdata", "//data.broadinstitute.org/igvdata")
      } else if (url.includes("//igvdata.broadinstitute.org")) {
          return url.replace("//igvdata.broadinstitute.org", "//s3.amazonaws.com/igv.broadinstitute.org")
      } else if (url.includes("//igv.genepattern.org")) {
          return url.replace("//igv.genepattern.org", "//igv-genepattern-org.s3.amazonaws.com")
      } else if (url.startsWith("ftp://ftp.ncbi.nlm.nih.gov/geo")) {
          return url.replace("ftp://", "https://")
      } else {
          return url
      }
  }


  function arrayBufferToString$1(arraybuffer) {

      let plain;
      if (isgzipped$1(arraybuffer)) {
          plain = ungzip_blocks$1(arraybuffer);
      } else {
          plain = new Uint8Array(arraybuffer);
      }

      if ('TextDecoder' in getGlobalObject$1()) {
          return new TextDecoder().decode(plain)
      } else {
          return decodeUTF8$1(plain)
      }
  }

  /**
   * Use when TextDecoder is not available (primarily IE).
   *
   * From: https://gist.github.com/Yaffle/5458286
   *
   * @param octets
   * @returns {string}
   */
  function decodeUTF8$1(octets) {
      var string = "";
      var i = 0;
      while (i < octets.length) {
          var octet = octets[i];
          var bytesNeeded = 0;
          var codePoint = 0;
          if (octet <= 0x7F) {
              bytesNeeded = 0;
              codePoint = octet & 0xFF;
          } else if (octet <= 0xDF) {
              bytesNeeded = 1;
              codePoint = octet & 0x1F;
          } else if (octet <= 0xEF) {
              bytesNeeded = 2;
              codePoint = octet & 0x0F;
          } else if (octet <= 0xF4) {
              bytesNeeded = 3;
              codePoint = octet & 0x07;
          }
          if (octets.length - i - bytesNeeded > 0) {
              var k = 0;
              while (k < bytesNeeded) {
                  octet = octets[i + k + 1];
                  codePoint = (codePoint << 6) | (octet & 0x3F);
                  k += 1;
              }
          } else {
              codePoint = 0xFFFD;
              bytesNeeded = octets.length - i;
          }
          string += String.fromCodePoint(codePoint);
          i += bytesNeeded + 1;
      }
      return string
  }


  function getGlobalObject$1() {
      if (typeof self !== 'undefined') {
          return self
      }
      if (typeof global !== 'undefined') {
          return global
      } else {
          return window
      }
  }

  const igvxhr$1 = new IGVXhr$1();

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /** An implementation of an interval tree, following the explanation.
   * from CLR.
   *
   * Public interface:
   *   Constructor  IntervalTree
   *   Insertion    insert
   *   Search       findOverlapping
   */

  var BLACK$1 = 1;
  var RED = 2;

  var NIL$1 = {};
  NIL$1.color = BLACK$1;
  NIL$1.parent = NIL$1;
  NIL$1.left = NIL$1;
  NIL$1.right = NIL$1;


  class IntervalTree {

      constructor() {
          this.root = NIL$1;
      }

      insert(start, end, value) {

          var interval = new Interval(start, end, value);
          var x = new Node(interval);
          this.treeInsert(x);
          x.color = RED;
          while (x !== this.root && x.parent.color === RED) {
              if (x.parent === x.parent.parent.left) {
                  let y = x.parent.parent.right;
                  if (y.color === RED) {
                      x.parent.color = BLACK$1;
                      y.color = BLACK$1;
                      x.parent.parent.color = RED;
                      x = x.parent.parent;
                  } else {
                      if (x === x.parent.right) {
                          x = x.parent;
                          leftRotate.call(this, x);
                      }
                      x.parent.color = BLACK$1;
                      x.parent.parent.color = RED;
                      rightRotate.call(this, x.parent.parent);
                  }
              } else {
                  let y = x.parent.parent.left;
                  if (y.color === RED) {
                      x.parent.color = BLACK$1;
                      y.color = BLACK$1;
                      x.parent.parent.color = RED;
                      x = x.parent.parent;
                  } else {
                      if (x === x.parent.left) {
                          x = x.parent;
                          rightRotate.call(this, x);
                      }
                      x.parent.color = BLACK$1;
                      x.parent.parent.color = RED;
                      leftRotate.call(this, x.parent.parent);
                  }
              }
          }
          this.root.color = BLACK$1;
      }

      /**
       *
       * @param start - query interval
       * @param end - query interval
       * @returns Array of all intervals overlapping the query region
       */
      findOverlapping(start, end) {


          var searchInterval = new Interval(start, end, 0);

          if (this.root === NIL$1) return [];

          var intervals = searchAll.call(this, searchInterval, this.root, []);

          if (intervals.length > 1) {
              intervals.sort(function (i1, i2) {
                  return i1.low - i2.low;
              });
          }

          return intervals;
      }

      /**
       * Dump info on intervals to console.  For debugging.
       */
      logIntervals() {

          logNode(this.root);

          function logNode(node, indent) {

              if (node.left !== NIL$1) logNode(node.left);
              if (node.right !== NIL$1) logNode(node.right);
          }

      }

      mapIntervals(func) {

          applyInterval(this.root);

          function applyInterval(node) {

              func(node.interval);

              if (node.left !== NIL$1) applyInterval(node.left);
              if (node.right !== NIL$1) applyInterval(node.right);
          }
      }


      /**
       * Note:  Does not maintain RB constraints,  this is done post insert
       *
       * @param x  a Node
       */
      treeInsert(x) {
          var node = this.root;
          var y = NIL$1;
          while (node !== NIL$1) {
              y = node;
              if (x.interval.low <= node.interval.low) {
                  node = node.left;
              } else {
                  node = node.right;
              }
          }
          x.parent = y;

          if (y === NIL$1) {
              this.root = x;
              x.left = x.right = NIL$1;
          } else {
              if (x.interval.low <= y.interval.low) {
                  y.left = x;
              } else {
                  y.right = x;
              }
          }

          applyUpdate.call(this, x);
      }
  }

  function searchAll(interval, node, results) {

      if (node.interval.overlaps(interval)) {
          results.push(node.interval);
      }

      if (node.left !== NIL$1 && node.left.max >= interval.low) {
          searchAll.call(this, interval, node.left, results);
      }

      if (node.right !== NIL$1 && node.right.min <= interval.high) {
          searchAll.call(this, interval, node.right, results);
      }

      return results;
  }

  function leftRotate(x) {
      var y = x.right;
      x.right = y.left;
      if (y.left !== NIL$1) {
          y.left.parent = x;
      }
      y.parent = x.parent;
      if (x.parent === NIL$1) {
          this.root = y;
      } else {
          if (x.parent.left === x) {
              x.parent.left = y;
          } else {
              x.parent.right = y;
          }
      }
      y.left = x;
      x.parent = y;

      applyUpdate.call(this, x);
      // no need to apply update on y, since it'll y is an ancestor
      // of x, and will be touched by applyUpdate().
  }


  function rightRotate(x) {
      var y = x.left;
      x.left = y.right;
      if (y.right !== NIL$1) {
          y.right.parent = x;
      }
      y.parent = x.parent;
      if (x.parent === NIL$1) {
          this.root = y;
      } else {
          if (x.parent.right === x) {
              x.parent.right = y;
          } else {
              x.parent.left = y;
          }
      }
      y.right = x;
      x.parent = y;


      applyUpdate.call(this, x);
      // no need to apply update on y, since it'll y is an ancestor
      // of x, and will be touched by applyUpdate().
  }


  // Applies the statistic update on the node and its ancestors.
  function applyUpdate(node) {
      while (node !== NIL$1) {
          var nodeMax = node.left.max > node.right.max ? node.left.max : node.right.max;
          var intervalHigh = node.interval.high;
          node.max = nodeMax > intervalHigh ? nodeMax : intervalHigh;

          var nodeMin = node.left.min < node.right.min ? node.left.min : node.right.min;
          var intervalLow = node.interval.low;
          node.min = nodeMin < intervalLow ? nodeMin : intervalLow;

          node = node.parent;
      }
  }


  class Interval {
      constructor(low, high, value) {
          this.low = low;
          this.high = high;
          this.value = value;
      }

      equals(other) {
          if (!other) {
              return false;
          }
          if (this === other) {
              return true;
          }
          return (this.low === other.low &&
              this.high === other.high);

      }

      compareTo(other) {
          if (this.low < other.low)
              return -1;
          if (this.low > other.low)
              return 1;

          if (this.high < other.high)
              return -1;
          if (this.high > other.high)
              return 1;

          return 0;
      }

      /**
       * Returns true if this interval overlaps the other.
       */
      overlaps(other) {
              return (this.low <= other.high && other.low <= this.high);
      }
  }

  function Node(interval) {
      this.parent = NIL$1;
      this.left = NIL$1;
      this.right = NIL$1;
      this.interval = interval;
      this.color = RED;
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Object for caching lists of features.  Supports effecient queries for sub-range  (chr, start, end)
   *
   * @param featureList
   * @param The genomic range spanned by featureList (optional)
   * @constructor
   */

  class FeatureCache$1 {

      constructor(featureList, genome, range) {

          featureList = featureList || [];
          this.treeMap = this.buildTreeMap(featureList, genome);
          this.range = range;
          this.count = featureList.length;
      }

      containsRange(genomicRange) {
          // No range means cache contains all features
          return (this.range === undefined || this.range.contains(genomicRange.chr, genomicRange.start, genomicRange.end));
      }

      queryFeatures(chr, start, end) {

          const tree = this.treeMap[chr];

          if (!tree) return [];

          const intervals = tree.findOverlapping(start, end);

          if (intervals.length === 0) {
              return [];
          } else {
              // Trim the list of features in the intervals to those
              // overlapping the requested range.
              // Assumption: features are sorted by start position

              const featureList = [];
              const all = this.allFeatures[chr];
              if (all) {
                  for (let interval of intervals) {
                      const indexRange = interval.value;
                      for (let i = indexRange.start; i < indexRange.end; i++) {
                          let feature = all[i];
                          if (feature.start > end) break;
                          else if (feature.end >= start) {
                              featureList.push(feature);
                          }
                      }
                  }
                  featureList.sort(function (a, b) {
                      return a.start - b.start;
                  });
              }
              return featureList;
          }
      };

      /**
       * Returns all features, unsorted.
       *
       * @returns {Array}
       */
      getAllFeatures() {
          return this.allFeatures;
      }

      buildTreeMap(featureList, genome) {

          const treeMap = {};
          const chromosomes = [];
          this.allFeatures = {};

          if (featureList) {
              for (let feature of featureList) {

                  let chr = feature.chr;
                  // Translate to "official" name
                  if (genome) {
                      chr = genome.getChromosomeName(chr);
                  }

                  let geneList = this.allFeatures[chr];
                  if (!geneList) {
                      chromosomes.push(chr);
                      geneList = [];
                      this.allFeatures[chr] = geneList;
                  }
                  geneList.push(feature);
              }


              // Now build interval tree for each chromosome
              for (let chr of chromosomes) {
                  const chrFeatures = this.allFeatures[chr];
                  chrFeatures.sort(function (f1, f2) {
                      return (f1.start === f2.start ? 0 : (f1.start > f2.start ? 1 : -1));
                  });
                  treeMap[chr] = buildIntervalTree$1(chrFeatures);
              }
          }

          return treeMap;
      }
  }

  /**
   * Build an interval tree from the feature list for fast interval based queries.   We lump features in groups
   * of 10, or total size / 100,   to reduce size of the tree.
   *
   * @param featureList
   */
  function buildIntervalTree$1(featureList) {

      const tree = new IntervalTree();
      const len = featureList.length;
      const chunkSize = Math.max(10, Math.round(len / 10));

      for (let i = 0; i < len; i += chunkSize) {
          const e = Math.min(len, i + chunkSize);
          const subArray = new IndexRange(i, e); //featureList.slice(i, e);
          const iStart = featureList[i].start;
          //
          let iEnd = iStart;
          for (let j = i; j < e; j++) {
              iEnd = Math.max(iEnd, featureList[j].end);
          }
          tree.insert(iStart, iEnd, subArray);
      }

      return tree;
  }


  class IndexRange {
      constructor(start, end) {
          this.start = start;
          this.end = end;
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const FeatureUtils = {

      packFeatures: function (features, maxRows, sorted) {

          var start;
          var end;

          if (!features) return;

          maxRows = maxRows || 10000;

          if (!sorted) {
              features.sort(function (a, b) {
                  return a.start - b.start;
              });
          }


          if (features.length === 0) {
              return [];

          } else {

              var bucketList = [],
                  allocatedCount = 0,
                  lastAllocatedCount = 0,
                  nextStart,
                  row,
                  index,
                  bucket,
                  feature,
                  gap = 2,
                  bucketStart;

              start = features[0].start;
              end = features[features.length - 1].start;

              bucketStart = Math.max(start, features[0].start);
              nextStart = bucketStart;

              features.forEach(function (alignment) {

                  var buckListIndex = Math.max(0, alignment.start - bucketStart);
                  if (bucketList[buckListIndex] === undefined) {
                      bucketList[buckListIndex] = [];
                  }
                  bucketList[buckListIndex].push(alignment);
              });


              row = 0;


              while (allocatedCount < features.length && row <= maxRows) {


                  while (nextStart <= end) {

                      bucket = undefined;

                      while (!bucket && nextStart <= end) {

                          index = nextStart - bucketStart;
                          if (bucketList[index] === undefined) {
                              ++nextStart;                     // No buckets at this index
                          } else {
                              bucket = bucketList[index];
                          }

                      } // while (bucket)

                      if (!bucket) {
                          break;
                      }
                      feature = bucket.pop();
                      if (0 === bucket.length) {
                          bucketList[index] = undefined;
                      }

                      feature.row = row;

                      nextStart = feature.end + gap;
                      ++allocatedCount;

                  } // while (nextStart)

                  row++;
                  nextStart = bucketStart;

                  if (allocatedCount === lastAllocatedCount) break;   // Protect from infinite loops

                  lastAllocatedCount = allocatedCount;

              } // while (allocatedCount)

          }
      },


      /**
       * Find features overlapping the given interval.  It is assumed that all features share the same chromosome.
       *
       * TODO -- significant overlap with FeatureCache, refactor to combine
       *
       * @param featureList
       * @param start
       * @param end
       */
      findOverlapping: function (featureList, start, end) {

          if (!featureList || featureList.length === 0) {
              return [];
          } else {
              const tree = buildIntervalTree(featureList);
              const intervals = tree.findOverlapping(start, end);

              if (intervals.length === 0) {
                  return [];
              } else {
                  // Trim the list of features in the intervals to those
                  // overlapping the requested range.
                  // Assumption: features are sorted by start position

                  featureList = [];

                  intervals.forEach(function (interval) {
                      const intervalFeatures = interval.value;
                      const len = intervalFeatures.length;
                      for (let i = 0; i < len; i++) {
                          const feature = intervalFeatures[i];
                          if (feature.start > end) break;
                          else if (feature.end > start) {
                              featureList.push(feature);
                          }
                      }
                  });

                  featureList.sort(function (a, b) {
                      return a.start - b.start;
                  });

                  return featureList;
              }
          }

      }
  };


  /**
   * Build an interval tree from the feature list for fast interval based queries.   We lump features in groups
   * of 10, or total size / 100,   to reduce size of the tree.
   *
   * @param featureList
   */
  function buildIntervalTree(featureList) {

      const tree = new IntervalTree();
      const len = featureList.length;
      const chunkSize = Math.max(10, Math.round(len / 100));

      featureList.sort(function (f1, f2) {
          return (f1.start === f2.start ? 0 : (f1.start > f2.start ? 1 : -1));
      });

      for (let i = 0; i < len; i += chunkSize) {
          const e = Math.min(len, i + chunkSize);
          const subArray = featureList.slice(i, e);
          const iStart = subArray[0].start;
          let iEnd = iStart;
          subArray.forEach(function (feature) {
              iEnd = Math.max(iEnd, feature.end);
          });
          tree.insert(iStart, iEnd, subArray);
      }

      return tree;
  }

  const appleCrayonRGBPalette =
      {
          cantaloupe: {r: 255, g: 206, b: 110},
          honeydew: {r: 206, g: 250, b: 110},
          spindrift: {r: 104, g: 251, b: 208},
          sky: {r: 106, g: 207, b: 255},
          lavender: {r: 210, g: 120, b: 255},
          carnation: {r: 255, g: 127, b: 211},
          licorice: {r: 0, g: 0, b: 0},
          snow: {r: 255, g: 255, b: 255},
          salmon: {r: 255, g: 114, b: 110},
          banana: {r: 255, g: 251, b: 109},
          flora: {r: 104, g: 249, b: 110},
          ice: {r: 104, g: 253, b: 255},
          orchid: {r: 110, g: 118, b: 255},
          bubblegum: {r: 255, g: 122, b: 255},
          lead: {r: 30, g: 30, b: 30},
          mercury: {r: 232, g: 232, b: 232},
          tangerine: {r: 255, g: 136, b: 2},
          lime: {r: 131, g: 249, b: 2},
          sea_foam: {r: 3, g: 249, b: 135},
          aqua: {r: 0, g: 140, b: 255},
          grape: {r: 137, g: 49, b: 255},
          strawberry: {r: 255, g: 41, b: 135},
          tungsten: {r: 58, g: 58, b: 58},
          silver: {r: 208, g: 208, b: 208},
          maraschino: {r: 255, g: 33, b: 1},
          lemon: {r: 255, g: 250, b: 3},
          spring: {r: 5, g: 248, b: 2},
          turquoise: {r: 0, g: 253, b: 255},
          blueberry: {r: 0, g: 46, b: 255},
          magenta: {r: 255, g: 57, b: 255},
          iron: {r: 84, g: 84, b: 83},
          magnesium: {r: 184, g: 184, b: 184},
          mocha: {r: 137, g: 72, b: 0},
          fern: {r: 69, g: 132, b: 1},
          moss: {r: 1, g: 132, b: 72},
          ocean: {r: 0, g: 74, b: 136},
          eggplant: {r: 73, g: 26, b: 136},
          maroon: {r: 137, g: 22, b: 72},
          steel: {r: 110, g: 110, b: 110},
          aluminum: {r: 160, g: 159, b: 160},
          cayenne: {r: 137, g: 17, b: 0},
          aspargus: {r: 136, g: 133, b: 1},
          clover: {r: 2, g: 132, b: 1},
          teal: {r: 0, g: 134, b: 136},
          midnight: {r: 0, g: 24, b: 136},
          plum: {r: 137, g: 30, b: 136},
          tin: {r: 135, g: 134, b: 135},
          nickel: {r: 136, g: 135, b: 135}
      };

  function appleCrayonRGB(name) {
      const {r, g, b} = appleCrayonRGBPalette[name];
      return `rgb(${r},${g},${b})`
  }

  function appleCrayonRGBA(name, alpha) {
      const {r, g, b} = appleCrayonRGBPalette[name];
      return `rgba(${r},${g},${b},${alpha})`
  }

  const colorPalettes = {

      Set1:
          [
              "rgb(228,26,28)",
              "rgb(55,126,184)",
              "rgb(77,175,74)",
              "rgb(166,86,40)",
              "rgb(152,78,163)",
              "rgb(255,127,0)",
              "rgb(247,129,191)",
              "rgb(153,153,153)",
              "rgb(255,255,51)"
          ],

      Dark2:
          [
              "rgb(27,158,119)",
              "rgb(217,95,2)",
              "rgb(117,112,179)",
              "rgb(231,41,138)",
              "rgb(102,166,30)",
              "rgb(230,171,2)",
              "rgb(166,118,29)",
              "rgb(102,102,102)"
          ],

      Set2:
          [
              "rgb(102, 194,165)",
              "rgb(252,141,98)",
              "rgb(141,160,203)",
              "rgb(231,138,195)",
              "rgb(166,216,84)",
              "rgb(255,217,47)",
              "rgb(229,196,148)",
              "rgb(179,179,179)"
          ],

      Set3:
          [
              "rgb(141,211,199)",
              "rgb(255,255,179)",
              "rgb(190,186,218)",
              "rgb(251,128,114)",
              "rgb(128,177,211)",
              "rgb(253,180,98)",
              "rgb(179,222,105)",
              "rgb(252,205,229)",
              "rgb(217,217,217)",
              "rgb(188,128,189)",
              "rgb(204,235,197)",
              "rgb(255,237,111)"
          ],

      Pastel1:
          [
              "rgb(251,180,174)",
              "rgb(179,205,227)",
              "rgb(204,235,197)",
              "rgb(222,203,228)",
              "rgb(254,217,166)",
              "rgb(255,255,204)",
              "rgb(229,216,189)",
              "rgb(253,218,236)"
          ],

      Pastel2:
          [
              "rgb(173,226,207)",
              "rgb(253,205,172)",
              "rgb(203,213,232)",
              "rgb(244,202,228)",
              "rgb(230,245,201)",
              "rgb(255,242,174)",
              "rgb(243,225,206)"
          ],

      Accent:
          [
              "rgb(127,201,127)",
              "rgb(190,174,212)",
              "rgb(253,192,134)",
              "rgb(255,255,153)",
              "rgb(56,108,176)",
              "rgb(240,2,127)",
              "rgb(191,91,23)"
          ]
  };

  class PaletteColorTable {

      constructor(palette) {
          this.colors = colorPalettes[palette];
          if (!Array.isArray(this.colors)) this.colors = [];
          this.colorTable = {};
          this.nextIdx = 0;
          this.colorGenerator = new RandomColorGenerator();
      }

      getColor(key) {
          if (!this.colorTable.hasOwnProperty(key)) {
              if (this.nextIdx < this.colors.length) {
                  this.colorTable[key] = this.colors[this.nextIdx];
              } else {
                  this.colorTable[key] = this.colorGenerator.get();
              }
              this.nextIdx++;
          }
          return this.colorTable[key]
      }
  }

  class ColorTable {
      constructor(colors) {
          this.colorTable = colors || {};
          this.nextIdx = 0;
          this.colorGenerator = new RandomColorGenerator();
      }

      getColor(key) {
          if (!this.colorTable.hasOwnProperty(key)) {
              if (this.colorTable.hasOwnProperty("*")) {
                  return this.colorTable["*"]
              }
              this.colorTable[key] = this.colorGenerator.get();
          }
          return this.colorTable[key]
      }
  }

  // Random color generator from https://github.com/sterlingwes/RandomColor/blob/master/rcolor.js
  // Free to use & distribute under the MIT license
  // Wes Johnson (@SterlingWes)
  //
  // inspired by http://martin.ankerl.com/2009/12/09/how-to-create-random-colors-programmatically/
  function RandomColorGenerator() {
      this.hue = Math.random();
      this.goldenRatio = 0.618033988749895;
      this.hexwidth = 2;
  }

  RandomColorGenerator.prototype.hsvToRgb = function (h, s, v) {
      var h_i = Math.floor(h * 6),
          f = h * 6 - h_i,
          p = v * (1 - s),
          q = v * (1 - f * s),
          t = v * (1 - (1 - f) * s),
          r = 255,
          g = 255,
          b = 255;
      switch (h_i) {
          case 0:
              r = v, g = t, b = p;
              break
          case 1:
              r = q, g = v, b = p;
              break
          case 2:
              r = p, g = v, b = t;
              break
          case 3:
              r = p, g = q, b = v;
              break
          case 4:
              r = t, g = p, b = v;
              break
          case 5:
              r = v, g = p, b = q;
              break
      }
      return [Math.floor(r * 256), Math.floor(g * 256), Math.floor(b * 256)]
  };

  RandomColorGenerator.prototype.padHex = function (str) {
      if (str.length > this.hexwidth) return str
      return new Array(this.hexwidth - str.length + 1).join('0') + str
  };

  RandomColorGenerator.prototype.get = function (saturation, value) {
      this.hue += this.goldenRatio;
      this.hue %= 1;
      if (typeof saturation !== "number") saturation = 0.5;
      if (typeof value !== "number") value = 0.95;
      var rgb = this.hsvToRgb(this.hue, saturation, value);

      return "#" + this.padHex(rgb[0].toString(16))
          + this.padHex(rgb[1].toString(16))
          + this.padHex(rgb[2].toString(16))

  };

  new RandomColorGenerator();

  function randomRGB$1(min, max) {

      min = IGVMath.clamp(min, 0, 255);
      max = IGVMath.clamp(max, 0, 255);

      const r = Math.round(Math.random() * (max - min) + min).toString(10);
      const g = Math.round(Math.random() * (max - min) + min).toString(10);
      const b = Math.round(Math.random() * (max - min) + min).toString(10);
      return `rgb(${r},${g},${b})`

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of ctx software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and ctx permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  const IGVGraphics = {

      configureHighDPICanvas: function (ctx, w, h) {

          const scaleFactor = window.devicePixelRatio;
          // const scaleFactor = 1

          ctx.canvas.style.width = (`${w}px`);
          ctx.canvas.width = Math.floor(scaleFactor * w);

          ctx.canvas.style.height = (`${h}px`);
          ctx.canvas.height = Math.floor(scaleFactor * h);

          ctx.scale(scaleFactor, scaleFactor);

      },

      setProperties: function (ctx, properties) {

          for (var key in properties) {
              if (properties.hasOwnProperty(key)) {
                  var value = properties[key];
                  ctx[key] = value;
              }
          }
      },

      strokeLine: function (ctx, x1, y1, x2, y2, properties) {

          x1 = Math.floor(x1) + 0.5;
          y1 = Math.floor(y1) + 0.5;
          x2 = Math.floor(x2) + 0.5;
          y2 = Math.floor(y2) + 0.5;

          if (properties) {
              ctx.save();
              IGVGraphics.setProperties(ctx, properties);
          }

          ctx.beginPath();
          ctx.moveTo(x1, y1);
          ctx.lineTo(x2, y2);
          ctx.stroke();

          if (properties) ctx.restore();
      },

      fillRect: function (ctx, x, y, w, h, properties) {
          x = Math.round(x);
          y = Math.round(y);

          if (properties) {
              ctx.save();
              IGVGraphics.setProperties(ctx, properties);
          }

          ctx.fillRect(x, y, w, h);

          if (properties) ctx.restore();
      },

      fillPolygon: function (ctx, x, y, properties) {
          if (properties) {
              ctx.save();
              IGVGraphics.setProperties(ctx, properties);
          }
          doPath(ctx, x, y);
          ctx.fill();
          if (properties) ctx.restore();
      },

      strokePolygon: function (ctx, x, y, properties) {
          if (properties) {
              ctx.save();
              IGVGraphics.setProperties(ctx, properties);
          }
          doPath(ctx, x, y);
          ctx.stroke();
          if (properties) ctx.restore();
      },

      fillText: function (ctx, text, x, y, properties, transforms) {

          if (properties || transforms) {
              ctx.save();
          }

          if (properties) {
              IGVGraphics.setProperties(ctx, properties);
          }

          if (transforms) {
              // Slow path with context saving and extra translate
              ctx.translate(x, y);

              for (var transform in transforms) {
                  var value = transforms[transform];

                  // TODO: Add error checking for robustness
                  if (transform === 'translate') {
                      ctx.translate(value['x'], value['y']);
                  }
                  if (transform === 'rotate') {
                      ctx.rotate(value['angle'] * Math.PI / 180);
                  }
              }

              ctx.fillText(text, 0, 0);
          } else {
              ctx.fillText(text, x, y);
          }

          if (properties || transforms) ctx.restore();
      },

      strokeText: function (ctx, text, x, y, properties, transforms) {


          if (properties || transforms) {
              ctx.save();
          }

          if (properties) {
              IGVGraphics.setProperties(ctx, properties);
          }

          if (transforms) {
              ctx.translate(x, y);

              for (var transform in transforms) {
                  var value = transforms[transform];

                  // TODO: Add error checking for robustness
                  if (transform === 'translate') {
                      ctx.translate(value['x'], value['y']);
                  }
                  if (transform === 'rotate') {
                      ctx.rotate(value['angle'] * Math.PI / 180);
                  }
              }

              ctx.strokeText(text, 0, 0);
          } else {
              ctx.strokeText(text, x, y);
          }

          if (properties || transforms) ctx.restore();
      },

      strokeCircle: function (ctx, x, y, radius, properties) {
          if (properties) {
              ctx.save();
              IGVGraphics.setProperties(ctx, properties);
          }
          ctx.beginPath();
          ctx.arc(x, y, radius, 0, 2 * Math.PI);
          ctx.stroke();
          if (properties) ctx.restore();
      },

      fillCircle: function (ctx, x, y, radius, properties) {
          if (properties) {
              ctx.save();
              IGVGraphics.setProperties(ctx, properties);
          }
          ctx.beginPath();
          ctx.arc(x, y, radius, 0, 2 * Math.PI);
          ctx.fill();
          if (properties) ctx.restore();
      },

      drawArrowhead: function (ctx, x, y, size, lineWidth) {

          ctx.save();
          if (!size) {
              size = 5;
          }
          if (lineWidth) {
              ctx.lineWidth = lineWidth;
          }
          ctx.beginPath();
          ctx.moveTo(x, y - size / 2);
          ctx.lineTo(x, y + size / 2);
          ctx.lineTo(x + size, y);
          ctx.lineTo(x, y - size / 2);
          ctx.closePath();
          ctx.fill();
          ctx.restore();
      },

      dashedLine: function (ctx, x1, y1, x2, y2, dashLen, properties = {}) {
          if (dashLen === undefined) dashLen = 2;
          ctx.setLineDash([dashLen, dashLen]);
          IGVGraphics.strokeLine(ctx, x1, y1, x2, y2, properties);
          ctx.setLineDash([]);
      },

      roundRect: function (ctx, x, y, width, height, radius, fill, stroke) {

          if (typeof stroke == "undefined") {
              stroke = true;
          }
          if (typeof radius === "undefined") {
              radius = 5;
          }
          ctx.beginPath();
          ctx.moveTo(x + radius, y);
          ctx.lineTo(x + width - radius, y);
          ctx.quadraticCurveTo(x + width, y, x + width, y + radius);
          ctx.lineTo(x + width, y + height - radius);
          ctx.quadraticCurveTo(x + width, y + height, x + width - radius, y + height);
          ctx.lineTo(x + radius, y + height);
          ctx.quadraticCurveTo(x, y + height, x, y + height - radius);
          ctx.lineTo(x, y + radius);
          ctx.quadraticCurveTo(x, y, x + radius, y);
          ctx.closePath();
          if (stroke) {
              ctx.stroke();
          }
          if (fill) {
              ctx.fill();
          }
      },
      polygon: function (ctx, x, y, fill, stroke) {

          if (typeof stroke == "undefined") {
              stroke = true;
          }

          ctx.beginPath();
          var len = x.length;
          ctx.moveTo(x[0], y[0]);
          for (var i = 1; i < len; i++) {
              ctx.lineTo(x[i], y[i]);
              // this.moveTo(x[i], y[i]);
          }

          ctx.closePath();
          if (stroke) {
              ctx.stroke();
          }
          if (fill) {
              ctx.fill();
          }
      },

      drawRandomColorVerticalLines: ctx => {
          for (let x = 0; x < ctx.canvas.width; x++) {
              IGVGraphics.fillRect(ctx, x, 0, 1, ctx.canvas.height, { fillStyle: randomRGB$1(100, 250) });
          }
      },

      labelTransformWithContext: (ctx, exe) => {
          ctx.translate(exe, 0);
          ctx.scale(-1, 1);
          ctx.translate(-exe, 0);
      }

  };

  function doPath(ctx, x, y) {


      var i, len = x.length;
      for (i = 0; i < len; i++) {
          x[i] = Math.round(x[i]);
          y[i] = Math.round(y[i]);
      }

      ctx.beginPath();
      ctx.moveTo(x[0], y[0]);
      for (i = 1; i < len; i++) {
          ctx.lineTo(x[i], y[i]);
      }
      ctx.closePath();
  }

  class Alert {
      constructor(parent) {
          this.dialog = new AlertDialog$1(parent);

      }

      present(alert, callback) {
          this.dialog.present(alert, callback);
      }
  }

  const FileFormats = {

      gwascatalog: {
          fields: [
              'bin',
              'chr',
              'start',
              'end',
              'name',
              'pubMedID',
              'author',
              'pubDate',
              'journal',
              'title',
              'trait',
              'initSample',
              'replSample',
              'region',
              'genes',
              'riskAllele',
              'riskAlFreq',
              'pValue',
              'pValueDesc',
              'orOrBeta',
              'ci95',
              'platform',
              'cnv'
          ]
      },

      wgrna: {
          fields:
              [
                  'bin',
                  'chr',
                  'start',
                  'end',
                  'name',
                  'score',
                  'strand',
                  'thickStart',
                  'thickEnd',
                  'type'
              ]
      },

      cpgislandext: {
          fields:

              [
                  'bin',
                  'chr',
                  'start',
                  'end',
                  'name',
                  'length',
                  'cpgNum',
                  'gcNum',
                  'perCpg',
                  'perGc',
                  'obsExp'
              ]
      },

      clinVarMain: {
          fields: [
              'chr1',
              'start',
              'end',
              'name',
              'score',
              'strand',
              'thickStart',
              'thickEnd',
              'reserved',
              'blockCount',  // Number of blocks
              'blockSizes',  // Comma separated list of block sizes
              'chromStarts', // Start positions relative to chromStart
              'origName',    // NM_198053.2(CD247):c.462C>T (p.Asp154=)	ClinVar Variation Report
              'clinSign',    // Likely benign	Clinical significance
              'reviewStatus', // 	based on: criteria provided,single submitter	Review Status
              'type',         // single nucleotide variant	Type of Variant
              'geneId', 	    // CD247	Gene Symbol
              'snpId',       //	181656780	dbSNP ID
              'nsvId',       //		dbVar ID
              'rcvAcc',      //	RCV000642347	ClinVar Allele Submission
              'testedInGtr', //	N	Genetic Testing Registry
              'phenotypeList', //	Immunodeficiency due to defect in cd3-zeta	Phenotypes
              'phenotype', //	MedGen:C1857798, OMIM:610163	Phenotype identifiers
              'origin', //	germline	Data origin
              'assembly', //	GRCh37	Genome assembly
              'cytogenetic', //	1q24.2	Cytogenetic status
              'hgvsCod', //	NM_198053.2:c.462C>T	Nucleotide HGVS
              'hgvsProt', //	NP_932170.1:p.Asp154=	Protein HGVS
              'numSubmit', //	1	Number of submitters
              'lastEval', //	Dec 19,2017	Last evaluation
              'guidelines', //		Guidelines
              'otherIds'
          ]
      }
  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Test if the given value is a string or number.  Not using typeof as it fails on boxed primitives.
   *
   * @param value
   * @returns boolean
   */

  function isSimpleType(value) {
      const simpleTypes = new Set(["boolean", "number", "string", "symbol"]);
      const valueType = typeof value;
      return (value !== undefined && (simpleTypes.has(valueType) || value.substring || value.toFixed))
  }

  function buildOptions(config, options) {

      var defaultOptions = {
          oauthToken: config.oauthToken,
          headers: config.headers,
          withCredentials: config.withCredentials,
          filename: config.filename
      };

      return Object.assign(defaultOptions, options)
  }

  /**
   * isMobile test from http://detectmobilebrowsers.com
   * TODO -- improve UI design so this isn't neccessary
   * @returns {boolean}
   */

  // igv.isMobile = function () {
  //
  //     const a = (navigator.userAgent || navigator.vendor || window.opera);
  //     return (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a) ||
  //         /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4)))
  //
  // }

  const doAutoscale = function (features) {
      var min, max;

      if (features && features.length > 0) {
          min = Number.MAX_VALUE;
          max = -Number.MAX_VALUE;

          for(let f of features) {
              if (!Number.isNaN(f.value)) {
                  min = Math.min(min, f.value);
                  max = Math.max(max, f.value);
              }
          }

          // Insure we have a zero baseline
          if (max > 0) min = Math.min(0, min);
          if (max < 0) max = 0;
      } else {
          // No features -- default
          min = 0;
          max = 100;
      }

      return {min: min, max: max}
  };

  const validateGenomicExtent = function (chromosomeLengthBP, genomicExtent, minimumBP) {

      let ss = genomicExtent.start;
      let ee = genomicExtent.end;

      if (undefined === ee) {

          ss -= minimumBP / 2;
          ee = ss + minimumBP;

          if (ee > chromosomeLengthBP) {
              ee = chromosomeLengthBP;
              ss = ee - minimumBP;
          } else if (ss < 0) {
              ss = 0;
              ee = minimumBP;
          }

      } else if (ee - ss < minimumBP) {

          const center = (ee + ss) / 2;

          if (center - minimumBP / 2 < 0) {
              ss = 0;
              ee = ss + minimumBP;
          } else if (center + minimumBP / 2 > chromosomeLengthBP) {
              ee = chromosomeLengthBP;
              ss = ee - minimumBP;
          } else {
              ss = center - minimumBP / 2;
              ee = ss + minimumBP;
          }
      }

      genomicExtent.start = Math.ceil(ss);
      genomicExtent.end = Math.floor(ee);
  };

  /*!
   * is-number <https://github.com/jonschlinkert/is-number>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Released under the MIT License.
   */

  const isNumber = function (num) {
      if (typeof num === 'number') {
          return num - num === 0
      }
      if (typeof num === 'string' && num.trim() !== '') {
          return Number.isFinite ? Number.isFinite(+num) : isFinite(+num)
      }
      return false
  };

  async function getFilename$1(url) {
      if (isString$2(url) && url.startsWith("https://drive.google.com")) {
          // This will fail if Google API key is not defined
          if (getApiKey$1() === undefined) {
              throw Error("Google drive is referenced, but API key is not defined.  An API key is required for Google Drive access")
          }
          const json = await getDriveFileInfo$1(url);
          return json.originalFileName || json.name
      } else {
          return getFilename$2(url)
      }
  }

  function prettyBasePairNumber(raw) {

      var denom,
          units,
          value,
          floored;

      if (raw > 1e7) {
          denom = 1e6;
          units = " mb";
      } else if (raw > 1e4) {

          denom = 1e3;
          units = " kb";

          value = raw / denom;
          floored = Math.floor(value);
          return numberFormatter$1(floored) + units
      } else {
          return numberFormatter$1(raw) + " bp"
      }

      value = raw / denom;
      floored = Math.floor(value);

      return floored.toString() + units
  }


  function isDataURL(obj) {
      return (isString$2(obj) && obj.startsWith("data:"))
  }

  function createColumn(columnContainer, className) {
      const column = domUtils.div({class: className});
      columnContainer.appendChild(column);
  }


  function insertElementBefore(element, referenceNode) {
      referenceNode.parentNode.insertBefore(element, referenceNode);
  }

  function insertElementAfter(element, referenceNode) {
      referenceNode.parentNode.insertBefore(element, referenceNode.nextSibling);
  }

  /**
   * Test to see if page is loaded in a secure context, that is by https or is localhost.
   */
  function isSecureContext() {
      return window.location.protocol === "https:" || window.location.hostname === "localhost"
  }

  // reference: https://pretagteam.com/question/find-element-height-including-margin
  function getElementAbsoluteHeight(element) {

      // Get the DOM Node if you pass in a string
      element = (typeof element === 'string') ? document.querySelector(element) : element;

      const styles = window.getComputedStyle(element);
      const margin = parseFloat(styles['marginTop']) + parseFloat(styles['marginBottom']);
      const height = element.offsetHeight;

      return Math.ceil(margin + height);
  }

  /**
   * Decoder for bedpe records.
   *
   * Bedpe format was created by Aaron Quinlan et al as part of the bedtools project.
   * The spec is here:  https://bedtools.readthedocs.io/en/latest/content/general-usage.html,
   *
   * 1      2      3    4      5      6    7    8     9       10      11-
   * chrom1 start1 end1 chrom2 start2 end2 name score strand1 strand2 <Any number of additional, user-defined fields>
   *
   * However there are off spec variants, an important one being a 7 column format with score in place of the standard
   * name column.
   *
   * A common variant is a "hiccups" output file, which is standard bedpe with the exception of a header line
   * of the form
   *
   * chr1    x1    x2    chr2    y1    y2    name    score    strand1    strand2    color    observed    expectedBL    expectedDonut    expectedH    expectedV    fdrBL    fdrDonut    fdrH    fdrV
   *
   * The "hiccups" output is apparently not standardized as this is found at ENCODE, with a non-helpful "tsv" extension
   *
   * chr1    x1    x2    chr2    y1    y2    color    observed    expectedBL    expectedDonut    expectedH    expectedV    fdrBL    fdrDonut    fdrH    fdrV    numCollapsed    centroid1    centroid2    radius
   * chr9    136790000    136795000    chr9    136990000    136995000    0,255,255    101.0    31.100368    38.40316    56.948116    34.040756    1.1876738E-13    1.05936405E-13    2.5148233E-4    1.7220993E-13    1    136792500    136992500    25590
   *
   * The "hiccups" documentation specfies yet another set of column headers
   * chromosome1    x1    x2    chromosome2    y1    y2    color    observed expected_bottom_left    expected_donut    expected_horizontal    expected_vertical fdr_bottom_left    fdr_donut    fdr_horizontal    fdr_vertical number_collapsed    centroid1    centroid2    radius
   *
   * @param tokens
   * @param ignore
   * @returns {{start1: number, end2: number, end1: number, chr1: *, chr2: *, start2: number}|undefined}
   */

  function decodeBedpe(tokens, header) {

      if (tokens.length < 6) {
          return undefined
      }

      var feature = {
          chr1: tokens[0],
          start1: Number.parseInt(tokens[1]),
          end1: Number.parseInt(tokens[2]),
          chr2: tokens[3],
          start2: Number.parseInt(tokens[4]),
          end2: Number.parseInt(tokens[5])
      };

      if (isNaN(feature.start1) || isNaN(feature.end1) || isNaN(feature.start2) || isNaN(feature.end2)) {
          //throw Error(`Error parsing line: ${tokens.join('\t')}`);
          return undefined
      }

      // Determine if this is a "hiccups" file.  Store result on "header" so it doesn't need repeated for every feature
      if(header && header.hiccups === undefined) {
          header.hiccups = header.columnNames ? isHiccups(header.columnNames) : false;
      }
      const hiccups = header && header.hiccups;
      const stdColumns = hiccups ? 6 : 10;

      if(!hiccups) {
          if (tokens.length > 6 && tokens[6] !== ".") {
              feature.name = tokens[6];
          }

          if (tokens.length > 7 && tokens[7] !== ".") {
              feature.score = Number(tokens[7]);
          }

          if (tokens.length > 8 && tokens[8] !== ".") {
              feature.strand1 = tokens[8];
          }

          if (tokens.length > 9 && tokens[9] !== ".") {
              feature.strand2 = tokens[9];
          }
      }

      // Optional extra columns
      if (header) {
          const colorColumn = header.colorColumn;
          if (colorColumn && colorColumn < tokens.length) {
              feature.color = IGVColor.createColorString(tokens[colorColumn]);
          }
          const thicknessColumn = header.thicknessColumn;
          if (thicknessColumn && thicknessColumn < tokens.length) {
              feature.thickness = tokens[thicknessColumn];
          }

          if (tokens.length > stdColumns && header.columnNames && header.columnNames.length === tokens.length) {
              feature.extras = tokens.slice(stdColumns);
          }
      }


      // Set total extent of feature
      if (feature.chr1 === feature.chr2) {
          feature.chr = feature.chr1;
          feature.start = Math.min(feature.start1, feature.start2);
          feature.end = Math.max(feature.end1, feature.end2);

      }
      return feature
  }

  /**
   * Hack for non-standard bedPE formats, where numeric score can be in column 7 (name field from spec)
   * @param features
   */
  function fixBedPE(features) {

      if (features.length == 0) return

      // Assume all features have same properties
      const firstFeature = features[0];
      if (firstFeature.score === undefined && firstFeature.name !== undefined) {
          // Name field (col 7) is sometimes used for score.
          for (let f of features) {
              if (!(isNumber(f.name) || f.name === '.')) return
          }
          for (let f of features) {
              f.score = Number(f.name);
              delete f.name;
          }
      }

      // Make copies of inter-chr features, one for each chromosome
      const interChrFeatures = features.filter(f => f.chr1 !== f.chr2);
      for (let f1 of interChrFeatures) {
          const f2 = Object.assign({}, f1);
          f2.dup = true;
          features.push(f2);

          f1.chr = f1.chr1;
          f1.start = f1.start1;
          f1.end = f1.end1;

          f2.chr = f2.chr2;
          f2.start = f2.start2;
          f2.end = f2.end2;
      }
  }


  /**
   * Special decoder for Hic Domain files.   In these files feature1 == feature2, they are really bed records.
   * @param tokens
   * @param ignore
   * @returns {*}
   */
  function decodeBedpeDomain(tokens, header) {

      if (tokens.length < 8) return undefined

      return {
          chr: tokens[0],
          start: Number.parseInt(tokens[1]),
          end: Number.parseInt(tokens[2]),
          color: IGVColor.createColorString(tokens[6]),
          value: Number(tokens[7])
      }
  }

  function isHiccups(columns) {
      return columns && (columns.includes("fdrDonut") || columns.includes("fdr_donut"))
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const knownFileExtensions = new Set([

      "narrowpeak",
      "broadpeak",
      "regionpeak",
      "peaks",
      "bedgraph",
      "wig",
      "gff3",
      "gff",
      "gtf",
      "fusionjuncspan",
      "refflat",
      "seg",
      "aed",
      "bed",
      "vcf",
      "bb",
      "bigbed",
      "biginteract",
      "biggenepred",
      "bignarrowpeak",
      "bw",
      "bigwig",
      "bam",
      "tdf",
      "refgene",
      "genepred",
      "genepredext",
      "bedpe",
      "bp",
      "snp",
      "rmsk",
      "cram",
      "gwas",
      "maf",
      "mut",
      "tsv",
      "hiccups",
      "fasta",
      "fa",
      "fna",
      "pytor"
  ]);

  /**
   * Return a custom format object with the given name.
   * @param name
   * @returns {*}
   */
  function getFormat(name) {

      if (FileFormats && FileFormats[name]) {
          return expandFormat(FileFormats[name])
      } else {
          return undefined
      }

      function expandFormat(format) {

          const fields = format.fields;
          const keys = ['chr', 'start', 'end'];

          for (let i = 0; i < fields.length; i++) {
              for (let key of keys) {
                  if (key === fields[i]) {
                      format[key] = i;
                  }
              }
          }

          return format
      }
  }

  function inferFileFormat(fn) {

      var idx, ext;

      fn = fn.toLowerCase();

      // Special case -- UCSC refgene files
      if (fn.endsWith("refgene.txt.gz") ||
          fn.endsWith("refgene.txt.bgz") ||
          fn.endsWith("refgene.txt") ||
          fn.endsWith("refgene.sorted.txt.gz") ||
          fn.endsWith("refgene.sorted.txt.bgz")) {
          return "refgene"
      }


      //Strip parameters -- handle local files later
      idx = fn.indexOf("?");
      if (idx > 0) {
          fn = fn.substr(0, idx);
      }

      //Strip aux extensions .gz, .tab, and .txt
      if (fn.endsWith(".gz")) {
          fn = fn.substr(0, fn.length - 3);
      }

      if (fn.endsWith(".txt") || fn.endsWith(".tab") || fn.endsWith(".bgz")) {
          fn = fn.substr(0, fn.length - 4);
      }


      idx = fn.lastIndexOf(".");
      ext = idx < 0 ? fn : fn.substr(idx + 1);

      switch (ext) {
          case "bw":
              return "bigwig"
          case "bb":
              return "bigbed"
          case "fasta":
          case "fa":
          case "fna":
              return "fasta"
          default:
              if (knownFileExtensions.has(ext)) {
                  return ext
              } else {
                  return undefined
              }

      }

  }

  function inferIndexPath(url, extension) {

      if (isString$2(url)) {
          if (url.includes("?")) {
              const idx = url.indexOf("?");
              return url.substring(0, idx) + "." + extension + url.substring(idx)
          } else {
              return url + "." + extension
          }
      } else {
          return undefined
      }
  }


  function inferTrackType(config) {

      translateDeprecatedTypes(config);

      if (config.type) {
          return config.type
      }

      if (config.format) {
          const format = config.format.toLowerCase();
          switch (format) {
              case "bw":
              case "bigwig":
              case "wig":
              case "bedgraph":
              case "tdf":
                  return "wig"
              case "vcf":
                  return "variant"
              case "seg":
                  return "seg"
              case "mut":
              case "maf":
                  return "mut"
              case "bam":
              case "cram":
                  return "alignment"
              case "hiccups":
              case "bedpe":
              case "bedpe-loop":
              case "biginteract":
                  return "interact"
              case "bp":
                  return "arc"
              case "gwas":
                  return "gwas"
              case "bed":
              case "bigbed":
              case "bb":
              case "biggenepred":
              case "bignarrowpeak":
                  return "bedtype"
              case "fasta":
                  return "sequence"
              case "pytor":
                  return "cnvpytor"
              default:
                  return "annotation"
          }
      }
  }

  function translateDeprecatedTypes(config) {

      if (config.featureType) {  // Translate deprecated "feature" type
          config.type = config.type || config.featureType;
          config.featureType = undefined;
      }
      if ("junctions" === config.type) {
          config.type = "junction";
      } else if ("bed" === config.type) {
          config.type = "annotation";
          config.format = config.format || "bed";
      } else if ("annotations" === config.type) {
          config.type = "annotation";
      } else if ("alignments" === config.type) {
          config.type = "alignment";
      } else if ("bam" === config.type) {
          config.type = "alignment";
          config.format = "bam";
      } else if ("vcf" === config.type) {
          config.type = "variant";
          config.format = "vcf";
      } else if ("t2d" === config.type) {
          config.type = "gwas";
      } else if ("FusionJuncSpan" === config.type && !config.format) {
          config.format = "fusionjuncspan";
      } else if ("aed" === config.type) {
          config.type = "annotation";
          config.format = config.format || "aed";
      }
  }

  /**
   * Attempt to infer the file format by reading a few lines from the header.  Currently this only supports "tsv" extensions,
   * it was added specifically for "hiccups" type tsv files in ENCODE.  Might be expanded in the future.
   *
   * @param url
   * @returns {Promise<void>}
   */
  async function inferFileFormatFromHeader(config) {

      if (config.url) {
          const firstBytes = await igvxhr$1.loadString(config.url, buildOptions(config, {range: {start: 0, size: 1000}}));
          if(firstBytes) {
              const columnNames = firstBytes.split('\n')[0].split('\t');
              if(isHiccups(columnNames)) {
                  return "hiccups"
              }
          }
      }

      return undefined

  }

  var TrackUtils = /*#__PURE__*/Object.freeze({
      __proto__: null,
      knownFileExtensions: knownFileExtensions,
      getFormat: getFormat,
      inferFileFormat: inferFileFormat,
      inferFileFormatFromHeader: inferFileFormatFromHeader,
      inferTrackType: inferTrackType,
      inferIndexPath: inferIndexPath
  });

  const pairs =
      [
          ['A', 'T'],
          ['G', 'C'],
          ['Y', 'R'],
          ['W', 'S'],
          ['K', 'M'],
          ['D', 'H'],
          ['B', 'V']
      ];

  const complements = new Map();
  for (let p of pairs) {
      const p1 = p[0];
      const p2 = p[1];
      complements.set(p1, p2);
      complements.set(p2, p1);
      complements.set(p1.toLowerCase(), p2.toLowerCase());
      complements.set(p2.toLowerCase(), p1.toLowerCase());
  }

  function reverseComplementSequence(sequence) {

      let comp = '';
      let idx = sequence.length;
      while (idx-- > 0) {
          const base = sequence[idx];
          comp += complements.has(base) ? complements.get(base) : base;
      }
      return comp
  }

  class Chromosome {
      constructor(name, order, bpLength) {
          this.name = name;
          this.order = order;
          this.bpLength = bpLength;
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const splitLines$4 = splitLines$5;

  const reservedProperties$1 = new Set(['fastaURL', 'indexURL', 'cytobandURL', 'indexed']);

  class NonIndexedFasta {


      constructor(reference) {

          this.fastaURL = reference.fastaURL;
          this.withCredentials = reference.withCredentials;
          this.chromosomeNames = [];
          this.chromosomes = {};
          this.sequences = new Map();

          // Build a track-like config object from the referenceObject
          const config = {};
          for (let key in reference) {
              if (reference.hasOwnProperty(key) && !reservedProperties$1.has(key)) {
                  config[key] = reference[key];
              }
          }
          this.config = config;
      }


      async init() {
          return this.loadAll()
      }

      async getSequence(chr, start, end) {

          if (!this.sequences.has(chr)) {
              return undefined
          }

          let seqSlice = this.sequences.get(chr).find(ss => ss.contains(start, end));
          if (!seqSlice) {
              seqSlice = this.sequences.get(chr).find(ss => ss.overlaps(start, end));
              if (!seqSlice) {
                  return undefined
              }
          }

          start -= seqSlice.offset;
          end -= seqSlice.offset;

          let prefix = "";
          if (start < 0) {
              for (let i = start; i < Math.min(end, 0); i++) {
                  prefix += "*";
              }
          }

          if (end <= 0) {
              return Promise.resolve(prefix)
          }

          const seq = seqSlice.sequence;
          const seqEnd = Math.min(end, seq.length);
          return prefix + seq.substring(start, seqEnd)
      }

      async loadAll() {

          let data;
          if (isDataURL(this.fastaURL)) {
              let bytes = decodeDataURI$1(this.fastaURL);
              data = "";
              for (let b of bytes) {
                  data += String.fromCharCode(b);
              }
          } else {
              data = await igvxhr$1.load(this.fastaURL, buildOptions(this.config));
          }

          const chrNameSet = new Set();
          const lines = splitLines$4(data);
          const len = lines.length;
          let lineNo = 0;
          let order = 0;
          let nextLine;
          let current = {};
          while (lineNo < len) {
              nextLine = lines[lineNo++].trim();
              if (nextLine.startsWith("#") || nextLine.length === 0) ; else if (nextLine.startsWith(">")) {
                  // Start the next sequence
                  if(current && current.seq) {
                      pushChromosome.call(this, current, order++);
                  }

                  const parts = nextLine.substr(1).split(/\s+/);

                  // Check for samtools style locus string.   This is not perfect, and could fail on weird sequence names
                  const nameParts = parts[0].split(':');
                  current.chr = nameParts[0];
                  current.seq = "";
                  current.offset = 0;
                  if (nameParts.length > 1 && nameParts[1].indexOf('-') > 0) {
                      const locusParts = nameParts[1].split('-');
                      if (locusParts.length === 2 &&
                          /^[0-9]+$/.test(locusParts[0]) &&
                          /^[0-9]+$/.test(locusParts[1])) ;
                      const from = Number.parseInt(locusParts[0]);
                      const to = Number.parseInt(locusParts[1]);
                      if (to > from) {   // TODO this should be an error
                          current.offset = from - 1;
                      }

                      // Check for chromosome length token
                      if (parts.length > 1 && parts[1].startsWith("@len=")) {
                          try {
                              current.length = parseInt(parts[1].trim().substring(5));
                          } catch (e) {
                              current.length = undefined;
                              console.error(`Error parsing sequence length for ${nextLine}`);
                          }
                      } else {
                          current.length = undefined;
                      }
                  }
              } else {
                  current.seq += nextLine;
              }
              // add last seq
              if (current && current.seq) {
                  pushChromosome.call(this, current, order);
              }
          }

          function pushChromosome(current, order) {
              const length = current.length || (current.offset + current.seq.length);
              if (!chrNameSet.has(current.chr)) {
                  this.chromosomeNames.push(current.chr);
                  this.sequences.set(current.chr, []);
                  this.chromosomes[current.chr] = new Chromosome(current.chr, order, length);
                  chrNameSet.add(current.chr);
              } else {
                  const c = this.chromosomes[current.chr];
                  c.bpLength = Math.max(c.bpLength, length);
              }
              this.sequences.get(current.chr).push(new SequenceSlice(current.offset, current.seq));
          }
      }
  }

  class SequenceSlice {

      constructor(offset, sequence) {
          this.offset = offset;
          this.sequence = sequence;
      }

      contains(start, end) {
          return this.offset <= start && this.end >= end
      }

      overlaps(start, end) {
          return this.offset < end && this.end > start
      }

      get end() {
          return this.offset + this.sequence.length
      }

  }

  const GenomicInterval = function (chr, start, end, features) {
      this.chr = chr;
      this.start = start;
      this.end = end;
      this.features = features;
  };

  GenomicInterval.prototype.contains = function (chr, start, end) {
      return this.chr === chr &&
          this.start <= start &&
          this.end >= end
  };

  GenomicInterval.prototype.containsRange = function (range) {
      return this.chr === range.chr &&
          this.start <= range.start &&
          this.end >= range.end
  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const splitLines$3 = splitLines$5;

  const reservedProperties = new Set(['fastaURL', 'indexURL', 'compressedIndexURL', 'cytobandURL', 'indexed']);

  class FastaSequence {

      constructor(reference) {

          this.file = reference.fastaURL;
          this.indexFile = reference.indexURL || reference.indexFile || this.file + ".fai";
          this.compressedIndexFile = reference.compressedIndexURL || false;
          this.withCredentials = reference.withCredentials;
          this.chromosomeNames = [];
          this.chromosomes = {};
          this.sequences = {};
          this.offsets = {};

          // Build a track-like config object from the referenceObject
          const config = {};
          for (let key in reference) {
              if (reference.hasOwnProperty(key) && !reservedProperties.has(key)) {
                  config[key] = reference[key];
              }
          }
          this.config = config;
      }


      async init() {
          return this.getIndex()
      }

      async getSequence(chr, start, end) {

          const hasCachedSquence = this.interval && this.interval.contains(chr, start, end);

          if (!hasCachedSquence) {

              // Expand query, to minimum of 50kb
              let qstart = start;
              let qend = end;
              if ((end - start) < 50000) {
                  const w = (end - start);
                  const center = Math.round(start + w / 2);
                  qstart = Math.max(0, center - 25000);
                  qend = center + 25000;
              }

              const seqBytes = await this.readSequence(chr, qstart, qend);
              this.interval = new GenomicInterval(chr, qstart, qend, seqBytes);
          }

          const offset = start - this.interval.start;
          const n = end - start;
          const seq = this.interval.features ? this.interval.features.substr(offset, n) : null;
          return seq
      }

      async getIndex() {

          if (this.index) {
              return this.index
          } else {
              const data = await igvxhr$1.load(this.indexFile, buildOptions(this.config));
              const lines = splitLines$3(data);
              const len = lines.length;
              let lineNo = 0;
              let order = 0;
              this.index = {};

              while (lineNo < len) {
                  const tokens = lines[lineNo++].split("\t");
                  const nTokens = tokens.length;

                  if (nTokens === 5) {
                      // Parse the index line.
                      const chr = tokens[0];
                      const size = parseInt(tokens[1]);
                      const position = parseInt(tokens[2]);
                      const basesPerLine = parseInt(tokens[3]);
                      const bytesPerLine = parseInt(tokens[4]);

                      const indexEntry = {
                          size: size,
                          position: position,
                          basesPerLine: basesPerLine,
                          bytesPerLine: bytesPerLine
                      };

                      this.chromosomeNames.push(chr);
                      this.index[chr] = indexEntry;
                      this.chromosomes[chr] = new Chromosome(chr, order++, size);
                  }
              }
              return this.index
          }
      }


      //Code is losely based on https://github.com/GMOD/bgzf-filehandle
      //Reworked however in orde to work with the igvxhr interface for loading files
      //Additionally, replaced calls to the Long.js interface with standard JS calls for ArrayBuffers and the associated views
      //
      //The compressed index is an array of blocks, with each block being a pair: compressed-position & uncompressed-position (both in bytes)
      async getCompressedIndex() {
          const GZI_NUM_BYTES_OFFSET = 8;
          const GZI_NUM_BYTES_BLOCK = 8;
          if (this.compressedIndex) {
              return this.compressedIndex
          }
          if (!this.compressedIndexFile) {
              this.compressedIndex = [];
              return this.compressedIndex
          }
          //In contrast to the 'normal' reference (for which the index is chromosome based), this index is block-based
          //As such there is not need to make it a hash. An array is sufficient.
          this.compressedIndex = [];
          const gziData = await igvxhr$1.loadArrayBuffer(this.compressedIndexFile, buildOptions(this.config));
          const givenFileSize = gziData.byteLength;
          if (givenFileSize < GZI_NUM_BYTES_OFFSET) {
              return this.compressedIndex
          }
          //First 8 bytes are a little endian unsigned bigint (64bit), indicating the number of blocks in the index.
          const numBlocksBuffer = gziData.slice(0, GZI_NUM_BYTES_OFFSET);
          const numBlocks = Number((new DataView(numBlocksBuffer)).getBigUint64(0, true));
          //The remainder of the gzi content are pairs of little endian unsigned bigint (64bit) numbers.
          //The first of the pair is the compressed position of a block
          //The second of the pair is the uncompressed position of a block

          //Sanity check:
          //Is the size of the array-buffer (of the entire file) correct with regards to the number of blocks detailled by the first 8 bytes of the file?
          //Total file-size should be:
          // 8 + 2*(num_entries*8) bytes, with the first 8 bytes indicating the number of entries
          const expectedFileSize = GZI_NUM_BYTES_OFFSET + numBlocks * 2 * GZI_NUM_BYTES_BLOCK;
          if (givenFileSize != expectedFileSize) {
              return this.compressedIndex
          }

          //Push the first block to the index: the first block always has positions 0 for both the compressed and uncompressed file
          this.compressedIndex.push([0, 0]);

          //Further process all the blocks of the GZI index, and keep them in memory
          for (let blockNumber = 0; blockNumber < numBlocks; blockNumber++) {
              const bufferBlockStart = GZI_NUM_BYTES_OFFSET + blockNumber * 2 * GZI_NUM_BYTES_BLOCK;
              const bufferBlockEnd = GZI_NUM_BYTES_OFFSET + blockNumber * 2 * GZI_NUM_BYTES_BLOCK + 2 * GZI_NUM_BYTES_BLOCK;
              const bufferBlock = gziData.slice(bufferBlockStart, bufferBlockEnd);
              const viewBlock = new DataView(bufferBlock);
              const compressedPosition = Number(viewBlock.getBigUint64(0, true));  //First 8 bytes
              const uncompressedPosition = Number(viewBlock.getBigUint64(GZI_NUM_BYTES_BLOCK, true)); //Last 8 bytes
              this.compressedIndex.push([compressedPosition, uncompressedPosition]);
          }
          return this.compressedIndex
      }

      //The Fasta-index gives a byte-position of the chromosomal sequences within the FASTA file.
      //These locations need to be remapped to the locations within the zipped reference genome, using the GZI index
      //This function provides this functionality by 
      //1) taking the indicated start/stop byte locations within the UNCOMPRESSED FASTA file
      //2) remapping these byte locations to the correct blocks (and associated positions) within the COMPRESSED FASTA file
      //Subsequently, the calling method can then extract the correct blocks from the compressed FASTA files and uncompressed the data
      async getRelevantCompressedBlockNumbers(queryPositionStart, queryPositionEnd) {
          const UNCOMPRESSED_POSITION = 1;
          //Fallback for impossible values
          if (queryPositionStart < 0 || queryPositionEnd < 0 || queryPositionEnd < queryPositionStart) {
              return []
          }
          //Ensure compressed index is loaded
          await this.getCompressedIndex();
          let result = [];
          //Now search for the correct block-numbers (going from 0 to length(compressed-index)) which overlap with the provided byte-positions
          const lowestBlockNumber = 0;
          const highestBlockNumber = this.compressedIndex.length - 1;
          //Failsafe if for some reason the compressed index wasn't loaded or doesn't contain any data
          if (this.compressedIndex.length == 0) {
              return []
          }
          //Failsafe: if the queryPositionStart is greater than the uncompressed-position of the final block,
          //then this final block is the only possible result
          if (queryPositionStart > (this.compressedIndex)[highestBlockNumber][UNCOMPRESSED_POSITION]) {
              return [highestBlockNumber]
          }

          //Rather than doing a linear search over all blocks, a binary search is done for speed considerations
          //We are searching for the highest block number for which its position is smaller than the query start position
          //Afterwards we will simply expand the blocks until the entire query range is covered
          let searchLow = lowestBlockNumber;
          let searchHigh = highestBlockNumber;
          let searchPosition = Math.floor(this.compressedIndex.length / 2);
          let maxIterations = this.compressedIndex.length + 1;
          let solutionFound = false;
          //instead of doing a while(true), this for-loop prevents eternal loops in case of issues
          for (let iteration = 0; iteration < maxIterations; iteration++) {
              const searchUncompressedPosition = (this.compressedIndex)[searchPosition][UNCOMPRESSED_POSITION];
              const nextSearchUncompressedPosition = (searchPosition < (this.compressedIndex.length - 1)) ? (this.compressedIndex)[searchPosition + 1][UNCOMPRESSED_POSITION] : Infinity;
              //The query position lies within the current search block
              if (searchUncompressedPosition <= queryPositionStart && nextSearchUncompressedPosition > queryPositionStart) {
                  solutionFound = true;
                  break //searchPosition is the correct block number index
              }
              //Current block lies before the query position
              else if (searchUncompressedPosition < queryPositionStart) {
                  searchLow = searchPosition + 1;
              }
              //Current block lies after the query position
              else {
                  searchHigh = searchPosition - 1;
              }
              searchPosition = Math.ceil((searchHigh - searchLow) / 2) + searchLow;
          }
          //If for some reason the binary search did not reveal a correct block index, then we return the empty result
          if (!solutionFound) {
              return []
          }

          //Now extend the result by adding additional blocks until the entire query range is covered
          result.push(searchPosition);
          for (let blockIndex = searchPosition + 1; blockIndex < this.compressedIndex.length; blockIndex++) {
              result.push(blockIndex);
              const blockUncompressedPosition = (this.compressedIndex)[blockIndex][UNCOMPRESSED_POSITION];
              if (blockUncompressedPosition >= queryPositionEnd) {
                  break
              }
          }

          //It is possible that the query end position lies AFTER the start of the final block
          //If this is the case, we add a 'fake' negative index which will be interpreted by the loadAndUncompressBlocks method as an indicator
          //to read until the end of the file 
          const finalRelevantBlock = result[result.length - 1];
          const finalIndexBlock = this.compressedIndex.length - 1;
          if (finalRelevantBlock === finalIndexBlock && (this.compressedIndex)[finalRelevantBlock][UNCOMPRESSED_POSITION] < queryPositionEnd) {
              result.push(-1);
          }

          return result
      }


      //Load the content from the blockIndices.
      //This is done on a per-block basis
      //Content of the first block will be trimmed in order to match the expected offset
      async loadAndUncompressBlocks(blockIndices, startByte) {
          const COMPRESSED_POSITION = 0;
          const UNCOMPRESSED_POSITION = 1;
          //Normally the compressed index should already exist, we're just makeing sure here
          await this.getCompressedIndex();

          if (blockIndices.length == 0) {
              return ""
          }

          //Storing data in seperate array with indices in order to assert order due to async behaviour of loops
          let resultCache = Array(blockIndices.length - 1);
          for (let i = 0; i < blockIndices.length - 1; i++) {
              const currentBlockNumber = blockIndices[i];
              const currentBlockInfo = (this.compressedIndex)[currentBlockNumber];
              const currentBlockCompressedPosition = currentBlockInfo[COMPRESSED_POSITION];

              const nextBlockNumber = blockIndices[i + 1];
              let compressedBytes = [];
              if (nextBlockNumber != -1) {  //default : read current entire block only
                  const nextBlockInfo = (this.compressedIndex)[nextBlockNumber];
                  const nextBlockCompressedPosition = nextBlockInfo[COMPRESSED_POSITION];
                  const compressedLength = nextBlockCompressedPosition - currentBlockCompressedPosition;
                  compressedBytes = await igvxhr$1.loadArrayBuffer(this.file, buildOptions(this.config, {
                      range: {
                          start: currentBlockCompressedPosition,
                          size: compressedLength
                      }
                  }));
              } else {   // special case for query within final block: read until the end of the file
                  compressedBytes = await igvxhr$1.loadArrayBuffer(this.file, buildOptions(this.config, {
                      range: {
                          start: currentBlockCompressedPosition
                      }
                  }));
              }
              //now unzip the compressed bytes, and store them in the resultCache
              const uncompressedBytes = await unbgzf$1(compressedBytes);
              resultCache[i] = uncompressedBytes;
          }

          //Iterate over the result cache, create sequences from the data, and create a full sequence string from the data
          let result = "";
          for (let i = 0; i < resultCache.length; i++) {
              for (let j = 0; j < resultCache[i].length; j++) {
                  const c = String.fromCharCode(resultCache[i][j]);
                  result = result + c;
              }
          }

          //postprocess this data: because entire blocks are read we need to remove the first N bases of the first used block, 
          //which are not included in the original query positions
          const firstBlockInfo = (this.compressedIndex)[blockIndices[0]];
          const offset = startByte - firstBlockInfo[UNCOMPRESSED_POSITION];
          result = result.substring(offset);

          return result
      }


      async readSequence(chr, qstart, qend) {

          await this.getIndex();
          await this.getCompressedIndex(); //This will work even if no compressed index file is set

          const idxEntry = this.index[chr];
          if (!idxEntry) {
              // Tag interval with null so we don't try again
              this.interval = new GenomicInterval(chr, qstart, qend, null);
              return null
          }

          const start = Math.max(0, qstart);    // qstart should never be < 0
          const end = Math.min(idxEntry.size, qend);
          const bytesPerLine = idxEntry.bytesPerLine;
          const basesPerLine = idxEntry.basesPerLine;
          const position = idxEntry.position;
          const nEndBytes = bytesPerLine - basesPerLine;
          const startLine = Math.floor(start / basesPerLine);
          const endLine = Math.floor(end / basesPerLine);
          const base0 = startLine * basesPerLine;   // Base at beginning of start line
          const offset = start - base0;
          const startByte = position + startLine * bytesPerLine + offset;
          const base1 = endLine * basesPerLine;
          const offset1 = end - base1;
          const endByte = position + endLine * bytesPerLine + offset1 - 1;
          const byteCount = endByte - startByte + 1;

          if (byteCount <= 0) {
              console.error("No sequence for " + chr + ":" + qstart + "-" + qend);
              return null
          }

          //If the compressed index file is set, then we are dealing with a compressed genome sequence
          //The selection of startByte/endByte is done for the non-compressed genome sequence.
          //These need to be 'converted' to the correct byte positions in the compressed genome sequence,
          //by making use of the compressed index (GZI file)
          let allBytes;
          if (!this.compressedIndexFile) {
              allBytes = await igvxhr$1.load(this.file, buildOptions(this.config, {
                  range: {
                      start: startByte,
                      size: byteCount
                  }
              }));
          } else {
              let relevantBlockIndices = await this.getRelevantCompressedBlockNumbers(startByte, endByte);
              if (relevantBlockIndices.length === 0) {
                  return null
              }
              allBytes = await this.loadAndUncompressBlocks(relevantBlockIndices, startByte);
          }

          if (!allBytes) {
              return null
          }

          let nBases,
              seqBytes = "",
              srcPos = 0,
              allBytesLength = allBytes.length;

          if (offset > 0) {
              nBases = Math.min(end - start, basesPerLine - offset);
              seqBytes += allBytes.substr(srcPos, nBases);
              srcPos += (nBases + nEndBytes);
          }

          while (srcPos < allBytesLength) {
              nBases = Math.min(basesPerLine, allBytesLength - srcPos);
              seqBytes += allBytes.substr(srcPos, nBases);
              srcPos += (nBases + nEndBytes);
          }

          return seqBytes

      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const splitLines$2 = splitLines$5;

  class ChromSizes {


      constructor(url) {
          this.url = url;
          this.chromosomeNames = [];
          this.chromosomes = {};
      }


      async init() {
          return this.loadAll()
      }

      async getSequence(chr, start, end) {

          return undefined // TODO -- return array of "N"s?
      }

      async loadAll() {

          let data;
          if (isDataURL(this.url)) {
              let bytes = decodeDataURI$1(this.fastaURL);
              data = "";
              for (let b of bytes) {
                  data += String.fromCharCode(b);
              }
          } else {
              data = await igvxhr$1.load(this.url, {});
          }


          this.chromosomeNames = [];
          this.chromosomes = {};

          const lines = splitLines$2(data);
          let order = 0;
          for (let nextLine of lines) {
              const tokens = nextLine.split('\t');
              this.chromosomeNames.push(tokens[0]);
              const chrLength = Number.parseInt(tokens[1]);
              const chromosome = new Chromosome(tokens[0], order++, chrLength);
              this.chromosomes[tokens[0]] = chromosome;

          }
      }

  }

  async function loadFasta(reference) {

      let fasta;
      if ("chromsizes" === reference.format) {
          fasta = new ChromSizes(reference.fastaURL);
      } else if (isDataURL(reference.fastaURL) || reference.indexed === false) {
          fasta = new NonIndexedFasta(reference);
      } else {
          fasta = new FastaSequence(reference);
      }
      await fasta.init();
      return fasta
  }

  const defaultNucleotideColors = {
      "A": "rgb(  0, 200,   0)",
      "C": "rgb(  0,0,200)",
      "T": "rgb(255,0,0)",
      "G": "rgb(209,113,  5)",
      "N": "rgb(80,80,80)"
  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const defaultSequenceTrackOrder = Number.MIN_SAFE_INTEGER;

  const translationDict = {
      'TTT': 'F',
      'TTC': 'F',
      'TTA': 'L',
      'TTG': 'L',
      'CTT': 'L',
      'CTC': 'L',
      'CTA': 'L',
      'CTG': 'L',
      'ATT': 'I',
      'ATC': 'I',
      'ATA': 'I',
      'ATG': 'M',
      'GTT': 'V',
      'GTC': 'V',
      'GTA': 'V',
      'GTG': 'V',
      'TCT': 'S',
      'TCC': 'S',
      'TCA': 'S',
      'TCG': 'S',
      'CCT': 'P',
      'CCC': 'P',
      'CCA': 'P',
      'CCG': 'P',
      'ACT': 'T',
      'ACC': 'T',
      'ACA': 'T',
      'ACG': 'T',
      'GCT': 'A',
      'GCC': 'A',
      'GCA': 'A',
      'GCG': 'A',
      'TAT': 'Y',
      'TAC': 'Y',
      'TAA': 'STOP',
      'TAG': 'STOP',
      'CAT': 'H',
      'CAC': 'H',
      'CAA': 'Q',
      'CAG': 'Q',
      'AAT': 'N',
      'AAC': 'N',
      'AAA': 'K',
      'AAG': 'K',
      'GAT': 'D',
      'GAC': 'D',
      'GAA': 'E',
      'GAG': 'E',
      'TGT': 'C',
      'TGC': 'C',
      'TGA': 'STOP',
      'TGG': 'W',
      'CGT': 'R',
      'CGC': 'R',
      'CGA': 'R',
      'CGG': 'R',
      'AGT': 'S',
      'AGC': 'S',
      'AGA': 'R',
      'AGG': 'R',
      'GGT': 'G',
      'GGC': 'G',
      'GGA': 'G',
      'GGG': 'G'
  };

  const complement = {};
  const t1 = ['A', 'G', 'C', 'T', 'Y', 'R', 'W', 'S', 'K', 'M', 'D', 'V', 'H', 'B', 'N', 'X'];
  const t2 = ['T', 'C', 'G', 'A', 'R', 'Y', 'W', 'S', 'M', 'K', 'H', 'B', 'D', 'V', 'N', 'X'];
  for (let i = 0; i < t1.length; i++) {
      complement[t1[i]] = t2[i];
      complement[t1[i].toLowerCase()] = t2[i].toLowerCase();
  }

  const DEFAULT_HEIGHT = 25;
  const TRANSLATED_HEIGHT = 115;
  const SEQUENCE_HEIGHT = 15;
  const FRAME_HEIGHT = 25;
  const FRAME_BORDER = 5;
  const BP_PER_PIXEL_THRESHOLD = 1 / 10;

  const bppFeatureFetchThreshold = 10;

  class SequenceTrack {

      constructor(config, browser) {

          this.config = config;
          this.browser = browser;
          this.type = "sequence";
          this.removable = config.removable === undefined ? true : config.removable;      // Defaults to true
          this.name = config.name;
          this.id = config.id;
          this.sequenceType = config.sequenceType || "dna";             //   dna | rna | prot
          this.disableButtons = false;
          this.order = config.order || defaultSequenceTrackOrder;
          this.ignoreTrackMenu = false;

          this.reversed = config.reversed === true;
          this.frameTranslate = config.frameTranslate === true;
          this.height = this.frameTranslate ? TRANSLATED_HEIGHT : DEFAULT_HEIGHT;

          // Hack for backward compatibility
          if(config.url) {
              config.fastaURL = config.url;
          }

          if(!config.fastaURL) {
              // Mark this as the genome reference sequence ==> backward compatibility convention
              this.id = config.id || "sequence";
          }

      }

      menuItemList() {
          return [
              {
                  name: this.reversed ? "Forward" : "Reverse",
                  click: () => {
                      this.reversed = !this.reversed;
                      this.trackView.repaintViews();
                  }
              },
              {
                  name: this.frameTranslate ? "Close Translation" : "Three-frame Translate",
                  click: () => {
                      this.frameTranslate = !this.frameTranslate;
                      if (this.frameTranslate) {
                          for (let vp of this.trackView.viewports) {
                              vp.setContentHeight(TRANSLATED_HEIGHT);
                          }
                          this.trackView.setTrackHeight(TRANSLATED_HEIGHT);
                      } else {
                          for (let vp of this.trackView.viewports) {
                              vp.setContentHeight(DEFAULT_HEIGHT);
                          }
                          this.trackView.setTrackHeight(DEFAULT_HEIGHT);
                      }
                      this.trackView.repaintViews();

                  }
              }
          ]
      }

      contextMenuItemList(clickState) {
          const viewport = clickState.viewport;
          if (viewport.referenceFrame.bpPerPixel <= 1) {
              const pixelWidth = viewport.getWidth();
              const bpWindow = pixelWidth * viewport.referenceFrame.bpPerPixel;
              const chr = viewport.referenceFrame.chr;
              const start = Math.floor(viewport.referenceFrame.start);
              const end = Math.ceil(start + bpWindow);
              const items = [
                  {
                      label: this.reversed ? 'View visible sequence (reversed)...' : 'View visible sequence...',
                      click: async () => {
                          let seq = await this.browser.genome.sequence.getSequence(chr, start, end);
                          if (!seq) {
                              seq = "Unknown sequence";
                          } else if (this.reversed) {
                              seq = reverseComplementSequence(seq);
                          }
                          this.browser.alert.present(seq);
                      }
                  }
              ];
              if (isSecureContext()) {
                  items.push({
                      label: 'Copy visible sequence',
                      click: async () => {
                          let seq = await this.browser.genome.sequence.getSequence(chr, start, end);
                          if (!seq) {
                              seq = "Unknown sequence";
                          } else if (this.reversed) {
                              seq = reverseComplementSequence(seq);
                          }
                          try {
                              await navigator.clipboard.writeText(seq);
                          } catch (e) {
                              console.error(e);
                              this.browser.alert.present(`error copying sequence to clipboard ${e}`);
                          }
                      }

                  });
              }
              items.push('<hr/>');

              return items
          } else {
              return undefined
          }
      }

      translateSequence(seq) {

          const threeFrame = [[], [], []];

          for (let fNum of [0, 1, 2]) {
              let idx = fNum;

              while ((seq.length - idx) >= 3) {
                  let st = seq.slice(idx, idx + 3);
                  if (this.reversed) {
                      st = st.split('').reverse().join('');
                  }

                  const aa = translationDict[st.toUpperCase()] || "";
                  threeFrame[fNum].push({
                      codons: st,
                      aminoA: aa
                  });
                  idx += 3;
              }
          }

          return threeFrame
      }

      /**
       * Return the source for sequence.  If an explicit fasta url is defined, use it, otherwise fetch sequence
       * from the current genome
       * *
       * @returns {Promise<WrappedFasta|*>}
       */
      async getSequenceSource() {
          if(this.config.fastaURL) {
              if(!this.fasta) {
                  this.fasta = new WrappedFasta(this.config, this.browser.genome);
                  await this.fasta.init();
              }
              return this.fasta
          } else {
              return this.browser.genome.sequence
          }
      }

      async getFeatures(chr, start, end, bpPerPixel) {

          start = Math.floor(start);
          end = Math.floor(end);

          if (bpPerPixel && bpPerPixel > bppFeatureFetchThreshold) {
              return null
          } else {
              const sequenceSource = await this.getSequenceSource();
              const sequence = await sequenceSource.getSequence(chr, start, end);
              return {
                  bpStart: start,
                  sequence: sequence
              }
          }
      }

      draw(options) {

          const ctx = options.context;

          if (options.features) {

              let sequence = options.features.sequence;
              if(!sequence) {
                  return
              }

              if (this.reversed) {
                  sequence = sequence.split('').map(function (cv) {
                      return complement[cv]
                  }).join('');
              }

              const sequenceBpStart = options.features.bpStart;  // genomic position at start of sequence
              const bpEnd = 1 + options.bpStart + (options.pixelWidth * options.bpPerPixel);

              for (let bp = Math.floor(options.bpStart); bp <= bpEnd; bp++) {

                  const seqIdx = Math.floor(bp - sequenceBpStart);

                  if (seqIdx >= 0 && seqIdx < sequence.length) {

                      const offsetBP = bp - options.bpStart;
                      const aPixel = offsetBP / options.bpPerPixel;
                      const pixelWidth = 1 / options.bpPerPixel;
                      const baseLetter = sequence[seqIdx];
                      const color = this.fillColor(baseLetter.toUpperCase());

                      if (options.bpPerPixel > BP_PER_PIXEL_THRESHOLD) {
                          IGVGraphics.fillRect(ctx, aPixel, FRAME_BORDER, pixelWidth, SEQUENCE_HEIGHT - FRAME_BORDER, {fillStyle: color});
                      } else {
                          const textPixel = aPixel + 0.5 * (pixelWidth - ctx.measureText(baseLetter).width);




                          if ('y' === options.axis) {
                              ctx.save();
                              IGVGraphics.labelTransformWithContext(ctx, textPixel);
                              IGVGraphics.strokeText(ctx, baseLetter, textPixel, SEQUENCE_HEIGHT, {strokeStyle: color});
                              ctx.restore();
                          } else {
                              IGVGraphics.strokeText(ctx, baseLetter, textPixel, SEQUENCE_HEIGHT, {strokeStyle: color});
                          }

                      }
                  }
              }

              if (this.frameTranslate) {

                  let y = SEQUENCE_HEIGHT + 2 * FRAME_BORDER;
                  const translatedSequence = this.translateSequence(sequence);

                  for (let fNum = 0; fNum < translatedSequence.length; fNum++) {    // == 3, 1 for each frame

                      const aaSequence = translatedSequence[fNum];  // AA sequence for this frame

                      for (let idx = 0; idx < aaSequence.length; idx++) {

                          let color = 0 === idx % 2 ? 'rgb(160,160,160)' : 'rgb(224,224,224)';
                          const cv = aaSequence[idx];

                          const bpPos = sequenceBpStart + fNum + (idx * 3);
                          const bpOffset = bpPos - options.bpStart;
                          const p0 = Math.floor(bpOffset / options.bpPerPixel);
                          const p1 = Math.floor((bpOffset + 3) / options.bpPerPixel);
                          const pc = Math.round((p0 + p1) / 2);

                          if (p1 < 0) {
                              continue   // off left edge
                          } else if (p0 > options.pixelWidth) {
                              break      // off right edge
                          }

                          let aaLabel = cv.aminoA;
                          if (cv.aminoA.indexOf('STOP') > -1) {
                              color = 'rgb(255, 0, 0)';
                              aaLabel = 'STOP'; //Color blind accessible
                          } else if (cv.aminoA === 'M') {
                              color = 'rgb(0, 153, 0)';
                              aaLabel = 'START'; //Color blind accessible
                          }

                          IGVGraphics.fillRect(ctx, p0, y, p1 - p0, FRAME_HEIGHT, {fillStyle: color});

                          if (options.bpPerPixel <= 1 / 10) {
                              IGVGraphics.strokeText(ctx, aaLabel, pc - (ctx.measureText(aaLabel).width / 2), y + 15);
                          }
                      }
                      y += (FRAME_HEIGHT + FRAME_BORDER);
                  }
              }
          }
      }

      get supportsWholeGenome() {
          return false
      }

      computePixelHeight(ignore) {
          this.height = this.frameTranslate ? TRANSLATED_HEIGHT : DEFAULT_HEIGHT;
          return this.height
      }

      fillColor(index) {

          if (this.color) {
              return this.color
          } else if ("dna" === this.sequenceType) {
              // return this.browser.nucleotideColors[index] || 'gray'
              return defaultNucleotideColors[index] || 'gray'
          } else {
              return 'rgb(0, 0, 150)'
          }
      }

      /**
       * Return the current state of the track.  Used to create sessions and bookmarks.
       *
       * @returns {*|{}}
       */
      getState() {
          const config = {
              type: "sequence"
          };
          if (this.order !== defaultSequenceTrackOrder) {
              config.order = this.order;
          }
          if (this.reversed) {
              config.revealed = true;
          }
          return config
      }

  }

  /**
   * Wrapper for a Fasta object that does chr name alias translation.   This is not neccessary for the genome fasta,
   * as it defines the reference name, but can be neccessary if loading an additional fasta as a track
   *
   */
  class WrappedFasta {

      constructor(config, genome) {
          this.config = config;
          this.genome = genome;
      }

      async init() {
          this.fasta = await loadFasta(this.config);
          this.chrNameMap = new Map();
          for(let name of this.fasta.chromosomeNames) {
              this.chrNameMap.set(this.genome.getChromosomeName(name), name);
          }
      }

      async getSequence(chr, start, end) {
          const chrName = this.chrNameMap.has(chr) ? this.chrNameMap.get(chr) : chr;
          return this.fasta.getSequence(chrName, start, end)
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class Viewport {

      constructor(trackView, viewportColumn, referenceFrame, width) {

          this.guid = domUtils.guid();
          this.trackView = trackView;
          this.referenceFrame = referenceFrame;

          this.browser = trackView.browser;

          this.$viewport = $$1('<div class="igv-viewport">');
          viewportColumn.appendChild(this.$viewport.get(0));

          if (trackView.track.height) {
              this.$viewport.get(0).style.height = `${trackView.track.height}px`;
          }

          // Create an alert dialog for the sequence track to copy ref sequence to.
          if (trackView.track instanceof SequenceTrack) {
              this.alert = new AlertDialog$1(this.$viewport.get(0));
          }

          this.contentTop = 0;
          this.contentHeight = this.$viewport.height();


          this.$viewport.width(width);

          this.initializationHelper();

      }

      initializationHelper() {

      }

      showMessage(message) {
          if (!this.messageDiv) {
              this.messageDiv = document.createElement('div');
              this.messageDiv.className = 'igv-viewport-message';
              //this.contentDiv.append(this.messageDiv)
              this.$viewport.append($$1(this.messageDiv));
          }
          this.messageDiv.textContent = message;
          this.messageDiv.style.display = 'inline-block';
      }

      hideMessage(message) {
          if (this.messageDiv)
              this.messageDiv.style.display = 'none';
      }

      setTrackLabel(label) {
      }

      startSpinner() {
      }

      stopSpinner() {
      }

      checkZoomIn() {
          return true
      }

      shift() {
      }

      setTop(contentTop) {

          this.contentTop = contentTop;
          this.$viewport.height();

          //this.$content.css('top', `${contentTop}px`)
          //
          // if (undefined === this.canvasVerticalRange || this.canvasVerticalRange.bottom < viewBottom || this.canvasVerticalRange.top > viewTop) {
          //     console.log("Repaint " + this.canvasVerticalRange)
          //    this.repaint()
          // }

      }

      async loadFeatures() {
          return undefined
      }

      clearCache() {

      }

      async repaint() {
      }

      draw(drawConfiguration, features, roiFeatures) {
      }

      checkContentHeight(features) {

          let track = this.trackView.track;
          features = features || this.cachedFeatures;
          if ("FILL" === track.displayMode) {
              this.setContentHeight(this.$viewport.height());
          } else if (typeof track.computePixelHeight === 'function') {
              if (features && features.length > 0) {
                  let requiredContentHeight = track.computePixelHeight(features);
                  //let currentContentHeight = this.$content.height()
                  let currentContentHeight = this.contentHeight;
                  if (requiredContentHeight !== currentContentHeight) {
                      this.setContentHeight(requiredContentHeight);
                  }
              }
          }
      }

      getContentHeight() {
          //return this.$content.height()
          return this.contentHeight
      }

      setContentHeight(contentHeight) {
         this.contentHeight = contentHeight;
      }

      isLoading() {
          return false
      }

      saveSVG() {

      }

      isVisible() {
          return this.$viewport.width()
      }

      setWidth(width) {
          this.$viewport.width(width);
      }

      getWidth() {
          return this.$viewport.width()
      }

      getContentTop() {
          return this.contentTop
      }

      containsPosition(chr, position) {
      }

      addMouseHandlers() {
      }

      removeMouseHandlers() {
      }

      /**
       * Called when the associated track is removed.  Do any needed cleanup here.
       */
      dispose() {

          if (this.popover) {
              this.popover.dispose();
          }

          this.$viewport.get(0).remove();

          // Null out all properties -- this should not be neccessary, but just in case there is a
          // reference to self somewhere we want to free memory.
          for (let key of Object.keys(this)) {
              this[key] = undefined;
          }
      }

  }

  /*!!
   *  Canvas 2 Svg v1.0.19
   *  A low level canvas to SVG converter. Uses a mock canvas context to build an SVG document.
   *
   *  Licensed under the MIT license:
   *  http://www.opensource.org/licenses/mit-license.php
   *
   *  Author:
   *  Kerry Liu
   *
   *  Copyright (c) 2014 Gliffy Inc.
   */

  //helper function to format a string
  function format(str, args) {
      var keys = Object.keys(args), i;
      for (i = 0; i < keys.length; i++) {
          str = str.replace(new RegExp("\\{" + keys[i] + "\\}", "gi"), args[keys[i]]);
      }
      return str
  }

  //helper function that generates a random string
  function randomString(holder) {
      var chars, randomstring, i;
      if (!holder) {
          throw new Error("cannot create a random attribute name for an undefined object")
      }
      chars = "ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
      randomstring = "";
      do {
          randomstring = "";
          for (i = 0; i < 12; i++) {
              randomstring += chars[Math.floor(Math.random() * chars.length)];
          }
      } while (holder[randomstring])
      return randomstring
  }

  //helper function to map named to numbered entities
  function createNamedToNumberedLookup(items, radix) {
      var i, entity, lookup = {}, base10;
      items = items.split(',');
      radix = radix || 10;
      // Map from named to numbered entities.
      for (i = 0; i < items.length; i += 2) {
          entity = '&' + items[i + 1] + ';';
          base10 = parseInt(items[i], radix);
          lookup[entity] = '&#' + base10 + ';';
      }
      //FF and IE need to create a regex from hex values ie &nbsp; == \xa0
      lookup["\\xa0"] = '&#160;';
      return lookup
  }

  //helper function to map canvas-textAlign to svg-textAnchor
  function getTextAnchor(textAlign) {
      //TODO: support rtl languages
      var mapping = {"left": "start", "right": "end", "center": "middle", "start": "start", "end": "end"};
      return mapping[textAlign] || mapping.start
  }

  //helper function to map canvas-textBaseline to svg-dominantBaseline
  function getDominantBaseline(textBaseline) {
      //INFO: not supported in all browsers
      var mapping = {
          "alphabetic": "alphabetic",
          "hanging": "hanging",
          "top": "text-before-edge",
          "bottom": "text-after-edge",
          "middle": "central"
      };
      return mapping[textBaseline] || mapping.alphabetic
  }


  /**
   * Return a new normalized vector of given vector
   */
  function normalize(vector) {
      var len = Math.sqrt(vector[0] * vector[0] + vector[1] * vector[1]);
      return [vector[0] / len, vector[1] / len]
  }


  function intersectRect(rect1, rect2) {
      return (rect1.x < rect2.x + rect2.width &&
          rect1.x + rect1.width > rect2.x &&
          rect1.y < rect2.y + rect2.height &&
          rect1.y + rect1.height > rect2.y)
  }


  // Unpack entities lookup where the numbers are in radix 32 to reduce the size
  // entity mapping courtesy of tinymce
  const namedEntities = createNamedToNumberedLookup(
      '50,nbsp,51,iexcl,52,cent,53,pound,54,curren,55,yen,56,brvbar,57,sect,58,uml,59,copy,' +
      '5a,ordf,5b,laquo,5c,not,5d,shy,5e,reg,5f,macr,5g,deg,5h,plusmn,5i,sup2,5j,sup3,5k,acute,' +
      '5l,micro,5m,para,5n,middot,5o,cedil,5p,sup1,5q,ordm,5r,raquo,5s,frac14,5t,frac12,5u,frac34,' +
      '5v,iquest,60,Agrave,61,Aacute,62,Acirc,63,Atilde,64,Auml,65,Aring,66,AElig,67,Ccedil,' +
      '68,Egrave,69,Eacute,6a,Ecirc,6b,Euml,6c,Igrave,6d,Iacute,6e,Icirc,6f,Iuml,6g,ETH,6h,Ntilde,' +
      '6i,Ograve,6j,Oacute,6k,Ocirc,6l,Otilde,6m,Ouml,6n,times,6o,Oslash,6p,Ugrave,6q,Uacute,' +
      '6r,Ucirc,6s,Uuml,6t,Yacute,6u,THORN,6v,szlig,70,agrave,71,aacute,72,acirc,73,atilde,74,auml,' +
      '75,aring,76,aelig,77,ccedil,78,egrave,79,eacute,7a,ecirc,7b,euml,7c,igrave,7d,iacute,7e,icirc,' +
      '7f,iuml,7g,eth,7h,ntilde,7i,ograve,7j,oacute,7k,ocirc,7l,otilde,7m,ouml,7n,divide,7o,oslash,' +
      '7p,ugrave,7q,uacute,7r,ucirc,7s,uuml,7t,yacute,7u,thorn,7v,yuml,ci,fnof,sh,Alpha,si,Beta,' +
      'sj,Gamma,sk,Delta,sl,Epsilon,sm,Zeta,sn,Eta,so,Theta,sp,Iota,sq,Kappa,sr,Lambda,ss,Mu,' +
      'st,Nu,su,Xi,sv,Omicron,t0,Pi,t1,Rho,t3,Sigma,t4,Tau,t5,Upsilon,t6,Phi,t7,Chi,t8,Psi,' +
      't9,Omega,th,alpha,ti,beta,tj,gamma,tk,delta,tl,epsilon,tm,zeta,tn,eta,to,theta,tp,iota,' +
      'tq,kappa,tr,lambda,ts,mu,tt,nu,tu,xi,tv,omicron,u0,pi,u1,rho,u2,sigmaf,u3,sigma,u4,tau,' +
      'u5,upsilon,u6,phi,u7,chi,u8,psi,u9,omega,uh,thetasym,ui,upsih,um,piv,812,bull,816,hellip,' +
      '81i,prime,81j,Prime,81u,oline,824,frasl,88o,weierp,88h,image,88s,real,892,trade,89l,alefsym,' +
      '8cg,larr,8ch,uarr,8ci,rarr,8cj,darr,8ck,harr,8dl,crarr,8eg,lArr,8eh,uArr,8ei,rArr,8ej,dArr,' +
      '8ek,hArr,8g0,forall,8g2,part,8g3,exist,8g5,empty,8g7,nabla,8g8,isin,8g9,notin,8gb,ni,8gf,prod,' +
      '8gh,sum,8gi,minus,8gn,lowast,8gq,radic,8gt,prop,8gu,infin,8h0,ang,8h7,and,8h8,or,8h9,cap,8ha,cup,' +
      '8hb,int,8hk,there4,8hs,sim,8i5,cong,8i8,asymp,8j0,ne,8j1,equiv,8j4,le,8j5,ge,8k2,sub,8k3,sup,8k4,' +
      'nsub,8k6,sube,8k7,supe,8kl,oplus,8kn,otimes,8l5,perp,8m5,sdot,8o8,lceil,8o9,rceil,8oa,lfloor,8ob,' +
      'rfloor,8p9,lang,8pa,rang,9ea,loz,9j0,spades,9j3,clubs,9j5,hearts,9j6,diams,ai,OElig,aj,oelig,b0,' +
      'Scaron,b1,scaron,bo,Yuml,m6,circ,ms,tilde,802,ensp,803,emsp,809,thinsp,80c,zwnj,80d,zwj,80e,lrm,' +
      '80f,rlm,80j,ndash,80k,mdash,80o,lsquo,80p,rsquo,80q,sbquo,80s,ldquo,80t,rdquo,80u,bdquo,810,dagger,' +
      '811,Dagger,81g,permil,81p,lsaquo,81q,rsaquo,85c,euro', 32);


  //Some basic mappings for attributes and default values.
  const STYLES = {
      "strokeStyle": {
          svgAttr: "stroke", //corresponding svg attribute
          canvas: "#000000", //canvas default
          svg: "none",       //svg default
          apply: "stroke"    //apply on stroke() or fill()
      },
      "fillStyle": {
          svgAttr: "fill",
          canvas: "#000000",
          svg: null, //svg default is black, but we need to special case this to handle canvas stroke without fill
          apply: "fill"
      },
      "lineCap": {
          svgAttr: "stroke-linecap",
          canvas: "butt",
          svg: "butt",
          apply: "stroke"
      },
      "lineJoin": {
          svgAttr: "stroke-linejoin",
          canvas: "miter",
          svg: "miter",
          apply: "stroke"
      },
      "miterLimit": {
          svgAttr: "stroke-miterlimit",
          canvas: 10,
          svg: 4,
          apply: "stroke"
      },
      "lineWidth": {
          svgAttr: "stroke-width",
          canvas: 1,
          svg: 1,
          apply: "stroke"
      },
      "globalAlpha": {
          svgAttr: "opacity",
          canvas: 1,
          svg: 1,
          apply: "fill stroke"
      },
      "font": {
          //font converts to multiple svg attributes, there is custom logic for this
          canvas: "10px sans-serif"
      },
      "shadowColor": {
          canvas: "#000000"
      },
      "shadowOffsetX": {
          canvas: 0
      },
      "shadowOffsetY": {
          canvas: 0
      },
      "shadowBlur": {
          canvas: 0
      },
      "textAlign": {
          canvas: "start"
      },
      "textBaseline": {
          canvas: "alphabetic"
      },
      "lineDash": {
          svgAttr: "stroke-dasharray",
          canvas: [],
          svg: null,
          apply: "stroke"
      }
  };

  /**
   *
   * @param gradientNode - reference to the gradient
   * @constructor
   */
  class CanvasGradient {
      constructor(gradientNode, ctx) {
          this.__root = gradientNode;
          this.__ctx = ctx;
      }

      /**
       * Adds a color stop to the gradient root
       */
      addColorStop(offset, color) {
          var stop = this.__ctx.__createElement("stop"), regex, matches;
          stop.setAttribute("offset", offset);
          if (color && color.indexOf("rgba") !== -1) {
              //separate alpha value, since webkit can't handle it
              regex = /rgba\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d?\.?\d*)\s*\)/gi;
              matches = regex.exec(color);
              stop.setAttribute("stop-color", format("rgb({r},{g},{b})", {r: matches[1], g: matches[2], b: matches[3]}));
              stop.setAttribute("stop-opacity", matches[4]);
          } else {
              stop.setAttribute("stop-color", color);
          }
          this.__root.appendChild(stop);
      }
  }

  class CanvasPattern {
      constructor(pattern, ctx) {
          this.__root = pattern;
          this.__ctx = ctx;
      }
  }

  /**
   * The mock canvas context
   * @param config - options include:
   * ctx - existing Context2D to wrap around
   * width - width of your canvas (defaults to 500)
   * height - height of your canvas (defaults to 500)
   * enableMirroring - enables canvas mirroring (get image data) (defaults to false)
   * document - the document object (defaults to the current document)
   */
  class ctx {
      constructor(config) {

          if (!(this instanceof ctx)) {
              //did someone call this without new?
              return new ctx(config)
          }

          // clone config
          this.config = config;

          //setup options
          this.width = config.width;
          this.height = config.height;
          this.enableMirroring = config.enableMirroring || false;

          this.canvas = this;   ///point back to this instance!
          this.__document = document;

          // allow passing in an existing context to wrap around
          // if a context is passed in, we know a canvas already exist
          if (config.ctx) {
              this.__ctx = config.ctx;
          } else {
              this.__canvas = this.__document.createElement("canvas");
              this.__ctx = this.__canvas.getContext("2d");
          }

          // give this canvas a type
          this.isSVG = true;

          this.__setDefaultStyles();
          this.__stack = [this.__getStyleState()];
          this.__groupStack = [];

          // root svg element
          this.__root = this.__createElement("svg");
          this.__root.setAttribute("width", this.width);
          this.__root.setAttribute("height", this.height);

          // allow contents to overflow svg bbox
          this.__root.setAttribute('overflow', 'visible');

          // viewbox
          if (config.viewbox) {
              const str = config.viewbox.x + ' ' + config.viewbox.y + ' ' + config.viewbox.width + ' ' + config.viewbox.height;
              this.__root.setAttribute("viewBox", str);

              this.viewbox = config.viewbox;
          }

          // make sure we don't generate the same ids in defs
          this.__ids = {};

          // defs
          this.__defs = this.__createElement("defs");
          this.__root.appendChild(this.__defs);

          this.multiLocusGap = config.multiLocusGap;

          // svg background color
          let backdropConfig =
              {
                  id: 'svg_output_backdrop',
                  width: '100%',
                  height: '100%',
                  fill: config.backdropColor || 'white'
              };

          let backdropRect = this.__createElement('rect', backdropConfig);
          this.__root.appendChild(backdropRect);

          // root group
          this.__rootGroup = this.__createElement('g', {id: 'root-group'});
          this.__root.appendChild(this.__rootGroup);

          // point current element to root group
          this.__currentElement = this.__rootGroup;
      }

      setWidth(width) {

          this.width = width;
          this.__root.setAttribute("width", this.width);

          const str = this.config.viewbox.x + ' ' + this.config.viewbox.y + ' ' + width + ' ' + this.config.viewbox.height;
          this.__root.setAttribute("viewBox", str);

      };

      setHeight(height) {

          this.height = height;
          this.__root.setAttribute("height", this.height);

          const str = this.config.viewbox.x + ' ' + this.config.viewbox.y + ' ' + this.config.viewbox.width + ' ' + height;
          this.__root.setAttribute("viewBox", str);

      };

      /**
       * Creates the specified svg element
       * @private
       */
      __createElement(elementName, properties, resetFill) {

          if (typeof properties === "undefined") {
              properties = {};
          }

          let element = this.__document.createElementNS("http://www.w3.org/2000/svg", elementName);

          if (resetFill) {
              //if fill or stroke is not specified, the svg element should not display. By default SVG's fill is black.
              element.setAttribute("fill", "none");
              element.setAttribute("stroke", "none");
          }

          for (let key of Object.keys(properties)) {
              element.setAttribute(key, properties[key]);
          }

          return element
      };

      /**
       * Applies default canvas styles to the context
       * @private
       */
      __setDefaultStyles() {
          //default 2d canvas context properties see:http://www.w3.org/TR/2dcontext/
          var keys = Object.keys(STYLES), i, key;
          for (i = 0; i < keys.length; i++) {
              key = keys[i];
              this[key] = STYLES[key].canvas;
          }
      };

      /**
       * Applies styles on restore
       * @param styleState
       * @private
       */
      __applyStyleState(styleState) {
          var keys = Object.keys(styleState), i, key;
          for (i = 0; i < keys.length; i++) {
              key = keys[i];
              this[key] = styleState[key];
          }
      };

      /**
       * Gets the current style state
       * @return {Object}
       * @private
       */
      __getStyleState() {
          var i, styleState = {}, keys = Object.keys(STYLES), key;
          for (i = 0; i < keys.length; i++) {
              key = keys[i];
              styleState[key] = this[key];
          }
          return styleState
      };

      /**
       * Apples the current styles to the current SVG element. On "ctx.fill" or "ctx.stroke"
       * @param type
       * @private
       */
      __applyStyleToCurrentElement(type) {
          var currentElement = this.__currentElement;
          var currentStyleGroup = this.__currentElementsToStyle;
          if (currentStyleGroup) {
              currentElement.setAttribute(type, "");
              currentElement = currentStyleGroup.element;
              currentStyleGroup.children.forEach(function (node) {
                  node.setAttribute(type, "");
              });
          }

          var keys = Object.keys(STYLES), i, style, value, id, regex, matches;
          for (i = 0; i < keys.length; i++) {
              style = STYLES[keys[i]];
              value = this[keys[i]];
              if (style.apply) {
                  //is this a gradient or pattern?
                  if (value instanceof CanvasPattern) {
                      //pattern
                      if (value.__ctx) {
                          //copy over defs
                          while (value.__ctx.__defs.childNodes.length) {
                              id = value.__ctx.__defs.childNodes[0].getAttribute("id");
                              this.__ids[id] = id;
                              this.__defs.appendChild(value.__ctx.__defs.childNodes[0]);
                          }
                      }
                      currentElement.setAttribute(style.apply, format("url(#{id})", {id: value.__root.getAttribute("id")}));
                  } else if (value instanceof CanvasGradient) {
                      //gradient
                      currentElement.setAttribute(style.apply, format("url(#{id})", {id: value.__root.getAttribute("id")}));
                  } else if (style && style.apply.indexOf(type) !== -1 && style.svg !== value) {
                      if ((style.svgAttr === "stroke" || style.svgAttr === "fill") && value && value.indexOf("rgba") !== -1) {
                          //separate alpha value, since illustrator can't handle it
                          regex = /rgba\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d?\.?\d*)\s*\)/gi;
                          matches = regex.exec(value);
                          currentElement.setAttribute(style.svgAttr, format("rgb({r},{g},{b})", {
                              r: matches[1],
                              g: matches[2],
                              b: matches[3]
                          }));
                          //should take globalAlpha here
                          var opacity = matches[4];
                          var globalAlpha = this.globalAlpha;
                          if (globalAlpha != null) {
                              opacity *= globalAlpha;
                          }
                          currentElement.setAttribute(style.svgAttr + "-opacity", opacity);
                      } else {
                          var attr = style.svgAttr;
                          if (keys[i] === 'globalAlpha') {
                              attr = type + '-' + style.svgAttr;
                              if (currentElement.getAttribute(attr)) {
                                  //fill-opacity or stroke-opacity has already been set by stroke or fill.
                                  continue
                              }
                          }
                          //otherwise only update attribute if right type, and not svg default
                          currentElement.setAttribute(attr, value);
                      }
                  }
              }
          }
      };

      /**
       * Will return the closest group or svg node. May return the current element.
       * @private
       */
      __closestGroupOrSvg(node) {
          node = node || this.__currentElement;
          if (node.nodeName === "g" || node.nodeName === "svg") {
              return node
          } else {
              return this.__closestGroupOrSvg(node.parentNode)
          }
      };

      /**
       * Returns the serialized value of the svg so far
       * @param fixNamedEntities - Standalone SVG doesn't support named entities, which document.createTextNode encodes.
       *                           If true, we attempt to find all named entities and encode it as a numeric entity.
       * @return serialized svg
       */
      getSerializedSvg(fixNamedEntities) {
          var serialized = new XMLSerializer().serializeToString(this.__root),
              keys, i, key, value, regexp;

          //IE search for a duplicate xmnls because they didn't implement setAttributeNS correctly
          // xmlns = /xmlns="http:\/\/www\.w3\.org\/2000\/svg".+xmlns="http:\/\/www\.w3\.org\/2000\/svg/gi;
          // if (xmlns.test(serialized)) {
          //     serialized = serialized.replace('xmlns="http://www.w3.org/2000/svg','xmlns:xlink="http://www.w3.org/1999/xlink');
          // }

          if (fixNamedEntities) {
              keys = Object.keys(namedEntities);
              //loop over each named entity and replace with the proper equivalent.
              for (i = 0; i < keys.length; i++) {
                  key = keys[i];
                  value = namedEntities[key];
                  regexp = new RegExp(key, "gi");
                  if (regexp.test(serialized)) {
                      serialized = serialized.replace(regexp, value);
                  }
              }
          }

          return serialized
      };


      /**
       * Returns the root svg
       * @return
       */
      getSvg() {
          return this.__root
      };

      /**
       * Will generate a group tag.
       */
      saveWithTranslationAndClipRect(id, tx, ty, width, height, clipYOffset) {

          // clip rect
          const clip_id = `${id}_clip_rect`;
          let clipPath = this.__createElement('clipPath', {id: clip_id});

          this.__defs.appendChild(clipPath);

          const config =
              {
                  x: '0',
                  y: clipYOffset.toString(),
                  width: width.toString(),
                  height: height.toString()
              };

          clipPath.appendChild(this.__createElement('rect', config));

          const group = this.__createElement("g");
          group.setAttribute('transform', format('translate({x},{y})', {x: tx, y: ty}));
          group.setAttribute('clip-path', format('url(#{id})', {id: clip_id}));

          const parent = this.__closestGroupOrSvg();
          parent.appendChild(group);
          this.__groupStack.push(parent);

          this.__currentElement = group;
          this.__stack.push(this.__getStyleState());
      };

      save() {
          var group = this.__createElement("g");
          var parent = this.__closestGroupOrSvg();
          this.__groupStack.push(parent);
          parent.appendChild(group);
          this.__currentElement = group;
          this.__stack.push(this.__getStyleState());
      };

      /**
       * Sets current element to parent, or just root if already root
       */
      restore() {
          this.__currentElement = this.__groupStack.pop();
          this.__currentElementsToStyle = null;
          //Clearing canvas will make the poped group invalid, currentElement is set to the root group node.
          if (!this.__currentElement) {
              this.__currentElement = this.__root.childNodes[1];
          }
          var state = this.__stack.pop();
          this.__applyStyleState(state);
      };

      /**
       * Helper method to add transform
       * @private
       */
      __addTransform(t) {
          //if the current element has siblings, add another group
          var parent = this.__closestGroupOrSvg();
          if (parent.childNodes.length > 0) {
              if (this.__currentElement.nodeName === "path") {
                  if (!this.__currentElementsToStyle) this.__currentElementsToStyle = {element: parent, children: []};
                  this.__currentElementsToStyle.children.push(this.__currentElement);
                  this.__applyCurrentDefaultPath();
              }

              var group = this.__createElement("g");
              parent.appendChild(group);
              this.__currentElement = group;
          }

          var transform = this.__currentElement.getAttribute("transform");
          if (transform) {
              transform += " ";
          } else {
              transform = "";
          }
          transform += t;
          this.__currentElement.setAttribute("transform", transform);
      };

      addTrackGroupWithTranslationAndClipRect(id, tx, ty, width, height, clipYOffset) {

          // clip rect
          const clip_id = id + '_clip_rect';
          let clipPath = this.__createElement('clipPath', {id: clip_id});

          this.__defs.appendChild(clipPath);
          clipPath.appendChild(this.__createElement('rect', {
              x: '0',
              y: clipYOffset.toString(),
              width: width.toString(),
              height: height.toString()
          }));

          let group = this.__createElement('g');
          this.__rootGroup.appendChild(group);

          group.setAttribute('transform', format('translate({x},{y})', {x: tx, y: ty}));
          group.setAttribute('id', (id + '_group'));

          // add clip rect
          group.setAttribute('clip-path', format('url(#{id})', {id: clip_id}));

          this.__currentElement = group;
      };

      /**
       *  scales the current element
       */
      scale(x, y) {
          if (y === undefined) {
              y = x;
          }
          this.__addTransform(format("scale({x},{y})", {x: x, y: y}));
      };

      /**
       * rotates the current element
       */
      rotate(angle) {
          var degrees = (angle * 180 / Math.PI);
          this.__addTransform(format("rotate({angle},{cx},{cy})", {angle: degrees, cx: 0, cy: 0}));
      };

      /**
       * translates the current element
       */
      translate(x, y) {
          this.__addTransform(format("translate({x},{y})", {x: x, y: y}));
      };

      /**
       * applies a transform to the current element
       */
      transform(a, b, c, d, e, f) {
          this.__addTransform(format("matrix({a},{b},{c},{d},{e},{f})", {a: a, b: b, c: c, d: d, e: e, f: f}));
      };

      /**
       * Create a new Path Element
       */
      beginPath() {
          var path, parent;

          // Note that there is only one current default path, it is not part of the drawing state.
          // See also: https://html.spec.whatwg.org/multipage/scripting.html#current-default-path
          this.__currentDefaultPath = "";
          this.__currentPosition = {};

          path = this.__createElement("path", {}, true);
          parent = this.__closestGroupOrSvg();
          parent.appendChild(path);
          this.__currentElement = path;
      };

      /**
       * Helper function to apply currentDefaultPath to current path element
       * @private
       */
      __applyCurrentDefaultPath() {
          var currentElement = this.__currentElement;
          if (currentElement.nodeName === "path") {
              currentElement.setAttribute("d", this.__currentDefaultPath);
          } else {
              console.error("Attempted to apply path command to node", currentElement.nodeName);
          }
      };

      /**
       * Helper function to add path command
       * @private
       */
      __addPathCommand(command) {
          this.__currentDefaultPath += " ";
          this.__currentDefaultPath += command;
      };

      /**
       * Adds the move command to the current path element,
       * if the currentPathElement is not empty create a new path element
       */
      moveTo(x, y) {
          if (this.__currentElement.nodeName !== "path") {
              this.beginPath();
          }

          // creates a new subpath with the given point
          this.__currentPosition = {x: x, y: y};
          this.__addPathCommand(format("M {x} {y}", {x: x, y: y}));
      };

      /**
       * Closes the current path
       */
      closePath() {
          if (this.__currentDefaultPath) {
              this.__addPathCommand("Z");
          }
      };

      /**
       * Adds a line to command
       */
      lineTo(x, y) {
          this.__currentPosition = {x: x, y: y};
          if (this.__currentDefaultPath && this.__currentDefaultPath.indexOf('M') > -1) {
              this.__addPathCommand(format("L {x} {y}", {x: x, y: y}));
          } else {
              this.__addPathCommand(format("M {x} {y}", {x: x, y: y}));
          }
      };

      /**
       * Add a bezier command
       */
      bezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y) {
          this.__currentPosition = {x: x, y: y};
          this.__addPathCommand(format("C {cp1x} {cp1y} {cp2x} {cp2y} {x} {y}",
              {cp1x: cp1x, cp1y: cp1y, cp2x: cp2x, cp2y: cp2y, x: x, y: y}));
      };

      /**
       * Adds a quadratic curve to command
       */
      quadraticCurveTo(cpx, cpy, x, y) {
          this.__currentPosition = {x: x, y: y};
          this.__addPathCommand(format("Q {cpx} {cpy} {x} {y}", {cpx: cpx, cpy: cpy, x: x, y: y}));
      };

      /**
       * Adds the arcTo to the current path
       *
       * @see http://www.w3.org/TR/2015/WD-2dcontext-20150514/#dom-context-2d-arcto
       */
      arcTo(x1, y1, x2, y2, radius) {
          // Let the point (x0, y0) be the last point in the subpath.
          var x0 = this.__currentPosition && this.__currentPosition.x;
          var y0 = this.__currentPosition && this.__currentPosition.y;

          // First ensure there is a subpath for (x1, y1).
          if (typeof x0 == "undefined" || typeof y0 == "undefined") {
              return
          }

          // Negative values for radius must cause the implementation to throw an IndexSizeError exception.
          if (radius < 0) {
              throw new Error("IndexSizeError: The radius provided (" + radius + ") is negative.")
          }

          // If the point (x0, y0) is equal to the point (x1, y1),
          // or if the point (x1, y1) is equal to the point (x2, y2),
          // or if the radius radius is zero,
          // then the method must add the point (x1, y1) to the subpath,
          // and connect that point to the previous point (x0, y0) by a straight line.
          if (((x0 === x1) && (y0 === y1))
              || ((x1 === x2) && (y1 === y2))
              || (radius === 0)) {
              this.lineTo(x1, y1);
              return
          }

          // Otherwise, if the points (x0, y0), (x1, y1), and (x2, y2) all lie on a single straight line,
          // then the method must add the point (x1, y1) to the subpath,
          // and connect that point to the previous point (x0, y0) by a straight line.
          var unit_vec_p1_p0 = normalize([x0 - x1, y0 - y1]);
          var unit_vec_p1_p2 = normalize([x2 - x1, y2 - y1]);
          if (unit_vec_p1_p0[0] * unit_vec_p1_p2[1] === unit_vec_p1_p0[1] * unit_vec_p1_p2[0]) {
              this.lineTo(x1, y1);
              return
          }

          // Otherwise, let The Arc be the shortest arc given by circumference of the circle that has radius radius,
          // and that has one point tangent to the half-infinite line that crosses the point (x0, y0) and ends at the point (x1, y1),
          // and that has a different point tangent to the half-infinite line that ends at the point (x1, y1), and crosses the point (x2, y2).
          // The points at which this circle touches these two lines are called the start and end tangent points respectively.

          // note that both vectors are unit vectors, so the length is 1
          var cos = (unit_vec_p1_p0[0] * unit_vec_p1_p2[0] + unit_vec_p1_p0[1] * unit_vec_p1_p2[1]);
          var theta = Math.acos(Math.abs(cos));

          // Calculate origin
          var unit_vec_p1_origin = normalize([
              unit_vec_p1_p0[0] + unit_vec_p1_p2[0],
              unit_vec_p1_p0[1] + unit_vec_p1_p2[1]
          ]);
          var len_p1_origin = radius / Math.sin(theta / 2);
          var x = x1 + len_p1_origin * unit_vec_p1_origin[0];
          var y = y1 + len_p1_origin * unit_vec_p1_origin[1];

          // Calculate start angle and end angle
          // rotate 90deg clockwise (note that y axis points to its down)
          var unit_vec_origin_start_tangent = [
              -unit_vec_p1_p0[1],
              unit_vec_p1_p0[0]
          ];
          // rotate 90deg counter clockwise (note that y axis points to its down)
          var unit_vec_origin_end_tangent = [
              unit_vec_p1_p2[1],
              -unit_vec_p1_p2[0]
          ];
          var getAngle = function (vector) {
              // get angle (clockwise) between vector and (1, 0)
              var x = vector[0];
              var y = vector[1];
              if (y >= 0) { // note that y axis points to its down
                  return Math.acos(x)
              } else {
                  return -Math.acos(x)
              }
          };
          var startAngle = getAngle(unit_vec_origin_start_tangent);
          var endAngle = getAngle(unit_vec_origin_end_tangent);

          // Connect the point (x0, y0) to the start tangent point by a straight line
          this.lineTo(x + unit_vec_origin_start_tangent[0] * radius,
              y + unit_vec_origin_start_tangent[1] * radius);

          // Connect the start tangent point to the end tangent point by arc
          // and adding the end tangent point to the subpath.
          this.arc(x, y, radius, startAngle, endAngle);
      };

      /**
       * Sets the stroke property on the current element
       */
      stroke() {
          if (this.__currentElement.nodeName === "path") {
              this.__currentElement.setAttribute("paint-order", "fill stroke markers");
          }
          this.__applyCurrentDefaultPath();
          this.__applyStyleToCurrentElement("stroke");
      };

      /**
       * Sets fill properties on the current element
       */
      fill() {
          if (this.__currentElement.nodeName === "path") {
              this.__currentElement.setAttribute("paint-order", "stroke fill markers");
          }
          this.__applyCurrentDefaultPath();
          this.__applyStyleToCurrentElement("fill");
      };

      /**
       *  Adds a rectangle to the path.
       */
      rect(x, y, width, height) {
          if (this.__currentElement.nodeName !== "path") {
              this.beginPath();
          }
          this.moveTo(x, y);
          this.lineTo(x + width, y);
          this.lineTo(x + width, y + height);
          this.lineTo(x, y + height);
          this.lineTo(x, y);
          this.closePath();
      };


      /**
       * adds a rectangle element
       */
      fillRect(x, y, width, height) {

          if (height < 0) {
              y += height;
              height = -height;
          }
          if (width < 0) {
              x += width;
              width = -width;
          }
          // See if rect intersects current viewbox
          var r2 = {
              x: x,
              y: y,
              width: width,
              height: height
          };

          if (this.viewbox) {
              if (!intersectRect(this.viewbox, r2)) {
                  return
              }
          }

          var rect, parent;
          rect = this.__createElement("rect", r2, true);
          parent = this.__closestGroupOrSvg();
          parent.appendChild(rect);
          this.__currentElement = rect;
          this.__applyStyleToCurrentElement("fill");
      };

      /**
       * Draws a rectangle with no fill
       * @param x
       * @param y
       * @param width
       * @param height
       */
      strokeRect(x, y, width, height) {
          var rect, parent;
          rect = this.__createElement("rect", {
              x: x,
              y: y,
              width: width,
              height: height
          }, true);
          parent = this.__closestGroupOrSvg();
          parent.appendChild(rect);
          this.__currentElement = rect;
          this.__applyStyleToCurrentElement("stroke");
      };

      // stroke ellipse
      strokeEllipse(cx, cy, rx, ry, rotation, startAngle, endAngle, isCCW) {
          this.__ellipse(cx, cy, rx, ry, rotation, startAngle, endAngle, isCCW, 'stroke');
      }

      // fill ellipse
      fillEllipse(cx, cy, rx, ry, rotation, startAngle, endAngle, isCCW) {
          this.__ellipse(cx, cy, rx, ry, rotation, startAngle, endAngle, isCCW, 'fill');
      }

      // ellipse helper
      __ellipse(cx, cy, rx, ry, rotation, startAngle, endAngle, isCCW, style) {

          const config =
              {
                  cx,
                  cy,
                  rx,
                  ry
              };
          const element = this.__createElement('ellipse', config, true);
          const parent = this.__closestGroupOrSvg();
          parent.appendChild(element);
          this.__currentElement = element;
          this.__applyStyleToCurrentElement(style);
      }

      /**
       * Clear entire canvas:
       * 1. save current transforms
       * 2. remove all the childNodes of the root g element
       */
      __clearCanvas() {
          var current = this.__closestGroupOrSvg(),
              transform = current.getAttribute("transform");
          var rootGroup = this.__root.childNodes[1];
          var childNodes = rootGroup.childNodes;
          for (var i = childNodes.length - 1; i >= 0; i--) {
              if (childNodes[i]) {
                  rootGroup.removeChild(childNodes[i]);
              }
          }
          this.__currentElement = rootGroup;
          //reset __groupStack as all the child group nodes are all removed.
          this.__groupStack = [];
          if (transform) {
              this.__addTransform(transform);
          }
      };

      /**
       * "Clears" a canvas by just drawing a white rectangle in the current group.
       */
      clearRect(x, y, width, height) {
          //clear entire canvas
          if (x === 0 && y === 0 && width === this.width && height === this.height) {
              this.__clearCanvas();
              return
          }
          var rect, parent = this.__closestGroupOrSvg();
          rect = this.__createElement("rect", {
              x: x,
              y: y,
              width: width,
              height: height,
              fill: "#FFFFFF"
          }, true);
          parent.appendChild(rect);
      };

      /**
       * Adds a linear gradient to a defs tag.
       * Returns a canvas gradient object that has a reference to it's parent def
       */
      createLinearGradient(x1, y1, x2, y2) {
          var grad = this.__createElement("linearGradient", {
              id: randomString(this.__ids),
              x1: x1 + "px",
              x2: x2 + "px",
              y1: y1 + "px",
              y2: y2 + "px",
              "gradientUnits": "userSpaceOnUse"
          }, false);
          this.__defs.appendChild(grad);
          return new CanvasGradient(grad, this)
      };

      /**
       * Adds a radial gradient to a defs tag.
       * Returns a canvas gradient object that has a reference to it's parent def
       */
      createRadialGradient(x0, y0, r0, x1, y1, r1) {
          var grad = this.__createElement("radialGradient", {
              id: randomString(this.__ids),
              cx: x1 + "px",
              cy: y1 + "px",
              r: r1 + "px",
              fx: x0 + "px",
              fy: y0 + "px",
              "gradientUnits": "userSpaceOnUse"
          }, false);
          this.__defs.appendChild(grad);
          return new CanvasGradient(grad, this)

      };

      /**
       * Parses the font string and returns svg mapping
       * @private
       */
      __parseFont() {
          var regex = /^\s*(?=(?:(?:[-a-z]+\s*){0,2}(italic|oblique))?)(?=(?:(?:[-a-z]+\s*){0,2}(small-caps))?)(?=(?:(?:[-a-z]+\s*){0,2}(bold(?:er)?|lighter|[1-9]00))?)(?:(?:normal|\1|\2|\3)\s*){0,3}((?:xx?-)?(?:small|large)|medium|smaller|larger|[.\d]+(?:\%|in|[cem]m|ex|p[ctx]))(?:\s*\/\s*(normal|[.\d]+(?:\%|in|[cem]m|ex|p[ctx])))?\s*([-,\'\"\sa-z0-9]+?)\s*$/i;
          var fontPart = regex.exec(this.font);
          var data = {
              style: fontPart[1] || 'normal',
              size: fontPart[4] || '10px',
              family: fontPart[6] || 'sans-serif',
              weight: fontPart[3] || 'normal',
              decoration: fontPart[2] || 'normal',
              href: null
          };

          //canvas doesn't support underline natively, but we can pass this attribute
          if (this.__fontUnderline === "underline") {
              data.decoration = "underline";
          }

          //canvas also doesn't support linking, but we can pass this as well
          if (this.__fontHref) {
              data.href = this.__fontHref;
          }

          return data
      };

      /**
       * Helper to link text fragments
       * @param font
       * @param element
       * @return {*}
       * @private
       */
      __wrapTextLink(font, element) {
          if (font.href) {
              var a = this.__createElement("a");
              a.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", font.href);
              a.appendChild(element);
              return a
          }
          return element
      };

      /**
       * Fills or strokes text
       * @param text
       * @param x
       * @param y
       * @param action - stroke or fill
       * @private
       */
      __applyText(text, x, y, action) {
          var font = this.__parseFont(),
              parent = this.__closestGroupOrSvg(),
              textElement = this.__createElement("text", {
                  "font-family": font.family,
                  "font-size": font.size,
                  "font-style": font.style,
                  "font-weight": font.weight,
                  "text-decoration": font.decoration,
                  "x": x,
                  "y": y,
                  "text-anchor": getTextAnchor(this.textAlign),
                  "dominant-baseline": getDominantBaseline(this.textBaseline)
              }, true);

          textElement.appendChild(this.__document.createTextNode(text));
          this.__currentElement = textElement;
          this.__applyStyleToCurrentElement(action);
          parent.appendChild(this.__wrapTextLink(font, textElement));
      };

      /**
       * Creates a text element
       * @param text
       * @param x
       * @param y
       */
      fillText(text, x, y) {
          this.__applyText(text, x, y, "fill");
      };

      /**
       * Strokes text
       * @param text
       * @param x
       * @param y
       */
      strokeText(text, x, y) {
          this.__applyText(text, x, y, "stroke");
      };

      /**
       * No need to implement this for svg.
       * @param text
       * @return {TextMetrics}
       */
      measureText(text) {
          this.__ctx.font = this.font;
          return this.__ctx.measureText(text)
      };

      /**
       *  Arc command!
       */
      arc(x, y, radius, startAngle, endAngle, counterClockwise) {
          // in canvas no circle is drawn if no angle is provided.
          if (startAngle === endAngle) {
              return
          }
          startAngle = startAngle % (2 * Math.PI);
          endAngle = endAngle % (2 * Math.PI);
          if (startAngle === endAngle) {
              //circle time! subtract some of the angle so svg is happy (svg elliptical arc can't draw a full circle)
              endAngle = ((endAngle + (2 * Math.PI)) - 0.001 * (counterClockwise ? -1 : 1)) % (2 * Math.PI);
          }
          var endX = x + radius * Math.cos(endAngle),
              endY = y + radius * Math.sin(endAngle),
              startX = x + radius * Math.cos(startAngle),
              startY = y + radius * Math.sin(startAngle),
              sweepFlag = counterClockwise ? 0 : 1,
              largeArcFlag = 0,
              diff = endAngle - startAngle;

          // https://github.com/gliffy/canvas2svg/issues/4
          if (diff < 0) {
              diff += 2 * Math.PI;
          }

          if (counterClockwise) {
              largeArcFlag = diff > Math.PI ? 0 : 1;
          } else {
              largeArcFlag = diff > Math.PI ? 1 : 0;
          }

          this.lineTo(startX, startY);
          this.__addPathCommand(format("A {rx} {ry} {xAxisRotation} {largeArcFlag} {sweepFlag} {endX} {endY}",
              {
                  rx: radius,
                  ry: radius,
                  xAxisRotation: 0,
                  largeArcFlag: largeArcFlag,
                  sweepFlag: sweepFlag,
                  endX: endX,
                  endY: endY
              }));

          this.__currentPosition = {x: endX, y: endY};
      };

      /**
       * The ellipse() method creates an elliptical arc centered at (x, y) with the radii radiusX and radiusY. The path
       * starts at startAngle and ends at endAngle, and travels in the direction given by counterclockwise (defaulting to clockwise).
       */
  // ellipse (x, y, radiusX, radiusY, rotation, startAngle, endAngle, counterclockwise) {
  //     // TODO -- implement
  // }

      /**
       * Generates a ClipPath from the clip command.
       */
      clip() {
          var group = this.__closestGroupOrSvg(),
              clipPath = this.__createElement("clipPath"),
              id = randomString(this.__ids),
              newGroup = this.__createElement("g");

          this.__applyCurrentDefaultPath();
          group.removeChild(this.__currentElement);
          clipPath.setAttribute("id", id);
          clipPath.appendChild(this.__currentElement);

          this.__defs.appendChild(clipPath);

          //set the clip path to this group
          group.setAttribute("clip-path", format("url(#{id})", {id: id}));

          //clip paths can be scaled and transformed, we need to add another wrapper group to avoid later transformations
          // to this path
          group.appendChild(newGroup);

          this.__currentElement = newGroup;

      };

      /**
       * Draws a canvas, image or mock context to this canvas.
       * Note that all svg dom manipulation uses node.childNodes rather than node.children for IE support.
       * http://www.whatwg.org/specs/web-apps/current-work/multipage/the-canvas-element.html#dom-context-2d-drawimage
       */
      drawImage() {
          //convert arguments to a real array
          var args = Array.prototype.slice.call(arguments),
              image = args[0],
              dx, dy, dw, dh, sx = 0, sy = 0, sw, sh, parent, svg, defs, group,
              svgImage, canvas, context, id;

          if (args.length === 3) {
              dx = args[1];
              dy = args[2];
              sw = image.width;
              sh = image.height;
              dw = sw;
              dh = sh;
          } else if (args.length === 5) {
              dx = args[1];
              dy = args[2];
              dw = args[3];
              dh = args[4];
              sw = image.width;
              sh = image.height;
          } else if (args.length === 9) {
              sx = args[1];
              sy = args[2];
              sw = args[3];
              sh = args[4];
              dx = args[5];
              dy = args[6];
              dw = args[7];
              dh = args[8];
          } else {
              throw new Error("Invalid number of arguments passed to drawImage: " + arguments.length)
          }

          parent = this.__closestGroupOrSvg();
          this.__currentElement;
          var translateDirective = "translate(" + dx + ", " + dy + ")";
          if (image instanceof ctx) {
              //canvas2svg mock canvas context. In the future we may want to clone nodes instead.
              //also I'm currently ignoring dw, dh, sw, sh, sx, sy for a mock context.
              svg = image.getSvg().cloneNode(true);
              if (svg.childNodes && svg.childNodes.length > 1) {
                  defs = svg.childNodes[0];
                  while (defs.childNodes.length) {
                      id = defs.childNodes[0].getAttribute("id");
                      this.__ids[id] = id;
                      this.__defs.appendChild(defs.childNodes[0]);
                  }
                  group = svg.childNodes[1];
                  if (group) {
                      //save original transform
                      var originTransform = group.getAttribute("transform");
                      var transformDirective;
                      if (originTransform) {
                          transformDirective = originTransform + " " + translateDirective;
                      } else {
                          transformDirective = translateDirective;
                      }
                      group.setAttribute("transform", transformDirective);
                      parent.appendChild(group);
                  }
              }
          } else if (image.nodeName === "CANVAS" || image.nodeName === "IMG") {
              //canvas or image
              svgImage = this.__createElement("image");
              svgImage.setAttribute("width", dw);
              svgImage.setAttribute("height", dh);
              svgImage.setAttribute("preserveAspectRatio", "none");

              if (sx || sy || sw !== image.width || sh !== image.height) {
                  //crop the image using a temporary canvas
                  canvas = this.__document.createElement("canvas");
                  canvas.width = dw;
                  canvas.height = dh;
                  context = canvas.getContext("2d");
                  context.drawImage(image, sx, sy, sw, sh, 0, 0, dw, dh);
                  image = canvas;
              }
              svgImage.setAttribute("transform", translateDirective);
              svgImage.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href",
                  image.nodeName === "CANVAS" ? image.toDataURL() : image.getAttribute("src"));
              parent.appendChild(svgImage);
          }
      };

      /**
       * Generates a pattern tag
       */
      createPattern(image, repetition) {

          let pattern = this.__document.__createElement("pattern");
          let id = randomString(this.__ids);
          let img;

          pattern.setAttribute("id", id);
          pattern.setAttribute("width", image.width);
          pattern.setAttribute("height", image.height);
          if (image.nodeName === "CANVAS" || image.nodeName === "IMG") {
              img = this.__createElement("image");
              img.setAttribute("width", image.width);
              img.setAttribute("height", image.height);
              img.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href",
                  image.nodeName === "CANVAS" ? image.toDataURL() : image.getAttribute("src"));
              pattern.appendChild(img);
              this.__defs.appendChild(pattern);
          } else if (image instanceof ctx) {
              pattern.appendChild(image.__root.childNodes[1]);
              this.__defs.appendChild(pattern);
          }
          return new CanvasPattern(pattern, this)
      };

      setLineDash(dashArray) {
          if (dashArray && dashArray.length > 0) {
              this.lineDash = dashArray.join(",");
          } else {
              this.lineDash = null;
          }
      };

      /**
       * Not yet implemented
       */
      drawFocusRing() {
      };

      createImageData() {
      };

      getImageData() {
      };

      putImageData() {
      };

      globalCompositeOperation() {
      };

      setTransform() {
      };
  }

  const Cytoband = function (start, end, name, typestain) {
      this.start = start;
      this.end = end;
      this.name = name;
      this.stain = 0;

      // Set the type, either p, n, or c
      if (typestain === 'acen') {
          this.type = 'c';
      } else {
          this.type = typestain.charAt(1);
          if (this.type === 'p') {
              this.stain = parseInt(typestain.substring(4));
          }
      }
  };

  const _version$1 = "2.15.2";
  function version$2() {
      return _version$1
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const DEFAULT_GENOMES_URL = "https://igv.org/genomes/genomes.json";
  const BACKUP_GENOMES_URL = "https://s3.amazonaws.com/igv.org.genomes/genomes.json";

  const splitLines$1 = splitLines$5;

  const GenomeUtils = {

      loadGenome: async function (options) {

          const cytobandUrl = options.cytobandURL;
          const aliasURL = options.aliasURL;
          const sequence = await loadFasta(options);

          let aliases;
          if (aliasURL) {
              aliases = await loadAliases(aliasURL, sequence.config);
          }

          const genome = new Genome(options, sequence, aliases);

          // Delay loading cytbands untils after genome initialization to use chromosome aliases (1 vs chr1, etc).
          if (cytobandUrl) {
              genome.cytobands  = await loadCytobands(cytobandUrl, sequence.config, genome);
          }

          return genome
      },

      initializeGenomes: async function (config) {

          if (!GenomeUtils.KNOWN_GENOMES) {

              const table = {};

              // Get default genomes
              if (config.loadDefaultGenomes !== false) {
                  try {
                      const url = DEFAULT_GENOMES_URL + `?randomSeed=${Math.random().toString(36)}&version=${version$2()}`;  // prevent caching
                      const jsonArray = await igvxhr$1.loadJson(url, {timeout: 5000});
                      processJson(jsonArray);
                  } catch (e) {
                      console.error(e);
                      try {
                          const url = BACKUP_GENOMES_URL + `?randomSeed=${Math.random().toString(36)}&version=${version$2()}`;  // prevent caching
                          const jsonArray = await igvxhr$1.loadJson(url, {});
                          processJson(jsonArray);
                      } catch (e) {
                          console.error(e);
                          console.warn("Errors loading default genome definitions.");
                      }
                  }
              }

              // Add user-defined genomes
              const genomeList = config.genomeList || config.genomes;
              if (genomeList) {
                  if (typeof genomeList === 'string') {
                      const jsonArray = await igvxhr$1.loadJson(genomeList, {});
                      processJson(jsonArray);
                  } else {
                      processJson(genomeList);
                  }
              }

              GenomeUtils.KNOWN_GENOMES = table;

              function processJson(jsonArray) {
                  jsonArray.forEach(function (json) {
                      table[json.id] = json;
                  });
                  return table
              }
          }
      },

      isWholeGenomeView: function (chr) {
          return 'all' === chr.toLowerCase()
      },

      // Expand a genome id to a reference object, if needed
      expandReference: function (alert, idOrConfig) {

          // idOrConfig might be json
          if (isString$2(idOrConfig) && idOrConfig.startsWith("{")) {
              try {
                  idOrConfig = JSON.parse(idOrConfig);
              } catch (e) {
                  // Apparently its not json,  could be an ID starting with "{".  Unusual but legal.
              }
          }

          let genomeID;
          if (isString$2(idOrConfig)) {
              genomeID = idOrConfig;
          } else if (idOrConfig.genome) {
              genomeID = idOrConfig.genome;
          } else if (idOrConfig.id !== undefined && idOrConfig.fastaURL === undefined) {
              // Backward compatibility
              genomeID = idOrConfig.id;
          }

          if (genomeID) {
              const knownGenomes = GenomeUtils.KNOWN_GENOMES;
              const reference = knownGenomes[genomeID];
              if (!reference) {
                  alert.present(new Error(`Unknown genome id: ${genomeID}`), undefined);
              }
              return reference
          } else {
              return idOrConfig
          }
      }
  };


  class Genome {

      constructor(config, sequence, aliases) {

          this.config = config;
          this.id = config.id || generateGenomeID(config);
          this.sequence = sequence;
          this.chromosomeNames = sequence.chromosomeNames;
          this.chromosomes = sequence.chromosomes;  // An object (functions as a dictionary)
          this.featureDB = {};   // Hash of name -> feature, used for search function.

          this.wholeGenomeView = config.wholeGenomeView === undefined || config.wholeGenomeView;
          if (this.wholeGenomeView && Object.keys(sequence.chromosomes).length > 1) {
              constructWG(this, config);
          } else {
              this.wgChromosomeNames = sequence.chromosomeNames;
          }

          /**
           * Return the official chromosome name for the (possibly) alias.  Deals with
           * 1 <-> chr1,  chrM <-> MT,  IV <-> chr4, etc.
           * @param str
           */
          var chrAliasTable = {},
              self = this;


          // The standard mappings
          chrAliasTable["all"] = "all";
          this.chromosomeNames.forEach(function (name) {
              var alias = name.startsWith("chr") ? name.substring(3) : "chr" + name;
              chrAliasTable[alias.toLowerCase()] = name;
              if (name === "chrM") chrAliasTable["mt"] = "chrM";
              if (name === "MT") chrAliasTable["chrm"] = "MT";
              chrAliasTable[name.toLowerCase()] = name;
          });

          // Custom mappings
          if (aliases) {
              aliases.forEach(function (array) {
                  // Find the official chr name
                  var defName, i;

                  for (i = 0; i < array.length; i++) {
                      if (self.chromosomes[array[i]]) {
                          defName = array[i];
                          break
                      }
                  }

                  if (defName) {
                      array.forEach(function (alias) {
                          if (alias !== defName) {
                              chrAliasTable[alias.toLowerCase()] = defName;
                              chrAliasTable[alias] = defName;      // Should not be needed
                          }
                      });
                  }

              });
          }

          this.chrAliasTable = chrAliasTable;

      }

      showWholeGenomeView() {
          return this.config.wholeGenomeView !== false
      }

      toJSON() {
          return Object.assign({}, this.config, {tracks: undefined})
      }

      getInitialLocus() {

      }

      getHomeChromosomeName() {
          if (this.showWholeGenomeView() && this.chromosomes.hasOwnProperty("all")) {
              return "all"
          } else {
              return this.chromosomeNames[0]

          }
      }

      getChromosomeName(str) {
          const chr = str ? this.chrAliasTable[str.toLowerCase()] : str;
          return chr ? chr : str
      }

      getChromosome(chr) {
          chr = this.getChromosomeName(chr);
          return this.chromosomes[chr]
      }

      getCytobands(chr) {
          return this.cytobands ? this.cytobands[chr] : null
      }

      getLongestChromosome() {

          var longestChr,
              chromosomes = this.chromosomes;
          for (let key in chromosomes) {
              if (chromosomes.hasOwnProperty(key)) {
                  var chr = chromosomes[key];
                  if (longestChr === undefined || chr.bpLength > longestChr.bpLength) {
                      longestChr = chr;
                  }
              }
              return longestChr
          }
      }

      getChromosomes() {
          return this.chromosomes
      }

      /**
       * Return the genome coordinate in kb for the give chromosome and position.
       * NOTE: This might return undefined if the chr is filtered from whole genome view.
       */
      getGenomeCoordinate(chr, bp) {

          var offset = this.getCumulativeOffset(chr);
          if (offset === undefined) return undefined

          return offset + bp
      }

      /**
       * Return the chromosome and coordinate in bp for the given genome coordinate
       */
      getChromosomeCoordinate(genomeCoordinate) {

          if (this.cumulativeOffsets === undefined) {
              this.cumulativeOffsets = computeCumulativeOffsets.call(this);
          }

          let lastChr = undefined;
          let lastCoord = 0;
          for (let name of this.wgChromosomeNames) {

              const cumulativeOffset = this.cumulativeOffsets[name];
              if (cumulativeOffset > genomeCoordinate) {
                  const position = genomeCoordinate - lastCoord;
                  return {chr: lastChr, position: position}
              }
              lastChr = name;
              lastCoord = cumulativeOffset;
          }

          // If we get here off the end
          return {chr: this.wgChromosomeNames[this.wgChromosomeNames.length - 1], position: 0}

      };


      /**
       * Return the offset in genome coordinates (kb) of the start of the given chromosome
       * NOTE:  This might return undefined if the chromosome is filtered from whole genome view.
       */
      getCumulativeOffset(chr) {

          if (this.cumulativeOffsets === undefined) {
              this.cumulativeOffsets = computeCumulativeOffsets.call(this);
          }

          const queryChr = this.getChromosomeName(chr);
          return this.cumulativeOffsets[queryChr]

          function computeCumulativeOffsets() {

              let self = this;
              let acc = {};
              let offset = 0;
              for (let name of self.wgChromosomeNames) {

                  acc[name] = Math.floor(offset);

                  const chromosome = self.getChromosome(name);

                  offset += chromosome.bpLength;
              }

              return acc
          }
      }

      /**
       * Return the nominal genome length, this is the length of the main chromosomes (no scaffolds, etc).
       */
      getGenomeLength() {

          let self = this;

          if (!this.bpLength) {
              let bpLength = 0;
              self.wgChromosomeNames.forEach(function (cname) {
                  let c = self.chromosomes[cname];
                  bpLength += c.bpLength;
              });
              this.bpLength = bpLength;
          }
          return this.bpLength
      }

      async getSequence(chr, start, end) {
          chr = this.getChromosomeName(chr);
          return this.sequence.getSequence(chr, start, end)
      }
  }

  async function loadCytobands(cytobandUrl, config, genome) {

      let data;
      if (isDataURL(cytobandUrl)) {
          const plain = decodeDataURI$1(cytobandUrl);
          data = "";
          const len = plain.length;
          for (let i = 0; i < len; i++) {
              data += String.fromCharCode(plain[i]);
          }
      } else {
          data = await igvxhr$1.loadString(cytobandUrl, buildOptions(config));
      }

      // var bands = [],
      //     lastChr,
      //     n = 0,
      //     c = 1,
      //
      //     len = lines.length,
      const cytobands = {};
      let lastChr;
      let bands = [];
      const lines = splitLines$1(data);
      for (let line of lines) {
          var tokens = line.split("\t");
          var chr = genome.getChromosomeName(tokens[0]);
          if (!lastChr) lastChr = chr;

          if (chr !== lastChr) {
              cytobands[lastChr] = bands;
              bands = [];
              lastChr = chr;
          }

          if (tokens.length === 5) {
              //10	0	3000000	p15.3	gneg
              var start = parseInt(tokens[1]);
              var end = parseInt(tokens[2]);
              var name = tokens[3];
              var stain = tokens[4];
              bands.push(new Cytoband(start, end, name, stain));
          }
      }

      return cytobands
  }

  function loadAliases(aliasURL, config) {

      return igvxhr$1.loadString(aliasURL, buildOptions(config))

          .then(function (data) {

              var lines = splitLines$1(data),
                  aliases = [];

              lines.forEach(function (line) {
                  if (!line.startsWith("#") && line.length > 0) aliases.push(line.split("\t"));
              });

              return aliases
          })

  }

  function constructWG(genome, config) {

      let wgChromosomes;
      if (config.chromosomeOrder) {
          if (Array.isArray(config.chromosomeOrder)) {
              genome.wgChromosomeNames = config.chromosomeOrder;
          } else {
              genome.wgChromosomeNames = config.chromosomeOrder.split(',').map(nm => nm.trim());
          }
          wgChromosomes = genome.wgChromosomeNames.map(nm => genome.chromosomes[nm]).filter(chr => chr !== undefined);

      } else {

          // Trim small chromosomes.
          const lengths = Object.keys(genome.chromosomes).map(key => genome.chromosomes[key].bpLength);
          const median = lengths.reduce((a, b) => Math.max(a, b));
          const threshold = median / 50;
          wgChromosomes = Object.values(genome.chromosomes).filter(chr => chr.bpLength > threshold);

          // Sort chromosomes.  First segregate numeric and alpha names, sort numeric, leave alpha as is
          const numericChromosomes = wgChromosomes.filter(chr => isDigit(chr.name.replace('chr', '')));
          const alphaChromosomes = wgChromosomes.filter(chr => !isDigit(chr.name.replace('chr', '')));
          numericChromosomes.sort((a, b) => Number.parseInt(a.name.replace('chr', '')) - Number.parseInt(b.name.replace('chr', '')));

          const wgChromosomeNames = numericChromosomes.map(chr => chr.name);
          for (let chr of alphaChromosomes) {
              wgChromosomeNames.push(chr.name);
          }
          genome.wgChromosomeNames = wgChromosomeNames;
      }


      // Compute psuedo-chromosome "all"
      const l = wgChromosomes.reduce((accumulator, currentValue) => accumulator += currentValue.bpLength, 0);
      genome.chromosomes["all"] = {
          name: "all",
          bpLength: l
      };

      function isDigit(val) {
          return /^\d+$/.test(val)
      }

  }

  function generateGenomeID(config) {
      if (config.id !== undefined) {
          return config.id
      } else if (config.fastaURL && isString$2(config.fastaURL)) {
          return config.fastaURL
      } else if (config.fastaURL && config.fastaURL.name) {
          return config.fastaURL.name
      } else {
          return ("0000" + (Math.random() * Math.pow(36, 4) << 0).toString(36)).slice(-4)
      }
  }

  /**
   * Created by dat on 9/16/16.
   */

  const NOT_LOADED_MESSAGE = 'Error loading track data';
  let lastClickTime = 0;
  let lastHoverUpdateTime = 0;
  let popupTimerID;

  class TrackViewport extends Viewport {

      constructor(trackView, viewportColumn, referenceFrame, width) {
          super(trackView, viewportColumn, referenceFrame, width);
      }

      initializationHelper() {

          this.$spinner = $$1('<div>', {class: 'igv-loading-spinner-container'});
          this.$viewport.append(this.$spinner);
          this.$spinner.append($$1('<div>'));

          const track = this.trackView.track;
          if ('sequence' !== track.type) {
              this.$zoomInNotice = this.createZoomInNotice(this.$viewport);
          }

          if (track.name && "sequence" !== track.id) {
              this.$trackLabel = $$1('<div class="igv-track-label">');
              this.$viewport.append(this.$trackLabel);
              this.setTrackLabel(track.name);
              if (false === this.browser.trackLabelsVisible) {
                  this.$trackLabel.hide();
              }
          }

          this.stopSpinner();
          this.addMouseHandlers();
      }

      setContentHeight(contentHeight) {
          super.setContentHeight(contentHeight);
          if (this.featureCache) this.featureCache.redraw = true;
      }

      setTrackLabel(label) {

          this.$trackLabel.empty();
          this.$trackLabel.html(label);

          const txt = this.$trackLabel.text();
          this.$trackLabel.attr('title', txt);
      }

      startSpinner() {
          this.$spinner.show();
      }

      stopSpinner() {
          if (this.$spinner) {
              this.$spinner.hide();
          }
      }

      /**
       * Test to determine if we are zoomed in far enough to see features. Applicable to tracks with visibility windows.
       *
       * As a side effect the viewports canvas is removed if zoomed out.
       *
       * @returns {boolean} true if we are zoomed in past visibility window, false otherwise
       */
      checkZoomIn() {

          const zoomedOutOfWindow = () => {
              if (this.referenceFrame.chr.toLowerCase() === "all" && !this.trackView.track.supportsWholeGenome) {
                  return true
              } else {
                  const visibilityWindow = this.trackView.track.visibilityWindow;
                  return (
                      visibilityWindow !== undefined && visibilityWindow > 0 &&
                      (this.referenceFrame.bpPerPixel * this.$viewport.width() > visibilityWindow))
              }
          };

          if (this.trackView.track && "sequence" === this.trackView.track.type && this.referenceFrame.bpPerPixel > bppFeatureFetchThreshold) {
              $$1(this.canvas).remove();
              this.canvas = undefined;
              //this.featureCache = undefined
              return false
          }

          if (!(this.viewIsReady())) {
              return false
          }


          if (zoomedOutOfWindow()) {

              // Out of visibility window
              if (this.canvas) {
                  $$1(this.canvas).remove();
                  this.canvas = undefined;
                  //this.featureCache = undefined
              }
              if (this.trackView.track.autoHeight) {
                  const minHeight = this.trackView.minHeight || 0;
                  this.setContentHeight(minHeight);
              }
              if (this.$zoomInNotice) {
                  this.$zoomInNotice.show();
              }
              return false
          } else {
              if (this.$zoomInNotice) {
                  this.$zoomInNotice.hide();
              }
              return true
          }

      }

      /**
       * Adjust the canvas to the current genomic state.
       */
      shift() {
          const referenceFrame = this.referenceFrame;
          if (this.canvas &&
              this.canvas._data &&
              this.canvas._data.referenceFrame.chr === this.referenceFrame.chr &&
              this.canvas._data.bpPerPixel === referenceFrame.bpPerPixel) {
              const pixelOffset = Math.round((this.canvas._data.bpStart - referenceFrame.start) / referenceFrame.bpPerPixel);
              this.canvas.style.left = pixelOffset + "px";
          }
      }

      /**
       * Set the content top of the current view.  This is triggered by scrolling.   If the current canvas extent is not
       * sufficient to cover the new vertical range repaint.
       *
       * @param contentTop - the "top" property of the virtual content div, 0 unless track is scrolled vertically
       *
       *
       */
      setTop(contentTop) {

          super.setTop(contentTop);

          if (!this.canvas) {
              this.repaint();
          } else {
              // See if currently painted canvas covers the vertical range of the viewport.  If not repaint
              const h = this.$viewport.height();
              const vt = contentTop + this.canvas._data.pixelTop;
              const vb = vt + this.canvas._data.pixelHeight;
              if (vt > 0 || vb < h) {
                  this.repaint();
              }
          }

          // Now offset backing canvas to align with the contentTop visual offset.
          let offset = contentTop + this.canvas._data.pixelTop;
          this.canvas.style.top = `${offset}px`;
      }

      async loadFeatures() {

          const referenceFrame = this.referenceFrame;
          const chr = referenceFrame.chr;

          // Expand the requested range so we can pan a bit without reloading.  But not beyond chromosome bounds
          const chrLength = this.browser.genome.getChromosome(chr).bpLength;
          const pixelWidth = this.$viewport.width();// * 3;
          const bpWidth = pixelWidth * referenceFrame.bpPerPixel;
          const bpStart = Math.floor(Math.max(0, referenceFrame.start - bpWidth));
          const bpEnd = Math.ceil(Math.min(chrLength, referenceFrame.start + bpWidth + bpWidth));  // Add one screen width to end

          if (this.loading && this.loading.start === bpStart && this.loading.end === bpEnd) {
              return undefined
          }
          this.loading = {start: bpStart, end: bpEnd};
          this.startSpinner();

          try {
              const track = this.trackView.track;
              const features = await this.getFeatures(track, chr, bpStart, bpEnd, referenceFrame.bpPerPixel);
              if (features) {
                  let roiFeatures = [];
                  if (track.roiSets && track.roiSets.length > 0) {
                      for (let roiSet of track.roiSets) {
                          const features = await roiSet.getFeatures(chr, bpStart, bpEnd, referenceFrame.bpPerPixel);
                          roiFeatures.push({track: roiSet, features});
                      }
                  }

                  const mr = track && ("wig" === track.type || "merged" === track.type);   // wig tracks are potentially multiresolution (e.g. bigwig)
                  this.featureCache = new FeatureCache(chr, bpStart, bpEnd, referenceFrame.bpPerPixel, features, roiFeatures, mr);
                  this.loading = false;
                  this.hideMessage();
                  this.stopSpinner();
                  return this.featureCache
              }
          } catch (error) {
              // Track might have been removed during load
              if (this.trackView && this.trackView.disposed !== true) {
                  this.showMessage(NOT_LOADED_MESSAGE);
                  this.browser.alert.present(error);
                  console.error(error);
              }
          } finally {
              this.loading = false;
              this.stopSpinner();
          }
      }

      /**
       * Compute the genomic extent and needed pixelWidth to repaint the canvas for the current genomic state.
       * Normally the canvas is size 3X the width of the viewport, however there is no left-right panning for WGV so
       * canvas width is viewport width.
       * @returns {{bpEnd: *, pixelWidth: (*|number), bpStart: number}}
       */
      repaintDimensions() {
          const isWGV = GenomeUtils.isWholeGenomeView(this.referenceFrame.chr);
          const pixelWidth = isWGV ? this.$viewport.width() : 3 * this.$viewport.width();
          const bpPerPixel = this.referenceFrame.bpPerPixel;
          const bpStart = this.referenceFrame.start - (isWGV ? 0 : pixelWidth / 3 * bpPerPixel);
          const bpEnd = this.referenceFrame.end + (isWGV ? 0 : pixelWidth / 3 * bpPerPixel);
          return {
              bpStart, bpEnd, pixelWidth
          }
      }

      /**
       * Repaint the canvas using the cached features
       *
       */
      repaint() {

          if (undefined === this.featureCache) {
              return
          }

          const {features, roiFeatures} = this.featureCache;

          // Canvas dimensions.
          // For deep tracks we paint a canvas == 3*viewportHeight centered on the current vertical scroll position
          const {bpStart, bpEnd, pixelWidth} = this.repaintDimensions();
          const viewportHeight = this.$viewport.height();
          const contentHeight = this.getContentHeight();
          const maxHeight = roiFeatures ? Math.max(contentHeight, viewportHeight) : contentHeight;  // Need to fill viewport for ROIs.
          const pixelHeight = Math.min(maxHeight, 3 * viewportHeight);
          if (0 === pixelWidth || 0 === pixelHeight) {
              if (this.canvas) {
                  $$1(this.canvas).remove();
              }
              return
          }
          const pixelTop = Math.max(0, -this.contentTop - Math.floor(pixelHeight / 3));

          const bpPerPixel = this.referenceFrame.bpPerPixel;
          const pixelXOffset = Math.round((bpStart - this.referenceFrame.start) / bpPerPixel);
          const canvasTop = (this.contentTop || 0) + pixelTop;
          const newCanvas = document.createElement('canvas');//  $('<canvas class="igv-canvas">').get(0)
          newCanvas.style.position = 'relative';
          newCanvas.style.display = 'block';
          newCanvas.style.width = pixelWidth + "px";
          newCanvas.style.height = pixelHeight + "px";
          newCanvas.style.left = pixelXOffset + "px";
          newCanvas.style.top = canvasTop + "px";

          // Always use high DPI if in "FILL" display mode, otherwise use track setting;
          const devicePixelRatio = ("FILL" === this.trackView.track.displayMode || this.trackView.track.supportHiDPI !== false) ?
              window.devicePixelRatio : 1;
          newCanvas.width = devicePixelRatio * pixelWidth;
          newCanvas.height = devicePixelRatio * pixelHeight;

          const ctx = newCanvas.getContext("2d");
          ctx.scale(devicePixelRatio, devicePixelRatio);
          ctx.translate(0, -pixelTop);

          const drawConfiguration =
              {
                  context: ctx,
                  pixelXOffset,
                  pixelWidth,
                  pixelHeight,
                  pixelTop,
                  bpStart,
                  bpEnd: bpEnd,
                  bpPerPixel,
                  referenceFrame: this.referenceFrame,
                  selection: this.selection,
                  viewport: this,
                  viewportWidth: this.$viewport.width()
              };

          this.draw(drawConfiguration, features, roiFeatures);

          if (this.canvas) {
              $$1(this.canvas).remove();
          }
          newCanvas._data = drawConfiguration;
          this.canvas = newCanvas;
          this.$viewport.append($$1(newCanvas));

      }

      refresh() {
          if (!(this.canvas && this.featureCache)) return

          const drawConfiguration = this.canvas._data;
          drawConfiguration.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
          const {features, roiFeatures} = this.featureCache;
          this.draw(drawConfiguration, features, roiFeatures);
      }

      /**
       * Draw the associated track.
       *
       * @param drawConfiguration
       * @param features
       * @param roiFeatures
       */
      draw(drawConfiguration, features, roiFeatures) {

          if (features) {
              drawConfiguration.features = features;
              this.trackView.track.draw(drawConfiguration);
          }
          if (roiFeatures && roiFeatures.length > 0) {
              for (let r of roiFeatures) {
                  drawConfiguration.features = r.features;
                  r.track.draw(drawConfiguration);
              }
          }
      }

      containsPosition(chr, position) {
          if (this.referenceFrame.chr === chr && position >= this.referenceFrame.start) {
              return position <= this.referenceFrame.calculateEnd(this.getWidth())
          } else {
              return false
          }
      }

      isLoading() {
          return this.loading
      }

      savePNG() {

          if (!this.canvas) return

          const canvasMetadata = this.canvas._data;
          const canvasTop = canvasMetadata ? canvasMetadata.pixelTop : 0;
          const devicePixelRatio = window.devicePixelRatio;
          const w = this.$viewport.width() * devicePixelRatio;
          const h = this.$viewport.height() * devicePixelRatio;
          const x = -$$1(this.canvas).position().left * devicePixelRatio;
          const y = (-this.contentTop - canvasTop) * devicePixelRatio;

          const ctx = this.canvas.getContext("2d");
          const imageData = ctx.getImageData(x, y, w, h);
          const exportCanvas = document.createElement('canvas');
          const exportCtx = exportCanvas.getContext('2d');
          exportCanvas.width = imageData.width;
          exportCanvas.height = imageData.height;
          exportCtx.putImageData(imageData, 0, 0);

          // filename = this.trackView.track.name + ".png";
          const filename = (this.$trackLabel.text() ? this.$trackLabel.text() : "image") + ".png";
          const data = exportCanvas.toDataURL("image/png");
          download$1(filename, data);
      }

      saveSVG() {

          const marginTop = 32;
          const marginLeft = 32;

          let {width, height} = this.browser.columnContainer.getBoundingClientRect();

          const h_render = 8000;

          const config =
              {

                  width,
                  height: h_render,

                  backdropColor: 'white',

                  multiLocusGap: 0,

                  viewbox:
                      {
                          x: 0,
                          y: 0,
                          width,
                          height: h_render
                      }

              };

          const context = new ctx(config);

          const delta =
              {
                  deltaX: marginLeft,
                  deltaY: marginTop
              };

          this.renderViewportToSVG(context, delta);

          // reset height to trim away unneeded svg canvas real estate. Yes, a bit of a hack.
          context.setHeight(height);

          const str = (this.trackView.track.name || this.trackView.track.id).replace(/\W/g, '');
          const index = this.browser.referenceFrameList.indexOf(this.referenceFrame);

          const svg = context.getSerializedSvg(true);
          const data = URL.createObjectURL(new Blob([svg], {type: "application/octet-stream"}));

          const id = `${str}_referenceFrame_${index}_guid_${domUtils.guid()}`;
          download$1(`${id}.svg`, data);

      }

      // called by trackView.renderSVGContext() when rendering
      // entire browser as SVG

      renderViewportToSVG(context, {deltaX, deltaY}) {

          if (this.$zoomInNotice && this.$zoomInNotice.is(":visible")) {
              return
          }

          const {width, height} = this.$viewport.get(0).getBoundingClientRect();

          const str = (this.trackView.track.name || this.trackView.track.id).replace(/\W/g, '');
          const index = this.browser.referenceFrameList.indexOf(this.referenceFrame);
          const id = `${str}_referenceFrame_${index}_guid_${domUtils.guid()}`;
          this.drawSVGWithContext(context, width, height, id, deltaX, deltaY + this.contentTop, -this.contentTop);

      }

      renderSVGContext(context, {deltaX, deltaY}) {

          this.renderViewportToSVG(context, {deltaX, deltaY});

          if (this.$zoomInNotice && this.$zoomInNotice.is(":visible")) {
              return
          }

          if (this.$trackLabel && true === this.browser.trackLabelsVisible) {
              const {x, y, width, height} = domUtils.relativeDOMBBox(this.$viewport.get(0), this.$trackLabel.get(0));
              this.renderTrackLabelSVG(context, deltaX + x, deltaY + y, width, height);
          }

      }

      // render track label element called from renderSVGContext()
      renderTrackLabelSVG(context, tx, ty, width, height) {

          const str = (this.trackView.track.name || this.trackView.track.id).replace(/\W/g, '');
          const id = `${str}_track_label_guid_${domUtils.guid()}`;

          context.saveWithTranslationAndClipRect(id, tx, ty, width, height, 0);

          context.fillStyle = "white";
          context.fillRect(0, 0, width, height);

          context.font = "12px Arial";
          context.fillStyle = 'rgb(68, 68, 68)';

          const {width: stringWidth} = context.measureText(this.$trackLabel.text());
          const dx = 0.25 * (width - stringWidth);
          const dy = 0.7 * (height - 12);
          context.fillText(this.$trackLabel.text(), dx, height - dy);

          context.strokeStyle = 'rgb(68, 68, 68)';
          context.strokeRect(0, 0, width, height);

          context.restore();

      }

      // called by renderSVGContext()
      drawSVGWithContext(context, width, height, id, x, y, yClipOffset) {

          context.saveWithTranslationAndClipRect(id, x, y, width, height, yClipOffset);

          let {start, bpPerPixel} = this.referenceFrame;

          const config =
              {
                  context,
                  viewport: this,
                  referenceFrame: this.referenceFrame,
                  top: yClipOffset,
                  pixelTop: yClipOffset,
                  pixelWidth: width,
                  pixelHeight: height,
                  bpStart: start,
                  bpEnd: start + (width * bpPerPixel),
                  bpPerPixel,
                  viewportWidth: width,
                  selection: this.selection
              };

          const features = this.featureCache ? this.featureCache.features : undefined;
          const roiFeatures = this.featureCache ? this.featureCache.roiFeatures : undefined;
          this.draw(config, features, roiFeatures);

          context.restore();

      }

      get cachedFeatures() {
          return this.featureCache ? this.featureCache.features : []
      }

      clearCache() {
          this.featureCache = undefined;
          if (this.canvas) this.canvas._data = undefined;
      }

      async getFeatures(track, chr, start, end, bpPerPixel) {
          if (this.featureCache && this.featureCache.containsRange(chr, start, end, bpPerPixel)) {
              return this.featureCache.features
          } else if (typeof track.getFeatures === "function") {
              const features = await track.getFeatures(chr, start, end, bpPerPixel, this);
              this.checkContentHeight(features);
              return features
          } else {
              return undefined
          }
      }

      needsRepaint() {

          if (!this.canvas) return true

          const data = this.canvas._data;
          return !data ||
              this.referenceFrame.start < data.bpStart ||
              this.referenceFrame.end > data.bpEnd ||
              this.referenceFrame.chr !== data.referenceFrame.chr ||
              this.referenceFrame.bpPerPixel != data.bpPerPixel
      }

      needsReload() {
          if (!this.featureCache) return true
          const {chr, bpPerPixel} = this.referenceFrame;
          const {bpStart, bpEnd} = this.repaintDimensions();
          return (!this.featureCache.containsRange(chr, bpStart, bpEnd, bpPerPixel))
      }

      createZoomInNotice($parent) {

          const $container = $$1('<div>', {class: 'igv-zoom-in-notice-container'});
          $parent.append($container);

          const $e = $$1('<div>');
          $container.append($e);

          $e.text('Zoom in to see features');

          $container.hide();

          return $container
      }

      viewIsReady() {
          return this.browser && this.browser.referenceFrameList && this.referenceFrame
      }

      addMouseHandlers() {

          const viewport = this.$viewport.get(0);

          this.addViewportContextMenuHandler(viewport);

          // Mouse down
          const md = (event) => {
              this.enableClick = true;
              this.browser.mouseDownOnViewport(event, this);
              domUtils.pageCoordinates(event);
          };
          viewport.addEventListener('mousedown', md);
          viewport.addEventListener('touchstart', md);

          // Mouse up
          const mu = (event) => {
              // Any mouse up cancels drag and scrolling
              if (this.browser.dragObject || this.browser.isScrolling) {
                  this.browser.cancelTrackPan();
                  // event.preventDefault();
                  // event.stopPropagation();
                  this.enableClick = false;   // Until next mouse down
              } else {
                  this.browser.cancelTrackPan();
                  this.browser.endTrackDrag();
              }
          };
          viewport.addEventListener('mouseup', mu);
          viewport.addEventListener('touchend', mu);

          // Mouse move
          if (typeof this.trackView.track.hoverText === 'function') {
              viewport.addEventListener('mousemove', (event => {
                  if (event.buttons === 0 && (Date.now() - lastHoverUpdateTime > 100)) {
                      lastHoverUpdateTime = Date.now();
                      const clickState = this.createClickState(event);
                      if (clickState) {
                          const tooltip = this.trackView.track.hoverText(clickState);
                          if (tooltip) {
                              this.$viewport[0].setAttribute("title", tooltip);
                          } else {
                              this.$viewport[0].removeAttribute("title");
                          }
                      }
                  }
              }));
          }

          this.addViewportClickHandler(this.$viewport.get(0));

          if (this.trackView.track.name && "sequence" !== this.trackView.track.config.type) {
              this.addTrackLabelClickHandler(this.$trackLabel.get(0));
          }

      }

      addViewportContextMenuHandler(viewport) {

          viewport.addEventListener('contextmenu', (event) => {

              // Ignore if we are doing a drag.  This can happen with touch events.
              if (this.browser.dragObject) {
                  return false
              }

              const clickState = this.createClickState(event);

              if (undefined === clickState) {
                  return false
              }

              event.preventDefault();

              // Track specific items
              let menuItems = [];
              if (typeof this.trackView.track.contextMenuItemList === "function") {
                  const trackMenuItems = this.trackView.track.contextMenuItemList(clickState);
                  if (trackMenuItems) {
                      menuItems = trackMenuItems;
                  }
              }

              // Add items common to all tracks
              if (menuItems.length > 0) {
                  menuItems.push({label: $$1('<HR>')});
              }

              menuItems.push({label: 'Save Image (PNG)', click: () => this.savePNG()});
              menuItems.push({label: 'Save Image (SVG)', click: () => this.saveSVG()});

              this.browser.menuPopup.presentTrackContextMenu(event, menuItems);
          });

      }


      addViewportClickHandler(viewport) {

          viewport.addEventListener('click', (event) => {

              if (this.enableClick && this.canvas) {
                  if (3 === event.which || event.ctrlKey) {
                      return
                  }

                  // Close any currently open popups
                  $$1('.igv-popover').hide();


                  if (this.browser.dragObject || this.browser.isScrolling) {
                      return
                  }

                  // Treat as a mouse click, its either a single or double click.
                  // Handle here and stop propogation / default
                  event.preventDefault();

                  const mouseX = domUtils.translateMouseCoordinates(event, this.$viewport.get(0)).x;
                  const mouseXCanvas = domUtils.translateMouseCoordinates(event, this.canvas).x;
                  const referenceFrame = this.referenceFrame;
                  const xBP = Math.floor((referenceFrame.start) + referenceFrame.toBP(mouseXCanvas));

                  const time = Date.now();

                  if (time - lastClickTime < this.browser.constants.doubleClickDelay) {

                      // double-click
                      if (popupTimerID) {
                          window.clearTimeout(popupTimerID);
                          popupTimerID = undefined;
                      }

                      const centerBP = Math.round(referenceFrame.start + referenceFrame.toBP(mouseX));

                      let string;

                      if ('all' === this.referenceFrame.chr.toLowerCase()) {

                          const chr = this.browser.genome.getChromosomeCoordinate(centerBP).chr;

                          if (1 === this.browser.referenceFrameList.length) {
                              string = chr;
                          } else {
                              const loci = this.browser.referenceFrameList.map(({locusSearchString}) => locusSearchString);
                              const index = this.browser.referenceFrameList.indexOf(this.referenceFrame);
                              loci[index] = chr;
                              string = loci.join(' ');
                          }

                          this.browser.search(string);

                      } else {
                          this.browser.zoomWithScaleFactor(0.5, centerBP, this.referenceFrame);
                      }


                  } else {
                      // single-click

                      if (event.shiftKey && typeof this.trackView.track.shiftClick === "function") {

                          this.trackView.track.shiftClick(xBP, event);

                      } else if (typeof this.trackView.track.popupData === "function") {

                          popupTimerID = setTimeout(() => {

                                  const content = this.getPopupContent(event);
                                  if (content) {
                                      if (this.popover) this.popover.dispose();
                                      this.popover = new Popover(this.browser.columnContainer);
                                      this.popover.presentContentWithEvent(event, content);
                                  }
                                  window.clearTimeout(popupTimerID);
                                  popupTimerID = undefined;
                              },
                              this.browser.constants.doubleClickDelay);
                      }
                  }

                  lastClickTime = time;

              }
          });
      }

      addTrackLabelClickHandler(trackLabel) {

          trackLabel.addEventListener('click', (event) => {

              event.stopPropagation();

              const {track} = this.trackView;

              let str;
              if (typeof track.description === 'function') {
                  str = track.description();
              } else if (track.description) {
                  str = `<div>${track.description}</div>`;
              }

              if (str) {
                  if (this.popover) {
                      this.popover.dispose();
                  }
                  this.popover = new Popover(this.browser.columnContainer, (track.name || ''));
                  this.popover.presentContentWithEvent(event, str);
              }
          });
      }

      createClickState(event) {

          if (!this.canvas) return  // Can happen during initialization

          const referenceFrame = this.referenceFrame;
          const viewportCoords = domUtils.translateMouseCoordinates(event, this.$viewport.get(0));
          const canvasCoords = domUtils.translateMouseCoordinates(event, this.canvas);
          const genomicLocation = ((referenceFrame.start) + referenceFrame.toBP(viewportCoords.x));

          return {
              event,
              viewport: this,
              referenceFrame,
              genomicLocation,
              y: viewportCoords.y - this.contentTop,
              canvasX: canvasCoords.x,
              canvasY: canvasCoords.y
          }

      }

      getPopupContent(event) {

          const clickState = this.createClickState(event);

          if (undefined === clickState) {
              return
          }

          let track = this.trackView.track;
          const dataList = track.popupData(clickState);

          const popupClickHandlerResult = this.browser.fireEvent('trackclick', [track, dataList]);

          let content;
          if (undefined === popupClickHandlerResult || true === popupClickHandlerResult) {
              // Indicates handler did not handle the result, or the handler wishes default behavior to occur
              if (dataList && dataList.length > 0) {
                  content = formatPopoverText(dataList);
              }

          } else if (typeof popupClickHandlerResult === 'string') {
              content = popupClickHandlerResult;
          }

          return content
      }


  }


  function formatPopoverText(nameValues) {

      const rows = nameValues.map(nameValue => {

          if (nameValue.name) {
              const str = `<span>${nameValue.name}</span>&nbsp&nbsp&nbsp${nameValue.value}`;
              return `<div title="${nameValue.value}">${str}</div>`
          } else if ('<hr>' === nameValue) { // this can be retired if nameValue.html is allowed.
              return nameValue
          } else if (nameValue.html) {
              return nameValue.html
          } else {
              return `<div title="${nameValue}">${nameValue}</div>`
          }

      });

      return rows.join('')
  }

  class FeatureCache {

      constructor(chr, tileStart, tileEnd, bpPerPixel, features, roiFeatures, multiresolution) {
          this.chr = chr;
          this.bpStart = tileStart;
          this.bpEnd = tileEnd;
          this.bpPerPixel = bpPerPixel;
          this.features = features;
          this.roiFeatures = roiFeatures;
          this.multiresolution = multiresolution;
      }

      containsRange(chr, start, end, bpPerPixel) {

          // For multi-resolution tracks allow for a 2X change in bpPerPixel
          const r = this.multiresolution ? this.bpPerPixel / bpPerPixel : 1;

          return start >= this.bpStart && end <= this.bpEnd && chr === this.chr && r > 0.5 && r < 2
      }

      overlapsRange(chr, start, end) {
          return this.chr === chr && end >= this.bpStart && start <= this.bpEnd
      }
  }

  /**
   * Decode UCSC "interact" files.  See https://genome.ucsc.edu/goldenpath/help/interact.html
   *
   0  string chrom;        "Chromosome (or contig, scaffold, etc.). For interchromosomal, use 2 records"
   1  uint chromStart;     "Start position of lower region. For interchromosomal, set to chromStart of this region"
   2  uint chromEnd;       "End position of upper region. For interchromosomal, set to chromEnd of this region"
   3  string name;         "Name of item, for display.  Usually 'sourceName/targetName/exp' or empty"
   4  uint score;          "Score (0-1000)"
   5  double value;        "Strength of interaction or other data value. Typically basis for score"
   6  string exp;          "Experiment name (metadata for filtering). Use . if not applicable"
   7  string color;        "Item color.  Specified as r,g,b or hexadecimal #RRGGBB or html color name, as in //www.w3.org/TR/css3-color/#html4. Use 0 and spectrum setting to shade by score"
   8  string sourceChrom;  "Chromosome of source region (directional) or lower region. For non-directional interchromosomal, chrom of this region."
   9  uint sourceStart;    "Start position in chromosome of source/lower/this region"
   10 uint sourceEnd;      "End position in chromosome of source/lower/this region"
   11 string sourceName;   "Identifier of source/lower/this region"
   12 string sourceStrand; "Orientation of source/lower/this region: + or -.  Use . if not applicable"
   13 string targetChrom;  "Chromosome of target region (directional) or upper region. For non-directional interchromosomal, chrom of other region"
   14 uint targetStart;    "Start position in chromosome of target/upper/this region"
   15 uint targetEnd;      "End position in chromosome of target/upper/this region"
   16 string targetName;   "Identifier of target/upper/this region"
   17 string targetStrand; "Orientation of target/upper/this region: + or -.  Use . if not applicable"
   *
   * @param tokens
   * @param ignore
   * @returns {*}
   */
  function decodeInteract(tokens, header) {

      if (tokens.length < 6) {
          return undefined
      }

      var feature = {
          chr: tokens[0],
          start: tokens[1],
          end: tokens[2],

          chr1: tokens[8],
          start1: Number.parseInt(tokens[9]),
          end1: Number.parseInt(tokens[10]),

          chr2: tokens[13],
          start2: Number.parseInt(tokens[14]),
          end2: Number.parseInt(tokens[15]),

          name: tokens[3],
          score: Number(tokens[4]),
          value: Number(tokens[5]),
          color: tokens[7] === '.' ? undefined : tokens[7] === "0" ? "rgb(0,0,0)" : tokens[7],

      };

      return feature
  }

  /**
   * Some interpretations of the sequence ontology needed to assemble GFF transcripts.
   *
   */

  const transcriptTypes = new Set(['transcript', 'primary_transcript', 'processed_transcript', 'mRNA', 'mrna',
      'lnc_RNA', 'miRNA', 'ncRNA', 'rRNA', 'scRNA', 'snRNA', 'snoRNA', 'tRNA']);
  const cdsTypes = new Set(['CDS', 'cds']);
  const codonTypes = new Set(['start_codon', 'stop_codon']);
  const utrTypes = new Set(['5UTR', '3UTR', 'UTR', 'five_prime_UTR', 'three_prime_UTR', "3'-UTR", "5'-UTR"]);
  const exonTypes = new Set(['exon', 'coding-exon']);

  const transcriptPartTypes = new Set();
  for (let cltn of [cdsTypes, codonTypes, utrTypes, exonTypes]) {
      for (let t of cltn) {
          transcriptPartTypes.add(t);
      }
  }

  function isExon(type) {
      return exonTypes.has(type)
  }

  function isIntron(type) {
      return type.includes("intron")
  }

  function isCoding(type) {
      return cdsTypes.has(type) || codonTypes.has(type)
  }

  function isUTR(type) {
      return utrTypes.has(type)
  }

  function isTranscript(type) {
      return transcriptTypes.has(type) || type.endsWith("RNA") || type.endsWith("transcript")
  }

  function isTranscriptPart(type) {
      return transcriptPartTypes.has(type) || type.endsWith("RNA") || isIntron(type)
  }

  const filterPopupProperties = new Set(["id", "parent", "name"]);

  class GFFFeature {

      constructor(properties) {
          Object.assign(this, properties);
      }

      popupData(genomicLocation) {

          const pd = this.geneObject ? this.geneObject.popupData() : [];

          if (this.geneObject) {
              pd.push('<hr/>');
          }

          if (this.name) {
              pd.push({name: 'Name', value: this.name});
          }

          pd.push({name: 'Type', value: this.type});
          pd.push({name: 'Source', value: this.source});
          if (this.score !== undefined) {
              pd.push({name: 'Score', value: this.score});
          }

          if (this.attributeString) {
              const atts = parseAttributeString(this.attributeString, this.delim);
              for (let [key, value] of atts) {
                  if (value !== undefined && value.length > 0 && !filterPopupProperties.has(key.toLowerCase())) {
                      pd.push({name: key + ":", value: value});
                  }
              }
          }
          pd.push({
              name: 'Location',
              value: `${this.chr}:${numberFormatter$1(this.start + 1)}-${numberFormatter$1(this.end)}`
          });
          return pd
      }

      getAttributeValue(attributeName) {
          if (this.hasOwnProperty(attributeName)) {
              return this[attributeName]
          } else {
              // TODO -- fetch from attribute string and cache
              if (!this._attributeCache) {
                  this._attributeCache = new Map();
              }
              if (this._attributeCache.has(attributeName)) {
                  return this._attributeCache.get(attributeName)
              } else {
                  const atts = parseAttributeString(this.attributeString, this.delim);
                  let v;
                  for (let [key, value] of atts) {
                      if (key === attributeName) {
                          v = value;
                          break
                      }
                  }
                  this._attributeCache.set(attributeName, v);
                  return v
              }
          }
      }
  }

  class GFFTranscript extends GFFFeature {

      constructor(feature) {
          super(feature);
          this.exons = [];
          this.parts = [];
      }

      addExon(feature) {

          this.exons.push(feature);

          // Expand feature --  for transcripts not explicitly represented in the file (gtf)
          this.start = Math.min(this.start, feature.start);
          this.end = Math.max(this.end, feature.end);
      }

      addPart(feature) {
          this.parts.push(feature);
      }

      assembleParts() {

          if (this.parts.length === 0) return

          this.parts.sort(function (a, b) {
              return a.start - b.start
          });

          // Create exons, if neccessary
          let lastStart = this.parts[0].start;
          let lastEnd = this.parts[0].end;
          for (let i = 1; i < this.parts.length; i++) {
              const part = this.parts[i];
              if (isIntron(part.type)) {
                  continue
              }
              if (part.start <= lastEnd) {
                  lastEnd = Math.max(lastEnd, part.end);
              } else {
                  let exon = this.findExonContaining({start: lastStart, end: lastEnd});
                  if (!exon) {
                      this.exons.push({start: lastStart, end: lastEnd, psuedo: true});
                  }
                  lastStart = part.start;
                  lastEnd = part.end;
              }
          }
          let exon = this.findExonContaining({start: lastStart, end: lastEnd});
          if (!exon) {
              this.exons.push({start: lastStart, end: lastEnd, psuedo: true});
              this.start = Math.min(this.start, lastStart);
              this.end = Math.max(this.end, lastEnd);
          }


          for (let part of this.parts) {
              const type = part.type;
              if (isCoding(type)) {
                  this.addCDS(part);
              } else if (isUTR(type)) {
                  this.addUTR(part);
              }
          }
      }

      findExonContaining({start, end}) {
          for (let exon of this.exons) {
              if (exon.end >= end && exon.start <= start) {
                  return exon
              }
          }
          return undefined
      }

      addCDS(cds) {

          let exon;
          const exons = this.exons;

          for (let e of exons) {
              if (e.start <= cds.start && e.end >= cds.end) {
                  exon = e;
                  break
              }
          }

          if (exon) {
              exon.cdStart = exon.cdStart ? Math.min(cds.start, exon.cdStart) : cds.start;
              exon.cdEnd = exon.cdEnd ? Math.max(cds.end, exon.cdEnd) : cds.end;
          } else {
              // cds.cdStart = cds.start
              // cds.cdEnd = cds.end
              // exons.push(cds)
              console.error("No exon found spanning " + cds.start + "-" + cds.end);
          }

          // Expand feature --  for transcripts not explicitly represented in the file (gtf files)
          // this.start = Math.min(this.start, cds.start);
          // this.end = Math.max(this.end, cds.end);

          this.cdStart = this.cdStart ? Math.min(cds.start, this.cdStart) : cds.start;
          this.cdEnd = this.cdEnd ? Math.max(cds.end, this.cdEnd) : cds.end;
      }

      addUTR(utr) {

          let exon;
          const exons = this.exons;

          // Find exon containing CDS
          for (let i = 0; i < exons.length; i++) {
              if (exons[i].start <= utr.start && exons[i].end >= utr.end) {
                  exon = exons[i];
                  break
              }
          }

          if (exon) {
              if (utr.start === exon.start && utr.end === exon.end) {
                  exon.utr = true;
              } else {
                  if (utr.end < exon.end) {
                      exon.cdStart = utr.end;
                  }
                  if (utr.start > exon.start) {
                      exon.cdEnd = utr.start;
                  }
              }

          } else {
              // utr.utr = true
              // exons.push(utr)
              console.error("No exon found spanning " + cds.start + "-" + cds.end);
          }

          // Expand feature --  for transcripts not explicitly represented in the file
          // this.start = Math.min(this.start, utr.start);
          // this.end = Math.max(this.end, utr.end);

      }

      finish() {

          this.assembleParts();

          var cdStart = this.cdStart;
          var cdEnd = this.cdEnd;

          this.exons.sort(function (a, b) {
              return a.start - b.start
          });

          // Search for UTR exons that were not explicitly tagged
          if (cdStart) {
              this.exons.forEach(function (exon) {
                  if (exon.end < cdStart || exon.start > cdEnd) exon.utr = true;
              });
          }
      }

      popupData(genomicLocation) {

          const pd = super.popupData(genomicLocation);

          // If clicked over an exon add its attributes
          for (let exon of this.exons) {
              if (exon.pseudo) continue  // An implicit exon
              if (genomicLocation >= exon.start && genomicLocation < exon.end && typeof exon.popupData === 'function') {
                  pd.push('<hr/>');
                  const exonData = exon.popupData(genomicLocation);
                  for (let att of exonData) {
                      pd.push(att);
                  }
              }
          }

          for (let part of this.parts) {
              if (genomicLocation >= part.start && genomicLocation < part.end && typeof part.popupData === 'function') {
                  pd.push('<hr/>');
                  const partData = part.popupData(genomicLocation);
                  for (let att of partData) {
                      pd.push(att);
                  }
              }
          }


          return pd
      }
  }

  function decode(tokens, header) {

      const format = header.format;
      if (tokens.length < 9) {
          return undefined      // Not a valid gff record
      }

      const delim = ('gff3' === format) ? '=' : ' ';
      return new GFFFeature({
          source: decodeGFFAttribute(tokens[1]),
          type: tokens[2],
          chr: tokens[0],
          start: parseInt(tokens[3]) - 1,
          end: parseInt(tokens[4]),
          score: "." === tokens[5] ? undefined : Number(tokens[5]),
          strand: tokens[6],
          phase: "." === tokens[7] ? 0 : parseInt(tokens[7]),
          attributeString: tokens[8],
          delim: delim
      })
  }


  /**
   * Decode a single gff record (1 line in file).  Aggregations such as gene models are constructed at a higher level.
   *      ctg123 . mRNA            1050  9000  .  +  .  ID=mRNA00001;Parent=gene00001
   * @param tokens
   * @param ignore
   * @returns {*}
   */
  function decodeGFF3(tokens, header) {

      const feature = decode(tokens, header);

      if (!feature) {
          return
      }

      const attributes = parseAttributeString(feature.attributeString, feature.delim);

      // Search for color value as case insenstivie key
      for (let [key, value] of attributes) {
          const keyLower = key.toLowerCase();
          if ("color" === keyLower || "colour" === keyLower) {
              feature.color = IGVColor.createColorString(value);
          } else if (key === "ID") {
              feature.id = value;
          } else if (key === "Parent") {
              feature.parent = value;
          }
      }
      return feature
  }

  /**
   * GTF format example:
   NC_000008.11    BestRefSeq    gene    127735434    127742951    .    +    .    gene_id "MYC"; transcript_id ""; db_xref "GeneID:4609"; db_xref "HGNC:HGNC:7553"; db_xref "MIM:190080"; description "MYC proto-oncogene, bHLH transcription factor"; gbkey "Gene"; gene "MYC"; gene_biotype "protein_coding"; gene_synonym "bHLHe39"; gene_synonym "c-Myc"; gene_synonym "MRTL"; gene_synonym "MYCC";
   NC_000008.11    BestRefSeq    transcript    127735434    127742951    .    +    .    gene_id "MYC"; transcript_id "NM_001354870.1"; db_xref "GeneID:4609"; gbkey "mRNA"; gene "MYC"; product "MYC proto-oncogene, bHLH transcription factor, transcript variant 2"; transcript_biotype "mRNA";
   NC_000008.11    BestRefSeq    exon    127735434    127736623    .    +    .    gene_id "MYC"; transcript_id "NM_001354870.1"; db_xref "GeneID:4609"; gene "MYC"; product "MYC proto-oncogene, bHLH transcription factor, transcript variant 2"; transcript_biotype "mRNA"; exon_number "1";
   *
   * @param tokens
   * @param ignore
   * @returns {*}
   */
  function decodeGTF(tokens, header) {

      const feature = decode(tokens, header);

      if (!feature) {
          return
      }

      const attributes = parseAttributeString(feature.attributeString, feature.delim);

      // GTF files specify neither ID nor parent fields, but they can be inferred from common conventions
      let idField;
      let parentField;
      switch (feature.type) {
          case "gene":
              idField = "gene_id";
              break
          case "transcript":
              idField = "transcript_id";
              parentField = "gene_id";
              break
          default:
              parentField = "transcript_id";
      }

      for (let [key, value] of attributes) {
          const keyLower = key.toLowerCase();
          if ("color" === keyLower || "colour" === keyLower) {
              feature.color = IGVColor.createColorString(value);
          } else if (key === idField) {
              feature.id = value;
          } else if (key === parentField) {
              feature.parent = value;
          }
      }
      return feature

  }


  /**
   * Parse the attribute string, returning an array of key-value pairs.  An array is used rather than a map as attribute
   * keys are not required to be unique.
   *
   * @param attributeString
   * @param keyValueDelim
   * @returns {[]}
   */
  function parseAttributeString(attributeString, keyValueDelim, relaxed = false) {
      // parse 'attributes' string (see column 9 docs in https://github.com/The-Sequence-Ontology/Specifications/blob/master/gff3.md)
      var attributes = [];
      for (let kv of attributeString.split(';')) {
          kv = kv.trim();
          const idx = kv.indexOf(keyValueDelim);
          if (idx > 0 && idx < kv.length - 1) {
              const key = stripQuotes(decodeGFFAttribute(kv.substring(0, idx).trim(), relaxed));
              let value = stripQuotes(decodeGFFAttribute(kv.substring(idx + 1).trim(), relaxed));
              attributes.push([key, value]);
          }
      }
      return attributes
  }

  function stripQuotes(value) {
      if (value.startsWith('"') && value.endsWith('"')) {
          value = value.substr(1, value.length - 2);
      }
      return value
  }

  // GFF3 attributes have specific percent encoding rules, the list below are required, all others are forbidden
  /*
  tab (%09)
  newline (%0A)
  carriage return (%0D)
  % percent (%25)
  control characters (%00 through %1F, %7F)
  In addition, the following characters have reserved meanings in column 9 and must be escaped when used in other contexts:
  ; semicolon (%3B)
  = equals (%3D)
  & ampersand (%26)
  , comma (%2C)
   */

  const encodings$2 = new Map([
      ["%09", "\t"],
      ["%0A", "\n"],
      ["%0D", "\r"],
      ["%25", "%"],
      ["%3B", ";"],
      ["%3D", "="],
      ["%26", "&"],
      ["%2C", ","]
  ]);

  function decodeGFFAttribute(str, relaxed = false) {

      if (!str.includes("%")) {
          return str
      }
      if (relaxed) {
          return decodeURIComponent(str);
      }
      let decoded = "";
      for (let i = 0; i < str.length; i++) {

          if (str.charCodeAt(i) === 37 && i < str.length - 2) {
              const key = str.substring(i, i + 3);
              if (encodings$2.has(key)) {
                  decoded += encodings$2.get(key);
              } else {
                  decoded += key;
              }
              i += 2;
          } else {
              decoded += str.charAt(i);
          }
      }
      return decoded

  }

  /**
   * Wrapper class to record a decoding error.
   */

  class DecodeError {
      constructor(message) {
          this.message = message;
      }
  }

  /**
   * Decode the UCSC bed format.  Only the first 3 columns (chr, start, end) are required.   The remaining columns
   * must follow standard bed order, but we will tolerate deviations after column 3.
   *
   * @param tokens
   * @param ignore
   * @returns decoded feature, or null if this is not a valid record
   */
  function decodeBed(tokens, header) {


      if (tokens.length < 3) return undefined

      header && header.gffTags;

      const chr = tokens[0];
      const start = parseInt(tokens[1]);
      const end = tokens.length > 2 ? parseInt(tokens[2]) : start + 1;
      if (isNaN(start) || isNaN(end)) {
          return new DecodeError(`Unparsable bed record.`)
      }
      const feature = new UCSCBedFeature({chr: chr, start: start, end: end, score: 1000});

      try {
          if (tokens.length > 3) {

              // Potentially parse name field as GFF column 9 style streng.
              if (tokens[3].indexOf(';') > 0 && tokens[3].indexOf('=') > 0) {
                  const attributeKVs = parseAttributeString(tokens[3], '=', true);
                  feature.attributes = {};
                  for (let kv of attributeKVs) {
                      feature.attributes[kv[0]] = kv[1];
                      if (header.nameField != undefined && kv[0] === header.nameField) {
                          feature.name = kv[1];
                      }
                  }
              }
              if (!feature.name) {
                  feature.name = tokens[3] === '.' ? '' : tokens[3];
              }
          }

          if (tokens.length > 4) {
              feature.score = tokens[4] === '.' ? 0 : Number(tokens[4]);
              if (isNaN(feature.score)) {
                  return feature
              }
          }

          if (tokens.length > 5) {
              feature.strand = tokens[5];
              if (!(feature.strand === '.' || feature.strand === '+' || feature.strand === '-')) {
                  return feature
              }
          }

          if (tokens.length > 6) {
              feature.cdStart = parseInt(tokens[6]);
              if (isNaN(feature.cdStart)) {
                  return feature
              }
          }

          if (tokens.length > 7) {
              feature.cdEnd = parseInt(tokens[7]);
              if (isNaN(feature.cdEnd)) {
                  return feature
              }
          }

          if (tokens.length > 8) {
              if (tokens[8] !== "." && tokens[8] !== "0")
                  feature.color = IGVColor.createColorString(tokens[8]);
          }

          if (tokens.length > 11) {
              const exonCount = parseInt(tokens[9]);
              // Some basic validation
              if (exonCount > 1000) {
                  // unlikely
                  return feature
              }

              const exonSizes = tokens[10].replace(/,$/, '').split(',');
              const exonStarts = tokens[11].replace(/,$/, '').split(',');
              if (!(exonSizes.length === exonStarts.length && exonCount === exonSizes.length)) {
                  return feature
              }

              const exons = [];
              for (let i = 0; i < exonCount; i++) {
                  const eStart = start + parseInt(exonStarts[i]);
                  const eEnd = eStart + parseInt(exonSizes[i]);
                  exons.push({start: eStart, end: eEnd});
              }
              if (exons.length > 0) {
                  findUTRs$1(exons, feature.cdStart, feature.cdEnd);
                  feature.exons = exons;
              }
          }

          // Optional extra columns
          if (header) {
              let thicknessColumn = header.thicknessColumn;
              let colorColumn = header.colorColumn;
              if (colorColumn && colorColumn < tokens.length) {
                  feature.color = IGVColor.createColorString(tokens[colorColumn]);
              }
              if (thicknessColumn && thicknessColumn < tokens.length) {
                  feature.thickness = tokens[thicknessColumn];
              }
          }
      } catch
          (e) {

      }

      return feature
  }

  /**
   * Decode a UCSC repeat masker record.
   */
  function decodeRepeatMasker(tokens, header) {

      /**
       * Columns, from UCSC documentation
       *
       * 0  bin    585    smallint(5) unsigned    Indexing field to speed chromosome range queries.
       * 1  swScore    1504    int(10) unsigned    Smith Waterman alignment score
       * 2  milliDiv    13    int(10) unsigned    Base mismatches in parts per thousand
       * 3  milliDel    4    int(10) unsigned    Bases deleted in parts per thousand
       * 4  milliIns    13    int(10) unsigned    Bases inserted in parts per thousand
       * 5  genoName    chr1    varchar(255)    Genomic sequence name
       * 6  genoStart    10000    int(10) unsigned    Start in genomic sequence
       * 7  genoEnd    10468    int(10) unsigned    End in genomic sequence
       * 8  genoLeft    -249240153    int(11)    -#bases after match in genomic sequence
       * 9  strand    +    char(1)    Relative orientation + or -
       * 10 repName    (CCCTAA)n    varchar(255)    Name of repeat
       * 11 repClass    Simple_repeat    varchar(255)    Class of repeat
       * 12 repFamily    Simple_repeat    varchar(255)    Family of repeat
       * 13 repStart    1    int(11)    Start (if strand is +) or -#bases after match (if strand is -) in repeat sequence
       * 14 repEnd    463    int(11)    End in repeat sequence
       * 15 repLeft    0    int(11)    -#bases after match (if strand is +) or start (if strand is -) in repeat sequence
       * 16 id    1    char(1)    First digit of id field in RepeatMasker .out file. Best ignored.
       */
      if (tokens.length <= 15) return undefined

      const feature = {
          swScore: Number.parseInt(tokens[1]),
          milliDiv: Number.parseInt(tokens[2]),
          milliDel: Number.parseInt(tokens[3]),
          milliIns: Number.parseInt(tokens[4]),
          chr: tokens[5],
          start: Number.parseInt(tokens[6]),
          end: Number.parseInt(tokens[7]),
          //genoLeft: tokens[8],
          strand: tokens[9],
          repName: tokens[10],
          repClass: tokens[11],
          repFamily: tokens[12],
          repStart: Number.parseInt(tokens[13]),
          repEnd: Number.parseInt(tokens[14]),
          repLeft: Number.parseInt(tokens[15])
      };

      return feature

  }

  /**
   * Decode a UCSC "genePred" record.
   *
   * @param tokens
   * @param ignore
   * @returns {*}
   */
  function decodeGenePred(tokens, header) {

      var shift = header.shift === undefined ? 0 : 1;

      if (tokens.length <= 9 + shift) return undefined

      const cdStart = parseInt(tokens[5 + shift]);
      const cdEnd = parseInt(tokens[6 + shift]);
      var feature = {
          name: tokens[0 + shift],
          chr: tokens[1 + shift],
          strand: tokens[2 + shift],
          start: parseInt(tokens[3 + shift]),
          end: parseInt(tokens[4 + shift]),
          cdStart: cdStart,
          cdEnd: cdEnd,
          id: tokens[0 + shift]
      };
      const exons = decodeExons(parseInt(tokens[7 + shift]), tokens[8 + shift], tokens[9 + shift]);
      findUTRs$1(exons, cdStart, cdEnd);

      feature.exons = exons;

      return feature

  }

  /**
   * Decode a UCSC "genePredExt" record.  refGene files are in this format.
   *
   * @param tokens
   * @param ignore
   * @returns {*}
   */
  function decodeGenePredExt(tokens, header) {

      var shift = header.shift === undefined ? 0 : 1;

      if (tokens.length <= 11 + shift) return undefined

      const cdStart = parseInt(tokens[5 + shift]);
      const cdEnd = parseInt(tokens[6 + shift]);
      const feature = {
          name: tokens[11 + shift],
          chr: tokens[1 + shift],
          strand: tokens[2 + shift],
          start: parseInt(tokens[3 + shift]),
          end: parseInt(tokens[4 + shift]),
          cdStart: cdStart,
          cdEnd: cdEnd,
          id: tokens[0 + shift]
      };

      const exons = decodeExons(parseInt(tokens[7 + shift]), tokens[8 + shift], tokens[9 + shift]);
      findUTRs$1(exons, cdStart, cdEnd);

      feature.exons = exons;

      return feature
  }

  /**
   * Decode a UCSC "refFlat" record
   * @param tokens
   * @param ignore
   * @returns {*}
   */
  function decodeReflat(tokens, header) {

      var shift = header.shift === undefined ? 0 : 1;

      if (tokens.length <= 10 + shift) return undefined

      const cdStart = parseInt(tokens[6 + shift]);
      const cdEnd = parseInt(tokens[7 + shift]);
      var feature = {
          name: tokens[0 + shift],
          id: tokens[1 + shift],
          chr: tokens[2 + shift],
          strand: tokens[3 + shift],
          start: parseInt(tokens[4 + shift]),
          end: parseInt(tokens[5 + shift]),
          cdStart: cdStart,
          cdEnd: cdEnd
      };

      const exons = decodeExons(parseInt(tokens[8 + shift]), tokens[9 + shift], tokens[10 + shift]);
      findUTRs$1(exons, cdStart, cdEnd);
      feature.exons = exons;

      return feature
  }

  /**
   * Decode a UCS PSL record *
   * @param tokens
   * @param header
   * @returns {DecodeError|UCSCBedFeature|undefined}
   */
  function decodePSL(tokens, header) {

      /*
      * 0 matches - Number of bases that match that aren't repeats
      * 1 misMatches - Number of bases that don't match
      * 2 repMatches - Number of bases that match but are part of repeats
      * 3 nCount - Number of "N" bases
      * 4 qNumInsert - Number of inserts in query
      * 5 qBaseInsert - Number of bases inserted in query
      * 6 tNumInsert - Number of inserts in target
      * 7 tBaseInsert - Number of bases inserted in target
      * 8 strand - "+" or "-" for query strand. For translated alignments, second "+"or "-" is for target genomic strand.
      * 9 qName - Query sequence name
      * 10 qSize - Query sequence size.
      * 11 qStart - Alignment start position in query
      * 12 qEnd - Alignment end position in query
      * 13 tName - Target sequence name
      * 14 tSize - Target sequence size
      * 15 tStart - Alignment start position in target
      * 16 tEnd - Alignment end position in target
      * 17 blockCount - Number of blocks in the alignment (a block contains no gaps)
      * 18 blockSizes - Comma-separated list of sizes of each block. If the query is a protein and the target the genome, blockSizes are in amino acids. See below for more information on protein query PSLs.
      * 19 qStarts - Comma-separated list of starting positions of each block in query
      * 20 tStarts - Comma-separated list of starting positions of each block in target
       */


      if (tokens.length < 21) return undefined

      const chr = tokens[13];
      const start = parseInt(tokens[15]);
      const end = parseInt(tokens[16]);
      const strand = tokens[8].charAt(0);
      const exonCount = parseInt(tokens[17]);
      const exons = [];
      const exonStarts = tokens[20].replace(/,$/, '').split(',');
      const exonSizes = tokens[18].replace(/,$/, '').split(',');

      for (let i = 0; i < exonCount; i++) {
          const start = parseInt(exonStarts[i]);
          const end = start + parseInt(exonSizes[i]);
          exons.push({start: start, end: end});
      }

      return new PSLFeature({chr, start, end, strand, exons, tokens})
  }


  function decodeExons(exonCountToken, exonStartsToken, exonEndsToken) {

      const exonCount = parseInt(exonCountToken);
      const exonStarts = exonStartsToken.replace(/,$/, '').split(',');
      const exonEnds = exonEndsToken.replace(/,$/, '').split(',');
      const exons = [];
      for (let i = 0; i < exonCount; i++) {
          const start = parseInt(exonStarts[i]);
          const end = parseInt(exonEnds[i]);
          exons.push({start: start, end: end});
      }
      return exons

  }

  function findUTRs$1(exons, cdStart, cdEnd) {

      for (let exon of exons) {
          const end = exon.end;
          const start = exon.start;
          if (end < cdStart || start > cdEnd) {
              exon.utr = true;
          } else {
              if (cdStart >= start && cdStart <= end) {
                  exon.cdStart = cdStart;
              }
              if (cdEnd >= start && cdEnd <= end) {
                  exon.cdEnd = cdEnd;
              }
          }
      }

  }

  function decodePeak(tokens, header) {

      var tokenCount, chr, start, end, strand, name, score, qValue, signal, pValue;

      tokenCount = tokens.length;
      if (tokenCount < 9) {
          return undefined
      }

      chr = tokens[0];
      start = parseInt(tokens[1]);
      end = parseInt(tokens[2]);
      name = tokens[3];
      score = Number(tokens[4]);
      strand = tokens[5].trim();
      signal = Number(tokens[6]);
      pValue = Number(tokens[7]);
      qValue = Number(tokens[8]);

      if (score === 0) score = signal;

      return {
          chr: chr, start: start, end: end, name: name, score: score, strand: strand, signal: signal,
          pValue: pValue, qValue: qValue
      }
  }

  function decodeBedGraph(tokens, header) {

      var chr, start, end, value;

      if (tokens.length <= 3) return undefined

      chr = tokens[0];
      start = parseInt(tokens[1]);
      end = parseInt(tokens[2]);
      value = Number(tokens[3]);
      const feature = {chr: chr, start: start, end: end, value: value};

      // Optional extra columns
      if (header) {
          let colorColumn = header.colorColumn;
          if (colorColumn && colorColumn < tokens.length) {
              feature.color = IGVColor.createColorString(tokens[colorColumn]);
          }
      }

      return feature
  }

  function decodeWig(tokens, header) {

      const wig = header.wig;

      if (wig && wig.format === "fixedStep") {
          const ss = (wig.index * wig.step) + wig.start;
          const ee = ss + wig.span;
          const value = Number(tokens[0]);
          ++(wig.index);
          return isNaN(value) ? null : {chr: wig.chrom, start: ss, end: ee, value: value}
      } else if (wig && wig.format === "variableStep") {

          if (tokens.length < 2) return null
          const ss = parseInt(tokens[0], 10) - 1;
          const ee = ss + wig.span;
          const value = Number(tokens[1]);
          return isNaN(value) ? null : {chr: wig.chrom, start: ss, end: ee, value: value}

      } else {
          return decodeBedGraph(tokens)
      }
  }

  function decodeSNP(tokens, header) {

      if (tokens.length < 6) return undefined

      const autoSql = [
          'bin',
          'chr',
          'start',
          'end',
          'name',
          'score',
          'strand',
          'refNCBI',
          'refUCSC',
          'observed',
          'molType',
          'class',
          'valid',
          'avHet',
          'avHetSE',
          'func',
          'locType',
          'weight',
          'exceptions',
          'submitterCount',
          'submitters',
          'alleleFreqCount',
          'alleles',
          'alleleNs',
          'alleleFreqs',
          'bitfields'
      ];


      const feature = {
          chr: tokens[1],
          start: Number.parseInt(tokens[2]),
          end: Number.parseInt(tokens[3]),
          name: tokens[4],
          score: Number.parseInt(tokens[5])
      };

      const n = Math.min(tokens.length, autoSql.length);
      for (let i = 6; i < n; i++) {
          feature[autoSql[i]] = tokens[i];
      }
      return feature

  }

  class UCSCBedFeature {

      constructor(properties) {
          Object.assign(this, properties);
      }

      getAttributeValue(attributeName) {
          if (this.hasOwnProperty(attributeName)) {
              return this[attributeName]
          } else if (this.attributes) {
              return this.attributes[attributeName]
          }
      }
  }

  /*
  * 0 matches - Number of bases that match that aren't repeats
  * 1 misMatches - Number of bases that don't match
  * 2 repMatches - Number of bases that match but are part of repeats
  * 3 nCount - Number of "N" bases
  * 4 qNumInsert - Number of inserts in query
  * 5 qBaseInsert - Number of bases inserted in query
  * 6 tNumInsert - Number of inserts in target
  * 7 tBaseInsert - Number of bases inserted in target
  * 8 strand - "+" or "-" for query strand. For translated alignments, second "+"or "-" is for target genomic strand.
  * 9 qName - Query sequence name
  * 10 qSize - Query sequence size.
  * 11 qStart - Alignment start position in query
  * 12 qEnd - Alignment end position in query
  * 13 tName - Target sequence name
  * 14 tSize - Target sequence size
  * 15 tStart - Alignment start position in target
  * 16 tEnd - Alignment end position in target
  * 17 blockCount - Number of blocks in the alignment (a block contains no gaps)
  * 18 blockSizes - Comma-separated list of sizes of each block. If the query is a protein and the target the genome, blockSizes are in amino acids. See below for more information on protein query PSLs.
  * 19 qStarts - Comma-separated list of starting positions of each block in query
  * 20 tStarts - Comma-separated list of starting positions of each block in target
   */

  class PSLFeature {


      constructor(properties) {
          Object.assign(this, properties);
      }

      get score() {
          const tokens = this.tokens;
          const match = parseInt(tokens[0]);
          const repMatch = parseInt(tokens[2]);
          const misMatch = parseInt(tokens[1]);
          const qGapCount = parseInt(tokens[4]);
          const tGapCount = parseInt(tokens[6]);
          const qSize = parseInt(tokens[10]);
          return Math.floor((1000 * (match + repMatch - misMatch - qGapCount - tGapCount)) / qSize)
      }

      get matches() {
          return this.tokens[0]
      }

      get misMatches() {
          return this.tokens[1]
      }

      get repMatches() {
          return this.tokens[2]
      }

      get nCount() {
          return this.tokens[3]
      }

      get qNumInsert() {
          return this.tokens[4]
      }

      get qBaseInsert() {
          return this.tokens[5]
      }

      get tNumInsert() {
          return this.tokens[6]
      }

      get tBaseInsert() {
          return this.tokens[7]

      }

      popupData() {
          return [
              {name: 'chr', value: this.chr},
              {name: 'start', value: this.start + 1},
              {name: 'end', value: this.end},
              {name: 'strand', value: this.strand},
              {name: 'score', value: this.score},
              {name: 'match', value: this.matches},
              {name: "mis-match", value: this.misMatches},
              {name: "rep. match", value: this.repMatches},
              {name: "N's", value: this.nCount},
              {name: 'Q gap count', value: this.qNumInsert},
              {name: 'Q gap bases', value: this.qBaseInsert},
              {name: 'T gap count', value: this.tNumInsert},
              {name: 'T gap bases', value: this.tBaseInsert},
          ]
      }

  }

  function decodeFusionJuncSpan(tokens, header) {

      /*
       Format:

       0       #scaffold
       1       fusion_break_name
       2       break_left
       3       break_right
       4       num_junction_reads
       5       num_spanning_frags
       6       spanning_frag_coords

       0       B3GNT1--NPSR1
       1       B3GNT1--NPSR1|2203-10182
       2       2203
       3       10182
       4       189
       5       1138
       6       1860-13757,1798-13819,1391-18127,1443-17174,...

       */


      if (tokens.length < 7) return undefined

      var chr = tokens[0];
      var fusion_name = tokens[1];
      var junction_left = parseInt(tokens[2]);
      var junction_right = parseInt(tokens[3]);
      var num_junction_reads = parseInt(tokens[4]);
      var num_spanning_frags = parseInt(tokens[5]);

      var spanning_frag_coords_text = tokens[6];

      var feature = {
          chr: chr,
          name: fusion_name,
          junction_left: junction_left,
          junction_right: junction_right,
          num_junction_reads: num_junction_reads,
          num_spanning_frags: num_spanning_frags,
          spanning_frag_coords: [],

          start: -1,
          end: -1
      }; // set start and end later based on min/max of span coords

      var min_coord = junction_left;
      var max_coord = junction_right;

      if (num_spanning_frags > 0) {

          var coord_pairs = spanning_frag_coords_text.split(',');

          for (var i = 0; i < coord_pairs.length; i++) {
              var split_coords = coord_pairs[i].split('-');

              var span_left = split_coords[0];
              var span_right = split_coords[1];

              if (span_left < min_coord) {
                  min_coord = span_left;
              }
              if (span_right > max_coord) {
                  max_coord = span_right;
              }
              feature.spanning_frag_coords.push({left: span_left, right: span_right});

          }
      }

      feature.start = min_coord;
      feature.end = max_coord;


      return feature

  }

  function decodeGtexGWAS(tokens, header) {
      //chrom	chromStart	chromEnd	Strongest SNP-risk allele	Disease/Phenotype	P-value	Odds ratio or beta	PUBMEDID
      //1	1247493	1247494	rs12103-A	Inflammatory bowel disease	8.00E-13	1.1	23128233

      const tokenCount = tokens.length;
      if (tokenCount < 7) {
          return null
      }
      const feature = {
          chr: tokens[0],
          start: parseInt(tokens[1]) - 1,
          end: parseInt(tokens[2]),
          'Strongest SNP-risk allele': tokens[3],
          'Disease/Phenotype': tokens[4],
          'P-value': tokens[5],
          'Odds ratio or beta': tokens[6],
      };
      if (tokens.length > 6) {
          feature['PUBMEDID'] = `<a target = "blank" href = "https://www.ncbi.nlm.nih.gov/pubmed/${tokens[7]}">${tokens[7]}</a>`;
      }
      return feature
  }

  /**
   * Decode a custom columnar format.  Required columns are 'chr' and 'start'
   *
   * @param tokens
   * @param ignore
   * @returns decoded feature, or null if this is not a valid record
   */
  function decodeCustom(tokens, header) {

      const format = header.customFormat;

      if (tokens.length < format.fields.length) return undefined

      const coords = format.coords || 0;

      const chr = tokens[format.chr];
      const start = parseInt(tokens[format.start]) - coords;
      const end = format.end !== undefined ? parseInt(tokens[format.end]) : start + 1;

      const feature = {chr: chr, start: start, end: end};

      if (format.fields) {
          format.fields.forEach(function (field, index) {

              if (index !== format.chr &&
                  index !== format.start &&
                  index !== format.end) {

                  feature[field] = tokens[index];
              }
          });
      }

      return feature

  }

  /**
   * Decode a gcnv record, a bed style format encoding copy number variation
   *
   * @param tokens
   * @param header
   */

  function decodeGcnv(tokens, header) {

      const columnNames = header.columnNames;
      if (!columnNames) {
          throw Error("Sample names are not defined.   Missing column headers?")
      }
      const sampleCount = columnNames.length - 3;

      const chr = tokens[0];
      const start = parseInt(tokens[1]);
      const end = parseInt(tokens[2]);
      const values = tokens.slice(3).map(Number);

      if (values.length == sampleCount) {
          return {
              chr: chr,
              start: start,
              end: end,
              values: values,
          }
      } else {
          // TODO Throw error?
          console.warn(`${chr}:${start}-${end} row contains ${values.length} sample columns instead of the expected ${sampleCount} columns. Skipping...`);
          return undefined
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   *  Parser for column style (tab delimited, etc) text file formats (bed, gff, vcf, etc).
   *
   *
   */


  /**
   * Return a parser for the given file format.
   */
  class FeatureParser {

      constructor(config) {

          this.config = config;
          this.header = {};
          if (config.nameField) {
              this.header.nameField = config.nameField;
          }

          this.skipRows = 0;   // The number of fixed header rows to skip.  Override for specific types as needed

          if (config.decode) {
              this.decode = config.decode;
              this.delimiter = config.delimiter || "\t";
          } else if (config.format) {
              this.header.format = config.format.toLowerCase();
              this.setDecoder(this.header.format);
          }

          if (!this.delimiter) {
              this.delimiter = "\t";
          }
      }

      /**
       * Parse metadata from the file.   A variety of conventions are in use to supply metadata about file contents
       * through header lines (e.g. 'track') and # directives. This method unifies metadata as properties of a
       * 'header' object.
       *
       * @param data
       * @returns {{}}
       */
      async parseHeader(dataWrapper) {

          let header = this.header;
          let columnNames;
          let line;
          while ((line = await dataWrapper.nextLine()) !== undefined) {
              if (line.startsWith("track") || line.startsWith("#track")) {
                  let h = parseTrackLine$1(line);
                  Object.assign(header, h);
              } else if (line.startsWith("browser")) ; else if (line.startsWith("#columns")) {
                  let h = parseColumnsDirective$1(line);
                  Object.assign(header, h);
              } else if (line.startsWith("##gff-version 3")) {
                  header.format = "gff3";
              } else if (line.startsWith("#gffTags")) {
                  header.gffTags = true;
              } else if (line.startsWith("fixedStep") || line.startsWith("variableStep")) {
                  // Wig directives -- we are in the data section
                  break
              } else if (line.startsWith("#")) {
                  const tokens = line.split(this.delimiter || "\t");
                  if (tokens.length > 1) {
                      columnNames = tokens;   // Possible column names
                  }
              } else {
                  // All directives that could change the format, and thus decoder, should have been read by now.
                  this.setDecoder(header.format);

                  // If the line can be parsed as a feature assume we are beyond the header, if any
                  const tokens = line.split(this.delimiter || "\t");
                  try {
                      const tmpHeader = Object.assign({columnNames}, header);
                      if (this.decode(tokens, tmpHeader)) {
                          break
                      } else {
                          if (tokens.length > 1) {
                              columnNames = tokens; // possible column names
                          }
                      }
                  } catch (e) {
                      // Not a feature
                      if (tokens.length > 1) {
                          columnNames = tokens; // possible column names
                      }
                  }
              }
          }

          if (columnNames) {
              header.columnNames = columnNames;
              for (let n = 0; n < columnNames.length; n++) {
                  if (columnNames[n] === "color" || columnNames[n] === "colour") {
                      header.colorColumn = n;
                  } else if (columnNames[n] === "thickness") {
                      header.thicknessColumn = n;
                  }
              }
          }

          this.header = header;    // Directives might be needed for parsing lines
          return header
      }

      async parseFeatures(dataWrapper) {

          const allFeatures = [];
          const decode = this.decode;
          const format = this.header.format;
          const delimiter = this.delimiter || "\t";
          let i = 0;
          let errorCount = 0;
          let line;
          while ((line = await dataWrapper.nextLine()) !== undefined) {
              i++;
              if (i <= this.skipRows) continue

              if (!line || line.startsWith("track") || line.startsWith("#") || line.startsWith("browser")) {
                  continue
              } else if (format === "wig" && line.startsWith("fixedStep")) {
                  this.header.wig = parseFixedStep(line);
                  continue
              } else if (format === "wig" && line.startsWith("variableStep")) {
                  this.header.wig = parseVariableStep(line);
                  continue
              }

              const tokens = line.split(delimiter);
              if (tokens.length < 1) {
                  continue
              }

              const feature = decode(tokens, this.header);

              if (feature instanceof DecodeError) {
                  errorCount++;
                  if (errorCount > 0) {
                      console.error(`Error parsing line '${line}': ${feature.message}`);
                  }
                  continue
              }

              if (feature) {
                  allFeatures.push(feature);
              }
          }

          // Special hack for bedPE
          if (decode === decodeBedpe) {
              fixBedPE(allFeatures);
          }

          return allFeatures

      }

      setDecoder(format) {

          switch (format) {
              case "narrowpeak":
              case "broadpeak":
              case "regionpeak":
              case "peaks":
                  this.decode = decodePeak;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "bedgraph":
                  this.decode = decodeBedGraph;
                  this.delimiter = /\s+/;
                  break
              case "wig":
                  this.decode = decodeWig;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "gff3" :
              case "gff":
                  this.decode = decodeGFF3;
                  this.delimiter = "\t";
                  break
              case "gtf" :
                  this.decode = decodeGTF;
                  this.delimiter = "\t";
                  break
              case "fusionjuncspan":
                  // bhaas, needed for FusionInspector view
                  this.decode = decodeFusionJuncSpan;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "gtexgwas":
                  this.skipRows = 1;
                  this.decode = decodeGtexGWAS;
                  this.delimiter = "\t";
                  break
              case "refflat":
                  this.decode = decodeReflat;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "genepred":
                  this.decode = decodeGenePred;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "genepredext":
                  this.decode = decodeGenePredExt;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "ensgene":
                  this.decode = decodeGenePred;
                  this.header.shift = 1;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "refgene":
                  this.decode = decodeGenePredExt;
                  this.delimiter = this.config.delimiter || /\s+/;
                  this.header.shift = 1;
                  break
              case "bed":
                  this.decode = decodeBed;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "bedpe":
              case "hiccups":
                  this.decode = decodeBedpe;
                  this.delimiter = this.config.delimiter || "\t";
                  break
              case "bedpe-domain":
                  this.decode = decodeBedpeDomain;
                  this.headerLine = true;
                  this.delimiter = this.config.delimiter || "\t";
                  break
              case "bedpe-loop":
                  this.decode = decodeBedpe;
                  this.delimiter = this.config.delimiter || "\t";
                  this.header = {colorColumn: 7};
                  break
              case "interact":
                  this.decode = decodeInteract;
                  this.delimiter = this.config.delimiter || /\s+/;
                  break
              case "snp":
                  this.decode = decodeSNP;
                  this.delimiter = "\t";
                  break
              case "rmsk":
                  this.decode = decodeRepeatMasker;
                  this.delimiter = "\t";
                  break
              case "gcnv":
                  this.decode = decodeGcnv;
                  this.delimiter = "\t";
                  break
              default:
                  const customFormat = getFormat(format);
                  if (customFormat !== undefined) {
                      this.decode = decodeCustom;
                      this.header.customFormat = customFormat;
                      this.delimiter = customFormat.delimiter || "\t";
                  } else {
                      this.decode = decodeBed;
                      this.delimiter = this.config.delimiter || /\s+/;
                  }
          }

      }
  }

  function parseTrackLine$1(line) {

      const properties = {};
      const tokens = line.split(/(?:")([^"]+)(?:")|([^\s"]+)(?=\s+|$)/g);

      // Clean up tokens array
      let curr;
      const tmp = [];
      for (let tk of tokens) {
          if (!tk || tk.trim().length === 0) continue
          if (tk.endsWith("=")) {
              curr = tk;
          } else if (curr) {
              tmp.push(curr + tk);
              curr = undefined;
          } else {
              tmp.push(tk);
          }
      }

      for (let str of tmp) {
          if (!str) return
          var kv = str.split('=', 2);
          if (kv.length === 2) {
              const key = kv[0].trim();
              const value = kv[1].trim();
              if (properties.hasOwnProperty(key)) {
                  let currentValue = properties[key];
                  if (Array.isArray(currentValue)) {
                      currentValue.push(value);
                  } else {
                      properties[key] = [currentValue, value];
                  }
              } else {
                  properties[key] = value;
              }
          }
      }
      if ("interact" == properties["type"]) {
          properties["format"] = "interact";
      } else if ("gcnv" === properties["type"]) {
          properties["format"] = "gcnv";
      }
      return properties
  }

  function parseColumnsDirective$1(line) {

      let properties = {};
      let t1 = line.split(/\s+/);

      if (t1.length === 2) {
          let t2 = t1[1].split(";");
          t2.forEach(function (keyValue) {
              let t = keyValue.split("=");
              if (t[0] === "color") {
                  properties.colorColumn = Number.parseInt(t[1]) - 1;
              } else if (t[0] === "thickness") {
                  properties.thicknessColumn = Number.parseInt(t[1]) - 1;
              }
          });
      }

      return properties
  }

  function parseFixedStep(line) {
      const tokens = line.split(/\s+/);
      const chrom = tokens[1].split("=")[1];
      const start = parseInt(tokens[2].split("=")[1], 10) - 1;
      const step = parseInt(tokens[3].split("=")[1], 10);
      const span = (tokens.length > 4) ? parseInt(tokens[4].split("=")[1], 10) : 1;
      return {format: "fixedStep", chrom, start, step, span, index: 0}
  }

  function parseVariableStep(line) {
      const tokens = line.split(/\s+/);
      const chrom = tokens[1].split("=")[1];
      const span = tokens.length > 2 ? parseInt(tokens[2].split("=")[1], 10) : 1;
      return {format: "variableStep", chrom, span}
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2018 Regents of the University of California
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const DEFAULT_COLOR$1 = 'rgb(150,150,150)';

  const fixColor = (colorString) => {
      if (isString$2(colorString)) {
          return (colorString.indexOf(",") > 0 && !(colorString.startsWith("rgb(") || colorString.startsWith("rgba("))) ?
              `rgb(${colorString})` : colorString
      } else {
          return colorString
      }
  };

  /**
   * A collection of properties and methods shared by all (or most) track types.
   *
   * @param config
   * @param browser
   * @constructor
   */
  class TrackBase {

      constructor(config, browser) {
          this.browser = browser;
          this.init(config);
      }

      /**
       * Initialize track properties from the config object.  This method is typically overriden in subclasses, which
       * will call this implementation as super.init(config).
       *
       * @param config
       */
      init(config) {

          if (config.displayMode) {
              config.displayMode = config.displayMode.toUpperCase();
          }

          this.config = config;
          this.url = config.url;
          this.type = config.type;

          this.supportHiDPI = config.supportHiDPI === undefined ? true : config.supportHiDPI;

          if (config.name || config.label) {
              this.name = config.name || config.label;
          } else if (isFile$2(config.url)) {
              this.name = config.url.name;
          } else if (isString$2(config.url) && !config.url.startsWith("data:")) {
              this.name = getFilename$2(config.url);
          }

          this.id = this.config.id === undefined ? this.name : this.config.id;

          this.order = config.order;

          if (config.color) this.color = fixColor(config.color);
          if (config.altColor) this.altColor = fixColor(config.altColor);
          if ("civic-ws" === config.sourceType) {    // Ugly proxy for specialized track type
              this.defaultColor = "rgb(155,20,20)";
          } else {
              this.defaultColor = "rgb(0,0,150)";
          }

          this.autoscaleGroup = config.autoscaleGroup;

          this.removable = config.removable === undefined ? true : config.removable;      // Defaults to true

          this.height = config.height || 100;
          this.autoHeight = config.autoHeight;
          this.minHeight = config.minHeight || Math.min(25, this.height);
          this.maxHeight = config.maxHeight || Math.max(1000, this.height);

          this.visibilityWindow = config.visibilityWindow;

          if (config.onclick) {
              this.onclick = config.onclick;
              config.onclick = undefined;   // functions cannot be saved in sessions, clear it here.
          }

          if (config.description) {
              // Override description -- displayed when clicking on track label.  Convert to function if neccessary
              if (typeof config.description === 'function') {
                  this.description = config.description;
              } else {
                  this.description = () => config.description;
              }
          }

          // Support for mouse hover text.  This can be expensive, off by default.
          // this.hoverText = function(clickState) => return tool tip text
          if (config.hoverTextFields) {
              this.hoverText = hoverText.bind(this);
          } else if (typeof this.config.hoverText === 'function') {
              this.hoverText = this.config.hoverText;
          }
      }

      get name() {
          return this._name
      }

      set name(name) {
          this._name = name;
          if (this.trackView) {
              this.trackView.setTrackLabelName(name);
          }
      }

      /**
       * Update track properties from the config object.
       *
       * @param config
       */
      updateConfig(config) {
          this.init(config);
      }

      clearCachedFeatures() {
          if (this.trackView) {
              this.trackView.clearCachedFeatures();
          }
      }

      updateViews() {
          if (this.trackView) {
              this.trackView.updateViews();
          }
      }

      /**
       * Default implementation -- update config with current values.
       * to create session object for bookmarking, sharing.  Updates the track "config" object to reflect the
       * current state.  Only simple properties (string, number, boolean) are updated.
       */
      getState() {

          // Create copy of config, minus transient properties (convention is name starts with '_').  Also, all
          // function properties are transient as they cannot be saved in json
          const state = {};
          for (let key of Object.keys(this.config)) {
              if (!key.startsWith("_") && typeof this.config[key] !== "function" && this.config[key] !== undefined) {
                  state[key] = this.config[key];
              }
          }

          // Update original config values with any changes
          for (let key of Object.keys(state)) {
              if (key.startsWith("_")) continue   // transient property
              const value = this[key];
              if (value && (isSimpleType(value) || typeof value === "boolean" || key === "metadata")) {
                  state[key] = value;
              }
          }

          if (this.color) state.color = this.color;
          if (this.altColor) state.altColor = this.altColor;

          // Flatten dataRange if present
          if (!this.autoscale && this.dataRange) {
              state.min = this.dataRange.min;
              state.max = this.dataRange.max;
          }


          // Check for non-json-if-yable properties.  Perhaps we should test what can be saved.
          for (let key of Object.keys(state)) {
              const value = state[key];
              if (typeof value === 'function') {
                  throw Error(`Property '${key}' of track '${this.name} is a function. Functions cannot be saved in sessions.`)
              }
              if (value instanceof File) {   // Test specifically for File.  Other types of File-like objects might be savable
                  const str = `Track ${this.name} is a local file. Sessions cannot be saved with local file references.`;
                  throw Error(str)
              }
              if (value instanceof Promise) {
                  throw Error(`Property '${key}' of track '${this.name} is a Promise. Promises cannot be saved in sessions.`)
              }
          }

          return state
      }

      get supportsWholeGenome() {
          return this.config.supportsWholeGenome === true
      }

      /**
       * Does the track support sample names.  Current sample aware tracks include VCF (with genotypes), MUT, MAF, and SEG
       * @returns {boolean}
       */
      hasSamples() {
          return false
      }

      getGenomeId() {
          return this.browser.genome ? this.browser.genome.id : undefined
      }

      /**
       * Set certain track properties, usually from a "track" line.  Not all UCSC properties are supported.
       *
       * Track configuration settings have precendence over track line properties, so if both are present ignore the
       * track line.
       *
       * @param properties
       */
      setTrackProperties(properties) {

          if (this.disposed) return   // This track was removed during async load

          const tracklineConfg = {};
          let tokens;
          for (let key of Object.keys(properties)) {
              switch (key.toLowerCase()) {
                  case "usescore":
                      tracklineConfg.useScore = (
                          properties[key] === 1 || properties[key] === "1" || properties[key] === "on" || properties[key] === true);
                      break
                  case "visibility":
                      //0 - hide, 1 - dense, 2 - full, 3 - pack, and 4 - squish
                      switch (properties[key]) {
                          case "2":
                          case "3":
                          case "pack":
                          case "full":
                              tracklineConfg.displayMode = "EXPANDED";
                              break
                          case "4":
                          case "squish":
                              tracklineConfg.displayMode = "SQUISHED";
                              break
                          case "1":
                          case "dense":
                              tracklineConfg.displayMode = "COLLAPSED";
                      }
                      break
                  case "color":
                  case "altcolor":
                      tracklineConfg[key] = properties[key].startsWith("rgb(") ? properties[key] : "rgb(" + properties[key] + ")";
                      break
                  case "featurevisiblitywindow":
                  case "visibilitywindow":
                      tracklineConfg.visibilityWindow = Number.parseInt(properties[key]);
                      break
                  case "maxheightpixels":
                      tokens = properties[key].split(":");
                      if (tokens.length === 3) {
                          tracklineConfg.minHeight = Number.parseInt(tokens[2]);
                          tracklineConfg.height = Number.parseInt(tokens[1]);
                          tracklineConfg.maxHeight = Number.parseInt(tokens[0]);
                      }
                      break
                  case "viewlimits":
                      if (!this.config.autoscale) {   // autoscale in the config has precedence
                          tokens = properties[key].split(":");
                          let min = 0;
                          let max;
                          if (tokens.length == 1) {
                              max = Number(tokens[0]);
                          } else if (tokens.length == 2) {
                              min = Number(tokens[0]);
                              max = Number(tokens[1]);
                          }
                          tracklineConfg.autoscale = false;
                          tracklineConfg.dataRange = {min, max};
                          this.viewLimitMin = min;
                          this.viewLimitMax = max;
                      }
                  case "name":
                      tracklineConfg[key] = properties[key];
                      break
                  case "url":
                      tracklineConfg["infoURL"] = properties[key];
                      break
                  case "type":
                      const v = properties[key];
                      if (UCSCTypeMappings.has(v)) {
                          tracklineConfg[key] = UCSCTypeMappings.get(v);
                      } else {
                          tracklineConfg[key] = v;
                      }
                      break
                  case "graphtype":
                      tracklineConfg["graphType"] = properties[key];
                      break
                  default:
                      tracklineConfg[key] = properties[key];
              }
          }

          // Track configuration objects have precedence over track line properties in general.  The "name" property
          // is an exception if it was derived and not explicitly entered (that is derived from the web app from filename).
          for (let key of Object.keys(tracklineConfg)) {

              if (!this.config.hasOwnProperty(key) || (key === "name" && this.config._derivedName)) {
                  let value = tracklineConfg[key];
                  if ("true" === value) value = true;
                  if ("false" === value) value = false;

                  this[key] = value;
                  if (key === "height" && this.trackView) {
                      try {
                          const h = Number.parseInt(value);
                          this.trackView.setTrackHeight(h);
                      } catch (e) {
                          console.error(e);
                      }
                  }
              }
          }
      }

      /**
       * Return the features clicked over.  Default implementation assumes an array of features and only considers
       * the genomic location.   Overriden by most subclasses.
       *
       * @param clickState
       * @param features
       * @returns {[]|*[]}
       */
      clickedFeatures(clickState) {

          // We use the cached features rather than method to avoid async load.  If the
          // feature is not already loaded this won't work,  but the user wouldn't be mousing over it either.
          const features = clickState.viewport.cachedFeatures;

          if (!features || !Array.isArray(features) || features.length === 0) {
              return []
          }

          const genomicLocation = clickState.genomicLocation;

          // When zoomed out we need some tolerance around genomicLocation
          const tolerance = (clickState.referenceFrame.bpPerPixel > 0.2) ? 3 * clickState.referenceFrame.bpPerPixel : 0.2;
          const ss = genomicLocation - tolerance;
          const ee = genomicLocation + tolerance;
          return (FeatureUtils.findOverlapping(features, ss, ee))
      }

      /**
       * Default popup text function -- just extracts string and number properties in random order.
       * @param feature
       * @returns {Array}
       */
      extractPopupData(feature, genomeId) {

          const filteredProperties = new Set(['row', 'color', 'chr', 'start', 'end', 'cdStart', 'cdEnd', 'strand', 'alpha']);
          const data = [];

          let alleles, alleleFreqs;
          for (let property in feature) {

              if (feature.hasOwnProperty(property) &&
                  !filteredProperties.has(property) &&
                  isSimpleType(feature[property])) {

                  let value = feature[property];
                  data.push({name: capitalize(property), value: value});

                  if (property === "alleles") {
                      alleles = feature[property];
                  } else if (property === "alleleFreqs") {
                      alleleFreqs = feature[property];
                  }
              }
          }

          if (alleles && alleleFreqs) {

              if (alleles.endsWith(",")) {
                  alleles = alleles.substr(0, alleles.length - 1);
              }
              if (alleleFreqs.endsWith(",")) {
                  alleleFreqs = alleleFreqs.substr(0, alleleFreqs.length - 1);
              }

              let a = alleles.split(",");
              let af = alleleFreqs.split(",");
              if (af.length > 1) {
                  let b = [];
                  for (let i = 0; i < af.length; i++) {
                      b.push({a: a[i], af: Number(af[i])});
                  }
                  b.sort(function (x, y) {
                      return x.af - y.af
                  });

                  let ref = b[b.length - 1].a;
                  if (ref.length === 1) {
                      for (let i = b.length - 2; i >= 0; i--) {
                          let alt = b[i].a;
                          if (alt.length === 1) {
                              if (!genomeId) genomeId = this.getGenomeId();
                              const cravatLink = TrackBase.getCravatLink(feature.chr, feature.start + 1, ref, alt, genomeId);
                              if (cravatLink) {
                                  data.push('<hr/>');
                                  data.push({html: cravatLink});
                                  data.push('<hr/>');
                              }
                          }
                      }
                  }
              }
          }

          if (feature.attributes) {
              for (let key of Object.keys(feature.attributes)) {
                  data.push({name: key, value: feature.attributes[key]});
              }
          }

          // final chr position
          let posString = `${feature.chr}:${numberFormatter$1(feature.start + 1)}-${numberFormatter$1(feature.end)}`;
          if (feature.strand) {
              posString += ` (${feature.strand})`;
          }

          data.push({name: 'Location', value: posString});

          return data

      }


      /**
       * Default track description -- displayed on click of track label.  This can be overriden in the track
       * configuration, or in subclasses.
       */
      description() {

          const wrapKeyValue = (k, v) => `<div class="igv-track-label-popup-shim"><b>${k}: </b>${v}</div>`;

          let str = '<div class="igv-track-label-popup">';
          if (this.url) {
              if (isFile$2(this.url)) {
                  str += wrapKeyValue('Filename', this.url.name);
              } else {
                  str += wrapKeyValue('URL', this.url);
              }
          } else {
              str = this.name;
          }
          if (this.config) {
              if (this.config.metadata) {
                  for (let key of Object.keys(this.config.metadata)) {
                      const value = this.config.metadata[key];
                      str += wrapKeyValue(key, value);
                  }
              }

              // Add any config properties that are capitalized
              for (let key of Object.keys(this.config)) {
                  if (key.startsWith("_")) continue   // transient property
                  let first = key.substr(0, 1);
                  if (first !== first.toLowerCase()) {
                      const value = this.config[key];
                      if (value && isSimpleType(value)) {
                          str += wrapKeyValue(key, value);
                      }
                  }
              }

          }
          str += '</div>';
          return str
      }

      /**
       * Return color for a specific feature of this track.  This default implementation is overriden by subclasses*
       * @param f
       * @returns {*|string|string}
       */
      getColorForFeature(f) {
         return (typeof this.color === "function") ? this.color(feature) : this.color || DEFAULT_COLOR$1
      }

      /**
       * Track has been permanently removed.  Release resources and other cleanup
       */
      dispose() {

          this.disposed = true;

          // This should not be neccessary, but in case there is some unknown reference holding onto this track object,
          // for example in client code, release any resources here.
          for (let key of Object.keys(this)) {
              this[key] = undefined;
          }
      }

      static getCravatLink(chr, position, ref, alt, genomeID) {

          if ("hg38" === genomeID || "GRCh38" === genomeID) {

              const cravatChr = chr.startsWith("chr") ? chr : "chr" + chr;
              return `<a target="_blank" href="https://run.opencravat.org/result/nocache/variant.html` +
                  `?chrom=${cravatChr}&pos=${position}&ref_base=${ref}&alt_base=${alt}"><b>Cravat ${ref}->${alt}</b></a>`

          } else {
              return undefined
          }
      }
  }

  function hoverText(clickState) {

      if (!this.hoverTextFields) return

      const features = this.clickedFeatures(clickState);

      if (features && features.length > 0) {
          let str = "";
          for (let i = 0; i < features.length; i++) {
              if (i === 10) {
                  str += "; ...";
                  break
              }
              if (!features[i]) continue

              const f = features[i]._f || features[i];
              if (str.length > 0) str += "\n";

              str = "";
              for (let field of this.hoverTextFields) {
                  if (str.length > 0) str += "\n";
                  if (f.hasOwnProperty(field)) {
                      str += f[field];
                  } else if (typeof f.getAttribute === "function") {
                      str += f.getAttribute(field);
                  }
              }

          }
          return str
      }
  }

  /**
   * Map UCSC track line "type" setting to file format.  In igv.js "type" refers to the track type, not the input file format
   * @type {Map<string, string>}
   */
  const UCSCTypeMappings = new Map([
      ["wiggle_0", "wig"],
      ["bed", "bed"],
      ["bigBed", "bigBed"],
      ["bigWig", "bigWig"]
  ]);

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  /**
   *  Define parser for seg files  (.bed, .gff, .vcf, etc).  A parser should implement 2 methods
   *
   *     parseHeader(data) - return an object representing a header.  Details are format specific
   *
   *     parseFeatures(data) - return a list of features
   *
   */


  class SegParser {

      constructor(type) {
          this.type = type || 'seg';   // One of seg, mut, or maf

          switch (this.type) {
              case 'mut':
                  this.sampleColumn = 3;
                  this.chrColumn = 0;
                  this.startColumn = 1;
                  this.endColumn = 2;
                  this.dataColumn = 4;
                  break
              case 'maf':
                  this.sampleColumn = 15;
                  this.chrColumn = 4;
                  this.startColumn = 5;
                  this.endColumn = 6;
                  this.dataColumn = 8;
                  break
              default:
                  this.sampleColumn = 0;
                  this.chrColumn = 1;
                  this.startColumn = 2;
                  this.endColumn = 3;
              // Data column determined after reading header
          }
      }

      async parseHeader(dataWrapper) {
          let line;
          while ((line = await dataWrapper.nextLine()) !== undefined) {
              if (line.startsWith("#")) ; else {
                  const tokens = line.split("\t");
                  this.header = {headings: tokens};
                  break
              }
          }
          return this.header
      }

      async parseFeatures(dataWrapper) {

          const allFeatures = [];
          let extraHeaders;
          if (!this.header) {
              this.header = await this.parseHeader(dataWrapper);  // This will only work for non-indexed files
          }
          if ('seg' === this.type) {
              this.dataColumn = this.header.headings.length - 1;
          }
          if (this.header.headings.length > 5) {
              extraHeaders = this.extractExtraColumns(this.header.headings);
          }
          const valueColumnName = this.header.headings[this.dataColumn];

          let line;
          while ((line = await dataWrapper.nextLine()) !== undefined) {
              const tokens = line.split("\t");
              const value = ('seg' === this.type) ? Number(tokens[this.dataColumn]) : tokens[this.dataColumn];
              if (tokens.length > this.dataColumn) {
                  const feature = new SegFeature({
                      sample: tokens[this.sampleColumn],
                      chr: tokens[this.chrColumn],
                      start: parseInt(tokens[this.startColumn]) - 1,
                      end: parseInt(tokens[this.endColumn]),
                      value,
                      valueColumnName
                  });
                  if (extraHeaders) {
                      const extraValues = this.extractExtraColumns(tokens);
                      feature.setAttributes({names: extraHeaders, values: extraValues});
                  }
                  allFeatures.push(feature);
              }
          }
          return allFeatures
      }

      extractExtraColumns(tokens) {
          const extras = [];
          for (let i = 0; i < tokens.length; i++) {
              if (i !== this.chrColumn && i !== this.startColumn && i !== this.endColumn && i !== this.sampleColumn) {
                  extras.push(tokens[i]);
              }
          }
          return extras
      }

  }

  class SegFeature {

      constructor({sample, chr, start, end, value, valueColumnName}) {
          this.sample = sample;
          this.chr = chr;
          this.start = start;
          this.end = end;
          this.value = value;
          this.valueColumnName = valueColumnName;
      }

      setAttributes({names, values}) {
          this.attributeNames = names;
          this.attributeValues = values;
      }

      getAttribute(name) {
          if (this.attributeNames) {
              const idx = this.attributeNames.indexOf(name);
              if (idx >= 0) {
                  return this.attributeValues[idx]
              }
          }
          return undefined
      }


      popupData(type, genomeID) {
          const filteredProperties = new Set(['chr', 'start', 'end', 'sample', 'value', 'row', 'color', 'sampleKey',
              'uniqueSampleKey', 'sampleId', 'chromosome', 'uniquePatientKey']);
          const locationString = (this.chr + ":" +
              numberFormatter$1(this.start + 1) + "-" +
              numberFormatter$1(this.end));
          const pd = [
              {name: "Sample", value: this.sample},
              {name: "Location", value: locationString},
              {name: this.valueColumnName ? capitalize(this.valueColumnName) : "Value", value: this.value}
          ];

          // TODO -- the Cravat stuff should probably be in the track (SegTrack)
          if ("mut" === type && "hg38" === genomeID) {
              const l = this.extractCravatLink(genomeID);
              if (l) {
                  pd.push('<hr/>');
                  pd.push({html: l});
                  pd.push('<hr/>');
              }
          }

          if (this.attributeNames && this.attributeNames.length > 0) {
              for (let i = 0; i < this.attributeNames.length; i++) {
                  if (!filteredProperties.has(this.attributeNames[i]) & this.valueColumnName !== this.attributeNames[i]) {
                      pd.push({name: capitalize(this.attributeNames[i]), value: this.attributeValues[i]});
                  }
              }
          }
          return pd
      }

      extractCravatLink(genomeId) {

          let ref, alt;
          if (this.attributeNames && this.attributeNames.length > 0) {
              for (let i = 0; i < this.attributeNames.length; i++) {
                  if (!ref && "Reference_Allele" === this.attributeNames[i]) {
                      ref = this.attributeValues[i];
                  }
                  if (!alt && this.attributeNames[i].startsWith("Tumor_Seq_Allele") && this.attributeValues[i] !== ref) {
                      alt = this.attributeValues[i];
                  }
                  if (ref && alt) {
                      return TrackBase.getCravatLink(this.chr, this.start + 1, ref, alt, genomeId)
                  }
              }
          }

      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Create a variant from an array of tokens representing a line in a "VCF" file
   * @param tokens
   */
  function createVCFVariant(tokens) {
      const variant = new Variant();
      variant.chr = tokens[0]; // TODO -- use genome aliases
      variant.pos = parseInt(tokens[1]);
      variant.names = tokens[2];    // id in VCF
      variant.referenceBases = tokens[3];
      variant.alternateBases = tokens[4];
      variant.quality = tokens[5];
      variant.filter = tokens[6];
      variant.info = {};
      const infoStr = tokens[7];
      if (infoStr) {
          for (let elem of infoStr.split(';')) {
              var element = elem.split('=');
              variant.info[element[0]] = element[1];
          }
      }
      variant.init();
      return variant
  }


  /**
   * @deprecated - the GA4GH API has been deprecated.  This code no longer maintained.
   * @param json
   * @returns {Variant}
   */
  function createGAVariant(json) {

      var variant = new Variant();

      variant.chr = json.referenceName;
      variant.start = parseInt(json.start);  // Might get overriden below
      variant.end = parseInt(json.end);      // Might get overriden below
      variant.pos = variant.start + 1;       // GA4GH is 0 based.
      variant.names = arrayToString(json.names, "; ");
      variant.referenceBases = json.referenceBases;
      variant.alternateBases = arrayToString(json.alternateBases);
      variant.quality = json.quality;
      variant.filter = arrayToString(json.filter);


      // Flatten GA4GH attributes array
      variant.info = {};
      if (json.info) {
          Object.keys(json.info).forEach(function (key) {
              var value,
                  valueArray = json.info[key];

              if (Array.isArray(valueArray)) {
                  value = valueArray.join(",");
              } else {
                  value = valueArray;
              }
              variant.info[key] = value;
          });
      }


      // Need to build a hash of calls for fast lookup
      // Note from the GA4GH spec on call ID:
      //
      // The ID of the call set this variant call belongs to. If this field is not present,
      // the ordering of the call sets from a SearchCallSetsRequest over this GAVariantSet
      // is guaranteed to match the ordering of the calls on this GAVariant.
      // The number of results will also be the same.
      variant.calls = {};
      var id;
      if (json.calls) {
          json.calls.forEach(function (call) {
              id = call.callSetId;
              variant.calls[id] = call;

          });
      }

      init(variant);

      return variant

  }


  class Variant {

      init() {

          const ref = this.referenceBases;
          const altBases = this.alternateBases;

          if (this.info) {
              if (this.info["VT"]) {
                  this.type = this.info["VT"];
              } else if (this.info["SVTYPE"]) {
                  this.type = "SV";
              } else if (this.info["PERIOD"]) {
                  this.type = "STR";
              }
          }
          if (this.type === undefined) {
              this.type = determineType(ref, altBases);
          }
          if (this.type === "NONVARIANT") {
              this.heterozygosity = 0;
          }

          // Determine start/end coordinates -- these are the coordinates representing the actual variant,
          // not the leading or trailing reference
          if (this.info["END"]) {
              this.start = this.pos - 1;
              if (this.info["CHR2"] && this.info["CHR2"] !== this.chr) {
                  this.end = this.start + 1;
              } else {
                  this.end = Number.parseInt(this.info["END"]);
              }
          } else {
              if (this.type === "NONVARIANT") {
                  this.start = this.pos - 1;      // convert to 0-based coordinate convention
                  this.end = this.start + ref.length;
              } else {

                  const altTokens = altBases.split(",").filter(token => token.length > 0);
                  this.alleles = [];
                  this.start = undefined;
                  this.end = undefined;

                  for (let alt of altTokens) {

                      this.alleles.push(alt);

                      // We don't yet handle  SV and other special alt representations
                      if ("SV" !== this.type && isKnownAlt(alt)) {

                          let altLength = alt.length;
                          let lengthOnRef = ref.length;
                          const lmin = Math.min(altLength, lengthOnRef);

                          // Trim off matching bases.  Try first match, then right -> left,  then any remaining left -> right
                          let s = 0;

                          while (s < lmin && (ref.charCodeAt(s) === alt.charCodeAt(s))) {
                              s++;
                              altLength--;
                              lengthOnRef--;
                          }

                          // right -> left from end
                          while (altLength > 0 && lengthOnRef > 0) {
                              const altIdx = s + altLength - 1;
                              const refIdx = s + lengthOnRef - 1;
                              if (alt.charCodeAt(altIdx) === ref.charCodeAt(refIdx)) {
                                  altLength--;
                                  lengthOnRef--;
                              } else {
                                  break
                              }
                          }

                          // if any remaining, left -> right
                          while (altLength > 0 && lengthOnRef > 0) {
                              const altIdx = s;
                              const refIdx = s;
                              if (alt.charCodeAt(altIdx) === ref.charCodeAt(refIdx)) {
                                  s++;
                                  altLength--;
                                  lengthOnRef--;
                              } else {
                                  break
                              }
                          }

                          const alleleStart = this.pos + s - 1;      // -1 for zero based coordinates
                          const alleleEnd = alleleStart + lengthOnRef;
                          this.start = this.start === undefined ? alleleStart : Math.min(this.start, alleleStart);
                          this.end = this.end === undefined ? alleleEnd : Math.max(this.end, alleleEnd);
                      }
                  }

                  // Default to single base representation @ position for variant types not otherwise handled
                  if (this.start === undefined) {
                      this.start = this.pos - 1;
                      this.end = this.pos;
                  }
              }
          }
      }

      popupData(genomicLocation, genomeId) {

          const posString = `${numberFormatter$1(this.pos)}`;
          const locString = this.start === this.end ?
              `${numberFormatter$1(this.start)} | ${numberFormatter$1(this.start + 1)}` :
              `${numberFormatter$1(this.start + 1)}-${numberFormatter$1(this.end)}`;
          const fields = [
              {name: "Chr", value: this.chr},
              {name: "Pos", value: posString},
              {name: "Loc", value: locString},
              {name: "ID", value: this.names ? this.names : ""},
              {name: "Ref", value: this.referenceBases},
              {name: "Alt", value: this.alternateBases.replace("<", "&lt;")},
              {name: "Qual", value: this.quality},
              {name: "Filter", value: this.filter}
          ];

          if ("SNP" === this.type) {
              let ref = this.referenceBases;
              if (ref.length === 1) {
                  let altArray = this.alternateBases.split(",");
                  for (let alt of altArray) {
                      if (alt.length === 1) {
                          let l = TrackBase.getCravatLink(this.chr, this.pos, ref, alt, genomeId);
                          if (l) {
                              fields.push('<hr/>');
                              fields.push({html: l});
                          }
                      }
                  }
              }
          }

          if (this.hasOwnProperty("heterozygosity")) {
              fields.push({name: "Heterozygosity", value: this.heterozygosity});
          }

          if (this.info) {
              fields.push({html: '<hr style="border-top: dotted 1px;border-color: #c9c3ba" />'});
              for (let key of Object.keys(this.info)) {
                  fields.push({name: key, value: arrayToString(decodeURIComponent(this.info[key]))});
              }
          }

          return fields
      }

      getInfo(tag) {
          return this.info ? this.info[tag] : undefined;
      }

      isRefBlock() {
          return "NONVARIANT" === this.type
      }

  }

  const knownAltBases = new Set(["A", "C", "T", "G"].map(c => c.charCodeAt(0)));

  function isKnownAlt(alt) {
      for (let i = 0; i < alt.length; i++) {
          if (!knownAltBases.has(alt.charCodeAt(i))) {
              return false
          }
      }
      return true
  }


  function determineType(ref, altAlleles) {
      const refLength = ref.length;
      if (altAlleles === undefined) {
          return "UNKNOWN"
      } else if (altAlleles.trim().length === 0 ||
          altAlleles === "<NON_REF>" ||
          altAlleles === "<*>" ||
          altAlleles === ".") {
          return "NONVARIANT"
      } else {
          const alleles = altAlleles.split(",");
          const types = alleles.map(function (a) {
              if (refLength === 1 && a.length === 1) {
                  return "SNP"
              } else {
                  return "<NON_REF>" === a ? "NONVARIANT" : "OTHER"
              }
          });
          let type = types[0];
          for (let t of types) {
              if (t !== type) {
                  return "MIXED"
              }
          }
          return type
      }
  }

  function arrayToString(value, delim) {

      if (delim === undefined) delim = ",";

      if (!(Array.isArray(value))) {
          return value
      }
      return value.join(delim)
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Parser for VCF files.
   */

  class VcfParser {

      construtor() {
      }

      async parseHeader(dataWrapper, genome) {

          const header = {};

          header.chrAliasTable = new Map();

          // First line must be file format
          let line = await dataWrapper.nextLine();
          if (line.startsWith("##fileformat")) {
              header.version = line.substr(13);
          } else {
              throw new Error("Invalid VCF file: missing fileformat line")
          }

          while ((line = await dataWrapper.nextLine()) !== undefined) {

              if (line.startsWith("#")) {

                  let id;
                  const values = {};

                  if (line.startsWith("##")) {

                      if (line.startsWith("##INFO") || line.startsWith("##FILTER") || line.startsWith("##FORMAT")) {

                          const ltIdx = line.indexOf("<");
                          const gtIdx = line.lastIndexOf(">");

                          if (!(ltIdx > 2 && gtIdx > 0)) {
                              continue
                          }

                          const type = line.substring(2, ltIdx - 1);
                          if (!header[type]) header[type] = {};

                          //##INFO=<ID=AF,Number=A,Type=Float,Description="Allele frequency based on Flow Evaluator observation counts">
                          // ##FILTER=<ID=NOCALL,Description="Generic filter. Filtering details stored in FR info tag.">
                          // ##FORMAT=<ID=AF,Number=A,Type=Float,Description="Allele frequency based on Flow Evaluator observation counts">

                          const tokens = splitStringRespectingQuotes(line.substring(ltIdx + 1, gtIdx - 1), ",");

                          for (let token of tokens) {
                              var kv = token.split("=");
                              if (kv.length > 1) {
                                  if (kv[0] === "ID") {
                                      id = kv[1];
                                  } else {
                                      values[kv[0]] = kv[1];
                                  }
                              }
                          }

                          if (id) {
                              header[type][id] = values;
                          }
                      } else if (line.startsWith("##contig") && genome) {
                          const idx1 = line.indexOf("<ID=");
                          let idx2 = line.indexOf(",", idx1);
                          if (idx2 == -1) {
                              idx2 = line.indexOf(">", idx1);
                          }
                          const chr = line.substring(idx1 + 4, idx2);
                          const canonicalChromosome = genome.getChromosomeName(chr);
                          header.chrAliasTable.set(canonicalChromosome, chr);
                      } else ;
                  } else if (line.startsWith("#CHROM")) {
                      const tokens = line.split("\t");

                      if (tokens.length > 8) {

                          // call set names -- use column index for id
                          header.callSets = [];
                          for (let j = 9; j < tokens.length; j++) {
                              header.callSets.push({id: j, name: tokens[j]});
                          }
                      }
                  }

              } else {
                  break
              }

          }

          this.header = header;  // Will need to intrepret genotypes and info field

          return header
      }


      /**
       * Parse data as a collection of Variant objects.
       *
       * @param data
       * @returns {Array}
       */
      async parseFeatures(dataWrapper) {

          const allFeatures = [];
          const callSets = this.header.callSets;
          const nExpectedColumns = 8 + (callSets ? callSets.length + 1 : 0);
          let line;
          while ((line = await dataWrapper.nextLine()) !== undefined) {
              if (line && !line.startsWith("#")) {

                  const tokens = line.split("\t");
                  if (tokens.length === nExpectedColumns) {
                      const variant = createVCFVariant(tokens);
                      variant.header = this.header;       // Keep a pointer to the header to interpret fields for popup text
                      //variant.line = line              // Uncomment for debugging
                      allFeatures.push(variant);

                      if (tokens.length > 9) {

                          // Format
                          const callFields = extractCallFields(tokens[8].split(":"));

                          variant.calls = {};
                          for (let index = 9; index < tokens.length; index++) {

                              const token = tokens[index];

                              const callSet = callSets[index - 9];
                              const call = {
                                  callSetName: callSet.name,
                                  info: {}
                              };

                              variant.calls[callSet.id] = call;

                              token.split(":").forEach(function (callToken, idx) {

                                  switch (idx) {
                                      case callFields.genotypeIndex:
                                          call.genotype = [];
                                          callToken.split(/[\|\/]/).forEach(function (s) {
                                              call.genotype.push('.' === s ? s : parseInt(s));
                                          });
                                          break

                                      default:
                                          call.info[callFields.fields[idx]] = callToken;
                                  }
                              });
                          }
                      }

                      // If this is a structural variant create a complement of this variant for the other end
                      // The test for "SV" is not comprehensive, there is not yet a standard for this
                      if (variant.info && variant.info.CHR2 && variant.info.END) {
                          allFeatures.push(svComplement(variant));
                      }
                  }
              }
          }

          return allFeatures
      }
  }

  function extractCallFields(tokens) {

      const callFields = {
          genotypeIndex: -1,
          fields: tokens
      };
      for (let i = 0; i < tokens.length; i++) {
          if ("GT" === tokens[i]) {
              callFields.genotypeIndex = i;
          }
      }
      return callFields
  }

  function svComplement(v) {

      const chr2 = v.info.CHR2;
      const pos2 = Number.parseInt(v.info.END);
      return {
          chr: chr2,
          start: pos2 - 1,
          end: pos2,
          _f: v
      }

  }

  /**
   * Parser for IGV desktop GWAS files.  See http://software.broadinstitute.org/software/igv/GWAS
   */
  class GWASParser {

      constructor(config) {
          // Defaults - can be overriden by header
          this.config = config;
          if (config.columns) {
              if (config.columns.chromosome === undefined ||
                  config.columns.position === undefined ||
                  config.columns.value === undefined) {
                  throw Error("columns property must define chrCol, posCol, and valueCol")
              }
              this.posCol = config.columns.position - 1;
              this.chrCol = config.columns.chromosome - 1;
              this.valueCol = config.columns.value - 1;
          } else {
              // Defaults -- can be overriden in header
              this.posCol = 2;
              this.chrCol = 1;
              this.valueCol = 3;
          }
      }

      async parseHeader(dataWrapper) {
          const headerLine = await dataWrapper.nextLine();
          return this.parseHeaderLine(headerLine)
      }

      parseHeaderLine(headerLine) {
          this.columns = headerLine.split(/\t/);
          if (!this.config.columns) {
              for (let i = 0; i < this.columns.length; i++) {
                  const c = this.columns[i].toLowerCase();
                  switch (c) {
                      case 'chr':
                      case 'chromosome':
                      case 'chr_id':
                          this.chrCol = i;
                          break
                      case 'bp':
                      case 'pos':
                      case 'position':
                      case 'chr_pos':
                          this.posCol = i;
                          break
                      case 'p':
                      case 'pval':
                      case 'pvalue':
                      case 'p-value':
                      case 'p.value':
                          this.valueCol = i;
                          break
                  }
              }
          }
          return this.columns
      }

      async parseFeatures(dataWrapper) {

          const allFeatures = [];
          const headerLine = dataWrapper.nextLine();
          if (!this.columns) {
              this.parseHeaderLine(headerLine);
          }
          let line;
          while ((line = dataWrapper.nextLine()) !== undefined) {
              const tokens = line.split(/\t/);
              if (tokens.length === this.columns.length) {
                  const chr = tokens[this.chrCol];
                  const start = parseInt(tokens[this.posCol]) - 1;
                  const end = start + 1;
                  const value = Number(tokens[this.valueCol]);
                  allFeatures.push(new GWASFeature({
                      chr: chr,
                      start: start,
                      end: end,
                      value: value,
                      line: line,
                      columns: this.columns
                  }));
              }
          }
          return allFeatures
      }
  }

  class GWASFeature {

      constructor({chr, start, end, value, line, columns}) {
          this.chr = chr;
          this.start = start;
          this.end = end;
          this.value = value;
          this.line = line;
          this.columns = columns;
      }

      popupData() {
          const tokens = this.line.split(/\t/);
          return this.columns.map(function (c, index) {
              return {name: c, value: tokens[index]}
          })
      }

      getAttribute(attrName) {
          const tokens = this.line.split(/\t/);
          for (let i = 0; i < this.columns.length; i++) {
              if (this.columns[i] === attrName) {
                  return tokens[i]
              }
          }
          return undefined
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   *  Define parsers for bed-like files  (.bed, .gff, .vcf, etc).  A parser should implement 2 methods
   *
   *     parseHeader(data) - return an object representing a header or metadata.  Details are format specific
   *
   *     parseFeatures(data) - return an array of features
   *
   */

  var aedRegexpNoNamespace = new RegExp("([^:]*)\\(([^)]*)\\)"); // name(type) for AED parsing (namespace undefined)
  var aedRegexpNamespace = new RegExp("([^:]*):([^(]*)\\(([^)]*)\\)"); // namespace:name(type) for AED parsing


  class AEDParser {

      constructor(config) {
          const decode = config ? config.decode : undefined;
          this.nameField = config ? config.nameField : undefined;
          this.skipRows = 0;   // The number of fixed header rows to skip.  Override for specific types as needed
          if (decode) {
              this.decode = decode;
          } else {
              this.decode = decodeAed;
          }
          this.delimiter = "\t";
      }

      async parseHeader(dataWrapper) {
          let line;
          let header;
          while (line = await dataWrapper.nextLine()) {
              if (line.startsWith("track") || line.startsWith("#") || line.startsWith("browser")) {
                  if (line.startsWith("track") || line.startsWith("#track")) {
                      let h = parseTrackLine(line);
                      if (header) {
                          Object.assign(header, h);
                      } else {
                          header = h;
                      }
                  } else if (line.startsWith("#columns")) {
                      let h = parseColumnsDirective(line);
                      if (header) {
                          Object.assign(header, h);
                      } else {
                          header = h;
                      }
                  } else if (line.startsWith("##gff-version 3")) {
                      this.format = "gff3";
                      if (!header) header = {};
                      header["format"] = "gff3";
                  }
              } else {
                  break
              }
          }
          this.header = header;    // Directives might be needed for parsing lines
          return header
      }

      async parseFeatures(dataWrapper) {

          const allFeatures = [];
          const decode = this.decode;
          const delimiter = this.delimiter || "\t";
          let i = 0;
          let line;
          let wig;

          while ((line = dataWrapper.nextLine()) !== undefined) {
              i++;
              if (i <= this.skipRows || line.startsWith("track") || line.startsWith("#") || line.startsWith("browser")) {
                  continue
              }

              let tokens = readTokensAed();
              if (tokens.length < 1) {
                  continue
              }

              if (!this.aed) {
                  // Store information about the aed header in the parser itself
                  // This is done only once - on the first row
                  this.aed = parseAedHeaderRow(tokens);
                  continue
              }

              const feature = decode.call(this, tokens, wig);
              if (feature) {
                  allFeatures.push(feature);
              }
          }

          return allFeatures

          // Double quoted strings can contain newlines in AED
          // "" is an escape for a ".
          // Parse all this, clean it up, split into tokens in a custom way
          function readTokensAed() {
              var tokens = [],
                  token = "",
                  quotedString = false,
                  n,
                  c;

              while (line || line === '') {
                  for (n = 0; n < line.length; n++) {
                      c = line.charAt(n);
                      if (c === delimiter) {
                          if (!quotedString) {
                              tokens.push(token);
                              token = "";
                          } else {
                              token += c;
                          }
                      } else if (c === "\"") {
                          // Look ahead to the next character
                          if (n + 1 < line.length && line.charAt(n + 1) === "\"") {
                              if (quotedString) {
                                  // Turn "" into a single " in the output string
                                  token += "\"";
                              }
                              // Skip the next double quote
                              n++;
                          } else {
                              // We know the next character is NOT a double quote, flip our state
                              quotedString = !quotedString;
                          }
                      } else {
                          token += c;
                      }
                  }
                  // We are at the end of the line
                  if (quotedString) {
                      token += '\n'; // Add newline to the token
                      line = nextLine(); // Keep going
                  } else {
                      // We can end the loop
                      break
                  }
              }
              // Push the last token
              tokens.push(token);
              return tokens
          }
      }
  }


  function parseAedToken(value) {
      // Example: refseq:accessionNumber(aed:String)
      // refseq - namespace, will be declared later
      // accessionNumber - name of the field
      // aed:String - type of the field
      // The namespace part may be missing
      var match = aedRegexpNamespace.exec(value);
      if (match) {
          return {
              namespace: match[1],
              name: match[2],
              type: match[3]
          }
      }

      match = aedRegexpNoNamespace.exec(value);
      if (match) {
          return {
              namespace: '?',
              name: match[1],
              type: match[2]
          }
      } else {
          throw new Error("Error parsing the header row of AED file - column not in ns:name(ns:type) format")
      }
  }

  function parseAedHeaderRow(tokens) {
      // First row of AED file defines column names
      // Each header item is an aed token - see parseAedToken
      var aed,
          k,
          token,
          aedToken;

      // Initialize aed section to be filled in
      aed = {
          columns: [ // Information about the namespace, name and type of each column
              // Example entry:
              // { namespace: 'bio', name: 'start', type: 'aed:Integer' }
          ],
          metadata: { // Metadata about the entire AED file
              // Example:
              // {
              //    aed: {
              //       application: { value: "CHaS Browser 3.3.0.139 (r10838)", type: "aed:String" },
              //       created: { value: "2018-01-02T10:20:30.123+01:00", type: "aed:DateTime" },
              //       modified: { value: "2018-03-04T11:22:33.456+01:00", type: "aed:DateTime" },
              //    }
              //    affx: {
              //       ucscGenomeVersion: { value: "hg19", type: "aed:String" }
              //    },
              //    namespace: {
              //       omim: { value: "http://affymetrix.com/ontology/www.ncbi.nlm.nih.gov/omim/", type: "aed:URI" },
              //       affx: { value: "http://affymetrix.com/ontology/", type: "aed:URI" },
              //       refseq: { value: "http://affymetrix.com/ontology/www.ncbi.nlm.nih.gov/RefSeq/", type: "aed:URI" }
              //    }
              // }
          }
      };
      for (k = 0; k < tokens.length; k++) {
          token = tokens[k];
          aedToken = parseAedToken(token);
          aed.columns.push(aedToken);
      }

      return aed
  }

  function parseTrackLine(line) {

      const properties = {};
      const tokens = line.split(/(?:")([^"]+)(?:")|([^\s"]+)(?=\s+|$)/g);


      // Clean up tokens array
      let curr;
      const tmp = [];
      for (let tk of tokens) {
          if (!tk || tk.trim().length === 0) continue
          if (tk.endsWith("=") > 0) {
              curr = tk;
          } else if (curr) {
              tmp.push(curr + tk);
              curr = undefined;
          } else {
              tmp.push(tk);
          }
      }
      for (let str of tmp) {
          if (!str) return
          var kv = str.split('=', 2);
          if (kv.length === 2) {
              const key = kv[0].trim();
              const value = kv[1].trim();
              properties[key] = value;
          }

      }

      return properties
  }

  function parseColumnsDirective(line) {

      let properties = {};
      let t1 = line.split(/\s+/);

      if (t1.length === 2) {

          let t2 = t1[1].split(";");

          t2.forEach(function (keyValue) {

              let t = keyValue.split("=");

              if (t[0] === "color") {
                  properties.colorColumn = Number.parseInt(t[1]) - 1;
              } else if (t[0] === "thickness") {
                  properties.thicknessColumn = Number.parseInt(t[1]) - 1;
              }
          });
      }

      return properties
  }

  /**
   * AED file feature.
   *
   * @param aed link to the AED file object containing file-level metadata and column descriptors
   * @param allColumns All columns as parsed from the AED
   *
   * Other values are parsed one by one
   */
  function AedFeature(aed, allColumns) {
      var token, aedColumn, aedColumns = aed.columns;

      // Link to AED file (for metadata)
      this.aed = aed;

      // Unparsed columns from AED file
      this.allColumns = allColumns;

      // Prepare space for the parsed values
      this.chr = null;
      this.start = null;
      this.end = null;
      this.score = 1000;
      this.strand = '.';
      this.cdStart = null;
      this.cdEnd = null;
      this.name = null;
      this.color = null;

      for (let i = 0; i < allColumns.length; i++) {
          token = allColumns[i];
          if (!token) {
              // Skip empty fields
              continue
          }
          aedColumn = aedColumns[i];
          if (aedColumn.type === 'aed:Integer') {
              token = parseInt(token);
          }
          var arr = [];
          if (aedColumn.namespace.length > 0) {
              for (let j = 0; j < aedColumn.namespace.length; j++) {
                  arr.push(aedColumn.namespace.charCodeAt(j));
              }
          }
          if (aedColumn.namespace.trim() === 'bio') {
              if (aedColumn.name === 'sequence') {
                  this.chr = token;
              } else if (aedColumn.name === 'start') {
                  this.start = token;
              } else if (aedColumn.name === 'end') {
                  this.end = token;
              } else if (aedColumn.name === 'cdsMin') {
                  this.cdStart = token;
              } else if (aedColumn.name === 'cdsMax') {
                  this.cdEnd = token;
              } else if (aedColumn.name === 'strand') {
                  this.strand = token;
              }
          } else if (aedColumn.namespace === 'aed') {
              if (aedColumn.name === 'name') {
                  this.name = token;
              }
          } else if (aedColumn.namespace === 'style') {
              if (aedColumn.name === 'color') {
                  this.color = IGVColor.createColorString(token);
              }
          }
      }
  }

  AedFeature.prototype.popupData = function () {
      var data = [],
          aed = this.aed;
      // Just dump everything we have for now
      for (var i = 0; i < this.allColumns.length; i++) {
          var featureValue = this.allColumns[i];
          var name = aed.columns[i].name;
          // Skip columns that are not interesting - you know the sequence, and you can see color
          if (name !== 'sequence' && name !== 'color') {
              if (featureValue) {
                  data.push({name: name, value: featureValue});
              }
          }
      }
      return data
  };

  /**
   * Decode the AED file format
   * @param tokens
   * @param ignore
   * @returns decoded feature, or null if this is not a valid record
   */
  function decodeAed(tokens, ignore) {
      var name, value, token,
          nonEmptyTokens = 0,
          aedColumns = this.aed.columns,
          aedColumn,
          aedKey,
          i;

      // Each aed row must match the exact number of columns or we skip it
      if (tokens.length !== aedColumns.length) {
          return undefined
      }

      for (i = 0; i < tokens.length; i++) {
          aedColumn = aedColumns[i];
          token = tokens[i];
          if (token !== '') {
              nonEmptyTokens++;
          }
          if (aedColumn.name === 'name' && aedColumn.namespace === 'aed') {
              name = token;
          } else if (aedColumn.name === 'value' && aedColumn.namespace === 'aed') {
              value = token;
          }
      }

      if (nonEmptyTokens === 2 && name && value) {
          // Special row that defines metadata for the entire file
          aedKey = parseAedToken(name);
          // Store in the metadata section
          if (!this.aed.metadata[aedKey.namespace]) {
              this.aed.metadata[aedKey.namespace] = {};
          }
          if (!this.aed.metadata[aedKey.namespace][aedKey.name]) {
              this.aed.metadata[aedKey.namespace][aedKey.name] = {
                  type: aedKey.type,
                  value: value
              };
          }
          // Ignore this value
          return undefined
      }

      var feature = new AedFeature(this.aed, tokens);

      if (!feature.chr || (!feature.start && feature.start !== 0) || !feature.end) {
          return undefined
      }

      return feature
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  // TODO -- big endian?

  class BinaryParser {
      constructor(dataView, littleEndian) {

          this.littleEndian = littleEndian !== undefined ? littleEndian : true;
          this.position = 0;
          this.view = dataView;
          this.length = dataView.byteLength;
      }

      available() {
          return this.length - this.position
      }

      remLength() {
          return this.length - this.position
      }

      hasNext() {
          return this.position < this.length - 1
      }

      getByte() {
          var retValue = this.view.getUint8(this.position, this.littleEndian);
          this.position++;
          return retValue
      }

      getShort() {

          var retValue = this.view.getInt16(this.position, this.littleEndian);
          this.position += 2;
          return retValue
      }

      getUShort() {

          // var byte1 = this.getByte(),
          //     byte2 = this.getByte(),
          //     retValue = ((byte2 << 24 >>> 16) + (byte1 << 24 >>> 24));
          //     return retValue;

          //
          var retValue = this.view.getUint16(this.position, this.littleEndian);
          this.position += 2;
          return retValue
      }


      getInt() {

          var retValue = this.view.getInt32(this.position, this.littleEndian);
          this.position += 4;
          return retValue
      }


      getUInt() {
          var retValue = this.view.getUint32(this.position, this.littleEndian);
          this.position += 4;
          return retValue
      }

      getLong() {

          // DataView doesn't support long. So we'll try manually

          var b = [];
          b[0] = this.view.getUint8(this.position);
          b[1] = this.view.getUint8(this.position + 1);
          b[2] = this.view.getUint8(this.position + 2);
          b[3] = this.view.getUint8(this.position + 3);
          b[4] = this.view.getUint8(this.position + 4);
          b[5] = this.view.getUint8(this.position + 5);
          b[6] = this.view.getUint8(this.position + 6);
          b[7] = this.view.getUint8(this.position + 7);

          var value = 0;
          if (this.littleEndian) {
              for (let i = b.length - 1; i >= 0; i--) {
                  value = (value * 256) + b[i];
              }
          } else {
              for (let i = 0; i < b.length; i++) {
                  value = (value * 256) + b[i];
              }
          }


          this.position += 8;
          return value
      }

      getString(len) {

          var s = "";
          var c;
          while ((c = this.view.getUint8(this.position++)) !== 0) {
              s += String.fromCharCode(c);
              if (len && s.length === len) break
          }
          return s
      }

      getFixedLengthString(len) {

          var s = "";
          var i;
          var c;
          for (i = 0; i < len; i++) {
              c = this.view.getUint8(this.position++);
              if (c > 0) {
                  s += String.fromCharCode(c);
              }
          }
          return s
      }

      getFixedLengthTrimmedString(len) {

          var s = "";
          var i;
          var c;
          for (i = 0; i < len; i++) {
              c = this.view.getUint8(this.position++);
              if (c > 32) {
                  s += String.fromCharCode(c);
              }
          }
          return s
      }

      getFloat() {

          var retValue = this.view.getFloat32(this.position, this.littleEndian);
          this.position += 4;
          return retValue


      }

      getDouble() {

          var retValue = this.view.getFloat64(this.position, this.littleEndian);
          this.position += 8;
          return retValue
      }

      skip(n) {

          this.position += n;
          return this.position
      }


      /**
       * Return a BGZip (bam and tabix) virtual pointer
       * TODO -- why isn't 8th byte used ?
       * @returns {*}
       */
      getVPointer() {

          var position = this.position,
              offset = (this.view.getUint8(position + 1) << 8) | (this.view.getUint8(position)),
              byte6 = ((this.view.getUint8(position + 6) & 0xff) * 0x100000000),
              byte5 = ((this.view.getUint8(position + 5) & 0xff) * 0x1000000),
              byte4 = ((this.view.getUint8(position + 4) & 0xff) * 0x10000),
              byte3 = ((this.view.getUint8(position + 3) & 0xff) * 0x100),
              byte2 = ((this.view.getUint8(position + 2) & 0xff)),
              block = byte6 + byte5 + byte4 + byte3 + byte2;
          this.position += 8;

          //       if (block == 0 && offset == 0) {
          //           return null;
          //       } else {
          return new VPointer(block, offset)
          //       }
      }
  }

  class VPointer {
      constructor(block, offset) {
          this.block = block;
          this.offset = offset;
      }

      isLessThan(vp) {
          return this.block < vp.block ||
              (this.block === vp.block && this.offset < vp.offset)
      }

      isGreaterThan(vp) {
          return this.block > vp.block ||
              (this.block === vp.block && this.offset > vp.offset)
      }

      isEqualTo(vp) {
          return this.block === vp.block && this.offset === vp.offset
      }

      print() {
          return "" + this.block + ":" + this.offset
      }
  }

  function optimizeChunks(chunks, lowest) {

      if (chunks.length === 0) return chunks

      chunks.sort(function (c0, c1) {

          const dif = c0.minv.block - c1.minv.block;
          if (dif !== 0) {
              return dif
          } else {
              return c0.minv.offset - c1.minv.offset
          }
      });

      if(chunks.length <= 1) {
          return chunks
      }

      // console.log("Before trimming " + chunks.length)
      // for (let c of chunks) {
      //     console.log(`${c.minv.block} ${c.minv.offset}  -  ${c.maxv.block} ${c.maxv.offset}`)
      // }

      if (lowest) {
          chunks = chunks.filter(c => c.maxv.isGreaterThan(lowest));
      }

      // console.log("Before merging " + chunks.length)
      // for (let c of chunks) {
      //     console.log(`${c.minv.block} ${c.minv.offset}  -  ${c.maxv.block} ${c.maxv.offset}`)
      // }

      const mergedChunks = [];
      let lastChunk;
      for (let chunk of chunks) {

          if (!lastChunk) {
              mergedChunks.push(chunk);
              lastChunk = chunk;
          } else {
              if (canMerge(lastChunk, chunk)) {
                  if (chunk.maxv.isGreaterThan(lastChunk.maxv)) {
                      lastChunk.maxv = chunk.maxv;
                  }
              } else {
                  mergedChunks.push(chunk);
                  lastChunk = chunk;
              }
          }
      }

      // console.log("After merging " + mergedChunks.length)
      // for (let c of mergedChunks) {
      //     console.log(`${c.minv.block} ${c.minv.offset}  -  ${c.maxv.block} ${c.maxv.offset}`)
      // }

      return mergedChunks
  }


  /**
   * Merge 2 blocks if the file position gap between them is < 16 kb, and the total size is < ~5 mb
   * @param chunk1
   * @param chunk2
   * @returns {boolean|boolean}
   */
  function canMerge(chunk1, chunk2) {
      chunk2.minv.block - chunk1.maxv.block;
      const sizeEstimate = chunk1.maxv.block - chunk1.minv.block;
      return sizeEstimate < 5000000
  }

  // Represents a CSI Bam or Tabix index

  const CSI1_MAGIC$1 = 21582659; // CSI\1
  const CSI2_MAGIC$1 = 38359875; // CSI\2

  async function parseCsiIndex(arrayBuffer, genome) {

      const idx = new CSIIndex();
      idx.parse(arrayBuffer, genome);
      return idx
  }

  class CSIIndex {

      constructor(tabix) {
          this.tabix = true;   // Means whatever is indexed is BGZipped
      }

      parse(arrayBuffer, genome) {
          const parser = new BinaryParser(new DataView(arrayBuffer));

          const magic = parser.getInt();

          if (magic !== CSI1_MAGIC$1) {
              if (magic === CSI2_MAGIC$1) {
                  throw Error("CSI version 2 is not supported.  Please enter an issue at https://github.com/igvteam/igv.js")
              } else {
                  throw Error("Not a CSI index")
              }
          }

          this.indices = [];
          this.blockMin = Number.MAX_SAFE_INTEGER;
          this.lastBlockPosition = [];
          this.sequenceIndexMap = {};

          this.minShift = parser.getInt();
          this.depth = parser.getInt();
          const lAux = parser.getInt();
          const seqNames = [];
          let bmax = 0;

          if (lAux >= 28) {
              // Tabix header parameters aren't used, but they must be read to advance the pointer
              parser.getInt();
              parser.getInt();
              parser.getInt();
              parser.getInt();
              parser.getInt();
              parser.getInt();
              const l_nm = parser.getInt();
              const nameEndPos = parser.position + l_nm;
              let i = 0;
              while (parser.position < nameEndPos) {
                  let seq_name = parser.getString();
                  // Translate to "official" chr name.
                  if (genome) {
                      seq_name = genome.getChromosomeName(seq_name);
                  }
                  this.sequenceIndexMap[seq_name] = i;
                  seqNames[i] = seq_name;
                  i++;
              }
          }

          const MAX_BIN = this.bin_limit() + 1;
          const nref = parser.getInt();
          for (let ref = 0; ref < nref; ref++) {
              const binIndex = [];
              const loffset = [];
              const nbin = parser.getInt();
              for (let b = 0; b < nbin; b++) {

                  const binNumber = parser.getInt();
                  loffset[binNumber] = parser.getVPointer();

                  if (binNumber > MAX_BIN) {
                      // This is a psuedo bin, not used but we have to consume the bytes
                      parser.getInt(); // # of chunks for this bin
                      parser.getVPointer();   // unmapped beg
                      parser.getVPointer();   // unmapped end
                      parser.getLong();
                      parser.getLong();

                  } else {

                      binIndex[binNumber] = [];
                      const nchnk = parser.getInt(); // # of chunks for this bin

                      for (let i = 0; i < nchnk; i++) {
                          const cs = parser.getVPointer();    //chunk_beg
                          const ce = parser.getVPointer();    //chunk_end
                          if (cs && ce) {
                              if (cs.block < this.blockMin) {
                                  this.blockMin = cs.block;    // Block containing first alignment
                              }
                              if (ce.block > bmax) {
                                  bmax = ce.block;
                              }
                              binIndex[binNumber].push([cs, ce]);
                          }
                      }
                  }
              }

              if (nbin > 0) {
                  this.indices[ref] = {
                      binIndex: binIndex,
                      loffset: loffset
                  };
              }
          }
          this.lastBlockPosition = bmax;
      }

      get chromosomeNames() {
          return Object.keys(this.sequenceIndexMap)
      }

      /**
       * Fetch blocks for a particular genomic range.  This method is public so it can be unit-tested.
       *
       * @param refId  the sequence dictionary index of the chromosome
       * @param min  genomic start position
       * @param max  genomic end position
       * @param return an array of {minv: {filePointer, offset}, {maxv: {filePointer, offset}}
       */
      chunksForRange(refId, min, max) {

          const ba = this.indices[refId];
          if (!ba) {
              return []
          } else {
              const overlappingBins = this.reg2bins(min, max);        // List of bin #s that overlap min, max
              if (overlappingBins.length == 0) return []

              const chunks = [];
              // Find chunks in overlapping bins.  Leaf bins (< 4681) are not pruned
              for (let binRange of overlappingBins) {
                  for (let bin = binRange[0]; bin <= binRange[1]; bin++) {
                      if (ba.binIndex[bin]) {
                          const binChunks = ba.binIndex[bin];
                          for (let c of binChunks) {
                              const cs = c[0];
                              const ce = c[1];
                              chunks.push({minv: cs, maxv: ce, bin: bin});
                          }
                      }
                  }
              }

              const lowestOffset = ba.loffset[overlappingBins[0]];

              return optimizeChunks(chunks, lowestOffset)
          }

      }

      // reg2bins implementation adapted from GMOD/tabix-js  https://github.com/GMOD/tabix-js/blob/master/src/csi.ts
      reg2bins(beg, end) {
          beg -= 1; // < convert to 1-based closed
          if (beg < 1) beg = 1;
          if (end > 2 ** 34) end = 2 ** 34; // 17 GiB ought to be enough for anybody
          end -= 1;
          let l = 0;
          let t = 0;
          let s = this.minShift + this.depth * 3;
          const bins = [];
          for (; l <= this.depth; s -= 3, t += (1 << l * 3), l += 1) {
              const b = t + (beg >> s);
              const e = t + (end >> s);
              //
              // ITS NOT CLEAR WHERE THIS TEST CAME FROM,  but maxBinNumber is never set, and its not clear what it represents.
              // if (e - b + bins.length > this.maxBinNumber)
              //     throw new Error(
              //         `query ${beg}-${end} is too large for current binning scheme (shift ${this.minShift}, depth ${this.depth}), try a smaller query or a coarser index binning scheme`,
              //     )
              //
              bins.push([b, e]);
          }
          return bins
      }


      bin_limit() {
          return ((1 << (this.depth + 1) * 3) - 1) / 7
      }

  }

  // Represents a BAM or Tabix index.

  const BAI_MAGIC$1 = 21578050;
  const TABIX_MAGIC$1 = 21578324;


  async function parseBamIndex(arrayBuffer, genome) {
      const index = new BamIndex();
      await index.parse(arrayBuffer, false, genome);
      return index
  }

  async function parseTabixIndex(arrayBuffer, genome) {
      const index = new BamIndex();
      await index.parse(arrayBuffer, true, genome);
      return index
  }

  class BamIndex {

      constructor() {

      }

      async parse(arrayBuffer, tabix, genome) {

          const indices = [];
          let blockMin = Number.MAX_SAFE_INTEGER;
          let blockMax = 0;

          const parser = new BinaryParser(new DataView(arrayBuffer));
          const magic = parser.getInt();
          const sequenceIndexMap = {};
          if (magic === BAI_MAGIC$1 || (tabix && magic === TABIX_MAGIC$1)) {

              const nref = parser.getInt();
              if (tabix) {
                  // Tabix header parameters aren't used, but they must be read to advance the pointer
                  parser.getInt();
                  parser.getInt();
                  parser.getInt();
                  parser.getInt();
                  parser.getInt();
                  parser.getInt();
                  parser.getInt();

                  for (let i = 0; i < nref; i++) {
                      let seq_name = parser.getString();
                      // Translate to "official" chr name.
                      if (genome) {
                          seq_name = genome.getChromosomeName(seq_name);
                      }
                      sequenceIndexMap[seq_name] = i;
                  }
              }

              // Loop through sequences
              for (let ref = 0; ref < nref; ref++) {

                  const binIndex = {};
                  const linearIndex = [];
                  const nbin = parser.getInt();

                  for (let b = 0; b < nbin; b++) {
                      const binNumber = parser.getInt();
                      if (binNumber === 37450) {
                          // This is a psuedo bin, not used but we have to consume the bytes
                          parser.getInt(); // # of chunks for this bin
                          parser.getVPointer();   // unmapped beg
                          parser.getVPointer();   // unmapped end
                          parser.getLong();
                          parser.getLong();

                      } else {

                          binIndex[binNumber] = [];
                          const nchnk = parser.getInt(); // # of chunks for this bin

                          for (let i = 0; i < nchnk; i++) {
                              const cs = parser.getVPointer();    //chunk_beg
                              const ce = parser.getVPointer();    //chunk_end
                              if (cs && ce) {
                                  if (cs.block < blockMin) {
                                      blockMin = cs.block;    // Block containing first alignment
                                  }
                                  if (ce.block > blockMax) {
                                      blockMax = ce.block;
                                  }
                                  binIndex[binNumber].push([cs, ce]);
                              }
                          }
                      }
                  }

                  const nintv = parser.getInt();
                  for (let i = 0; i < nintv; i++) {
                      const cs = parser.getVPointer();
                      linearIndex.push(cs);   // Might be null
                  }

                  if (nbin > 0) {
                      indices[ref] = {
                          binIndex: binIndex,
                          linearIndex: linearIndex
                      };
                  }
              }

              this.firstBlockPosition = blockMin;
              this.lastBlockPosition = blockMax;
              this.indices = indices;
              this.sequenceIndexMap = sequenceIndexMap;
              this.tabix = tabix;

          } else {
              throw new Error(indexURL + " is not a " + (tabix ? "tabix" : "bai") + " file")
          }


      }

      get chromosomeNames() {
          return Object.keys(this.sequenceIndexMap)
      }

      /**
       * Fetch chunks for a particular genomic range.  This method is public so it can be unit-tested.
       *
       * @param refId  the sequence dictionary index of the chromosome
       * @param min  genomic start position
       * @param max  genomic end position
       * @param return an array of objects representing chunks (file spans) {minv: {block, offset}, {maxv: {block, offset}}
       */
      chunksForRange(refId, min, max) {

          const bam = this;
          const ba = bam.indices[refId];

          if (!ba) {
              return []
          } else {
              const overlappingBins = reg2bins(min, max);        // List of bin #s that overlap min, max

              //console.log("bin ranges")
              //for(let b of overlappingBins) {
              //    console.log(`${b[0]} - ${b[1]}`)
              //}

              const chunks = [];
              // Find chunks in overlapping bins.  Leaf bins (< 4681) are not pruned
              for (let binRange of overlappingBins) {
                  for (let bin = binRange[0]; bin <= binRange[1]; bin++) {
                      if (ba.binIndex[bin]) {
                          const binChunks = ba.binIndex[bin];
                          for (let c of binChunks) {
                              const cs = c[0];
                              const ce = c[1];
                              chunks.push({minv: cs, maxv: ce});
                          }
                      }
                  }
              }

              // Use the linear index to find minimum file position of chunks that could contain alignments in the region
              const nintv = ba.linearIndex.length;

              let lowest;
              const minLin = Math.min(min >> 14, nintv - 1);    // i.e. min / 16384
              const maxLin = Math.min(max >> 14, nintv - 1);
              for (let i = minLin; i <= maxLin; i++) {
                  const vp = ba.linearIndex[i];
                  if (vp) {
                      lowest = vp;       // lowest file offset that contains alignments overlapping (min, max)
                      break
                  }
              }

              return optimizeChunks(chunks, lowest)
          }
      }
  }



  /**
   * Calculate the list of bins that overlap with region [beg, end]
   *
   */
  function reg2bins(beg, end) {
      const list = [];
      if (end >= 1 << 29) end = 1 << 29;
      --end;
      list.push([0, 0]);
      list.push([1 + (beg >> 26), 1 + (end >> 26)]);
      list.push([9 + (beg >> 23), 9 + (end >> 23)]);
      list.push([73 + (beg >> 20), 73 + (end >> 20)]);
      list.push([585 + (beg >> 17), 585 + (end >> 17)]);
      list.push([4681 + (beg >> 14), 4681 + (end >> 14)]);

      // for (k = 1 + (beg >> 26); k <= 1 + (end >> 26); ++k) list.push(k);
      // for (k = 9 + (beg >> 23); k <= 9 + (end >> 23); ++k) list.push(k);
      // for (k = 73 + (beg >> 20); k <= 73 + (end >> 20); ++k) list.push(k);
      // for (k = 585 + (beg >> 17); k <= 585 + (end >> 17); ++k) list.push(k);
      // for (k = 4681 + (beg >> 14); k <= 4681 + (end >> 14); ++k) list.push(k);
      return list
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  async function parseTribbleIndex(arrayBuffer, genome) {

      const index = new TribbleIndex();
      index.parse(arrayBuffer, genome);
      return index
  }

  class TribbleIndex {

      constructor() {

      }

      async parse(arrayBuffer, genome) {

          let blockMax = 0;
          this.chrIndex = {};
          this.lastBlockPosition = [];
          const parser = new BinaryParser(new DataView(arrayBuffer));
          readHeader(parser);

          let nChrs = parser.getInt();
          while (nChrs-- > 0) {

              // todo -- support interval tree index, we're assuming its a linear index

              let chr = parser.getString();
              if (genome) chr = genome.getChromosomeName(chr); // Translate to canonical name

              const binWidth = parser.getInt();
              const nBins = parser.getInt();
              const longestFeature = parser.getInt();
              parser.getInt() > 0;
              parser.getInt();

              // note the code below accounts for > 60% of the total time to read an index
              let pos = parser.getLong();
              const blocks = [];
              for (let binNumber = 0; binNumber < nBins; binNumber++) {
                  const nextPos = parser.getLong();
                  blocks.push({min: pos, max: nextPos}); //        {position: pos, size: size});
                  pos = nextPos;
                  if (nextPos > blockMax) {
                      blockMax = nextPos;
                  }
              }
              this.chrIndex[chr] = {chr: chr, blocks: blocks, longestFeature: longestFeature, binWidth: binWidth};
          }

          this.lastBlockPosition = blockMax;


          /**
           * Read the header .   Data here is not used in igv.js but we need to read it to advance the pointer.
           * @param parser
           */
          function readHeader(parser) {

              parser.getInt();     //   view._getInt32(offset += 32, true);
              parser.getInt();
              const version = parser.getInt();
              parser.getString();
              parser.getLong();
              parser.getLong();
              parser.getString();
              parser.getInt();
              if (version >= 3) {
                  let nProperties = parser.getInt();
                  while (nProperties-- > 0) {
                      parser.getString();
                      parser.getString();
                  }
              }
          }
      }

      get chromosomeNames() {
          return Object.keys(this.chrIndex)
      }


      /**
       * Fetch blocks for a particular genomic range.
       *
       * @param queryChr the sequence dictionary index of the chromosome
       * @param min  genomic start position
       * @param max  genomic end position
       */
      chunksForRange(queryChr, min, max) { //function (refId, min, max) {
          const chrIdx = this.chrIndex[queryChr];

          if (chrIdx) {
              const blocks = chrIdx.blocks;
              const longestFeature = chrIdx.longestFeature;
              const binWidth = chrIdx.binWidth;
              const adjustedPosition = Math.max(min - longestFeature, 0);
              const startBinNumber = Math.floor(adjustedPosition / binWidth);

              if (startBinNumber >= blocks.length) // are we off the end of the bin list, so return nothing
                  return []
              else {
                  const endBinNumber = Math.min(Math.floor((max - 1) / binWidth), blocks.length - 1);

                  // By definition blocks are adjacent in the file for the liner index.  Combine them into one merged block
                  const startPos = blocks[startBinNumber].min;
                  const endPos = blocks[endBinNumber].max;
                  const size = endPos - startPos;
                  if (size === 0) {
                      return []
                  } else {
                      const mergedBlock = {minv: {block: startPos, offset: 0}, maxv: {block: endPos, offset: 0}};
                      return [mergedBlock]
                  }
              }
          } else {
              return undefined
          }
      }
  }

  const CSI1_MAGIC = 21582659; // CSI\1
  const CSI2_MAGIC = 38359875; // CSI\2
  const BAI_MAGIC = 21578050;
  const TABIX_MAGIC = 21578324;
  const TRIBBLE_MAGIC = 1480870228;   //  byte[]{'T', 'I', 'D', 'X'};

  /**
   * @param indexURL
   * @param config
   * @param tabix
   *
   */
  async function loadIndex(indexURL, config, genome) {

      let arrayBuffer = await igvxhr$1.loadArrayBuffer(indexURL, buildOptions(config));
      let dv = new DataView(arrayBuffer);

      // Some indexs are bgzipped, specifically tabix, and csi.  Bam (bai) are not.  Tribble is usually not.
      // Check first 2 bytes of file for gzip magic number, and inflate if neccessary
      if (dv.getUint8(0) === 0x1f && dv.getUint8(1) === 0x8b) {    // gzipped
          const inflate = unbgzf$1(arrayBuffer);
          arrayBuffer = inflate.buffer;
          dv = new DataView(arrayBuffer);
      }

      const magic = dv.getInt32(0, true);
      switch (magic) {
          case BAI_MAGIC:
              return parseBamIndex(arrayBuffer, genome)
          case TABIX_MAGIC:
              return parseTabixIndex(arrayBuffer, genome)
          case CSI1_MAGIC:
              return parseCsiIndex(arrayBuffer, genome)
          case TRIBBLE_MAGIC:
              return parseTribbleIndex(arrayBuffer, genome)
          case CSI2_MAGIC:
              throw Error("CSI version 2 is not supported.")
          default:
              throw Error(`Unrecognized index type: ${indexURL}`)
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  function getDataWrapper$1(data) {

      if (typeof (data) == 'string' || data instanceof String) {
          return new StringDataWrapper$1(data)
      } else {
          return new ByteArrayDataWrapper$1(data)
      }
  }


  // Data might be a string, or an UInt8Array
  class StringDataWrapper$1 {

      constructor(string) {
          this.data = string;
          this.ptr = 0;
      }

      nextLine() {
          var start = this.ptr,
              idx = this.data.indexOf('\n', start),
              data = this.data;

          if (idx > 0) {
              this.ptr = idx + 1;   // Advance pointer for next line
              if (idx > start && data.charAt(idx - 1) === '\r') {
                  // Trim CR manually in CR/LF sequence
                  return data.substring(start, idx - 1)
              }
              return data.substring(start, idx)
          } else {
              var length = data.length;
              this.ptr = length;
              // Return undefined only at the very end of the data
              return (start >= length) ? undefined : data.substring(start)
          }
      }
  }

  class ByteArrayDataWrapper$1 {

      constructor(array) {
          this.data = array;
          this.length = this.data.length;
          this.ptr = 0;
      }

      nextLine() {

          var c, result;
          result = "";

          if (this.ptr >= this.length) return undefined

          for (var i = this.ptr; i < this.length; i++) {
              c = String.fromCharCode(this.data[i]);
              if (c === '\r') continue
              if (c === '\n') break
              result = result + c;
          }

          this.ptr = i + 1;
          return result
      }

  }

  /**
   * Class to iterate line-by-line over a BGZipped text file.  This class is useful for iterating from the start of
   * the file.  Not useful for indexed queries.
   */

  class BGZLineReader {

      constructor(config) {
          this.config = config;
          this.filePtr = 0;
          this.bufferPtr = 0;
          this.buffer;
      }

      async nextLine() {

          let result = undefined;

          try {
              while (true) {
                  const length = this.buffer ? this.buffer.length : 0;
                  while (this.bufferPtr < length) {
                      const c = String.fromCharCode(this.buffer[this.bufferPtr++]);
                      if (c === '\r') continue
                      if (c === '\n') {
                          return result
                      }
                      result = result ? result + c : c;
                  }
                  if (this.eof) {
                      return result
                  } else {
                      await this.readNextBlock();
                  }
              }
          } catch (e) {
              console.warn(e);
              this.eof = true;
              return result
          }
      }

      async readNextBlock() {

          const bsizeOptions = buildOptions(this.config, {
              range: {
                  start: this.filePtr,
                  size: 26
              }
          });
          const abuffer = await igvxhr$1.loadArrayBuffer(this.config.url, bsizeOptions);
          const bufferSize = bgzBlockSize$1(abuffer);

          if (bufferSize === 0) {
              this.eof = true;
              this.buffer = undefined;
          } else {

              const options = buildOptions(this.config, {range: {start: this.filePtr, size: bufferSize}});
              const data = await igvxhr$1.loadArrayBuffer(this.config.url, options);
              if (data.byteLength < bufferSize) {
                  this.eof = true; // Assumption
              }
              this.buffer = unbgzf$1(data);
              if(this.buffer.byteLength == 0) {
                  this.eof = true;
              }
              this.bufferPtr = 0;
              this.filePtr += data.byteLength; //data.byteLength;
          }
      }

  }

  function concatenateArrayBuffers(arrayBuffers) {

      if (arrayBuffers.length === 1) {
          return arrayBuffers[0]
      }

      let len = 0;
      for (const b of arrayBuffers) {
          len += b.byteLength;
      }
      const c = new Uint8Array(len);
      let offset = 0;
      for (const b of arrayBuffers) {
          c.set(new Uint8Array(b), offset);
          offset += b.byteLength;
      }
      return c.buffer
  }

  /**
   * Return the block size for the data buffer.
   * @param data
   * @returns {number}
   */
  const bgzBlockSize = (data) => {
      const ba = ArrayBuffer.isView(data) ? data : new Uint8Array(data);
      const bsize = (ba[17] << 8 | ba[16]) + 1;
      return bsize
  };

  class BGZBlockLoader {

      constructor(config) {
          this.config = config;
          this.cacheBlocks = false != config.cacheBlocks;   // Default to true
          this.cache = undefined;
      }

      /**
       * Return inflated data from startBlock through endBlock as an UInt8Array
       *
       * @param minv minimum virtual pointer  {block, offset}
       * @param maxv maximum virtual pointer  {block, offset}
       * @returns {Promise<Uint8Array>}
       */
      async getData(minv, maxv) {

          const startBlock = minv.block;
          const endBlock = maxv.block;
          const skipEnd = maxv.offset === 0;

          const blocks = await this.getInflatedBlocks(startBlock, endBlock, skipEnd);
          if (blocks.length === 1) {
              return blocks[0]
          }

          let len = 0;
          for (const b of blocks) {
              len += b.byteLength;
          }
          const c = new Uint8Array(len);
          let offset = 0;
          for (const b of blocks) {
              c.set(b, offset);
              offset += b.byteLength;
          }
          return c
      }

      /**
       * Return the inflated data for the specified blocks as an array of Uint8Arrays.  This method is public so
       * it can be unit tested. *
       * @param startBlock
       * @param endBlock
       * @returns {Promise<*[Uint8Array]>}
       */
      async getInflatedBlocks(startBlock, endBlock, skipEnd) {

          if (!this.cacheBlocks) {
              const buffer = await this.loadBLockData(startBlock, endBlock, {skipEnd});
              return inflateBlocks(buffer)
          } else {

              const c = this.cache;
              if (c &&
                  c.startBlock <= startBlock &&
                  (c.endBlock >= endBlock || skipEnd && c.nextEndBlock === endBlock)) {
                  //console.log("Complete overlap")
                  const startOffset = startBlock - c.startBlock;
                  const endOffset = endBlock - c.startBlock;
                  return inflateBlocks(c.buffer, startOffset, endOffset)
                  // Don't update cache, still valid
              } else {

                  let buffer;
                  if (!c || (c.startBlock > endBlock || c.endBlock < startBlock)) {
                      // no overlap with cache
                      buffer = await this.loadBLockData(startBlock, endBlock, {skipEnd});
                  } else {

                      //console.log("Some overlap")
                      const arrayBuffers = [];

                      // Load blocks preceding cache start, if any
                      if (startBlock < c.startBlock) {
                          // load first blocks
                          const startBuffer = await this.loadBLockData(startBlock, c.startBlock, {skipEnd: true});
                          arrayBuffers.push(startBuffer);
                      }

                      // Slice cached buffer as needed
                      let cachedBuffer;
                      if (startBlock <= c.startBlock && endBlock >= c.endBlock) {
                          cachedBuffer = c.buffer;
                      } else {
                          const start = Math.max(0, startBlock - c.startBlock);
                          let end;
                          if (endBlock >= c.endBlock) {
                              end = c.buffer.byteLength;
                          } else {
                              // We need to find the byte position of the end of "endBlock"
                              const boundaries = findBlockBoundaries(c.buffer);
                              for (let i = 0; i < boundaries.length - 1; i++) {
                                  if (c.startBlock + boundaries[i] === endBlock) {
                                      end = boundaries[i + 1];
                                      break
                                  }
                              }
                              // Do something if end not found
                          }
                          cachedBuffer = c.buffer.slice(start, end);
                      }
                      arrayBuffers.push(cachedBuffer);

                      // Load end blocks, if any
                      if (endBlock > c.endBlock) {
                          const endBuffer = await this.loadBLockData(c.endBlock, endBlock, {skipStart: true, skipEnd});
                          arrayBuffers.push(endBuffer);
                      }

                      buffer = concatenateArrayBuffers(arrayBuffers);
                  }

                  // If skipEnd === true we need to find boundary of last block in cache
                  let nextEndBlock = endBlock;
                  if(skipEnd) {
                      const boundaries = findBlockBoundaries(buffer);
                      endBlock = boundaries[boundaries.length - 1];
                  }

                  this.cache = {startBlock, endBlock, nextEndBlock, buffer};
                  return inflateBlocks(buffer)
              }
          }
      }

      async loadBLockData(startBlock, endBlock, options) {

          const config = this.config;
          const skipStart = options && options.skipStart;
          const skipEnd = options && options.skipEnd;

          // Get size of last block if not skipped
          let lastBlockSize = 0;
          if (!skipEnd) {
              const bsizeOptions = buildOptions(config, {range: {start: endBlock, size: 26}});
              const abuffer = await igvxhr$1.loadArrayBuffer(config.url, bsizeOptions);
              lastBlockSize = bgzBlockSize(abuffer);
          }

          if (skipStart) {
              const bsizeOptions = buildOptions(config, {range: {start: startBlock, size: 26}});
              const abuffer = await igvxhr$1.loadArrayBuffer(config.url, bsizeOptions);
              startBlock += bgzBlockSize(abuffer);
          }

          // Load data for all blocks
          const loadOptions = buildOptions(config, {
              range: {
                  start: startBlock,
                  size: endBlock + lastBlockSize - startBlock
              }
          });

          //console.log(`${this.config.name}  Loaded ${startBlock} - ${endBlock + lastBlockSize}   (${(endBlock + lastBlockSize - startBlock) / 1000} kb)`)

          return igvxhr$1.loadArrayBuffer(config.url, loadOptions)
      }
  }

  function findBlockBoundaries(arrayBuffer) {

      const byteLengh = arrayBuffer.byteLength;
      let offset = 0;
      const blockBoundaries = [0];
      while (offset < byteLengh) {
          //console.log("Cache block "  + offset)
          const ba = new Uint8Array(arrayBuffer, offset);
          const bsize = (ba[17] << 8 | ba[16]) + 1;
          offset += bsize;
          if (offset < byteLengh) {
              blockBoundaries.push(offset);
          }
      }
      return blockBoundaries
  }


  /**
   * Inflate compressed blocks within the data buffer*
   * @param data
   * @param startBlock - optional file location for start block.  Default == 0
   * @param endBlock - optional file location for last block to decompress.
   * @returns {*[]}
   */
  function inflateBlocks(data, startBlock, endBlock) {

      startBlock = startBlock || 0;

      const oBlockList = [];
      let ptr = startBlock;

      const lim = data.byteLength - 18;
      while (ptr < lim) {
          try {
              //console.log(113873 + ptr)
              const header = new Uint8Array(data, ptr, 18);
              const xlen = (header[11] << 8) | (header[10]);
              const bsize = ((header[17] << 8) | (header[16]));  // Total block size, including header, minus 1
              const start = 12 + xlen + ptr;    // Start of CDATA
              const bytesLeft = data.byteLength - start;
              const cDataSize = bsize - xlen - 18;

              if (bytesLeft < cDataSize || cDataSize <= 0) {
                  // This is unexpected.  Throw error?
                  break
              }

              const cdata = new Uint8Array(data, start, cDataSize);
              const unc = inflateRaw_1$2(cdata);
              oBlockList.push(unc);

              if (endBlock === ptr) {
                  break
              } else {
                  // Advance to next block
                  ptr += bsize + 1;
              }

          } catch (e) {
              console.error(e);
              break
          }
      }
      return oBlockList
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Reader for "bed like" files (tab delimited files with 1 feature per line: bed, gff, vcf, etc)
   *
   * @param config
   * @constructor
   */
  class FeatureFileReader {

      constructor(config, genome) {

          var uriParts;

          this.config = config || {};
          this.genome = genome;
          this.indexURL = config.indexURL;
          this.indexed = config.indexed;

          if (isFile$2(this.config.url)) {
              this.filename = this.config.url.name;
          } else if (isDataURL(this.config.url)) {
              this.indexed = false;  // by definition
              this.dataURI = config.url;
          } else {
              uriParts = parseUri$1(this.config.url);
              this.filename = config.filename || uriParts.file;
          }

          this.parser = this.getParser(this.config);

          if (this.config.format === "vcf" && !this.config.indexURL) {
              console.warn("Warning: index file not specified.  The entire vcf file will be loaded.");
          }

      }

      async defaultVisibilityWindow() {
          if (this.config.indexURL) {
              const index = await this.getIndex();
              if (index && index.lastBlockPosition) {
                  let gl = 0;
                  const s = 10000;
                  for (let c of index.chromosomeNames) {
                      const chromosome = this.genome.getChromosome(c);
                      if (chromosome) {
                          gl += chromosome.bpLength;
                      }
                  }
                  return Math.round((gl / index.lastBlockPosition) * s)
              }
          }
      }

      /**
       * Return a promise to load features for the genomic interval
       * @param chr
       * @param start
       * @param end
       */
      async readFeatures(chr, start, end) {

          const index = await this.getIndex();
          if (index) {
              this.indexed = true;
              return this.loadFeaturesWithIndex(chr, start, end)
          } else if (this.dataURI) {
              this.indexed = false;
              return this.loadFeaturesFromDataURI()
          } else {
              this.indexed = false;
              return this.loadFeaturesNoIndex()
          }

      }

      async readHeader() {

          if (this.dataURI) {
              await this.loadFeaturesFromDataURI(this.dataURI);
              return this.header
          } else {

              if (this.config.indexURL) {
                  const index = await this.getIndex();
                  if (!index) {
                      // Note - it should be impossible to get here
                      throw new Error("Unable to load index: " + this.config.indexURL)
                  }

                  let dataWrapper;
                  if (index.tabix) {
                      this._blockLoader = new BGZBlockLoader(this.config);
                      dataWrapper = new BGZLineReader(this.config);
                  } else {
                      // Tribble
                      const maxSize = Object.values(index.chrIndex)
                          .flatMap(chr => chr.blocks)
                          .map(block => block.max)
                          .reduce((previous, current) =>
                              Math.min(previous, current), Number.MAX_SAFE_INTEGER);

                      const options = buildOptions(this.config, {bgz: index.tabix, range: {start: 0, size: maxSize}});
                      const data = await igvxhr$1.loadString(this.config.url, options);
                      dataWrapper = getDataWrapper$1(data);
                  }


                  this.header = await this.parser.parseHeader(dataWrapper);  // Cache header, might be needed to parse features
                  return this.header

              } else {
                  // If this is a non-indexed file we will load all features in advance
                  const options = buildOptions(this.config);
                  const data = await igvxhr$1.loadString(this.config.url, options);
                  let dataWrapper = getDataWrapper$1(data);
                  this.header = await this.parser.parseHeader(dataWrapper);

                  // Reset data wrapper and parse features
                  dataWrapper = getDataWrapper$1(data);
                  this.features = await this.parser.parseFeatures(dataWrapper);   // cache features
                  return this.header
              }
          }
      }


      getParser(config) {

          switch (config.format) {
              case "vcf":
                  return new VcfParser(config)
              case "seg" :
                  return new SegParser("seg")
              case "mut":
                  return new SegParser("mut")
              case "maf":
                  return new SegParser("maf")
              case "gwas" :
                  return new GWASParser(config)
              case "aed" :
                  return new AEDParser(config)
              default:
                  return new FeatureParser(config)
          }
      }

      async loadFeaturesNoIndex() {

          if (this.features) {
              // An optimization hack for non-indexed files, features are temporarily cached when header is read.
              const tmp = this.features;
              delete this.features;
              return tmp
          } else {
              const options = buildOptions(this.config);    // Add oauth token, if any
              const data = await igvxhr$1.loadString(this.config.url, options);
              if (!this.header) {
                  const dataWrapper = getDataWrapper$1(data);
                  this.header = await this.parser.parseHeader(dataWrapper);
              }
              const dataWrapper = getDataWrapper$1(data);
              const features = await this.parser.parseFeatures(dataWrapper);   // <= PARSING DONE HERE
              return features
          }
      }

      async loadFeaturesWithIndex(chr, start, end) {

          // insure that header has been loaded -- tabix _blockLoader is initialized as side effect
          if(!this.dataURI && !this.header) {
              await this.readHeader();
          }

          //console.log("Using index"
          const config = this.config;
          const parser = this.parser;
          const tabix = this.index.tabix;
          const refId = tabix ? this.index.sequenceIndexMap[chr] : chr;
          if (refId === undefined) {
              return []
          }

          const genome = this.genome;
          const chunks = this.index.chunksForRange(refId, start, end);
          if (!chunks || chunks.length === 0) {
              return []
          } else {
              const allFeatures = [];
              for (let chunk of chunks) {

                  let inflated;
                  if (tabix) {
                      inflated = await this._blockLoader.getData(chunk.minv, chunk.maxv);
                  } else {
                      const options = buildOptions(config, {
                          range: {
                              start: chunk.minv.block,
                              size: chunk.maxv.block - chunk.minv.block + 1
                          }
                      });
                      inflated = await igvxhr$1.loadString(config.url, options);
                  }

                  const slicedData = chunk.minv.offset ? inflated.slice(chunk.minv.offset) : inflated;
                  const dataWrapper = getDataWrapper$1(slicedData);
                  let slicedFeatures = await parser.parseFeatures(dataWrapper);

                  // Filter psuedo-features (e.g. created mates for VCF SV records)
                  slicedFeatures = slicedFeatures.filter(f => f._f === undefined);

                  // Filter features not in requested range.
                  let inInterval = false;
                  for (let i = 0; i < slicedFeatures.length; i++) {
                      const f = slicedFeatures[i];

                      const canonicalChromosome = genome ? genome.getChromosomeName(f.chr) : f.chr;
                      if (canonicalChromosome !== chr) {
                          if (allFeatures.length === 0) {
                              continue  //adjacent chr to the left
                          } else {
                              break //adjacent chr to the right
                          }
                      }
                      if (f.start > end) {
                          allFeatures.push(f);  // First feature beyond interval
                          break
                      }
                      if (f.end >= start && f.start <= end) {
                          if (!inInterval) {
                              inInterval = true;
                              if (i > 0) {
                                  allFeatures.push(slicedFeatures[i - 1]);
                              }
                          }
                          allFeatures.push(f);
                      }
                  }

              }
              allFeatures.sort(function (a, b) {
                  return a.start - b.start
              });

              return allFeatures
          }
      }

      async getIndex() {
          if (this.index) {
              return this.index
          } else if (this.config.indexURL) {
              this.index = await this.loadIndex();
              return this.index
          }
      }

      /**
       * Return a Promise for the async loaded index
       */
      async loadIndex() {
          const indexURL = this.config.indexURL;
          return loadIndex(indexURL, this.config, this.genome)
      }

      async loadFeaturesFromDataURI() {

          if (this.features) {
              // An optimization hack for non-indexed files, features are temporarily cached when header is read.
              const tmp = this.features;
              delete this.features;
              return tmp
          } else {
              const plain = decodeDataURI$1(this.dataURI);
              let dataWrapper = getDataWrapper$1(plain);
              this.header = await this.parser.parseHeader(dataWrapper);
              if (this.header instanceof String && this.header.startsWith("##gff-version 3")) {
                  this.format = 'gff3';
              }

              dataWrapper = getDataWrapper$1(plain);
              this.features = await this.parser.parseFeatures(dataWrapper);
              return this.features
          }
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const isString$1 = isString$2;


  class CustomServiceReader {
      constructor(config) {
          this.config = config;
      }

      async readFeatures(chr, start, end) {

          let url;
          if (typeof this.config.url === 'function') {
              url = this.config.url({chr, start, end});
          } else {
              url = this.config.url
                  .replace("$CHR", chr)
                  .replace("$START", start)
                  .replace("$END", end);
          }

          let config = Object.assign({}, this.config);
          if (this.config.body !== undefined) {
              if (typeof this.config.body === 'function') {
                  config.body = this.config.body({chr, start, end});
              } else {
                  config.body =
                      this.config.body
                          .replace("$CHR", chr)
                          .replace("$START", start)
                          .replace("$END", end);
              }
          }


          let features;
          const data = await igvxhr$1.load(url, config);
          if (data) {
              if (typeof this.config.parser === "function") {
                  features = this.config.parser(data);
              } else if (isString$1(data)) {
                  features = JSON.parse(data);
              } else {
                  features = data;
              }
          }
          if (this.config.mappings) {
              let mappingKeys = Object.keys(this.config.mappings);
              for (let f of features) {
                  for (let key of mappingKeys) {
                      f[key] = f[this.config.mappings[key]];
                  }
              }
          }
          return features
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const UCSCServiceReader = function (config, genome) {
      this.config = config;
      this.genome = genome;
      this.expandQueryInterval = false;
  };

  UCSCServiceReader.prototype.readFeatures = function (chr, start, end) {

      const s = Math.max(0, Math.floor(start));
      let e = Math.ceil(end);

      if (this.genome) {
          const c = this.genome.getChromosome(chr);
          if (c && e > c.bpLength) {
              e = c.bpLength;
          }
      }


      const url = this.config.url + '?db=' + this.config.db + '&table=' + this.config.tableName + '&chr=' + chr + '&start=' + s + '&end=' + e;

      return igvxhr$1.loadJson(url, this.config)
          .then(function (data) {
              if (data) {
                  data.forEach(function (sample) {
                      if (sample.hasOwnProperty('exonStarts') &&
                          sample.hasOwnProperty('exonEnds') &&
                          sample.hasOwnProperty('exonCount') &&
                          sample.hasOwnProperty('cdsStart') &&
                          sample.hasOwnProperty('cdsEnd')) {
                          addExons(sample);
                      }
                  });
                  return data
              } else {
                  return null
              }
          })
  };

  function addExons(sample) {
      var exonCount, exonStarts, exonEnds, exons, eStart, eEnd;
      exonCount = sample['exonCount'];
      exonStarts = sample['exonStarts'].split(',');
      exonEnds = sample['exonEnds'].split(',');
      exons = [];

      for (var i = 0; i < exonCount; i++) {
          eStart = parseInt(exonStarts[i]);
          eEnd = parseInt(exonEnds[i]);
          var exon = {start: eStart, end: eEnd};

          if (sample.cdsStart > eEnd || sample.cdsEnd < sample.cdsStart) exon.utr = true;   // Entire exon is UTR
          if (sample.cdsStart >= eStart && sample.cdsStart <= eEnd) exon.cdStart = sample.cdsStart;
          if (sample.cdsEnd >= eStart && sample.cdsEnd <= eEnd) exon.cdEnd = sample.cdsEnd;

          exons.push(exon);
      }

      sample.exons = exons;
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2021 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const gffNameFields = ["Name", "gene_name", "gene", "gene_id", "alias", "locus", "name"];

  class GFFHelper {

      constructor(options) {
          this.format = options.format;
          this.nameField = options.nameField;
          this.filterTypes = options.filterTypes === undefined ?
              new Set(['chromosome']) :
              new Set(options.filterTypes);
      }

      combineFeatures(features, genomicInterval) {

          let combinedFeatures;

          const filterTypes = this.filterTypes;
          features = features.filter(f => filterTypes === undefined || !filterTypes.has(f.type));

          if ("gff3" === this.format) {
              const tmp = this.combineFeaturesById(features);
              combinedFeatures = this.combineFeaturesByType(tmp);
          } else {
              combinedFeatures = this.combineFeaturesByType(features);
          }
          combinedFeatures.sort(function (a, b) {
              return a.start - b.start
          });
          this.numberExons(combinedFeatures, genomicInterval);
          this.nameFeatures(combinedFeatures);
          return combinedFeatures
      }

      /**
       * Combine multiple non-transcript model features with the same ID on the same chromosome into a single feature.
       * Features that are part of the transcript model (e.g. exon, mRNA, etc) are combined later.
       *
       * @param features
       * @returns {[]}
       */
      combineFeaturesById(features) {

          const chrIdMap = new Map();
          const combinedFeatures = [];

          for (let f of features) {
              if (isTranscriptPart(f.type) || isTranscript(f.type) || !f.id) {
                  combinedFeatures.push(f);
              } else {
                  let idMap = chrIdMap.get(f.chr);
                  if (!idMap) {
                      idMap = new Map();
                      chrIdMap.set(f.chr, idMap);
                  }

                  let featureArray = idMap.get(f.id);
                  if (featureArray) {
                      featureArray.push(f);
                  } else {
                      idMap.set(f.id, [f]);
                  }
              }
          }

          for (let idMap of chrIdMap.values()) {
              for (let featureArray of idMap.values()) {
                  if (featureArray.length > 1) {
                      // Use the first feature as prototypical (for column 9 attributes), and adjust start/end
                      // Parts are represented as "exons", as that is how they are presented visually
                      const cf = featureArray[0];
                      cf.exons = [];
                      for (let f of featureArray) {
                          cf.start = Math.min(cf.start, f.start);
                          cf.end = Math.max(cf.end, f.end);
                          cf.exons.push({
                              start: f.start,
                              end: f.end
                          });
                      }
                      combinedFeatures.push(cf);
                  } else {
                      combinedFeatures.push(featureArray[0]);
                  }
              }
          }

          return combinedFeatures
      }

      combineFeaturesByType(features) {

          // Build dictionary of genes
          const genes = features.filter(f => "gene" === f.type || f.type.endsWith("_gene"));
          const geneMap = Object.create(null);
          for (let g of genes) {
              geneMap[g.id] = g;
          }

          // 1. Build dictionary of transcripts
          const transcripts = Object.create(null);
          const combinedFeatures = [];
          const consumedFeatures = new Set();
          const filterTypes = this.filterTypes;

          features = features.filter(f => filterTypes === undefined || !filterTypes.has(f.type));

          for (let f of features) {

              if (f.type === "biological_region") ;

              if (isTranscript(f.type)) {
                  const transcriptId = f.id; // getAttribute(f.attributeString, "transcript_id", /\s+/);
                  if (undefined !== transcriptId) {
                      const gffTranscript = new GFFTranscript(f);
                      transcripts[transcriptId] = gffTranscript;
                      combinedFeatures.push(gffTranscript);
                      consumedFeatures.add(f);
                      const g = geneMap[f.parent];
                      if (g) {
                          gffTranscript.geneObject = g;
                          consumedFeatures.add(g);
                      }
                  }
              }
          }

          // Add exons and transcript parts
          for (let f of features) {
              if (isTranscriptPart(f.type)) {
                  const parents = getParents(f);
                  if (parents) {
                      for (let id of parents) {

                          let transcript = transcripts[id];
                          if (!transcript && this.format === "gtf") {
                              // GTF does not require explicit transcript record, start one with this feature.
                              const psuedoTranscript = Object.assign({}, f);
                              psuedoTranscript.type = "transcript";
                              transcript = new GFFTranscript(psuedoTranscript);
                              transcripts[id] = transcript;
                              combinedFeatures.push(transcript);
                          }
                          if (transcript !== undefined) {

                              if (isExon(f.type)) {
                                  if (parents.length > 1) {
                                      // Make a copy as exon can be modified differently by CDS, etc, for each transcript
                                      const e2 = new GFFFeature(f);
                                      transcript.addExon(e2);
                                  } else {
                                      transcript.addExon(f);
                                  }
                              } else {
                                  transcript.addPart(f);
                              }
                              consumedFeatures.add(f);
                          }
                      }
                  }
              }
          }

          // Finish transcripts
          combinedFeatures.forEach(function (f) {
              if (typeof f.finish === "function") {
                  f.finish();
              }
          });

          // Add other features
          const others = features.filter(f => !consumedFeatures.has(f));
          for (let f of others) {
              combinedFeatures.push(f);
          }

          return combinedFeatures

          function getParents(f) {
              if (f.parent && f.parent.trim() !== "") {
                  return f.parent.trim().split(",")
              } else {
                  return null
              }
          }
      }

      numberExons(features, genomicInterval) {

          for (let f of features) {
              if (f.exons &&
                  (!genomicInterval ||
                      (f.end <= genomicInterval.end && f.start > genomicInterval.start))) {
                  for (let i = 0; i < f.exons.length; i++) {
                      const exon = f.exons[i];
                      exon.number = f.strand === "-" ? f.exons.length - i : i + 1;
                  }
              }
          }
      }

      nameFeatures(features) {
          // Find name (label) property
          for (let f of features) {
              if (f.attributeString) {
                  const delim = ('gff3' === this.format) ? '=' : ' ';
                  const attributes = parseAttributeString(f.attributeString, delim);
                  const attributesMap = new Map(attributes);
                  if (this.nameField) {
                      f.name = attributesMap.get(this.nameField);
                  } else {
                      for (let nameField of gffNameFields) {
                          if (attributesMap.has(nameField)) {
                              f.name = attributesMap.get(nameField);
                              break
                          }
                      }
                  }
              }
          }
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2015 UC San Diego
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const GtexReader = function (config) {

      this.config = config;
      this.url = config.url;
      this.tissueId = config.tissueSiteDetailId;
      this.indexed = true;
      this.datasetId = config.datasetId || "gtex_v8";
  };

  GtexReader.prototype.readFeatures = async function (chr, bpStart, bpEnd) {


      let self = this,
          queryChr = chr.startsWith("chr") ? chr : "chr" + chr,
          queryStart = Math.floor(bpStart),
          queryEnd = Math.ceil(bpEnd),
          datasetId = this.datasetId,
          queryURL = this.url + "?chromosome=" + queryChr + "&start=" + queryStart + "&end=" + queryEnd +
              "&tissueSiteDetailId=" + this.tissueId + "&datasetId=" + datasetId;

      const json = await igvxhr$1.loadJson(queryURL, {
          withCredentials: self.config.withCredentials
      });
      if (json && json.singleTissueEqtl) {
          //variants = json.variants;
          //variants.sort(function (a, b) {
          //    return a.POS - b.POS;
          //});
          //source.cache = new FeatureCache(chr, queryStart, queryEnd, variants);

          json.singleTissueEqtl.forEach(function (eqtl) {
              eqtl.chr = eqtl.chromosome;
              eqtl.position = eqtl.pos;
              eqtl.start = eqtl.pos - 1;
              eqtl.end = eqtl.start + 1;
              eqtl.snp = eqtl.snpId;
              eqtl.geneName = eqtl.geneSymbol;
              eqtl.geneId = eqtl.gencodeId;

          });

          return json.singleTissueEqtl
      } else {
          return undefined
      }
  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  // Experimental class for fetching features from an mpg webservice.
  // http://immvar.broadinstitute.org:3000/load_data?chromosome=&start=&end=&categories=

  const ImmVarReader = function (config) {

      this.config = config;
      this.url = config.url;
      this.cellConditionId = config.cellConditionId;
      this.valueThreshold = config.valueThreshold ? config.valueThreshold : 5E-2;

  };

  ImmVarReader.prototype.readFeatures = function (queryChr, queryStart, queryEnd) {

      var self = this,
          queryURL = this.url + "?chromosome=" + queryChr + "&start=" + queryStart + "&end=" + queryEnd +
              "&cell_condition_id=" + this.cellConditionId;

      return new Promise(function (fulfill, reject) {
          igvxhr$1.loadJson(queryURL, {
              withCredentials: self.config.withCredentials
          }).then(function (json) {

              if (json) {
                  //variants = json.variants;
                  //variants.sort(function (a, b) {
                  //    return a.POS - b.POS;
                  //});
                  //source.cache = new FeatureCache(chr, queryStart, queryEnd, variants);

                  json.eqtls.forEach(function (eqtl) {
                      eqtl.chr = eqtl.chromosome;
                      eqtl.start = eqtl.position;
                      eqtl.end = eqtl.position + 1;
                  });

                  fulfill(json.eqtls);
              } else {
                  fulfill(null);
              }

          }).catch(function (error) {
              reject(error);
          });

      })
  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const apiKey = igvxhr$1.apiKey;

  function ga4ghGet(options) {
      var url = options.url + "/" + options.entity + "/" + options.entityId;
      options.headers = ga4ghHeaders();
      return igvxhr$1.loadJson(url, options)      // Returns a promise
  }

  function ga4ghSearch(options) {

      return new Promise(function (fulfill, reject) {
          var results = options.results ? options.results : [],
              url = options.url,
              body = options.body,
              decode = options.decode,
              paramSeparator = "?",
              fields = options.fields;  // Partial response


          if (apiKey) {
              url = url + paramSeparator + "key=" + apiKey;
              paramSeparator = "&";
          }

          if (fields) {
              url = url + paramSeparator + "fields=" + fields;
          }


          // Start the recursive load cycle.  Data is fetched in chunks, if more data is available a "nextPageToken" is returned.
          return loadChunk()

          function loadChunk(pageToken) {

              if (pageToken) {
                  body.pageToken = pageToken;
              } else {
                  if (body.pageToken !== undefined) delete body.pageToken;    // Remove previous page token, if any
              }

              var sendData = JSON.stringify(body);

              igvxhr$1.loadJson(url, {
                  sendData: sendData,
                  contentType: "application/json",
                  headers: ga4ghHeaders(),
                  //    oauthToken: ga4ghToken()
              })
                  .then(function (json) {
                      var nextPageToken, tmp;

                      if (json) {

                          tmp = decode ? decode(json) : json;

                          if (tmp) {

                              tmp.forEach(function (a) {
                                  {
                                      results.push(a);
                                  }
                              });
                          }


                          nextPageToken = json["nextPageToken"];

                          if (nextPageToken) {
                              loadChunk(nextPageToken);
                          } else {
                              fulfill(results);
                          }
                      } else {
                          fulfill(results);
                      }

                  })
                  .catch(function (error) {
                      reject(error);
                  });
          }

      })


  }

  function ga4ghHeaders() {
      return {
          "Cache-Control": "no-cache"
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const Ga4ghVariantReader = function (config, genome) {

      this.config = config;
      this.genome = genome;
      this.url = config.url;
      this.variantSetId = config.variantSetId;
      this.callSetIds = config.callSetIds;
      this.includeCalls = (config.includeCalls === undefined ? true : config.includeCalls);

  };

  // Simulate a VCF file header
  Ga4ghVariantReader.prototype.readHeader = function () {

      var self = this;


      if (self.header) {
          return Promise.resolve(self.header)
      } else {

          self.header = {};

          if (self.includeCalls === false) {
              return Promise.resolve(self.header)
          } else {

              var readURL = self.url + "/callsets/search";

              return ga4ghSearch({
                  url: readURL,
                  fields: "nextPageToken,callSets(id,name)",
                  body: {
                      "variantSetIds": (Array.isArray(self.variantSetId) ? self.variantSetId : [self.variantSetId]),
                      "pageSize": "10000"
                  },
                  decode: function (json) {
                      // If specific callSetIds are specified filter to those
                      if (self.callSetIds) {
                          var callSets = [],
                              csIdSet = new Set();

                          self.callSetIds.forEach(function (csid) {
                              csIdSet.add(csid);
                          });

                          json.callSets.forEach(function (cs) {
                              if (csIdSet.has(cs.id)) {
                                  callSets.push(cs);
                              }
                          });
                          return callSets
                      } else {
                          return json.callSets
                      }
                  }
              })
                  .then(function (callSets) {
                      self.header.callSets = callSets;
                      return self.header
                  })
          }
      }
  };


  Ga4ghVariantReader.prototype.readFeatures = function (chr, bpStart, bpEnd) {

      const self = this;
      const genome = this.genome;

      return self.readHeader()

          .then(function (header) {
              return getChrAliasTable()
          })

          .then(function (chrAliasTable) {

              var queryChr = chrAliasTable.hasOwnProperty(chr) ? chrAliasTable[chr] : chr,
                  readURL = self.url + "/variants/search";

              return ga4ghSearch({
                  url: readURL,
                  fields: (self.includeCalls ? undefined : "nextPageToken,variants(id,variantSetId,names,referenceName,start,end,referenceBases,alternateBases,quality,filter,info)"),
                  body: {
                      "variantSetIds": (Array.isArray(self.variantSetId) ? self.variantSetId : [self.variantSetId]),
                      "callSetIds": (self.callSetIds ? self.callSetIds : undefined),
                      "referenceName": queryChr,
                      "start": bpStart.toString(),
                      "end": bpEnd.toString(),
                      "pageSize": "10000"
                  },
                  decode: function (json) {

                      var v;

                      var variants = [];

                      json.variants.forEach(function (json) {

                          v = createGAVariant(json);

                          if (!v.isRefBlock()) {
                              variants.push(v);
                          }
                      });

                      return variants
                  }
              })
          })


      function getChrAliasTable() {

          return new Promise(function (fulfill, reject) {

              if (self.chrAliasTable) {
                  fulfill(self.chrAliasTable);
              } else {
                  self.readMetadata().then(function (json) {

                      self.metadata = json.metadata;
                      self.chrAliasTable = {};

                      if (json.referenceBounds && genome) {

                          json.referenceBounds.forEach(function (rb) {
                              var refName = rb.referenceName,
                                  alias = genome.getChromosomeName(refName);
                              self.chrAliasTable[alias] = refName;

                          });
                      }
                      fulfill(self.chrAliasTable);

                  });
              }

          })
      }

  };


  Ga4ghVariantReader.prototype.readMetadata = function () {

      return ga4ghGet({
          url: this.url,
          entity: "variantsets",
          entityId: this.variantSetId
      })
  };

  class CivicReader {

      constructor(config) {
          this.config = config;
      }

      async readFeatures(chr, start, end) {

          const json = await igvxhr$1.loadJson(this.config.url + "/variants/?count=50000");
          const records = json.records;
          const features = [];

          for (let record of records) {

              if (record.coordinates) {

                  record.id;
                  const coordinates = record.coordinates;

                  if (coordinates.chromosome) {
                      features.push(
                          new CivicVariant(
                              coordinates.chromosome,
                              coordinates.start - 1,     // UCSC 0 convention
                              coordinates.stop,
                              record
                          ));
                  }

                  if (coordinates.chromosome2) {
                      features.push(
                          new CivicVariant(
                              coordinates.chromosome2,
                              coordinates.start2 - 1,     // UCSC 0 convention
                              coordinates.stop2,
                              record
                          ));
                  }
              }

          }
          return features

      }
  }

  class CivicVariant {

      constructor(chr, start, end, record) {
          this.chr = chr;
          this.start = start;
          this.end = end;
          this.id = record.id;
          this.entrezName = record.entrez_name;
          this.name = record.name;
          this.actionabilityScore = record.civic_actionability_score;

          if (record.coordinates.reference_bases) {
              this.refBases = record.coordinates.reference_bases;
          }
          if (record.coordinates.variant_bases) {
              this.altBases = record.coordinates.variant_bases;
          }
          if (record.variant_types) {
              this.variant_types = record.variant_types;
          }

          this.locationString = (this.chr + ":" +
              numberFormatter$1(this.start + 1) + "-" +
              numberFormatter$1(this.end));

          // Color based on actionability score
          if (this.actionabilityScore !== undefined) {
              let alpha;
              if (this.actionabilityScore <= 10) {
                  alpha = 0.2;
              } else {
                  const v = Math.min(30, this.actionabilityScore);
                  alpha = 0.2 + 0.8 * Math.log10((v - 10) / 2);
              }
              this.alpha = alpha;
          }


      }

      popupData() {


          const link = createLink("CIViC", "https://civicdb.org/links/variants/" + this.id);
          this.refBases !== this.altBases &&
              this.refBases && this.refBases.length === 1 &&
              this.altBases && this.altBases.length === 1;


          const pd = [link];
          pd.push({
              name: "Entrez",
              value: createLink(this.entrezName, "https://ghr.nlm.nih.gov/gene/" + this.entrezName)
          });
          pd.push({name: "Name", value: this.name});

          if (this.variant_types && this.variant_types.length > 0) {

              const name = this.variant_types.length === 1 ? "Type" : "Types";
              let typeString;
              for (let vt of this.variant_types) {
                  if (!typeString) typeString = vt.display_name;
                  else typeString += ", " + vt.display_name;
              }

              pd.push({name: name, value: typeString});
          }

          pd.push({name: "Actionability", value: this.actionabilityScore});


          pd.push({name: "Location", value: this.locationString});

          return pd


          function createLink(text, href) {
              return "<a target='_blank' " + "href='" + href + "'>" + text + "</a>"
          }

      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class HtsgetReader {

      constructor(config, genome) {
          this.config = config;
          this.genome = genome;
          this.format = config.format ? config.format.toUpperCase() : "BAM";    // Backward compatibility
          if (!(this.format === "BAM" || this.format === "VCF")) {
              throw  Error(`htsget format ${config.format} is not supported`)
          }
      }

      async readHeaderData() {
          const url = `${getUrl(this.config)}?class=header&format=${this.format}`;
          const ticket = await igvxhr$1.loadJson(url, buildOptions(this.config));
          return await this.loadUrls(ticket.htsget.urls)
      }

      async readData(chr, start, end) {
          const url = `${getUrl(this.config)}?format=${this.format}&referenceName=${chr}&start=${Math.floor(start)}&end=${Math.ceil(end)}`;
          const ticket = await igvxhr$1.loadJson(url, buildOptions(this.config));
          return this.loadUrls(ticket.htsget.urls)
      }

      async loadUrls(urls) {

          const promiseArray = [];
          for (let urlData of urls) {

              if (urlData.url.startsWith('data:')) {
                  // this is a data-uri
                  promiseArray.push(Promise.resolve(dataUriToBytes(urlData.url)));

              } else {

                  const options = buildOptions(this.config || {});

                  if (urlData.headers) {
                      options.headers = Object.assign(options.headers || {}, urlData.headers);
                  }

                  promiseArray.push(igvxhr$1.loadArrayBuffer(urlData.url, options));
              }
          }
          const arrayBuffers = await Promise.all(promiseArray);
          return concatArrays(arrayBuffers)
      }


      static async inferFormat(config) {
          try {
              const url = getUrl(config);
              const headerURL = `${url}${url.includes("?") ? "&" : "?"}class=header`;
              const ticket = await igvxhr$1.loadJson(headerURL, buildOptions(config));
              if (ticket.htsget) {
                  const format = ticket.htsget.format;
                  if (!(format === "BAM" || format === "VCF")) {
                      throw  Error(`htsget format ${format} is not supported`)
                  }
                  config.format = format.toLowerCase();
                  config.sourceType = "htsget";
                  if (!config.name) {
                      config.name = await getFilename$1(config.url);
                  }
              }
          } catch (e) {
              // Errors => this is not an htsget source, not an application error.  Ignore
          }
      }
  }

  /**
   * Extract the full url from the config.  Striving for backward compatibility, "endpoint" and "id" are deprecated.
   *
   * @param config
   */
  function getUrl(config) {
      if (config.url && config.endpoint && config.id) {
          return config.url + config.endpoint + config.id    // Deprecated
      } else if (config.endpoint && config.id) {
          return config.endpoint + config.id                // Deprecated
      } else if (config.url) {
          if (config.url.startsWith("htsget://")) {
              return config.url.replace("htsget://", "https://")    // htsget -> http not supported
          } else {
              return config.url
          }
      } else {
          throw Error("Must specify either 'url', or 'endpoint' and 'id")
      }


  }

  /**
   * Concatenate a list of array buffers, returning an UInt8Array
   * @param arrayBuffers
   */
  function concatArrays(arrayBuffers) {

      let len = 0;
      for (let a of arrayBuffers) {
          len += a.byteLength;
      }

      let offset = 0;
      const newArray = new Uint8Array(len);
      for (let buf of arrayBuffers) {
          const a = new Uint8Array(buf);
          newArray.set(a, offset);
          offset += a.length;
      }

      return newArray
  }

  function dataUriToBytes(dataUri) {

      const split = dataUri.split(',');
      const info = split[0].split(':')[1];
      let dataString = split[1];

      if (info.indexOf('base64') >= 0) {
          dataString = atob(dataString);
      } else {
          dataString = decodeURI(dataString);
      }

      const bytes = new Uint8Array(dataString.length);
      for (var i = 0; i < dataString.length; i++) {
          bytes[i] = dataString.charCodeAt(i);
      }

      return bytes
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class HtsgetVariantReader extends HtsgetReader {

      constructor(config, genome) {
          super(config, genome);
          this.parser = new VcfParser();
      }

      async readHeader() {
          if (!this.header) {
              const data = await this.readHeaderData();
              const dataWrapper = getDataWrapper$1(data);
              this.header = await this.parser.parseHeader(dataWrapper, this.genome);
              this.chrAliasTable = this.header.chrAliasTable;
          }
          return this.header
      }

      async readFeatures(chr, start, end) {

          if (this.config.format && this.config.format.toUpperCase() !== "VCF") {
              throw  Error(`htsget format ${this.config.format} is not supported`)
          }

          if (!this.chrAliasTable) {
              await this.readHeader();
          }

          let queryChr = this.chrAliasTable.has(chr) ? this.chrAliasTable.get(chr) : chr;

          const data = await this.readData(queryChr, start, end);

          const dataWrapper = getDataWrapper$1(data);

          return this.parser.parseFeatures(dataWrapper)

          //  return dataWrapper;

      }

  }

  // Assigns a row # to each feature.  If the feature does not fit in any row and #rows == maxRows no
  // row number is assigned.
  function pack(featureList, maxRows) {

      maxRows = maxRows || Number.MAX_SAFE_INTEGER;
      const rows = [];
      featureList.sort(function (a, b) {
          return a.start - b.start
      });
      rows.push(-1000);

      for (let feature of featureList) {
          let r = 0;
          const len = Math.min(rows.length, maxRows);
          for (r = 0; r < len; r++) {
              if (feature.start >= rows[r]) {
                  feature.row = r;
                  rows[r] = feature.end;
                  break
              }
          }
          feature.row = r;
          rows[r] = feature.end;
      }
  }

  const DEFAULT_MAX_WG_COUNT$1 = 10000;

  /**
   * Return a collection of "whole genome" features wrapping the supplied features, possibly downsampled.  The purpose
   * is to support painting features in "whole genome view".
   *
   * @param allFeatures - dictionary (object), keys are chromosome names, values are lists of features
   * @param genome
   * @param maxWGCount - optional, maximum # of whole genome features to computer
   * @returns {*[]}
   */
  function computeWGFeatures(allFeatures, genome, maxWGCount) {

      const max = maxWGCount || DEFAULT_MAX_WG_COUNT$1;

      const makeWGFeature = (f) => {
          const wg = Object.assign({}, f);
          wg.chr = "all";
          wg.start = genome.getGenomeCoordinate(f.chr, f.start);
          wg.end = genome.getGenomeCoordinate(f.chr, f.end);
          wg._f = f;
          // Don't draw exons in whole genome view
          if (wg["exons"]) delete wg["exons"];
          return wg
      };

      const wgChromosomeNames = new Set(genome.wgChromosomeNames);
      const wgFeatures = [];
      let count = 0;
      for (let c of genome.wgChromosomeNames) {

          if(Array.isArray(allFeatures)) {
              const featureDict = {};
              for(let f of allFeatures) {
                  const chr = genome.getChromosomeName(f.chr);
                  if(!featureDict.hasOwnProperty(chr)) {
                      featureDict[chr] = [];
                  }
                  featureDict[chr].push(f);
              }
              allFeatures = featureDict;
          }

          const features = allFeatures[c];

          if (features) {
              for (let f of features) {
                  let queryChr = genome.getChromosomeName(f.chr);
                  if (wgChromosomeNames.has(queryChr)) {
                      if (wgFeatures.length < max) {
                          wgFeatures.push(makeWGFeature(f));
                      } else {
                          //Reservoir sampling
                          const samplingProb = max / (count + 1);
                          if (Math.random() < samplingProb) {
                              const idx = Math.floor(Math.random() * (max - 1));
                              wgFeatures[idx] = makeWGFeature(f);
                          }
                      }
                  }
                  count++;
              }
          }
      }

      wgFeatures.sort(function (a, b) {
          return a.start - b.start
      });

      return wgFeatures
  }

  function packFeatures(features, maxRows) {

      maxRows = maxRows || 1000;
      if (features == null || features.length === 0) {
          return
      }
      // Segregate by chromosome
      const chrFeatureMap = {};
      const chrs = [];
      for (let feature of features) {
          const chr = feature.chr;
          let flist = chrFeatureMap[chr];
          if (!flist) {
              flist = [];
              chrFeatureMap[chr] = flist;
              chrs.push(chr);
          }
          flist.push(feature);
      }

      // Loop through chrosomosomes and pack features;
      for (let chr of chrs) {
          pack(chrFeatureMap[chr], maxRows);
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014-2015 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const DEFAULT_MAX_WG_COUNT = 10000;

  /**
   * feature source for "bed like" files (tab or whitespace delimited files with 1 feature per line: bed, gff, vcf, etc)
   *
   * @param config
   * @constructor
   */
  class TextFeatureSource {

      constructor(config, genome) {

          this.config = config || {};
          this.genome = genome;
          this.sourceType = (config.sourceType === undefined ? "file" : config.sourceType);
          this.maxWGCount = config.maxWGCount || DEFAULT_MAX_WG_COUNT;

          const queryableFormats = new Set(["bigwig", "bw", "bigbed", "bb", "biginteract", "biggenepred", "bignarrowpeak", "tdf"]);

          if (config.reader) {
              // Explicit reader implementation
              this.reader = config.reader;
              this.queryable = config.queryable !== false;
          } else if (config.sourceType === "ga4gh") {
              this.reader = new Ga4ghVariantReader(config, genome);
              this.queryable = true;
          } else if (config.sourceType === "immvar") {
              this.reader = new ImmVarReader(config);
              this.queryable = true;
          } else if (config.type === "eqtl" && config.sourceType === "gtex-ws") {
              this.reader = new GtexReader(config);
              this.queryable = true;
          } else if ("htsget" === config.sourceType) {
              this.reader = new HtsgetVariantReader(config, genome);
          } else if (config.sourceType === 'ucscservice') {
              this.reader = new UCSCServiceReader(config.source);
              this.queryable = true;
          } else if (config.sourceType === 'custom') {
              this.reader = new CustomServiceReader(config.source);
              this.queryable = false !== config.source.queryable;
          } else if ("civic-ws" === config.sourceType) {
              this.reader = new CivicReader(config);
              this.queryable = false;
          } else {
              // File of some type (i.e. not a webservice)
              this.reader = new FeatureFileReader(config, genome);
              if (config.queryable !== undefined) {
                  this.queryable = config.queryable;
              } else if (queryableFormats.has(config.format) || this.reader.indexed) {
                  this.queryable = true;
              } else ;
          }
      }

      async defaultVisibilityWindow() {
          if (this.reader && typeof this.reader.defaultVisibilityWindow === 'function') {
              return this.reader.defaultVisibilityWindow()
          }
      }

      async trackType() {
          const header = await this.getHeader();
          if (header) {
              return header.type
          } else {
              return undefined    // Convention for unknown or unspecified
          }
      }

      async getHeader() {
          if (!this.header) {

              if (this.reader && typeof this.reader.readHeader === "function") {
                  const header = await this.reader.readHeader();
                  if (header) {
                      this.header = header;
                      if (header.format) {
                          this.config.format = header.format;
                      }
                  } else {
                      this.header = {};
                  }
              } else {
                  this.header = {};
              }
          }
          return this.header
      }

      /**
       * Required function for all data source objects.  Fetches features for the
       * range requested.
       *
       * This function is quite complex due to the variety of reader types backing it, some indexed, some queryable,
       * some not.
       *
       * @param chr
       * @param start
       * @param end
       * @param bpPerPixel
       */
      async getFeatures({chr, start, end, bpPerPixel, visibilityWindow}) {

          const genome = this.genome;
          const queryChr = genome ? genome.getChromosomeName(chr) : chr;
          const isWholeGenome = ("all" === queryChr.toLowerCase());

          // Various conditions that can require a feature load
          //   * view is "whole genome" but no features are loaded
          //   * cache is disabled
          //   * cache does not contain requested range
          if ((isWholeGenome && !this.wgFeatures && this.supportsWholeGenome()) ||
              this.config.disableCache ||
              !this.featureCache ||
              !this.featureCache.containsRange(new GenomicInterval(queryChr, start, end))) {
              await this.loadFeatures(queryChr, start, end, visibilityWindow);
          }

          if (isWholeGenome) {
              if (!this.wgFeatures) {
                  if (this.supportsWholeGenome()) {
                      this.wgFeatures = computeWGFeatures(this.featureCache.getAllFeatures(), this.genome, this.maxWGCount);
                  } else {
                      this.wgFeatures = [];
                  }
              }
              return this.wgFeatures
          } else {
              return this.featureCache.queryFeatures(queryChr, start, end)
          }
      }

      supportsWholeGenome() {
          return !this.queryable   // queryable (indexed, web services) sources don't support whole genome view
      }

      // TODO -- experimental, will only work for non-indexed sources
      getAllFeatures() {
          if (this.queryable || !this.featureCache) {   // queryable sources don't support all features
              return []
          } else {
              return this.featureCache.getAllFeatures()
          }
      }


      async loadFeatures(queryChr, start, end, visibilityWindow) {

          const reader = this.reader;
          let intervalStart = start;
          let intervalEnd = end;

          // Use visibility window to potentially expand query interval.
          // This can save re-queries as we zoom out.  Visibility window <= 0 is a special case
          // indicating whole chromosome should be read at once.
          if ((!visibilityWindow || visibilityWindow <= 0) && this.config.expandQuery !== false) {
              // Whole chromosome
              const chromosome = this.genome ? this.genome.getChromosome(queryChr) : undefined;
              intervalStart = 0;
              intervalEnd = Math.max(chromosome ? chromosome.bpLength : Number.MAX_SAFE_INTEGER, end);
          } else if (visibilityWindow > (end - start) && this.config.expandQuery !== false) {
              const expansionWindow = Math.min(4.1 * (end - start), visibilityWindow);
              intervalStart = Math.max(0, (start + end) / 2 - expansionWindow);
              intervalEnd = start + expansionWindow;
          }

          let features = await reader.readFeatures(queryChr, intervalStart, intervalEnd);
          if (this.queryable === undefined) {
              this.queryable = reader.indexed;
          }

          const genomicInterval = this.queryable ?
              new GenomicInterval(queryChr, intervalStart, intervalEnd) :
              undefined;

          if (features) {

              if (this.config.assembleGFF !== false &&
                  ("gtf" === this.config.format || "gff3" === this.config.format || "gff" === this.config.format)) {
                  features = (new GFFHelper(this.config)).combineFeatures(features, genomicInterval);
              }

              // Assign overlapping features to rows
              if (this.config.format !== "wig" && this.config.type !== "junctions") {
                  const maxRows = this.config.maxRows || Number.MAX_SAFE_INTEGER;
                  packFeatures(features, maxRows);
              }

              // Note - replacing previous cache with new one.  genomicInterval is optional (might be undefined => includes all features)
              this.featureCache = new FeatureCache$1(features, this.genome, genomicInterval);

              // If track is marked "searchable"< cache features by name -- use this with caution, memory intensive
              if (this.config.searchable || this.config.searchableFields) {
                  this.addFeaturesToDB(features);
              }
          } else {
              this.featureCache = new FeatureCache$1([], genomicInterval);     // Empty cache
          }
      }

      addFeaturesToDB(featureList) {
          for (let feature of featureList) {
              if (feature.name) {
                  this.genome.featureDB[feature.name.toUpperCase()] = feature;
              }
              if (feature.gene && feature.gene.name) {
                  this.genome.featureDB[feature.gene.name.toUpperCase()] = feature;
              }

              if (this.config.searchableFields) {
                  for (let f of this.config.searchableFields) {
                      const value = feature.getAttributeValue(f);
                      if (value) {
                          if (value.indexOf(" ") > 0) {
                              this.genome.featureDB[value.replaceAll(" ", "+").toUpperCase()] = feature;
                              this.genome.featureDB[value.replaceAll(" ", "%20").toUpperCase()] = feature;
                          } else {
                              this.genome.featureDB[value.toUpperCase()] = feature;
                          }
                      }
                  }
              }
          }
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class BufferedReader {

      constructor(config, contentLength, bufferSize) {
          this.path = config.url;
          this.bufferSize = bufferSize ? bufferSize : 512000;
          this.range = {start: -1, size: -1};
          this.config = config;
      }

      /**
       *
       * @param requestedRange - byte rangeas {start, size}
       * @param fulfill - function to receive result
       * @param asUint8 - optional flag to return result as an UInt8Array
       */
      async dataViewForRange(requestedRange, asUint8) {

          const hasData = (this.data && (this.range.start <= requestedRange.start) &&
              ((this.range.start + this.range.size) >= (requestedRange.start + requestedRange.size)));

          if (!hasData) {
              let bufferSize;
              // If requested range size is specified, potentially expand buffer size
              if (requestedRange.size) {
                  bufferSize = Math.max(this.bufferSize, requestedRange.size);
              } else {
                  bufferSize = this.bufferSize;
              }
              const loadRange = {start: requestedRange.start, size: bufferSize};
              const arrayBuffer = await igvxhr$1.loadArrayBuffer(this.path, buildOptions(this.config, {range: loadRange}));
              this.data = arrayBuffer;
              this.range = loadRange;
          }

          const len = this.data.byteLength;
          const bufferStart = requestedRange.start - this.range.start;
          return asUint8 ?
              new Uint8Array(this.data, bufferStart, len - bufferStart) :
              new DataView(this.data, bufferStart, len - bufferStart)
      }
  }

  function getDecoder(definedFieldCount, fieldCount, autoSql, format) {

      if ("biginteract" === format || (autoSql && ('chromatinInteract' === autoSql.table) || 'interact' === autoSql.table)) {
          return decodeInteract
      } else {
          const standardFieldCount = definedFieldCount - 3;
          return function (feature, tokens) {

              if (standardFieldCount > 0) {
                  feature.name = tokens[0];
              }
              if (standardFieldCount > 1) {
                  feature.score = Number(tokens[1]);
              }
              if (standardFieldCount > 2) {
                  feature.strand = tokens[2];
              }
              if (standardFieldCount > 3) {
                  feature.cdStart = parseInt(tokens[3]);
              }
              if (standardFieldCount > 4) {
                  feature.cdEnd = parseInt(tokens[4]);
              }
              if (standardFieldCount > 5) {
                  if (tokens[5] !== "." && tokens[5] !== "0" && tokens[5] !== "-1") {
                      const c = IGVColor.createColorString(tokens[5]);
                      feature.color = c.startsWith("rgb") ? c : undefined;
                  }
              }
              if (standardFieldCount > 8) {
                  const exonCount = parseInt(tokens[6]);
                  const exonSizes = tokens[7].split(',');
                  const exonStarts = tokens[8].split(',');
                  const exons = [];
                  for (let i = 0; i < exonCount; i++) {
                      const eStart = feature.start + parseInt(exonStarts[i]);
                      const eEnd = eStart + parseInt(exonSizes[i]);
                      exons.push({start: eStart, end: eEnd});
                  }
                  findUTRs(exons, feature.cdStart, feature.cdEnd);
                  feature.exons = exons;
              }

              if (autoSql) {
                  // TODO -- these should be equal, validate?  fieldCount-definedFieldCount, as.fields.length, tokens.length-3
                  const extraStart = definedFieldCount;
                  for (let i = extraStart; i < fieldCount; i++) {
                      if (i < autoSql.fields.length) {
                          const name = autoSql.fields[i].name;
                          const value = tokens[i - 3];
                          feature[name] = value;
                      }
                  }
              }
          }
      }

      //table chromatinInteract
  // "Chromatin interaction between two regions"
  //     (
  //     string chrom;      "Chromosome (or contig, scaffold, etc.). For interchromosomal, use 2 records"
  //     uint chromStart;   "Start position of lower region. For interchromosomal, set to chromStart of this region"
  //     uint chromEnd;     "End position of upper region. For interchromosomal, set to chromEnd of this region"
  //     string name;       "Name of item, for display"
  //     uint score;        "Score from 0-1000"
  //     double value;      "Strength of interaction or other data value. Typically basis for score"
  //     string exp;        "Experiment name (metadata for filtering). Use . if not applicable"
  //     string color;      "Item color.  Specified as r,g,b or hexadecimal #RRGGBB or html color name, as in //www.w3.org/TR/css3-color/#html4."
  //     string region1Chrom;  "Chromosome of lower region. For non-directional interchromosomal, chrom of this region."
  //     uint region1Start;  "Start position of lower/this region"
  //     uint region1End;    "End position in chromosome of lower/this region"
  //     string region1Name;  "Identifier of lower/this region"
  //     string region1Strand; "Orientation of lower/this region: + or -.  Use . if not applicable"
  //     string region2Chrom; "Chromosome of upper region. For non-directional interchromosomal, chrom of other region"
  //     uint region2Start;  "Start position in chromosome of upper/this region"
  //     uint region2End;    "End position in chromosome of upper/this region"
  //     string region2Name; "Identifier of upper/this region"
  //     string region2Strand; "Orientation of upper/this region: + or -.  Use . if not applicable"
  //     )
      function decodeInteract(feature, tokens) {

          feature.chr1 = tokens[5];
          feature.start1 = Number.parseInt(tokens[6]);
          feature.end1 = Number.parseInt(tokens[7]);

          feature.chr2 = tokens[10];
          feature.start2 = Number.parseInt(tokens[11]);
          feature.end2 = Number.parseInt(tokens[12]);

          feature.name = tokens[0];
          feature.score = Number(tokens[1]);
          feature.value = Number(tokens[2]);
          feature.color = tokens[4] === '.' ? undefined : tokens[4] === "0" ? "rgb(0,0,0)" : tokens[4];

          return feature
      }
  }

  function findUTRs(exons, cdStart, cdEnd) {

      for (let exon of exons) {
          const end = exon.end;
          const start = exon.start;
          if (end < cdStart || start > cdEnd) {
              exon.utr = true;
          } else {
              if (cdStart >= start && cdStart <= end) {
                  exon.cdStart = cdStart;
              }
              if (cdEnd >= start && cdEnd <= end) {
                  exon.cdEnd = cdEnd;
              }
          }
      }
  }

  function scoreShade(score, color) {
      const alpha = Math.min(1, 0.11 + 0.89 * (score / 779));
      return alpha.toString()
  }

  function parseAutoSQL(str) {

      let table;
      const fields = [];
      let startDecoding = false;
      const lines = str.trim().split(/\s*[\r\n]+\s*/g);
      for (let line of lines) {
          if (line.startsWith('table')) {
              table = line.split(/\s+/)[1].trim();
          } else if (line.startsWith('(')) {
              startDecoding = true;
          } else if (line.startsWith(')')) ; else if (startDecoding) {
              if (line.length > 0) {
                  const idx = line.indexOf(';');
                  const tokens = line.substr(0, idx).split(/\s+/);
                  const description = line.substr(idx + 1).replace(/"/g, '').trim();
                  fields.push({
                      type: tokens[0],
                      name: tokens[1],
                      description: description
                  });
              }
          }
      }
      return {
          table: table,
          fields: fields
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  let BIGWIG_MAGIC_LTH = 0x888FFC26; // BigWig Magic Low to High
  let BIGWIG_MAGIC_HTL = 0x26FC8F66; // BigWig Magic High to Low
  let BIGBED_MAGIC_LTH = 0x8789F2EB; // BigBed Magic Low to High
  let BIGBED_MAGIC_HTL = 0xEBF28987; // BigBed Magic High to Low
  let BBFILE_HEADER_SIZE = 64;
  let RPTREE_HEADER_SIZE = 48;
  let RPTREE_NODE_LEAF_ITEM_SIZE = 32;   // leaf item size
  let RPTREE_NODE_CHILD_ITEM_SIZE = 24;  // child item size
  let BUFFER_SIZE = 512000;     //  buffer

  class BWReader {

      constructor(config, genome) {
          this.path = config.url;
          this.format = config.format || "bigwig";
          this.genome = genome;
          this.rpTreeCache = {};
          this.config = config;
          this.loader = isDataURL(this.path) ? new DataBuffer(this.path) : igvxhr$1;
      }

      async readWGFeatures(bpPerPixel, windowFunction) {
          await this.loadHeader();
          const chrIdx1 = 0;
          const chrIdx2 = this.chromTree.idToChrom.length - 1;
          const chr1 = this.chromTree.idToChrom[chrIdx1];
          const chr2 = this.chromTree.idToChrom[chrIdx2];
          return this.readFeatures(chr1, 0, chr2, Number.MAX_VALUE, bpPerPixel, windowFunction)
      }

      async readFeatures(chr1, bpStart, chr2, bpEnd, bpPerPixel, windowFunction) {

          await this.loadHeader();
          const chrIdx1 = this.chromTree.chromToID[chr1];
          const chrIdx2 = this.chromTree.chromToID[chr2];
          if (chrIdx1 === undefined || chrIdx2 === undefined) {
              return []
          }

          let treeOffset;
          let decodeFunction;
          if (this.type === "bigwig") {
              // Select a biwig "zoom level" appropriate for the current resolution.
              const zoomLevelHeaders = await this.getZoomHeaders();
              let zoomLevelHeader = bpPerPixel ? zoomLevelForScale$1(bpPerPixel, zoomLevelHeaders) : undefined;
              if (zoomLevelHeader) {
                  treeOffset = zoomLevelHeader.indexOffset;
                  decodeFunction = decodeZoomData;
              } else {
                  treeOffset = this.header.fullIndexOffset;
                  decodeFunction = decodeWigData;
              }
          } else {
              // bigbed, zoom data is not currently used in igv for bed type features
              treeOffset = this.header.fullIndexOffset;
              decodeFunction = getBedDataDecoder.call(this);
          }


          // Load the R Tree and fine leaf items
          const rpTree = await this.loadRPTree(treeOffset);
          const leafItems = await rpTree.findLeafItemsOverlapping(chrIdx1, bpStart, chrIdx2, bpEnd);
          if (!leafItems || leafItems.length === 0) {
              return []
          } else {

              // Consolidate leaf items and get all data at once
              let start = Number.MAX_VALUE;
              let end = 0;
              for (let item of leafItems) {
                  start = Math.min(start, item.dataOffset);
                  end = Math.max(end, item.dataOffset + item.dataSize);
              }
              const size = end - start;
              const arrayBuffer = await this.loader.loadArrayBuffer(this.config.url, buildOptions(this.config, {
                  range: {
                      start: start,
                      size: size
                  }
              }));

              // Parse data and return features
              const allFeatures = [];
              for (let item of leafItems) {
                  const uint8Array = new Uint8Array(arrayBuffer, item.dataOffset - start, item.dataSize);
                  let plain;
                  const isCompressed = this.header.uncompressBuffSize > 0;
                  if (isCompressed) {
                      plain = inflate_1$3(uint8Array);
                  } else {
                      plain = uint8Array;
                  }
                  decodeFunction.call(this, new DataView(plain.buffer), chrIdx1, bpStart, chrIdx2, bpEnd, allFeatures, this.chromTree.idToChrom, windowFunction);
              }

              allFeatures.sort(function (a, b) {
                  return a.start - b.start
              });

              return allFeatures
          }
      }

      async getZoomHeaders() {
          if (this.zoomLevelHeaders) {
              return this.zoomLevelHeaders
          } else {
              await this.loadHeader();
              return this.zoomLevelHeaders
          }
      }

      async loadHeader() {

          if (this.header) {
              return this.header
          } else {
              let data = await this.loader.loadArrayBuffer(this.path, buildOptions(this.config, {
                  range: {
                      start: 0,
                      size: BBFILE_HEADER_SIZE
                  }
              }));

              let header;

              // Assume low-to-high unless proven otherwise
              this.littleEndian = true;

              let binaryParser = new BinaryParser(new DataView(data));
              let magic = binaryParser.getUInt();
              if (magic === BIGWIG_MAGIC_LTH) {
                  this.type = "bigwig";
              } else if (magic === BIGBED_MAGIC_LTH) {
                  this.type = "bigbed";
              } else {
                  //Try big endian order
                  this.littleEndian = false;

                  binaryParser.littleEndian = false;
                  binaryParser.position = 0;
                  let magic = binaryParser.getUInt();

                  if (magic === BIGWIG_MAGIC_HTL) {
                      this.type = "bigwig";
                  } else if (magic === BIGBED_MAGIC_HTL) {
                      this.type = "bigbed";
                  } else ;
              }
              // Table 5  "Common header for bigwig and bigbed files"
              header = {
                  bwVersion: binaryParser.getUShort(),
                  nZoomLevels: binaryParser.getUShort(),
                  chromTreeOffset: binaryParser.getLong(),
                  fullDataOffset: binaryParser.getLong(),
                  fullIndexOffset: binaryParser.getLong(),
                  fieldCount: binaryParser.getUShort(),
                  definedFieldCount: binaryParser.getUShort(),
                  autoSqlOffset: binaryParser.getLong(),
                  totalSummaryOffset: binaryParser.getLong(),
                  uncompressBuffSize: binaryParser.getInt(),
                  extensionOffset: binaryParser.getLong()
              };

              ///////////

              const startOffset = BBFILE_HEADER_SIZE;
              let range = {start: startOffset, size: (header.fullDataOffset - startOffset + 5)};
              data = await this.loader.loadArrayBuffer(this.path, buildOptions(this.config, {range: range}));

              const nZooms = header.nZoomLevels;
              binaryParser = new BinaryParser(new DataView(data));

              this.zoomLevelHeaders = [];
              this.firstZoomDataOffset = Number.MAX_SAFE_INTEGER;
              for (let i = 1; i <= nZooms; i++) {
                  const zoomNumber = nZooms - i;
                  const zlh = new ZoomLevelHeader(zoomNumber, binaryParser);
                  this.firstZoomDataOffset = Math.min(zlh.dataOffset, this.firstZoomDataOffset);
                  this.zoomLevelHeaders[zoomNumber] = zlh;
              }

              // Autosql
              if (header.autoSqlOffset > 0) {
                  binaryParser.position = header.autoSqlOffset - startOffset;
                  const autoSqlString = binaryParser.getString();
                  if (autoSqlString) {
                      this.autoSql = parseAutoSQL(autoSqlString);
                  }
              }

              // Total summary
              if (header.totalSummaryOffset > 0) {
                  binaryParser.position = header.totalSummaryOffset - startOffset;
                  this.totalSummary = new BWTotalSummary(binaryParser);
              }

              // Chrom data index
              if (header.chromTreeOffset > 0) {
                  binaryParser.position = header.chromTreeOffset - startOffset;
                  this.chromTree = new BPTree(binaryParser, startOffset, this.genome);
              } else {
                  // TODO -- this is an error, not expected
                  throw "BigWig chromosome tree offset <= 0"
              }

              //Finally total data count
              binaryParser.position = header.fullDataOffset - startOffset;
              header.dataCount = binaryParser.getInt();
              ///////////

              this.setDefaultVisibilityWindow(header);

              this.header = header;
              return this.header

          }
      }

      async loadRPTree(offset) {

          let rpTree = this.rpTreeCache[offset];
          if (rpTree) {
              return rpTree
          } else {
              rpTree = new RPTree(offset, this.config, this.littleEndian, this.loader);
              await rpTree.load();
              this.rpTreeCache[offset] = rpTree;
              return rpTree
          }
      }

      async getType() {
          await this.loadHeader();
          return this.type
      }

      async getTrackType() {
          await this.loadHeader();
          if (this.type === "bigwig") {
              return "wig"
          } else {
              return this.autoSql && this.autoSql.table === "chromatinInteract" ? "interact" : "annotation"
          }
      }

      setDefaultVisibilityWindow(header) {
          if (this.type === "bigwig") {
              this.visibilityWindow = -1;
          } else {
              // bigbed
              let genomeSize = this.genome ? this.genome.getGenomeLength() : 3088286401;
              // Estimate window size to return ~ 1,000 features, assuming even distribution across the genome
              this.visibilityWindow = header.dataCount < 1000 ? -1 : 1000 * (genomeSize / header.dataCount);

          }
      }
  }


  class ZoomLevelHeader {
      constructor(index, byteBuffer) {
          this.index = index;
          this.reductionLevel = byteBuffer.getInt();
          this.reserved = byteBuffer.getInt();
          this.dataOffset = byteBuffer.getLong();
          this.indexOffset = byteBuffer.getLong();
      }
  }

  class RPTree {

      constructor(fileOffset, config, littleEndian, loader) {

          this.config = config;
          this.loader = loader;
          this.fileOffset = fileOffset; // File offset to beginning of tree
          this.path = config.url;
          this.littleEndian = littleEndian;
      }

      async load() {
          const rootNodeOffset = this.fileOffset + RPTREE_HEADER_SIZE;
          const bufferedReader = isDataURL(this.path) ?
              this.loader :
              new BufferedReader(this.config, BUFFER_SIZE);
          this.rootNode = await this.readNode(rootNodeOffset, bufferedReader);
          return this
      }

      async readNode(filePosition, bufferedReader) {

          let dataView = await bufferedReader.dataViewForRange({start: filePosition, size: 4}, false);
          let binaryParser = new BinaryParser(dataView, this.littleEndian);
          const type = binaryParser.getByte();
          const isLeaf = (type === 1);
          binaryParser.getByte();
          const count = binaryParser.getUShort();
          filePosition += 4;

          let bytesRequired = count * (isLeaf ? RPTREE_NODE_LEAF_ITEM_SIZE : RPTREE_NODE_CHILD_ITEM_SIZE);
          let range2 = {start: filePosition, size: bytesRequired};
          dataView = await bufferedReader.dataViewForRange(range2, false);
          const items = new Array(count);
          binaryParser = new BinaryParser(dataView);

          if (isLeaf) {
              for (let i = 0; i < count; i++) {
                  let item = {
                      isLeaf: true,
                      startChrom: binaryParser.getInt(),
                      startBase: binaryParser.getInt(),
                      endChrom: binaryParser.getInt(),
                      endBase: binaryParser.getInt(),
                      dataOffset: binaryParser.getLong(),
                      dataSize: binaryParser.getLong()
                  };
                  items[i] = item;

              }
              return new RPTreeNode(items)
          } else { // non-leaf
              for (let i = 0; i < count; i++) {

                  let item = {
                      isLeaf: false,
                      startChrom: binaryParser.getInt(),
                      startBase: binaryParser.getInt(),
                      endChrom: binaryParser.getInt(),
                      endBase: binaryParser.getInt(),
                      childOffset: binaryParser.getLong()
                  };
                  items[i] = item;
              }

              return new RPTreeNode(items)
          }

      }

      async findLeafItemsOverlapping(chrIdx1, startBase, chrIdx2, endBase) {

          let self = this;

          return new Promise(function (fulfill, reject) {

              let leafItems = [],
                  processing = new Set(),
                  bufferedReader = isDataURL(self.path) ?
                      self.loader :
                      new BufferedReader(self.config, BUFFER_SIZE);

              processing.add(0);  // Zero represents the root node
              findLeafItems(self.rootNode, 0);

              function findLeafItems(node, nodeId) {

                  if (overlaps(node, chrIdx1, startBase, chrIdx2, endBase)) {

                      let items = node.items;

                      items.forEach(function (item) {

                          if (overlaps(item, chrIdx1, startBase, chrIdx2, endBase)) {

                              if (item.isLeaf) {
                                  leafItems.push(item);
                              } else {
                                  if (item.childNode) {
                                      findLeafItems(item.childNode);
                                  } else {
                                      processing.add(item.childOffset);  // Represent node to-be-loaded by its file position

                                      self.readNode(item.childOffset, bufferedReader)
                                          .then(function (node) {
                                              item.childNode = node;
                                              findLeafItems(node, item.childOffset);
                                          })
                                          .catch(reject);
                                  }
                              }
                          }
                      });

                  }

                  if (nodeId !== undefined) processing.delete(nodeId);

                  // Wait until all nodes are processed
                  if (processing.size === 0) {
                      fulfill(leafItems);
                  }
              }
          })
      }
  }

  class RPTreeNode {

      constructor(items) {

          this.items = items;

          let minChromId = Number.MAX_SAFE_INTEGER,
              maxChromId = 0,
              minStartBase = Number.MAX_SAFE_INTEGER,
              maxEndBase = 0,
              i,
              item;

          for (i = 0; i < items.length; i++) {
              item = items[i];
              minChromId = Math.min(minChromId, item.startChrom);
              maxChromId = Math.max(maxChromId, item.endChrom);
              minStartBase = Math.min(minStartBase, item.startBase);
              maxEndBase = Math.max(maxEndBase, item.endBase);
          }

          this.startChrom = minChromId;
          this.endChrom = maxChromId;
          this.startBase = minStartBase;
          this.endBase = maxEndBase;
      }
  }

  class BPTree {

      constructor(binaryParser, startOffset, genome) {

          let magic = binaryParser.getInt();
          let blockSize = binaryParser.getInt();
          let keySize = binaryParser.getInt();
          let valSize = binaryParser.getInt();
          let itemCount = binaryParser.getLong();
          let reserved = binaryParser.getLong();
          let chromToId = {};
          let idToChrom = [];

          this.header = {
              magic: magic,
              blockSize: blockSize,
              keySize: keySize,
              valSize: valSize,
              itemCount: itemCount,
              reserved: reserved
          };
          this.chromToID = chromToId;
          this.idToChrom = idToChrom;

          // Recursively walk tree to populate dictionary
          readTreeNode(binaryParser, -1);


          function readTreeNode(byteBuffer, offset) {

              if (offset >= 0) byteBuffer.position = offset;

              let type = byteBuffer.getByte();
                  byteBuffer.getByte();
                  let count = byteBuffer.getUShort(),
                  i,
                  key,
                  chromId,
                  childOffset,
                  bufferOffset,
                  currOffset;


              if (type === 1) {

                  for (i = 0; i < count; i++) {

                      key = byteBuffer.getFixedLengthTrimmedString(keySize);
                      chromId = byteBuffer.getInt();
                      byteBuffer.getInt();

                      if (genome) key = genome.getChromosomeName(key);  // Translate to canonical chr name
                      chromToId[key] = chromId;
                      idToChrom[chromId] = key;

                  }
              } else { // non-leaf

                  for (i = 0; i < count; i++) {

                      key = byteBuffer.getFixedLengthTrimmedString(keySize);
                      childOffset = byteBuffer.getLong();
                      bufferOffset = childOffset - startOffset;
                      currOffset = byteBuffer.position;
                      readTreeNode(byteBuffer, bufferOffset);
                      byteBuffer.position = currOffset;
                  }
              }

          }
      }
  }

  /**
   * Return true if {chrIdx1:startBase-chrIdx2:endBase} overlaps item's interval
   * @returns {boolean}
   */
  function overlaps(item, chrIdx1, startBase, chrIdx2, endBase) {

      if (!item) {
          return false
      }

      return ((chrIdx2 > item.startChrom) || (chrIdx2 === item.startChrom && endBase >= item.startBase)) &&
          ((chrIdx1 < item.endChrom) || (chrIdx1 === item.endChrom && startBase <= item.endBase))


  }

  class BWTotalSummary {

      constructor(byteBuffer) {
          if (byteBuffer) {
              this.basesCovered = byteBuffer.getLong();
              this.minVal = byteBuffer.getDouble();
              this.maxVal = byteBuffer.getDouble();
              this.sumData = byteBuffer.getDouble();
              this.sumSquares = byteBuffer.getDouble();
              computeStats.call(this);
          } else {
              this.basesCovered = 0;
              this.minVal = 0;
              this.maxVal = 0;
              this.sumData = 0;
              this.sumSquares = 0;
              this.mean = 0;
              this.stddev = 0;
          }
      }
  }

  function computeStats() {
      let n = this.basesCovered;
      if (n > 0) {
          this.mean = this.sumData / n;
          this.stddev = Math.sqrt(this.sumSquares / (n - 1));

          let min = this.minVal < 0 ? this.mean - 2 * this.stddev : 0,
              max = this.maxVal > 0 ? this.mean + 2 * this.stddev : 0;

          this.defaultRange = {
              min: min,
              max: max
          };
      }
  }

  function zoomLevelForScale$1(bpPerPixel, zoomLevelHeaders) {
      let level;
      for (let i = 0; i < zoomLevelHeaders.length; i++) {
          const zl = zoomLevelHeaders[i];
          if (zl.reductionLevel < bpPerPixel) {
              level = zl;
              break
          }
      }
      return level
  }


  function decodeWigData(data, chrIdx1, bpStart, chrIdx2, bpEnd, featureArray, chrDict) {

      const binaryParser = new BinaryParser(data);
      const chromId = binaryParser.getInt();
      let chromStart = binaryParser.getInt();
      let chromEnd = binaryParser.getInt();
      const itemStep = binaryParser.getInt();
      const itemSpan = binaryParser.getInt();
      const type = binaryParser.getByte();
      binaryParser.getByte();
      let itemCount = binaryParser.getUShort();

      if (chromId >= chrIdx1 && chromId <= chrIdx2) {

          while (itemCount-- > 0) {
              let value;
              switch (type) {
                  case 1:
                      chromStart = binaryParser.getInt();
                      chromEnd = binaryParser.getInt();
                      value = binaryParser.getFloat();
                      break
                  case 2:
                      chromStart = binaryParser.getInt();
                      value = binaryParser.getFloat();
                      chromEnd = chromStart + itemSpan;
                      break
                  case 3:  // Fixed step
                      value = binaryParser.getFloat();
                      chromEnd = chromStart + itemSpan;
                      chromStart += itemStep;
                      break
              }

              if (chromId < chrIdx1 || (chromId === chrIdx1 && chromEnd < bpStart)) continue
              else if (chromId > chrIdx2 || (chromId === chrIdx2 && chromStart >= bpEnd)) break

              if (Number.isFinite(value)) {
                  const chr = chrDict[chromId];
                  featureArray.push({chr: chr, start: chromStart, end: chromEnd, value: value});

              }
          }
      }
  }

  function getBedDataDecoder() {

      const minSize = 3 * 4 + 1;   // Minimum # of bytes required for a bed record
      const decoder = getDecoder(this.header.definedFieldCount, this.header.fieldCount, this.autoSql, this.format);
      return function (data, chrIdx1, bpStart, chrIdx2, bpEnd, featureArray, chrDict) {
          const binaryParser = new BinaryParser(data);
          while (binaryParser.remLength() >= minSize) {

              const chromId = binaryParser.getInt();
              const chr = chrDict[chromId];
              const chromStart = binaryParser.getInt();
              const chromEnd = binaryParser.getInt();
              const rest = binaryParser.getString();
              if (chromId < chrIdx1 || (chromId === chrIdx1 && chromEnd < bpStart)) continue
              else if (chromId > chrIdx2 || (chromId === chrIdx2 && chromStart >= bpEnd)) break

              if (chromEnd > 0) {
                  const feature = {chr: chr, start: chromStart, end: chromEnd};
                  featureArray.push(feature);
                  const tokens = rest.split("\t");
                  decoder(feature, tokens);
              }
          }
      }
  }


  function decodeZoomData(data, chrIdx1, bpStart, chrIdx2, bpEnd, featureArray, chrDict, windowFunction) {

      const binaryParser = new BinaryParser(data);
      const minSize = 8 * 4;  // Minimum # of bytes required for a zoom record


      while (binaryParser.remLength() >= minSize) {
          const chromId = binaryParser.getInt();
          const chr = chrDict[chromId];
          const chromStart = binaryParser.getInt();
          const chromEnd = binaryParser.getInt();
          const validCount = binaryParser.getInt();
          const minVal = binaryParser.getFloat();
          const maxVal = binaryParser.getFloat();
          const sumData = binaryParser.getFloat();
          binaryParser.getFloat();
          let value;
          switch (windowFunction) {
              case "min":
                  value = minVal;
                  break
              case "max":
                  value = maxVal;
                  break
              default:
                  value = validCount === 0 ? 0 : sumData / validCount;
          }

          if (chromId < chrIdx1 || (chromId === chrIdx1 && chromEnd < bpStart)) continue
          else if (chromId > chrIdx2 || (chromId === chrIdx2 && chromStart >= bpEnd)) break


          if (Number.isFinite(value)) {
              featureArray.push({chr: chr, start: chromStart, end: chromEnd, value: value});


          }
      }
  }

  class DataBuffer {

      constructor(dataURI) {
          this.data = decodeDataURI$1(dataURI).buffer;
      }

      /**
       * igvxhr interface
       * @param ignore
       * @param options
       * @returns {any}
       */
      loadArrayBuffer(ignore, options) {
          const range = options.range;
          return range ? this.data.slice(range.start, range.start + range.size) : this.data
      }

      /**
       * BufferedReader interface
       *
       * @param requestedRange - byte rangeas {start, size}
       * @param fulfill - function to receive result
       * @param asUint8 - optional flag to return result as an UInt8Array
       */
      async dataViewForRange(requestedRange, asUint8) {
          const len = Math.min(this.data.byteLength - requestedRange.start, requestedRange.size);
          return asUint8 ?
              new Uint8Array(this.data, requestedRange.start, len) :
              new DataView(this.data, requestedRange.start, len)
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class BWSource {

      constructor(config, genome) {
          this.reader = new BWReader(config, genome);
          this.genome = genome;
          this.format = config.format || "bigwig";
          this.wgValues = {};
      }

      async getFeatures({chr, start, end, bpPerPixel, windowFunction}) {

          const isBigWig = this.reader.type === "bigwig";

          const features = (chr.toLowerCase() === "all") ?
              (isBigWig ? await this.getWGValues(windowFunction) : []) :
              await this.reader.readFeatures(chr, start, chr, end, bpPerPixel, windowFunction);

          if (!isBigWig) {
              pack(features);
          }
          return features
      }

      async getHeader() {
          return this.reader.loadHeader()
      }

      getDefaultRange() {
          if (this.reader.totalSummary !== undefined) {
              return this.reader.totalSummary.defaultRange
          } else {
              return undefined
          }
      }

      async defaultVisibilityWindow() {
          return this.reader.defaultVisibilityWindow
      }

      async getWGValues(windowFunction) {

          const nominalScreenWidth = 1000;      // This doesn't need to be precise
          const genome = this.genome;

          if (this.wgValues[windowFunction]) {
              return this.wgValues[windowFunction]
          } else {

              const bpPerPixel = genome.getGenomeLength() / nominalScreenWidth;
              const features = await this.reader.readWGFeatures(bpPerPixel, windowFunction);
              let wgValues = [];
              for (let f of features) {
                  const chr = f.chr;
                  const offset = genome.getCumulativeOffset(chr);
                  const wgFeature = Object.assign({}, f);
                  wgFeature.chr = "all";
                  wgFeature.start = offset + f.start;
                  wgFeature.end = offset + f.end;
                  wgValues.push(wgFeature);
              }
              this.wgValues[windowFunction] = wgValues;
              return wgValues
          }
      }

      supportsWholeGenome() {
          return this.reader.type === "bigwig"
      }

      async trackType() {
          return this.reader.getTrackType()
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const GZIP_FLAG = 0x1;

  class TDFReader {

      constructor(config, genome) {
          this.config = config;
          this.genome = genome;
          this.path = config.url;
          this.groupCache = {};
          this.datasetCache = {};
      }


      async readHeader() {

          if (this.magic !== undefined) {
              return this   // Already read
          }

          let data = await igvxhr$1.loadArrayBuffer(this.path, buildOptions(this.config, {range: {start: 0, size: 64000}}));
          let binaryParser = new BinaryParser(new DataView(data));
          this.magic = binaryParser.getInt();
          this.version = binaryParser.getInt();
          this.indexPos = binaryParser.getLong();
          this.indexSize = binaryParser.getInt();
          binaryParser.getInt();


          if (this.version >= 2) {
              let nWindowFunctions = binaryParser.getInt();
              this.windowFunctions = [];
              while (nWindowFunctions-- > 0) {
                  this.windowFunctions.push(binaryParser.getString());
              }
          }

          this.trackType = binaryParser.getString();
          this.trackLine = binaryParser.getString();

          let nTracks = binaryParser.getInt();
          this.trackNames = [];
          while (nTracks-- > 0) {
              this.trackNames.push(binaryParser.getString());
          }
          this.genomeID = binaryParser.getString();
          this.flags = binaryParser.getInt();
          this.compressed = (this.flags & GZIP_FLAG) !== 0;

          // Now read index
          data = await igvxhr$1.loadArrayBuffer(this.path, buildOptions(this.config, {
              range: {
                  start: this.indexPos,
                  size: this.indexSize
              }
          }));
          binaryParser = new BinaryParser(new DataView(data));
          this.datasetIndex = {};
          let nEntries = binaryParser.getInt();
          while (nEntries-- > 0) {
              const name = binaryParser.getString();
              const pos = binaryParser.getLong();
              const size = binaryParser.getInt();
              this.datasetIndex[name] = {position: pos, size: size};
          }

          this.groupIndex = {};
          nEntries = binaryParser.getInt();
          while (nEntries-- > 0) {
              const name = binaryParser.getString();
              const pos = binaryParser.getLong();
              const size = binaryParser.getInt();
              this.groupIndex[name] = {position: pos, size: size};
          }

          return this
      }

      async readDataset(chr, windowFunction, zoom) {

          const key = chr + "_" + windowFunction + "_" + zoom;

          if (this.datasetCache[key]) {
              return this.datasetCache[key]

          } else {
              await this.readHeader();
              const wf = (this.version < 2) ? "" : "/" + windowFunction;
              const zoomString = (chr.toLowerCase() === "all" || zoom === undefined) ? "0" : zoom.toString();

              let dsName;
              if (windowFunction === "raw") {
                  dsName = "/" + chr + "/raw";
              } else {
                  dsName = "/" + chr + "/z" + zoomString + wf;
              }
              const indexEntry = this.datasetIndex[dsName];

              if (indexEntry === undefined) {
                  return undefined
              }

              const data = await igvxhr$1.loadArrayBuffer(this.path, buildOptions(this.config, {
                  range: {
                      start: indexEntry.position,
                      size: indexEntry.size
                  }
              }));

              if (!data) {
                  return undefined
              }

              const binaryParser = new BinaryParser(new DataView(data));
              let nAttributes = binaryParser.getInt();
              const attributes = {};
              while (nAttributes-- > 0) {
                  attributes[binaryParser.getString()] = binaryParser.getString();
              }
              const dataType = binaryParser.getString();
              const tileWidth = binaryParser.getFloat();
              let nTiles = binaryParser.getInt();
              const tiles = [];
              while (nTiles-- > 0) {
                  tiles.push({position: binaryParser.getLong(), size: binaryParser.getInt()});
              }

              const dataset = {
                  name: dsName,
                  attributes: attributes,
                  dataType: dataType,
                  tileWidth: tileWidth,
                  tiles: tiles
              };

              this.datasetCache[key] = dataset;
              return dataset
          }
      }

      async readRootGroup() {

          const genome = this.genome;
          const rootGroup = this.groupCache["/"];
          if (rootGroup) {
              return rootGroup
          } else {

              const group = await this.readGroup("/");
              const names = group["chromosomes"];
              const maxZoomString = group["maxZoom"];

              // Now parse out interesting attributes.
              if (maxZoomString) {
                  this.maxZoom = Number(maxZoomString);
              }

              const totalCountString = group["totalCount"];
              if (totalCountString) {
                  group.totalCount = Number(totalCountString);
              }

              // Chromosome names
              const chrAliasTable = {};
              if (names) {
                  names.split(",").forEach(function (chr) {
                      const canonicalName = genome.getChromosomeName(chr);
                      chrAliasTable[canonicalName] = chr;
                  });
              }
              this.chrAliasTable = chrAliasTable;

              this.groupCache["/"] = group;
              return group
          }
      }

      async readGroup(name) {

          const group = this.groupCache[name];
          if (group) {
              return group
          } else {

              await this.readHeader();
              const indexEntry = this.groupIndex[name];
              if (indexEntry === undefined) {
                  return undefined
              }

              const data = await igvxhr$1.loadArrayBuffer(this.path, buildOptions(this.config, {
                  range: {
                      start: indexEntry.position,
                      size: indexEntry.size
                  }
              }));

              if (!data) {
                  return undefined
              }

              const binaryParser = new BinaryParser(new DataView(data));
              const group = {name: name};
              let nAttributes = binaryParser.getInt();
              while (nAttributes-- > 0) {
                  const key = binaryParser.getString();
                  const value = binaryParser.getString();
                  group[key] = value;
              }
              this.groupCache[name] = group;
              return group
          }
      }


      async readTiles(tileIndeces, nTracks) {

          tileIndeces.sort(function (a, b) {
              return a.position - b.position
          });

          tileIndeces = tileIndeces.filter(function (idx) {
              return idx.size > 0
          });

          if (tileIndeces.length === 0) {
              return Promise.resolve([])
          }

          const firstEntry = tileIndeces[0];
          const lastEntry = tileIndeces[tileIndeces.length - 1];
          const position = firstEntry.position;
          const size = (lastEntry.position + lastEntry.size) - position;
          const data = await igvxhr$1.loadArrayBuffer(this.path, buildOptions(this.config, {
              range: {
                  start: position,
                  size: size
              }
          }));

          const tiles = [];

          // Loop through and decode tiles
          for (let indexEntry of tileIndeces) {
              const start = indexEntry.position - position;
              const size = indexEntry.size;
              if (size > 0) {
                  let tileData;
                  if (this.compressed) {
                      const plain = inflate_1$3(data.slice(start, start + size));
                      tileData = plain.buffer;
                  } else {
                      tileData = data.slice(start, start + size);
                  }

                  const binaryParser = new BinaryParser(new DataView(tileData));
                  const type = binaryParser.getString();
                  let tile;
                  switch (type) {
                      case "fixedStep":
                          tile = createFixedStep(binaryParser, nTracks);
                          break
                      case "variableStep":
                          tile = createVariableStep(binaryParser, nTracks);
                          break
                      case "bed":
                      case "bedWithName":
                          tile = createBed(binaryParser, nTracks, type);
                          break
                      default:
                          throw "Unknown tile type: " + type
                  }
                  tiles.push(tile);
              }
          }
          return tiles
      }

      async readTile(indexEntry, nTracks) {

          let data = await igvxhr$1.loadArrayBuffer(this.path, buildOptions(this.config, {
              range: {
                  start: indexEntry.position,
                  size: indexEntry.size
              }
          }));

          if (this.compressed) {
              const plain = inflate_1$3(data);
              data = plain.buffer;
          }

          const binaryParser = new BinaryParser(new DataView(data));
          const type = binaryParser.getString();
          switch (type) {
              case "fixedStep":
                  return createFixedStep(binaryParser, nTracks)
              case "variableStep":
                  return createVariableStep(binaryParser, nTracks)
              case "bed":
              case "bedWithName":
                  return createBed(binaryParser, nTracks, type)
              default:
                  throw "Unknown tile type: " + type
          }
      }

  }

  function createFixedStep(binaryParser, nTracks) {
      const nPositions = binaryParser.getInt();
      const start = binaryParser.getInt();
      const span = binaryParser.getFloat();

      const data = [];
      let nt = nTracks;
      while (nt-- > 0) {
          let np = nPositions;
          const dtrack = [];
          while (np-- > 0) {
              dtrack.push(binaryParser.getFloat());
          }
          data.push(dtrack);
      }

      return {
          type: "fixedStep",
          start: start,
          span: span,
          data: data,
          nTracks: nTracks,
          nPositions: nPositions
      }
  }

  function createVariableStep(binaryParser, nTracks) {

      const tileStart = binaryParser.getInt();
      const span = binaryParser.getFloat();
      const nPositions = binaryParser.getInt();
      const start = [];

      let np = nPositions;
      while (np-- > 0) {
          start.push(binaryParser.getInt());
      }
      binaryParser.getInt();  // # of samples, ignored but should === nTracks

      const data = [];
      let nt = nTracks;
      while (nt-- > 0) {
          np = nPositions;
          const dtrack = [];
          while (np-- > 0) {
              dtrack.push(binaryParser.getFloat());
          }
          data.push(dtrack);
      }

      return {
          type: "variableStep",
          tileStart: tileStart,
          span: span,
          start: start,
          data: data,
          nTracks: nTracks,
          nPositions: nPositions
      }
  }

  function createBed(binaryParser, nTracks, type) {

      const nPositions = binaryParser.getInt();

      let n = nPositions;
      const start = [];
      while (n-- > 0) {
          start.push(binaryParser.getInt());
      }

      n = nPositions;
      const end = [];
      while (n-- > 0) {
          end.push(binaryParser.getInt());
      }

      binaryParser.getInt();  // # of samples, ignored but should === nTracks
      const data = [];
      let nt = nTracks;
      while (nt-- > 0) {
          let np = nPositions;
          const dtrack = [];
          while (np-- > 0) {
              dtrack.push(binaryParser.getFloat());
          }
          data.push(dtrack);
      }

      if (type === "bedWithName") {
          n = nPositions;
          const name = [];
          while (n-- > 0) {
              name.push(binaryParser.getString());
          }
      }

      return {
          type: type,
          start: start,
          end: end,
          data: data,
          nTracks: nTracks,
          nPositions: nPositions
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class TDFSource {

      constructor(config, genome) {
          this.genome = genome;
          this.windowFunction = config.windowFunction || "mean";
          this.reader = new TDFReader(config, genome);
      }

      async getFeatures({chr, start, end, bpPerPixel}) {

          if (chr.toLowerCase() === "all") {
              const wgFeatures = [];
              const genome = this.genome;
              const chrNames = this.genome.wgChromosomeNames;
              if (chrNames) {
                  for (let c of genome.wgChromosomeNames) {
                      const len = genome.getChromosome(c).bpLength;
                      bpPerPixel = len / 1000;
                      const chrFeatures = await this._getFeatures(c, 0, len, bpPerPixel);
                      if (chrFeatures) {
                          for (let f of chrFeatures) {
                              const wg = Object.assign({}, f);
                              wg.chr = "all";
                              wg.start = genome.getGenomeCoordinate(f.chr, f.start);
                              wg.end = genome.getGenomeCoordinate(f.chr, f.end);
                              wg._f = f;
                              wgFeatures.push(wg);
                          }
                      }
                  }
              }
              return wgFeatures

          } else {
              return this._getFeatures(chr, start, end, bpPerPixel)
          }
      }

      async _getFeatures(chr, start, end, bpPerPixel) {
          const genomicInterval = new GenomicInterval(chr, start, end);
          const genome = this.genome;


          if (!this.rootGroup) {
              this.rootGroup = await this.reader.readRootGroup();
              if (!this.normalizationFactor) {
                  const totalCount = this.rootGroup.totalCount;
                  if (totalCount) {
                      this.normalizationFactor = 1.0e6 / totalCount;
                  }
              }
          }

          genomicInterval.bpPerPixel = bpPerPixel;
          const zoom = zoomLevelForScale(chr, bpPerPixel, genome);
          let queryChr = this.reader.chrAliasTable[chr];
          let maxZoom = this.reader.maxZoom;
          if (queryChr === undefined) queryChr = chr;
          if (maxZoom === undefined) maxZoom = -1;

          const wf = zoom > maxZoom ? "raw" : this.windowFunction;
          const dataset = await this.reader.readDataset(queryChr, wf, zoom);
          if (dataset == null) {
              return []
          }

          const tileWidth = dataset.tileWidth;
          const startTile = Math.floor(start / tileWidth);
          const endTile = Math.floor(end / tileWidth);
          const NTRACKS = 1;   // TODO read this
          const tiles = await this.reader.readTiles(dataset.tiles.slice(startTile, endTile + 1), NTRACKS);
          const features = [];
          for (let tile of tiles) {
              switch (tile.type) {
                  case "bed":
                      decodeBedTile(tile, chr, start, end, bpPerPixel, features);
                      break
                  case "variableStep":
                      decodeVaryTile(tile, chr, start, end, bpPerPixel, features);
                      break
                  case "fixedStep":
                      decodeFixedTile(tile, chr, start, end, bpPerPixel, features);
                      break
                  default:
                      throw ("Unknown tile type: " + tile.type)
              }
          }
          features.sort(function (a, b) {
              return a.start - b.start
          });

          return features
      }

      get supportsWholeGenome() {
          return true
      }
  }

  function decodeBedTile(tile, chr, bpStart, bpEnd, bpPerPixel, features) {

      const nPositions = tile.nPositions;
      const starts = tile.start;
      const ends = tile.end;
      const data = tile.data[0];   // Single track for now
      for (let i = 0; i < nPositions; i++) {
          const s = starts[i];
          const e = ends[i];
          if (e < bpStart) continue
          if (s > bpEnd) break
          features.push({
              chr: chr,
              start: s,
              end: e,
              value: data[i]
          });
      }
  }

  function decodeVaryTile(tile, chr, bpStart, bpEnd, bpPerPixel, features) {

      const nPositions = tile.nPositions;
      const starts = tile.start;
      const span = tile.span;
      const data = tile.data[0];   // Single track for now
      for (let i = 0; i < nPositions; i++) {
          const s = starts[i];
          const e = s + span;
          if (e < bpStart) continue
          if (s > bpEnd) break
          features.push({
              chr: chr,
              start: s,
              end: e,
              value: data[i]
          });
      }
  }

  function decodeFixedTile(tile, chr, bpStart, bpEnd, bpPerPixel, features) {

      const nPositions = tile.nPositions;
      let s = tile.start;
      const span = tile.span;
      const data = tile.data[0];   // Single track for now

      for (let i = 0; i < nPositions; i++) {
          const e = s + span;
          if (s > bpEnd) break
          if (e >= bpStart) {
              if (!Number.isNaN(data[i])) {
                  features.push({
                      chr: chr,
                      start: s,
                      end: e,
                      value: data[i]
                  });
              }
          }
          s = e;
      }
  }


  var log2 = Math.log(2);

  function zoomLevelForScale(chr, bpPerPixel, genome) {

      // Convert bpPerPixel to IGV "zoom" level.   This is a bit convoluted,  IGV computes zoom levels assuming
      // display in a 700 pixel window.  The fully zoomed out view of a chromosome is zoom level "0".
      // Zoom level 1 is magnified 2X,  and so forth

      var chrSize = genome.getChromosome(chr).bpLength;

      return Math.ceil(Math.log(Math.max(0, (chrSize / (bpPerPixel * 700)))) / log2)
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014-2015 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * feature source for features supplied directly, as opposed to reading and parsing from a file or webservice
   *
   * @param config
   * @constructor
   */
  class StaticFeatureSource {

      constructor(config, genome) {

          this.config = config;
          this.genome = genome;
          this.queryable = false;
          this.updateFeatures(config.features);

      }

      updateFeatures(features) {
          features = fixFeatures(features, this.genome);
          packFeatures(features);
          if (this.config.mappings) {
              mapProperties(features, this.config.mappings);
          }
          this.featureCache = new FeatureCache$1(features, this.genome);
      }

      /**
       * Required function for all data source objects.  Fetches features for the
       * range requested.
       *
       * This function is complex due to the variety of reader types backing it, some indexed, some queryable,
       * some not.
       *
       * @param chr
       * @param start
       * @param end
       * @param bpPerPixel
       */
      async getFeatures({chr, start, end, bpPerPixel, visibilityWindow}) {

          const genome = this.genome;
          const queryChr = genome ? genome.getChromosomeName(chr) : chr;
          const isWholeGenome = ("all" === queryChr.toLowerCase());

          // Various conditions that can require a feature load
          //   * view is "whole genome" but no features are loaded
          //   * cache is disabled
          //   * cache does not contain requested range
          if (isWholeGenome) {
              return computeWGFeatures(this.featureCache.getAllFeatures(), this.genome, this.maxWGCount)
          } else {
              return this.featureCache.queryFeatures(queryChr, start, end)
          }
      }

      //
      // supportsWholeGenome() {
      //    return true
      // }

      getAllFeatures() {
          return this.featureCache.getAllFeatures()
      }

      supportsWholeGenome() {
          return true
      }


  }


  /**
   * This function is used to apply properties normally added during parsing to  features supplied directly in the
   * config as an array of objects.   At the moment the only application is bedpe type features.
   * @param features
   */
  function fixFeatures(features, genome) {

      if (genome) {
          for (let feature of features) {
              feature.chr = genome.getChromosomeName(feature.chr);
          }
      }

      return features
  }



  function mapProperties(features, mappings) {
      let mappingKeys = Object.keys(mappings);
      features.forEach(function (f) {
          mappingKeys.forEach(function (key) {
              f[key] = f[mappings[key]];
          });
      });
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014-2015 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const bbFormats = new Set(['bigwig', 'bw', 'bigbed', 'bb', 'biginteract', 'biggenepred', 'bignarrowpeak']);

  function FeatureSource(config, genome) {

      const format = config.format ? config.format.toLowerCase() : undefined;

      if (config.features) {
          return new StaticFeatureSource(config, genome)
      } else if (bbFormats.has(format)) {
          return new BWSource(config, genome)
      } else if ("tdf" === format) {
          return new TDFSource(config, genome)
      } else {
          return new TextFeatureSource(config, genome)
      }
  }

  const appleCrayonColorName = 'nickel';

  const ROI_DEFAULT_ALPHA = 2 / 16;

  const ROI_DEFAULT_COLOR = appleCrayonRGBA(appleCrayonColorName, ROI_DEFAULT_ALPHA);
  const ROI_DEFAULT_HEADER_COLOR = 'rgb(190,190,190)';

  const ROI_USER_HEADER_DEFINED_COLOR = 'rgba(155,185,129)';
  const ROI_USER_DEFINED_COLOR = ROI_DEFAULT_COLOR;

  class ROISet {

      constructor(config, genome) {

          this.url = config.url;

          if (config.name) {
              this.name = config.name;
          } else if (config.url && isFile$2(config.url)) {
              this.name = config.url.name;
          } else if (config.url && isString$2(config.url) && !config.url.startsWith("data:")) {
              this.name = getFilename$2(config.url);
          }

          this.isUserDefined = config.isUserDefined;

          if (config.features) {
              this.featureSource = new DynamicFeatureSource(config.features, genome);
          } else {
              if (config.format) {
                  config.format = config.format.toLowerCase();
              } else {
                  const filename = getFilename$2(config.url);
                  config.format = inferFileFormat(filename);
              }
              this.featureSource = config.featureSource || FeatureSource(config, genome);
          }

          if (true === this.isUserDefined) {
              this.color = config.color || ROI_USER_DEFINED_COLOR;
              this.headerColor = ROI_USER_HEADER_DEFINED_COLOR;

          } else {

              this.color = config.color || ROI_DEFAULT_COLOR;
              this.headerColor = ROI_DEFAULT_HEADER_COLOR;

              // Use body color with alpha pinned to 1
              // const [ r, g, b, discard ] = rgbaStringTokens(this.color)
              // this.headerColor = `rgba(${ r },${ g },${ b },${ 1.0 })`

          }
      }

      async getFeatures(chr, start, end) {
          return this.featureSource.getFeatures({chr, start, end})
      }

      async getAllFeatures() {
          return typeof this.featureSource.getAllFeatures === 'function' ? await this.featureSource.getAllFeatures() : {}
      }

      addFeature(feature) {
          if (this.isUserDefined) {
              this.featureSource.addFeature(feature);
          } else {
              console.error("Attempt to add ROI to non user-defined set");
          }
      }

      removeFeature(feature) {
          if (this.isUserDefined) {
              this.featureSource.removeFeature(feature);
          } else {
              console.error("Attempt to remove ROI from non user-defined set");
          }
      }

      toJSON() {
          if (this.url) {
              return {name: this.name, color: this.color, url: this.url, isUserDefined: this.isUserDefined}
          } else {
              const featureMap = this.featureSource.getAllFeatures();
              const features = [];
              for (let chr of Object.keys(featureMap)) {
                  for (let f of featureMap[chr]) {
                      features.push(f);
                  }
              }
              return {name: this.name, color: this.color, features: features, isUserDefined: this.isUserDefined}
          }
      }

      dispose() {
          for (let key of Object.keys(this)) {
              this[key] = undefined;
          }
      }

  }

  const SCREEN_COORDS_WIDTH_THRESHOLD = 3;

  function screenCoordinates(regionStartBP, regionEndBP, bpStart, bpp) {

      let xStart = Math.round((regionStartBP - bpStart) / bpp);
      const xEnd = Math.round((regionEndBP - bpStart) / bpp);

      let width = xEnd - xStart;

      if (width < SCREEN_COORDS_WIDTH_THRESHOLD) {
          width = SCREEN_COORDS_WIDTH_THRESHOLD;
          xStart -= 1;
      }

      return {x: xStart, width}
  }


  /**
   * Special feature source that allows addition of features dynamically
   */
  class DynamicFeatureSource {

      constructor(features, genome) {
          this.featureMap = {};
          this.genome = genome;

          for (let feature of features) {

              // Store as canonical chr name (i.e. translate aliases)
              const chrKey = genome ? genome.getChromosomeName(feature.chr) : feature.chr;

              let featureList = this.featureMap[chrKey];
              if (!featureList) {
                  featureList = [];
                  this.featureMap[chrKey] = featureList;
              }
              featureList.push(feature);
          }

          for (let key of Object.keys(this.featureMap)) {
              this.featureMap[key].sort((a, b) => a.start - b.start);
          }
      }

      getFeatures({chr, start, end}) {
          if (chr.toLowerCase() === 'all') {
              return computeWGFeatures(this.featureMap, this.genome)
          } else {
              // TODO -- this use of filter is O(N), and might not scale well for large feature lists.
              const featureList = this.featureMap[chr];
              return featureList ? featureList.filter(feature => feature.end > start && feature.start < end) : []
          }
      }

      getAllFeatures() {
          return this.featureMap
      }

      supportsWholeGenome() {
          return true
      }

      addFeature(feature) {
          let featureList = this.featureMap[feature.chr];
          if (!featureList) {
              featureList = [];
              this.featureMap[feature.chr] = featureList;
          }
          featureList.push(feature);
          featureList.sort((a, b) => a.start - b.start);
      }

      removeFeature({chr, start, end}) {

          if (this.featureMap[chr]) {
              const match = `${chr}-${start}-${end}`;
              this.featureMap[chr] = this.featureMap[chr].filter(feature => match !== `${feature.chr}-${feature.start}-${feature.end}`);
          }
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const RULER_SWEEPER_COLOR = 'rgba(68, 134, 247, 0.25)';

  class RulerSweeper {

      constructor(rulerViewport, column, browser, referenceFrame) {

          this.rulerViewport = rulerViewport;

          this.rulerSweeper = domUtils.div({class: 'igv-ruler-sweeper'});
          column.appendChild(this.rulerSweeper);

          this.browser = browser;
          this.referenceFrame = referenceFrame;

          this.isMouseHandlers = undefined;

          this.addBrowserObserver();
      }

      addBrowserObserver() {

          const observerHandler = () => {
              if (this.referenceFrame) {
                  GenomeUtils.isWholeGenomeView(this.referenceFrame.chr) ? this.removeMouseHandlers() : this.addMouseHandlers();
              }
          };

          // Viewport Content
          this.boundObserverHandler = observerHandler.bind(this);
          this.browser.on('locuschange', this.boundObserverHandler);

      }

      removeBrowserObserver() {
          this.browser.off('locuschange', this.boundObserverHandler);
      }

      addMouseHandlers() {

          if (true === this.isMouseHandlers) {
              return
          }

          const threshold = 1;

          let isMouseDown;
          let isMouseIn;
          let mouseDownX;
          let left;
          let width;
          let dx;

          // Viewport Content
          this.boundContentMouseDownHandler = contentMouseDownHandler.bind(this);
          this.rulerViewport.contentDiv.addEventListener('mousedown', this.boundContentMouseDownHandler);

          function contentMouseDownHandler(event) {

              isMouseDown = true;
              isMouseIn = true;

              const {x} = domUtils.translateMouseCoordinates(event, this.rulerViewport.contentDiv);
              left = mouseDownX = x;

              width = threshold;


              this.rulerSweeper.style.display = 'block';
              this.rulerSweeper.style.backgroundColor = true === event.shiftKey ? ROI_USER_DEFINED_COLOR : RULER_SWEEPER_COLOR;

              this.rulerSweeper.style.left = `${left}px`;
              this.rulerSweeper.style.width = `${width}px`;

          }

          // Document
          this.boundDocumentMouseMoveHandler = documentMouseMoveHandler.bind(this);
          document.addEventListener('mousemove', this.boundDocumentMouseMoveHandler);

          function documentMouseMoveHandler(event) {

              let mouseCurrentX;

              if (isMouseDown && isMouseIn) {

                  const {x} = domUtils.translateMouseCoordinates(event, this.rulerViewport.contentDiv);
                  mouseCurrentX = Math.max(Math.min(x, this.rulerViewport.contentDiv.clientWidth), 0);

                  dx = mouseCurrentX - mouseDownX;

                  width = Math.abs(dx);
                  this.rulerSweeper.style.width = `${width}px`;

                  if (dx < 0) {
                      left = mouseDownX + dx;
                      this.rulerSweeper.style.left = `${left}px`;
                  }

              }

          }

          this.boundDocumentMouseUpHandler = documentMouseUpHandler.bind(this);
          document.addEventListener('mouseup', this.boundDocumentMouseUpHandler);

          function documentMouseUpHandler(event) {

              let genomicExtent;

              if (true === isMouseDown && true === isMouseIn) {

                  isMouseDown = isMouseIn = undefined;

                  this.rulerSweeper.style.display = 'none';

                  if (width > threshold) {

                      genomicExtent =
                          {
                              start: Math.floor(this.referenceFrame.calculateEnd(left)),
                              end: Math.floor(this.referenceFrame.calculateEnd(left + width)),
                          };


                      const shiftKeyPressed = event.shiftKey;

                      if (true === shiftKeyPressed) {
                          this.browser.roiManager.updateUserDefinedROISet(Object.assign({chr: this.referenceFrame.chr}, genomicExtent));
                      } else {

                          validateGenomicExtent(this.browser.genome.getChromosome(this.referenceFrame.chr).bpLength, genomicExtent, this.browser.minimumBases());
                          updateReferenceFrame(this.referenceFrame, genomicExtent, this.rulerViewport.contentDiv.clientWidth);
                          this.browser.updateViews(this.referenceFrame);

                      }

                  }

              }

          }

          this.isMouseHandlers = true;
      }

      removeMouseHandlers() {
          this.rulerViewport.contentDiv.removeEventListener('mousedown', this.boundContentMouseDownHandler);
          document.removeEventListener('mousemove', this.boundDocumentMouseMoveHandler);
          document.removeEventListener('mouseup', this.boundDocumentMouseUpHandler);
          this.isMouseHandlers = false;
      }

      dispose() {
          this.removeBrowserObserver();
          this.removeMouseHandlers();
          this.rulerSweeper.remove();
      }

  }

  function updateReferenceFrame(referenceFrame, genomicExtent, pixelWidth) {
      referenceFrame.start = Math.round(genomicExtent.start);
      referenceFrame.end = Math.round(genomicExtent.end);
      referenceFrame.bpPerPixel = (referenceFrame.end - referenceFrame.start) / pixelWidth;
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  class PairedAlignment {

      constructor(firstAlignment) {

          this.paired = true;
          this.firstAlignment = firstAlignment;
          this.chr = firstAlignment.chr;
          this.readName = firstAlignment.readName;

          if (firstAlignment.start < firstAlignment.mate.position) {
              this.start = firstAlignment.start;
              this.scStart = firstAlignment.scStart;
              this.connectingStart = firstAlignment.start + firstAlignment.lengthOnRef;
              this.connectingEnd = firstAlignment.mate.position;
          } else {
              this.start = firstAlignment.mate.position;
              this.scStart = this.start;
              this.connectingStart = firstAlignment.mate.position;
              this.connectingEnd = firstAlignment.start;
          }

          this.end = Math.max(firstAlignment.mate.position, firstAlignment.start + firstAlignment.lengthOnRef);  // Approximate
          this.lengthOnRef = this.end - this.start;

          let scEnd = Math.max(this.end, firstAlignment.scStart + firstAlignment.scLengthOnRef);
          this.scLengthOnRef = scEnd - this.scStart;

      }

      setSecondAlignment(secondAlignment) {

          // TODO -- check the chrs are equal,  error otherwise
          this.secondAlignment = secondAlignment;
          const firstAlignment = this.firstAlignment;

          if (secondAlignment.start > firstAlignment.start) {
              this.connectingEnd = secondAlignment.start;
          } else {
              this.connectingStart = secondAlignment.start + secondAlignment.lengthOnRef;
          }

          this.start = Math.min(firstAlignment.start, secondAlignment.start);
          this.end = Math.max(firstAlignment.start + firstAlignment.lengthOnRef, secondAlignment.start + secondAlignment.lengthOnRef);
          this.lengthOnRef = this.end - this.start;

          this.scStart = Math.min(firstAlignment.scStart, secondAlignment.scStart);
          const scEnd = Math.max(firstAlignment.scStart + firstAlignment.scLengthOnRef, secondAlignment.scStart + secondAlignment.scLengthOnRef);
          this.scLengthOnRef = scEnd - this.scStart;

      }

      containsLocation(genomicLocation, showSoftClips) {
          const s = showSoftClips ? this.scStart : this.start;
          const l = showSoftClips ? this.scLengthOnRef : this.lengthOnRef;
          return (genomicLocation >= s && genomicLocation <= (s + l))
      }

      alignmentContaining(genomicLocation, showSoftClips) {
          if (this.firstAlignment.containsLocation(genomicLocation, showSoftClips)) {
              return this.firstAlignment
          } else if (this.secondAlignment && this.secondAlignment.containsLocation(genomicLocation, showSoftClips)) {
              return this.secondAlignment
          } else {
              return undefined
          }
      }

      popupData(genomicLocation) {

          let nameValues = this.firstAlignment.popupData(genomicLocation);

          if (this.secondAlignment) {
              nameValues.push("-------------------------------");
              nameValues = nameValues.concat(this.secondAlignment.popupData(genomicLocation));
          }
          return nameValues
      }

      isPaired() {
          return true // By definition
      }

      isMateMapped() {
          return true // By definition
      }

      isProperPair() {
          return this.firstAlignment.isProperPair()
      }

      get fragmentLength() {
          return Math.abs(this.firstAlignment.fragmentLength)
      }

      firstOfPairStrand() {

          if (this.firstAlignment.isFirstOfPair()) {
              return this.firstAlignment.strand
          } else if (this.secondAlignment && this.secondAlignment.isFirstOfPair()) {
              return this.secondAlignment.strand
          } else {
              return this.firstAlignment.mate.strand    // Assumption is mate is first-of-pair
          }
      }

      hasTag(str) {
          return this.firstAlignment.hasTag(str) || (this.secondAlignment &&  this.secondAlignment.hasTag(str))
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class BamAlignmentRow {

      constructor() {

          this.alignments = [];
          this.score = undefined;
      }

      findAlignment(genomicLocation) {

          const alignmentContains = (a, genomicLocation) => {
              return genomicLocation >= a.start && genomicLocation < a.start + a.lengthOnRef
          };

          // find single alignment that overlaps sort location
          let centerAlignment;
          for (let i = 0; i < this.alignments.length; i++) {
              const a = this.alignments[i];
              if (genomicLocation >= a.start && genomicLocation < a.start + a.lengthOnRef) {
                  if (a.paired) {
                      if (a.firstAlignment && alignmentContains(a.firstAlignment, genomicLocation)) {
                          centerAlignment = a.firstAlignment;
                      } else if (a.secondAlignment && alignmentContains(a.secondAlignment, genomicLocation)) {
                          centerAlignment = a.secondAlignment;
                      }
                  } else {
                      centerAlignment = a;
                  }
                  break
              }
          }

          return centerAlignment

      }

      getSortValue({position, option, tag}, alignmentContainer) {

          if (!option) option = "BASE";

          const alignment = this.findAlignment(position);
          if (undefined === alignment) {  // This condition should never occur
              return Number.MAX_VALUE
          }

          switch (option) {
              case "NUCLEOTIDE":
              case "BASE": {
                  return calculateBaseScore(alignment, alignmentContainer, position)
              }
              case "STRAND":
                  return alignment.strand ? 1 : -1
              case "START":
                  return alignment.start
              case "TAG": {
                  return alignment.tags()[tag]
              }
              case "READ_NAME":
                  return alignment.readName
              case "INSERT_SIZE":
                  return -Math.abs(alignment.fragmentLength)
              case "GAP_SIZE":
                  return -alignment.gapSizeAt(position)
              case "MATE_CHR":
                  return alignment.mate
              case "MQ":
                  return alignment.mq === undefined ? Number.MAX_VALUE : -alignment.mq
              case "ALIGNED_READ_LENGTH":
                  return -alignment.lengthOnRef
              default:
                  return Number.MAX_VALUE
          }


          function calculateBaseScore(alignment, alignmentContainer, genomicLocation) {

              let reference;
              const idx = Math.floor(genomicLocation) - alignmentContainer.start;
              if (idx < alignmentContainer.sequence.length) {
                  reference = alignmentContainer.sequence.charAt(idx);
              }
              if (!reference) {
                  return 0
              }
              const base = alignment.readBaseAt(genomicLocation);
              const quality = alignment.readBaseQualityAt(genomicLocation);

              const coverageMap = alignmentContainer.coverageMap;
              const coverageMapIndex = Math.floor(genomicLocation - coverageMap.bpStart);
              const coverage = coverageMap.coverage[coverageMapIndex];

              // Insertions.  These are additive with base scores as they occur between bases, so you can have a
              // base mismatch AND an insertion
              let baseScore = 0;
              if (alignment.insertions) {
                  for (let ins of alignment.insertions) {
                      if (ins.start === genomicLocation) {
                          baseScore = -coverage.ins;
                      }
                  }
              }


              if (!base) {
                  // Either deletion or skipped (splice junction)
                  const delCount = coverage.del;
                  if (delCount > 0) {
                      baseScore -= delCount;
                  } else if (baseScore === 0) {    // Don't modify insertion score, if any
                      baseScore = 1;
                  }
              } else {
                  reference = reference.toUpperCase();
                  if ('N' === base && baseScore === 0) {
                      baseScore = 2;
                  } else if ((reference === base || '=' === base) && baseScore === 0) {
                      baseScore = 4 - quality / 1000;
                  } else if ("X" === base || reference !== base) {
                      const count = coverage["pos" + base] + coverage["neg" + base];
                      baseScore -= (count + (quality / 1000));
                  }
              }


              return baseScore
          }
      }


  }

  const alignmentSpace = 2;

  function canBePaired(alignment) {
      return alignment.isPaired() &&
          alignment.mate &&
          alignment.isMateMapped() &&
          alignment.chr === alignment.mate.chr &&
          (alignment.isFirstOfPair() || alignment.isSecondOfPair()) && !(alignment.isSecondary() || alignment.isSupplementary())
  }


  function pairAlignments(rows) {

      const pairCache = {};
      const result = [];

      for (let row of rows) {
          for (let alignment of row.alignments) {
              if (canBePaired(alignment)) {
                  let pairedAlignment = pairCache[alignment.readName];
                  if (pairedAlignment) {
                      pairedAlignment.setSecondAlignment(alignment);
                      pairCache[alignment.readName] = undefined;   // Don't need to track this anymore.
                  } else {
                      pairedAlignment = new PairedAlignment(alignment);
                      pairCache[alignment.readName] = pairedAlignment;
                      result.push(pairedAlignment);
                  }
              } else {
                  result.push(alignment);
              }
          }
      }
      return result
  }

  function unpairAlignments(rows) {
      const result = [];
      for (let row of rows) {
          for (let alignment of row.alignments) {
              if (alignment instanceof PairedAlignment) {
                  if (alignment.firstAlignment) result.push(alignment.firstAlignment);  // shouldn't need the null test
                  if (alignment.secondAlignment) result.push(alignment.secondAlignment);
              } else {
                  result.push(alignment);
              }
          }
      }
      return result
  }

  function packAlignmentRows(alignments, start, end, showSoftClips) {

      //console.log(`packAlignmentRows ${start} ${end}`)
      //const t0 = Date.now()

      if (!alignments) {
          return undefined
      } else if (alignments.length === 0) {
          return []
      } else {
          alignments.sort(function (a, b) {
              return showSoftClips ? a.scStart - b.scStart : a.start - b.start
          });

          const packedAlignmentRows = [];
          let alignmentRow;
          let nextStart = 0;
          let nextIDX = 0;
          const allocated = new Set();
          const startNewRow = () => {
              alignmentRow = new BamAlignmentRow();
              packedAlignmentRows.push(alignmentRow);
              nextStart = 0;
              nextIDX = 0;
              allocated.clear();
          };
          startNewRow();

          while (alignments.length > 0) {
              if (nextIDX >= 0 && nextIDX < alignments.length) {
                  const alignment = alignments[nextIDX];
                  allocated.add(alignment);
                  alignmentRow.alignments.push(alignment);
                  nextStart = showSoftClips ?
                      alignment.scStart + alignment.scLengthOnRef + alignmentSpace :
                      alignment.start + alignment.lengthOnRef + alignmentSpace;
                  nextIDX = binarySearch$1(alignments, (a) => (showSoftClips ? a.scStart : a.start) > nextStart, nextIDX);
              } else {
                  // Remove allocated alignments and start new row
                  alignments = alignments.filter(a => !allocated.has(a));
                  startNewRow();
              }
          }
          //console.log(`Done in ${Date.now() - t0} ms`)
          return packedAlignmentRows
      }
  }


  /**
   * Return 0 <= i <= array.length such that !pred(array[i - 1]) && pred(array[i]).
   *
   * returns an index 0 ≤ i ≤ array.length such that the given predicate is false for array[i - 1] and true for array[i]* *
   */
  function binarySearch$1(array, pred, min) {
      let lo = min - 1, hi = array.length;
      while (1 + lo < hi) {
          const mi = lo + ((hi - lo) >> 1);
          if (pred(array[mi])) {
              hi = mi;
          } else {
              lo = mi;
          }
      }
      return hi
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  class AlignmentContainer {

      //            this.config.samplingWindowSize, this.config.samplingDepth,
      //             this.config.pairsSupported, this.config.alleleFreqThreshold)
      constructor(chr, start, end, {samplingWindowSize, samplingDepth, pairsSupported, alleleFreqThreshold}) {

          this.chr = chr;
          this.start = Math.floor(start);
          this.end = Math.ceil(end);
          this.length = (end - start);

          this.alleleFreqThreshold = alleleFreqThreshold === undefined ? 0.2 : alleleFreqThreshold;

          this.coverageMap = new CoverageMap(chr, start, end, this.alleleFreqThreshold);
          this.alignments = [];
          this.downsampledIntervals = [];

          this.samplingWindowSize = samplingWindowSize === undefined ? 100 : samplingWindowSize;
          this.samplingDepth = samplingDepth === undefined ? 1000 : samplingDepth;

          this.pairsSupported = pairsSupported === undefined ? true : pairsSupported;
          this.paired = false;  // false until proven otherwise
          this.pairsCache = {};  // working cache of paired alignments by read name

          this.downsampledReads = new Set();

          this.currentBucket = new DownsampleBucket(this.start, this.start + this.samplingWindowSize, this);

          this.filter = function filter(alignment) {         // TODO -- pass this in
              return alignment.isMapped() && !alignment.isFailsVendorQualityCheck()
          };

      }

      push(alignment) {

          if (this.filter(alignment) === false) return

          this.coverageMap.incCounts(alignment);   // Count coverage before any downsampling

          if (this.pairsSupported && this.downsampledReads.has(alignment.readName)) {
              return   // Mate already downsampled -- pairs are treated as a single alignment for downsampling
          }

          if (alignment.start >= this.currentBucket.end) {
              this.finishBucket();
              this.currentBucket = new DownsampleBucket(alignment.start, alignment.start + this.samplingWindowSize, this);
          }

          this.currentBucket.addAlignment(alignment);

      }

      forEach(callback) {
          this.alignments.forEach(callback);
      }

      finish() {

          if (this.currentBucket !== undefined) {
              this.finishBucket();
          }

          this.alignments.sort(function (a, b) {
              return a.start - b.start
          });

          this.pairsCache = undefined;
          this.downsampledReads = undefined;
      }

      contains(chr, start, end) {
          return this.chr === chr &&
              this.start <= start &&
              this.end >= end
      }

      hasDownsampledIntervals() {
          return this.downsampledIntervals && this.downsampledIntervals.length > 0
      }

      finishBucket() {
          this.alignments = this.alignments.concat(this.currentBucket.alignments);
          if (this.currentBucket.downsampledCount > 0) {
              this.downsampledIntervals.push(new DownsampledInterval(
                  this.currentBucket.start,
                  this.currentBucket.end,
                  this.currentBucket.downsampledCount));
          }
          this.paired = this.paired || this.currentBucket.paired;
      }

      setViewAsPairs(bool) {
          let alignments;
          if (bool) {
              alignments = pairAlignments(this.packedAlignmentRows);
          } else {
              alignments = unpairAlignments(this.packedAlignmentRows);
          }
          this.packedAlignmentRows = packAlignmentRows(alignments, this.start, this.end);
      }

      setShowSoftClips(bool) {
          const alignments = this.allAlignments();
          this.packedAlignmentRows = packAlignmentRows(alignments, this.start, this.end, bool);
      }

      repack(bpPerPixel, showSoftClips) {
          const alignments = this.allAlignments();
          this.packedAlignmentRows = packAlignmentRows(alignments, this.start, this.end, showSoftClips);

      }

      allAlignments() {
          const alignments = [];
          for (let row of this.packedAlignmentRows) {
              for (let alignment of row.alignments) {
                  alignments.push(alignment);
              }
          }
          return alignments
      }

      getMax(start, end) {
          return this.coverageMap.getMax(start, end)
      }

      sortRows(options) {

          const newRows = [];
          const undefinedRow = [];
          for (let row of this.packedAlignmentRows) {
              const alignment = row.findAlignment(options.position);
              if (undefined !== alignment) {
                  newRows.push(row);
              } else {
                  undefinedRow.push(row);
              }
          }

          newRows.sort((rowA, rowB) => {
              const direction = options.direction;
              const rowAValue = rowA.getSortValue(options, this);
              const rowBValue = rowB.getSortValue(options, this);

              if (rowBValue === undefined && rowBValue !== undefined) return 1
              else if (rowAValue !== undefined && rowBValue === undefined) return -1

              const i = rowAValue > rowBValue ? 1 : (rowAValue < rowBValue ? -1 : 0);
              return true === direction ? i : -i
          });

          for (let row of undefinedRow) {
              newRows.push(row);
          }

          this.packedAlignmentRows = newRows;
      }

  }


  class DownsampleBucket {

      constructor(start, end, alignmentContainer) {

          this.start = start;
          this.end = end;
          this.alignments = [];
          this.downsampledCount = 0;
          this.samplingDepth = alignmentContainer.samplingDepth;
          this.pairsSupported = alignmentContainer.pairsSupported;
          this.downsampledReads = alignmentContainer.downsampledReads;
          this.pairsCache = alignmentContainer.pairsCache;
      }

      addAlignment(alignment) {

          var idx, replacedAlignment, pairedAlignment;

          if (this.pairsSupported && canBePaired(alignment)) {
              pairedAlignment = this.pairsCache[alignment.readName];
              if (pairedAlignment) {
                  // Not subject to downsampling, just update the existing alignment
                  pairedAlignment.setSecondAlignment(alignment);
                  this.pairsCache[alignment.readName] = undefined;   // Don't need to track this anymore. NOTE: Don't "delete", causes runtime performance issues
                  return
              }
          }

          if (this.alignments.length < this.samplingDepth) {

              if (this.pairsSupported && canBePaired(alignment)) {

                  // First alignment in a pair
                  pairedAlignment = new PairedAlignment(alignment);
                  this.paired = true;
                  this.pairsCache[alignment.readName] = pairedAlignment;
                  this.alignments.push(pairedAlignment);

              } else {
                  this.alignments.push(alignment);
              }

          } else {

              idx = Math.floor(Math.random() * (this.samplingDepth + this.downsampledCount - 1));

              if (idx < this.samplingDepth) {

                  // Keep the new item
                  //  idx = Math.floor(Math.random() * (this.alignments.length - 1));
                  replacedAlignment = this.alignments[idx];   // To be replaced

                  if (this.pairsSupported && canBePaired(alignment)) {

                      if (this.pairsCache[replacedAlignment.readName] !== undefined) {
                          this.pairsCache[replacedAlignment.readName] = undefined;
                      }

                      pairedAlignment = new PairedAlignment(alignment);
                      this.paired = true;
                      this.pairsCache[alignment.readName] = pairedAlignment;
                      this.alignments[idx] = pairedAlignment;

                  } else {
                      this.alignments[idx] = alignment;
                  }
                  this.downsampledReads.add(replacedAlignment.readName);

              } else {
                  this.downsampledReads.add(alignment.readName);
              }

              this.downsampledCount++;
          }


      }
  }

  class CoverageMap {

      constructor(chr, start, end, alleleFreqThreshold) {

          this.chr = chr;
          this.bpStart = start;
          this.length = (end - start);

          this.coverage = new Array(this.length);
          this.maximum = 0;

          this.threshold = alleleFreqThreshold;
          this.qualityWeight = true;
      }

      /**
       * Return the maximum coverage value between start and end.  This is used for autoscaling.
       * @param start
       * @param end
       */
      getMax(start, end) {
          let max = 0;
          const len = this.coverage.length;
          for (let i = 0; i < len; i++) {
              const pos = this.bpStart + i;
              if (pos > end) break
              const cov = this.coverage[i];
              if (pos >= start && cov) {
                  max = Math.max(max, cov.total);
              }
          }
          return max
      }

      incCounts(alignment) {

          var self = this;

          if (alignment.blocks === undefined) {
              incBlockCount(alignment);
          } else {
              alignment.blocks.forEach(function (block) {
                  incBlockCount(block);
              });
          }

          if (alignment.gaps) {
              for (let del of alignment.gaps) {
                  if (del.type === 'D') {
                      const offset = del.start - self.bpStart;
                      for (let i = offset; i < offset + del.len; i++) {
                          if (i < 0) continue
                          if (!this.coverage[i]) {
                              this.coverage[i] = new Coverage(self.threshold);
                          }
                          this.coverage[i].del++;
                      }
                  }
              }
          }

          if (alignment.insertions) {
              for (let del of alignment.insertions) {
                  const i = del.start - this.bpStart;
                  if (i < 0) continue
                  if (!this.coverage[i]) {
                      this.coverage[i] = new Coverage(self.threshold);
                  }
                  this.coverage[i].ins++;
              }
          }

          function incBlockCount(block) {

              if ('S' === block.type) return

              const seq = alignment.seq;
              const qual = alignment.qual;
              const seqOffset = block.seqOffset;

              for (let i = block.start - self.bpStart, j = 0; j < block.len; i++, j++) {

                  if (!self.coverage[i]) {
                      self.coverage[i] = new Coverage(self.threshold);
                  }

                  const base = (seq == undefined) ? "N" : seq.charAt(seqOffset + j);
                  const key = (alignment.strand) ? "pos" + base : "neg" + base;
                  const q = qual && seqOffset + j < qual.length ? qual[seqOffset + j] : 30;

                  self.coverage[i][key] += 1;
                  self.coverage[i]["qual" + base] += q;

                  self.coverage[i].total += 1;
                  self.coverage[i].qual += q;

                  self.maximum = Math.max(self.coverage[i].total, self.maximum);

              }
          }
      }
  }


  class Coverage {

      constructor(alleleThreshold) {

          this.qualityWeight = true;

          this.posA = 0;
          this.negA = 0;

          this.posT = 0;
          this.negT = 0;

          this.posC = 0;
          this.negC = 0;
          this.posG = 0;

          this.negG = 0;

          this.posN = 0;
          this.negN = 0;

          this.pos = 0;
          this.neg = 0;

          this.qualA = 0;
          this.qualT = 0;
          this.qualC = 0;
          this.qualG = 0;
          this.qualN = 0;

          this.qual = 0;

          this.total = 0;
          this.del = 0;
          this.ins = 0;

          this.threshold = alleleThreshold;
      }

      hoverText() {
          const pos = this.posA + this.posT + this.posC + this.posG + this.posN;
          const neg = this.negA + this.negT + this.negC + this.negG + this.negN;
          return `${this.total} (${pos}+, ${neg}-)`
      }

      isMismatch(refBase) {
          const threshold = this.threshold * ((this.qualityWeight && this.qual) ? this.qual : this.total);
          let mismatchQualitySum = 0;
          for (let base of ["A", "T", "C", "G"]) {
              if (base !== refBase) {
                  mismatchQualitySum += ((this.qualityWeight && this.qual) ? this["qual" + base] : (this["pos" + base] + this["neg" + base]));
              }
          }
          return mismatchQualitySum >= threshold
      }
  }

  class DownsampledInterval {

      constructor(start, end, counts) {
          this.start = start;
          this.end = end;
          this.counts = counts;
      }

      popupData(genomicLocation) {
          return [
              {name: "start", value: this.start + 1},
              {name: "end", value: this.end},
              {name: "# downsampled:", value: this.counts}]
      }
  }

  class SupplementaryAlignment {

      constructor(rec) {
          const tokens = rec.split(',');
          this.chr = tokens[0];
          this.start = parseInt(tokens[1]);
          this.strand = tokens[2].charAt(0);
          this.mapQ = parseInt(tokens[4]);
          this.numMismatches = parseInt(tokens[5]);
          this.lenOnRef = BamUtils.computeLengthOnReference(tokens[3]);
      }

      printString() {
          return this.chr + ":" + numberFormatter$1(this.start) + "-" + numberFormatter$1(this.start + this.lenOnRef)
              + " (" + this.strand + ") = " + numberFormatter$1(this.lenOnRef) + "bp @MAPQ: " + this.mapQ + " NM: " + this.numMismatches
      }
  }

  function createSupplementaryAlignments(str) {
      const tokens = str.split(';');
      return tokens.filter(t => t.length > 0).map(str => new SupplementaryAlignment(str))
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const READ_PAIRED_FLAG = 0x1;
  const PROPER_PAIR_FLAG = 0x2;
  const READ_UNMAPPED_FLAG = 0x4;
  const MATE_UNMAPPED_FLAG = 0x8;
  const READ_STRAND_FLAG$2 = 0x10;
  const MATE_STRAND_FLAG$2 = 0x20;
  const FIRST_OF_PAIR_FLAG = 0x40;
  const SECOND_OF_PAIR_FLAG = 0x80;
  const SECONDARY_ALIGNMNET_FLAG = 0x100;
  const READ_FAILS_VENDOR_QUALITY_CHECK_FLAG = 0x200;
  const DUPLICATE_READ_FLAG = 0x400;
  const SUPPLEMENTARY_ALIGNMENT_FLAG = 0x800;
  const ELEMENT_SIZE = {
      c: 1,
      C: 1,
      s: 2,
      S: 2,
      i: 4,
      I: 4,
      f: 4
  };

  const MAX_CIGAR = 50;

  /**
   * readName
   * chr
   * cigar
   * lengthOnRef
   * start
   * seq
   * qual
   * mq
   * strand
   * blocks
   */

  class BamAlignment {

      constructor() {
          this.hidden = false;
      }

      isMapped() {
          return (this.flags & READ_UNMAPPED_FLAG) === 0
      }

      isPaired() {
          return (this.flags & READ_PAIRED_FLAG) !== 0
      }

      isProperPair() {
          return (this.flags & PROPER_PAIR_FLAG) !== 0
      }

      isFirstOfPair() {
          return (this.flags & FIRST_OF_PAIR_FLAG) !== 0
      }

      isSecondOfPair() {
          return (this.flags & SECOND_OF_PAIR_FLAG) !== 0
      }

      isSecondary() {
          return (this.flags & SECONDARY_ALIGNMNET_FLAG) !== 0
      }

      isSupplementary() {
          return (this.flags & SUPPLEMENTARY_ALIGNMENT_FLAG) !== 0
      }

      isFailsVendorQualityCheck() {
          return (this.flags & READ_FAILS_VENDOR_QUALITY_CHECK_FLAG) !== 0
      }

      isDuplicate() {
          return (this.flags & DUPLICATE_READ_FLAG) !== 0
      }

      isMateMapped() {
          return (this.flags & MATE_UNMAPPED_FLAG) === 0
      }

      isNegativeStrand() {
          return (this.flags & READ_STRAND_FLAG$2) !== 0
      }

      isMateNegativeStrand() {
          return (this.flags & MATE_STRAND_FLAG$2) !== 0
      }

      hasTag(tag) {
          const tmpTags = this.tagDict || decodeTags(this.tagBA);
          return tmpTags.hasOwnProperty(tag)
      }

      tags() {
          if (!this.tagDict) {
              if (this.tagBA) {
                  this.tagDict = decodeTags(this.tagBA);
                  this.tagBA = undefined;
              } else {
                  this.tagDict = {};  // Mark so we don't try again.  The record has no tags
              }
          }
          return this.tagDict
      }

      /**
       * Does alignment (or alignment extended by soft clips) contain the genomic location?
       *
       * @param genomicLocation
       * @param showSoftClips
       * @returns {boolean|boolean}
       */
      containsLocation(genomicLocation, showSoftClips) {
          const s = showSoftClips ? this.scStart : this.start;
          const l = showSoftClips ? this.scLengthOnRef : this.lengthOnRef;
          return (genomicLocation >= s && genomicLocation <= (s + l))
      }

      popupData(genomicLocation) {

          // if the user clicks on a base next to an insertion, show just the
          // inserted bases in a popup (like in desktop IGV).
          const nameValues = [];

          // Consert genomic location to int
          genomicLocation = Math.floor(genomicLocation);

          if (this.insertions) {

              const seq = this.seq;

              for (let insertion of this.insertions) {
                  var ins_start = insertion.start;
                  if (genomicLocation === ins_start || genomicLocation === ins_start - 1) {
                      nameValues.push({name: 'Insertion', value: seq.substr(insertion.seqOffset, insertion.len)});
                      nameValues.push({name: 'Location', value: ins_start});
                      return nameValues
                  }
              }
          }

          nameValues.push({name: 'Read Name', value: this.readName});

          // Sample
          // Read group
          nameValues.push('<hr/>');

          // Add 1 to genomic location to map from 0-based computer units to user-based units
          nameValues.push({name: 'Alignment Start', value: numberFormatter$1(1 + this.start), borderTop: true});
          nameValues.push({name: 'Read Strand', value: (true === this.strand ? '(+)' : '(-)'), borderTop: true});

          // Abbreviate long cigar strings, keeping the beginning and end to show cliping
          let cigar = this.cigar;
          if (cigar && cigar.length > MAX_CIGAR) {
              const half = MAX_CIGAR / 2;
              cigar = `${cigar.substring(0, half - 2)} ... ${cigar.substring(cigar.length - half + 2)}`;
          }
          nameValues.push({name: 'Cigar', value: cigar});

          nameValues.push({name: 'Mapping Quality', value: this.mq});
          nameValues.push({name: 'Secondary', value: yesNo(this.isSecondary())});
          nameValues.push({name: 'Supplementary', value: yesNo(this.isSupplementary())});
          nameValues.push({name: 'Duplicate', value: yesNo(this.isDuplicate())});
          nameValues.push({name: 'Failed QC', value: yesNo(this.isFailsVendorQualityCheck())});

          if (this.isPaired()) {
              nameValues.push('<hr/>');
              nameValues.push({name: 'First in Pair', value: !this.isSecondOfPair(), borderTop: true});
              nameValues.push({name: 'Mate is Mapped', value: yesNo(this.isMateMapped())});
              if (this.pairOrientation) {
                  nameValues.push({name: 'Pair Orientation', value: this.pairOrientation});
              }
              if (this.isMateMapped()) {
                  nameValues.push({name: 'Mate Chromosome', value: this.mate.chr});
                  nameValues.push({name: 'Mate Start', value: (this.mate.position + 1)});
                  nameValues.push({name: 'Mate Strand', value: (true === this.mate.strand ? '(+)' : '(-)')});
                  nameValues.push({name: 'Insert Size', value: this.fragmentLength});
                  // Mate Start
                  // Mate Strand
                  // Insert Size
              }
              // First in Pair
              // Pair Orientation

          }

          const tagDict = this.tags();

          if (tagDict.hasOwnProperty('SA')) {
              nameValues.push('<hr/>');
              nameValues.push({name: 'Supplementary Alignments', value: ''});
              const sa = createSupplementaryAlignments(tagDict['SA']);
              if (sa) {
                  nameValues.push('<ul>');
                  for (let s of sa) {
                      nameValues.push(`<li>${s.printString()}</li>`);
                  }
                  nameValues.push('</ul>');
              }
          }

          const hiddenTags = new Set(['SA', 'MD']);
          nameValues.push('<hr/>');
          for (let key in tagDict) {
              if (!hiddenTags.has(key)) {
                  nameValues.push({name: key, value: tagDict[key]});
              }
          }

          nameValues.push({name: 'Hidden Tags', value: 'SA, MD'});

          nameValues.push('<hr/>');
          nameValues.push({name: 'Genomic Location: ', value: numberFormatter$1(1 + genomicLocation)});
          nameValues.push({name: 'Read Base:', value: this.readBaseAt(genomicLocation)});
          nameValues.push({name: 'Base Quality:', value: this.readBaseQualityAt(genomicLocation)});

          return nameValues


          function yesNo(bool) {
              return bool ? 'Yes' : 'No'
          }
      }

      readBaseAt(genomicLocation) {

          const block = blockAtGenomicLocation(this.blocks, genomicLocation);
          if (block) {
              if ("*" === this.seq) {
                  return "*"
              } else {
                  const idx = block.seqIndexAt(genomicLocation);
                  // if (idx >= 0 && idx < this.seq.length) {
                  return this.seq[idx]
                  //  }
              }
          } else {
              return undefined
          }
      }

      readBaseQualityAt(genomicLocation) {

          const block = blockAtGenomicLocation(this.blocks, genomicLocation);
          if (block) {
              if ("*" === this.qual) {
                  return 30
              } else {
                  const idx = block.seqIndexAt(genomicLocation);
                  if (idx >= 0 && this.qual && idx < this.qual.length) {
                      return this.qual[idx]
                  } else {
                      return 30
                  }
              }
          } else {
              return undefined
          }
      }

      gapSizeAt(genomicLocation) {
          if (this.gaps) {
              for (let gap of this.gaps) {
                  if (genomicLocation >= gap.start && genomicLocation < gap.start + gap.len) {
                      return gap.len
                  }
              }
          }
          return 0
      }

      /**
       * Return soft clipped blocks, if they exist, keyed by alignment end (left or right)
       */
      softClippedBlocks() {
          let left;
          let right;
          let interiorSeen;
          for(let b of this.blocks) {
              if('S' === b.type) {
                  if(interiorSeen) {
                      right = b;
                  } else {
                      left = b;
                  }
              } else if('H' !== b.type) {
                  interiorSeen = true;
              }
          }
          return {left, right}
      }

  }

  function blockAtGenomicLocation(blocks, genomicLocation) {

      for (let i = 0; i < blocks.length; i++) {
          const block = blocks[i];
          if (genomicLocation >= block.start && genomicLocation < block.start + block.len) {
              return block
          }
      }
      return undefined
  }

  function decodeTags(ba) {

      let p = 0;
      const len = ba.length;
      const tags = {};

      while (p < len) {
          const tag = String.fromCharCode(ba[p]) + String.fromCharCode(ba[p + 1]);
          p += 2;

          const type = String.fromCharCode(ba[p++]);
          let value;
          if (type === 'A') {
              value = String.fromCharCode(ba[p]);
              p++;
          } else if (type === 'i' || type === 'I') {
              value = readInt$1(ba, p);
              p += 4;
          } else if (type === 'c') {
              value = readInt8(ba, p);
              p++;
          } else if (type === 'C') {
              value = readUInt8(ba, p);
              p++;
          } else if (type === 's' || type === 'S') {
              value = readShort(ba, p);
              p += 2;
          } else if (type === 'f') {
              value = readFloat(ba, p);
              p += 4;
          } else if (type === 'Z') {
              value = '';
              for (; ;) {
                  var cc = ba[p++];
                  if (cc === 0) {
                      break
                  } else {
                      value += String.fromCharCode(cc);
                  }
              }
          } else if (type === 'B') {
              const elementType = String.fromCharCode(ba[p++]);
              let elementSize = ELEMENT_SIZE[elementType];
              if (elementSize === undefined) {
                  tags[tag] = `Error: unknown element type '${elementType}'`;
                  break
              }
              const numElements = readInt$1(ba, p);
              p += (4 + numElements * elementSize);
              value = '[not shown]';
          } else {
              //'Unknown type ' + type;
              value = 'Error unknown type: ' + type;
              tags[tag] = value;
              break
          }
          tags[tag] = value;
      }
      return tags
  }


  function readInt$1(ba, offset) {
      return (ba[offset + 3] << 24) | (ba[offset + 2] << 16) | (ba[offset + 1] << 8) | (ba[offset])
  }

  function readShort(ba, offset) {
      return (ba[offset + 1] << 8) | (ba[offset])
  }

  function readFloat(ba, offset) {
      const dataView = new DataView(ba.buffer);
      return dataView.getFloat32(offset)
  }

  function readInt8(ba, offset) {
      const dataView = new DataView(ba.buffer);
      return dataView.getInt8(offset)
  }

  function readUInt8(ba, offset) {
      const dataView = new DataView(ba.buffer);
      return dataView.getUint8(offset)
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Created by jrobinso on 4/5/18.
   */


  class AlignmentBlock {
      constructor(b) {
          if (b) {
              Object.assign(this, b);
          }
      }

      seqIndexAt(genomicLocation) {
          return Math.floor(genomicLocation) - this.start + this.seqOffset
      }
  }

  class BamFilter {
      constructor(options) {
          if (!options) options = {};
          this.vendorFailed = options.vendorFailed === undefined ? true : options.vendorFailed;
          this.duplicates = options.duplicates === undefined ? true : options.duplicates;
          this.secondary = options.secondary || false;
          this.supplementary = options.supplementary || false;
          this.mqThreshold = options.mqThreshold === undefined ? 0 : options.mqThreshold;
          if (options.readgroups) {
              this.readgroups = new Set(options.readgroups);
          }
      }

      pass(alignment) {
          if (this.vendorFailed && alignment.isFailsVendorQualityCheck()) return false
          if (this.duplicates && alignment.isDuplicate()) return false
          if (this.secondary && alignment.isSecondary()) return false
          if (this.supplementary && alignment.isSupplementary()) return false
          if (alignment.mq < this.mqThreshold) return false
          if (this.readgroups) {
              var rg = alignment.tags()['RG'];
              return this.readgroups.has(rg)
          }
          return true
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  /**
   * This code is based on the Biodalliance BAM reader by Thomas Down,  2011
   *
   * https://github.com/dasmoth/dalliance/blob/master/js/bam.js
   */

  const SEQ_DECODER = ['=', 'A', 'C', 'x', 'G', 'x', 'x', 'x', 'T', 'x', 'x', 'x', 'x', 'x', 'x', 'N'];
  const CIGAR_DECODER = ['M', 'I', 'D', 'N', 'S', 'H', 'P', '=', 'X', '?', '?', '?', '?', '?', '?', '?'];
  const READ_STRAND_FLAG$1 = 0x10;
  const MATE_STRAND_FLAG$1 = 0x20;

  const BAM1_MAGIC_BYTES = new Uint8Array([0x42, 0x41, 0x4d, 0x01]); // BAM\1
  const BAM1_MAGIC_NUMBER = readInt(BAM1_MAGIC_BYTES, 0);

  const DEFAULT_ALLELE_FREQ_THRESHOLD = 0.2;
  const DEFAULT_SAMPLING_WINDOW_SIZE = 100;
  const DEFAULT_SAMPLING_DEPTH = 500;
  const MAXIMUM_SAMPLING_DEPTH = 10000;

  const BamUtils = {

      readHeader: function (url, options, genome) {

          return igvxhr$1.loadArrayBuffer(url, options)

              .then(function (compressedBuffer) {

                  var header, unc, uncba;

                  unc = unbgzf$1(compressedBuffer);
                  uncba = unc;

                  header = BamUtils.decodeBamHeader(uncba, genome);

                  return header

              })

      },

      /**
       *
       * @param ba  bytes to decode as a UInt8Array
       * @param genome  optional igv genome object
       * @returns {{ magicNumer: number, size: number, chrNames: Array, chrToIndex: ({}|*), chrAliasTable: ({}|*) }}
       */
      decodeBamHeader: function (ba, genome) {

          var magic, samHeaderLen, samHeader, chrToIndex, chrNames, chrAliasTable, alias;

          magic = readInt(ba, 0);
          if (magic !== BAM1_MAGIC_NUMBER) {
              throw new Error('BAM header errror: bad magic number.  This could be caused by either a corrupt or missing file.')
          }

          samHeaderLen = readInt(ba, 4);
          samHeader = '';

          for (var i = 0; i < samHeaderLen; ++i) {
              samHeader += String.fromCharCode(ba[i + 8]);
          }

          var nRef = readInt(ba, samHeaderLen + 8);
          var p = samHeaderLen + 12;

          chrToIndex = {};
          chrNames = [];
          chrAliasTable = {};

          for (i = 0; i < nRef; ++i) {
              var lName = readInt(ba, p);
              var name = '';
              for (var j = 0; j < lName - 1; ++j) {
                  name += String.fromCharCode(ba[p + 4 + j]);
              }
              readInt(ba, p + lName + 4);
              //dlog(name + ': ' + lRef);

              chrToIndex[name] = i;
              chrNames[i] = name;

              if (genome) {
                  alias = genome.getChromosomeName(name);
                  chrAliasTable[alias] = name;
              }

              p = p + 8 + lName;
          }

          return {
              magicNumber: magic,
              size: p,
              chrNames: chrNames,
              chrToIndex: chrToIndex,
              chrAliasTable: chrAliasTable
          }

      },

      bam_tag2cigar: function (ba, block_end, seq_offset, lseq, al, cigarArray) {

          function type2size(x) {
              if (x === 'C' || x === 'c' || x === 'A') return 1
              else if (x === 'S' || x === 's') return 2
              else if (x === 'I' || x === 'i' || x === 'f') return 4
              else return 0
          }

          // test if the real CIGAR is encoded in a CG:B,I tag
          if (cigarArray.length !== 1 || al.start < 0) return false
          var p = seq_offset + ((lseq + 1) >> 1) + lseq;
          while (p + 4 < block_end) {
              var tag = String.fromCharCode(ba[p]) + String.fromCharCode(ba[p + 1]);
              if (tag === 'CG') break
              var type = String.fromCharCode(ba[p + 2]);
              if (type === 'B') { // the binary array type
                  type = String.fromCharCode(ba[p + 3]);
                  var size = type2size(type);
                  var len = readInt(ba, p + 4);
                  p += 8 + size * len;
              } else if (type === 'Z' || type === 'H') { // 0-terminated string
                  p += 3;
                  while (ba[p++] !== 0) {
                  }
              } else { // other atomic types
                  p += 3 + type2size(type);
              }
          }
          if (p >= block_end) return false // no CG tag
          if (String.fromCharCode(ba[p + 2]) !== 'B' || String.fromCharCode(ba[p + 3]) !== 'I') return false // not of type B,I

          // now we know the real CIGAR length and its offset in the binary array
          var cigar_len = readInt(ba, p + 4);
          var cigar_offset = p + 8; // 4 for "CGBI" and 4 for length
          if (cigar_offset + cigar_len * 4 > block_end) return false // out of bound

          // decode CIGAR
          var cigar = '';
          var lengthOnRef = 0;
          cigarArray.length = 0; // empty the old array
          p = cigar_offset;
          for (var k = 0; k < cigar_len; ++k, p += 4) {
              var cigop = readInt(ba, p);
              var opLen = (cigop >> 4);
              var opLtr = CIGAR_DECODER[cigop & 0xf];
              if (opLtr === 'M' || opLtr === 'EQ' || opLtr === 'X' || opLtr === 'D' || opLtr === 'N' || opLtr === '=')
                  lengthOnRef += opLen;
              cigar = cigar + opLen + opLtr;
              cigarArray.push({len: opLen, ltr: opLtr});
          }

          // update alignment record. We are not updating bin, as apparently it is not used.
          al.cigar = cigar;
          al.lengthOnRef = lengthOnRef;
          return true
      },

      /**
       *
       * @param ba                 bytes to decode as an UInt8Array
       * @param offset             offset position of ba array to start decoding
       * @param alignmentContainer container to receive the decoded alignments
       * @param min                minimum genomic position
       * @param max                maximum genomic position
       * @param chrIdx             chromosome index
       * @param chrNames            array of chromosome names
       * @param filter             a BamFilter object
       *
       * @return true if we have moved beyond the right end of the genomic range.
       */
      decodeBamRecords: function (ba, offset, alignmentContainer, chrNames, chrIdx, min, max, filter) {

          while (offset < ba.length) {

              const blockSize = readInt(ba, offset);
              const blockEnd = offset + blockSize + 4;
              const alignment = new BamAlignment();
              const refID = readInt(ba, offset + 4);
              const pos = readInt(ba, offset + 8);

              if (blockEnd > ba.length) {
                  return
              }
              if (refID < 0) {
                  offset = blockEnd;
                  continue   // unmapped read
              } else if (chrIdx !== undefined && (refID > chrIdx || pos > max)) {
                  return true    // off right edge, we're done
              } else if (chrIdx !== undefined && (refID < chrIdx)) {
                  offset = blockEnd;
                  continue   // ref ID to left of start, not sure this is possible
              }

              const bin_mq_nl = readInt(ba, offset + 12);
              const mq = (bin_mq_nl & 0xff00) >> 8;
              const nl = bin_mq_nl & 0xff;

              const flag_nc = readInt(ba, offset + 16);
              const flag = (flag_nc & 0xffff0000) >> 16;
              const nc = flag_nc & 0xffff;

              const lseq = readInt(ba, offset + 20);
              const mateChrIdx = readInt(ba, offset + 24);
              const matePos = readInt(ba, offset + 28);
              const fragmentLength = readInt(ba, offset + 32);

              let readName = [];
              for (let j = 0; j < nl - 1; ++j) {
                  readName.push(String.fromCharCode(ba[offset + 36 + j]));
              }
              readName = readName.join('');

              let lengthOnRef = 0;
              let cigar = '';
              let p = offset + 36 + nl;
              const cigarArray = [];
              // concatenate M,=,EQ,and X

              let lastCigRecord;
              for (let c = 0; c < nc; ++c) {
                  var cigop = readInt(ba, p);
                  var opLen = (cigop >> 4);
                  var opLtr = CIGAR_DECODER[cigop & 0xf];
                  if (opLtr === 'M' || opLtr === 'EQ' || opLtr === 'X' || opLtr === 'D' || opLtr === 'N' || opLtr === '=')
                      lengthOnRef += opLen;
                  cigar = cigar + opLen + opLtr;
                  p += 4;

                  // if(mOperators.has(opLtr) && mOperators.has(lastCigRecord.ltr)) {
                  //     lastCigRecord.len += opLen;
                  //     lastCigRecord.ltr = 'M'
                  // }
                  // else {
                  lastCigRecord = {len: opLen, ltr: opLtr};
                  cigarArray.push(lastCigRecord);
                  //}
              }

              alignment.chr = chrNames[refID];
              alignment.start = pos;
              alignment.flags = flag;
              alignment.strand = !(flag & READ_STRAND_FLAG$1);
              alignment.readName = readName;
              alignment.cigar = cigar;
              alignment.lengthOnRef = lengthOnRef;
              alignment.fragmentLength = fragmentLength;
              alignment.mq = mq;

              BamUtils.bam_tag2cigar(ba, blockEnd, p, lseq, alignment, cigarArray);

              alignment.end = alignment.start + alignment.lengthOnRef;

              if (alignment.end < min) {
                  offset = blockEnd;
                  continue
              }  // Record out-of-range "to the left", skip to next one


              let seq = [];
              const seqBytes = (lseq + 1) >> 1;
              for (let j = 0; j < seqBytes; ++j) {
                  var sb = ba[p + j];
                  seq.push(SEQ_DECODER[(sb & 0xf0) >> 4]);
                  seq.push(SEQ_DECODER[(sb & 0x0f)]);
              }
              seq = seq.slice(0, lseq).join('');  // seq might have one extra character (if lseq is an odd number)
              p += seqBytes;


              const qualArray = [];
              for (let j = 0; j < lseq; ++j) {
                  qualArray.push(ba[p + j]);
              }
              p += lseq;

              if (mateChrIdx >= 0) {
                  alignment.mate = {
                      chr: chrNames[mateChrIdx],
                      position: matePos,
                      strand: !(flag & MATE_STRAND_FLAG$1)
                  };
              }

              alignment.seq = seq;
              alignment.qual = qualArray;
              alignment.tagBA = new Uint8Array(ba.buffer.slice(p, blockEnd));  // decode these on demand

              this.setPairOrientation(alignment);

              if ((undefined === filter || filter.pass(alignment))) {
                  makeBlocks(alignment, cigarArray);
                  alignmentContainer.push(alignment);
              }
              offset = blockEnd;
          }
      },

      decodeSamRecords: function (sam, alignmentContainer, chr, min, max, filter) {

          var lines, i, j, len, tokens, qualString, rnext, lengthOnRef,
              alignment, cigarArray, started;

          lines = splitLines$5(sam);
          len = lines.length;
          started = false;

          for (i = 0; i < len; i++) {

              tokens = lines[i].split('\t');

              alignment = new BamAlignment();

              alignment.chr = tokens[2];
              alignment.start = Number.parseInt(tokens[3]) - 1;
              alignment.flags = Number.parseInt(tokens[1]);
              alignment.readName = tokens[0];
              alignment.strand = !(alignment.flags & READ_STRAND_FLAG$1);
              alignment.mq = Number.parseInt(tokens[4]);
              alignment.cigar = tokens[5];
              alignment.fragmentLength = Number.parseInt(tokens[8]);
              alignment.seq = tokens[9];

              if (alignment.chr === '*' || !alignment.isMapped()) continue  // Unmapped

              if (alignment.chr !== chr) {
                  if (started) break // Off the right edge, we're done
                  else continue // Possibly to the left, skip but keep looping
              } else if (alignment.start > max) {
                  break    // off right edge, we're done
              }

              lengthOnRef = 0;
              cigarArray = buildOperators(alignment.cigar);
              cigarArray.forEach(function (op) {
                  var opLen = op.len;
                  var opLtr = op.ltr;
                  if (opLtr === 'M' || opLtr === 'EQ' || opLtr === 'X' || opLtr === 'D' || opLtr === 'N' || opLtr === '=')
                      lengthOnRef += opLen;
              });
              alignment.lengthOnRef = lengthOnRef;
              // TODO for lh3: parse the CG:B,I tag in SAM here

              if (alignment.start + lengthOnRef < min) {
                  continue    // To the left, skip and continue
              }


              qualString = tokens[10];
              alignment.qual = [];
              for (j = 0; j < qualString.length; j++) {
                  alignment.qual[j] = qualString.charCodeAt(j) - 33;
              }
              alignment.tagDict = tokens.length < 11 ? {} : decodeSamTags(tokens.slice(11));

              if (alignment.isMateMapped()) {
                  rnext = tokens[6];
                  alignment.mate = {
                      chr: (rnext === '=') ? alignment.chr : rnext,
                      position: Number.parseInt(tokens[7]),
                      strand: !(alignment.flags & MATE_STRAND_FLAG$1)
                  };
              }

              this.setPairOrientation(alignment);

              if (undefined === filter || filter.pass(alignment)) {
                  makeBlocks(alignment, cigarArray);
                  alignmentContainer.push(alignment);
              }
          }
      },

      setReaderDefaults: function (reader, config) {

          reader.filter = new BamFilter(config.filter);

          if (config.readgroup) {
              reader.filter.readgroups = new Set([config.readgroup]);
          }

          reader.alleleFreqThreshold = config.alleleFreqThreshold === undefined ? DEFAULT_ALLELE_FREQ_THRESHOLD : config.alleleFreqThreshold;

          reader.samplingWindowSize = config.samplingWindowSize === undefined ? DEFAULT_SAMPLING_WINDOW_SIZE : config.samplingWindowSize;
          reader.samplingDepth = config.samplingDepth === undefined ? DEFAULT_SAMPLING_DEPTH : config.samplingDepth;

          if (reader.samplingDepth > MAXIMUM_SAMPLING_DEPTH) {
              reader.samplingDepth = MAXIMUM_SAMPLING_DEPTH;
          }

          if (config.viewAsPairs) {
              reader.pairsSupported = true;
          } else {
              reader.pairsSupported = config.pairsSupported === undefined ? true : config.pairsSupported;
          }
      },

      setPairOrientation: function (alignment) {

          if (alignment.isMapped() && alignment.mate && alignment.isMateMapped() && alignment.mate.chr === alignment.chr) {
              var s1 = alignment.strand ? 'F' : 'R';

              var mate = alignment.mate;
              var s2 = mate.strand ? 'F' : 'R';
              var o1 = ' ';
              var o2 = ' ';
              if (alignment.isFirstOfPair()) {
                  o1 = '1';
                  o2 = '2';
              } else if (alignment.isSecondOfPair()) {
                  o1 = '2';
                  o2 = '1';
              }

              var tmp = [];
              var isize = alignment.fragmentLength;
              var estReadLen = alignment.end - alignment.start;
              if (isize === 0) {
                  //isize not recorded.  Need to estimate.  This calculation was validated against an Illumina
                  // -> <- library bam.
                  var estMateEnd = alignment.start < mate.position ?
                      mate.position + estReadLen : mate.position - estReadLen;
                  isize = estMateEnd - alignment.start;
              }

              //if (isize > estReadLen) {
              if (isize > 0) {
                  tmp[0] = s1;
                  tmp[1] = o1;
                  tmp[2] = s2;
                  tmp[3] = o2;

              } else {
                  tmp[2] = s1;
                  tmp[3] = o1;
                  tmp[0] = s2;
                  tmp[1] = o2;
              }
              // }
              alignment.pairOrientation = tmp.join('');
          }
      },

      computeLengthOnReference: function (cigarString) {

          let len = 0;
          let buf = '';

          for (let i = 0; i < cigarString.length; i++) {
              const c = cigarString.charCodeAt(i);
              if (c > 47 && c < 58) {
                  buf += cigarString.charAt(i);
              } else {
                  switch (c) {
                      case 78:  // N
                      case 68:  // D
                      case 77:  // M
                      case 61:  // =
                      case 88:  // X
                          len += parseInt(buf.toString());
                  }
                  buf = '';
              }
          }
          return len
      }
  };


  /**
   * Split the alignment record into blocks as specified in the cigarArray.  Each aligned block contains
   * its portion of the read sequence and base quality strings.  A read sequence or base quality string
   * of "*" indicates the value is not recorded.  In all other cases the length of the block sequence (block.seq)
   * and quality string (block.qual) must == the block length.
   *
   * @param alignment
   * @param cigarArray
   * @returns array of blocks
   */
  function makeBlocks(alignment, cigarArray) {

      const blocks = [];

      let insertions;
      let gaps;
      let seqOffset = 0;
      let pos = alignment.start;

      alignment.scStart = alignment.start;
      alignment.scLengthOnRef = alignment.lengthOnRef;

      for (let c of cigarArray) {

          let scPos;
          switch (c.ltr) {
              case 'H' :
                  break // ignore hard clips
              case 'P' :
                  break // ignore pads
              case 'S' :

                  scPos = pos;
                  alignment.scLengthOnRef += c.len;
                  if (blocks.length === 0) {
                      alignment.scStart -= c.len;
                      scPos -= c.len;
                  }
                  blocks.push(new AlignmentBlock({
                      start: scPos,
                      seqOffset: seqOffset,
                      len: c.len,
                      type: 'S'
                  }));
                  seqOffset += c.len;
                  break // soft clip read bases
              case 'N' :
              case 'D':
                  if (gaps === undefined) {
                      gaps = [];
                  }
                  gaps.push({
                      start: pos,
                      len: c.len,
                      type: c.ltr
                  });
                  pos += c.len;
                  break
              case 'I' :

                  if (insertions === undefined) {
                      insertions = [];
                  }
                  insertions.push(new AlignmentBlock({
                      start: pos,
                      len: c.len,
                      seqOffset: seqOffset,
                      type: 'I'
                  }));
                  seqOffset += c.len;
                  break
              case 'M' :
              case 'EQ' :
              case '=' :
              case 'X' :
                  blocks.push(new AlignmentBlock({
                      start: pos,
                      seqOffset: seqOffset,
                      len: c.len,
                      type: 'M'
                  }));
                  seqOffset += c.len;
                  pos += c.len;

                  break
          }
      }

      alignment.blocks = blocks;
      alignment.insertions = insertions;
      alignment.gaps = gaps;

  }

  function readInt(ba, offset) {
      return (ba[offset + 3] << 24) | (ba[offset + 2] << 16) | (ba[offset + 1] << 8) | (ba[offset])
  }

  /**
   * Build a list of cigar operators from a cigarString.  Removes padding operators and concatenates consecutive
   * operators of the same type
   *
   * @param cigarString
   * @return
   */
  function buildOperators(cigarString) {

      var operators, buffer, i, len, prevOp, next, op, nBases;

      operators = [];
      buffer = [];

      // Create list of cigar operators
      prevOp = null;
      len = cigarString.length;
      for (i = 0; i < len; i++) {
          next = cigarString.charAt(i);
          if (isDigit(next)) {
              buffer.push(next);
          } else {
              op = next;
              nBases = Number.parseInt(buffer.join(''));
              buffer = [];

              if (prevOp !== null && prevOp.ltr === op) {
                  prevOp.len += nBases;
              } else {
                  prevOp = {len: nBases, ltr: op};
                  operators.push(prevOp);
              }
          }
      }
      return operators

  }

  function isDigit(a) {
      var charCode = a.charCodeAt(0);
      return (charCode >= 48 && charCode <= 57) // 0-9
  }

  function decodeSamTags(tags) {

      var tagDict = {};
      tags.forEach(function (tag) {
          var tokens = tag.split(':');
          tagDict[tokens[0]] = tokens[2];
      });

      return tagDict
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Class for reading a bam file
   *
   * @param config
   * @constructor
   */
  class BamReaderNonIndexed {

      constructor(config, genome) {
          this.config = config;
          this.genome = genome;
          this.bamPath = config.url;
          this.isDataUri = isDataURL(config.url);
          BamUtils.setReaderDefaults(this, config);
      }

      // Return an alignment container
      async readAlignments(chr, bpStart, bpEnd) {

          if (this.alignmentCache) {
              const header = this.header;
              const queryChr = header.chrAliasTable.hasOwnProperty(chr) ? header.chrAliasTable[chr] : chr;
              const qAlignments = this.alignmentCache.queryFeatures(queryChr, bpStart, bpEnd);
              const alignmentContainer = new AlignmentContainer(chr, bpStart, bpEnd, this.config);
              for (let a of qAlignments) {
                  alignmentContainer.push(a);
              }
              alignmentContainer.finish();
              return alignmentContainer

          } else {
              if (this.isDataUri) {
                  const data = decodeDataURI$2(this.bamPath);
                  const unc = unbgzf$1(data.buffer);
                  this.parseAlignments(unc);
                  return this.fetchAlignments(chr, bpStart, bpEnd)
              } else {
                  const arrayBuffer = await igvxhr$1.loadArrayBuffer(this.bamPath, buildOptions(this.config));
                  const unc = unbgzf$1(arrayBuffer);
                  this.parseAlignments(unc);
                  return this.fetchAlignments(chr, bpStart, bpEnd)
              }
          }

      }

      parseAlignments(data) {
          const alignments = [];
          this.header = BamUtils.decodeBamHeader(data);
          BamUtils.decodeBamRecords(data, this.header.size, alignments, this.header.chrNames);
          this.alignmentCache = new FeatureCache$1(alignments, this.genome);
      }

      fetchAlignments(chr, bpStart, bpEnd) {
          const queryChr = this.header.chrAliasTable.hasOwnProperty(chr) ? this.header.chrAliasTable[chr] : chr;
          const features = this.alignmentCache.queryFeatures(queryChr, bpStart, bpEnd);
          const alignmentContainer = new AlignmentContainer(chr, bpStart, bpEnd, this.config);
          for (let feature of features) {
              alignmentContainer.push(feature);
          }
          alignmentContainer.finish();
          return alignmentContainer
      }

  }

  function decodeDataURI$2(dataURI) {

      const split = dataURI.split(',');
      const info = split[0].split(':')[1];
      let dataString = split[1];

      if (info.indexOf('base64') >= 0) {
          dataString = atob(dataString);
      } else {
          dataString = decodeURI(dataString);
      }

      const bytes = new Uint8Array(dataString.length);
      for (var i = 0; i < dataString.length; i++) {
          bytes[i] = dataString.charCodeAt(i);
      }
      return bytes
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Class for reading a bam file
   *
   * @param config
   * @constructor
   */
  class BamReader {

      constructor(config, genome) {
          this.config = config;
          this.genome = genome;
          this.bamPath = config.url;
          this.baiPath = config.indexURL;
          BamUtils.setReaderDefaults(this, config);

          this._blockLoader = new BGZBlockLoader(config);
      }

      async readAlignments(chr, bpStart, bpEnd) {

          const chrToIndex = await this.getChrIndex();
          const queryChr = this.chrAliasTable.hasOwnProperty(chr) ? this.chrAliasTable[chr] : chr;
          const chrId = chrToIndex[queryChr];
          const alignmentContainer = new AlignmentContainer(chr, bpStart, bpEnd, this.config);

          if (chrId === undefined) {
              return alignmentContainer

          } else {

              const bamIndex = await this.getIndex();
              const chunks = bamIndex.chunksForRange(chrId, bpStart, bpEnd);

              if (!chunks || chunks.length === 0) {
                  return alignmentContainer
              }

              for (let c of chunks) {
                  const ba = await this._blockLoader.getData(c.minv, c.maxv);
                  const done = BamUtils.decodeBamRecords(ba, c.minv.offset, alignmentContainer, this.indexToChr, chrId, bpStart, bpEnd, this.filter);
                  if (done) {
                      break
                  }
              }
              alignmentContainer.finish();
              return alignmentContainer
          }
      }

      async getHeader() {
          if (!this.header) {
              const genome = this.genome;
              const index = await this.getIndex();
              let len;
              if (index.firstBlockPosition) {
                  const bsizeOptions = buildOptions(this.config, {range: {start: index.firstBlockPosition, size: 26}});
                  const abuffer = await igvxhr$1.loadArrayBuffer(this.bamPath, bsizeOptions);
                  const bsize = bgzBlockSize$1(abuffer);
                  len = index.firstBlockPosition + bsize;   // Insure we get the complete compressed block containing the header
              } else {
                  len = 64000;
              }

              const options = buildOptions(this.config, {range: {start: 0, size: len}});
              this.header = await BamUtils.readHeader(this.bamPath, options, genome);
          }
          return this.header
      }

      async getIndex() {
          const genome = this.genome;
          if (!this.index) {
              this.index = await loadIndex(this.baiPath, this.config, genome);
          }
          return this.index
      }

      async getChrIndex() {
          if (this.chrToIndex) {
              return this.chrToIndex
          } else {
              const header = await this.getHeader();
              this.chrToIndex = header.chrToIndex;
              this.indexToChr = header.chrNames;
              this.chrAliasTable = header.chrAliasTable;
              return this.chrToIndex

          }
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class ShardedBamReader {

      constructor(config, genome) {

          this.config = config;
          this.genome = genome;

          const bamReaders = {};

          config.sources.sequences.forEach(function (chr) {
              const queryChr = genome ? genome.getChromosomeName(chr) : chr;
              bamReaders[queryChr] = getReader(config, genome, chr);
          });

          this.bamReaders = bamReaders;

          BamUtils.setReaderDefaults(this, config);
      }

      async readAlignments(chr, start, end) {

          if (!this.bamReaders.hasOwnProperty(chr)) {
              return new AlignmentContainer(chr, start, end, this.config)
          } else {

              let reader = this.bamReaders[chr];
              const a = await reader.readAlignments(chr, start, end);
              return a
          }
      }
  }

  function getReader(config, genome, chr) {
      const tmp = {
          url: config.sources.url.replace("$CHR", chr)
      };
      if (config.sources.indexURL) {
          tmp.indexURL = config.sources.indexURL.replace("$CHR", chr);
      }
      const bamConfig = Object.assign(config, tmp);

      // TODO -- support non-indexed, htsget, etc
      return new BamReader(bamConfig, genome)
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Class for reading bam records from an igv.js-flask server backed by pysam.  Deprecated.
   *
   * @param config
   * @constructor
   */
  const BamWebserviceReader = function (config, genome) {

      this.config = config;
      this.genome = genome;
      BamUtils.setReaderDefaults(this, config);

  };

  // Example http://localhost:5000/alignments/?reference=/Users/jrobinso/hg19mini.fa&file=/Users/jrobinso/cram_with_crai_index.cram&region=1:100-2000

  BamWebserviceReader.prototype.readAlignments = function (chr, bpStart, bpEnd) {

      var self = this;

      return getHeader.call(self)

          .then(function (header) {

              var queryChr, url;

              queryChr = header.chrAliasTable.hasOwnProperty(chr) ? header.chrAliasTable[chr] : chr;

              url = self.config.url +
                  "?reference=" + self.config.referenceFile +
                  "&file=" + self.config.alignmentFile + "" +
                  "&region=" + queryChr + ":" + bpStart + "-" + bpEnd;


              return igvxhr$1.loadString(url, buildOptions(self.config))

                  .then(function (sam) {

                      var alignmentContainer;

                      header.chrToIndex[queryChr];

                      alignmentContainer = new AlignmentContainer(chr, bpStart, bpEnd, self.config);

                      BamUtils.decodeSamRecords(sam, alignmentContainer, queryChr, bpStart, bpEnd, self.filter);

                      return alignmentContainer

                  })

          })
  };


  // Example  http://localhost:5000/alignments/?reference=/Users/jrobinso/hg19mini.fa&file=/Users/jrobinso/cram_with_crai_index.cram&options=-b%20-H
  function getHeader() {

      const self = this;
      const genome = this.genome;

      if (this.header) {

          return Promise.resolve(this.header)

      } else {

          const url = this.config.url + "?file=" + this.config.alignmentFile + "&options=-b,-H";
          const options = buildOptions(this.config);

          return BamUtils.readHeader(url, options, genome)

              .then(function (header) {

                  self.header = header;
                  return header

              })
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class HtsgetBamReader extends HtsgetReader {

      constructor(config, genome) {
          super(config, genome);
          BamUtils.setReaderDefaults(this, config);
      }


      async readAlignments(chr, start, end) {

          if (!this.header) {
              const compressedData = await this.readHeaderData();
              const ba = unbgzf$1(compressedData.buffer);
              this.header = BamUtils.decodeBamHeader(ba, this.genome);
              this.chrAliasTable = new Map();
              for (let key of Object.keys(this.header.chrAliasTable)) {
                  this.chrAliasTable.set(key, this.header.chrAliasTable[key]);
              }
          }

          let queryChr = this.chrAliasTable.has(chr) ? this.chrAliasTable.get(chr) : chr;

          const compressedData = await this.readData(queryChr, start, end);

          // BAM decoding
          const ba = unbgzf$1(compressedData.buffer);

          const chrIdx = this.header.chrToIndex[chr];
          const alignmentContainer = new AlignmentContainer(chr, start, end, this.config);
          BamUtils.decodeBamRecords(ba, this.header.size, alignmentContainer, this.header.chrNames, chrIdx, start, end);
          alignmentContainer.finish();

          return alignmentContainer

      }

  }

  /*! For license information please see cram-bundle.js.LICENSE.txt */
  const fn = ()=>{var e={368:function(e,t,r){var n=this&&this.__awaiter||function(e,t,r,n){return new(r||(r=Promise))((function(i,o){function s(e){try{f(n.next(e));}catch(e){o(e);}}function a(e){try{f(n.throw(e));}catch(e){o(e);}}function f(e){var t;e.done?i(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t);}))).then(s,a);}f((n=n.apply(e,t||[])).next());}))},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const o=i(r(4105)),s=i(r(1269)),a=r(597),f=r(3427),h=r(8577);function l(e,t){if(t.some((e=>void 0===e)))throw new h.CramMalformedError("invalid .crai index file");const[r,n,i,o,s,a]=t;e[r]||(e[r]=[]),e[r].push({start:n,span:i,containerStart:o,sliceStart:s,sliceBytes:a});}t.default=class{constructor(e){this.filehandle=(0, f.open)(e.url,e.path,e.filehandle),this._parseCache=new o.default({cache:new s.default({maxSize:1}),fill:(e,t)=>this.parseIndex()});}parseIndex(){const e={};return this.filehandle.readFile().then((e=>31===e[0]&&139===e[1]?(0, a.unzip)(e):e)).then((t=>{if(t.length>4&&21578050===t.readUInt32LE(0))throw new h.CramMalformedError("invalid .crai index file. note: file appears to be a .bai index. this is technically legal but please open a github issue if you need support");let r=[],n="";for(let i=0;i<t.length;i+=1){const o=t[i];if(o>=48&&o<=57||!n&&45===o)n+=String.fromCharCode(o);else if(9===o)r.push(Number.parseInt(n,10)),n="";else if(10===o)r.push(Number.parseInt(n,10)),n="",l(e,r),r=[];else if(13!==o&&32!==o)throw new h.CramMalformedError("invalid .crai index file")}return n&&r.push(Number.parseInt(n,10)),6===r.length&&l(e,r),Object.entries(e).forEach((([t,r])=>{e[t]=r.sort(((e,t)=>e.start-t.start||e.span-t.span));})),e}))}getIndex(e={}){return this._parseCache.get("index",null,e.signal)}hasDataForReferenceSequence(e){return n(this,void 0,void 0,(function*(){return !!(yield this.getIndex())[e]}))}getEntriesForRange(e,t,r){return n(this,void 0,void 0,(function*(){const n=(yield this.getIndex())[e];if(!n)return [];const i=e=>{const n=e.start,i=e.start+e.span;return n>r?-1:i<=t?1:0},o=[];for(let e=0;e<n.length;e+=1)0===i(n[e])&&o.push(n[e]);return o}))}};},1050:(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.default=class{constructor(e,t){this.parameters=e,this.dataType=t;}};},4863:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8577),o=n(r(1050)),s=r(1074);class a extends o.default{constructor(e,t){if(super(e,t),"int"!==this.dataType)throw new i.CramUnimplementedError(`${this.dataType} decoding not yet implemented by BETA codec`)}decode(e,t,r,n){return (0, s.getBits)(t.content,n.coreBlock,this.parameters.length)-this.parameters.offset}}t.default=a;},1738:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(9488),o=n(r(1050));class s extends o.default{constructor(e,t,r){if(super(e,t),this.instantiateCodec=r,"byteArray"!==t)throw new TypeError(`byteArrayLength does not support data type ${t}`)}decode(e,t,r,n){const i=this._getLengthCodec().decode(e,t,r,n),o=this._getDataCodec(),s=new Uint8Array(i);for(let a=0;a<i;a+=1)s[a]=o.decode(e,t,r,n);return s}_getLengthCodec(){const e=this.parameters.lengthsEncoding;return this.instantiateCodec(e,"int")}_getDataCodec(){const e=this.parameters.valuesEncoding;return this.instantiateCodec(e,"byte")}}t.default=s,"_getLengthCodec _getDataCodec".split(" ").forEach((e=>(0, i.tinyMemoize)(s,e)));},1405:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8577),o=n(r(1050)),s=r(1074);class a extends o.default{constructor(e,t){if(super(e,t),"byteArray"!==t)throw new TypeError(`byteArrayStop codec does not support data type ${t}`)}decode(e,t,r,n){const{blockContentId:o}=this.parameters,s=r[o];if(!s)throw new i.CramMalformedError(`no block found with content ID ${o}`);const a=n.externalBlocks.getCursor(o);return this._decodeByteArray(s,a)}_decodeByteArray(e,t){const r=e.content,{stopByte:n}=this.parameters,i=t.bytePosition;let o=t.bytePosition;for(;r[o]!==n&&o<r.length;){if(o===r.length)throw new s.CramBufferOverrunError("byteArrayStop reading beyond length of data buffer?");o+=1;}return t.bytePosition=o+1,r.subarray(i,o)}}t.default=a;},5844:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8577),o=n(r(1050)),s=r(9488),a=r(1074);class f extends o.default{constructor(e,t){if(super(e,t),"int"===this.dataType)this._decodeData=this._decodeInt;else {if("byte"!==this.dataType)throw new i.CramUnimplementedError(`${this.dataType} decoding not yet implemented by EXTERNAL codec`);this._decodeData=this._decodeByte;}}decode(e,t,r,n){const{blockContentId:o}=this.parameters,s=r[o];if(!s)throw new i.CramMalformedError(`no block found with content ID ${o}`);const a=n.externalBlocks.getCursor(o);return this._decodeData(s,a)}_decodeInt(e,t){const[r,n]=(0, s.parseItf8)(e.content,t.bytePosition);return t.bytePosition=t.bytePosition+n,r}_decodeByte(e,t){if(t.bytePosition>=e.content.length)throw new a.CramBufferOverrunError("attempted to read beyond end of block. this file seems truncated.");return e.content[t.bytePosition++]}}t.default=f;},4229:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8577),o=n(r(1050)),s=r(1074);class a extends o.default{constructor(e,t){if(super(e,t),"int"!==this.dataType)throw new i.CramUnimplementedError(`${this.dataType} decoding not yet implemented by GAMMA codec`)}decode(e,t,r,n){let i=1;for(;0===(0, s.getBits)(t.content,n.coreBlock,1);)i+=1;return ((0, s.getBits)(t.content,n.coreBlock,i-1)|1<<i-1)-this.parameters.offset}}t.default=a;},1074:(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.getBits=t.CramBufferOverrunError=void 0;class r extends Error{}t.CramBufferOverrunError=r,t.getBits=function(e,t,n){let i=0;if(t.bytePosition+(7-t.bitPosition+n)/8>e.length)throw new r("read error during decoding. the file seems to be truncated.");for(let r=n;r;r--)i<<=1,i|=e[t.bytePosition]>>t.bitPosition&1,t.bitPosition-=1,t.bitPosition<0&&(t.bytePosition+=1),t.bitPosition&=7;return i};},2082:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8577),o=n(r(1050)),s=r(1074);class a extends o.default{constructor(e,t){if(super(e,t),this.codes={},this.codeBook={},this.sortedByValue=[],this.sortedCodes=[],this.sortedValuesByBitCode=[],this.sortedBitCodes=[],this.sortedBitLengthsByBitCode=[],this.bitCodeToValue=[],!["byte","int"].includes(this.dataType))throw new TypeError(`${this.dataType} decoding not yet implemented by HUFFMAN_INT codec`);this.buildCodeBook(),this.buildCodes(),this.buildCaches(),0===this.sortedCodes[0].bitLength&&(this._decode=this._decodeZeroLengthCode);}buildCodeBook(){let e=new Array(this.parameters.numCodes);for(let t=0;t<this.parameters.numCodes;t+=1)e[t]={symbol:this.parameters.symbols[t],bitLength:this.parameters.bitLengths[t]};e=e.sort(((e,t)=>e.bitLength-t.bitLength||e.symbol-t.symbol)),this.codeBook={},e.forEach((e=>{this.codeBook[e.bitLength]||(this.codeBook[e.bitLength]=[]),this.codeBook[e.bitLength].push(e.symbol);}));}buildCodes(){this.codes={};let e=0,t=-1;Object.entries(this.codeBook).forEach((([r,n])=>{const o=parseInt(r,10);n.forEach((r=>{const n={bitLength:o,value:r,bitCode:0};t+=1;const s=o-e;if(t<<=s,n.bitCode=t,e+=s,function(e){let t=e-(e>>1)&1431655765;return t=(858993459&t)+(t>>2&858993459),16843009*(t+(t>>4)&252645135)>>24}(t)>o)throw new i.CramMalformedError("Symbol out of range");this.codes[r]=n;}));}));}buildCaches(){this.sortedCodes=Object.values(this.codes).sort(((e,t)=>e.bitLength-t.bitLength||e.bitCode-t.bitCode)),this.sortedByValue=Object.values(this.codes).sort(((e,t)=>e.value-t.value)),this.sortedValuesByBitCode=this.sortedCodes.map((e=>e.value)),this.sortedBitCodes=this.sortedCodes.map((e=>e.bitCode)),this.sortedBitLengthsByBitCode=this.sortedCodes.map((e=>e.bitLength));const e=Math.max(...this.sortedBitCodes);this.bitCodeToValue=new Array(e+1).fill(-1);for(let e=0;e<this.sortedBitCodes.length;e+=1)this.bitCodeToValue[this.sortedCodes[e].bitCode]=e;}decode(e,t,r,n){return this._decode(e,t,n.coreBlock)}_decodeZeroLengthCode(){return this.sortedCodes[0].value}_decode(e,t,r){const n=t.content;let o=0,a=0;for(let e=0;e<this.sortedCodes.length;e+=1){const t=this.sortedCodes[e].bitLength;a<<=t-o,a|=(0, s.getBits)(n,r,t-o),o=t;{const r=this.bitCodeToValue[a];if(r>-1&&this.sortedBitLengthsByBitCode[r]===t)return this.sortedValuesByBitCode[r];for(let r=e;this.sortedCodes[r+1].bitLength===t&&r<this.sortedCodes.length;r+=1)e+=1;}}throw new i.CramMalformedError("Huffman symbol not found.")}}t.default=a;},8772:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.instantiateCodec=void 0;const i=r(8577),o=n(r(2082)),s=n(r(5844)),a=n(r(1405)),f=n(r(1738)),h=n(r(4863)),l=n(r(4229)),u=n(r(8821)),c={1:s.default,3:o.default,4:f.default,5:a.default,6:h.default,7:u.default,9:l.default};t.instantiateCodec=function e(t,r){const n=(o="ignore"===r?0:t.codecId,c[o]);var o;if(!n)throw new i.CramUnimplementedError(`no codec implemented for codec ID ${t.codecId}`);return new n(t.parameters,r,e)};},8821:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8577),o=n(r(1050)),s=r(1074);class a extends o.default{constructor(e,t){if(super(e,t),"int"!==this.dataType)throw new i.CramUnimplementedError(`${this.dataType} decoding not yet implemented by SUBEXP codec`)}decode(e,t,r,n){let i,o,a=0;for(;(0, s.getBits)(t.content,n.coreBlock,1);)a+=1;return 0===a?(i=this.parameters.K,o=(0, s.getBits)(t.content,n.coreBlock,i)):(i=a+this.parameters.K-1,o=1<<i|(0, s.getBits)(t.content,n.coreBlock,i)),o-this.parameters.offset}}t.default=a;},2615:(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.default={CRAM_FLAG_PRESERVE_QUAL_SCORES:1,CRAM_FLAG_DETACHED:2,CRAM_FLAG_MATE_DOWNSTREAM:4,CRAM_FLAG_NO_SEQ:8,CRAM_FLAG_MASK:15,CRAM_M_REVERSE:1,CRAM_M_UNMAP:2,BAM_FPAIRED:1,BAM_FPROPER_PAIR:2,BAM_FUNMAP:4,BAM_FMUNMAP:8,BAM_FREVERSE:16,BAM_FMREVERSE:32,BAM_FREAD1:64,BAM_FREAD2:128,BAM_FSECONDARY:256,BAM_FQCFAIL:512,BAM_FDUP:1024,BAM_FSUPPLEMENTARY:2048,BAM_CMATCH:0,BAM_CINS:1,BAM_CDEL:2,BAM_CREF_SKIP:3,BAM_CSOFT_CLIP:4,BAM_CHARD_CLIP:5,BAM_CPAD:6,BAM_CEQUAL:7,BAM_CDIFF:8,BAM_CBACK:9,BAM_CIGAR_STR:"MIDNSHP:XB",BAM_CIGAR_SHIFT:4,BAM_CIGAR_MASK:15,BAM_CIGAR_TYPE:246183};},8543:(e,t,r)=>{Object.defineProperty(t,"__esModule",{value:!0});const n=r(8772),i=r(8577),o={BF:"int",CF:"int",RI:"int",RL:"int",AP:"int",RG:"int",MF:"int",NS:"int",NP:"int",TS:"int",NF:"int",TC:"byte",TN:"int",FN:"int",FC:"byte",FP:"int",BS:"byte",IN:"byteArray",SC:"byteArray",DL:"int",BA:"byte",BB:"byteArray",RS:"int",PD:"int",HC:"int",MQ:"int",RN:"byteArray",QS:"byte",QQ:"byteArray",TL:"int"};t.default=class{constructor(e){this.dataSeriesCodecCache={},this.tagCodecCache={},this.tagEncoding={},this.readNamesIncluded=e.preservation.RN,this.APdelta=e.preservation.AP,this.referenceRequired=!!e.preservation.RR,this.tagIdsDictionary=e.preservation.TD,this.substitutionMatrix=function(e){const t=new Array(5);for(let e=0;e<5;e+=1)t[e]=new Array(4);return t[0][e[0]>>6&3]="C",t[0][e[0]>>4&3]="G",t[0][e[0]>>2&3]="T",t[0][e[0]>>0&3]="N",t[1][e[1]>>6&3]="A",t[1][e[1]>>4&3]="G",t[1][e[1]>>2&3]="T",t[1][e[1]>>0&3]="N",t[2][e[2]>>6&3]="A",t[2][e[2]>>4&3]="C",t[2][e[2]>>2&3]="T",t[2][e[2]>>0&3]="N",t[3][e[3]>>6&3]="A",t[3][e[3]>>4&3]="C",t[3][e[3]>>2&3]="G",t[3][e[3]>>0&3]="N",t[4][e[4]>>6&3]="A",t[4][e[4]>>4&3]="C",t[4][e[4]>>2&3]="G",t[4][e[4]>>0&3]="T",t}(e.preservation.SM),this.dataSeriesEncoding=e.dataSeriesEncoding,this.tagEncoding=e.tagEncoding,this.preservation=e.preservation,this._size=e._size,this._endPosition=e._endPosition;}getCodecForTag(e){if(!this.tagCodecCache[e]){const t=this.tagEncoding[e];t&&(this.tagCodecCache[e]=(0, n.instantiateCodec)(t,"byteArray"));}return this.tagCodecCache[e]}getTagNames(e){return this.tagIdsDictionary[e]}getCodecForDataSeries(e){let t=this.dataSeriesCodecCache[e];if(void 0===t){const r=this.dataSeriesEncoding[e];if(r){const s=o[e];if(!s)throw new i.CramMalformedError(`data series name ${e} not defined in file compression header`);t=(0, n.instantiateCodec)(r,s),this.dataSeriesCodecCache[e]=t;}}return t}toJSON(){const e={};return Object.keys(this).forEach((t=>{/Cache$/.test(t)||(e[t]=this[t]);})),e}};},6284:function(e,t,r){var n=this&&this.__awaiter||function(e,t,r,n){return new(r||(r=Promise))((function(i,o){function s(e){try{f(n.next(e));}catch(e){o(e);}}function a(e){try{f(n.throw(e));}catch(e){o(e);}}function f(e){var t;e.done?i(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t);}))).then(s,a);}f((n=n.apply(e,t||[])).next());}))},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const o=r(8577),s=r(9488),a=i(r(6601)),f=i(r(8543));class h{constructor(e,t){this.file=e,this.filePosition=t;}getHeader(){return this._readContainerHeader(this.filePosition)}getCompressionHeaderBlock(){return n(this,void 0,void 0,(function*(){if(!(yield this.getHeader()).numRecords)return null;const e=yield this.file.getSectionParsers(),t=yield this.getFirstBlock();if(void 0===t)return;if("COMPRESSION_HEADER"!==t.contentType)throw new o.CramMalformedError(`invalid content type ${t.contentType} in what is supposed to be the compression header block`);const r=(0, s.parseItem)(t.content,e.cramCompressionHeader.parser,0,t.contentPosition);return Object.assign(Object.assign({},t),{parsedContent:r})}))}getFirstBlock(){return n(this,void 0,void 0,(function*(){const e=yield this.getHeader();return this.file.readBlock(e._endPosition)}))}getCompressionScheme(){return n(this,void 0,void 0,(function*(){const e=yield this.getCompressionHeaderBlock();if(e)return new f.default(e.parsedContent)}))}getSlice(e,t){return new a.default(this,e,t)}_readContainerHeader(e){return n(this,void 0,void 0,(function*(){const t=yield this.file.getSectionParsers(),{cramContainerHeader1:r,cramContainerHeader2:n}=t,{size:i}=yield this.file.stat();if(e>=i)return;const o=Buffer.allocUnsafe(r.maxLength);yield this.file.read(o,0,r.maxLength,e);const a=(0, s.parseItem)(o,r.parser),f=(0, s.itf8Size)(a.numLandmarks);if(e+a.length>=i)return void console.warn(`${this.file}: container header at ${e} indicates that the container has length ${a.length}, which extends beyond the length of the file. Skipping this container.`);const h=Buffer.allocUnsafe(n.maxLength(a.numLandmarks));yield this.file.read(h,0,n.maxLength(a.numLandmarks),e+a._size-f);const l=(0, s.parseItem)(h,n.parser);return this.file.validateChecksums&&void 0!==l.crc32&&(yield this.file.checkCrc32(e,a._size+l._size-f-4,l.crc32,`container header beginning at position ${e}`)),Object.assign(a,l,{_size:a._size+l._size-f,_endPosition:a._size+l._size-f+e})}))}}t.default=h,"getHeader getCompressionHeaderBlock getCompressionScheme".split(" ").forEach((e=>(0, s.tinyMemoize)(h,e)));},5457:function(e,t,r){var n=this&&this.__awaiter||function(e,t,r,n){return new(r||(r=Promise))((function(i,o){function s(e){try{f(n.next(e));}catch(e){o(e);}}function a(e){try{f(n.throw(e));}catch(e){o(e);}}function f(e){var t;e.done?i(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t);}))).then(s,a);}f((n=n.apply(e,t||[])).next());}))},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const o=r(597),s=i(r(2779)),a=i(r(1269)),f=r(8577),h=i(r(9675)),l=r(6141),u=i(r(3498)),c=i(r(6284)),d=r(3427),p=r(9488),g=r(7578);class m{constructor(e){var t;if(this.file=(0, d.open)(e.url,e.path,e.filehandle),this.validateChecksums=!0,this.fetchReferenceSequenceCallback=e.seqFetch,this.options={checkSequenceMD5:e.checkSequenceMD5,cacheSize:null!==(t=e.cacheSize)&&void 0!==t?t:2e4},this.featureCache=new a.default({maxSize:this.options.cacheSize}),function(){const e=new Uint32Array([287454020]),t=new Uint8Array(e.buffer);return 68===t[0]?0:17===t[0]?1:2}()>0)throw new Error("Detected big-endian machine, may be unable to run")}read(e,t,r,n){return this.file.read(e,t,r,n)}stat(){return this.file.stat()}getDefinition(){return n(this,void 0,void 0,(function*(){const e=Buffer.allocUnsafe(l.cramFileDefinition.maxLength);yield this.file.read(e,0,l.cramFileDefinition.maxLength,0);const t=l.cramFileDefinition.parser.parse(e).result;if(2!==t.majorVersion&&3!==t.majorVersion)throw new f.CramUnimplementedError(`CRAM version ${t.majorVersion} not supported`);return t}))}getSamHeader(){return n(this,void 0,void 0,(function*(){const e=yield this.getContainerById(0);if(!e)throw new f.CramMalformedError("file contains no containers");const t=yield e.getFirstBlock();if(void 0===t)return (0, g.parseHeaderText)("");const r=t.content,n=r.readInt32LE(0),i=r.toString("utf8",4,4+n);return this.header=i,(0, g.parseHeaderText)(i)}))}getHeaderText(){return n(this,void 0,void 0,(function*(){return yield this.getSamHeader(),this.header}))}getSectionParsers(){return n(this,void 0,void 0,(function*(){const{majorVersion:e}=yield this.getDefinition();return (0, l.getSectionParsers)(e)}))}getContainerById(e){return n(this,void 0,void 0,(function*(){const t=yield this.getSectionParsers();let r=t.cramFileDefinition.maxLength;const{size:n}=yield this.file.stat(),{cramContainerHeader1:i}=t;let o;for(let t=0;t<=e;t+=1){if(r+i.maxLength+8>=n)return;o=this.getContainerAtPosition(r);const s=yield o.getHeader();if(!s)throw new f.CramMalformedError(`container ${e} not found in file`);if(0===t){r=s._endPosition;for(let e=0;e<s.numBlocks;e+=1){const e=yield this.readBlock(r);if(void 0===e)return;r=e._endPosition;}}else r+=s._size+s.length;}return o}))}checkCrc32(e,t,r,i){return n(this,void 0,void 0,(function*(){const n=Buffer.allocUnsafe(t);yield this.file.read(n,0,t,e);const o=s.default.unsigned(n);if(o!==r)throw new f.CramMalformedError(`crc mismatch in ${i}: recorded CRC32 = ${r}, but calculated CRC32 = ${o}`)}))}containerCount(){return n(this,void 0,void 0,(function*(){const e=yield this.getSectionParsers(),{size:t}=yield this.file.stat(),{cramContainerHeader1:r}=e;let n=0,i=e.cramFileDefinition.maxLength;for(;i+r.maxLength+8<t;){const e=yield this.getContainerAtPosition(i).getHeader();if(!e)break;if(0===n){i=e._endPosition;for(let t=0;t<e.numBlocks;t+=1){const e=yield this.readBlock(i);if(void 0===e)return;i=e._endPosition;}}else i+=e._size+e.length;n+=1;}return n}))}getContainerAtPosition(e){return new c.default(this,e)}readBlockHeader(e){return n(this,void 0,void 0,(function*(){const t=yield this.getSectionParsers(),{cramBlockHeader:r}=t,{size:n}=yield this.file.stat();if(e+r.maxLength>=n)return;const i=Buffer.allocUnsafe(r.maxLength);return yield this.file.read(i,0,r.maxLength,e),(0, p.parseItem)(i,r.parser,0,e)}))}_parseSection(e,t,r=e.maxLength,i){return n(this,void 0,void 0,(function*(){let n;if(i)n=i;else {const{size:e}=yield this.file.stat();if(t+r>=e)return;n=Buffer.allocUnsafe(r),yield this.file.read(n,0,r,t);}const o=(0, p.parseItem)(n,e.parser,0,t);if(o._size!==r)throw new f.CramMalformedError(`section read error: requested size ${r} does not equal parsed size ${o._size}`);return o}))}_uncompress(e,t,r){if("gzip"===e)(0, o.unzip)(t).copy(r);else if("bzip2"===e){const e=bzip2.array(t);let n,i=bzip2.header(e),o=0;do{n=bzip2.decompress(e,i),-1!=n&&(Buffer.from(n).copy(r,o),o+=n.length,i-=n.length);}while(-1!=n)}else if("rans"===e)(0, h.default)(t,r);else if("rans4x16"===e)u.default.r4x16_uncompress(t,r);else if("arith"===e)u.default.arith_uncompress(t,r);else if("fqzcomp"===e)u.default.fqzcomp_uncompress(t,r);else {if("tok3"!==e)throw new f.CramUnimplementedError(`${e} decompression not yet implemented`);u.default.tok3_uncompress(t,r);}}readBlock(e){return n(this,void 0,void 0,(function*(){const{majorVersion:t}=yield this.getDefinition(),r=yield this.getSectionParsers(),n=yield this.readBlockHeader(e);if(void 0===n)return;const i=n._endPosition,o=Buffer.allocUnsafe(n.uncompressedSize),s=Object.assign(Object.assign({},n),{_endPosition:i,contentPosition:i,content:o});if("raw"!==n.compressionMethod){const e=Buffer.allocUnsafe(n.compressedSize);yield this.read(e,0,n.compressedSize,i),this._uncompress(n.compressionMethod,e,o);}else yield this.read(o,0,n.uncompressedSize,i);if(t>=3){const t=yield this._parseSection(r.cramBlockCrc32,i+n.compressedSize);if(void 0===t)return;s.crc32=t.crc32,this.validateChecksums&&(yield this.checkCrc32(e,n._size+n.compressedSize,t.crc32,"block data")),s._endPosition=t._endPosition,s._size=s.compressedSize+r.cramBlockCrc32.maxLength;}else s._endPosition=i+s.compressedSize,s._size=s.compressedSize;return s}))}}t.default=m,"getDefinition getSectionParsers getSamHeader".split(" ").forEach((e=>(0, p.tinyMemoize)(m,e)));},8222:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.CramRecord=void 0;const i=n(r(5457));var o=r(8631);Object.defineProperty(t,"CramRecord",{enumerable:!0,get:function(){return n(o).default}}),t.default=i.default;},8631:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.MateFlagsDecoder=t.CramFlagsDecoder=t.BamFlagsDecoder=t.MateFlags=t.CramFlags=t.BamFlags=void 0;const i=n(r(2615)),o={a:0,A:0,c:1,C:1,g:2,G:2,t:3,T:3,n:4,N:4};function s(e){const t={};for(const[r,n]of e)t["is"+n]=e=>!!(e&r),t["set"+n]=e=>e|r;return t}t.BamFlags=[[1,"Paired"],[2,"ProperlyPaired"],[4,"SegmentUnmapped"],[8,"MateUnmapped"],[16,"ReverseComplemented"],[32,"MateReverseComplemented"],[64,"Read1"],[128,"Read2"],[256,"Secondary"],[512,"FailedQc"],[1024,"Duplicate"],[2048,"Supplementary"]],t.CramFlags=[[1,"PreservingQualityScores"],[2,"Detached"],[4,"WithMateDownstream"],[8,"DecodeSequenceAsStar"]],t.MateFlags=[[1,"OnNegativeStrand"],[2,"Unmapped"]],t.BamFlagsDecoder=s(t.BamFlags),t.CramFlagsDecoder=s(t.CramFlags),t.MateFlagsDecoder=s(t.MateFlags),t.default=class{constructor({flags:e,cramFlags:t,readLength:r,mappingQuality:n,lengthOnRef:i,qualityScores:o,mateRecordNumber:s,readBases:a,readFeatures:f,mateToUse:h,readGroupId:l,readName:u,sequenceId:c,uniqueId:d,templateSize:p,alignmentStart:g,tags:m}){this.flags=e,this.cramFlags=t,this.readLength=r,this.mappingQuality=n,this.lengthOnRef=i,this.qualityScores=o,a&&(this.readBases=a),this.readGroupId=l,this.readName=u,this.sequenceId=c,this.uniqueId=d,this.templateSize=p,this.alignmentStart=g,this.tags=m,f&&(this.readFeatures=f),h&&(this.mate={flags:h.mateFlags,readName:h.mateReadName,sequenceId:h.mateSequenceId,alignmentStart:h.mateAlignmentStart}),s&&(this.mateRecordNumber=s);}isPaired(){return !!(this.flags&i.default.BAM_FPAIRED)}isProperlyPaired(){return !!(this.flags&i.default.BAM_FPROPER_PAIR)}isSegmentUnmapped(){return !!(this.flags&i.default.BAM_FUNMAP)}isMateUnmapped(){return !!(this.flags&i.default.BAM_FMUNMAP)}isReverseComplemented(){return !!(this.flags&i.default.BAM_FREVERSE)}isMateReverseComplemented(){return !!(this.flags&i.default.BAM_FMREVERSE)}isRead1(){return !!(this.flags&i.default.BAM_FREAD1)}isRead2(){return !!(this.flags&i.default.BAM_FREAD2)}isSecondary(){return !!(this.flags&i.default.BAM_FSECONDARY)}isFailedQc(){return !!(this.flags&i.default.BAM_FQCFAIL)}isDuplicate(){return !!(this.flags&i.default.BAM_FDUP)}isSupplementary(){return !!(this.flags&i.default.BAM_FSUPPLEMENTARY)}isDetached(){return !!(this.cramFlags&i.default.CRAM_FLAG_DETACHED)}hasMateDownStream(){return !!(this.cramFlags&i.default.CRAM_FLAG_MATE_DOWNSTREAM)}isPreservingQualityScores(){return !!(this.cramFlags&i.default.CRAM_FLAG_PRESERVE_QUAL_SCORES)}isUnknownBases(){return !!(this.cramFlags&i.default.CRAM_FLAG_NO_SEQ)}getReadBases(){if(!this.readBases&&this._refRegion){const e=function(e,t){if(!e.lengthOnRef&&!e.readLength)return null;if(e.isUnknownBases())return null;const r=e.alignmentStart-t.start;if(!e.readFeatures)return t.seq.substr(r,e.lengthOnRef).toUpperCase();let n="",i=r,o=0;for(;n.length<e.readLength;)if(o<e.readFeatures.length){const r=e.readFeatures[o];if("Q"===r.code||"q"===r.code)o+=1;else if(r.pos===n.length+1)if(o+=1,"b"===r.code){const e=r.data;n+=e,i+=e.length;}else "B"===r.code?(n+=r.data[0],i+=1):"X"===r.code?(n+=r.sub,i+=1):"I"===r.code?n+=r.data:"D"===r.code?i+=r.data:"i"===r.code?n+=r.data:"N"===r.code?i+=r.data:"S"===r.code?n+=r.data:"P"===r.code||r.code;else if(o<e.readFeatures.length){const r=t.seq.substr(i,e.readFeatures[o].pos-n.length-1);n+=r,i+=r.length;}}else {const r=t.seq.substr(i,e.readLength-n.length);n+=r,i+=r.length;}return n.toUpperCase()}(this,this._refRegion);e&&(this.readBases=e);}return this.readBases}getPairOrientation(){if(!this.isSegmentUnmapped()&&this.isPaired()&&!this.isMateUnmapped()&&this.mate&&this.sequenceId===this.mate.sequenceId){const e=this.isReverseComplemented()?"R":"F",t=this.isMateReverseComplemented()?"R":"F";let r=" ",n=" ";this.isRead1()?(r="1",n="2"):this.isRead2()&&(r="2",n="1");const i=[];let o=this.templateLength||this.templateSize;if(void 0===o)throw new Error("One of templateSize and templateLength must be set");return this.alignmentStart>this.mate.alignmentStart&&o>0&&(o=-o),o>0?(i[0]=e,i[1]=r,i[2]=t,i[3]=n):(i[2]=e,i[3]=r,i[0]=t,i[1]=n),i.join("")}return null}addReferenceSequence(e,t){this.readFeatures&&this.readFeatures.forEach((r=>{"X"===r.code&&function(e,t,r,n){if(!t)return;const i=n.refPos-t.start,s=t.seq.charAt(i);s&&(n.ref=s);let a=o[s];void 0===a&&(a=4);const f=r.substitutionMatrix[a][n.data];f&&(n.sub=f);}(0,e,t,r);})),!this.readBases&&e.start<=this.alignmentStart&&e.end>=this.alignmentStart+(this.lengthOnRef||this.readLength)-1&&(this._refRegion=e);}toJSON(){const e={};return Object.keys(this).forEach((t=>{"_"!==t.charAt(0)&&(e[t]=this[t]);})),e.readBases=this.getReadBases(),e}};},6141:(e,t,r)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.getSectionParsers=t.cramFileDefinition=t.isMappedSliceHeader=void 0;const n=r(9996),i=(new n.Parser).itf8(),o={parser:(new n.Parser).string("magic",{length:4}).uint8("majorVersion").uint8("minorVersion").string("fileId",{length:20,stripNull:!0}),maxLength:26};t.cramFileDefinition=o;const s={parser:(new n.Parser).uint8("compressionMethod",{formatter:e=>{const t=["raw","gzip","bzip2","lzma","rans","rans4x16","arith","fqzcomp","tok3"][e];if(!t)throw new Error(`compression method number ${e} not implemented`);return t}}).uint8("contentType",{formatter:e=>{const t=["FILE_HEADER","COMPRESSION_HEADER","MAPPED_SLICE_HEADER","UNMAPPED_SLICE_HEADER","EXTERNAL_DATA","CORE_DATA"][e];if(!t)throw new Error(`invalid block content type id ${e}`);return t}}).itf8("contentId").itf8("compressedSize").itf8("uncompressedSize"),maxLength:17},a={parser:(new n.Parser).uint32("crc32"),maxLength:4},f=(new n.Parser).itf8("size").buffer("ents",{length:"size",formatter:e=>{function t(t,r){const n=e.toString("utf8",t,r),i=[];for(let e=0;e<n.length;e+=3)i.push(n.substr(e,3));return i}var r,n=[],i=0;for(r=0;r<e.length;r+=1)e[r]||(n.push(t(i,r)),i=r+1);return r>i&&n.push(t(i,r)),n}}),h=(new n.Parser).uint8(null,{formatter:e=>!!e}),l=(new n.Parser).itf8("mapSize").itf8("mapCount").array("ents",{length:"mapCount",type:(new n.Parser).string("key",{length:2,stripNull:!1}).choice("value",{tag:"key",choices:{MI:h,UI:h,PI:h,RN:h,AP:h,RR:h,SM:(new n.Parser).array(null,{type:"uint8",length:5}),TD:(new n.Parser).nest(null,{type:f,formatter:e=>e.ents})}})});function u(e){const t={};for(let r=0;r<e.ents.length;r+=1){const{key:n,value:i}=e.ents[r];t[n]&&console.warn(`duplicate key ${n} in map`),t[n]=i;}return t}const c={cramFileDefinition:o,cramBlockHeader:s,cramBlockCrc32:a};t.isMappedSliceHeader=function(e){return "number"==typeof e.refSeqId};const d={cramUnmappedSliceHeader(e){let t=0,r=(new n.Parser).itf8("numRecords");return t+=5,e>=3?(r=r.ltf8("recordCounter"),t+=9):2===e&&(r=r.itf8("recordCounter"),t+=5),r=r.itf8("numBlocks").itf8("numContentIds").array("contentIds",{type:i,length:"numContentIds"}),t+=10,e>=2&&(r=r.array("md5",{type:"uint8",length:16}),t+=16),{parser:r,maxLength:e=>t+5*e}},cramMappedSliceHeader(e){let t=(new n.Parser).itf8("refSeqId").itf8("refSeqStart").itf8("refSeqSpan").itf8("numRecords"),r=20;return e>=3?(t=t.ltf8("recordCounter"),r+=9):2===e&&(t=t.itf8("recordCounter"),r+=5),t=t.itf8("numBlocks").itf8("numContentIds").array("contentIds",{type:i,length:"numContentIds"}).itf8("refBaseBlockId"),r+=15,e>=2&&(t=t.array("md5",{type:"uint8",length:16}),r+=16),{parser:t,maxLength:e=>r+5*e}},cramEncoding:e=>({parser:(new n.Parser).namely("cramEncoding").itf8("codecId").itf8("parametersBytes").choice("parameters",{tag:"codecId",choices:{0:new n.Parser,1:(new n.Parser).itf8("blockContentId"),2:(new n.Parser).itf8("offset").itf8("M"),3:n.Parser.start().itf8("numCodes").array("symbols",{length:"numCodes",type:i}).itf8("numLengths").array("bitLengths",{length:"numLengths",type:i}),4:n.Parser.start().nest("lengthsEncoding",{type:"cramEncoding"}).nest("valuesEncoding",{type:"cramEncoding"}),5:(new n.Parser).uint8("stopByte").itf8("blockContentId"),6:(new n.Parser).itf8("offset").itf8("length"),7:(new n.Parser).itf8("offset").itf8("K"),8:(new n.Parser).itf8("offset").itf8("log2m"),9:(new n.Parser).itf8("offset")}})}),cramDataSeriesEncodingMap(e){return (new n.Parser).itf8("mapSize").itf8("mapCount").array("ents",{length:"mapCount",type:(new n.Parser).string("key",{length:2,stripNull:!1}).nest("value",{type:this.cramEncoding(e).parser})})},cramTagEncodingMap(e){return (new n.Parser).itf8("mapSize").itf8("mapCount").array("ents",{length:"mapCount",type:(new n.Parser).itf8("key",{formatter:e=>String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(255&e)}).nest("value",{type:this.cramEncoding(e).parser})})},cramCompressionHeader(e){let t=new n.Parser;return t=t.nest("preservation",{type:l,formatter:u}).nest("dataSeriesEncoding",{type:this.cramDataSeriesEncodingMap(e),formatter:u}).nest("tagEncoding",{type:this.cramTagEncodingMap(e),formatter:u}),{parser:t}},cramContainerHeader1(e){let t=(new n.Parser).int32("length").itf8("refSeqId").itf8("refSeqStart").itf8("alignmentSpan").itf8("numRecords"),r=24;return e>=3?(t=t.ltf8("recordCounter"),r+=9):2===e&&(t=t.itf8("recordCounter"),r+=5),e>1&&(t=t.ltf8("numBases"),r+=9),t=t.itf8("numBlocks").itf8("numLandmarks"),r+=10,{parser:t,maxLength:r}},cramContainerHeader2(e){let t=(new n.Parser).itf8("numLandmarks").array("landmarks",{type:(new n.Parser).itf8(),length:"numLandmarks"}),r=0;return e>=3&&(t=t.uint32("crc32"),r=4),{parser:t,maxLength:e=>5+5*e+r}}};t.getSectionParsers=function(e){const t=Object.assign({},c);return Object.keys(d).forEach((r=>{t[r]=d[r](e);})),t};},3757:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=n(r(3720)),o=r(8577),s=r(8631),a=r(6141);function f(e){let t="";for(let r=0;r<e.length&&0!==e[r];r++)t+=String.fromCharCode(e[r]);return t}function h(e,t){if("Z"===e)return f(t);if("A"===e)return String.fromCharCode(t[0]);if("I"===e)return i.default.fromBytesLE(t).toNumber();if("i"===e)return new Int32Array(t.buffer)[0];if("s"===e)return new Int16Array(t.buffer)[0];if("S"===e)return new Uint16Array(t.buffer)[0];if("c"===e)return new Int8Array(t.buffer)[0];if("C"===e)return t[0];if("f"===e)return new Float32Array(t.buffer)[0];if("H"===e)return Number.parseInt(f(t).replace(/^0x/,""),16);if("B"===e)return function(e){const t=String.fromCharCode(e[0]),r=Int32Array.from(e.slice(1))[0],n=new Array(r);if(e=e.slice(5),"c"===t){const t=new Int8Array(e.buffer);for(let e=0;e<r;e+=1)n[e]=t[e];}else if("C"===t){const t=new Uint8Array(e.buffer);for(let e=0;e<r;e+=1)n[e]=t[e];}else if("s"===t){const t=new Int16Array(e.buffer);for(let e=0;e<r;e+=1)n[e]=t[e];}else if("S"===t){const t=new Uint16Array(e.buffer);for(let e=0;e<r;e+=1)n[e]=t[e];}else if("i"===t){const t=new Int32Array(e.buffer);for(let e=0;e<r;e+=1)n[e]=t[e];}else if("I"===t){const t=new Uint32Array(e.buffer);for(let e=0;e<r;e+=1)n[e]=t[e];}else {if("f"!==t)throw new Error("unknown type: "+t);{const t=new Float32Array(e.buffer);for(let e=0;e<r;e+=1)n[e]=t[e];}}return n}(t);throw new o.CramMalformedError(`Unrecognized tag type ${e}`)}t.default=function(e,t,r,n,i,l,u,c,d){let p=t("BF");const g=t("CF");if(!(0, a.isMappedSliceHeader)(n.parsedContent))throw new Error;let m;m=c>1&&-2===n.parsedContent.refSeqId?t("RI"):n.parsedContent.refSeqId;const y=t("RL");let b=t("AP");r.APdelta&&(b+=u.lastAlignmentStart),u.lastAlignmentStart=b;const v=t("RG");let w,_,B,E;if(r.readNamesIncluded&&(w=f(t("RN"))),s.CramFlagsDecoder.isDetached(g)){const e=t("MF");let n;r.readNamesIncluded||(n=f(t("RN")),w=n);const i=t("NS"),o=t("NP");(e||i>-1)&&(_={mateFlags:e,mateSequenceId:i,mateAlignmentStart:o,mateReadName:n}),B=t("TS"),s.MateFlagsDecoder.isUnmapped(e)&&(p=s.BamFlagsDecoder.setMateUnmapped(p)),s.MateFlagsDecoder.isOnNegativeStrand(e)&&(p=s.BamFlagsDecoder.setMateReverseComplemented(p));}else s.CramFlagsDecoder.isWithMateDownstream(g)&&(E=t("NF")+d+1);const S=t("TL");if(S<0)throw new o.CramMalformedError("invalid TL index");const A={},C=r.getTagNames(S),R=C.length;for(let t=0;t<R;t+=1){const n=C[t],s=n.substr(0,2),a=n.substr(2,1),f=r.getCodecForTag(n);if(!f)throw new o.CramMalformedError(`no codec defined for auxiliary tag ${n}`);const c=f.decode(e,i,l,u);A[s]=h(a,c);}let k,x,I,M,F;if(s.BamFlagsDecoder.isSegmentUnmapped(p))if(s.CramFlagsDecoder.isDecodeSequenceAsStar(g))F=null,M=null;else {const e=new Array(y);for(let r=0;r<e.length;r+=1)e[r]=t("BA");if(F=String.fromCharCode(...e),s.CramFlagsDecoder.isPreservingQualityScores(g)){M=new Array(y);for(let r=0;r<e.length;r+=1)M[r]=t("QS");}}else {const e=t("FN");if(e&&(k=function(e,t,r,n,i){let s=0,a=e-1;const f=new Array(t);function h([e,t]){const n=r(t);if("character"===e)return String.fromCharCode(n);if("string"===e){let e="";for(let t=0;t<n.byteLength;t++)e+=String.fromCharCode(n[t]);return e}return "numArray"===e?n.toArray():n}for(let e=0;e<t;e+=1){const t=String.fromCharCode(r("FC")),n=r("FP"),l={B:["character","BA"],S:["string",i>1?"SC":"IN"],X:["number","BS"],D:["number","DL"],I:["string","IN"],i:["character","BA"],b:["string","BB"],q:["numArray","QQ"],Q:["number","QS"],H:["number","HC"],P:["number","PD"],N:["number","RS"]}[t];if(!l)throw new o.CramMalformedError(`invalid read feature code "${t}"`);let u=h(l);const c={B:["number","QS"]}[t];c&&(u=[u,h(c)]),s+=n;const d=s;a+=n;const p=a;"D"===t||"N"===t?a+=u:"I"===t||"S"===t?a-=u.length:"i"===t&&(a-=1),f[e]={code:t,pos:d,refPos:p,data:u};}return f}(b,e,t,0,c)),x=y,k)for(const{code:e,data:t}of k)"D"===e||"N"===e?x+=t:"I"===e||"S"===e?x-=t.length:"i"===e&&(x-=1);if(Number.isNaN(x)&&(console.warn(`${w||`${m}:${b}`} record has invalid read features`),x=y),I=t("MQ"),s.CramFlagsDecoder.isPreservingQualityScores(g)){M=new Array(y);for(let e=0;e<M.length;e++)M[e]=t("QS");}}return {readLength:y,sequenceId:m,cramFlags:g,flags:p,alignmentStart:b,readGroupId:v,readName:w,mateToUse:_,templateSize:B,mateRecordNumber:E,readFeatures:k,lengthOnRef:x,mappingQuality:I,qualityScores:M,readBases:F,tags:A}};},6601:function(e,t,r){var n=this&&this.__awaiter||function(e,t,r,n){return new(r||(r=Promise))((function(i,o){function s(e){try{f(n.next(e));}catch(e){o(e);}}function a(e){try{f(n.throw(e));}catch(e){o(e);}}function f(e){var t;e.done?i(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t);}))).then(s,a);}f((n=n.apply(e,t||[])).next());}))},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const o=r(8577),s=r(9488),a=i(r(2615)),f=i(r(3757)),h=i(r(8631)),l=r(6141),u=r(1074);function c(e,t,r,n){if(!n)throw new o.CramMalformedError("could not resolve intra-slice mate pairs, file seems truncated or malformed");const i=!!(n.mate||void 0!==n.mateRecordNumber&&n.mateRecordNumber!==t);r.readName||(r.readName=String(r.uniqueId),n.readName=r.readName),r.mate={sequenceId:n.sequenceId,alignmentStart:n.alignmentStart,uniqueId:n.uniqueId},n.readName&&(r.mate.readName=n.readName),n.mate||void 0!==n.mateRecordNumber||(n.mate={sequenceId:r.sequenceId,alignmentStart:r.alignmentStart,uniqueId:r.uniqueId},r.readName&&(n.mate.readName=r.readName)),r.flags|=a.default.BAM_FPAIRED,n.flags&a.default.BAM_FUNMAP&&(r.flags|=a.default.BAM_FMUNMAP),r.flags&a.default.BAM_FUNMAP&&(n.flags|=a.default.BAM_FMUNMAP),n.flags&a.default.BAM_FREVERSE&&(r.flags|=a.default.BAM_FMREVERSE),r.flags&a.default.BAM_FREVERSE&&(n.flags|=a.default.BAM_FMREVERSE),void 0===r.templateLength&&(i?function(e,t,r){const n=function t(r){const n=[r];if(void 0!==r.mateRecordNumber&&r.mateRecordNumber>=0){const i=e[r.mateRecordNumber];if(!i)throw new o.CramMalformedError("intra-slice mate record not found, this file seems malformed");n.push(...t(i));}return n}(r),i=n.map((e=>e.alignmentStart)),s=n.map((e=>e.alignmentStart+e.readLength-1)),a=Math.max(...s)-Math.min(...i)+1;a>=0&&n.forEach((e=>{if(void 0!==e.templateLength)throw new o.CramMalformedError("mate pair group has some members that have template lengths already, this file seems malformed");e.templateLength=a;}));}(e,0,r):function(e,t){const r=Math.min(e.alignmentStart,t.alignmentStart),n=Math.max(e.alignmentStart+e.readLength-1,t.alignmentStart+t.readLength-1)-r+1;e.templateLength=n,t.templateLength=n;}(r,n)),delete r.mateRecordNumber;}class d{constructor(e,t,r){this.container=e,this.containerPosition=t,this.file=e.file;}getHeader(){return n(this,void 0,void 0,(function*(){const e=yield this.file.getSectionParsers(),t=yield this.container.getHeader(),r=yield this.file.readBlock(t._endPosition+this.containerPosition);if(void 0===r)throw new Error;if("MAPPED_SLICE_HEADER"===r.contentType){const n=(0, s.parseItem)(r.content,e.cramMappedSliceHeader.parser,0,t._endPosition);return Object.assign(Object.assign({},r),{parsedContent:n})}if("UNMAPPED_SLICE_HEADER"===r.contentType){const n=(0, s.parseItem)(r.content,e.cramUnmappedSliceHeader.parser,0,t._endPosition);return Object.assign(Object.assign({},r),{parsedContent:n})}throw new o.CramMalformedError(`error reading slice header block, invalid content type ${r.contentType}`)}))}getBlocks(){return n(this,void 0,void 0,(function*(){const e=yield this.getHeader();let t=e._endPosition;const r=new Array(e.parsedContent.numBlocks);for(let e=0;e<r.length;e+=1){const n=yield this.file.readBlock(t);if(void 0===n)throw new Error;r[e]=n,t=r[e]._endPosition;}return r}))}getCoreDataBlock(){return n(this,void 0,void 0,(function*(){return (yield this.getBlocks())[0]}))}_getBlocksContentIdIndex(){return n(this,void 0,void 0,(function*(){const e=yield this.getBlocks(),t={};return e.forEach((e=>{"EXTERNAL_DATA"===e.contentType&&(t[e.contentId]=e);})),t}))}getBlockByContentId(e){return n(this,void 0,void 0,(function*(){return (yield this._getBlocksContentIdIndex())[e]}))}getReferenceRegion(){return n(this,void 0,void 0,(function*(){const e=(yield this.getHeader()).parsedContent;if(!(0, l.isMappedSliceHeader)(e))throw new Error;if(e.refSeqId<0)return;const t=yield this.container.getCompressionScheme();if(void 0===t)throw new Error;if(e.refBaseBlockId>=0){const t=yield this.getBlockByContentId(e.refBaseBlockId);if(!t)throw new o.CramMalformedError("embedded reference specified, but reference block does not exist");return {seq:t.data.toString("utf8"),start:e.refSeqStart,end:e.refSeqStart+e.refSeqSpan-1,span:e.refSeqSpan}}if(t.referenceRequired||this.file.fetchReferenceSequenceCallback){if(!this.file.fetchReferenceSequenceCallback)throw new Error("reference sequence not embedded, and seqFetch callback not provided, cannot fetch reference sequence");const t=yield this.file.fetchReferenceSequenceCallback(e.refSeqId,e.refSeqStart,e.refSeqStart+e.refSeqSpan-1);if(t.length!==e.refSeqSpan)throw new o.CramArgumentError("seqFetch callback returned a reference sequence of the wrong length");return {seq:t,start:e.refSeqStart,end:e.refSeqStart+e.refSeqSpan-1,span:e.refSeqSpan}}}))}getAllRecords(){return this.getRecords((()=>!0))}_fetchRecords(){return n(this,void 0,void 0,(function*(){const{majorVersion:e}=yield this.file.getDefinition(),t=yield this.container.getCompressionScheme();if(void 0===t)throw new Error;const r=yield this.getHeader();if(void 0===r)throw new Error;const n=yield this._getBlocksContentIdIndex();if(e>1&&this.file.options.checkSequenceMD5&&(0, l.isMappedSliceHeader)(r.parsedContent)&&r.parsedContent.refSeqId>=0&&"0000000000000000"!==r.parsedContent.md5.join("")){const e=yield this.getReferenceRegion();if(e){const{seq:t,start:n,end:i}=e,a=(0, s.sequenceMD5)(t),f=r.parsedContent.md5.map((e=>(e<16?"0":"")+e.toString(16))).join("");if(a!==f)throw new o.CramMalformedError(`MD5 checksum reference mismatch for ref ${r.parsedContent.refSeqId} pos ${n}..${i}. recorded MD5: ${f}, calculated MD5: ${a}`)}}const i=yield this.getCoreDataBlock(),a={lastAlignmentStart:(0, l.isMappedSliceHeader)(r.parsedContent)?r.parsedContent.refSeqStart:0,coreBlock:{bitPosition:7,bytePosition:0},externalBlocks:{map:new Map,getCursor(e){let t=this.map.get(e);return void 0===t&&(t={bitPosition:7,bytePosition:0},this.map.set(e,t)),t}}},d=e=>{const r=t.getCodecForDataSeries(e);if(!r)throw new o.CramMalformedError(`no codec defined for ${e} data series`);return r.decode(this,i,n,a)};let p=new Array(r.parsedContent.numRecords);for(let o=0;o<p.length;o+=1)try{const s=(0,f.default)(this,d,t,r,i,n,a,e,o);p[o]=new h.default(Object.assign(Object.assign({},s),{uniqueId:r.contentPosition+r.parsedContent.recordCounter+o+1}));}catch(e){if(e instanceof u.CramBufferOverrunError){console.warn("read attempted beyond end of buffer, file seems truncated."),p=p.filter((e=>!!e));break}throw e}for(let e=0;e<p.length;e+=1){const{mateRecordNumber:t}=p[e];void 0!==t&&t>=0&&c(p,e,p[e],p[t]);}return p}))}getRecords(e){return n(this,void 0,void 0,(function*(){const t=this.container.filePosition+this.containerPosition;let r=this.file.featureCache.get(t.toString());r||(r=this._fetchRecords(),this.file.featureCache.set(t.toString(),r));const i=(yield r).filter(e);if(i.length&&this.file.fetchReferenceSequenceCallback){const e=yield this.getHeader();if((0, l.isMappedSliceHeader)(e.parsedContent)&&(e.parsedContent.refSeqId>=0||-2===e.parsedContent.refSeqId)){const t=e.parsedContent.refSeqId>=0?e.parsedContent.refSeqId:void 0,r=yield this.container.getCompressionScheme();if(void 0===r)throw new Error;const o={};for(let e=0;e<i.length;e+=1){const r=void 0!==t?t:i[e].sequenceId;let n=o[r];n||(n={id:r,start:i[e].alignmentStart,end:-1/0,seq:null},o[r]=n);const s=i[e].alignmentStart+(i[e].lengthOnRef||i[e].readLength)-1;s>n.end&&(n.end=s),i[e].alignmentStart<n.start&&(n.start=i[e].alignmentStart);}yield Promise.all(Object.values(o).map((e=>n(this,void 0,void 0,(function*(){-1!==e.id&&e.start<=e.end&&(e.seq=yield this.file.fetchReferenceSequenceCallback(e.id,e.start,e.end));})))));for(let e=0;e<i.length;e+=1){const n=o[void 0!==t?t:i[e].sequenceId];if(n&&n.seq){const t=n.seq;i[e].addReferenceSequence(Object.assign(Object.assign({},n),{seq:t}),r);}}}}return i}))}}t.default=d,"getHeader getBlocks _getBlocksContentIdIndex".split(" ").forEach((e=>(0, s.tinyMemoize)(d,e)));},9488:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.sequenceMD5=t.tinyMemoize=t.parseItem=t.parseItf8=t.itf8Size=void 0;const i=n(r(2568)),o=r(1074);t.itf8Size=function(e){return -128&e?-16384&e?-2097152&e?-268435456&e?5:4:3:2:1},t.parseItf8=function(e,t){let r=t;const n=e[r];let i;if(n<128?(i=n,r+=1):n<192?(i=16383&(n<<8|e[r+1]),r+=2):n<224?(i=2097151&(n<<16|e[r+1]<<8|e[r+2]),r+=3):n<240?(i=268435455&(n<<24|e[r+1]<<16|e[r+2]<<8|e[r+3]),r+=4):(i=(15&n)<<28|e[r+1]<<20|e[r+2]<<12|e[r+3]<<4|15&e[r+4],r+=5),r>e.length)throw new o.CramBufferOverrunError("Attempted to read beyond end of buffer; this file seems truncated.");return [i,r-t]},t.parseItem=function(e,t,r=0,n=0){const{offset:i,result:o}=t.parse(e);return Object.assign(Object.assign({},o),{_endPosition:i+n,_size:i-r})},t.tinyMemoize=function(e,t){const r=e.prototype[t],n=`_memo_${t}`;e.prototype[t]=function(){if(!(n in this)){const e=r.call(this);this[n]=e,Promise.resolve(e).catch((()=>{delete this[n];}));}return this[n]};},t.sequenceMD5=function(e){return (0, i.default)(e.toUpperCase().replace(/[^\x21-\x7e]/g,""))};},8577:(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.CramArgumentError=t.CramSizeLimitError=t.CramMalformedError=t.CramUnimplementedError=t.CramError=void 0;class r extends Error{}t.CramError=r;class n extends Error{}t.CramUnimplementedError=n,t.CramMalformedError=class extends r{},t.CramSizeLimitError=class extends r{},t.CramArgumentError=class extends r{};},5590:function(e,t,r){var n=this&&this.__createBinding||(Object.create?function(e,t,r,n){void 0===n&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);i&&!("get"in i?!t.__esModule:i.writable||i.configurable)||(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){void 0===n&&(n=r),e[n]=t[r];}),i=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t});}:function(e,t){e.default=t;}),o=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&n(t,e,r);return i(t,e),t},s=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.CramRecord=t.CraiIndex=t.IndexedCramFile=t.CramFile=void 0;const a=o(r(8222));t.CramFile=a.default,Object.defineProperty(t,"CramRecord",{enumerable:!0,get:function(){return a.CramRecord}});const f=s(r(946));t.IndexedCramFile=f.default;const h=s(r(368));t.CraiIndex=h.default;},946:function(e,t,r){var n=this&&this.__awaiter||function(e,t,r,n){return new(r||(r=Promise))((function(i,o){function s(e){try{f(n.next(e));}catch(e){o(e);}}function a(e){try{f(n.throw(e));}catch(e){o(e);}}function f(e){var t;e.done?i(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t);}))).then(s,a);}f((n=n.apply(e,t||[])).next());}))},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const o=r(8577),s=i(r(8222));t.default=class{constructor(e){if(e.cram?this.cram=e.cram:this.cram=new s.default({url:e.cramUrl,path:e.cramPath,filehandle:e.cramFilehandle,seqFetch:e.seqFetch,checkSequenceMD5:e.checkSequenceMD5,cacheSize:e.cacheSize}),!(this.cram instanceof s.default))throw new Error("invalid arguments: no cramfile");if(this.index=e.index,!this.index.getEntriesForRange)throw new Error("invalid arguments: not an index");this.fetchSizeLimit=e.fetchSizeLimit||3e6;}getRecordsForRange(e,t,r,i={}){return n(this,void 0,void 0,(function*(){if(i.viewAsPairs=i.viewAsPairs||!1,i.pairAcrossChr=i.pairAcrossChr||!1,i.maxInsertSize=i.maxInsertSize||2e5,"string"==typeof e)throw new o.CramUnimplementedError("string sequence names not yet supported");const n=e,s=yield this.index.getEntriesForRange(n,t,r),a=s.map((e=>e.sliceBytes)).reduce(((e,t)=>e+t),0);if(a>this.fetchSizeLimit)throw new o.CramSizeLimitError(`data size of ${a.toLocaleString()} bytes exceeded fetch size limit of ${this.fetchSizeLimit.toLocaleString()} bytes`);const f=n=>n.sequenceId===e&&n.alignmentStart<=r&&void 0!==n.lengthOnRef&&n.alignmentStart+n.lengthOnRef-1>=t,h=yield Promise.all(s.map((e=>this.getRecordsInSlice(e,f))));let l=Array.prototype.concat(...h);if(i.viewAsPairs){const e={},t={};for(let r=0;r<l.length;r+=1){const n=l[r].readName;if(void 0===n)throw new Error;const i=l[r].uniqueId;e[n]||(e[n]=0),e[n]+=1,t[i]=1;}const r={};Object.entries(e).forEach((([e,t])=>{1===t&&(r[e]=!0);}));const o=[];for(let e=0;e<l.length;e+=1){const t=l[e],s=t.readName;if(void 0===s)throw new Error;if(r[s]&&t.mate&&(t.mate.sequenceId===n||i.pairAcrossChr)&&Math.abs(t.alignmentStart-t.mate.alignmentStart)<i.maxInsertSize){const e=this.index.getEntriesForRange(t.mate.sequenceId,t.mate.alignmentStart,t.mate.alignmentStart+1);o.push(e);}}const s=yield Promise.all(o);let a=[];for(let e=0;e<s.length;e+=1)a.push(...s[e]);a=a.sort(((e,t)=>e.toString().localeCompare(t.toString()))).filter(((e,t,r)=>!t||e.toString()!==r[t-1].toString()));const h=[],u=a.map((e=>e.sliceBytes)).reduce(((e,t)=>e+t),0);if(u>this.fetchSizeLimit)throw new Error(`mate data size of ${u.toLocaleString()} bytes exceeded fetch size limit of ${this.fetchSizeLimit.toLocaleString()} bytes`);a.forEach((e=>{let n=this.cram.featureCache.get(e.toString());n||(n=this.getRecordsInSlice(e,(()=>!0)),this.cram.featureCache.set(e.toString(),n));const i=n.then((e=>{const n=[];for(let i=0;i<e.length;i+=1){const o=e[i];if(void 0===o.readName)throw new Error;r[o.readName]&&!t[o.uniqueId]&&n.push(o);}return n}));h.push(i);}));const c=yield Promise.all(h);if(c.length){const e=c.reduce(((e,t)=>e.concat(t)));l=l.concat(e);}}return l}))}getRecordsInSlice({containerStart:e,sliceStart:t,sliceBytes:r},n){return this.cram.getContainerAtPosition(e).getSlice(t,r).getRecords(n)}hasDataForReferenceSequence(e){return this.index.hasDataForReferenceSequence(e)}};},3427:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.open=t.fromUrl=t.RemoteFile=t.LocalFile=void 0;const i=n(r(8575)),o=r(4319),s=r(2949);function a(e){const{protocol:t,pathname:r}=i.default.parse(e);return "file:"===t?new s.LocalFile(unescape((0, o.ensureNotNullish)(r))):new s.RemoteFile(e)}Object.defineProperty(t,"LocalFile",{enumerable:!0,get:function(){return s.LocalFile}}),Object.defineProperty(t,"RemoteFile",{enumerable:!0,get:function(){return s.RemoteFile}}),t.fromUrl=a,t.open=function(e,t,r){if(r)return r;if(e)return a(e);if(t)return new s.LocalFile(t);throw new Error("no url, path, or filehandle provided, cannot open")};},5702:(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.RANS_BYTE_L=t.TOTFREQ=t.TF_SHIFT=void 0,t.TF_SHIFT=12,t.TOTFREQ=4096,t.RANS_BYTE_L=1<<23;},6484:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8577),o=r(5702),s=n(r(7634));t.default=function(e,t,r,n){let a=e.getInt(),f=e.getInt(),h=e.getInt(),l=e.getInt();const u=n.remaining(),c=-4&u;for(let i=0;i<c;i+=4){const u=t.R[s.default.get(a,o.TF_SHIFT)],c=t.R[s.default.get(f,o.TF_SHIFT)],d=t.R[s.default.get(h,o.TF_SHIFT)],p=t.R[s.default.get(l,o.TF_SHIFT)];n.putAt(i,u),n.putAt(i+1,c),n.putAt(i+2,d),n.putAt(i+3,p),a=s.default.advanceSymbolStep(a,r[255&u],o.TF_SHIFT),f=s.default.advanceSymbolStep(f,r[255&c],o.TF_SHIFT),h=s.default.advanceSymbolStep(h,r[255&d],o.TF_SHIFT),l=s.default.advanceSymbolStep(l,r[255&p],o.TF_SHIFT),a=s.default.renormalize(a,e),f=s.default.renormalize(f,e),h=s.default.renormalize(h,e),l=s.default.renormalize(l,e);}let d;switch(n.setPosition(c),3&u){case 0:break;case 1:d=t.R[s.default.get(a,o.TF_SHIFT)],s.default.advanceSymbol(a,e,r[255&d],o.TF_SHIFT),n.put(d);break;case 2:d=t.R[s.default.get(a,o.TF_SHIFT)],s.default.advanceSymbol(a,e,r[255&d],o.TF_SHIFT),n.put(d),d=t.R[s.default.get(f,o.TF_SHIFT)],s.default.advanceSymbol(f,e,r[255&d],o.TF_SHIFT),n.put(d);break;case 3:d=t.R[s.default.get(a,o.TF_SHIFT)],s.default.advanceSymbol(a,e,r[255&d],o.TF_SHIFT),n.put(d),d=t.R[s.default.get(f,o.TF_SHIFT)],s.default.advanceSymbol(f,e,r[255&d],o.TF_SHIFT),n.put(d),d=t.R[s.default.get(h,o.TF_SHIFT)],s.default.advanceSymbol(h,e,r[255&d],o.TF_SHIFT),n.put(d);break;default:throw new i.CramMalformedError("invalid output size encountered during rANS decoding")}n.setPosition(0);};},7121:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(5702),o=n(r(7634));t.default=function(e,t,r,n){const s=t.remaining();let a=e.getInt(),f=e.getInt(),h=e.getInt(),l=e.getInt();const u=s>>2;let c=0,d=u,p=2*u,g=3*u,m=0,y=0,b=0,v=0;for(;c<u;c+=1,d+=1,p+=1,g+=1){const s=255&r[m].R[o.default.get(a,i.TF_SHIFT)],u=255&r[y].R[o.default.get(f,i.TF_SHIFT)],w=255&r[b].R[o.default.get(h,i.TF_SHIFT)],_=255&r[v].R[o.default.get(l,i.TF_SHIFT)];t.putAt(c,s),t.putAt(d,u),t.putAt(p,w),t.putAt(g,_),a=o.default.advanceSymbolStep(a,n[m][s],i.TF_SHIFT),f=o.default.advanceSymbolStep(f,n[y][u],i.TF_SHIFT),h=o.default.advanceSymbolStep(h,n[b][w],i.TF_SHIFT),l=o.default.advanceSymbolStep(l,n[v][_],i.TF_SHIFT),a=o.default.renormalize(a,e),f=o.default.renormalize(f,e),h=o.default.renormalize(h,e),l=o.default.renormalize(l,e),m=s,y=u,b=w,v=_;}for(;g<s;g+=1){const s=255&r[v].R[o.default.get(l,i.TF_SHIFT)];t.putAt(g,s),l=o.default.advanceSymbol(l,e,n[v][s],i.TF_SHIFT),v=s;}};},7634:(e,t,r)=>{Object.defineProperty(t,"__esModule",{value:!0});const n=r(8577),i=r(5702);class o{constructor(){this.F=void 0,this.C=void 0;}}function s(e,t,r,n){return r*(e>>n)+(e&(1<<n)-1)-t}const a={FC:o,AriDecoder:class{constructor(){this.fc=new Array(256);for(let e=0;e<this.fc.length;e+=1)this.fc[e]=new o;this.R=null;}},Symbol:class{constructor(){this.start=void 0,this.freq=void 0;}},symbolInit:function(e,t,r){if(!(t<=65536))throw new n.CramMalformedError("assertion failed: start <= 1<<16");if(!(r<=65536-t))throw new n.CramMalformedError("assertion failed: freq <= 1<<16");e.start=t,e.freq=r;},advanceStep:s,advanceSymbolStep:function(e,t,r){return s(e,t.start,t.freq,r)},get:function(e,t){return e&(1<<t)-1},advanceSymbol:function(e,t,r,n){return function(e,t,r,n,o){if((e=n*(e>>o)+(e&(1<<o)-1)-r)<i.RANS_BYTE_L)do{e=e<<8|255&t.get();}while(e<i.RANS_BYTE_L);return e}(e,t,r.start,r.freq,n)},renormalize:function(e,t){if(e<i.RANS_BYTE_L)do{e=e<<8|255&t.get();}while(e<i.RANS_BYTE_L);return e}};t.default=a;},696:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0}),t.readStatsO1=t.readStatsO0=void 0;const i=r(8577),o=r(5702),s=n(r(7634));function a(e){if(!e)throw new i.CramMalformedError("assertion failed")}t.readStatsO0=function(e,t,r){let n=0,i=0,f=255&e.get();do{null==t.fc[f]&&(t.fc[f]=new s.default.FC),t.fc[f].F=255&e.get(),t.fc[f].F>=128&&(t.fc[f].F&=-129,t.fc[f].F=(127&t.fc[f].F)<<8|255&e.get()),t.fc[f].C=i,s.default.symbolInit(r[f],t.fc[f].C,t.fc[f].F),t.R||(t.R=new Array(o.TOTFREQ)),t.R.fill(f,i,i+t.fc[f].F),i+=t.fc[f].F,0===n&&f+1===(255&e.getByteAt(e.position()))?(f=255&e.get(),n=255&e.get()):0!==n?(n-=1,f+=1):f=255&e.get();}while(0!==f);a(i<o.TOTFREQ);},t.readStatsO1=function(e,t,r){let n=0,i=255&e.get();do{let f=0,h=0,l=255&e.get();null==t[i]&&(t[i]=new s.default.AriDecoder);do{null==t[i].fc[l]&&(t[i].fc[l]=new s.default.FC),t[i].fc[l].F=255&e.get(),t[i].fc[l].F>=128&&(t[i].fc[l].F&=-129,t[i].fc[l].F=(127&t[i].fc[l].F)<<8|255&e.get()),t[i].fc[l].C=h,0===t[i].fc[l].F&&(t[i].fc[l].F=o.TOTFREQ),null==r[i][l]&&(r[i][l]=new s.default.RansDecSymbol),s.default.symbolInit(r[i][l],t[i].fc[l].C,t[i].fc[l].F),null==t[i].R&&(t[i].R=new Array(o.TOTFREQ)),t[i].R.fill(l,h,h+t[i].fc[l].F),h+=t[i].fc[l].F,a(h<=o.TOTFREQ),0===f&&l+1===(255&e.getByteAt(e.position()))?(l=255&e.get(),f=255&e.get()):0!==f?(f-=1,l+=1):l=255&e.get();}while(0!==l);0===n&&i+1===(255&e.getByteAt(e.position()))?(i=255&e.get(),n=255&e.get()):0!==n?(n-=1,i+=1):i=255&e.get();}while(0!==i)};},9675:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8577),o=n(r(7634)),s=r(696),a=n(r(6484)),f=n(r(7121));class h{constructor(e,t=0){this._buffer=e,this._position=t,this.length=e.length;}get(){const e=this._buffer[this._position];return this._position+=1,e}getByte(){return this.get()}getByteAt(e){return this._buffer[e]}position(){return this._position}put(e){return this._buffer[this._position]=e,this._position+=1,e}putAt(e,t){return this._buffer[e]=t,t}setPosition(e){return this._position=e,e}getInt(){const e=this._buffer.readInt32LE(this._position);return this._position+=4,e}remaining(){return this._buffer.length-this._position}}t.default=function(e,t,r=0){if(0===e.length)return t.fill(0),t;const n=new h(e,r),l=n.get();if(0!==l&&1!==l)throw new i.CramMalformedError(`Invalid rANS order ${l}`);if(n.getInt()!==n.remaining()-4)throw new i.CramMalformedError("Incorrect input length.");const u=n.getInt(),c=new h(t||Buffer.allocUnsafe(u));if(c.length<u)throw new i.CramMalformedError(`Output buffer too small to fit ${u} bytes.`);switch(l){case 0:return function(e,t){const r=new o.default.AriDecoder,n=new Array(256);for(let e=0;e<n.length;e+=1)n[e]=new o.default.Symbol;return (0, s.readStatsO0)(e,r,n),(0, a.default)(e,r,n,t),t}(n,c);case 1:return function(e,t){const r=new Array(256);for(let e=0;e<r.length;e+=1)r[e]=new o.default.AriDecoder;const n=new Array(256);for(let e=0;e<n.length;e+=1){n[e]=new Array(256);for(let t=0;t<n[e].length;t+=1)n[e][t]=new o.default.Symbol;}return (0, s.readStatsO1)(e,r,n),(0, f.default)(e,t,r,n),t}(n,c);default:throw new i.CramMalformedError(`Invalid rANS order: ${l}`)}};},7578:(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.parseHeaderText=void 0,t.parseHeaderText=function(e){const t=e.split(/\r?\n/),r=[];return t.forEach((e=>{const[t,...n]=e.split(/\t/),i=n.map((e=>{const[t,r]=e.split(":",2);return {tag:t,value:r}}));t&&r.push({tag:t.substr(1),data:i});})),r};},4319:(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ensureNotNullish=void 0,t.ensureNotNullish=function(e){if(null==e)throw new Error("Value must not be nullish.");return e};},597:(e,t,r)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.unzip=void 0;const n=r(9591);t.unzip=function(e){return Buffer.from((0, n.inflate)(e))};},9996:(e,t,r)=>{function n(e){return n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},n(e)}var i=r(8764).Buffer,o=r(22),s=r(2961)._,a=r(3720);"undefined"!=typeof window&&(window.Buffer=i),"undefined"!=typeof self&&(self.Buffer=i);var f={UInt8:1,UInt16LE:2,UInt16BE:2,UInt32LE:4,UInt32BE:4,Int8:1,Int16LE:2,Int16BE:2,Int32LE:4,Int32BE:4,FloatLE:4,FloatBE:4,DoubleLE:8,DoubleBE:8,UInt64:8,Int64:8},h={},l="___parser_",u=[];!function(){var e;for(e=1;e<=32;e++)u.push(e);}();var c={};Object.keys(f).concat(Object.keys({String:null,Buffer:null,Array:null,Skip:null,Choice:null,Nest:null,Bit:null,Itf8:null,Ltf8:null})).forEach((function(e){c[e.toLowerCase()]=e;}));var d=function(){this.varName="",this.type="",this.options={},this.next=null,this.head=null,this.compiled=null,this.endian="le",this.constructorFn=null,this.alias=null;};d.start=function(){return new d},Object.keys(f).forEach((function(e){d.prototype[e.toLowerCase()]=function(t,r){return this.setNextParser(e.toLowerCase(),t,r)};var t=e.replace(/BE|LE/,"").toLowerCase();t in d.prototype||(d.prototype[t]=function(e,r){return this[t+this.endian](e,r)});})),u.forEach((function(e){d.prototype["bit".concat(e.toString())]=function(t,r){return r||(r={}),r.length=e,this.setNextParser("bit",t,r)};})),d.prototype.namely=function(e){return h[e]=this,this.alias=e,this},d.prototype.skip=function(e,t){if(t&&t.assert)throw new Error("assert option on skip is not allowed.");return this.setNextParser("skip","",{length:e})},d.prototype.string=function(e,t){if(!t.zeroTerminated&&!t.length&&!t.greedy)throw new Error("Neither length, zeroTerminated, nor greedy is defined for string.");if((t.zeroTerminated||t.length)&&t.greedy)throw new Error("greedy is mutually exclusive with length and zeroTerminated for string.");if(t.stripNull&&!t.length&&!t.greedy)throw new Error("Length or greedy must be defined if stripNull is defined.");return t.encoding=t.encoding||"utf8",this.setNextParser("string",e,t)},d.prototype.buffer=function(e,t){if(!t.length&&!t.readUntil)throw new Error("Length nor readUntil is defined in buffer parser");return this.setNextParser("buffer",e,t)},d.prototype.array=function(e,t){if(!t.readUntil&&!t.length&&!t.lengthInBytes)throw new Error("Length option of array is not defined.");if(!t.type)throw new Error("Type option of array is not defined.");if("string"==typeof t.type&&!h[t.type]&&Object.keys(f).indexOf(c[t.type])<0)throw new Error('Specified primitive type "'.concat(t.type,'" is not supported.'));return this.setNextParser("array",e,t)},d.prototype.choice=function(e,t){if(1===arguments.length&&"object"===n(e)&&(t=e,e=null),!t.tag)throw new Error("Tag option of array is not defined.");if(!t.choices)throw new Error("Choices option of array is not defined.");return Object.keys(t.choices).forEach((function(r){if(!t.choices[r])throw new Error("Choice Case ".concat(r," of ").concat(e," is not valid."));if("string"==typeof t.choices[r]&&!h[t.choices[r]]&&Object.keys(f).indexOf(c[t.choices[r]])<0)throw new Error('Specified primitive type "'.concat(t.choices[r],'" is not supported.'))}),this),this.setNextParser("choice",e,t)},d.prototype.nest=function(e,t){if(1===arguments.length&&"object"===n(e)&&(t=e,e=null),!t.type)throw new Error("Type option of nest is not defined.");if(!(t.type instanceof d||h[t.type]))throw new Error("Type option of nest must be a Parser object.");if(!(t.type instanceof d||e))throw new Error("options.type must be a object if variable name is omitted.");return this.setNextParser("nest",e,t)},d.prototype.endianess=function(e){switch(e.toLowerCase()){case"little":this.endian="le";break;case"big":this.endian="be";break;default:throw new Error("Invalid endianess: ".concat(e))}return this},d.prototype.create=function(e){if(!(e instanceof Function))throw new Error("Constructor must be a Function object.");return this.constructorFn=e,this},d.prototype.getCode=function(){var e=new s;return e.pushCode("if (!Buffer.isBuffer(buffer)) {"),e.generateError('"argument buffer is not a Buffer object"'),e.pushCode("}"),this.alias?this.addAliasedCode(e):this.addRawCode(e),this.alias?e.pushCode("return {0}(0)",l+this.alias):e.pushCode("return { offset: offset, result: vars };"),e.code},d.prototype.addRawCode=function(e){e.pushCode("var offset = 0;"),this.constructorFn?e.pushCode("var vars = new constructorFn();"):e.pushCode("var vars = {};"),this.generate(e),this.resolveReferences(e),e.pushCode("return { offset: offset, result: vars };");},d.prototype.addAliasedCode=function(e){return e.pushCode("function {0}(offset) {",l+this.alias),this.constructorFn?e.pushCode("var vars = new constructorFn();"):e.pushCode("var vars = {};"),this.generate(e),e.markResolved(this.alias),this.resolveReferences(e),e.pushCode("return { offset: offset, result: vars };"),e.pushCode("}"),e},d.prototype.resolveReferences=function(e){var t=e.getUnresolvedReferences();e.markRequested(t),t.forEach((function(t){h[t].addAliasedCode(e);}));},d.prototype.compile=function(){var e="(function(buffer, constructorFn, Long) { ".concat(this.getCode()," })");this.compiled=o.runInThisContext(e);},d.prototype.sizeOf=function(){var e=NaN;if(Object.keys(f).indexOf(this.type)>=0)e=f[this.type];else if("String"===this.type&&"number"==typeof this.options.length)e=this.options.length;else if("Buffer"===this.type&&"number"==typeof this.options.length)e=this.options.length;else if("Array"===this.type&&"number"==typeof this.options.length){var t=NaN;"string"==typeof this.options.type?t=f[c[this.options.type]]:this.options.type instanceof d&&(t=this.options.type.sizeOf()),e=this.options.length*t;}else "Skip"===this.type?e=this.options.length:"Nest"===this.type?e=this.options.type.sizeOf():this.type||(e=0);return this.next&&(e+=this.next.sizeOf()),e},d.prototype.parse=function(e){return this.compiled||this.compile(),this.compiled(e,this.constructorFn,a)},d.prototype.setNextParser=function(e,t,r){var n=new d;return n.type=c[e],n.varName=t,n.options=r||n.options,n.endian=this.endian,this.head?this.head.next=n:this.next=n,this.head=n,this},d.prototype.generate=function(e){this.type&&(this["generate".concat(this.type)](e),this.generateAssert(e));var t=e.generateVariable(this.varName);return this.options.formatter&&this.generateFormatter(e,t,this.options.formatter),this.generateNext(e)},d.prototype.generateAssert=function(e){if(this.options.assert){var t=e.generateVariable(this.varName);switch(n(this.options.assert)){case"function":e.pushCode("if (!({0}).call(vars, {1})) {",this.options.assert,t);break;case"number":e.pushCode("if ({0} !== {1}) {",this.options.assert,t);break;case"string":e.pushCode('if ("{0}" !== {1}) {',this.options.assert,t);break;default:throw new Error("Assert option supports only strings, numbers and assert functions.")}e.generateError('"Assert error: {0} is " + {0}',t),e.pushCode("}");}},d.prototype.generateNext=function(e){return this.next&&(e=this.next.generate(e)),e},Object.keys(f).forEach((function(e){d.prototype["generate".concat(e)]=function(t){"UInt64"===e?t.pushCode("{0} = Long.fromBytes(buffer.slice(offset,offset+8), true, this.endian === 'le').toNumber();",t.generateVariable(this.varName),e):"Int64"===e?t.pushCode("{0} = Long.fromBytes(buffer.slice(offset,offset+8), false, this.endian === 'le').toNumber();",t.generateVariable(this.varName),e):t.pushCode("{0} = buffer.read{1}(offset);",t.generateVariable(this.varName),e),t.pushCode("offset += {0};",f[e]);};})),d.prototype.generateBit=function(e){var t=JSON.parse(JSON.stringify(this));if(t.varName=e.generateVariable(t.varName),e.bitFields.push(t),!this.next||this.next&&["Bit","Nest"].indexOf(this.next.type)<0){var r=0;e.bitFields.forEach((function(e){r+=e.options.length;}));var n=e.generateTmpVariable();if(r<=8)e.pushCode("var {0} = buffer.readUInt8(offset);",n),r=8;else if(r<=16)e.pushCode("var {0} = buffer.readUInt16BE(offset);",n),r=16;else if(r<=24){var i=e.generateTmpVariable(),o=e.generateTmpVariable();e.pushCode("var {0} = buffer.readUInt16BE(offset);",i),e.pushCode("var {0} = buffer.readUInt8(offset + 2);",o),e.pushCode("var {2} = ({0} << 8) | {1};",i,o,n),r=24;}else {if(!(r<=32))throw new Error("Currently, bit field sequence longer than 4-bytes is not supported.");e.pushCode("var {0} = buffer.readUInt32BE(offset);",n),r=32;}e.pushCode("offset += {0};",r/8);var s=0,a="be"===this.endian;e.bitFields.forEach((function(t){e.pushCode("{0} = {1} >> {2} & {3};",t.varName,n,a?r-s-t.options.length:s,(1<<t.options.length)-1),s+=t.options.length;})),e.bitFields=[];}},d.prototype.generateSkip=function(e){var t=e.generateOption(this.options.length);e.pushCode("offset += {0};",t);},d.prototype.generateString=function(e){var t=e.generateVariable(this.varName),r=e.generateTmpVariable();this.options.length&&this.options.zeroTerminated?(e.pushCode("var {0} = offset;",r),e.pushCode("while(buffer.readUInt8(offset++) !== 0 && offset - {0}  < {1});",r,this.options.length),e.pushCode("{0} = buffer.toString('{1}', {2}, offset - {2} < {3} ? offset - 1 : offset);",t,this.options.encoding,r,this.options.length)):this.options.length?(e.pushCode("{0} = buffer.toString('{1}', offset, offset + {2});",t,this.options.encoding,e.generateOption(this.options.length)),e.pushCode("offset += {0};",e.generateOption(this.options.length))):this.options.zeroTerminated?(e.pushCode("var {0} = offset;",r),e.pushCode("while(buffer.readUInt8(offset++) !== 0);"),e.pushCode("{0} = buffer.toString('{1}', {2}, offset - 1);",t,this.options.encoding,r)):this.options.greedy&&(e.pushCode("var {0} = offset;",r),e.pushCode("while(buffer.length > offset++);"),e.pushCode("{0} = buffer.toString('{1}', {2}, offset);",t,this.options.encoding,r)),this.options.stripNull&&e.pushCode("{0} = {0}.replace(/\\x00+$/g, '')",t);},d.prototype.generateBuffer=function(e){"eof"===this.options.readUntil?e.pushCode("{0} = buffer.slice(offset);",e.generateVariable(this.varName)):(e.pushCode("{0} = buffer.slice(offset, offset + {1});",e.generateVariable(this.varName),e.generateOption(this.options.length)),e.pushCode("offset += {0};",e.generateOption(this.options.length))),this.options.clone&&e.pushCode("{0} = Buffer.from({0});",e.generateVariable(this.varName));},d.prototype.generateArray=function(e){var t=e.generateOption(this.options.length),r=e.generateOption(this.options.lengthInBytes),n=this.options.type,i=e.generateTmpVariable(),o=e.generateVariable(this.varName),s=e.generateTmpVariable(),a=this.options.key,u="string"==typeof a;if(u?e.pushCode("{0} = {};",o):e.pushCode("{0} = [];",o),"function"==typeof this.options.readUntil?e.pushCode("do {"):"eof"===this.options.readUntil?e.pushCode("for (var {0} = 0; offset < buffer.length; {0}++) {",i):void 0!==r?e.pushCode("for (var {0} = offset; offset - {0} < {1}; ) {",i,r):e.pushCode("for (var {0} = 0; {0} < {1}; {0}++) {",i,t),"string"==typeof n)if(h[n]){var p=e.generateTmpVariable();e.pushCode("var {0} = {1}(offset);",p,l+n),e.pushCode("var {0} = {1}.result; offset = {1}.offset;",s,p),n!==this.alias&&e.addReference(n);}else e.pushCode("var {0} = buffer.read{1}(offset);",s,c[n]),e.pushCode("offset += {0};",f[c[n]]);else n instanceof d&&(e.pushCode("var {0} = {};",s),e.pushScope(s),n.generate(e),e.popScope());u?e.pushCode("{0}[{2}.{1}] = {2};",o,a,s):e.pushCode("{0}.push({1});",o,s),e.pushCode("}"),"function"==typeof this.options.readUntil&&e.pushCode(" while (!({0}).call(this, {1}, buffer.slice(offset)));",this.options.readUntil,s);},d.prototype.generateChoiceCase=function(e,t,r){if("string"==typeof r)if(h[r]){var n=e.generateTmpVariable();e.pushCode("var {0} = {1}(offset);",n,l+r),e.pushCode("{0} = {1}.result; offset = {1}.offset;",e.generateVariable(this.varName),n),r!==this.alias&&e.addReference(r);}else e.pushCode("{0} = buffer.read{1}(offset);",e.generateVariable(this.varName),c[r]),e.pushCode("offset += {0};",f[c[r]]);else r instanceof d&&(e.pushPath(t),r.generate(e),e.popPath(t));},d.prototype.generateChoice=function(e){var t=e.generateOption(this.options.tag);this.varName&&e.pushCode("{0} = {};",e.generateVariable(this.varName)),e.pushCode("switch({0}) {",t),Object.keys(this.options.choices).forEach((function(t){var r=this.options.choices[t];Number.isNaN(parseInt(t,10))?e.pushCode("case '{0}':",t):e.pushCode("case {0}:",t),this.generateChoiceCase(e,this.varName,r),e.pushCode("break;");}),this),e.pushCode("default:"),this.options.defaultChoice?this.generateChoiceCase(e,this.varName,this.options.defaultChoice):e.generateError('"Met undefined tag value " + {0} + " at choice"',t),e.pushCode("}");},d.prototype.generateNest=function(e){var t=e.generateVariable(this.varName);if(this.options.type instanceof d)this.varName&&e.pushCode("{0} = {};",t),e.pushPath(this.varName),this.options.type.generate(e),e.popPath(this.varName);else if(h[this.options.type]){var r=e.generateTmpVariable();e.pushCode("var {0} = {1}(offset);",r,l+this.options.type),e.pushCode("{0} = {1}.result; offset = {1}.offset;",t,r),this.options.type!==this.alias&&e.addReference(this.options.type);}},d.prototype.generateFormatter=function(e,t,r){"function"==typeof r&&e.pushCode("{0} = ({1}).call(this, {0});",t,r);},d.prototype.isInteger=function(){return !!this.type.match(/U?Int[8|16|32][BE|LE]?|Bit\d+/)},d.prototype.itf8=function(e,t){return this.setNextParser("itf8",e,t)},d.prototype.itf8=function(e,t){return this.setNextParser("itf8",e,t)},d.prototype.generateItf8=function(e){var t=e.generateVariable(this.varName),r=e.generateTmpVariable();e.pushCode("\n    var ".concat(r," = buffer[offset];\n    if (").concat(r," < 0x80) {\n      ").concat(t," = ").concat(r,";\n      offset += 1;\n    } else if (").concat(r," < 0xc0) {\n      ").concat(t," = ((").concat(r,"<<8) | buffer[offset+1]) & 0x3fff;\n      offset += 2;\n    } else if (").concat(r," < 0xe0) {\n      ").concat(t," = ((").concat(r,"<<16) | (buffer[offset+1]<< 8) |  buffer[offset+2]) & 0x1fffff;\n      offset += 3;\n    } else if (").concat(r," < 0xf0) {\n      ").concat(t," = ((").concat(r,"<<24) | (buffer[offset+1]<<16) | (buffer[offset+2]<<8) | buffer[offset+3]) & 0x0fffffff;\n      offset += 4\n    } else {\n      ").concat(t," = ((").concat(r," & 0x0f)<<28) | (buffer[offset+1]<<20) | (buffer[offset+2]<<12) | (buffer[offset+3]<<4) | (buffer[offset+4] & 0x0f);\n      // x=((0xff & 0x0f)<<28) | (0xff<<20) | (0xff<<12) | (0xff<<4) | (0x0f & 0x0f);\n      // TODO *val_p = uv < 0x80000000UL ? uv : -((int32_t) (0xffffffffUL - uv)) - 1;\n      offset += 5\n    }\n  "));},d.prototype.ltf8=function(e,t){return this.setNextParser("ltf8",e,t)},d.prototype.generateLtf8=function(e){var t=e.generateVariable(this.varName),r=e.generateTmpVariable();e.pushCode("\n  var ".concat(r," = buffer[offset];\n  if (").concat(r," < 0x80) {\n    ").concat(t," = ").concat(r,";\n    offset += 1;\n  } else if (").concat(r," < 0xc0) {\n    ").concat(t," = ((buffer[offset]<<8) | buffer[offset+1]) & 0x3fff;\n    offset += 2;\n  } else if (").concat(r," < 0xe0) {\n    ").concat(t," = ((buffer[offset]<<16) | (buffer[offset+1]<<8) | buffer[offset+2]) & 0x1fffff;\n    ").concat(t," = (((").concat(r," & 63) << 16) | buffer.readUInt16LE(offset + 1));\n    offset += 3;\n  } else if (").concat(r," < 0xf0) {\n    ").concat(t," = ((buffer[offset]<<24) | (buffer[offset+1]<<16) | (buffer[offset+2]<<8) | buffer[offset+3]) & 0x0fffffff;\n    offset += 4;\n  } else if (").concat(r," < 0xf8) {\n    ").concat(t," = (((buffer[offset] & 15) * Math.pow(2,32))) +\n      (buffer[offset+1]<<24) | (buffer[offset+2]<<16 | buffer[offset+3]<<8 | buffer[offset+4])\n    // TODO *val_p = uv < 0x80000000UL ? uv : -((int32_t) (0xffffffffUL - uv)) - 1;\n    offset += 5;\n  } else if (").concat(r," < 0xfc) {\n    ").concat(t," = ((((buffer[offset] & 7) << 8) | buffer[offset+1] )) * Math.pow(2,32) +\n      (buffer[offset+2]<<24) | (buffer[offset+3]<<16 | buffer[offset+4]<<8 | buffer[offset+5])\n    offset += 6;\n  } else if (").concat(r," < 0xfe) {\n    ").concat(t," = ((((buffer[offset] & 3) << 16) | buffer[offset+1]<<8 | buffer[offset+2])) * Math.pow(2,32) +\n      (buffer[offset+3]<<24) | (buffer[offset+4]<<16 | buffer[offset+5]<<8 | buffer[offset+6])\n    offset += 7;\n  } else if (").concat(r," < 0xff) {\n    ").concat(t," = Long.fromBytesBE(buffer.slice(offset+1,offset+8));\n    if (").concat(t,".greaterThan(Number.MAX_SAFE_INTEGER) || ").concat(t,".lessThan(Number.MIN_SAFE_INTEGER))\n      throw new Error('integer overflow')\n    ").concat(t," = ").concat(t,".toNumber()\n    offset += 8;\n  } else {\n    ").concat(t," = Long.fromBytesBE(buffer.slice(offset+1,offset+9));\n    if (").concat(t,".greaterThan(Number.MAX_SAFE_INTEGER) || ").concat(t,".lessThan(Number.MIN_SAFE_INTEGER))\n      throw new Error('integer overflow')\n    ").concat(t," = ").concat(t,".toNumber()\n    offset += 9;\n  }\n  "));},t.Parser=d;},2961:(e,t)=>{function r(e){return r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},r(e)}var n=function(){this.code="",this.scopes=[["vars"]],this.isAsync=!1,this.bitFields=[],this.tmpVariableCount=0,this.references={};};n.prototype.generateVariable=function(e){var t=[];for(Array.prototype.push.apply(t,this.scopes[this.scopes.length-1]);/^\$parent\./.test(e);)t.pop(),e=e.replace(/^\$parent\./,"");return e&&t.push(e),t.join(".")},n.prototype.generateOption=function(e){switch(r(e)){case"number":return e.toString();case"string":return this.generateVariable(e);case"function":return "(".concat(e,").call(").concat(this.generateVariable(),", vars)");default:return}},n.prototype.generateError=function(){var e=Array.prototype.slice.call(arguments),t=n.interpolate.apply(this,e);this.isAsync?this.pushCode("return process.nextTick(function() { callback(new Error(".concat(t,"), vars); });")):this.pushCode("throw new Error(".concat(t,");"));},n.prototype.generateTmpVariable=function(){return "$tmp".concat(this.tmpVariableCount++)},n.prototype.pushCode=function(){var e=Array.prototype.slice.call(arguments);this.code+="".concat(n.interpolate.apply(this,e),"\n");},n.prototype.pushPath=function(e){e&&this.scopes[this.scopes.length-1].push(e);},n.prototype.popPath=function(e){e&&this.scopes[this.scopes.length-1].pop();},n.prototype.pushScope=function(e){this.scopes.push([e]);},n.prototype.popScope=function(){this.scopes.pop();},n.prototype.addReference=function(e){this.references[e]||(this.references[e]={resolved:!1,requested:!1});},n.prototype.markResolved=function(e){this.references[e].resolved=!0;},n.prototype.markRequested=function(e){e.forEach(function(e){this.references[e].requested=!0;}.bind(this));},n.prototype.getUnresolvedReferences=function(){var e=this.references;return Object.keys(this.references).filter((function(t){return !e[t].resolved&&!e[t].requested}))},n.interpolate=function(e){var t=/{\d+}/g,r=e.match(t),n=Array.prototype.slice.call(arguments,1);return r&&r.forEach((function(t){var r=parseInt(t.substr(1,t.length-2),10);e=e.replace(t,n[r].toString());})),e},t._=n;},22:e=>{e.exports.runInThisContext=function(e){return new Function("code","return eval(code);").call(globalThis,e)};},445:(e,t,r)=>{const n=r(7381),i=r(9260),o=r(576),s=r(4693),a=128;e.exports=class{decode(e){return this.stream=new i(e),this.decodeStream(this.stream)}decodeStream(e,t=0){var r=this.stream.ReadByte();16&r||(t=this.stream.ReadUint7());var n,i=t,o=1&r;if(8&r)return this.decodeStripe(this.stream,t);if(r&a&&([n,i]=this.decodePackMeta(this.stream)),32&r)var s=this.decodeCat(this.stream,i);else s=4&r?this.decodeExt(this.stream,i):64&r?o?this.decodeRLE1(this.stream,i):this.decodeRLE0(this.stream,i):o?this.decode1(this.stream,i):this.decode0(this.stream,i);return r&a&&(s=this.decodePack(s,n,t)),s}encode(e,t){if(this.stream=new i("",0,1.1*e.length+100),this.stream.WriteByte(t),16&t||this.stream.WriteUint7(e.length),8&t)return Buffer.concat([this.stream.buf.slice(0,this.stream.pos),this.encodeStripe(this.stream,e,t>>8)]);var r,n=1&t,o=e.length;return t&a&&([r,e,o]=this.encodePack(e)),t&a&&this.stream.WriteStream(r),64&t?n?this.encodeRLE1(e,o,this.stream):this.encodeRLE0(e,o,this.stream):n?this.encode1(e,o,this.stream):this.encode0(e,o,this.stream)}decode0(e,t){var r=new Buffer.allocUnsafe(t),i=e.ReadByte();0==i&&(i=256);var s=new o(i),a=new n(e);a.RangeStartDecode(e);for(var f=0;f<t;f++)r[f]=s.ModelDecode(e,a);return r}encode0(e,t,r){for(var i=0,s=0;s<t;s++)i<e[s]&&(i=e[s]);i++;var a=new o(i);r.WriteByte(i);var f=new n(r);for(s=0;s<t;s++)a.ModelEncode(r,f,e[s]);return f.RangeFinishEncode(r),r.buf.slice(0,r.pos)}decode1(e,t){var r=new Buffer.allocUnsafe(t),i=e.ReadByte();0==i&&(i=256);for(var s=new Array(i),a=0;a<i;a++)s[a]=new o(i);var f=new n(e);f.RangeStartDecode(e);var h=0;for(a=0;a<t;a++)r[a]=s[h].ModelDecode(e,f),h=r[a];return r}encode1(e,t,r){for(var i=0,s=0;s<t;s++)i<e[s]&&(i=e[s]);i++;var a=new Array(i);for(s=0;s<i;s++)a[s]=new o(i);r.WriteByte(i);var f=new n(r),h=0;for(s=0;s<t;s++)a[h].ModelEncode(r,f,e[s]),h=e[s];return f.RangeFinishEncode(r),r.buf.slice(0,r.pos)}decodeExt(e,t){var r=new Buffer.allocUnsafe(t),n=s.array(e.buf.slice(e.pos)),i=s.header(n),o=0;do{var a=s.decompress(n,i);-1!=a&&(Buffer.from(a).copy(r,o),o+=a.length,i-=a.length);}while(-1!=a);return r}encodeExt(e,t){}decodeRLE0(e,t){var r=new Buffer.allocUnsafe(t),i=e.ReadByte();0==i&&(i=256);for(var s=new o(i),a=new Array(258),f=0;f<=257;f++)a[f]=new o(4);var h=new n(e);for(h.RangeStartDecode(e),f=0;f<t;){r[f]=s.ModelDecode(e,h);for(var l=a[r[f]].ModelDecode(e,h),u=l,c=256;3==l;)l=a[c].ModelDecode(e,h),c=257,u+=l;for(var d=1;d<=u;d++)r[f+d]=r[f];f+=u+1;}return r}encodeRLE0(e,t,r){for(var i=0,s=0;s<t;s++)i<e[s]&&(i=e[s]);i++;var a=new o(i),f=new Array(258);for(s=0;s<=257;s++)f[s]=new o(4);r.WriteByte(i);var h=new n(r);for(s=0;s<t;){a.ModelEncode(r,h,e[s]);for(var l=1;s+l<t&&e[s+l]==e[s];)l++;l--;var u=e[s];e[s],s+=l+1;var c=l>=3?3:l;for(f[u].ModelEncode(r,h,c),l-=c,u=256;3==c;)c=l>=3?3:l,f[u].ModelEncode(r,h,c),u=257,l-=c;}return h.RangeFinishEncode(r),r.buf.slice(0,r.pos)}decodeRLE1(e,t){var r=new Buffer.allocUnsafe(t),i=e.ReadByte();0==i&&(i=256);for(var s=new Array(i),a=0;a<i;a++)s[a]=new o(i);var f=new Array(258);for(a=0;a<=257;a++)f[a]=new o(4);var h=new n(e);h.RangeStartDecode(e);var l=0;for(a=0;a<t;){r[a]=s[l].ModelDecode(e,h),l=r[a];for(var u=f[r[a]].ModelDecode(e,h),c=u,d=256;3==u;)u=f[d].ModelDecode(e,h),d=257,c+=u;for(var p=1;p<=c;p++)r[a+p]=r[a];a+=c+1;}return r}encodeRLE1(e,t,r){for(var i=0,s=0;s<t;s++)i<e[s]&&(i=e[s]);i++;var a=new Array(i);for(s=0;s<i;s++)a[s]=new o(i);var f=new Array(258);for(s=0;s<=257;s++)f[s]=new o(4);r.WriteByte(i);for(var h=new n(r),l=(s=0,0);s<t;){a[l].ModelEncode(r,h,e[s]);for(var u=1;s+u<t&&e[s+u]==e[s];)u++;u--;var c=e[s];l=e[s],s+=u+1;var d=u>=3?3:u;for(f[c].ModelEncode(r,h,d),u-=d,c=256;3==d;)d=u>=3?3:u,f[c].ModelEncode(r,h,d),c=257,u-=d;}return h.RangeFinishEncode(r),r.buf.slice(0,r.pos)}decodePackMeta(e){this.nsym=e.ReadByte();for(var t=new Array(this.nsym),r=0;r<this.nsym;r++)t[r]=e.ReadByte();return [t,e.ReadUint7()]}decodePack(e,t,r){var n=new Buffer.allocUnsafe(r);if(this.nsym<=1)for(var i=0;i<r;i++)n[i]=t[0];else if(this.nsym<=2){i=0;for(var o=0;i<r;i++){if(i%8==0)var s=e[o++];n[i]=t[1&s],s>>=1;}}else if(this.nsym<=4)for(i=0,o=0;i<r;i++)i%4==0&&(s=e[o++]),n[i]=t[3&s],s>>=2;else {if(!(this.nsym<=16))return e;for(i=0,o=0;i<r;i++)i%2==0&&(s=e[o++]),n[i]=t[15&s],s>>=4;}return n}packMeta(e){for(var t=new i("",0,1024),r=new Array(256),n=0;n<e.length;n++)r[e[n]]=1;var o=0;for(n=0;n<256;n++)r[n]&&(r[n]=++o);for(t.WriteByte(o),n=0;n<256;n++)r[n]&&(t.WriteByte(n),r[n]--);return [t,r,o]}encodePack(e){var t,r,n;[t,r,n]=this.packMeta(e);var i=e.length,o=0;if(n<=1)return t.WriteUint7(0),[t,new Buffer.allocUnsafe(0),0];if(n<=2){for(var s=new Buffer.allocUnsafe(Math.floor((i+7)/8)),a=(o=0,0);o<(-8&i);o+=8,a++)s[a]=(r[e[o+0]]<<0)+(r[e[o+1]]<<1)+(r[e[o+2]]<<2)+(r[e[o+3]]<<3)+(r[e[o+4]]<<4)+(r[e[o+5]]<<5)+(r[e[o+6]]<<6)+(r[e[o+7]]<<7);if(o<i){s[a]=0;for(var f=0;o<i;)s[a]|=r[e[o++]]<<f,f++;a++;}return t.WriteUint7(a),[t,s,s.length]}if(n<=4){for(s=new Buffer.allocUnsafe(Math.floor((i+3)/4)),o=0,a=0;o<(-4&i);o+=4,a++)s[a]=(r[e[o+0]]<<0)+(r[e[o+1]]<<2)+(r[e[o+2]]<<4)+(r[e[o+3]]<<6);if(o<i){for(s[a]=0,f=0;o<i;)s[a]|=r[e[o++]]<<f,f+=2;a++;}return t.WriteUint7(a),[t,s,s.length]}if(n<=16){for(s=new Buffer.allocUnsafe(Math.floor((i+1)/2)),o=0,a=0;o<(-2&i);o+=2,a++)s[a]=(r[e[o+0]]<<0)+(r[e[o+1]]<<4);return o<i&&(s[a++]=r[e[o++]]),t.WriteUint7(a),[t,s,s.length]}return t.WriteUint7(e.length),[t,e,e.length]}encodeStripe(e,t,r){0==r&&(r=4);for(var n=new Array(r),o=new Array(r),s=0;s<r;s++)o[s]=Math.floor(t.length/r)+(t.length%r>s),n[s]=new Array(o[s]);for(var a=0,f=0;f<t.length;f+=r,a++)for(var h=0;h<r;h++)a<n[h].length&&(n[h][a]=t[f+h]);var l=new Array(r),u=0;for(s=0;s<r;s++){var c=this.encode(n[s],0),d=this.encode(n[s],1);l[s]=d.length<c.length?d:c,u+=l[s].length;}var p=new i("",0,u+5*r+1);for(p.WriteByte(r),s=0;s<r;s++)p.WriteUint7(l[s].length);for(s=0;s<r;s++)p.WriteData(l[s],l[s].length);return p.buf.slice(0,p.buf.pos)}decodeStripe(e,t){for(var r=e.ReadByte(),n=new Array(r),i=new Array(r),o=0;o<r;o++)n[o]=e.ReadUint7();var s=new Array(r);for(o=0;o<r;o++)i[o]=Math.floor(t/r)+(t%r>o),s[o]=this.decodeStream(e,i[o]);var a=new Buffer.allocUnsafe(t);for(o=0;o<r;o++)for(var f=0;f<i[o];f++)a[f*r+o]=s[o][f];return a}decodeCat(e,t){for(var r=new Buffer.allocUnsafe(t),n=0;n<t;n++)r[n]=e.ReadByte();return r}};},7381:e=>{e.exports=class{constructor(e){this.low=0,this.range=4294967295,this.code=0,this.FFnum=0,this.carry=0,this.cache=0;}RangeStartDecode(e){for(var t=0;t<5;t++)this.code=(this.code<<8)+e.ReadByte();this.code&=4294967295,this.code>>>=0;}RangeGetFrequency(e){return this.range=Math.floor(this.range/e),Math.floor(this.code/this.range)}RangeDecode(e,t,r,n){for(this.code-=t*this.range,this.range*=r;this.range<1<<24;)this.range*=256,this.code=256*this.code+e.ReadByte();}RangeShiftLow(e){if(this.low<4278190080|this.carry){for(e.WriteByte(this.cache+this.carry);this.FFnum;)e.WriteByte(this.carry-1),this.FFnum--;this.cache=this.low>>>24,this.carry=0;}else this.FFnum++;this.low<<=8,this.low>>>=0;}RangeEncode(e,t,r,n){var i=this.low;for(this.range=Math.floor(this.range/n),this.low+=t*this.range,this.low>>>=0,this.range*=r,this.low<i&&(0!=this.carry&&void 0,this.carry=1);this.range<1<<24;)this.range*=256,this.RangeShiftLow(e);}RangeFinishEncode(e){for(var t=0;t<5;t++)this.RangeShiftLow(e);}};},576:e=>{e.exports=class{constructor(e=256){this.total_freq=e,this.max_sym=e-1,this.S=new Array,this.F=new Array;for(var t=0;t<=this.max_sym;t++)this.S[t]=t,this.F[t]=1;}ModelDecode(e,t){for(var r=t.RangeGetFrequency(this.total_freq),n=0,i=0;n+this.F[i]<=r;)n+=this.F[i++];t.RangeDecode(e,n,this.F[i],this.total_freq),this.F[i]+=16,this.total_freq+=16,this.total_freq>65519&&this.ModelRenormalise();var o=this.S[i];if(i>0&&this.F[i]>this.F[i-1]){var s=this.F[i];this.F[i]=this.F[i-1],this.F[i-1]=s,s=this.S[i],this.S[i]=this.S[i-1],this.S[i-1]=s;}return o}ModelRenormalise(){this.total_freq=0;for(var e=0;e<=this.max_sym;e++)this.F[e]-=Math.floor(this.F[e]/2),this.total_freq+=this.F[e];}ModelEncode(e,t,r){for(var n=0,i=0;this.S[i]!=r;i++)n+=this.F[i];if(t.RangeEncode(e,n,this.F[i],this.total_freq),this.F[i]+=16,this.total_freq+=16,this.total_freq>65519&&this.ModelRenormalise(),r=this.S[i],i>0&&this.F[i]>this.F[i-1]){var o=this.F[i];this.F[i]=this.F[i-1],this.F[i-1]=o,o=this.S[i],this.S[i]=this.S[i-1],this.S[i-1]=o;}}};},5260:(e,t,r)=>{const n=r(9260),i=r(576),o=r(7381);function s(e,t,r){for(var n=0,i=0,o=-1,s=new Array(1024);i<r;){var a=e.ReadByte();if(s[n++]=a,i+=a,a==o){var f=e.ReadByte();for(i+=a*f;f--;)s[n++]=a;}o=a;}var h=0;for(n=0,i=0;i<r;){var l=0;do{var u=s[n++];l+=u;}while(255==u);for(;l--;)t[i++]=h;h++;}}function a(e,t,r){var n=e.context;return t.qctx=(t.qctx<<e.qshift)+e.qtab[r],n+=(t.qctx&(1<<e.qbits)-1)<<e.qloc,e.do_pos&&(n+=e.ptab[Math.min(t.p,1023)]<<e.ploc),e.do_delta&&(n+=e.dtab[Math.min(t.delta,255)]<<e.dloc,t.delta+=t.prevq!=r?1:0,t.prevq=r),e.do_sel&&(n+=t.s<<e.sloc),t.p--,65535&n}function f(e){var t={};t.context=e.ReadUint16(),t.pflags=e.ReadByte(),t.do_dedup=2&t.pflags,t.fixed_len=4&t.pflags,t.do_sel=8&t.pflags,t.do_qmap=16&t.pflags,t.do_pos=32&t.pflags,t.do_delta=64&t.pflags,t.do_qtab=128&t.pflags,t.max_sym=e.ReadByte();var r=e.ReadByte();if(t.qbits=r>>4,t.qshift=15&r,r=e.ReadByte(),t.qloc=r>>4,t.sloc=15&r,r=e.ReadByte(),t.ploc=r>>4,t.dloc=15&r,t.qmap=new Array(256),16&t.pflags)for(var n=0;n<t.max_sym;n++)t.qmap[n]=e.ReadByte();else for(n=0;n<256;n++)t.qmap[n]=n;if(t.qtab=new Array(1024),t.qbits>0&&128&t.pflags)s(e,t.qtab,256);else for(n=0;n<256;n++)t.qtab[n]=n;return t.ptab=new Array(1024),32&t.pflags&&s(e,t.ptab,1024),t.dtab=new Array(256),64&t.pflags&&s(e,t.dtab,256),t}function h(e,t,r,n,i,o){r.max_sel>0?i.s=n.sel.ModelDecode(e,t):i.s=0,i.x=r.stab[i.s];var s=r.params[i.x];if(s.fixed_len>=0){var a=n.len[0].ModelDecode(e,t);a|=n.len[1].ModelDecode(e,t)<<8,a|=n.len[2].ModelDecode(e,t)<<16,a|=n.len[3].ModelDecode(e,t)<<24,s.fixed_len>0&&(s.fixed_len=-a);}else a=-s.fixed_len;i.len=a,r.do_rev&&(o[i.rec]=n.rev.ModelDecode(e,t)),i.is_dup=0,2&s.pflags&&n.dup.ModelDecode(e,t)&&(i.is_dup=1),i.p=a,i.delta=0,i.qctx=0,i.prevq=0,i.rec++;}function l(e,t,r){for(var n=0,i=0,o=new Array(2*r),s=0;n<r;){for(var a=n;n<r&&t[n]==i;)n++;var f=n-a;do{var h=Math.min(255,f);o[s++]=h,f-=h;}while(255==h);i++;}var l=-1,u=new Array(2*r),c=0;for(n=0;n<s;){var d=o[n++];if(u[c++]=d,d==l){for(a=n;n<s&&o[n]==l&&n-a<255;)n++;u[c++]=n-a;}else l=d;}e.WriteData(u,c);}e.exports={decode:function(e,t){return function(e,t){var r=e.ReadUint7(),n=function(e){var t={max_sym:0};if(5==e.ReadByte()){var r=e.ReadByte(),n=1&r?e.ReadByte():1,i=r.nparam>1?r.nparam-1:0,o=new Array(256);if(2&r)i=e.ReadByte(),s(e,o,256);else {for(var a=0;a<n;a++)o[a]=a;for(;a<256;a++)o[a]=n-1;}t.do_rev=4&r,t.stab=o,t.max_sel=i,t.params=new Array(t.nparam);for(var h=0;h<n;h++)t.params[h]=f(e),t.max_sym<t.params[h].max_sym&&(t.max_sym=t.params[h].max_sym);return t}console.error("Invalid FQZComp version number");}(e);if(n){var l=n.params,u=new Array(t.length),c=function(e){var t={};t.qual=new Array(65536);for(var r=0;r<65536;r++)t.qual[r]=new i(e.max_sym+1);for(t.len=new Array(4),r=0;r<4;r++)t.len[r]=new i(256);return t.rev=new i(2),t.dup=new i(2),e.max_sel>0&&(t.sel=new i(e.max_sel+1)),t}(n),d=new o(e);d.RangeStartDecode(e);for(var p=new Buffer.allocUnsafe(r),g={qctx:0,prevq:0,delta:0,p:0,s:0,x:0,len:0,is_dup:0,rec:0},m=0;m<r;){if(0==g.p){if(h(e,d,n,c,g,u),g.is_dup>0&&c.dup.ModelDecode(e,d)){for(var y=0;y<len;y++)p[m+y]=p[m+y-g.len];m+=g.len,g.p=0;continue}t.push(g.len);var b=(l=n.params[g.x]).context;}var v=c.qual[b].ModelDecode(e,d);p[m++]=l.qmap[v],b=a(l,g,v);}return n.do_rev&&function(e,t,r,n){for(var i=0,o=0;o<t;){if(r[i])for(var s=0,a=n[i]-1;s<a;){var f=e[o+s];e[o+s]=e[o+a],e[o+a]=f,s++,a--;}o+=n[i++];}}(p,r,u,t),p}}(new n(e),t)},encode:function(e,t,r){for(var s=new Array(2),a=new Array(2),f=new Array(2),h=new Array(2),u=new Array(256),c=0;c<2;c++)s[c]=new Array(256),a[c]=new Array(256),f[c]=new Array(1024),h[c]=new Array(256);(p=new n("",0,1.1*e.length+100)).WriteUint7(e.length);var d=function(e,t,r,n){for(var i=r[0],o=0;o<r.length&&r[o]==i;o++);var s=o==r.length?1:0,a=0,f=0;for(o=0;o<256;o++)n[0][o]=0;var h=0,l=0;for(o=0;o<e.length;o++)0==l&&(l=t[h<t.length-1?h++:h]),n[0][e[o]]++,l--;for(o=0;o<256;o++)n[0][o]&&(f<o&&(f=o),a++);var u=5,c=0;return a<=16&&(c=1,u=a<=2?1:a<=4?2:a<=8?3:4),[{qbits:8+(u>4),qshift:u,qloc:7,pbits:7,pshift:t[0]>128?1:0,ploc:0,dbits:u>4?0:1,dshift:3,dloc:15,sbits:0,sloc:15,do_stab:0,context:0,max_sym:f,nsym:a,do_qmap:c,do_dedup:0,fixed_len:1==t.length?1:0,do_sel:0,do_rev:0,do_pos:1,do_delta:u<=4?1:0,do_qtab:0,qbits:8+(u>4)-(0==s),sbits:1,sloc:15-(u<=4),do_stab:1,do_sel:1}]}(e,t,r,s),p=function(e,t,r,n,i,o,s){for(var a=[0,1,1,1,2,2,2,2,2,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7],f=0;f<t.length;f++)s[f]=f;for(;f<256;f++)s[f]=t.length-1;e.WriteByte(5);var h=(t.length>1?1:0)|(t[0].do_stab?2:0);if(e.WriteByte(h),1&h&&e.WriteByte(t.length),2&h){var u=1<<t[0].sbits;u>0&&u--,e.WriteByte(u),l(e,s,256);}for(var c=0;c<t.length;c++){if(e.WriteUint16(t[c].context),e.WriteByte((t[c].do_qtab?128:0)|(t[c].do_delta?64:0)|(t[c].do_pos?32:0)|(t[c].do_qmap?16:0)|(t[c].do_sel?8:0)|(t[c].fixed_len?4:0)|(t[c].do_dedup?2:0)),t[c].do_qmap?e.WriteByte(t[c].nsym):e.WriteByte(t[c].max_sym),e.WriteByte(t[c].qbits<<4|t[c].qshift),e.WriteByte(t[c].qloc<<4|t[c].sloc),e.WriteByte(t[c].ploc<<4|t[c].dloc),t[c].do_qmap){t[c].max_sym=t[c].nsym;var d=0;for(f=0;f<256;f++)r[c][f]&&(e.WriteByte(f),r[c][f]=d++);for(;d<t[c].nsym;d++)e.WriteByte(0);}else for(f=0;f<256;f++)r[c][f]=f;if(t[c].qbits>0){for(f=0;f<256;f++)n[c][f]=f;t[c].do_qtab&&l(e,n[c],256);}if(t[c].pbits>0){for(f=0;f<1024;f++)i[c][f]=Math.min((1<<t[c].pbits)-1,f>>t[c].pshift);l(e,i[c],1024);}if(t[c].dbits>0){for(f=0;f<256;f++)a[f]>(1<<t[c].dbits)-1&&(a[f]=(1<<t[c].dbits)-1);for(f=0;f<256;f++)o[c][f]=a[Math.min(a.length-1,f>>t[c].dshift)];l(e,o[c],256);}}return e}(p,d,s,a,f,h,u);return function(e,t,r,n,s,a,f,h,l,u){var c=1<<s[0].sbits;c>0&&c--;for(var d=t.length,p=0,g=0;g<s.length;g++)p<s[g].max_sym&&(p=s[g].max_sym);for(var m=new Array(65536),y=0;y<65536;y++)m[y]=new i(p+1);var b=new Array(4);for(y=0;y<4;y++)b[y]=new i(256);new i(2),new i(2);for(var v=new i(c+1),w=new o(t),_=(g=0,y=0,0);y<d;){if(0==g){var B=n[_];s[0].sbits>0&&v.ModelEncode(e,w,B);var E=u[B],S=r[Math.min(r.length-1,_++)];s[E].fixed_len?s[E].fixed_len>0&&(b[0].ModelEncode(e,w,255&S),b[1].ModelEncode(e,w,S>>8&255),b[2].ModelEncode(e,w,S>>16&255),b[3].ModelEncode(e,w,S>>24&255),s[E].fixed_len=-1):(b[0].ModelEncode(e,w,255&S),b[1].ModelEncode(e,w,S>>8&255),b[2].ModelEncode(e,w,S>>16&255),b[3].ModelEncode(e,w,S>>24&255)),s[E].do_dedup&&process.exit(1),g=S;var A=0,C=s[E].context,R=0,k=0;}var x=t[y++],I=a[E][x];m[C].ModelEncode(e,w,I),R=(R<<s[E].qshift)+f[E][I],C=s[E].context,C+=(R&(1<<s[E].qbits)-1)<<s[E].qloc,s[E].pbits>0&&(C+=h[E][Math.min(g,1023)]<<s[E].ploc),s[E].dbits>0&&(C+=l[E][Math.min(A,255)]<<s[E].dloc,A+=k!=I?1:0,k=I),s[E].do_sel&&(C+=B<<s[E].sloc),C&=65535,g--;}return w.RangeFinishEncode(e),e.buf.slice(0,e.pos)}(p,e,t,r,d,s,a,f,h,u)}};},3498:(e,t,r)=>{var n=r(4459),i=r(594),o=r(445),s=r(5260),a=r(2881);e.exports={r4x8_uncompress:function(e,t){n.decode(e).copy(t,0,0);},r4x16_uncompress:function(e,t){i.decode(e).copy(t,0,0);},arith_uncompress:function(e,t){o.decode(e).copy(t,0,0);},fqzcomp_uncompress:function(e,t){var r=new Array;s.decode(e,r).copy(t,0,0);},tok3_uncompress:function(e,t){var r=a.decode(e,0,"\0");Buffer.from(r,"binary").copy(t,0,0);}};},9260:e=>{e.exports=class{constructor(e,t=0,r=0){0!=r?(this.buf=Buffer.allocUnsafe(r),this.length=r):(this.buf=e,this.length=e.length),this.pos=t;}EOF(){return this.pos>=this.length}ReadData(e){var t=this.buf.slice(this.pos,this.pos+e);return this.pos+=e,t}ReadByte(){const e=this.buf[this.pos];return this.pos++,e}ReadChar(){const e=this.buf[this.pos];return this.pos++,String.fromCharCode(e)}ReadUint16(){return this.ReadByte()|this.ReadByte()<<8}ReadUint32(){const e=this.buf.readInt32LE(this.pos);return this.pos+=4,e}ReadString(){var e="";do{var t=this.buf[this.pos++];t&&(e+=String.fromCharCode(t));}while(t);return e}ReadUint7(){var e=0;do{var t=this.ReadByte();e=e<<7|127&t;}while(128&t);return e}ReadITF8(){var e=this.buf[this.pos];return this.pos++,e>=240?(e=(15&e)<<28,e+=(this.buf[this.pos+0]<<20)+(this.buf[this.pos+1]<<12)+(this.buf[this.pos+2]<<4)+(this.buf[this.pos+3]>>4),this.pos+=4):e>=224?(e=(15&e)<<24,e+=(this.buf[this.pos+0]<<16)+(this.buf[this.pos+1]<<8)+(this.buf[this.pos+2]<<0),this.pos+=3):e>=192?(e=(31&e)<<16,e+=(this.buf[this.pos+0]<<8)+(this.buf[this.pos+1]<<0),this.pos+=2):e>=128&&(e=(63&e)<<8,e+=this.buf[this.pos],this.pos++),e}WriteByte(e){this.buf[this.pos++]=e;}WriteChar(e){this.buf[this.pos++]=e.charCodeAt(0);}WriteString(e){for(var t=0;t<e.length;t++)this.buf[this.pos++]=e.charCodeAt(t);this.buf[this.pos++]=0;}WriteData(e,t){for(var r=0;r<t;r++)this.buf[this.pos++]=e[r];}WriteStream(e){this.WriteData(e.buf,e.pos);}WriteUint16(e){this.WriteByte(255&e),this.WriteByte(e>>8&255);}WriteUint32(e){this.buf.writeInt32LE(e,this.pos),this.pos+=4;}WriteUint7(e){var t=0,r=e;do{t+=7,r>>=7;}while(r>0);do{t-=7,this.WriteByte((e>>t&127)+((t>0)<<7));}while(t>0)}WriteITF8(e){e<0&&(e=1+e),e<=127?this.buf[this.pos++]=e:e<=16383?(this.buf[this.pos++]=128|Math.floor(e/256),this.buf[this.pos++]=255&e):e<131071?(this.buf[this.pos++]=192|Math.floor(e/65536),this.buf[this.pos++]=255&Math.floor(e/256),this.buf[this.pos++]=255&e):e<268435455?(this.buf[this.pos++]=224|Math.floor(e/16777216),this.buf[this.pos++]=255&Math.floor(e/65536),this.buf[this.pos++]=255&Math.floor(e/256),this.buf[this.pos++]=255&e):(this.buf[this.pos++]=240|Math.floor(e/268435456),this.buf[this.pos++]=255&Math.floor(e/1048576),this.buf[this.pos++]=255&Math.floor(e/4096),this.buf[this.pos++]=255&Math.floor(e/4),this.buf[this.pos++]=15&e);}WriteByteNeg(e){this.buf[--this.pos]=e;}};},4459:(e,t,r)=>{const n=r(9260);function i(e){return 4095&e}function o(e,t){for(var r=0;t>=e[r+1];)r++;return r}function s(e){for(var t=new Array(4096),r=0,n=0;n<4096;n++){for(;n>=e[r+1];)r++;t[n]=r;}return t}function a(e,t,r){return r*(e>>12)+(4095&e)-t}function f(e,t){for(;t<1<<23;)t=(t<<8)+e.ReadByte();return t}function h(e,t){t.WriteByteNeg(e>>24&255),t.WriteByteNeg(e>>16&255),t.WriteByteNeg(e>>8&255),t.WriteByteNeg(e>>0&255);}function l(e,t,r,n,i){return e=function(e,t,r,n){for(var i=(1<<23>>n<<8)*r;e>=i;)t.WriteByteNeg(255&e),e>>=8;return e}(e,t,n,i),(Math.floor(e/n)<<i)+e%n+r}function u(e,t,r){for(var n=0;n<256;n++)t[n]=0;var i=e.ReadByte(),o=i,s=0;do{var a=e.ReadITF8();t[i]=a,s>0?(s--,i++):(i=e.ReadByte())==o+1&&(s=e.ReadByte()),o=i;}while(0!=i);for(r[0]=0,n=0;n<=255;n++)r[n+1]=r[n]+t[n];}function c(e){for(var t=0,r=0;r<256;r++)t+=e[r];const n=4096;var i=n/t;do{var o=0,s=0,a=0;for(t=0,r=0;r<256;r++)0!=e[r]&&(o<e[r]&&(o=e[r],s=r),e[r]=Math.floor(e[r]*i),0==e[r]&&(e[r]=1),t+=e[r]);t<n?e[s]+=n-t:t-n<e[s]/2&&e[s]>2?e[s]-=t-n:t!=n&&(i*=.99,a=1);}while(a)}function d(e,t){for(var r=0,n=0;n<256;n++)if(t[n]){if(r>0)r--;else if(e.WriteByte(n),n>0&&t[n-1]>0){for(r=n+1;r<256&&t[r];r++);r-=n+1,e.WriteByte(r);}e.WriteITF8(t[n]);}e.WriteByte(0);}e.exports={decode:function(e){var t=new n(e),r=t.ReadByte(),h=(t.ReadUint32(),t.ReadUint32());return 0==r?function(e,t){var r=new Array(256),n=new Array(256);u(e,r,n);for(var o=s(n),h=new Array(4),l=0;l<4;l++)h[l]=e.ReadUint32();var c=new Buffer.allocUnsafe(t);for(l=0;l<t;l++){var d=l%4,p=o[i(h[d])];c[l]=p,h[d]=a(h[d],n[p],r[p]),h[d]=f(e,h[d]);}return c}(t,h):function(e,t){var r=new Array(256),n=new Array(256);!function(e,t,r){for(var n=0;n<256;n++){t[n]=new Array(256),r[n]=new Array(256);for(var i=0;i<256;i++)t[n][i]=0;}var o=e.ReadByte(),s=o,a=0;do{u(e,t[o],r[o]),a>0?(a--,o++):(o=e.ReadByte())==s+1&&(a=e.ReadByte()),s=o;}while(0!=o)}(e,r,n);for(var h=new Array(256),l=0;l<256;l++)h[l]=s(n[l]);for(var c=new Array(4),d=new Array(4),p=0;p<4;p++)c[p]=e.ReadUint32(),d[p]=0;var g=new Buffer.allocUnsafe(t),m=Math.floor(t/4);for(l=0;l<m;l++)for(p=0;p<4;p++){var y=i(c[p]),b=h[d[p]][y];g[l+p*m]=b,c[p]=a(c[p],n[d[p]][b],r[d[p]][b]),c[p]=f(e,c[p]),d[p]=b;}for(l*=4;l<t;)y=i(c[3]),b=o(n[d[3]],y),g[l++]=b,c[3]=a(c[3],n[d[3]][b],r[d[3]][b]),c[3]=f(e,c[3]),d[3]=b;return g}(t,h)},encode:function(e,t){return 0==t?function(e){const t=e.length;var r=new n("",0,780);r.WriteByte(0),r.WriteUint32(0),r.WriteUint32(0);var i=new Array(256);(((function(e,t){for(var r=0;r<256;r++)t[r]=0;for(r=0;r<e.length;r++)t[e[r]]++;})))(e,i),c(i),d(r,i);var o=new Array(256);o[0]=0;for(var s=1;s<256;s++)o[s]=o[s-1]+i[s-1];var a=new Array(4);for(s=0;s<4;s++)a[s]=1<<23;var f=Math.floor(1.05*t+100),u=new n("",f,f);for(s=t-1;s>=0;s--)a[s%4]=l(a[s%4],u,o[e[s]],i[e[s]],12);for(s=3;s>=0;s--)h(a[s],u);var p=r.pos;return r.buf.writeInt32LE(p-9+(u.length-u.pos),1),r.buf.writeInt32LE(t,5),Buffer.concat([r.buf.slice(0,r.pos),u.buf.slice(u.pos,u.length)],r.pos+u.length-u.pos)}(e):function(e){const t=e.length;var r=new n("",0,198156);r.WriteByte(1),r.WriteUint32(0),r.WriteUint32(0);for(var i=new Array(256),o=new Array(256),s=new Array(256),a=0;a<256;a++)o[a]=new Array(256),s[a]=new Array(256);for(function(e,t,r){for(var n=0;n<256;n++){r[n]=0;for(var i=0;i<256;i++)t[n][i]=0;}var o=0;for(n=0;n<e.length;n++)r[e[n]]++,t[o][e[n]]++,o=e[n];t[0][e[1*(e.length>>2)]]++,t[0][e[2*(e.length>>2)]]++,t[0][e[3*(e.length>>2)]]++,r[0]+=3;}(e,o,i),function(e,t){for(var r=0;r<256;r++)t[r]&&c(e[r]);}(o,i),function(e,t,r){for(var n=0,i=0;i<256;i++)if(r[i]){if(n>0)n--;else if(e.WriteByte(i),i>0&&r[i-1]>0){for(n=i+1;n<256&&r[n];n++);n-=i+1,e.WriteByte(n);}d(e,t[i]);}e.WriteByte(0);}(r,o,i),a=0;a<256;a++)if(i[a]){s[a][0]=0;for(var f=1;f<256;f++)s[a][f]=s[a][f-1]+o[a][f-1];}var u=new Array(4),p=new Array(4);for(f=0;f<4;f++)u[f]=1<<23,p[f]=0;var g=new n("",t,t),m=Math.floor(t/4),y=new Array(4),b=new Array(4);for(f=0;f<4;f++)y[f]=(f+1)*m-2,b[f]=e[y[f]+1];for(b[3]=e[t-1],a=t-2;a>4*m-2;a--)u[3]=l(u[3],g,s[e[a]][b[3]],o[e[a]][b[3]],12),b[3]=e[a];for(;y[0]>=0;)for(f=3;f>=0;f--){var v=e[y[f]];u[f]=l(u[f],g,s[v][b[f]],o[v][b[f]],12),b[f]=v,y[f]--;}for(f=3;f>=0;f--)u[f]=l(u[f],g,s[0][b[f]],o[0][b[f]],12);for(a=3;a>=0;a--)h(u[a],g);var w=r.pos;return r.buf.writeInt32LE(w-9+(g.length-g.pos),1),r.buf.writeInt32LE(t,5),Buffer.concat([r.buf.slice(0,r.pos),g.buf.slice(g.pos,g.length)],r.pos+g.length-g.pos)}(e)}};},594:(e,t,r)=>{const n=r(9260);function i(e,t){return e&(1<<t)-1}function o(e,t){for(var r=0;t>=e[r+1];)r++;return r}function s(e,t){for(var r=1<<t,n=new Array(r),i=0,o=0;o<r;o++){for(;o>=e[i+1];)i++;n[o]=i;}return n}function a(e,t,r,n){return r*(e>>n)+(e&(1<<n)-1)-t}function f(e,t){return t<32768&&(t=(t<<16)+e.ReadUint16()),t}function h(e,t){t.WriteByteNeg(e>>24&255),t.WriteByteNeg(e>>16&255),t.WriteByteNeg(e>>8&255),t.WriteByteNeg(e>>0&255);}function l(e,t,r,n,i){return e=function(e,t,r,n){for(var i=(1<<31-n)*r;e>=i;)t.WriteByteNeg(e>>8&255),t.WriteByteNeg(255&e),e>>=16;return e}(e,t,n,i),(Math.floor(e/n)<<i)+e%n+r}function u(e,t,r){0==r&&(r=4);for(var i=new Array(r),o=new Array(r),s=0;s<r;s++)o[s]=Math.floor(t.length/r)+(t.length%r>s),i[s]=new Array(o[s]);for(var a=0,f=0;f<t.length;f+=r,a++)for(var h=0;h<r;h++)a<i[h].length&&(i[h][a]=t[f+h]);var l=new Array(r),u=0;for(s=0;s<r;s++){var c=d(i[s],0),p=d(i[s],1);l[s]=p.length<c.length?p:c,u+=l[s].length;}var g=new n("",0,u+5*r+1);for(g.WriteByte(r),s=0;s<r;s++)g.WriteUint7(l[s].length);for(s=0;s<r;s++)g.WriteData(l[s],l[s].length);return g.buf.slice(0,g.buf.pos)}function c(e,t){var r=e.ReadByte(),h=1&r,l=8&r,u=32&r,d=64&r,m=128&r;if(16&r||(t=e.ReadUint7()),l)return function(e,t){for(var r=e.ReadByte(),n=new Array(r),i=new Array(r),o=0;o<r;o++)n[o]=e.ReadUint7();var s=new Array(r);for(o=0;o<r;o++)i[o]=Math.floor(t/r)+(t%r>o),s[o]=c(e,i[o]);var a=new Buffer.allocUnsafe(t);for(o=0;o<r;o++)for(var f=0;f<i[o];f++)a[f*r+o]=s[o][f];return a}(e,t);if(m)var b=t,[v,w,t]=function(e){for(var t=e.ReadByte(),r=new Array(t),n=0;n<t;n++)r[n]=e.ReadByte();return [r,t,e.ReadUint7()]}(e);if(d)var _=t,[B,E,t]=function(e){var t=e.ReadUint7(),r=e.ReadUint7();if(1&t)var i=e.ReadData((t-1)/2);else {var o=e.ReadUint7();i=e.ReadData(o),i=g(new n(i),t/2);}i=new n(i);var s=new Array(256),a=i.ReadByte();0==a&&(a=256);for(var f=0;f<a;f++)s[i.ReadByte()]=1;return [s,i,r]}(e);if(u)var S=e.ReadData(t);else S=0==h?g(e,t):function(e,t){var r=(c=e.ReadByte())>>4,h=e;if(1&c){var l=e.ReadUint7(),u=e.ReadUint7(),c=new n(e.ReadData(u));h=new n(g(c,l));}var d=new Array(256),m=new Array(256);!function(e,t,r,n){for(var i=0;i<256;i++){t[i]=new Array(256),r[i]=new Array(256);for(var o=0;o<256;o++)t[i][o]=0;}var s=p(e);for(i=0;i<256;i++)if(s[i]){var a=0;for(o=0;o<256;o++)s[o]&&(a>0?a--:(t[i][o]=e.ReadUint7(),0==t[i][o]&&(a=e.ReadByte())));for(y(t[i],n),r[i][0]=0,o=0;o<256;o++)r[i][o+1]=r[i][o]+t[i][o];}}(h,d,m,r);for(var b=new Array(256),v=0;v<256;v++)b[v]=s(m[v],r);for(var w=new Array(4),_=new Array(4),B=0;B<4;B++)w[B]=e.ReadUint32(),_[B]=0;var E=new Buffer.allocUnsafe(t),S=Math.floor(t/4);for(v=0;v<S;v++)for(B=0;B<4;B++){var A=i(w[B],r),C=b[_[B]][A];E[v+B*S]=C,w[B]=a(w[B],m[_[B]][C],d[_[B]][C],r),w[B]=f(e,w[B]),_[B]=C;}for(v*=4;v<t;)A=i(w[3],r),C=o(m[_[3]],A),E[v++]=C,w[3]=a(w[3],m[_[3]][C],d[_[3]][C],r),w[3]=f(e,w[3]),_[3]=C;return E}(e,t);return d&&(S=function(e,t,r,i){new n(e);for(var o=new Buffer.allocUnsafe(i),s=0,a=0;s<i;a++){var f=e[a];if(t[f])for(var h=r.ReadUint7(),l=0;l<=h;l++)o[s++]=f;else o[s++]=f;}return o}(S,B,E,_)),m&&(S=function(e,t,r,n){var i=new Buffer.allocUnsafe(n),o=0;if(r<=1)for(var s=0;s<n;s++)i[s]=t[0];else if(r<=2)for(s=0;s<n;s++){if(s%8==0)var a=e[o++];i[s]=t[1&a],a>>=1;}else if(r<=4)for(s=0;s<n;s++)s%4==0&&(a=e[o++]),i[s]=t[3&a],a>>=2;else if(r<=16)for(s=0;s<n;s++)s%2==0&&(a=e[o++]),i[s]=t[15&a],a>>=4;return i}(S,v,w,b)),S}function d(e,t){var r=new n("",0,10);r.WriteByte(t);var i=1&t,o=8&t,s=32&t,a=64&t,f=128&t,c=t>>8;if(16&t||r.WriteUint7(e.length),o)return Buffer.concat([r.buf.slice(0,r.pos),u(0,e,c)]);var d=new Buffer.alloc(0);f&&([d,e]=function(e){for(var t=new Array(256),r=0;r<256;r++)t[r]=0;for(r=0;r<e.length;r++)t[e[r]]++;var i=new Array(256),o=0;for(r=0;r<256;r++)t[r]>0&&(i[r]=o++);if(!(o>16)){if(o<=1)var s=new Buffer.allocUnsafe(0);else if(o<=2){s=new Buffer.allocUnsafe(Math.ceil(e.length/8));var a=-1;for(r=0;r<e.length;r++)r%8==0&&(s[++a]=0),s[a]+=i[e[r]]<<r%8;}else if(o<=4)for(s=new Buffer.allocUnsafe(Math.ceil(e.length/4)),a=-1,r=0;r<e.length;r++)r%4==0&&(s[++a]=0),s[a]+=i[e[r]]<<r%4*2;else for(s=new Buffer.allocUnsafe(Math.ceil(e.length/2)),a=-1,r=0;r<e.length;r++)r%2==0&&(s[++a]=0),s[a]+=i[e[r]]<<r%2*4;var f=new n("",0,o+5);for(f.WriteByte(o),a=0,r=0;r<256;r++)t[r]>0&&(t[r]=a++,f.WriteByte(r));return f.WriteUint7(s.length),[f.buf.slice(0,f.pos),s]}}(e));var p=new Buffer.alloc(0);if(a&&([p,e]=function(e){for(var t=new Array(256),r=0;r<256;r++)t[r]=0;var i=-1;for(r=0;r<e.length;r++)t[e[r]]+=e[r]==i?1:-1,i=e[r];var o=0;for(r=0;r<256;r++)t[r]>0&&o++;for(o||(o=1,t[0]=1),(h=new n("",0,o+1+e.length)).WriteByte(o),r=0;r<256;r++)t[r]>0&&h.WriteByte(r);var s=new Buffer.allocUnsafe(e.length),a=0;for(r=0;r<e.length;r++)if(s[a++]=e[r],t[e[r]]>0){i=e[r];for(var f=0;r+f+1<e.length&&e[r+f+1]==i;)f++;h.WriteUint7(f),r+=f;}var h,l=v(h.buf.slice(0,h.pos)),u=new n("",0,16);return u.WriteUint7(2*h.pos),u.WriteUint7(a),u.WriteUint7(l.length),[h=Buffer.concat([u.buf.slice(0,u.pos),l]),s.slice(0,a)]}(e)),e.length<4&&1==i&&(i=0,r.buf[0]&=-2),s)var g=e;else g=0==i?v(e):function(e){const t=e.length;for(var r=new n("",0,198156),i=new Array(256),o=new Array(256),s=new Array(256),a=0;a<256;a++)o[a]=new Array(256),s[a]=new Array(256);var f=12;(((function(e,t,r){for(var n=0;n<256;n++){r[n]=0;for(var i=0;i<256;i++)t[n][i]=0;}var o=0;for(n=0;n<e.length;n++)r[o]++,t[o][e[n]]++,o=e[n];r[o]++,t[0][e[1*(e.length>>2)]]++,t[0][e[2*(e.length>>2)]]++,t[0][e[3*(e.length>>2)]]++,r[0]+=3;})))(e,o,i),function(e,t,r){for(var n=0;n<256;n++)if(t[n]){var i=Math.ceil(Math.log2(t[n]));i>12&&(i=12),m(e[n],i);}}(o,i);var u=new n("",0,198156);!function(e,t,r){b(e,r);for(var n=0;n<256;n++)if(r[n])for(var i=0,o=0;o<256;o++)if(r[o])if(i)i--;else if(e.WriteUint7(t[n][o]),!t[n][o]){for(var s=o+1;s<256;s++)if(r[s]){if(0!=t[n][s])break;i++;}e.WriteByte(i);}}(u,o,i);var c=v(u.buf.slice(0,u.pos));for(c.length<u.pos?(r.WriteByte(193),r.WriteUint7(u.pos),r.WriteUint7(c.length),r.WriteData(c,c.length)):(r.WriteByte(192),r.WriteData(u.buf,u.pos)),function(e,t,r){for(var n=0;n<256;n++)t[n]&&y(e[n],12);}(o,i),a=0;a<256;a++)if(i[a]){s[a][0]=0;for(var d=1;d<256;d++)s[a][d]=s[a][d-1]+o[a][d-1];}var p=new Array(4),g=new Array(4);for(d=0;d<4;d++)p[d]=32768,g[d]=0;var w=new n("",1.05*t+100>>0,1.05*t+100>>0),_=Math.floor(t/4),B=new Array(4),E=new Array(4);for(d=0;d<4;d++)B[d]=(d+1)*_-2,E[d]=e[B[d]+1];for(E[3]=e[t-1],a=t-2;a>4*_-2;a--)p[3]=l(p[3],w,s[e[a]][E[3]],o[e[a]][E[3]],f),E[3]=e[a];for(;B[0]>=0;)for(d=3;d>=0;d--){var S=e[B[d]];p[d]=l(p[d],w,s[S][E[d]],o[S][E[d]],f),E[d]=S,B[d]--;}for(d=3;d>=0;d--)p[d]=l(p[d],w,s[0][E[d]],o[0][E[d]],f);for(a=3;a>=0;a--)h(p[a],w);return Buffer.concat([r.buf.slice(0,r.pos),w.buf.slice(w.pos,w.length)],r.pos+w.length-w.pos)}(e);return Buffer.concat([r.buf.slice(0,r.pos),d,p,g])}function p(e){for(var t=new Array(256),r=0;r<256;r++)t[r]=0;var n=0,i=e.ReadByte(),o=i;do{t[i]=1,n>0?(n--,i++):(i=e.ReadByte())==o+1&&(n=e.ReadByte()),o=i;}while(0!=i);return t}function g(e,t){var r=new Array(256),n=new Array(256);!function(e,t,r){for(var n=0;n<256;n++)t[n]=0;var i=p(e);for(n=0;n<256;n++)i[n]>0&&(t[n]=e.ReadUint7());for(y(t,12),r[0]=0,n=0;n<=255;n++)r[n+1]=r[n]+t[n];}(e,r,n);for(var o=s(n,12),h=new Array(4),l=0;l<4;l++)h[l]=e.ReadUint32();var u=new Buffer.allocUnsafe(t);for(l=0;l<t;l++){var c=l%4,d=o[i(h[c],12)];u[l]=d,h[c]=a(h[c],n[d],r[d],12),h[c]=f(e,h[c]);}return u}function m(e,t){for(var r=0,n=0;n<256;n++)r+=e[n];const i=1<<t;var o=i/r;do{var s=0,a=0,f=0;for(r=0,n=0;n<256;n++)0!=e[n]&&(s<e[n]&&(s=e[n],a=n),e[n]=Math.floor(e[n]*o),0==e[n]&&(e[n]=1),r+=e[n]);r<i?e[a]+=i-r:r-i<e[a]/2&&e[a]>2?e[a]-=r-i:r!=i&&(o=i/r,f=1);}while(f)}function y(e,t){for(var r=0,n=0;n<256;n++)r+=e[n];if(0!=r&&r!=1<<t){for(var i=0;r<1<<t;)r*=2,i++;for(n=0;n<256;n++)e[n]<<=i;}}function b(e,t){for(var r=0,n=0;n<256;n++)if(t[n])if(r>0)r--;else if(e.WriteByte(n),n>0&&t[n-1]>0){for(r=n+1;r<256&&t[r];r++);r-=n+1,e.WriteByte(r);}e.WriteByte(0);}function v(e){const t=e.length;var r=new n("",0,780),i=new Array(256);!function(e,t){for(var r=0;r<256;r++)t[r]=0;for(r=0;r<e.length;r++)t[e[r]]++;}(e,i);var o=Math.ceil(Math.log2(t));o>12&&(o=12),m(i,o),function(e,t){b(e,t);for(var r=0;r<256;r++)t[r]&&e.WriteUint7(t[r]);}(r,i),m(i,12);var s=new Array(256);s[0]=0;for(var a=1;a<256;a++)s[a]=s[a-1]+i[a-1];var f=new Array(4);for(a=0;a<4;a++)f[a]=32768;var u=new n("",1.05*t+100>>0,1.05*t+100>>0);for(a=t-1;a>=0;a--)f[a%4]=l(f[a%4],u,s[e[a]],i[e[a]],12);for(a=3;a>=0;a--)h(f[a],u);return Buffer.concat([r.buf.slice(0,r.pos),u.buf.slice(u.pos,u.length)],r.pos+u.length-u.pos)}e.exports={decode:function(e){return c(new n(e),0)},encode:d};},2881:(e,t,r)=>{const n=r(9260),i=r(594);var o=new(r(445));function s(e,t){for(var r=e+"";r.length<t;)r="0"+r;return r}function a(e,t,r,n){var i=e[0][0].ReadByte(),o=n-e[0][i].ReadUint32();if(5==i)return t[n]=t[o],r[n]=r[o],t[n];var a=1;t[n]="",r[n]=new Array(256);do{switch(i=e[a][0].ReadByte()){case 2:r[n][a]=e[a][2].ReadChar();break;case 1:r[n][a]=e[a][1].ReadString();break;case 7:r[n][a]=e[a][7].ReadUint32();break;case 3:var f=e[a][3].ReadUint32(),h=e[a][4].ReadByte();r[n][a]=s(f,h);break;case 8:r[n][a]=(r[o][a]>>0)+e[a][8].ReadByte();break;case 9:f=(r[o][a]>>0)+e[a][9].ReadByte(),h=r[o][a].length,r[n][a]=s(f,h);break;case 10:r[n][a]=r[o][a];break;default:r[n][a]="";}t[n]+=r[n][a++];}while(12!=i);return t[n]}function f(e,t,r,n,i,o){for(var s=0;s<n.length;s++)if(!(r>0&&5==t[s][0].type)&&t[s][r])switch(e[0].WriteByte(t[s][r].type),t[s][r].type){case 6:e[6].WriteUint32(t[s][r].val);break;case 5:e[5].WriteUint32(t[s][r].val);break;case 1:e[1].WriteString(t[s][r].val);break;case 2:e[2].WriteChar(t[s][r].val);break;case 7:e[7].WriteUint32(t[s][r].val);break;case 3:e[3].WriteUint32(t[s][r].val),e[4].WriteByte(t[s][r].val.length);break;case 8:case 9:e[t[s][r].type].WriteByte(t[s][r].val);}}function h(e,t,r,n){for(var i=0;i<=12;i++)if(!(e[i].pos<=0)){n.WriteByte(i+(0==i?128:0)),e[i]=e[i].buf.slice(0,e[i].pos);var o=l(e[i],r);n.WriteUint7(o.length),n.WriteData(o,o.length);}}function l(e,t){var r,n=1<<30,s=[0,1,64,65,128,129,201];for(var a in s){var f=s[a];if(!(1&f&&e.length<100||8&f&&e.length%4!=0)){try{var h=t?o.encode(e,f):i.encode(e,f);}catch(e){h=0;}h&&n>h.length&&(n=h.length,r=h);}}return r}function u(e,t,r,n,i){var o=0,s=i-1;e[i]=new Array(256),t[n]?e[i][0]={type:5,val:i-t[n]}:e[i][0]={type:6,val:0==i?0:1},t[n]=i;for(var a=n.match(/([a-zA-Z0-9]{1,9})|([^a-zA-Z0-9]+)/g),f=0;f<a.length;f++){var h=f+1,l=1,u=a[f];if(a[f].match(/^0+[0-9]*$/g)?l=3:a[f].match(/^[0-9]+$/g)?l=7:1==a[f].length&&(l=2),s>=0&&e[s][h])if(e[s][h].str==a[f])l=10,u="";else if(7==e[s][h].type||8==e[s][h].type){var c=u-e[s][h].str;r[h]++,c>=0&&c<256&&r[h]>i/2&&(l=8,u=c);}else 3!=e[s][h].type&&9!=e[s][h].type||e[s][h].str.length!=u.length||(c=u-e[s][h].str,r[h]++,c>=0&&c<256&&r[h]>i/2&&(l=9,u=c));e[i][h]={str:a[f],val:u,type:l},o<e[i][h].val.length+3&&(o=e[i][h].val.length+3);}return e[i][++h]={type:12},[h+1,o]}e.exports={encode:function(e,t){var r=e.toString();"\n"==r[r.length-1]&&(r=r.substring(0,r.length-1));var i=r.split("\n"),o=new n("",0,2*r.length+1e4);o.WriteUint32(r.length),o.WriteUint32(i.length),o.WriteByte(t);for(var s=new Array(i.length),a={},l=new Array(256).fill(0),c=0,d=0,p=0;p<i.length;p++){var[g,m]=u(s,a,l,i[p],p);c<g&&(c=g),d<m&&(d=m);}for(var y=0;y<c;y++){for(var b=new Array(13),v=0;v<=12;v++)b[v]=new n("",0,i.length*d);f(b,s,y,i),h(b,0,t,o);}return o.buf.slice(0,o.pos)},decode:function(e,t,r){(e=new n(e)).ReadUint32();var s=e.ReadUint32(),f=e.ReadByte(),h=function(e,t,r,s){for(var a=-1,f=new Array(256);!e.EOF();){var h=e.ReadByte(),l=128&h,u=64&h,c=63&h;if(l&&(f[++a]=new Array(13)),0!=c&&l){var d=new Array(s-1).fill(10);f[a][0]=new n(Buffer.from([c].concat(d)));}if(u){var p=e.ReadByte(),g=e.ReadByte();f[a][c]=new n(f[p][g].buf);}else {var m=e.ReadUint7(),y=e.ReadData(m);f[a][c]=r?o.decode(y):i.decode(y),f[a][c]=new n(f[a][c]);}}return f}(e,0,f,s),l=new Array(s),u=new Array(s),c="";void 0===r&&(r="\n");for(var d=0;d<s;d++)c+=a(h,l,u,d)+r;return c}};},1422:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=r(8904),o=n(r(9049)),s=n(r(450));class a{constructor({fill:e,cache:t}){if("function"!=typeof e)throw new TypeError("must pass a fill function");if("object"!=typeof t)throw new TypeError("must pass a cache object");if("function"!=typeof t.get||"function"!=typeof t.set||"function"!=typeof t.delete)throw new TypeError("cache must implement get(key), set(key, val), and and delete(key)");this.cache=t,this.fillCallback=e;}static isAbortException(e){return "AbortError"===e.name||"ERR_ABORTED"===e.code||"AbortError: aborted"===e.message||"Error: aborted"===e.message}evict(e,t){this.cache.get(e)===t&&this.cache.delete(e);}fill(e,t,r,n){const i=new o.default,a=new s.default;a.addCallback(n);const f={aborter:i,promise:this.fillCallback(t,i.signal,(e=>{a.callback(e);})),settled:!1,statusReporter:a,get aborted(){return this.aborter.signal.aborted}};f.aborter.addSignal(r),f.aborter.signal.addEventListener("abort",(()=>{f.settled||this.evict(e,f);})),f.promise.then((()=>{f.settled=!0;}),(()=>{f.settled=!0,this.evict(e,f);})).catch((e=>{throw console.error(e),e})),this.cache.set(e,f);}static checkSinglePromise(e,t){function r(){if(t&&t.aborted)throw Object.assign(new Error("aborted"),{code:"ERR_ABORTED"})}return e.then((e=>(r(),e)),(e=>{throw r(),e}))}has(e){return this.cache.has(e)}get(e,t,r,n){if(!r&&t instanceof i.AbortSignal)throw new TypeError("second get argument appears to be an AbortSignal, perhaps you meant to pass `null` for the fill data?");const o=this.cache.get(e);return o?o.aborted&&!o.settled?(this.evict(e,o),this.get(e,t,r,n)):o.settled?o.promise:(o.aborter.addSignal(r),o.statusReporter.addCallback(n),a.checkSinglePromise(o.promise,r)):(this.fill(e,t,r,n),a.checkSinglePromise(this.cache.get(e).promise,r))}delete(e){const t=this.cache.get(e);t&&(t.settled||t.aborter.abort(),this.cache.delete(e));}clear(){const e=this.cache.keys();let t=0;for(let r=e.next();!r.done;r=e.next())this.delete(r.value),t+=1;return t}}t.default=a;},9049:(e,t,r)=>{Object.defineProperty(t,"__esModule",{value:!0});const n=r(8904);class i{}t.default=class{constructor(){this.signals=new Set,this.abortController=new n.AbortController;}addSignal(e=new i){if(this.signal.aborted)throw new Error("cannot add a signal, already aborted!");this.signals.add(e),e.aborted?this.handleAborted(e):"function"==typeof e.addEventListener&&e.addEventListener("abort",(()=>{this.handleAborted(e);}));}handleAborted(e){this.signals.delete(e),0===this.signals.size&&this.abortController.abort();}get signal(){return this.abortController.signal}abort(){this.abortController.abort();}};},450:(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.default=class{constructor(){this.callbacks=new Set;}addCallback(e=(()=>{})){this.callbacks.add(e),e(this.currentMessage);}callback(e){this.currentMessage=e,this.callbacks.forEach((t=>{t(e);}));}};},8904:(e,t,r)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.AbortSignal=t.AbortController=void 0;const n=r(5988);var i=function(){if("undefined"!=typeof self)return self;if("undefined"!=typeof window)return window;if(void 0!==r.g)return r.g;throw new Error("unable to locate global object")};let o=void 0===i().AbortController?n.AbortController:i().AbortController;t.AbortController=o;let s=void 0===i().AbortController?n.AbortSignal:i().AbortSignal;t.AbortSignal=s;},4105:function(e,t,r){var n=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=n(r(1422));t.default=i.default;},5988:(e,t)=>{function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function n(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n);}}function i(e,t,r){return t&&n(e.prototype,t),r&&n(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function o(e){return o=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},o(e)}function s(e,t){return s=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},s(e,t)}function a(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function f(e,t){if(t&&("object"==typeof t||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return a(e)}function h(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=o(e)););return e}function l(){return l="undefined"!=typeof Reflect&&Reflect.get?Reflect.get.bind():function(e,t,r){var n=h(e,t);if(n){var i=Object.getOwnPropertyDescriptor(n,t);return i.get?i.get.call(arguments.length<3?e:r):i.value}},l.apply(this,arguments)}Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(){r(this,e),Object.defineProperty(this,"listeners",{value:{},writable:!0,configurable:!0});}return i(e,[{key:"addEventListener",value:function(e,t,r){e in this.listeners||(this.listeners[e]=[]),this.listeners[e].push({callback:t,options:r});}},{key:"removeEventListener",value:function(e,t){if(e in this.listeners)for(var r=this.listeners[e],n=0,i=r.length;n<i;n++)if(r[n].callback===t)return void r.splice(n,1)}},{key:"dispatchEvent",value:function(e){if(e.type in this.listeners){for(var t=this.listeners[e.type].slice(),r=0,n=t.length;r<n;r++){var i=t[r];try{i.callback.call(this,e);}catch(e){Promise.resolve().then((function(){throw e}));}i.options&&i.options.once&&this.removeEventListener(e.type,i.callback);}return !e.defaultPrevented}}}]),e}(),c=function(e){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&s(e,t);}(c,e);var t,n,h=(t=c,n=function(){if("undefined"==typeof Reflect||!Reflect.construct)return !1;if(Reflect.construct.sham)return !1;if("function"==typeof Proxy)return !0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return !1}}(),function(){var e,r=o(t);if(n){var i=o(this).constructor;e=Reflect.construct(r,arguments,i);}else e=r.apply(this,arguments);return f(this,e)});function c(){var e;return r(this,c),(e=h.call(this)).listeners||u.call(a(e)),Object.defineProperty(a(e),"aborted",{value:!1,writable:!0,configurable:!0}),Object.defineProperty(a(e),"onabort",{value:null,writable:!0,configurable:!0}),Object.defineProperty(a(e),"reason",{value:void 0,writable:!0,configurable:!0}),e}return i(c,[{key:"toString",value:function(){return "[object AbortSignal]"}},{key:"dispatchEvent",value:function(e){"abort"===e.type&&(this.aborted=!0,"function"==typeof this.onabort&&this.onabort.call(this,e)),l(o(c.prototype),"dispatchEvent",this).call(this,e);}}]),c}(u),d=function(){function e(){r(this,e),Object.defineProperty(this,"signal",{value:new c,writable:!0,configurable:!0});}return i(e,[{key:"abort",value:function(e){var t;try{t=new Event("abort");}catch(e){"undefined"!=typeof document?document.createEvent?(t=document.createEvent("Event")).initEvent("abort",!1,!1):(t=document.createEventObject()).type="abort":t={type:"abort",bubbles:!1,cancelable:!1};}var r=e;if(void 0===r)if("undefined"==typeof document)(r=new Error("This operation was aborted")).name="AbortError";else try{r=new DOMException("signal is aborted without reason");}catch(e){(r=new Error("This operation was aborted")).name="AbortError";}this.signal.reason=r,this.signal.dispatchEvent(t);}},{key:"toString",value:function(){return "[object AbortController]"}}]),e}();"undefined"!=typeof Symbol&&Symbol.toStringTag&&(d.prototype[Symbol.toStringTag]="AbortController",c.prototype[Symbol.toStringTag]="AbortSignal"),t.AbortController=d,t.AbortSignal=c,t.abortableFetch=function(e){"function"==typeof e&&(e={fetch:e});var t=e,r=t.fetch,n=t.Request,i=void 0===n?r.Request:n,o=t.AbortController,s=t.__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL,a=void 0!==s&&s;if(!function(e){return e.__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL?(!0):"function"==typeof e.Request&&!e.Request.prototype.hasOwnProperty("signal")||!e.AbortController}({fetch:r,Request:i,AbortController:o,__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL:a}))return {fetch:r,Request:f};var f=i;(f&&!f.prototype.hasOwnProperty("signal")||a)&&((f=function(e,t){var r;t&&t.signal&&(r=t.signal,delete t.signal);var n=new i(e,t);return r&&Object.defineProperty(n,"signal",{writable:!1,enumerable:!1,configurable:!0,value:r}),n}).prototype=i.prototype);var h=r;return {fetch:function(e,t){var r=f&&f.prototype.isPrototypeOf(e)?e.signal:t?t.signal:void 0;if(r){var n;try{n=new DOMException("Aborted","AbortError");}catch(e){(n=new Error("Aborted")).name="AbortError";}if(r.aborted)return Promise.reject(n);var i=new Promise((function(e,t){r.addEventListener("abort",(function(){return t(n)}),{once:!0});}));return t&&t.signal&&delete t.signal,Promise.race([i,h(e,t)])}return h(e,t)},Request:f}};},9742:(e,t)=>{t.byteLength=function(e){var t=f(e),r=t[0],n=t[1];return 3*(r+n)/4-n},t.toByteArray=function(e){var t,r,o=f(e),s=o[0],a=o[1],h=new i(function(e,t,r){return 3*(t+r)/4-r}(0,s,a)),l=0,u=a>0?s-4:s;for(r=0;r<u;r+=4)t=n[e.charCodeAt(r)]<<18|n[e.charCodeAt(r+1)]<<12|n[e.charCodeAt(r+2)]<<6|n[e.charCodeAt(r+3)],h[l++]=t>>16&255,h[l++]=t>>8&255,h[l++]=255&t;return 2===a&&(t=n[e.charCodeAt(r)]<<2|n[e.charCodeAt(r+1)]>>4,h[l++]=255&t),1===a&&(t=n[e.charCodeAt(r)]<<10|n[e.charCodeAt(r+1)]<<4|n[e.charCodeAt(r+2)]>>2,h[l++]=t>>8&255,h[l++]=255&t),h},t.fromByteArray=function(e){for(var t,n=e.length,i=n%3,o=[],s=16383,a=0,f=n-i;a<f;a+=s)o.push(h(e,a,a+s>f?f:a+s));return 1===i?(t=e[n-1],o.push(r[t>>2]+r[t<<4&63]+"==")):2===i&&(t=(e[n-2]<<8)+e[n-1],o.push(r[t>>10]+r[t>>4&63]+r[t<<2&63]+"=")),o.join("")};for(var r=[],n=[],i="undefined"!=typeof Uint8Array?Uint8Array:Array,o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s=0,a=o.length;s<a;++s)r[s]=o[s],n[o.charCodeAt(s)]=s;function f(e){var t=e.length;if(t%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var r=e.indexOf("=");return -1===r&&(r=t),[r,r===t?0:4-r%4]}function h(e,t,n){for(var i,o,s=[],a=t;a<n;a+=3)i=(e[a]<<16&16711680)+(e[a+1]<<8&65280)+(255&e[a+2]),s.push(r[(o=i)>>18&63]+r[o>>12&63]+r[o>>6&63]+r[63&o]);return s.join("")}n["-".charCodeAt(0)]=62,n["_".charCodeAt(0)]=63;},2779:(e,t,r)=>{var n=r(8764).Buffer,i=[0,1996959894,3993919788,2567524794,124634137,1886057615,3915621685,2657392035,249268274,2044508324,3772115230,2547177864,162941995,2125561021,3887607047,2428444049,498536548,1789927666,4089016648,2227061214,450548861,1843258603,4107580753,2211677639,325883990,1684777152,4251122042,2321926636,335633487,1661365465,4195302755,2366115317,997073096,1281953886,3579855332,2724688242,1006888145,1258607687,3524101629,2768942443,901097722,1119000684,3686517206,2898065728,853044451,1172266101,3705015759,2882616665,651767980,1373503546,3369554304,3218104598,565507253,1454621731,3485111705,3099436303,671266974,1594198024,3322730930,2970347812,795835527,1483230225,3244367275,3060149565,1994146192,31158534,2563907772,4023717930,1907459465,112637215,2680153253,3904427059,2013776290,251722036,2517215374,3775830040,2137656763,141376813,2439277719,3865271297,1802195444,476864866,2238001368,4066508878,1812370925,453092731,2181625025,4111451223,1706088902,314042704,2344532202,4240017532,1658658271,366619977,2362670323,4224994405,1303535960,984961486,2747007092,3569037538,1256170817,1037604311,2765210733,3554079995,1131014506,879679996,2909243462,3663771856,1141124467,855842277,2852801631,3708648649,1342533948,654459306,3188396048,3373015174,1466479909,544179635,3110523913,3462522015,1591671054,702138776,2966460450,3352799412,1504918807,783551873,3082640443,3233442989,3988292384,2596254646,62317068,1957810842,3939845945,2647816111,81470997,1943803523,3814918930,2489596804,225274430,2053790376,3826175755,2466906013,167816743,2097651377,4027552580,2265490386,503444072,1762050814,4150417245,2154129355,426522225,1852507879,4275313526,2312317920,282753626,1742555852,4189708143,2394877945,397917763,1622183637,3604390888,2714866558,953729732,1340076626,3518719985,2797360999,1068828381,1219638859,3624741850,2936675148,906185462,1090812512,3747672003,2825379669,829329135,1181335161,3412177804,3160834842,628085408,1382605366,3423369109,3138078467,570562233,1426400815,3317316542,2998733608,733239954,1555261956,3268935591,3050360625,752459403,1541320221,2607071920,3965973030,1969922972,40735498,2617837225,3943577151,1913087877,83908371,2512341634,3803740692,2075208622,213261112,2463272603,3855990285,2094854071,198958881,2262029012,4057260610,1759359992,534414190,2176718541,4139329115,1873836001,414664567,2282248934,4279200368,1711684554,285281116,2405801727,4167216745,1634467795,376229701,2685067896,3608007406,1308918612,956543938,2808555105,3495958263,1231636301,1047427035,2932959818,3654703836,1088359270,936918e3,2847714899,3736837829,1202900863,817233897,3183342108,3401237130,1404277552,615818150,3134207493,3453421203,1423857449,601450431,3009837614,3294710456,1567103746,711928724,3020668471,3272380065,1510334235,755167117];function o(e){if(n.isBuffer(e))return e;var t="function"==typeof n.alloc&&"function"==typeof n.from;if("number"==typeof e)return t?n.alloc(e):new n(e);if("string"==typeof e)return t?n.from(e):new n(e);throw new Error("input must be buffer, number, or string, received "+typeof e)}function s(e){var t=o(4);return t.writeInt32BE(e,0),t}function a(e,t){e=o(e),n.isBuffer(t)&&(t=t.readUInt32BE(0));for(var r=-1^~~t,s=0;s<e.length;s++)r=i[255&(r^e[s])]^r>>>8;return -1^r}function f(){return s(a.apply(null,arguments))}"undefined"!=typeof Int32Array&&(i=new Int32Array(i)),f.signed=function(){return a.apply(null,arguments)},f.unsigned=function(){return a.apply(null,arguments)>>>0},e.exports=f;},8764:(e,t,r)=>{const n=r(9742),i=r(645),o="function"==typeof Symbol&&"function"==typeof Symbol.for?Symbol.for("nodejs.util.inspect.custom"):null;t.Buffer=f,t.SlowBuffer=function(e){return +e!=e&&(e=0),f.alloc(+e)},t.INSPECT_MAX_BYTES=50;const s=2147483647;function a(e){if(e>s)throw new RangeError('The value "'+e+'" is invalid for option "size"');const t=new Uint8Array(e);return Object.setPrototypeOf(t,f.prototype),t}function f(e,t,r){if("number"==typeof e){if("string"==typeof t)throw new TypeError('The "string" argument must be of type string. Received type number');return u(e)}return h(e,t,r)}function h(e,t,r){if("string"==typeof e)return function(e,t){if("string"==typeof t&&""!==t||(t="utf8"),!f.isEncoding(t))throw new TypeError("Unknown encoding: "+t);const r=0|g(e,t);let n=a(r);const i=n.write(e,t);return i!==r&&(n=n.slice(0,i)),n}(e,t);if(ArrayBuffer.isView(e))return function(e){if(Q(e,Uint8Array)){const t=new Uint8Array(e);return d(t.buffer,t.byteOffset,t.byteLength)}return c(e)}(e);if(null==e)throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type "+typeof e);if(Q(e,ArrayBuffer)||e&&Q(e.buffer,ArrayBuffer))return d(e,t,r);if("undefined"!=typeof SharedArrayBuffer&&(Q(e,SharedArrayBuffer)||e&&Q(e.buffer,SharedArrayBuffer)))return d(e,t,r);if("number"==typeof e)throw new TypeError('The "value" argument must not be of type number. Received type number');const n=e.valueOf&&e.valueOf();if(null!=n&&n!==e)return f.from(n,t,r);const i=function(e){if(f.isBuffer(e)){const t=0|p(e.length),r=a(t);return 0===r.length||e.copy(r,0,0,t),r}return void 0!==e.length?"number"!=typeof e.length||Y(e.length)?a(0):c(e):"Buffer"===e.type&&Array.isArray(e.data)?c(e.data):void 0}(e);if(i)return i;if("undefined"!=typeof Symbol&&null!=Symbol.toPrimitive&&"function"==typeof e[Symbol.toPrimitive])return f.from(e[Symbol.toPrimitive]("string"),t,r);throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type "+typeof e)}function l(e){if("number"!=typeof e)throw new TypeError('"size" argument must be of type number');if(e<0)throw new RangeError('The value "'+e+'" is invalid for option "size"')}function u(e){return l(e),a(e<0?0:0|p(e))}function c(e){const t=e.length<0?0:0|p(e.length),r=a(t);for(let n=0;n<t;n+=1)r[n]=255&e[n];return r}function d(e,t,r){if(t<0||e.byteLength<t)throw new RangeError('"offset" is outside of buffer bounds');if(e.byteLength<t+(r||0))throw new RangeError('"length" is outside of buffer bounds');let n;return n=void 0===t&&void 0===r?new Uint8Array(e):void 0===r?new Uint8Array(e,t):new Uint8Array(e,t,r),Object.setPrototypeOf(n,f.prototype),n}function p(e){if(e>=s)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+s.toString(16)+" bytes");return 0|e}function g(e,t){if(f.isBuffer(e))return e.length;if(ArrayBuffer.isView(e)||Q(e,ArrayBuffer))return e.byteLength;if("string"!=typeof e)throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. Received type '+typeof e);const r=e.length,n=arguments.length>2&&!0===arguments[2];if(!n&&0===r)return 0;let i=!1;for(;;)switch(t){case"ascii":case"latin1":case"binary":return r;case"utf8":case"utf-8":return V(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*r;case"hex":return r>>>1;case"base64":return Z(e).length;default:if(i)return n?-1:V(e).length;t=(""+t).toLowerCase(),i=!0;}}function m(e,t,r){let n=!1;if((void 0===t||t<0)&&(t=0),t>this.length)return "";if((void 0===r||r>this.length)&&(r=this.length),r<=0)return "";if((r>>>=0)<=(t>>>=0))return "";for(e||(e="utf8");;)switch(e){case"hex":return I(this,t,r);case"utf8":case"utf-8":return C(this,t,r);case"ascii":return k(this,t,r);case"latin1":case"binary":return x(this,t,r);case"base64":return A(this,t,r);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return M(this,t,r);default:if(n)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),n=!0;}}function y(e,t,r){const n=e[t];e[t]=e[r],e[r]=n;}function b(e,t,r,n,i){if(0===e.length)return -1;if("string"==typeof r?(n=r,r=0):r>2147483647?r=2147483647:r<-2147483648&&(r=-2147483648),Y(r=+r)&&(r=i?0:e.length-1),r<0&&(r=e.length+r),r>=e.length){if(i)return -1;r=e.length-1;}else if(r<0){if(!i)return -1;r=0;}if("string"==typeof t&&(t=f.from(t,n)),f.isBuffer(t))return 0===t.length?-1:v(e,t,r,n,i);if("number"==typeof t)return t&=255,"function"==typeof Uint8Array.prototype.indexOf?i?Uint8Array.prototype.indexOf.call(e,t,r):Uint8Array.prototype.lastIndexOf.call(e,t,r):v(e,[t],r,n,i);throw new TypeError("val must be string, number or Buffer")}function v(e,t,r,n,i){let o,s=1,a=e.length,f=t.length;if(void 0!==n&&("ucs2"===(n=String(n).toLowerCase())||"ucs-2"===n||"utf16le"===n||"utf-16le"===n)){if(e.length<2||t.length<2)return -1;s=2,a/=2,f/=2,r/=2;}function h(e,t){return 1===s?e[t]:e.readUInt16BE(t*s)}if(i){let n=-1;for(o=r;o<a;o++)if(h(e,o)===h(t,-1===n?0:o-n)){if(-1===n&&(n=o),o-n+1===f)return n*s}else -1!==n&&(o-=o-n),n=-1;}else for(r+f>a&&(r=a-f),o=r;o>=0;o--){let r=!0;for(let n=0;n<f;n++)if(h(e,o+n)!==h(t,n)){r=!1;break}if(r)return o}return -1}function w(e,t,r,n){r=Number(r)||0;const i=e.length-r;n?(n=Number(n))>i&&(n=i):n=i;const o=t.length;let s;for(n>o/2&&(n=o/2),s=0;s<n;++s){const n=parseInt(t.substr(2*s,2),16);if(Y(n))return s;e[r+s]=n;}return s}function _(e,t,r,n){return G(V(t,e.length-r),e,r,n)}function B(e,t,r,n){return G(function(e){const t=[];for(let r=0;r<e.length;++r)t.push(255&e.charCodeAt(r));return t}(t),e,r,n)}function E(e,t,r,n){return G(Z(t),e,r,n)}function S(e,t,r,n){return G(function(e,t){let r,n,i;const o=[];for(let s=0;s<e.length&&!((t-=2)<0);++s)r=e.charCodeAt(s),n=r>>8,i=r%256,o.push(i),o.push(n);return o}(t,e.length-r),e,r,n)}function A(e,t,r){return 0===t&&r===e.length?n.fromByteArray(e):n.fromByteArray(e.slice(t,r))}function C(e,t,r){r=Math.min(e.length,r);const n=[];let i=t;for(;i<r;){const t=e[i];let o=null,s=t>239?4:t>223?3:t>191?2:1;if(i+s<=r){let r,n,a,f;switch(s){case 1:t<128&&(o=t);break;case 2:r=e[i+1],128==(192&r)&&(f=(31&t)<<6|63&r,f>127&&(o=f));break;case 3:r=e[i+1],n=e[i+2],128==(192&r)&&128==(192&n)&&(f=(15&t)<<12|(63&r)<<6|63&n,f>2047&&(f<55296||f>57343)&&(o=f));break;case 4:r=e[i+1],n=e[i+2],a=e[i+3],128==(192&r)&&128==(192&n)&&128==(192&a)&&(f=(15&t)<<18|(63&r)<<12|(63&n)<<6|63&a,f>65535&&f<1114112&&(o=f));}}null===o?(o=65533,s=1):o>65535&&(o-=65536,n.push(o>>>10&1023|55296),o=56320|1023&o),n.push(o),i+=s;}return function(e){const t=e.length;if(t<=R)return String.fromCharCode.apply(String,e);let r="",n=0;for(;n<t;)r+=String.fromCharCode.apply(String,e.slice(n,n+=R));return r}(n)}t.kMaxLength=s,f.TYPED_ARRAY_SUPPORT=function(){try{const e=new Uint8Array(1),t={foo:function(){return 42}};return Object.setPrototypeOf(t,Uint8Array.prototype),Object.setPrototypeOf(e,t),42===e.foo()}catch(e){return !1}}(),f.TYPED_ARRAY_SUPPORT||"undefined"==typeof console||"function"!=typeof console.error||console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support."),Object.defineProperty(f.prototype,"parent",{enumerable:!0,get:function(){if(f.isBuffer(this))return this.buffer}}),Object.defineProperty(f.prototype,"offset",{enumerable:!0,get:function(){if(f.isBuffer(this))return this.byteOffset}}),f.poolSize=8192,f.from=function(e,t,r){return h(e,t,r)},Object.setPrototypeOf(f.prototype,Uint8Array.prototype),Object.setPrototypeOf(f,Uint8Array),f.alloc=function(e,t,r){return function(e,t,r){return l(e),e<=0?a(e):void 0!==t?"string"==typeof r?a(e).fill(t,r):a(e).fill(t):a(e)}(e,t,r)},f.allocUnsafe=function(e){return u(e)},f.allocUnsafeSlow=function(e){return u(e)},f.isBuffer=function(e){return null!=e&&!0===e._isBuffer&&e!==f.prototype},f.compare=function(e,t){if(Q(e,Uint8Array)&&(e=f.from(e,e.offset,e.byteLength)),Q(t,Uint8Array)&&(t=f.from(t,t.offset,t.byteLength)),!f.isBuffer(e)||!f.isBuffer(t))throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');if(e===t)return 0;let r=e.length,n=t.length;for(let i=0,o=Math.min(r,n);i<o;++i)if(e[i]!==t[i]){r=e[i],n=t[i];break}return r<n?-1:n<r?1:0},f.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return !0;default:return !1}},f.concat=function(e,t){if(!Array.isArray(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return f.alloc(0);let r;if(void 0===t)for(t=0,r=0;r<e.length;++r)t+=e[r].length;const n=f.allocUnsafe(t);let i=0;for(r=0;r<e.length;++r){let t=e[r];if(Q(t,Uint8Array))i+t.length>n.length?(f.isBuffer(t)||(t=f.from(t)),t.copy(n,i)):Uint8Array.prototype.set.call(n,t,i);else {if(!f.isBuffer(t))throw new TypeError('"list" argument must be an Array of Buffers');t.copy(n,i);}i+=t.length;}return n},f.byteLength=g,f.prototype._isBuffer=!0,f.prototype.swap16=function(){const e=this.length;if(e%2!=0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(let t=0;t<e;t+=2)y(this,t,t+1);return this},f.prototype.swap32=function(){const e=this.length;if(e%4!=0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(let t=0;t<e;t+=4)y(this,t,t+3),y(this,t+1,t+2);return this},f.prototype.swap64=function(){const e=this.length;if(e%8!=0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(let t=0;t<e;t+=8)y(this,t,t+7),y(this,t+1,t+6),y(this,t+2,t+5),y(this,t+3,t+4);return this},f.prototype.toString=function(){const e=this.length;return 0===e?"":0===arguments.length?C(this,0,e):m.apply(this,arguments)},f.prototype.toLocaleString=f.prototype.toString,f.prototype.equals=function(e){if(!f.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e||0===f.compare(this,e)},f.prototype.inspect=function(){let e="";const r=t.INSPECT_MAX_BYTES;return e=this.toString("hex",0,r).replace(/(.{2})/g,"$1 ").trim(),this.length>r&&(e+=" ... "),"<Buffer "+e+">"},o&&(f.prototype[o]=f.prototype.inspect),f.prototype.compare=function(e,t,r,n,i){if(Q(e,Uint8Array)&&(e=f.from(e,e.offset,e.byteLength)),!f.isBuffer(e))throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. Received type '+typeof e);if(void 0===t&&(t=0),void 0===r&&(r=e?e.length:0),void 0===n&&(n=0),void 0===i&&(i=this.length),t<0||r>e.length||n<0||i>this.length)throw new RangeError("out of range index");if(n>=i&&t>=r)return 0;if(n>=i)return -1;if(t>=r)return 1;if(this===e)return 0;let o=(i>>>=0)-(n>>>=0),s=(r>>>=0)-(t>>>=0);const a=Math.min(o,s),h=this.slice(n,i),l=e.slice(t,r);for(let e=0;e<a;++e)if(h[e]!==l[e]){o=h[e],s=l[e];break}return o<s?-1:s<o?1:0},f.prototype.includes=function(e,t,r){return -1!==this.indexOf(e,t,r)},f.prototype.indexOf=function(e,t,r){return b(this,e,t,r,!0)},f.prototype.lastIndexOf=function(e,t,r){return b(this,e,t,r,!1)},f.prototype.write=function(e,t,r,n){if(void 0===t)n="utf8",r=this.length,t=0;else if(void 0===r&&"string"==typeof t)n=t,r=this.length,t=0;else {if(!isFinite(t))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");t>>>=0,isFinite(r)?(r>>>=0,void 0===n&&(n="utf8")):(n=r,r=void 0);}const i=this.length-t;if((void 0===r||r>i)&&(r=i),e.length>0&&(r<0||t<0)||t>this.length)throw new RangeError("Attempt to write outside buffer bounds");n||(n="utf8");let o=!1;for(;;)switch(n){case"hex":return w(this,e,t,r);case"utf8":case"utf-8":return _(this,e,t,r);case"ascii":case"latin1":case"binary":return B(this,e,t,r);case"base64":return E(this,e,t,r);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return S(this,e,t,r);default:if(o)throw new TypeError("Unknown encoding: "+n);n=(""+n).toLowerCase(),o=!0;}},f.prototype.toJSON=function(){return {type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};const R=4096;function k(e,t,r){let n="";r=Math.min(e.length,r);for(let i=t;i<r;++i)n+=String.fromCharCode(127&e[i]);return n}function x(e,t,r){let n="";r=Math.min(e.length,r);for(let i=t;i<r;++i)n+=String.fromCharCode(e[i]);return n}function I(e,t,r){const n=e.length;(!t||t<0)&&(t=0),(!r||r<0||r>n)&&(r=n);let i="";for(let n=t;n<r;++n)i+=K[e[n]];return i}function M(e,t,r){const n=e.slice(t,r);let i="";for(let e=0;e<n.length-1;e+=2)i+=String.fromCharCode(n[e]+256*n[e+1]);return i}function F(e,t,r){if(e%1!=0||e<0)throw new RangeError("offset is not uint");if(e+t>r)throw new RangeError("Trying to access beyond buffer length")}function O(e,t,r,n,i,o){if(!f.isBuffer(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(t>i||t<o)throw new RangeError('"value" argument is out of bounds');if(r+n>e.length)throw new RangeError("Index out of range")}function T(e,t,r,n,i){j(t,n,i,e,r,7);let o=Number(t&BigInt(4294967295));e[r++]=o,o>>=8,e[r++]=o,o>>=8,e[r++]=o,o>>=8,e[r++]=o;let s=Number(t>>BigInt(32)&BigInt(4294967295));return e[r++]=s,s>>=8,e[r++]=s,s>>=8,e[r++]=s,s>>=8,e[r++]=s,r}function U(e,t,r,n,i){j(t,n,i,e,r,7);let o=Number(t&BigInt(4294967295));e[r+7]=o,o>>=8,e[r+6]=o,o>>=8,e[r+5]=o,o>>=8,e[r+4]=o;let s=Number(t>>BigInt(32)&BigInt(4294967295));return e[r+3]=s,s>>=8,e[r+2]=s,s>>=8,e[r+1]=s,s>>=8,e[r]=s,r+8}function P(e,t,r,n,i,o){if(r+n>e.length)throw new RangeError("Index out of range");if(r<0)throw new RangeError("Index out of range")}function N(e,t,r,n,o){return t=+t,r>>>=0,o||P(e,0,r,4),i.write(e,t,r,n,23,4),r+4}function L(e,t,r,n,o){return t=+t,r>>>=0,o||P(e,0,r,8),i.write(e,t,r,n,52,8),r+8}f.prototype.slice=function(e,t){const r=this.length;(e=~~e)<0?(e+=r)<0&&(e=0):e>r&&(e=r),(t=void 0===t?r:~~t)<0?(t+=r)<0&&(t=0):t>r&&(t=r),t<e&&(t=e);const n=this.subarray(e,t);return Object.setPrototypeOf(n,f.prototype),n},f.prototype.readUintLE=f.prototype.readUIntLE=function(e,t,r){e>>>=0,t>>>=0,r||F(e,t,this.length);let n=this[e],i=1,o=0;for(;++o<t&&(i*=256);)n+=this[e+o]*i;return n},f.prototype.readUintBE=f.prototype.readUIntBE=function(e,t,r){e>>>=0,t>>>=0,r||F(e,t,this.length);let n=this[e+--t],i=1;for(;t>0&&(i*=256);)n+=this[e+--t]*i;return n},f.prototype.readUint8=f.prototype.readUInt8=function(e,t){return e>>>=0,t||F(e,1,this.length),this[e]},f.prototype.readUint16LE=f.prototype.readUInt16LE=function(e,t){return e>>>=0,t||F(e,2,this.length),this[e]|this[e+1]<<8},f.prototype.readUint16BE=f.prototype.readUInt16BE=function(e,t){return e>>>=0,t||F(e,2,this.length),this[e]<<8|this[e+1]},f.prototype.readUint32LE=f.prototype.readUInt32LE=function(e,t){return e>>>=0,t||F(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},f.prototype.readUint32BE=f.prototype.readUInt32BE=function(e,t){return e>>>=0,t||F(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},f.prototype.readBigUInt64LE=X((function(e){H(e>>>=0,"offset");const t=this[e],r=this[e+7];void 0!==t&&void 0!==r||W(e,this.length-8);const n=t+256*this[++e]+65536*this[++e]+this[++e]*2**24,i=this[++e]+256*this[++e]+65536*this[++e]+r*2**24;return BigInt(n)+(BigInt(i)<<BigInt(32))})),f.prototype.readBigUInt64BE=X((function(e){H(e>>>=0,"offset");const t=this[e],r=this[e+7];void 0!==t&&void 0!==r||W(e,this.length-8);const n=t*2**24+65536*this[++e]+256*this[++e]+this[++e],i=this[++e]*2**24+65536*this[++e]+256*this[++e]+r;return (BigInt(n)<<BigInt(32))+BigInt(i)})),f.prototype.readIntLE=function(e,t,r){e>>>=0,t>>>=0,r||F(e,t,this.length);let n=this[e],i=1,o=0;for(;++o<t&&(i*=256);)n+=this[e+o]*i;return i*=128,n>=i&&(n-=Math.pow(2,8*t)),n},f.prototype.readIntBE=function(e,t,r){e>>>=0,t>>>=0,r||F(e,t,this.length);let n=t,i=1,o=this[e+--n];for(;n>0&&(i*=256);)o+=this[e+--n]*i;return i*=128,o>=i&&(o-=Math.pow(2,8*t)),o},f.prototype.readInt8=function(e,t){return e>>>=0,t||F(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},f.prototype.readInt16LE=function(e,t){e>>>=0,t||F(e,2,this.length);const r=this[e]|this[e+1]<<8;return 32768&r?4294901760|r:r},f.prototype.readInt16BE=function(e,t){e>>>=0,t||F(e,2,this.length);const r=this[e+1]|this[e]<<8;return 32768&r?4294901760|r:r},f.prototype.readInt32LE=function(e,t){return e>>>=0,t||F(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},f.prototype.readInt32BE=function(e,t){return e>>>=0,t||F(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},f.prototype.readBigInt64LE=X((function(e){H(e>>>=0,"offset");const t=this[e],r=this[e+7];void 0!==t&&void 0!==r||W(e,this.length-8);const n=this[e+4]+256*this[e+5]+65536*this[e+6]+(r<<24);return (BigInt(n)<<BigInt(32))+BigInt(t+256*this[++e]+65536*this[++e]+this[++e]*2**24)})),f.prototype.readBigInt64BE=X((function(e){H(e>>>=0,"offset");const t=this[e],r=this[e+7];void 0!==t&&void 0!==r||W(e,this.length-8);const n=(t<<24)+65536*this[++e]+256*this[++e]+this[++e];return (BigInt(n)<<BigInt(32))+BigInt(this[++e]*2**24+65536*this[++e]+256*this[++e]+r)})),f.prototype.readFloatLE=function(e,t){return e>>>=0,t||F(e,4,this.length),i.read(this,e,!0,23,4)},f.prototype.readFloatBE=function(e,t){return e>>>=0,t||F(e,4,this.length),i.read(this,e,!1,23,4)},f.prototype.readDoubleLE=function(e,t){return e>>>=0,t||F(e,8,this.length),i.read(this,e,!0,52,8)},f.prototype.readDoubleBE=function(e,t){return e>>>=0,t||F(e,8,this.length),i.read(this,e,!1,52,8)},f.prototype.writeUintLE=f.prototype.writeUIntLE=function(e,t,r,n){e=+e,t>>>=0,r>>>=0,n||O(this,e,t,r,Math.pow(2,8*r)-1,0);let i=1,o=0;for(this[t]=255&e;++o<r&&(i*=256);)this[t+o]=e/i&255;return t+r},f.prototype.writeUintBE=f.prototype.writeUIntBE=function(e,t,r,n){e=+e,t>>>=0,r>>>=0,n||O(this,e,t,r,Math.pow(2,8*r)-1,0);let i=r-1,o=1;for(this[t+i]=255&e;--i>=0&&(o*=256);)this[t+i]=e/o&255;return t+r},f.prototype.writeUint8=f.prototype.writeUInt8=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,1,255,0),this[t]=255&e,t+1},f.prototype.writeUint16LE=f.prototype.writeUInt16LE=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,2,65535,0),this[t]=255&e,this[t+1]=e>>>8,t+2},f.prototype.writeUint16BE=f.prototype.writeUInt16BE=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,2,65535,0),this[t]=e>>>8,this[t+1]=255&e,t+2},f.prototype.writeUint32LE=f.prototype.writeUInt32LE=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,4,4294967295,0),this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e,t+4},f.prototype.writeUint32BE=f.prototype.writeUInt32BE=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,4,4294967295,0),this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e,t+4},f.prototype.writeBigUInt64LE=X((function(e,t=0){return T(this,e,t,BigInt(0),BigInt("0xffffffffffffffff"))})),f.prototype.writeBigUInt64BE=X((function(e,t=0){return U(this,e,t,BigInt(0),BigInt("0xffffffffffffffff"))})),f.prototype.writeIntLE=function(e,t,r,n){if(e=+e,t>>>=0,!n){const n=Math.pow(2,8*r-1);O(this,e,t,r,n-1,-n);}let i=0,o=1,s=0;for(this[t]=255&e;++i<r&&(o*=256);)e<0&&0===s&&0!==this[t+i-1]&&(s=1),this[t+i]=(e/o>>0)-s&255;return t+r},f.prototype.writeIntBE=function(e,t,r,n){if(e=+e,t>>>=0,!n){const n=Math.pow(2,8*r-1);O(this,e,t,r,n-1,-n);}let i=r-1,o=1,s=0;for(this[t+i]=255&e;--i>=0&&(o*=256);)e<0&&0===s&&0!==this[t+i+1]&&(s=1),this[t+i]=(e/o>>0)-s&255;return t+r},f.prototype.writeInt8=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,1,127,-128),e<0&&(e=255+e+1),this[t]=255&e,t+1},f.prototype.writeInt16LE=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,2,32767,-32768),this[t]=255&e,this[t+1]=e>>>8,t+2},f.prototype.writeInt16BE=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,2,32767,-32768),this[t]=e>>>8,this[t+1]=255&e,t+2},f.prototype.writeInt32LE=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,4,2147483647,-2147483648),this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24,t+4},f.prototype.writeInt32BE=function(e,t,r){return e=+e,t>>>=0,r||O(this,e,t,4,2147483647,-2147483648),e<0&&(e=4294967295+e+1),this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e,t+4},f.prototype.writeBigInt64LE=X((function(e,t=0){return T(this,e,t,-BigInt("0x8000000000000000"),BigInt("0x7fffffffffffffff"))})),f.prototype.writeBigInt64BE=X((function(e,t=0){return U(this,e,t,-BigInt("0x8000000000000000"),BigInt("0x7fffffffffffffff"))})),f.prototype.writeFloatLE=function(e,t,r){return N(this,e,t,!0,r)},f.prototype.writeFloatBE=function(e,t,r){return N(this,e,t,!1,r)},f.prototype.writeDoubleLE=function(e,t,r){return L(this,e,t,!0,r)},f.prototype.writeDoubleBE=function(e,t,r){return L(this,e,t,!1,r)},f.prototype.copy=function(e,t,r,n){if(!f.isBuffer(e))throw new TypeError("argument should be a Buffer");if(r||(r=0),n||0===n||(n=this.length),t>=e.length&&(t=e.length),t||(t=0),n>0&&n<r&&(n=r),n===r)return 0;if(0===e.length||0===this.length)return 0;if(t<0)throw new RangeError("targetStart out of bounds");if(r<0||r>=this.length)throw new RangeError("Index out of range");if(n<0)throw new RangeError("sourceEnd out of bounds");n>this.length&&(n=this.length),e.length-t<n-r&&(n=e.length-t+r);const i=n-r;return this===e&&"function"==typeof Uint8Array.prototype.copyWithin?this.copyWithin(t,r,n):Uint8Array.prototype.set.call(e,this.subarray(r,n),t),i},f.prototype.fill=function(e,t,r,n){if("string"==typeof e){if("string"==typeof t?(n=t,t=0,r=this.length):"string"==typeof r&&(n=r,r=this.length),void 0!==n&&"string"!=typeof n)throw new TypeError("encoding must be a string");if("string"==typeof n&&!f.isEncoding(n))throw new TypeError("Unknown encoding: "+n);if(1===e.length){const t=e.charCodeAt(0);("utf8"===n&&t<128||"latin1"===n)&&(e=t);}}else "number"==typeof e?e&=255:"boolean"==typeof e&&(e=Number(e));if(t<0||this.length<t||this.length<r)throw new RangeError("Out of range index");if(r<=t)return this;let i;if(t>>>=0,r=void 0===r?this.length:r>>>0,e||(e=0),"number"==typeof e)for(i=t;i<r;++i)this[i]=e;else {const o=f.isBuffer(e)?e:f.from(e,n),s=o.length;if(0===s)throw new TypeError('The value "'+e+'" is invalid for argument "value"');for(i=0;i<r-t;++i)this[i+t]=o[i%s];}return this};const z={};function D(e,t,r){z[e]=class extends r{constructor(){super(),Object.defineProperty(this,"message",{value:t.apply(this,arguments),writable:!0,configurable:!0}),this.name=`${this.name} [${e}]`,this.stack,delete this.name;}get code(){return e}set code(e){Object.defineProperty(this,"code",{configurable:!0,enumerable:!0,value:e,writable:!0});}toString(){return `${this.name} [${e}]: ${this.message}`}};}function q(e){let t="",r=e.length;const n="-"===e[0]?1:0;for(;r>=n+4;r-=3)t=`_${e.slice(r-3,r)}${t}`;return `${e.slice(0,r)}${t}`}function j(e,t,r,n,i,o){if(e>r||e<t){const n="bigint"==typeof t?"n":"";let i;throw i=o>3?0===t||t===BigInt(0)?`>= 0${n} and < 2${n} ** ${8*(o+1)}${n}`:`>= -(2${n} ** ${8*(o+1)-1}${n}) and < 2 ** ${8*(o+1)-1}${n}`:`>= ${t}${n} and <= ${r}${n}`,new z.ERR_OUT_OF_RANGE("value",i,e)}!function(e,t,r){H(t,"offset"),void 0!==e[t]&&void 0!==e[t+r]||W(t,e.length-(r+1));}(n,i,o);}function H(e,t){if("number"!=typeof e)throw new z.ERR_INVALID_ARG_TYPE(t,"number",e)}function W(e,t,r){if(Math.floor(e)!==e)throw H(e,r),new z.ERR_OUT_OF_RANGE(r||"offset","an integer",e);if(t<0)throw new z.ERR_BUFFER_OUT_OF_BOUNDS;throw new z.ERR_OUT_OF_RANGE(r||"offset",`>= ${r?1:0} and <= ${t}`,e)}D("ERR_BUFFER_OUT_OF_BOUNDS",(function(e){return e?`${e} is outside of buffer bounds`:"Attempt to access memory outside buffer bounds"}),RangeError),D("ERR_INVALID_ARG_TYPE",(function(e,t){return `The "${e}" argument must be of type number. Received type ${typeof t}`}),TypeError),D("ERR_OUT_OF_RANGE",(function(e,t,r){let n=`The value of "${e}" is out of range.`,i=r;return Number.isInteger(r)&&Math.abs(r)>2**32?i=q(String(r)):"bigint"==typeof r&&(i=String(r),(r>BigInt(2)**BigInt(32)||r<-(BigInt(2)**BigInt(32)))&&(i=q(i)),i+="n"),n+=` It must be ${t}. Received ${i}`,n}),RangeError);const $=/[^+/0-9A-Za-z-_]/g;function V(e,t){let r;t=t||1/0;const n=e.length;let i=null;const o=[];for(let s=0;s<n;++s){if(r=e.charCodeAt(s),r>55295&&r<57344){if(!i){if(r>56319){(t-=3)>-1&&o.push(239,191,189);continue}if(s+1===n){(t-=3)>-1&&o.push(239,191,189);continue}i=r;continue}if(r<56320){(t-=3)>-1&&o.push(239,191,189),i=r;continue}r=65536+(i-55296<<10|r-56320);}else i&&(t-=3)>-1&&o.push(239,191,189);if(i=null,r<128){if((t-=1)<0)break;o.push(r);}else if(r<2048){if((t-=2)<0)break;o.push(r>>6|192,63&r|128);}else if(r<65536){if((t-=3)<0)break;o.push(r>>12|224,r>>6&63|128,63&r|128);}else {if(!(r<1114112))throw new Error("Invalid code point");if((t-=4)<0)break;o.push(r>>18|240,r>>12&63|128,r>>6&63|128,63&r|128);}}return o}function Z(e){return n.toByteArray(function(e){if((e=(e=e.split("=")[0]).trim().replace($,"")).length<2)return "";for(;e.length%4!=0;)e+="=";return e}(e))}function G(e,t,r,n){let i;for(i=0;i<n&&!(i+r>=t.length||i>=e.length);++i)t[i+r]=e[i];return i}function Q(e,t){return e instanceof t||null!=e&&null!=e.constructor&&null!=e.constructor.name&&e.constructor.name===t.name}function Y(e){return e!=e}const K=function(){const e="0123456789abcdef",t=new Array(256);for(let r=0;r<16;++r){const n=16*r;for(let i=0;i<16;++i)t[n+i]=e[r]+e[i];}return t}();function X(e){return "undefined"==typeof BigInt?J:e}function J(){throw new Error("BigInt not supported")}},4693:e=>{var t={array:function(e){var t=0,r=0,n=[0,1,3,7,15,31,63,127,255];return function(i){for(var o=0;i>0;){var s=8-t;i>=s?(o<<=s,o|=n[s]&e[r++],t=0,i-=s):(o<<=i,o|=(e[r]&n[i]<<8-i-t)>>8-i-t,t+=i,i=0);}return o}},simple:function(e){var r,n,i=t.header(e),o=[],s=0;do{-1!=(n=t.decompress(e,i))&&(o.push(n),s+=n.byteLength);}while(-1!=n);r=new Uint8Array(s),s=0;for(var a=0;a<o.length;++a)n=o[a],r.set(n,s),s+=n.byteLength;return r},header:function(e){if(4348520!=e(24))throw "No magic number found";var t=e(8)-48;if(t<1||t>9)throw "Not a BZIP archive";return t},decompress:function(e,t,r){for(var n=9e5,i="",o=0;o<6;o++)i+=e(8).toString(16);if("177245385090"==i)return -1;if("314159265359"!=i)throw "eek not valid bzip data";if(e(32),e(1))throw "unsupported obsolete version";var s=e(24);if(s>n)throw "Initial position larger than buffer size";var a=e(16),f=new Uint8Array(256),h=0;for(o=0;o<16;o++)if(a&1<<15-o){var l=e(16);for(g=0;g<16;g++)l&1<<15-g&&(f[h++]=16*o+g);}var u=e(3);if(u<2||u>6)throw "another error";var c=e(15);if(0==c)throw "meh";var d=[];for(o=0;o<u;o++)d[o]=o;var p=new Uint8Array(32768);for(o=0;o<c;o++){for(var g=0;e(1);g++)if(g>=u)throw "whoops another error";var m=d[g];d.splice(g,1),d.splice(0,0,m),p[o]=m;}var y=h+2,b=[];for(g=0;g<u;g++){var v,w,_,B=new Uint8Array(258),E=new Uint8Array(21);for(a=e(5),o=0;o<y;o++){for(;;){if(a<1||a>20)throw "I gave up a while ago on writing error messages";if(!e(1))break;e(1)?a--:a++;}B[o]=a;}for(v=w=B[0],o=1;o<y;o++)B[o]>w?w=B[o]:B[o]<v&&(v=B[o]);(_=b[g]={}).permute=new Uint32Array(258),_.limit=new Uint32Array(21),_.base=new Uint32Array(21),_.minLen=v,_.maxLen=w;var S=_.base.subarray(1),A=_.limit.subarray(1),C=0;for(o=v;o<=w;o++)for(a=0;a<y;a++)B[a]==o&&(_.permute[C++]=a);for(o=v;o<=w;o++)E[o]=A[o]=0;for(o=0;o<y;o++)E[B[o]]++;for(C=a=0,o=v;o<w;o++)C+=E[o],A[o]=C-1,C<<=1,S[o+1]=C-(a+=E[o]);A[w]=C+E[w]-1,S[v]=0;}var R,k,x,I=new Uint32Array(256);for(o=0;o<256;o++)d[o]=o;R=k=y=x=0;for(var M=new Uint32Array(n);;){if(!y--){if(y=49,x>=c)throw "meow i'm a kitty, that's an error";S=(_=b[p[x++]]).base.subarray(1),A=_.limit.subarray(1);}for(g=e(o=_.minLen);;){if(o>_.maxLen)throw "rawr i'm a dinosaur";if(g<=A[o])break;o++,g=g<<1|e(1);}if((g-=S[o])<0||g>=258)throw "moo i'm a cow";var F=_.permute[g];if(0!=F&&1!=F){if(R){if(R=0,k+a>=n)throw "Boom.";for(I[m=f[d[0]]]+=a;a--;)M[k++]=m;}if(F>h)break;if(k>=n)throw "I can't think of anything. Error";m=d[o=F-1],d.splice(o,1),d.splice(0,0,m),I[m=f[m]]++,M[k++]=m;}else R||(R=1,a=0),a+=0==F?R:2*R,R<<=1;}if(s<0||s>=k)throw "I'm a monkey and I'm throwing something at someone, namely you";for(g=0,o=0;o<256;o++)l=g+I[o],I[o]=g,g=l;for(o=0;o<k;o++)M[I[m=255&M[o]]]|=o<<8,I[m]++;var O=0,T=0,U=0;k&&(T=255&(O=M[s]),O>>=8,U=-1);var P,N,L,z=new Uint8Array(n),D=0;for(r||(r=1/0);k;){for(k--,N=T,T=255&(O=M[O]),O>>=8,3==U++?(P=T,L=N,T=-1):(P=1,L=T);P--;)if(z[D++]=L,!--r)return z;T!=N&&(U=0);}return z.subarray(0,D)}};e.exports=t;},487:e=>{var t={utf8:{stringToBytes:function(e){return t.bin.stringToBytes(unescape(encodeURIComponent(e)))},bytesToString:function(e){return decodeURIComponent(escape(t.bin.bytesToString(e)))}},bin:{stringToBytes:function(e){for(var t=[],r=0;r<e.length;r++)t.push(255&e.charCodeAt(r));return t},bytesToString:function(e){for(var t=[],r=0;r<e.length;r++)t.push(String.fromCharCode(e[r]));return t.join("")}}};e.exports=t;},1012:e=>{var t,r;t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r={rotl:function(e,t){return e<<t|e>>>32-t},rotr:function(e,t){return e<<32-t|e>>>t},endian:function(e){if(e.constructor==Number)return 16711935&r.rotl(e,8)|4278255360&r.rotl(e,24);for(var t=0;t<e.length;t++)e[t]=r.endian(e[t]);return e},randomBytes:function(e){for(var t=[];e>0;e--)t.push(Math.floor(256*Math.random()));return t},bytesToWords:function(e){for(var t=[],r=0,n=0;r<e.length;r++,n+=8)t[n>>>5]|=e[r]<<24-n%32;return t},wordsToBytes:function(e){for(var t=[],r=0;r<32*e.length;r+=8)t.push(e[r>>>5]>>>24-r%32&255);return t},bytesToHex:function(e){for(var t=[],r=0;r<e.length;r++)t.push((e[r]>>>4).toString(16)),t.push((15&e[r]).toString(16));return t.join("")},hexToBytes:function(e){for(var t=[],r=0;r<e.length;r+=2)t.push(parseInt(e.substr(r,2),16));return t},bytesToBase64:function(e){for(var r=[],n=0;n<e.length;n+=3)for(var i=e[n]<<16|e[n+1]<<8|e[n+2],o=0;o<4;o++)8*n+6*o<=8*e.length?r.push(t.charAt(i>>>6*(3-o)&63)):r.push("=");return r.join("")},base64ToBytes:function(e){e=e.replace(/[^A-Z0-9+\/]/gi,"");for(var r=[],n=0,i=0;n<e.length;i=++n%4)0!=i&&r.push((t.indexOf(e.charAt(n-1))&Math.pow(2,-2*i+8)-1)<<2*i|t.indexOf(e.charAt(n))>>>6-2*i);return r}},e.exports=r;},2949:(e,t,r)=>{r.r(t),r.d(t,{BlobFile:()=>h,LocalFile:()=>i(),RemoteFile:()=>a,fromUrl:()=>l,open:()=>u});var n=r(7067),i=r.n(n),o=r(8764);const s="undefined"!=typeof window?window:"undefined"!=typeof self?self:{fetch:void 0};class a{constructor(e,t={}){this.baseOverrides={},this.url=e;const r=t.fetch||s.fetch&&s.fetch.bind(s);if(!r)throw new TypeError("no fetch function supplied, and none found in global environment");t.overrides&&(this.baseOverrides=t.overrides),this.fetchImplementation=r;}async getBufferFromResponse(e){if("function"==typeof e.buffer)return e.buffer();if("function"==typeof e.arrayBuffer){const t=await e.arrayBuffer();return o.Buffer.from(t)}throw new TypeError("invalid HTTP response object, has no buffer method, and no arrayBuffer method")}async fetch(e,t){let r;try{r=await this.fetchImplementation(e,t);}catch(n){if(!`${n}`.includes("Failed to fetch"))throw n;console.warn(`generic-filehandle: refetching ${e} to attempt to work around chrome CORS header caching bug`),r=await this.fetchImplementation(e,{...t,cache:"reload"});}return r}async read(e,t=0,r,n=0,i={}){const{headers:o={},signal:s,overrides:a={}}=i;r<1/0?o.range=`bytes=${n}-${n+r}`:r===1/0&&0!==n&&(o.range=`bytes=${n}-`);const f={...this.baseOverrides,...a,headers:{...o,...a.headers,...this.baseOverrides.headers},method:"GET",redirect:"follow",mode:"cors",signal:s},h=await this.fetch(this.url,f);if(!h.ok)throw new Error(`HTTP ${h.status} ${h.statusText} ${this.url}`);if(200===h.status&&0===n||206===h.status){const n=await this.getBufferFromResponse(h),i=n.copy(e,t,0,Math.min(r,n.length)),o=h.headers.get("content-range"),s=/\/(\d+)$/.exec(o||"");return s&&s[1]&&(this._stat={size:parseInt(s[1],10)}),{bytesRead:i,buffer:e}}if(200===h.status)throw new Error("${this.url} fetch returned status 200, expected 206");throw new Error(`HTTP ${h.status} fetching ${this.url}`)}async readFile(e={}){let t,r;"string"==typeof e?(t=e,r={}):(t=e.encoding,r=e,delete r.encoding);const{headers:n={},signal:i,overrides:o={}}=r,s={headers:n,method:"GET",redirect:"follow",mode:"cors",signal:i,...this.baseOverrides,...o},a=await this.fetch(this.url,s);if(!a)throw new Error("generic-filehandle failed to fetch");if(200!==a.status)throw Object.assign(new Error(`HTTP ${a.status} fetching ${this.url}`),{status:a.status});if("utf8"===t)return a.text();if(t)throw new Error(`unsupported encoding: ${t}`);return this.getBufferFromResponse(a)}async stat(){if(!this._stat){const e=o.Buffer.allocUnsafe(10);if(await this.read(e,0,10,0),!this._stat)throw new Error(`unable to determine size of file at ${this.url}`)}return this._stat}async close(){}}function f(e){const t=new FileReader;return new Promise(((r,n)=>{t.onerror=()=>{t.abort(),n(new Error("problem reading blob"));},t.onabort=()=>{n(new Error("blob reading was aborted"));},t.onload=()=>{t.result&&"string"!=typeof t.result?r(t.result):n(new Error("unknown error reading blob"));},t.readAsArrayBuffer(e);}))}class h{constructor(e){this.blob=e,this.size=e.size;}async read(e,t=0,r,n=0){if(!r)return {bytesRead:0,buffer:e};const i=n,s=i+r,a=await f(this.blob.slice(i,s)),h=o.Buffer.from(a);return {bytesRead:h.copy(e,t),buffer:h}}async readFile(e){let t;if(t="string"==typeof e?e:e&&e.encoding,"utf8"===t)return function(e){const t=new FileReader;return new Promise(((r,n)=>{t.onerror=()=>{t.abort(),n(new Error("problem reading blob"));},t.onabort=()=>{n(new Error("blob reading was aborted"));},t.onload=()=>{t.result&&"string"==typeof t.result?r(t.result):n(new Error("unknown error reading blob"));},t.readAsText(e);}))}(this.blob);if(t)throw new Error(`unsupported encoding: ${t}`);const r=await f(this.blob);return o.Buffer.from(r)}async stat(){return {size:this.size}}async close(){}}function l(e,t={}){return new a(e,t)}function u(e,t,r,n={}){if(void 0!==r)return r;if(void 0!==e)return l(e,n);if(void 0!==t)return new(i())(t,n);throw new Error("no url, path, or filehandle provided, cannot open")}},645:(e,t)=>{t.read=function(e,t,r,n,i){var o,s,a=8*i-n-1,f=(1<<a)-1,h=f>>1,l=-7,u=r?i-1:0,c=r?-1:1,d=e[t+u];for(u+=c,o=d&(1<<-l)-1,d>>=-l,l+=a;l>0;o=256*o+e[t+u],u+=c,l-=8);for(s=o&(1<<-l)-1,o>>=-l,l+=n;l>0;s=256*s+e[t+u],u+=c,l-=8);if(0===o)o=1-h;else {if(o===f)return s?NaN:1/0*(d?-1:1);s+=Math.pow(2,n),o-=h;}return (d?-1:1)*s*Math.pow(2,o-n)},t.write=function(e,t,r,n,i,o){var s,a,f,h=8*o-i-1,l=(1<<h)-1,u=l>>1,c=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,d=n?0:o-1,p=n?1:-1,g=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(a=isNaN(t)?1:0,s=l):(s=Math.floor(Math.log(t)/Math.LN2),t*(f=Math.pow(2,-s))<1&&(s--,f*=2),(t+=s+u>=1?c/f:c*Math.pow(2,1-u))*f>=2&&(s++,f/=2),s+u>=l?(a=0,s=l):s+u>=1?(a=(t*f-1)*Math.pow(2,i),s+=u):(a=t*Math.pow(2,u-1)*Math.pow(2,i),s=0));i>=8;e[r+d]=255&a,d+=p,a/=256,i-=8);for(s=s<<i|a,h+=i;h>0;e[r+d]=255&s,d+=p,s/=256,h-=8);e[r+d-p]|=128*g;};},8738:e=>{function t(e){return !!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}e.exports=function(e){return null!=e&&(t(e)||function(e){return "function"==typeof e.readFloatLE&&"function"==typeof e.slice&&t(e.slice(0,0))}(e)||!!e._isBuffer)};},3720:e=>{e.exports=r;var t=null;try{t=new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0,97,115,109,1,0,0,0,1,13,2,96,0,1,127,96,4,127,127,127,127,1,127,3,7,6,0,1,1,1,1,1,6,6,1,127,1,65,0,11,7,50,6,3,109,117,108,0,1,5,100,105,118,95,115,0,2,5,100,105,118,95,117,0,3,5,114,101,109,95,115,0,4,5,114,101,109,95,117,0,5,8,103,101,116,95,104,105,103,104,0,0,10,191,1,6,4,0,35,0,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,126,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,127,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,128,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,129,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,130,34,4,66,32,135,167,36,0,32,4,167,11])),{}).exports;}catch(e){}function r(e,t,r){this.low=0|e,this.high=0|t,this.unsigned=!!r;}function n(e){return !0===(e&&e.__isLong__)}r.prototype.__isLong__,Object.defineProperty(r.prototype,"__isLong__",{value:!0}),r.isLong=n;var i={},o={};function s(e,t){var r,n,s;return t?(s=0<=(e>>>=0)&&e<256)&&(n=o[e])?n:(r=f(e,(0|e)<0?-1:0,!0),s&&(o[e]=r),r):(s=-128<=(e|=0)&&e<128)&&(n=i[e])?n:(r=f(e,e<0?-1:0,!1),s&&(i[e]=r),r)}function a(e,t){if(isNaN(e))return t?y:m;if(t){if(e<0)return y;if(e>=d)return B}else {if(e<=-p)return E;if(e+1>=p)return _}return e<0?a(-e,t).neg():f(e%c|0,e/c|0,t)}function f(e,t,n){return new r(e,t,n)}r.fromInt=s,r.fromNumber=a,r.fromBits=f;var h=Math.pow;function l(e,t,r){if(0===e.length)throw Error("empty string");if("NaN"===e||"Infinity"===e||"+Infinity"===e||"-Infinity"===e)return m;if("number"==typeof t?(r=t,t=!1):t=!!t,(r=r||10)<2||36<r)throw RangeError("radix");var n;if((n=e.indexOf("-"))>0)throw Error("interior hyphen");if(0===n)return l(e.substring(1),t,r).neg();for(var i=a(h(r,8)),o=m,s=0;s<e.length;s+=8){var f=Math.min(8,e.length-s),u=parseInt(e.substring(s,s+f),r);if(f<8){var c=a(h(r,f));o=o.mul(c).add(a(u));}else o=(o=o.mul(i)).add(a(u));}return o.unsigned=t,o}function u(e,t){return "number"==typeof e?a(e,t):"string"==typeof e?l(e,t):f(e.low,e.high,"boolean"==typeof t?t:e.unsigned)}r.fromString=l,r.fromValue=u;var c=4294967296,d=c*c,p=d/2,g=s(1<<24),m=s(0);r.ZERO=m;var y=s(0,!0);r.UZERO=y;var b=s(1);r.ONE=b;var v=s(1,!0);r.UONE=v;var w=s(-1);r.NEG_ONE=w;var _=f(-1,2147483647,!1);r.MAX_VALUE=_;var B=f(-1,-1,!0);r.MAX_UNSIGNED_VALUE=B;var E=f(0,-2147483648,!1);r.MIN_VALUE=E;var S=r.prototype;S.toInt=function(){return this.unsigned?this.low>>>0:this.low},S.toNumber=function(){return this.unsigned?(this.high>>>0)*c+(this.low>>>0):this.high*c+(this.low>>>0)},S.toString=function(e){if((e=e||10)<2||36<e)throw RangeError("radix");if(this.isZero())return "0";if(this.isNegative()){if(this.eq(E)){var t=a(e),r=this.div(t),n=r.mul(t).sub(this);return r.toString(e)+n.toInt().toString(e)}return "-"+this.neg().toString(e)}for(var i=a(h(e,6),this.unsigned),o=this,s="";;){var f=o.div(i),l=(o.sub(f.mul(i)).toInt()>>>0).toString(e);if((o=f).isZero())return l+s;for(;l.length<6;)l="0"+l;s=""+l+s;}},S.getHighBits=function(){return this.high},S.getHighBitsUnsigned=function(){return this.high>>>0},S.getLowBits=function(){return this.low},S.getLowBitsUnsigned=function(){return this.low>>>0},S.getNumBitsAbs=function(){if(this.isNegative())return this.eq(E)?64:this.neg().getNumBitsAbs();for(var e=0!=this.high?this.high:this.low,t=31;t>0&&0==(e&1<<t);t--);return 0!=this.high?t+33:t+1},S.isZero=function(){return 0===this.high&&0===this.low},S.eqz=S.isZero,S.isNegative=function(){return !this.unsigned&&this.high<0},S.isPositive=function(){return this.unsigned||this.high>=0},S.isOdd=function(){return 1==(1&this.low)},S.isEven=function(){return 0==(1&this.low)},S.equals=function(e){return n(e)||(e=u(e)),(this.unsigned===e.unsigned||this.high>>>31!=1||e.high>>>31!=1)&&this.high===e.high&&this.low===e.low},S.eq=S.equals,S.notEquals=function(e){return !this.eq(e)},S.neq=S.notEquals,S.ne=S.notEquals,S.lessThan=function(e){return this.comp(e)<0},S.lt=S.lessThan,S.lessThanOrEqual=function(e){return this.comp(e)<=0},S.lte=S.lessThanOrEqual,S.le=S.lessThanOrEqual,S.greaterThan=function(e){return this.comp(e)>0},S.gt=S.greaterThan,S.greaterThanOrEqual=function(e){return this.comp(e)>=0},S.gte=S.greaterThanOrEqual,S.ge=S.greaterThanOrEqual,S.compare=function(e){if(n(e)||(e=u(e)),this.eq(e))return 0;var t=this.isNegative(),r=e.isNegative();return t&&!r?-1:!t&&r?1:this.unsigned?e.high>>>0>this.high>>>0||e.high===this.high&&e.low>>>0>this.low>>>0?-1:1:this.sub(e).isNegative()?-1:1},S.comp=S.compare,S.negate=function(){return !this.unsigned&&this.eq(E)?E:this.not().add(b)},S.neg=S.negate,S.add=function(e){n(e)||(e=u(e));var t=this.high>>>16,r=65535&this.high,i=this.low>>>16,o=65535&this.low,s=e.high>>>16,a=65535&e.high,h=e.low>>>16,l=0,c=0,d=0,p=0;return d+=(p+=o+(65535&e.low))>>>16,c+=(d+=i+h)>>>16,l+=(c+=r+a)>>>16,l+=t+s,f((d&=65535)<<16|(p&=65535),(l&=65535)<<16|(c&=65535),this.unsigned)},S.subtract=function(e){return n(e)||(e=u(e)),this.add(e.neg())},S.sub=S.subtract,S.multiply=function(e){if(this.isZero())return m;if(n(e)||(e=u(e)),t)return f(t.mul(this.low,this.high,e.low,e.high),t.get_high(),this.unsigned);if(e.isZero())return m;if(this.eq(E))return e.isOdd()?E:m;if(e.eq(E))return this.isOdd()?E:m;if(this.isNegative())return e.isNegative()?this.neg().mul(e.neg()):this.neg().mul(e).neg();if(e.isNegative())return this.mul(e.neg()).neg();if(this.lt(g)&&e.lt(g))return a(this.toNumber()*e.toNumber(),this.unsigned);var r=this.high>>>16,i=65535&this.high,o=this.low>>>16,s=65535&this.low,h=e.high>>>16,l=65535&e.high,c=e.low>>>16,d=65535&e.low,p=0,y=0,b=0,v=0;return b+=(v+=s*d)>>>16,y+=(b+=o*d)>>>16,b&=65535,y+=(b+=s*c)>>>16,p+=(y+=i*d)>>>16,y&=65535,p+=(y+=o*c)>>>16,y&=65535,p+=(y+=s*l)>>>16,p+=r*d+i*c+o*l+s*h,f((b&=65535)<<16|(v&=65535),(p&=65535)<<16|(y&=65535),this.unsigned)},S.mul=S.multiply,S.divide=function(e){if(n(e)||(e=u(e)),e.isZero())throw Error("division by zero");var r,i,o;if(t)return this.unsigned||-2147483648!==this.high||-1!==e.low||-1!==e.high?f((this.unsigned?t.div_u:t.div_s)(this.low,this.high,e.low,e.high),t.get_high(),this.unsigned):this;if(this.isZero())return this.unsigned?y:m;if(this.unsigned){if(e.unsigned||(e=e.toUnsigned()),e.gt(this))return y;if(e.gt(this.shru(1)))return v;o=y;}else {if(this.eq(E))return e.eq(b)||e.eq(w)?E:e.eq(E)?b:(r=this.shr(1).div(e).shl(1)).eq(m)?e.isNegative()?b:w:(i=this.sub(e.mul(r)),o=r.add(i.div(e)));if(e.eq(E))return this.unsigned?y:m;if(this.isNegative())return e.isNegative()?this.neg().div(e.neg()):this.neg().div(e).neg();if(e.isNegative())return this.div(e.neg()).neg();o=m;}for(i=this;i.gte(e);){r=Math.max(1,Math.floor(i.toNumber()/e.toNumber()));for(var s=Math.ceil(Math.log(r)/Math.LN2),l=s<=48?1:h(2,s-48),c=a(r),d=c.mul(e);d.isNegative()||d.gt(i);)d=(c=a(r-=l,this.unsigned)).mul(e);c.isZero()&&(c=b),o=o.add(c),i=i.sub(d);}return o},S.div=S.divide,S.modulo=function(e){return n(e)||(e=u(e)),t?f((this.unsigned?t.rem_u:t.rem_s)(this.low,this.high,e.low,e.high),t.get_high(),this.unsigned):this.sub(this.div(e).mul(e))},S.mod=S.modulo,S.rem=S.modulo,S.not=function(){return f(~this.low,~this.high,this.unsigned)},S.and=function(e){return n(e)||(e=u(e)),f(this.low&e.low,this.high&e.high,this.unsigned)},S.or=function(e){return n(e)||(e=u(e)),f(this.low|e.low,this.high|e.high,this.unsigned)},S.xor=function(e){return n(e)||(e=u(e)),f(this.low^e.low,this.high^e.high,this.unsigned)},S.shiftLeft=function(e){return n(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?f(this.low<<e,this.high<<e|this.low>>>32-e,this.unsigned):f(0,this.low<<e-32,this.unsigned)},S.shl=S.shiftLeft,S.shiftRight=function(e){return n(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?f(this.low>>>e|this.high<<32-e,this.high>>e,this.unsigned):f(this.high>>e-32,this.high>=0?0:-1,this.unsigned)},S.shr=S.shiftRight,S.shiftRightUnsigned=function(e){if(n(e)&&(e=e.toInt()),0==(e&=63))return this;var t=this.high;return e<32?f(this.low>>>e|t<<32-e,t>>>e,this.unsigned):f(32===e?t:t>>>e-32,0,this.unsigned)},S.shru=S.shiftRightUnsigned,S.shr_u=S.shiftRightUnsigned,S.toSigned=function(){return this.unsigned?f(this.low,this.high,!1):this},S.toUnsigned=function(){return this.unsigned?this:f(this.low,this.high,!0)},S.toBytes=function(e){return e?this.toBytesLE():this.toBytesBE()},S.toBytesLE=function(){var e=this.high,t=this.low;return [255&t,t>>>8&255,t>>>16&255,t>>>24,255&e,e>>>8&255,e>>>16&255,e>>>24]},S.toBytesBE=function(){var e=this.high,t=this.low;return [e>>>24,e>>>16&255,e>>>8&255,255&e,t>>>24,t>>>16&255,t>>>8&255,255&t]},r.fromBytes=function(e,t,n){return n?r.fromBytesLE(e,t):r.fromBytesBE(e,t)},r.fromBytesLE=function(e,t){return new r(e[0]|e[1]<<8|e[2]<<16|e[3]<<24,e[4]|e[5]<<8|e[6]<<16|e[7]<<24,t)},r.fromBytesBE=function(e,t){return new r(e[4]<<24|e[5]<<16|e[6]<<8|e[7],e[0]<<24|e[1]<<16|e[2]<<8|e[3],t)};},2568:(e,t,r)=>{var n,i,o,s,a;n=r(1012),i=r(487).utf8,o=r(8738),s=r(487).bin,(a=function(e,t){e.constructor==String?e=t&&"binary"===t.encoding?s.stringToBytes(e):i.stringToBytes(e):o(e)?e=Array.prototype.slice.call(e,0):Array.isArray(e)||e.constructor===Uint8Array||(e=e.toString());for(var r=n.bytesToWords(e),f=8*e.length,h=1732584193,l=-271733879,u=-1732584194,c=271733878,d=0;d<r.length;d++)r[d]=16711935&(r[d]<<8|r[d]>>>24)|4278255360&(r[d]<<24|r[d]>>>8);r[f>>>5]|=128<<f%32,r[14+(f+64>>>9<<4)]=f;var p=a._ff,g=a._gg,m=a._hh,y=a._ii;for(d=0;d<r.length;d+=16){var b=h,v=l,w=u,_=c;h=p(h,l,u,c,r[d+0],7,-680876936),c=p(c,h,l,u,r[d+1],12,-389564586),u=p(u,c,h,l,r[d+2],17,606105819),l=p(l,u,c,h,r[d+3],22,-1044525330),h=p(h,l,u,c,r[d+4],7,-176418897),c=p(c,h,l,u,r[d+5],12,1200080426),u=p(u,c,h,l,r[d+6],17,-1473231341),l=p(l,u,c,h,r[d+7],22,-45705983),h=p(h,l,u,c,r[d+8],7,1770035416),c=p(c,h,l,u,r[d+9],12,-1958414417),u=p(u,c,h,l,r[d+10],17,-42063),l=p(l,u,c,h,r[d+11],22,-1990404162),h=p(h,l,u,c,r[d+12],7,1804603682),c=p(c,h,l,u,r[d+13],12,-40341101),u=p(u,c,h,l,r[d+14],17,-1502002290),h=g(h,l=p(l,u,c,h,r[d+15],22,1236535329),u,c,r[d+1],5,-165796510),c=g(c,h,l,u,r[d+6],9,-1069501632),u=g(u,c,h,l,r[d+11],14,643717713),l=g(l,u,c,h,r[d+0],20,-373897302),h=g(h,l,u,c,r[d+5],5,-701558691),c=g(c,h,l,u,r[d+10],9,38016083),u=g(u,c,h,l,r[d+15],14,-660478335),l=g(l,u,c,h,r[d+4],20,-405537848),h=g(h,l,u,c,r[d+9],5,568446438),c=g(c,h,l,u,r[d+14],9,-1019803690),u=g(u,c,h,l,r[d+3],14,-187363961),l=g(l,u,c,h,r[d+8],20,1163531501),h=g(h,l,u,c,r[d+13],5,-1444681467),c=g(c,h,l,u,r[d+2],9,-51403784),u=g(u,c,h,l,r[d+7],14,1735328473),h=m(h,l=g(l,u,c,h,r[d+12],20,-1926607734),u,c,r[d+5],4,-378558),c=m(c,h,l,u,r[d+8],11,-2022574463),u=m(u,c,h,l,r[d+11],16,1839030562),l=m(l,u,c,h,r[d+14],23,-35309556),h=m(h,l,u,c,r[d+1],4,-1530992060),c=m(c,h,l,u,r[d+4],11,1272893353),u=m(u,c,h,l,r[d+7],16,-155497632),l=m(l,u,c,h,r[d+10],23,-1094730640),h=m(h,l,u,c,r[d+13],4,681279174),c=m(c,h,l,u,r[d+0],11,-358537222),u=m(u,c,h,l,r[d+3],16,-722521979),l=m(l,u,c,h,r[d+6],23,76029189),h=m(h,l,u,c,r[d+9],4,-640364487),c=m(c,h,l,u,r[d+12],11,-421815835),u=m(u,c,h,l,r[d+15],16,530742520),h=y(h,l=m(l,u,c,h,r[d+2],23,-995338651),u,c,r[d+0],6,-198630844),c=y(c,h,l,u,r[d+7],10,1126891415),u=y(u,c,h,l,r[d+14],15,-1416354905),l=y(l,u,c,h,r[d+5],21,-57434055),h=y(h,l,u,c,r[d+12],6,1700485571),c=y(c,h,l,u,r[d+3],10,-1894986606),u=y(u,c,h,l,r[d+10],15,-1051523),l=y(l,u,c,h,r[d+1],21,-2054922799),h=y(h,l,u,c,r[d+8],6,1873313359),c=y(c,h,l,u,r[d+15],10,-30611744),u=y(u,c,h,l,r[d+6],15,-1560198380),l=y(l,u,c,h,r[d+13],21,1309151649),h=y(h,l,u,c,r[d+4],6,-145523070),c=y(c,h,l,u,r[d+11],10,-1120210379),u=y(u,c,h,l,r[d+2],15,718787259),l=y(l,u,c,h,r[d+9],21,-343485551),h=h+b>>>0,l=l+v>>>0,u=u+w>>>0,c=c+_>>>0;}return n.endian([h,l,u,c])})._ff=function(e,t,r,n,i,o,s){var a=e+(t&r|~t&n)+(i>>>0)+s;return (a<<o|a>>>32-o)+t},a._gg=function(e,t,r,n,i,o,s){var a=e+(t&n|r&~n)+(i>>>0)+s;return (a<<o|a>>>32-o)+t},a._hh=function(e,t,r,n,i,o,s){var a=e+(t^r^n)+(i>>>0)+s;return (a<<o|a>>>32-o)+t},a._ii=function(e,t,r,n,i,o,s){var a=e+(r^(t|~n))+(i>>>0)+s;return (a<<o|a>>>32-o)+t},a._blocksize=16,a._digestsize=16,e.exports=function(e,t){if(null==e)throw new Error("Illegal argument "+e);var r=n.wordsToBytes(a(e,t));return t&&t.asBytes?r:t&&t.asString?s.bytesToString(r):n.bytesToHex(r)};},9591:(e,t,r)=>{var n={};(0, r(4236).assign)(n,r(4555),r(8843),r(1619)),e.exports=n;},4555:(e,t,r)=>{var n=r(405),i=r(4236),o=r(9373),s=r(8898),a=r(2292),f=Object.prototype.toString;function h(e){if(!(this instanceof h))return new h(e);this.options=i.assign({level:-1,method:8,chunkSize:16384,windowBits:15,memLevel:8,strategy:0,to:""},e||{});var t=this.options;t.raw&&t.windowBits>0?t.windowBits=-t.windowBits:t.gzip&&t.windowBits>0&&t.windowBits<16&&(t.windowBits+=16),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new a,this.strm.avail_out=0;var r=n.deflateInit2(this.strm,t.level,t.method,t.windowBits,t.memLevel,t.strategy);if(0!==r)throw new Error(s[r]);if(t.header&&n.deflateSetHeader(this.strm,t.header),t.dictionary){var l;if(l="string"==typeof t.dictionary?o.string2buf(t.dictionary):"[object ArrayBuffer]"===f.call(t.dictionary)?new Uint8Array(t.dictionary):t.dictionary,0!==(r=n.deflateSetDictionary(this.strm,l)))throw new Error(s[r]);this._dict_set=!0;}}function l(e,t){var r=new h(t);if(r.push(e,!0),r.err)throw r.msg||s[r.err];return r.result}h.prototype.push=function(e,t){var r,s,a=this.strm,h=this.options.chunkSize;if(this.ended)return !1;s=t===~~t?t:!0===t?4:0,"string"==typeof e?a.input=o.string2buf(e):"[object ArrayBuffer]"===f.call(e)?a.input=new Uint8Array(e):a.input=e,a.next_in=0,a.avail_in=a.input.length;do{if(0===a.avail_out&&(a.output=new i.Buf8(h),a.next_out=0,a.avail_out=h),1!==(r=n.deflate(a,s))&&0!==r)return this.onEnd(r),this.ended=!0,!1;0!==a.avail_out&&(0!==a.avail_in||4!==s&&2!==s)||("string"===this.options.to?this.onData(o.buf2binstring(i.shrinkBuf(a.output,a.next_out))):this.onData(i.shrinkBuf(a.output,a.next_out)));}while((a.avail_in>0||0===a.avail_out)&&1!==r);return 4===s?(r=n.deflateEnd(this.strm),this.onEnd(r),this.ended=!0,0===r):2!==s||(this.onEnd(0),a.avail_out=0,!0)},h.prototype.onData=function(e){this.chunks.push(e);},h.prototype.onEnd=function(e){0===e&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=i.flattenChunks(this.chunks)),this.chunks=[],this.err=e,this.msg=this.strm.msg;},t.Deflate=h,t.deflate=l,t.deflateRaw=function(e,t){return (t=t||{}).raw=!0,l(e,t)},t.gzip=function(e,t){return (t=t||{}).gzip=!0,l(e,t)};},8843:(e,t,r)=>{var n=r(7948),i=r(4236),o=r(9373),s=r(1619),a=r(8898),f=r(2292),h=r(2401),l=Object.prototype.toString;function u(e){if(!(this instanceof u))return new u(e);this.options=i.assign({chunkSize:16384,windowBits:0,to:""},e||{});var t=this.options;t.raw&&t.windowBits>=0&&t.windowBits<16&&(t.windowBits=-t.windowBits,0===t.windowBits&&(t.windowBits=-15)),!(t.windowBits>=0&&t.windowBits<16)||e&&e.windowBits||(t.windowBits+=32),t.windowBits>15&&t.windowBits<48&&0==(15&t.windowBits)&&(t.windowBits|=15),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new f,this.strm.avail_out=0;var r=n.inflateInit2(this.strm,t.windowBits);if(r!==s.Z_OK)throw new Error(a[r]);if(this.header=new h,n.inflateGetHeader(this.strm,this.header),t.dictionary&&("string"==typeof t.dictionary?t.dictionary=o.string2buf(t.dictionary):"[object ArrayBuffer]"===l.call(t.dictionary)&&(t.dictionary=new Uint8Array(t.dictionary)),t.raw&&(r=n.inflateSetDictionary(this.strm,t.dictionary))!==s.Z_OK))throw new Error(a[r])}function c(e,t){var r=new u(t);if(r.push(e,!0),r.err)throw r.msg||a[r.err];return r.result}u.prototype.push=function(e,t){var r,a,f,h,u,c=this.strm,d=this.options.chunkSize,p=this.options.dictionary,g=!1;if(this.ended)return !1;a=t===~~t?t:!0===t?s.Z_FINISH:s.Z_NO_FLUSH,"string"==typeof e?c.input=o.binstring2buf(e):"[object ArrayBuffer]"===l.call(e)?c.input=new Uint8Array(e):c.input=e,c.next_in=0,c.avail_in=c.input.length;do{if(0===c.avail_out&&(c.output=new i.Buf8(d),c.next_out=0,c.avail_out=d),(r=n.inflate(c,s.Z_NO_FLUSH))===s.Z_NEED_DICT&&p&&(r=n.inflateSetDictionary(this.strm,p)),r===s.Z_BUF_ERROR&&!0===g&&(r=s.Z_OK,g=!1),r!==s.Z_STREAM_END&&r!==s.Z_OK)return this.onEnd(r),this.ended=!0,!1;c.next_out&&(0!==c.avail_out&&r!==s.Z_STREAM_END&&(0!==c.avail_in||a!==s.Z_FINISH&&a!==s.Z_SYNC_FLUSH)||("string"===this.options.to?(f=o.utf8border(c.output,c.next_out),h=c.next_out-f,u=o.buf2string(c.output,f),c.next_out=h,c.avail_out=d-h,h&&i.arraySet(c.output,c.output,f,h,0),this.onData(u)):this.onData(i.shrinkBuf(c.output,c.next_out)))),0===c.avail_in&&0===c.avail_out&&(g=!0);}while((c.avail_in>0||0===c.avail_out)&&r!==s.Z_STREAM_END);return r===s.Z_STREAM_END&&(a=s.Z_FINISH),a===s.Z_FINISH?(r=n.inflateEnd(this.strm),this.onEnd(r),this.ended=!0,r===s.Z_OK):a!==s.Z_SYNC_FLUSH||(this.onEnd(s.Z_OK),c.avail_out=0,!0)},u.prototype.onData=function(e){this.chunks.push(e);},u.prototype.onEnd=function(e){e===s.Z_OK&&("string"===this.options.to?this.result=this.chunks.join(""):this.result=i.flattenChunks(this.chunks)),this.chunks=[],this.err=e,this.msg=this.strm.msg;},t.Inflate=u,t.inflate=c,t.inflateRaw=function(e,t){return (t=t||{}).raw=!0,c(e,t)},t.ungzip=c;},4236:(e,t)=>{var r="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Int32Array;function n(e,t){return Object.prototype.hasOwnProperty.call(e,t)}t.assign=function(e){for(var t=Array.prototype.slice.call(arguments,1);t.length;){var r=t.shift();if(r){if("object"!=typeof r)throw new TypeError(r+"must be non-object");for(var i in r)n(r,i)&&(e[i]=r[i]);}}return e},t.shrinkBuf=function(e,t){return e.length===t?e:e.subarray?e.subarray(0,t):(e.length=t,e)};var i={arraySet:function(e,t,r,n,i){if(t.subarray&&e.subarray)e.set(t.subarray(r,r+n),i);else for(var o=0;o<n;o++)e[i+o]=t[r+o];},flattenChunks:function(e){var t,r,n,i,o,s;for(n=0,t=0,r=e.length;t<r;t++)n+=e[t].length;for(s=new Uint8Array(n),i=0,t=0,r=e.length;t<r;t++)o=e[t],s.set(o,i),i+=o.length;return s}},o={arraySet:function(e,t,r,n,i){for(var o=0;o<n;o++)e[i+o]=t[r+o];},flattenChunks:function(e){return [].concat.apply([],e)}};t.setTyped=function(e){e?(t.Buf8=Uint8Array,t.Buf16=Uint16Array,t.Buf32=Int32Array,t.assign(t,i)):(t.Buf8=Array,t.Buf16=Array,t.Buf32=Array,t.assign(t,o));},t.setTyped(r);},9373:(e,t,r)=>{var n=r(4236),i=!0,o=!0;try{String.fromCharCode.apply(null,[0]);}catch(e){i=!1;}try{String.fromCharCode.apply(null,new Uint8Array(1));}catch(e){o=!1;}for(var s=new n.Buf8(256),a=0;a<256;a++)s[a]=a>=252?6:a>=248?5:a>=240?4:a>=224?3:a>=192?2:1;function f(e,t){if(t<65534&&(e.subarray&&o||!e.subarray&&i))return String.fromCharCode.apply(null,n.shrinkBuf(e,t));for(var r="",s=0;s<t;s++)r+=String.fromCharCode(e[s]);return r}s[254]=s[254]=1,t.string2buf=function(e){var t,r,i,o,s,a=e.length,f=0;for(o=0;o<a;o++)55296==(64512&(r=e.charCodeAt(o)))&&o+1<a&&56320==(64512&(i=e.charCodeAt(o+1)))&&(r=65536+(r-55296<<10)+(i-56320),o++),f+=r<128?1:r<2048?2:r<65536?3:4;for(t=new n.Buf8(f),s=0,o=0;s<f;o++)55296==(64512&(r=e.charCodeAt(o)))&&o+1<a&&56320==(64512&(i=e.charCodeAt(o+1)))&&(r=65536+(r-55296<<10)+(i-56320),o++),r<128?t[s++]=r:r<2048?(t[s++]=192|r>>>6,t[s++]=128|63&r):r<65536?(t[s++]=224|r>>>12,t[s++]=128|r>>>6&63,t[s++]=128|63&r):(t[s++]=240|r>>>18,t[s++]=128|r>>>12&63,t[s++]=128|r>>>6&63,t[s++]=128|63&r);return t},t.buf2binstring=function(e){return f(e,e.length)},t.binstring2buf=function(e){for(var t=new n.Buf8(e.length),r=0,i=t.length;r<i;r++)t[r]=e.charCodeAt(r);return t},t.buf2string=function(e,t){var r,n,i,o,a=t||e.length,h=new Array(2*a);for(n=0,r=0;r<a;)if((i=e[r++])<128)h[n++]=i;else if((o=s[i])>4)h[n++]=65533,r+=o-1;else {for(i&=2===o?31:3===o?15:7;o>1&&r<a;)i=i<<6|63&e[r++],o--;o>1?h[n++]=65533:i<65536?h[n++]=i:(i-=65536,h[n++]=55296|i>>10&1023,h[n++]=56320|1023&i);}return f(h,n)},t.utf8border=function(e,t){var r;for((t=t||e.length)>e.length&&(t=e.length),r=t-1;r>=0&&128==(192&e[r]);)r--;return r<0||0===r?t:r+s[e[r]]>t?r:t};},6069:e=>{e.exports=function(e,t,r,n){for(var i=65535&e|0,o=e>>>16&65535|0,s=0;0!==r;){r-=s=r>2e3?2e3:r;do{o=o+(i=i+t[n++]|0)|0;}while(--s);i%=65521,o%=65521;}return i|o<<16|0};},1619:e=>{e.exports={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8};},2869:e=>{var t=function(){for(var e,t=[],r=0;r<256;r++){e=r;for(var n=0;n<8;n++)e=1&e?3988292384^e>>>1:e>>>1;t[r]=e;}return t}();e.exports=function(e,r,n,i){var o=t,s=i+n;e^=-1;for(var a=i;a<s;a++)e=e>>>8^o[255&(e^r[a])];return -1^e};},405:(e,t,r)=>{var n,i=r(4236),o=r(342),s=r(6069),a=r(2869),f=r(8898),h=-2,l=258,u=262,c=103,d=113,p=666;function g(e,t){return e.msg=f[t],t}function m(e){return (e<<1)-(e>4?9:0)}function y(e){for(var t=e.length;--t>=0;)e[t]=0;}function b(e){var t=e.state,r=t.pending;r>e.avail_out&&(r=e.avail_out),0!==r&&(i.arraySet(e.output,t.pending_buf,t.pending_out,r,e.next_out),e.next_out+=r,t.pending_out+=r,e.total_out+=r,e.avail_out-=r,t.pending-=r,0===t.pending&&(t.pending_out=0));}function v(e,t){o._tr_flush_block(e,e.block_start>=0?e.block_start:-1,e.strstart-e.block_start,t),e.block_start=e.strstart,b(e.strm);}function w(e,t){e.pending_buf[e.pending++]=t;}function _(e,t){e.pending_buf[e.pending++]=t>>>8&255,e.pending_buf[e.pending++]=255&t;}function B(e,t,r,n){var o=e.avail_in;return o>n&&(o=n),0===o?0:(e.avail_in-=o,i.arraySet(t,e.input,e.next_in,o,r),1===e.state.wrap?e.adler=s(e.adler,t,o,r):2===e.state.wrap&&(e.adler=a(e.adler,t,o,r)),e.next_in+=o,e.total_in+=o,o)}function E(e,t){var r,n,i=e.max_chain_length,o=e.strstart,s=e.prev_length,a=e.nice_match,f=e.strstart>e.w_size-u?e.strstart-(e.w_size-u):0,h=e.window,c=e.w_mask,d=e.prev,p=e.strstart+l,g=h[o+s-1],m=h[o+s];e.prev_length>=e.good_match&&(i>>=2),a>e.lookahead&&(a=e.lookahead);do{if(h[(r=t)+s]===m&&h[r+s-1]===g&&h[r]===h[o]&&h[++r]===h[o+1]){o+=2,r++;do{}while(h[++o]===h[++r]&&h[++o]===h[++r]&&h[++o]===h[++r]&&h[++o]===h[++r]&&h[++o]===h[++r]&&h[++o]===h[++r]&&h[++o]===h[++r]&&h[++o]===h[++r]&&o<p);if(n=l-(p-o),o=p-l,n>s){if(e.match_start=t,s=n,n>=a)break;g=h[o+s-1],m=h[o+s];}}}while((t=d[t&c])>f&&0!=--i);return s<=e.lookahead?s:e.lookahead}function S(e){var t,r,n,o,s,a=e.w_size;do{if(o=e.window_size-e.lookahead-e.strstart,e.strstart>=a+(a-u)){i.arraySet(e.window,e.window,a,a,0),e.match_start-=a,e.strstart-=a,e.block_start-=a,t=r=e.hash_size;do{n=e.head[--t],e.head[t]=n>=a?n-a:0;}while(--r);t=r=a;do{n=e.prev[--t],e.prev[t]=n>=a?n-a:0;}while(--r);o+=a;}if(0===e.strm.avail_in)break;if(r=B(e.strm,e.window,e.strstart+e.lookahead,o),e.lookahead+=r,e.lookahead+e.insert>=3)for(s=e.strstart-e.insert,e.ins_h=e.window[s],e.ins_h=(e.ins_h<<e.hash_shift^e.window[s+1])&e.hash_mask;e.insert&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[s+3-1])&e.hash_mask,e.prev[s&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=s,s++,e.insert--,!(e.lookahead+e.insert<3)););}while(e.lookahead<u&&0!==e.strm.avail_in)}function A(e,t){for(var r,n;;){if(e.lookahead<u){if(S(e),e.lookahead<u&&0===t)return 1;if(0===e.lookahead)break}if(r=0,e.lookahead>=3&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+3-1])&e.hash_mask,r=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),0!==r&&e.strstart-r<=e.w_size-u&&(e.match_length=E(e,r)),e.match_length>=3)if(n=o._tr_tally(e,e.strstart-e.match_start,e.match_length-3),e.lookahead-=e.match_length,e.match_length<=e.max_lazy_match&&e.lookahead>=3){e.match_length--;do{e.strstart++,e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+3-1])&e.hash_mask,r=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart;}while(0!=--e.match_length);e.strstart++;}else e.strstart+=e.match_length,e.match_length=0,e.ins_h=e.window[e.strstart],e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+1])&e.hash_mask;else n=o._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(n&&(v(e,!1),0===e.strm.avail_out))return 1}return e.insert=e.strstart<2?e.strstart:2,4===t?(v(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(v(e,!1),0===e.strm.avail_out)?1:2}function C(e,t){for(var r,n,i;;){if(e.lookahead<u){if(S(e),e.lookahead<u&&0===t)return 1;if(0===e.lookahead)break}if(r=0,e.lookahead>=3&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+3-1])&e.hash_mask,r=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),e.prev_length=e.match_length,e.prev_match=e.match_start,e.match_length=2,0!==r&&e.prev_length<e.max_lazy_match&&e.strstart-r<=e.w_size-u&&(e.match_length=E(e,r),e.match_length<=5&&(1===e.strategy||3===e.match_length&&e.strstart-e.match_start>4096)&&(e.match_length=2)),e.prev_length>=3&&e.match_length<=e.prev_length){i=e.strstart+e.lookahead-3,n=o._tr_tally(e,e.strstart-1-e.prev_match,e.prev_length-3),e.lookahead-=e.prev_length-1,e.prev_length-=2;do{++e.strstart<=i&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+3-1])&e.hash_mask,r=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart);}while(0!=--e.prev_length);if(e.match_available=0,e.match_length=2,e.strstart++,n&&(v(e,!1),0===e.strm.avail_out))return 1}else if(e.match_available){if((n=o._tr_tally(e,0,e.window[e.strstart-1]))&&v(e,!1),e.strstart++,e.lookahead--,0===e.strm.avail_out)return 1}else e.match_available=1,e.strstart++,e.lookahead--;}return e.match_available&&(n=o._tr_tally(e,0,e.window[e.strstart-1]),e.match_available=0),e.insert=e.strstart<2?e.strstart:2,4===t?(v(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(v(e,!1),0===e.strm.avail_out)?1:2}function R(e,t,r,n,i){this.good_length=e,this.max_lazy=t,this.nice_length=r,this.max_chain=n,this.func=i;}function k(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=8,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new i.Buf16(1146),this.dyn_dtree=new i.Buf16(122),this.bl_tree=new i.Buf16(78),y(this.dyn_ltree),y(this.dyn_dtree),y(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new i.Buf16(16),this.heap=new i.Buf16(573),y(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new i.Buf16(573),y(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0;}function x(e){var t;return e&&e.state?(e.total_in=e.total_out=0,e.data_type=2,(t=e.state).pending=0,t.pending_out=0,t.wrap<0&&(t.wrap=-t.wrap),t.status=t.wrap?42:d,e.adler=2===t.wrap?0:1,t.last_flush=0,o._tr_init(t),0):g(e,h)}function I(e){var t,r=x(e);return 0===r&&((t=e.state).window_size=2*t.w_size,y(t.head),t.max_lazy_match=n[t.level].max_lazy,t.good_match=n[t.level].good_length,t.nice_match=n[t.level].nice_length,t.max_chain_length=n[t.level].max_chain,t.strstart=0,t.block_start=0,t.lookahead=0,t.insert=0,t.match_length=t.prev_length=2,t.match_available=0,t.ins_h=0),r}function M(e,t,r,n,o,s){if(!e)return h;var a=1;if(-1===t&&(t=6),n<0?(a=0,n=-n):n>15&&(a=2,n-=16),o<1||o>9||8!==r||n<8||n>15||t<0||t>9||s<0||s>4)return g(e,h);8===n&&(n=9);var f=new k;return e.state=f,f.strm=e,f.wrap=a,f.gzhead=null,f.w_bits=n,f.w_size=1<<f.w_bits,f.w_mask=f.w_size-1,f.hash_bits=o+7,f.hash_size=1<<f.hash_bits,f.hash_mask=f.hash_size-1,f.hash_shift=~~((f.hash_bits+3-1)/3),f.window=new i.Buf8(2*f.w_size),f.head=new i.Buf16(f.hash_size),f.prev=new i.Buf16(f.w_size),f.lit_bufsize=1<<o+6,f.pending_buf_size=4*f.lit_bufsize,f.pending_buf=new i.Buf8(f.pending_buf_size),f.d_buf=1*f.lit_bufsize,f.l_buf=3*f.lit_bufsize,f.level=t,f.strategy=s,f.method=r,I(e)}n=[new R(0,0,0,0,(function(e,t){var r=65535;for(r>e.pending_buf_size-5&&(r=e.pending_buf_size-5);;){if(e.lookahead<=1){if(S(e),0===e.lookahead&&0===t)return 1;if(0===e.lookahead)break}e.strstart+=e.lookahead,e.lookahead=0;var n=e.block_start+r;if((0===e.strstart||e.strstart>=n)&&(e.lookahead=e.strstart-n,e.strstart=n,v(e,!1),0===e.strm.avail_out))return 1;if(e.strstart-e.block_start>=e.w_size-u&&(v(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,4===t?(v(e,!0),0===e.strm.avail_out?3:4):(e.strstart>e.block_start&&(v(e,!1),e.strm.avail_out),1)})),new R(4,4,8,4,A),new R(4,5,16,8,A),new R(4,6,32,32,A),new R(4,4,16,16,C),new R(8,16,32,32,C),new R(8,16,128,128,C),new R(8,32,128,256,C),new R(32,128,258,1024,C),new R(32,258,258,4096,C)],t.deflateInit=function(e,t){return M(e,t,8,15,8,0)},t.deflateInit2=M,t.deflateReset=I,t.deflateResetKeep=x,t.deflateSetHeader=function(e,t){return e&&e.state?2!==e.state.wrap?h:(e.state.gzhead=t,0):h},t.deflate=function(e,t){var r,i,s,f;if(!e||!e.state||t>5||t<0)return e?g(e,h):h;if(i=e.state,!e.output||!e.input&&0!==e.avail_in||i.status===p&&4!==t)return g(e,0===e.avail_out?-5:h);if(i.strm=e,r=i.last_flush,i.last_flush=t,42===i.status)if(2===i.wrap)e.adler=0,w(i,31),w(i,139),w(i,8),i.gzhead?(w(i,(i.gzhead.text?1:0)+(i.gzhead.hcrc?2:0)+(i.gzhead.extra?4:0)+(i.gzhead.name?8:0)+(i.gzhead.comment?16:0)),w(i,255&i.gzhead.time),w(i,i.gzhead.time>>8&255),w(i,i.gzhead.time>>16&255),w(i,i.gzhead.time>>24&255),w(i,9===i.level?2:i.strategy>=2||i.level<2?4:0),w(i,255&i.gzhead.os),i.gzhead.extra&&i.gzhead.extra.length&&(w(i,255&i.gzhead.extra.length),w(i,i.gzhead.extra.length>>8&255)),i.gzhead.hcrc&&(e.adler=a(e.adler,i.pending_buf,i.pending,0)),i.gzindex=0,i.status=69):(w(i,0),w(i,0),w(i,0),w(i,0),w(i,0),w(i,9===i.level?2:i.strategy>=2||i.level<2?4:0),w(i,3),i.status=d);else {var u=8+(i.w_bits-8<<4)<<8;u|=(i.strategy>=2||i.level<2?0:i.level<6?1:6===i.level?2:3)<<6,0!==i.strstart&&(u|=32),u+=31-u%31,i.status=d,_(i,u),0!==i.strstart&&(_(i,e.adler>>>16),_(i,65535&e.adler)),e.adler=1;}if(69===i.status)if(i.gzhead.extra){for(s=i.pending;i.gzindex<(65535&i.gzhead.extra.length)&&(i.pending!==i.pending_buf_size||(i.gzhead.hcrc&&i.pending>s&&(e.adler=a(e.adler,i.pending_buf,i.pending-s,s)),b(e),s=i.pending,i.pending!==i.pending_buf_size));)w(i,255&i.gzhead.extra[i.gzindex]),i.gzindex++;i.gzhead.hcrc&&i.pending>s&&(e.adler=a(e.adler,i.pending_buf,i.pending-s,s)),i.gzindex===i.gzhead.extra.length&&(i.gzindex=0,i.status=73);}else i.status=73;if(73===i.status)if(i.gzhead.name){s=i.pending;do{if(i.pending===i.pending_buf_size&&(i.gzhead.hcrc&&i.pending>s&&(e.adler=a(e.adler,i.pending_buf,i.pending-s,s)),b(e),s=i.pending,i.pending===i.pending_buf_size)){f=1;break}f=i.gzindex<i.gzhead.name.length?255&i.gzhead.name.charCodeAt(i.gzindex++):0,w(i,f);}while(0!==f);i.gzhead.hcrc&&i.pending>s&&(e.adler=a(e.adler,i.pending_buf,i.pending-s,s)),0===f&&(i.gzindex=0,i.status=91);}else i.status=91;if(91===i.status)if(i.gzhead.comment){s=i.pending;do{if(i.pending===i.pending_buf_size&&(i.gzhead.hcrc&&i.pending>s&&(e.adler=a(e.adler,i.pending_buf,i.pending-s,s)),b(e),s=i.pending,i.pending===i.pending_buf_size)){f=1;break}f=i.gzindex<i.gzhead.comment.length?255&i.gzhead.comment.charCodeAt(i.gzindex++):0,w(i,f);}while(0!==f);i.gzhead.hcrc&&i.pending>s&&(e.adler=a(e.adler,i.pending_buf,i.pending-s,s)),0===f&&(i.status=c);}else i.status=c;if(i.status===c&&(i.gzhead.hcrc?(i.pending+2>i.pending_buf_size&&b(e),i.pending+2<=i.pending_buf_size&&(w(i,255&e.adler),w(i,e.adler>>8&255),e.adler=0,i.status=d)):i.status=d),0!==i.pending){if(b(e),0===e.avail_out)return i.last_flush=-1,0}else if(0===e.avail_in&&m(t)<=m(r)&&4!==t)return g(e,-5);if(i.status===p&&0!==e.avail_in)return g(e,-5);if(0!==e.avail_in||0!==i.lookahead||0!==t&&i.status!==p){var B=2===i.strategy?function(e,t){for(var r;;){if(0===e.lookahead&&(S(e),0===e.lookahead)){if(0===t)return 1;break}if(e.match_length=0,r=o._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++,r&&(v(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,4===t?(v(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(v(e,!1),0===e.strm.avail_out)?1:2}(i,t):3===i.strategy?function(e,t){for(var r,n,i,s,a=e.window;;){if(e.lookahead<=l){if(S(e),e.lookahead<=l&&0===t)return 1;if(0===e.lookahead)break}if(e.match_length=0,e.lookahead>=3&&e.strstart>0&&(n=a[i=e.strstart-1])===a[++i]&&n===a[++i]&&n===a[++i]){s=e.strstart+l;do{}while(n===a[++i]&&n===a[++i]&&n===a[++i]&&n===a[++i]&&n===a[++i]&&n===a[++i]&&n===a[++i]&&n===a[++i]&&i<s);e.match_length=l-(s-i),e.match_length>e.lookahead&&(e.match_length=e.lookahead);}if(e.match_length>=3?(r=o._tr_tally(e,1,e.match_length-3),e.lookahead-=e.match_length,e.strstart+=e.match_length,e.match_length=0):(r=o._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++),r&&(v(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,4===t?(v(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(v(e,!1),0===e.strm.avail_out)?1:2}(i,t):n[i.level].func(i,t);if(3!==B&&4!==B||(i.status=p),1===B||3===B)return 0===e.avail_out&&(i.last_flush=-1),0;if(2===B&&(1===t?o._tr_align(i):5!==t&&(o._tr_stored_block(i,0,0,!1),3===t&&(y(i.head),0===i.lookahead&&(i.strstart=0,i.block_start=0,i.insert=0))),b(e),0===e.avail_out))return i.last_flush=-1,0}return 4!==t?0:i.wrap<=0?1:(2===i.wrap?(w(i,255&e.adler),w(i,e.adler>>8&255),w(i,e.adler>>16&255),w(i,e.adler>>24&255),w(i,255&e.total_in),w(i,e.total_in>>8&255),w(i,e.total_in>>16&255),w(i,e.total_in>>24&255)):(_(i,e.adler>>>16),_(i,65535&e.adler)),b(e),i.wrap>0&&(i.wrap=-i.wrap),0!==i.pending?0:1)},t.deflateEnd=function(e){var t;return e&&e.state?42!==(t=e.state.status)&&69!==t&&73!==t&&91!==t&&t!==c&&t!==d&&t!==p?g(e,h):(e.state=null,t===d?g(e,-3):0):h},t.deflateSetDictionary=function(e,t){var r,n,o,a,f,l,u,c,d=t.length;if(!e||!e.state)return h;if(2===(a=(r=e.state).wrap)||1===a&&42!==r.status||r.lookahead)return h;for(1===a&&(e.adler=s(e.adler,t,d,0)),r.wrap=0,d>=r.w_size&&(0===a&&(y(r.head),r.strstart=0,r.block_start=0,r.insert=0),c=new i.Buf8(r.w_size),i.arraySet(c,t,d-r.w_size,r.w_size,0),t=c,d=r.w_size),f=e.avail_in,l=e.next_in,u=e.input,e.avail_in=d,e.next_in=0,e.input=t,S(r);r.lookahead>=3;){n=r.strstart,o=r.lookahead-2;do{r.ins_h=(r.ins_h<<r.hash_shift^r.window[n+3-1])&r.hash_mask,r.prev[n&r.w_mask]=r.head[r.ins_h],r.head[r.ins_h]=n,n++;}while(--o);r.strstart=n,r.lookahead=2,S(r);}return r.strstart+=r.lookahead,r.block_start=r.strstart,r.insert=r.lookahead,r.lookahead=0,r.match_length=r.prev_length=2,r.match_available=0,e.next_in=l,e.input=u,e.avail_in=f,r.wrap=a,0},t.deflateInfo="pako deflate (from Nodeca project)";},2401:e=>{e.exports=function(){this.text=0,this.time=0,this.xflags=0,this.os=0,this.extra=null,this.extra_len=0,this.name="",this.comment="",this.hcrc=0,this.done=!1;};},4264:e=>{e.exports=function(e,t){var r,n,i,o,s,a,f,h,l,u,c,d,p,g,m,y,b,v,w,_,B,E,S,A,C;r=e.state,n=e.next_in,A=e.input,i=n+(e.avail_in-5),o=e.next_out,C=e.output,s=o-(t-e.avail_out),a=o+(e.avail_out-257),f=r.dmax,h=r.wsize,l=r.whave,u=r.wnext,c=r.window,d=r.hold,p=r.bits,g=r.lencode,m=r.distcode,y=(1<<r.lenbits)-1,b=(1<<r.distbits)-1;e:do{p<15&&(d+=A[n++]<<p,p+=8,d+=A[n++]<<p,p+=8),v=g[d&y];t:for(;;){if(d>>>=w=v>>>24,p-=w,0==(w=v>>>16&255))C[o++]=65535&v;else {if(!(16&w)){if(0==(64&w)){v=g[(65535&v)+(d&(1<<w)-1)];continue t}if(32&w){r.mode=12;break e}e.msg="invalid literal/length code",r.mode=30;break e}_=65535&v,(w&=15)&&(p<w&&(d+=A[n++]<<p,p+=8),_+=d&(1<<w)-1,d>>>=w,p-=w),p<15&&(d+=A[n++]<<p,p+=8,d+=A[n++]<<p,p+=8),v=m[d&b];r:for(;;){if(d>>>=w=v>>>24,p-=w,!(16&(w=v>>>16&255))){if(0==(64&w)){v=m[(65535&v)+(d&(1<<w)-1)];continue r}e.msg="invalid distance code",r.mode=30;break e}if(B=65535&v,p<(w&=15)&&(d+=A[n++]<<p,(p+=8)<w&&(d+=A[n++]<<p,p+=8)),(B+=d&(1<<w)-1)>f){e.msg="invalid distance too far back",r.mode=30;break e}if(d>>>=w,p-=w,B>(w=o-s)){if((w=B-w)>l&&r.sane){e.msg="invalid distance too far back",r.mode=30;break e}if(E=0,S=c,0===u){if(E+=h-w,w<_){_-=w;do{C[o++]=c[E++];}while(--w);E=o-B,S=C;}}else if(u<w){if(E+=h+u-w,(w-=u)<_){_-=w;do{C[o++]=c[E++];}while(--w);if(E=0,u<_){_-=w=u;do{C[o++]=c[E++];}while(--w);E=o-B,S=C;}}}else if(E+=u-w,w<_){_-=w;do{C[o++]=c[E++];}while(--w);E=o-B,S=C;}for(;_>2;)C[o++]=S[E++],C[o++]=S[E++],C[o++]=S[E++],_-=3;_&&(C[o++]=S[E++],_>1&&(C[o++]=S[E++]));}else {E=o-B;do{C[o++]=C[E++],C[o++]=C[E++],C[o++]=C[E++],_-=3;}while(_>2);_&&(C[o++]=C[E++],_>1&&(C[o++]=C[E++]));}break}}break}}while(n<i&&o<a);n-=_=p>>3,d&=(1<<(p-=_<<3))-1,e.next_in=n,e.next_out=o,e.avail_in=n<i?i-n+5:5-(n-i),e.avail_out=o<a?a-o+257:257-(o-a),r.hold=d,r.bits=p;};},7948:(e,t,r)=>{var n=r(4236),i=r(6069),o=r(2869),s=r(4264),a=r(9241),f=-2,h=12,l=30;function u(e){return (e>>>24&255)+(e>>>8&65280)+((65280&e)<<8)+((255&e)<<24)}function c(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new n.Buf16(320),this.work=new n.Buf16(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0;}function d(e){var t;return e&&e.state?(t=e.state,e.total_in=e.total_out=t.total=0,e.msg="",t.wrap&&(e.adler=1&t.wrap),t.mode=1,t.last=0,t.havedict=0,t.dmax=32768,t.head=null,t.hold=0,t.bits=0,t.lencode=t.lendyn=new n.Buf32(852),t.distcode=t.distdyn=new n.Buf32(592),t.sane=1,t.back=-1,0):f}function p(e){var t;return e&&e.state?((t=e.state).wsize=0,t.whave=0,t.wnext=0,d(e)):f}function g(e,t){var r,n;return e&&e.state?(n=e.state,t<0?(r=0,t=-t):(r=1+(t>>4),t<48&&(t&=15)),t&&(t<8||t>15)?f:(null!==n.window&&n.wbits!==t&&(n.window=null),n.wrap=r,n.wbits=t,p(e))):f}function m(e,t){var r,n;return e?(n=new c,e.state=n,n.window=null,0!==(r=g(e,t))&&(e.state=null),r):f}var y,b,v=!0;function w(e){if(v){var t;for(y=new n.Buf32(512),b=new n.Buf32(32),t=0;t<144;)e.lens[t++]=8;for(;t<256;)e.lens[t++]=9;for(;t<280;)e.lens[t++]=7;for(;t<288;)e.lens[t++]=8;for(a(1,e.lens,0,288,y,0,e.work,{bits:9}),t=0;t<32;)e.lens[t++]=5;a(2,e.lens,0,32,b,0,e.work,{bits:5}),v=!1;}e.lencode=y,e.lenbits=9,e.distcode=b,e.distbits=5;}function _(e,t,r,i){var o,s=e.state;return null===s.window&&(s.wsize=1<<s.wbits,s.wnext=0,s.whave=0,s.window=new n.Buf8(s.wsize)),i>=s.wsize?(n.arraySet(s.window,t,r-s.wsize,s.wsize,0),s.wnext=0,s.whave=s.wsize):((o=s.wsize-s.wnext)>i&&(o=i),n.arraySet(s.window,t,r-i,o,s.wnext),(i-=o)?(n.arraySet(s.window,t,r-i,i,0),s.wnext=i,s.whave=s.wsize):(s.wnext+=o,s.wnext===s.wsize&&(s.wnext=0),s.whave<s.wsize&&(s.whave+=o))),0}t.inflateReset=p,t.inflateReset2=g,t.inflateResetKeep=d,t.inflateInit=function(e){return m(e,15)},t.inflateInit2=m,t.inflate=function(e,t){var r,c,d,p,g,m,y,b,v,B,E,S,A,C,R,k,x,I,M,F,O,T,U,P,N=0,L=new n.Buf8(4),z=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];if(!e||!e.state||!e.output||!e.input&&0!==e.avail_in)return f;(r=e.state).mode===h&&(r.mode=13),g=e.next_out,d=e.output,y=e.avail_out,p=e.next_in,c=e.input,m=e.avail_in,b=r.hold,v=r.bits,B=m,E=y,T=0;e:for(;;)switch(r.mode){case 1:if(0===r.wrap){r.mode=13;break}for(;v<16;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(2&r.wrap&&35615===b){r.check=0,L[0]=255&b,L[1]=b>>>8&255,r.check=o(r.check,L,2,0),b=0,v=0,r.mode=2;break}if(r.flags=0,r.head&&(r.head.done=!1),!(1&r.wrap)||(((255&b)<<8)+(b>>8))%31){e.msg="incorrect header check",r.mode=l;break}if(8!=(15&b)){e.msg="unknown compression method",r.mode=l;break}if(v-=4,O=8+(15&(b>>>=4)),0===r.wbits)r.wbits=O;else if(O>r.wbits){e.msg="invalid window size",r.mode=l;break}r.dmax=1<<O,e.adler=r.check=1,r.mode=512&b?10:h,b=0,v=0;break;case 2:for(;v<16;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(r.flags=b,8!=(255&r.flags)){e.msg="unknown compression method",r.mode=l;break}if(57344&r.flags){e.msg="unknown header flags set",r.mode=l;break}r.head&&(r.head.text=b>>8&1),512&r.flags&&(L[0]=255&b,L[1]=b>>>8&255,r.check=o(r.check,L,2,0)),b=0,v=0,r.mode=3;case 3:for(;v<32;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}r.head&&(r.head.time=b),512&r.flags&&(L[0]=255&b,L[1]=b>>>8&255,L[2]=b>>>16&255,L[3]=b>>>24&255,r.check=o(r.check,L,4,0)),b=0,v=0,r.mode=4;case 4:for(;v<16;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}r.head&&(r.head.xflags=255&b,r.head.os=b>>8),512&r.flags&&(L[0]=255&b,L[1]=b>>>8&255,r.check=o(r.check,L,2,0)),b=0,v=0,r.mode=5;case 5:if(1024&r.flags){for(;v<16;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}r.length=b,r.head&&(r.head.extra_len=b),512&r.flags&&(L[0]=255&b,L[1]=b>>>8&255,r.check=o(r.check,L,2,0)),b=0,v=0;}else r.head&&(r.head.extra=null);r.mode=6;case 6:if(1024&r.flags&&((S=r.length)>m&&(S=m),S&&(r.head&&(O=r.head.extra_len-r.length,r.head.extra||(r.head.extra=new Array(r.head.extra_len)),n.arraySet(r.head.extra,c,p,S,O)),512&r.flags&&(r.check=o(r.check,c,S,p)),m-=S,p+=S,r.length-=S),r.length))break e;r.length=0,r.mode=7;case 7:if(2048&r.flags){if(0===m)break e;S=0;do{O=c[p+S++],r.head&&O&&r.length<65536&&(r.head.name+=String.fromCharCode(O));}while(O&&S<m);if(512&r.flags&&(r.check=o(r.check,c,S,p)),m-=S,p+=S,O)break e}else r.head&&(r.head.name=null);r.length=0,r.mode=8;case 8:if(4096&r.flags){if(0===m)break e;S=0;do{O=c[p+S++],r.head&&O&&r.length<65536&&(r.head.comment+=String.fromCharCode(O));}while(O&&S<m);if(512&r.flags&&(r.check=o(r.check,c,S,p)),m-=S,p+=S,O)break e}else r.head&&(r.head.comment=null);r.mode=9;case 9:if(512&r.flags){for(;v<16;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(b!==(65535&r.check)){e.msg="header crc mismatch",r.mode=l;break}b=0,v=0;}r.head&&(r.head.hcrc=r.flags>>9&1,r.head.done=!0),e.adler=r.check=0,r.mode=h;break;case 10:for(;v<32;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}e.adler=r.check=u(b),b=0,v=0,r.mode=11;case 11:if(0===r.havedict)return e.next_out=g,e.avail_out=y,e.next_in=p,e.avail_in=m,r.hold=b,r.bits=v,2;e.adler=r.check=1,r.mode=h;case h:if(5===t||6===t)break e;case 13:if(r.last){b>>>=7&v,v-=7&v,r.mode=27;break}for(;v<3;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}switch(r.last=1&b,v-=1,3&(b>>>=1)){case 0:r.mode=14;break;case 1:if(w(r),r.mode=20,6===t){b>>>=2,v-=2;break e}break;case 2:r.mode=17;break;case 3:e.msg="invalid block type",r.mode=l;}b>>>=2,v-=2;break;case 14:for(b>>>=7&v,v-=7&v;v<32;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if((65535&b)!=(b>>>16^65535)){e.msg="invalid stored block lengths",r.mode=l;break}if(r.length=65535&b,b=0,v=0,r.mode=15,6===t)break e;case 15:r.mode=16;case 16:if(S=r.length){if(S>m&&(S=m),S>y&&(S=y),0===S)break e;n.arraySet(d,c,p,S,g),m-=S,p+=S,y-=S,g+=S,r.length-=S;break}r.mode=h;break;case 17:for(;v<14;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(r.nlen=257+(31&b),b>>>=5,v-=5,r.ndist=1+(31&b),b>>>=5,v-=5,r.ncode=4+(15&b),b>>>=4,v-=4,r.nlen>286||r.ndist>30){e.msg="too many length or distance symbols",r.mode=l;break}r.have=0,r.mode=18;case 18:for(;r.have<r.ncode;){for(;v<3;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}r.lens[z[r.have++]]=7&b,b>>>=3,v-=3;}for(;r.have<19;)r.lens[z[r.have++]]=0;if(r.lencode=r.lendyn,r.lenbits=7,U={bits:r.lenbits},T=a(0,r.lens,0,19,r.lencode,0,r.work,U),r.lenbits=U.bits,T){e.msg="invalid code lengths set",r.mode=l;break}r.have=0,r.mode=19;case 19:for(;r.have<r.nlen+r.ndist;){for(;k=(N=r.lencode[b&(1<<r.lenbits)-1])>>>16&255,x=65535&N,!((R=N>>>24)<=v);){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(x<16)b>>>=R,v-=R,r.lens[r.have++]=x;else {if(16===x){for(P=R+2;v<P;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(b>>>=R,v-=R,0===r.have){e.msg="invalid bit length repeat",r.mode=l;break}O=r.lens[r.have-1],S=3+(3&b),b>>>=2,v-=2;}else if(17===x){for(P=R+3;v<P;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}v-=R,O=0,S=3+(7&(b>>>=R)),b>>>=3,v-=3;}else {for(P=R+7;v<P;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}v-=R,O=0,S=11+(127&(b>>>=R)),b>>>=7,v-=7;}if(r.have+S>r.nlen+r.ndist){e.msg="invalid bit length repeat",r.mode=l;break}for(;S--;)r.lens[r.have++]=O;}}if(r.mode===l)break;if(0===r.lens[256]){e.msg="invalid code -- missing end-of-block",r.mode=l;break}if(r.lenbits=9,U={bits:r.lenbits},T=a(1,r.lens,0,r.nlen,r.lencode,0,r.work,U),r.lenbits=U.bits,T){e.msg="invalid literal/lengths set",r.mode=l;break}if(r.distbits=6,r.distcode=r.distdyn,U={bits:r.distbits},T=a(2,r.lens,r.nlen,r.ndist,r.distcode,0,r.work,U),r.distbits=U.bits,T){e.msg="invalid distances set",r.mode=l;break}if(r.mode=20,6===t)break e;case 20:r.mode=21;case 21:if(m>=6&&y>=258){e.next_out=g,e.avail_out=y,e.next_in=p,e.avail_in=m,r.hold=b,r.bits=v,s(e,E),g=e.next_out,d=e.output,y=e.avail_out,p=e.next_in,c=e.input,m=e.avail_in,b=r.hold,v=r.bits,r.mode===h&&(r.back=-1);break}for(r.back=0;k=(N=r.lencode[b&(1<<r.lenbits)-1])>>>16&255,x=65535&N,!((R=N>>>24)<=v);){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(k&&0==(240&k)){for(I=R,M=k,F=x;k=(N=r.lencode[F+((b&(1<<I+M)-1)>>I)])>>>16&255,x=65535&N,!(I+(R=N>>>24)<=v);){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}b>>>=I,v-=I,r.back+=I;}if(b>>>=R,v-=R,r.back+=R,r.length=x,0===k){r.mode=26;break}if(32&k){r.back=-1,r.mode=h;break}if(64&k){e.msg="invalid literal/length code",r.mode=l;break}r.extra=15&k,r.mode=22;case 22:if(r.extra){for(P=r.extra;v<P;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}r.length+=b&(1<<r.extra)-1,b>>>=r.extra,v-=r.extra,r.back+=r.extra;}r.was=r.length,r.mode=23;case 23:for(;k=(N=r.distcode[b&(1<<r.distbits)-1])>>>16&255,x=65535&N,!((R=N>>>24)<=v);){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(0==(240&k)){for(I=R,M=k,F=x;k=(N=r.distcode[F+((b&(1<<I+M)-1)>>I)])>>>16&255,x=65535&N,!(I+(R=N>>>24)<=v);){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}b>>>=I,v-=I,r.back+=I;}if(b>>>=R,v-=R,r.back+=R,64&k){e.msg="invalid distance code",r.mode=l;break}r.offset=x,r.extra=15&k,r.mode=24;case 24:if(r.extra){for(P=r.extra;v<P;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}r.offset+=b&(1<<r.extra)-1,b>>>=r.extra,v-=r.extra,r.back+=r.extra;}if(r.offset>r.dmax){e.msg="invalid distance too far back",r.mode=l;break}r.mode=25;case 25:if(0===y)break e;if(S=E-y,r.offset>S){if((S=r.offset-S)>r.whave&&r.sane){e.msg="invalid distance too far back",r.mode=l;break}S>r.wnext?(S-=r.wnext,A=r.wsize-S):A=r.wnext-S,S>r.length&&(S=r.length),C=r.window;}else C=d,A=g-r.offset,S=r.length;S>y&&(S=y),y-=S,r.length-=S;do{d[g++]=C[A++];}while(--S);0===r.length&&(r.mode=21);break;case 26:if(0===y)break e;d[g++]=r.length,y--,r.mode=21;break;case 27:if(r.wrap){for(;v<32;){if(0===m)break e;m--,b|=c[p++]<<v,v+=8;}if(E-=y,e.total_out+=E,r.total+=E,E&&(e.adler=r.check=r.flags?o(r.check,d,E,g-E):i(r.check,d,E,g-E)),E=y,(r.flags?b:u(b))!==r.check){e.msg="incorrect data check",r.mode=l;break}b=0,v=0;}r.mode=28;case 28:if(r.wrap&&r.flags){for(;v<32;){if(0===m)break e;m--,b+=c[p++]<<v,v+=8;}if(b!==(4294967295&r.total)){e.msg="incorrect length check",r.mode=l;break}b=0,v=0;}r.mode=29;case 29:T=1;break e;case l:T=-3;break e;case 31:return -4;default:return f}return e.next_out=g,e.avail_out=y,e.next_in=p,e.avail_in=m,r.hold=b,r.bits=v,(r.wsize||E!==e.avail_out&&r.mode<l&&(r.mode<27||4!==t))&&_(e,e.output,e.next_out,E-e.avail_out)?(r.mode=31,-4):(B-=e.avail_in,E-=e.avail_out,e.total_in+=B,e.total_out+=E,r.total+=E,r.wrap&&E&&(e.adler=r.check=r.flags?o(r.check,d,E,e.next_out-E):i(r.check,d,E,e.next_out-E)),e.data_type=r.bits+(r.last?64:0)+(r.mode===h?128:0)+(20===r.mode||15===r.mode?256:0),(0===B&&0===E||4===t)&&0===T&&(T=-5),T)},t.inflateEnd=function(e){if(!e||!e.state)return f;var t=e.state;return t.window&&(t.window=null),e.state=null,0},t.inflateGetHeader=function(e,t){var r;return e&&e.state?0==(2&(r=e.state).wrap)?f:(r.head=t,t.done=!1,0):f},t.inflateSetDictionary=function(e,t){var r,n=t.length;return e&&e.state?0!==(r=e.state).wrap&&11!==r.mode?f:11===r.mode&&i(1,t,n,0)!==r.check?-3:_(e,t,n,n)?(r.mode=31,-4):(r.havedict=1,0):f},t.inflateInfo="pako inflate (from Nodeca project)";},9241:(e,t,r)=>{var n=r(4236),i=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0],o=[16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78],s=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0],a=[16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64];e.exports=function(e,t,r,f,h,l,u,c){var d,p,g,m,y,b,v,w,_,B=c.bits,E=0,S=0,A=0,C=0,R=0,k=0,x=0,I=0,M=0,F=0,O=null,T=0,U=new n.Buf16(16),P=new n.Buf16(16),N=null,L=0;for(E=0;E<=15;E++)U[E]=0;for(S=0;S<f;S++)U[t[r+S]]++;for(R=B,C=15;C>=1&&0===U[C];C--);if(R>C&&(R=C),0===C)return h[l++]=20971520,h[l++]=20971520,c.bits=1,0;for(A=1;A<C&&0===U[A];A++);for(R<A&&(R=A),I=1,E=1;E<=15;E++)if(I<<=1,(I-=U[E])<0)return -1;if(I>0&&(0===e||1!==C))return -1;for(P[1]=0,E=1;E<15;E++)P[E+1]=P[E]+U[E];for(S=0;S<f;S++)0!==t[r+S]&&(u[P[t[r+S]]++]=S);if(0===e?(O=N=u,b=19):1===e?(O=i,T-=257,N=o,L-=257,b=256):(O=s,N=a,b=-1),F=0,S=0,E=A,y=l,k=R,x=0,g=-1,m=(M=1<<R)-1,1===e&&M>852||2===e&&M>592)return 1;for(;;){v=E-x,u[S]<b?(w=0,_=u[S]):u[S]>b?(w=N[L+u[S]],_=O[T+u[S]]):(w=96,_=0),d=1<<E-x,A=p=1<<k;do{h[y+(F>>x)+(p-=d)]=v<<24|w<<16|_|0;}while(0!==p);for(d=1<<E-1;F&d;)d>>=1;if(0!==d?(F&=d-1,F+=d):F=0,S++,0==--U[E]){if(E===C)break;E=t[r+u[S]];}if(E>R&&(F&m)!==g){for(0===x&&(x=R),y+=A,I=1<<(k=E-x);k+x<C&&!((I-=U[k+x])<=0);)k++,I<<=1;if(M+=1<<k,1===e&&M>852||2===e&&M>592)return 1;h[g=F&m]=R<<24|k<<16|y-l|0;}}return 0!==F&&(h[y+F]=E-x<<24|64<<16|0),c.bits=R,0};},8898:e=>{e.exports={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"};},342:(e,t,r)=>{var n=r(4236);function i(e){for(var t=e.length;--t>=0;)e[t]=0;}var o=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],s=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],a=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],f=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],h=new Array(576);i(h);var l=new Array(60);i(l);var u=new Array(512);i(u);var c=new Array(256);i(c);var d=new Array(29);i(d);var p,g,m,y=new Array(30);function b(e,t,r,n,i){this.static_tree=e,this.extra_bits=t,this.extra_base=r,this.elems=n,this.max_length=i,this.has_stree=e&&e.length;}function v(e,t){this.dyn_tree=e,this.max_code=0,this.stat_desc=t;}function w(e){return e<256?u[e]:u[256+(e>>>7)]}function _(e,t){e.pending_buf[e.pending++]=255&t,e.pending_buf[e.pending++]=t>>>8&255;}function B(e,t,r){e.bi_valid>16-r?(e.bi_buf|=t<<e.bi_valid&65535,_(e,e.bi_buf),e.bi_buf=t>>16-e.bi_valid,e.bi_valid+=r-16):(e.bi_buf|=t<<e.bi_valid&65535,e.bi_valid+=r);}function E(e,t,r){B(e,r[2*t],r[2*t+1]);}function S(e,t){var r=0;do{r|=1&e,e>>>=1,r<<=1;}while(--t>0);return r>>>1}function A(e,t,r){var n,i,o=new Array(16),s=0;for(n=1;n<=15;n++)o[n]=s=s+r[n-1]<<1;for(i=0;i<=t;i++){var a=e[2*i+1];0!==a&&(e[2*i]=S(o[a]++,a));}}function C(e){var t;for(t=0;t<286;t++)e.dyn_ltree[2*t]=0;for(t=0;t<30;t++)e.dyn_dtree[2*t]=0;for(t=0;t<19;t++)e.bl_tree[2*t]=0;e.dyn_ltree[512]=1,e.opt_len=e.static_len=0,e.last_lit=e.matches=0;}function R(e){e.bi_valid>8?_(e,e.bi_buf):e.bi_valid>0&&(e.pending_buf[e.pending++]=e.bi_buf),e.bi_buf=0,e.bi_valid=0;}function k(e,t,r,n){var i=2*t,o=2*r;return e[i]<e[o]||e[i]===e[o]&&n[t]<=n[r]}function x(e,t,r){for(var n=e.heap[r],i=r<<1;i<=e.heap_len&&(i<e.heap_len&&k(t,e.heap[i+1],e.heap[i],e.depth)&&i++,!k(t,n,e.heap[i],e.depth));)e.heap[r]=e.heap[i],r=i,i<<=1;e.heap[r]=n;}function I(e,t,r){var n,i,a,f,h=0;if(0!==e.last_lit)do{n=e.pending_buf[e.d_buf+2*h]<<8|e.pending_buf[e.d_buf+2*h+1],i=e.pending_buf[e.l_buf+h],h++,0===n?E(e,i,t):(E(e,(a=c[i])+256+1,t),0!==(f=o[a])&&B(e,i-=d[a],f),E(e,a=w(--n),r),0!==(f=s[a])&&B(e,n-=y[a],f));}while(h<e.last_lit);E(e,256,t);}function M(e,t){var r,n,i,o=t.dyn_tree,s=t.stat_desc.static_tree,a=t.stat_desc.has_stree,f=t.stat_desc.elems,h=-1;for(e.heap_len=0,e.heap_max=573,r=0;r<f;r++)0!==o[2*r]?(e.heap[++e.heap_len]=h=r,e.depth[r]=0):o[2*r+1]=0;for(;e.heap_len<2;)o[2*(i=e.heap[++e.heap_len]=h<2?++h:0)]=1,e.depth[i]=0,e.opt_len--,a&&(e.static_len-=s[2*i+1]);for(t.max_code=h,r=e.heap_len>>1;r>=1;r--)x(e,o,r);i=f;do{r=e.heap[1],e.heap[1]=e.heap[e.heap_len--],x(e,o,1),n=e.heap[1],e.heap[--e.heap_max]=r,e.heap[--e.heap_max]=n,o[2*i]=o[2*r]+o[2*n],e.depth[i]=(e.depth[r]>=e.depth[n]?e.depth[r]:e.depth[n])+1,o[2*r+1]=o[2*n+1]=i,e.heap[1]=i++,x(e,o,1);}while(e.heap_len>=2);e.heap[--e.heap_max]=e.heap[1],function(e,t){var r,n,i,o,s,a,f=t.dyn_tree,h=t.max_code,l=t.stat_desc.static_tree,u=t.stat_desc.has_stree,c=t.stat_desc.extra_bits,d=t.stat_desc.extra_base,p=t.stat_desc.max_length,g=0;for(o=0;o<=15;o++)e.bl_count[o]=0;for(f[2*e.heap[e.heap_max]+1]=0,r=e.heap_max+1;r<573;r++)(o=f[2*f[2*(n=e.heap[r])+1]+1]+1)>p&&(o=p,g++),f[2*n+1]=o,n>h||(e.bl_count[o]++,s=0,n>=d&&(s=c[n-d]),a=f[2*n],e.opt_len+=a*(o+s),u&&(e.static_len+=a*(l[2*n+1]+s)));if(0!==g){do{for(o=p-1;0===e.bl_count[o];)o--;e.bl_count[o]--,e.bl_count[o+1]+=2,e.bl_count[p]--,g-=2;}while(g>0);for(o=p;0!==o;o--)for(n=e.bl_count[o];0!==n;)(i=e.heap[--r])>h||(f[2*i+1]!==o&&(e.opt_len+=(o-f[2*i+1])*f[2*i],f[2*i+1]=o),n--);}}(e,t),A(o,h,e.bl_count);}function F(e,t,r){var n,i,o=-1,s=t[1],a=0,f=7,h=4;for(0===s&&(f=138,h=3),t[2*(r+1)+1]=65535,n=0;n<=r;n++)i=s,s=t[2*(n+1)+1],++a<f&&i===s||(a<h?e.bl_tree[2*i]+=a:0!==i?(i!==o&&e.bl_tree[2*i]++,e.bl_tree[32]++):a<=10?e.bl_tree[34]++:e.bl_tree[36]++,a=0,o=i,0===s?(f=138,h=3):i===s?(f=6,h=3):(f=7,h=4));}function O(e,t,r){var n,i,o=-1,s=t[1],a=0,f=7,h=4;for(0===s&&(f=138,h=3),n=0;n<=r;n++)if(i=s,s=t[2*(n+1)+1],!(++a<f&&i===s)){if(a<h)do{E(e,i,e.bl_tree);}while(0!=--a);else 0!==i?(i!==o&&(E(e,i,e.bl_tree),a--),E(e,16,e.bl_tree),B(e,a-3,2)):a<=10?(E(e,17,e.bl_tree),B(e,a-3,3)):(E(e,18,e.bl_tree),B(e,a-11,7));a=0,o=i,0===s?(f=138,h=3):i===s?(f=6,h=3):(f=7,h=4);}}i(y);var T=!1;function U(e,t,r,i){B(e,0+(i?1:0),3),function(e,t,r,i){R(e),_(e,r),_(e,~r),n.arraySet(e.pending_buf,e.window,t,r,e.pending),e.pending+=r;}(e,t,r);}t._tr_init=function(e){T||(function(){var e,t,r,n,i,f=new Array(16);for(r=0,n=0;n<28;n++)for(d[n]=r,e=0;e<1<<o[n];e++)c[r++]=n;for(c[r-1]=n,i=0,n=0;n<16;n++)for(y[n]=i,e=0;e<1<<s[n];e++)u[i++]=n;for(i>>=7;n<30;n++)for(y[n]=i<<7,e=0;e<1<<s[n]-7;e++)u[256+i++]=n;for(t=0;t<=15;t++)f[t]=0;for(e=0;e<=143;)h[2*e+1]=8,e++,f[8]++;for(;e<=255;)h[2*e+1]=9,e++,f[9]++;for(;e<=279;)h[2*e+1]=7,e++,f[7]++;for(;e<=287;)h[2*e+1]=8,e++,f[8]++;for(A(h,287,f),e=0;e<30;e++)l[2*e+1]=5,l[2*e]=S(e,5);p=new b(h,o,257,286,15),g=new b(l,s,0,30,15),m=new b(new Array(0),a,0,19,7);}(),T=!0),e.l_desc=new v(e.dyn_ltree,p),e.d_desc=new v(e.dyn_dtree,g),e.bl_desc=new v(e.bl_tree,m),e.bi_buf=0,e.bi_valid=0,C(e);},t._tr_stored_block=U,t._tr_flush_block=function(e,t,r,n){var i,o,s=0;e.level>0?(2===e.strm.data_type&&(e.strm.data_type=function(e){var t,r=4093624447;for(t=0;t<=31;t++,r>>>=1)if(1&r&&0!==e.dyn_ltree[2*t])return 0;if(0!==e.dyn_ltree[18]||0!==e.dyn_ltree[20]||0!==e.dyn_ltree[26])return 1;for(t=32;t<256;t++)if(0!==e.dyn_ltree[2*t])return 1;return 0}(e)),M(e,e.l_desc),M(e,e.d_desc),s=function(e){var t;for(F(e,e.dyn_ltree,e.l_desc.max_code),F(e,e.dyn_dtree,e.d_desc.max_code),M(e,e.bl_desc),t=18;t>=3&&0===e.bl_tree[2*f[t]+1];t--);return e.opt_len+=3*(t+1)+5+5+4,t}(e),i=e.opt_len+3+7>>>3,(o=e.static_len+3+7>>>3)<=i&&(i=o)):i=o=r+5,r+4<=i&&-1!==t?U(e,t,r,n):4===e.strategy||o===i?(B(e,2+(n?1:0),3),I(e,h,l)):(B(e,4+(n?1:0),3),function(e,t,r,n){var i;for(B(e,t-257,5),B(e,r-1,5),B(e,n-4,4),i=0;i<n;i++)B(e,e.bl_tree[2*f[i]+1],3);O(e,e.dyn_ltree,t-1),O(e,e.dyn_dtree,r-1);}(e,e.l_desc.max_code+1,e.d_desc.max_code+1,s+1),I(e,e.dyn_ltree,e.dyn_dtree)),C(e),n&&R(e);},t._tr_tally=function(e,t,r){return e.pending_buf[e.d_buf+2*e.last_lit]=t>>>8&255,e.pending_buf[e.d_buf+2*e.last_lit+1]=255&t,e.pending_buf[e.l_buf+e.last_lit]=255&r,e.last_lit++,0===t?e.dyn_ltree[2*r]++:(e.matches++,t--,e.dyn_ltree[2*(c[r]+256+1)]++,e.dyn_dtree[2*w(t)]++),e.last_lit===e.lit_bufsize-1},t._tr_align=function(e){B(e,2,3),E(e,256,h),function(e){16===e.bi_valid?(_(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):e.bi_valid>=8&&(e.pending_buf[e.pending++]=255&e.bi_buf,e.bi_buf>>=8,e.bi_valid-=8);}(e);};},2292:e=>{e.exports=function(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0;};},2587:e=>{function t(e,t){return Object.prototype.hasOwnProperty.call(e,t)}e.exports=function(e,r,n,i){r=r||"&",n=n||"=";var o={};if("string"!=typeof e||0===e.length)return o;var s=/\+/g;e=e.split(r);var a=1e3;i&&"number"==typeof i.maxKeys&&(a=i.maxKeys);var f=e.length;a>0&&f>a&&(f=a);for(var h=0;h<f;++h){var l,u,c,d,p=e[h].replace(s,"%20"),g=p.indexOf(n);g>=0?(l=p.substr(0,g),u=p.substr(g+1)):(l=p,u=""),c=decodeURIComponent(l),d=decodeURIComponent(u),t(o,c)?Array.isArray(o[c])?o[c].push(d):o[c]=[o[c],d]:o[c]=d;}return o};},2361:e=>{var t=function(e){switch(typeof e){case"string":return e;case"boolean":return e?"true":"false";case"number":return isFinite(e)?e:"";default:return ""}};e.exports=function(e,r,n,i){return r=r||"&",n=n||"=",null===e&&(e=void 0),"object"==typeof e?Object.keys(e).map((function(i){var o=encodeURIComponent(t(i))+n;return Array.isArray(e[i])?e[i].map((function(e){return o+encodeURIComponent(t(e))})).join(r):o+encodeURIComponent(t(e[i]))})).join(r):i?encodeURIComponent(t(i))+n+encodeURIComponent(t(e)):""};},7673:(e,t,r)=>{t.decode=t.parse=r(2587),t.encode=t.stringify=r(2361);},1269:e=>{class t{constructor(e={}){if(!(e.maxSize&&e.maxSize>0))throw new TypeError("`maxSize` must be a number greater than 0");this.maxSize=e.maxSize,this.cache=new Map,this.oldCache=new Map,this._size=0;}_set(e,t){this.cache.set(e,t),this._size++,this._size>=this.maxSize&&(this._size=0,this.oldCache=this.cache,this.cache=new Map);}get(e){if(this.cache.has(e))return this.cache.get(e);if(this.oldCache.has(e)){const t=this.oldCache.get(e);return this.oldCache.delete(e),this._set(e,t),t}}set(e,t){return this.cache.has(e)?this.cache.set(e,t):this._set(e,t),this}has(e){return this.cache.has(e)||this.oldCache.has(e)}peek(e){return this.cache.has(e)?this.cache.get(e):this.oldCache.has(e)?this.oldCache.get(e):void 0}delete(e){const t=this.cache.delete(e);return t&&this._size--,this.oldCache.delete(e)||t}clear(){this.cache.clear(),this.oldCache.clear(),this._size=0;}*keys(){for(const[e]of this)yield e;}*values(){for(const[,e]of this)yield e;}*[Symbol.iterator](){for(const e of this.cache)yield e;for(const e of this.oldCache){const[t]=e;this.cache.has(t)||(yield e);}}get size(){let e=0;for(const t of this.oldCache.keys())this.cache.has(t)||e++;return this._size+e}}e.exports=t;},2511:function(e,t,r){var n;e=r.nmd(e),function(i){t&&t.nodeType,e&&e.nodeType;var o="object"==typeof r.g&&r.g;o.global!==o&&o.window!==o&&o.self;var s,a=2147483647,f=36,h=/^xn--/,l=/[^\x20-\x7E]/,u=/[\x2E\u3002\uFF0E\uFF61]/g,c={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},d=Math.floor,p=String.fromCharCode;function g(e){throw RangeError(c[e])}function m(e,t){for(var r=e.length,n=[];r--;)n[r]=t(e[r]);return n}function y(e,t){var r=e.split("@"),n="";return r.length>1&&(n=r[0]+"@",e=r[1]),n+m((e=e.replace(u,".")).split("."),t).join(".")}function b(e){for(var t,r,n=[],i=0,o=e.length;i<o;)(t=e.charCodeAt(i++))>=55296&&t<=56319&&i<o?56320==(64512&(r=e.charCodeAt(i++)))?n.push(((1023&t)<<10)+(1023&r)+65536):(n.push(t),i--):n.push(t);return n}function v(e){return m(e,(function(e){var t="";return e>65535&&(t+=p((e-=65536)>>>10&1023|55296),e=56320|1023&e),t+p(e)})).join("")}function w(e,t){return e+22+75*(e<26)-((0!=t)<<5)}function _(e,t,r){var n=0;for(e=r?d(e/700):e>>1,e+=d(e/t);e>455;n+=f)e=d(e/35);return d(n+36*e/(e+38))}function B(e){var t,r,n,i,o,s,h,l,u,c,p,m=[],y=e.length,b=0,w=128,B=72;for((r=e.lastIndexOf("-"))<0&&(r=0),n=0;n<r;++n)e.charCodeAt(n)>=128&&g("not-basic"),m.push(e.charCodeAt(n));for(i=r>0?r+1:0;i<y;){for(o=b,s=1,h=f;i>=y&&g("invalid-input"),((l=(p=e.charCodeAt(i++))-48<10?p-22:p-65<26?p-65:p-97<26?p-97:f)>=f||l>d((a-b)/s))&&g("overflow"),b+=l*s,!(l<(u=h<=B?1:h>=B+26?26:h-B));h+=f)s>d(a/(c=f-u))&&g("overflow"),s*=c;B=_(b-o,t=m.length+1,0==o),d(b/t)>a-w&&g("overflow"),w+=d(b/t),b%=t,m.splice(b++,0,w);}return v(m)}function E(e){var t,r,n,i,o,s,h,l,u,c,m,y,v,B,E,S=[];for(y=(e=b(e)).length,t=128,r=0,o=72,s=0;s<y;++s)(m=e[s])<128&&S.push(p(m));for(n=i=S.length,i&&S.push("-");n<y;){for(h=a,s=0;s<y;++s)(m=e[s])>=t&&m<h&&(h=m);for(h-t>d((a-r)/(v=n+1))&&g("overflow"),r+=(h-t)*v,t=h,s=0;s<y;++s)if((m=e[s])<t&&++r>a&&g("overflow"),m==t){for(l=r,u=f;!(l<(c=u<=o?1:u>=o+26?26:u-o));u+=f)E=l-c,B=f-c,S.push(p(w(c+E%B,0))),l=d(E/B);S.push(p(w(l,0))),o=_(r,v,n==i),r=0,++n;}++r,++t;}return S.join("")}s={version:"1.3.2",ucs2:{decode:b,encode:v},decode:B,encode:E,toASCII:function(e){return y(e,(function(e){return l.test(e)?"xn--"+E(e):e}))},toUnicode:function(e){return y(e,(function(e){return h.test(e)?B(e.slice(4).toLowerCase()):e}))}},void 0===(n=function(){return s}.call(t,r,t,e))||(e.exports=n);}();},8575:(e,t,r)=>{var n=r(2511),i=r(2502);function o(){this.protocol=null,this.slashes=null,this.auth=null,this.host=null,this.port=null,this.hostname=null,this.hash=null,this.search=null,this.query=null,this.pathname=null,this.path=null,this.href=null;}t.parse=v,t.resolve=function(e,t){return v(e,!1,!0).resolve(t)},t.resolveObject=function(e,t){return e?v(e,!1,!0).resolveObject(t):t},t.format=function(e){return i.isString(e)&&(e=v(e)),e instanceof o?e.format():o.prototype.format.call(e)},t.Url=o;var s=/^([a-z0-9.+-]+:)/i,a=/:[0-9]*$/,f=/^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/,h=["{","}","|","\\","^","`"].concat(["<",">",'"',"`"," ","\r","\n","\t"]),l=["'"].concat(h),u=["%","/","?",";","#"].concat(l),c=["/","?","#"],d=/^[+a-z0-9A-Z_-]{0,63}$/,p=/^([+a-z0-9A-Z_-]{0,63})(.*)$/,g={javascript:!0,"javascript:":!0},m={javascript:!0,"javascript:":!0},y={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,"http:":!0,"https:":!0,"ftp:":!0,"gopher:":!0,"file:":!0},b=r(7673);function v(e,t,r){if(e&&i.isObject(e)&&e instanceof o)return e;var n=new o;return n.parse(e,t,r),n}o.prototype.parse=function(e,t,r){if(!i.isString(e))throw new TypeError("Parameter 'url' must be a string, not "+typeof e);var o=e.indexOf("?"),a=-1!==o&&o<e.indexOf("#")?"?":"#",h=e.split(a);h[0]=h[0].replace(/\\/g,"/");var v=e=h.join(a);if(v=v.trim(),!r&&1===e.split("#").length){var w=f.exec(v);if(w)return this.path=v,this.href=v,this.pathname=w[1],w[2]?(this.search=w[2],this.query=t?b.parse(this.search.substr(1)):this.search.substr(1)):t&&(this.search="",this.query={}),this}var _=s.exec(v);if(_){var B=(_=_[0]).toLowerCase();this.protocol=B,v=v.substr(_.length);}if(r||_||v.match(/^\/\/[^@\/]+@[^@\/]+/)){var E="//"===v.substr(0,2);!E||_&&m[_]||(v=v.substr(2),this.slashes=!0);}if(!m[_]&&(E||_&&!y[_])){for(var S,A,C=-1,R=0;R<c.length;R++)-1!==(k=v.indexOf(c[R]))&&(-1===C||k<C)&&(C=k);for(-1!==(A=-1===C?v.lastIndexOf("@"):v.lastIndexOf("@",C))&&(S=v.slice(0,A),v=v.slice(A+1),this.auth=decodeURIComponent(S)),C=-1,R=0;R<u.length;R++){var k;-1!==(k=v.indexOf(u[R]))&&(-1===C||k<C)&&(C=k);}-1===C&&(C=v.length),this.host=v.slice(0,C),v=v.slice(C),this.parseHost(),this.hostname=this.hostname||"";var x="["===this.hostname[0]&&"]"===this.hostname[this.hostname.length-1];if(!x)for(var I=this.hostname.split(/\./),M=(R=0,I.length);R<M;R++){var F=I[R];if(F&&!F.match(d)){for(var O="",T=0,U=F.length;T<U;T++)F.charCodeAt(T)>127?O+="x":O+=F[T];if(!O.match(d)){var P=I.slice(0,R),N=I.slice(R+1),L=F.match(p);L&&(P.push(L[1]),N.unshift(L[2])),N.length&&(v="/"+N.join(".")+v),this.hostname=P.join(".");break}}}this.hostname.length>255?this.hostname="":this.hostname=this.hostname.toLowerCase(),x||(this.hostname=n.toASCII(this.hostname));var z=this.port?":"+this.port:"",D=this.hostname||"";this.host=D+z,this.href+=this.host,x&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),"/"!==v[0]&&(v="/"+v));}if(!g[B])for(R=0,M=l.length;R<M;R++){var q=l[R];if(-1!==v.indexOf(q)){var j=encodeURIComponent(q);j===q&&(j=escape(q)),v=v.split(q).join(j);}}var H=v.indexOf("#");-1!==H&&(this.hash=v.substr(H),v=v.slice(0,H));var W=v.indexOf("?");if(-1!==W?(this.search=v.substr(W),this.query=v.substr(W+1),t&&(this.query=b.parse(this.query)),v=v.slice(0,W)):t&&(this.search="",this.query={}),v&&(this.pathname=v),y[B]&&this.hostname&&!this.pathname&&(this.pathname="/"),this.pathname||this.search){z=this.pathname||"";var $=this.search||"";this.path=z+$;}return this.href=this.format(),this},o.prototype.format=function(){var e=this.auth||"";e&&(e=(e=encodeURIComponent(e)).replace(/%3A/i,":"),e+="@");var t=this.protocol||"",r=this.pathname||"",n=this.hash||"",o=!1,s="";this.host?o=e+this.host:this.hostname&&(o=e+(-1===this.hostname.indexOf(":")?this.hostname:"["+this.hostname+"]"),this.port&&(o+=":"+this.port)),this.query&&i.isObject(this.query)&&Object.keys(this.query).length&&(s=b.stringify(this.query));var a=this.search||s&&"?"+s||"";return t&&":"!==t.substr(-1)&&(t+=":"),this.slashes||(!t||y[t])&&!1!==o?(o="//"+(o||""),r&&"/"!==r.charAt(0)&&(r="/"+r)):o||(o=""),n&&"#"!==n.charAt(0)&&(n="#"+n),a&&"?"!==a.charAt(0)&&(a="?"+a),t+o+(r=r.replace(/[?#]/g,(function(e){return encodeURIComponent(e)})))+(a=a.replace("#","%23"))+n},o.prototype.resolve=function(e){return this.resolveObject(v(e,!1,!0)).format()},o.prototype.resolveObject=function(e){if(i.isString(e)){var t=new o;t.parse(e,!1,!0),e=t;}for(var r=new o,n=Object.keys(this),s=0;s<n.length;s++){var a=n[s];r[a]=this[a];}if(r.hash=e.hash,""===e.href)return r.href=r.format(),r;if(e.slashes&&!e.protocol){for(var f=Object.keys(e),h=0;h<f.length;h++){var l=f[h];"protocol"!==l&&(r[l]=e[l]);}return y[r.protocol]&&r.hostname&&!r.pathname&&(r.path=r.pathname="/"),r.href=r.format(),r}if(e.protocol&&e.protocol!==r.protocol){if(!y[e.protocol]){for(var u=Object.keys(e),c=0;c<u.length;c++){var d=u[c];r[d]=e[d];}return r.href=r.format(),r}if(r.protocol=e.protocol,e.host||m[e.protocol])r.pathname=e.pathname;else {for(var p=(e.pathname||"").split("/");p.length&&!(e.host=p.shift()););e.host||(e.host=""),e.hostname||(e.hostname=""),""!==p[0]&&p.unshift(""),p.length<2&&p.unshift(""),r.pathname=p.join("/");}if(r.search=e.search,r.query=e.query,r.host=e.host||"",r.auth=e.auth,r.hostname=e.hostname||e.host,r.port=e.port,r.pathname||r.search){var g=r.pathname||"",b=r.search||"";r.path=g+b;}return r.slashes=r.slashes||e.slashes,r.href=r.format(),r}var v=r.pathname&&"/"===r.pathname.charAt(0),w=e.host||e.pathname&&"/"===e.pathname.charAt(0),_=w||v||r.host&&e.pathname,B=_,E=r.pathname&&r.pathname.split("/")||[],S=(p=e.pathname&&e.pathname.split("/")||[],r.protocol&&!y[r.protocol]);if(S&&(r.hostname="",r.port=null,r.host&&(""===E[0]?E[0]=r.host:E.unshift(r.host)),r.host="",e.protocol&&(e.hostname=null,e.port=null,e.host&&(""===p[0]?p[0]=e.host:p.unshift(e.host)),e.host=null),_=_&&(""===p[0]||""===E[0])),w)r.host=e.host||""===e.host?e.host:r.host,r.hostname=e.hostname||""===e.hostname?e.hostname:r.hostname,r.search=e.search,r.query=e.query,E=p;else if(p.length)E||(E=[]),E.pop(),E=E.concat(p),r.search=e.search,r.query=e.query;else if(!i.isNullOrUndefined(e.search))return S&&(r.hostname=r.host=E.shift(),(x=!!(r.host&&r.host.indexOf("@")>0)&&r.host.split("@"))&&(r.auth=x.shift(),r.host=r.hostname=x.shift())),r.search=e.search,r.query=e.query,i.isNull(r.pathname)&&i.isNull(r.search)||(r.path=(r.pathname?r.pathname:"")+(r.search?r.search:"")),r.href=r.format(),r;if(!E.length)return r.pathname=null,r.search?r.path="/"+r.search:r.path=null,r.href=r.format(),r;for(var A=E.slice(-1)[0],C=(r.host||e.host||E.length>1)&&("."===A||".."===A)||""===A,R=0,k=E.length;k>=0;k--)"."===(A=E[k])?E.splice(k,1):".."===A?(E.splice(k,1),R++):R&&(E.splice(k,1),R--);if(!_&&!B)for(;R--;R)E.unshift("..");!_||""===E[0]||E[0]&&"/"===E[0].charAt(0)||E.unshift(""),C&&"/"!==E.join("/").substr(-1)&&E.push("");var x,I=""===E[0]||E[0]&&"/"===E[0].charAt(0);return S&&(r.hostname=r.host=I?"":E.length?E.shift():"",(x=!!(r.host&&r.host.indexOf("@")>0)&&r.host.split("@"))&&(r.auth=x.shift(),r.host=r.hostname=x.shift())),(_=_||r.host&&E.length)&&!I&&E.unshift(""),E.length?r.pathname=E.join("/"):(r.pathname=null,r.path=null),i.isNull(r.pathname)&&i.isNull(r.search)||(r.path=(r.pathname?r.pathname:"")+(r.search?r.search:"")),r.auth=e.auth||r.auth,r.slashes=r.slashes||e.slashes,r.href=r.format(),r},o.prototype.parseHost=function(){var e=this.host,t=a.exec(e);t&&(":"!==(t=t[0])&&(this.port=t.substr(1)),e=e.substr(0,e.length-t.length)),e&&(this.hostname=e);};},2502:e=>{e.exports={isString:function(e){return "string"==typeof e},isObject:function(e){return "object"==typeof e&&null!==e},isNull:function(e){return null===e},isNullOrUndefined:function(e){return null==e}};},7067:()=>{}},t={};function r(n){var i=t[n];if(void 0!==i)return i.exports;var o=t[n]={id:n,loaded:!1,exports:{}};return e[n].call(o.exports,o,o.exports,r),o.loaded=!0,o.exports}r.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return r.d(t,{a:t}),t},r.d=(e,t)=>{for(var n in t)r.o(t,n)&&!r.o(e,n)&&Object.defineProperty(e,n,{enumerable:!0,get:t[n]});},r.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),r.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),r.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0});},r.nmd=e=>(e.paths=[],e.children||(e.children=[]),e);var n=r(5590);
      //window.gmodCRAM=n
      return n;
  };

  const gmodCRAM = fn();

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2018 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const READ_STRAND_FLAG = 0x10;
  const MATE_STRAND_FLAG = 0x20;

  const CRAM_MATE_STRAND_FLAG = 0x1;

  /**
   * Class for reading a cram file.  Wraps the gMOD Cram package.
   *
   * @param config
   * @constructor
   */
  class CramReader {

      constructor(config, genome, browser) {

          this.config = config;
          this.browser = browser;
          this.genome = genome;

          this.cramFile = new gmodCRAM.CramFile({
              filehandle: new FileHandler(config.url, config),
              seqFetch: config.seqFetch || seqFetch.bind(this),
              checkSequenceMD5: config.checkSequenceMD5 !== undefined ? config.checkSequenceMD5 : true
          });

          const indexFileHandle = new FileHandler(config.indexURL, config);
          this.indexedCramFile = new gmodCRAM.IndexedCramFile({
              cram: this.cramFile,
              index: new gmodCRAM.CraiIndex({
                  filehandle: indexFileHandle
              }),
              fetchSizeLimit: 30000000
          });

          BamUtils.setReaderDefaults(this, config);

          function seqFetch(seqID, start, end) {

              const sequence = this.genome.sequence;
              const genome = this.genome;

              return this.getHeader()
                  .then(function (header) {
                      const chr = genome.getChromosomeName(header.chrNames[seqID]);
                      return sequence.getSequence(chr, start - 1, end)
                  })
          }
      }


      /**
       * Parse the sequence dictionary from the SAM header and build chr name tables.  This function
       * is public so it can be unit tested.
       *
       * @returns {PromiseLike<chrName, chrToIndex, chrAliasTable}>}
       */

      async getHeader() {

          if (!this.header) {
              const genome = this.genome;
              const samHeader = await this.cramFile.getSamHeader();
              const chrToIndex = {};
              const chrNames = [];
              const chrAliasTable = {};
              const readGroups = [];

              for (let line of samHeader) {
                  if ('SQ' === line.tag) {
                      for (let d of line.data) {
                          if (d.tag === "SN") {
                              const seq = d.value;
                              chrToIndex[seq] = chrNames.length;
                              chrNames.push(seq);
                              if (genome) {
                                  const alias = genome.getChromosomeName(seq);
                                  chrAliasTable[alias] = seq;
                              }
                              break
                          }
                      }
                  } else if ('RG' === line.tag) {
                      readGroups.push(line.data);
                  }
              }

              this.header = {
                  chrNames: chrNames,
                  chrToIndex: chrToIndex,
                  chrAliasTable: chrAliasTable,
                  readGroups: readGroups
              };
          }

          return this.header
      }

      async readAlignments(chr, bpStart, bpEnd) {

          this.browser;
          const header = await this.getHeader();
          const queryChr = header.chrAliasTable.hasOwnProperty(chr) ? header.chrAliasTable[chr] : chr;
          const chrIdx = header.chrToIndex[queryChr];
          const alignmentContainer = new AlignmentContainer(chr, bpStart, bpEnd, this.config);

          if (chrIdx === undefined) {
              return alignmentContainer

          } else {

              try {
                  const records = await this.indexedCramFile.getRecordsForRange(chrIdx, bpStart, bpEnd);

                  for (let record of records) {

                      const refID = record.sequenceId;
                      const pos = record.alignmentStart;
                      const alignmentEnd = pos + record.lengthOnRef;

                      if (refID < 0) {
                          continue   // unmapped read
                      } else if (refID > chrIdx || pos > bpEnd) {
                          return    // off right edge, we're done
                      } else if (refID < chrIdx) {
                          continue   // Sequence to left of start, not sure this is possible
                      }
                      if (alignmentEnd < bpStart) {
                          continue
                      }  // Record out-of-range "to the left", skip to next one

                      const alignment = decodeCramRecord(record, header.chrNames);

                      if (this.filter.pass(alignment)) {
                          alignmentContainer.push(alignment);
                      }
                  }

                  alignmentContainer.finish();
                  return alignmentContainer
              } catch (error) {
                  let message = error.message;
                  if (message && message.indexOf("MD5") >= 0) {
                      message = "Sequence mismatch. Is this the correct genome for the loaded CRAM?";
                  }
                  this.browser.alert.present(new Error(message));
                  throw error
              }
          }

          function decodeCramRecord(record, chrNames) {

              const alignment = new BamAlignment();

              alignment.chr = chrNames[record.sequenceId];
              alignment.start = record.alignmentStart - 1;
              alignment.lengthOnRef = record.lengthOnRef;
              alignment.flags = record.flags;
              alignment.strand = !(record.flags & READ_STRAND_FLAG);
              alignment.fragmentLength = record.templateLength || record.templateSize;
              alignment.mq = record.mappingQuality;
              alignment.end = record.alignmentStart + record.lengthOnRef;
              alignment.readGroupId = record.readGroupId;

              if (record.mate && record.mate.sequenceId !== undefined) {
                  const strand = record.mate.flags !== undefined ?
                      !(record.mate.flags & CRAM_MATE_STRAND_FLAG) :
                      !(record.flags & MATE_STRAND_FLAG);

                  alignment.mate = {
                      chr: chrNames[record.mate.sequenceId],
                      position: record.mate.alignmentStart,
                      strand: strand
                  };
              }

              alignment.seq = record.getReadBases();
              alignment.qual = record.qualityScores;
              alignment.tagDict = record.tags;
              alignment.readName = record.readName;

              // TODO -- cigar encoded in tag?
              // BamUtils.bam_tag2cigar(ba, blockEnd, p, lseq, alignment, cigarArray);

              makeBlocks(record, alignment);

              if (alignment.mate && alignment.start > alignment.mate.position && alignment.fragmentLength > 0) {
                  alignment.fragmentLength = -alignment.fragmentLength;
              }

              BamUtils.setPairOrientation(alignment);

              return alignment

          }

          function makeBlocks(cramRecord, alignment) {

              const blocks = [];
              let insertions;
              let gaps;
              let basesUsed = 0;
              let cigarString = '';

              alignment.scStart = alignment.start;
              alignment.scLengthOnRef = alignment.lengthOnRef;

              if (cramRecord.readFeatures) {

                  for (let feature of cramRecord.readFeatures) {

                      const code = feature.code;
                      const data = feature.data;
                      const readPos = feature.pos - 1;
                      const refPos = feature.refPos - 1;

                      switch (code) {
                          case 'S' :
                          case 'I':
                          case 'i':
                          case 'N':
                          case 'D':
                              if (readPos > basesUsed) {
                                  const len = readPos - basesUsed;
                                  blocks.push(new AlignmentBlock({
                                      start: refPos - len,
                                      seqOffset: basesUsed,
                                      len: len,
                                      type: 'M'
                                  }));
                                  basesUsed += len;
                                  cigarString += len + 'M';
                              }

                              if ('S' === code) {
                                  let scPos = refPos;
                                  alignment.scLengthOnRef += data.length;
                                  if (readPos === 0) {
                                      alignment.scStart -= data.length;
                                      scPos -= data.length;
                                  }
                                  const len = data.length;
                                  blocks.push(new AlignmentBlock({
                                      start: scPos,
                                      seqOffset: basesUsed,
                                      len: len,
                                      type: 'S'
                                  }));
                                  basesUsed += len;
                                  cigarString += len + code;
                              } else if ('I' === code || 'i' === code) {
                                  if (insertions === undefined) {
                                      insertions = [];
                                  }
                                  const len = 'i' === code ? 1 : data.length;
                                  insertions.push(new AlignmentBlock({
                                      start: refPos,
                                      len: len,
                                      seqOffset: basesUsed,
                                      type: 'I'
                                  }));
                                  basesUsed += len;
                                  cigarString += len + code;
                              } else if ('D' === code || 'N' === code) {
                                  if (!gaps) {
                                      gaps = [];
                                  }
                                  gaps.push({
                                      start: refPos,
                                      len: data,
                                      type: code
                                  });
                                  cigarString += data + code;
                              }
                              break

                          case 'H':
                          case 'P':
                              cigarString += data + code;
                              break
                          //  Ignore
                      }
                  }
              }

              // Last block
              const len = cramRecord.readLength - basesUsed;
              if (len > 0) {
                  blocks.push(new AlignmentBlock({
                      start: cramRecord.alignmentStart + cramRecord.lengthOnRef - len - 1,
                      seqOffset: basesUsed,
                      len: len,
                      type: 'M'
                  }));

                  cigarString += len + 'M';
              }

              alignment.blocks = blocks;
              alignment.insertions = insertions;
              alignment.gaps = gaps;
              alignment.cigar = cigarString;

          }

      }
  }

  class FileHandler {

      constructor(source, config) {
          this.position = 0;
          this.url = source;
          this.config = config;
          this.cache = new BufferCache({
              fetch: (start, length) => this._fetch(start, length),
          });
      }

      async _fetch(position, length) {

          const loadRange = {start: position, size: length};
          this._stat = {size: undefined};
          const arrayBuffer = await igvxhr$1.loadArrayBuffer(this.url, buildOptions(this.config, {range: loadRange}));
          return Buffer.from(arrayBuffer)
      }

      async read(buffer, offset = 0, length = Infinity, position = 0) {
          let readPosition = position;
          if (readPosition === null) {
              readPosition = this.position;
              this.position += length;
          }
          return this.cache.get(buffer, offset, length, position)
      }

      async readFile() {
          const arrayBuffer = await igvxhr$1.loadArrayBuffer(this.url, buildOptions(this.config));
          return Buffer.from(arrayBuffer)
      }

      async stat() {
          if (!this._stat) {
              const buf = Buffer.allocUnsafe(10);
              await this.read(buf, 0, 10, 0);
              if (!this._stat)
                  throw new Error(`unable to determine size of file at ${this.url}`)
          }
          return this._stat
      }
  }

  class BufferCache {

      constructor({fetch, size = 10000000, chunkSize = 32768}) {

          this.fetch = fetch;
          this.chunkSize = chunkSize;
          this.lruCache = new QuickLRU({maxSize: Math.floor(size / chunkSize)});
      }

      async get(outputBuffer, offset, length, position) {
          if (outputBuffer.length < offset + length)
              throw new Error('output buffer not big enough for request')

          // calculate the list of chunks involved in this fetch
          const firstChunk = Math.floor(position / this.chunkSize);
          const lastChunk = Math.floor((position + length) / this.chunkSize);

          // fetch them all as necessary
          const fetches = new Array(lastChunk - firstChunk + 1);
          for (let chunk = firstChunk; chunk <= lastChunk; chunk += 1) {
              fetches[chunk - firstChunk] = this._getChunk(chunk).then(data => ({
                  data,
                  chunkNumber: chunk,
              }));
          }

          // stitch together the response buffer using them
          const chunks = await Promise.all(fetches);
          const chunksOffset = position - chunks[0].chunkNumber * this.chunkSize;
          chunks.forEach(({data, chunkNumber}) => {
              const chunkPositionStart = chunkNumber * this.chunkSize;
              let copyStart = 0;
              let copyEnd = this.chunkSize;
              let copyOffset =
                  offset + (chunkNumber - firstChunk) * this.chunkSize - chunksOffset;

              if (chunkNumber === firstChunk) {
                  copyOffset = offset;
                  copyStart = chunksOffset;
              }
              if (chunkNumber === lastChunk) {
                  copyEnd = position + length - chunkPositionStart;
              }

              data.copy(outputBuffer, copyOffset, copyStart, copyEnd);
          });
      }

      _getChunk(chunkNumber) {
          const cachedPromise = this.lruCache.get(chunkNumber);
          if (cachedPromise) return cachedPromise

          const freshPromise = this.fetch(
              chunkNumber * this.chunkSize,
              this.chunkSize,
          );
          this.lruCache.set(chunkNumber, freshPromise);
          return freshPromise
      }
  }

  class QuickLRU {
      constructor(options = {}) {
          if (!(options.maxSize && options.maxSize > 0)) {
              throw new TypeError('`maxSize` must be a number greater than 0')
          }

          this.maxSize = options.maxSize;
          this.cache = new Map();
          this.oldCache = new Map();
          this._size = 0;
      }

      _set(key, value) {
          this.cache.set(key, value);
          this._size++;

          if (this._size >= this.maxSize) {
              this._size = 0;
              this.oldCache = this.cache;
              this.cache = new Map();
          }
      }

      get(key) {
          if (this.cache.has(key)) {
              return this.cache.get(key)
          }

          if (this.oldCache.has(key)) {
              const value = this.oldCache.get(key);
              this._set(key, value);
              return value
          }
      }

      set(key, value) {
          if (this.cache.has(key)) {
              this.cache.set(key, value);
          } else {
              this._set(key, value);
          }

          return this
      }

      has(key) {
          return this.cache.has(key) || this.oldCache.has(key)
      }

      peek(key) {
          if (this.cache.has(key)) {
              return this.cache.get(key)
          }

          if (this.oldCache.has(key)) {
              return this.oldCache.get(key)
          }
      }

      delete(key) {
          const deleted = this.cache.delete(key);
          if (deleted) {
              this._size--;
          }

          return this.oldCache.delete(key) || deleted
      }

      clear() {
          this.cache.clear();
          this.oldCache.clear();
          this._size = 0;
      }

      * keys() {
          for (const [key] of this) {
              yield key;
          }
      }

      * values() {
          for (const [, value] of this) {
              yield value;
          }
      }

      * [Symbol.iterator]() {
          for (const item of this.cache) {
              yield item;
          }

          for (const item of this.oldCache) {
              const [key] = item;
              if (!this.cache.has(key)) {
                  yield item;
              }
          }
      }

      get size() {
          let oldCacheSize = 0;
          for (const key of this.oldCache.keys()) {
              if (!this.cache.has(key)) {
                  oldCacheSize++;
              }
          }

          return this._size + oldCacheSize
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  var CigarOperationTable = {
      "ALIGNMENT_MATCH": "M",
      "INSERT": "I",
      "DELETE": "D",
      "SKIP": "N",
      "CLIP_SOFT": "S",
      "CLIP_HARD": "H",
      "PAD": "P",
      "SEQUENCE_MATCH": "=",
      "SEQUENCE_MISMATCH": "X"
  };

  const Ga4ghAlignmentReader = function (config, genome) {

      this.config = config;
      this.genome = genome;
      this.url = config.url;
      this.filter = new BamFilter(config.filter);
      this.readGroupSetIds = config.readGroupSetIds;
      this.authKey = config.authKey;   // Might be undefined or nill

      this.samplingWindowSize = config.samplingWindowSize === undefined ? 100 : config.samplingWindowSize;
      this.samplingDepth = config.samplingDepth === undefined ? 1000 : config.samplingDepth;
      if (config.viewAsPairs) {
          this.pairsSupported = true;
      } else {
          this.pairsSupported = config.pairsSupported === undefined ? true : config.pairsSupported;
      }
  };


  Ga4ghAlignmentReader.prototype.readAlignments = function (chr, bpStart, bpEnd) {

      const genome = this.genome;
      const self = this;

      return getChrAliasTable()

          .then(function (chrAliasTable) {

              var queryChr = chrAliasTable.hasOwnProperty(chr) ? chrAliasTable[chr] : chr,
                  readURL = self.url + "/reads/search";

              return ga4ghSearch({
                  url: readURL,
                  body: {
                      "readGroupSetIds": [self.readGroupSetIds],
                      "referenceName": queryChr,
                      "start": bpStart,
                      "end": bpEnd,
                      "pageSize": "10000"
                  },
                  decode: decodeGa4ghReads,
                  results: new AlignmentContainer(chr, bpStart, bpEnd, self.config)
              })
          })


      function getChrAliasTable() {

          if (self.chrAliasTable) {

              return Promise.resolve(self.chrAliasTable)

          } else {

              return self.readMetadata()

                  .then(function (json) {

                      self.chrAliasTable = {};

                      if (genome && json.readGroups && json.readGroups.length > 0) {

                          var referenceSetId = json.readGroups[0].referenceSetId;

                          if (referenceSetId) {

                              // Query for reference names to build an alias table (map of genome ref names -> dataset ref names)
                              var readURL = self.url + "/references/search";

                              return ga4ghSearch({
                                  url: readURL,
                                  body: {
                                      "referenceSetId": referenceSetId
                                  },
                                  decode: function (j) {
                                      return j.references
                                  }
                              })
                                  .then(function (references) {


                                      references.forEach(function (ref) {
                                          var refName = ref.name,
                                              alias = genome.getChromosomeName(refName);
                                          self.chrAliasTable[alias] = refName;
                                      });


                                      return self.chrAliasTable

                                  })
                          } else {

                              // Try hardcoded constants -- workaround for non-compliant data at Google
                              populateChrAliasTable(self.chrAliasTable, self.config.datasetId);

                              return self.chrAliasTable
                          }
                      } else {
                          // No browser object, can't build map.  This can occur when run from unit tests
                          return self.chrAliasTable
                      }
                  })
          }
      }

      /**
       * Decode an array of ga4gh read records
       *

       */
      function decodeGa4ghReads(j) {

          var i,
              jsonRecords = j.alignments,
              len = jsonRecords.length,
              alignment,
              jsonAlignment,
              cigarDecoded,
              alignments = [],
              mate,
              blocks;

          for (i = 0; i < len; i++) {

              let record = jsonRecords[i];

              alignment = new BamAlignment();

              alignment.readName = record.fragmentName;
              alignment.properPlacement = record.properPlacement;
              alignment.duplicateFragment = record.duplicateFragment;
              alignment.numberReads = record.numberReads;
              alignment.fragmentLength = record.fragmentLength;
              alignment.readNumber = record.readNumber;
              alignment.failedVendorQualityChecks = record.failedVendorQualityChecks;
              alignment.secondaryAlignment = record.secondaryAlignment;
              alignment.supplementaryAlignment = record.supplementaryAlignment;
              alignment.seq = record.alignedSequence;
              alignment.qual = record.alignedQuality;
              alignment.matePos = record.nextMatePosition;
              alignment.tagDict = record.info;
              alignment.flags = encodeFlags();


              jsonAlignment = record.alignment;
              if (jsonAlignment) {
                  alignment.mapped = true;

                  alignment.chr = record.alignment.position.referenceName;
                  if (genome) alignment.chr = genome.getChromosomeName(alignment.chr);

                  alignment.start = parseInt(record.alignment.position.position);
                  alignment.strand = !(record.alignment.position.reverseStrand);
                  alignment.mq = record.alignment.mappingQuality;
                  alignment.cigar = encodeCigar(record.alignment.cigar);
                  cigarDecoded = translateCigar(record.alignment.cigar);

                  alignment.lengthOnRef = cigarDecoded.lengthOnRef;

                  blocks = makeBlocks(alignment, cigarDecoded.array);
                  alignment.blocks = blocks.blocks;
                  alignment.insertions = blocks.insertions;

              } else {
                  alignment.mapped = false;
              }

              mate = record.nextMatePosition;
              if (mate) {
                  alignment.mate = {
                      chr: mate.referenceFrame,
                      position: parseInt(mate.position),
                      strand: !mate.reverseStrand
                  };
              }

              if (self.filter.pass(alignment)) {
                  alignments.push(alignment);
              }


          }

          return alignments


          // Encode a cigar string -- used for popup text
          function encodeCigar(cigarArray) {

              var cigarString = "";
              cigarArray.forEach(function (cigarUnit) {
                  var op = CigarOperationTable[cigarUnit.operation],
                      len = cigarUnit.operationLength;
                  cigarString = cigarString + (len + op);
              });

              return cigarString
          }

          // TODO -- implement me
          function encodeFlags(json) {
              return 0
          }

          function translateCigar(cigar) {

              var cigarUnit, opLen, opLtr,
                  lengthOnRef = 0,
                  cigarArray = [],
                  i;

              for (i = 0; i < cigar.length; i++) {

                  cigarUnit = cigar[i];

                  opLtr = CigarOperationTable[cigarUnit.operation];
                  opLen = parseInt(cigarUnit.operationLength);    // Google represents long as a String

                  if (opLtr === 'M' || opLtr === 'EQ' || opLtr === 'X' || opLtr === 'D' || opLtr === 'N' || opLtr === '=')
                      lengthOnRef += opLen;

                  cigarArray.push({len: opLen, ltr: opLtr});

              }

              return {lengthOnRef: lengthOnRef, array: cigarArray}
          }


          /**
           * Split the alignment record into blocks as specified in the cigarArray.  Each aligned block contains
           * its portion of the read sequence and base quality strings.  A read sequence or base quality string
           * of "*" indicates the value is not recorded.  In all other cases the length of the block sequence (block.seq)
           * and quality string (block.qual) must == the block length.
           *
           * NOTE: Insertions are not yet treated // TODO
           *
           * @param record
           * @param cigarArray
           * @returns array of blocks
           */
          function makeBlocks(record, cigarArray) {


              var blocks = [],
                  gaps,
                  insertions,
                  seqOffset = 0,
                  pos = record.start,
                  len = cigarArray.length,
                  gapType;

              for (var i = 0; i < len; i++) {

                  var c = cigarArray[i];

                  switch (c.ltr) {
                      case 'H' :
                          break // ignore hard clips
                      case 'P' :
                          break // ignore pads
                      case 'S' :
                          seqOffset += c.len;
                          gapType = 'S';
                          break // soft clip read bases
                      case 'N' :
                      case 'D' :
                          if (gaps === undefined) {
                              gaps = [];
                          }
                          gaps.push({
                              start: pos,
                              len: c.len,
                              type: c.ltr
                          });
                          pos += c.len;
                          break
                      case 'I' :
                          if (insertions === undefined) insertions = [];
                          insertions.push(new AlignmentBlock({
                              start: pos,
                              len: c.len,
                              seqOffset: seqOffset
                          }));
                          seqOffset += c.len;
                          break
                      case 'M' :
                      case 'EQ' :
                      case '=' :
                      case 'X' :
                          blocks.push(
                              new AlignmentBlock({
                                  start: pos,
                                  len: c.len,
                                  seqOffset: seqOffset,
                                  gapType: gapType
                              }));
                          seqOffset += c.len;
                          pos += c.len;

                          break
                  }
              }

              return {blocks: blocks, insertions: insertions, gaps: gaps}
          }
      }
  };


  Ga4ghAlignmentReader.prototype.readMetadata = function () {

      return ga4ghGet({
          url: this.url,
          entity: "readgroupsets",
          entityId: this.readGroupSetIds
      })
  };

  /**
   * Hardcoded hack to work around some non-compliant google datasets
   *
   * @param chrAliasTable
   * @param datasetId
   */
  function populateChrAliasTable(chrAliasTable, datasetId) {
      var i;
      if ("461916304629" === datasetId || "337315832689" === datasetId) {
          for (i = 1; i < 23; i++) {
              chrAliasTable["chr" + i] = i;
          }
          chrAliasTable["chrX"] = "X";
          chrAliasTable["chrY"] = "Y";
          chrAliasTable["chrM"] = "MT";
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class BamSource {

      constructor(config, browser) {

          const genome = browser.genome;

          this.config = config;
          this.genome = genome;

          if (isDataURL(config.url)) {
              this.config.indexed = false;
          }

          if ("ga4gh" === config.sourceType) {
              this.bamReader = new Ga4ghAlignmentReader(config, genome);
          } else if ("pysam" === config.sourceType) {
              this.bamReader = new BamWebserviceReader(config, genome);
          } else if ("htsget" === config.sourceType) {
              this.bamReader = new HtsgetBamReader(config, genome);
          } else if ("shardedBam" === config.sourceType) {
              this.bamReader = new ShardedBamReader(config, genome);
          } else if ("cram" === config.format) {
              this.bamReader = new CramReader(config, genome, browser);
          } else {
              if (!this.config.indexURL && config.indexed !== false) {
                  if (isString$2(this.config.url)) {
                      const inferIndexPath$1 = inferIndexPath(this.config.url, "bai");
                      if (inferIndexPath$1) {
                          console.error(`Warning: no indexURL specified for ${this.config.url}.  Guessing ${this.baiPath}`);
                          this.config.indexURL = inferIndexPath$1;
                      } else {
                          console.error(`Warning: no indexURL specified for ${this.config.url}.`);
                          this.config.indexed = false;
                      }
                  } else {
                      console.error(`Warning: no indexURL specified for ${this.config.name}.`);
                      this.config.indexed = false;
                  }
              }

              if (this.config.indexed !== false) { // && this.config.indexURL) {
                  this.bamReader = new BamReader(config, genome);
              } else {
                  this.bamReader = new BamReaderNonIndexed(config, genome);
              }
          }

          this.viewAsPairs = config.viewAsPairs;
          this.showSoftClips = config.showSoftClips;
      }

      setViewAsPairs(bool) {
          this.viewAsPairs = bool;
      }

      setShowSoftClips(bool) {
          this.showSoftClips = bool;
      }

      async getAlignments(chr, bpStart, bpEnd) {

          const genome = this.genome;
          const showSoftClips = this.showSoftClips;

          const alignmentContainer = await this.bamReader.readAlignments(chr, bpStart, bpEnd);
          let alignments = alignmentContainer.alignments;
          if (!this.viewAsPairs) {
              alignments = unpairAlignments([{alignments: alignments}]);
          }
          const hasAlignments = alignments.length > 0;
          alignmentContainer.packedAlignmentRows = packAlignmentRows(alignments, alignmentContainer.start, alignmentContainer.end, showSoftClips);

          this.alignmentContainer = alignmentContainer;

          if (hasAlignments) {
              const sequence = await genome.sequence.getSequence(chr, alignmentContainer.start, alignmentContainer.end);
              if (sequence) {
                  alignmentContainer.coverageMap.refSeq = sequence;    // TODO -- fix this
                  alignmentContainer.sequence = sequence;           // TODO -- fix this
                  return alignmentContainer
              } else {
                  console.error("No sequence for: " + chr + ":" + alignmentContainer.start + "-" + alignmentContainer.end);
              }
          }
          return alignmentContainer

      }
  }

  function paintAxis(ctx, pixelWidth, pixelHeight) {

      var x1,
          x2,
          y1,
          y2,
          a,
          b,
          reference,
          shim,
          font = {
              'font': 'normal 10px Arial',
              'textAlign': 'right',
              'strokeStyle': "black"
          };

      if (undefined === this.dataRange || undefined === this.dataRange.max || undefined === this.dataRange.min) {
          return
      }

      let flipAxis = (undefined === this.flipAxis) ? false : this.flipAxis;

      IGVGraphics.fillRect(ctx, 0, 0, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});

      reference = 0.95 * pixelWidth;
      x1 = reference - 8;
      x2 = reference;

      //shim = 0.5 * 0.125;
      shim = .01;
      y1 = y2 = shim * pixelHeight;

      a = {x: x2, y: y1};

      // tick
      IGVGraphics.strokeLine(ctx, x1, y1, x2, y2, font);
      IGVGraphics.fillText(ctx, prettyPrint(flipAxis ? this.dataRange.min : this.dataRange.max), x1 + 4, y1 + 12, font);

      //shim = 0.25 * 0.125;
      y1 = y2 = (1.0 - shim) * pixelHeight;

      b = {x: x2, y: y1};

      // tick
      IGVGraphics.strokeLine(ctx, x1, y1, x2, y2, font);
      IGVGraphics.fillText(ctx, prettyPrint(flipAxis ? this.dataRange.max : this.dataRange.min), x1 + 4, y1 - 4, font);

      IGVGraphics.strokeLine(ctx, a.x, a.y, b.x, b.y, font);

      function prettyPrint(number) {
          // if number >= 100, show whole number
          // if >= 1 show 1 significant digits
          // if <  1 show 2 significant digits

          if (number === 0) {
              return "0"
          } else if (Math.abs(number) >= 10) {
              return number.toFixed()
          } else if (Math.abs(number) >= 1) {
              return number.toFixed(1)
          } else {
              return number.toFixed(2)
          }
      }
  }

  class Locus {

      constructor({chr, start, end}) {
          this.chr = chr;
          this.start = start;
          this.end = end;
      }


      contains(locus) {
          return locus.chr === this.chr && locus.start >= this.start && locus.end <= this.end
      }

      overlaps(locus) {
          return locus.chr === this.chr && !(locus.end < this.start || locus.start > this.end)
      }

      extend(l) {
          if (l.chr !== this.chr) return
          this.start = Math.min(l.start, this.start);
          this.end = Math.max(l.end, this.end);
      }

      getLocusString() {
          if ('all' === this.chr) {
              return 'all'
          } else {
              const ss = numberFormatter$1(Math.floor(this.start) + 1);
              const ee = numberFormatter$1(Math.round(this.end));
              return `${this.chr}:${ss}-${ee}`
          }
      }

      static fromLocusString(str) {
          if ('all' === str) {
              return new Locus({chr: 'all'})
          }
          const parts = str.split(':');
          const chr = parts[0];
          const se = parts[1].split("-");
          const start = Number.parseInt(se[0].replace(/,/g, "")) - 1;
          const end = Number.parseInt(se[1].replace(/,/g, ""));
          return new Locus({chr, start, end})
      }
  }

  /*!
   * vanilla-picker v2.12.1
   * https://vanilla-picker.js.org
   *
   * Copyright 2017-2021 Andreas Borgen (https://github.com/Sphinxxxx), Adam Brooks (https://github.com/dissimulate)
   * Released under the ISC license.
   */
  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var slicedToArray = function () {
    function sliceIterator(arr, i) {
      var _arr = [];
      var _n = true;
      var _d = false;
      var _e = undefined;

      try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"]) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    return function (arr, i) {
      if (Array.isArray(arr)) {
        return arr;
      } else if (Symbol.iterator in Object(arr)) {
        return sliceIterator(arr, i);
      } else {
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      }
    };
  }();

  String.prototype.startsWith = String.prototype.startsWith || function (needle) {
      return this.indexOf(needle) === 0;
  };
  String.prototype.padStart = String.prototype.padStart || function (len, pad) {
      var str = this;while (str.length < len) {
          str = pad + str;
      }return str;
  };

  var colorNames = { cb: '0f8ff', tqw: 'aebd7', q: '-ffff', qmrn: '7fffd4', zr: '0ffff', bg: '5f5dc', bsq: 'e4c4', bck: '---', nch: 'ebcd', b: '--ff', bvt: '8a2be2', brwn: 'a52a2a', brw: 'deb887', ctb: '5f9ea0', hrt: '7fff-', chcT: 'd2691e', cr: '7f50', rnw: '6495ed', crns: '8dc', crms: 'dc143c', cn: '-ffff', Db: '--8b', Dcn: '-8b8b', Dgnr: 'b8860b', Dgr: 'a9a9a9', Dgrn: '-64-', Dkhk: 'bdb76b', Dmgn: '8b-8b', Dvgr: '556b2f', Drng: '8c-', Drch: '9932cc', Dr: '8b--', Dsmn: 'e9967a', Dsgr: '8fbc8f', DsTb: '483d8b', DsTg: '2f4f4f', Dtrq: '-ced1', Dvt: '94-d3', ppnk: '1493', pskb: '-bfff', mgr: '696969', grb: '1e90ff', rbrc: 'b22222', rwht: 'af0', stg: '228b22', chs: '-ff', gnsb: 'dcdcdc', st: '8f8ff', g: 'd7-', gnr: 'daa520', gr: '808080', grn: '-8-0', grnw: 'adff2f', hnw: '0fff0', htpn: '69b4', nnr: 'cd5c5c', ng: '4b-82', vr: '0', khk: '0e68c', vnr: 'e6e6fa', nrb: '0f5', wngr: '7cfc-', mnch: 'acd', Lb: 'add8e6', Lcr: '08080', Lcn: 'e0ffff', Lgnr: 'afad2', Lgr: 'd3d3d3', Lgrn: '90ee90', Lpnk: 'b6c1', Lsmn: 'a07a', Lsgr: '20b2aa', Lskb: '87cefa', LsTg: '778899', Lstb: 'b0c4de', Lw: 'e0', m: '-ff-', mgrn: '32cd32', nn: 'af0e6', mgnt: '-ff', mrn: '8--0', mqm: '66cdaa', mmb: '--cd', mmrc: 'ba55d3', mmpr: '9370db', msg: '3cb371', mmsT: '7b68ee', '': '-fa9a', mtr: '48d1cc', mmvt: 'c71585', mnLb: '191970', ntc: '5fffa', mstr: 'e4e1', mccs: 'e4b5', vjw: 'dead', nv: '--80', c: 'df5e6', v: '808-0', vrb: '6b8e23', rng: 'a5-', rngr: '45-', rch: 'da70d6', pgnr: 'eee8aa', pgrn: '98fb98', ptrq: 'afeeee', pvtr: 'db7093', ppwh: 'efd5', pchp: 'dab9', pr: 'cd853f', pnk: 'c0cb', pm: 'dda0dd', pwrb: 'b0e0e6', prp: '8-080', cc: '663399', r: '--', sbr: 'bc8f8f', rb: '4169e1', sbrw: '8b4513', smn: 'a8072', nbr: '4a460', sgrn: '2e8b57', ssh: '5ee', snn: 'a0522d', svr: 'c0c0c0', skb: '87ceeb', sTb: '6a5acd', sTgr: '708090', snw: 'afa', n: '-ff7f', stb: '4682b4', tn: 'd2b48c', t: '-8080', thst: 'd8bfd8', tmT: '6347', trqs: '40e0d0', vt: 'ee82ee', whT: '5deb3', wht: '', hts: '5f5f5', w: '-', wgrn: '9acd32' };

  function printNum(num) {
      var decs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

      var str = decs > 0 ? num.toFixed(decs).replace(/0+$/, '').replace(/\.$/, '') : num.toString();
      return str || '0';
  }

  var Color = function () {
      function Color(r, g, b, a) {
          classCallCheck(this, Color);


          var that = this;
          function parseString(input) {

              if (input.startsWith('hsl')) {
                  var _input$match$map = input.match(/([\-\d\.e]+)/g).map(Number),
                      _input$match$map2 = slicedToArray(_input$match$map, 4),
                      h = _input$match$map2[0],
                      s = _input$match$map2[1],
                      l = _input$match$map2[2],
                      _a = _input$match$map2[3];

                  if (_a === undefined) {
                      _a = 1;
                  }

                  h /= 360;
                  s /= 100;
                  l /= 100;
                  that.hsla = [h, s, l, _a];
              } else if (input.startsWith('rgb')) {
                  var _input$match$map3 = input.match(/([\-\d\.e]+)/g).map(Number),
                      _input$match$map4 = slicedToArray(_input$match$map3, 4),
                      _r = _input$match$map4[0],
                      _g = _input$match$map4[1],
                      _b = _input$match$map4[2],
                      _a2 = _input$match$map4[3];

                  if (_a2 === undefined) {
                      _a2 = 1;
                  }

                  that.rgba = [_r, _g, _b, _a2];
              } else {
                  if (input.startsWith('#')) {
                      that.rgba = Color.hexToRgb(input);
                  } else {
                      that.rgba = Color.nameToRgb(input) || Color.hexToRgb(input);
                  }
              }
          }

          if (r === undefined) ; else if (Array.isArray(r)) {
              this.rgba = r;
          } else if (b === undefined) {
              var color = r && '' + r;
              if (color) {
                  parseString(color.toLowerCase());
              }
          } else {
              this.rgba = [r, g, b, a === undefined ? 1 : a];
          }
      }

      createClass(Color, [{
          key: 'printRGB',
          value: function printRGB(alpha) {
              var rgb = alpha ? this.rgba : this.rgba.slice(0, 3),
                  vals = rgb.map(function (x, i) {
                  return printNum(x, i === 3 ? 3 : 0);
              });

              return alpha ? 'rgba(' + vals + ')' : 'rgb(' + vals + ')';
          }
      }, {
          key: 'printHSL',
          value: function printHSL(alpha) {
              var mults = [360, 100, 100, 1],
                  suff = ['', '%', '%', ''];

              var hsl = alpha ? this.hsla : this.hsla.slice(0, 3),
                  vals = hsl.map(function (x, i) {
                  return printNum(x * mults[i], i === 3 ? 3 : 1) + suff[i];
              });

              return alpha ? 'hsla(' + vals + ')' : 'hsl(' + vals + ')';
          }
      }, {
          key: 'printHex',
          value: function printHex(alpha) {
              var hex = this.hex;
              return alpha ? hex : hex.substring(0, 7);
          }
      }, {
          key: 'rgba',
          get: function get() {
              if (this._rgba) {
                  return this._rgba;
              }
              if (!this._hsla) {
                  throw new Error('No color is set');
              }

              return this._rgba = Color.hslToRgb(this._hsla);
          },
          set: function set(rgb) {
              if (rgb.length === 3) {
                  rgb[3] = 1;
              }

              this._rgba = rgb;
              this._hsla = null;
          }
      }, {
          key: 'rgbString',
          get: function get() {
              return this.printRGB();
          }
      }, {
          key: 'rgbaString',
          get: function get() {
              return this.printRGB(true);
          }
      }, {
          key: 'hsla',
          get: function get() {
              if (this._hsla) {
                  return this._hsla;
              }
              if (!this._rgba) {
                  throw new Error('No color is set');
              }

              return this._hsla = Color.rgbToHsl(this._rgba);
          },
          set: function set(hsl) {
              if (hsl.length === 3) {
                  hsl[3] = 1;
              }

              this._hsla = hsl;
              this._rgba = null;
          }
      }, {
          key: 'hslString',
          get: function get() {
              return this.printHSL();
          }
      }, {
          key: 'hslaString',
          get: function get() {
              return this.printHSL(true);
          }
      }, {
          key: 'hex',
          get: function get() {
              var rgb = this.rgba,
                  hex = rgb.map(function (x, i) {
                  return i < 3 ? x.toString(16) : Math.round(x * 255).toString(16);
              });

              return '#' + hex.map(function (x) {
                  return x.padStart(2, '0');
              }).join('');
          },
          set: function set(hex) {
              this.rgba = Color.hexToRgb(hex);
          }
      }], [{
          key: 'hexToRgb',
          value: function hexToRgb(input) {

              var hex = (input.startsWith('#') ? input.slice(1) : input).replace(/^(\w{3})$/, '$1F').replace(/^(\w)(\w)(\w)(\w)$/, '$1$1$2$2$3$3$4$4').replace(/^(\w{6})$/, '$1FF');

              if (!hex.match(/^([0-9a-fA-F]{8})$/)) {
                  throw new Error('Unknown hex color; ' + input);
              }

              var rgba = hex.match(/^(\w\w)(\w\w)(\w\w)(\w\w)$/).slice(1).map(function (x) {
                  return parseInt(x, 16);
              });

              rgba[3] = rgba[3] / 255;
              return rgba;
          }
      }, {
          key: 'nameToRgb',
          value: function nameToRgb(input) {

              var hash = input.toLowerCase().replace('at', 'T').replace(/[aeiouyldf]/g, '').replace('ght', 'L').replace('rk', 'D').slice(-5, 4),
                  hex = colorNames[hash];
              return hex === undefined ? hex : Color.hexToRgb(hex.replace(/\-/g, '00').padStart(6, 'f'));
          }
      }, {
          key: 'rgbToHsl',
          value: function rgbToHsl(_ref) {
              var _ref2 = slicedToArray(_ref, 4),
                  r = _ref2[0],
                  g = _ref2[1],
                  b = _ref2[2],
                  a = _ref2[3];

              r /= 255;
              g /= 255;
              b /= 255;

              var max = Math.max(r, g, b),
                  min = Math.min(r, g, b);
              var h = void 0,
                  s = void 0,
                  l = (max + min) / 2;

              if (max === min) {
                  h = s = 0;
              } else {
                  var d = max - min;
                  s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
                  switch (max) {
                      case r:
                          h = (g - b) / d + (g < b ? 6 : 0);break;
                      case g:
                          h = (b - r) / d + 2;break;
                      case b:
                          h = (r - g) / d + 4;break;
                  }

                  h /= 6;
              }

              return [h, s, l, a];
          }
      }, {
          key: 'hslToRgb',
          value: function hslToRgb(_ref3) {
              var _ref4 = slicedToArray(_ref3, 4),
                  h = _ref4[0],
                  s = _ref4[1],
                  l = _ref4[2],
                  a = _ref4[3];

              var r = void 0,
                  g = void 0,
                  b = void 0;

              if (s === 0) {
                  r = g = b = l;
              } else {
                  var hue2rgb = function hue2rgb(p, q, t) {
                      if (t < 0) t += 1;
                      if (t > 1) t -= 1;
                      if (t < 1 / 6) return p + (q - p) * 6 * t;
                      if (t < 1 / 2) return q;
                      if (t < 2 / 3) return p + (q - p) * (2 / 3 - t) * 6;
                      return p;
                  };

                  var q = l < 0.5 ? l * (1 + s) : l + s - l * s,
                      p = 2 * l - q;

                  r = hue2rgb(p, q, h + 1 / 3);
                  g = hue2rgb(p, q, h);
                  b = hue2rgb(p, q, h - 1 / 3);
              }

              var rgba = [r * 255, g * 255, b * 255].map(Math.round);
              rgba[3] = a;

              return rgba;
          }
      }]);
      return Color;
  }();

  var EventBucket = function () {
      function EventBucket() {
          classCallCheck(this, EventBucket);

          this._events = [];
      }

      createClass(EventBucket, [{
          key: 'add',
          value: function add(target, type, handler) {
              target.addEventListener(type, handler, false);
              this._events.push({
                  target: target,
                  type: type,
                  handler: handler
              });
          }
      }, {
          key: 'remove',
          value: function remove(target, type, handler) {
              this._events = this._events.filter(function (e) {
                  var isMatch = true;
                  if (target && target !== e.target) {
                      isMatch = false;
                  }
                  if (type && type !== e.type) {
                      isMatch = false;
                  }
                  if (handler && handler !== e.handler) {
                      isMatch = false;
                  }

                  if (isMatch) {
                      EventBucket._doRemove(e.target, e.type, e.handler);
                  }
                  return !isMatch;
              });
          }
      }, {
          key: 'destroy',
          value: function destroy() {
              this._events.forEach(function (e) {
                  return EventBucket._doRemove(e.target, e.type, e.handler);
              });
              this._events = [];
          }
      }], [{
          key: '_doRemove',
          value: function _doRemove(target, type, handler) {
              target.removeEventListener(type, handler, false);
          }
      }]);
      return EventBucket;
  }();

  function parseHTML(htmlString) {

      var div = document.createElement('div');
      div.innerHTML = htmlString;
      return div.firstElementChild;
  }

  function dragTrack(eventBucket, area, callback) {
      var dragging = false;

      function clamp(val, min, max) {
          return Math.max(min, Math.min(val, max));
      }

      function onMove(e, info, starting) {
          if (starting) {
              dragging = true;
          }
          if (!dragging) {
              return;
          }

          e.preventDefault();

          var bounds = area.getBoundingClientRect(),
              w = bounds.width,
              h = bounds.height,
              x = info.clientX,
              y = info.clientY;

          var relX = clamp(x - bounds.left, 0, w),
              relY = clamp(y - bounds.top, 0, h);

          callback(relX / w, relY / h);
      }

      function onMouse(e, starting) {
          var button = e.buttons === undefined ? e.which : e.buttons;
          if (button === 1) {
              onMove(e, e, starting);
          } else {
              dragging = false;
          }
      }

      function onTouch(e, starting) {
          if (e.touches.length === 1) {
              onMove(e, e.touches[0], starting);
          } else {
              dragging = false;
          }
      }

      eventBucket.add(area, 'mousedown', function (e) {
          onMouse(e, true);
      });
      eventBucket.add(area, 'touchstart', function (e) {
          onTouch(e, true);
      });
      eventBucket.add(window, 'mousemove', onMouse);
      eventBucket.add(area, 'touchmove', onTouch);
      eventBucket.add(window, 'mouseup', function (e) {
          dragging = false;
      });
      eventBucket.add(area, 'touchend', function (e) {
          dragging = false;
      });
      eventBucket.add(area, 'touchcancel', function (e) {
          dragging = false;
      });
  }

  var BG_TRANSP = 'linear-gradient(45deg, lightgrey 25%, transparent 25%, transparent 75%, lightgrey 75%) 0 0 / 2em 2em,\n                   linear-gradient(45deg, lightgrey 25%,       white 25%,       white 75%, lightgrey 75%) 1em 1em / 2em 2em';
  var HUES = 360;

  var EVENT_KEY = 'keydown',
      EVENT_CLICK_OUTSIDE = 'mousedown',
      EVENT_TAB_MOVE = 'focusin';

  function $$2(selector, context) {
      return (context || document).querySelector(selector);
  }

  function stopEvent(e) {

      e.preventDefault();
      e.stopPropagation();
  }
  function onKey(bucket, target, keys, handler, stop) {
      bucket.add(target, EVENT_KEY, function (e) {
          if (keys.indexOf(e.key) >= 0) {
              if (stop) {
                  stopEvent(e);
              }
              handler(e);
          }
      });
  }

  var Picker = function () {
      function Picker(options) {
          classCallCheck(this, Picker);


          this.settings = {

              popup: 'right',
              layout: 'default',
              alpha: true,
              editor: true,
              editorFormat: 'hex',
              cancelButton: false,
              defaultColor: '#0cf'
          };

          this._events = new EventBucket();

          this.onChange = null;

          this.onDone = null;

          this.onOpen = null;

          this.onClose = null;

          this.setOptions(options);
      }

      createClass(Picker, [{
          key: 'setOptions',
          value: function setOptions(options) {
              var _this = this;

              if (!options) {
                  return;
              }
              var settings = this.settings;

              function transfer(source, target, skipKeys) {
                  for (var key in source) {
                      if (skipKeys && skipKeys.indexOf(key) >= 0) {
                          continue;
                      }

                      target[key] = source[key];
                  }
              }

              if (options instanceof HTMLElement) {
                  settings.parent = options;
              } else {

                  if (settings.parent && options.parent && settings.parent !== options.parent) {
                      this._events.remove(settings.parent);
                      this._popupInited = false;
                  }

                  transfer(options, settings);

                  if (options.onChange) {
                      this.onChange = options.onChange;
                  }
                  if (options.onDone) {
                      this.onDone = options.onDone;
                  }
                  if (options.onOpen) {
                      this.onOpen = options.onOpen;
                  }
                  if (options.onClose) {
                      this.onClose = options.onClose;
                  }

                  var col = options.color || options.colour;
                  if (col) {
                      this._setColor(col);
                  }
              }

              var parent = settings.parent;
              if (parent && settings.popup && !this._popupInited) {

                  var openProxy = function openProxy(e) {
                      return _this.openHandler(e);
                  };

                  this._events.add(parent, 'click', openProxy);

                  onKey(this._events, parent, [' ', 'Spacebar', 'Enter'], openProxy);

                  this._popupInited = true;
              } else if (options.parent && !settings.popup) {
                  this.show();
              }
          }
      }, {
          key: 'openHandler',
          value: function openHandler(e) {
              if (this.show()) {

                  e && e.preventDefault();

                  this.settings.parent.style.pointerEvents = 'none';

                  var toFocus = e && e.type === EVENT_KEY ? this._domEdit : this.domElement;
                  setTimeout(function () {
                      return toFocus.focus();
                  }, 100);

                  if (this.onOpen) {
                      this.onOpen(this.colour);
                  }
              }
          }
      }, {
          key: 'closeHandler',
          value: function closeHandler(e) {
              var event = e && e.type;
              var doHide = false;

              if (!e) {
                  doHide = true;
              } else if (event === EVENT_CLICK_OUTSIDE || event === EVENT_TAB_MOVE) {

                  var knownTime = (this.__containedEvent || 0) + 100;
                  if (e.timeStamp > knownTime) {
                      doHide = true;
                  }
              } else {

                  stopEvent(e);

                  doHide = true;
              }

              if (doHide && this.hide()) {
                  this.settings.parent.style.pointerEvents = '';

                  if (event !== EVENT_CLICK_OUTSIDE) {
                      this.settings.parent.focus();
                  }

                  if (this.onClose) {
                      this.onClose(this.colour);
                  }
              }
          }
      }, {
          key: 'movePopup',
          value: function movePopup(options, open) {

              this.closeHandler();

              this.setOptions(options);
              if (open) {
                  this.openHandler();
              }
          }
      }, {
          key: 'setColor',
          value: function setColor(color, silent) {
              this._setColor(color, { silent: silent });
          }
      }, {
          key: '_setColor',
          value: function _setColor(color, flags) {
              if (typeof color === 'string') {
                  color = color.trim();
              }
              if (!color) {
                  return;
              }

              flags = flags || {};
              var c = void 0;
              try {

                  c = new Color(color);
              } catch (ex) {
                  if (flags.failSilently) {
                      return;
                  }
                  throw ex;
              }

              if (!this.settings.alpha) {
                  var hsla = c.hsla;
                  hsla[3] = 1;
                  c.hsla = hsla;
              }
              this.colour = this.color = c;
              this._setHSLA(null, null, null, null, flags);
          }
      }, {
          key: 'setColour',
          value: function setColour(colour, silent) {
              this.setColor(colour, silent);
          }
      }, {
          key: 'show',
          value: function show() {
              var parent = this.settings.parent;
              if (!parent) {
                  return false;
              }

              if (this.domElement) {
                  var toggled = this._toggleDOM(true);

                  this._setPosition();

                  return toggled;
              }

              var html = this.settings.template || '<div class="picker_wrapper" tabindex="-1"><div class="picker_arrow"></div><div class="picker_hue picker_slider"><div class="picker_selector"></div></div><div class="picker_sl"><div class="picker_selector"></div></div><div class="picker_alpha picker_slider"><div class="picker_selector"></div></div><div class="picker_editor"><input aria-label="Type a color name or hex value"/></div><div class="picker_sample"></div><div class="picker_done"><button>Ok</button></div><div class="picker_cancel"><button>Cancel</button></div></div>';
              var wrapper = parseHTML(html);

              this.domElement = wrapper;
              this._domH = $$2('.picker_hue', wrapper);
              this._domSL = $$2('.picker_sl', wrapper);
              this._domA = $$2('.picker_alpha', wrapper);
              this._domEdit = $$2('.picker_editor input', wrapper);
              this._domSample = $$2('.picker_sample', wrapper);
              this._domOkay = $$2('.picker_done button', wrapper);
              this._domCancel = $$2('.picker_cancel button', wrapper);

              wrapper.classList.add('layout_' + this.settings.layout);
              if (!this.settings.alpha) {
                  wrapper.classList.add('no_alpha');
              }
              if (!this.settings.editor) {
                  wrapper.classList.add('no_editor');
              }
              if (!this.settings.cancelButton) {
                  wrapper.classList.add('no_cancel');
              }
              this._ifPopup(function () {
                  return wrapper.classList.add('popup');
              });

              this._setPosition();

              if (this.colour) {
                  this._updateUI();
              } else {
                  this._setColor(this.settings.defaultColor);
              }
              this._bindEvents();

              return true;
          }
      }, {
          key: 'hide',
          value: function hide() {
              return this._toggleDOM(false);
          }
      }, {
          key: 'destroy',
          value: function destroy() {
              this._events.destroy();
              if (this.domElement) {
                  this.settings.parent.removeChild(this.domElement);
              }
          }
      }, {
          key: '_bindEvents',
          value: function _bindEvents() {
              var _this2 = this;

              var that = this,
                  dom = this.domElement,
                  events = this._events;

              function addEvent(target, type, handler) {
                  events.add(target, type, handler);
              }

              addEvent(dom, 'click', function (e) {
                  return e.preventDefault();
              });

              dragTrack(events, this._domH, function (x, y) {
                  return that._setHSLA(x);
              });

              dragTrack(events, this._domSL, function (x, y) {
                  return that._setHSLA(null, x, 1 - y);
              });

              if (this.settings.alpha) {
                  dragTrack(events, this._domA, function (x, y) {
                      return that._setHSLA(null, null, null, 1 - y);
                  });
              }

              var editInput = this._domEdit;
              {
                  addEvent(editInput, 'input', function (e) {
                      that._setColor(this.value, { fromEditor: true, failSilently: true });
                  });

                  addEvent(editInput, 'focus', function (e) {
                      var input = this;

                      if (input.selectionStart === input.selectionEnd) {
                          input.select();
                      }
                  });
              }

              this._ifPopup(function () {

                  var popupCloseProxy = function popupCloseProxy(e) {
                      return _this2.closeHandler(e);
                  };

                  addEvent(window, EVENT_CLICK_OUTSIDE, popupCloseProxy);
                  addEvent(window, EVENT_TAB_MOVE, popupCloseProxy);
                  onKey(events, dom, ['Esc', 'Escape'], popupCloseProxy);

                  var timeKeeper = function timeKeeper(e) {
                      _this2.__containedEvent = e.timeStamp;
                  };
                  addEvent(dom, EVENT_CLICK_OUTSIDE, timeKeeper);

                  addEvent(dom, EVENT_TAB_MOVE, timeKeeper);

                  addEvent(_this2._domCancel, 'click', popupCloseProxy);
              });

              var onDoneProxy = function onDoneProxy(e) {
                  _this2._ifPopup(function () {
                      return _this2.closeHandler(e);
                  });
                  if (_this2.onDone) {
                      _this2.onDone(_this2.colour);
                  }
              };
              addEvent(this._domOkay, 'click', onDoneProxy);
              onKey(events, dom, ['Enter'], onDoneProxy);
          }
      }, {
          key: '_setPosition',
          value: function _setPosition() {
              var parent = this.settings.parent,
                  elm = this.domElement;

              if (parent !== elm.parentNode) {
                  parent.appendChild(elm);
              }

              this._ifPopup(function (popup) {

                  if (getComputedStyle(parent).position === 'static') {
                      parent.style.position = 'relative';
                  }

                  var cssClass = popup === true ? 'popup_right' : 'popup_' + popup;

                  ['popup_top', 'popup_bottom', 'popup_left', 'popup_right'].forEach(function (c) {

                      if (c === cssClass) {
                          elm.classList.add(c);
                      } else {
                          elm.classList.remove(c);
                      }
                  });

                  elm.classList.add(cssClass);
              });
          }
      }, {
          key: '_setHSLA',
          value: function _setHSLA(h, s, l, a, flags) {
              flags = flags || {};

              var col = this.colour,
                  hsla = col.hsla;

              [h, s, l, a].forEach(function (x, i) {
                  if (x || x === 0) {
                      hsla[i] = x;
                  }
              });
              col.hsla = hsla;

              this._updateUI(flags);

              if (this.onChange && !flags.silent) {
                  this.onChange(col);
              }
          }
      }, {
          key: '_updateUI',
          value: function _updateUI(flags) {
              if (!this.domElement) {
                  return;
              }
              flags = flags || {};

              var col = this.colour,
                  hsl = col.hsla,
                  cssHue = 'hsl(' + hsl[0] * HUES + ', 100%, 50%)',
                  cssHSL = col.hslString,
                  cssHSLA = col.hslaString;

              var uiH = this._domH,
                  uiSL = this._domSL,
                  uiA = this._domA,
                  thumbH = $$2('.picker_selector', uiH),
                  thumbSL = $$2('.picker_selector', uiSL),
                  thumbA = $$2('.picker_selector', uiA);

              function posX(parent, child, relX) {
                  child.style.left = relX * 100 + '%';
              }
              function posY(parent, child, relY) {
                  child.style.top = relY * 100 + '%';
              }

              posX(uiH, thumbH, hsl[0]);

              this._domSL.style.backgroundColor = this._domH.style.color = cssHue;

              posX(uiSL, thumbSL, hsl[1]);
              posY(uiSL, thumbSL, 1 - hsl[2]);

              uiSL.style.color = cssHSL;

              posY(uiA, thumbA, 1 - hsl[3]);

              var opaque = cssHSL,
                  transp = opaque.replace('hsl', 'hsla').replace(')', ', 0)'),
                  bg = 'linear-gradient(' + [opaque, transp] + ')';

              this._domA.style.background = bg + ', ' + BG_TRANSP;

              if (!flags.fromEditor) {
                  var format = this.settings.editorFormat,
                      alpha = this.settings.alpha;

                  var value = void 0;
                  switch (format) {
                      case 'rgb':
                          value = col.printRGB(alpha);break;
                      case 'hsl':
                          value = col.printHSL(alpha);break;
                      default:
                          value = col.printHex(alpha);
                  }
                  this._domEdit.value = value;
              }

              this._domSample.style.color = cssHSLA;
          }
      }, {
          key: '_ifPopup',
          value: function _ifPopup(actionIf, actionElse) {
              if (this.settings.parent && this.settings.popup) {
                  actionIf && actionIf(this.settings.popup);
              } else {
                  actionElse && actionElse();
              }
          }
      }, {
          key: '_toggleDOM',
          value: function _toggleDOM(toVisible) {
              var dom = this.domElement;
              if (!dom) {
                  return false;
              }

              var displayStyle = toVisible ? '' : 'none',
                  toggle = dom.style.display !== displayStyle;

              if (toggle) {
                  dom.style.display = displayStyle;
              }
              return toggle;
          }
      }]);
      return Picker;
  }();

  {
      var style = document.createElement('style');
      style.textContent = '.picker_wrapper.no_alpha .picker_alpha{display:none}.picker_wrapper.no_editor .picker_editor{position:absolute;z-index:-1;opacity:0}.picker_wrapper.no_cancel .picker_cancel{display:none}.layout_default.picker_wrapper{display:flex;flex-flow:row wrap;justify-content:space-between;align-items:stretch;font-size:10px;width:25em;padding:.5em}.layout_default.picker_wrapper input,.layout_default.picker_wrapper button{font-size:1rem}.layout_default.picker_wrapper>*{margin:.5em}.layout_default.picker_wrapper::before{content:"";display:block;width:100%;height:0;order:1}.layout_default .picker_slider,.layout_default .picker_selector{padding:1em}.layout_default .picker_hue{width:100%}.layout_default .picker_sl{flex:1 1 auto}.layout_default .picker_sl::before{content:"";display:block;padding-bottom:100%}.layout_default .picker_editor{order:1;width:6.5rem}.layout_default .picker_editor input{width:100%;height:100%}.layout_default .picker_sample{order:1;flex:1 1 auto}.layout_default .picker_done,.layout_default .picker_cancel{order:1}.picker_wrapper{box-sizing:border-box;background:#f2f2f2;box-shadow:0 0 0 1px silver;cursor:default;font-family:sans-serif;color:#444;pointer-events:auto}.picker_wrapper:focus{outline:none}.picker_wrapper button,.picker_wrapper input{box-sizing:border-box;border:none;box-shadow:0 0 0 1px silver;outline:none}.picker_wrapper button:focus,.picker_wrapper button:active,.picker_wrapper input:focus,.picker_wrapper input:active{box-shadow:0 0 2px 1px #1e90ff}.picker_wrapper button{padding:.4em .6em;cursor:pointer;background-color:#f5f5f5;background-image:linear-gradient(0deg, gainsboro, transparent)}.picker_wrapper button:active{background-image:linear-gradient(0deg, transparent, gainsboro)}.picker_wrapper button:hover{background-color:#fff}.picker_selector{position:absolute;z-index:1;display:block;-webkit-transform:translate(-50%, -50%);transform:translate(-50%, -50%);border:2px solid #fff;border-radius:100%;box-shadow:0 0 3px 1px #67b9ff;background:currentColor;cursor:pointer}.picker_slider .picker_selector{border-radius:2px}.picker_hue{position:relative;background-image:linear-gradient(90deg, red, yellow, lime, cyan, blue, magenta, red);box-shadow:0 0 0 1px silver}.picker_sl{position:relative;box-shadow:0 0 0 1px silver;background-image:linear-gradient(180deg, white, rgba(255, 255, 255, 0) 50%),linear-gradient(0deg, black, rgba(0, 0, 0, 0) 50%),linear-gradient(90deg, #808080, rgba(128, 128, 128, 0))}.picker_alpha,.picker_sample{position:relative;background:linear-gradient(45deg, lightgrey 25%, transparent 25%, transparent 75%, lightgrey 75%) 0 0/2em 2em,linear-gradient(45deg, lightgrey 25%, white 25%, white 75%, lightgrey 75%) 1em 1em/2em 2em;box-shadow:0 0 0 1px silver}.picker_alpha .picker_selector,.picker_sample .picker_selector{background:none}.picker_editor input{font-family:monospace;padding:.2em .4em}.picker_sample::before{content:"";position:absolute;display:block;width:100%;height:100%;background:currentColor}.picker_arrow{position:absolute;z-index:-1}.picker_wrapper.popup{position:absolute;z-index:2;margin:1.5em}.picker_wrapper.popup,.picker_wrapper.popup .picker_arrow::before,.picker_wrapper.popup .picker_arrow::after{background:#f2f2f2;box-shadow:0 0 10px 1px rgba(0,0,0,.4)}.picker_wrapper.popup .picker_arrow{width:3em;height:3em;margin:0}.picker_wrapper.popup .picker_arrow::before,.picker_wrapper.popup .picker_arrow::after{content:"";display:block;position:absolute;top:0;left:0;z-index:-99}.picker_wrapper.popup .picker_arrow::before{width:100%;height:100%;-webkit-transform:skew(45deg);transform:skew(45deg);-webkit-transform-origin:0 100%;transform-origin:0 100%}.picker_wrapper.popup .picker_arrow::after{width:150%;height:150%;box-shadow:none}.popup.popup_top{bottom:100%;left:0}.popup.popup_top .picker_arrow{bottom:0;left:0;-webkit-transform:rotate(-90deg);transform:rotate(-90deg)}.popup.popup_bottom{top:100%;left:0}.popup.popup_bottom .picker_arrow{top:0;left:0;-webkit-transform:rotate(90deg) scale(1, -1);transform:rotate(90deg) scale(1, -1)}.popup.popup_left{top:0;right:100%}.popup.popup_left .picker_arrow{top:0;right:0;-webkit-transform:scale(-1, 1);transform:scale(-1, 1)}.popup.popup_right{top:0;left:100%}.popup.popup_right .picker_arrow{top:0;left:0}';
      document.documentElement.firstElementChild.appendChild(style);

      Picker.StyleElement = style;
  }

  function getChrColor$1(chr) {
      if (chrColorMap$1[chr]) {
          return chrColorMap$1[chr];
      } else if (chrColorMap$1["chr" + chr]) {
          const color = chrColorMap$1["chr" + chr];
          chrColorMap$1[chr] = color;
          return color;
      } else {
          const color = randomRGB();
          chrColorMap$1[chr] = color;
          return color;
      }
  }

  function randomRGB (min, max) {

      var r = Math.round(Math.random() * 255).toString(10);
      var g = Math.round(Math.random() * 255).toString(10);
      var b = Math.round(Math.random() * 255).toString(10);
      return "rgb(" + r + "," + g + "," + b + ")";
  }

  const chrColorMap$1 = {
      "chrX": "rgb(204, 153, 0)",
      "chrY": "rgb(153, 204, 0",
      "chrUn": "rgb(50, 50, 50)",
      "chr1": "rgb(80, 80, 255)",
      "chrI": "rgb(139, 155, 187)",
      "chr2": "rgb(206, 61, 50)",
      "chrII": "rgb(206, 61, 50)",
      "chr2a": "rgb(216, 71, 60)",
      "chr2b": "rgb(226, 81, 70)",
      "chr3": "rgb(116, 155, 88)",
      "chrIII": "rgb(116, 155, 88)",
      "chr4": "rgb(240, 230, 133)",
      "chrIV": "rgb(240, 230, 133)",
      "chr5": "rgb(70, 105, 131)",
      "chr6": "rgb(186, 99, 56)",
      "chr7": "rgb(93, 177, 221)",
      "chr8": "rgb(128, 34, 104)",
      "chr9": "rgb(107, 215, 107)",
      "chr10": "rgb(213, 149, 167)",
      "chr11": "rgb(146, 72, 34)",
      "chr12": "rgb(131, 123, 141)",
      "chr13": "rgb(199, 81, 39)",
      "chr14": "rgb(213, 143, 92)",
      "chr15": "rgb(122, 101, 165)",
      "chr16": "rgb(228, 175, 105)",
      "chr17": "rgb(59, 27, 83)",
      "chr18": "rgb(205, 222, 183)",
      "chr19": "rgb(97, 42, 121)",
      "chr20": "rgb(174, 31, 99)",
      "chr21": "rgb(231, 199, 111)",
      "chr22": "rgb(90, 101, 94)",
      "chr23": "rgb(204, 153, 0)",
      "chr24": "rgb(153, 204, 0)",
      "chr25": "rgb(51, 204, 0)",
      "chr26": "rgb(0, 204, 51)",
      "chr27": "rgb(0, 204, 153)",
      "chr28": "rgb(0, 153, 204)",
      "chr29": "rgb(10, 71, 255)",
      "chr30": "rgb(71, 117, 255)",
      "chr31": "rgb(255, 194, 10)",
      "chr32": "rgb(255, 209, 71)",
      "chr33": "rgb(153, 0, 51)",
      "chr34": "rgb(153, 26, 0)",
      "chr35": "rgb(153, 102, 0)",
      "chr36": "rgb(128, 153, 0)",
      "chr37": "rgb(51, 153, 0)",
      "chr38": "rgb(0, 153, 26)",
      "chr39": "rgb(0, 153, 102)",
      "chr40": "rgb(0, 128, 153)",
      "chr41": "rgb(0, 51, 153)",
      "chr42": "rgb(26, 0, 153)",
      "chr43": "rgb(102, 0, 153)",
      "chr44": "rgb(153, 0, 128)",
      "chr45": "rgb(214, 0, 71)",
      "chr46": "rgb(255, 20, 99)",
      "chr47": "rgb(0, 214, 143)",
      "chr48": "rgb(20, 255, 177)",
  };

  class ChordSetManager {

      constructor(config) {
          this.tracks = [];
          this.chordSets = [];
      }

      addChordSet(chordSet) {

          // If a chord set with this name exists replace it (same track, same region)
          this.chordSets = this.chordSets.filter(g => g.name !== chordSet.name);
          this.chordSets.push(chordSet);

          let track = this.tracks.find(t => chordSet.trackName === t.name);
          if (track) {
              track.chordSets = track.chordSets.filter(cs => cs.name !== chordSet.name);
              track.chordSets.push(chordSet);
          }
          if (!track) {
              track = new IGVTrack(chordSet);
              this.tracks.push(track);
          }
      }

      clearChords() {
          this.tracks = [];
          this.chordSets = [];
      }

      getTrack(name) {
          return this.tracks.find(t => name === t.name)
      }

      getChordSet(name) {
          return this.chordSets.find(cs => name === cs.name)
      }

  }

  class IGVTrack {
      constructor(chordSet) {
          this.name = chordSet.trackName;
          this.color = chordSet.trackColor;
          this.visible = true;
          this.chordSets = [chordSet];
          this.id = guid$1$1();
      }

      get chords() {
          if (this.chordSets.length === 1) {
              return this.chordSets[0].chords
          }
          const chords = [];
          for (let cs of this.chordSets) {
              for (let c of cs.chords) {
                  chords.push(c);
              }
          }
          return chords
      }
  }


  function guid$1$1() {
      return ("0000" + (Math.random() * Math.pow(36, 4) << 0).toString(36)).slice(-4)
  }

  const EXP5 = Math.exp(5);

  class CircularView {

      static isInstalled() {
          return window["JBrowseReactCircularGenomeView"] !== undefined && window["React"] !== undefined && window["ReactDOM"] !== undefined
      }

      /**
       * Create a new CircularView
       *
       * @param parent
       * @param config - configuration options
       *   {
       *       assembly: {name: string, id: string, chromosomes: [{name: string, bpLength: integer, color: string}]
       *       onChordClick: function called upon chord click with chord feature as argument
       *   }
       */
      constructor(parent, config) {

          config = config || {};
          this.config = config;

          if (CircularView.isInstalled()) {

              this.parent = parent;
              this.groupByTrack = config.groupByTrack === true;
              this.chordManager = new ChordSetManager(config);

              // wrapper for toolbar and circular-view container
              const wrapper = document.createElement('div');
              wrapper.className = 'igv-circview-container';
              parent.appendChild(wrapper);

              // toolbar
              this.createControls(wrapper);
              this.resetControlPanel();

              // circular view container
              const element = document.createElement('div');
              element.className = 'igv-circview-circular-genome-view';
              wrapper.appendChild(element);
              this.container = element;

              if (config.assembly) {
                  this.setAssembly(config.assembly);
              }

              this.width = config.width || 500;
              this.height = config.height || 500;
              this.setSize(this.width, this.height);

          } else {
              console.error("JBrowse circular view is not installed");
          }
      }

      createControls(parent) {

          // toolbar
          const toolbarDiv = document.createElement('div');
          toolbarDiv.className = 'igv-circview-toolbar';
          parent.appendChild(toolbarDiv);
          this.toolbar = toolbarDiv;

          // control panel
          const controlPanelDiv = document.createElement('div');
          controlPanelDiv.className = 'igv-circview-track-panel';
          parent.appendChild(controlPanelDiv);
          this.controlPanel = controlPanelDiv;
          this.controlPanel.style.display = 'none';


          // toolbar button container - Track Options - Clear All
          const buttonContainer = document.createElement('div');
          buttonContainer.className = 'igv-circview-toolbar-button-container';
          this.toolbar.appendChild(buttonContainer);

          // Show Controls
          this.showControlsButton = document.createElement('div');
          this.showControlsButton.className = 'igv-circview-button';
          buttonContainer.appendChild(this.showControlsButton);
          this.showControlsButton.innerText = 'none' === this.controlPanel.style.display ? 'Show Controls' : 'Hide Controls';
          this.showControlsButton.addEventListener('click', (event) => {
              const panelRows = this.controlPanel.querySelectorAll('div');
              if (panelRows.length > 0) {
                  if ('none' === this.controlPanel.style.display) {
                      this.controlPanel.style.display = 'flex';
                      event.target.innerText = 'Hide Controls';
                  } else {
                      this.controlPanel.style.display = 'none';
                      event.target.innerText = 'Show Controls';
                  }
              }
          });

          // Clear All
          let button = document.createElement('div');
          button.className = 'igv-circview-button';
          buttonContainer.appendChild(button);
          button.innerText = 'Clear All';
          button.addEventListener('click', () => {
              this.clearChords();
          });

          // Close
          if (false !== this.config.showCloseButton) {
              button = document.createElement('div');
              button.className = 'igv-circview-button';
              buttonContainer.appendChild(button);
              button.innerText = 'Close';
              button.addEventListener('click', () => {
                  this.visible = false;
              });
          }
      }

      resetControlPanel() {
          this.controlPanel.innerHTML = '';
          this.controlPanel.appendChild(this.createGroupByCB());
          const chordSets = this.groupByTrack ? this.chordManager.tracks : this.chordManager.chordSets;
          for(let cs of chordSets) {
              this.addToControlPanel(cs);
          }
      }

      createGroupByCB() {
          const groupByCB = document.createElement('input');
          groupByCB.type = 'checkbox';
          groupByCB.id = 'groupByCB';
          groupByCB.style.width = '1.4em';
          groupByCB.style.height = '1.4em';
          groupByCB.checked = this.groupByTrack;

          groupByCB.onclick = (evt) => {
              this.groupByTrack = evt.target.checked;
              this.resetControlPanel();
              this.render();
          };

          const groupByLabel = document.createElement('label');
          groupByLabel.for = 'groupByCB';
          groupByLabel.innerText = 'Group by track';
          groupByLabel.style.color = 'black';
          groupByLabel.style.paddingLeft = '10px';
          const trackPanelRow = document.createElement('div');
          trackPanelRow.style.width = '100%';
          trackPanelRow.style.paddingTop = '5px';
          trackPanelRow.style.paddingBottom = '5px';
          trackPanelRow.style.background = 'rgb(216, 230, 234)';
          trackPanelRow.appendChild(groupByCB);
          trackPanelRow.appendChild(groupByLabel);
          return trackPanelRow
      }

      addToControlPanel(chordSet) {

          // single track row - container for hide-button | color-picker-swatch | track-name
          const row = document.createElement('div');
          this.controlPanel.appendChild(row);


          // track hide|show
          const hideShowButton = document.createElement('div');
          hideShowButton.className = 'igv-circview-button';
          row.appendChild(hideShowButton);
          hideShowButton.innerText = true === chordSet.visible ? 'Hide' : 'Show';
          hideShowButton.addEventListener('click', event => {
              if (true === chordSet.visible) {
                  this.hideChordSet(chordSet.name);
                  event.target.innerText = "Show";
              } else {
                  this.showChordSet(chordSet.name);
                  event.target.innerText = "Hide";
              }
          });

          // The alpha range slider.  Create this here so we can reference it from the color picker
          const alphaSlider = document.createElement('input');
          const valueToAlpha = (value) => Math.exp(value / 200) / EXP5;
          const alphaToValue = (alpha) => 200 * Math.log(alpha * EXP5);

          // color
          const colorPickerButton = document.createElement('div');
          colorPickerButton.className = 'igv-circview-button';
          colorPickerButton.innerHTML = '&nbsp;&nbsp;&nbsp;&nbsp;';   // <- important for button to size properly
          row.appendChild(colorPickerButton);
          colorPickerButton.style.backgroundColor = setAlpha(chordSet.color, 1);
          const pickerConfig =
              {
                  parent: colorPickerButton,
                  popup: 'right',
                  editorFormat: 'rgb',
                  color: chordSet.color,
                  onChange: ({rgbaString}) => {
                      colorPickerButton.style.backgroundColor = setAlpha(rgbaString, 1);
                      this.setColor(chordSet.name, rgbaString);
                      alphaSlider.value = alphaToValue(getAlpha(chordSet.color));
                  }
              };
          const picker = new Picker(pickerConfig);

          // alpha transparency
          alphaSlider.setAttribute('title', 'Adjust transparency of arcs');
          alphaSlider.type = 'range';
          //alphaSlider.className = 'igv-circview-alpha-slider'
          alphaSlider.style.width = '100px';
          alphaSlider.style.marginRight = '10px';
          alphaSlider.setAttribute('class', 'range');
          alphaSlider.setAttribute('min', '0');
          alphaSlider.setAttribute('max', '1000');
          alphaSlider.value = alphaToValue(getAlpha(chordSet.color));
          alphaSlider.oninput = () => {
              const v = valueToAlpha(alphaSlider.value);
              this.setColor(chordSet.name, setAlpha(chordSet.color, v));
              picker.setColor(chordSet.color);
          };
          row.appendChild(alphaSlider);

          // track name
          const trackNameDive = document.createElement('div');
          trackNameDive.style.color = 'black';
          row.appendChild(trackNameDive);
          trackNameDive.innerText = trackNameDive.title = chordSet.name;

      }

      /**
       * Reset view with a new set of chromosomes.
       *
       * @param igvGenome {name: string, id: string, chromosomes: [{name: string, bpLength: integer, color: string}
       */
      setAssembly(igvGenome) {

          const id = this.genomeId || guid$3();

          if (this.genomeId === id) {
              return
          }
          this.chordManager.clearChords();
          this.genomeId = id;
          this.chrNames = new Set(igvGenome.chromosomes.map(chr => shortChrName$1(chr.name)));

          const regions = [];
          const colors = [];
          for (let chr of igvGenome.chromosomes) {
              const shortName = shortChrName$1(chr.name);
              colors.push(chr.color || getChrColor$1(shortName));
              regions.push(
                  {
                      refName: shortName,
                      uniqueId: shortName,
                      start: 0,
                      end: chr.bpLength
                  }
              );
          }

          this.assembly = {
              name: igvGenome.name,
              sequence: {
                  trackId: id,
                  type: 'ReferenceSequenceTrack',
                  adapter: {
                      type: 'FromConfigSequenceAdapter',
                      features: regions,
                  },
              },
              refNameColors: colors
          };

          this.render();

      }

      /**
       * Append or replace current set of chords to the global set or a specific track.
       *
       * @param newChords array of chord feature objects.  Example:
       * [
       *   {
       *     "uniqueId": "chr1:129763372-129763376_chr1:129806775-129806790",
       *     "color": "rgba(0, 0, 255, 0.1)",
       *     "refName": "1",
       *     "start": 129763372,
       *     "end": 129763376,
       *     "mate": {
       *       "refName": "2",
       *       "start": 129806775,
       *       "end": 129806790
       *     }
       *   }
       * ]
       * @param options {
       *     name: string,    // Track name
       *     color: string,   // Track color
       *     append: boolean  // Replace or append chords to current set.  Default is append (true)
       * }
       */

      addChords(newChords, options = {}) {

          const tmp = options.name || options.track || "*";
          const trackName = tmp.split(' ')[0].replaceAll("%20", " ");
          const chordSetName = tmp.replaceAll("%20", " ");

          const chordSet =  {
              name: chordSetName,
              trackName: trackName,
              chords: newChords,
              color: options.color || "black",
              trackColor: options.trackColor || options.color || "black",
              visible: true,
              id: options.id || guid$3()
          };

          this.chordManager.addChordSet(chordSet);

          this.resetControlPanel();

          this.render();
      }

      /**
       * Set the nominal size of the view in pixels.  Size is reduced some aribtrary amount to account for borders and margins
       */
      setSize(width, height) {

          height = height || width;

          this.width = width;
          this.height = height;
          if (this.viewState) {
              const view = this.viewState.session.view;
              view.setWidth(width);
              view.setHeight(height /* this is the height of the area inside the border in pixels */);
              view.setBpPerPx(view.minBpPerPx);
          }
      }

      getSize() {
          return Math.min(this.width, this.height)
      }

      clearChords() {
          //this.tracks = []
          this.chordManager.clearChords();
          this.resetControlPanel();
          this.render();
      }

      clearSelection() {
          this.viewState.pluginManager.rootModel.session.clearSelection();
      }

      /**
       * Deprecated, use "visible" property
       */
      show() {
          this.parent.style.display = 'block';
      }

      /**
       * Deprecated, use "visible" property
       */
      hide() {
          this.parent.style.display = 'none';
      }

      get visible() {
          return this.parent.style.display !== 'none'
      }

      set visible(isVisible) {
          this.parent.style.display = isVisible ? 'block' : 'none';
      }

      hideChordSet(trackName) {
          let cs = this.getChordSet(trackName);
          if (cs) {
              cs.visible = false;
              this.render();
          } else {
              console.warn(`No track with name: ${name}`);
          }
      }

      showChordSet(name) {
          let cs = this.getChordSet(name);
          if (cs) {
              cs.visible = true;
              this.render();
          } else {
              console.warn(`No track with name: ${name}`);
          }
      }

      // showTrack(trackID) {
      //     let idx = this.tracks.findIndex(t => trackID === t.id)
      //     if (idx >= 0) {
      //         const track = this.tracks[idx]
      //         track.visible = true
      //         this.tracks.splice(idx, 1)   // Change z-order
      //         this.tracks.push(track)
      //         this.render()
      //     } else {
      //         console.warn(`No track with name: ${name}`)
      //     }
      // }

      // TODO -- remove corresponding row from track panel
      deleteTrack(trackID) {
          let idx = this.tracks.findIndex(t => trackID === t.name);
          if (idx >= 0) {
              this.tracks.splice(idx, 1);
          }
          this.render();
      }

      getChordSet(name) {
          return this.groupByTrack ? this.chordManager.getTrack(name) : this.chordManager.getChordSet(name)
      }

      setColor(name, color) {
          const t = this.getChordSet(name);
          if (t) {
              t.color = color;
              const trackID = t.id;
              for (let jbrowseTrack of this.viewState.config.tracks) {
                  if (trackID === jbrowseTrack.trackId) {
                      jbrowseTrack.displays[0].renderer.strokeColor.set(color);
                      break
                  }
              }
          }
      }

      /**
       * The main render function.  Render here means build the React DOM.  Trying to change react state dynamically
       * has been buggy, so we completely rebuild the DOM ("render") on any state change.
       */
      render() {

          const {
              createViewState,
              JBrowseCircularGenomeView,
          } = JBrowseReactCircularGenomeView;

          // Remove all children from possible previous renders.  React might do this for us when we render, but just in case.
          ReactDOM.unmountComponentAtNode(this.container);

          const visibleChordSets =
              (this.groupByTrack ? this.chordManager.tracks : this.chordManager.chordSets).filter(t => t.visible);

          const jbrowseTracks = [];
          const colors = [];

          for (let chordSet of visibleChordSets) {

              jbrowseTracks.push({
                  trackId: chordSet.id,
                  name: chordSet.name,
                  assemblyNames: ['forIGV'],
                  type: 'VariantTrack',
                  adapter: {
                      type: 'FromConfigAdapter',
                      features: chordSet.chords,
                  }
              });
              colors.push(chordSet.color);
          }

          this.viewState = createViewState({
              assembly: this.assembly,
              tracks: jbrowseTracks,
          });

          // Set view colors
          for (let i = 0; i < visibleChordSets.length; i++) {
              this.viewState.config.tracks[i].displays[0].renderer.strokeColor.set(colors[i]);
              //this.viewState.config.tracks[i].displays[0].renderer.strokeColor.set("jexl:get(feature, 'color') || 'black'");
              //this.viewState.config.tracks[i].displays[0].renderer.strokeColorSelected.set("jexl:get(feature, 'highlightColor') || 'red'");
          }

          this.element = React.createElement(JBrowseCircularGenomeView, {viewState: this.viewState});
          this.setSize(this.width, this.height);

          ReactDOM.render(this.element, this.container);

          const onChordClick = this.config.onChordClick || defaultOnChordClick;
          for (let i = 0; i < visibleChordSets.length; i++) {
              this.viewState.session.view.showTrack(this.viewState.config.tracks[i].trackId);
              if (onChordClick) {
                  this.viewState.pluginManager.jexl.addFunction('onChordClick', onChordClick);
                  this.viewState.config.tracks[i].displays[0].onChordClick.set(
                      'jexl:onChordClick(feature, track, pluginManager)'
                  );
              }
          }
      }
  }

  function setAlpha(rgba, alpha) {
      const [a, b, c, ignore] = rgba.split(','); // rgba(r g b alpha)
      return `${a},${b},${c},${alpha})`
  }

  function getAlpha(rgba) {
      if (rgba.startsWith("rgba(")) {
          return Number(rgba.split(',')[3].replace(')', ''))
      } else {
          return 1
      }
  }

  function shortChrName$1(chrName) {
      return chrName.startsWith("chr") ? chrName.substring(3) : chrName
  }

  function defaultOnChordClick(feature, chordTrack, pluginManager) {
  }

  function guid$3() {
      return ("0000" + (Math.random() * Math.pow(36, 4) << 0).toString(36)).slice(-4)
  }

  function embedCSS$1() {

      const css =  '.igv-circview-container {\n  width: fit-content;\n  height: fit-content;\n  box-sizing: content-box;\n  color: dimgray;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 12px;\n  background-color: white;\n  border-color: dimgray;\n  border-style: solid;\n  border-width: thin;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n}\n\n.igv-circview-toolbar {\n  position: relative;\n  width: 100%;\n  height: 32px;\n  background-color: lightgrey;\n  border-bottom-style: solid;\n  border-bottom-color: dimgray;\n  border-bottom-width: thin;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center;\n}\n\n.igv-circview-toolbar-button-container {\n  height: 100%;\n  width: fit-content;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-circview-toolbar-button-container > div {\n  margin: 4px;\n}\n\n.igv-circview-track-panel {\n  z-index: 1024;\n  position: absolute;\n  top: 33px;\n  left: 0;\n  width: 100%;\n  height: fit-content;\n  border-bottom-style: solid;\n  border-bottom-color: dimgray;\n  border-bottom-width: thin;\n  background-color: white;\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n}\n.igv-circview-track-panel > div {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-circview-track-panel > div > div {\n  margin: 4px;\n}\n\n.igv-circview-swatch-button {\n  cursor: pointer;\n  padding: 5px;\n  width: 8px;\n  height: 8px;\n  border: 1px solid #8d8b8b;\n  border-radius: 16px;\n}\n\n.igv-circview-button {\n  cursor: pointer;\n  padding: 5px;\n  color: #444;\n  vertical-align: middle;\n  text-align: center;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 12px;\n  border: 1px solid #8d8b8b;\n  border-radius: 4px;\n  background: #efefef;\n  box-shadow: 0 0 5px -1px rgba(0, 0, 0, 0.2);\n}\n\n.igv-circview-button:hover {\n  background: #efefef;\n  box-shadow: 0 0 5px -1px rgba(0, 0, 0, 0.6);\n}\n\n.igv-circview-button:active {\n  color: #007bff;\n  box-shadow: 0 0 5px -1px rgba(0, 0, 0, 0.6);\n}\n\n/*# sourceMappingURL=circular-view.css.map */\n';

      const style = document.createElement('style');
      style.setAttribute('type', 'text/css');
      style.innerHTML = css;
      document.head.insertBefore(style, document.head.childNodes[ document.head.childNodes.length - 1 ]);
  }

  if(typeof document !== 'undefined') {

      if (!stylesheetExists("circular-view.css")) {
          embedCSS$1();
      }

      function stylesheetExists(stylesheetName) {
          for (let ss of document.styleSheets) {
              ss = ss.href ? ss.href.replace(/^.*[\\\/]/, '') : '';
              if (ss === stylesheetName) {
                  return true;
              }
          }
          return false;
      }
  }

  /**
   * The minimum length for a VCF structural variant.  VCF records < this length are ignored in the circular view
   * @type {number}
   */
  const MINIMUM_SV_LENGTH = 1000000;

  const shortChrName = (chrName) => {
      return chrName.startsWith("chr") ? chrName.substring(3) : chrName
  };

  const makePairedAlignmentChords = (alignments) => {

      const chords = [];
      for (let a of alignments) {

          if(a.paired) {
              if(a.firstAlignment && a.secondAlignment) {
                  chords.push({
                      uniqueId: a.readName,
                      refName: shortChrName(a.firstAlignment.chr),
                      start: a.firstAlignment.start,
                      end: a.firstAlignment.end,
                      mate: {
                          refName: shortChrName(a.secondAlignment.chr),
                          start: a.secondAlignment.start,
                          end: a.secondAlignment.end,
                      }
                  });
              }
          }
          else {
              const mate = a.mate;
              if (mate && mate.chr && mate.position) {
                  chords.push({
                      uniqueId: a.readName,
                      refName: shortChrName(a.chr),
                      start: a.start,
                      end: a.end,
                      mate: {
                          refName: shortChrName(mate.chr),
                          start: mate.position - 1,
                          end: mate.position,
                      }
                  });
              }
          }
      }
      return chords
  };

  const makeSupplementalAlignmentChords = (alignments) => {

      const makeChords = (a) => {
          const sa = a.tags()['SA'];
          const supAl = createSupplementaryAlignments(sa);
          let n = 0;
          for (let s of supAl) {
              if (s.start !== a.start) {
                  chords.push({
                      uniqueId: `${a.readName}_${n++}`,
                      refName: shortChrName(a.chr),
                      start: a.start,
                      end: a.end,
                      mate: {
                          refName: shortChrName(s.chr),
                          start: s.start,
                          end: s.start + s.lenOnRef
                      }
                  });
              }
          }
      };

      const chords = [];
      for (let a of alignments) {
          if(a.paired) {
              makeChords(a.firstAlignment);
              if(a.secondAlignment) {
                  makeChords(a.secondAlignment);
              }
          } else {
              makeChords(a);
          }
      }
      return chords
  };

  const makeBedPEChords = (features) => {

      return features.map(v => {

          // If v is a whole-genome feature, get the true underlying variant.
          const f = v._f || v;

          return {
              uniqueId: `${f.chr1}:${f.start1}-${f.end1}_${f.chr2}:${f.start2}-${f.end2}`,
              refName: shortChrName(f.chr1),
              start: f.start1,
              end: f.end1,
              mate: {
                  refName: shortChrName(f.chr2),
                  start: f.start2,
                  end: f.end2,
              }
          }
      })
  };


  const makeVCFChords = (features) => {

      const svFeatures = features.filter(v => {
          const f = v._f || v;
          const isLargeEnough = f.info && f.info.CHR2 && f.info.END &&
              (f.info.CHR2 !== f.chr || Math.abs(Number.parseInt(f.info.END) - f.pos) > MINIMUM_SV_LENGTH);
          return isLargeEnough
      });
      return svFeatures.map(v => {

          // If v is a whole-genome feature, get the true underlying variant.
          const f = v._f || v;

          const pos2 = Number.parseInt(f.info.END);
          const start2 = pos2 - 100;
          const end2 = pos2 + 100;

          return {
              uniqueId: `${f.chr}:${f.start}-${f.end}_${f.info.CHR2}:${f.info.END}`,
              refName: shortChrName(f.chr),
              start: f.start,
              end: f.end,
              mate: {
                  refName: shortChrName(f.info.CHR2),
                  start: start2,
                  end: end2
              }
          }
      })
  };

  function makeCircViewChromosomes(genome) {
      const regions = [];
      const colors = [];
      for (let chrName of genome.wgChromosomeNames) {
          const chr = genome.getChromosome(chrName);
          colors.push(getChrColor(chr.name));
          regions.push(
              {
                  name: chr.name,
                  bpLength: chr.bpLength
              }
          );
      }
      return regions
  }

  function sendChords(chords, track, refFrame, alpha) {

      const baseColor =  track.color || 'rgb(0,0,255)';

      const chordSetColor = IGVColor.addAlpha("all" === refFrame.chr ? baseColor : getChrColor(refFrame.chr), alpha);
      const trackColor = IGVColor.addAlpha(baseColor, alpha);

      // name the chord set to include locus and filtering information
      const encodedName = track.name.replaceAll(' ', '%20');
      const chordSetName = "all" === refFrame.chr ? encodedName :
          `${encodedName}  ${refFrame.chr}:${refFrame.start}-${refFrame.end}`;
      track.browser.circularView.addChords(chords, {track: chordSetName, color: chordSetColor, trackColor: trackColor});

      // show circular view if hidden
      if(!track.browser.circularViewVisible) track.browser.circularViewVisible = true;

  }


  function createCircularView(el, browser) {

      const circularView = new CircularView(el, {

          onChordClick: (feature, chordTrack, pluginManager) => {

              const f1 = feature.data;
              const f2 = f1.mate;
              addFrameForFeature(f1);
              addFrameForFeature(f2);

              function addFrameForFeature(feature) {

                  feature.chr = browser.genome.getChromosomeName(feature.refName);
                  let frameFound = false;
                  for (let referenceFrame of browser.referenceFrameList) {
                      const l = Locus.fromLocusString(referenceFrame.getLocusString());
                      if (l.contains(feature)) {
                          frameFound = true;
                          break
                      } else if (l.overlaps(feature)) {
                          referenceFrame.extend(feature);
                          frameFound = true;
                          break
                      }
                  }
                  if (!frameFound) {
                      const flanking = 2000;
                      const center = (feature.start + feature.end) / 2;
                      browser.addMultiLocusPanel(feature.chr, center - flanking, center + flanking);

                  }
              }
          }
      });

      return circularView
  }

  class PairedEndStats {

      constructor(alignments, {minTLENPercentile, maxTLENPercentile}) {
          this.totalCount = 0;
          this.frCount = 0;
          this.rfCount = 0;
          this.ffCount = 0;
          this.sumF = 0;
          this.sumF2 = 0;
          this.lp = minTLENPercentile === undefined ? 0.1 : minTLENPercentile;
          this.up = maxTLENPercentile === undefined ? 99.5 : maxTLENPercentile;
          this.isizes = [];
          this.compute(alignments);
      }

      compute(alignments) {

          for (let alignment of alignments) {
              if (alignment.isProperPair()) {
                  var tlen = Math.abs(alignment.fragmentLength);
                  this.sumF += tlen;
                  this.sumF2 += tlen * tlen;
                  this.isizes.push(tlen);

                  var po = alignment.pairOrientation;

                  if (typeof po === "string" && po.length === 4) {
                      var tmp = '' + po.charAt(0) + po.charAt(2);
                      switch (tmp) {
                          case 'FF':
                          case 'RR':
                              this.ffCount++;
                              break
                          case "FR":
                              this.frCount++;
                              break
                          case"RF":
                              this.rfCount++;
                      }
                  }
                  this.totalCount++;
              }
          }

          if (this.ffCount / this.totalCount > 0.9) this.orienation = "ff";
          else if (this.frCount / this.totalCount > 0.9) this.orienation = "fr";
          else if (this.rfCount / this.totalCount > 0.9) this.orienation = "rf";

          this.minTLEN = this.lp === 0 ? 0 : percentile(this.isizes, this.lp);
          this.maxTLEN = percentile(this.isizes, this.up);

          // var fMean = this.sumF / this.totalCount
          // var stdDev = Math.sqrt((this.totalCount * this.sumF2 - this.sumF * this.sumF) / (this.totalCount * this.totalCount))
          // this.minTLEN = fMean - 3 * stdDev
          // this.maxTLEN = fMean + 3 * stdDev

      }
  }

  function percentile(array, p) {

      if (array.length === 0) return undefined
      var k = Math.floor(array.length * (p / 100));
      array.sort(function (a, b) {
          return a - b
      });
      return array[k]

  }

  const GtexUtils$1 = {

      getTissueInfo: function (datasetId, baseURL) {
          datasetId = datasetId || 'gtex_v8';
          baseURL = baseURL || 'https://gtexportal.org/rest/v1';
          let url = baseURL + '/dataset/tissueInfo?datasetId=' + datasetId;
          return igvxhr$1.loadJson(url, {})
      },

      //https://gtexportal.org/rest/v1/association/singleTissueEqtlByLocation?chromosome=7&start=98358766&end=101523798&tissueName=Liver&datasetId=gtex_v7
      //https://gtexportal.org/rest/v1/association/singleTissueEqtlByLocation?chromosome=7&start=98358766&end=101523798&tissueSiteDetailId=Liver&datasetId=gtex_v8
      trackConfiguration: function (tissueSummary, baseURL) {
          baseURL = baseURL || 'https://gtexportal.org/rest/v1';
          return {
              type: "eqtl",
              sourceType: "gtex-ws",
              url: baseURL + '/association/singleTissueEqtlByLocation',
              tissueSiteDetailId: tissueSummary.tissueSiteDetailId,
              name: (tissueSummary.tissueSiteDetailId.split('_').join(' ')),
              visibilityWindow: 250000
          }
      }
  };

  /**
   * @param feature
   * @param bpStart  genomic location of the left edge of the current canvas
   * @param xScale  scale in base-pairs per pixel
   * @returns {{px: number, px1: number, pw: number, h: number, py: number}}
   */
  function calculateFeatureCoordinates(feature, bpStart, xScale) {
      let px = (feature.start - bpStart) / xScale;
      let px1 = (feature.end - bpStart) / xScale;
      //px = Math.round((feature.start - bpStart) / xScale),
      //px1 = Math.round((feature.end - bpStart) / xScale),
      let pw = px1 - px;

      if (pw < 3) {
          pw = 3;
          px -= 1.5;
      }

      return {
          px: px,
          px1: px1,
          pw: pw
      }
  }

  /**
   *
   * @param feature
   * @param bpStart  genomic location of the left edge of the current canvas
   * @param xScale  scale in base-pairs per pixel
   * @param pixelHeight  pixel height of the current canvas
   * @param ctx  the canvas 2d context
   * @param options  genomic state
   */
  function renderFeature(feature, bpStart, xScale, pixelHeight, ctx, options) {

      try {
          ctx.save();

          // Set ctx color to a known valid color.  If getColorForFeature returns an invalid color string it is ignored, and
          // this default will be used.
          ctx.fillStyle = this.defaultColor;
          ctx.strokeStyle = this.defaultColor;

          const color = this.getColorForFeature(feature);
          ctx.fillStyle = color;
          ctx.strokeStyle = color;

          let h;
          let py;
          if (this.displayMode === "SQUISHED" && feature.row !== undefined) {
              h = this.featureHeight / 2;
              py = this.margin + this.squishedRowHeight * feature.row;
          } else if (this.displayMode === "EXPANDED" && feature.row !== undefined) {
              h = this.featureHeight;
              py = this.margin + this.expandedRowHeight * feature.row;
          } else {  // collapsed
              h = this.featureHeight;
              py = this.margin;
          }

          const pixelWidth = options.pixelWidth;   // typical 3*viewportWidth

          const cy = py + h / 2;
          const h2 = h / 2;
          const py2 = cy - h2 / 2;

          const exonCount = feature.exons ? feature.exons.length : 0;
          const coord = calculateFeatureCoordinates(feature, bpStart, xScale);
          const step = this.arrowSpacing;
          const direction = feature.strand === '+' ? 1 : feature.strand === '-' ? -1 : 0;

          if (exonCount === 0) {
              // single-exon transcript
              const xLeft = Math.max(0, coord.px);
              const xRight = Math.min(pixelWidth, coord.px1);
              const width = xRight - xLeft;
              ctx.fillRect(xLeft, py, width, h);

              // Arrows
              // Do not draw if strand is not +/-
              if (direction !== 0) {
                  ctx.fillStyle = "white";
                  ctx.strokeStyle = "white";
                  for (let x = xLeft + step / 2; x < xRight; x += step) {
                      // draw arrowheads along central line indicating transcribed orientation
                      IGVGraphics.strokeLine(ctx, x - direction * 2, cy - 2, x, cy);
                      IGVGraphics.strokeLine(ctx, x - direction * 2, cy + 2, x, cy);
                  }
                  ctx.fillStyle = color;
                  ctx.strokeStyle = color;
              }
          } else {
              // multi-exon transcript
              IGVGraphics.strokeLine(ctx, coord.px + 1, cy, coord.px1 - 1, cy); // center line for introns


              const xLeft = Math.max(0, coord.px) + step / 2;
              const xRight = Math.min(pixelWidth, coord.px1);
              for (let x = xLeft; x < xRight; x += step) {
                  // draw arrowheads along central line indicating transcribed orientation
                  IGVGraphics.strokeLine(ctx, x - direction * 2, cy - 2, x, cy);
                  IGVGraphics.strokeLine(ctx, x - direction * 2, cy + 2, x, cy);
              }
              for (let e = 0; e < exonCount; e++) {
                  // draw the exons
                  const exon = feature.exons[e];
                  let ePx = Math.round((exon.start - bpStart) / xScale);
                  let ePx1 = Math.round((exon.end - bpStart) / xScale);
                  let ePw = Math.max(1, ePx1 - ePx);
                  let ePxU;

                  if (ePx + ePw < 0) {
                      continue  // Off the left edge
                  }
                  if (ePx > pixelWidth) {
                      break // Off the right edge
                  }

                  if (exon.utr) {
                      ctx.fillRect(ePx, py2, ePw, h2); // Entire exon is UTR
                  } else {
                      if (exon.cdStart) {
                          ePxU = Math.round((exon.cdStart - bpStart) / xScale);
                          ctx.fillRect(ePx, py2, ePxU - ePx, h2); // start is UTR
                          ePw -= (ePxU - ePx);
                          ePx = ePxU;

                      }
                      if (exon.cdEnd) {
                          ePxU = Math.round((exon.cdEnd - bpStart) / xScale);
                          ctx.fillRect(ePxU, py2, ePx1 - ePxU, h2); // start is UTR
                          ePw -= (ePx1 - ePxU);
                          ePx1 = ePxU;
                      }

                      ePw = Math.max(ePw, 1);
                      ctx.fillRect(ePx, py, ePw, h);

                      // Arrows
                      if (ePw > step + 5 && direction !== 0) {
                          ctx.fillStyle = "white";
                          ctx.strokeStyle = "white";
                          for (let x = ePx + step / 2; x < ePx1; x += step) {
                              // draw arrowheads along central line indicating transcribed orientation
                              IGVGraphics.strokeLine(ctx, x - direction * 2, cy - 2, x, cy);
                              IGVGraphics.strokeLine(ctx, x - direction * 2, cy + 2, x, cy);
                          }
                          ctx.fillStyle = color;
                          ctx.strokeStyle = color;

                      }
                  }
              }
          }

          if (options.drawLabel && this.displayMode !== "SQUISHED") {
              renderFeatureLabel.call(this, ctx, feature, coord.px, coord.px1, py, options.referenceFrame, options);
          }
      } finally {
          ctx.restore();
      }
  }

  /**
   * @param ctx       the canvas 2d context
   * @param feature
   * @param featureX  feature start in pixel coordinates
   * @param featureX1 feature end in pixel coordinates
   * @param featureY  feature y-coordinate
   * @param windowX   visible window start x-coordinate
   * @param windowX1  visible window end x-coordinate
   * @param referenceFrame  genomic state
   * @param options  options
   */
  function renderFeatureLabel(ctx, feature, featureX, featureX1, featureY, referenceFrame, options) {

      try {
          ctx.save();

          let name = feature.name;
          if (name === undefined && feature.gene) name = feature.gene.name;
          if (name === undefined) name = feature.id || feature.ID;
          if (!name || name === '.') return


          let pixelXOffset = options.pixelXOffset || 0;
          const t1 = Math.max(featureX, -pixelXOffset);
          const t2 = Math.min(featureX1, -pixelXOffset + options.viewportWidth);
          let centerX = (t1 + t2) / 2;

          let transform;
          if (this.displayMode === "COLLAPSED" && this.labelDisplayMode === "SLANT") {
              transform = {rotate: {angle: 45}};
          }
          const labelY = getFeatureLabelY(featureY, transform);

          let color = this.getColorForFeature(feature);
          let geneColor;
          let gtexSelection = false;
          if (referenceFrame.selection && GtexUtils$1.gtexLoaded) {
              // TODO -- for gtex, figure out a better way to do this
              gtexSelection = true;
              geneColor = referenceFrame.selection.colorForGene(name);
          }

          const geneFontStyle = {
              textAlign: "SLANT" === this.labelDisplayMode ? undefined : 'center',
              fillStyle: geneColor || color,
              strokeStyle: geneColor || color
          };

          const textBox = ctx.measureText(name);
          const xleft = centerX - textBox.width / 2;
          const xright = centerX + textBox.width / 2;
          const lastLabelX = options.rowLastLabelX[feature.row] || -Number.MAX_SAFE_INTEGER;
          if (options.labelAllFeatures || xleft > lastLabelX || gtexSelection) {
              options.rowLastLabelX[feature.row] = xright;

              if ('y' === options.axis) {
                  ctx.save();
                  IGVGraphics.labelTransformWithContext(ctx, centerX);
                  IGVGraphics.fillText(ctx, name, centerX, labelY, geneFontStyle, transform);
                  ctx.restore();
              } else {
                  IGVGraphics.fillText(ctx, name, centerX, labelY, geneFontStyle, transform);
              }
          }

      } finally {
          ctx.restore();
      }
  }

  function getFeatureLabelY(featureY, transform) {
      return transform ? featureY + 20 : featureY + 25
  }

  // SNP constants

  const codingNonSynonSet = new Set(['nonsense', 'missense', 'stop-loss', 'frameshift', 'cds-indel']);
  const codingSynonSet = new Set(['coding-synon']);
  const spliceSiteSet = new Set(['splice-3', 'splice-5']);
  const untranslatedSet = new Set(['untranslated-5', 'untranslated-3']);


  /**
   * Renderer for a UCSC snp track
   *
   * @param snp
   * @param bpStart  genomic location of the left edge of the current canvas
   * @param xScale  scale in base-pairs per pixel
   * @param pixelHeight  pixel height of the current canvas
   * @param ctx  the canvas 2d context
   */
  function renderSnp(snp, bpStart, xScale, pixelHeight, ctx) {

      var coord = calculateFeatureCoordinates(snp, bpStart, xScale),
          py = this.margin,
          h,
          colorArrLength = this.snpColors.length,
          colorPriority;

      h = this.displayMode === "squished" ? this.squishedRowHeight : this.expandedRowHeight;

      switch (this.colorBy) {
          case 'function':
              colorPriority = colorByFunc(snp.func);
              break
          case 'class':
              colorPriority = colorByClass(snp['class']);
      }

      ctx.fillStyle = this.snpColors[colorPriority];
      ctx.fillRect(coord.px, py, coord.pw, h);

      // Coloring functions, convert a value to a priority

      function colorByFunc(theFunc) {
          var priorities;
          var funcArray = theFunc.split(',');
          // possible func values


          priorities = funcArray.map(function (func) {
              if (codingNonSynonSet.has(func) || spliceSiteSet.has(func)) {
                  return colorArrLength - 1
              } else if (codingSynonSet.has(func)) {
                  return colorArrLength - 2
              } else if (untranslatedSet.has(func)) {
                  return colorArrLength - 3
              } else { // locusSet.has(func) || intronSet.has(func)
                  return 0
              }
          });

          return priorities.reduce(function (a, b) {
              return Math.max(a, b)
          })
      }

      function colorByClass(cls) {
          if (cls === 'deletion') {
              return colorArrLength - 1
          } else if (cls === 'mnp') {
              return colorArrLength - 2
          } else if (cls === 'microsatellite' || cls === 'named') {
              return colorArrLength - 3
          } else { // cls === 'single' || cls === 'in-del' || cls === 'insertion'
              return 0
          }
      }
  }

  /**
   *
   * @param feature
   * @param bpStart  genomic location of the left edge of the current canvas
   * @param xScale  scale in base-pairs per pixel
   * @param pixelHeight  pixel height of the current canvas
   * @param ctx  the canvas 2d context
   */
  function renderFusionJuncSpan(feature, bpStart, xScale, pixelHeight, ctx) {

      const rowHeight = (this.displayMode === "EXPANDED") ? this.expandedRowHeight : this.squishedRowHeight;
      let py = this.margin;
      if (this.displayMode !== "COLLAPSED" && feature.row !== undefined) {
          py += feature.row * rowHeight;
      }

      const cy = py + 0.5 * rowHeight;
      const topY = cy - 0.5 * rowHeight;
      const bottomY = cy + 0.5 * rowHeight;

      // draw the junction arc
      const junctionLeftPx = Math.round((feature.junction_left - bpStart) / xScale);
      const junctionRightPx = Math.round((feature.junction_right - bpStart) / xScale);

      ctx.beginPath();
      ctx.moveTo(junctionLeftPx, cy);
      ctx.bezierCurveTo(junctionLeftPx, topY, junctionRightPx, topY, junctionRightPx, cy);

      ctx.lineWidth = 1 + Math.log(feature.num_junction_reads) / Math.log(2);
      ctx.strokeStyle = 'blue';
      ctx.stroke();

      // draw the spanning arcs
      const spanningCoords = feature.spanning_frag_coords;
      for (let i = 0; i < spanningCoords.length; i++) {

          const spanningInfo = spanningCoords[i];
          const spanLeftPx = Math.round((spanningInfo.left - bpStart) / xScale);
          const spanRightPx = Math.round((spanningInfo.right - bpStart) / xScale);

          ctx.beginPath();
          ctx.moveTo(spanLeftPx, cy);
          ctx.bezierCurveTo(spanLeftPx, bottomY, spanRightPx, bottomY, spanRightPx, cy);

          ctx.lineWidth = 1;
          ctx.strokeStyle = 'purple';
          ctx.stroke();
      }
  }

  class FeatureTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
      }

      init(config) {
          super.init(config);

          this.type = config.type || "annotation";

          // Set maxRows -- protects against pathological feature packing cases (# of rows of overlapping feaures)
          this.maxRows = config.maxRows === undefined ? 1000 : config.maxRows;

          this.displayMode = config.displayMode || "EXPANDED";    // COLLAPSED | EXPANDED | SQUISHED
          this.labelDisplayMode = config.labelDisplayMode;

          if (config._featureSource) {
              this.featureSource = config._featureSource;
              delete config._featureSource;
          } else {
              this.featureSource = config.featureSource ?
                  config.featureSource :
                  FeatureSource(config, this.browser.genome);
          }

          // Set default heights
          this.autoHeight = config.autoHeight;
          this.margin = config.margin === undefined ? 10 : config.margin;

          this.featureHeight = config.featureHeight || 14;

          if ("FusionJuncSpan" === config.type) {
              this.render = config.render || renderFusionJuncSpan;
              this.squishedRowHeight = config.squishedRowHeight || 50;
              this.expandedRowHeight = config.expandedRowHeight || 50;
              this.height = config.height || this.margin + 2 * this.expandedRowHeight;
          } else if ('snp' === config.type) {
              this.render = config.render || renderSnp;
              // colors ordered based on priority least to greatest
              this.snpColors = ['rgb(0,0,0)', 'rgb(0,0,255)', 'rgb(0,255,0)', 'rgb(255,0,0)'];
              this.colorBy = 'function';
              this.expandedRowHeight = config.expandedRowHeight || 10;
              this.squishedRowHeight = config.squishedRowHeight || 5;
              this.height = config.height || 30;
          } else {
              this.render = config.render || renderFeature;
              this.arrowSpacing = 30;
              // adjust label positions to make sure they're always visible
              monitorTrackDrag(this);
              this.squishedRowHeight = config.squishedRowHeight || 15;
              this.expandedRowHeight = config.expandedRowHeight || 30;
              this.height = config.height || this.margin + 2 * this.expandedRowHeight;

              // Set colorBy fields considering legacy options for backward compatibility
              if (config.colorBy) {
                  if (config.colorBy.field) {
                      config.colorTable = config.colorBy.pallete || config.colorBy.palette;
                      config.colorBy = config.colorBy.field;
                  }
                  this.colorBy = config.colorBy;   // Can be undefined => default
                  if (config.colorTable) {
                      this.colorTable = new ColorTable(config.colorTable);
                  } else {
                      this.colorTable = new PaletteColorTable("Set1");
                  }
              }
          }

          //UCSC useScore option
          this.useScore = config.useScore;
      }

      async postInit() {

          if (typeof this.featureSource.getHeader === "function") {
              this.header = await this.featureSource.getHeader();
              if (this.disposed) return   // This track was removed during async load
          }

          // Set properties from track line
          if (this.header) {
              this.setTrackProperties(this.header);
          }

          if (this.visibilityWindow === undefined && typeof this.featureSource.defaultVisibilityWindow === 'function') {
              this.visibilityWindow = await this.featureSource.defaultVisibilityWindow();
          }

          return this

      }

      get supportsWholeGenome() {
          if (this.config.supportsWholeGenome !== undefined) {
              return this.config.supportsWholeGenome
          } else if (this.featureSource && typeof this.featureSource.supportsWholeGenome === 'function') {
              return this.featureSource.supportsWholeGenome()
          } else {
              if (this.visibilityWindow === undefined && (this.config.indexed === false || !this.config.indexURL)) {
                  return true
              }
          }
      }

      async getFeatures(chr, start, end, bpPerPixel) {
          const visibilityWindow = this.visibilityWindow;
          return this.featureSource.getFeatures({chr, start, end, bpPerPixel, visibilityWindow})
      };


      /**
       * The required height in pixels required for the track content.   This is not the visible track height, which
       * can be smaller (with a scrollbar) or larger.
       *
       * @param features
       * @returns {*}
       */
      computePixelHeight(features) {

          if (this.displayMode === "COLLAPSED") {
              return this.margin + this.expandedRowHeight
          } else {
              let maxRow = 0;
              if (features && (typeof features.forEach === "function")) {
                  for (let feature of features) {
                      if (feature.row && feature.row > maxRow) {
                          maxRow = feature.row;
                      }
                  }
              }

              const height = this.margin + (maxRow + 1) * ("SQUISHED" === this.displayMode ? this.squishedRowHeight : this.expandedRowHeight);
              return height

          }
      };

      draw(options) {

          const featureList = options.features;
          const ctx = options.context;
          const bpPerPixel = options.bpPerPixel;
          const bpStart = options.bpStart;
          const pixelWidth = options.pixelWidth;
          const pixelHeight = options.pixelHeight;
          const bpEnd = bpStart + pixelWidth * bpPerPixel + 1;


          if (!this.config.isMergedTrack) {
              IGVGraphics.fillRect(ctx, 0, options.pixelTop, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});
          }

          if (featureList) {

              const rowFeatureCount = [];
              options.rowLastX = [];
              options.rowLastLabelX = [];
              for (let feature of featureList) {
                  if (feature.start > bpStart && feature.end < bpEnd) {
                      const row = this.displayMode === "COLLAPSED" ? 0 : feature.row || 0;
                      if (rowFeatureCount[row] === undefined) {
                          rowFeatureCount[row] = 1;
                      } else {
                          rowFeatureCount[row]++;
                      }
                      options.rowLastX[row] = -Number.MAX_SAFE_INTEGER;
                      options.rowLastLabelX[row] = -Number.MAX_SAFE_INTEGER;
                  }
              }
              const maxFeatureCount = Math.max(1, Math.max(...rowFeatureCount));
              const pixelsPerFeature = pixelWidth / maxFeatureCount;

              let lastPxEnd = [];
              for (let feature of featureList) {
                  if (feature.end < bpStart) continue
                  if (feature.start > bpEnd) break
                  const row = this.displayMode === 'COLLAPSED' ? 0 : feature.row;
                  options.drawLabel = options.labelAllFeatures || pixelsPerFeature > 10;
                  const pxEnd = Math.ceil((feature.end - bpStart) / bpPerPixel);
                  const last = lastPxEnd[row];
                  if (!last || pxEnd > last) {
                      this.render.call(this, feature, bpStart, bpPerPixel, pixelHeight, ctx, options);

                      // Ensure a visible gap between features
                      const pxStart = Math.floor((feature.start - bpStart) / bpPerPixel);
                      if (last && pxStart - last <= 0) {
                          ctx.globalAlpha = 0.5;
                          IGVGraphics.strokeLine(ctx, pxStart, 0, pxStart, pixelHeight, {'strokeStyle': "rgb(255, 255, 255)"});
                          ctx.globalAlpha = 1.0;
                      }
                      lastPxEnd[row] = pxEnd;
                  }
              }

          }

      };

      clickedFeatures(clickState) {

          const y = clickState.y - this.margin;
          const allFeatures = super.clickedFeatures(clickState);

          let row;
          switch (this.displayMode) {
              case 'SQUISHED':
                  row = Math.floor(y / this.squishedRowHeight);
                  break
              case 'EXPANDED':
                  row = Math.floor(y / this.expandedRowHeight);
                  break
              default:
                  row = undefined;
          }

          return allFeatures.filter(function (feature) {
              return (row === undefined || feature.row === undefined || row === feature.row)
          })
      }

      /**
       * Return "popup data" for feature @ genomic location.  Data is an array of key-value pairs
       */
      popupData(clickState, features) {

          if (features === undefined) features = this.clickedFeatures(clickState);
          const genomicLocation = clickState.genomicLocation;
          const data = [];
          for (let feature of features) {

              // Whole genome hack, whole-genome psuedo features store the "real" feature in an _f field
              const f = feature._f || feature;

              const featureData = (typeof f.popupData === "function") ?
                  f.popupData(genomicLocation) :
                  this.extractPopupData(f);

              if (featureData) {

                  if (data.length > 0) {
                      data.push("<hr/><hr/>");
                  }

                  // If we have an infoURL, find the name property and create the link.  We do this at this level
                  // to catch name properties in both custom popupData functions and the generic extractPopupData function

                  const infoURL = this.infoURL || this.config.infoURL;
                  for (let fd of featureData) {
                      data.push(fd);
                      if (infoURL &&
                          fd.name &&
                          fd.name.toLowerCase() === "name" &&
                          fd.value &&
                          isString$2(fd.value) &&
                          !fd.value.startsWith("<")) {
                          const href = infoURL.replace("$$", feature.name);
                          fd.value = `<a target=_blank href=${href}>${fd.value}</a>`;
                      }
                  }


                  //Array.prototype.push.apply(data, featureData);

                  // If we have clicked over an exon number it.
                  // Disabled for GFF and GTF files if the visibility window is < the feature length since we don't know if we have all exons
                  const isGFF = "gff" === this.config.format || "gff3" === this.config.format || "gtf" === this.config.format;
                  if (f.exons) {
                      for (let i = 0; i < f.exons.length; i++) {
                          const exon = f.exons[i];
                          if (genomicLocation >= exon.start && genomicLocation <= exon.end) {
                              const exonNumber = isGFF ?
                                  exon.number :
                                  f.strand === "-" ? f.exons.length - i : i + 1;
                              if (exonNumber) {
                                  data.push('<hr/>');
                                  data.push({name: "Exon Number", value: exonNumber});
                              }
                              break
                          }
                      }
                  }
              }
          }

          return data

      }

      menuItemList() {

          const menuItems = [];

          if (this.render === renderSnp) {
              menuItems.push('<hr/>');
              for (let colorScheme of ["function", "class"]) {
                  menuItems.push({
                      object: $$1(createCheckbox('Color by ' + colorScheme, colorScheme === this.colorBy)),
                      click: () => {
                          this.colorBy = colorScheme;
                          this.trackView.repaintViews();
                      }
                  });
              }
          }

          menuItems.push('<hr/>');
          for (let displayMode of ["COLLAPSED", "SQUISHED", "EXPANDED"]) {
              const lut =
                  {
                      "COLLAPSED": "Collapse",
                      "SQUISHED": "Squish",
                      "EXPANDED": "Expand"
                  };

              menuItems.push(
                  {
                      object: $$1(createCheckbox(lut[displayMode], displayMode === this.displayMode)),
                      click: () => {
                          this.displayMode = displayMode;
                          this.config.displayMode = displayMode;
                          this.trackView.checkContentHeight();
                          this.trackView.repaintViews();
                      }
                  });
          }

          return menuItems

      };


      contextMenuItemList(clickState) {

          const features = this.clickedFeatures(clickState);

          if (undefined === features || 0 === features.length) {
              return undefined
          }

          if (features.length > 1) {
              features.sort((a, b) => (b.end - b.start) - (a.end - a.start));
          }
          const f = features[0];   // The shortest clicked feature

          if ((f.end - f.start) <= 1000000) {
              const list = [{
                  label: 'View feature sequence',
                  click: async () => {
                      let seq = await this.browser.genome.getSequence(f.chr, f.start, f.end);
                      if (!seq) {
                          seq = "Unknown sequence";
                      } else if (f.strand === '-') {
                          seq = reverseComplementSequence(seq);
                      }
                      this.browser.alert.present(seq);

                  }
              }];

              if (isSecureContext() && navigator.clipboard !== undefined) {
                  list.push(
                      {
                          label: 'Copy feature sequence',
                          click: async () => {
                              let seq = await this.browser.genome.getSequence(f.chr, f.start, f.end);
                              if (!seq) {
                                  seq = "Unknown sequence";
                              } else if (f.strand === '-') {
                                  seq = reverseComplementSequence(seq);
                              }
                              try {
                                  await navigator.clipboard.writeText(seq);
                              } catch (e) {
                                  console.error(e);
                                  this.browser.alert.present(`error copying sequence to clipboard ${e}`);
                              }
                          }
                      }
                  );
              }
              list.push('<hr/>');
              return list
          } else {
              return undefined
          }
      }

      description() {

          // if('snp' === this.type) {
          if (renderSnp === this.render) {
              let desc = "<html>" + this.name + '<hr/>';
              desc += '<em>Color By Function:</em><br>';
              desc += '<span style="color:red">Red</span>: Coding-Non-Synonymous, Splice Site<br>';
              desc += '<span style="color:green">Green</span>: Coding-Synonymous<br>';
              desc += '<span style="color:blue">Blue</span>: Untranslated<br>';
              desc += '<span style="color:black">Black</span>: Intron, Locus, Unknown<br><br>';
              desc += '<em>Color By Class:</em><br>';
              desc += '<span style="color:red">Red</span>: Deletion<br>';
              desc += '<span style="color:green">Green</span>: MNP<br>';
              desc += '<span style="color:blue">Blue</span>: Microsatellite, Named<br>';
              desc += '<span style="color:black">Black</span>: Indel, Insertion, SNP';
              desc += "</html>";
              return desc
          } else {
              return super.description()
          }

      };

      /**
       * Return color for feature.
       * @param feature
       * @returns {string}
       */

      getColorForFeature(feature) {

          let color;
          if (this.altColor && "-" === feature.strand) {
              color = (typeof this.altColor === "function") ? this.altColor(feature) : this.altColor;
          } else if (this.color) {
              color = (typeof this.color === "function") ? this.color(feature) : this.color;  // Explicit setting via menu, or possibly track line if !config.color
          } else if (this.colorBy) {
              const value = feature.getAttributeValue ?
                  feature.getAttributeValue(this.colorBy) :
                  feature[this.colorBy];
              color = this.colorTable.getColor(value);
          } else if (feature.color) {
              color = feature.color;   // Explicit color for feature
          } else {
              color = this.defaultColor;   // Track default
          }

          if (feature.alpha && feature.alpha !== 1) {
              color = IGVColor.addAlpha(color, feature.alpha);
          } else if (this.useScore && feature.score && !Number.isNaN(feature.score)) {
              // UCSC useScore option, for scores between 0-1000.  See https://genome.ucsc.edu/goldenPath/help/customTrack.html#TRACK
              const min = this.config.min ? this.config.min : this.viewLimitMin ? this.viewLimitMin : 0;
              const max = this.config.max ? this.config.max : this.viewLimitMax ? this.viewLimitMax : 1000;
              const alpha = getAlpha(min, max, feature.score);
              feature.alpha = alpha;    // Avoid computing again
              color = IGVColor.addAlpha(color, alpha);
          }


          function getAlpha(min, max, score) {
              const binWidth = (max - min) / 9;
              const binNumber = Math.floor((score - min) / binWidth);
              return Math.min(1.0, 0.2 + (binNumber * 0.8) / 9)
          }

          return color
      }


      /**
       * Called when the track is removed.  Do any needed cleanup here
       */
      dispose() {
          this.trackView = undefined;
      }
  }

  /**
   * Monitors track drag events, updates label position to ensure that they're always visible.
   * @param track
   */
  function monitorTrackDrag(track) {

      if (track.browser.on) {
          track.browser.on('trackdragend', onDragEnd);
          track.browser.on('trackremoved', unSubscribe);
      }

      function onDragEnd() {
          if (track.trackView && track.displayMode !== "SQUISHED") {
              track.trackView.repaintViews();      // TODO -- refine this to the viewport that was dragged after DOM refactor
          }
      }

      function unSubscribe(removedTrack) {
          if (track.browser.un && track === removedTrack) {
              track.browser.un('trackdragend', onDragEnd);
              track.browser.un('trackremoved', unSubscribe);
          }
      }

  }

  class RegionTableBase {
      constructor(config) {

          this.config = config;

          this.browser = config.browser;

          this.container = domUtils.div({ class: 'igv-roi-table' });

          config.parent.appendChild(this.container);

          this.headerDOM = config;

          this.columnTitleDOM = config.columnFormat;

          this.rowContainerDOM = this.container;

          this.footerDOM = config.gotoButtonHandler;

          this.columnFormat = config.columnFormat;

          this.tableRowSelectionList = [];

      }

      set headerDOM({ browser, parent, headerTitle, dismissHandler }) {

          // header
          const dom = domUtils.div();
          this.container.appendChild(dom);

          // header title
          const div = domUtils.div();
          dom.appendChild(div);
          div.innerText = headerTitle;

          // table dismiss button
          const dismiss = domUtils.div();
          dom.appendChild(dismiss);
          dismiss.appendChild(icons$1$1.createIcon('times'));

          this.boundDismissHandler = mouseClickHandler.bind(this);

          dismiss.addEventListener('click', this.boundDismissHandler);

          function mouseClickHandler (event) {
              event.stopPropagation();
              dismissHandler();
          }

          const { y:y_root } = browser.root.getBoundingClientRect();
          const { y:y_parent } = parent.getBoundingClientRect();
          const constraint = -(y_parent - y_root);
          makeDraggable$2(this.container, dom, { minX:0, minY:constraint });

          this.container.style.display = 'none';

          this._headerDOM = dom;

      }

      set columnTitleDOM(columnFormat) {

          const dom = domUtils.div({ class: 'igv-roi-table-column-titles' });
          this.container.appendChild(dom);

          for (const { label, width } of columnFormat) {
              const col = domUtils.div();
              dom.appendChild(col);
              col.style.width = width;
              col.innerText = label;
          }

      }

      set rowContainerDOM(container) {

          const dom = domUtils.div({ class: 'igv-roi-table-row-container' });
          container.appendChild(dom);

          dom.style.minWidth = this.config.width;

          this._rowContainerDOM = dom;
      }

      get rowContainerDOM() {
          return this._rowContainerDOM
      }

      set footerDOM(gotoButtonHandler) {

          const dom = domUtils.div();
          this.container.appendChild(dom);

          // Go To Button
          const gotoButton = domUtils.div({class: 'igv-roi-table-button'});
          dom.appendChild(gotoButton);

          gotoButton.id = 'igv-roi-table-view-button';
          gotoButton.textContent = 'Go To';
          gotoButton.style.pointerEvents = 'none';

          this._footerDOM = dom;

          this.gotoButton = gotoButton;

          this.boundGotoButtonHandler = gotoButtonHandler.bind(this);

          this.gotoButton.addEventListener('click', this.boundGotoButtonHandler);

      }

      tableRowDOMHelper(dom) {

          dom.addEventListener('mousedown', event => {
              event.stopPropagation();

              dom.classList.toggle('igv-roi-table-row-selected');
              dom.classList.contains('igv-roi-table-row-selected') ? dom.classList.remove('igv-roi-table-row-hover') : dom.classList.add('igv-roi-table-row-hover');

              this.setTableRowSelectionState(dom.classList.contains('igv-roi-table-row-selected'));
          });

          dom.addEventListener('mouseover', e => {
              dom.classList.contains('igv-roi-table-row-selected') ? dom.classList.remove('igv-roi-table-row-hover') : dom.classList.add('igv-roi-table-row-hover');
          });

          dom.addEventListener('mouseout', e => {
              dom.classList.remove('igv-roi-table-row-hover');
          });

      }

      clearTable() {
          const elements = this.rowContainerDOM.querySelectorAll('.igv-roi-table-row');
          for (let el of elements) {
              el.remove();
          }
      }

      setTableRowSelectionState(isTableRowSelected) {
          isTableRowSelected ? this.tableRowSelectionList.push(1) : this.tableRowSelectionList.pop();
          this.gotoButton.style.pointerEvents = this.tableRowSelectionList.length > 0 ? 'auto' : 'none';
      }

      present() {
          this.container.style.left = `${ 0 }px`;

          const { y:y_root } = this.browser.root.getBoundingClientRect();
          const { y:y_parent } = this.config.parent.getBoundingClientRect();

          this.container.style.top  = `${ y_root - y_parent }px`;
          this.container.style.display = 'flex';
      }

      dismiss() {
          this.container.style.display = 'none';
      }

      dispose() {

          this.container.innerHTML = '';
          this.container.remove();

          for (const key of Object.keys(this)) {
              this[key] = undefined;
          }

          document.removeEventListener('click', this.boundDismissHandler);

      }

  }

  class BlatTable extends RegionTableBase {

      constructor(config) {

          const cooked = Object.assign({ 'width':'1040px' }, config);
          super(cooked);

          this.descriptionDOM = config;

      }


      set columnTitleDOM(columnFormat) {

          const dom = domUtils.div({ class: 'igv-roi-table-column-titles' });
          this.container.appendChild(dom);

          for (const format of columnFormat) {
              const col = domUtils.div();
              dom.appendChild(col);
              col.style.width = format.width || 'fit-content';
              col.innerText = format.label;
          }

      }

      set descriptionDOM(config) {

          if (config.description) {

              let dom;

              const found = this.container.querySelector('.igv-roi-table-column-titles');
              dom = domUtils.div({ class: 'igv-roi-table-description' });
              this.container.insertBefore(dom, found);
              dom.innerHTML = config.description;

              dom = domUtils.div({ class: 'igv-roi-table-goto-explainer' });
              this.container.insertBefore(dom, found);
              dom.innerHTML = `Select one or more rows and click Go To to view the regions`;

          }

      }

      tableRowDOM(record) {

          const dom = domUtils.div({ class: 'igv-roi-table-row' });

          const pretty = record.map(item => isFinite(item) ? numberFormatter$1(item) : item);

          for (let i = 0; i < pretty.length; i++) {

              const el = domUtils.div();
              dom.appendChild(el);

              const format = this.columnFormat[ i ];
              el.style.width = format.width || 'fit-content';
              el.innerText = pretty[ i ];
          }

          this.tableRowDOMHelper(dom);

          return dom
      }

      renderTable(records) {

          Array.from(this.rowContainerDOM.querySelectorAll('.igv-roi-table-row')).forEach(el => el.remove());

          if (records.length > 0) {

              for (let record of records) {
                  const row = this.tableRowDOM(record);
                  this.rowContainerDOM.appendChild(row);
              }

          }

      }

      static getColumnFormatConfiguration() {

          /*
          return [
              { label:         'chr', width: '60px' },
              { label:       'start', width: '100px' },
              { label:         'end', width: '100px' },
              { label:      'strand', width: '50px' },
              { label:       'score', width: '50px' },
              { label:       'match', width: '50px' },
              { label:   "mis-match", width: '70px' },
              { label:  "rep. match", width: '70px' },
              { label:         "N's", width: '32px' },
              { label: 'Q gap count', width: '90px' },
              { label: 'Q gap bases', width: '90px' },
              { label: 'T gap count', width: '90px' },
              { label: 'T gap bases', width: '90px' },
          ]
          */

          return [
              { label:         'chr', width: '7%' },
              { label:       'start', width: '12%' },
              { label:         'end', width: '12%' },
              { label:      'strand', width: '5%' },
              { label:       'score', width: '5%' },
              { label:       'match', width: '5%' },
              { label:   "mis-match", width: '7%' },
              { label:  "rep. match", width: '7%' },
              { label:         "N's", width: '3%' },
              { label: 'Q gap count', width: '9%' },
              { label: 'Q gap bases', width: '9%' },
              { label: 'T gap count', width: '9%' },
              { label: 'T gap bases', width: '9%' },
          ]
      }

      static gotoButtonHandler (event) {

          event.stopPropagation();

          const selectedRows = this.container.querySelectorAll('.igv-roi-table-row-selected');

          const loci = [];
          for (const row of selectedRows) {

              const record = [];
              row.querySelectorAll('div').forEach(el => record.push(el.innerText));

              const [ chr, start, end ] = record;
              loci.push(`${ chr }:${ start }-${ end }`);
          }

          for (const el of this.container.querySelectorAll('.igv-roi-table-row')) {
              el.classList.remove('igv-roi-table-row-selected');
          }

          this.setTableRowSelectionState(false);

          this.browser.search(loci.join(' '));

          // console.log(`browser search( ${loci.join(' ')} )`)

      }

  }

  /*
  http://genome.ucsc.edu/cgi-bin/hgBlat
  ?userSeq=CTAATCAtctacactggtttctactgaaatgtctgttgtcatagacttaattgtgtcttcagatacagcagttctgttatttctgagttttacctggggcaagagaatctttagcaagtttaaaggcacctatatctggaatcacccctccctccagatgaatatcacagactctcccattaaaggtcttgccTTCCTTGATAGCATCATCACTCCA
  &type=DNA
  &db=hg38
  &output=json
   */


  //const blatServer = "https://genome.ucsc.edu/cgi-bin/hgBlat"
  const blatServer = "https://igv.org/services/blat.php";


  async function blat(userSeq, db) {

      const url = `${blatServer}?userSeq=${userSeq}&type=DNA&db=${db}&output=json`;

      const results = await igvxhr$1.loadJson(url, {});

      results.fields;

      const features = results.blat.map(decodePSL);

      return features
  }

  class BlatTrack extends FeatureTrack {


      constructor(config, browser) {
          super(config, browser);
          if (!this.name) {
              this.name = 'Blat Results';
          }
          this.sequence = config.sequence;
          this.table = undefined;
      }

      openTableView() {

          if (undefined === this.table) {

              const rows = this.config.features.map(f => [
                  f.chr,
                  (f.start + 1),
                  f.end,
                  f.strand,
                  f.score,
                  f.matches,
                  f.misMatches,
                  f.repMatches,
                  f.nCount,
                  f.qNumInsert,
                  f.qBaseInsert,
                  f.tNumInsert,
                  f.tBaseInsert
              ]);

              const config =
                  {
                      browser: this.browser,
                      parent: this.browser.parent,
                      headerTitle: this.config.title,
                      description: `BLAT result for query sequence:<br>${ this.sequence }`,
                      dismissHandler: () => {
                          this.table.dismiss();
                          this.table.dispose();
                          this.table = undefined;
                      },
                      columnFormat: BlatTable.getColumnFormatConfiguration(),
                      gotoButtonHandler: BlatTable.gotoButtonHandler
                  };

              this.table = new BlatTable(config);
              this.table.renderTable(rows);
          }

          this.table.present();

      }

      menuItemList() {

          const menuItems = super.menuItemList();

          menuItems.push('<hr/>');
          menuItems.push({
              label: 'Open table view',
              click: () => this.openTableView()
          });
          return menuItems
      }


      /**
       * Track has been permanently removed.  Release resources and other cleanup
       */
      dispose() {
          super.dispose();
          // Release DOM element for table
          if (this.table) {
              this.table.popover.parentElement.removeChild(this.table.popover);

          }


      }
  }


  async function createBlatTrack({sequence, browser, name, title}) {

      const db = browser.genome.id;   // TODO -- blat specific property

      const features = await blat(sequence, db);

      const trackConfig = {
          type: 'blat',
          name: name || 'blat results',
          title: title || 'blat results',
          sequence: sequence,
          features: features
      };

      const track = await browser.loadTrack(trackConfig);

      track.openTableView();

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const alignmentStartGap = 5;
  const downsampleRowHeight = 5;
  const DEFAULT_COVERAGE_TRACK_HEIGHT = 50;
  const DEFAULT_TRACK_HEIGHT$1 = 300;
  const DEFAULT_ALIGNMENT_COLOR = "rgb(185, 185, 185)";
  const DEFAULT_COVERAGE_COLOR = "rgb(150, 150, 150)";
  const DEFAULT_CONNECTOR_COLOR = "rgb(200, 200, 200)";
  const MINIMUM_BLAT_LENGTH = 20;

  class BAMTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
      }

      init(config) {
          super.init(config);
          this.type = "alignment";

          if (config.alleleFreqThreshold === undefined) {
              config.alleleFreqThreshold = 0.2;
          }

          this.featureSource = new BamSource(config, this.browser);

          this.showCoverage = config.showCoverage === undefined ? true : config.showCoverage;
          this.showAlignments = config.showAlignments === undefined ? true : config.showAlignments;

          this.coverageTrack = new CoverageTrack(config, this);
          this.alignmentTrack = new AlignmentTrack(config, this);
          this.alignmentTrack.setTop(this.coverageTrack, this.showCoverage);
          this.visibilityWindow = config.visibilityWindow || 30000;
          this.viewAsPairs = config.viewAsPairs;
          this.pairsSupported = config.pairsSupported !== false;
          this.showSoftClips = config.showSoftClips;
          this.showAllBases = config.showAllBases;
          this.showInsertions = false !== config.showInsertions;
          this.showMismatches = false !== config.showMismatches;
          this.color = config.color;
          this.coverageColor = config.coverageColor;

          // The sort object can be an array in the case of multi-locus view, however if multiple sort positions
          // are present for a given reference frame the last one will take precedence
          if (config.sort) {
              if (Array.isArray(config.sort)) {
                  // Legacy support
                  this.assignSort(config.sort[0]);
              } else {
                  this.assignSort(config.sort);
              }
          }

          // Invoke height setter last to allocated to coverage and alignment tracks
          this.height = (config.height !== undefined ? config.height : DEFAULT_TRACK_HEIGHT$1);
      }

      set height(h) {
          this._height = h;
          if (this.coverageTrack && this.showAlignments) {
              this.alignmentTrack.height = this.showCoverage ? h - this.coverageTrack.height : h;
          }
      }

      get height() {
          return this._height
      }

      get minTemplateLength() {
          const configMinTLEN = this.config.minTLEN !== undefined ? this.config.minTLEN : this.config.minFragmentLength;
          return (configMinTLEN !== undefined) ? configMinTLEN :
              this._pairedEndStats ? this._pairedEndStats.minTLEN : 0
      }

      get maxTemplateLength() {
          const configMaxTLEN = this.config.maxTLEN !== undefined ? this.config.maxTLEN : this.config.maxFragmentLength;
          return (configMaxTLEN !== undefined) ? configMaxTLEN :
              this._pairedEndStats ? this._pairedEndStats.maxTLEN : 1000
      }

      sort(options) {
          options = this.assignSort(options);

          for (let vp of this.trackView.viewports) {
              if (vp.containsPosition(options.chr, options.position)) {
                  const alignmentContainer = vp.cachedFeatures;
                  if (alignmentContainer) {
                      alignmentContainer.sortRows(options);
                      vp.repaint();
                  }
              }
          }
      }

      /**
       * Fix syntax problems for sort options.
       * @param options
       */
      assignSort(options) {
          // convert old syntax
          if (options.locus) {
              const range = parseLocusString$1(options.locus);
              options.chr = range.chr;
              options.position = range.start;
          } else {
              options.position--;
          }
          options.direction = options.direction === "ASC" || options.direction === true;

          // chr aliasing
          options.chr = this.browser.genome.getChromosomeName(options.chr);
          this.sortObject = options;

          return this.sortObject
      }

      async getFeatures(chr, bpStart, bpEnd, bpPerPixel, viewport) {

          const alignmentContainer = await this.featureSource.getAlignments(chr, bpStart, bpEnd);

          if (alignmentContainer.paired && !this._pairedEndStats && !this.config.maxFragmentLength) {
              const pairedEndStats = new PairedEndStats(alignmentContainer.alignments, this.config);
              if (pairedEndStats.totalCount > 99) {
                  this._pairedEndStats = pairedEndStats;
              }
          }
          alignmentContainer.alignments = undefined;  // Don't need to hold onto these anymore

          const sort = this.sortObject;
          if (sort) {
              if (sort.chr === chr && sort.position >= bpStart && sort.position <= bpEnd) {
                  alignmentContainer.sortRows(sort);
              }
          }

          return alignmentContainer
      }


      /**
       * Compute the pixel height required to display all content.  This is not the same as the viewport height
       * (track.height) which might include a scrollbar.
       *
       * @param alignmentContainer
       * @returns {number}
       */
      computePixelHeight(alignmentContainer) {
          return (this.showCoverage ? this.coverageTrack.height : 0) +
              (this.showAlignments ? this.alignmentTrack.computePixelHeight(alignmentContainer) : 0) +
              15
      }

      draw(options) {

          IGVGraphics.fillRect(options.context, 0, options.pixelTop, options.pixelWidth, options.pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});

          if (true === this.showCoverage && this.coverageTrack.height > 0) {
              this.trackView.axisCanvas.style.display = 'block';
              this.coverageTrack.draw(options);
          } else {
              this.trackView.axisCanvas.style.display = 'none';
          }

          if (true === this.showAlignments) {
              this.alignmentTrack.setTop(this.coverageTrack, this.showCoverage);
              this.alignmentTrack.draw(options);
          }
      }

      paintAxis(ctx, pixelWidth, pixelHeight) {

          this.coverageTrack.paintAxis(ctx, pixelWidth, this.coverageTrack.height);

          // if (this.browser.isMultiLocusMode()) {
          //     ctx.clearRect(0, 0, pixelWidth, pixelHeight);
          // } else {
          //     this.coverageTrack.paintAxis(ctx, pixelWidth, this.coverageTrack.height);
          // }
      }

      contextMenuItemList(config) {
          return this.alignmentTrack.contextMenuItemList(config)
      }

      popupData(clickState) {
          if (true === this.showCoverage && clickState.y >= this.coverageTrack.top && clickState.y < this.coverageTrack.height) {
              return this.coverageTrack.popupData(clickState)
          } else {
              return this.alignmentTrack.popupData(clickState)
          }
      }

      /**
       * Return the features (alignment, coverage, downsampled interval) clicked on.  Needed for "onclick" event.
       * @param clickState
       * @param features
       */
      clickedFeatures(clickState) {

          let clickedObject;
          if (true === this.showCoverage && clickState.y >= this.coverageTrack.top && clickState.y < this.coverageTrack.height) {
              clickedObject = this.coverageTrack.getClickedObject(clickState);
          } else {
              clickedObject = this.alignmentTrack.getClickedObject(clickState);
          }
          return clickedObject ? [clickedObject] : undefined
      }

      hoverText(clickState) {
          if (true === this.showCoverage && clickState.y >= this.coverageTrack.top && clickState.y < this.coverageTrack.height) {
              const clickedObject = this.coverageTrack.getClickedObject(clickState);
              if (clickedObject) {
                  return clickedObject.hoverText()
              }
          }

      }

      menuItemList() {


          // Start with overage track items
          let menuItems = [];

          menuItems = menuItems.concat(MenuUtils.numericDataMenuItems(this.trackView));

          // Color by items
          menuItems.push('<hr/>');
          const $e = $$1('<div class="igv-track-menu-category">');
          $e.text('Color by:');
          menuItems.push({name: undefined, object: $e, click: undefined, init: undefined});

          const colorByMenuItems = [{key: 'strand', label: 'read strand'}];
          if (this.alignmentTrack.hasPairs) {
              colorByMenuItems.push({key: 'firstOfPairStrand', label: 'first-of-pair strand'});
              colorByMenuItems.push({key: 'pairOrientation', label: 'pair orientation'});
              colorByMenuItems.push({key: 'tlen', label: 'insert size (TLEN)'});
              colorByMenuItems.push({key: 'unexpectedPair', label: 'pair orientation & insert size (TLEN)'});
          }
          const tagLabel = 'tag' + (this.alignmentTrack.colorByTag ? ' (' + this.alignmentTrack.colorByTag + ')' : '');
          colorByMenuItems.push({key: 'tag', label: tagLabel});
          for (let item of colorByMenuItems) {
              const selected = (this.alignmentTrack.colorBy === item.key);
              menuItems.push(this.colorByCB(item, selected));
          }

          // Show coverage / alignment options
          const adjustTrackHeight = () => {
              if (!this.autoHeight) {
                  const h = 15 +
                      (this.showCoverage ? this.coverageTrack.height : 0) +
                      (this.showAlignments ? this.alignmentTrack.height : 0);
                  this.trackView.setTrackHeight(h);
              }
          };

          menuItems.push('<hr/>');
          menuItems.push({
              object: $$1(createCheckbox("Show Coverage", this.showCoverage)),
              click: () => {
                  this.showCoverage = !this.showCoverage;
                  adjustTrackHeight();
                  this.trackView.checkContentHeight();
                  this.trackView.repaintViews();
              }
          });
          menuItems.push({
              object: $$1(createCheckbox("Show Alignments", this.showAlignments)),
              click: () => {
                  this.showAlignments = !this.showAlignments;
                  adjustTrackHeight();
                  this.trackView.checkContentHeight();
                  this.trackView.repaintViews();
              }
          });

          // Show all bases
          menuItems.push('<hr/>');
          menuItems.push({
              object: $$1(createCheckbox("Show all bases", this.showAllBases)),
              click: () => {
                  this.showAllBases = !this.showAllBases;
                  this.config.showAllBases = this.showAllBases;
                  this.trackView.repaintViews();
              }
          });

          // Show mismatches
          menuItems.push('<hr/>');
          menuItems.push({
              object: $$1(createCheckbox("Show mismatches", this.showMismatches)),
              click: () => {
                  this.showMismatches = !this.showMismatches;
                  this.config.showMismatches = this.showMismatches;
                  this.trackView.repaintViews();
              }
          });

          // Insertions
          menuItems.push({
              object: $$1(createCheckbox("Show insertions", this.showInsertions)),
              click: () => {
                  this.showInsertions = !this.showInsertions;
                  this.config.showInsertions = this.showInsertions;
                  this.getCachedAlignmentContainers();
                  this.trackView.repaintViews();
              }
          });

          // Soft clips
          menuItems.push({
              object: $$1(createCheckbox("Show soft clips", this.showSoftClips)),
              click: () => {
                  this.showSoftClips = !this.showSoftClips;
                  this.config.showSoftClips = this.showSoftClips;
                  this.featureSource.setShowSoftClips(this.showSoftClips);
                  const alignmentContainers = this.getCachedAlignmentContainers();
                  for (let ac of alignmentContainers) {
                      ac.setShowSoftClips(this.showSoftClips);
                  }
                  this.trackView.repaintViews();
              }
          });

          // View as pairs
          if (this.pairsSupported && this.alignmentTrack.hasPairs) {
              menuItems.push('<hr/>');
              menuItems.push({
                  object: $$1(createCheckbox("View as pairs", this.viewAsPairs)),
                  click: () => {
                      this.viewAsPairs = !this.viewAsPairs;
                      this.config.viewAsPairs = this.viewAsPairs;
                      this.featureSource.setViewAsPairs(this.viewAsPairs);
                      const alignmentContainers = this.getCachedAlignmentContainers();
                      for (let ac of alignmentContainers) {
                          ac.setViewAsPairs(this.viewAsPairs);
                      }
                      this.trackView.repaintViews();
                  }
              });
          }

          // Add chords to JBrowse circular view, if present
          if (this.browser.circularView &&
              (this.alignmentTrack.hasPairs || this.alignmentTrack.hasSupplemental)) {
              menuItems.push('<hr/>');
              if (this.alignmentTrack.hasPairs) {
                  menuItems.push({
                      label: 'Add discordant pairs to circular view',
                      click: () => {
                          for (let viewport of this.trackView.viewports) {
                              this.addPairedChordsForViewport(viewport);
                          }
                      }
                  });
              }
              if (this.alignmentTrack.hasSupplemental) {
                  menuItems.push({
                      label: 'Add split reads to circular view',
                      click: () => {
                          for (let viewport of this.trackView.viewports) {
                              this.addSplitChordsForViewport(viewport);
                          }
                      }
                  });
              }
          }


          // Display mode
          menuItems.push('<hr/>');
          const $dml = $$1('<div class="igv-track-menu-category">');
          $dml.text('Display mode:');
          menuItems.push({name: undefined, object: $dml, click: undefined, init: undefined});

          menuItems.push({
              object: $$1(createCheckbox("expand", this.alignmentTrack.displayMode === "EXPANDED")),
              click: () => {
                  this.alignmentTrack.displayMode = "EXPANDED";
                  this.config.displayMode = "EXPANDED";
                  this.trackView.checkContentHeight();
                  this.trackView.repaintViews();
              }
          });

          menuItems.push({
              object: $$1(createCheckbox("squish", this.alignmentTrack.displayMode === "SQUISHED")),
              click: () => {
                  this.alignmentTrack.displayMode = "SQUISHED";
                  this.config.displayMode = "SQUISHED";
                  this.trackView.checkContentHeight();
                  this.trackView.repaintViews();
              }
          });

          return menuItems
      }


      /**
       * Create a "color by" checkbox menu item, optionally initially checked
       * @param menuItem
       * @param showCheck
       * @returns {{init: undefined, name: undefined, click: clickHandler, object: (jQuery|HTMLElement|jQuery.fn.init)}}
       */
      colorByCB(menuItem, showCheck) {
          const $e = $$1(createCheckbox(menuItem.label, showCheck));
          const clickHandler = (ev) => {

              if (menuItem.key !== 'tag') {
                  if (menuItem.key === this.alignmentTrack.colorBy) {
                      this.alignmentTrack.colorBy = 'none';
                      this.config.colorBy = 'none';
                      this.trackView.repaintViews();
                  } else {
                      this.alignmentTrack.colorBy = menuItem.key;
                      this.config.colorBy = menuItem.key;
                      this.trackView.repaintViews();
                  }
              } else {
                  this.browser.inputDialog.present({
                      label: 'Tag Name',
                      value: this.alignmentTrack.colorByTag ? this.alignmentTrack.colorByTag : '',
                      callback: (tag) => {
                          if (tag) {
                              this.alignmentTrack.colorBy = 'tag';
                              this.alignmentTrack.colorByTag = tag;
                              if (!this.alignmentTrack.tagColors) {
                                  this.alignmentTrack.tagColors = new PaletteColorTable("Set1");
                              }
                          } else {
                              this.alignmentTrack.colorBy = 'none';
                              this.alignmentTrack.colorByTag = '';
                          }
                          this.trackView.repaintViews();
                      }
                  }, ev);

              }

          };

          return {name: undefined, object: $e, click: clickHandler, init: undefined}
      }

      /**
       * Return the current state of the track.  Used to create sessions and bookmarks.
       *
       * @returns {*|{}}
       */
      getState() {

          const config = super.getState();

          if (this.sortObject) {
              config.sort = {
                  chr: this.sortObject.chr,
                  position: this.sortObject.position + 1,
                  option: this.sortObject.option,
                  direction: this.sortObject.direction ? "ASC" : "DESC"
              };
          }

          return config
      }

      getCachedAlignmentContainers() {
          return this.trackView.viewports.map(vp => vp.cachedFeatures)
      }

      get dataRange() {
          return this.coverageTrack.dataRange
      }

      set dataRange(dataRange) {
          this.coverageTrack.dataRange = dataRange;
      }

      get logScale() {
          return this.coverageTrack.logScale
      }

      set logScale(logScale) {
          this.coverageTrack.logScale = logScale;
      }

      get autoscale() {
          return this.coverageTrack.autoscale
      }

      set autoscale(autoscale) {
          this.coverageTrack.autoscale = autoscale;
      }

      /**
       * Add chords to the circular view for the given viewport, represented by its reference frame
       * @param refFrame
       */
      addPairedChordsForViewport(viewport) {

          const maxTemplateLength = this.maxTemplateLength;
          const inView = [];
          const refFrame = viewport.referenceFrame;
          for (let a of viewport.cachedFeatures.allAlignments()) {
              if (a.end >= refFrame.start
                  && a.start <= refFrame.end) {
                  if (a.paired) {
                      if (a.end - a.start > maxTemplateLength) {
                          inView.push(a);
                      }
                  } else {
                      if (a.mate
                          && a.mate.chr
                          && (a.mate.chr !== a.chr || Math.max(a.fragmentLength) > maxTemplateLength)) {
                          inView.push(a);
                      }
                  }
              }
          }
          const chords = makePairedAlignmentChords(inView);
          sendChords(chords, this, refFrame, 0.02);

          // const chordSetColor = IGVColor.addAlpha("all" === refFrame.chr ? this.color : getChrColor(refFrame.chr), 0.02)
          // const trackColor = IGVColor.addAlpha(this.color || 'rgb(0,0,255)', 0.02)
          //
          // // name the chord set to include track name and locus
          // const encodedName = this.name.replaceAll(' ', '%20')
          // const chordSetName = "all" === refFrame.chr ? encodedName :
          //     `${encodedName} (${refFrame.chr}:${refFrame.start}-${refFrame.end}`
          // this.browser.circularView.addChords(chords, {name: chordSetName, color: chordSetColor, trackColor: trackColor})
      }

      addSplitChordsForViewport(viewport) {

          const inView = [];
          const refFrame = viewport.referenceFrame;
          for (let a of viewport.cachedFeatures.allAlignments()) {

              const sa = a.hasTag('SA');
              if (a.end >= refFrame.start && a.start <= refFrame.end && sa) {
                  inView.push(a);
              }
          }

          const chords = makeSupplementalAlignmentChords(inView);
          sendChords(chords, this, refFrame, 0.02);

          // const chordSetColor = IGVColor.addAlpha("all" === refFrame.chr ? this.color : getChrColor(refFrame.chr), 0.02)
          // const trackColor = IGVColor.addAlpha(this.color || 'rgb(0,0,255)', 0.02)
          //
          // // name the chord set to include track name and locus
          // const encodedName = this.name.replaceAll(' ', '%20')
          // const chordSetName = "all" === refFrame.chr ? encodedName :
          //     `${encodedName} (${refFrame.chr}:${refFrame.start}-${refFrame.end}`
          // this.browser.circularView.addChords(chords, {name: chordSetName, color: chordSetColor, trackColor: trackColor})
      }
  }


  class CoverageTrack {

      constructor(config, parent) {
          this.parent = parent;
          this.featureSource = parent.featureSource;
          this.height = config.coverageTrackHeight !== undefined ? config.coverageTrackHeight : DEFAULT_COVERAGE_TRACK_HEIGHT;

          this.paintAxis = paintAxis;
          this.top = 0;

          this.autoscale = config.autoscale || config.max === undefined;
          if (!this.autoscale) {
              this.dataRange = {
                  min: config.min || 0,
                  max: config.max
              };
          }

      }

      draw(options) {

          const pixelTop = options.pixelTop;
          pixelTop + options.pixelHeight;
          const nucleotideColors = this.parent.browser.nucleotideColors;

          if (pixelTop > this.height) {
              return //scrolled out of view
          }

          const ctx = options.context;
          const alignmentContainer = options.features;
          const coverageMap = alignmentContainer.coverageMap;

          let sequence;
          if (coverageMap.refSeq) {
              sequence = coverageMap.refSeq.toUpperCase();
          }

          const bpPerPixel = options.bpPerPixel;
          const bpStart = options.bpStart;
          const pixelWidth = options.pixelWidth;
          const bpEnd = bpStart + pixelWidth * bpPerPixel + 1;

          // paint for all coverage buckets
          // If alignment track color is != default, use it
          let color;
          if (this.parent.coverageColor) {
              color = this.parent.coverageColor;
          } else if (this.parent.color !== undefined && typeof this.parent.color !== "function") {
              color = IGVColor.darkenLighten(this.parent.color, -35);
          } else {
              color = DEFAULT_COVERAGE_COLOR;
          }
          IGVGraphics.setProperties(ctx, {
              fillStyle: color,
              strokeStyle: color
          });

          const w = Math.max(1, Math.ceil(1.0 / bpPerPixel));
          for (let i = 0, len = coverageMap.coverage.length; i < len; i++) {

              const bp = (coverageMap.bpStart + i);
              if (bp < bpStart) continue
              if (bp > bpEnd) break

              const item = coverageMap.coverage[i];
              if (!item) continue

              const h = Math.round((item.total / this.dataRange.max) * this.height);
              const y = this.height - h;
              const x = Math.floor((bp - bpStart) / bpPerPixel);


              // IGVGraphics.setProperties(ctx, {fillStyle: "rgba(0, 200, 0, 0.25)", strokeStyle: "rgba(0, 200, 0, 0.25)" });
              IGVGraphics.fillRect(ctx, x, y, w, h);
          }

          // coverage mismatch coloring -- don't try to do this in above loop, color bar will be overwritten when w<1
          if (sequence) {
              for (let i = 0, len = coverageMap.coverage.length; i < len; i++) {

                  const bp = (coverageMap.bpStart + i);
                  if (bp < bpStart) continue
                  if (bp > bpEnd) break

                  const item = coverageMap.coverage[i];
                  if (!item) continue

                  const h = (item.total / this.dataRange.max) * this.height;
                  let y = this.height - h;
                  const x = Math.floor((bp - bpStart) / bpPerPixel);

                  const refBase = sequence[i];
                  if (item.isMismatch(refBase)) {
                      IGVGraphics.setProperties(ctx, {fillStyle: nucleotideColors[refBase]});
                      IGVGraphics.fillRect(ctx, x, y, w, h);

                      let accumulatedHeight = 0.0;
                      for (let nucleotide of ["A", "C", "T", "G"]) {

                          const count = item["pos" + nucleotide] + item["neg" + nucleotide];

                          // non-logoritmic
                          const hh = (count / this.dataRange.max) * this.height;
                          y = (this.height - hh) - accumulatedHeight;
                          accumulatedHeight += hh;
                          IGVGraphics.setProperties(ctx, {fillStyle: nucleotideColors[nucleotide]});
                          IGVGraphics.fillRect(ctx, x, y, w, hh);
                      }
                  }
              }
          }
      }

      getClickedObject(clickState) {

          let features = clickState.viewport.cachedFeatures;
          if (!features || features.length === 0) return

          const genomicLocation = Math.floor(clickState.genomicLocation);
          const coverageMap = features.coverageMap;
          const coverageMapIndex = Math.floor(genomicLocation - coverageMap.bpStart);
          return coverageMap.coverage[coverageMapIndex]
      }

      popupData(clickState) {

          const nameValues = [];

          const coverage = this.getClickedObject(clickState);
          if (coverage) {
              const genomicLocation = Math.floor(clickState.genomicLocation);
              const referenceFrame = clickState.viewport.referenceFrame;

              nameValues.push(referenceFrame.chr + ":" + numberFormatter$1(1 + genomicLocation));

              nameValues.push({name: 'Total Count', value: coverage.total});

              // A
              let tmp = coverage.posA + coverage.negA;
              if (tmp > 0) tmp = tmp.toString() + " (" + Math.round((tmp / coverage.total) * 100.0) + "%, " + coverage.posA + "+, " + coverage.negA + "- )";
              nameValues.push({name: 'A', value: tmp});

              // C
              tmp = coverage.posC + coverage.negC;
              if (tmp > 0) tmp = tmp.toString() + " (" + Math.round((tmp / coverage.total) * 100.0) + "%, " + coverage.posC + "+, " + coverage.negC + "- )";
              nameValues.push({name: 'C', value: tmp});

              // G
              tmp = coverage.posG + coverage.negG;
              if (tmp > 0) tmp = tmp.toString() + " (" + Math.round((tmp / coverage.total) * 100.0) + "%, " + coverage.posG + "+, " + coverage.negG + "- )";
              nameValues.push({name: 'G', value: tmp});

              // T
              tmp = coverage.posT + coverage.negT;
              if (tmp > 0) tmp = tmp.toString() + " (" + Math.round((tmp / coverage.total) * 100.0) + "%, " + coverage.posT + "+, " + coverage.negT + "- )";
              nameValues.push({name: 'T', value: tmp});

              // N
              tmp = coverage.posN + coverage.negN;
              if (tmp > 0) tmp = tmp.toString() + " (" + Math.round((tmp / coverage.total) * 100.0) + "%, " + coverage.posN + "+, " + coverage.negN + "- )";
              nameValues.push({name: 'N', value: tmp});

              nameValues.push('<HR/>');
              nameValues.push({name: 'DEL', value: coverage.del.toString()});
              nameValues.push({name: 'INS', value: coverage.ins.toString()});
          }

          return nameValues

      }

  }

  class AlignmentTrack {

      constructor(config, parent) {

          this.parent = parent;
          this.browser = parent.browser;
          this.featureSource = parent.featureSource;
          this.top = 0 === config.coverageTrackHeight ? 0 : config.coverageTrackHeight + 5;
          this.displayMode = config.displayMode || "EXPANDED";
          this.alignmentRowHeight = config.alignmentRowHeight || 14;
          this.squishedRowHeight = config.squishedRowHeight || 3;

          this.negStrandColor = config.negStrandColor || "rgba(150, 150, 230, 0.75)";
          this.posStrandColor = config.posStrandColor || "rgba(230, 150, 150, 0.75)";
          this.insertionColor = config.insertionColor || "rgb(138, 94, 161)";
          this.insertionTextColor = config.insertionTextColor || "white";
          this.showInsertionText = config.showInsertionText === undefined ? false : !!config.showInsertionText;
          this.deletionColor = config.deletionColor || "black";
          this.deletionTextColor = config.deletionTextColor || "black";
          this.showDeletionText = config.showDeletionText === undefined ? false : !!config.showDeletionText;
          this.skippedColor = config.skippedColor || "rgb(150, 170, 170)";
          this.pairConnectorColor = config.pairConnectorColor;

          this.smallTLENColor = config.smallTLENColor || config.smallFragmentLengthColor || "rgb(0, 0, 150)";
          this.largeTLENColor = config.largeTLENColor || config.largeFragmentLengthColor || "rgb(200, 0, 0)";

          this.pairOrientation = config.pairOrienation || 'fr';
          this.pairColors = {};
          this.pairColors["RL"] = config.rlColor || "rgb(0, 150, 0)";
          this.pairColors["RR"] = config.rrColor || "rgb(20, 50, 200)";
          this.pairColors["LL"] = config.llColor || "rgb(0, 150, 150)";

          this.colorBy = config.colorBy || "unexpectedPair";
          this.colorByTag = config.colorByTag ? config.colorByTag.toUpperCase() : undefined;
          this.bamColorTag = config.bamColorTag === undefined ? "YC" : config.bamColorTag;

          this.hideSmallIndels = config.hideSmallIndels;
          this.indelSizeThreshold = config.indelSizeThreshold || 1;

          this.hasPairs = false;   // Until proven otherwise
          this.hasSupplemental = false;
      }

      setTop(coverageTrack, showCoverage) {
          this.top = (0 === coverageTrack.height || false === showCoverage) ? 0 : (5 + coverageTrack.height);
      }

      /**
       * Compute the pixel height required to display all content.
       *
       * @param alignmentContainer
       * @returns {number|*}
       */
      computePixelHeight(alignmentContainer) {

          if (alignmentContainer.packedAlignmentRows) {
              const h = alignmentContainer.hasDownsampledIntervals() ? downsampleRowHeight + alignmentStartGap : 0;
              const alignmentRowHeight = this.displayMode === "SQUISHED" ?
                  this.squishedRowHeight :
                  this.alignmentRowHeight;
              return h + (alignmentRowHeight * alignmentContainer.packedAlignmentRows.length) + 5
          } else {
              return 0
          }
      }

      draw(options) {

          const alignmentContainer = options.features;
          const ctx = options.context;
          const bpPerPixel = options.bpPerPixel;
          const bpStart = options.bpStart;
          const pixelWidth = options.pixelWidth;
          const bpEnd = bpStart + pixelWidth * bpPerPixel + 1;
          const showSoftClips = this.parent.showSoftClips;
          const showAllBases = this.parent.showAllBases;
          const nucleotideColors = this.browser.nucleotideColors;

          //alignmentContainer.repack(bpPerPixel, showSoftClips);
          const packedAlignmentRows = alignmentContainer.packedAlignmentRows;


          ctx.save();

          let referenceSequence = alignmentContainer.sequence;
          if (referenceSequence) {
              referenceSequence = referenceSequence.toUpperCase();
          }
          let alignmentRowYInset = 0;

          let pixelTop = options.pixelTop;
          if (this.top) {
              ctx.translate(0, this.top);
          }
          const pixelBottom = pixelTop + options.pixelHeight;

          if (alignmentContainer.hasDownsampledIntervals()) {
              alignmentRowYInset = downsampleRowHeight + alignmentStartGap;

              alignmentContainer.downsampledIntervals.forEach(function (interval) {
                  var xBlockStart = (interval.start - bpStart) / bpPerPixel,
                      xBlockEnd = (interval.end - bpStart) / bpPerPixel;

                  if (xBlockEnd - xBlockStart > 5) {
                      xBlockStart += 1;
                      xBlockEnd -= 1;
                  }
                  IGVGraphics.fillRect(ctx, xBlockStart, 2, (xBlockEnd - xBlockStart), downsampleRowHeight - 2, {fillStyle: "black"});
              });

          } else {
              alignmentRowYInset = 0;
          }

          // Transient variable -- rewritten on every draw, used for click object selection
          this.alignmentsYOffset = alignmentRowYInset;
          const alignmentRowHeight = this.displayMode === "SQUISHED" ?
              this.squishedRowHeight :
              this.alignmentRowHeight;

          if (packedAlignmentRows) {

              const nRows = packedAlignmentRows.length;

              for (let rowIndex = 0; rowIndex < nRows; rowIndex++) {

                  const alignmentRow = packedAlignmentRows[rowIndex];
                  const alignmentY = alignmentRowYInset + (alignmentRowHeight * rowIndex);
                  const alignmentHeight = alignmentRowHeight <= 4 ? alignmentRowHeight : alignmentRowHeight - 2;

                  if (alignmentY > pixelBottom) {
                      break
                  } else if (alignmentY + alignmentHeight < pixelTop) {
                      continue
                  }

                  for (let alignment of alignmentRow.alignments) {

                      this.hasPairs = this.hasPairs || alignment.isPaired();
                      if (this.browser.circularView) {
                          // This is an expensive check, only do it if needed
                          this.hasSupplemental = this.hasSupplemental || alignment.hasTag('SA');
                      }

                      if ((alignment.start + alignment.lengthOnRef) < bpStart) continue
                      if (alignment.start > bpEnd) break
                      if (true === alignment.hidden) {
                          continue
                      }

                      if (alignment instanceof PairedAlignment) {

                          drawPairConnector.call(this, alignment, alignmentY, alignmentHeight);

                          drawSingleAlignment.call(this, alignment.firstAlignment, alignmentY, alignmentHeight);

                          if (alignment.secondAlignment) {
                              drawSingleAlignment.call(this, alignment.secondAlignment, alignmentY, alignmentHeight);
                          }

                      } else {
                          drawSingleAlignment.call(this, alignment, alignmentY, alignmentHeight);
                      }

                  }
              }
          }
          ctx.restore();

          // alignment is a PairedAlignment
          function drawPairConnector(alignment, yRect, alignmentHeight) {

              var connectorColor = this.getConnectorColor(alignment.firstAlignment),
                  xBlockStart = (alignment.connectingStart - bpStart) / bpPerPixel,
                  xBlockEnd = (alignment.connectingEnd - bpStart) / bpPerPixel,
                  yStrokedLine = yRect + alignmentHeight / 2;

              if ((alignment.connectingEnd) < bpStart || alignment.connectingStart > bpEnd) {
                  return
              }
              if (alignment.mq <= 0) {
                  connectorColor = IGVColor.addAlpha(connectorColor, 0.15);
              }
              IGVGraphics.setProperties(ctx, {fillStyle: connectorColor, strokeStyle: connectorColor});
              IGVGraphics.strokeLine(ctx, xBlockStart, yStrokedLine, xBlockEnd, yStrokedLine);

          }

          function drawSingleAlignment(alignment, yRect, alignmentHeight) {


              if ((alignment.start + alignment.lengthOnRef) < bpStart || alignment.start > bpEnd) {
                  return
              }

              const blocks = showSoftClips ? alignment.blocks : alignment.blocks.filter(b => 'S' !== b.type);

              let alignmentColor = this.getAlignmentColor(alignment);
              const outlineColor = alignmentColor;
              if (alignment.mq <= 0) {
                  alignmentColor = IGVColor.addAlpha(alignmentColor, 0.15);
              }
              IGVGraphics.setProperties(ctx, {fillStyle: alignmentColor, strokeStyle: outlineColor});

              // Save bases to draw into an array for later drawing, so they can be overlaid on insertion blocks,
              // which is relevant if we have insertions with size label
              const basesToDraw = [];

              for (let b = 0; b < blocks.length; b++) {   // Can't use forEach here -- we need ability to break

                  const block = blocks[b];

                  // Somewhat complex test, neccessary to insure gaps are drawn.
                  // If this is not the last block, and the next block starts before the orign (off screen to left) then skip.
                  if ((b !== blocks.length - 1) && blocks[b + 1].start < bpStart) continue

                  // drawBlock returns bases to draw, which are drawn on top of insertion blocks (if they're wider than
                  // the space between two bases) like in Java IGV
                  basesToDraw.push(...drawBlock.call(this, block, b));

                  if ((block.start + block.len) > bpEnd) {
                      // Do this after drawBlock to insure gaps are drawn
                      break
                  }
              }

              if (alignment.gaps) {
                  const yStrokedLine = yRect + alignmentHeight / 2;
                  for (let gap of alignment.gaps) {
                      const sPixel = (gap.start - bpStart) / bpPerPixel;
                      const ePixel = ((gap.start + gap.len) - bpStart) / bpPerPixel;
                      const lineWidth = ePixel - sPixel;
                      const gapLenText = gap.len.toString();
                      const gapTextWidth = gapLenText.length * 6;
                      const gapCenter = sPixel + (lineWidth / 2);

                      const color = ("D" === gap.type) ? this.deletionColor : this.skippedColor;

                      IGVGraphics.strokeLine(ctx, sPixel, yStrokedLine, ePixel, yStrokedLine, {
                          strokeStyle: color,
                          lineWidth: 2,
                      });

                      // Add gap width as text like Java IGV if it fits nicely and is a multi-base gap
                      if (this.showDeletionText && gap.len > 1 && lineWidth >= gapTextWidth + 8) {
                          const textStart = gapCenter - (gapTextWidth / 2);
                          IGVGraphics.fillRect(ctx, textStart - 1, yRect - 1, gapTextWidth + 2, 12, {fillStyle: "white"});
                          IGVGraphics.fillText(ctx, gapLenText, textStart, yRect + 10, {
                              'font': 'normal 10px monospace',
                              'fillStyle': this.deletionTextColor,
                          });
                      }
                  }
              }

              if (alignment.insertions && this.parent.showInsertions) {
                  let lastXBlockStart = -1;
                  for (let insertionBlock of alignment.insertions) {
                      if (this.hideSmallIndels && insertionBlock.len <= this.indelSizeThreshold) {
                          continue
                      }
                      if (insertionBlock.start < bpStart) {
                          continue
                      }
                      if (insertionBlock.start > bpEnd) {
                          break
                      }

                      const refOffset = insertionBlock.start - bpStart;
                      const insertLenText = insertionBlock.len.toString();

                      const textPixelWidth = 2 + (insertLenText.length * 6);
                      const basePixelWidth = (!this.showInsertionText || insertionBlock.len === 1)
                          ? 2
                          : Math.round(insertionBlock.len / bpPerPixel);
                      const widthBlock = Math.max(Math.min(textPixelWidth, basePixelWidth), 2);

                      const xBlockStart = (refOffset / bpPerPixel) - (widthBlock / 2);
                      if ((xBlockStart - lastXBlockStart) > 2) {
                          const props = {fillStyle: this.insertionColor};

                          // Draw decorations like Java IGV to make an 'I' shape
                          IGVGraphics.fillRect(ctx, xBlockStart - 2, yRect, widthBlock + 4, 2, props);
                          IGVGraphics.fillRect(ctx, xBlockStart, yRect + 2, widthBlock, alignmentHeight - 4, props);
                          IGVGraphics.fillRect(ctx, xBlockStart - 2, yRect + alignmentHeight - 2, widthBlock + 4, 2, props);

                          // Show # of inserted bases as text if it's a multi-base insertion and the insertion block
                          // is wide enough to hold text (its size is capped at the text label size, but can be smaller
                          // if the browser is zoomed out and the insertion is small)
                          if (this.showInsertionText && insertionBlock.len > 1 && basePixelWidth > textPixelWidth) {
                              IGVGraphics.fillText(ctx, insertLenText, xBlockStart + 1, yRect + 10, {
                                  'font': 'normal 10px monospace',
                                  'fillStyle': this.insertionTextColor,
                              });
                          }
                          lastXBlockStart = xBlockStart;
                      }
                  }
              }

              basesToDraw.forEach(({bbox, baseColor, readChar}) => {
                  renderBlockOrReadChar(ctx, bpPerPixel, bbox, baseColor, readChar);
              });


              function drawBlock(block, b) {
                  // Collect bases to draw for later rendering
                  const blockBasesToDraw = [];

                  const offsetBP = block.start - alignmentContainer.start;
                  const blockStartPixel = (block.start - bpStart) / bpPerPixel;
                  const blockEndPixel = ((block.start + block.len) - bpStart) / bpPerPixel;
                  const blockWidthPixel = Math.max(1, blockEndPixel - blockStartPixel);

                  //const arrowHeadWidthPixel = alignmentRowHeight / 2.0;
                  const nomPixelWidthOnRef = 100 / bpPerPixel;
                  const arrowHeadWidthPixel = Math.min(alignmentRowHeight / 2.0, nomPixelWidthOnRef / 6);

                  const isSoftClip = 'S' === block.type;

                  const strokeOutline =
                      alignment.mq <= 0 ||
                      this.highlightedAlignmentReadNamed === alignment.readName ||
                      isSoftClip;

                  let blockOutlineColor = outlineColor;
                  if (this.highlightedAlignmentReadNamed === alignment.readName) blockOutlineColor = 'red';
                  else if (isSoftClip) blockOutlineColor = 'rgb(50,50,50)';

                  const lastBlockPositiveStrand = (true === alignment.strand && b === blocks.length - 1);
                  const lastBlockReverseStrand = (false === alignment.strand && b === 0);
                  const lastBlock = lastBlockPositiveStrand | lastBlockReverseStrand;

                  if (lastBlock) {
                      let xListPixel;
                      let yListPixel;
                      if (lastBlockPositiveStrand) {
                          xListPixel = [
                              blockStartPixel,
                              blockEndPixel,
                              blockEndPixel + arrowHeadWidthPixel,
                              blockEndPixel,
                              blockStartPixel,
                              blockStartPixel];
                          yListPixel = [
                              yRect,
                              yRect,
                              yRect + (alignmentHeight / 2.0),
                              yRect + alignmentHeight,
                              yRect + alignmentHeight,
                              yRect];

                      }

                      // Last block on - strand ?
                      else if (lastBlockReverseStrand) {
                          xListPixel = [
                              blockEndPixel,
                              blockStartPixel,
                              blockStartPixel - arrowHeadWidthPixel,
                              blockStartPixel,
                              blockEndPixel,
                              blockEndPixel];
                          yListPixel = [
                              yRect,
                              yRect,
                              yRect + (alignmentHeight / 2.0),
                              yRect + alignmentHeight,
                              yRect + alignmentHeight,
                              yRect];

                      }
                      IGVGraphics.fillPolygon(ctx, xListPixel, yListPixel, {fillStyle: alignmentColor});

                      if (strokeOutline) {
                          IGVGraphics.strokePolygon(ctx, xListPixel, yListPixel, {strokeStyle: blockOutlineColor});
                      }
                  }

                  // Internal block
                  else {
                      IGVGraphics.fillRect(ctx, blockStartPixel, yRect, blockWidthPixel, alignmentHeight, {fillStyle: alignmentColor});

                      if (strokeOutline) {
                          ctx.save();
                          ctx.strokeStyle = blockOutlineColor;
                          ctx.strokeRect(blockStartPixel, yRect, blockWidthPixel, alignmentHeight);
                          ctx.restore();
                      }
                  }


                  // Read base coloring

                  if (isSoftClip ||
                      showAllBases ||
                      this.parent.showMismatches && (referenceSequence && alignment.seq && alignment.seq !== "*")) {

                      const seq = alignment.seq ? alignment.seq.toUpperCase() : undefined;
                      const qual = alignment.qual;
                      const seqOffset = block.seqOffset;
                      const widthPixel = Math.max(1, 1 / bpPerPixel);


                      for (let i = 0, len = block.len; i < len; i++) {

                          const xPixel = ((block.start + i) - bpStart) / bpPerPixel;

                          if (xPixel + widthPixel < 0) continue   // Off left edge
                          if (xPixel > pixelWidth) break  // Off right edge

                          let readChar = seq ? seq.charAt(seqOffset + i) : '';
                          const refChar = offsetBP + i >= 0 ? referenceSequence.charAt(offsetBP + i) : '';

                          if (readChar === "=") {
                              readChar = refChar;
                          }
                          if (readChar === "X" || refChar !== readChar || isSoftClip || showAllBases) {

                              let baseColor;
                              if (!isSoftClip && qual !== undefined && qual.length > seqOffset + i) {
                                  const readQual = qual[seqOffset + i];
                                  baseColor = shadedBaseColor(readQual, nucleotideColors[readChar]);
                              } else {
                                  baseColor = nucleotideColors[readChar];
                              }
                              if (baseColor) {
                                  blockBasesToDraw.push({
                                      bbox: {
                                          x: xPixel,
                                          y: yRect,
                                          width: widthPixel,
                                          height: alignmentHeight
                                      },
                                      baseColor,
                                      readChar,
                                  });
                              }
                          }
                      }
                  }

                  return blockBasesToDraw
              }

              function renderBlockOrReadChar(context, bpp, bbox, color, char) {
                  var threshold,
                      center;

                  threshold = 1.0 / 10.0;
                  if (bpp <= threshold && bbox.height >= 8) {

                      // render letter
                      const fontHeight = Math.min(10, bbox.height);
                      context.font = '' + fontHeight + 'px sans-serif';
                      center = bbox.x + (bbox.width / 2.0);
                      IGVGraphics.strokeText(context, char, center - (context.measureText(char).width / 2), fontHeight - 1 + bbox.y, {strokeStyle: color});
                  } else {

                      // render colored block
                      IGVGraphics.fillRect(context, bbox.x, bbox.y, bbox.width, bbox.height, {fillStyle: color});
                  }
              }
          }

      };

      popupData(clickState) {
          const clickedObject = this.getClickedObject(clickState);
          return clickedObject ? clickedObject.popupData(clickState.genomicLocation) : undefined
      };

      contextMenuItemList(clickState) {

          const viewport = clickState.viewport;
          const list = [];

          const sortByOption = (option) => {
              const cs = this.parent.sortObject;
              const direction = (cs && cs.position === Math.floor(clickState.genomicLocation)) ? !cs.direction : true;
              const newSortObject = {
                  chr: viewport.referenceFrame.chr,
                  position: Math.floor(clickState.genomicLocation),
                  option: option,
                  direction: direction
              };
              this.parent.sortObject = newSortObject;
              viewport.cachedFeatures.sortRows(newSortObject);
              viewport.repaint();
          };
          list.push('<b>Sort by...</b>');
          list.push({label: '&nbsp; base', click: () => sortByOption("BASE")});
          list.push({label: '&nbsp; read strand', click: () => sortByOption("STRAND")});
          list.push({label: '&nbsp; insert size', click: () => sortByOption("INSERT_SIZE")});
          list.push({label: '&nbsp; gap size', click: () => sortByOption("GAP_SIZE")});
          list.push({label: '&nbsp; chromosome of mate', click: () => sortByOption("MATE_CHR")});
          list.push({label: '&nbsp; mapping quality', click: () => sortByOption("MQ")});
          list.push({label: '&nbsp; read name', click: () => sortByOption("READ_NAME")});
          list.push({label: '&nbsp; aligned read length', click: () => sortByOption("ALIGNED_READ_LENGTH")});
          list.push({
              label: '&nbsp; tag', click: () => {
                  const cs = this.parent.sortObject;
                  const direction = (cs && cs.position === Math.floor(clickState.genomicLocation)) ? !cs.direction : true;
                  const config =
                      {
                          label: 'Tag Name',
                          value: this.sortByTag ? this.sortByTag : '',
                          callback: (tag) => {
                              if (tag) {
                                  const newSortObject = {
                                      chr: viewport.referenceFrame.chr,
                                      position: Math.floor(clickState.genomicLocation),
                                      option: "TAG",
                                      tag: tag,
                                      direction: direction
                                  };
                                  this.sortByTag = tag;
                                  this.parent.sortObject = newSortObject;
                                  viewport.cachedFeatures.sortRows(newSortObject);
                                  viewport.repaint();
                              }
                          }
                      };
                  this.browser.inputDialog.present(config, clickState.event);
              }
          });
          list.push('<hr/>');

          const clickedObject = this.getClickedObject(clickState);

          if (clickedObject) {

              const showSoftClips = this.parent.showSoftClips;
              const clickedAlignment = (typeof clickedObject.alignmentContaining === 'function') ?
                  clickedObject.alignmentContaining(clickState.genomicLocation, showSoftClips) :
                  clickedObject;
              if (clickedAlignment) {
                  if (clickedAlignment.isPaired() && clickedAlignment.isMateMapped()) {
                      list.push({
                          label: 'View mate in split screen',
                          click: () => {
                              if (clickedAlignment.mate) {
                                  const referenceFrame = clickState.viewport.referenceFrame;
                                  if (this.browser.genome.getChromosome(clickedAlignment.mate.chr)) {
                                      this.highlightedAlignmentReadNamed = clickedAlignment.readName;
                                      //this.browser.presentMultiLocusPanel(clickedAlignment, referenceFrame)
                                      const bpWidth = referenceFrame.end - referenceFrame.start;
                                      const frameStart = clickedAlignment.mate.position - bpWidth / 2;
                                      const frameEnd = clickedAlignment.mate.position + bpWidth / 2;
                                      this.browser.addMultiLocusPanel(clickedAlignment.mate.chr, frameStart, frameEnd, referenceFrame);
                                  } else {
                                      this.browser.alert.present(`Reference does not contain chromosome: ${clickedAlignment.mate.chr}`);
                                  }
                              }
                          },
                          init: undefined
                      });
                  }

                  list.push({
                      label: 'View read sequence',
                      click: () => {
                          const seqstring = clickedAlignment.seq; //.map(b => String.fromCharCode(b)).join("");
                          if (!seqstring || "*" === seqstring) {
                              this.browser.alert.present("Read sequence: *");
                          } else {
                              this.browser.alert.present(seqstring);
                          }
                      }
                  });

                  if (isSecureContext()) {
                      list.push({
                          label: 'Copy read sequence',
                          click: async () => {
                              const seq = clickedAlignment.seq; //.map(b => String.fromCharCode(b)).join("");
                              try {
                                  //console.log(`seq: ${seq}`)
                                  await navigator.clipboard.writeText(seq);
                              } catch (e) {
                                  console.error(e);
                                  this.browser.alert.present(`error copying sequence to clipboard ${e}`);
                              }

                          }
                      });
                  }

                  // TODO if genome supports blat
                  const seqstring = clickedAlignment.seq;
                  if (seqstring && "*" != seqstring) {
                      list.push({
                          label: 'BLAT read sequence',
                          click: () => {
                              const sequence = clickedAlignment.isNegativeStrand() ? reverseComplementSequence(seqstring) : seqstring;
                              const name = `${clickedAlignment.readName} - blat`;
                              const title = `${this.parent.name} - ${name}`;
                              createBlatTrack({sequence, browser: this.browser, name, title});
                          }
                      });

                      const softClips = clickedAlignment.softClippedBlocks();
                      if (softClips.left && softClips.left.len > MINIMUM_BLAT_LENGTH) {
                          list.push({
                              label: 'BLAT left soft-clipped sequence',
                              click: () => {
                                  const clippedSequence = seqstring.substr(softClips.left.seqOffset, softClips.left.len);
                                  const sequence = clickedAlignment.isNegativeStrand() ? reverseComplementSequence(clippedSequence) : clippedSequence;
                                  const name = `${clickedAlignment.readName} - blat left clip`;
                                  const title = `${this.parent.name} - ${name}`;
                                  createBlatTrack({sequence, browser: this.browser, name, title});
                              }
                          });
                      }
                      if (softClips.right && softClips.right.length > MINIMUM_BLAT_LENGTH) {
                          list.push({
                              label: 'BLAT right soft-clipped sequence',
                              click: () => {
                                  const clippedSequence = seqstring.substr(softClips.right.seqOffset, softClips.right.len);
                                  const sequence = clickedAlignment.isNegativeStrand() ? reverseComplementSequence(clippedSequence) : clippedSequence;
                                  const name = `${clickedAlignment.readName} - blat right clip`;
                                  const title = `${this.parent.name} - ${name}`;
                                  createBlatTrack({sequence, browser: this.browser, name, title});
                              }
                          });
                      }
                  }

                  list.push('<hr/>');
              }
          }

          // Experimental JBrowse feature
          if (this.browser.circularView && (this.hasPairs || this.hasSupplemental)) {
              if (this.hasPairs) {
                  list.push({
                      label: 'Add discordant pairs to circular view',
                      click: () => {
                          this.parent.addPairedChordsForViewport(viewport);
                      }
                  });
              }
              if (this.hasSupplemental) {
                  list.push({
                      label: 'Add split reads to circular view',
                      click: () => {
                          this.parent.addSplitChordsForViewport(viewport);
                      }
                  });
              }
              list.push('<hr/>');
          }

          return list

      }

      getClickedObject(clickState) {

          const viewport = clickState.viewport;
          const y = clickState.y;
          const genomicLocation = clickState.genomicLocation;

          const showSoftClips = this.parent.showSoftClips;

          let features = viewport.cachedFeatures;
          if (!features || features.length === 0) return

          let packedAlignmentRows = features.packedAlignmentRows;
          let downsampledIntervals = features.downsampledIntervals;
          const alignmentRowHeight = this.displayMode === "SQUISHED" ?
              this.squishedRowHeight :
              this.alignmentRowHeight;

          let packedAlignmentsIndex = Math.floor((y - this.top - this.alignmentsYOffset) / alignmentRowHeight);

          if (packedAlignmentsIndex < 0) {
              for (let i = 0; i < downsampledIntervals.length; i++) {
                  if (downsampledIntervals[i].start <= genomicLocation && (downsampledIntervals[i].end >= genomicLocation)) {
                      return downsampledIntervals[i]
                  }
              }
          } else if (packedAlignmentsIndex < packedAlignmentRows.length) {
              const alignmentRow = packedAlignmentRows[packedAlignmentsIndex];
              const clicked = alignmentRow.alignments.filter(alignment => alignment.containsLocation(genomicLocation, showSoftClips));
              if (clicked.length > 0) return clicked[0]
          }

          return undefined

      };

      /**
       * Return the color for connectors in paired alignment view.   If explicitly set return that, otherwise return
       * the alignment color, unless the color option can result in split colors (separte color for each mate).
       *
       * @param alignment
       * @returns {string}
       */
      getConnectorColor(alignment) {

          if (this.pairConnectorColor) {
              return this.pairConnectorColor
          }

          switch (this.colorBy) {
              case "strand":
              case "firstOfPairStrand":
              case "pairOrientation":
              case "tag":
                  if (this.parent.color) {
                      return (typeof this.parent.color === "function") ? this.parent.color(alignment) : this.parent.color
                  }
                  return DEFAULT_CONNECTOR_COLOR
              default:
                  return this.getAlignmentColor(alignment)

          }
      }

      getAlignmentColor(alignment) {

          let color = DEFAULT_ALIGNMENT_COLOR;   // The default color if nothing else applies
          if (this.parent.color) {
              color = (typeof this.parent.color === "function") ? this.parent.color(alignment) : this.parent.color;
          }
          const option = this.colorBy;
          switch (option) {
              case "strand":
                  color = alignment.strand ? this.posStrandColor : this.negStrandColor;
                  break

              case "firstOfPairStrand":

                  if (alignment instanceof PairedAlignment) {
                      color = alignment.firstOfPairStrand() ? this.posStrandColor : this.negStrandColor;
                  } else if (alignment.isPaired()) {

                      if (alignment.isFirstOfPair()) {
                          color = alignment.strand ? this.posStrandColor : this.negStrandColor;
                      } else if (alignment.isSecondOfPair()) {
                          color = alignment.strand ? this.negStrandColor : this.posStrandColor;
                      } else {
                          console.error("ERROR. Paired alignments are either first or second.");
                      }
                  }
                  break

              case "unexpectedPair":
              case "pairOrientation":

                  if (this.pairOrientation && alignment.pairOrientation) {
                      const oTypes = orientationTypes[this.pairOrientation];
                      if (oTypes) {
                          const pairColor = this.pairColors[oTypes[alignment.pairOrientation]];
                          if (pairColor) {
                              color = pairColor;
                              break
                          }
                      }
                  }
                  if ("pairOrientation" === option) {
                      break
                  }

              case "tlen":
              case "fragmentLength":

                  if (alignment.mate && alignment.isMateMapped()) {
                      if (alignment.mate.chr !== alignment.chr) {
                          color = getChrColor(alignment.mate.chr);
                      } else if (this.parent.minTemplateLength && Math.abs(alignment.fragmentLength) < this.parent.minTemplateLength) {
                          color = this.smallTLENColor;
                      } else if (this.parent.maxTemplateLength && Math.abs(alignment.fragmentLength) > this.parent.maxTemplateLength) {
                          color = this.largeTLENColor;
                      }
                  }
                  break

              case "tag":
                  const tagValue = alignment.tags()[this.colorByTag];
                  if (tagValue !== undefined) {
                      if (this.bamColorTag === this.colorByTag) {
                          // UCSC style color option
                          color = "rgb(" + tagValue + ")";
                      } else {

                          if (!this.tagColors) {
                              this.tagColors = new PaletteColorTable("Set1");
                          }
                          color = this.tagColors.getColor(tagValue);
                      }
                  }
                  break
          }

          return color

      }
  }

  function shadedBaseColor(qual, baseColor) {

      const minQ = 5;   //prefs.getAsInt(PreferenceManager.SAM_BASE_QUALITY_MIN),
      const maxQ = 20;  //prefs.getAsInt(PreferenceManager.SAM_BASE_QUALITY_MAX);

      let alpha;
      if (qual < minQ) {
          alpha = 0.1;
      } else {
          alpha = Math.max(0.1, Math.min(1.0, 0.1 + 0.9 * (qual - minQ) / (maxQ - minQ)));
      }
      // Round alpha to nearest 0.1
      alpha = Math.round(alpha * 10) / 10.0;

      if (alpha < 1) {
          baseColor = IGVColor.addAlpha(baseColor, alpha);
      }
      return baseColor
  }

  const orientationTypes = {

      "fr": {
          "F1R2": "LR",
          "F2R1": "LR",
          "F1F2": "LL",
          "F2F1": "LL",
          "R1R2": "RR",
          "R2R1": "RR",
          "R1F2": "RL",
          "R2F1": "RL"
      },

      "rf": {
          "R1F2": "LR",
          "R2F1": "LR",
          "R1R2": "LL",
          "R2R1": "LL",
          "F1F2": "RR",
          "F2F1": "RR",
          "F1R2": "RL",
          "F2R1": "RL"
      },

      "ff": {
          "F2F1": "LR",
          "R1R2": "LR",
          "F2R1": "LL",
          "R1F2": "LL",
          "R2F1": "RR",
          "F1R2": "RR",
          "R2R1": "RL",
          "F1F2": "RL"
      }
  };

  function getChrColor(chr) {
      if (chrColorMap[chr]) {
          return chrColorMap[chr]
      } else if (chrColorMap["chr" + chr]) {
          const color = chrColorMap["chr" + chr];
          chrColorMap[chr] = color;
          return color
      } else {
          const color = IGVColor.randomRGB(0, 255);
          chrColorMap[chr] = color;
          return color
      }
  }

  const chrColorMap = {
      "chrX": "rgb(204, 153, 0)",
      "chrY": "rgb(153, 204, 0)",
      "chrUn": "rgb(50, 50, 50)",
      "chr1": "rgb(80, 80, 255)",
      "chrI": "rgb(139, 155, 187)",
      "chr2": "rgb(206, 61, 50)",
      "chrII": "rgb(206, 61, 50)",
      "chr2a": "rgb(216, 71, 60)",
      "chr2b": "rgb(226, 81, 70)",
      "chr3": "rgb(116, 155, 88)",
      "chrIII": "rgb(116, 155, 88)",
      "chr4": "rgb(240, 230, 133)",
      "chrIV": "rgb(240, 230, 133)",
      "chr5": "rgb(70, 105, 131)",
      "chr6": "rgb(186, 99, 56)",
      "chr7": "rgb(93, 177, 221)",
      "chr8": "rgb(128, 34, 104)",
      "chr9": "rgb(107, 215, 107)",
      "chr10": "rgb(213, 149, 167)",
      "chr11": "rgb(146, 72, 34)",
      "chr12": "rgb(131, 123, 141)",
      "chr13": "rgb(199, 81, 39)",
      "chr14": "rgb(213, 143, 92)",
      "chr15": "rgb(122, 101, 165)",
      "chr16": "rgb(228, 175, 105)",
      "chr17": "rgb(59, 27, 83)",
      "chr18": "rgb(205, 222, 183)",
      "chr19": "rgb(97, 42, 121)",
      "chr20": "rgb(174, 31, 99)",
      "chr21": "rgb(231, 199, 111)",
      "chr22": "rgb(90, 101, 94)",
      "chr23": "rgb(204, 153, 0)",
      "chr24": "rgb(153, 204, 0)",
      "chr25": "rgb(51, 204, 0)",
      "chr26": "rgb(0, 204, 51)",
      "chr27": "rgb(0, 204, 153)",
      "chr28": "rgb(0, 153, 204)",
      "chr29": "rgb(10, 71, 255)",
      "chr30": "rgb(71, 117, 255)",
      "chr31": "rgb(255, 194, 10)",
      "chr32": "rgb(255, 209, 71)",
      "chr33": "rgb(153, 0, 51)",
      "chr34": "rgb(153, 26, 0)",
      "chr35": "rgb(153, 102, 0)",
      "chr36": "rgb(128, 153, 0)",
      "chr37": "rgb(51, 153, 0)",
      "chr38": "rgb(0, 153, 26)",
      "chr39": "rgb(0, 153, 102)",
      "chr40": "rgb(0, 128, 153)",
      "chr41": "rgb(0, 51, 153)",
      "chr42": "rgb(26, 0, 153)",
      "chr43": "rgb(102, 0, 153)",
      "chr44": "rgb(153, 0, 128)",
      "chr45": "rgb(214, 0, 71)",
      "chr46": "rgb(255, 20, 99)",
      "chr47": "rgb(0, 214, 143)",
      "chr48": "rgb(20, 255, 177)",
  };

  let timer;
  let currentViewport = undefined;
  const toolTipTimeout = 1e4;

  class RulerViewport extends TrackViewport {

      constructor(trackView, $viewportColumn, referenceFrame, width) {
          super(trackView, $viewportColumn, referenceFrame, width);
      }

      get contentDiv() {
          return this.$viewport.get(0)
      }

      initializationHelper() {

          this.$multiLocusCloseButton = $$1('<div>', {class: 'igv-multi-locus-close-button'});
          this.$viewport.append(this.$multiLocusCloseButton);
          this.$multiLocusCloseButton.get(0).appendChild(icons$1$1.createIcon("times-circle"));

          this.$multiLocusCloseButton.click(() => {
              this.browser.removeMultiLocusPanel(this.referenceFrame);
          });

          this.$rulerLabel = $$1('<div>', {class: 'igv-multi-locus-ruler-label'});
          this.$viewport.append(this.$rulerLabel);

          let div;
          div = document.createElement('div');
          this.$rulerLabel.append($$1(div));

          this.$rulerLabel.get(0).addEventListener('click', async event => {
              event.stopPropagation();
              await this.browser.gotoMultilocusPanel(this.referenceFrame);
          });

          this.$tooltip = $$1('<div>', {class: 'igv-ruler-tooltip'});
          this.$tooltip.height(this.$viewport.height());

          this.$viewport.append(this.$tooltip);

          this.$tooltipContent = $$1('<div>');
          this.$tooltip.append(this.$tooltipContent);

          this.rulerSweeper = new RulerSweeper(this, this.$viewport.get(0).parentElement, this.browser, this.referenceFrame);

          this.attachMouseHandlers(GenomeUtils.isWholeGenomeView(this.referenceFrame.chr));

          this.$tooltip.hide();

          this.dismissLocusLabel();
      }

      presentLocusLabel(viewportWidth) {

          this.$multiLocusCloseButton.show();

          this.$rulerLabel.show();
          this.$rulerLabel.get(0).style.backgroundColor = getChrColor(this.referenceFrame.chr);

          const textDiv = this.$rulerLabel.get(0).querySelector('div');

          const { width } = this.$rulerLabel.get(0).getBoundingClientRect();

          textDiv.innerHTML = `${ this.referenceFrame.getMultiLocusLabel(viewportWidth) }`;
          const { width:textDivWidth } = textDiv.getBoundingClientRect();

          if (textDivWidth/width > 0.5) {
              textDiv.innerHTML = `${ this.referenceFrame.getMultiLocusLabelBPLengthOnly(viewportWidth) }`;
          }

          //console.log(`${ Date.now() } textDiv ${ StringUtils.numberFormatter(Math.floor(textDivWidth)) }`)

      }

      // Use in conjuction with .igv-multi-locus-ruler-label-square-dot css class (_dom-misc.scss)
      dismissLocusLabel() {
          this.$rulerLabel.hide();
          this.$multiLocusCloseButton.hide();
      }

      attachMouseHandlers(isWholeGenomeView) {

          this.namespace = `.ruler_track_viewport_${this.browser.referenceFrameList.indexOf(this.referenceFrame)}`;

          this.$viewport.off(this.namespace);

          if (true === isWholeGenomeView) {

              const index = this.browser.referenceFrameList.indexOf(this.referenceFrame);

              const click = `click${this.namespace}`;
              this.$viewport.on(click, (e) => {

                  const {x: pixel} = domUtils.translateMouseCoordinates(e, this.$viewport.get(0));
                  const bp = Math.round(this.referenceFrame.start + this.referenceFrame.toBP(pixel));

                  let searchString;

                  const {chr} = this.browser.genome.getChromosomeCoordinate(bp);

                  if (1 === this.browser.referenceFrameList.length) {
                      searchString = chr;
                  } else {

                      let loci = this.browser.referenceFrameList.map(({locusSearchString}) => locusSearchString);

                      loci[index] = chr;

                      searchString = loci.join(' ');
                  }

                  this.browser.search(searchString);
              });

              this.$viewport.get(0).style.cursor = 'pointer';
          } else {
              this.$viewport.get(0).style.cursor = 'default';
          }

      }

      mouseMove(event) {

          if (true === this.browser.cursorGuideVisible) {

              if (undefined === currentViewport) {
                  currentViewport = this;
                  this.$tooltip.show();
              } else if (currentViewport.guid !== this.guid) {
                  if (currentViewport.$tooltip) {
                      currentViewport.$tooltip.hide();
                  }
                  this.$tooltip.show();
                  currentViewport = this;
              } else {
                  this.$tooltip.show();
              }

              const isWholeGenome = (this.browser.isMultiLocusWholeGenomeView() || GenomeUtils.isWholeGenomeView(this.referenceFrame.chr));

              if (isWholeGenome) {
                  this.$tooltip.hide();
                  return
              }

              const {x} = domUtils.translateMouseCoordinates(event, this.$viewport.get(0));
              const {start, bpPerPixel} = this.referenceFrame;
              const bp = Math.round(0.5 + start + Math.max(0, x) * bpPerPixel);

              this.$tooltipContent.text(numberFormatter$1(bp));

              const {width: ww} = this.$tooltipContent.get(0).getBoundingClientRect();
              const {width: w} = this.$viewport.get(0).getBoundingClientRect();

              this.$tooltip.css({left: `${IGVMath.clamp(x, 0, w - ww)}px`});

              // hide tooltip when movement stops
              clearTimeout(timer);
              timer = setTimeout(() => {
                  if (this.$tooltip) this.$tooltip.hide();
              }, toolTipTimeout);

          }

      }

      startSpinner() {
      }

      stopSpinner() {
      }

      dispose() {
          this.rulerSweeper.dispose();
          super.dispose();
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class IdeogramViewport extends TrackViewport {

      constructor(trackView, viewportColumn, referenceFrame, width) {
          super(trackView, viewportColumn, referenceFrame, width);
      }

      initializationHelper() {

          this.canvas = document.createElement('canvas');
          this.canvas.className = 'igv-ideogram-canvas';
          //this.$content.append($(this.canvas))
          this.$viewport.append($$1(this.canvas));
          this.ideogram_ctx = this.canvas.getContext('2d');

          this.addMouseHandlers();
      }

      addMouseHandlers() {
          this.addViewportClickHandler(this.$viewport.get(0));
      }

      addViewportClickHandler(viewport) {

          this.boundClickHandler = clickHandler.bind(this);
          viewport.addEventListener('click', this.boundClickHandler);

          function clickHandler(event) {

              const {xNormalized, width} = domUtils.translateMouseCoordinates(event, this.ideogram_ctx.canvas);
              const {bpLength} = this.browser.genome.getChromosome(this.referenceFrame.chr);
              const locusLength = this.referenceFrame.bpPerPixel * width;
              const chrCoveragePercentage = locusLength / bpLength;

              let xPercentage = xNormalized;
              if (xPercentage - (chrCoveragePercentage / 2.0) < 0) {
                  xPercentage = chrCoveragePercentage / 2.0;
              }

              if (xPercentage + (chrCoveragePercentage / 2.0) > 1.0) {
                  xPercentage = 1.0 - chrCoveragePercentage / 2.0;
              }

              const ss = Math.round((xPercentage - (chrCoveragePercentage / 2.0)) * bpLength);
              const ee = Math.round((xPercentage + (chrCoveragePercentage / 2.0)) * bpLength);

              this.referenceFrame.start = ss;
              this.referenceFrame.end = ee;
              this.referenceFrame.bpPerPixel = (ee - ss) / width;

              this.browser.updateViews(this.referenceFrame, this.browser.trackViews, true);

          }

      }

      setWidth(width) {
          this.$viewport.width(width);
      }

      drawSVGWithContext(context, width, height, id, x, y, yClipOffset) {

          context.saveWithTranslationAndClipRect(id, x, y, width, height, yClipOffset);

          this.trackView.track.draw({
              context,
              referenceFrame: this.referenceFrame,
              pixelWidth: width,
              pixelHeight: height
          });

          context.restore();
      }

      repaint() {
          this.draw({referenceFrame: this.referenceFrame});
      }

      draw({referenceFrame}) {

          IGVGraphics.configureHighDPICanvas(this.ideogram_ctx, this.$viewport.width(), this.$viewport.height());

          this.trackView.track.draw({
              context: this.ideogram_ctx,
              referenceFrame,
              pixelWidth: this.$viewport.width(),
              pixelHeight: this.$viewport.height()
          });
      }

      startSpinner() {
      }

      stopSpinner() {
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  function createViewport(trackView, column, referenceFrame, width) {

      if ('ruler' === trackView.track.type) {
          return new RulerViewport(trackView, column, referenceFrame, width)
      } else if ('ideogram' === trackView.track.id) {
          return new IdeogramViewport(trackView, column, referenceFrame, width)
      } else {
          const viewportObject = new TrackViewport(trackView, column, referenceFrame, width);

          // if ('sequence' === trackView.track.type) {
          //     viewportObject.$viewport.get(0).style.marginTop = '0px'
          // }

          return viewportObject
      }
  }

  const maxFontSize = 10;

  const fontConfigureTemplate =
      {
          // font: '2pt sans-serif',
          textAlign: 'start',
          textBaseline: 'bottom',
          strokeStyle: 'black',
          fillStyle: 'black'
      };

  class SampleNameViewport {

      constructor(trackView, column, unused, width) {

          this.guid = domUtils.guid();
          this.trackView = trackView;

          this.browser = trackView.browser;

          this.viewport = domUtils.div({class: 'igv-viewport'});

          column.appendChild(this.viewport);

          if (trackView.track.height) {
              this.viewport.style.height = `${trackView.track.height}px`;
          }

          this.canvas = document.createElement('canvas');
          this.viewport.appendChild(this.canvas);
          this.ctx = this.canvas.getContext("2d");

          this.trackScrollDelta = 0;

          this.contentTop = 0;

          this.setWidth(width);

          if (false === this.browser.showSampleNames) {
              this.hide();
          }

          this.addMouseHandlers();
      }

      checkCanvas() {

          const dpi = window.devicePixelRatio;
          const requiredHeight = this.viewport.clientHeight;
          const requiredWidth = this.browser.sampleNameViewportWidth;

          if (this.canvas.width !== requiredWidth * dpi || this.canvas.height !== requiredHeight * dpi) {
              const canvas = this.canvas;
              canvas.width = requiredWidth * dpi;
              canvas.height = requiredHeight * dpi;
              canvas.style.width = `${requiredWidth}px`;
              canvas.style.height = `${requiredHeight}px`;
              this.ctx = this.canvas.getContext("2d");
              this.ctx.scale(dpi, dpi);
          }

      }

      setTop(contentTop) {

          if (typeof this.trackView.track.getSamples === 'function') {
              this.contentTop = contentTop;
              const samples = this.trackView.track.getSamples();
              this.repaint(samples);
          }

      }

      setWidth(width) {
          this.viewport.innerWidth = width;
          this.checkCanvas();
      }

      show() {
          this.viewport.style.display = 'block';
      }

      hide() {
          this.viewport.style.display = 'none';
      }

      async repaint(samples) {

          this.checkCanvas();
          this.draw({context: this.ctx, samples});
      }

      draw({context, samples}) {

          if (!samples || samples.names.length === 0/* || samples.height < 1*/) {
              return
          }

          configureFont(context, fontConfigureTemplate, samples.height);
          const sampleNameXShim = 4;

          context.clearRect(0, 0, context.canvas.width, context.canvas.height);

          context.fillStyle = appleCrayonRGB('lead');

          const viewportHeight = this.viewport.getBoundingClientRect().height;
          let y = (samples.yOffset || 0) + this.contentTop;    // contentTop will always be a negative number (top relative to viewport)

          for (let name of samples.names) {
              if (y > viewportHeight) {
                  break
              }
              if (y + samples.height > 0) {
                  const text = name;
                  const yFont = getYFont(context, text, y, samples.height);
                  context.fillText(text, sampleNameXShim, yFont);

              }
              y += samples.height;
          }
      }

      renderSVGContext(context, {deltaX, deltaY}) {

          if (typeof this.trackView.track.getSamples === 'function') {

              const samples = this.trackView.track.getSamples();

              const yScrollDelta = 0;   // This is not relevant, scrolling is handled in "draw"

              const {width, height} = this.viewport.getBoundingClientRect();

              const str = (this.trackView.track.name || this.trackView.track.id).replace(/\W/g, '');
              const id = `${str}_sample_names_guid_${domUtils.guid()}`;

              context.saveWithTranslationAndClipRect(id, deltaX, deltaY + yScrollDelta, width, height, -yScrollDelta);

              this.draw({context, samples});

              context.restore();
          }
      }

      addMouseHandlers() {
          this.addViewportContextMenuHandler(this.viewport);
      }

      removeMouseHandlers() {
          this.removeViewportContextMenuHandler(this.viewport);
      }

      addViewportContextMenuHandler(viewport) {
          this.boundContextMenuHandler = contextMenuHandler.bind(this);
          viewport.addEventListener('contextmenu', this.boundContextMenuHandler);

          function contextMenuHandler(event) {

              event.preventDefault();
              event.stopPropagation();

              const config =
                  {
                      label: 'Name Panel Width',
                      value: this.browser.sampleNameViewportWidth,
                      callback: newWidth => {
                          this.browser.sampleNameViewportWidth = parseInt(newWidth);
                          for (let {sampleNameViewport} of this.browser.trackViews) {
                              sampleNameViewport.setWidth(this.browser.sampleNameViewportWidth);
                          }
                          this.browser.layoutChange();
                      }
                  };

              this.browser.inputDialog.present(config, event);
          }

      }

      removeViewportContextMenuHandler(viewport) {
          viewport.removeEventListener('contextmenu', this.boundContextMenuHandler);
      }

      dispose() {
          this.removeMouseHandlers();
          this.viewport.remove();
      }
  }

  function getYFont(context, text, y, height) {
      return y + height - getSampleNameYShim(context, text, height)
  }

  function getSampleNameYShim(context, text, h) {
      const {actualBoundingBoxAscent, actualBoundingBoxDescent} = context.measureText(text);
      return (h - (actualBoundingBoxAscent + actualBoundingBoxDescent)) / 2
  }

  function configureFont(ctx, {textAlign, textBaseline, strokeStyle, fillStyle}, sampleHeight) {
      const pixels = Math.min(sampleHeight, maxFontSize);
      ctx.font = `${pixels}px sans-serif`;
      ctx.textAlign = textAlign;
      ctx.textBaseline = textBaseline;
      ctx.fillStyle = fillStyle;
  }

  const MenuPopup = function (parent) {

      this.popover = domUtils.div({class: 'igv-menu-popup'});
      parent.appendChild(this.popover);

      const header = domUtils.div({class: 'igv-menu-popup-header'});
      this.popover.appendChild(header);

      uiUtils.attachDialogCloseHandlerWithParent(header, () => this.hide());

      this.popoverContent = domUtils.div();
      this.popover.appendChild(this.popoverContent);

      makeDraggable$2(this.popover, header);

      header.addEventListener('click', e => {
          e.stopPropagation();
          e.preventDefault();
          // absorb click to prevent it leaking through to parent DOM element
      });

      this.hide();

  };

  MenuPopup.prototype.hide = function () {
      this.popover.style.display = 'none';
  };

  MenuPopup.prototype.presentMenuList = function (menuList) {

      hideAllMenuPopups();

      if (menuList.length > 0) {

          this.popoverContent.innerHTML = '';

          menuList = MenuUtils.trackMenuItemListHelper(menuList, this);

          for (let item of menuList) {

              if (item.init) {
                  item.init();
              }

              let $e = item.object;
              if (0 === menuList.indexOf(item)) {
                  $e.removeClass('igv-track-menu-border-top');
              }

              if ($e.hasClass('igv-track-menu-border-top') || $e.hasClass('igv-menu-popup-check-container')) ; else if ($e.is('div')) {
                  $e.addClass('igv-menu-popup-shim');
              }

              this.popoverContent.appendChild($e.get(0));

          }

          // NOTE: style.display most NOT be 'none' when calculating width. a display = 'none' will always
          //       yield a width of zero (0).
          this.popover.style.display = 'flex';

          const {width} = this.popover.getBoundingClientRect();

          this.popover.style.left = `${-width}px`;
          this.popover.style.top = `${0}px`;

      }
  };

  MenuPopup.prototype.presentTrackContextMenu = function (e, menuItems) {

      this.popoverContent.innerHTML = '';

      const menuElements = createMenuElements(menuItems, this.popover);
      for (let {el} of menuElements) {
          this.popoverContent.appendChild(el);
      }

      present(e, this.popover);

  };

  MenuPopup.prototype.dispose = function () {

      this.popoverContent.innerHTML = '';
      this.popover.innerHTML = '';

      Object.keys(this).forEach(function (key) {
          this[key] = undefined;
      });
  };

  function createMenuElements(itemList, popover) {

      return itemList.map(item => {

          let el;

          if (typeof item === 'string' && '<hr/>' === item) {
              el = document.createElement('hr');
          } else if (typeof item === 'string') {
              el = domUtils.div({class: 'context-menu'});
              el.innerHTML = item;
          } else if (typeof item === 'Node') {
              el = item;
          } else {
              if (typeof item.init === 'function') {
                  item.init();
              }

              if ("checkbox" === item.type) {
                  el = createCheckbox("Show all bases", item.value);
              } else if ("color" === item.type) {

                  const colorPicker = new GenericColorPicker({parent: popover.parentElement, width: 364});
                  colorPicker.configure(undefined, {color: color => item.click(color)});

                  el = domUtils.div({class: 'context-menu'});
                  if (typeof item.label === 'string') {
                      el.innerHTML = item.label;
                  }
                  const clickHandler = e => {
                      colorPicker.show();
                      domUtils.hide(popover);
                      e.preventDefault();
                      e.stopPropagation();
                  };
                  el.addEventListener('click', clickHandler);
                  el.addEventListener('touchend', clickHandler);
                  el.addEventListener('mouseup', function (e) {
                      e.preventDefault();
                      e.stopPropagation();
                  });
              } else {
                  el = domUtils.div({class: 'context-menu'});
                  if (typeof item.label === 'string') {
                      el.innerHTML = item.label;
                  }
              }

              if (item.click && "color" !== item.type) {
                  el.addEventListener('click', handleClick);
                  el.addEventListener('touchend', handleClick);
                  el.addEventListener('mouseup', function (e) {
                      e.preventDefault();
                      e.stopPropagation();
                  });

                  // eslint-disable-next-line no-inner-declarations
                  function handleClick(e) {
                      item.click();
                      domUtils.hide(popover);
                      e.preventDefault();
                      e.stopPropagation();
                  }
              }
          }

          return {el, init: item.init}
      })

  }

  function present(e, popover) {

      // NOTE: style.display most NOT be 'none' when calculating width. a display = 'none' will always
      //       yield a width of zero (0).
      popover.style.display = 'flex';

      const {x, y} = domUtils.translateMouseCoordinates(e, popover.parentNode);
      const {width} = popover.getBoundingClientRect();
      const xmax = x + width;

      const {width: parentWidth} = popover.parentNode.getBoundingClientRect();

      popover.style.left = `${xmax > parentWidth ? (x - (xmax - parentWidth)) : x}px`;
      popover.style.top = `${y}px`;

  }

  const hideAllMenuPopups = () => {

      const menus = document.querySelectorAll('.igv-menu-popup');
      for (let i = 0; i < menus.length; i++) {
          menus[i].style.display = 'none';
      }

  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const igv_axis_column_width = 50;
  const scrollbarExclusionTypes = new Set(['ruler', 'ideogram']);
  const colorPickerExclusionTypes = new Set(['ruler', 'sequence', 'ideogram']);

  class TrackView {

      constructor(browser, columnContainer, track) {
          this.browser = browser;
          this.track = track;
          track.trackView = this;
          this.addDOMToColumnContainer(browser, columnContainer, browser.referenceFrameList);
      }

      /**
       * Start a spinner for the track on any of its viewports.  In practice this is called during initialization
       * when there is only one.
       */
      startSpinner() {
          if (this.viewports && this.viewports.length > 0) {
              this.viewports[0].startSpinner();
          }
      }

      stopSpinner() {
          if (this.viewports && this.viewports.length > 0) {
              this.viewports[0].stopSpinner();
          }
      }

      addDOMToColumnContainer(browser, columnContainer, referenceFrameList) {

          // Axis
          this.axis = this.createAxis(browser, this.track);

          // Create a viewport for each reference frame
          this.viewports = [];
          const viewportWidth = browser.calculateViewportWidth(referenceFrameList.length);
          const viewportColumns = columnContainer.querySelectorAll('.igv-column');
          for (let i = 0; i < viewportColumns.length; i++) {
              const viewport = createViewport(this, viewportColumns[i], referenceFrameList[i], viewportWidth);
              this.viewports.push(viewport);
          }

          // SampleName Viewport
          this.sampleNameViewport = new SampleNameViewport(this, browser.columnContainer.querySelector('.igv-sample-name-column'), undefined, browser.sampleNameViewportWidth);

          // Track Scrollbar
          this.createTrackScrollbar(browser);

          // Track Drag
          this.createTrackDragHandle(browser);

          // Track Gear
          this.createTrackGearPopup(browser);

      }

      createAxis(browser, track) {

          const axis = domUtils.div();
          browser.columnContainer.querySelector('.igv-axis-column').appendChild(axis);

          axis.style.height = `${track.height}px`;

          if (typeof track.paintAxis === 'function') {
              if (track.dataRange) {
                  axis.addEventListener('click', () => {
                      browser.dataRangeDialog.configure(this);
                      browser.dataRangeDialog.present($$1(browser.columnContainer));
                  });
              }


              const {width, height} = axis.getBoundingClientRect();
              this.axisCanvas = document.createElement('canvas');
              this.axisCanvas.style.width = `${width}px`;
              this.axisCanvas.style.height = `${height}px`;
              axis.appendChild(this.axisCanvas);
          }

          return axis

      }

      resizeAxisCanvas(width, height) {

          this.axis.style.width = `${width}px`;
          this.axis.style.height = `${height}px`;

          if (typeof this.track.paintAxis === 'function') {
              // Size the canvas in CSS (logical) pixels.  The buffer size will be set when painted.
              this.axisCanvas.style.width = `${width}px`;
              this.axisCanvas.style.height = `${height}px`;

          }
      }

      removeDOMFromColumnContainer() {

          // Axis
          if (this.boundAxisClickHander) {
              this.removeAxisEventListener(this.axis);
          }
          this.axis.remove();

          // Track Viewports
          for (let viewport of this.viewports) {
              viewport.$viewport.remove();
          }

          // SampleName Viewport
          this.sampleNameViewport.dispose();

          // empty trackScrollbar Column
          this.removeTrackScrollMouseHandlers();
          this.outerScroll.remove();

          // empty trackDrag Column
          this.removeTrackDragMouseHandlers();
          this.dragHandle.remove();

          // empty trackGear Column
          this.removeTrackGearMouseHandlers();
          this.gearContainer.remove();

      }

      renderSVGContext(context, {deltaX, deltaY}) {

          renderSVGAxis(context, this.track, this.axisCanvas, deltaX, deltaY);

          const {width: axisWidth} = this.axis.getBoundingClientRect();

          const {y} = this.viewports[0].$viewport.get(0).getBoundingClientRect();

          let delta =
              {
                  deltaX: axisWidth + deltaX,
                  deltaY: y + deltaY
              };

          for (let viewport of this.viewports) {
              viewport.renderSVGContext(context, delta);
              const {width} = viewport.$viewport.get(0).getBoundingClientRect();
              delta.deltaX += width;
          }

          if (true === this.browser.showSampleNames) {
              this.sampleNameViewport.renderSVGContext(context, delta);
          }
      }

      dataRange() {
          return this.track.dataRange ? this.track.dataRange : undefined
      }

      setDataRange(min, max) {
          if (min !== undefined) {
              this.track.dataRange.min = min;
          }
          if (max !== undefined) {
              this.track.dataRange.max = max;
          }
          this.track.autoscale = false;
          this.repaintViews();
      }

      presentColorPicker(key) {

          if (false === colorPickerExclusionTypes.has(this.track.type)) {

              const trackColors = [];
              const color = this.track.color || this.track.defaultColor;
              if (isString$2(color)) {
                  trackColors.push(color);
              }
              if (this.track.altColor && isString$2(this.track.altColor)) {
                  trackColors.push(this.track.altColor);
              }
              const defaultColors = trackColors.map(c => c.startsWith("#") ? c : c.startsWith("rgb(") ? IGVColor.rgbToHex(c) : IGVColor.colorNameToHex(c));
              const colorHandlers =
                  {
                      color: color => {
                          this.track.color = color;
                          this.repaintViews();
                      },
                      altColor: color => {
                          this.track.altColor = color;
                          this.repaintViews();
                      }

                  };
              this.browser.genericColorPicker.configure(defaultColors, colorHandlers);
              this.browser.genericColorPicker.setActiveColorHandler(key);
              this.browser.genericColorPicker.show();
          }

      }

      setTrackHeight(newHeight, force) {

          if (!force) {
              if (this.track.minHeight) {
                  newHeight = Math.max(this.track.minHeight, newHeight);
              }
              if (this.track.maxHeight) {
                  newHeight = Math.min(this.track.maxHeight, newHeight);
              }
          }

          this.track.height = newHeight;

          this.resizeAxisCanvas(this.axis.clientWidth, this.track.height);

          if (typeof this.track.paintAxis === 'function') {
              this.paintAxis();
          }

          for (let {$viewport} of this.viewports) {
              $viewport.height(newHeight);
          }

          this.sampleNameViewport.viewport.style.height = `${newHeight}px`;

          // If the track does not manage its own content height set it equal to the viewport height here
          if (typeof this.track.computePixelHeight !== "function") {
              for (let vp of this.viewports) {
                  vp.setContentHeight(newHeight);
              }
          }

          this.repaintViews();

          if (false === scrollbarExclusionTypes.has(this.track.type)) {
              this.updateScrollbar();
          }

          this.dragHandle.style.height = `${newHeight}px`;
          this.gearContainer.style.height = `${newHeight}px`;

      }

      updateScrollbar() {

          const viewportHeight = this.viewports[0].$viewport.height();
          this.outerScroll.style.height = `${viewportHeight}px`;

          const viewportContentHeight = this.maxViewportContentHeight();
          const innerScrollHeight = Math.round((viewportHeight / viewportContentHeight) * viewportHeight);

          if (viewportContentHeight > viewportHeight) {
              this.innerScroll.style.display = 'block';
              this.innerScroll.style.height = `${innerScrollHeight}px`;
          } else {
              this.innerScroll.style.display = 'none';
          }
      }

      moveScroller(delta) {

          const y = $$1(this.innerScroll).position().top + delta;
          const top = Math.min(Math.max(0, y), this.outerScroll.clientHeight - this.innerScroll.clientHeight);
          $$1(this.innerScroll).css('top', `${top}px`);

          const contentHeight = this.maxViewportContentHeight();
          const contentTop = -Math.round(top * (contentHeight / this.viewports[0].$viewport.height()));

          for (let viewport of this.viewports) {
              viewport.setTop(contentTop);
          }

          this.sampleNameViewport.trackScrollDelta = delta;
          this.sampleNameViewport.setTop(contentTop);

      }

      isLoading() {
          for (let viewport of this.viewports) {
              if (viewport.isLoading()) return true
          }
      }

      /**
       * Repaint all viewports without loading any new data.   Use this for events that change visual aspect of data,
       * e.g. color, sort order, etc, but do not change the genomic state.
       */
      repaintViews() {

          for (let viewport of this.viewports) {
              if (viewport.isVisible()) {
                  viewport.repaint();
              }
          }

          if (typeof this.track.paintAxis === 'function') {
              this.paintAxis();
          }

          // Repaint sample names last
          this.repaintSamples();
      }

      repaintSamples() {

          if (typeof this.track.getSamples === 'function') {
              const samples = this.track.getSamples();
              this.sampleNameViewport.repaint(samples);
          }
      }

      // track labels
      setTrackLabelName(name) {
          this.viewports.forEach(viewport => viewport.setTrackLabel(name));
      }

      /**
       * Called in response to a window resize event, change in # of multilocus panels, or other event that changes
       * the width of the track view.
       *
       * @param viewportWidth  The width of each viewport in this track view.
       */
      resize(viewportWidth) {
          for (let viewport of this.viewports) {
              viewport.setWidth(viewportWidth);
          }
      }

      /**
       * Update viewports to reflect current genomic state, possibly loading additional data.
       *
       * @param force - if true, force a repaint even if no new data is loaded
       * @returns {Promise<void>}
       */
      async updateViews() {

          if (!(this.browser && this.browser.referenceFrameList)) return

          const visibleViewports = this.viewports.filter(viewport => viewport.isVisible());

          // Shift viewports left/right to current genomic state (pans canvas)
          visibleViewports.forEach(viewport => viewport.shift());

          // If dragging (panning) return
          if (this.browser.dragObject) {
              return
          }

          // Filter zoomed out views.  This has the side effect or turning off or no the zoomed out notice
          const viewportsToRepaint = visibleViewports.filter(vp => vp.needsRepaint()).filter(viewport => viewport.checkZoomIn());

          // Get viewports that require a data load
          const viewportsToReload = viewportsToRepaint.filter(viewport => viewport.needsReload());

          // Trigger viewport to load features needed to cover current genomic range
          // NOTE: these must be loaded synchronously, do not user Promise.all,  not all file readers are thread safe
          for (let viewport of viewportsToReload) {
              await viewport.loadFeatures();
          }

          if (this.disposed) return   // Track was removed during load

          // Special case for variant tracks in multilocus view.  The # of rows to allocate to the variant (site)
          // section depends on data from all the views.  We only need to adjust this however if any data was loaded
          // (i.e. reloadableViewports.length > 0)
          if (this.track && typeof this.track.variantRowCount === 'function' && viewportsToReload.length > 0) {
              let maxRow = 0;
              for (let viewport of this.viewports) {
                  if (viewport.featureCache && viewport.featureCache.features) {
                      maxRow = Math.max(maxRow, viewport.featureCache.features.reduce((a, f) => Math.max(a, f.row || 0), 0));
                  }
              }
              const current = this.track.nVariantRows;
              if (current !== maxRow + 1) {
                  this.track.variantRowCount(maxRow + 1);
                  for (let viewport of this.viewports) {
                      viewport.checkContentHeight();
                  }
              }
          }

          if (this.track.autoscale) {
              let allFeatures = [];
              for (let visibleViewport of visibleViewports) {
                  const referenceFrame = visibleViewport.referenceFrame;
                  const start = referenceFrame.start;
                  const end = start + referenceFrame.toBP(visibleViewport.getWidth());
                  if (visibleViewport.featureCache && visibleViewport.featureCache.features) {
                      // If the "features" object has a getMax function use it.  Currently only alignmentContainer implements this, for coverage.
                      if (typeof visibleViewport.featureCache.features.getMax === 'function') {
                          const max = visibleViewport.featureCache.features.getMax(start, end);
                          allFeatures.push({value: max});
                      } else {
                          const viewFeatures = FeatureUtils.findOverlapping(visibleViewport.featureCache.features, start, end);
                          for (let f of viewFeatures) {
                              allFeatures.push(f);
                          }
                      }
                  }
              }
              if (typeof this.track.doAutoscale === 'function') {
                  this.track.dataRange = this.track.doAutoscale(allFeatures);
              } else {
                  this.track.dataRange = doAutoscale(allFeatures);
              }
          }

          const refreshView = (this.track.autoscale || this.track.autoscaleGroup || this.track.type === 'ruler');
          for (let vp of visibleViewports) {
              if (viewportsToRepaint.includes(vp)) {
                  vp.repaint();
              } else if (refreshView) {
                  vp.refresh();
              }
          }

          this.adjustTrackHeight();

          // Repaint sample names last
          this.repaintSamples();

          this.updateRulerViewportLabels();
      }

      clearCachedFeatures() {
          for (let viewport of this.viewports) {
              viewport.clearCache();
          }
      }

      updateRulerViewportLabels() {

          const viewportWidth = this.browser.calculateViewportWidth(this.viewports.length);

          for (let viewport of this.viewports) {
              if ('ruler' === this.track.type) {
                  if (this.viewports.length > 1) {
                      viewport.presentLocusLabel(viewportWidth);
                  } else {
                      viewport.dismissLocusLabel();
                  }
              }
          }

      }

      /**
       * Return a promise to get all in-view features across all viewports.  Used for group autoscaling.
       */
      async getInViewFeatures() {

          if (!(this.browser && this.browser.referenceFrameList)) {
              return []
          }

          let allFeatures = [];
          const visibleViewports = this.viewports.filter(viewport => viewport.isVisible());
          for (let vp of visibleViewports) {

              const referenceFrame = vp.referenceFrame;
              const {chr, start, bpPerPixel} = vp.referenceFrame;
              const end = start + referenceFrame.toBP(vp.getWidth());
              const needsReload = !vp.featureCache || !vp.featureCache.containsRange(chr, start, end, bpPerPixel);

              if (needsReload) {
                  await vp.loadFeatures();
              }
              if (vp.featureCache && vp.featureCache.features) {

                  if (typeof vp.featureCache.features.getMax === 'function') {
                      const max = vp.featureCache.features.getMax(start, end);
                      allFeatures.push({value: max});
                  } else {
                      const vpFeatures = typeof vp.featureCache.queryFeatures === 'function' ?
                          vp.featureCache.queryFeatures(chr, start, end) :
                          FeatureUtils.findOverlapping(vp.featureCache.features, start, end);
                      allFeatures = allFeatures.concat(vpFeatures);
                  }
              }
          }
          return allFeatures
      }

      checkContentHeight() {

          for (let viewport of this.viewports) {
              viewport.checkContentHeight();
          }
          this.adjustTrackHeight();

      }

      adjustTrackHeight() {

          var contentHeight = this.maxViewportContentHeight();
          if (this.track.autoHeight) {
              this.setTrackHeight(contentHeight, false);
          } else if (this.track.paintAxis) {   // Avoid duplication, paintAxis is already called in setTrackHeight
              this.paintAxis();
          }

          if (false === scrollbarExclusionTypes.has(this.track.type)) {

              // Adjust scrollbar, if needed, to insure content is in view
              const currentTop = this.viewports[0].getContentTop();
              const viewportHeight = this.viewports[0].$viewport.height();
              const minTop = Math.min(0, viewportHeight - contentHeight);
              if(currentTop < minTop) {
                   for (let viewport of this.viewports) {
                      viewport.setTop(minTop);
                  }
              }
              this.updateScrollbar();
          }
      }

      createTrackScrollbar(browser) {

          const outerScroll = domUtils.div();
          browser.columnContainer.querySelector('.igv-scrollbar-column').appendChild(outerScroll);
          outerScroll.style.height = `${this.track.height}px`;
          this.outerScroll = outerScroll;

          if (false === scrollbarExclusionTypes.has(this.track.type)) {
              const innerScroll = domUtils.div();
              outerScroll.appendChild(innerScroll);
              this.innerScroll = innerScroll;

              this.addTrackScrollMouseHandlers(browser);
          }

      }

      createTrackDragHandle(browser) {

          const className = 'ideogram' === this.track.type || 'ruler' === this.track.type ? 'igv-track-drag-shim' : 'igv-track-drag-handle';
          this.dragHandle = domUtils.div({class: className});
          browser.columnContainer.querySelector('.igv-track-drag-column').appendChild(this.dragHandle);
          this.dragHandle.style.height = `${this.track.height}px`;

          this.addTrackDragMouseHandlers(browser);

      }

      createTrackGearPopup(browser) {

          this.gearContainer = domUtils.div();
          browser.columnContainer.querySelector('.igv-gear-menu-column').appendChild(this.gearContainer);
          this.gearContainer.style.height = `${this.track.height}px`;

          if (true === this.track.ignoreTrackMenu) ; else {

              this.gear = domUtils.div();
              this.gearContainer.appendChild(this.gear);
              this.gear.appendChild(icons$1$1.createIcon('cog'));

              this.trackGearPopup = new MenuPopup(this.gear);

              this.addTrackGearMouseHandlers();
          }

      }

      addAxisEventListener(axis) {

          this.boundAxisClickHander = axisClickHandler.bind(this);
          axis.addEventListener('click', this.boundAxisClickHander);

          function axisClickHandler(event) {
              this.browser.dataRangeDialog.configure(this);
              this.browser.dataRangeDialog.present($$1(this.browser.columnContainer));
          }

      }

      removeAxisEventListener(axis) {
          axis.removeEventListener('click', this.boundAxisClickHander);
      }

      addTrackScrollMouseHandlers(browser) {

          // Mouse Down
          this.boundTrackScrollMouseDownHandler = trackScrollMouseDownHandler.bind(this);
          this.innerScroll.addEventListener('mousedown', this.boundTrackScrollMouseDownHandler);

          function trackScrollMouseDownHandler(event) {

              event.stopPropagation();

              const {y} = domUtils.pageCoordinates(event);

              $$1(this.innerScroll).data('yDown', y.toString());

              this.boundColumnContainerMouseMoveHandler = columnContainerMouseMoveHandler.bind(this);
              browser.columnContainer.addEventListener('mousemove', this.boundColumnContainerMouseMoveHandler);

              function columnContainerMouseMoveHandler(event) {

                  event.stopPropagation();

                  const {y} = domUtils.pageCoordinates(event);

                  this.moveScroller(y - parseInt($$1(this.innerScroll).data('yDown')));

                  $$1(this.innerScroll).data('yDown', y.toString());

              }
          }

          this.boundColumnContainerMouseUpHandler = columnContainerMouseUpHandler.bind(this);
          browser.columnContainer.addEventListener('mouseup', this.boundColumnContainerMouseUpHandler);

          function columnContainerMouseUpHandler(event) {
              browser.columnContainer.removeEventListener('mousemove', this.boundColumnContainerMouseMoveHandler);
          }

      }

      removeTrackScrollMouseHandlers() {
          if (false === scrollbarExclusionTypes.has(this.track.type)) {
              this.innerScroll.removeEventListener('mousedown', this.boundTrackScrollMouseDownHandler);
              this.browser.columnContainer.removeEventListener('mouseup', this.boundColumnContainerMouseUpHandler);
              this.browser.columnContainer.removeEventListener('mousemove', this.boundColumnContainerMouseMoveHandler);
          }
      }

      addTrackDragMouseHandlers(browser) {

          if ('ideogram' === this.track.id || 'ruler' === this.track.id) ; else {

              let currentDragHandle = undefined;

              // Mouse Down
              this.boundTrackDragMouseDownHandler = trackDragMouseDownHandler.bind(this);
              this.dragHandle.addEventListener('mousedown', this.boundTrackDragMouseDownHandler);

              function trackDragMouseDownHandler(event) {

                  event.preventDefault();

                  currentDragHandle = event.target;
                  currentDragHandle.classList.add('igv-track-drag-handle-hover');

                  browser.startTrackDrag(this);

              }

              // Mouse Up
              this.boundDocumentTrackDragMouseUpHandler = documentTrackDragMouseUpHandler.bind(this);
              document.addEventListener('mouseup', this.boundDocumentTrackDragMouseUpHandler);

              function documentTrackDragMouseUpHandler(event) {

                  browser.endTrackDrag();

                  if (currentDragHandle && event.target !== currentDragHandle) {
                      currentDragHandle.classList.remove('igv-track-drag-handle-hover');
                  }

                  currentDragHandle = undefined;
              }

              // Mouse Enter
              this.boundTrackDragMouseEnterHandler = trackDragMouseEnterHandler.bind(this);
              this.dragHandle.addEventListener('mouseenter', this.boundTrackDragMouseEnterHandler);

              function trackDragMouseEnterHandler(event) {
                  event.preventDefault();

                  if (undefined === currentDragHandle) {
                      event.target.classList.add('igv-track-drag-handle-hover');
                  }

                  browser.updateTrackDrag(this);

              }

              // Mouse Out
              this.dragHandle.addEventListener('mouseout', e => {
                  e.preventDefault();

                  if (undefined === currentDragHandle) {
                      e.target.classList.remove('igv-track-drag-handle-hover');
                  }
              });

              this.boundTrackDragMouseOutHandler = trackDragMouseOutHandler.bind(this);
              this.dragHandle.addEventListener('mouseout', this.boundTrackDragMouseOutHandler);

              function trackDragMouseOutHandler(event) {
                  event.preventDefault();

                  if (undefined === currentDragHandle) {
                      event.target.classList.remove('igv-track-drag-handle-hover');
                  }
              }

          }

      }

      removeTrackDragMouseHandlers() {

          if ('ideogram' === this.track.id || 'ruler' === this.track.id) ; else {
              this.dragHandle.removeEventListener('mousedown', this.boundTrackDragMouseDownHandler);
              document.removeEventListener('mouseup', this.boundDocumentTrackDragMouseUpHandler);
              this.dragHandle.removeEventListener('mouseup', this.boundTrackDragMouseEnterHandler);
              this.dragHandle.removeEventListener('mouseout', this.boundTrackDragMouseOutHandler);
          }

      }

      addTrackGearMouseHandlers() {
          if (true === this.track.ignoreTrackMenu) ; else {

              this.boundTrackGearClickHandler = trackGearClickHandler.bind(this);
              this.gear.addEventListener('click', this.boundTrackGearClickHandler);

              function trackGearClickHandler(event) {
                  event.preventDefault();
                  event.stopPropagation();
                  this.trackGearPopup.presentMenuList(MenuUtils.trackMenuItemList(this));
              }

          }

      }

      removeTrackGearMouseHandlers() {
          if (true === this.track.ignoreTrackMenu) ; else {
              this.gear.removeEventListener('click', this.boundTrackGearClickHandler);
          }

      }

      /**
       * Do any cleanup here
       */
      dispose() {

          this.removeAxisEventListener(this.axis);
          this.axis.remove();

          for (let viewport of this.viewports) {
              viewport.dispose();
          }

          this.sampleNameViewport.dispose();

          this.removeTrackScrollMouseHandlers();
          this.outerScroll.remove();

          this.removeTrackDragMouseHandlers();
          this.dragHandle.remove();

          this.removeTrackGearMouseHandlers();
          this.gearContainer.remove();

          if (typeof this.track.dispose === "function") {
              this.track.dispose();
          }

          for (let key of Object.keys(this)) {
              this[key] = undefined;
          }

          if (this.alert) {
              this.alert.container.remove();    // This is quite obviously a hack, need a "dispose" method on AlertDialog
          }

          this.disposed = true;
      }

      paintAxis() {

          if (typeof this.track.paintAxis === 'function') {

              // Set the canvas buffer size, this is the resolution it is drawn at.  This is done here in case the browser
              // has been drug between screens at different dpi resolutions since the last repaint
              const {width, height} = this.axisCanvas.getBoundingClientRect();
              const dpi = window.devicePixelRatio || 1;
              this.axisCanvas.height = dpi * height;
              this.axisCanvas.width = dpi * width;

              // Get a scaled context to draw aon
              const axisCanvasContext = this.axisCanvas.getContext('2d');
              axisCanvasContext.scale(dpi, dpi);

              this.track.paintAxis(axisCanvasContext, width, height);
          }
      }

      maxViewportContentHeight() {
          return Math.max(this.viewports.map(viewport => viewport.getContentHeight()))
      }

  }

  function renderSVGAxis(context, track, axisCanvas, deltaX, deltaY) {

      if (typeof track.paintAxis === 'function') {

          const {y, width, height} = axisCanvas.getBoundingClientRect();

          const str = (track.name || track.id).replace(/\W/g, '');
          const id = `${str}_axis_guid_${domUtils.guid()}`;

          context.saveWithTranslationAndClipRect(id, deltaX, y + deltaY, width, height, 0);

          track.paintAxis(context, width, height);

          context.restore();
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const DEFAULT_COLOR = "rgb(150,150,150)";

  class WigTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
      }

      init(config) {
          super.init(config);

          this.type = "wig";
          this.height = config.height || 50;
          this.featureType = 'numeric';
          this.paintAxis = paintAxis;

          const format = config.format ? config.format.toLowerCase() : config.format;
          this.flipAxis = config.flipAxis ? config.flipAxis : false;
          this.logScale = config.logScale ? config.logScale : false;
          if (config.featureSource) {
              this.featureSource = config.featureSource;
              delete config.featureSource;
          } else if ("bigwig" === format) {
              this.featureSource = new BWSource(config, this.browser.genome);
          } else if ("tdf" === format) {
              this.featureSource = new TDFSource(config, this.browser.genome);
          } else {
              this.featureSource = FeatureSource(config, this.browser.genome);
          }

          this.autoscale = config.autoscale || config.max === undefined;
          if (!this.autoscale) {
              this.dataRange = {
                  min: config.min || 0,
                  max: config.max
              };
          }

          this.windowFunction = config.windowFunction || "mean";
          this.graphType = config.graphType || "bar";
          this.normalize = config.normalize;  // boolean, for use with "TDF" files
          this.scaleFactor = config.scaleFactor;  // optional scale factor, ignored if normalize === true;
      }

      async postInit() {
          const header = await this.getHeader();
          if (this.disposed) return   // This track was removed during async load
          if (header) this.setTrackProperties(header);
      }

      async getFeatures(chr, start, end, bpPerPixel) {
          const features = await this.featureSource.getFeatures({
              chr,
              start,
              end,
              bpPerPixel,
              visibilityWindow: this.visibilityWindow,
              windowFunction: this.windowFunction
          });
          if (this.normalize && this.featureSource.normalizationFactor) {
              const scaleFactor = this.featureSource.normalizationFactor;
              for (let f of features) {
                  f.value *= scaleFactor;
              }
          }
          if (this.scaleFactor) {
              const scaleFactor = this.scaleFactor;
              for (let f of features) {
                  f.value *= scaleFactor;
              }
          }
          return features
      }

      menuItemList() {
          let items = [];

          if (this.flipAxis !== undefined) {
              items.push('<hr>');
              items.push({
                  label: "Flip y-axis",
                  click: () => {
                      this.flipAxis = !this.flipAxis;
                      this.trackView.repaintViews();
                  }
              });
          }

          items = items.concat(MenuUtils.numericDataMenuItems(this.trackView));

          return items
      }

      async getHeader() {

          if (typeof this.featureSource.getHeader === "function") {
              this.header = await this.featureSource.getHeader();
          }
          return this.header
      }

      // TODO: refactor to igvUtils.js
      getScaleFactor(min, max, height, logScale) {
          const scale = logScale ? height / (Math.log10(max + 1) - (min <= 0 ? 0 : Math.log10(min + 1))) : height / (max - min);
          return scale
      }

      computeYPixelValue(yValue, yScaleFactor) {
          return (this.flipAxis ? (yValue - this.dataRange.min) : (this.dataRange.max - yValue)) * yScaleFactor
      }

      computeYPixelValueInLogScale(yValue, yScaleFactor) {
          let maxValue = this.dataRange.max;
          let minValue = this.dataRange.min;
          if (maxValue <= 0) return 0 // TODO:
          if (minValue <= -1) minValue = 0;
          minValue = (minValue <= 0) ? 0 : Math.log10(minValue + 1);
          maxValue = Math.log10(maxValue + 1);
          yValue = Math.log10(yValue + 1);
          return ((this.flipAxis ? (yValue - minValue) : (maxValue - yValue)) * yScaleFactor)
      }

      draw(options) {

          const features = options.features;
          const ctx = options.context;
          const bpPerPixel = options.bpPerPixel;
          const bpStart = options.bpStart;
          const pixelWidth = options.pixelWidth;
          options.pixelHeight;
          const bpEnd = bpStart + pixelWidth * bpPerPixel + 1;
          const posColor = this.color || DEFAULT_COLOR;

          let baselineColor;
          if (typeof posColor === "string" && posColor.startsWith("rgb(")) {
              baselineColor = IGVColor.addAlpha(posColor, 0.1);
          }
          const scaleFactor = this.getScaleFactor(this.dataRange.min, this.dataRange.max, options.pixelHeight, this.logScale);
          const yScale = (yValue) => this.logScale
              ? this.computeYPixelValueInLogScale(yValue, scaleFactor)
              : this.computeYPixelValue(yValue, scaleFactor);

          if (features && features.length > 0) {

              if (this.dataRange.min === undefined) this.dataRange.min = 0;

              // Max can be less than min if config.min is set but max left to autoscale.   If that's the case there is
              // nothing to paint.
              if (this.dataRange.max > this.dataRange.min) {

                  let lastPixelEnd = -1;
                  let lastY;
                  const y0 = yScale(0);
                  for (let f of features) {

                      if (f.end < bpStart) continue
                      if (f.start > bpEnd) break

                      const x = Math.floor((f.start - bpStart) / bpPerPixel);
                      if (isNaN(x)) continue

                      let y = yScale(f.value);

                      const rectEnd = Math.ceil((f.end - bpStart) / bpPerPixel);
                      const width = Math.max(1, rectEnd - x);

                      const color = this.getColorForFeature(f);

                      if (this.graphType === "points") {
                          const pointSize = this.config.pointSize || 3;
                          const px = x + width / 2;
                          IGVGraphics.fillCircle(ctx, px, y, pointSize / 2, {"fillStyle": color, "strokeStyle": color});

                      } else if (this.graphType === "line") {
                          if (lastY != undefined) {
                              IGVGraphics.strokeLine(ctx, lastPixelEnd, lastY, x, y, {
                                  "fillStyle": color,
                                  "strokeStyle": color
                              });
                          }
                          IGVGraphics.strokeLine(ctx, x, y, x + width, y, {"fillStyle": color, "strokeStyle": color});
                      } else {
                          const height = y - y0;
                          IGVGraphics.fillRect(ctx, x, y0, width, height, {fillStyle: color});

                      }
                      lastPixelEnd = x + width;
                      lastY = y;
                  }

                  // If the track includes negative values draw a baseline
                  if (this.dataRange.min < 0) {
                      const basepx = (this.dataRange.max / (this.dataRange.max - this.dataRange.min)) * options.pixelHeight;
                      IGVGraphics.strokeLine(ctx, 0, basepx, options.pixelWidth, basepx, {strokeStyle: baselineColor});
                  }
              }
          }

          // Draw guidelines
          if (this.config.hasOwnProperty('guideLines')) {
              for (let line of this.config.guideLines) {
                  if (line.hasOwnProperty('color') && line.hasOwnProperty('y') && line.hasOwnProperty('dotted')) {
                      let y = yScale(line.y);
                      let props = {
                          'strokeStyle': line['color'],
                          'strokeWidth': 2
                      };
                      if (line['dotted']) IGVGraphics.dashedLine(options.context, 0, y, options.pixelWidth, y, 5, props);
                      else IGVGraphics.strokeLine(options.context, 0, y, options.pixelWidth, y, props);
                  }
              }
          }
      }

      popupData(clickState, features) {

          if (features === undefined) features = this.clickedFeatures(clickState);

          if (features && features.length > 0) {

              const genomicLocation = clickState.genomicLocation;
              const popupData = [];

              // Sort features based on distance from click
              features.sort(function (a, b) {
                  const distA = Math.abs((a.start + a.end) / 2 - genomicLocation);
                  const distB = Math.abs((b.start + b.end) / 2 - genomicLocation);
                  return distA - distB
              });

              // Display closest 10
              const displayFeatures = features.length > 10 ? features.slice(0, 10) : features;

              // Resort in ascending order
              displayFeatures.sort(function (a, b) {
                  return a.start - b.start
              });

              for (let selectedFeature of displayFeatures) {
                  if (selectedFeature) {
                      if (popupData.length > 0) {
                          popupData.push('<hr/>');
                      }
                      let posString = (selectedFeature.end - selectedFeature.start) === 1 ?
                          numberFormatter$1(selectedFeature.start + 1)
                          : numberFormatter$1(selectedFeature.start + 1) + "-" + numberFormatter$1(selectedFeature.end);
                      popupData.push({name: "Position:", value: posString});
                      popupData.push({
                          name: "Value:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
                          value: numberFormatter$1(selectedFeature.value)
                      });
                  }
              }
              if (displayFeatures.length < features.length) {
                  popupData.push("<hr/>...");
              }

              return popupData

          } else {
              return []
          }
      }

      get supportsWholeGenome() {
          return !this.config.indexURL && this.config.supportsWholeGenome !== false
      }

      /**
       * Return color for feature.
       * @param feature
       * @returns {string}
       */

      getColorForFeature(f) {
          let c = (f.value < 0 && this.altColor) ? this.altColor : this.color || DEFAULT_COLOR;
          return (typeof c === "function") ? c(f.value) : c
      }

      /**
       * Called when the track is removed.  Do any needed cleanup here
       */
      dispose() {
          this.trackView = undefined;
      }

      /**
       * Return the current state of the track.  Used to create sessions and bookmarks.
       *
       * @returns {*|{}}
       */
      getState() {

          const config = super.getState();

          if (this.flipAxis !== undefined) config.flipAxis = this.flipAxis;
          if (this.logScale !== undefined) config.logScale = this.logScale;

          return config
      }
  }

  /**
   *
   * @param cs - object containing
   * 1) array of threshold values defining bin boundaries in ascending order
   * 2) array of colors for bins  (length == thresholds.length + 1)
   * @constructor
   */
  function BinnedColorScale(cs) {
      this.thresholds = cs.thresholds;
      this.colors = cs.colors;
  }

  BinnedColorScale.prototype.getColor = function (value) {

      for (let threshold of this.thresholds) {
          if (value < threshold) {
              return this.colors[this.thresholds.indexOf(threshold)]
          }
      }

      return this.colors[this.colors.length - 1]

  };

  /**
   *
   * @param scale - object with the following properties
   *           low
   *           lowR
   *           lowG
   *           lowB
   *           high
   *           highR
   *           highG
   *           highB
   *
   * @constructor
   */
  function GradientColorScale(scale) {

      this.scale = scale;
      this.lowColor = "rgb(" + scale.lowR + "," + scale.lowG + "," + scale.lowB + ")";
      this.highColor = "rgb(" + scale.highR + "," + scale.highG + "," + scale.highB + ")";
      this.diff = scale.high - scale.low;

  }

  GradientColorScale.prototype.getColor = function (value) {

      var scale = this.scale, r, g, b, frac;

      if (value <= scale.low) return this.lowColor
      else if (value >= scale.high) return this.highColor

      frac = (value - scale.low) / this.diff;
      r = Math.floor(scale.lowR + frac * (scale.highR - scale.lowR));
      g = Math.floor(scale.lowG + frac * (scale.highG - scale.lowG));
      b = Math.floor(scale.lowB + frac * (scale.highB - scale.lowB));

      return "rgb(" + r + "," + g + "," + b + ")"
  };

  class ConstantColorScale {
      constructor(color) {
          this.color = color;
      }

      getColor() {
          return this.color
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class SegTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
      }

      init(config) {
          super.init(config);

          this.type = config.type || "seg";
          if (this.type === 'maf') this.type = 'mut';
          this.isLog = config.isLog;
          this.displayMode = config.displayMode || "EXPANDED"; // EXPANDED | SQUISHED
          this.height = config.height || 300;
          this.maxHeight = config.maxHeight || 500;
          this.squishedRowHeight = config.sampleSquishHeight || config.squishedRowHeight || 2;
          this.expandedRowHeight = config.sampleExpandHeight || config.expandedRowHeight || 13;
          this.sampleHeight = this.squishedRowHeight;      // Initial value, will get overwritten when rendered

          if (config.color) {
              this.color = config.color;
          } else {
              // Color scales for "seg" (copy number) tracks.
              this.posColorScale = config.posColorScale ||
                  new GradientColorScale({
                      low: 0.1,
                      lowR: 255,
                      lowG: 255,
                      lowB: 255,
                      high: 1.5,
                      highR: 255,
                      highG: 0,
                      highB: 0
                  });
              this.negColorScale = config.negColorScale ||
                  new GradientColorScale({
                      low: -1.5,
                      lowR: 0,
                      lowG: 0,
                      lowB: 255,
                      high: -0.1,
                      highR: 255,
                      highG: 255,
                      highB: 255
                  });

              // Default color table for mutation (mut and maf) tracks
              if (this.type === "mut") {
                  this.colorTable = new ColorTable(config.colorTable || MUT_COLORS);
              }
          }

          this.sampleKeys = [];
          this.sampleNames = new Map();
          if (config.samples) {
              // Explicit setting, keys == names
              for (let s of config.samples) {
                  this.sampleKeys.push(s);
                  this.sampleNames.set(s, s);
              }
              this.explicitSamples = true;
          }

          //   this.featureSource = config.sourceType === "bigquery" ?
          //       new igv.BigQueryFeatureSource(this.config) :

          // Disable whole genome downsampling unless explicitly.
          const configCopy = Object.assign({}, this.config);
          configCopy.maxWGCount = configCopy.maxWGCount || Number.MAX_SAFE_INTEGER;
          this.featureSource = FeatureSource(configCopy, this.browser.genome);

          this.initialSort = config.sort;
      }

      async postInit() {
          if (typeof this.featureSource.getHeader === "function") {
              this.header = await this.featureSource.getHeader();
              if(this.disposed) return;   // This track was removed during async load
          }
          // Set properties from track line
          if (this.header) {
              this.setTrackProperties(this.header);
          }
      }


      menuItemList() {

          const menuItems = [];
          const lut =
              {
                  "SQUISHED": "Squish",
                  "EXPANDED": "Expand",
                  "FILL": "Fill"
              };

          menuItems.push('<hr/>');
          menuItems.push("DisplayMode:");

          const displayOptions = this.type === 'seg' ? ["SQUISHED", "EXPANDED", "FILL"] : ["SQUISHED", "EXPANDED"];

          for (let displayMode of displayOptions) {

              const checkBox = createCheckbox(lut[displayMode], displayMode === this.displayMode);
              menuItems.push(
                  {
                      object: $$1(checkBox),
                      click: () => {
                          this.displayMode = displayMode;
                          this.config.displayMode = displayMode;
                          this.trackView.checkContentHeight();
                          this.trackView.repaintViews();
                          this.trackView.moveScroller(this.trackView.sampleNameViewport.trackScrollDelta);
                      }
                  });
          }

          return menuItems

      }

      hasSamples() {
          return true   // SEG, MUT, and MAF tracks have samples by definition
      }

      getSamples() {
          return {
              names: this.sampleKeys.map(key => this.sampleNames.get(key)),
              height: this.sampleHeight,
              yOffset: 0
          }
      }

      async getFeatures(chr, start, end) {
          const features = await this.featureSource.getFeatures({chr, start, end});
          if (this.initialSort) {
              const sort = this.initialSort;
              this.sortSamples(sort.chr, sort.start, sort.end, sort.direction, features);
              this.initialSort = undefined;  // Sample order is sorted,
          }
          return features
      }


      draw({context, renderSVG, pixelTop, pixelWidth, pixelHeight, features, bpPerPixel, bpStart}) {

          IGVGraphics.fillRect(context, 0, pixelTop, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});

          if (features && features.length > 0) {

              this.checkForLog(features);

              // New segments could conceivably add new samples
              this.updateSampleKeys(features);

              // Create a map for fast id -> row lookup
              const samples = {};
              this.sampleKeys.forEach(function (id, index) {
                  samples[id] = index;
              });

              let border;
              switch (this.displayMode) {
                  case "FILL":
                      this.sampleHeight = pixelHeight / this.sampleKeys.length;
                      border = 0;
                      break

                  case "SQUISHED":
                      this.sampleHeight = this.squishedRowHeight;
                      border = 0;
                      break
                  default:   // EXPANDED
                      this.sampleHeight = this.expandedRowHeight;
                      border = 1;
              }
              const rowHeight = this.sampleHeight;


              // this.featureMap = new Map()

              for (let segment of features) {
                  segment.pixelRect = undefined;   // !important, reset this in case segment is not drawn
              }

              const pixelBottom = pixelTop + pixelHeight;
              const bpEnd = bpStart + pixelWidth * bpPerPixel + 1;
              const xScale = bpPerPixel;

              this.sampleYStart = undefined;
              for (let f of features) {

                  if (f.end < bpStart) continue
                  if (f.start > bpEnd) break

                  const sampleKey = f.sampleKey || f.sample;
                  f.row = samples[sampleKey];
                  const y = f.row * rowHeight + border;

                  if (undefined === this.sampleYStart) {
                      this.sampleYStart = y;
                  }

                  const bottom = y + rowHeight;

                  if (bottom < pixelTop || y > pixelBottom) {
                      continue
                  }

                  const segmentStart = Math.max(f.start, bpStart);
                  // const segmentStart = segment.start;
                  let x = Math.round((segmentStart - bpStart) / xScale);

                  const segmentEnd = Math.min(f.end, bpEnd);
                  // const segmentEnd = segment.end;
                  const x1 = Math.round((segmentEnd - bpStart) / xScale);
                  let w = Math.max(1, x1 - x);

                  let color;
                  if (this.color) {
                      if (typeof this.color === "function") {
                          color = this.color(f);
                      } else {
                          color = this.color;
                      }
                  } else if (this.colorTable) {
                      color = this.colorTable.getColor(f.value.toLowerCase());
                  }

                  let h;
                  if ("mut" === this.type) {
                      h = rowHeight - 2 * border;
                      if (w < 3) {
                          w = 3;
                          x -= 1;
                      }
                  } else {
                      // Assume seg track
                      let value = f.value;
                      if (!this.isLog) {
                          value = IGVMath.log2(value / 2);
                      }
                      if (value < -0.1) {
                          color = this.negColorScale.getColor(value);
                      } else if (value > 0.1) {
                          color = this.posColorScale.getColor(value);
                      } else {
                          color = "white";
                      }

                      let sh = rowHeight;
                      if (rowHeight < 0.25) {
                          const f = 0.1 + 2 * Math.abs(value);
                          sh = Math.min(1, f * rowHeight);
                      }
                      h = sh - 2 * border;
                  }


                  f.pixelRect = {x, y, w, h};

                  // Use for diagnostic rendering
                  // context.fillStyle = randomRGB(180, 240)
                  // context.fillStyle = randomGrey(200, 255)
                  context.fillStyle = color;
                  context.fillRect(x, y, w, h);
              }

          }

      }


      checkForLog(features) {
          if (this.isLog === undefined) {
              this.isLog = false;
              for (let feature of features) {
                  if (feature.value < 0) {
                      this.isLog = true;
                      return
                  }
              }
          }
      }

      /**
       * Optional method to compute pixel height to accomodate the list of features.  The implementation below
       * has side effects (modifiying the samples hash).  This is unfortunate, but harmless.
       *
       * Note displayMode "FILL" is handled by the viewport
       *
       * @param features
       * @returns {number}
       */
      computePixelHeight(features) {
          if (!features) return 0
          const sampleHeight = ("SQUISHED" === this.displayMode) ? this.squishedRowHeight : this.expandedRowHeight;
          this.updateSampleKeys(features);
          return this.sampleKeys.length * sampleHeight
      }

      /**
       * Sort samples by the average value over the genomic range in the direction indicated (1 = ascending, -1 descending)
       */
      async sortSamples(chr, start, end, direction, featureList) {

          if (!featureList) {
              featureList = await this.featureSource.getFeatures({chr, start, end});
          }
          if (!featureList) return

          this.updateSampleKeys(featureList);

          const scores = {};
          const d2 = (direction === "ASC" ? 1 : -1);

          const sortSeg = () => {
              // Compute weighted average score for each sample
              const bpLength = end - start + 1;
              for (let segment of featureList) {
                  if (segment.end < start) continue
                  if (segment.start > end) break
                  const min = Math.max(start, segment.start);
                  const max = Math.min(end, segment.end);
                  const f = (max - min) / bpLength;
                  const sampleKey = segment.sampleKey || segment.sample;
                  const s = scores[sampleKey] || 0;
                  scores[sampleKey] = s + f * segment.value;
              }

              // Now sort sample names by score
              this.sampleKeys.sort(function (a, b) {
                  let s1 = scores[a];
                  let s2 = scores[b];
                  if (!s1) s1 = d2 * Number.MAX_VALUE;
                  if (!s2) s2 = d2 * Number.MAX_VALUE;
                  if (s1 === s2) return 0
                  else if (s1 > s2) return d2
                  else return d2 * -1
              });
          };

          const sortMut = () => {
              // Compute weighted average score for each sample
              for (let segment of featureList) {
                  if (segment.end < start) continue
                  if (segment.start > end) break
                  const sampleKey = segment.sampleKey || segment.sample;
                  if (!scores.hasOwnProperty(sampleKey) || segment.value.localeCompare(scores[sampleKey]) > 0) {
                      scores[sampleKey] = segment.value;
                  }
              }
              // Now sort sample names by score
              this.sampleKeys.sort(function (a, b) {
                  let sa = scores[a] || "";
                  let sb = scores[b] || "";
                  return d2 * (sa.localeCompare(sb))
              });
          };

          if ("mut" === this.type) {
              sortMut();
          } else {
              sortSeg();
          }

          this.trackView.repaintViews();

      }

      clickedFeatures(clickState) {

          const allFeatures = super.clickedFeatures(clickState);
          const y = clickState.y;
          return allFeatures.filter(function (feature) {
              const rect = feature.pixelRect;
              return rect && y >= rect.y && y <= (rect.y + rect.h)
          })

      }

      hoverText(clickState) {
          const features = this.clickedFeatures(clickState);
          if(features && features.length > 0) {
              return `${features[0].sample}: ${features[0].value}`
          }
      }

      popupData(clickState, featureList) {

          if(featureList === undefined) featureList = this.clickedFeatures(clickState);

          const items = [];

          for (let feature of featureList) {

              // Double line divider between features
              if (items.length > 0) {
                  items.push('<hr/>');
                  items.push('<hr/>');
              }

              // hack for whole genome features, which save the original feature as "_f"
              const f = feature._f || feature;

              const data = (typeof f.popupData === 'function') ?
                  f.popupData(this.type, this.browser.genome.id) :
                  this.extractPopupData(f);
              Array.prototype.push.apply(items, data);

          }

          return items
      }

      contextMenuItemList(clickState) {

          const referenceFrame = clickState.viewport.referenceFrame;
          const genomicLocation = clickState.genomicLocation;

          // Define a region 5 "pixels" wide in genomic coordinates
          const sortDirection = this.config.sort ?
              (this.config.sort.direction === "ASC" ? "DESC" : "ASC") :      // Toggle from previous sort
              "DESC";
          const bpWidth = referenceFrame.toBP(2.5);

          const sortHandler = (sort) => {
              const viewport = clickState.viewport;
              const features = viewport.cachedFeatures;
              this.sortSamples(sort.chr, sort.start, sort.end, sort.direction, features);
          };

          const sortLabel = this.type === 'seg' ? 'Sort by value' : 'Sort by type';

          return [
              {
                  label: sortLabel, click: (e) => {


                      const sort = {
                          direction: sortDirection,
                          chr: clickState.viewport.referenceFrame.chr,
                          start: genomicLocation - bpWidth,
                          end: genomicLocation + bpWidth

                      };

                      sortHandler(sort);

                      this.config.sort = sort;

                  }
              }]

      }

      get supportsWholeGenome() {
          return (this.config.indexed === false || !this.config.indexURL) && this.config.supportsWholeGenome !== false
      }

      updateSampleKeys(featureList) {

          if (this.explicitSamples) return

          for (let feature of featureList) {
              const sampleKey = feature.sampleKey || feature.sample;
              if (!this.sampleNames.has(sampleKey)) {
                  this.sampleNames.set(sampleKey, feature.sample);
                  this.sampleKeys.push(sampleKey);
              }
          }
      }
  }

  // Mut and MAF file default color table

  const MUT_COLORS = {

      "indel": "rgb(0,200,0)",
      "targeted region": "rgb(236,155,43)",
      "truncating": "rgb(	150,0,0)",
      "non-coding transcript": "rgb(0,0,150)",

      // Colors from https://www.nature.com/articles/nature11404
      "synonymous": "rgb(109,165,95)",
      "silent": "rgb(109,135,80)",
      "missense_mutation": "rgb(72,130,187)",
      "missense": "rgb(72,130,187)",
      "splice site": "rgb(143,83,155)",
      "splice_region": "rgb(143,83,155)",
      "nonsense": "rgb(216, 57,81)",
      "nonsense_mutation": "rgb(216, 57,81)",
      "frame_shift_del": "rgb(226,135,65)",
      "frame_shift_ins": "rgb(226,135,65)",
      "in_frame_del": "rgb(247,235,94)",
      "in_frame_ins": "rgb(247,235,94)",
      "*other*": "rgb(159,91,50)"
      //
      // 3'Flank
      // 3'UTR
      // 5'Flank
      // 5'UTR
      // Frame_Shift_Del
      // Frame_Shift_Ins
      // IGR
      // In_Frame_Del
      // In_Frame_Ins
      // Intron
      // Missense_Mutation
      // Nonsense_Mutation
      // Nonstop_Mutation
      // RNA
      // Silent
      // Splice_Region
      // Splice_Site
      // Translation_Start_Site
      // Variant_Classification

  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  /**
   * Represents 2 or more wig tracks overlaid on a common viewport.
   */
  class MergedTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
          this.type = "merged";
          this.featureType = 'numeric';
          this.paintAxis = paintAxis;
          this.graphType = config.graphType;
      }

      init(config) {
          if (!config.tracks) {
              throw Error("Error: no tracks defined for merged track" + config)
          }

          super.init(config);
      }

      async postInit() {

          this.tracks = [];
          const p = [];
          for (let tconf of this.config.tracks) {
              tconf.isMergedTrack = true;
              const t = await this.browser.createTrack(tconf);
              if (t) {
                  t.autoscale = false;     // Scaling done from merged track
                  this.tracks.push(t);
              } else {
                  console.warn("Could not create track " + tconf);
              }

              if (typeof t.postInit === 'function') {
                  p.push(t.postInit());
              }
          }

          this.flipAxis = this.config.flipAxis ? this.config.flipAxis : false;
          this.logScale = this.config.logScale ? this.config.logScale : false;
          this.autoscale = this.config.autoscale || this.config.max === undefined;
          if (!this.autoscale) {
              this.dataRange = {
                  min: this.config.min || 0,
                  max: this.config.max
              };
          }
          for (let t of this.tracks) {
              t.autoscale = false;
              t.dataRange = this.dataRange;
          }

          this.height = this.config.height || 50;

          return Promise.all(p)
      }

      get height() {
          return this._height
      }

      set height(h) {
          this._height = h;
          if (this.tracks) {
              for (let t of this.tracks) {
                  t.height = h;
                  t.config.height = h;
              }
          }
      }

      menuItemList() {
          let items = [];
          if (this.flipAxis !== undefined) {
              items.push({
                  label: "Flip y-axis",
                  click: () => {
                      this.flipAxis = !this.flipAxis;
                      this.trackView.repaintViews();
                  }
              });
          }

          items = items.concat(MenuUtils.numericDataMenuItems(this.trackView));

          return items
      }

      /**
       * Returns a MergedFeatureCollection containing an array of features for the specified range, 1 for each track.
       */
      async getFeatures(chr, bpStart, bpEnd, bpPerPixel) {

          const promises = this.tracks.map((t) => t.getFeatures(chr, bpStart, bpEnd, bpPerPixel));
          const featureArrays = await Promise.all(promises);
          return new MergedFeatureCollection(featureArrays)
      }

      draw(options) {

          const mergedFeatures = options.features;    // A MergedFeatureCollection

          for (let i = 0, len = this.tracks.length; i < len; i++) {
              const trackOptions = Object.assign({}, options);
              trackOptions.features = mergedFeatures.featureArrays[i];
              this.tracks[i].dataRange = this.dataRange;
              this.tracks[i].flipAxis = this.flipAxis;
              this.tracks[i].logScale = this.logScale;
              if (this.graphType) {
                  this.tracks[i].graphType = this.graphType;
              }
              this.tracks[i].draw(trackOptions);
          }
      }

      popupData(clickState) {

          if(clickState.viewport && clickState.viewport.cachedFeatures) {

              const featuresArray = clickState.viewport.cachedFeatures.featureArrays;

              if (featuresArray && featuresArray.length === this.tracks.length) {
                  // Array of feature arrays, 1 for each track
                  const popupData = [];
                  for (let i = 0; i < this.tracks.length; i++) {
                      if (i > 0) popupData.push('<hr/>');
                      popupData.push(`<div style=background-color:rgb(245,245,245);border-bottom-style:dashed;border-bottom-width:1px;padding-bottom:5px;padding-top:10px;font-weight:bold;font-size:larger >${this.tracks[i].name}</div>`);
                      const trackPopupData = this.tracks[i].popupData(clickState, featuresArray[i]);
                      popupData.push(...trackPopupData);

                  }
                  return popupData
              }
          }
      }

      clickedFeatures(clickState) {


          // We use the cached features rather than method to avoid async load.  If the
          // feature is not already loaded this won't work,  but the user wouldn't be mousing over it either.
          const mergedFeaturesCollection = clickState.viewport.cachedFeatures;

          if(!mergedFeaturesCollection) {
              return [];
          }

          const genomicLocation = clickState.genomicLocation;
          const clickedFeatures = [];
          for(let features of mergedFeaturesCollection.featureArrays) {
              // When zoomed out we need some tolerance around genomicLocation
              const tolerance = (clickState.referenceFrame.bpPerPixel > 0.2) ? 3 * clickState.referenceFrame.bpPerPixel : 0.2;
              const ss = genomicLocation - tolerance;
              const ee = genomicLocation + tolerance;
              const tmp = (FeatureUtils.findOverlapping(features, ss, ee));
              for(let f of tmp) {
                  clickedFeatures.push(f);
              }
          }
          return clickedFeatures;
      }


      get supportsWholeGenome() {
          return this.tracks.every(track => track.supportsWholeGenome)
      }
  }


  class MergedFeatureCollection {

      constructor(featureArrays) {
          this.featureArrays = featureArrays;
      }

      getMax(start, end) {
          let max = -Number.MAX_VALUE;
          for (let a of this.featureArrays) {
              for (let f of a) {
                  if (typeof f.value !== 'undefined' && !Number.isNaN(f.value)) {
                      if (f.end < start) {
                          continue
                      }
                      if (f.start > end) {
                          break
                      }
                      max = Math.max(max, f.value);
                  }
              }
          }
          return max
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2018 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  function getArcType(config) {
      if (!config.arcType) {
          return "nested"
      }
      switch (config.arcType) {
          case "chiapet":
              return "inView"
          case "chiapetoutbound":
              return "partialInView"
          default:
              return config.arcType
      }
  }

  const DEFAULT_ARC_COLOR = "rgb(180,25,137)";

  class InteractionTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
      }

      init(config) {

          super.init(config);
          this.theta = config.theta || Math.PI / 4;
          this.sinTheta = Math.sin(this.theta);
          this.cosTheta = Math.cos(this.theta);
          this.height = config.height || 250;
          this.arcType = getArcType(config);   // nested | proportional | inView | partialInView
          this.arcOrientation = (config.arcOrientation === undefined ? true : config.arcOrientation); // true for up, false for down
          this.showBlocks = config.showBlocks === undefined ? true : config.showBlocks;
          this.blockHeight = config.blockHeight || 3;
          this.thickness = config.thickness || 1;
          this.color = config.color;
          this.alpha = config.alpha || 0.02;  // was: 0.15
          this.painter = {flipAxis: !this.arcOrientation, dataRange: this.dataRange, paintAxis: paintAxis};

          if (config.valueColumn) {
              this.valueColumn = config.valueColumn;
              this.hasValue = true;
          } else if (config.useScore) {
              this.hasValue = true;
              this.valueColumn = "score";
          }

          this.logScale = config.logScale !== false;   // i.e. defaul to true (undefined => true)
          if (config.max) {
              this.dataRange = {
                  min: config.min || 0,
                  max: config.max
              };
              this.autoscale = false;
          } else {
              this.autoscale = true;
          }

          // Create the FeatureSource and override the default whole genome method
          if (config.featureSource) {
              this.featureSource = config.featureSource;
              delete config._featureSource;
          } else {
              this.featureSource = FeatureSource(config, this.browser.genome);
              this.featureSource.getWGFeatures = getWGFeatures;
          }
      }

      async postInit() {

          if (typeof this.featureSource.getHeader === "function") {
              this.header = await this.featureSource.getHeader();
              if(this.disposed) return;   // This track was removed during async load
          }

          // Set properties from track line
          if (this.header) {
              this.setTrackProperties(this.header);
          }

          if (this.visibilityWindow === undefined && typeof this.featureSource.defaultVisibilityWindow === 'function') {
              this.visibilityWindow = await this.featureSource.defaultVisibilityWindow();
              this.featureSource.visibilityWindow = this.visibilityWindow;  // <- this looks odd
          }

          return this
      }

      get supportsWholeGenome() {
          return true
      }

      async getFeatures(chr, start, end) {
          const visibilityWindow = this.visibilityWindow;
          const features = await this.featureSource.getFeatures({chr, start, end, visibilityWindow});

          // Check for score or value
          if (this.hasValue === undefined && features && features.length > 0) {
              this.hasValue = features[0].score !== undefined;
          }

          return features
      }

      draw(options) {

          if (this.arcType === "proportional") {
              this.drawProportional(options);
          } else if (this.arcType === "inView" || this.arcType === "partialInView") {
              this.drawProportional(options);
          } else {
              this.drawNested(options);
          }
      }

      drawNested(options) {

          const ctx = options.context;
          const pixelWidth = options.pixelWidth;
          const pixelHeight = options.pixelHeight;
          const viewportWidth = options.viewportWidth;
          const bpPerPixel = options.bpPerPixel;
          const bpStart = options.bpStart;
          const xScale = bpPerPixel;

          IGVGraphics.fillRect(ctx, 0, options.pixelTop, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});

          const featureList = options.features;

          if (featureList) {

              // Autoscale theta
              autoscaleNested.call(this);
              const y = this.arcOrientation ? options.pixelHeight : 0;
              const direction = this.arcOrientation;

              ctx.font = "8px sans-serif";
              ctx.textAlign = "center";

              for (let feature of featureList) {

                  // Reset transient property drawState.  An undefined value => feature has not been drawn.
                  feature.drawState = undefined;

                  let color;
                  if(typeof this.color === 'function') {
                      color = this.color(feature);
                  } else {
                      color = this.color || feature.color || DEFAULT_ARC_COLOR;
                      if (color && this.config.useScore) {
                          color = getAlphaColor(color, scoreShade(feature.score));
                      }
                  }

                  ctx.lineWidth = feature.thickness || this.thickness || 1;

                  if (feature.chr1 === feature.chr2 || feature.chr === 'all') {

                      const {m1, m2} = getMidpoints(feature, this.browser.genome);

                      let pixelStart = Math.round((m1 - bpStart) / xScale);
                      let pixelEnd = Math.round((m2 - bpStart) / xScale);
                      if (pixelEnd < 0 || pixelStart > pixelWidth) continue

                      let w = (pixelEnd - pixelStart);
                      if (w < 3) {
                          w = 3;
                          pixelStart--;
                      }

                      const a = w / 2;
                      const r = a / this.sinTheta;
                      const b = this.cosTheta * r;
                      const xc = pixelStart + a;

                      let yc, startAngle, endAngle;
                      if (direction) { // UP
                          yc = this.height + b;
                          startAngle = Math.PI + Math.PI / 2 - this.theta;
                          endAngle = Math.PI + Math.PI / 2 + this.theta;
                      } else { // DOWN
                          yc = -b;
                          startAngle = Math.PI / 2 - this.theta;
                          endAngle = Math.PI / 2 + this.theta;
                      }

                      if (this.showBlocks && feature.chr !== 'all') {
                          const s1 = (feature.start1 - bpStart) / xScale;
                          const e1 = (feature.end1 - bpStart) / xScale;
                          const s2 = (feature.start2 - bpStart) / xScale;
                          const e2 = (feature.end2 - bpStart) / xScale;
                          const hb = this.arcOrientation ? -this.blockHeight : this.blockHeight;
                          ctx.fillRect(s1, y, e1 - s1, hb);
                          ctx.fillRect(s2, y, e2 - s2, hb);
                      }

                      // Alpha shade (de-emphasize) arcs that extend beyond viewport, unless alpha shading is used for score.
                      if (color && !this.config.useScore && w > viewportWidth) {
                          color = getAlphaColor(color, this.alpha);
                      }
                      ctx.strokeStyle = color;
                      ctx.fillStyle = color;
                      ctx.beginPath();
                      ctx.arc(xc, yc, r, startAngle, endAngle, false);
                      ctx.stroke();
                      feature.drawState = {xc, yc, r};
                  } else {

                      let pixelStart = Math.round((feature.start - bpStart) / xScale);
                      let pixelEnd = Math.round((feature.end - bpStart) / xScale);
                      if (pixelEnd < 0 || pixelStart > pixelWidth) continue

                      let w = (pixelEnd - pixelStart);
                      if (w < 3) {
                          w = 3;
                          pixelStart--;
                      }
                      const otherChr = feature.chr === feature.chr1 ? feature.chr2 : feature.chr1;
                      ctx.strokeStyle = color;
                      // get a sense of trans "spread"
                      ctx.fillStyle = getAlphaColor(getChrColor(otherChr), 0.5);
                      // ctx.fillStyle = color

                      if (direction) {
                          // UP
                          ctx.fillRect(pixelStart, this.height / 2, w, this.height / 2);
                          ctx.fillText(otherChr, pixelStart + w / 2, this.height / 2 - 5);
                          feature.drawState = {x: pixelStart, y: this.height / 2, w: w, h: this.height / 2};
                      } else {
                          ctx.fillRect(pixelStart, 0, w, this.height / 2);
                          ctx.fillText(otherChr, pixelStart + w / 2, this.height / 2 + 13);
                          feature.drawState = {x: pixelStart, y: 0, w: w, h: this.height / 2};
                      }
                  }
              }
          }

          function autoscaleNested() {
              let max = 0;
              for (let feature of featureList) {
                  let pixelStart = (feature.start - bpStart) / xScale;
                  let pixelEnd = (feature.end - bpStart) / xScale;
                  if (pixelStart >= 0 && pixelEnd <= pixelWidth) {
                      max = Math.max(max, pixelEnd - pixelStart);
                  }
              }
              let a = Math.min(viewportWidth, max) / 2;
              if (max > 0) {
                  let coa = (pixelHeight - 10) / a;
                  this.theta = estimateTheta(coa);
                  this.sinTheta = Math.sin(this.theta);
                  this.cosTheta = Math.cos(this.theta);
              }
          }
      }

      getScaleFactor(min, max, height, logScale) {
          const scale = logScale ? height / (Math.log10(max + 1) - (min <= 0 ? 0 : Math.log10(min + 1))) : height / (max - min);
          return scale
      }

      drawProportional(options) {

          const ctx = options.context;
          const pixelWidth = options.pixelWidth;
          const pixelHeight = options.pixelHeight;
          const bpPerPixel = options.bpPerPixel;
          const bpStart = options.bpStart;
          const xScale = bpPerPixel;
          const refStart = options.referenceFrame.start;
          const refEnd = options.referenceFrame.end;


          IGVGraphics.fillRect(ctx, 0, options.pixelTop, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});

          const featureList = options.features;

          if (featureList && featureList.length > 0) {

              // we use the min as a filter but not moving the axis
              const effectiveMin = 0;
              const yScale = this.getScaleFactor(effectiveMin, this.dataRange.max, options.pixelHeight - 1, this.logScale);
              const y = this.arcOrientation ? options.pixelHeight : 0;

              for (let feature of featureList) {

                  // Reset transient property drawState.  An undefined value => feature has not been drawn.
                  feature.drawState = undefined;

                  const value = this.valueColumn ? feature[this.valueColumn] : feature.score;
                  if (value === undefined || Number.isNaN(value)) continue

                  const radiusY = Math.round((this.logScale ? Math.log10(value + 1) : value) * yScale);

                  if (feature.chr1 === feature.chr2 || feature.chr === 'all') {

                      const {m1, m2} = getMidpoints(feature, this.browser.genome);

                      let pixelStart = Math.round((m1 - bpStart) / xScale);
                      let pixelEnd = Math.round((m2 - bpStart) / xScale);
                      let w = (pixelEnd - pixelStart);
                      if (w < 3) {
                          w = 3;
                          pixelStart--;
                      }

                      // Various filters
                      if (value < this.dataRange.min || value > this.dataRange.max) continue
                      if ("proportional" !== this.arcType) {
                          const showOutbound = (this.arcType === "partialInView");
                          const within = (m1 >= refStart && m2 <= refEnd);
                          let outBound = false;
                          let inBound = false;
                          if (!within && showOutbound) {
                              outBound = (refStart <= m1 && m1 <= refEnd);
                              if (!outBound) inBound = (refStart <= m2 && m2 <= refEnd);
                          }
                          if (!(within || outBound || inBound)) continue
                      }


                      const radiusX = w / 2;
                      const xc = pixelStart + w / 2;
                      feature.drawState = {xc, yc: y, radiusX, radiusY};

                      // const arcKey = ((pixelStart << 16) | pixelEnd)
                      // let arc = arcCaches.get(arcKey)
                      // if (arc !== undefined) {
                      //     if (arc.has(radiusY)) {
                      //         continue
                      //     }
                      //     arc.add(radiusY)
                      // } else {
                      //     let arcHeights = new Set()
                      //     arcHeights.add(radiusY)
                      //     arcCaches.set(arcKey, arcHeights)
                      // }

                      const counterClockwise = this.arcOrientation ? true : false;
                      const color = feature.color || this.color;
                      ctx.strokeStyle = color;
                      ctx.lineWidth = feature.thickness || this.thickness || 1;

                      if (true === ctx.isSVG) {
                          ctx.strokeEllipse(xc, y, radiusX, radiusY, 0, 0, Math.PI, counterClockwise);
                      } else {
                          ctx.beginPath();
                          ctx.ellipse(xc, y, radiusX, radiusY, 0, 0, Math.PI, counterClockwise);
                          ctx.stroke();
                      }

                      if (this.alpha) {
                          ctx.fillStyle = getAlphaColor(color, this.alpha);
                          if (true === ctx.isSVG) {
                              ctx.fillEllipse(xc, y, radiusX, radiusY, 0, 0, Math.PI, counterClockwise);
                          } else {
                              ctx.fill();
                          }
                      }

                      if (this.showBlocks && feature.chr !== 'all') {
                          ctx.fillStyle = color;
                          const s1 = (feature.start1 - bpStart) / xScale;
                          const e1 = (feature.end1 - bpStart) / xScale;
                          const s2 = (feature.start2 - bpStart) / xScale;
                          const e2 = (feature.end2 - bpStart) / xScale;
                          const hb = this.arcOrientation ? -this.blockHeight : this.blockHeight;
                          ctx.fillRect(s1, y, e1 - s1, hb);
                          ctx.fillRect(s2, y, e2 - s2, hb);
                      }

                  } else {
                      // Inter chromosome
                      let pixelStart = Math.round((feature.start - bpStart) / xScale);
                      let pixelEnd = Math.round((feature.end - bpStart) / xScale);
                      if (pixelEnd < 0 || pixelStart > pixelWidth || value < this.dataRange.min || value > this.dataRange.max) continue

                      const h = Math.min(radiusY, this.height - 13);   // Leave room for text
                      let w = (pixelEnd - pixelStart);
                      if (w < 3) {
                          w = 3;
                          pixelStart--;
                      }
                      const otherChr = feature.chr === feature.chr1 ? feature.chr2 : feature.chr1;
                      ctx.font = "8px sans-serif";
                      ctx.textAlign = "center";
                      // get a sense of trans "spread"
                      ctx.fillStyle = getAlphaColor(getChrColor(otherChr), 0.5);
                      if (this.arcOrientation) {
                          // UP
                          const y = this.height - h;
                          ctx.fillRect(pixelStart, y, w, h);
                          ctx.fillText(otherChr, pixelStart + w / 2, y - 5);
                          feature.drawState = {x: pixelStart, y, w, h};
                      } else {
                          ctx.fillRect(pixelStart, 0, w, h);
                          ctx.fillText(otherChr, pixelStart + w / 2, h + 13);
                          feature.drawState = {x: pixelStart, y: 0, w, h};
                      }
                  }
              }
          }
      }

      clearAxis(ctx, pixelWidth, pixelHeight) {
          IGVGraphics.fillRect(ctx, 0, 0, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});
      }

      paintAxis(ctx, pixelWidth, pixelHeight) {
          // dataRane is interpreted differently for interactino tracks -- all arcs are drawn from "zero", irrespective of dataRange.min
          const axisRange = {min: 0, max: this.dataRange.max};
          if (this.arcType === "proportional") {
              this.painter.flipAxis = !this.arcOrientation;
              this.painter.dataRange = axisRange;
              this.painter.paintAxis(ctx, pixelWidth, pixelHeight);
          } else if (this.arcType === "inView" || this.arcType === "partialInView") {
              this.painter.flipAxis = !this.arcOrientation;
              this.painter.dataRange = axisRange;
              this.painter.paintAxis(ctx, pixelWidth, pixelHeight);
          } else {
              this.clearAxis(ctx, pixelWidth, pixelHeight);
          }
      }

      menuItemList() {

          let items = [];

          if (this.hasValue) {
              items.push("<hr/>");
              const lut =
                  {
                      "nested": "Nested",
                      "proportional": "Proportional - All",
                      "inView": "Proportional - Both Ends in View",
                      "partialInView": "Proportional - One End in View"
                  };
              items.push("<b>Arc Type</b>");
              for (let arcType of ["nested", "proportional", "inView", "partialInView"]) {
                  items.push(
                      {
                          object: $$1(createCheckbox(lut[arcType], arcType === this.arcType)),
                          click: () => {
                              this.arcType = arcType;
                              this.trackView.repaintViews();
                          }
                      });
              }
          }
          items.push("<hr/>");

          items.push({
              name: "Toggle arc direction",
              click: () => {
                  this.arcOrientation = !this.arcOrientation;
                  this.trackView.repaintViews();
              }
          });
          items.push({
              name: this.showBlocks ? "Hide Blocks" : "Show Blocks",
              click: () => {
                  this.showBlocks = !this.showBlocks;
                  this.trackView.repaintViews();
              }
          });


          if (this.arcType === "proportional" || this.arcType === "inView" || this.arcType === "partialInView") {
              // MenuUtils.numericDataMenuItems(this.trackView).forEach(item => items.push(item))
              items = items.concat(MenuUtils.numericDataMenuItems(this.trackView));
          }

          if (this.browser.circularView) {
              items.push('<hr/>');
              items.push({
                  label: 'Add interactions to circular view',
                  click: () => {
                      for (let viewport of this.trackView.viewports) {
                          this.addChordsForViewport(viewport.referenceFrame);
                      }
                  }
              });
          }

          return items
      }

      contextMenuItemList(clickState) {

          // Experimental JBrowse feature
          if (this.browser.circularView ) {
              const viewport = clickState.viewport;
              const list = [];

              list.push({
                  label: 'Add interactions to circular view',
                  click: () => {
                      const refFrame = viewport.referenceFrame;
                      // first pass: to get all the relevant features
                      this.addChordsForViewport(refFrame);
                  }
              });

              list.push('<hr/>');
              return list
          }
      }

      /**
       * Add chords to the circular view for the given viewport, represented by its reference frame
       * @param refFrame
       */
      addChordsForViewport(refFrame) {
          const cachedFeatures = "all" === refFrame.chr ?
              this.featureSource.getAllFeatures() :
              this.featureSource.featureCache.queryFeatures(refFrame.chr, refFrame.start, refFrame.end);

          // inView features are simply features that have been drawn, i.e. have a drawState
          const inView = cachedFeatures.filter(f => f.drawState);
          if(inView.length === 0) return;

          const chords = makeBedPEChords(inView);
          sendChords(chords, this, refFrame, 0.5);
          //
          //
          // // for filtered set, distinguishing the chromosomes is more critical than tracks
          // const chordSetColor = IGVColor.addAlpha("all" === refFrame.chr ? this.color : getChrColor(refFrame.chr), 0.5)
          // const trackColor = IGVColor.addAlpha(this.color, 0.5)
          //
          // // name the chord set to include locus and filtering information
          // const encodedName = this.name.replaceAll(' ', '%20')
          // const chordSetName = "all" === refFrame.chr ?
          //     encodedName :
          //     `${encodedName} (${refFrame.chr}:${refFrame.start}-${refFrame.end} ; range:${this.dataRange.min}-${this.dataRange.max})`
          // this.browser.circularView.addChords(chords, {track: chordSetName, color: chordSetColor, trackColor: trackColor})
      }

      doAutoscale(features) {

          // if ("proportional" === this.arcType) {
          let max = 0;
          if (features) {
              for (let f of features) {
                  const v = this.valueColumn ? f[this.valueColumn] : f.score;
                  if (!Number.isNaN(v)) {
                      max = Math.max(max, v);
                  }
              }
          }
          return {min: 0, max: max}
          // }
      }

      popupData(clickState, features) {

          if(features === undefined) features = this.clickedFeatures(clickState);

          const data = [];
          for (let feature of features) {

              const f = feature._ || feature;   // For "whole genome" features, which keeps a pointer to the original

              data.push({name: "Region 1", value: positionString(f.chr1, f.start1, f.end1, f.strand1)});
              data.push({name: "Region 2", value: positionString(f.chr2, f.start2, f.end2, f.strand2)});
              if (f.name) {
                  data.push({name: "Name", value: f.name});
              }
              if (f.value !== undefined) {
                  data.push({name: "Value", value: f.value});
              }
              if (f.score !== undefined) {
                  data.push({name: "Score", value: f.score});
              }


              if (f.extras && this.header && this.header.columnNames) {
                  const columnNames = this.header.columnNames;
                  const stdColumns = this.header.hiccups ? 6 : 10;
                  for (let i = stdColumns; i < columnNames.length; i++) {
                      if(this.header.colorColumn === i) continue;
                      if (columnNames[i] === 'info') {
                          extractInfoColumn(data, f.extras[i - stdColumns]);
                      } else {
                          data.push({name: columnNames[i], value: f.extras[i - stdColumns]});
                      }
                  }
              }
              // For now just return the top hit
              break

              //if (data.length > 0) {
              //     data.push("<HR>");
              // }
          }
          return data
      }

      clickedFeatures(clickState) {

          // We use the cached features rather than method to avoid async load.  If the
          // feature is not already loaded this won't work,  but the user wouldn't be mousing over it either.
          const featureList =  clickState.viewport.cachedFeatures;
          const candidates = [];
          if (featureList) {
              const proportional = (this.arcType === "proportional" || this.arcType === "inView" || this.arcType === "partialInView");

              for (let feature of featureList) {

                  if (!feature.drawState) continue

                  if (feature.chr1 === feature.chr2 || feature.chr === 'all') {
                      if (proportional) {
                          //(x-xc)^2/radiusX^2 + (y-yc)^2/radiusY^2 <= 1
                          const {xc, yc, radiusX, radiusY} = feature.drawState;
                          const dx = clickState.canvasX - xc;
                          const dy = clickState.canvasY - yc;
                          const score = (dx / radiusX) * (dx / radiusX) + (dy / radiusY) * (dy / radiusY);
                          if (score <= 1) {
                              candidates.push({score: 1 / score, feature});
                          }
                      } else {
                          const {xc, yc, r} = feature.drawState;
                          const dx = clickState.canvasX - xc;
                          const dy = clickState.canvasY - yc;
                          const score = Math.abs(Math.sqrt(dx * dx + dy * dy) - r);
                          if (score < 5) {
                              candidates.push({score, feature});
                          }
                      }
                  } else {
                      const {x, y, w, h} = feature.drawState;
                      const tolerance = 5;
                      if (clickState.canvasX >= x - tolerance && clickState.canvasX <= x + w + tolerance &&
                          clickState.canvasY >= y && clickState.canvasY <= y + h) {
                          const score = -Math.abs(clickState.canvasX - (x + w / 2));
                          candidates.push({score, feature});
                          break
                      }
                  }
              }
          }

          if (candidates.length > 1) {
              candidates.sort((a, b) => a.score - b.score);
          }
          return candidates.map((c) => c.feature)
      }

      /**
       * Return the current state of the track.  Used to create sessions and bookmarks.
       *
       * @returns {*|{}}
       */
      getState() {

          const config = super.getState();

          // if (this.height !== undefined) config.height = this.height;
          if (this.arcType !== undefined) config.arcType = this.arcType;
          if (this.arcOrientation !== undefined) config.arcOrientation = this.arcOrientation;
          if (this.showBlocks !== undefined) config.showBlocks = this.showBlocks;
          if (this.blockHeight !== undefined) config.blockHeight = this.blockHeight;
          if (this.thickness !== undefined) config.thickness = this.thickness;
          if (this.alpha !== undefined) config.alpha = this.alpha;

          return config
      }
  }

  function getMidpoints(feature, genome) {
      let m1 = (feature.start1 + feature.end1) / 2;
      let m2 = (feature.start2 + feature.end2) / 2;
      if (feature.chr === 'all') {
          m1 = genome.getGenomeCoordinate(feature.chr1, m1);
          m2 = genome.getGenomeCoordinate(feature.chr2, m2);
      }
      if (m1 > m2) {
          const tmp = m1;
          m1 = m2;
          m2 = tmp;
      }
      return {m1, m2}
  }

  function positionString(chr, start, end, strand) {

      return strand && strand !== '.' ?
          `${chr}:${numberFormatter$1(start + 1)}-${numberFormatter$1(end)} (${strand})` :
          `${chr}:${numberFormatter$1(start + 1)}-${numberFormatter$1(end)}`
  }

  /**
   * Estimate theta given the ratio of track height to 1/2 the feature width (coa).  This relationship is approximately linear.
   */
  function estimateTheta(x) {
      let coa = [0.01570925532366355, 0.15838444032453644, 0.3249196962329063, 0.5095254494944288, 0.7265425280053609, 0.9999999999999999];
      let theta = [0.031415926535897934, 0.3141592653589793, 0.6283185307179586, 0.9424777960769379, 1.2566370614359172, 1.5707963267948966];
      let idx;

      for (idx = 0; idx < coa.length; idx++) {
          if (coa[idx] > x) {
              break
          }
      }

      let left = idx === 0 ? 0 : coa[idx - 1];
      let right = idx < coa.length ? coa[idx] : 1;
      let r = (x - left) / (right - left);

      let thetaLeft = idx === 0 ? 0 : theta[idx - 1];
      let thetaRight = idx < theta.length ? theta[idx] : Math.PI / 2;

      return Math.min(Math.PI/2,  (thetaLeft + r * (thetaRight - thetaLeft)))

  }

  const colorAlphaCache = new Map();

  function getAlphaColor(color, alpha) {
      const key = `${color}_${alpha}`;
      let c = colorAlphaCache.get(key);
      if (!c) {
          c = IGVColor.addAlpha(color, alpha);
          colorAlphaCache.set(key, c);
      }
      return c
  }


  /**
   * Called in the context of FeatureSource  (i.e. this == the feature source (a TextFeatureSource) for the track
   *
   * @param allFeatures
   * @returns {[]}
   */
  function getWGFeatures(allFeatures) {

      const makeWGFeature = (f) => {
          const wg = Object.assign({}, f);
          wg.chr = "all";
          wg.start = genome.getGenomeCoordinate(f.chr1, f.start1);
          wg.end = genome.getGenomeCoordinate(f.chr2, f.end2);
          return wg
      };

      const genome = this.genome;

      // First pass -- find the max score feature
      let maxScoreFeature;
      let totalFeatureCount = 0;
      for (let c of genome.wgChromosomeNames) {
          let chrFeatures = allFeatures[c];
          if (chrFeatures) {
              for (let f of chrFeatures) {
                  if (!f.dup) {
                      totalFeatureCount++;
                      if (f.score && (!maxScoreFeature || f.score > maxScoreFeature.score)) {
                          maxScoreFeature = f;
                      }
                  }
              }
          }
      }

      const maxCount = this.maxWGCount;
      const nBins = maxScoreFeature && maxScoreFeature.score > 0 && totalFeatureCount > maxCount ? 5 : 1;   // TODO make a function of total # of features & maxCount?
      const featuresPerBin = Math.floor(maxCount / nBins);
      const binSize = maxScoreFeature && maxScoreFeature.score > 0 ? Math.log(maxScoreFeature.score) / nBins : Number.MAX_SAFE_INTEGER;

      let binnedFeatures = [];
      let counts = [];
      for (let i = 0; i < nBins; i++) {
          counts.push([0]);
          binnedFeatures.push([]);
      }

      for (let c of genome.wgChromosomeNames) {
          let chrFeatures = allFeatures[c];
          if (chrFeatures) {
              for (let f of chrFeatures) {
                  if (!f.dup) {
                      const bin = f.score  ? Math.max(0, Math.min(nBins - 1, Math.floor(Math.log(f.score) / binSize))) : 0;
                      if (binnedFeatures[bin].length < featuresPerBin) {
                          binnedFeatures[bin].push(makeWGFeature(f));
                      } else {
                          //Reservoir sampling
                          const samplingProb = featuresPerBin / (counts[bin] + 1);
                          if (Math.random() < samplingProb) {
                              const idx = Math.floor(Math.random() * (featuresPerBin - 1));
                              binnedFeatures[bin][idx] = makeWGFeature(f);
                          }
                      }
                      counts[bin]++;
                  }
              }
          }
      }

      let wgFeatures;
      if (nBins === 1) {
          wgFeatures = binnedFeatures[0];
      } else {
          wgFeatures = [];
          for (let bf of binnedFeatures) {
              for (let f of bf) wgFeatures.push(f);
          }
          // Keep the feature with max score
          if (maxScoreFeature) {
              wgFeatures.push(makeWGFeature(maxScoreFeature));
          }
          wgFeatures.sort(function (a, b) {
              return a.start - b.start
          });
      }


      return wgFeatures
  }

  /**
   * Extract a gff style info column for popup text.  This convention used by 10X for bedpe files
   *     ALLELIC_FRAC=0.0375670840787;BLACK1=.;BLACK2=.;...
   * @param data
   * @param str
   */
  function extractInfoColumn(data, str) {
      const kvs = str.split(';');
      for (let t of kvs) {
          const kv = t.split('=');
          if (kv.length === 2) {
              data.push({name: kv[0], value: kv[1]});
          }
      }

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const isString = isString$2;


  const DEFAULT_VISIBILITY_WINDOW = 1000000;
  const TOP_MARGIN = 10;
  const STANDARD_FIELDS = new Map([["REF", "referenceBases"], ["ALT", "alternateBases"], ["QUAL", "quality"], ["FILTER", "filter"]]);


  class VariantTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
      }

      init(config) {

          super.init(config);

          this.visibilityWindow = config.visibilityWindow;
          this.displayMode = config.displayMode || "EXPANDED";    // COLLAPSED | EXPANDED | SQUISHED
          this.labelDisplayMode = config.labelDisplayMode;
          this.expandedVariantHeight = config.expandedVariantHeight || config.variantHeight || 10;
          this.squishedVariantHeight = config.squishedVariantHeight || 2;
          this.squishedCallHeight = config.squishedCallHeight || 1;
          this.expandedCallHeight = config.expandedCallHeight || 10;
          this.expandedVGap = config.expandedVGap !== undefined ? config.expandedVGap : 2;
          this.squishedVGap = config.squishedVGap !== undefined ? config.squishedVGap : 1;
          this.expandedGroupGap = config.expandedGroupGap || 10;
          this.squishedGroupGap = config.squishedGroupGap || 5;
          this.featureHeight = config.featureHeight || 14;
          this.visibilityWindow = config.visibilityWindow;
          this.featureSource = FeatureSource(config, this.browser.genome);
          this.noGenotypeColor = config.noGenotypeColor || "rgb(200,180,180)";
          this.noCallColor = config.noCallColor || "rgb(225, 225, 225)";
          this.nonRefColor = config.nonRefColor || "rgb(200, 200, 215)";
          this.mixedColor = config.mixedColor || "rgb(200, 220, 200)";
          this.homrefColor = config.homrefColor || "rgb(200, 200, 200)";
          this.homvarColor = config.homvarColor || "rgb(17,248,254)";
          this.hetvarColor = config.hetvarColor || "rgb(34,12,253)";
          this.sortDirection = "ASC";
          this.type = config.type || "variant";

          this.colorBy = config.colorBy;   // Can be undefined => default
          this._initColorBy = config.colorBy;
          if (config.colorTable) {
              this.colorTables = new Map();
              this.colorTables.set(config.colorBy, new ColorTable(config.colorTable));
          }

          this._strokecolor = config.strokecolor;
          this._context_hook = config.context_hook;

          this.showGenotypes = config.showGenotypes === undefined ? true : config.showGenotypes;

          // The number of variant rows are computed dynamically, but start with "1" by default
          this.variantRowCount(1);

      }

      async postInit() {

          this.header = await this.getHeader();   // cricital, don't remove'
          if(this.disposed) return;   // This track was removed during async load
          if (undefined === this.visibilityWindow && this.config.indexed !== false) {
              const fn = isFile$2(this.config.url) ? this.config.url.name : this.config.url;
              if (isString(fn) && fn.toLowerCase().includes("gnomad")) {
                  this.visibilityWindow = 1000;  // these are known to be very dense
              } else if (typeof this.featureSource.defaultVisibilityWindow === 'function') {
                  this.visibilityWindow = await this.featureSource.defaultVisibilityWindow();
              } else {
                  this.visibilityWindow = DEFAULT_VISIBILITY_WINDOW;
              }
          }
          return this

      }

      get supportsWholeGenome() {
          return this.config.indexed === false || this.config.supportsWholeGenome === true
      }

      get color() {
          return this._color
      }

      set color(c) {
          this._color = c;
          this.colorBy = undefined;
      }

      async getHeader() {

          if (!this.header) {
              if (typeof this.featureSource.getHeader === "function") {
                  const header = await this.featureSource.getHeader();
                  if (header) {
                      this.callSets = header.callSets || [];
                  }
                  this.header = header;
              }
              this.sampleNames = this.callSets ? this.callSets.map(cs => cs.name) : [];
          }

          return this.header
      }

      getCallsetsLength() {
          return this.callSets ? this.callSets.length : 0
      }

      async getFeatures(chr, start, end, bpPerPixel) {

          if (this.header === undefined) {
              this.header = await this.getHeader();
          }
          return this.featureSource.getFeatures({chr, start, end, bpPerPixel, visibilityWindow: this.visibilityWindow})
      }

      hasSamples() {
          return this.getCallsetsLength() > 0
      }

      getSamples() {
          return {
              yOffset: this.sampleYOffset,
              names: this.sampleNames,
              height: this.sampleHeight
          }
      }

      /**
       * The required height in pixels required for the track content.   This is not the visible track height, which
       * can be smaller (with a scrollbar) or larger.
       *
       * @param features
       * @returns {*}
       */
      computePixelHeight(features) {

          if (!features || features.length == 0) return TOP_MARGIN

          const nVariantRows = (this.displayMode === "COLLAPSED") ? 1 : this.nVariantRows;
          const vGap = (this.displayMode === "SQUISHED") ? this.squishedVGap : this.expandedVGap;
          const variantHeight = (this.displayMode === "SQUISHED") ? this.squishedVariantHeight : this.expandedVariantHeight;
          const callHeight = (this.displayMode === "SQUISHED") ? this.squishedCallHeight : this.expandedCallHeight;
          const nCalls = this.showGenotypes === false ? 0 : this.getCallsetsLength() * nVariantRows;
          const h = TOP_MARGIN + nVariantRows * (variantHeight + vGap);
          return h + vGap + (nCalls + 1) * (callHeight + vGap)

      }

      variantRowCount(count) {
          this.nVariantRows = count;
      }

      draw({context, pixelWidth, pixelHeight, bpPerPixel, bpStart, pixelTop, features}) {

          IGVGraphics.fillRect(context, 0, pixelTop, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});

          const vGap = ("SQUISHED" === this.displayMode) ? this.squishedVGap : this.expandedVGap;
          const rowCount = ("COLLAPSED" === this.displayMode) ? 1 : this.nVariantRows;
          const variantHeight = ("SQUISHED" === this.displayMode) ? this.squishedVariantHeight : this.expandedVariantHeight;
          this.variantBandHeight = TOP_MARGIN + rowCount * (variantHeight + vGap);

          let callSets = this.callSets;
          if(!callSets && this._f) {
              callSets = this._f.callSets;   // "Complementary" variant for structural variants
          }
          const nCalls = this.getCallsetsLength();
          if (callSets && nCalls > 0 && this.showGenotypes !== false) {
              IGVGraphics.strokeLine(context, 0, this.variantBandHeight, pixelWidth, this.variantBandHeight, {strokeStyle: 'rgb(224,224,224) '});
          }

          if (features) {

              const callHeight = ("SQUISHED" === this.displayMode) ? this.squishedCallHeight : this.expandedCallHeight;
              const vGap = ("SQUISHED" === this.displayMode) ? this.squishedVGap : this.expandedVGap;
              const bpEnd = bpStart + pixelWidth * bpPerPixel + 1;

              // Loop through variants.  A variant == a row in a VCF file
              for (let variant of features) {

                  if (variant.end < bpStart) continue
                  if (variant.start > bpEnd) break

                  const variantHeight = ("SQUISHED" === this.displayMode) ? this.squishedVariantHeight : this.expandedVariantHeight;
                  const y = TOP_MARGIN + ("COLLAPSED" === this.displayMode ? 0 : variant.row * (variantHeight + vGap));
                  const h = variantHeight;

                  // Compute pixel width.   Minimum width is 3 pixels,  if > 5 pixels create gap between variants
                  let x = Math.round((variant.start - bpStart) / bpPerPixel);
                  let x1 = Math.round((variant.end - bpStart) / bpPerPixel);
                  let w = Math.max(1, x1 - x);
                  if (w < 3) {
                      w = 3;
                      x -= 1;
                  } else if (w > 5) {
                      x += 1;
                      w -= 2;
                  }
                  context.fillStyle = this.getColorForFeature(variant);
                  context.fillRect(x, y, w, h);

                  //only paint stroke if a color is defined
                  let strokecolor = this.getVariantStrokecolor(variant);
                  if (strokecolor){
                    context.strokeStyle = strokecolor;
                    context.strokeRect(x, y, w, h);
                  }

                  // call hook if _context_hook fn is defined
                  this.callContextHook(variant, context, x, y, w, h);

                  variant.pixelRect = {x, y, w, h};

                  // Loop though the calls for this variant.  There will potentially be a call for each sample.
                  if (nCalls > 0 && this.showGenotypes !== false) {

                      const nVariantRows = "COLLAPSED" === this.displayMode ? 1 : this.nVariantRows;
                      this.sampleYOffset = this.variantBandHeight + vGap;
                      this.sampleHeight = nVariantRows * (callHeight + vGap);  // For each sample, there is a call for each variant at this position

                      let sampleNumber = 0;
                      if(callSets && variant.calls) {
                          for (let callSet of callSets) {
                              const call = variant.calls[callSet.id];
                              if (call) {
                                  const row = "COLLAPSED" === this.displayMode ? 0 : variant.row;
                                  const py = this.sampleYOffset + sampleNumber * this.sampleHeight + row * (callHeight + vGap);
                                  let allVar = true;  // until proven otherwise
                                  let allRef = true;
                                  let noCall = false;

                                  if (call.genotype) {
                                      for (let g of call.genotype) {
                                          if ('.' === g) {
                                              noCall = true;
                                              break
                                          } else {
                                              if (g !== 0) allRef = false;
                                              if (g === 0) allVar = false;
                                          }
                                      }
                                  }

                                  if (!call.genotype) {
                                      context.fillStyle = this.noGenotypeColor;
                                  } else if (noCall) {
                                      context.fillStyle = this.noCallColor;
                                  } else if (allRef) {
                                      context.fillStyle = this.homrefColor;
                                  } else if (allVar) {
                                      context.fillStyle = this.homvarColor;
                                  } else {
                                      context.fillStyle = this.hetvarColor;
                                  }

                                  context.fillRect(x, py, w, callHeight);

                                  callSet.pixelRect = {x, y: py, w, h: callHeight};
                              }
                              sampleNumber++;
                          }
                      }
                  }
              }

          }
      };


      getColorForFeature(variant) {

          const v = variant._f || variant;
          let variantColor;

          if (this.colorBy) {
              const colorBy = this.colorBy;
              let value;
              if (v.info.hasOwnProperty(colorBy)) {
                  value = v.info[colorBy];
              } else if (STANDARD_FIELDS.has(colorBy)) {
                  const key = STANDARD_FIELDS.get(colorBy);
                  value = v[key];
              }
              variantColor = this.getVariantColorTable(colorBy).getColor(value);
              if (!variantColor) {
                  variantColor = "gray";
              }

          } else if (this._color) {
              variantColor = (typeof this._color === "function") ? this._color(variant) : this._color;
          } else if ("NONVARIANT" === v.type) {
              variantColor = this.nonRefColor;
          } else if ("MIXED" === v.type) {
              variantColor = this.mixedColor;
          } else {
              variantColor = this.defaultColor;
          }
          return variantColor
      }



      getVariantStrokecolor(variant) {

          const v = variant._f || variant;
          let variantStrokeColor;

          if (this._strokecolor) {
              variantStrokeColor = (typeof this._strokecolor === "function") ? this._strokecolor(v) : this._strokecolor;
          } else {
              variantStrokeColor = undefined;
          }
          return variantStrokeColor
      }

      callContextHook(variant, context, x, y, w, h) {
          if (this._context_hook) {
            if (typeof this._context_hook === "function") {
              const v = variant._f || variant;

              context.save();
              this._context_hook(v, context, x, y, w, h);
              context.restore();
            }
          }
      }

      clickedFeatures(clickState) {

          let featureList = super.clickedFeatures(clickState);

          const vGap = (this.displayMode === 'EXPANDED') ? this.expandedVGap : this.squishedVGap;
          const callHeight = vGap + ("SQUISHED" === this.displayMode ? this.squishedCallHeight : this.expandedCallHeight);
          // Find the variant row (i.e. row assigned during feature packing)
          const yOffset = clickState.y;
          if (yOffset <= this.variantBandHeight) {
              // Variant
              const variantHeight = ("SQUISHED" === this.displayMode) ? this.squishedVariantHeight : this.expandedVariantHeight;
              const variantRow = Math.floor((yOffset - TOP_MARGIN) / (variantHeight + vGap));
              if ("COLLAPSED" !== this.displayMode) {
                  featureList = featureList.filter(f => f.row === variantRow);
              }
          } else if (this.callSets) {
              const callSets = this.callSets;
              const sampleY = yOffset - this.variantBandHeight;
              const sampleRow = Math.floor(sampleY / this.sampleHeight);
              if (sampleRow >= 0 && sampleRow < callSets.length) {
                  const variantRow = Math.floor((sampleY - sampleRow * this.sampleHeight) / callHeight);
                  const variants = "COLLAPSED" === this.displayMode ? featureList : featureList.filter(f => f.row === variantRow);
                  const cs = callSets[sampleRow];
                  featureList = variants.map(v => {
                      const call = v.calls[cs.id];
                      expandGenotype(call, v);
                      return call
                  });
              }
          }

          return featureList
      }


      /**
       * Return "popup data" for feature @ genomic location.  Data is an array of key-value pairs
       */
      popupData(clickState, featureList) {

          if(featureList === undefined) featureList = this.clickedFeatures(clickState);
          const genomicLocation = clickState.genomicLocation;
          const genomeID = this.browser.genome.id;
          const sampleInformation = this.browser.sampleInformation;

          let popupData = [];
          for (let v of featureList) {

              const f = v._f || v;    // Get real variant from psuedo-variant, e.g. whole genome or SV mate

              if (popupData.length > 0) {
                  popupData.push({html: '<hr style="border-top-width:2px ;border-color: #c9c3ba" />'});
              }

              if (typeof f.popupData === 'function') {
                  const v = f.popupData(genomicLocation, genomeID);
                  Array.prototype.push.apply(popupData, v);
              } else {
                  // Assume this is a call (genotype)
                  const call = f;

                  if (call.callSetName !== undefined) {
                      popupData.push({name: 'Name', value: call.callSetName});
                  }

                  if (call.genotypeName) {
                      popupData.push({name: 'Genotype', value: call.genotypeName});
                  }

                  if (call.phaseset !== undefined) {
                      popupData.push({name: 'Phase set', value: call.phaseset});
                  }
                  if (call.genotypeLikelihood !== undefined) {
                      popupData.push({name: 'genotypeLikelihood', value: call.genotypeLikelihood.toString()});
                  }

                  if (sampleInformation) {
                      var attr = sampleInformation.getAttributes(call.callSetName);
                      if (attr) {
                          Object.keys(attr).forEach(function (attrName) {
                              var displayText = attrName.replace(/([A-Z])/g, " $1");
                              displayText = displayText.charAt(0).toUpperCase() + displayText.slice(1);
                              popupData.push({name: displayText, value: attr[attrName]});
                          });
                      }
                  }

                  var infoKeys = Object.keys(call.info);
                  if (infoKeys.length) {
                      popupData.push('<hr/>');
                  }
                  infoKeys.forEach(function (key) {
                      popupData.push({name: key, value: decodeURIComponent(call.info[key])});
                  });
              }
          }
          return popupData

      }


  // VariantTrack.prototype.contextMenuItemList = function (clickState) {
  //
  //     const self = this;
  //     const menuItems = [];
  //
  //     const featureList = this.clickedFeatures(clickState);
  //
  //     if (this.callSets && featureList && featureList.length > 0) {
  //
  //         featureList.forEach(function (variant) {
  //
  //             if ('str' === variant.type) {
  //
  //                 menuItems.push({
  //                     label: 'Sort by allele length',
  //                     click: function () {
  //                         sortCallSetsByAlleleLength(self.callSets, variant, self.sortDirection);
  //                         self.sortDirection = (self.sortDirection === "ASC") ? "DESC" : "ASC";
  //                         self.trackView.repaintViews();
  //                     }
  //                 });
  //
  //             }
  //
  //         });
  //     }
  //
  //
  //     function sortCallSetsByAlleleLength(callSets, variant, direction) {
  //         var d = (direction === "DESC") ? 1 : -1;
  //         Object.keys(callSets).forEach(function (property) {
  //             callSets[property].sort(function (a, b) {
  //                 var aNan = isNaN(variant.calls[a.id].genotype[0]);
  //                 var bNan = isNaN(variant.calls[b.id].genotype[0]);
  //                 if (aNan && bNan) {
  //                     return 0;
  //                 } else if (aNan) {
  //                     return 1;
  //                 } else if (bNan) {
  //                     return -1;
  //                 } else {
  //                     var a0 = getAlleleString(variant.calls[a.id], variant, 0);
  //                     var a1 = getAlleleString(variant.calls[a.id], variant, 1);
  //                     var b0 = getAlleleString(variant.calls[b.id], variant, 0);
  //                     var b1 = getAlleleString(variant.calls[b.id], variant, 1);
  //                     var result = Math.max(b0.length, b1.length) - Math.max(a0.length, a1.length);
  //                     if (result === 0) {
  //                         result = Math.min(b0.length, b1.length) - Math.min(a0.length, a1.length);
  //                     }
  //                     return d * result;
  //                 }
  //             });
  //         });
  //     }
  //
  //
  //     return menuItems;
  //
  // };

      menuItemList() {

          const menuItems = [];

          // color-by INFO attribute
          if (this.header.INFO) {
              //Code below will present checkboxes for all info fields of type "String".   Wait until this is requested
              //const stringInfoKeys = Object.keys(this.header.INFO).filter(key => "String" === this.header.INFO[key].Type);

              // For now stick to explicit info fields (well, exactly 1 for starters)
              if (this.header.INFO) {
                  //const stringInfoKeys = Object.keys(this.header.INFO).filter(key => this.header.INFO[key].Type === "String")
                  const stringInfoKeys = this.header.INFO.SVTYPE ? ['SVTYPE'] : [];
                  if (this._initColorBy && this._initColorBy !== 'SVTYPE') {
                      stringInfoKeys.push(this._initColorBy);
                  }
                  if (stringInfoKeys.length > 0) {
                      menuItems.push('<hr/>');
                      const $e = $$1('<div class="igv-track-menu-category igv-track-menu-border-top">');
                      $e.text('Color by:');
                      menuItems.push({name: undefined, object: $e, click: undefined, init: undefined});
                      stringInfoKeys.sort();
                      for (let item of stringInfoKeys) {
                          const selected = (this.colorBy === item);
                          const label = item ? item : 'None';
                          menuItems.push(this.colorByCB({key: item, label: label}, selected));
                      }
                      menuItems.push(this.colorByCB({key: undefined, label: 'None'}, this.colorBy === undefined));
                      menuItems.push('<hr/>');
                  }
              }
          }

          if (this.getCallsetsLength() > 0) {
              menuItems.push({object: $$1('<div class="igv-track-menu-border-top">')});
              menuItems.push({
                  object: $$1(createCheckbox("Show Genotypes", this.showGenotypes)),
                  click: () => {
                      this.showGenotypes = !this.showGenotypes;
                      //adjustTrackHeight();
                      this.trackView.checkContentHeight();
                      this.trackView.repaintViews();
                  }
              });
          }

          menuItems.push({object: $$1('<div class="igv-track-menu-border-top">')});
          for (let displayMode of ["COLLAPSED", "SQUISHED", "EXPANDED"]) {
              var lut =
                  {
                      "COLLAPSED": "Collapse",
                      "SQUISHED": "Squish",
                      "EXPANDED": "Expand"
                  };

              menuItems.push(
                  {
                      object: $$1(createCheckbox(lut[displayMode], displayMode === this.displayMode)),
                      click: () => {
                          this.displayMode = displayMode;
                          this.trackView.checkContentHeight();
                          this.trackView.repaintViews();
                      }
                  });
          }

          // Experimental JBrowse circular view integration
          if (this.browser.circularView) {

              menuItems.push('<hr>');
              menuItems.push({
                  label: 'Add SVs to circular view',
                  click: () => {
                      for (let viewport of this.trackView.viewports) {
                          this.sendChordsForViewport(viewport);
                      }
                  }
              });
          }

          return menuItems
      }


      contextMenuItemList(clickState) {

          // Experimental JBrowse circular view integration
          if (this.browser.circularView) {
              const viewport = clickState.viewport;
              const list = [];

              list.push({
                  label: 'Add SVs to Circular View',
                  click: () => {
                      this.sendChordsForViewport(viewport);
                  }
              });

              list.push('<hr/>');
              return list
          }
      }


      sendChordsForViewport(viewport) {
          const refFrame = viewport.referenceFrame;
          let inView;
          if("all" === refFrame.chr) {
              const all = this.featureSource.getAllFeatures();
              const arrays = Object.keys(all).map(k => all[k]);
              inView = [].concat(...arrays);
          } else {
            inView = this.featureSource.featureCache.queryFeatures(refFrame.chr, refFrame.start, refFrame.end);

          }

          const chords = makeVCFChords(inView);
          sendChords(chords, this, refFrame, 0.5);
      }

      /**
       * Create a "color by" checkbox menu item, optionally initially checked
       * @param menuItem
       * @param showCheck
       * @returns {{init: undefined, name: undefined, click: clickHandler, object: (jQuery|HTMLElement|jQuery.fn.init)}}
       */
      colorByCB(menuItem, showCheck) {

          const $e = $$1(createCheckbox(menuItem.label, showCheck));
          const clickHandler = () => {

              if (menuItem.key === this.colorBy) {
                  this.colorBy = undefined;
                  delete this.config.colorBy;
                  this.trackView.repaintViews();
              } else {
                  this.colorBy = menuItem.key;
                  this.config.colorBy = menuItem.key;
                  this.trackView.repaintViews();
              }

          };

          return {name: undefined, object: $e, click: clickHandler, init: undefined}
      }

      getState() {

          const config = super.getState();
          if (this._color && typeof this._color !== "function") {
              config.color = this._color;
          }
          return config

      }

      getVariantColorTable(key) {

          if (!this.colorTables) {
              this.colorTables = new Map();
          }

          if (!this.colorTables.has(key)) {
              let tbl;
              switch (key) {
                  case "SVTYPE" :
                      tbl = SV_COLOR_TABLE;
                      break
                  default:
                      tbl = new PaletteColorTable("Set1");
              }
              this.colorTables.set(key, tbl);
          }
          return this.colorTables.get(key)
      }
  }


  function expandGenotype(call, variant) {

      if (call.genotype) {
          let gt = '';
          if (variant.alternateBases === ".") {
              gt = "No Call";
          } else {
              const altArray = variant.alternateBases.split(",");
              for (let allele of call.genotype) {
                  if (gt.length > 0) {
                      gt += "|";
                  }
                  if ('.' === allele) {
                      gt += '.';
                  } else if (allele === 0) {
                      gt += variant.referenceBases;
                  } else {
                      let alt = altArray[allele - 1].replace("<", "&lt;");
                      gt += alt;
                  }
              }
          }
          call.genotypeName = gt;
      }
  }


  const SV_COLOR_TABLE = new ColorTable({
      'DEL': '#ff2101',
      'INS': '#001888',
      'DUP': '#028401',
      'INV': '#008688',
      'CNV': '#8931ff',
      'BND': '#891100',
      '*': '#002eff'
  });

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class EqtlTrack extends TrackBase {

      constructor(config, browser) {

          super(config, browser);
      }

      init(config) {
          super.init(config);

          this.name = config.name;
          this.pValueField = config.pValueField || "pValue";
          this.geneField = config.geneField || "geneSymbol";
          this.snpField = config.snpField || "snp";

          const min = config.minLogP || config.min;
          const max = config.maxLogP || config.max;
          this.dataRange = {
              min: min || 3.5,
              max: max || 25
          };
          if (!max) {
              this.autoscale = true;
          } else {
              this.autoscale = config.autoscale;
          }
          this.autoscalePercentile = (config.autoscalePercentile === undefined ? 98 : config.autoscalePercentile);


          this.background = config.background;    // No default
          this.divider = config.divider || "rgb(225,225,225)";
          this.dotSize = config.dotSize || 2;
          this.height = config.height || 100;
          this.autoHeight = false;
          this.disableButtons = config.disableButtons;

          // Limit visibility window to 2 mb,  gtex server gets flaky beyond that
          this.visibilityWindow = config.visibilityWindow === undefined ?
              2000000 : config.visibilityWindow >= 0 ? Math.min(2000000, config.visibilityWindow) : 2000000;

          this.featureSource = FeatureSource(config, this.browser.genome);

          GtexUtils$1.gtexLoaded = true;
      }

      paintAxis(ctx, pixelWidth, pixelHeight) {

          const yScale = (this.dataRange.max - this.dataRange.min) / pixelHeight;

          const font = {
              'font': 'normal 10px Arial',
              'textAlign': 'right',
              'strokeStyle': "black"
          };

          IGVGraphics.fillRect(ctx, 0, 0, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});

          // Determine a tick spacing such that there is at least 10 pixels between ticks

          const n = Math.ceil((this.dataRange.max - this.dataRange.min) * 10 / pixelHeight);

          for (let p = 4; p <= this.dataRange.max; p += n) {

              // TODO: Dashes may not actually line up with correct scale. Ask Jim about this

              const ref = 0.85 * pixelWidth;
              const x1 = ref - 5;
              const x2 = ref;
              const y = pixelHeight - (p - this.dataRange.min) / yScale;

              IGVGraphics.strokeLine(ctx, x1, y, x2, y, font); // Offset dashes up by 2 pixel

              if (y > 8) {
                  IGVGraphics.fillText(ctx, p, x1 - 1, y + 2, font);
              } // Offset numbers down by 2 pixels;
          }

          font['textAlign'] = 'center';

          IGVGraphics.fillText(ctx, "-log10(pvalue)", pixelWidth / 4, pixelHeight / 2, font, {rotate: {angle: -90}});

      };

      async getFeatures(chr, start, end) {

          const pValueField = this.pValueField;
          const visibilityWindow = this.visibilityWindow;
          const features = await this.featureSource.getFeatures({chr, start, end, visibilityWindow});
          features.forEach(function (f) {
              f.value = f[pValueField];
          });
          return features
      }

      draw(options) {

          const ctx = options.context;

          const pixelWidth = options.pixelWidth;
          const pixelHeight = options.pixelHeight;

          if (this.background) {
              IGVGraphics.fillRect(ctx, 0, 0, pixelWidth, pixelHeight, {'fillStyle': this.background});
          }
          IGVGraphics.strokeLine(ctx, 0, pixelHeight - 1, pixelWidth, pixelHeight - 1, {'strokeStyle': this.divider});

          const drawEqtls = (drawSelected) => {

              const radius = drawSelected ? 2 * this.dotSize : this.dotSize;
              const bpStart = options.bpStart;
              const yScale = (this.dataRange.max - this.dataRange.min) / pixelHeight;
              const selection = options.referenceFrame.selection;

              for (let eqtl of options.features) {

                  const px = (eqtl.start - bpStart + 0.5) / options.bpPerPixel;
                  if (px < 0) continue
                  else if (px > pixelWidth) break

                  const snp = eqtl.snp.toUpperCase();
                  const geneName = eqtl[this.geneField].toUpperCase();

                  const isSelected = selection &&
                      (selection.snp === snp || selection.gene === geneName);

                  if (!drawSelected || isSelected) {

                      // Add eqtl's gene to the selection if this is the selected snp.
                      // TODO -- this should not be done here in the rendering code.
                      if (selection && selection.snp === snp) {
                          selection.addGene(geneName);
                      }

                      var mLogP = -Math.log(eqtl[this.pValueField]) / Math.LN10;
                      if (mLogP >= this.dataRange.min) {
                          let capped;
                          if (mLogP > this.dataRange.max) {
                              mLogP = this.dataRange.max;
                              capped = true;
                          } else {
                              capped = false;

                          }

                          const py = Math.max(0 + radius, pixelHeight - Math.round((mLogP - this.dataRange.min) / yScale));
                          eqtl.px = px;
                          eqtl.py = py;
                          eqtl.radius = radius;

                          let color;
                          if (drawSelected && selection) {
                              color = selection.colorForGene(geneName);
                              IGVGraphics.setProperties(ctx, {fillStyle: color, strokeStyle: "black"});
                          } else {
                              color = capped ? "rgb(150, 150, 150)" : "rgb(180, 180, 180)";
                              IGVGraphics.setProperties(ctx, {fillStyle: color, strokeStyle: color});
                          }

                          IGVGraphics.fillCircle(ctx, px, py, radius);
                          IGVGraphics.strokeCircle(ctx, px, py, radius);
                      }
                  }
              }
          };

          // Draw in two passes, with "selected" eqtls drawn last
          drawEqtls(false);
          drawEqtls(true);

      }

      /**
       * Return "popup data" for feature @ genomic location.  Data is an array of key-value pairs
       */
      popupData(clickState, features) {

          if(features === undefined) features = clickState.viewport.cachedFeatures;
          if (!features || features.length === 0) return []

          const tolerance = 3;
          const tissue = this.name;
          const popupData = [];

          for (let feature of features) {
              // Hit test --use square vs circle for efficiency (no sqrt)
              if (Math.abs(feature.px - clickState.canvasX) < (feature.radius + tolerance) &&
                  Math.abs(feature.py - clickState.canvasY) < (feature.radius + tolerance)) {

                  if (popupData.length > 0) {
                      popupData.push('<hr/>');
                  }
                  popupData.push(
                      {name: "snp id", value: feature.snp},
                      {name: "gene id", value: feature.geneId},
                      {name: "gene name", value: feature.geneName},
                      {name: "p value", value: feature.pValue},
                      {name: "tissue", value: tissue});

              }
          }

          return popupData
      }

      menuItemList() {
          return MenuUtils.numericDataMenuItems(this.trackView)
      }

      doAutoscale(featureList) {

          if (featureList.length > 0) {

              var values = featureList
                  .map(function (eqtl) {
                      return -Math.log(eqtl.value) / Math.LN10
                  });

              this.dataRange.max = IGVMath.percentile(values, this.autoscalePercentile);
          } else {
              // No features -- default
              const max = this.config.maxLogP || this.config.max;
              this.dataRange.max = max || 25;
          }

          return this.dataRange
      }

  }

  /**
   * Colors used for coding omosomes
   */

  const GWASColors = {
      "X": "rgb(204, 153, 0)",
      "Y": "rgb(153, 204, 0)",
      "Un": "darkGray)",
      "1": "rgb(80, 80, 255)",
      "2": "rgb(206, 61, 50)",
      "2a": "rgb(210, 65, 55)",
      "2b": "rgb(215, 70, 60)",
      "3": "rgb(116, 155, 88)",
      "4": "rgb(240, 230, 133)",
      "5": "rgb(70, 105, 131)",
      "6": "rgb(186, 99, 56)",
      "7": "rgb(93, 177, 221)",
      "8": "rgb(128, 34, 104)",
      "9": "rgb(107, 215, 107)",
      "10": "rgb(213, 149, 167)",
      "11": "rgb(146, 72, 34)",
      "12": "rgb(131, 123, 141)",
      "13": "rgb(199, 81, 39)",
      "14": "rgb(213, 143, 92)",
      "15": "rgb(122, 101, 165)",
      "16": "rgb(228, 175, 105)",
      "17": "rgb(59, 27, 83)",
      "18": "rgb(205, 222, 183)",
      "19": "rgb(97, 42, 121)",
      "20": "rgb(174, 31, 99)",
      "21": "rgb(231, 199, 111)",
      "22": "rgb(90, 101, 94)",
      "23": "rgb(204, 153, 0)",
      "24": "rgb(153, 204, 0)",
      "25": "rgb(51, 204, 0)",
      "26": "rgb(0, 204, 51)",
      "27": "rgb(0, 204, 153)",
      "28": "rgb(0, 153, 204)",
      "29": "rgb(10, 71, 255)",
      "30": "rgb(71, 117, 255)",
      "31": "rgb(255, 194, 10)",
      "32": "rgb(255, 209, 71)",
      "33": "rgb(153, 0, 51)",
      "34": "rgb(153, 26, 0)",
      "35": "rgb(153, 102, 0)",
      "36": "rgb(128, 153, 0)",
      "37": "rgb(51, 153, 0)",
      "38": "rgb(0, 153, 26)",
      "39": "rgb(0, 153, 102)",
      "40": "rgb(0, 128, 153)",
      "41": "rgb(0, 51, 153)",
      "42": "rgb(26, 0, 153)",
      "43": "rgb(102, 0, 153)",
      "44": "rgb(153, 0, 128)",
      "45": "rgb(214, 0, 71)",
      "46": "rgb(255, 20, 99)",
      "47": "rgb(0, 214, 143)",
      "48": "rgb(20, 255, 177)"
  };

  //  aliasing
  for (let key of Object.keys(GWASColors)) {
      const altName = "chr" + key;
      GWASColors[altName] = GWASColors[key];
  }

  // romanizing
  for(let a = 1; a <= 48; a++) {
      if(a === 10) continue   // Don't overide "X"
      const roman = romanize(a);
      GWASColors[roman] = GWASColors[a.toString()];
  }


  function romanize (num) {
      if (!+num) return false;
      var digits = String(+num).split('');
      var key = ['','C','CC','CCC','CD','D','DC','DCC','DCCC','CM',
          '','X','XX','XXX','XL','L','LX','LXX','LXXX','XC',
          '','I','II','III','IV','V','VI','VII','VIII','IX'];
      var roman = '', i = 3;
      while (i--) roman = (key[+digits.pop() + (i * 10)] || '') + roman;
      return Array(+digits.join('') + 1).join('M') + roman;
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const DEFAULT_POPOVER_WINDOW = 100000000;

  //const type = "gwas";

  class GWASTrack extends TrackBase {

      constructor(config, browser) {

          super(config, browser);
      }

      init(config) {

          super.init(config);

          this.useChrColors = config.useChrColors === undefined ? true : config.useChrColors;
          this.trait = config.trait;
          this.posteriorProbability = config.posteriorProbability;
          this.valueProperty = "bed" === config.format ? "score" : "value";
          this.height = config.height || 100;   // The preferred height
          this.autoscale = config.autoscale;
          this.autoscalePercentile = config.autoscalePercentile === undefined ? 98 : config.autoscalePercentile;
          this.background = config.background;    // No default
          this.divider = config.divider || "rgb(225,225,225)";
          this.dotSize = config.dotSize || 3;
          this.popoverWindow = (config.popoverWindow === undefined ? DEFAULT_POPOVER_WINDOW : config.popoverWindow);

          // Color settings
          if (this.useChrColors) {
              this.colorScale = new ColorTable(config.colorTable || GWASColors);
          } else if (config.color) {
              this.colorScale = new ConstantColorScale(config.color);
          } else {
              this.colorScale =
                  new BinnedColorScale(config.colorScale ||
                      {
                          thresholds: [5e-8, 5e-4, 0.5],
                          colors: ["rgb(255,50,50)", "rgb(251,100,100)", "rgb(251,170,170)", "rgb(227,238,249)"],
                      });
          }

          this.featureSource = FeatureSource(config, this.browser.genome);
      }

      async postInit() {

          if (typeof this.featureSource.getHeader === "function") {
              this.header = await this.featureSource.getHeader();
              if (this.disposed) return   // This track was removed during async load
          }

          // Set properties from track line
          if (this.header) {
              this.setTrackProperties(this.header);   // setTrackProperties defined in TrackBase
          }

          // Set initial range if specfied, unless autoscale == true
          if (!this.autoscale) {
              if (this.posteriorProbability) {
                  this.dataRange = {
                      min: this.config.min === undefined ? 0 : this.config.min,
                      max: this.config.max === undefined ? 1 : this.config.max
                  };
              } else {
                  this.dataRange = {
                      min: this.config.min === undefined ? 0 : this.config.min,
                      max: this.config.max === undefined ? 25 : this.config.max
                  };
              }
          }

          return this

      }


      get supportsWholeGenome() {
          return true
      }

      async getFeatures(chr, start, end) {
          const visibilityWindow = this.visibilityWindow;
          return this.featureSource.getFeatures({chr, start, end, visibilityWindow})
      }

      draw(options) {

          const featureList = options.features;
          const ctx = options.context;
          const pixelWidth = options.pixelWidth;
          const pixelHeight = options.pixelHeight;
          if (this.background) {
              IGVGraphics.fillRect(ctx, 0, 0, pixelWidth, pixelHeight, {'fillStyle': this.background});
          }
          IGVGraphics.strokeLine(ctx, 0, pixelHeight - 1, pixelWidth, pixelHeight - 1, {'strokeStyle': this.divider});

          if (featureList) {

              const bpPerPixel = options.bpPerPixel;
              const bpStart = options.bpStart;
              const bpEnd = bpStart + pixelWidth * bpPerPixel + 1;
              for (let variant of featureList) {
                  const pos = variant.start;
                  if (pos < bpStart) continue
                  if (pos > bpEnd) break

                  let val;
                  if (this.posteriorProbability) {
                      val = variant[this.valueProperty];
                  } else {
                      const pvalue = variant[this.valueProperty];
                      if (!pvalue) continue
                      val = -Math.log10(pvalue);
                  }

                  const colorKey = this.useChrColors ?
                      variant._f ? variant._f.chr : variant.chr :
                      val;

                  const color = this.colorScale.getColor(colorKey);
                  const yScale = (this.dataRange.max - this.dataRange.min) / pixelHeight;
                  const px = Math.round((pos - bpStart) / bpPerPixel);
                  const py = Math.max(this.dotSize, pixelHeight - Math.round((val - this.dataRange.min) / yScale));

                  if (color) {
                      IGVGraphics.setProperties(ctx, {fillStyle: color, strokeStyle: "black"});
                  }
                  IGVGraphics.fillCircle(ctx, px, py, this.dotSize);
                  variant.px = px;
                  variant.py = py;
              }
          }
      }

      paintAxis(ctx, pixelWidth, pixelHeight) {

          IGVGraphics.fillRect(ctx, 0, 0, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});
          var font = {
              'font': 'normal 10px Arial',
              'textAlign': 'right',
              'strokeStyle': "black"
          };

          const yScale = (this.dataRange.max - this.dataRange.min) / pixelHeight;
          if (this.posteriorProbability) {
              const n = 0.1;
              for (let p = this.dataRange.min; p < this.dataRange.max; p += n) {
                  const yp = pixelHeight - Math.round((p - this.dataRange.min) / yScale);
                  IGVGraphics.strokeLine(ctx, 45, yp - 2, 50, yp - 2, font); // Offset dashes up by 2 pixel
                  IGVGraphics.fillText(ctx, p.toFixed(1), 44, yp + 2, font); // Offset numbers down by 2 pixels;
              }
          } else {
              const n = Math.ceil((this.dataRange.max - this.dataRange.min) * 10 / pixelHeight);
              for (let p = this.dataRange.min; p < this.dataRange.max; p += n) {
                  const yp = pixelHeight - Math.round((p - this.dataRange.min) / yScale);
                  IGVGraphics.strokeLine(ctx, 45, yp, 50, yp, font); // Offset dashes up by 2 pixel
                  IGVGraphics.fillText(ctx, Math.floor(p), 44, yp + 4, font); // Offset numbers down by 2 pixels;
              }
          }

          font['textAlign'] = 'center';
          if (this.posteriorProbability) {
              IGVGraphics.fillText(ctx, "PPA", pixelWidth / 2, pixelHeight / 2, font, {rotate: {angle: -90}});
          } else {
              IGVGraphics.fillText(ctx, "-log10(pvalue)", pixelWidth / 2, pixelHeight / 2, font, {rotate: {angle: -90}});
          }
      }

      popupData(clickState, features) {

          if (features === undefined) features = clickState.viewport.cachedFeatures;

          let data = [];
          const track = clickState.viewport.trackView.track;

          if (features) {
              let count = 0;
              for (let f of features) {
                  const xDelta = Math.abs(clickState.canvasX - f.px);
                  const yDelta = Math.abs(clickState.canvasY - f.py);
                  const value = f[this.valueProperty];
                  if (xDelta < this.dotSize && yDelta < this.dotSize) {
                      if (count > 0) {
                          data.push("<HR/>");
                      }
                      if (count == 5) {
                          data.push("...");
                          break
                      }
                      if (typeof f.popupData === 'function') {
                          data = data.concat(f.popupData());
                      } else {
                          const chr = f.realChr || f.chr;
                          const pos = (f.realStart || f.start) + 1;
                          data.push({name: 'chromosome', value: chr});
                          data.push({name: 'position', value: pos});
                          data.push({name: 'name', value: f.name});
                          if (track.posteriorProbability) {
                              data.push({name: 'posterior probability', value: value});
                          } else {
                              data.push({name: 'pValue', value: value});
                          }
                      }
                      count++;
                  }
              }
          }

          return data
      }

      menuItemList() {
          return MenuUtils.numericDataMenuItems(this.trackView)
      }

      doAutoscale(featureList) {

          if (featureList.length > 0) {
              // posterior probabilities are treated without modification, but we need to take a negative logarithm of P values
              const valueProperty = this.valueProperty;
              const posterior = this.posteriorProbability;
              const features =
                  featureList.map(function (feature) {
                      const v = feature[valueProperty];
                      return {value: posterior ? v : -Math.log(v) / Math.LN10}
                  });
              this.dataRange = doAutoscale(features);

          } else {
              // No features -- pick something reasonable for PPAs and p-values
              if (this.posteriorProbability) {
                  this.dataRange = {min: this.config.min || 0, max: this.config.max || 1};
              } else {
                  this.dataRange = {min: this.config.max || 25, max: this.config.min || 0};
              }
          }

          return this.dataRange
      }

  }

  const X_PIXEL_DIFF_THRESHOLD = 1;

  class GCNVTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
      }

      init(config) {
          super.init(config);

          this.autoscale = config.autoscale || config.max === undefined;
          this.dataRange = {
              min: config.min || 0,
              max: config.max
          };

          this.windowFunction = config.windowFunction || "mean";
          this.paintAxis = paintAxis;
          this.graphType = config.graphType || "bar";

          //hack to avoid creating feature source multiple times.  If config.type is not set the file must be read
          //to determine type, which results in creation of a feature source.
          if (config._featureSource) {
              this.featureSource = config._featureSource;
              delete config._featureSource;
          } else {
              this.featureSource = FeatureSource(this.config, this.browser.genome);
          }

          // Visibility window hardcoded to -1  (== whole chromosome).  Draw method needs feature beyond current view,
          // when/if this is resolved visibilityWindow can be used.
          this.visibilityWindow = -1;
          this.featureSource.visibilityWindow = this.visibilityWindow;
      }

      async postInit() {

          if (typeof this.featureSource.getHeader === "function") {
              this.header = await this.featureSource.getHeader();
              if(this.disposed) return;   // This track was removed during async load
              this.sampleNames = this.header.columnNames.slice(3);

              // Set generic properties from track line
              this.setTrackProperties(this.header);   // setTrackProperties defined in TrackBase

              // set option to highlight sample track line on click
              if (this.header.hasOwnProperty("clickToHighlight")) {
                  let colour = this.header["clickToHighlight"];
                  this.config.clickToHighlight = colour;
                  this.config.samplesClickedToHighlight = {};
              }

              // Special track line properties
              if (this.header.hasOwnProperty("highlight")) {
                  this.config.highlightSamples = {};
                  let v = this.header["highlight"];
                  if (!Array.isArray(v)) v = [v];
                  for (let h of v) {
                      const tokens = h.split(";");
                      if (tokens.length === 2) {
                          this.config.highlightSamples[tokens[0]] = tokens[1];
                      }

                  }
              }
          }
      }

      menuItemList() {
          return MenuUtils.numericDataMenuItems(this.trackView)
      }

      async getFeatures(chr, start, end) {
          const chrFeatures = await this.featureSource.getFeatures({
              chr,
              start: 0,
              end: Number.MAX_SAFE_INTEGER,
              visibilityWindow: this.visibilityWindow
          });
          let prevIndex = undefined;
          let nextIndex = undefined;
          for (let i = 1; i < chrFeatures.length - 1; i++) {
              if (prevIndex === undefined && chrFeatures[i].end > start) {
                  prevIndex = i - 1;
              }
              if (nextIndex === undefined && chrFeatures[i].start > end) {
                  nextIndex = i + 1;
                  break
              }
          }
          if (prevIndex === undefined) prevIndex = 0;
          if (nextIndex === undefined) nextIndex = chrFeatures.length;
          return chrFeatures.slice(prevIndex, nextIndex)
      }

      draw(options) {

          const {features, context, bpPerPixel, bpStart, pixelWidth, pixelHeight} = options;

          ///let baselineColor;
          //if (typeof self.color === "string" && self.color.startsWith("rgb(")) {
          //    baselineColor = IGVColor.addAlpha(self.color, 0.1);
          //}

          const yScale = (yValue) => {
              return ((this.dataRange.max - yValue) / (this.dataRange.max - this.dataRange.min)) * pixelHeight
          };

          const getX = function (bpPosition) {
              let x = Math.floor((bpPosition - bpStart) / bpPerPixel);
              if (isNaN(x)) console.warn('isNaN(x). feature start ' + numberFormatter$1(bpPosition) +
                  ' bp start ' + numberFormatter$1(bpStart));
              return x
          };

          const drawGuideLines = (options) => {
              if (this.config.hasOwnProperty('guideLines')) {
                  for (let line of this.config.guideLines) {
                      if (line.hasOwnProperty('color') && line.hasOwnProperty('y') && line.hasOwnProperty('dotted')) {
                          let y = yScale(line.y);
                          let props = {
                              'strokeStyle': line['color'],
                              'strokeWidth': 2
                          };
                          if (line['dotted']) IGVGraphics.dashedLine(options.context, 0, y, options.pixelWidth, y, 5, props);
                          else IGVGraphics.strokeLine(options.context, 0, y, options.pixelWidth, y, props);
                      }
                  }
              }
          };

          if (features && features.length > 0) {

              if (this.dataRange.min === undefined) this.dataRange.min = 0;

              // Max can be less than min if config.min is set but max left to autoscale. If that's the case there is
              // nothing to paint.
              if (this.dataRange.max > this.dataRange.min) {
                  const highlightSamples = this.config.highlightSamples;
                  const onlyHandleClicksForHighlightedSamples = this.config.onlyHandleClicksForHighlightedSamples;
                  const clickToHighlight = this.config.clickToHighlight;

                  let previousEnd = -1;
                  let previousValues = {};

                  let highlightConnectorLines = [];
                  let highlightFeatureLines = [];

                  // clickDetectorCache allows fast retrieval of whether a mouse click hits a rendered line segment
                  // by storing lists of rendered line segments, keyed by their right x coordinate in canvas pixel space.
                  // this cache is regenerated on every draw.
                  this.clickDetectorCache = {};

                  for (let feature of features) {
                      const x1 = getX(feature.start);
                      const x2 = getX(feature.end);
                      const previousX = previousEnd >= 0 ? getX(previousEnd) : x1;

                      if (isNaN(x1) || isNaN(x2)) continue
                      // if ((x1 - previousX < X_PIXEL_DIFF_THRESHOLD) && (x2 - x1 < X_PIXEL_DIFF_THRESHOLD)) continue;

                      this.clickDetectorCache[x1] = [];
                      this.clickDetectorCache[x2] = [];
                      for (let i = 0; i < feature.values.length; i++) {
                          const sampleName = this.sampleNames[i];
                          const value = feature.values[i];
                          const y = yScale(value);
                          if (x1 - previousX >= X_PIXEL_DIFF_THRESHOLD) {
                              const previousValue = previousValues[sampleName];
                              const previousY = yScale(previousValue);
                              const highlightColor = highlightSamples && highlightSamples[sampleName];


                              if (highlightColor) {
                                  highlightConnectorLines.push([previousX, previousY, x1, y, highlightColor]);
                              } else if (clickToHighlight && sampleName in this.config.samplesClickedToHighlight) {
                                  highlightConnectorLines.push([previousX, previousY, x1, y, this.config.samplesClickedToHighlight[sampleName]]);
                              } else {
                                  IGVGraphics.strokeLine(context, previousX, previousY, x1, y, {strokeStyle: '#D9D9D9'});
                              }
                              if (!onlyHandleClicksForHighlightedSamples || sampleName in highlightSamples) {
                                  this.clickDetectorCache[x1].push([previousX, previousY, x1, y, sampleName, highlightColor || 'gray']);
                              }
                          }

                          if (x2 - x1 >= X_PIXEL_DIFF_THRESHOLD) {
                              const highlightColor = highlightSamples && highlightSamples[sampleName];
                              if (highlightColor) {
                                  highlightFeatureLines.push([x1, y, x2, y, highlightColor]);
                              } else if (clickToHighlight && sampleName in this.config.samplesClickedToHighlight) {
                                  highlightFeatureLines.push([x1, y, x2, y, this.config.samplesClickedToHighlight[sampleName]]);
                              } else {
                                  IGVGraphics.strokeLine(context, x1, y, x2, y, {strokeStyle: 'gray'});
                              }
                              if (!onlyHandleClicksForHighlightedSamples || sampleName in highlightSamples) {
                                  this.clickDetectorCache[x2].push([x1, y, x2, y, sampleName, highlightColor || 'gray']);
                              }
                          }

                          previousValues[sampleName] = value;

                          //IGVGraphics.fillCircle(ctx, px, y, pointSize / 2, {"fillStyle": color, "strokeStyle": color});
                          //IGVGraphics.fillRect(ctx, x, y, width, height, {fillStyle: color});
                      }
                      previousEnd = feature.end;
                  }

                  for (let f of highlightConnectorLines) {
                      IGVGraphics.strokeLine(context, f[0], f[1], f[2], f[3], {strokeStyle: f[4], lineWidth: 1.3});
                  }
                  for (let f of highlightFeatureLines) {
                      IGVGraphics.strokeLine(context, f[0], f[1], f[2], f[3], {strokeStyle: f[4], lineWidth: 2});
                  }

                  /*
                  // If the track includes negative values draw a baseline
                  if (this.dataRange.min < 0) {
                      const basepx = (self.dataRange.max / (this.dataRange.max - this.dataRange.min)) * options.pixelHeight;
                      IGVGraphics.strokeLine(context, 0, basepx, options.pixelWidth, basepx, {strokeStyle: baselineColor});
                  }
                  */
              }
          }

          drawGuideLines(options);
      }

      doAutoscale(features) {

          let min, max;
          if (features.length > 0) {
              min = Number.MAX_VALUE;
              max = -Number.MAX_VALUE;

              features.forEach(function (feature) {
                  min = Math.min(min, ...feature.values);
                  max = Math.max(max, ...feature.values);
              });

              min -= 0.01;
              max += 0.01;
          } else {
              // No features -- default
              min = 0;
              max = 100;
          }

          return {min: min, max: max}
      }

      clickedFeatures(clickState) {
          //console.warn('click', clickState.canvasX, clickState.canvasY, clickState)

          const BOUNDING_BOX_PADDING = 10;
          const MIN_DISTANCE_TO_SEGMENT = 5;

          const clickX = clickState.canvasX;
          const clickY = clickState.canvasY;

          let key = null;
          for (key of Object.keys(this.clickDetectorCache)) {
              key = parseInt(key);
              if (key >= clickX) {
                  break
              }
          }


          if (key) {
              let closestDistanceSoFar = Number.MAX_VALUE;
              let closestResult = [];
              const segments = this.clickDetectorCache[key];
              for (let segment of segments) {
                  const x1 = segment[0];
                  const x2 = segment[2];
                  if (clickX < x1 || clickX > x2) return []

                  const y1 = segment[1];
                  const y2 = segment[3];

                  if ((clickY < Math.min(y1, y2) - BOUNDING_BOX_PADDING) || (clickY > Math.max(y1, y2) + BOUNDING_BOX_PADDING)) continue

                  const distance = distanceToLine(clickX, clickY, x1, y1, x2, y2);
                  if (distance < closestDistanceSoFar) {
                      closestResult = [{'name': segment[4], 'color': segment[5]}];
                      closestDistanceSoFar = distance;
                      //console.warn('closest:', 'name', segment[4], 'color', segment[5], distance);
                  }
              }

              if (closestDistanceSoFar < MIN_DISTANCE_TO_SEGMENT) {
                  // clickToHighlight set, add sample to dict of clicked lines
                  if (this.config.clickToHighlight) {
                      if (closestResult[0]['name'] in this.config.samplesClickedToHighlight) {
                          // clicked sample already highlighted => remove if clicked again
                          delete this.config.samplesClickedToHighlight[closestResult[0]['name']];
                      } else if (this.config.clickToHighlight === 'any') {
                          var colourList = [
                              'red', 'darkblue', 'green', 'teal', 'olivedrab',
                              'orange', 'maroon', 'purple', 'blue', 'gold',
                          ];
                          var colour = colourList[Math.floor(Math.random() * (colourList.length + 1))];
                          this.config.samplesClickedToHighlight[closestResult[0]['name']] = colour;
                      } else {
                          this.config.samplesClickedToHighlight[closestResult[0]['name']] = this.config.clickToHighlight;
                      }
                      this.trackView.repaintViews();  // prompt redraw to change colour of clicked sample
                  }
                  return closestResult
              }
          }

          return []
      }

      popupData(clickState, features) {

          if(features === undefined) features = this.clickedFeatures(clickState);

          const items = [];
          features.forEach(function (f) {
              for (let property of Object.keys(f)) {
                  if (isSimpleType(f[property])) {
                      items.push({name: property, value: f[property]});
                  }
              }
          });

          return items
      }

      get supportsWholeGenome() {
          return false
      }
  }


  function distanceToLine(x, y, ax, ay, bx, by) {
      /*
          Finds distance between point (x, y) and line defined by points (ax, ay) (bx, by)
          based on http://mathworld.wolfram.com/Point-LineDistance2-Dimensional.html
      */

      const bx_minus_ax = bx - ax;
      const by_minus_ay = by - ay;
      const v = Math.abs(bx_minus_ax * (ay - y) - (ax - x) * by_minus_ay);
      const r = Math.sqrt(bx_minus_ax * bx_minus_ax + by_minus_ay * by_minus_ay);

      const distance = r > 0 ? v / r : 0;
      //console.warn('Check if', x, y, 'is within', ax, ay, bx, by, '. Distance from line: ', distance);

      return distance
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class RnaStructTrack extends TrackBase {

      constructor(config, browser) {

          super(config, browser);

          // Set defaults
          if (!config.height) {
              this.height = 300;
          }

          this.arcOrientation = false;

          this.theta = Math.PI / 2;

          if ("bp" === config.format) {
              this.featureSource = new RNAFeatureSource(config, browser.genome);
          } else {
              this.featureSource = new TextFeatureSource(config, browser.genome);
          }
      }

      async getFeatures(chr, start, end) {
          const visibilityWindow = this.visibilityWindow;
          return this.featureSource.getFeatures({chr, start, end, visibilityWindow})
      }

      draw(options) {

          const ctx = options.context;

          const theta = Math.PI / 2;
          const pixelWidth = options.pixelWidth;
          const pixelHeight = options.pixelHeight;
          options.viewportWidth;
          const bpPerPixel = options.bpPerPixel;
          const bpStart = options.bpStart;
          const xScale = bpPerPixel;
          const orienation = this.arcOrientation;

          IGVGraphics.fillRect(ctx, 0, options.pixelTop, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});

          const featureList = options.features;

          if (featureList) {

              // Sort by score -- draw lowest scored features first
              sortByScore(featureList, 1);

              for (let feature of featureList) {

                  if (feature.startLeft) {

                      let sl = Math.round((feature.startLeft - bpStart) / xScale);
                      let sr = Math.round((feature.startRight - bpStart) / xScale);
                      let el = Math.round((feature.endLeft - bpStart) / xScale);
                      let er = Math.round((feature.endRight - bpStart) / xScale);

                      ctx.fillStyle = feature.color;
                      ctx.strokeStyle = feature.color;
                      ctx.beginPath();

                      // First arc
                      let x1 = (sl + er) / 2;
                      let r1 = (er - sl) / 2;
                      let y1 = this.height;
                      let sa = Math.PI + (Math.PI / 2 - theta);
                      let ea = 2 * Math.PI - (Math.PI / 2 - theta);

                      if (orienation) {
                          y1 = 0;
                          ctx.arc(x1, y1, r1, ea, sa);
                          ctx.lineTo(er, y1);
                      } else {
                          ctx.arc(x1, y1, r1, sa, ea);
                          ctx.lineTo(el, y1);
                      }

                      // Second arc
                      const x2 = (sr + el) / 2;
                      const r2 = (el - sr) / 2;
                      const y2 = y1;                        // Only for theta == pi/2

                      if (orienation) {
                          ctx.arc(x2, y2, r2, sa, ea, true);
                          ctx.lineTo(el, y2);
                      } else {
                          ctx.arc(x2, y2, r2, ea, sa, true);
                          ctx.lineTo(sl, y2);
                      }

                      ctx.stroke();
                      ctx.fill();

                      feature.drawState = {x1: x1, y1: y1, r1: r1, x2: x2, y2: y2, r2: r2, sa: sa, ea: ea};
                  } else {
                      let s = Math.round((feature.start - bpStart) / xScale);
                      let e = Math.round((feature.end - bpStart) / xScale);

                      ctx.strokeStyle = feature.color;

                      ctx.beginPath();

                      // First arc
                      let x = (s + e) / 2;
                      let r = (e - s) / 2;
                      let y = this.height;
                      let sa = Math.PI + (Math.PI / 2 - theta);
                      let ea = 2 * Math.PI - (Math.PI / 2 - theta);

                      if (orienation) {
                          y = 0;
                          ctx.arc(x, y, r, ea, sa);
                      } else {
                          ctx.arc(x, y, r, sa, ea);
                      }

                      ctx.stroke();

                      feature.drawState = {x1: x, y1: y, r1: r, sa: sa, ea: ea};

                  }

              }
          }
      }

      clickedFeatures(clickState) {

          const features = super.clickedFeatures(clickState);

          const clicked = [];

          // Sort by score in descending order   (opposite order than drawn)
          sortByScore(features, -1);

          for (let f of features) {
              const ds = f.drawState;

              // Distance from arc radius, or outer arc for type ".bp"
              const dx1 = (clickState.canvasX - ds.x1);
              const dy1 = (clickState.canvasY - ds.y1);
              const d1 = Math.sqrt(dx1 * dx1 + dy1 * dy1);
              const outerLim = ds.r1 + 3;


              let d2;
              let innerLim;
              if (ds.x2 === undefined) {
                  d2 = d1;
                  innerLim = ds.r1 - 3;

              } else {
                  const dx2 = (clickState.canvasX - ds.x2);
                  const dy2 = (clickState.canvasY - ds.y2);
                  d2 = Math.sqrt(dx2 * dx2 + dy2 * dy2);
                  innerLim = ds.r2 - 3;
              }


              // Between outer and inner arcs, with some tolerance
              if (d1 < outerLim && d2 > innerLim) {
                  clicked.push(f);
                  break
              }
          }
          return clicked
      }

      popupData(clickState, features) {

          if(features === undefined) features = this.clickedFeatures(clickState);

          if (features && features.length > 0) {

              return this.extractPopupData(features[0], this.getGenomeId())

          }
      }

      menuItemList() {

          var self = this;

          return [
              {
                  name: "Toggle arc direction",
                  click: function () {
                      self.arcOrientation = !self.arcOrientation;
                      self.trackView.repaintViews();
                  }
              }
          ]

      };


  }

  function sortByScore(featureList, direction) {

      featureList.sort(function (a, b) {
          const s1 = a.score === undefined ? -Number.MAX_VALUE : a.score;
          const s2 = b.score === undefined ? -Number.MAX_VALUE : b.score;
          const d = direction === undefined ? 1 : direction;

          return d * (s1 - s2)
      });
  }


  class RNAFeatureSource {

      constructor(config, genome) {
          this.config = config;
          this.genome = genome;
      }

      async getFeatures({chr, start, end, bpPerPixel, visibilityWindow}) {


          const genome = this.genome;

          if (!this.featureCache) {

              const options = buildOptions(this.config);

              const data = await igvxhr$1.loadString(this.config.url, options);

              this.featureCache = new FeatureCache$1(parseBP(data), genome);

              return this.featureCache.queryFeatures(chr, start, end)

          } else {
              return this.featureCache.queryFeatures(chr, start, end)
          }

          function parseBP(data) {

              if (!data) return null

              const dataWrapper = getDataWrapper$1(data);

              let header = true;
              let line;
              const colors = [];
              const descriptors = [];
              const features = [];

              while ((line = dataWrapper.nextLine()) !== undefined) {

                  const tokens = line.split('\t');

                  if (header && line.startsWith("color:")) {
                      const color = "rgb(" + tokens[1] + "," + tokens[2] + "," + tokens[3] + ")";
                      colors.push(color);
                      if (tokens.length > 4) {
                          descriptors.push(tokens[4]);
                      }
                      // TODO - use label
                  } else {
                      header = false;

                      const chr = tokens[0];
                      const startLeftNuc = Number.parseInt(tokens[1]) - 1;
                      const startRightNuc = Number.parseInt(tokens[2]) - 1;
                      const endLeftNuc = Number.parseInt(tokens[3]);
                      const endRightNuc = Number.parseInt(tokens[4]);
                      var colorIdx = Number.parseInt(tokens[5]);
                      const color = colors[colorIdx];


                      let feature;
                      if (startLeftNuc <= endRightNuc) {
                          feature = {
                              chr: chr,
                              startLeft: Math.min(startLeftNuc, startRightNuc),
                              startRight: Math.max(startLeftNuc, startRightNuc),
                              endLeft: Math.min(endLeftNuc, endRightNuc),
                              endRight: Math.max(endLeftNuc, endRightNuc),
                              color: color,
                              score: colorIdx
                          };
                      } else {
                          feature = {
                              chr: chr,
                              startLeft: Math.min(endLeftNuc, endRightNuc),
                              startRight: Math.max(endLeftNuc, endRightNuc),
                              endLeft: Math.min(startLeftNuc, startRightNuc),
                              endRight: Math.max(startLeftNuc, startRightNuc),
                              color: color,
                              score: colorIdx
                          };
                      }

                      feature.start = feature.startLeft;
                      feature.end = feature.endRight;

                      if (descriptors.length > colorIdx) {
                          feature.description = descriptors[colorIdx];
                      }

                      features.push(feature);
                  }
              }

              return features
          }
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /**
   * Class represents an ideogram of a chromsome cytobands.  It is used for the header of a track panel.
   *
   */
  class IdeogramTrack {
      constructor(browser) {
          this.browser = browser;
          this.type = 'ideogram';
          this.height = 16;
          this.order = Number.MIN_SAFE_INTEGER;
          this.disableButtons = true;
          this.ignoreTrackMenu = true;
      }

      async getFeatures(chr, start, end) {
          return []
      }

      computePixelHeight(ignore) {
          return this.height
      }

      draw({context, referenceFrame, pixelWidth, pixelHeight}) {

          const chr = referenceFrame.chr;
          const chromosome = referenceFrame.genome.getChromosome(chr);

          if (undefined === chromosome || pixelWidth <= 0 || pixelHeight <= 0 || 'all' === chr.toLowerCase()) {
              return
          }

          const stainColors = [];

          drawIdeogram({
              ctx: context,
              chr,
              referenceFrame,
              genome: referenceFrame.genome,
              width: pixelWidth,
              height: pixelHeight,
              stainColors
          });

          const widthBP = Math.round(referenceFrame.bpPerPixel * pixelWidth);
          const xBP = referenceFrame.start;

          // Total chromosome length can be > chromosome.bpLength for partial fastas.
          let chrLength = chromosome.bpLength;
          const cytobands = referenceFrame.genome.getCytobands(chr);
          if (cytobands && cytobands.length > 0 && cytobands[cytobands.length - 1].end) {
              chrLength = Math.max(chrLength, cytobands[cytobands.length - 1].end);
              chromosome.bpLength = chrLength;   // Correct bp length, bit of a hack
          }

          if (widthBP < chrLength) {

              const percentWidth = widthBP / chrLength;
              const percentX = xBP / chrLength;

              let x = Math.floor(percentX * pixelWidth);
              let ww = Math.floor(percentWidth * pixelWidth);

              x = Math.max(0, x);
              x = Math.min(pixelWidth - ww, x);

              // Push current context
              context.save();

              // Draw red box
              context.strokeStyle = "red";
              context.lineWidth = (ww < 2) ? 1 : 2;

              const xx = x + (context.lineWidth) / 2;
              ww = (ww < 2) ? 1 : ww - context.lineWidth;

              const yy = context.lineWidth / 2;
              const hh = pixelHeight - context.lineWidth;

              context.strokeRect(xx, yy, ww, hh);

              // Pop current context
              context.restore();
          }

      }

      dispose() {
          this.trackView = undefined;
      }
  }

  function drawIdeogram({ctx, chr, referenceFrame, genome, width, height, stainColors}) {

      const shim = 1;
      const shim2 = 0.5 * shim;
      const ideogramTop = 0;

      if (undefined === genome) {
          return
      }

      IGVGraphics.fillRect(ctx, 0, 0, width, height, {fillStyle: IGVColor.greyScale(255)});

      const cytobands = genome.getCytobands(chr);
      if (cytobands) {

          const center = (ideogramTop + height / 2);

          const xC = [];
          const yC = [];

          if (0 === cytobands.length) {
              return
          }

          // Get chrLength from the cytobands -- chromsome.bpLength might not work for igv-reports fasta files, which
          // contain only a portion of the chromosome sequence
          // *DOESNT WORK* const chrLength = referenceFrame.genome.getChromosome(chr).bpLength;

          const chrLength = cytobands[cytobands.length - 1].end;
          const scale = width / chrLength;

          // round rect clipping path
          ctx.beginPath();
          IGVGraphics.roundRect(ctx, shim2, shim2 + ideogramTop, width - 2 * shim2, height - 2 * shim2, (height - 2 * shim2) / 2, 0, 1);
          ctx.clip();

          for (let i = 0; i < cytobands.length; i++) {

              const cytoband = cytobands[i];
              const start = scale * cytoband.start;
              const end = scale * cytoband.end;

              if (cytoband.type === 'c') {

                  if (cytoband.name.charAt(0) === 'p') {
                      xC[0] = start;
                      yC[0] = height + ideogramTop;
                      xC[1] = start;
                      yC[1] = ideogramTop;
                      xC[2] = end;
                      yC[2] = center;
                  } else {
                      xC[0] = end;
                      yC[0] = height + ideogramTop;
                      xC[1] = end;
                      yC[1] = ideogramTop;
                      xC[2] = start;
                      yC[2] = center;
                  }

                  ctx.fillStyle = "rgb(150, 0, 0)";
                  ctx.strokeStyle = "rgb(150, 0, 0)";
                  IGVGraphics.polygon(ctx, xC, yC, 1, 0);
              } else {

                  ctx.fillStyle = getCytobandColor(stainColors, cytoband);
                  IGVGraphics.fillRect(ctx, start, shim + ideogramTop, (end - start), height - 2 * shim);
              }
          }
      }

      // round rect border
      ctx.strokeStyle = IGVColor.greyScale(41);
      IGVGraphics.roundRect(ctx, shim2, shim2 + ideogramTop, width - 2 * shim2, height - 2 * shim2, (height - 2 * shim2) / 2, 0, 1);
  }

  function getCytobandColor(colors, data) {

      if (data.type === 'c') { // centermere: "acen"
          return "rgb(150, 10, 10)"
      } else {
          var stain = data.stain; // + 4;

          var shade = 230;
          if (data.type === 'p') {
              shade = Math.floor(230 - stain / 100.0 * 230);
          }
          var c = colors[shade];
          if (!c) {
              c = "rgb(" + shade + "," + shade + "," + shade + ")";
              colors[shade] = c;
          }
          return c

      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  let JUNCTION_MOTIF_PALETTE = new PaletteColorTable("Dark2");

  // Lock in color-to-motif mapping so it's independent of data loading order. This list may not include all possible
  // motif values as this varies depending on the RNA-seq pipeline. The current list is based on STAR v2.4 docs.
  const someMotifValues = ['GT/AG', 'CT/AC', 'GC/AG', 'CT/GC', 'AT/AC', 'GT/AT', 'non-canonical'];
  someMotifValues.forEach(motif => {
      JUNCTION_MOTIF_PALETTE.getColor(motif);
  });

  // rendering context with values that only need to be computed once per render, rather than for each splice junction
  const junctionRenderingContext = {};

  class SpliceJunctionTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
      }


      init(config) {

          super.init(config);

          this.type = config.type || 'junctions';

          if (config._featureSource) {
              this.featureSource = config._featureSource;
              delete config._featureSource;
          } else {
              this.featureSource = config.featureSource ?
                  config.featureSource :
                  FeatureSource(config, this.browser.genome);
          }

          this.margin = config.margin === undefined ? 10 : config.margin;

          if (!this.height) {
              this.height = 100;
          }

          //set defaults
          if (config.colorByNumReadsThreshold === undefined) {
              config.colorByNumReadsThreshold = 5;
          }
      }

      async postInit() {

          if (typeof this.featureSource.getHeader === "function") {
              this.header = await this.featureSource.getHeader();
              if (this.disposed) return   // This track was removed during async load
          }

          // Set properties from track line
          if (this.header) {
              this.setTrackProperties(this.header);
          }

          if (this.visibilityWindow === undefined && typeof this.featureSource.defaultVisibilityWindow === 'function') {
              this.visibilityWindow = await this.featureSource.defaultVisibilityWindow();
          }

          return this

      }

      get supportsWholeGenome() {
          return false
      }

      async getFeatures(chr, start, end, bpPerPixel) {
          const visibilityWindow = this.visibilityWindow;
          return this.featureSource.getFeatures({chr, start, end, bpPerPixel, visibilityWindow})
      };


      /**
       * The required height in pixels required for the track content.   This is not the visible track height, which
       * can be smaller (with a scrollbar) or larger.
       *
       * @param features
       * @returns {*}
       */
      computePixelHeight(features) {
          return this.height
      };

      draw(options) {

          const featureList = options.features;
          const ctx = options.context;
          const bpPerPixel = options.bpPerPixel;
          const bpStart = options.bpStart;
          const pixelWidth = options.pixelWidth;
          const pixelHeight = options.pixelHeight;
          const bpEnd = bpStart + pixelWidth * bpPerPixel + 1;


          if (!this.config.isMergedTrack) {
              IGVGraphics.fillRect(ctx, 0, options.pixelTop, pixelWidth, pixelHeight, {'fillStyle': "rgb(255, 255, 255)"});
          }

          if (featureList) {


              junctionRenderingContext.referenceFrame = options.viewport.referenceFrame;
              junctionRenderingContext.referenceFrameStart = junctionRenderingContext.referenceFrame.start;
              junctionRenderingContext.referenceFrameEnd = junctionRenderingContext.referenceFrameStart +
                  junctionRenderingContext.referenceFrame.toBP(options.viewport.getWidth());

              // For a given viewport, records where features that are < 2px in width have been rendered already.
              // This prevents wasteful rendering of multiple such features onto the same pixels.
              junctionRenderingContext.featureZoomOutTracker = {};

              for (let feature of featureList) {
                  if (feature.end < bpStart) continue
                  if (feature.start > bpEnd) break
                  this.renderJunction(feature, bpStart, bpPerPixel, pixelHeight, ctx);
              }

          }

      };

      /**
       *
       * @param feature
       * @param bpStart  genomic location of the left edge of the current canvas
       * @param xScale  scale in base-pairs per pixel
       * @param pixelHeight  pixel height of the current canvas
       * @param ctx  the canvas 2d context
       */
      renderJunction(feature, bpStart, xScale, pixelHeight, ctx) {
          // cache whether this junction is rendered or filtered out. Use later to exclude non-rendered junctions from click detection.
          feature.isVisible = false;

          const junctionLeftPx = Math.round((feature.start - bpStart) / xScale);
          const junctionRightPx = Math.round((feature.end - bpStart) / xScale);
          const junctionMiddlePx = (junctionLeftPx + junctionRightPx) / 2;
          if (junctionRightPx - junctionLeftPx <= 3) {
              if (junctionMiddlePx in junctionRenderingContext.featureZoomOutTracker) {
                  return
              }
              junctionRenderingContext.featureZoomOutTracker[junctionMiddlePx] = true;
          }

          // TODO: cache filter and pixel calculations by doing them earlier when features are initially parsed?
          if (this.config.hideAnnotatedJunctions && feature.attributes.annotated_junction === "true") {
              return
          }
          if (this.config.hideUnannotatedJunctions && feature.attributes.annotated_junction === "false") {
              return
          }
          if (this.config.hideMotifs && this.config.hideMotifs.includes(feature.attributes.motif)) {
              return
          }
          if (this.config.hideStrand === feature.strand) {
              return
          }

          // check if splice junction is inside viewport
          if (this.config.minJunctionEndsVisible) {
              let numJunctionEndsVisible = 0;
              if (feature.start >= junctionRenderingContext.referenceFrameStart && feature.start <= junctionRenderingContext.referenceFrameEnd) {
                  numJunctionEndsVisible += 1;
              }
              if (feature.end >= junctionRenderingContext.referenceFrameStart && feature.end <= junctionRenderingContext.referenceFrameEnd) {
                  numJunctionEndsVisible += 1;
              }
              if (numJunctionEndsVisible < this.config.minJunctionEndsVisible) {
                  return
              }
          }

          let uniquelyMappedReadCount;
          let multiMappedReadCount;
          let totalReadCount;
          if (feature.attributes.uniquely_mapped) {
              uniquelyMappedReadCount = parseInt(feature.attributes.uniquely_mapped);
              if (uniquelyMappedReadCount < this.config.minUniquelyMappedReads) {
                  return
              }
              multiMappedReadCount = parseInt(feature.attributes.multi_mapped);
              totalReadCount = uniquelyMappedReadCount + multiMappedReadCount;
              if (totalReadCount < this.config.minTotalReads) {
                  return
              }
              if (totalReadCount > 0 && multiMappedReadCount / totalReadCount > this.config.maxFractionMultiMappedReads) {
                  return
              }
              if (feature.attributes.maximum_spliced_alignment_overhang && parseInt(feature.attributes.maximum_spliced_alignment_overhang) < this.config.minSplicedAlignmentOverhang) {
                  return
              }
          }

          let numSamplesWithThisJunction;
          if (feature.attributes.num_samples_with_this_junction) {
              numSamplesWithThisJunction = parseInt(feature.attributes.num_samples_with_this_junction);
              if (this.config.minSamplesWithThisJunction && numSamplesWithThisJunction < this.config.minSamplesWithThisJunction) {
                  return
              }
              if (this.config.maxSamplesWithThisJunction && numSamplesWithThisJunction > this.config.maxSamplesWithThisJunction) {
                  return
              }
              if (feature.attributes.num_samples_total) {
                  feature.attributes.percent_samples_with_this_junction = 100 * numSamplesWithThisJunction / Number(feature.attributes.num_samples_total);
                  if (this.config.minPercentSamplesWithThisJunction) {
                      if (feature.attributes.percent_samples_with_this_junction < this.config.minPercentSamplesWithThisJunction ||
                          feature.attributes.percent_samples_with_this_junction > this.config.maxPercentSamplesWithThisJunction) {
                          return
                      }
                  }
              }
          }

          const py = this.margin;
          const rowHeight = this.height;

          const cy = py + 0.5 * rowHeight;
          let topY = py;
          const bottomY = py + rowHeight;
          const bezierBottomY = bottomY - 10;

          // draw the junction arc
          const bezierControlLeftPx = (junctionLeftPx + junctionMiddlePx) / 2;
          const bezierControlRightPx = (junctionMiddlePx + junctionRightPx) / 2;

          let lineWidth = 1;
          if (feature.attributes.line_width) {
              lineWidth = Number(feature.attributes.line_width);
          } else {
              if (this.config.thicknessBasedOn === undefined || this.config.thicknessBasedOn === 'numUniqueReads') {
                  lineWidth = uniquelyMappedReadCount;
              } else if (this.config.thicknessBasedOn === 'numReads') {
                  lineWidth = totalReadCount;
              } else if (this.config.thicknessBasedOn === 'numSamplesWithThisJunction') {
                  if (numSamplesWithThisJunction !== undefined) {
                      lineWidth = numSamplesWithThisJunction;
                  }
              }
              lineWidth = 1 + Math.log(lineWidth + 1) / Math.log(12);
          }

          let bounceHeight;
          if (this.config.bounceHeightBasedOn === undefined || this.config.bounceHeightBasedOn === 'random') {
              // randomly but deterministically stagger topY coordinates to reduce overlap
              bounceHeight = (feature.start + feature.end) % 7;
          } else if (this.config.bounceHeightBasedOn === 'distance') {
              bounceHeight = 6 * (feature.end - feature.start) / (junctionRenderingContext.referenceFrameEnd - junctionRenderingContext.referenceFrameStart);
          } else if (this.config.bounceHeightBasedOn === 'thickness') {
              bounceHeight = 2 * lineWidth;
          }
          topY += rowHeight * Math.max(7 - bounceHeight, 0) / 10;

          let color;
          if (feature.attributes.color) {
              color = feature.attributes.color;  // Explicit setting
          } else if (this.config.colorBy === undefined || this.config.colorBy === 'numUniqueReads') {
              color = uniquelyMappedReadCount > this.config.colorByNumReadsThreshold ? 'blue' : '#AAAAAA';  // color gradient?
          } else if (this.config.colorBy === 'numReads') {
              color = totalReadCount > this.config.colorByNumReadsThreshold ? 'blue' : '#AAAAAA';
          } else if (this.config.colorBy === 'isAnnotatedJunction') {
              color = feature.attributes.annotated_junction === "true" ? '#b0b0ec' : 'orange';
          } else if (this.config.colorBy === 'strand') {
              color = feature.strand === "+" ? '#b0b0ec' : '#ecb0b0';
          } else if (this.config.colorBy === 'motif') {
              color = JUNCTION_MOTIF_PALETTE.getColor(feature.attributes.motif);
          } else {
              color = '#AAAAAA';
          }

          let label = "";
          if (feature.attributes.label) {
              label = feature.attributes.label.replace(/_/g, " ");
          } else if (this.config.labelWith === undefined || this.config.labelWith === 'uniqueReadCount') {
              //default label
              label = uniquelyMappedReadCount;
          } else if (this.config.labelWith === 'totalReadCount') {
              label = totalReadCount;
          } else if (this.config.labelWith === 'numSamplesWithThisJunction') {
              if (numSamplesWithThisJunction !== undefined) {
                  label = numSamplesWithThisJunction;
              }
          } else if (this.config.labelWith === 'percentSamplesWithThisJunction') {
              if (feature.attributes.percent_samples_with_this_junction !== undefined) {
                  label = feature.attributes.percent_samples_with_this_junction.toFixed(0) + '%';
              }
          } else if (this.config.labelWith === 'motif') {
              if (feature.attributes.motif !== undefined) {
                  label += feature.attributes.motif;
              }
          }

          if (this.config.labelWithInParen === 'uniqueReadCount') {
              label += ' (' + uniquelyMappedReadCount + ')';
          } else if (this.config.labelWithInParen === 'totalReadCount') {
              label += ' (' + totalReadCount + ')';
          } else if (this.config.labelWithInParen === 'multiMappedReadCount') {
              if (multiMappedReadCount > 0) {
                  label += ' (+' + multiMappedReadCount + ')';
              }
          } else if (this.config.labelWithInParen === 'numSamplesWithThisJunction') {
              if (numSamplesWithThisJunction !== undefined) {
                  label += ' (' + numSamplesWithThisJunction + ')';
              }
          } else if (this.config.labelWithInParen === 'percentSamplesWithThisJunction') {
              if (feature.attributes.percent_samples_with_this_junction !== undefined) {
                  label += ' (' + feature.attributes.percent_samples_with_this_junction.toFixed(0) + '%)';
              }
          } else if (this.config.labelWithInParen === 'motif') {
              if (feature.attributes.motif !== undefined) {
                  label += ` ${feature.attributes.motif}`;
              }
          }

          // data source: STAR splice junctions (eg. SJ.out.tab file converted to bed).
          // .bed "name" field used to store unique + multi-mapped read counts, so:
          // feature.score:  unique spanning read counts
          // feature.name:   unique + multi-mapped spanning read counts
          //example feature:  { chr: "chr17", start: 39662344, end: 39662803, name: "59", row: 0, score: 38, strand: "+"}
          feature.isVisible = true;
          ctx.beginPath();
          ctx.moveTo(junctionLeftPx, bezierBottomY);
          ctx.bezierCurveTo(bezierControlLeftPx, topY, bezierControlRightPx, topY, junctionRightPx, bezierBottomY);

          ctx.lineWidth = lineWidth;
          ctx.strokeStyle = color;
          ctx.stroke();

          const drawArrowhead = (ctx, x, y, size) => {
              //TODO draw better arrow heads: https://stackoverflow.com/questions/21052972/curved-thick-arrows-on-canvas
              ctx.beginPath();
              ctx.moveTo(x, y);
              ctx.lineTo(x - size / 2, y - size);
              ctx.lineTo(x + size / 2, y - size);
              ctx.lineTo(x, y);
              ctx.closePath();
              ctx.fill();
          };

          if (feature.attributes.left_shape || feature.attributes.right_shape) {
              ctx.fillStyle = color;
              const arrowSize = ctx.lineWidth > 2 ? 10 : 7;
              if (feature.attributes.left_shape) {
                  drawArrowhead(ctx, junctionLeftPx, bezierBottomY, arrowSize);
              }
              if (feature.attributes.right_shape) {
                  drawArrowhead(ctx, junctionRightPx, bezierBottomY, arrowSize);
              }
          }

          ctx.fillText(label, junctionMiddlePx - ctx.measureText(label).width / 2, (7 * topY + cy) / 8);
      }

      clickedFeatures(clickState) {

          const allFeatures = super.clickedFeatures(clickState);

          return allFeatures.filter(function (feature) {
              return (feature.isVisible && feature.attributes)
          })
      }

      /**
       * Return "popup data" for feature @ genomic location.  Data is an array of key-value pairs
       */
      popupData(clickState, features) {

          if (features === undefined) features = this.clickedFeatures(clickState);
          const genomicLocation = clickState.genomicLocation;

          const data = [];
          for (let feature of features) {

              const featureData = (typeof feature.popupData === "function") ?
                  feature.popupData(genomicLocation) :
                  this.extractPopupData(feature._f || feature, this.getGenomeId());

              if (featureData) {
                  if (data.length > 0) {
                      data.push("<hr/><hr/>");
                  }

                  Array.prototype.push.apply(data, featureData);
              }
          }

          return data
      }

      /**
       * Called when the track is removed.  Do any needed cleanup here
       */
      dispose() {
          this.trackView = undefined;
      }
  }

  class RemoteFile {

      constructor(args) {
          this.config = args;
          this.url = mapUrl$2(args.path || args.url);
      }


      async read(position, length) {

          //console.log(`${position} - ${position + length} (${length})`)

          const headers = this.config.headers || {};

          if (position !== undefined && length) {
              const rangeString = "bytes=" + position + "-" + (position + length - 1);
              headers['Range'] = rangeString;
          }

          let url = this.url.slice();    // slice => copy
          if (this.config.oauthToken) {
              const token = resolveToken(this.config.oauthToken);
              headers['Authorization'] = `Bearer ${token}`;
          }

          if (this.config.apiKey) {
              url = addParameter(url, "key", this.config.apiKey);
          }

          const response = await fetch(url, {
              method: 'GET',
              headers: headers,
              redirect: 'follow',
              mode: 'cors',
          });

          const status = response.status;

          if (status >= 400) {
              const err = Error(response.statusText);
              err.code = status;
              throw err
          } else {
              return response.arrayBuffer()
          }

          /**
           * token can be a string, a function that returns a string, or a function that returns a Promise for a string
           * @param token
           * @returns {Promise<*>}
           */
          async function resolveToken(token) {
              if (typeof token === 'function') {
                  return await Promise.resolve(token())    // Normalize the result to a promise, since we don't know what the function returns
              } else {
                  return token
              }
          }

      }
  }


  function mapUrl$2(url) {

      if (url.includes("//www.dropbox.com")) {
          return url.replace("//www.dropbox.com", "//dl.dropboxusercontent.com")
      } else if (url.startsWith("ftp://ftp.ncbi.nlm.nih.gov")) {
          return url.replace("ftp://", "https://")
      } else {
          return url
      }
  }


  function addParameter(url, name, value) {
      const paramSeparator = url.includes("?") ? "&" : "?";
      return url + paramSeparator + name + "=" + value
  }

  class BufferedFile {

      constructor(args) {
          this.file = args.file;
          this.fetchSize = args.fetchSize || 16000;
          this.maxSize = args.maxSize || 1000000;
          this.buffers = [];
      }

      async read(position, length) {


          let overlappingBuffers = this.buffers.filter( b => b.overlaps(position, position + length));

          // See if any buffers completely contain request, if so we're done
          for(let buffer of overlappingBuffers) {
              if(buffer.contains(position, position + length)) {
                return buffer.slice(position, position + length)
              }
          }


          if(overlappingBuffers.length === 0) {

              // No overlap with any existing buffer
              let size = Math.max(length, this.fetchSize);

              // Find index of first buffer to the right, if any, to potentially limit size
              this.buffers.sort((a, b) => a.start - b.start);
              const idx = binarySearch(this.buffers, (b) => b.start > position, 0);
              if(idx < this.buffers.length) {
                  size = Math.min(size, this.buffers[idx].start - position);
              }

              const bufferStart = position;
              const bufferData = await this.file.read(bufferStart, size);
              const buffer = new Buffer$1(bufferStart, bufferData);
              this.addBuffer(buffer);

              return buffer.slice(position, position + length)
          } else {

              // console.log("Cache hit")
              // Some overlap.   Fill gaps
              overlappingBuffers.sort((a, b) => a.start - b.start);
              const allBuffers = [];
              let currentEnd = position;
              for (let ob of overlappingBuffers) {
                  if (currentEnd < ob.start) {
                      const bufferStart = currentEnd;
                      const bufferSize = ob.start - currentEnd;
                      const bufferData = await this.file.read(bufferStart, bufferSize);
                      const buffer = new Buffer$1(bufferStart, bufferData);
                      allBuffers.push(buffer);
                  }
                  allBuffers.push(ob);
                  currentEnd = ob.end;
              }

              // Check end
              const requestedEnd = position + length;
              if (requestedEnd > currentEnd) {
                  const bufferStart = currentEnd;
                  const bufferSize = requestedEnd - bufferStart;
                  const bufferData = await this.file.read(bufferStart, bufferSize);
                  const buffer = new Buffer$1(bufferStart, bufferData);
                  allBuffers.push(buffer);
              }

              const newStart = allBuffers[0].start;
              const newArrayBuffer = concatArrayBuffers(allBuffers.map(b => b.buffer));
              const newBuffer = new Buffer$1(newStart, newArrayBuffer);

              // Replace the overlapping buffers with the new composite one
              const tmp = new Set(overlappingBuffers);
              this.buffers = this.buffers.filter(b => !tmp.has(b));
              this.addBuffer(newBuffer);

              return newBuffer.slice(position, position + length)
          }

      }

      addBuffer(buffer) {

          const size = this.buffers.reduce((a,b) => a + b.size, 0) + buffer.size;
          if(size > this.maxSize) {
              // console.log(`max buffer size exceeded`)
              const overage = size - this.maxSize;
              this.buffers.sort((a,b) => a.creationTime - b.creationTime);
              let sum = 0;
              let i;
              for(i=0; i<this.buffers.length; i++) {
                  sum += this.buffers[i].size;
                  if(sum > overage) {
                      break
                  }
              }
              // console.log('removing buffers')
              // for(let j=0; j<i; j++) console.log(`  ${this.buffers[j].toString()}`)
              this.buffers = (i < this.buffers.length - 1)  ? this.buffers.slice(i)  : [];
          }

          if(buffer.size <= this.maxSize) {
              this.buffers.push(buffer);
          }
      }



  }

  class Buffer$1 {

      constructor(bufferStart, buffer) {
          this.creationTime = Date.now();
          this.start = bufferStart;
          this.buffer = buffer;
      }

      slice(start, end) {
          if(start < this.start || end - start > this.buffer.byteLength) {
              throw Error("buffer bounds error")
          }
          return this.buffer.slice(start - this.start, end - this.start)
      }

      get end() {
          return this.start + this.buffer.byteLength
      }

      get size() {
          return this.buffer.byteLength
      }

      contains(start, end) {
          return start >= this.start && end <= this.end
      }

      overlaps(start, end) {
          return (start > this.start && start < this.end) || (end > this.start && end < this.end)
      }

      toString() {
          return `Buffer ${this.creationTime}   ${this.start} - ${this.end}`
      }

  }

  /**
   * concatenates 2 array buffers.
   * Credit: https://gist.github.com/72lions/4528834
   *
   * @private
   * @param {ArrayBuffers} buffer1 The first buffer.
   * @param {ArrayBuffers} buffer2 The second buffer.
   * @return {ArrayBuffers} The new ArrayBuffer created out of the two.
   */
  function concatArrayBuffers(buffers) {
      const size = buffers.reduce((a,b) => a + b.byteLength, 0);
      const tmp = new Uint8Array(size);
      let offset = 0;
      for(let b of buffers) {
          tmp.set(new Uint8Array(b), offset);
          offset += b.byteLength;
      }
      return tmp.buffer
  }

  /**
   * Return 0 <= i <= array.length such that !pred(array[i - 1]) && pred(array[i]).
   *
   * returns an index 0 ≤ i ≤ array.length such that the given predicate is false for array[i - 1] and true for array[i]* *
   */
  function binarySearch(array, pred, min) {
      let lo = min - 1, hi = array.length;
      while (1 + lo < hi) {
          const mi = lo + ((hi - lo) >> 1);
          if (pred(array[mi])) {
              hi = mi;
          } else {
              lo = mi;
          }
      }
      return hi
  }

  class BlobFile {

      constructor(blob) {
          this.file = blob;
      }

      async read(position, length) {

          if(length === 0) {
              return new ArrayBuffer()
          }

          const blob = (position != undefined && length) ?
              this.file.slice(position, position + length) :
              this.file;

          return blob.arrayBuffer()
      }
  }

  // esm/core.js
  async function _unpack_struct_from_async(structure, async_buf, offset = 0) {
    var output = /* @__PURE__ */ new Map();
    for (let [key, fmt] of structure.entries()) {
      let value = await struct.unpack_from_async("<" + fmt, async_buf, offset);
      offset += struct.calcsize(fmt);
      if (value.length == 1) {
        value = value[0];
      }
      output.set(key, value);
    }
    return output;
  }
  function _unpack_struct_from(structure, buf, offset = 0) {
    var output = /* @__PURE__ */ new Map();
    for (let [key, fmt] of structure.entries()) {
      let value = struct.unpack_from("<" + fmt, buf, offset);
      offset += struct.calcsize(fmt);
      if (value.length == 1) {
        value = value[0];
      }
      output.set(key, value);
    }
    return output;
  }
  function assert(thing) {
    if (!thing) {
      thing();
    }
  }
  function _structure_size(structure) {
    var fmt = "<" + Array.from(structure.values()).join("");
    return struct.calcsize(fmt);
  }
  function _padded_size(size, padding_multiple = 8) {
    return Math.ceil(size / padding_multiple) * padding_multiple;
  }
  var dtype_to_format = {
    "u": "Uint",
    "i": "Int",
    "f": "Float"
  };
  function dtype_getter(dtype_str) {
    var big_endian = struct._is_big_endian(dtype_str);
    var getter, nbytes;
    if (/S/.test(dtype_str)) {
      getter = "getString";
      nbytes = ((dtype_str.match(/S(\d*)/) || [])[1] || 1) | 0;
    } else {
      let [_, fstr, bytestr] = dtype_str.match(/[<>=!@]?(i|u|f)(\d*)/);
      nbytes = parseInt(bytestr || 4, 10);
      let nbits = nbytes * 8;
      getter = "get" + dtype_to_format[fstr] + nbits.toFixed();
    }
    return [getter, big_endian, nbytes];
  }
  var Struct = class {
    constructor() {
      this.big_endian = isBigEndian();
      this.getters = {
        "s": "getUint8",
        "b": "getInt8",
        "B": "getUint8",
        "h": "getInt16",
        "H": "getUint16",
        "i": "getInt32",
        "I": "getUint32",
        "l": "getInt32",
        "L": "getUint32",
        "q": "getInt64",
        "Q": "getUint64",
        "f": "getFloat32",
        "d": "getFloat64"
      };
      this.byte_lengths = {
        "s": 1,
        "b": 1,
        "B": 1,
        "h": 2,
        "H": 2,
        "i": 4,
        "I": 4,
        "l": 4,
        "L": 4,
        "q": 8,
        "Q": 8,
        "f": 4,
        "d": 8
      };
      let all_formats = Object.keys(this.byte_lengths).join("");
      this.fmt_size_regex = "(\\d*)([" + all_formats + "])";
    }
    calcsize(fmt) {
      var size = 0;
      var match;
      var regex = new RegExp(this.fmt_size_regex, "g");
      while ((match = regex.exec(fmt)) !== null) {
        let n = parseInt(match[1] || 1, 10);
        let f = match[2];
        let subsize = this.byte_lengths[f];
        size += n * subsize;
      }
      return size;
    }
    _is_big_endian(fmt) {
      var big_endian;
      if (/^</.test(fmt)) {
        big_endian = false;
      } else if (/^(!|>)/.test(fmt)) {
        big_endian = true;
      } else {
        big_endian = this.big_endian;
      }
      return big_endian;
    }
    async unpack_from_async(fmt, async_buf, offset) {
      var offset = Number(offset || 0);
      const total_size = this.calcsize(fmt);
      const local_buffer = await async_buf.slice(offset, offset + total_size);
      let local_offset = 0;
      var view = new DataView64(local_buffer);
      var output = [];
      var big_endian = this._is_big_endian(fmt);
      var match;
      var regex = new RegExp(this.fmt_size_regex, "g");
      while ((match = regex.exec(fmt)) !== null) {
        let n = parseInt(match[1] || 1, 10);
        let f = match[2];
        let getter = this.getters[f];
        let size = this.byte_lengths[f];
        if (f == "s") {
          output.push(new TextDecoder().decode(local_buffer.slice(local_offset, local_offset + n)));
          local_offset += n;
        } else {
          for (var i = 0; i < n; i++) {
            output.push(view[getter](local_offset, !big_endian));
            local_offset += size;
          }
        }
      }
      return output;
    }
    unpack_from(fmt, buffer, offset) {
      var offset = Number(offset || 0);
      const total_size = this.calcsize(fmt);
      const local_buffer = buffer.slice(offset, offset + total_size);
      let local_offset = 0;
      var view = new DataView64(local_buffer);
      var output = [];
      var big_endian = this._is_big_endian(fmt);
      var match;
      var regex = new RegExp(this.fmt_size_regex, "g");
      while ((match = regex.exec(fmt)) !== null) {
        let n = parseInt(match[1] || 1, 10);
        let f = match[2];
        let getter = this.getters[f];
        let size = this.byte_lengths[f];
        if (f == "s") {
          output.push(new TextDecoder().decode(local_buffer.slice(local_offset, local_offset + n)));
          local_offset += n;
        } else {
          for (var i = 0; i < n; i++) {
            output.push(view[getter](local_offset, !big_endian));
            local_offset += size;
          }
        }
      }
      return output;
    }
  };
  var struct = new Struct();
  function isBigEndian() {
    const array = new Uint8Array(4);
    const view = new Uint32Array(array.buffer);
    return !((view[0] = 1) & array[0]);
  }
  var DataView64 = class extends DataView {
    getUint64(byteOffset, littleEndian) {
      const left = BigInt(this.getUint32(byteOffset, littleEndian));
      const right = BigInt(this.getUint32(byteOffset + 4, littleEndian));
      let combined = littleEndian ? left + (right << 32n) : (left << 32n) + right;
      return Number(combined);
    }
    getInt64(byteOffset, littleEndian) {
      var low, high;
      if (littleEndian) {
        low = this.getUint32(byteOffset, true);
        high = this.getInt32(byteOffset + 4, true);
      } else {
        high = this.getInt32(byteOffset, false);
        low = this.getUint32(byteOffset + 4, false);
      }
      let combined = BigInt(low) + (BigInt(high) << 32n);
      return Number(combined);
    }
    getString(byteOffset, littleEndian, length) {
      const str_buffer = this.buffer.slice(byteOffset, byteOffset + length);
      const decoder = new TextDecoder();
      return decoder.decode(str_buffer);
    }
    getVLENStruct(byteOffset, littleEndian, length) {
      let item_size = this.getUint32(byteOffset, littleEndian);
      let collection_address = this.getUint64(byteOffset + 4, littleEndian);
      let object_index = this.getUint32(byteOffset + 12, littleEndian);
      return [item_size, collection_address, object_index];
    }
  };
  function bitSize(integer) {
    return integer.toString(2).length;
  }
  function _unpack_integer(nbytes, buf, offset = 0, littleEndian = true) {
    const local_buffer = buf.slice(offset, offset + nbytes);
    let bytes = new Uint8Array(local_buffer);
    if (!littleEndian) {
      bytes.reverse();
    }
    let integer = bytes.reduce((accumulator, currentValue, index) => accumulator + (currentValue << index * 8), 0);
    return integer;
  }

  // esm/datatype-msg.js
  var DatatypeMessage = class {
    constructor(buf, offset) {
      this.buf = buf;
      this.offset = offset;
      this.dtype = this.determine_dtype();
    }
    async determine_dtype() {
      let datatype_msg = await _unpack_struct_from_async(DATATYPE_MSG, this.buf, this.offset);
      this.offset += DATATYPE_MSG_SIZE;
      let datatype_class = datatype_msg.get("class_and_version") & 15;
      if (datatype_class == DATATYPE_FIXED_POINT) {
        return this._determine_dtype_fixed_point(datatype_msg);
      } else if (datatype_class == DATATYPE_FLOATING_POINT) {
        return this._determine_dtype_floating_point(datatype_msg);
      } else if (datatype_class == DATATYPE_TIME) {
        throw "Time datatype class not supported.";
      } else if (datatype_class == DATATYPE_STRING) {
        return this._determine_dtype_string(datatype_msg);
      } else if (datatype_class == DATATYPE_BITFIELD) {
        throw "Bitfield datatype class not supported.";
      } else if (datatype_class == DATATYPE_OPAQUE) {
        return {
          datatype_class: DATATYPE_OPAQUE,
          size: datatype_msg.get("size")
        };
      } else if (datatype_class == DATATYPE_COMPOUND) {
        return this._determine_dtype_compound(datatype_msg);
      } else if (datatype_class == DATATYPE_REFERENCE) {
        return ["REFERENCE", datatype_msg.get("size")];
      } else if (datatype_class == DATATYPE_ENUMERATED) {
        return this.determine_dtype();
      } else if (datatype_class == DATATYPE_ARRAY) {
        throw "Array datatype class not supported.";
      } else if (datatype_class == DATATYPE_VARIABLE_LENGTH) {
        let vlen_type = this._determine_dtype_vlen(datatype_msg);
        if (vlen_type[0] == "VLEN_SEQUENCE") {
          let base_type = this.determine_dtype();
          vlen_type = ["VLEN_SEQUENCE", base_type];
        }
        return vlen_type;
      } else {
        throw "Invalid datatype class " + datatype_class;
      }
    }
    _determine_dtype_fixed_point(datatype_msg) {
      let length_in_bytes = datatype_msg.get("size");
      if (![1, 2, 4, 8].includes(length_in_bytes)) {
        throw "Unsupported datatype size";
      }
      let signed = datatype_msg.get("class_bit_field_0") & 8;
      var dtype_char;
      if (signed > 0) {
        dtype_char = "i";
      } else {
        dtype_char = "u";
      }
      let byte_order = datatype_msg.get("class_bit_field_0") & 1;
      var byte_order_char;
      if (byte_order == 0) {
        byte_order_char = "<";
      } else {
        byte_order_char = ">";
      }
      this.offset += 4;
      return byte_order_char + dtype_char + length_in_bytes.toFixed();
    }
    _determine_dtype_floating_point(datatype_msg) {
      let length_in_bytes = datatype_msg.get("size");
      if (![1, 2, 4, 8].includes(length_in_bytes)) {
        throw "Unsupported datatype size";
      }
      let dtype_char = "f";
      let byte_order = datatype_msg.get("class_bit_field_0") & 1;
      var byte_order_char;
      if (byte_order == 0) {
        byte_order_char = "<";
      } else {
        byte_order_char = ">";
      }
      this.offset += 12;
      return byte_order_char + dtype_char + length_in_bytes.toFixed();
    }
    _determine_dtype_string(datatype_msg) {
      return "S" + datatype_msg.get("size").toFixed();
    }
    _determine_dtype_vlen(datatype_msg) {
      let vlen_type = datatype_msg.get("class_bit_field_0") & 1;
      if (vlen_type != 1) {
        return ["VLEN_SEQUENCE", 0, 0];
      }
      let padding_type = datatype_msg.get("class_bit_field_0") >> 4;
      let character_set = datatype_msg.get("class_bit_field_1") & 1;
      return ["VLEN_STRING", padding_type, character_set];
    }
    _determine_dtype_compound(datatype_msg) {
      throw "Compound type not yet implemented!";
    }
  };
  var DATATYPE_MSG = /* @__PURE__ */ new Map([
    ["class_and_version", "B"],
    ["class_bit_field_0", "B"],
    ["class_bit_field_1", "B"],
    ["class_bit_field_2", "B"],
    ["size", "I"]
  ]);
  var DATATYPE_MSG_SIZE = _structure_size(DATATYPE_MSG);
  var COMPOUND_PROP_DESC_V1 = /* @__PURE__ */ new Map([
    ["offset", "I"],
    ["dimensionality", "B"],
    ["reserved_0", "B"],
    ["reserved_1", "B"],
    ["reserved_2", "B"],
    ["permutation", "I"],
    ["reserved_3", "I"],
    ["dim_size_1", "I"],
    ["dim_size_2", "I"],
    ["dim_size_3", "I"],
    ["dim_size_4", "I"]
  ]);
  _structure_size(COMPOUND_PROP_DESC_V1);
  var DATATYPE_FIXED_POINT = 0;
  var DATATYPE_FLOATING_POINT = 1;
  var DATATYPE_TIME = 2;
  var DATATYPE_STRING = 3;
  var DATATYPE_BITFIELD = 4;
  var DATATYPE_OPAQUE = 5;
  var DATATYPE_COMPOUND = 6;
  var DATATYPE_REFERENCE = 7;
  var DATATYPE_ENUMERATED = 8;
  var DATATYPE_VARIABLE_LENGTH = 9;
  var DATATYPE_ARRAY = 10;
  function zero$1$2(buf) {
    let len = buf.length;
    while (--len >= 0) {
      buf[len] = 0;
    }
  }
  var MIN_MATCH$1$2 = 3;
  var MAX_MATCH$1$2 = 258;
  var LENGTH_CODES$1$2 = 29;
  var LITERALS$1$2 = 256;
  var L_CODES$1$2 = LITERALS$1$2 + 1 + LENGTH_CODES$1$2;
  var D_CODES$1$2 = 30;
  var DIST_CODE_LEN$2 = 512;
  var static_ltree$2 = new Array((L_CODES$1$2 + 2) * 2);
  zero$1$2(static_ltree$2);
  var static_dtree$2 = new Array(D_CODES$1$2 * 2);
  zero$1$2(static_dtree$2);
  var _dist_code$2 = new Array(DIST_CODE_LEN$2);
  zero$1$2(_dist_code$2);
  var _length_code$2 = new Array(MAX_MATCH$1$2 - MIN_MATCH$1$2 + 1);
  zero$1$2(_length_code$2);
  var base_length$2 = new Array(LENGTH_CODES$1$2);
  zero$1$2(base_length$2);
  var base_dist$2 = new Array(D_CODES$1$2);
  zero$1$2(base_dist$2);
  var adler32$2 = (adler, buf, len, pos) => {
    let s1 = adler & 65535 | 0, s2 = adler >>> 16 & 65535 | 0, n = 0;
    while (len !== 0) {
      n = len > 2e3 ? 2e3 : len;
      len -= n;
      do {
        s1 = s1 + buf[pos++] | 0;
        s2 = s2 + s1 | 0;
      } while (--n);
      s1 %= 65521;
      s2 %= 65521;
    }
    return s1 | s2 << 16 | 0;
  };
  var adler32_1$2 = adler32$2;
  var makeTable$2 = () => {
    let c, table = [];
    for (var n = 0; n < 256; n++) {
      c = n;
      for (var k = 0; k < 8; k++) {
        c = c & 1 ? 3988292384 ^ c >>> 1 : c >>> 1;
      }
      table[n] = c;
    }
    return table;
  };
  var crcTable$2 = new Uint32Array(makeTable$2());
  var crc32$2 = (crc, buf, len, pos) => {
    const t = crcTable$2;
    const end = pos + len;
    crc ^= -1;
    for (let i = pos; i < end; i++) {
      crc = crc >>> 8 ^ t[(crc ^ buf[i]) & 255];
    }
    return crc ^ -1;
  };
  var crc32_1$2 = crc32$2;
  var messages$2 = {
    2: "need dictionary",
    1: "stream end",
    0: "",
    "-1": "file error",
    "-2": "stream error",
    "-3": "data error",
    "-4": "insufficient memory",
    "-5": "buffer error",
    "-6": "incompatible version"
  };
  var constants$2$2 = {
    Z_NO_FLUSH: 0,
    Z_PARTIAL_FLUSH: 1,
    Z_SYNC_FLUSH: 2,
    Z_FULL_FLUSH: 3,
    Z_FINISH: 4,
    Z_BLOCK: 5,
    Z_TREES: 6,
    Z_OK: 0,
    Z_STREAM_END: 1,
    Z_NEED_DICT: 2,
    Z_ERRNO: -1,
    Z_STREAM_ERROR: -2,
    Z_DATA_ERROR: -3,
    Z_MEM_ERROR: -4,
    Z_BUF_ERROR: -5,
    Z_NO_COMPRESSION: 0,
    Z_BEST_SPEED: 1,
    Z_BEST_COMPRESSION: 9,
    Z_DEFAULT_COMPRESSION: -1,
    Z_FILTERED: 1,
    Z_HUFFMAN_ONLY: 2,
    Z_RLE: 3,
    Z_FIXED: 4,
    Z_DEFAULT_STRATEGY: 0,
    Z_BINARY: 0,
    Z_TEXT: 1,
    Z_UNKNOWN: 2,
    Z_DEFLATED: 8
  };
  var _has$2 = (obj, key) => {
    return Object.prototype.hasOwnProperty.call(obj, key);
  };
  var assign$2 = function(obj) {
    const sources = Array.prototype.slice.call(arguments, 1);
    while (sources.length) {
      const source = sources.shift();
      if (!source) {
        continue;
      }
      if (typeof source !== "object") {
        throw new TypeError(source + "must be non-object");
      }
      for (const p in source) {
        if (_has$2(source, p)) {
          obj[p] = source[p];
        }
      }
    }
    return obj;
  };
  var flattenChunks$2 = (chunks) => {
    let len = 0;
    for (let i = 0, l = chunks.length; i < l; i++) {
      len += chunks[i].length;
    }
    const result = new Uint8Array(len);
    for (let i = 0, pos = 0, l = chunks.length; i < l; i++) {
      let chunk = chunks[i];
      result.set(chunk, pos);
      pos += chunk.length;
    }
    return result;
  };
  var common$2 = {
    assign: assign$2,
    flattenChunks: flattenChunks$2
  };
  var STR_APPLY_UIA_OK$2 = true;
  try {
    String.fromCharCode.apply(null, new Uint8Array(1));
  } catch (__) {
    STR_APPLY_UIA_OK$2 = false;
  }
  var _utf8len$2 = new Uint8Array(256);
  for (let q = 0; q < 256; q++) {
    _utf8len$2[q] = q >= 252 ? 6 : q >= 248 ? 5 : q >= 240 ? 4 : q >= 224 ? 3 : q >= 192 ? 2 : 1;
  }
  _utf8len$2[254] = _utf8len$2[254] = 1;
  var string2buf$2 = (str) => {
    if (typeof TextEncoder === "function" && TextEncoder.prototype.encode) {
      return new TextEncoder().encode(str);
    }
    let buf, c, c2, m_pos, i, str_len = str.length, buf_len = 0;
    for (m_pos = 0; m_pos < str_len; m_pos++) {
      c = str.charCodeAt(m_pos);
      if ((c & 64512) === 55296 && m_pos + 1 < str_len) {
        c2 = str.charCodeAt(m_pos + 1);
        if ((c2 & 64512) === 56320) {
          c = 65536 + (c - 55296 << 10) + (c2 - 56320);
          m_pos++;
        }
      }
      buf_len += c < 128 ? 1 : c < 2048 ? 2 : c < 65536 ? 3 : 4;
    }
    buf = new Uint8Array(buf_len);
    for (i = 0, m_pos = 0; i < buf_len; m_pos++) {
      c = str.charCodeAt(m_pos);
      if ((c & 64512) === 55296 && m_pos + 1 < str_len) {
        c2 = str.charCodeAt(m_pos + 1);
        if ((c2 & 64512) === 56320) {
          c = 65536 + (c - 55296 << 10) + (c2 - 56320);
          m_pos++;
        }
      }
      if (c < 128) {
        buf[i++] = c;
      } else if (c < 2048) {
        buf[i++] = 192 | c >>> 6;
        buf[i++] = 128 | c & 63;
      } else if (c < 65536) {
        buf[i++] = 224 | c >>> 12;
        buf[i++] = 128 | c >>> 6 & 63;
        buf[i++] = 128 | c & 63;
      } else {
        buf[i++] = 240 | c >>> 18;
        buf[i++] = 128 | c >>> 12 & 63;
        buf[i++] = 128 | c >>> 6 & 63;
        buf[i++] = 128 | c & 63;
      }
    }
    return buf;
  };
  var buf2binstring$2 = (buf, len) => {
    if (len < 65534) {
      if (buf.subarray && STR_APPLY_UIA_OK$2) {
        return String.fromCharCode.apply(null, buf.length === len ? buf : buf.subarray(0, len));
      }
    }
    let result = "";
    for (let i = 0; i < len; i++) {
      result += String.fromCharCode(buf[i]);
    }
    return result;
  };
  var buf2string$2 = (buf, max) => {
    const len = max || buf.length;
    if (typeof TextDecoder === "function" && TextDecoder.prototype.decode) {
      return new TextDecoder().decode(buf.subarray(0, max));
    }
    let i, out;
    const utf16buf = new Array(len * 2);
    for (out = 0, i = 0; i < len; ) {
      let c = buf[i++];
      if (c < 128) {
        utf16buf[out++] = c;
        continue;
      }
      let c_len = _utf8len$2[c];
      if (c_len > 4) {
        utf16buf[out++] = 65533;
        i += c_len - 1;
        continue;
      }
      c &= c_len === 2 ? 31 : c_len === 3 ? 15 : 7;
      while (c_len > 1 && i < len) {
        c = c << 6 | buf[i++] & 63;
        c_len--;
      }
      if (c_len > 1) {
        utf16buf[out++] = 65533;
        continue;
      }
      if (c < 65536) {
        utf16buf[out++] = c;
      } else {
        c -= 65536;
        utf16buf[out++] = 55296 | c >> 10 & 1023;
        utf16buf[out++] = 56320 | c & 1023;
      }
    }
    return buf2binstring$2(utf16buf, out);
  };
  var utf8border$2 = (buf, max) => {
    max = max || buf.length;
    if (max > buf.length) {
      max = buf.length;
    }
    let pos = max - 1;
    while (pos >= 0 && (buf[pos] & 192) === 128) {
      pos--;
    }
    if (pos < 0) {
      return max;
    }
    if (pos === 0) {
      return max;
    }
    return pos + _utf8len$2[buf[pos]] > max ? pos : max;
  };
  var strings$2 = {
    string2buf: string2buf$2,
    buf2string: buf2string$2,
    utf8border: utf8border$2
  };
  function ZStream$2() {
    this.input = null;
    this.next_in = 0;
    this.avail_in = 0;
    this.total_in = 0;
    this.output = null;
    this.next_out = 0;
    this.avail_out = 0;
    this.total_out = 0;
    this.msg = "";
    this.state = null;
    this.data_type = 2;
    this.adler = 0;
  }
  var zstream$2 = ZStream$2;
  var BAD$1$2 = 30;
  var TYPE$1$2 = 12;
  var inffast$2 = function inflate_fast(strm, start) {
    let _in;
    let last;
    let _out;
    let beg;
    let end;
    let dmax;
    let wsize;
    let whave;
    let wnext;
    let s_window;
    let hold;
    let bits;
    let lcode;
    let dcode;
    let lmask;
    let dmask;
    let here;
    let op;
    let len;
    let dist;
    let from;
    let from_source;
    let input, output;
    const state = strm.state;
    _in = strm.next_in;
    input = strm.input;
    last = _in + (strm.avail_in - 5);
    _out = strm.next_out;
    output = strm.output;
    beg = _out - (start - strm.avail_out);
    end = _out + (strm.avail_out - 257);
    dmax = state.dmax;
    wsize = state.wsize;
    whave = state.whave;
    wnext = state.wnext;
    s_window = state.window;
    hold = state.hold;
    bits = state.bits;
    lcode = state.lencode;
    dcode = state.distcode;
    lmask = (1 << state.lenbits) - 1;
    dmask = (1 << state.distbits) - 1;
    top:
      do {
        if (bits < 15) {
          hold += input[_in++] << bits;
          bits += 8;
          hold += input[_in++] << bits;
          bits += 8;
        }
        here = lcode[hold & lmask];
        dolen:
          for (; ; ) {
            op = here >>> 24;
            hold >>>= op;
            bits -= op;
            op = here >>> 16 & 255;
            if (op === 0) {
              output[_out++] = here & 65535;
            } else if (op & 16) {
              len = here & 65535;
              op &= 15;
              if (op) {
                if (bits < op) {
                  hold += input[_in++] << bits;
                  bits += 8;
                }
                len += hold & (1 << op) - 1;
                hold >>>= op;
                bits -= op;
              }
              if (bits < 15) {
                hold += input[_in++] << bits;
                bits += 8;
                hold += input[_in++] << bits;
                bits += 8;
              }
              here = dcode[hold & dmask];
              dodist:
                for (; ; ) {
                  op = here >>> 24;
                  hold >>>= op;
                  bits -= op;
                  op = here >>> 16 & 255;
                  if (op & 16) {
                    dist = here & 65535;
                    op &= 15;
                    if (bits < op) {
                      hold += input[_in++] << bits;
                      bits += 8;
                      if (bits < op) {
                        hold += input[_in++] << bits;
                        bits += 8;
                      }
                    }
                    dist += hold & (1 << op) - 1;
                    if (dist > dmax) {
                      strm.msg = "invalid distance too far back";
                      state.mode = BAD$1$2;
                      break top;
                    }
                    hold >>>= op;
                    bits -= op;
                    op = _out - beg;
                    if (dist > op) {
                      op = dist - op;
                      if (op > whave) {
                        if (state.sane) {
                          strm.msg = "invalid distance too far back";
                          state.mode = BAD$1$2;
                          break top;
                        }
                      }
                      from = 0;
                      from_source = s_window;
                      if (wnext === 0) {
                        from += wsize - op;
                        if (op < len) {
                          len -= op;
                          do {
                            output[_out++] = s_window[from++];
                          } while (--op);
                          from = _out - dist;
                          from_source = output;
                        }
                      } else if (wnext < op) {
                        from += wsize + wnext - op;
                        op -= wnext;
                        if (op < len) {
                          len -= op;
                          do {
                            output[_out++] = s_window[from++];
                          } while (--op);
                          from = 0;
                          if (wnext < len) {
                            op = wnext;
                            len -= op;
                            do {
                              output[_out++] = s_window[from++];
                            } while (--op);
                            from = _out - dist;
                            from_source = output;
                          }
                        }
                      } else {
                        from += wnext - op;
                        if (op < len) {
                          len -= op;
                          do {
                            output[_out++] = s_window[from++];
                          } while (--op);
                          from = _out - dist;
                          from_source = output;
                        }
                      }
                      while (len > 2) {
                        output[_out++] = from_source[from++];
                        output[_out++] = from_source[from++];
                        output[_out++] = from_source[from++];
                        len -= 3;
                      }
                      if (len) {
                        output[_out++] = from_source[from++];
                        if (len > 1) {
                          output[_out++] = from_source[from++];
                        }
                      }
                    } else {
                      from = _out - dist;
                      do {
                        output[_out++] = output[from++];
                        output[_out++] = output[from++];
                        output[_out++] = output[from++];
                        len -= 3;
                      } while (len > 2);
                      if (len) {
                        output[_out++] = output[from++];
                        if (len > 1) {
                          output[_out++] = output[from++];
                        }
                      }
                    }
                  } else if ((op & 64) === 0) {
                    here = dcode[(here & 65535) + (hold & (1 << op) - 1)];
                    continue dodist;
                  } else {
                    strm.msg = "invalid distance code";
                    state.mode = BAD$1$2;
                    break top;
                  }
                  break;
                }
            } else if ((op & 64) === 0) {
              here = lcode[(here & 65535) + (hold & (1 << op) - 1)];
              continue dolen;
            } else if (op & 32) {
              state.mode = TYPE$1$2;
              break top;
            } else {
              strm.msg = "invalid literal/length code";
              state.mode = BAD$1$2;
              break top;
            }
            break;
          }
      } while (_in < last && _out < end);
    len = bits >> 3;
    _in -= len;
    bits -= len << 3;
    hold &= (1 << bits) - 1;
    strm.next_in = _in;
    strm.next_out = _out;
    strm.avail_in = _in < last ? 5 + (last - _in) : 5 - (_in - last);
    strm.avail_out = _out < end ? 257 + (end - _out) : 257 - (_out - end);
    state.hold = hold;
    state.bits = bits;
    return;
  };
  var MAXBITS$2 = 15;
  var ENOUGH_LENS$1$2 = 852;
  var ENOUGH_DISTS$1$2 = 592;
  var CODES$1$2 = 0;
  var LENS$1$2 = 1;
  var DISTS$1$2 = 2;
  var lbase$2 = new Uint16Array([
    3,
    4,
    5,
    6,
    7,
    8,
    9,
    10,
    11,
    13,
    15,
    17,
    19,
    23,
    27,
    31,
    35,
    43,
    51,
    59,
    67,
    83,
    99,
    115,
    131,
    163,
    195,
    227,
    258,
    0,
    0
  ]);
  var lext$2 = new Uint8Array([
    16,
    16,
    16,
    16,
    16,
    16,
    16,
    16,
    17,
    17,
    17,
    17,
    18,
    18,
    18,
    18,
    19,
    19,
    19,
    19,
    20,
    20,
    20,
    20,
    21,
    21,
    21,
    21,
    16,
    72,
    78
  ]);
  var dbase$2 = new Uint16Array([
    1,
    2,
    3,
    4,
    5,
    7,
    9,
    13,
    17,
    25,
    33,
    49,
    65,
    97,
    129,
    193,
    257,
    385,
    513,
    769,
    1025,
    1537,
    2049,
    3073,
    4097,
    6145,
    8193,
    12289,
    16385,
    24577,
    0,
    0
  ]);
  var dext$2 = new Uint8Array([
    16,
    16,
    16,
    16,
    17,
    17,
    18,
    18,
    19,
    19,
    20,
    20,
    21,
    21,
    22,
    22,
    23,
    23,
    24,
    24,
    25,
    25,
    26,
    26,
    27,
    27,
    28,
    28,
    29,
    29,
    64,
    64
  ]);
  var inflate_table$2 = (type, lens, lens_index, codes, table, table_index, work, opts) => {
    const bits = opts.bits;
    let len = 0;
    let sym = 0;
    let min = 0, max = 0;
    let root = 0;
    let curr = 0;
    let drop = 0;
    let left = 0;
    let used = 0;
    let huff = 0;
    let incr;
    let fill;
    let low;
    let mask;
    let next;
    let base = null;
    let base_index = 0;
    let end;
    const count = new Uint16Array(MAXBITS$2 + 1);
    const offs = new Uint16Array(MAXBITS$2 + 1);
    let extra = null;
    let extra_index = 0;
    let here_bits, here_op, here_val;
    for (len = 0; len <= MAXBITS$2; len++) {
      count[len] = 0;
    }
    for (sym = 0; sym < codes; sym++) {
      count[lens[lens_index + sym]]++;
    }
    root = bits;
    for (max = MAXBITS$2; max >= 1; max--) {
      if (count[max] !== 0) {
        break;
      }
    }
    if (root > max) {
      root = max;
    }
    if (max === 0) {
      table[table_index++] = 1 << 24 | 64 << 16 | 0;
      table[table_index++] = 1 << 24 | 64 << 16 | 0;
      opts.bits = 1;
      return 0;
    }
    for (min = 1; min < max; min++) {
      if (count[min] !== 0) {
        break;
      }
    }
    if (root < min) {
      root = min;
    }
    left = 1;
    for (len = 1; len <= MAXBITS$2; len++) {
      left <<= 1;
      left -= count[len];
      if (left < 0) {
        return -1;
      }
    }
    if (left > 0 && (type === CODES$1$2 || max !== 1)) {
      return -1;
    }
    offs[1] = 0;
    for (len = 1; len < MAXBITS$2; len++) {
      offs[len + 1] = offs[len] + count[len];
    }
    for (sym = 0; sym < codes; sym++) {
      if (lens[lens_index + sym] !== 0) {
        work[offs[lens[lens_index + sym]]++] = sym;
      }
    }
    if (type === CODES$1$2) {
      base = extra = work;
      end = 19;
    } else if (type === LENS$1$2) {
      base = lbase$2;
      base_index -= 257;
      extra = lext$2;
      extra_index -= 257;
      end = 256;
    } else {
      base = dbase$2;
      extra = dext$2;
      end = -1;
    }
    huff = 0;
    sym = 0;
    len = min;
    next = table_index;
    curr = root;
    drop = 0;
    low = -1;
    used = 1 << root;
    mask = used - 1;
    if (type === LENS$1$2 && used > ENOUGH_LENS$1$2 || type === DISTS$1$2 && used > ENOUGH_DISTS$1$2) {
      return 1;
    }
    for (; ; ) {
      here_bits = len - drop;
      if (work[sym] < end) {
        here_op = 0;
        here_val = work[sym];
      } else if (work[sym] > end) {
        here_op = extra[extra_index + work[sym]];
        here_val = base[base_index + work[sym]];
      } else {
        here_op = 32 + 64;
        here_val = 0;
      }
      incr = 1 << len - drop;
      fill = 1 << curr;
      min = fill;
      do {
        fill -= incr;
        table[next + (huff >> drop) + fill] = here_bits << 24 | here_op << 16 | here_val | 0;
      } while (fill !== 0);
      incr = 1 << len - 1;
      while (huff & incr) {
        incr >>= 1;
      }
      if (incr !== 0) {
        huff &= incr - 1;
        huff += incr;
      } else {
        huff = 0;
      }
      sym++;
      if (--count[len] === 0) {
        if (len === max) {
          break;
        }
        len = lens[lens_index + work[sym]];
      }
      if (len > root && (huff & mask) !== low) {
        if (drop === 0) {
          drop = root;
        }
        next += min;
        curr = len - drop;
        left = 1 << curr;
        while (curr + drop < max) {
          left -= count[curr + drop];
          if (left <= 0) {
            break;
          }
          curr++;
          left <<= 1;
        }
        used += 1 << curr;
        if (type === LENS$1$2 && used > ENOUGH_LENS$1$2 || type === DISTS$1$2 && used > ENOUGH_DISTS$1$2) {
          return 1;
        }
        low = huff & mask;
        table[low] = root << 24 | curr << 16 | next - table_index | 0;
      }
    }
    if (huff !== 0) {
      table[next + huff] = len - drop << 24 | 64 << 16 | 0;
    }
    opts.bits = root;
    return 0;
  };
  var inftrees$2 = inflate_table$2;
  var CODES$3 = 0;
  var LENS$3 = 1;
  var DISTS$3 = 2;
  var {
    Z_FINISH: Z_FINISH$1$2,
    Z_BLOCK: Z_BLOCK$3,
    Z_TREES: Z_TREES$2,
    Z_OK: Z_OK$1$2,
    Z_STREAM_END: Z_STREAM_END$1$2,
    Z_NEED_DICT: Z_NEED_DICT$1$2,
    Z_STREAM_ERROR: Z_STREAM_ERROR$1$2,
    Z_DATA_ERROR: Z_DATA_ERROR$1$2,
    Z_MEM_ERROR: Z_MEM_ERROR$1$2,
    Z_BUF_ERROR: Z_BUF_ERROR$3,
    Z_DEFLATED: Z_DEFLATED$4
  } = constants$2$2;
  var HEAD$2 = 1;
  var FLAGS$2 = 2;
  var TIME$2 = 3;
  var OS$2 = 4;
  var EXLEN$2 = 5;
  var EXTRA$2 = 6;
  var NAME$2 = 7;
  var COMMENT$2 = 8;
  var HCRC$2 = 9;
  var DICTID$2 = 10;
  var DICT$2 = 11;
  var TYPE$3 = 12;
  var TYPEDO$2 = 13;
  var STORED$2 = 14;
  var COPY_$2 = 15;
  var COPY$2 = 16;
  var TABLE$2 = 17;
  var LENLENS$2 = 18;
  var CODELENS$2 = 19;
  var LEN_$2 = 20;
  var LEN$2 = 21;
  var LENEXT$2 = 22;
  var DIST$2 = 23;
  var DISTEXT$2 = 24;
  var MATCH$2 = 25;
  var LIT$2 = 26;
  var CHECK$2 = 27;
  var LENGTH$2 = 28;
  var DONE$2 = 29;
  var BAD$3 = 30;
  var MEM$2 = 31;
  var SYNC$2 = 32;
  var ENOUGH_LENS$3 = 852;
  var ENOUGH_DISTS$3 = 592;
  var MAX_WBITS$3 = 15;
  var DEF_WBITS$2 = MAX_WBITS$3;
  var zswap32$2 = (q) => {
    return (q >>> 24 & 255) + (q >>> 8 & 65280) + ((q & 65280) << 8) + ((q & 255) << 24);
  };
  function InflateState$2() {
    this.mode = 0;
    this.last = false;
    this.wrap = 0;
    this.havedict = false;
    this.flags = 0;
    this.dmax = 0;
    this.check = 0;
    this.total = 0;
    this.head = null;
    this.wbits = 0;
    this.wsize = 0;
    this.whave = 0;
    this.wnext = 0;
    this.window = null;
    this.hold = 0;
    this.bits = 0;
    this.length = 0;
    this.offset = 0;
    this.extra = 0;
    this.lencode = null;
    this.distcode = null;
    this.lenbits = 0;
    this.distbits = 0;
    this.ncode = 0;
    this.nlen = 0;
    this.ndist = 0;
    this.have = 0;
    this.next = null;
    this.lens = new Uint16Array(320);
    this.work = new Uint16Array(288);
    this.lendyn = null;
    this.distdyn = null;
    this.sane = 0;
    this.back = 0;
    this.was = 0;
  }
  var inflateResetKeep$2 = (strm) => {
    if (!strm || !strm.state) {
      return Z_STREAM_ERROR$1$2;
    }
    const state = strm.state;
    strm.total_in = strm.total_out = state.total = 0;
    strm.msg = "";
    if (state.wrap) {
      strm.adler = state.wrap & 1;
    }
    state.mode = HEAD$2;
    state.last = 0;
    state.havedict = 0;
    state.dmax = 32768;
    state.head = null;
    state.hold = 0;
    state.bits = 0;
    state.lencode = state.lendyn = new Int32Array(ENOUGH_LENS$3);
    state.distcode = state.distdyn = new Int32Array(ENOUGH_DISTS$3);
    state.sane = 1;
    state.back = -1;
    return Z_OK$1$2;
  };
  var inflateReset$2 = (strm) => {
    if (!strm || !strm.state) {
      return Z_STREAM_ERROR$1$2;
    }
    const state = strm.state;
    state.wsize = 0;
    state.whave = 0;
    state.wnext = 0;
    return inflateResetKeep$2(strm);
  };
  var inflateReset2$2 = (strm, windowBits) => {
    let wrap;
    if (!strm || !strm.state) {
      return Z_STREAM_ERROR$1$2;
    }
    const state = strm.state;
    if (windowBits < 0) {
      wrap = 0;
      windowBits = -windowBits;
    } else {
      wrap = (windowBits >> 4) + 1;
      if (windowBits < 48) {
        windowBits &= 15;
      }
    }
    if (windowBits && (windowBits < 8 || windowBits > 15)) {
      return Z_STREAM_ERROR$1$2;
    }
    if (state.window !== null && state.wbits !== windowBits) {
      state.window = null;
    }
    state.wrap = wrap;
    state.wbits = windowBits;
    return inflateReset$2(strm);
  };
  var inflateInit2$2 = (strm, windowBits) => {
    if (!strm) {
      return Z_STREAM_ERROR$1$2;
    }
    const state = new InflateState$2();
    strm.state = state;
    state.window = null;
    const ret = inflateReset2$2(strm, windowBits);
    if (ret !== Z_OK$1$2) {
      strm.state = null;
    }
    return ret;
  };
  var inflateInit$2 = (strm) => {
    return inflateInit2$2(strm, DEF_WBITS$2);
  };
  var virgin$2 = true;
  var lenfix$2;
  var distfix$2;
  var fixedtables$2 = (state) => {
    if (virgin$2) {
      lenfix$2 = new Int32Array(512);
      distfix$2 = new Int32Array(32);
      let sym = 0;
      while (sym < 144) {
        state.lens[sym++] = 8;
      }
      while (sym < 256) {
        state.lens[sym++] = 9;
      }
      while (sym < 280) {
        state.lens[sym++] = 7;
      }
      while (sym < 288) {
        state.lens[sym++] = 8;
      }
      inftrees$2(LENS$3, state.lens, 0, 288, lenfix$2, 0, state.work, { bits: 9 });
      sym = 0;
      while (sym < 32) {
        state.lens[sym++] = 5;
      }
      inftrees$2(DISTS$3, state.lens, 0, 32, distfix$2, 0, state.work, { bits: 5 });
      virgin$2 = false;
    }
    state.lencode = lenfix$2;
    state.lenbits = 9;
    state.distcode = distfix$2;
    state.distbits = 5;
  };
  var updatewindow$2 = (strm, src, end, copy) => {
    let dist;
    const state = strm.state;
    if (state.window === null) {
      state.wsize = 1 << state.wbits;
      state.wnext = 0;
      state.whave = 0;
      state.window = new Uint8Array(state.wsize);
    }
    if (copy >= state.wsize) {
      state.window.set(src.subarray(end - state.wsize, end), 0);
      state.wnext = 0;
      state.whave = state.wsize;
    } else {
      dist = state.wsize - state.wnext;
      if (dist > copy) {
        dist = copy;
      }
      state.window.set(src.subarray(end - copy, end - copy + dist), state.wnext);
      copy -= dist;
      if (copy) {
        state.window.set(src.subarray(end - copy, end), 0);
        state.wnext = copy;
        state.whave = state.wsize;
      } else {
        state.wnext += dist;
        if (state.wnext === state.wsize) {
          state.wnext = 0;
        }
        if (state.whave < state.wsize) {
          state.whave += dist;
        }
      }
    }
    return 0;
  };
  var inflate$2$2 = (strm, flush) => {
    let state;
    let input, output;
    let next;
    let put;
    let have, left;
    let hold;
    let bits;
    let _in, _out;
    let copy;
    let from;
    let from_source;
    let here = 0;
    let here_bits, here_op, here_val;
    let last_bits, last_op, last_val;
    let len;
    let ret;
    const hbuf = new Uint8Array(4);
    let opts;
    let n;
    const order = new Uint8Array([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]);
    if (!strm || !strm.state || !strm.output || !strm.input && strm.avail_in !== 0) {
      return Z_STREAM_ERROR$1$2;
    }
    state = strm.state;
    if (state.mode === TYPE$3) {
      state.mode = TYPEDO$2;
    }
    put = strm.next_out;
    output = strm.output;
    left = strm.avail_out;
    next = strm.next_in;
    input = strm.input;
    have = strm.avail_in;
    hold = state.hold;
    bits = state.bits;
    _in = have;
    _out = left;
    ret = Z_OK$1$2;
    inf_leave:
      for (; ; ) {
        switch (state.mode) {
          case HEAD$2:
            if (state.wrap === 0) {
              state.mode = TYPEDO$2;
              break;
            }
            while (bits < 16) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            if (state.wrap & 2 && hold === 35615) {
              state.check = 0;
              hbuf[0] = hold & 255;
              hbuf[1] = hold >>> 8 & 255;
              state.check = crc32_1$2(state.check, hbuf, 2, 0);
              hold = 0;
              bits = 0;
              state.mode = FLAGS$2;
              break;
            }
            state.flags = 0;
            if (state.head) {
              state.head.done = false;
            }
            if (!(state.wrap & 1) || (((hold & 255) << 8) + (hold >> 8)) % 31) {
              strm.msg = "incorrect header check";
              state.mode = BAD$3;
              break;
            }
            if ((hold & 15) !== Z_DEFLATED$4) {
              strm.msg = "unknown compression method";
              state.mode = BAD$3;
              break;
            }
            hold >>>= 4;
            bits -= 4;
            len = (hold & 15) + 8;
            if (state.wbits === 0) {
              state.wbits = len;
            } else if (len > state.wbits) {
              strm.msg = "invalid window size";
              state.mode = BAD$3;
              break;
            }
            state.dmax = 1 << state.wbits;
            strm.adler = state.check = 1;
            state.mode = hold & 512 ? DICTID$2 : TYPE$3;
            hold = 0;
            bits = 0;
            break;
          case FLAGS$2:
            while (bits < 16) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            state.flags = hold;
            if ((state.flags & 255) !== Z_DEFLATED$4) {
              strm.msg = "unknown compression method";
              state.mode = BAD$3;
              break;
            }
            if (state.flags & 57344) {
              strm.msg = "unknown header flags set";
              state.mode = BAD$3;
              break;
            }
            if (state.head) {
              state.head.text = hold >> 8 & 1;
            }
            if (state.flags & 512) {
              hbuf[0] = hold & 255;
              hbuf[1] = hold >>> 8 & 255;
              state.check = crc32_1$2(state.check, hbuf, 2, 0);
            }
            hold = 0;
            bits = 0;
            state.mode = TIME$2;
          case TIME$2:
            while (bits < 32) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            if (state.head) {
              state.head.time = hold;
            }
            if (state.flags & 512) {
              hbuf[0] = hold & 255;
              hbuf[1] = hold >>> 8 & 255;
              hbuf[2] = hold >>> 16 & 255;
              hbuf[3] = hold >>> 24 & 255;
              state.check = crc32_1$2(state.check, hbuf, 4, 0);
            }
            hold = 0;
            bits = 0;
            state.mode = OS$2;
          case OS$2:
            while (bits < 16) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            if (state.head) {
              state.head.xflags = hold & 255;
              state.head.os = hold >> 8;
            }
            if (state.flags & 512) {
              hbuf[0] = hold & 255;
              hbuf[1] = hold >>> 8 & 255;
              state.check = crc32_1$2(state.check, hbuf, 2, 0);
            }
            hold = 0;
            bits = 0;
            state.mode = EXLEN$2;
          case EXLEN$2:
            if (state.flags & 1024) {
              while (bits < 16) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              state.length = hold;
              if (state.head) {
                state.head.extra_len = hold;
              }
              if (state.flags & 512) {
                hbuf[0] = hold & 255;
                hbuf[1] = hold >>> 8 & 255;
                state.check = crc32_1$2(state.check, hbuf, 2, 0);
              }
              hold = 0;
              bits = 0;
            } else if (state.head) {
              state.head.extra = null;
            }
            state.mode = EXTRA$2;
          case EXTRA$2:
            if (state.flags & 1024) {
              copy = state.length;
              if (copy > have) {
                copy = have;
              }
              if (copy) {
                if (state.head) {
                  len = state.head.extra_len - state.length;
                  if (!state.head.extra) {
                    state.head.extra = new Uint8Array(state.head.extra_len);
                  }
                  state.head.extra.set(input.subarray(next, next + copy), len);
                }
                if (state.flags & 512) {
                  state.check = crc32_1$2(state.check, input, copy, next);
                }
                have -= copy;
                next += copy;
                state.length -= copy;
              }
              if (state.length) {
                break inf_leave;
              }
            }
            state.length = 0;
            state.mode = NAME$2;
          case NAME$2:
            if (state.flags & 2048) {
              if (have === 0) {
                break inf_leave;
              }
              copy = 0;
              do {
                len = input[next + copy++];
                if (state.head && len && state.length < 65536) {
                  state.head.name += String.fromCharCode(len);
                }
              } while (len && copy < have);
              if (state.flags & 512) {
                state.check = crc32_1$2(state.check, input, copy, next);
              }
              have -= copy;
              next += copy;
              if (len) {
                break inf_leave;
              }
            } else if (state.head) {
              state.head.name = null;
            }
            state.length = 0;
            state.mode = COMMENT$2;
          case COMMENT$2:
            if (state.flags & 4096) {
              if (have === 0) {
                break inf_leave;
              }
              copy = 0;
              do {
                len = input[next + copy++];
                if (state.head && len && state.length < 65536) {
                  state.head.comment += String.fromCharCode(len);
                }
              } while (len && copy < have);
              if (state.flags & 512) {
                state.check = crc32_1$2(state.check, input, copy, next);
              }
              have -= copy;
              next += copy;
              if (len) {
                break inf_leave;
              }
            } else if (state.head) {
              state.head.comment = null;
            }
            state.mode = HCRC$2;
          case HCRC$2:
            if (state.flags & 512) {
              while (bits < 16) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              if (hold !== (state.check & 65535)) {
                strm.msg = "header crc mismatch";
                state.mode = BAD$3;
                break;
              }
              hold = 0;
              bits = 0;
            }
            if (state.head) {
              state.head.hcrc = state.flags >> 9 & 1;
              state.head.done = true;
            }
            strm.adler = state.check = 0;
            state.mode = TYPE$3;
            break;
          case DICTID$2:
            while (bits < 32) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            strm.adler = state.check = zswap32$2(hold);
            hold = 0;
            bits = 0;
            state.mode = DICT$2;
          case DICT$2:
            if (state.havedict === 0) {
              strm.next_out = put;
              strm.avail_out = left;
              strm.next_in = next;
              strm.avail_in = have;
              state.hold = hold;
              state.bits = bits;
              return Z_NEED_DICT$1$2;
            }
            strm.adler = state.check = 1;
            state.mode = TYPE$3;
          case TYPE$3:
            if (flush === Z_BLOCK$3 || flush === Z_TREES$2) {
              break inf_leave;
            }
          case TYPEDO$2:
            if (state.last) {
              hold >>>= bits & 7;
              bits -= bits & 7;
              state.mode = CHECK$2;
              break;
            }
            while (bits < 3) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            state.last = hold & 1;
            hold >>>= 1;
            bits -= 1;
            switch (hold & 3) {
              case 0:
                state.mode = STORED$2;
                break;
              case 1:
                fixedtables$2(state);
                state.mode = LEN_$2;
                if (flush === Z_TREES$2) {
                  hold >>>= 2;
                  bits -= 2;
                  break inf_leave;
                }
                break;
              case 2:
                state.mode = TABLE$2;
                break;
              case 3:
                strm.msg = "invalid block type";
                state.mode = BAD$3;
            }
            hold >>>= 2;
            bits -= 2;
            break;
          case STORED$2:
            hold >>>= bits & 7;
            bits -= bits & 7;
            while (bits < 32) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            if ((hold & 65535) !== (hold >>> 16 ^ 65535)) {
              strm.msg = "invalid stored block lengths";
              state.mode = BAD$3;
              break;
            }
            state.length = hold & 65535;
            hold = 0;
            bits = 0;
            state.mode = COPY_$2;
            if (flush === Z_TREES$2) {
              break inf_leave;
            }
          case COPY_$2:
            state.mode = COPY$2;
          case COPY$2:
            copy = state.length;
            if (copy) {
              if (copy > have) {
                copy = have;
              }
              if (copy > left) {
                copy = left;
              }
              if (copy === 0) {
                break inf_leave;
              }
              output.set(input.subarray(next, next + copy), put);
              have -= copy;
              next += copy;
              left -= copy;
              put += copy;
              state.length -= copy;
              break;
            }
            state.mode = TYPE$3;
            break;
          case TABLE$2:
            while (bits < 14) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            state.nlen = (hold & 31) + 257;
            hold >>>= 5;
            bits -= 5;
            state.ndist = (hold & 31) + 1;
            hold >>>= 5;
            bits -= 5;
            state.ncode = (hold & 15) + 4;
            hold >>>= 4;
            bits -= 4;
            if (state.nlen > 286 || state.ndist > 30) {
              strm.msg = "too many length or distance symbols";
              state.mode = BAD$3;
              break;
            }
            state.have = 0;
            state.mode = LENLENS$2;
          case LENLENS$2:
            while (state.have < state.ncode) {
              while (bits < 3) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              state.lens[order[state.have++]] = hold & 7;
              hold >>>= 3;
              bits -= 3;
            }
            while (state.have < 19) {
              state.lens[order[state.have++]] = 0;
            }
            state.lencode = state.lendyn;
            state.lenbits = 7;
            opts = { bits: state.lenbits };
            ret = inftrees$2(CODES$3, state.lens, 0, 19, state.lencode, 0, state.work, opts);
            state.lenbits = opts.bits;
            if (ret) {
              strm.msg = "invalid code lengths set";
              state.mode = BAD$3;
              break;
            }
            state.have = 0;
            state.mode = CODELENS$2;
          case CODELENS$2:
            while (state.have < state.nlen + state.ndist) {
              for (; ; ) {
                here = state.lencode[hold & (1 << state.lenbits) - 1];
                here_bits = here >>> 24;
                here_op = here >>> 16 & 255;
                here_val = here & 65535;
                if (here_bits <= bits) {
                  break;
                }
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              if (here_val < 16) {
                hold >>>= here_bits;
                bits -= here_bits;
                state.lens[state.have++] = here_val;
              } else {
                if (here_val === 16) {
                  n = here_bits + 2;
                  while (bits < n) {
                    if (have === 0) {
                      break inf_leave;
                    }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  hold >>>= here_bits;
                  bits -= here_bits;
                  if (state.have === 0) {
                    strm.msg = "invalid bit length repeat";
                    state.mode = BAD$3;
                    break;
                  }
                  len = state.lens[state.have - 1];
                  copy = 3 + (hold & 3);
                  hold >>>= 2;
                  bits -= 2;
                } else if (here_val === 17) {
                  n = here_bits + 3;
                  while (bits < n) {
                    if (have === 0) {
                      break inf_leave;
                    }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  hold >>>= here_bits;
                  bits -= here_bits;
                  len = 0;
                  copy = 3 + (hold & 7);
                  hold >>>= 3;
                  bits -= 3;
                } else {
                  n = here_bits + 7;
                  while (bits < n) {
                    if (have === 0) {
                      break inf_leave;
                    }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  hold >>>= here_bits;
                  bits -= here_bits;
                  len = 0;
                  copy = 11 + (hold & 127);
                  hold >>>= 7;
                  bits -= 7;
                }
                if (state.have + copy > state.nlen + state.ndist) {
                  strm.msg = "invalid bit length repeat";
                  state.mode = BAD$3;
                  break;
                }
                while (copy--) {
                  state.lens[state.have++] = len;
                }
              }
            }
            if (state.mode === BAD$3) {
              break;
            }
            if (state.lens[256] === 0) {
              strm.msg = "invalid code -- missing end-of-block";
              state.mode = BAD$3;
              break;
            }
            state.lenbits = 9;
            opts = { bits: state.lenbits };
            ret = inftrees$2(LENS$3, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
            state.lenbits = opts.bits;
            if (ret) {
              strm.msg = "invalid literal/lengths set";
              state.mode = BAD$3;
              break;
            }
            state.distbits = 6;
            state.distcode = state.distdyn;
            opts = { bits: state.distbits };
            ret = inftrees$2(DISTS$3, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
            state.distbits = opts.bits;
            if (ret) {
              strm.msg = "invalid distances set";
              state.mode = BAD$3;
              break;
            }
            state.mode = LEN_$2;
            if (flush === Z_TREES$2) {
              break inf_leave;
            }
          case LEN_$2:
            state.mode = LEN$2;
          case LEN$2:
            if (have >= 6 && left >= 258) {
              strm.next_out = put;
              strm.avail_out = left;
              strm.next_in = next;
              strm.avail_in = have;
              state.hold = hold;
              state.bits = bits;
              inffast$2(strm, _out);
              put = strm.next_out;
              output = strm.output;
              left = strm.avail_out;
              next = strm.next_in;
              input = strm.input;
              have = strm.avail_in;
              hold = state.hold;
              bits = state.bits;
              if (state.mode === TYPE$3) {
                state.back = -1;
              }
              break;
            }
            state.back = 0;
            for (; ; ) {
              here = state.lencode[hold & (1 << state.lenbits) - 1];
              here_bits = here >>> 24;
              here_op = here >>> 16 & 255;
              here_val = here & 65535;
              if (here_bits <= bits) {
                break;
              }
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            if (here_op && (here_op & 240) === 0) {
              last_bits = here_bits;
              last_op = here_op;
              last_val = here_val;
              for (; ; ) {
                here = state.lencode[last_val + ((hold & (1 << last_bits + last_op) - 1) >> last_bits)];
                here_bits = here >>> 24;
                here_op = here >>> 16 & 255;
                here_val = here & 65535;
                if (last_bits + here_bits <= bits) {
                  break;
                }
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              hold >>>= last_bits;
              bits -= last_bits;
              state.back += last_bits;
            }
            hold >>>= here_bits;
            bits -= here_bits;
            state.back += here_bits;
            state.length = here_val;
            if (here_op === 0) {
              state.mode = LIT$2;
              break;
            }
            if (here_op & 32) {
              state.back = -1;
              state.mode = TYPE$3;
              break;
            }
            if (here_op & 64) {
              strm.msg = "invalid literal/length code";
              state.mode = BAD$3;
              break;
            }
            state.extra = here_op & 15;
            state.mode = LENEXT$2;
          case LENEXT$2:
            if (state.extra) {
              n = state.extra;
              while (bits < n) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              state.length += hold & (1 << state.extra) - 1;
              hold >>>= state.extra;
              bits -= state.extra;
              state.back += state.extra;
            }
            state.was = state.length;
            state.mode = DIST$2;
          case DIST$2:
            for (; ; ) {
              here = state.distcode[hold & (1 << state.distbits) - 1];
              here_bits = here >>> 24;
              here_op = here >>> 16 & 255;
              here_val = here & 65535;
              if (here_bits <= bits) {
                break;
              }
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            if ((here_op & 240) === 0) {
              last_bits = here_bits;
              last_op = here_op;
              last_val = here_val;
              for (; ; ) {
                here = state.distcode[last_val + ((hold & (1 << last_bits + last_op) - 1) >> last_bits)];
                here_bits = here >>> 24;
                here_op = here >>> 16 & 255;
                here_val = here & 65535;
                if (last_bits + here_bits <= bits) {
                  break;
                }
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              hold >>>= last_bits;
              bits -= last_bits;
              state.back += last_bits;
            }
            hold >>>= here_bits;
            bits -= here_bits;
            state.back += here_bits;
            if (here_op & 64) {
              strm.msg = "invalid distance code";
              state.mode = BAD$3;
              break;
            }
            state.offset = here_val;
            state.extra = here_op & 15;
            state.mode = DISTEXT$2;
          case DISTEXT$2:
            if (state.extra) {
              n = state.extra;
              while (bits < n) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              state.offset += hold & (1 << state.extra) - 1;
              hold >>>= state.extra;
              bits -= state.extra;
              state.back += state.extra;
            }
            if (state.offset > state.dmax) {
              strm.msg = "invalid distance too far back";
              state.mode = BAD$3;
              break;
            }
            state.mode = MATCH$2;
          case MATCH$2:
            if (left === 0) {
              break inf_leave;
            }
            copy = _out - left;
            if (state.offset > copy) {
              copy = state.offset - copy;
              if (copy > state.whave) {
                if (state.sane) {
                  strm.msg = "invalid distance too far back";
                  state.mode = BAD$3;
                  break;
                }
              }
              if (copy > state.wnext) {
                copy -= state.wnext;
                from = state.wsize - copy;
              } else {
                from = state.wnext - copy;
              }
              if (copy > state.length) {
                copy = state.length;
              }
              from_source = state.window;
            } else {
              from_source = output;
              from = put - state.offset;
              copy = state.length;
            }
            if (copy > left) {
              copy = left;
            }
            left -= copy;
            state.length -= copy;
            do {
              output[put++] = from_source[from++];
            } while (--copy);
            if (state.length === 0) {
              state.mode = LEN$2;
            }
            break;
          case LIT$2:
            if (left === 0) {
              break inf_leave;
            }
            output[put++] = state.length;
            left--;
            state.mode = LEN$2;
            break;
          case CHECK$2:
            if (state.wrap) {
              while (bits < 32) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold |= input[next++] << bits;
                bits += 8;
              }
              _out -= left;
              strm.total_out += _out;
              state.total += _out;
              if (_out) {
                strm.adler = state.check = state.flags ? crc32_1$2(state.check, output, _out, put - _out) : adler32_1$2(state.check, output, _out, put - _out);
              }
              _out = left;
              if ((state.flags ? hold : zswap32$2(hold)) !== state.check) {
                strm.msg = "incorrect data check";
                state.mode = BAD$3;
                break;
              }
              hold = 0;
              bits = 0;
            }
            state.mode = LENGTH$2;
          case LENGTH$2:
            if (state.wrap && state.flags) {
              while (bits < 32) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              if (hold !== (state.total & 4294967295)) {
                strm.msg = "incorrect length check";
                state.mode = BAD$3;
                break;
              }
              hold = 0;
              bits = 0;
            }
            state.mode = DONE$2;
          case DONE$2:
            ret = Z_STREAM_END$1$2;
            break inf_leave;
          case BAD$3:
            ret = Z_DATA_ERROR$1$2;
            break inf_leave;
          case MEM$2:
            return Z_MEM_ERROR$1$2;
          case SYNC$2:
          default:
            return Z_STREAM_ERROR$1$2;
        }
      }
    strm.next_out = put;
    strm.avail_out = left;
    strm.next_in = next;
    strm.avail_in = have;
    state.hold = hold;
    state.bits = bits;
    if (state.wsize || _out !== strm.avail_out && state.mode < BAD$3 && (state.mode < CHECK$2 || flush !== Z_FINISH$1$2)) {
      if (updatewindow$2(strm, strm.output, strm.next_out, _out - strm.avail_out))
        ;
    }
    _in -= strm.avail_in;
    _out -= strm.avail_out;
    strm.total_in += _in;
    strm.total_out += _out;
    state.total += _out;
    if (state.wrap && _out) {
      strm.adler = state.check = state.flags ? crc32_1$2(state.check, output, _out, strm.next_out - _out) : adler32_1$2(state.check, output, _out, strm.next_out - _out);
    }
    strm.data_type = state.bits + (state.last ? 64 : 0) + (state.mode === TYPE$3 ? 128 : 0) + (state.mode === LEN_$2 || state.mode === COPY_$2 ? 256 : 0);
    if ((_in === 0 && _out === 0 || flush === Z_FINISH$1$2) && ret === Z_OK$1$2) {
      ret = Z_BUF_ERROR$3;
    }
    return ret;
  };
  var inflateEnd$2 = (strm) => {
    if (!strm || !strm.state) {
      return Z_STREAM_ERROR$1$2;
    }
    let state = strm.state;
    if (state.window) {
      state.window = null;
    }
    strm.state = null;
    return Z_OK$1$2;
  };
  var inflateGetHeader$2 = (strm, head) => {
    if (!strm || !strm.state) {
      return Z_STREAM_ERROR$1$2;
    }
    const state = strm.state;
    if ((state.wrap & 2) === 0) {
      return Z_STREAM_ERROR$1$2;
    }
    state.head = head;
    head.done = false;
    return Z_OK$1$2;
  };
  var inflateSetDictionary$2 = (strm, dictionary) => {
    const dictLength = dictionary.length;
    let state;
    let dictid;
    let ret;
    if (!strm || !strm.state) {
      return Z_STREAM_ERROR$1$2;
    }
    state = strm.state;
    if (state.wrap !== 0 && state.mode !== DICT$2) {
      return Z_STREAM_ERROR$1$2;
    }
    if (state.mode === DICT$2) {
      dictid = 1;
      dictid = adler32_1$2(dictid, dictionary, dictLength, 0);
      if (dictid !== state.check) {
        return Z_DATA_ERROR$1$2;
      }
    }
    ret = updatewindow$2(strm, dictionary, dictLength, dictLength);
    if (ret) {
      state.mode = MEM$2;
      return Z_MEM_ERROR$1$2;
    }
    state.havedict = 1;
    return Z_OK$1$2;
  };
  var inflateReset_1$2 = inflateReset$2;
  var inflateReset2_1$2 = inflateReset2$2;
  var inflateResetKeep_1$2 = inflateResetKeep$2;
  var inflateInit_1$2 = inflateInit$2;
  var inflateInit2_1$2 = inflateInit2$2;
  var inflate_2$1$2 = inflate$2$2;
  var inflateEnd_1$2 = inflateEnd$2;
  var inflateGetHeader_1$2 = inflateGetHeader$2;
  var inflateSetDictionary_1$2 = inflateSetDictionary$2;
  var inflateInfo$2 = "pako inflate (from Nodeca project)";
  var inflate_1$2$2 = {
    inflateReset: inflateReset_1$2,
    inflateReset2: inflateReset2_1$2,
    inflateResetKeep: inflateResetKeep_1$2,
    inflateInit: inflateInit_1$2,
    inflateInit2: inflateInit2_1$2,
    inflate: inflate_2$1$2,
    inflateEnd: inflateEnd_1$2,
    inflateGetHeader: inflateGetHeader_1$2,
    inflateSetDictionary: inflateSetDictionary_1$2,
    inflateInfo: inflateInfo$2
  };
  function GZheader$2() {
    this.text = 0;
    this.time = 0;
    this.xflags = 0;
    this.os = 0;
    this.extra = null;
    this.extra_len = 0;
    this.name = "";
    this.comment = "";
    this.hcrc = 0;
    this.done = false;
  }
  var gzheader$2 = GZheader$2;
  var toString$4 = Object.prototype.toString;
  var {
    Z_NO_FLUSH: Z_NO_FLUSH$4,
    Z_FINISH: Z_FINISH$5,
    Z_OK: Z_OK$5,
    Z_STREAM_END: Z_STREAM_END$5,
    Z_NEED_DICT: Z_NEED_DICT$3,
    Z_STREAM_ERROR: Z_STREAM_ERROR$4,
    Z_DATA_ERROR: Z_DATA_ERROR$4,
    Z_MEM_ERROR: Z_MEM_ERROR$3
  } = constants$2$2;
  function Inflate$1$2(options) {
    this.options = common$2.assign({
      chunkSize: 1024 * 64,
      windowBits: 15,
      to: ""
    }, options || {});
    const opt = this.options;
    if (opt.raw && opt.windowBits >= 0 && opt.windowBits < 16) {
      opt.windowBits = -opt.windowBits;
      if (opt.windowBits === 0) {
        opt.windowBits = -15;
      }
    }
    if (opt.windowBits >= 0 && opt.windowBits < 16 && !(options && options.windowBits)) {
      opt.windowBits += 32;
    }
    if (opt.windowBits > 15 && opt.windowBits < 48) {
      if ((opt.windowBits & 15) === 0) {
        opt.windowBits |= 15;
      }
    }
    this.err = 0;
    this.msg = "";
    this.ended = false;
    this.chunks = [];
    this.strm = new zstream$2();
    this.strm.avail_out = 0;
    let status = inflate_1$2$2.inflateInit2(this.strm, opt.windowBits);
    if (status !== Z_OK$5) {
      throw new Error(messages$2[status]);
    }
    this.header = new gzheader$2();
    inflate_1$2$2.inflateGetHeader(this.strm, this.header);
    if (opt.dictionary) {
      if (typeof opt.dictionary === "string") {
        opt.dictionary = strings$2.string2buf(opt.dictionary);
      } else if (toString$4.call(opt.dictionary) === "[object ArrayBuffer]") {
        opt.dictionary = new Uint8Array(opt.dictionary);
      }
      if (opt.raw) {
        status = inflate_1$2$2.inflateSetDictionary(this.strm, opt.dictionary);
        if (status !== Z_OK$5) {
          throw new Error(messages$2[status]);
        }
      }
    }
  }
  Inflate$1$2.prototype.push = function(data, flush_mode) {
    const strm = this.strm;
    const chunkSize = this.options.chunkSize;
    const dictionary = this.options.dictionary;
    let status, _flush_mode, last_avail_out;
    if (this.ended)
      return false;
    if (flush_mode === ~~flush_mode)
      _flush_mode = flush_mode;
    else
      _flush_mode = flush_mode === true ? Z_FINISH$5 : Z_NO_FLUSH$4;
    if (toString$4.call(data) === "[object ArrayBuffer]") {
      strm.input = new Uint8Array(data);
    } else {
      strm.input = data;
    }
    strm.next_in = 0;
    strm.avail_in = strm.input.length;
    for (; ; ) {
      if (strm.avail_out === 0) {
        strm.output = new Uint8Array(chunkSize);
        strm.next_out = 0;
        strm.avail_out = chunkSize;
      }
      status = inflate_1$2$2.inflate(strm, _flush_mode);
      if (status === Z_NEED_DICT$3 && dictionary) {
        status = inflate_1$2$2.inflateSetDictionary(strm, dictionary);
        if (status === Z_OK$5) {
          status = inflate_1$2$2.inflate(strm, _flush_mode);
        } else if (status === Z_DATA_ERROR$4) {
          status = Z_NEED_DICT$3;
        }
      }
      while (strm.avail_in > 0 && status === Z_STREAM_END$5 && strm.state.wrap > 0 && data[strm.next_in] !== 0) {
        inflate_1$2$2.inflateReset(strm);
        status = inflate_1$2$2.inflate(strm, _flush_mode);
      }
      switch (status) {
        case Z_STREAM_ERROR$4:
        case Z_DATA_ERROR$4:
        case Z_NEED_DICT$3:
        case Z_MEM_ERROR$3:
          this.onEnd(status);
          this.ended = true;
          return false;
      }
      last_avail_out = strm.avail_out;
      if (strm.next_out) {
        if (strm.avail_out === 0 || status === Z_STREAM_END$5) {
          if (this.options.to === "string") {
            let next_out_utf8 = strings$2.utf8border(strm.output, strm.next_out);
            let tail = strm.next_out - next_out_utf8;
            let utf8str = strings$2.buf2string(strm.output, next_out_utf8);
            strm.next_out = tail;
            strm.avail_out = chunkSize - tail;
            if (tail)
              strm.output.set(strm.output.subarray(next_out_utf8, next_out_utf8 + tail), 0);
            this.onData(utf8str);
          } else {
            this.onData(strm.output.length === strm.next_out ? strm.output : strm.output.subarray(0, strm.next_out));
          }
        }
      }
      if (status === Z_OK$5 && last_avail_out === 0)
        continue;
      if (status === Z_STREAM_END$5) {
        status = inflate_1$2$2.inflateEnd(this.strm);
        this.onEnd(status);
        this.ended = true;
        return true;
      }
      if (strm.avail_in === 0)
        break;
    }
    return true;
  };
  Inflate$1$2.prototype.onData = function(chunk) {
    this.chunks.push(chunk);
  };
  Inflate$1$2.prototype.onEnd = function(status) {
    if (status === Z_OK$5) {
      if (this.options.to === "string") {
        this.result = this.chunks.join("");
      } else {
        this.result = common$2.flattenChunks(this.chunks);
      }
    }
    this.chunks = [];
    this.err = status;
    this.msg = this.strm.msg;
  };
  function inflate$1$2(input, options) {
    const inflator = new Inflate$1$2(options);
    inflator.push(input);
    if (inflator.err)
      throw inflator.msg || messages$2[inflator.err];
    return inflator.result;
  }
  function inflateRaw$1$2(input, options) {
    options = options || {};
    options.raw = true;
    return inflate$1$2(input, options);
  }
  var Inflate_1$1$2 = Inflate$1$2;
  var inflate_2$3 = inflate$1$2;
  var inflateRaw_1$1$2 = inflateRaw$1$2;
  var ungzip$1$2 = inflate$1$2;
  var constants$4 = constants$2$2;
  var inflate_1$1$2 = {
    Inflate: Inflate_1$1$2,
    inflate: inflate_2$3,
    inflateRaw: inflateRaw_1$1$2,
    ungzip: ungzip$1$2,
    constants: constants$4
  };
  var { Inflate: Inflate$3, inflate: inflate$4, inflateRaw: inflateRaw$3, ungzip: ungzip$3 } = inflate_1$1$2;
  var inflate_1 = inflate$4;
  var ungzip_1$2 = ungzip$3;

  // esm/filters.js
  var zlib_decompress = function(buf, itemsize) {
    let input_array = new Uint8Array(buf);
    return inflate_1(input_array).buffer;
  };
  var unshuffle = function(buf, itemsize) {
    let buffer_size = buf.byteLength;
    let unshuffled_view = new Uint8Array(buffer_size);
    let step = Math.floor(buffer_size / itemsize);
    let shuffled_view = new DataView(buf);
    for (var j = 0; j < itemsize; j++) {
      for (var i = 0; i < step; i++) {
        unshuffled_view[j + i * itemsize] = shuffled_view.getUint8(j * step + i);
      }
    }
    return unshuffled_view.buffer;
  };
  var fletch32 = function(buf, itemsize) {
    _verify_fletcher32(buf);
    return buf.slice(0, -4);
  };
  function _verify_fletcher32(chunk_buffer) {
    var odd_chunk_buffer = chunk_buffer.byteLength % 2 != 0;
    var data_length = chunk_buffer.byteLength - 4;
    var view = new DataView(chunk_buffer);
    var sum1 = 0;
    var sum2 = 0;
    for (var offset = 0; offset < data_length - 1; offset += 2) {
      let datum = view.getUint16(offset, true);
      sum1 = (sum1 + datum) % 65535;
      sum2 = (sum2 + sum1) % 65535;
    }
    if (odd_chunk_buffer) {
      let datum = view.getUint8(data_length - 1);
      sum1 = (sum1 + datum) % 65535;
      sum2 = (sum2 + sum1) % 65535;
    }
    var [ref_sum1, ref_sum2] = struct.unpack_from(">HH", chunk_buffer, data_length);
    ref_sum1 = ref_sum1 % 65535;
    ref_sum2 = ref_sum2 % 65535;
    if (sum1 != ref_sum1 || sum2 != ref_sum2) {
      throw 'ValueError("fletcher32 checksum invalid")';
    }
    return true;
  }
  var GZIP_DEFLATE_FILTER = 1;
  var SHUFFLE_FILTER = 2;
  var FLETCH32_FILTER = 3;
  var Filters = /* @__PURE__ */ new Map([
    [GZIP_DEFLATE_FILTER, zlib_decompress],
    [SHUFFLE_FILTER, unshuffle],
    [FLETCH32_FILTER, fletch32]
  ]);

  // esm/btree.js
  var AbstractBTree = class {
    constructor(fh, offset) {
      this.fh = fh;
      this.offset = offset;
      this.depth = null;
    }
    async init() {
      this.all_nodes = /* @__PURE__ */ new Map();
      await this._read_root_node();
      await this._read_children();
    }
    async _read_children() {
      let node_level = this.depth;
      while (node_level > 0) {
        for (var parent_node of this.all_nodes.get(node_level)) {
          for (var child_addr of parent_node.get("addresses")) {
            this._add_node(await this._read_node(child_addr, node_level - 1));
          }
        }
        node_level--;
      }
    }
    async _read_root_node() {
      let root_node = await this._read_node(this.offset, null);
      this._add_node(root_node);
      this.depth = root_node.get("node_level");
    }
    _add_node(node) {
      let node_level = node.get("node_level");
      if (this.all_nodes.has(node_level)) {
        this.all_nodes.get(node_level).push(node);
      } else {
        this.all_nodes.set(node_level, [node]);
      }
    }
    async _read_node(offset, node_level) {
      let node = await this._read_node_header(offset, node_level);
      node.set("keys", []);
      node.set("addresses", []);
      return node;
    }
    async _read_node_header(offset) {
      throw "NotImplementedError: must define _read_node_header in implementation class";
    }
  };
  var BTreeV1 = class extends AbstractBTree {
    B_LINK_NODE = /* @__PURE__ */ new Map([
      ["signature", "4s"],
      ["node_type", "B"],
      ["node_level", "B"],
      ["entries_used", "H"],
      ["left_sibling", "Q"],
      ["right_sibling", "Q"]
    ]);
    async _read_node_header(offset, node_level) {
      let node = await _unpack_struct_from_async(this.B_LINK_NODE, this.fh, offset);
      if (node_level != null) {
        if (node.get("node_level") != node_level) {
          throw "node level does not match";
        }
      }
      return node;
    }
  };
  var BTreeV1Groups = class extends BTreeV1 {
    NODE_TYPE = 0;
    constructor(fh, offset) {
      super(fh, offset);
      this.ready = this.init();
    }
    async _read_node(offset, node_level) {
      let node = await this._read_node_header(offset, node_level);
      offset += _structure_size(this.B_LINK_NODE);
      let keys = [];
      let addresses = [];
      let entries_used = node.get("entries_used");
      for (var i = 0; i < entries_used; i++) {
        let key = (await struct.unpack_from_async("<Q", this.fh, offset))[0];
        offset += 8;
        let address = (await struct.unpack_from_async("<Q", this.fh, offset))[0];
        offset += 8;
        keys.push(key);
        addresses.push(address);
      }
      keys.push((await struct.unpack_from_async("<Q", this.fh, offset))[0]);
      node.set("keys", keys);
      node.set("addresses", addresses);
      return node;
    }
    symbol_table_addresses() {
      var all_address = [];
      var root_nodes = this.all_nodes.get(0);
      for (var node of root_nodes) {
        all_address = all_address.concat(node.get("addresses"));
      }
      return all_address;
    }
  };
  var BTreeV1RawDataChunks = class extends BTreeV1 {
    NODE_TYPE = 1;
    constructor(fh, offset, dims) {
      super(fh, offset);
      this.dims = dims;
      this.ready = this.init();
    }
    async _read_node(offset, node_level) {
      let node = await this._read_node_header(offset, node_level);
      offset += _structure_size(this.B_LINK_NODE);
      var keys = [];
      var addresses = [];
      let entries_used = node.get("entries_used");
      for (var i = 0; i < entries_used; i++) {
        let [chunk_size, filter_mask] = await struct.unpack_from_async("<II", this.fh, offset);
        offset += 8;
        let fmt = "<" + this.dims.toFixed() + "Q";
        let fmt_size = struct.calcsize(fmt);
        let chunk_offset = await struct.unpack_from_async(fmt, this.fh, offset);
        offset += fmt_size;
        let chunk_address = (await struct.unpack_from_async("<Q", this.fh, offset))[0];
        offset += 8;
        keys.push(/* @__PURE__ */ new Map([
          ["chunk_size", chunk_size],
          ["filter_mask", filter_mask],
          ["chunk_offset", chunk_offset]
        ]));
        addresses.push(chunk_address);
      }
      node.set("keys", keys);
      node.set("addresses", addresses);
      return node;
    }
    async construct_data_from_chunks(chunk_shape, data_shape, dtype, filter_pipeline) {
      var item_getter, item_big_endian, item_size;
      if (dtype instanceof Array) {
        let dtype_class = dtype[0];
        if (dtype_class == "REFERENCE") {
          let size = dtype[1];
          if (size != 8) {
            throw "NotImplementedError('Unsupported Reference type')";
          }
          var dtype = "<u8";
          item_getter = "getUint64";
          item_big_endian = false;
          item_size = 8;
        } else if (dtype_class == "VLEN_STRING" || dtype_class == "VLEN_SEQUENCE") {
          item_getter = "getVLENStruct";
          item_big_endian = false;
          item_size = 16;
        } else {
          throw "NotImplementedError('datatype not implemented')";
        }
      } else {
        [item_getter, item_big_endian, item_size] = dtype_getter(dtype);
      }
      var data_size = data_shape.reduce(function(a, b) {
        return a * b;
      }, 1);
      var chunk_size = chunk_shape.reduce(function(a, b) {
        return a * b;
      }, 1);
      let dims = data_shape.length;
      var current_stride = 1;
      chunk_shape.slice().map(function(d2) {
        let s = current_stride;
        current_stride *= d2;
        return s;
      });
      var current_stride = 1;
      var data_strides = data_shape.slice().reverse().map(function(d2) {
        let s = current_stride;
        current_stride *= d2;
        return s;
      }).reverse();
      var data = new Array(data_size);
      let chunk_buffer_size = chunk_size * item_size;
      for (var node of this.all_nodes.get(0)) {
        let node_keys = node.get("keys");
        let node_addresses = node.get("addresses");
        let nkeys = node_keys.length;
        for (var ik = 0; ik < nkeys; ik++) {
          let node_key = node_keys[ik];
          let addr = node_addresses[ik];
          var chunk_buffer;
          if (filter_pipeline == null) {
            chunk_buffer = await this.fh.slice(addr, addr + chunk_buffer_size);
          } else {
            chunk_buffer = await this.fh.slice(addr, addr + node_key.get("chunk_size"));
            let filter_mask = node_key.get("filter_mask");
            chunk_buffer = this._filter_chunk(chunk_buffer, filter_mask, filter_pipeline, item_size);
          }
          var chunk_offset = node_key.get("chunk_offset").slice();
          var apos = chunk_offset.slice();
          var cpos = apos.map(function() {
            return 0;
          });
          var cview = new DataView64(chunk_buffer);
          for (var ci = 0; ci < chunk_size; ci++) {
            for (var d = dims - 1; d >= 0; d--) {
              if (cpos[d] >= chunk_shape[d]) {
                cpos[d] = 0;
                apos[d] = chunk_offset[d];
                if (d > 0) {
                  cpos[d - 1] += 1;
                  apos[d - 1] += 1;
                }
              } else {
                break;
              }
            }
            let inbounds = apos.slice(0, -1).every(function(p, d2) {
              return p < data_shape[d2];
            });
            if (inbounds) {
              let cb_offset = ci * item_size;
              let datum = cview[item_getter](cb_offset, !item_big_endian, item_size);
              let ai = apos.slice(0, -1).reduce(function(prev, curr, index) {
                return curr * data_strides[index] + prev;
              }, 0);
              data[ai] = datum;
            }
            cpos[dims - 1] += 1;
            apos[dims - 1] += 1;
          }
        }
      }
      return data;
    }
    _filter_chunk(chunk_buffer, filter_mask, filter_pipeline, itemsize) {
      let num_filters = filter_pipeline.length;
      let buf = chunk_buffer.slice();
      for (var filter_index = num_filters - 1; filter_index >= 0; filter_index--) {
        if (filter_mask & 1 << filter_index) {
          continue;
        }
        let pipeline_entry = filter_pipeline[filter_index];
        let filter_id = pipeline_entry.get("filter_id");
        let client_data = pipeline_entry.get("client_data");
        if (Filters.has(filter_id)) {
          buf = Filters.get(filter_id)(buf, itemsize, client_data);
        } else {
          throw 'NotImplementedError("Filter with id:' + filter_id.toFixed() + ' not supported")';
        }
      }
      return buf;
    }
  };
  var BTreeV2 = class extends AbstractBTree {
    B_TREE_HEADER = /* @__PURE__ */ new Map([
      ["signature", "4s"],
      ["version", "B"],
      ["node_type", "B"],
      ["node_size", "I"],
      ["record_size", "H"],
      ["depth", "H"],
      ["split_percent", "B"],
      ["merge_percent", "B"],
      ["root_address", "Q"],
      ["root_nrecords", "H"],
      ["total_nrecords", "Q"]
    ]);
    B_LINK_NODE = /* @__PURE__ */ new Map([
      ["signature", "4s"],
      ["version", "B"],
      ["node_type", "B"]
    ]);
    constructor(fh, offset) {
      super(fh, offset);
      this.ready = this.init();
    }
    async _read_root_node() {
      let h = await this._read_tree_header(this.offset);
      this.address_formats = this._calculate_address_formats(h);
      this.header = h;
      this.depth = h.get("depth");
      let address = [h.get("root_address"), h.get("root_nrecords"), h.get("total_nrecords")];
      let root_node = await this._read_node(address, this.depth);
      this._add_node(root_node);
    }
    async _read_tree_header(offset) {
      let header = await _unpack_struct_from_async(this.B_TREE_HEADER, this.fh, this.offset);
      return header;
    }
    _calculate_address_formats(header) {
      let node_size = header.get("node_size");
      let record_size = header.get("record_size");
      let nrecords_max = 0;
      let ntotalrecords_max = 0;
      let address_formats = /* @__PURE__ */ new Map();
      let max_depth = header.get("depth");
      for (var node_level = 0; node_level <= max_depth; node_level++) {
        let offset_fmt = "";
        let num1_fmt = "";
        let num2_fmt = "";
        let offset_size, num1_size, num2_size;
        if (node_level == 0) {
          offset_size = 0;
          num1_size = 0;
          num2_size = 0;
        } else if (node_level == 1) {
          offset_size = 8;
          offset_fmt = "<Q";
          num1_size = this._required_bytes(nrecords_max);
          num1_fmt = this._int_format(num1_size);
          num2_size = 0;
        } else {
          offset_size = 8;
          offset_fmt = "<Q";
          num1_size = this._required_bytes(nrecords_max);
          num1_fmt = this._int_format(num1_size);
          num2_size = this._required_bytes(ntotalrecords_max);
          num2_fmt = this._int_format(num2_size);
        }
        address_formats.set(node_level, [
          offset_size,
          num1_size,
          num2_size,
          offset_fmt,
          num1_fmt,
          num2_fmt
        ]);
        if (node_level < max_depth) {
          let addr_size = offset_size + num1_size + num2_size;
          nrecords_max = this._nrecords_max(node_size, record_size, addr_size);
          if (ntotalrecords_max > 0) {
            ntotalrecords_max *= nrecords_max;
          } else {
            ntotalrecords_max = nrecords_max;
          }
        }
      }
      return address_formats;
    }
    _nrecords_max(node_size, record_size, addr_size) {
      return Math.floor((node_size - 10 - addr_size) / (record_size + addr_size));
    }
    _required_bytes(integer) {
      return Math.ceil(bitSize(integer) / 8);
    }
    _int_format(bytelength) {
      return ["<B", "<H", "<I", "<Q"][bytelength - 1];
    }
    async _read_node(address, node_level) {
      let [offset, nrecords, ntotalrecords] = address;
      let node = this._read_node_header(offset, node_level);
      offset += _structure_size(this.B_LINK_NODE);
      let record_size = this.header.get("record_size");
      let keys = [];
      for (let i = 0; i < nrecords; i++) {
        let record = await this._parse_record(this.fh, offset, record_size);
        offset += record_size;
        keys.push(record);
      }
      let addresses = [];
      let fmts = this.address_formats.get(node_level);
      if (node_level != 0) {
        let [offset_size, num1_size, num2_size, offset_fmt, num1_fmt, num2_fmt] = fmts;
        for (let j = 0; j <= nrecords; j++) {
          let address_offset = (await struct.unpack_from_async(offset_fmt, this.fh, offset))[0];
          offset += offset_size;
          let num1 = (await struct.unpack_from_async(num1_fmt, this.fh, offset))[0];
          offset += num1_size;
          let num2 = num1;
          if (num2_size > 0) {
            num2 = (await struct.unpack_from_async(num2_fmt, this.fh, offset))[0];
            offset += num2_size;
          }
          addresses.push([address_offset, num1, num2]);
        }
      }
      node.set("keys", keys);
      node.set("addresses", addresses);
      return node;
    }
    async _read_node_header(offset, node_level) {
      let node = await _unpack_struct_from_async(this.B_LINK_NODE, this.fh, offset);
      node.set("node_level", node_level);
      return node;
    }
    *iter_records() {
      for (let nodelist of this.all_nodes.values()) {
        for (let node of nodelist) {
          for (let key of node.get("keys")) {
            yield key;
          }
        }
      }
    }
    _parse_record(record) {
      throw "NotImplementedError";
    }
  };
  var BTreeV2GroupNames = class extends BTreeV2 {
    NODE_TYPE = 5;
    async _parse_record(buf, offset, size) {
      let namehash = (await struct.unpack_from_async("<I", buf, offset))[0];
      offset += 4;
      const heapid = await buf.slice(offset, offset + 7);
      return /* @__PURE__ */ new Map([["namehash", namehash], ["heapid", heapid]]);
    }
  };
  var BTreeV2GroupOrders = class extends BTreeV2 {
    NODE_TYPE = 6;
    async _parse_record(buf, offset, size) {
      let creationorder = (await struct.unpack_from_async("<Q", buf, offset))[0];
      offset += 8;
      const heapid = await buf.slice(offset, offset + 7);
      return /* @__PURE__ */ new Map([["creationorder", creationorder], ["heapid", heapid]]);
    }
  };

  // esm/misc-low-level.js
  var SuperBlock = class {
    constructor(fh, offset) {
      this.ready = this.init(fh, offset);
    }
    async init(fh, offset) {
      let version_hint = await struct.unpack_from_async("<B", fh, offset + 8);
      var contents;
      if (version_hint == 0) {
        contents = await _unpack_struct_from_async(SUPERBLOCK_V0, fh, offset);
        this._end_of_sblock = offset + SUPERBLOCK_V0_SIZE;
      } else if (version_hint == 2 || version_hint == 3) {
        contents = await _unpack_struct_from_async(SUPERBLOCK_V2_V3, fh, offset);
        this._end_of_sblock = offset + SUPERBLOCK_V2_V3_SIZE;
      } else {
        throw "unsupported superblock version: " + version_hint.toFixed();
      }
      if (contents.get("format_signature") != FORMAT_SIGNATURE) {
        throw "Incorrect file signature: " + contents.get("format_signature");
      }
      if (contents.get("offset_size") != 8 || contents.get("length_size") != 8) {
        throw "File uses non-64-bit addressing";
      }
      this.version = contents.get("superblock_version");
      this._contents = contents;
      this._root_symbol_table = null;
      this._fh = fh;
    }
    async get_offset_to_dataobjects() {
      if (this.version == 0) {
        var sym_table = new SymbolTable(this._fh, this._end_of_sblock, true);
        await sym_table.ready;
        this._root_symbol_table = sym_table;
        return sym_table.group_offset;
      } else if (this.version == 2 || this.version == 3) {
        return this._contents.get("root_group_address");
      } else {
        throw "Not implemented version = " + this.version.toFixed();
      }
    }
  };
  var Heap = class {
    constructor(fh, offset) {
      this.ready = this.init(fh, offset);
    }
    async init(fh, offset) {
      let local_heap = await _unpack_struct_from_async(LOCAL_HEAP, fh, offset);
      assert(local_heap.get("signature") == "HEAP");
      assert(local_heap.get("version") == 0);
      let data_offset = local_heap.get("address_of_data_segment");
      let heap_data = await fh.slice(data_offset, data_offset + local_heap.get("data_segment_size"));
      local_heap.set("heap_data", heap_data);
      this._contents = local_heap;
      this.data = heap_data;
    }
    get_object_name(offset) {
      let end = new Uint8Array(this.data).indexOf(0, offset);
      let name_size = end - offset;
      let name = struct.unpack_from("<" + name_size.toFixed() + "s", this.data, offset)[0];
      return name;
    }
  };
  var SymbolTable = class {
    constructor(fh, offset, root = false) {
      this.ready = this.init(fh, offset, root);
    }
    async init(fh, offset, root) {
      var node;
      if (root) {
        node = /* @__PURE__ */ new Map([["symbols", 1]]);
      } else {
        node = await _unpack_struct_from_async(SYMBOL_TABLE_NODE, fh, offset);
        if (node.get("signature") != "SNOD") {
          throw "incorrect node type";
        }
        offset += SYMBOL_TABLE_NODE_SIZE;
      }
      var entries = [];
      var n_symbols = node.get("symbols");
      for (var i = 0; i < n_symbols; i++) {
        entries.push(await _unpack_struct_from_async(SYMBOL_TABLE_ENTRY, fh, offset));
        offset += SYMBOL_TABLE_ENTRY_SIZE;
      }
      if (root) {
        this.group_offset = entries[0].get("object_header_address");
      }
      this.entries = entries;
      this._contents = node;
      return this;
    }
    assign_name(heap) {
      this.entries.forEach(function(entry) {
        let offset = entry.get("link_name_offset");
        let link_name = heap.get_object_name(offset);
        entry.set("link_name", link_name);
      });
    }
    get_links(heap) {
      var links = {};
      this.entries.forEach(function(e) {
        let cache_type = e.get("cache_type");
        let link_name = e.get("link_name");
        if (cache_type == 0 || cache_type == 1) {
          links[link_name] = e.get("object_header_address");
        } else if (cache_type == 2) {
          let scratch = e.get("scratch");
          let buf = new ArrayBuffer(4);
          let bufView = new Uint8Array(buf);
          for (var i = 0; i < 4; i++) {
            bufView[i] = scratch.charCodeAt(i);
          }
          let offset = struct.unpack_from("<I", buf, 0)[0];
          links[link_name] = heap.get_object_name(offset);
        }
      });
      return links;
    }
  };
  var GlobalHeap = class {
    constructor(fh, offset) {
      this.ready = this.init(fh, offset);
    }
    async init(fh, offset) {
      let header = await _unpack_struct_from_async(GLOBAL_HEAP_HEADER, fh, offset);
      offset += GLOBAL_HEAP_HEADER_SIZE;
      let heap_data_size = header.get("collection_size") - GLOBAL_HEAP_HEADER_SIZE;
      let heap_data = await fh.slice(offset, offset + heap_data_size);
      this.heap_data = heap_data;
      this._header = header;
      this._objects = null;
    }
    get objects() {
      if (this._objects == null) {
        this._objects = /* @__PURE__ */ new Map();
        var offset = 0;
        while (offset <= this.heap_data.byteLength - GLOBAL_HEAP_OBJECT_SIZE) {
          let info = _unpack_struct_from(GLOBAL_HEAP_OBJECT, this.heap_data, offset);
          if (info.get("object_index") == 0) {
            break;
          }
          offset += GLOBAL_HEAP_OBJECT_SIZE;
          let obj_data = this.heap_data.slice(offset, offset + info.get("object_size"));
          this._objects.set(info.get("object_index"), obj_data);
          offset += _padded_size(info.get("object_size"));
        }
      }
      return this._objects;
    }
  };
  var FractalHeap = class {
    constructor(fh, offset) {
      this.fh = fh;
      this.ready = this.init(offset);
    }
    async init(offset) {
      let header = await _unpack_struct_from_async(FRACTAL_HEAP_HEADER, this.fh, offset);
      offset += _structure_size(FRACTAL_HEAP_HEADER);
      assert(header.get("signature") == "FRHP");
      assert(header.get("version") == 0);
      if (header.get("filter_info_size") > 0) {
        throw "Filter info size not supported on FractalHeap";
      }
      if (header.get("btree_address_huge_objects") == UNDEFINED_ADDRESS) {
        header.set("btree_address_huge_objects", null);
      } else {
        throw "Huge objects not implemented in FractalHeap";
      }
      if (header.get("root_block_address") == UNDEFINED_ADDRESS) {
        header.set("root_block_address", null);
      }
      let nbits = header.get("log2_maximum_heap_size");
      let block_offset_size = this._min_size_nbits(nbits);
      let h = /* @__PURE__ */ new Map([
        ["signature", "4s"],
        ["version", "B"],
        ["heap_header_adddress", "Q"],
        ["block_offset", `${block_offset_size}B`]
      ]);
      this.indirect_block_header = new Map(h);
      this.indirect_block_header_size = _structure_size(h);
      if ((header.get("flags") & 2) == 2) {
        h.set("checksum", "I");
      }
      this.direct_block_header = h;
      this.direct_block_header_size = _structure_size(h);
      let maximum_dblock_size = header.get("maximum_direct_block_size");
      this._managed_object_offset_size = this._min_size_nbits(nbits);
      let value = Math.min(maximum_dblock_size, header.get("max_managed_object_size"));
      this._managed_object_length_size = this._min_size_integer(value);
      let start_block_size = header.get("starting_block_size");
      let table_width = header.get("table_width");
      if (!(start_block_size > 0)) {
        throw "Starting block size == 0 not implemented";
      }
      let log2_maximum_dblock_size = Number(Math.floor(Math.log2(maximum_dblock_size)));
      assert(1n << BigInt(log2_maximum_dblock_size) == maximum_dblock_size);
      let log2_start_block_size = Number(Math.floor(Math.log2(start_block_size)));
      assert(1n << BigInt(log2_start_block_size) == start_block_size);
      this._max_direct_nrows = log2_maximum_dblock_size - log2_start_block_size + 2;
      let log2_table_width = Math.floor(Math.log2(table_width));
      assert(1 << log2_table_width == table_width);
      this._indirect_nrows_sub = log2_table_width + log2_start_block_size - 1;
      this.header = header;
      this.nobjects = header.get("managed_object_count") + header.get("huge_object_count") + header.get("tiny_object_count");
      let managed = [];
      let root_address = header.get("root_block_address");
      let nrows = 0;
      if (root_address != null) {
        nrows = header.get("indirect_current_rows_count");
      }
      if (nrows > 0) {
        for await (let data of this._iter_indirect_block(this.fh, root_address, nrows)) {
          managed.push(data);
        }
      } else {
        let data = await this._read_direct_block(this.fh, root_address, start_block_size);
        managed.push(data);
      }
      let data_size = managed.reduce((p, c) => p + c.byteLength, 0);
      let combined = new Uint8Array(data_size);
      let moffset = 0;
      managed.forEach((m) => {
        combined.set(new Uint8Array(m), moffset);
        moffset += m.byteLength;
      });
      this.managed = combined.buffer;
    }
    async _read_direct_block(fh, offset, block_size) {
      let data = await fh.slice(offset, offset + block_size);
      let header = _unpack_struct_from(this.direct_block_header, data);
      assert(header.get("signature") == "FHDB");
      return data;
    }
    get_data(heapid) {
      let firstbyte = struct.unpack_from("<B", heapid, 0)[0];
      let idtype = firstbyte >> 4 & 3;
      let version = firstbyte >> 6;
      let data_offset = 1;
      if (idtype == 0) {
        assert(version == 0);
        let nbytes = this._managed_object_offset_size;
        let offset = _unpack_integer(nbytes, heapid, data_offset);
        data_offset += nbytes;
        nbytes = this._managed_object_length_size;
        let size = _unpack_integer(nbytes, heapid, data_offset);
        return this.managed.slice(offset, offset + size);
      } else if (idtype == 1) {
        throw "tiny objectID not supported in FractalHeap";
      } else if (idtype == 2) {
        throw "huge objectID not supported in FractalHeap";
      } else {
        throw "unknown objectID type in FractalHeap";
      }
    }
    _min_size_integer(integer) {
      return this._min_size_nbits(bitSize(integer));
    }
    _min_size_nbits(nbits) {
      return Math.ceil(nbits / 8);
    }
    async *_iter_indirect_block(fh, offset, nrows) {
      let header = await _unpack_struct_from_async(this.indirect_block_header, fh, offset);
      offset += this.indirect_block_header_size;
      assert(header.get("signature") == "FHIB");
      let block_offset_bytes = header.get("block_offset");
      let block_offset = block_offset_bytes.reduce((p, c, i) => p + (c << i * 8), 0);
      header.set("block_offset", block_offset);
      let [ndirect, nindirect] = this._indirect_info(nrows);
      let direct_blocks = [];
      for (let i = 0; i < ndirect; i++) {
        let address = (await struct.unpack_from_async("<Q", fh, offset))[0];
        offset += 8;
        if (address == UNDEFINED_ADDRESS) {
          break;
        }
        let block_size = this._calc_block_size(i);
        direct_blocks.push([address, block_size]);
      }
      let indirect_blocks = [];
      for (let i = ndirect; i < ndirect + nindirect; i++) {
        let address = (await struct.unpack_from_async("<Q", fh, offset))[0];
        offset += 8;
        if (address == UNDEFINED_ADDRESS) {
          break;
        }
        let block_size = this._calc_block_size(i);
        let nrows2 = this._iblock_nrows_from_block_size(block_size);
        indirect_blocks.push([address, nrows2]);
      }
      for (let [address, block_size] of direct_blocks) {
        let obj = await this._read_direct_block(fh, address, block_size);
        yield obj;
      }
      for (let [address, nrows2] of indirect_blocks) {
        for await (let obj of this._iter_indirect_block(fh, address, nrows2)) {
          yield obj;
        }
      }
    }
    _calc_block_size(iblock) {
      let row = Math.floor(iblock / this.header.get("table_width"));
      return 2 ** Math.max(row - 1, 0) * this.header.get("starting_block_size");
    }
    _iblock_nrows_from_block_size(block_size) {
      let log2_block_size = Math.floor(Math.log2(block_size));
      assert(2 ** log2_block_size == block_size);
      return log2_block_size - this._indirect_nrows_sub;
    }
    _indirect_info(nrows) {
      let table_width = this.header.get("table_width");
      let nobjects = nrows * table_width;
      let ndirect_max = this._max_direct_nrows * table_width;
      let ndirect, nindirect;
      if (nrows <= ndirect_max) {
        ndirect = nobjects;
        nindirect = 0;
      } else {
        ndirect = ndirect_max;
        nindirect = nobjects - ndirect_max;
      }
      return [ndirect, nindirect];
    }
    _int_format(bytelength) {
      return ["B", "H", "I", "Q"][bytelength - 1];
    }
  };
  var FORMAT_SIGNATURE = struct.unpack_from("8s", new Uint8Array([137, 72, 68, 70, 13, 10, 26, 10]).buffer)[0];
  var UNDEFINED_ADDRESS = struct.unpack_from("<Q", new Uint8Array([255, 255, 255, 255, 255, 255, 255, 255]).buffer)[0];
  var SUPERBLOCK_V0 = /* @__PURE__ */ new Map([
    ["format_signature", "8s"],
    ["superblock_version", "B"],
    ["free_storage_version", "B"],
    ["root_group_version", "B"],
    ["reserved_0", "B"],
    ["shared_header_version", "B"],
    ["offset_size", "B"],
    ["length_size", "B"],
    ["reserved_1", "B"],
    ["group_leaf_node_k", "H"],
    ["group_internal_node_k", "H"],
    ["file_consistency_flags", "L"],
    ["base_address_lower", "Q"],
    ["free_space_address", "Q"],
    ["end_of_file_address", "Q"],
    ["driver_information_address", "Q"]
  ]);
  var SUPERBLOCK_V0_SIZE = _structure_size(SUPERBLOCK_V0);
  var SUPERBLOCK_V2_V3 = /* @__PURE__ */ new Map([
    ["format_signature", "8s"],
    ["superblock_version", "B"],
    ["offset_size", "B"],
    ["length_size", "B"],
    ["file_consistency_flags", "B"],
    ["base_address", "Q"],
    ["superblock_extension_address", "Q"],
    ["end_of_file_address", "Q"],
    ["root_group_address", "Q"],
    ["superblock_checksum", "I"]
  ]);
  var SUPERBLOCK_V2_V3_SIZE = _structure_size(SUPERBLOCK_V2_V3);
  var SYMBOL_TABLE_ENTRY = /* @__PURE__ */ new Map([
    ["link_name_offset", "Q"],
    ["object_header_address", "Q"],
    ["cache_type", "I"],
    ["reserved", "I"],
    ["scratch", "16s"]
  ]);
  var SYMBOL_TABLE_ENTRY_SIZE = _structure_size(SYMBOL_TABLE_ENTRY);
  var SYMBOL_TABLE_NODE = /* @__PURE__ */ new Map([
    ["signature", "4s"],
    ["version", "B"],
    ["reserved_0", "B"],
    ["symbols", "H"]
  ]);
  var SYMBOL_TABLE_NODE_SIZE = _structure_size(SYMBOL_TABLE_NODE);
  var LOCAL_HEAP = /* @__PURE__ */ new Map([
    ["signature", "4s"],
    ["version", "B"],
    ["reserved", "3s"],
    ["data_segment_size", "Q"],
    ["offset_to_free_list", "Q"],
    ["address_of_data_segment", "Q"]
  ]);
  var GLOBAL_HEAP_HEADER = /* @__PURE__ */ new Map([
    ["signature", "4s"],
    ["version", "B"],
    ["reserved", "3s"],
    ["collection_size", "Q"]
  ]);
  var GLOBAL_HEAP_HEADER_SIZE = _structure_size(GLOBAL_HEAP_HEADER);
  var GLOBAL_HEAP_OBJECT = /* @__PURE__ */ new Map([
    ["object_index", "H"],
    ["reference_count", "H"],
    ["reserved", "I"],
    ["object_size", "Q"]
  ]);
  var GLOBAL_HEAP_OBJECT_SIZE = _structure_size(GLOBAL_HEAP_OBJECT);
  var FRACTAL_HEAP_HEADER = /* @__PURE__ */ new Map([
    ["signature", "4s"],
    ["version", "B"],
    ["object_index_size", "H"],
    ["filter_info_size", "H"],
    ["flags", "B"],
    ["max_managed_object_size", "I"],
    ["next_huge_object_index", "Q"],
    ["btree_address_huge_objects", "Q"],
    ["managed_freespace_size", "Q"],
    ["freespace_manager_address", "Q"],
    ["managed_space_size", "Q"],
    ["managed_alloc_size", "Q"],
    ["next_directblock_iterator_address", "Q"],
    ["managed_object_count", "Q"],
    ["huge_objects_total_size", "Q"],
    ["huge_object_count", "Q"],
    ["tiny_objects_total_size", "Q"],
    ["tiny_object_count", "Q"],
    ["table_width", "H"],
    ["starting_block_size", "Q"],
    ["maximum_direct_block_size", "Q"],
    ["log2_maximum_heap_size", "H"],
    ["indirect_starting_rows_count", "H"],
    ["root_block_address", "Q"],
    ["indirect_current_rows_count", "H"]
  ]);

  // esm/dataobjects.js
  var DataObjects = class {
    constructor(fh, offset) {
      this.ready = this.init(fh, offset);
    }
    async init(fh, offset) {
      let version_hint = (await struct.unpack_from_async("<B", fh, offset))[0];
      if (version_hint == 1) {
        var [msgs, msg_data, header] = await this._parse_v1_objects(fh, offset);
      } else if (version_hint == "O".charCodeAt(0)) {
        var [msgs, msg_data, header] = await this._parse_v2_objects(fh, offset);
      } else {
        throw "InvalidHDF5File('unknown Data Object Header')";
      }
      this.fh = fh;
      this.msgs = msgs;
      this.msg_data = msg_data;
      this.offset = offset;
      this._global_heaps = {};
      this._header = header;
      this._filter_pipeline = null;
      this._chunk_params_set = false;
      this._chunks = null;
      this._chunk_dims = null;
      this._chunk_address = null;
    }
    get dtype() {
      let msg = this.find_msg_type(DATATYPE_MSG_TYPE)[0];
      let msg_offset = msg.get("offset_to_message");
      return new DatatypeMessage(this.fh, msg_offset).dtype;
    }
    get chunks() {
      return this._get_chunk_params().then(() => {
        return this._chunks;
      });
    }
    get shape() {
      let msg = this.find_msg_type(DATASPACE_MSG_TYPE)[0];
      let msg_offset = msg.get("offset_to_message");
      return determine_data_shape(this.fh, msg_offset);
    }
    async get_filter_pipeline() {
      if (this._filter_pipeline != null) {
        return this._filter_pipeline;
      }
      let filter_msgs = this.find_msg_type(DATA_STORAGE_FILTER_PIPELINE_MSG_TYPE);
      if (!filter_msgs.length) {
        this._filter_pipeline = null;
        return this._filter_pipeline;
      }
      var offset = filter_msgs[0].get("offset_to_message");
      let [version, nfilters] = await struct.unpack_from_async("<BB", this.fh, offset);
      offset += struct.calcsize("<BB");
      var filters = [];
      if (version == 1) {
        await struct.unpack_from_async("<HI", this.fh, offset);
        offset += struct.calcsize("<HI");
        for (var _ = 0; _ < nfilters; _++) {
          let filter_info = await _unpack_struct_from_async(FILTER_PIPELINE_DESCR_V1, this.fh, offset);
          offset += FILTER_PIPELINE_DESCR_V1_SIZE;
          let padded_name_length = _padded_size(filter_info.get("name_length"), 8);
          let fmt = "<" + padded_name_length.toFixed() + "s";
          let filter_name = (await struct.unpack_from_async(fmt, this.fh, offset))[0];
          filter_info.set("filter_name", filter_name);
          offset += padded_name_length;
          fmt = "<" + filter_info.get("client_data_values").toFixed() + "I";
          let client_data = await struct.unpack_from_async(fmt, this.fh, offset);
          filter_info.set("client_data", client_data);
          offset += 4 * filter_info.get("client_data_values");
          if (filter_info.get("client_data_values") % 2) {
            offset += 4;
          }
          filters.push(filter_info);
        }
      } else if (version == 2) {
        for (let nf = 0; nf < nfilters; nf++) {
          let filter_info = /* @__PURE__ */ new Map();
          let buf = this.fh;
          let filter_id = (await struct.unpack_from_async("<H", buf, offset))[0];
          offset += 2;
          filter_info.set("filter_id", filter_id);
          let name_length = 0;
          if (filter_id > 255) {
            name_length = (await struct.unpack_from_async("<H", buf, offset))[0];
            offset += 2;
          }
          let flags = (await struct.unpack_from_async("<H", buf, offset))[0];
          offset += 2;
          let optional = (flags & 1) > 0;
          filter_info.set("optional", optional);
          let num_client_values = (await struct.unpack_from_async("<H", buf, offset))[0];
          offset += 2;
          let name;
          if (name_length > 0) {
            name = (await struct.unpack_from_async(`${name_length}s`, buf, offset))[0];
            offset += name_length;
          }
          filter_info.set("name", name);
          let client_values = await struct.unpack_from_async(`<${num_client_values}i`, buf, offset);
          offset += 4 * num_client_values;
          filter_info.set("client_data_values", client_values);
          filters.push(filter_info);
        }
      } else {
        throw `version ${version} is not supported`;
      }
      this._filter_pipeline = filters;
      return this._filter_pipeline;
    }
    find_msg_type(msg_type) {
      return this.msgs.filter(function(m) {
        return m.get("type") == msg_type;
      });
    }
    async get_attributes() {
      let attrs = {};
      let attr_msgs = this.find_msg_type(ATTRIBUTE_MSG_TYPE);
      for (let msg of attr_msgs) {
        let offset = msg.get("offset_to_message");
        let [name, value] = await this.unpack_attribute(offset);
        attrs[name] = value;
      }
      return attrs;
    }
    async get_fillvalue() {
      let msg = this.find_msg_type(FILLVALUE_MSG_TYPE)[0];
      var offset = msg.get("offset_to_message");
      var is_defined;
      let version = (await struct.unpack_from_async("<B", this.fh, offset))[0];
      var info, size, fillvalue;
      if (version == 1 || version == 2) {
        info = await _unpack_struct_from_async(FILLVAL_MSG_V1V2, this.fh, offset);
        offset += FILLVAL_MSG_V1V2_SIZE;
        is_defined = info.get("fillvalue_defined");
      } else if (version == 3) {
        info = await _unpack_struct_from_async(FILLVAL_MSG_V3, this.fh, offset);
        offset += FILLVAL_MSG_V3_SIZE;
        is_defined = info.get("flags") & 32;
      } else {
        throw 'InvalidHDF5File("Unknown fillvalue msg version: "' + String(version);
      }
      if (is_defined) {
        size = (await struct.unpack_from_async("<I", this.fh, offset))[0];
        offset += 4;
      } else {
        size = 0;
      }
      if (size) {
        let [getter, big_endian, size2] = dtype_getter(await this.dtype);
        let payload_view = new DataView64(await this.fh.slice(offset, offset + size2));
        fillvalue = payload_view[getter](offset, !big_endian, size2);
      } else {
        fillvalue = 0;
      }
      return fillvalue;
    }
    async unpack_attribute(offset) {
      let version = (await struct.unpack_from_async("<B", this.fh, offset))[0];
      var attr_map, padding_multiple;
      if (version == 1) {
        attr_map = await _unpack_struct_from_async(ATTR_MSG_HEADER_V1, this.fh, offset);
        assert(attr_map.get("version") == 1);
        offset += ATTR_MSG_HEADER_V1_SIZE;
        padding_multiple = 8;
      } else if (version == 3) {
        attr_map = await _unpack_struct_from_async(ATTR_MSG_HEADER_V3, this.fh, offset);
        assert(attr_map.get("version") == 3);
        offset += ATTR_MSG_HEADER_V3_SIZE;
        padding_multiple = 1;
      } else {
        throw "unsupported attribute message version: " + version;
      }
      let name_size = attr_map.get("name_size");
      let name = (await struct.unpack_from_async("<" + name_size.toFixed() + "s", this.fh, offset))[0];
      name = name.replace(/\x00$/, "");
      offset += _padded_size(name_size, padding_multiple);
      var dtype;
      try {
        dtype = await new DatatypeMessage(this.fh, offset).dtype;
      } catch (e) {
        console.warn("Attribute " + name + " type not implemented, set to null.");
        return [name, null];
      }
      offset += _padded_size(attr_map.get("datatype_size"), padding_multiple);
      let shape = await this.determine_data_shape(this.fh, offset);
      let items = shape.reduce(function(a, b) {
        return a * b;
      }, 1);
      offset += _padded_size(attr_map.get("dataspace_size"), padding_multiple);
      if (dtype.datatype_class === 5) {
        value = await this.fh.slice(offset, offset + dtype.size);
      } else {
        var value = await this._attr_value(dtype, this.fh, items, offset);
        if (shape.length == 0) {
          value = value[0];
        }
      }
      return [name, value];
    }
    async determine_data_shape(buf, offset) {
      let version = (await struct.unpack_from_async("<B", buf, offset))[0];
      var header;
      if (version == 1) {
        header = await _unpack_struct_from_async(DATASPACE_MSG_HEADER_V1, buf, offset);
        assert(header.get("version") == 1);
        offset += DATASPACE_MSG_HEADER_V1_SIZE;
      } else if (version == 2) {
        header = await _unpack_struct_from_async(DATASPACE_MSG_HEADER_V2, buf, offset);
        assert(header.get("version") == 2);
        offset += DATASPACE_MSG_HEADER_V2_SIZE;
      } else {
        throw "unknown dataspace message version";
      }
      let ndims = header.get("dimensionality");
      let dim_sizes = await struct.unpack_from_async("<" + ndims.toFixed() + "Q", buf, offset);
      return dim_sizes;
    }
    async _attr_value(dtype, buf, count, offset) {
      var value = new Array(count);
      if (dtype instanceof Array) {
        let dtype_class = dtype[0];
        for (var i = 0; i < count; i++) {
          if (dtype_class == "VLEN_STRING") {
            let character_set = dtype[2];
            var [vlen, vlen_data] = await this._vlen_size_and_data(buf, offset);
            const encoding = character_set == 0 ? "ascii" : "utf-8";
            const decoder = new TextDecoder(encoding);
            value[i] = decoder.decode(vlen_data);
            offset += 16;
          } else if (dtype_class == "REFERENCE") {
            var address = await struct.unpack_from_async("<Q", buf, offset);
            value[i] = address;
            offset += 8;
          } else if (dtype_class == "VLEN_SEQUENCE") {
            let base_dtype = dtype[1];
            var [vlen, vlen_data] = this._vlen_size_and_data(buf, offset);
            value[i] = this._attr_value(base_dtype, vlen_data, vlen, 0);
            offset += 16;
          } else {
            throw "NotImplementedError";
          }
        }
      } else {
        let [getter, big_endian, size] = dtype_getter(dtype);
        const arrayBuffer = await buf.slice(offset, offset + count * size);
        let view = new DataView64(arrayBuffer, 0);
        let bufferOffset = 0;
        for (var i = 0; i < count; i++) {
          value[i] = view[getter](bufferOffset, !big_endian, size);
          bufferOffset += size;
        }
      }
      return value;
    }
    async _vlen_size_and_data(buf, offset) {
      let vlen_size = (await struct.unpack_from_async("<I", buf, offset))[0];
      let gheap_id = await _unpack_struct_from_async(GLOBAL_HEAP_ID, buf, offset + 4);
      let gheap_address = gheap_id.get("collection_address");
      assert(gheap_id.get("collection_address") < Number.MAX_SAFE_INTEGER);
      var gheap;
      if (!(gheap_address in this._global_heaps)) {
        gheap = new GlobalHeap(this.fh, gheap_address);
        await gheap.ready;
        this._global_heaps[gheap_address] = gheap;
      }
      gheap = this._global_heaps[gheap_address];
      let vlen_data = gheap.objects.get(gheap_id.get("object_index"));
      return [vlen_size, vlen_data];
    }
    async _parse_v1_objects(fh, offset) {
      let header = await _unpack_struct_from_async(OBJECT_HEADER_V1, fh, offset);
      assert(header.get("version") == 1);
      let total_header_messages = header.get("total_header_messages");
      var block_size = header.get("object_header_size");
      var block_offset = offset + _structure_size(OBJECT_HEADER_V1);
      var msg_data = await fh.slice(block_offset, block_offset + block_size);
      var object_header_blocks = [[block_offset, block_size]];
      var current_block = 0;
      var local_offset = 0;
      var msgs = new Array(total_header_messages);
      for (var i = 0; i < total_header_messages; i++) {
        if (local_offset >= block_size) {
          [block_offset, block_size] = object_header_blocks[++current_block];
          local_offset = 0;
        }
        let msg = await _unpack_struct_from_async(HEADER_MSG_INFO_V1, fh, block_offset + local_offset);
        let offset_to_message = block_offset + local_offset + HEADER_MSG_INFO_V1_SIZE;
        msg.set("offset_to_message", offset_to_message);
        if (msg.get("type") == OBJECT_CONTINUATION_MSG_TYPE) {
          var [fh_off, size] = await struct.unpack_from_async("<QQ", fh, offset_to_message);
          object_header_blocks.push([fh_off, size]);
        }
        local_offset += HEADER_MSG_INFO_V1_SIZE + msg.get("size");
        msgs[i] = msg;
      }
      return [msgs, msg_data, header];
    }
    async _parse_v2_objects(buf, offset) {
      var [header, creation_order_size, block_offset] = await this._parse_v2_header(buf, offset);
      offset = block_offset;
      var msgs = [];
      var block_size = header.get("size_of_chunk_0");
      var msg_data = buf.slice(offset, offset += block_size);
      var object_header_blocks = [[block_offset, block_size]];
      var current_block = 0;
      var local_offset = 0;
      while (true) {
        if (local_offset >= block_size - HEADER_MSG_INFO_V2_SIZE) {
          let next_block = object_header_blocks[++current_block];
          if (next_block == null) {
            break;
          }
          [block_offset, block_size] = next_block;
          local_offset = 0;
        }
        let msg = await _unpack_struct_from_async(HEADER_MSG_INFO_V2, buf, block_offset + local_offset);
        let offset_to_message = block_offset + local_offset + HEADER_MSG_INFO_V2_SIZE + creation_order_size;
        msg.set("offset_to_message", offset_to_message);
        if (msg.get("type") == OBJECT_CONTINUATION_MSG_TYPE) {
          var [fh_off, size] = await struct.unpack_from_async("<QQ", buf, offset_to_message);
          object_header_blocks.push([fh_off + 4, size - 4]);
        }
        local_offset += HEADER_MSG_INFO_V2_SIZE + msg.get("size") + creation_order_size;
        msgs.push(msg);
      }
      return [msgs, msg_data, header];
    }
    async _parse_v2_header(buf, offset) {
      let header = await _unpack_struct_from_async(OBJECT_HEADER_V2, buf, offset);
      var creation_order_size;
      offset += _structure_size(OBJECT_HEADER_V2);
      assert(header.get("version") == 2);
      if (header.get("flags") & 4) {
        creation_order_size = 2;
      } else {
        creation_order_size = 0;
      }
      assert((header.get("flags") & 16) == 0);
      if (header.get("flags") & 32) {
        let times = await struct.unpack_from_async("<4I", buf, offset);
        offset += 16;
        header.set("access_time", times[0]);
        header.set("modification_time", times[1]);
        header.set("change_time", times[2]);
        header.set("birth_time", times[3]);
      }
      let chunk_fmt = ["<B", "<H", "<I", "<Q"][header.get("flags") & 3];
      header.set("size_of_chunk_0", (await struct.unpack_from_async(chunk_fmt, buf, offset))[0]);
      offset += struct.calcsize(chunk_fmt);
      return [header, creation_order_size, offset];
    }
    async find_link(name) {
      if (this._links) {
        for (link of this._links) {
          if (name === link[0]) {
            return link;
          }
        }
      } else {
        const links = [];
        for await (const link2 of this.iter_links()) {
          if (name === link2[0]) {
            return link2;
          }
          links.push(link2);
        }
        this._links = links;
      }
      return void 0;
    }
    async get_links() {
      const links = [];
      for await (const link2 of this.iter_links()) {
        links.push(link2);
      }
      return Object.fromEntries(links);
    }
    async *iter_links() {
      for (let msg of this.msgs) {
        if (msg.get("type") == SYMBOL_TABLE_MSG_TYPE) {
          yield* this._iter_links_from_symbol_tables(msg);
        } else if (msg.get("type") == LINK_MSG_TYPE) {
          yield this._get_link_from_link_msg(msg);
        } else if (msg.get("type") == LINK_INFO_MSG_TYPE) {
          yield* this._iter_link_from_link_info_msg(msg);
        }
      }
    }
    async *_iter_links_from_symbol_tables(sym_tbl_msg) {
      assert(sym_tbl_msg.get("size") == 16);
      let data = await _unpack_struct_from_async(SYMBOL_TABLE_MSG, this.fh, sym_tbl_msg.get("offset_to_message"));
      yield* this._iter_links_btree_v1(data.get("btree_address"), data.get("heap_address"));
    }
    async *_iter_links_btree_v1(btree_address, heap_address) {
      let btree = new BTreeV1Groups(this.fh, btree_address);
      await btree.ready;
      let heap = new Heap(this.fh, heap_address);
      await heap.ready;
      for (let symbol_table_address of btree.symbol_table_addresses()) {
        let table = new SymbolTable(this.fh, symbol_table_address);
        await table.ready;
        table.assign_name(heap);
        yield* Object.entries(table.get_links(heap));
      }
    }
    async _get_link_from_link_msg(link_msg) {
      let offset = link_msg.get("offset_to_message");
      return await this._decode_link_msg(this.fh, offset)[1];
    }
    async _decode_link_msg(data, offset) {
      let [version, flags] = await struct.unpack_from_async("<BB", data, offset);
      offset += 2;
      assert(version == 1);
      let size_of_length_of_link_name = 2 ** (flags & 3);
      let link_type_field_present = (flags & 2 ** 3) > 0;
      let link_name_character_set_field_present = (flags & 2 ** 4) > 0;
      let ordered = (flags & 2 ** 2) > 0;
      let link_type;
      if (link_type_field_present) {
        link_type = (await struct.unpack_from_async("<B", data, offset))[0];
        offset += 1;
      } else {
        link_type = 0;
      }
      assert([0, 1].includes(link_type));
      let creationorder;
      if (ordered) {
        creationorder = (await struct.unpack_from_async("<Q", data, offset))[0];
        offset += 8;
      }
      let link_name_character_set = 0;
      if (link_name_character_set_field_present) {
        link_name_character_set = (await struct.unpack_from_async("<B", data, offset))[0];
        offset += 1;
      }
      let encoding = link_name_character_set == 0 ? "ascii" : "utf-8";
      let name_size_fmt = ["<B", "<H", "<I", "<Q"][flags & 3];
      let name_size = (await struct.unpack_from_async(name_size_fmt, data, offset))[0];
      offset += size_of_length_of_link_name;
      let name = new TextDecoder(encoding).decode(await data.slice(offset, offset + name_size));
      offset += name_size;
      let address;
      if (link_type == 0) {
        address = (await struct.unpack_from_async("<Q", data, offset))[0];
      } else if (link_type == 1) {
        let length_of_soft_link_value = (await struct.unpack_from_async("<H", data, offset))[0];
        offset += 2;
        address = new TextDecoder(encoding).decode(await data.slice(offset, offset + length_of_soft_link_value));
      }
      return [creationorder, [name, address]];
    }
    async *_iter_link_from_link_info_msg(info_msg) {
      let offset = info_msg.get("offset_to_message");
      let data = await this._decode_link_info_msg(this.fh, offset);
      let heap_address = data.get("heap_address");
      let name_btree_address = data.get("name_btree_address");
      let order_btree_address = data.get("order_btree_address");
      if (name_btree_address != null) {
        yield* this._iter_links_btree_v2(name_btree_address, order_btree_address, heap_address);
      }
    }
    async *_iter_links_btree_v2(name_btree_address, order_btree_address, heap_address) {
      let heap = new FractalHeap(this.fh, heap_address);
      await heap.ready;
      let btree;
      const ordered = order_btree_address != null;
      if (ordered) {
        btree = new BTreeV2GroupOrders(this.fh, order_btree_address);
        await btree.ready;
      } else {
        btree = new BTreeV2GroupNames(this.fh, name_btree_address);
        await btree.ready;
      }
      let items = /* @__PURE__ */ new Map();
      for (let record of btree.iter_records()) {
        let data = heap.get_data(record.get("heapid"));
        let [creationorder, item] = await this._decode_link_msg(data, 0);
        const key = ordered ? creationorder : item[0];
        items.set(key, item);
      }
      let sorted_keys = Array.from(items.keys()).sort();
      for (let key of sorted_keys) {
        yield items.get(key);
      }
    }
    async _decode_link_info_msg(data, offset) {
      let [version, flags] = await struct.unpack_from_async("<BB", data, offset);
      assert(version == 0);
      offset += 2;
      if ((flags & 1) > 0) {
        offset += 8;
      }
      let fmt = (flags & 2) > 0 ? LINK_INFO_MSG2 : LINK_INFO_MSG1;
      let link_info = await _unpack_struct_from_async(fmt, data, offset);
      let output = /* @__PURE__ */ new Map();
      for (let [k, v] of link_info.entries()) {
        output.set(k, v == UNDEFINED_ADDRESS2 ? null : v);
      }
      return output;
    }
    get is_dataset() {
      return this.find_msg_type(DATASPACE_MSG_TYPE).length > 0;
    }
    async get_data() {
      let msg = this.find_msg_type(DATA_STORAGE_MSG_TYPE)[0];
      let msg_offset = msg.get("offset_to_message");
      var [version, dims, layout_class, property_offset] = await this._get_data_message_properties(msg_offset);
      if (layout_class == 0) {
        throw "Compact storage of DataObject not implemented";
      } else if (layout_class == 1) {
        return this._get_contiguous_data(property_offset);
      } else if (layout_class == 2) {
        return this._get_chunked_data(msg_offset);
      }
    }
    async _get_data_message_properties(msg_offset) {
      let dims, layout_class, property_offset;
      let [version, arg1, arg2] = await struct.unpack_from_async("<BBB", this.fh, msg_offset);
      if (version == 1 || version == 2) {
        dims = arg1;
        layout_class = arg2;
        property_offset = msg_offset;
        property_offset += struct.calcsize("<BBB");
        property_offset += struct.calcsize("<BI");
        assert(layout_class == 1 || layout_class == 2);
      } else if (version == 3 || version == 4) {
        layout_class = arg1;
        property_offset = msg_offset;
        property_offset += struct.calcsize("<BB");
      }
      assert(version >= 1 && version <= 4);
      return [version, dims, layout_class, property_offset];
    }
    async _get_contiguous_data(property_offset) {
      let [data_offset] = await struct.unpack_from_async("<Q", this.fh, property_offset);
      const shape = await this.shape;
      const dtype = await this.dtype;
      if (data_offset == UNDEFINED_ADDRESS2) {
        let size = shape.reduce(function(a, b) {
          return a * b;
        }, 1);
        return new Array(size);
      }
      var fullsize = shape.reduce(function(a, b) {
        return a * b;
      }, 1);
      if (!(dtype instanceof Array)) {
        if (/[<>=!@\|]?(i|u|f|S)(\d*)/.test(dtype)) {
          let [item_getter, item_is_big_endian, item_size] = dtype_getter(dtype);
          let output = new Array(fullsize);
          const local_buffer = await this.fh.slice(data_offset, data_offset + item_size * fullsize);
          let view = new DataView64(local_buffer);
          for (var i = 0; i < fullsize; i++) {
            output[i] = view[item_getter](i * item_size, !item_is_big_endian, item_size);
          }
          return output;
        } else if (dtype.datatype_class === 5) {
          return this.fh.slice(data_offset, data_offset + dtype.size);
        } else {
          throw "not Implemented - no proper dtype defined";
        }
      } else {
        let dtype_class = dtype[0];
        if (dtype_class == "REFERENCE") {
          let size = dtype[1];
          if (size != 8) {
            throw "NotImplementedError('Unsupported Reference type')";
          }
          let ref_addresses = await this.fh.slice(data_offset, data_offset + fullsize);
          return ref_addresses;
        } else if (dtype_class == "VLEN_STRING") {
          let character_set = dtype[2];
          const encoding = character_set == 0 ? "ascii" : "utf-8";
          const decoder = new TextDecoder(encoding);
          var value = [];
          for (var i = 0; i < fullsize; i++) {
            const [vlen, vlen_data] = await this._vlen_size_and_data(this.fh, data_offset);
            value[i] = decoder.decode(vlen_data);
            data_offset += 16;
          }
          return value;
        } else {
          throw "NotImplementedError('datatype not implemented')";
        }
      }
    }
    async _get_chunked_data(offset) {
      await this._get_chunk_params();
      if (this._chunk_address == UNDEFINED_ADDRESS2) {
        return [];
      }
      var chunk_btree = new BTreeV1RawDataChunks(this.fh, this._chunk_address, this._chunk_dims);
      await chunk_btree.ready;
      const dtype = await this.dtype;
      const shape = await this.shape;
      const chunks = await this.chunks;
      const filter_pipeline = await this.get_filter_pipeline();
      let data = await chunk_btree.construct_data_from_chunks(chunks, shape, dtype, filter_pipeline);
      if (dtype instanceof Array && /^VLEN/.test(dtype[0])) {
        let dtype_class = dtype[0];
        for (var i = 0; i < data.length; i++) {
          let [item_size, gheap_address, object_index] = data[i];
          var gheap;
          if (!(gheap_address in this._global_heaps)) {
            gheap = new GlobalHeap(this.fh, gheap_address);
            await gheap.ready;
            this._global_heaps[gheap_address] = gheap;
          } else {
            gheap = this._global_heaps[gheap_address];
          }
          let vlen_data = gheap.objects.get(object_index);
          if (dtype_class == "VLEN_STRING") {
            let character_set = dtype[2];
            const encoding = character_set == 0 ? "ascii" : "utf-8";
            const decoder = new TextDecoder(encoding);
            data[i] = decoder.decode(vlen_data);
          }
        }
      }
      return data;
    }
    async _get_chunk_params() {
      if (this._chunk_params_set) {
        return;
      }
      this._chunk_params_set = true;
      var msg = this.find_msg_type(DATA_STORAGE_MSG_TYPE)[0];
      var offset = msg.get("offset_to_message");
      var [version, dims, layout_class, property_offset] = await this._get_data_message_properties(offset);
      if (layout_class != 2) {
        return;
      }
      var data_offset;
      if (version == 1 || version == 2) {
        var address = (await struct.unpack_from_async("<Q", this.fh, property_offset))[0];
        data_offset = property_offset + struct.calcsize("<Q");
      } else if (version == 3) {
        var [dims, address] = await struct.unpack_from_async("<BQ", this.fh, property_offset);
        data_offset = property_offset + struct.calcsize("<BQ");
      }
      assert(version >= 1 && version <= 3);
      var fmt = "<" + (dims - 1).toFixed() + "I";
      var chunk_shape = await struct.unpack_from_async(fmt, this.fh, data_offset);
      this._chunks = chunk_shape;
      this._chunk_dims = dims;
      this._chunk_address = address;
      return;
    }
  };
  async function determine_data_shape(buf, offset) {
    let version = (await struct.unpack_from_async("<B", buf, offset))[0];
    var header;
    if (version == 1) {
      header = await _unpack_struct_from_async(DATASPACE_MSG_HEADER_V1, buf, offset);
      assert(header.get("version") == 1);
      offset += DATASPACE_MSG_HEADER_V1_SIZE;
    } else if (version == 2) {
      header = await _unpack_struct_from_async(DATASPACE_MSG_HEADER_V2, buf, offset);
      assert(header.get("version") == 2);
      offset += DATASPACE_MSG_HEADER_V2_SIZE;
    } else {
      throw "InvalidHDF5File('unknown dataspace message version')";
    }
    let ndims = header.get("dimensionality");
    let dim_sizes = await struct.unpack_from_async("<" + (ndims * 2).toFixed() + "I", buf, offset);
    return dim_sizes.filter(function(s, i) {
      return i % 2 == 0;
    });
  }
  var UNDEFINED_ADDRESS2 = struct.unpack_from("<Q", new Uint8Array([255, 255, 255, 255, 255, 255, 255, 255]).buffer);
  var GLOBAL_HEAP_ID = /* @__PURE__ */ new Map([
    ["collection_address", "Q"],
    ["object_index", "I"]
  ]);
  _structure_size(GLOBAL_HEAP_ID);
  var ATTR_MSG_HEADER_V1 = /* @__PURE__ */ new Map([
    ["version", "B"],
    ["reserved", "B"],
    ["name_size", "H"],
    ["datatype_size", "H"],
    ["dataspace_size", "H"]
  ]);
  var ATTR_MSG_HEADER_V1_SIZE = _structure_size(ATTR_MSG_HEADER_V1);
  var ATTR_MSG_HEADER_V3 = /* @__PURE__ */ new Map([
    ["version", "B"],
    ["flags", "B"],
    ["name_size", "H"],
    ["datatype_size", "H"],
    ["dataspace_size", "H"],
    ["character_set_encoding", "B"]
  ]);
  var ATTR_MSG_HEADER_V3_SIZE = _structure_size(ATTR_MSG_HEADER_V3);
  var OBJECT_HEADER_V1 = /* @__PURE__ */ new Map([
    ["version", "B"],
    ["reserved", "B"],
    ["total_header_messages", "H"],
    ["object_reference_count", "I"],
    ["object_header_size", "I"],
    ["padding", "I"]
  ]);
  var OBJECT_HEADER_V2 = /* @__PURE__ */ new Map([
    ["signature", "4s"],
    ["version", "B"],
    ["flags", "B"]
  ]);
  var DATASPACE_MSG_HEADER_V1 = /* @__PURE__ */ new Map([
    ["version", "B"],
    ["dimensionality", "B"],
    ["flags", "B"],
    ["reserved_0", "B"],
    ["reserved_1", "I"]
  ]);
  var DATASPACE_MSG_HEADER_V1_SIZE = _structure_size(DATASPACE_MSG_HEADER_V1);
  var DATASPACE_MSG_HEADER_V2 = /* @__PURE__ */ new Map([
    ["version", "B"],
    ["dimensionality", "B"],
    ["flags", "B"],
    ["type", "B"]
  ]);
  var DATASPACE_MSG_HEADER_V2_SIZE = _structure_size(DATASPACE_MSG_HEADER_V2);
  var HEADER_MSG_INFO_V1 = /* @__PURE__ */ new Map([
    ["type", "H"],
    ["size", "H"],
    ["flags", "B"],
    ["reserved", "3s"]
  ]);
  var HEADER_MSG_INFO_V1_SIZE = _structure_size(HEADER_MSG_INFO_V1);
  var HEADER_MSG_INFO_V2 = /* @__PURE__ */ new Map([
    ["type", "B"],
    ["size", "H"],
    ["flags", "B"]
  ]);
  var HEADER_MSG_INFO_V2_SIZE = _structure_size(HEADER_MSG_INFO_V2);
  var SYMBOL_TABLE_MSG = /* @__PURE__ */ new Map([
    ["btree_address", "Q"],
    ["heap_address", "Q"]
  ]);
  var LINK_INFO_MSG1 = /* @__PURE__ */ new Map([
    ["heap_address", "Q"],
    ["name_btree_address", "Q"]
  ]);
  var LINK_INFO_MSG2 = /* @__PURE__ */ new Map([
    ["heap_address", "Q"],
    ["name_btree_address", "Q"],
    ["order_btree_address", "Q"]
  ]);
  var FILLVAL_MSG_V1V2 = /* @__PURE__ */ new Map([
    ["version", "B"],
    ["space_allocation_time", "B"],
    ["fillvalue_write_time", "B"],
    ["fillvalue_defined", "B"]
  ]);
  var FILLVAL_MSG_V1V2_SIZE = _structure_size(FILLVAL_MSG_V1V2);
  var FILLVAL_MSG_V3 = /* @__PURE__ */ new Map([
    ["version", "B"],
    ["flags", "B"]
  ]);
  var FILLVAL_MSG_V3_SIZE = _structure_size(FILLVAL_MSG_V3);
  var FILTER_PIPELINE_DESCR_V1 = /* @__PURE__ */ new Map([
    ["filter_id", "H"],
    ["name_length", "H"],
    ["flags", "H"],
    ["client_data_values", "H"]
  ]);
  var FILTER_PIPELINE_DESCR_V1_SIZE = _structure_size(FILTER_PIPELINE_DESCR_V1);
  var DATASPACE_MSG_TYPE = 1;
  var LINK_INFO_MSG_TYPE = 2;
  var DATATYPE_MSG_TYPE = 3;
  var FILLVALUE_MSG_TYPE = 5;
  var LINK_MSG_TYPE = 6;
  var DATA_STORAGE_MSG_TYPE = 8;
  var DATA_STORAGE_FILTER_PIPELINE_MSG_TYPE = 11;
  var ATTRIBUTE_MSG_TYPE = 12;
  var OBJECT_CONTINUATION_MSG_TYPE = 16;
  var SYMBOL_TABLE_MSG_TYPE = 17;

  // esm/high-level.js
  var Group = class {
    constructor(name, parent) {
      if (parent == null) {
        this.parent = this;
        this.file = this;
      } else {
        this.parent = parent;
        this.file = parent.file;
      }
      this.name = name;
    }
    async init(dataobjects) {
      const index = this.file.index;
      if (index && this.name in index) {
        this._links = index[this.name];
      } else {
        this._links = await dataobjects.get_links();
      }
      this._dataobjects = dataobjects;
      this._attrs = null;
      this._keys = null;
    }
    get keys() {
      if (this._keys == null) {
        this._keys = Object.keys(this._links);
      }
      return this._keys.slice();
    }
    get values() {
      return this.keys.map((k) => this.get(k));
    }
    length() {
      return this.keys.length;
    }
    _dereference(ref) {
      if (!ref) {
        throw "cannot deference null reference";
      }
      let obj = this.file._get_object_by_address(ref);
      if (obj == null) {
        throw "reference not found in file";
      }
      return obj;
    }
    async get(y) {
      if (typeof y == "number") {
        return this._dereference(y);
      }
      var path = normpath(y);
      if (path == "/") {
        return this.file;
      }
      if (path == ".") {
        return this;
      }
      if (/^\//.test(path)) {
        return this.file.get(path.slice(1));
      }
      if (posix_dirname(path) != "") {
        var [next_obj, additional_obj] = path.split(/\/(.*)/);
      } else {
        var next_obj = path;
        var additional_obj = ".";
      }
      if (!(next_obj in this._links)) {
        throw next_obj + " not found in group";
      }
      var obj_name = normpath(this.name + "/" + next_obj);
      let link_target = this._links[next_obj];
      if (typeof link_target == "string") {
        try {
          return this.get(link_target);
        } catch (error) {
          return null;
        }
      }
      var dataobjs = new DataObjects(this.file._fh, link_target);
      await dataobjs.ready;
      if (dataobjs.is_dataset) {
        if (additional_obj != ".") {
          throw obj_name + " is a dataset, not a group";
        }
        return new Dataset(obj_name, dataobjs, this);
      } else {
        var new_group = new Group(obj_name, this);
        await new_group.init(dataobjs);
        return new_group.get(additional_obj);
      }
    }
    visit(func) {
      return this.visititems((name, obj) => func(name));
    }
    visititems(func) {
      var root_name_length = this.name.length;
      if (!/\/$/.test(this.name)) {
        root_name_length += 1;
      }
      var queue = this.values.slice();
      while (queue) {
        let obj = queue.shift();
        if (queue.length == 1)
          ;
        let name = obj.name.slice(root_name_length);
        let ret = func(name, obj);
        if (ret != null) {
          return ret;
        }
        if (obj instanceof Group) {
          queue = queue.concat(obj.values);
        }
      }
      return null;
    }
    get attrs() {
      if (this._attrs == null) {
        this._attrs = this._dataobjects.get_attributes();
      }
      return this._attrs;
    }
  };
  var File$1 = class extends Group {
    constructor(fh, filename, options) {
      super("/", null);
      this.ready = this.init(fh, filename, options);
    }
    async init(fh, filename, options) {
      var superblock = new SuperBlock(fh, 0);
      await superblock.ready;
      var offset = await superblock.get_offset_to_dataobjects();
      var dataobjects = new DataObjects(fh, offset);
      await dataobjects.ready;
      this.parent = this;
      this.file = this;
      this.name = "/";
      this._dataobjects = dataobjects;
      this._attrs = null;
      this._keys = null;
      this._fh = fh;
      this.filename = filename || "";
      this.mode = "r";
      this.userblock_size = 0;
      if (options && options.index) {
        this.index = options.index;
      } else {
        let index_offset;
        if (options && options.indexOffset) {
          index_offset = options.indexOffset;
        } else {
          const attrs = await this.attrs;
          if (attrs.hasOwnProperty("_index_offset")) {
            index_offset = attrs["_index_offset"];
          } else {
            const indexName = this.indexName || "_index";
            const index_link = await dataobjects.find_link(indexName);
            if (index_link) {
              index_offset = index_link[1];
            }
          }
        }
        if (index_offset) {
          try {
            const dataobject = new DataObjects(fh, index_offset);
            await dataobject.ready;
            const comp_index_data = await dataobject.get_data();
            const inflated = ungzip_1$2(comp_index_data);
            const json = new TextDecoder().decode(inflated);
            this.index = JSON.parse(json);
          } catch (e) {
            console.error(`Error loading index by offset ${e}`);
          }
        }
      }
      if (this.index && this.name in this.index) {
        this._links = this.index[this.name];
      } else {
        this._links = await dataobjects.get_links();
      }
    }
    _get_object_by_address(obj_addr) {
      if (this._dataobjects.offset == obj_addr) {
        return this;
      }
      return this.visititems((y) => {
        y._dataobjects.offset == obj_addr ? y : null;
      });
    }
  };
  var Dataset = class extends Array {
    constructor(name, dataobjects, parent) {
      super();
      this.parent = parent;
      this.file = parent.file;
      this.name = name;
      this._dataobjects = dataobjects;
      this._attrs = null;
      this._astype = null;
    }
    get value() {
      var data = this._dataobjects.get_data();
      if (this._astype == null) {
        return this.getValue(data);
      }
      return data.astype(this._astype);
    }
    get shape() {
      return this._dataobjects.shape;
    }
    get attrs() {
      return this._dataobjects.get_attributes();
    }
    get dtype() {
      return this._dataobjects.dtype;
    }
    get fillvalue() {
      return this._dataobjects.get_fillvalue();
    }
    async to_array() {
      const value = await this.value;
      const shape = await this.shape;
      return create_nested_array(value, shape);
    }
    async getValue(data) {
      const dtype = await this.dtype;
      if (dtype.startsWith("S")) {
        return (await data).map((s) => s.substr(0, s.indexOf("\0")));
      } else {
        return data;
      }
    }
  };
  function posix_dirname(p) {
    let sep = "/";
    let i = p.lastIndexOf(sep) + 1;
    let head = p.slice(0, i);
    let all_sep = new RegExp("^" + sep + "+$");
    let end_sep = new RegExp(sep + "$");
    if (head && !all_sep.test(head)) {
      head = head.replace(end_sep, "");
    }
    return head;
  }
  function normpath(path) {
    return path.replace(/\/(\/)+/g, "/");
  }
  function create_nested_array(value, shape) {
    const total_length = value.length;
    const dims_product = shape.reduce((previous, current) => previous * current, 1);
    if (total_length !== dims_product) {
      console.warn(`shape product: ${dims_product} does not match length of flattened array: ${total_length}`);
    }
    let output = value;
    const subdims = shape.slice(1).reverse();
    for (let dim of subdims) {
      const new_output = [];
      const { length } = output;
      let cursor = 0;
      while (cursor < length) {
        new_output.push(output.slice(cursor, cursor += dim));
      }
      output = new_output;
    }
    return output;
  }
  /*! pako 2.0.4 https://github.com/nodeca/pako @license (MIT AND Zlib) */

  async function openH5File(options) {

      // Some clients (notably igv-webapp) pass a File reference in the url field.  Fix this
      if(options.url && isBlobLike(options.url)) {
          options.file = options.url;
          options.url = undefined;
      }

      const isRemote = options.url !== undefined;
      let fileReader = options.reader ? options.reader : getReaderFor(options);

      // Set default options appropriate for spacewalk
      const fetchSize = options.fetchSize || 2000;
      const maxSize = options.maxSize || 200000;

      if (isRemote) {
          fileReader = new BufferedFile({file: fileReader, fetchSize, maxSize});
      }
      const asyncBuffer = new AsyncBuffer(fileReader);

      // Optional external index -- this is not common
      const index = await readExternalIndex(options);
      const indexOffset = options.indexOffset;

      // Create HDF5 file
      const filename = getFilenameFor(options);
      const hdfFile = new File$1(asyncBuffer, filename, {index, indexOffset});
      await hdfFile.ready;
      return hdfFile
  }

  async function readExternalIndex(options) {

      let indexReader;
      if(options.indexReader) {
          indexReader = options.indexReader;
      }
      else if(options.index) {
          return options.index
      } else if (options.indexURL) {
          indexReader = new RemoteFile({url: options.indexURL});
      } else if (options.indexPath) {
          indexReader = new NodeLocalFile({path: options.indexPath});
      } else if (options.indexFile) {
          indexReader = new BlobFile({file: options.indexFile});
      }
      if (indexReader) {
          const indexFileContents = await indexReader.read();
          const indexFileJson = new TextDecoder().decode(indexFileContents);
          return JSON.parse(indexFileJson)
      } else {
          return undefined
      }
  }


  function getReaderFor(options) {
      if (options.url) { // An absolute or relative URL
          return new RemoteFile(options)
      } else if (options.path) { // A file path
          return new NodeLocalFile(options)
      } else if (options.file) { // A Browser file blob
          return new BlobFile(options.file)
      } else {
          throw Error("One of 'url', 'path (node only)', or 'file (browser only)' must be specified")
      }
  }

  function getFilenameFor(options) {
      if (options.url) {
          return getFilename(options.url)
      } else if (options.path) {
          return getFilename(options.path)
      } else if (options.file) {
          return options.file.name
      }
  }

  /**
   * Wraps an io.Reader in an interface jsfive-async expects*
   */
  class AsyncBuffer {
      constructor(fileReader) {
          this.fileReader = fileReader;
      }

      async slice(start, end) {
          return this.fileReader.read(start, end - start)
      }
  }

  function getFilename(pathOrURL) {
      const idx = pathOrURL.lastIndexOf("/");
      return idx > 0 ? pathOrURL.substring(idx + 1) : pathOrURL
  }

  function isBlobLike(obj) {
      return typeof obj.slice === 'function' && typeof obj.arrayBuffer === 'function'
  }

  class HDF5Reader {
      
      constructor(h5_file, bin_size=100000){

          this.h5_file = h5_file;
          this.bin_size = bin_size;
          this.h5_obj = undefined;
      }
      
      async fetch(){

          if(!this.h5_obj) {
              this.h5_obj = await openH5File({
                  url: this.h5_file,
                  fetchSize: 1000000,
                  maxSize: 200000000
              });
          }
          return this.h5_obj
      }

      async get_keys(){
          /* returns a list of keys of the pytor file*/
          let h5_obj = await this.fetch();

          return h5_obj.keys
      }

      async get_rd_signal(bin_size=this.bin_size){

          let h5_obj = await this.fetch();
          let h5_obj_keys = h5_obj.keys;

          // console.log(h5_obj_keys)
          let signal_bin = new ParseSignals(h5_obj_keys);
          let rd_bins = signal_bin.get_rd_bins();
          let snp_bins = signal_bin.get_snp_bins();
          this.available_bins = [...new Set(rd_bins, snp_bins)];

          // let bin_size = this.bin_size
          if(! this.available_bins.includes(bin_size)){
              bin_size = this.available_bins.at(-1);    
          }

          const chr_ds = await h5_obj.get("rd_chromosomes");
          await chr_ds.dtype;
          let rd_chromosomes = await chr_ds.value;
          //console.log(`get_rd_signal rd_chromosomes  ${Date.now() - t0}`)
          //rd_chromosomes = fixString(rd_chromosomes)
          let rd_flag = "";

          // get rd stat
          let rd_stat = await this.rd_stat(h5_obj, h5_obj_keys, bin_size);
          
          var wigFeatures = [];
          var wigFeatures_gc = [];
          var wigFeatures_rd_call_meanshift = [];
          var wigFeatures_rd_call_combined = [];
          var wigFeatures_baf1 = [];
          var wigFeatures_baf2 = [];

          for (let chrom of rd_chromosomes) {
              // for normal rd signal
              var signal_rd = `his_rd_p_${chrom}_${bin_size}${rd_flag}`;
              let chr_wig = await this.get_chr_signal(h5_obj, h5_obj_keys, chrom, bin_size, signal_rd, rd_stat);
              wigFeatures = wigFeatures.concat(chr_wig);
              
              // rd gc corrected
              var signal_rd_gc = `his_rd_p_${chrom}_${bin_size}_GC`;
              let chr_wig_gc = await this.get_chr_signal(h5_obj, h5_obj_keys, chrom, bin_size, signal_rd_gc, rd_stat);
              wigFeatures_gc = wigFeatures_gc.concat(chr_wig_gc);

              // rd call MeanShift
              
              let signal_rd_call = `his_rd_p_${chrom}_${bin_size}_partition_GC_merge`;
              let chr_wig_rd_call_meanshift = await this.get_chr_signal(h5_obj, h5_obj_keys, chrom, bin_size, signal_rd_call, rd_stat);
              wigFeatures_rd_call_meanshift = wigFeatures_rd_call_meanshift.concat(chr_wig_rd_call_meanshift);
              
              let chr_wig_rd_call = await this.rd_call_combined(h5_obj, h5_obj_keys, chrom, bin_size, rd_stat);
              wigFeatures_rd_call_combined = wigFeatures_rd_call_combined.concat(chr_wig_rd_call);

              // baf likelihood
              let signal_baf_1 = `snp_likelihood_${chrom}_${bin_size}_mask`;
              let chr_wig_bafs = await this.get_baf_signals(h5_obj, h5_obj_keys, chrom, bin_size, signal_baf_1);

              // let signal_baf_1 = `snp_i1_${chrom}_${bin_size}_mask`
              // let chr_wig_bafs = await this.get_baf_signals_v2(h5_obj, h5_obj_keys, chrom, bin_size, signal_baf_1)

              wigFeatures_baf1 = wigFeatures_baf1.concat(chr_wig_bafs[0]);
              wigFeatures_baf2 = wigFeatures_baf2.concat(chr_wig_bafs[1]);
              // this.rd_call_combined(h5_obj, h5_obj_keys, chrom, bin_size, rd_stat)
          }
          this.callers = [];
          if (wigFeatures_rd_call_combined.length != 0){
              this.callers.push('ReadDepth');
          }
          if (wigFeatures_rd_call_combined.length != 0){
              this.callers.push('2D');
          }

          var obj = {};
          var signal_obj = {
              "RD_Raw": wigFeatures,
              "RD_Raw_gc_coor" : wigFeatures_gc,
              "ReadDepth": wigFeatures_rd_call_meanshift,
              "2D": wigFeatures_rd_call_combined,
              "BAF1": wigFeatures_baf1,
              "BAF2": wigFeatures_baf2
          };
          obj[bin_size] = signal_obj;
          return obj
      }

      decode_segments(segments_arr){
          let max = 2 ** 32 - 1;
          let segments = [];
          let l = [];
          for (let x of segments_arr){
              if(x == max){
                  segments.push(l);
                  l = [];
              } else {
                  l.push(x);
              }
          }
          return segments
      }

     async  rd_call_combined(h5_obj, h5_obj_keys, chrom, bin_size, rd_stat){
          let chr_wig = [];
          
          let segments;
          let mosaic_call_segments = `his_rd_p_${chrom}_${bin_size}_partition_GC_mosaic_segments_2d`;
          if (h5_obj_keys.includes(mosaic_call_segments)){
              const chrom_dataset = await h5_obj.get(mosaic_call_segments);
              let chrom_data = await chrom_dataset.value;
              //console.log(`rd_call_combined ${mosaic_call_segments}  ${Date.now() - t0}`)
              segments = this.decode_segments(chrom_data);
              
          }

          let mosaic_calls = `his_rd_p_${chrom}_${bin_size}_partition_GC_mosaic_call_2d`;
          if (h5_obj_keys.includes(mosaic_calls)){
              const segments_call_dataset = await h5_obj.get(mosaic_calls);
              let segments_call = await segments_call_dataset.to_array(); //create_nested_array(value, shape)
              segments.forEach((ind_segment, segment_idx) => {
                  ind_segment.forEach((bin_value, bin_idx) =>{
                      chr_wig.push({chr:chrom, start: bin_value*bin_size, end: (bin_value+1) * bin_size, value: (segments_call[0][segment_idx]/rd_stat[4]) *2});
                  });
              });
          }

          return chr_wig
          
      }

     async rd_stat(h5_obj, h5_obj_keys, bin_size){
          /* 
          returns a list for rd statistics information 
          paramter
          ---------
          h5_obj: cnvpytor read object
          h5_obj_keys: a list of available signal names
          bin_size: bin size
          
          */
          
          let rd_stat_signal =  `rd_stat_${bin_size}_auto`;
          let rd_stat;
          if (h5_obj_keys.includes(rd_stat_signal)){
              const rd_stat_dataset = await h5_obj.get(rd_stat_signal);
              rd_stat = await rd_stat_dataset.value;
              //console.log(`rd_stat_signal ${rd_stat_signal}  ${Date.now() - t0}`)
          }
          return rd_stat
      }

      
      async get_chr_signal(h5_obj, h5_obj_keys, chrom, bin_size, signal_name, rd_stat){
          /* return a list of dictionary for a chromosome */
          let chr_wig = [];
          
          if (h5_obj_keys.includes(signal_name)){
              const chrom_dataset = await h5_obj.get(signal_name);
              let chrom_data = await chrom_dataset.value;
              //console.log(`chr_signal ${signal_name}  ${Date.now() - t0}`)
              chrom_data.forEach((bin_value, bin_idx) => {
                  chr_wig.push({chr:chrom, start: bin_idx*bin_size, end: (bin_idx+1) * bin_size, value: (bin_value/rd_stat[4]) *2});
              });
          }
          return chr_wig
      }

      async get_baf_signals(h5_obj, h5_obj_keys, chrom, bin_size, signal_name){
          /* return two list of dictionary*/
          let chr_wig_1 = [];
          let chr_wig_2 = [];
          if (h5_obj_keys.includes(signal_name)){
              let chrom_dataset = await h5_obj.get(signal_name);
              let chrom_data = await chrom_dataset.to_array(); //create_nested_array(value, shape)
              chrom_data.forEach((bin_value, bin_idx) => {
                  let max_value =  Math.max(...bin_value);
                  const res = bin_value.indexOf(max_value);
                  let lh = Math.max(res / 200, 1 - res / 200);
                  chr_wig_1.push({chr:chrom, start: bin_idx*bin_size, end: (bin_idx+1) * bin_size, value: -2 * lh});
                  if(lh != 0.5){
                      chr_wig_2.push({chr:chrom, start: bin_idx*bin_size, end: (bin_idx+1) * bin_size, value: -2 *(1-lh)});
                  }
              });
          }
          return [chr_wig_1, chr_wig_2]
      }

      async get_baf_signals_v2(h5_obj, h5_obj_keys, chrom, bin_size, signal_name){
          
          /* return two list of dictionary*/
          let chr_wig_1 = [];
          let chr_wig_2 = [];
          if (h5_obj_keys.includes(signal_name)){
              let chrom_dataset = await h5_obj.get(signal_name);
              let chrom_data = await chrom_dataset.to_array(); //create_nested_array(value, shape)
              chrom_data.forEach((lh, bin_idx) => {
                  if (!isNaN(lh)){
                      chr_wig_1.push({chr:chrom, start: bin_idx*bin_size, end: (bin_idx+1) * bin_size, value: -2 * ( 0.5 - lh )});
                      if(lh != 0.5){
                          chr_wig_2.push({chr:chrom, start: bin_idx*bin_size, end: (bin_idx+1) * bin_size, value: -2 * ( 0.5 + lh )});
                      }
                  }
              });
          }
          return [chr_wig_1, chr_wig_2]

      }
  }

  class ParseSignals{

      constructor(signals){
          /*
          Parse a signal names

          parameter
          ---------
          signals: List of keys in pytor files
          */
          this.signals = signals;
      }

      get_rd_bins(){
          /* return list of rd bins */
          let rd_keys = [];
          this.signals.forEach( val => {
              let match = val.match(/^his_rd_p_(.*)_(\d+)$/);
              if(match){
                  rd_keys.push({chr:match[1], bin_size:match[2]});
              }});
          const rd_bins = [...new Set(rd_keys.map(item => Number(item.bin_size)))];
          return rd_bins
      }

      get_snp_bins(){
          /* return list of snp bins */
          let slected_signals = [];
          this.signals.forEach( val => {
              let match = val.match(/^snp_likelihood_(.*)_(\d+)_mask$/);
              if(match){
                  slected_signals.push({chr:match[1], bin_size:match[2]});
              }});
          const bins = [...new Set(slected_signals.map(item => Number(item.bin_size)))];
          return bins
      }
  }

  class GetFit {
    constructor(allBins) {
        this.allBins = allBins;
    }
    getValues() {
        const bins = Object.values(this.allBins).reduce(
            (binResult, bin) => { return binResult.concat(bin.filter(a => a.binScore > 0).map(a => a.binScore)) }, []);
        return bins
    }
    getMean(data) {
        return (data.reduce(function (a, b) { return a + b; }) / data.length);
    }
    fit_data() {
        let rd_list = this.getValues();
        let distParmas = getDistParams(rd_list);
        return distParmas
    }

    histogram(data, bins) {
        const step = bins[1] - bins[0];
        const hist_bins = [];

        data.forEach((value, index) => {
            bins.forEach((bin_value, bin_index) => {
                if (!hist_bins[bin_value]) {
                    hist_bins[bin_value] = { count: 0 };
                }
                if (bin_value <= value && value < bin_value + step) {
                    hist_bins[bin_value].count++;
                    return false;
                }
            });
        });
        const dist_p = [];
        hist_bins.forEach((bin, index) => { dist_p.push(bin.count); });
        return dist_p
    }

  }

  function range_function(start, stop, step) {
    const data_array = Array(Math.ceil((stop - start) / step))
      .fill(start)
      .map((x, y) => x + y * step);
    return data_array;
  }

  function filterOutliers(someArray) {

    if (someArray.length < 4)
      return someArray;

    let values, q1, q3, iqr, maxValue, minValue;

    values = someArray.slice().sort((a, b) => a - b); //copy array fast and sort

    if ((values.length / 4) % 1 === 0) { //find quartiles
      q1 = 1 / 2 * (values[(values.length / 4)] + values[(values.length / 4) + 1]);
      q3 = 1 / 2 * (values[(values.length * (3 / 4))] + values[(values.length * (3 / 4)) + 1]);
    } else {
      q1 = values[Math.floor(values.length / 4 + 1)];
      q3 = values[Math.ceil(values.length * (3 / 4) + 1)];
    }

    iqr = q3 - q1;
    maxValue = q3 + iqr * 1.5;
    minValue = q1 - iqr * 1.5;

    return values.filter((x) => (x >= minValue) && (x <= maxValue));
  }

  function getDistParams(bins) {
    let filteredBins = filterOutliers(bins);
    const n = filteredBins.length;
    const mean = filteredBins.reduce((a, b) => a + b) / n;
    const std = Math.sqrt(filteredBins.map(x => Math.pow(x - mean, 2)).reduce((a, b) => a + b) / n);
    return [mean, std]
  }

  function linspace(a, b, n) {
    if (typeof n === "undefined") n = Math.max(Math.round(b - a) + 1, 1);
    if (n < 2) {
        return n === 1 ? [a] : [];
    }
    var ret = Array(n);
    n--;
    for (let i = n; i >= 0; i--) {
        ret[i] = (i * b + (n - i) * a) / n;
    }
    return ret;
  }

  var g_utils = { range_function, getDistParams, linspace, GetFit};

  /** 
  * Evaluates the cumulative distribution function (CDF) for a Student's t distribution with degrees of freedom `v` at a value `t`.
  *
  * @params {number} t - value for the t test
  * @params {PositiveNumber} v - degree of freedom
  * @returns {Probability} evaluated CDF
  */
  function TdistributionCDF(t, v){
      if (isNaN( t ) || isNaN( v ) || v <= 0.0) {
  		return NaN;
  	}
  	if ( t === 0.0 ) {
  		return 0.5;
  	}
      return 1/2 + (1/2 * (incompbeta(1/2*v, 1/2, 1) - incompbeta(1/2*v, 1/2, v/(v+t*t)))) * Math.sign( t)

  }


  /** 
  * incompbeta(a,b,x) evaluates incomplete beta function, here a, b > 0 and 0 <= x <= 1. This function requires contfractbeta(a,b,x, ITMAX = 200) 
  *  code translated from  https://malishoaib.wordpress.com/2014/04/15/the-beautiful-beta-functions-in-raw-python/
  *
  * @params
  * @params
  * @params
  * @returns 
  */
  function incompbeta(a, b, x){
       
      if(x == 0){
          return 0;
      }
      else if (x == 1){
          return 1;
      }else
      {
          let lbeta = lgamma(a+b) - lgamma(a) - lgamma(b) + a * Math.log(x) + b * Math.log(1-x);
          if (x < (a+1) / (a+b+2)){
              return Math.exp(lbeta) * contfractbeta(a, b, x) / a;
          }
          else {
              return 1 - Math.exp(lbeta) * contfractbeta(b, a, 1-x) / b;
          }
      }
  }

  /**
   * contfractbeta() evaluates the continued fraction form of the incomplete Beta function; incompbeta().  
   *   (Code translated from: Numerical Recipes in C.)
   * 
   * @param {*} a 
   * @param {*} b 
   * @param {*} x 
   * @param {*} ITMAX 
   * @returns 
   */
  function contfractbeta(a,b,x, ITMAX = 1000){
       
      let EPS = 3.0e-7;
      let az = 1.0;
      let am = 1.0;
      let bm = 1.0;
      let qab = a + b;
      let qap = a + 1.0;
      let qam = a-1.0;
      let bz = 1.0 - qab*x/qap;
       
      //for i in range(ITMAX):
      for(let i =0; i<= ITMAX; i++){
          let em = parseFloat(i+1);
          let tem = em + em;
          let d = em*(b-em)*x/((qam+tem)*(a+tem));
          let ap = az + d*am;
          let bp = bz+d*bm;
          d = -(a+em)*(qab+em)*x/((qap+tem)*(a+tem));
          let app = ap+d*az;
          let bpp = bp+d*bz;
          let aold = az;
          am = ap/bpp;
          bm = bp/bpp;
          az = app/bpp;
          bz = 1.0;
          if (Math.abs(az-aold)<(EPS * Math.abs(az))){
              return az
          }
      }
  }

  /**
   * Evaluates factorial of a number
   * 
   * @param {Number} xf - Integer number 
   * @returns factorial of the number
   */
  function factorial(xf) {
      if ((xf == 0) || (xf == 1)) return 1;
      else {
          let result = (xf * factorial(xf - 1));
          return result
      }
  }

  /**
   * Evalues factorial for an integer or fraction using either either factorial or gamma function
   * 
   * @param {Number} a - integar or fraction number
   * @returns value of a gamma function
   */
  function gamma(a){
      let gamma;
      
      var qc = [75122.6331530, 80916.6278952, 36308.2951477, 8687.24529705, 1168.92649479, 83.8676043424, 2.50662827511];
      
      var sum1 = 0;
      var prod1 = 1;
      if (a == 0) { 
          gamma = 1e99; 
      }else {
          if ((a % 1) == 0) {//if integer
              gamma = factorial(a - 1);
          }
          else { //not integer
              for (let j = 0; j < qc.length; j++) {
                  sum1 = sum1 + qc[j] * Math.pow(a, j);
                  prod1 = prod1 * (a + j);
              }
              gamma = (sum1 * Math.pow((a + 5.5), (a + 0.5))) * Math.exp(-(a + 5.5)) / prod1;
          }
      }
      
      return gamma
  }

  /**
   * 
   * @param {Number} xg  - integar or fraction number
   * @returns natural log of gamma function
   */

  function lgamma(xg){
      return Math.log(gamma(xg))
  }

  function t_test_1_sample$1(mean, m, s, n) {
      if (s == 0) s = 1;
      var t = ((mean - m) / s) * Math.sqrt(n);
      var p = 1.0 - TdistributionCDF(Math.abs(t), (n - 1));
      return p
  }

  function t_test_2_samples$1(m1, s1, n1, m2, s2, n2) {
      if (s1 == 0) s1 = 1;
      if (s2 == 0) s2 = 1;
      var t = (m1 - m2) / Math.sqrt(s1 ** 2 / n1 + s2 ** 2 / n2);
      var df = ((s1 ** 2 / n1 + s2 ** 2 / n2) ** 2 * (n1 - 1) * (n2 - 1)) /
          ((s1 ** 4 * (n2 - 1)) / n1 ** 2 + (s2 ** 4 * (n1 - 1)) / n2 ** 2);

      var p = 1.0 - TdistributionCDF(Math.abs(t), parseInt(df + 0.5));

      return p
  }

  var t_dist = {TdistributionCDF, gamma, t_test_1_sample: t_test_1_sample$1, t_test_2_samples: t_test_2_samples$1};

  class CombinedCaller{
      constructor(wigFeatures, binSize) {
          this.wigFeatures = wigFeatures;
          this.binSize = binSize;
          // let fit_obj = this.get_fit()
          // this.globalMean = fit_obj.globalMean
          // this.globalStd = fit_obj.globalStd
      }
      get_fit(){
          var fit_info = new g_utils.GetFit(this.wigFeatures);
          var [globalMean, globalStd] = fit_info.fit_data();

          return {globalMean:globalMean, globalStd:globalStd}
         
      }
      async call_2d(omin=null, mcount=null, event_type="both", max_distance=0.1, baf_threshold=0, max_copy_number=10, min_cell_fraction=0.0){
          
          let fit_obj = this.get_fit();
          this.globalMean = fit_obj.globalMean;
          this.globalStd = fit_obj.globalStd;
          
          let overlap_min = omin==null ?  0.05 * this.binSize / 3e9: omin ;
          let min_count = mcount == null ? parseInt(this.binSize / 10000) : mcount ;

          let gstat_rd0 = [];
          let gstat_rd_all = [];
          let gstat_rd = [];
          let gstat_error = [];
          let gstat_lh = [];
          let gstat_n = [];
          
          for (const [chr, wig] of Object.entries(this.wigFeatures)) {
              let segments = [];
              let levels = [];
              let likelihoods = [];
              
              wig.forEach((bin, bin_idx) => {
                  if (bin.hets_count > 4 ){
                      
                      if( bin.dp_count > min_count ){
                          segments.push([bin_idx]);
                          levels.push(bin.binScore);
                          likelihoods.push(bin.likelihood_score);
                          delete bin.likelihood_score;
                          
                      }
                  }
              });

              let diff_level = [];
              for(let i=1; i<levels.length; i++){
                  diff_level.push(Math.abs(levels[i] - levels[i-1]));
              }
              let min_flank = [0];
              for(let i=1; i<diff_level.length; i++){
                  min_flank.push(Math.min(diff_level[i-1], diff_level[i]));    
              }
              min_flank.push(0);

              let error  = levels.map((x, x_idx) => {return Math.sqrt(Math.sqrt(x) ** 2 + this.globalStd ** 2 + Math.pow(min_flank[x_idx]/2, 2));});
              
              let overlaps = [];
              
              for(let i=0; i< segments.length-1; i++){
                  
                  let lh_overlap = 0;
                  try{
                      lh_overlap = likelihood_overlap(likelihoods[i], likelihoods[i+1]);
                  }catch{
                  }
                  
                  let rd_overlap = normal_overlap_approx(levels[i], error[i], levels[i+1], error[i+1]);
                  overlaps.push(rd_overlap * lh_overlap);
                  
              }
              
              while(overlaps.length >0) {
                  overlaps = overlaps.filter(num => typeof num === "number");
                  
                  let max_overlap = arrayMax(overlaps);
                  if(max_overlap < overlap_min){
                      // console.log("maxoverlap ",max_overlap,  "is smaller than overlap min")
                      break
                  }
                  let i = overlaps.indexOf(max_overlap);
                  
                  let merge_level = normal_merge(levels[i], error[i], levels[i + 1], error[i + 1]);
                  
                  let nlh;
                  let nlh_sum;
                  try{
                      nlh = likelihoods[i].map((l_value, l_idx) => { return l_value * likelihoods[i+1][l_idx]});
                  
                      nlh_sum = nlh.reduce((a, c_value) => {return a + c_value});
                      
                  }catch{
                  }
                  // nlh_sum = nlh.reduce((a, c_value) => {return a + c_value});

                  levels[i] = merge_level.nl;
                  error[i] = merge_level.ne;
                  
                  likelihoods[i] = nlh.map(function(item) { return item/nlh_sum } );
                  
                  segments[i].push(...segments[i+1]);

                  levels.splice(i + 1, 1);
                  error.splice(i + 1, 1);
                  segments.splice(i + 1, 1);
                  likelihoods.splice(i + 1, 1);
                  overlaps.splice(i, 1);
                  
                  if(i < overlaps.length){
                      
                      let rd_overlap = normal_overlap_approx(levels[i], error[i], levels[i+1], error[i+1]);
                      let new_overlap = rd_overlap * likelihood_overlap(likelihoods[i], likelihoods[i + 1]);
                      
                      overlaps[i] = new_overlap;
                  }
                  if(i > 0){
                      let new_overlap = normal_overlap_approx(levels[i - 1], error[i - 1], levels[i], error[i]) 
                      * likelihood_overlap(likelihoods[i - 1], likelihoods[i]);
                      overlaps[i - 1] = new_overlap;
                  }

              }
              let ons = -1;
              while(true){
                  overlaps = [];
                  for(let i=0; i< levels.length; i++){
                      for(let j=i; j<levels.length; j++){
                          if(segments[j][0] - segments[i].at(-1) < max_distance * (segments[i].length + segments[j].length)){
                              overlaps.push(normal_overlap_approx(levels[i], error[i], levels[j], error[j]) * likelihood_overlap(likelihoods[i], likelihoods[j]));
                          }
                      }
                  }
                  
                  if(overlaps.length == 0){
                      break
                  }
                  let max_overlap = arrayMax(overlaps);
                  if(max_overlap < overlap_min){
                      break
                  }
                  let i = 0; 
                  let j = 1;
                  while (i < segments.length - 1){
                      let overlap_value = normal_overlap_approx(levels[i], error[i], levels[j], error[j]) * likelihood_overlap(likelihoods[i], likelihoods[j]);

                      if((segments[j][0] - segments[i].at(-1)) < max_distance * (segments[i].length + segments[j].length) && overlap_value == max_overlap){
                          let merge_level = normal_merge(levels[i], error[i], levels[i + 1], error[i + 1]);

                          levels[i] = merge_level.nl;
                          error[i] = merge_level.ne;
                          let nlh = likelihoods[i].map((l_value, l_idx) => { return l_value * likelihoods[i+1][l_idx]});
                          let nlh_sum = nlh.reduce((a, c_value) => {return a + c_value});
                          likelihoods[i] = nlh.map(function(item) { return item/nlh_sum } );

                          
                          segments[i].push(...segments[i+1]);
                          segments[i] = segments[i].sort((a,b) => a-b);

                          levels.splice(j, 1);
                          error.splice(j, 1);
                          segments.splice(j, 1);
                          likelihoods.splice(j, 1);
                          
                          if(j >= segments.length){
                              i += 1;
                              j = i + 1;
                          }

                      }else {
                          j += 1;
                          if(j >= segments.length){
                              i += 1;
                              j = i + 1;
                          }
                      }
                  }
                  if(ons == segments.length){
                      break
                  }
                  ons = segments.length;
              }
              // console.log('final segments', segments)
              
              segments.forEach((seg_value, seg_idx) => {
                  let baf_info = likelihood_baf_pval(likelihoods[seg_idx]);
                  if(seg_value.length > 1){

                      seg_value.forEach((bin, bin_idx) =>{
                          gstat_rd_all.push(wig[bin]);
                          if(baf_info.mean <= baf_threshold){
                              gstat_rd0.push(wig[bin]);
                          }
                          wig[bin].segment_score = levels[seg_idx];
                      });
                      gstat_rd.push(levels[seg_idx]);
                      gstat_error.push(error[seg_idx]);
                      gstat_lh.push(likelihoods[seg_idx]);

                  }

              });

              continue
          }
          
          // Third stage for call
          
          // let data = gstat_rd0.lengthn == 0 ?  gstat_rd_all: gstat_rd0 ;
          
          let points = parseInt(1000 * (1 - min_cell_fraction));
          if(points == 0){
              points = 1;
          }
          let x = g_utils.linspace(min_cell_fraction, 1, points);
          let master_lh = {};
          let germline_lh = {};
          for(let cn=10; cn > -1; cn--){
              for(let h1=0; h1 < (cn/2+1); h1++){
                  let h2 = cn - h1;
                  let mrd = x.map((v, idx) => {return 1-v +v*cn/2});
                  let g_mrd = cn / 2;
                  let g_mbaf;
                  let mbaf;
                  if(cn > 0){
                      g_mbaf = 0.5 - (h1 / (h1 + h2));
                      mbaf = x.map((v, idx) => {return 0.5 - (1 - v + v * h1) / (2 - 2 * v + (h1 + h2) * v)});
                     
                  }else {
                      g_mbaf = 0;
                      mbaf =  x.map((v, idx) => {return 0*v});
                  }
                  
                  for( let ei=0; ei < gstat_rd.length; ei++){
                          
                      let g_lh = normal(g_mrd * this.globalMean, 1, gstat_rd[ei], gstat_error[ei]) * likelihood_of_baf(gstat_lh[ei], 0.5 + g_mbaf);
                      if(ei in germline_lh){
                          germline_lh[ei].push([cn, h1, h2, g_lh, 1.0]);
                      }else {
                          germline_lh[ei] = [cn, h1, h2, g_lh, 1.0];
                      }
                      let slh = 0;
                      let max_lh = 0;
                      let max_x = 0;
                      mrd.forEach((mi, idx) => {
                          if(!isNaN(mbaf[idx])){
                              let tmpl = normal(mi * this.globalMean, 1, gstat_rd[ei], gstat_error[ei]) * likelihood_of_baf(gstat_lh[ei], 0.5 + mbaf[idx]);
                              slh += tmpl;
                              if(tmpl > max_lh){
                                  max_lh = tmpl;
                                  max_x = x[idx];
                              }
                          }
                      });
                      if(ei in master_lh){
                          master_lh[ei].push([cn, h1, h2, slh / x.length, max_x]);
                      }else {
                          master_lh[ei] = [cn, h1, h2, slh / x.length, max_x];
                      }
                  }
                  
                  for( let ei=0; ei < gstat_rd.length; ei++){
                      if(event_type == "germline"){
                          master_lh[ei].sort((a, b) => a[3] - b[3]);
                      }
                      else {
                          master_lh[ei].sort((a, b) => a[3] - b[3]);
                          if(event_type == "both"){
                              
                              germline_lh[ei].sort((a, b) => a[3] - b[3]);
                              if(germline_lh[ei][0][3] > master_lh[ei][0][3]){
                                  //let tmp_list = list(filter( lambda x: x[0] != germline_lh[ei][0][0] and x[1] != germline_lh[ei][0][1], master_lh[ei]))
                                  let tmp_list = master_lh[ei].filter((x) => (x[0] != germline_lh[ei][0][0]) && (x[1] <= germline_lh[ei][0][1]));
                                  // console.log('tmp_list', tmp_list)
                                  // master_lh[ei] = [germline_lh[ei][0]] + tmp_list
                                  master_lh[ei] = [germline_lh[ei][0]].push(...tmp_list);
                              }
                          }
                      }
                  }
                  for( let ei=0; ei < gstat_rd.length; ei++){
                      if(master_lh[ei][0][0] > 2);
                      if(master_lh[ei][0][0] < 2);
                      gstat_rd[ei] / this.globalMean;
                      t_dist.t_test_1_sample(this.globalMean, gstat_rd[ei], gstat_error[ei], gstat_n[ei]);
                      // console.log(etype)

                  }
                  

                  // break
              }
              
          }
          
          var rawbinScore = this.formatDataStructure(this.wigFeatures, 'binScore', this.globalMean);
          var callScore = this.formatDataStructure(this.wigFeatures, 'segment_score', this.globalMean);
          
          return {binScore: rawbinScore, segment_score: callScore}
          
      }

      formatDataStructure(wigFeatures, feature_column, scaling_factor = 1) {
          const results = [];
          for (const [chr, wig] of Object.entries(wigFeatures)) {

              wig.forEach(sample => {
                  var new_sample = { ...sample };
                  if (scaling_factor != 1) {
                      new_sample.value = sample[feature_column] / scaling_factor * 2;
                  }
                  results.push(new_sample);
              });
          }

          return results
      }

      formatDataStructure_BAF(feature_column, scaling_factor = 2) {
          const baf1 = [];
          const baf2 = [];
          for (const [chr, wig] of Object.entries(this.wigFeatures)) {

              wig.forEach(sample => {
                  
                  var baf1_value = { ...sample };
                  var baf2_value = { ...sample };
                  
                  let value = sample[feature_column];
                  if (value != 0.5){
                      baf2_value.value = -2 * (1 - value);
                      baf2.push(baf2_value);
                  }
                  baf1_value.value = -2 * value;
                  baf1.push(baf1_value);
                      
              });
          }
          

          return [baf1, baf2]
      }
  }

  function arrayMax(arr) {
      return arr.reduce(function (p, v) {
        return ( p > v ? p : v );
      });
    }

  /**
   * Normal distribution.
   * 
   * @param {float} x - Variable.
   * @param {float} a - area
   * @param {float} x0 -  Mean value
   * @param {float} sigma - Sigma
   * @returns {float} - Value of distribution in x.
   */
  function normal(x, a, x0, sigma){
    
    return a * Math.exp(-1* (x - x0) ** 2 / (2 * sigma ** 2)) / Math.sqrt(2 * Math.PI) / sigma

  }

  /**
   *  Calculates two normal distributions overlap area.
   * 
   * @param {float} m1 - Mean value of the first distribution
   * @param {float} s1 - Sigma of the first distribution
   * @param {float} m2 - Mean value for second distribution
   * @param {float} s2 - Sigma of the second distribution
   * 
   * @returns {float} area - Area of overlap
   */
  function normal_overlap_approx(m1, s1, m2, s2){
     
      return Math.exp(-1* (m1-m2)**2/ (s1**2+s2**2))
  }


  /**
   * Returns overlap area of two likelihood functions.
   * 
   * @param {*} lk1 - First likelihood function.
   * @param {*} lk2 - Second likelihood function.
   * 
   * @returns {float}  - Overlap area.
   */
  function likelihood_overlap(likelihood_1, likelihood_2){
      let sum;
      try{
          sum = likelihood_1.reduce((accumulator, currentValue, currentIndex) => {return accumulator + Math.min(currentValue, likelihood_2[currentIndex])});
      }catch{
          return 0
      }

      return sum
  }

  /**
   * Calculates normal distribution that is product of two given normal distributions.
   * 
   * @param {float} m1 - Mean value of the first distribution
   * @param {float} s1 - Sigma of the first distribution
   * @param {float} m2 - Mean value for second distribution
   * @param {float} s2 - Sigma of the second distribution
   * @returns {Object} An object representing the first distribution
   * @property {float} nl - Mean value of the first distribution
   * @property {float} ne - Sigma of the first distribution
   */
  function normal_merge(m1, s1, m2, s2){
     
      if((s1 == 0) && (s2 == 0)){
          return {nl: 0.5 * (m1 + m2), ne: 0}
      }
      else {
          return {nl: (m1 * s2 * s2 + m2 * s1 * s1) / (s1 * s1 + s2 * s2), ne: Math.sqrt(s1 * s1 * s2 * s2 / (s1 * s1 + s2 * s2))}
      }
  }

  /**
   * Calculates likelihood for given baf
   * @param {*} likelihood 
   * @param {*} baf 
   * @returns {float}  likelihood value
   */
  function likelihood_of_baf(likelihood, baf){
     
      let bin = parseInt(baf * (likelihood.length - 1));
      let fr = baf * (likelihood.length - 1) - bin;
      if(bin < likelihood.length - 1){
          return likelihood[bin] * (1 - fr) + likelihood[bin + 1] * fr
      }
      else {
          return likelihood[bin]
      }
  }

  /**
   * 
   * Calculates baf level and p-value for given likelihood function.
   * 
   * @param {*} likelihood 
   * @returns {Object} An object representing BAF
   * @property {float} mean  BAF level (difference from 1/2)
   * @property {float} p  p-value for event different than 1/2
   */
  function likelihood_baf_pval(likelihood) {
      const res = likelihood.length;
      const max_lh = Math.max(...likelihood);
      let ix = likelihood.indexOf(max_lh);
      if (ix > Math.floor(res / 2)) {
        ix = res - 1 - ix;
      }
      const b = (res / 2 - ix) / (res + 1);
    
      const ix1 = Math.floor((res / 2 + ix) / 2);
      const ix2 = res - 1 - ix1;
      let p = likelihood.slice(ix1, ix2 + 1).reduce((acc, val) => acc + val, 0) / likelihood.reduce((acc, val) => acc + val, 0);
      if (ix === Math.floor(res / 2)) {
        p = 1.0;
      }
      return {mean:b, p:p};
    }

    var combined_caller = {CombinedCaller};

  function erf(x) {
      var m = 1.0, s = 1.0, sum = x * 1.0;
      for (var i = 1; i < 50; i++) {
          m *= i;
          s *= -1;
          sum += (s * Math.pow(x, 2.0 * i + 1.0)) / (m * (2.0 * i + 1.0));
      }
      return (2 * sum) / Math.sqrt(3.14159265358979)
  }

  function getEValue(mean, sigma, rd, start, end) {
      var arr = new DataStat(rd.slice(start, end));
      if (arr.std == 0) {
          if (sigma > 0) { arr.std = (sigma * arr.mean) / mean; }
          else { arr.std = 1; }
      }
      var p_val = t_test_1_sample(mean, arr.mean, arr.std, end - start) / (end - start);
      return p_val
  }

  function gaussianEValue(mean, sigma, rd, start, end) {
      var arr = new DataStat(rd.slice(start, end));

      if (arr.mean < mean) {
          var x = (arr.max - arr.mean) / (sigma * Math.sqrt(2));
          return Math.pow(0.5 * (1 + erf(x)), end - start)
      }
      var x = (arr.min - arr.mean) / (sigma * Math.sqrt(2));
      return Math.pow(0.5 * (1 - erf(x)), end - start)
  }

  function adjustToEvalue(mean, sigma, rd, start, end, pval, max_steps = 1000) {
      var val = getEValue(mean, sigma, rd, start, end);
      var step = 0, done = false;
      while ((val > pval) & !done & (step < max_steps)) {
          done = true;
          step += 1;
          var [v1, v2, v3, v4] = [1e10, 1e10, 1e10, 1e10];
          if (start > 0) v1 = getEValue(mean, sigma, rd, start - 1, end);
          if (end - start > 2) {
              var v2 = getEValue(mean, sigma, rd, start + 1, end);
              var v3 = getEValue(mean, sigma, rd, start, end - 1);
          }
          if (end < rd.length) { var v4 = getEValue(mean, sigma, rd, start, end + 1); }
          if (Math.min[(v4)] < val) {
              done = false;
              if (v1 == Math.min[(v4)]) {
                  start -= 1;
                  val = v1;
              }
              elif(v2 == Math.min[(v4)]); {
                  start += 1;
                  val = v2;
              }
              elif(v3 == Math.min[(v4)]); {
                  end -= 1;
                  val = v3;
              }
              elif(v4 == Math.min[(v4)]); {
                  end += 1;
                  val = v4;
              }
          }
      }
      if (val <= pval) { return end }
      return 0;
  }

  class DataStat {
      constructor(data_array) {
          this.data = data_array;
          this.mean = data_array.reduce((acc, n) => acc + n) / data_array.length;
          this.std = Math.sqrt(data_array.reduce((acc, n) => (n - this.mean) ** 2) / data_array.length);
      }
  }

  function t_test_1_sample(mean, m, s, n) {
      if (s == 0) s = 1;
      var t = ((mean - m) / s) * Math.sqrt(n);
      var p = 1.0 - t_dist.TdistributionCDF(Math.abs(t), (n - 1));
      return p
  }

  function t_test_2_samples(m1, s1, n1, m2, s2, n2) {
      if (s1 == 0) s1 = 1;
      if (s2 == 0) s2 = 1;
      var t = (m1 - m2) / Math.sqrt(s1 ** 2 / n1 + s2 ** 2 / n2);
      var df = ((s1 ** 2 / n1 + s2 ** 2 / n2) ** 2 * (n1 - 1) * (n2 - 1)) /
          ((s1 ** 4 * (n2 - 1)) / n1 ** 2 + (s2 ** 4 * (n1 - 1)) / n2 ** 2);

      var p = 1.0 - t_dist.TdistributionCDF(Math.abs(t), parseInt(df + 0.5));

      return p
  }

  class Partition {

      constructor(rd, mean, std) {
          this.rd = rd;
          this.mean = mean;
          this.std = std;
          this.bin_bands = [2, 3, 4, 5, 6, 7, 8, 10, 12, 14, 16, 20, 24, 28, 32, 40, 48, 56, 64, 80, 96, 112, 128];
      }

      get_rd_signal_bandwidth(data_array) {
          var new_array = [];

          data_array.forEach((value, index) => {
              var tmp_value = 0;
              if (value > this.mean / 4) {
                  tmp_value = this.mean / (this.std ** 2 * value);
              } else {
                  tmp_value = 4 / this.std ** 2;
              }
              new_array.push(tmp_value);
          });
          return new_array
      }

      meanShiftCaller(repeats = 3) {
          var ChrLevels = {};
          
          Object.entries(this.rd).forEach(([chr, chr_rd]) => {
              var masked = new Array(chr_rd.length).fill(false);

              // set the level
              var levels = new Array(chr_rd.length);

              for (let b = 0; b < chr_rd.length; b++) {
                  if (!masked[b]) { levels[b] = chr_rd[b]; }
              }

              this.bin_bands.forEach((bin_band, bin_band_index) => {
                  // not masked levels at current bin
                  // get boolean values
                  var not_masked = masked.map((value, index) => { return !value; });

                  // not masked level at current bin
                  var nm_levels = [];

                  Object.entries(chr_rd).forEach(([k, v]) => { nm_levels.push(v.binScore); });
                  
                  // set the mask border
                  var mask_borders = [0];
                  var count = 0;

                  for (let i = 0; i < masked.length; i++) {
                      if (masked[i]) {
                          if (count > 0) {
                              mask_borders.push(mask_borders[mask_borders.length - 1] + count - 1);
                              count = 0;
                          }
                      } else { count += 1; }
                  }

                  mask_borders.shift();

                  // repeating steps
                  for (let step = 0; step < repeats; step++) {
                      var isig = this.get_rd_signal_bandwidth(nm_levels);
                      var grad = new Array(nm_levels.length).fill(0);

                      for (let i = 0; i < nm_levels.length; i++) {
                          for (let j = i - 3 * bin_band; j <= i + 3 * bin_band + 1; j++) {
                              if (j < 0 || j >= nm_levels.length) continue;
                              if (Math.abs(i - j) >= nm_levels.length) continue;

                              var g_value = (j - i) * Math.exp((-0.5 * (j - i) ** 2) / bin_band ** 2) *
                                  Math.exp(-0.5 * (nm_levels[i] - nm_levels[j]) ** 2 * isig[i]);

                              grad[i] += g_value;
                          }
                      }
                      
                      // get the border
                      var border = new Array();
                      for (var i = 0; i < grad.length - 1; i++) {
                          if ((grad[i] < 0) & (grad[i + 1] >= 0)) border.push(i);
                      }

                      border.push(grad.length - 1);
                      border = border.concat(mask_borders).sort((a, b) => a - b);
                      border = Array.from(new Set(border));

                      var pb = 0;
                      for (var i = 0; i < border.length; i++) {
                          var range_array = nm_levels.slice(pb, border[i] + 1);
                          var range_mean = range_array.reduce((acc, n) => acc + n) / range_array.length;

                          nm_levels.fill(range_mean, pb, border[i] + 1);
                          pb = border[i] + 1;
                      }
                  }

                  for (var i = 0, j = 0; i < levels.length; i++) {
                      if (not_masked[i]) {
                          levels[i] = nm_levels[j];
                          j++;
                      }
                  }

                  //get the border
                  var border = new Array();
                  for (var i = 0; i < levels.length - 1; i++) {
                      //if(i == levels.length -1) continue;
                      var diff = Math.abs(levels[i + 1] - levels[i]);

                      if (diff > 0.01) border.push(i + 1);
                  }

                  border.unshift(0);
                  border.push(levels.length);

                  // reset the mask
                  masked = new Array(this.rd.length).fill(false);

                  // check the borders
                  for (var i = 1; i < border.length; i++) {
                      var seg = [border[i - 1], border[i]];
                      var seg_left = [border[i - 1], border[i - 1]];
                      if (i > 1) { seg_left[0] = border[i - 2]; } else continue;

                      var seg_right = [border[i], border[i]];
                      if (i < border.length - 1) { seg_right[1] = border[i + 1]; } else continue;

                      var n = seg[1] - seg[0];
                      var n_left = seg_left[1] - seg_left[0];
                      var n_right = seg_right[1] - seg_right[0];
                      if (n <= 1) continue;
                      var seg_array = new DataStat(levels.slice(seg[0], seg[1]));

                      if (n_right <= 15 || n_left <= 15 || n <= 15) {
                          var ns = 1.8 * Math.sqrt(levels[seg_left[0]] / this.mean) * this.std;
                          if (Math.abs(levels[seg_left[0]] - levels[seg[0]]) < ns) { continue }

                          ns = 1.8 * Math.sqrt(levels[seg_right[0]] / this.mean) * this.std;
                          if (Math.abs(levels[seg_right[0]] - levels[seg[0]]) < ns) { continue }
                      } else {
                          var seg_left_array = levels.slice(seg_left[0], seg_left[1]);
                          var seg_left_1 = new DataStat(seg_left_array);

                          var seg_right_array = levels.slice(seg_right[0], seg_right[1]);
                          var seg_right_1 = new DataStat(seg_right_array);

                          var ttest_2sample_1 = t_test_2_samples(seg_array.mean, seg_array.std, seg_array.data.length,
                              seg_left_1.mean, seg_left_1.std, seg_left_1.data.length);
                          if (ttest_2sample_1 > (0.01 / genome_size) * bin_size * (n + n_left)) { continue }

                          var ttest_2sample_2 = t_test_2_samples(seg_array.mean, seg_array.std, seg_array.data.length,
                              seg_right_1.mean, seg_right_1.std, seg_right_1.data.length);
                          if (ttest_2sample_2 > (0.01 / genome_size) * bin_size * (n + n_right)) { continue }
                      }

                      var ttest_1sample_1 = t_test_1_sample(this.mean, seg_array.mean, seg_array.std, seg_array.data.length);
                      if (ttest_1sample_1 > 0.05) { continue }
                      let segments_rd = nm_levels.slice(seg[0], seg[1]);
                      var raw_seg_data = new DataStat(segments_rd);

                      masked.fill(true, seg[0], seg[1]);
                      levels.fill(raw_seg_data.mean, seg[0], seg[1]);
                  }
              });

              ChrLevels[chr] = levels;

          });
          return ChrLevels
      }
      call_mean_shift(repeats = 3) {
          const bin_size = 1000;
          // const genome_size = bin_size * this.rd.length;
          const genome_size = 2871000000;
          var masked = new Array(this.rd.length).fill(false);

          // set the level
          var levels = new Array(this.rd.length);
          for (var b = 0; b < this.rd.length; b++) {
              if (!masked[b]) {
                  levels[b] = this.rd[b];
              }
          }
          this.bin_bands.forEach((bin_band, bin_band_index) => {
              // not masked levels at current bin
              // get boolean values
              var not_masked = masked.map((value, index) => {
                  return !value;
              });

              // not masked level at current bin
              // var nm_levels = not_masked.map((value, index) => {if(value) return this.rd[index]});
              var nm_levels = [];
              not_masked.forEach((value, index) => {
                  if (value) nm_levels.push(this.rd[index]);
              });

              // console.log(bin_band, nm_levels);

              // set the mask border
              var mask_borders = [0];
              var count = 0;

              for (var i = 0; i < masked.length; i++) {
                  if (masked[i]) {
                      if (count > 0) {
                          mask_borders.push(
                              mask_borders[mask_borders.length - 1] + count - 1,
                          );
                          count = 0;
                      }
                  } else {
                      count += 1;
                  }
              }

              mask_borders.shift();
              // repeating steps
              for (var step = 0; step < repeats; step++) {
                  var isig = this.get_rd_signal_bandwidth(nm_levels);
                  // console.log(isig);
                  var grad = new Array(nm_levels.length).fill(0);

                  for (var i = 0; i < nm_levels.length; i++) {
                      for (var j = i - 3 * bin_band; j <= i + 3 * bin_band + 1; j++) {
                          if (j < 0 || j >= nm_levels.length) continue;
                          if (Math.abs(i - j) >= nm_levels.length) continue;

                          var g_value =
                              (j - i) *
                              Math.exp((-0.5 * (j - i) ** 2) / bin_band ** 2) *
                              Math.exp(-0.5 * (nm_levels[i] - nm_levels[j]) ** 2 * isig[i]);
                          // console.log(g_value);
                          grad[i] += g_value;
                      }
                  }
                  // console.log(grad);

                  // get the border
                  var border = new Array();
                  for (var i = 0; i < grad.length - 1; i++) {
                      if ((grad[i] < 0) & (grad[i + 1] >= 0)) border.push(i);
                  }

                  border.push(grad.length - 1);
                  border = border.concat(mask_borders).sort((a, b) => a - b);
                  border = Array.from(new Set(border));

                  var pb = 0;
                  for (var i = 0; i < border.length; i++) {
                      var range_array = nm_levels.slice(pb, border[i] + 1);
                      var range_mean =
                          range_array.reduce((acc, n) => acc + n) / range_array.length;

                      nm_levels.fill(range_mean, pb, border[i] + 1);
                      pb = border[i] + 1;
                  }
              }

              for (var i = 0, j = 0; i < levels.length; i++) {
                  if (not_masked[i]) {
                      levels[i] = nm_levels[j];
                      j++;
                  }
              }

              //get the border
              var border = new Array();
              for (var i = 0; i < levels.length - 1; i++) {
                  //if(i == levels.length -1) continue;
                  var diff = Math.abs(levels[i + 1] - levels[i]);

                  if (diff > 0.01) border.push(i + 1);
              }

              border.unshift(0);
              border.push(levels.length);

              // reset the mask
              masked = new Array(this.rd.length).fill(false);

              // check the borders
              for (var i = 1; i < border.length; i++) {
                  var seg = [border[i - 1], border[i]];
                  var seg_left = [border[i - 1], border[i - 1]];
                  if (i > 1) {
                      seg_left[0] = border[i - 2];
                  } else continue;

                  var seg_right = [border[i], border[i]];
                  if (i < border.length - 1) {
                      seg_right[1] = border[i + 1];
                  } else continue;

                  var n = seg[1] - seg[0];
                  var n_left = seg_left[1] - seg_left[0];
                  var n_right = seg_right[1] - seg_right[0];
                  if (n <= 1) continue;
                  var seg_array = new DataStat(levels.slice(seg[0], seg[1]));

                  if (n_right <= 15 || n_left <= 15 || n <= 15) {
                      var ns = 1.8 * Math.sqrt(levels[seg_left[0]] / this.mean) * this.std;
                      if (Math.abs(levels[seg_left[0]] - levels[seg[0]]) < ns) {
                          continue;
                      }

                      ns = 1.8 * Math.sqrt(levels[seg_right[0]] / this.mean) * this.std;
                      if (Math.abs(levels[seg_right[0]] - levels[seg[0]]) < ns) {
                          continue;
                      }
                  } else {
                      var seg_left_array = levels.slice(seg_left[0], seg_left[1]);
                      var seg_left_1 = new DataStat(seg_left_array);

                      var seg_right_array = levels.slice(seg_right[0], seg_right[1]);
                      var seg_right_1 = new DataStat(seg_right_array);

                      var ttest_2sample_1 = t_test_2_samples(
                          seg_array.mean,
                          seg_array.std,
                          seg_array.data.length,
                          seg_left_1.mean,
                          seg_left_1.std,
                          seg_left_1.data.length,
                      );
                      if (
                          ttest_2sample_1 >
                          (0.01 / genome_size) * bin_size * (n + n_left)
                      ) {
                          continue;
                      }

                      var ttest_2sample_2 = t_test_2_samples(
                          seg_array.mean,
                          seg_array.std,
                          seg_array.data.length,
                          seg_right_1.mean,
                          seg_right_1.std,
                          seg_right_1.data.length,
                      );
                      if (
                          ttest_2sample_2 >
                          (0.01 / genome_size) * bin_size * (n + n_right)
                      ) {
                          continue;
                      }
                  }

                  var ttest_1sample_1 = t_test_1_sample(
                      this.mean,
                      seg_array.mean,
                      seg_array.std,
                      seg_array.data.length,
                  );
                  if (ttest_1sample_1 > 0.05) {
                      continue;
                  }
                  var raw_seg_data = new DataStat(this.rd.slice(seg[0], seg[1]));

                  masked.fill(true, seg[0], seg[1]);
                  levels.fill(raw_seg_data.mean, seg[0], seg[1]);
              }
          });
          return levels;
      }

      cnv_calling(bin_size = 100000) {
          var delta = 0.25;
          var delta = delta * this.mean;

          var min = this.mean - delta, max = this.mean + delta;
          // console.log('min: ', min, ', Max: ', max)

          // console.log('delta', delta)
          var normal_genome_size = 2971000000;

          var levels = this.meanShiftCaller();

          
          var merged_level = {};
          var cnv_levels = [];
          // var t_value = cdf(Math.abs(10), (5)) 
          // console.log('Testing student t test:', t_value)

          Object.entries(levels).forEach(([chr, chr_levels]) => {
              
              var done = false;
              while (!done) {
                  done = true;

                  //
                  // get the borders
                  //
                  var borders = new Array(1).fill(0);
                  for (let i = 0; i < chr_levels.length - 1; i++) {
                      var diff = Math.abs(chr_levels[i + 1] - chr_levels[i]);
                      if (diff > 0.01) borders.push(i + 1);
                  }
                  borders.push(chr_levels.length);

                  for (let ix = 0; ix < borders.length - 2; ix++) {
                      var v1 = Math.abs(chr_levels[borders[ix]] - chr_levels[borders[ix + 1]]);
                      // console.log(ix, v1);
                      if (v1 < delta) {
                          var v2 = v1 + 1, v3 = v1 + 1;

                          if (ix > 0) { v2 = Math.abs(chr_levels[borders[ix]] - chr_levels[borders[ix - 1]]); }
                          if (ix < borders.length - 3) { v3 = Math.abs(levels[borders[ix + 1]] - chr_levels[borders[ix + 2]]); }

                          if (v1 < v2 && v1 < v3) {
                              done = false;

                              var tmp_array = new DataStat(chr_levels.slice(borders[ix], borders[ix + 2]));
                              chr_levels.fill(tmp_array.mean, borders[ix], borders[ix + 2]);
                              borders.splice(ix + 1, ix + 1);
                          }
                      }
                  }
              }
              // console.log('updated levels', chr_levels)

              // var chr_rd = this.rd[chr]
              var chr_rd = [];
              Object.entries(this.rd[chr]).forEach(([bin, binDict]) => { chr_rd.push(binDict.binScore); });
              // console.log('cnv_calling', chr_rd)

              //
              // Calling Segments
              //

              //var flags = [""] * levels.length;
              var flags = new Array(chr_levels.length).fill("");

              // console.log('default levels', chr, chr_levels)
              var b = 0;
              var pval = (0.05 * bin_size) / normal_genome_size;
              while (b < chr_levels.length) {
                  var b0 = b, border_start = b;
                  while ((b < chr_levels.length) & (chr_levels[b] < min)) {
                      b += 1;
                  }
                  var border_end = b;

                  if (border_end > border_start + 1) {
                      // console.log('border min', border_start, border_end)
                      var adj = adjustToEvalue(this.mean, this.std, chr_rd, border_start, border_end, pval);
                      // console.log(adj)
                      if (adj) {
                          var border_start, border_end = adj;
                          flags.fill("D", border_start, border_end);
                      }
                  }
                  border_start = b;
                  while ((b < chr_levels.length) & (chr_levels[b] > max)) { b += 1; }
                  border_end = b;

                  if (border_end > border_start + 1) {
                      adj = adjustToEvalue(this.mean, this.std, chr_rd, border_start, border_end, pval);
                      // console.log(adj)
                      if (adj) {
                          (border_end = adj);
                          // flags[bs:be] = ["A"] * (be - bs)
                          flags.fill("A", border_start, border_end);
                      }
                  }
                  if (b == b0) b += 1;
              }

              //console.log(chr, 'segments', segments)
              //
              //  Calling additional deletions
              //
              b = 0;
              while (b < chr_levels.length) {
                  while ((b < chr_levels.length) & (flags[b] != "")) b += 1;
                  border_start = b;
                  while ((b < chr_levels.length) & (chr_levels[b] < min)) b += 1;
                  border_end = b;
                  if (border_end > border_start + 1) {
                      if (gaussianEValue(this.mean, this.std, chr_rd, border_start, border_end) < 0.05 / normal_genome_size) {
                          flags.fill(["d"] * (border_end - border_start), border_start, border_end);
                      }
                      b -= 1;
                  }
                  b += 1;
              }

              b = 0;
              var cf;
              if (b < chr_levels.length) cf = flags[b];

              border_start = 0;

              //var merge = [...this.rd]
              var merge = [...chr_rd];
              // console.log('initial merge', merge)
              while (b < chr_levels.length) {
                  while (flags[b] == cf) {
                      b += 1;
                      if (b >= flags.length) break;
                  }
                  if (b > border_start) {
                      var merge_arr = new DataStat(merge.slice(border_start, b));
                      merge.fill(merge_arr.mean, border_start, b);
                  }
                  if (b < chr_levels.length) cf = flags[b];
                  border_start = b;
              }

              merged_level[chr] = merge;


              //
              // calculate calls
              // 
              b = 0;
              while (b < chr_levels.length) {
                  cf = flags[b];
                  if (cf == "") {
                      b += 1;
                      continue
                  }
                  border_start = b;
                  while (b < chr_levels.length & cf == flags[b]) { b += 1; }
                  var border_arr = new DataStat(merge.slice(border_start, b));
                  let cnv = border_arr.mean / this.mean;
                  let event_type;
                  if (cf == "D") {
                      event_type = "deletion";
                  } else {
                      event_type = "duplication";
                  }
                  let cnv_dict = {
                      chr: chr,
                      start: bin_size * border_start + 1,
                      end: bin_size * b,
                      size: bin_size * (b - border_start + 1),
                      value: cnv * 2,
                      event_type: event_type
                  };
                  cnv_levels.push(cnv_dict);

              }
          });

          return [merged_level, cnv_levels]
      }
  }



  var read_depth_caller = { Partition };

  class CNVpytorVCF {
      constructor(allVariants, binSize) {
          this.allVariants = allVariants;
          this.rowBinSize = 10000;
          this.binSize = binSize;
          this.binFactor = binSize / this.rowBinSize;

      }

      async computeDepthFeatures() {

          const chromosomes = Object.keys(this.allVariants);
          const wigFeatures = [];

          for (let chr of chromosomes) {
              const variants = this.allVariants[chr];
              if (variants.length === 0) continue

              const firstSnp = variants[0];

              let sum = 0;
              let count = 0;
              let binStart = firstSnp.start = firstSnp.start % this.binSize;   // Place start at integer multiple of binSize
              let binEnd = binStart + this.binSize;
              let featureBin = 0;

              for (let snp of variants) {
                  const position = snp.start + 1;    // Convert from 0-base to 1-base coords
                  featureBin = Math.max(Math.floor((snp.start - 1) / this.binSize), 0);
                  if (position > binEnd) {

                      if (count > 0) {
                          wigFeatures.push({ chr, start: binStart, end: binEnd, value: sum, bin: featureBin, count: count });
                      }

                      // Start new bin
                      sum = 0;
                      //count = 0
                      binStart = snp.start - snp.start % this.binSize;
                      binEnd = binStart + this.binSize;
                  }

                  const dpValue = snp.calls[9].info["DP"];
                  // const dpValue = snp.getInfo("DP")

                  if (dpValue) {
                      sum += Number.parseInt(dpValue);
                      count++;
                  }
              }

              // final bin
              if (count > 0) {
                  wigFeatures.push({ chr, start: binStart, end: binEnd, value: sum, bin: featureBin, count: count });
              }
          }

          return wigFeatures
      }

      // for for read depth calculation
      async computeReadDepth() {
          const chromosomes = Object.keys(this.allVariants);
          var wigFeatures = {};

          for (let chr of chromosomes) {
              const variants = this.allVariants[chr];
              var featureBin;
              if (variants.length === 0) continue
              for (let snp of variants) {
                  featureBin = Math.max(Math.floor(snp.start / this.rowBinSize), 0);
                  if (!wigFeatures[chr]) { wigFeatures[chr] = []; }
                  if (!wigFeatures[chr][featureBin]) {

                      wigFeatures[chr][featureBin] = {
                          chr,
                          start: featureBin * this.rowBinSize,
                          end: (featureBin + 1) * this.rowBinSize,
                          value: 0,
                          sum_score: 0,
                          count: 0,
                      };
                  }
                  const dpValue = snp.calls[9].info["DP"];
                  if (dpValue) {
                      // sum += Number.parseInt(dpValue)
                      wigFeatures[chr][featureBin].sum_score += Number.parseInt(dpValue);
                      wigFeatures[chr][featureBin].count++;
                  }

              }
              // for last bin
              //let last_bin = wigFeatures[chr][featureBin]
              //last_bin.value = parseInt(last_bin.sum_score / last_bin.count) * 100
          }

          // adjust the bin values to actual bin size
          var avgbin = {};
          for (let chr of chromosomes) {
              if (!avgbin[chr]) { avgbin[chr] = []; }
              for (let k = 0; k < wigFeatures[chr].length / this.binFactor; k++) {
                  const featureBin = k;
                  if (!avgbin[chr][k]) {
                      avgbin[chr][k] = {
                          chr,
                          binScore: 0,
                          start: featureBin * this.binSize,
                          end: (featureBin + 1) * this.binSize,
                      };
                  }

                  for (var j = k * 10; j < 10 * k + 10; j++) {
                      if (wigFeatures[chr][j]) {
                          var tmp_score = parseInt(wigFeatures[chr][j].sum_score / wigFeatures[chr][j].count) * 100;
                          avgbin[chr][k].binScore += tmp_score;
                      }
                  }
              }
          }

          var finalFeatureSet = this.readDepthMeanshift(avgbin);
          return finalFeatureSet

      }
      readDepthMeanshift(wigFeatures) {

          // Get global mean and standrad deviation
          var fit_info = new g_utils.GetFit(wigFeatures);
          var [globamMean, globalStd] = fit_info.fit_data();

          // Apply partition method
          var partition = new read_depth_caller.Partition(wigFeatures, globamMean, globalStd);
          var partition_array = partition.meanShiftCaller();
          var caller_array = partition.cnv_calling();

          // Assign the partition values to each bin
          Object.entries(wigFeatures).forEach(([chr, chr_rd]) => {
              chr_rd.forEach((bin, index) => {
                  bin.partition_level = parseInt(partition_array[chr][index]);
                  bin.partition_call = parseInt(caller_array[0][chr][index]);
              });
          });

          var rawbinScore = this.formatDataStructure(wigFeatures, 'binScore', globamMean);
          var partition_levels = this.formatDataStructure(wigFeatures, 'partition_level', globamMean);
          var partition_call = this.formatDataStructure(wigFeatures, 'partition_call', globamMean);

          return [rawbinScore, partition_levels, partition_call, caller_array[1]]

      }
      formatDataStructure(wigFeatures, feature_column, scaling_factor = 1) {
          const results = [];
          for (const [chr, wig] of Object.entries(wigFeatures)) {

              wig.forEach(sample => {
                  var new_sample = { ...sample };
                  if (scaling_factor != 1) {
                      new_sample.value = sample[feature_column] / scaling_factor * 2;
                  }
                  results.push(new_sample);
              });
          }

          return results
      }

      async computeBAF_v2() {

          const chromosomes = Object.keys(this.allVariants);
          const wigFeatures = {};
          const baf1 = [], baf2 = [];

          for (let chr of chromosomes) {
              const variants = this.allVariants[chr];
              if (variants.length === 0) continue
              var featureBin;
              for (let snp of variants) {
                  featureBin = Math.max(Math.floor(snp.start / this.binSize), 0);

                  if (!wigFeatures[chr]) {
                      wigFeatures[chr] = [];
                  }
                  if (!wigFeatures[chr][featureBin]) {
                      if (featureBin > 0) {
                          // calculating the BAF likelihood for previous bin
                          let previous_featureBin = featureBin - 1;
                          if (wigFeatures[chr][previous_featureBin]) {

                              const updated_bin = this.get_max_min_score(wigFeatures[chr][previous_featureBin]);

                              if (updated_bin.value != 0.5) {
                                  let baf_wig = Object.assign({}, updated_bin);
                                  baf_wig.value = -2 * (1 - updated_bin.value);
                                  baf2.push(baf_wig);
                              }
                              updated_bin.value = - 2 * updated_bin.value;
                              wigFeatures[chr][previous_featureBin] = updated_bin;

                              baf1.push(wigFeatures[chr][previous_featureBin]);

                          }
                      }
                      wigFeatures[chr][featureBin] = {
                          chr,
                          start: featureBin * this.binSize,
                          end: (featureBin + 1) * this.binSize,
                          value: 0,
                          count: 0,
                          likelihood_score: [],
                          min_score: 0,
                      };
                  }
                  const calls = snp.calls[9];
                  let genotype = calls.genotype;
                  let ad_score = calls.info["AD"].split(',');
                  let ad_a = ad_score[0], ad_b = ad_score[1];

                  if ((genotype[0] == 0 && genotype[1] == 1) || (genotype[0] == 1 && genotype[1] == 0)) {
                      //apply the beta function
                      if (wigFeatures[chr][featureBin].likelihood_score.length == 0) {
                          wigFeatures[chr][featureBin].likelihood_score = g_utils.linspace(0, 1, 100).map((value, index) => {
                              return beta(ad_a, ad_b, value);
                          });
                      } else {
                          var sum = 0;

                          wigFeatures[chr][featureBin].likelihood_score = g_utils.linspace(0, 1, 100).map((value, index) => {
                              var likelihood_value = wigFeatures[chr][featureBin].likelihood_score[index] * beta(ad_a, ad_b, value);
                              sum = sum + likelihood_value;
                              return likelihood_value;
                          });

                          wigFeatures[chr][featureBin].likelihood_score = g_utils.linspace(0, 1, 100).map((value, index) => {
                              return wigFeatures[chr][featureBin].likelihood_score[index] / sum;
                          });
                      }
                      wigFeatures[chr][featureBin].count++;
                  }
              }

              // last feature bin
              const updated_bin = this.get_max_min_score(wigFeatures[chr][featureBin]);

              if (updated_bin.value != 0.5) {
                  let baf_wig = Object.assign({}, updated_bin);
                  baf_wig.value = -2 * (1 - updated_bin.value);
                  baf2.push(baf_wig);
              }
              updated_bin.value = -2 * updated_bin.value;
              wigFeatures[chr][featureBin] = updated_bin;
              baf1.push(wigFeatures[chr][featureBin]);
          }

          return [baf1, baf2]

      }


      format_BAF_likelihood(wigFeatures) {
          const results = [];

          for (const [chr, wig] of Object.entries(wigFeatures)) {
              wig.forEach(sample => {
                  var new_sample = { ...sample };
                  if (sample.value != 0.5) {
                      new_sample.value = 1 - sample.value;
                      results.push(new_sample);
                  }
              });
          }
          return results
      }

      get_max_min_score(sample) {

          if (sample.likelihood_score.length > 0) {
              const max = Math.max(...sample.likelihood_score);
              const res = sample.likelihood_score.indexOf(max);
              sample.value = Math.max(res / 100, 1 - res / 100);
              sample.min_score = Math.min(res / 100, 1 - res / 100);

          } else {
              sample.score = 0;
          }

          return sample
      }

      async getAllbins() {
          const bins = await this.computeDepthFeatures();

          //console.log('getAllbins', bins["value"])

          const fitter = new g_utils.GetFit(bins);

          fitter.fit_data();
          //  dconsole.log('rd list', distParams)

          return bins
      }

      async read_rd_baf(caller='ReadDepth'){
          
          const chromosomes = Object.keys(this.allVariants);
          var wigFeatures = {};

          for (let chr of chromosomes) {
              const variants = this.allVariants[chr];
              var featureBin;
              if (variants.length === 0) continue
              for (let snp of variants) {
                  featureBin = Math.max(Math.floor(snp.start / this.rowBinSize), 0);
                  if (!wigFeatures[chr]) { wigFeatures[chr] = []; }
                  if (!wigFeatures[chr][featureBin]) {

                      wigFeatures[chr][featureBin] = {
                          chr,
                          start: featureBin * this.rowBinSize,
                          end: (featureBin + 1) * this.rowBinSize,
                          // value: 0,
                          dp_sum_score: 0,
                          dp_count: 0,
                          hets_count:0,
                          hets: [],
                          //likelihood_score: [],
                      };
                  }
                  const calls = snp.calls[9];
                  const dpValue = calls.info["DP"];
                  if (dpValue) {
                      
                      wigFeatures[chr][featureBin].dp_sum_score += Number.parseInt(dpValue);
                      wigFeatures[chr][featureBin].dp_count++;
                  }
                  
                  let ad_score = calls.info["AD"].split(',');
                  let genotype = calls.genotype;
                  if ((genotype[0] == 0 && genotype[1] == 1) || (genotype[0] == 1 && genotype[1] == 0)) {
                      //apply the beta function
                      wigFeatures[chr][featureBin].hets_count++;
                      let ad_a = parseInt(ad_score[0]), ad_b = parseInt(ad_score[1]);
                      wigFeatures[chr][featureBin].hets.push({ref:ad_a, alt:ad_b});
                  }
             
              }
          
          }
      
          var avgbin = this.adjust_bin_size(wigFeatures);
          var finalFeatureSet;
          if(caller == 'ReadDepth'){
              finalFeatureSet = this.readDepthMeanshift(avgbin);
              var baf = this.formatDataStructure_BAF(avgbin, 'max_likelihood');
          }else if(caller=='2D'){
              
              let caller_obj = new combined_caller.CombinedCaller(avgbin,  this.binSize);        
              let processed_bins = await caller_obj.call_2d();
              
              finalFeatureSet = [processed_bins.binScore, [], processed_bins.segment_score];
      
              var baf = caller_obj.formatDataStructure_BAF('max_likelihood');
          }
          

          return [finalFeatureSet, baf]
      }

      formatDataStructure_BAF(wigFeatures, feature_column, scaling_factor = 2) {
          const baf1 = [];
          const baf2 = [];
          for (const [chr, wig] of Object.entries(wigFeatures)) {

              wig.forEach(sample => {
                  delete sample.likelihood_score;
                  var baf1_value = { ...sample };
                  var baf2_value = { ...sample };
                  
                  let value = sample[feature_column];
                  if (value != 0.5){
                      baf2_value.value = -2 * (1 - value);
                      baf2.push(baf2_value);
                  }
                  baf1_value.value = -2 * value;
                  baf1.push(baf1_value);
                      
              });
          }
          

          return [baf1, baf2]
      }
      
      adjust_bin_size(wigFeatures){
          const chromosomes = Object.keys(this.allVariants);
          // adjust the bin values to actual bin size
          var avgbin = {};
          for (let chr of chromosomes) {
              if (!avgbin[chr]) { avgbin[chr] = []; }
              for (let k = 0; k < wigFeatures[chr].length / this.binFactor; k++) {
                  const featureBin = k;
                  if (!avgbin[chr][k]) {
                      avgbin[chr][k] = {
                          chr,
                          start: featureBin * this.binSize,
                          end: (featureBin + 1) * this.binSize,
                          dp_count: 0,
                          hets_count: 0,
                          binScore: 0,
                          likelihood_score: [],
                      };
                  }

                  for (var j = k * 10; j < 10 * k + 10; j++) {
                     
                      if (wigFeatures[chr][j]) {
                          var tmp_score = parseInt(wigFeatures[chr][j].dp_sum_score / wigFeatures[chr][j].dp_count) * 100;
                          avgbin[chr][k].binScore += tmp_score;
                          avgbin[chr][k].dp_count += wigFeatures[chr][j].dp_count;
                          avgbin[chr][k].hets_count += wigFeatures[chr][j].hets_count;

                          if (wigFeatures[chr][j].hets.length != 0){
                          
                              
                              wigFeatures[chr][j].hets.forEach((hets, hets_idx) => {
                                  if(avgbin[chr][k].likelihood_score.length == 0){
                                      avgbin[chr][k].likelihood_score = g_utils.linspace(0, 1, 100).map((value, index) => {
                                          return beta(hets.ref, hets.alt, value);
                                      });
                                  }
                                  else {
                                      var likelihood_sum = 0;
                                      avgbin[chr][k].likelihood_score = g_utils.linspace(0, 1, 100).map((value, index) => {
                                          var likelihood_value = avgbin[chr][k].likelihood_score[index] * beta(hets.ref, hets.alt, value);
                                          likelihood_sum += likelihood_value;
                                          return likelihood_value;
                                      });

                                      avgbin[chr][k].likelihood_score = g_utils.linspace(0, 1, 100).map((value, index) => {
                                          return avgbin[chr][k].likelihood_score[index] / likelihood_sum;
                                      });
                         
                                  }
                              });
                              
                              // avgbin[chr][k].likelihood_score *= wigFeatures[chr][j].likelihood_score
                          }
                      }
                  }

                  const updated_bin = this.get_max_min_score(avgbin[chr][k]);
                  avgbin[chr][k].max_likelihood = updated_bin.value;
              }
          }
          return avgbin
      }

  }

  function beta(a, b, p, phased = true) {
      return p ** a * (1 - p) ** b + p ** b * (1 - p) ** a;
  }

  /*
  * The MIT License (MIT)
  *
  * Copyright (c) 2016-2017 The Regents of the University of California
  * Author: Arijit Panda
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in
  * all copies or substantial portions of the Software.
  *
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */


  /**
   * Represents 2 or more wig tracks overlaid on a common viewport.
   */

  const DEFAULT_TRACK_HEIGHT = 250;

  class CNVPytorTrack extends TrackBase {

      constructor(config, browser) {
          super(config, browser);
          this.featureType = 'numeric';
          this.paintAxis = paintAxis;
          
          if (!config.max) {
              this.defaultScale = true;
              this.autoscale = false;
          }

          // Invoke height setter last to allocated to coverage and alignment tracks
          this.height = (config.height !== undefined ? config.height : DEFAULT_TRACK_HEIGHT);
      }

      async init(config) {

          this.type = "cnvpytor";
          this.graphType = config.graphType || "points";
          this.bin_size = config.bin_size || 100000;
          this.signal_name = config.signal_name || "rd_snp";
          this.cnv_caller = config.cnv_caller || '2D';
          this.colors = config.colors || ['gray', 'black', 'green', 'blue'];
          super.init(config);

      }

      get supportsWholeGenome() {
          return true
      }

      get_signals() {
          let signals = [];

          if (this.signal_name == 'rd_snp') {
              signals = ["RD_Raw", "RD_Raw_gc_coor", this.cnv_caller, "BAF1", "BAF2"];

          } else if (this.signal_name == 'rd') {
              signals = ["RD_Raw", "RD_Raw_gc_coor", this.cnv_caller];

          } else if (this.signal_name == 'snp') {
              signals = ["BAF1", "BAF2"];

          } else if (this.signal_name == 'cnh') {
              signals = [this.cnv_caller];
          }
          return signals
      }

      get_signal_colors() {
          
          let signal_colors = [
              { singal_name: 'RD_Raw', color: this.colors[0] },
              { singal_name: 'RD_Raw_gc_coor', color: this.colors[1] },
              { singal_name: 'ReadDepth', color: this.colors[2] },
              { singal_name: '2D', color: this.colors[2] },
              { singal_name: 'BAF1', color: this.colors[3] },
              { singal_name: 'BAF2', color: this.colors[3] },
          ];
          return signal_colors
      }

      async postInit() {

          if (this.config.format == 'vcf') {
              this.featureSource = FeatureSource(this.config, this.browser.genome);
              this.header = await this.getHeader();


              var allVariants = this.featureSource.reader.features.reduce(function (r, a) {
                  r[a.chr] = r[a.chr] || [];
                  r[a.chr].push(a);
                  return r
              }, Object.create(null));

              const cnvpytor_obj = new CNVpytorVCF(allVariants, this.bin_size);
              
              let wigFeatures;
              let bafFeatures;
              this.wigFeatures_obj = {};
              this.wigFeatures_obj[this.bin_size] = {};

              let dataWigs;
              if(this.config.cnv_caller == '2D'){
                  
                  dataWigs = await cnvpytor_obj.read_rd_baf('2D');

                  wigFeatures = dataWigs[0];
                  bafFeatures = dataWigs[1];
                  this.wigFeatures_obj[this.bin_size]['2D'] = wigFeatures[2];

                  this.available_callers = ['2D'];
              }else {
                  dataWigs = await cnvpytor_obj.read_rd_baf();
                  wigFeatures = dataWigs[0];
                  bafFeatures = dataWigs[1];
                  this.wigFeatures_obj[this.bin_size]['ReadDepth'] = wigFeatures[2];
                  this.available_callers = ['ReadDepth'];
              }
              
              this.wigFeatures_obj[this.bin_size]['RD_Raw'] = wigFeatures[0];
              this.wigFeatures_obj[this.bin_size]['RD_Raw_gc_coor'] = wigFeatures[1];
              this.wigFeatures_obj[this.bin_size]['BAF1'] = bafFeatures[0];
              this.wigFeatures_obj[this.bin_size]['BAF2'] = bafFeatures[1];
              
              this.available_bins = [this.bin_size];
              
              this.set_available_callers();

          } else {
              this.cnvpytor_obj =   new HDF5Reader(this.config.url, this.bin_size);
              this.wigFeatures_obj = await this.cnvpytor_obj.get_rd_signal(this.bin_size);
              this.available_bins = this.cnvpytor_obj.available_bins;
              this.available_callers = this.cnvpytor_obj.callers;
              this.set_available_callers();
          }

          this.tracks = [];
          const p = [];

          this.signals = this.get_signals();
          this.signal_colors = this.get_signal_colors();

          for (let bin_size in this.wigFeatures_obj) {

              for (const [signal_name, wig] of Object.entries(this.wigFeatures_obj[bin_size])) {

                  if (this.signals.includes(signal_name)) {
                      let tconf = {};
                      tconf.type = "wig";
                      tconf.isMergedTrack = true;
                      tconf.features = wig;
                      tconf.name = signal_name;
                      tconf.color = this.signal_colors.filter(x => x.singal_name === signal_name).map(x => x.color);
                      const t = await this.browser.createTrack(tconf);
                      if (t) {
                          t.autoscale = false;     // Scaling done from merged track
                          this.tracks.push(t);
                      } else {
                          console.warn("Could not create track " + tconf);
                      }

                      if (typeof t.postInit === 'function') {
                          p.push(t.postInit());
                      }
                  }
              }

          }


          this.flipAxis = this.config.flipAxis ? this.config.flipAxis : false;
          this.logScale = this.config.logScale ? this.config.logScale : false;
          this.autoscale = this.config.autoscale;
          if (!this.autoscale) {
              this.dataRange = {
                  min: this.config.min || 0,
                  max: this.config.max
              };
          }
          for (let t of this.tracks) {
              t.autoscale = false;
              t.dataRange = this.dataRange;
          }

          return Promise.all(p)
      }

      set_available_callers() {
          if (!this.available_callers.includes(this.cnv_caller)) {
              if (this.available_callers.length > 0) {
                  this.cnv_caller = this.available_callers[0];
              } else {
                  this.cnv_caller = null;
              }
          }
      }

      async getHeader() {

          if (!this.header) {
              if (typeof this.featureSource.getHeader === "function") {
                  const header = await this.featureSource.getHeader();
                  if (header) {
                      this.callSets = header.callSets || [];
                  }
                  this.header = header;
              }
              this.sampleNames = this.callSets ? this.callSets.map(cs => cs.name) : [];
          }

          return this.header
      }

      get height() {
          return this._height
      }

      set height(h) {
          this._height = h;
          if (this.tracks) {
              for (let t of this.tracks) {
                  t.height = h;
                  t.config.height = h;
              }
          }
      }

      menuItemList() {
          let items = [];

          if (this.flipAxis !== undefined) {
              items.push({
                  label: "Flip y-axis",
                  click: () => {
                      this.flipAxis = !this.flipAxis;
                      this.trackView.repaintViews();
                  }
              });
          }

          items = items.concat(MenuUtils.numericDataMenuItems(this.trackView));

          items.push('<hr/>');
          items.push("Bin Sizes");
          for (let rd_bin of this.available_bins) {
              const checkBox = createCheckbox(rd_bin, rd_bin === this.bin_size);
              items.push({
                  object: $$1(checkBox),
                  click: async () => {
                      this.bin_size = rd_bin;

                      await this.recreate_tracks(rd_bin);
                      this.clearCachedFeatures();
                      this.trackView.updateViews();
                      this.trackView.repaintViews();
                  }
              });
          }
          items.push('<hr/>');
          items.push("Signal Type");

          let signal_dct = {"rd_snp": "RD and BAF Likelihood", "rd": "RD Signal", "snp": "BAF Likelihood"};
          for (let signal_name in signal_dct) {
              const checkBox = createCheckbox(signal_dct[signal_name], signal_name === this.signal_name);
              items.push({
                  object: $$1(checkBox),
                  click: async () => {
                      this.signal_name = signal_name;
                      await this.recreate_tracks(this.bin_size);
                      this.clearCachedFeatures();
                      this.trackView.updateViews();
                      this.trackView.repaintViews();

                  }
              });
          }

          // cnv caller setting
          items.push('<hr/>');
          items.push("CNV caller");
          for (let cnv_caller of this.available_callers) {
              const checkBox = createCheckbox(cnv_caller, cnv_caller === this.cnv_caller);
              items.push({
                  object: $$1(checkBox),
                  click: async () => {
                      this.cnv_caller = cnv_caller;
                      await this.recreate_tracks(this.bin_size);
                      this.clearCachedFeatures();
                      this.trackView.updateViews();
                      this.trackView.repaintViews();
                  }
              });
          }

          return items
      }

      async recreate_tracks(bin_size) {
          this.tracks = [];
          const p = [];

          if (!(bin_size in this.wigFeatures_obj)) {
              this.wigFeatures_obj = {...this.wigFeatures_obj, ...await this.cnvpytor_obj.get_rd_signal(bin_size)};
          }

          this.signals = this.get_signals();
          this.signal_colors = this.get_signal_colors();

          for (const [signal_name, wig] of Object.entries(this.wigFeatures_obj[bin_size])) {
              if (this.signals.includes(signal_name)) {
                  let tconf = {};
                  tconf.type = "wig";
                  tconf.isMergedTrack = true;
                  tconf.features = wig;
                  tconf.name = signal_name;
                  tconf.color = this.signal_colors.filter(x => x.singal_name === signal_name).map(x => x.color); 
                  const t = await this.browser.createTrack(tconf);
                  if (t) {
                      t.autoscale = false;     // Scaling done from merged track
                      this.tracks.push(t);
                  } else {
                      console.warn("Could not create track " + tconf);
                  }

                  if (typeof t.postInit === 'function') {
                      p.push(t.postInit());
                  }
              }

          }


          this.flipAxis = this.config.flipAxis ? this.config.flipAxis : false;
          this.logScale = this.config.logScale ? this.config.logScale : false;
          this.autoscale = this.config.autoscale;
          if (!this.autoscale) {
              this.dataRange = {
                  min: this.config.min || 0,
                  max: this.config.max
              };
          }
          for (let t of this.tracks) {
              t.autoscale = false;
              t.dataRange = this.dataRange;
          }
          return Promise.all(p)
      }

      async getFeatures(chr, bpStart, bpEnd, bpPerPixel) {

          if(this.tracks) {
              const promises = this.tracks.map((t) => t.getFeatures(chr, bpStart, bpEnd, bpPerPixel));
              return Promise.all(promises)
          } else {
              return undefined  // This can happen if a redraw is triggered before the track has initialized.
          }
      }

      // TODO: refactor to igvUtils.js
      getScaleFactor(min, max, height, logScale) {
          const scale = logScale ? height / (Math.log10(max + 1) - (min <= 0 ? 0 : Math.log10(min + 1))) : height / (max - min);
          return scale
      }

      computeYPixelValue(yValue, yScaleFactor) {
          return (this.flipAxis ? (yValue - this.dataRange.min) : (this.dataRange.max - yValue)) * yScaleFactor
      }

      computeYPixelValueInLogScale(yValue, yScaleFactor) {
          let maxValue = this.dataRange.max;
          let minValue = this.dataRange.min;
          if (maxValue <= 0) return 0 // TODO:
          if (minValue <= -1) minValue = 0;
          minValue = (minValue <= 0) ? 0 : Math.log10(minValue + 1);
          maxValue = Math.log10(maxValue + 1);
          yValue = Math.log10(yValue + 1);
          return ((this.flipAxis ? (yValue - minValue) : (maxValue - yValue)) * yScaleFactor)
      }

      draw(options) {

          // const mergedFeatures = options.features    // Array of feature arrays, 1 for each track
          const mergedFeatures = options.features;
          if(!mergedFeatures) return

          if (this.defaultScale) {
              if (this.signal_name == 'rd_snp') {
                  this.dataRange = {
                      min: this.config.min || this.dataRange.min || -2,
                      max: this.config.max || this.dataRange.max || 6
                  };
              } else if (this.signal_name == 'rd') {
                  this.dataRange = {
                      min: this.config.min || this.dataRange.min || 0,
                      max: this.config.max || this.dataRange.max || 6
                  };
              } else if (this.signal_name == 'snp') {
                  this.dataRange = {
                      min: this.config.min || this.dataRange.min || -2,
                      max: this.config.max || this.dataRange.max || 0
                  };
              }
          }

          if (this.autoscale) {
              this.dataRange = autoscale(options.referenceFrame.chr, mergedFeatures);
          }

          if(this.tracks) {
              for (let i = 0, len = this.tracks.length; i < len; i++) {
                  const trackOptions = Object.assign({}, options);
                  trackOptions.features = mergedFeatures[i];
                  this.tracks[i].dataRange = this.dataRange;
                  this.tracks[i].flipAxis = this.flipAxis;
                  this.tracks[i].logScale = this.logScale;
                  if (this.graphType) {
                      this.tracks[i].graphType = this.graphType;
                  }
                  this.tracks[i].draw(trackOptions);
              }
          }

          // guides lines
          const scaleFactor = this.getScaleFactor(this.dataRange.min, this.dataRange.max, options.pixelHeight, this.logScale);
          const yScale = (yValue) => this.logScale
              ? this.computeYPixelValueInLogScale(yValue, scaleFactor)
              : this.computeYPixelValue(yValue, scaleFactor);

           // Draw guidelines
           if (this.config.hasOwnProperty('guideLines')) {
              for (let line of this.config.guideLines) {
                  if (line.hasOwnProperty('color') && line.hasOwnProperty('y') && line.hasOwnProperty('dotted')) {
                      let y = yScale(line.y);
                      let props = {
                          'strokeStyle': line['color'],
                          'strokeWidth': 1
                      };
                      if (line['dotted']) IGVGraphics.dashedLine(options.context, 0, y, options.pixelWidth, y, 5, props);
                      else IGVGraphics.strokeLine(options.context, 0, y, options.pixelWidth, y, props);
                  }
              }
          }
      }

      popupData(clickState, features) {

          const featuresArray = features || clickState.viewport.cachedFeatures;

          if (featuresArray && featuresArray.length === this.tracks.length) {
              // Array of feature arrays, 1 for each track
              const popupData = [];
              for (let i = 0; i < this.tracks.length; i++) {
                  if (i > 0) popupData.push('<hr/>');
                  popupData.push(`<div style=background-color:rgb(245,245,245);border-bottom-style:dashed;border-bottom-width:1px;padding-bottom:5px;padding-top:10px;font-weight:bold;font-size:larger >${this.tracks[i].name}</div>`);
                  const trackPopupData = this.tracks[i].popupData(clickState, featuresArray[i]);
                  popupData.push(...trackPopupData);

              }
              return popupData
          }
      }

  }

  function autoscale(chr, featureArrays) {

      let min = 0;
      let max = -Number.MAX_VALUE;
      for (let features of featureArrays) {
          for (let f of features) {
              if (typeof f.value !== 'undefined' && !Number.isNaN(f.value)) {
                  min = Math.min(min, f.value);
                  max = Math.max(max, f.value);
              }
          }
      }
      return {min: min, max: max}
  }

  //import CNVPytorTrack from "./CNVpytor/cnvpytorTrack.js"


  const trackFunctions =
      new Map([
          ['ideogram', (config, browser) => new IdeogramTrack(config, browser)],
          ['sequence', (config, browser) => new SequenceTrack(config, browser)],
          ['feature', (config, browser) => new FeatureTrack(config, browser)],
          ['seg', (config, browser) => new SegTrack(config, browser)],
          ['mut', (config, browser) => new SegTrack(config, browser)],
          ['maf', (config, browser) => new SegTrack(config, browser)],
          ['wig', (config, browser) => new WigTrack(config, browser)],
          ['merged', (config, browser) => new MergedTrack(config, browser)],
          ['alignment', (config, browser) => new BAMTrack(config, browser)],
          ['interaction', (config, browser) => new InteractionTrack(config, browser)],
          ['interact', (config, browser) => new InteractionTrack(config, browser)],
          ['variant', (config, browser) => new VariantTrack(config, browser)],
          ['eqtl', (config, browser) => new EqtlTrack(config, browser)],
          ['gwas', (config, browser) => new GWASTrack(config, browser)],
          ['arc', (config, browser) => new RnaStructTrack(config, browser)],
          ['gcnv', (config, browser) => new GCNVTrack(config, browser)],
          ['junction', (config, browser) => new SpliceJunctionTrack(config, browser)],
          ['blat', (config, browser) => new BlatTrack(config, browser)],
          ['cnvpytor', (config, browser) => new CNVPytorTrack(config, browser)]
      ]);


  /**
   * Add a track constructor  the the factory lookup table.
   *
   * @param type
   * @param track
   */
  const addTrackCreatorFunction = function (type, track) {
      trackFunctions.set(type, track);
  };

  const getTrack = function (type, config, browser) {

      let trackKey;
      switch (type) {
          case "annotation":
          case "genes":
          case "fusionjuncspan":
          case "snp":
              trackKey = "feature";
              break
          case 'seg':
          case 'maf':
          case 'mut':
              trackKey = 'seg';
              break
          case 'junctions':
          case 'splicejunctions':
              trackKey = 'junction';
              break
          default:
              trackKey = type;
      }

      return trackFunctions.has(trackKey) ?
          trackFunctions.get(trackKey)(config, browser) :
          undefined
  };

  var TrackFactory = {
      tracks: trackFunctions,
      addTrack: addTrackCreatorFunction,
      trackFunctions,
      addTrackCreatorFunction,
      getTrack
  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */


  /**
   * Minimal support for the legacy IGV desktop session format.
   */

  class XMLSession {

      constructor(xmlString, knownGenomes) {

          const parser = new DOMParser();
          const xmlDoc = parser.parseFromString(xmlString, "text/xml");

          this.processRootNode(xmlDoc, knownGenomes);

          const resourceElements = xmlDoc.getElementsByTagName("Resource");
          const trackElements = xmlDoc.getElementsByTagName("Track");
          const hasTrackElements = trackElements && trackElements.length > 0;

          const tracks = [];
          this.tracks = tracks;

          const resourceMap = new Map();
          Array.from(resourceElements).forEach(function (r, idx) {
              var config = {
                  url: r.getAttribute("path"),
                  indexURL: r.getAttribute("index"),
                  order: idx
              };
              resourceMap.set(config.url, config);
              if (!hasTrackElements) {
                  tracks.push(config);
              }
          });

          // Check for optional Track section
          if (hasTrackElements) {

              Array.from(trackElements).forEach(function (track) {

                  const subtracks = track.getElementsByTagName("Track");

                  if (subtracks && subtracks.length > 0) {

                      const mergedTrack = {
                          type: 'merged',
                          tracks: []
                      };
                      extractTrackAttributes(track, mergedTrack);

                      tracks.push(mergedTrack);

                      Array.from(subtracks).forEach(function (t) {
                          t.processed = true;
                          const id = t.getAttribute("id");
                          const config = resourceMap.get(id);
                          if (config) {
                              mergedTrack.tracks.push(config);
                              extractTrackAttributes(t, config);
                              config.autoscale = false;
                              mergedTrack.height = config.height;

                              // Add alpha for merged track colors.  Alpha is not recorded by IGV desktop in XML session
                              //const color = t.getAttribute("color");
                              //if (color) {
                              //    config.color = "rgba(" + color + ",0.5)";
                              //}
                          }
                      });
                  } else if (!track.processed) {

                      const id = track.getAttribute("id");
                      const res = resourceMap.get(id);
                      if (res) {
                          tracks.push(res);
                          extractTrackAttributes(track, res);
                      }

                  }
              });
          }
      }

      processRootNode(xmlDoc, knownGenomes) {

          const elements = xmlDoc.getElementsByTagName("Session");
          if (!elements || elements.length === 0) ;
          const session = elements.item(0);
          const genome = session.getAttribute("genome");
          const locus = session.getAttribute("locus");
          const ucscID = session.getAttribute("ucscID");

          if (knownGenomes && knownGenomes.hasOwnProperty(genome)) {
              this.genome = genome;

          } else {
              this.reference = {
                  fastaURL: genome
              };
              if (ucscID) {
                  this.reference.id = ucscID;
              }
          }
          if (locus) {
              this.locus = locus;
          }
      }

  }


  function extractTrackAttributes(track, config) {


      config.name = track.getAttribute("name");

      const color = track.getAttribute("color");
      if (color) {
          config.color = "rgb(" + color + ")";
      }

      const altColor = track.getAttribute("altColor");
      if (color) {
          config.altColor = "rgb(" + altColor + ")";
      }

      const height = track.getAttribute("height");
      if (height) {
          config.height = parseInt(height);
      }

      const autoScale = track.getAttribute("autoScale");
      if (autoScale) {
          config.autoscale = (autoScale === "true");
      }

      const autoscaleGroup = track.getAttribute("autoscaleGroup");
      if (autoscaleGroup) {
          config.autoscaleGroup = autoscaleGroup;
      }

      const windowFunction = track.getAttribute("windowFunction");
      if (windowFunction) {
          config.windowFunction = windowFunction;
      }
      const visWindow = track.getAttribute("visibilityWindow") || track.getAttribute("featureVisibilityWindow");
      if (visWindow) {
          config.visibilityWindow = visWindow;
      }

      const indexed = track.getAttribute("indexed");
      if (indexed) {
          config.indexed = (indexed === "true");
      }

      const normalize = track.getAttribute("normalize");
      if (normalize) {
          config.normalize = normalize === "true";
      }

      const dataRangeCltn = track.getElementsByTagName("DataRange");
      if (dataRangeCltn.length > 0) {
          const dataRange = dataRangeCltn.item(0);
          config.min = Number(dataRange.getAttribute("minimum"));
          config.max = Number(dataRange.getAttribute("maximum"));
          config.logScale = dataRange.getAttribute("type") === "LOG";
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014-2015 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const splitLines = splitLines$5;

  class SampleInformation {
      constructor() {
          this.attributes = {};
          this.plinkLoaded = false;
      }

      async loadPlinkFile(url, config) {

          if (!config) config = {};

          var options = buildOptions(config);    // Add oauth token, if any
          const data = await igvxhr$1.loadString(url, options);
          var lines = splitLines(data);

          for (let line of lines) {
              var line_arr = line.split(' ');
              this.attributes[line_arr[1]] = {
                  familyId: line_arr[0],
                  fatherId: line_arr[2],
                  motherId: line_arr[3],
                  sex: line_arr[4],
                  phenotype: line_arr[5]
              };
          }
          this.plinkLoaded = true;
          return this
      }

      /**
       * Return the attributes for the given sample as a map-like object (key-value pairs)
       * @param sample
       */
      getAttributes(sample) {
          return this.attributes[sample]
      };

      getAttributeNames() {

          if (this.hasAttributes()) {
              return Object.keys(this.attributes[Object.keys(this.attributes)[0]])
          } else return []
      };

      hasAttributes() {
          return Object.keys(this.attributes).length > 0
      }
  }

  function loadPlinkFile(url, config) {
      const si = new SampleInformation();
      return si.loadPlinkFile(url, config)
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class GtexSelection {

      constructor(gene, snp) {
          this.geneColors = {};
          this.gene = null;
          this.snp = null;
          this.genesCount = 0;

          if (gene) {
              this.gene = gene.toUpperCase();
              this.geneColors[this.gene] = brewer[this.genesCount++];

          }
          if (snp) {
              this.snp = snp.toUpperCase();
          }
      }

      addGene(geneName) {
          if (!this.geneColors[geneName.toUpperCase()]) {
              this.geneColors[geneName.toUpperCase()] = brewer[this.genesCount++];
          }
      }

      colorForGene(geneName) {
          return this.geneColors[geneName.toUpperCase()]
      }
  }

  var brewer = [];
  // Set +!
  brewer.push("rgb(228,26,28)");
  brewer.push("rgb(55,126,184)");
  brewer.push("rgb(77,175,74)");
  brewer.push("rgb(166,86,40)");
  brewer.push("rgb(152,78,163)");
  brewer.push("rgb(255,127,0)");
  brewer.push("rgb(247,129,191)");
  brewer.push("rgb(153,153,153)");
  brewer.push("rgb(255,255,51)");

  // #Set 2
  brewer.push("rgb(102, 194, 165");
  brewer.push("rgb(252, 141, 98");
  brewer.push("rgb(141, 160, 203");
  brewer.push("rgb(231, 138, 195");
  brewer.push("rgb(166, 216, 84");
  brewer.push("rgb(255, 217, 47");
  brewer.push("rgb(229, 196, 148");
  brewer.push("rgb(179, 179, 179");

  //#Set 3
  brewer.push("rgb( 141, 211, 199");
  brewer.push("rgb(255, 255, 179");
  brewer.push("rgb(190, 186, 218");
  brewer.push("rgb(251, 128, 114");
  brewer.push("rgb(128, 177, 211");
  brewer.push("rgb(253, 180, 98");
  brewer.push("rgb(179, 222, 105");
  brewer.push("rgb(252, 205, 229");
  brewer.push("rgb(217, 217, 217");
  brewer.push("rgb(188, 128, 189");
  brewer.push("rgb(204, 235, 197");
  brewer.push("rgb(255, 237, 111");

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  // Reference frame classes.  Converts domain coordinates (usually genomic) to pixel coordinates

  class ReferenceFrame {

      constructor(genome, chr, start, end, bpPerPixel) {
          this.genome = genome;
          this.chr = chr;

          this.start = start;

          // TODO WARNING THIS IS NOT UPDATED !!!
          this.end = end;

          this.bpPerPixel = bpPerPixel;
          this.id = domUtils.guid();
      }

      /**
       * Extend this frame to accomodate the given locus.  Used th CircularView methods to merge 2 frames.
       * @param locus
       */
      extend(locus) {
          const newStart = Math.min(locus.start, this.start);
          const newEnd = Math.max(locus.end, this.end);
          const ratio = (newEnd - newStart) / (this.end - this.start);
          this.start = newStart;
          this.end = newEnd;
          this.bpPerPixel *= ratio;
      }

      calculateEnd(pixels) {
          return this.start + this.bpPerPixel * pixels
      }

      calculateBPP(end, pixels) {
          return (end - this.start) / pixels
      }

      set(json) {
          this.chr = json.chr;
          this.start = json.start;
          this.bpPerPixel = json.bpPerPixel;
      }

      toPixels(bp) {
          return bp / this.bpPerPixel
      }

      toBP(pixels) {
          return this.bpPerPixel * pixels
      }

      /**
       * Shift frame by stated pixels.  Return true if view changed, false if not.
       *
       * @param pixels
       * @param clamp -- if true "clamp" shift to prevent panning off edge of chromosome.  This is disabled if "show soft clipping" is on
       * @param viewportWidth
       */
      shiftPixels(pixels, viewportWidth, clamp) {

          const currentStart = this.start;
          const deltaBP = pixels * this.bpPerPixel;

          this.start += deltaBP;

          if(clamp) {
              this.clampStart(viewportWidth);
          }

          this.end = this.start + viewportWidth * this.bpPerPixel;

          return currentStart !== this.start
      }

      clampStart(viewportWidth) {
          // clamp left
          const min = (this.genome.getChromosome(this.chr).bpStart || 0);
          this.start = Math.max(min, this.start);

          // clamp right
          if (viewportWidth) {

              const {bpLength} = this.genome.getChromosome(this.chr);
              const maxStart = bpLength - (viewportWidth * this.bpPerPixel);

              if (this.start > maxStart) {
                  this.start = maxStart;
              }
          }
      }

      async zoomWithScaleFactor(browser, scaleFactor, viewportWidth, centerBPOrUndefined) {

          const centerBP = undefined === centerBPOrUndefined ? (this.start + this.toBP(viewportWidth / 2.0)) : centerBPOrUndefined;

          // save initial start and bpp
          const {start, bpPerPixel} = this.start;

          const {bpLength} = this.getChromosome();
          const bppThreshold = scaleFactor < 1.0 ? browser.minimumBases() / viewportWidth : bpLength / viewportWidth;

          // update bpp
          if (scaleFactor < 1.0) {
              this.bpPerPixel = Math.max(this.bpPerPixel * scaleFactor, bppThreshold);
          } else {
              this.bpPerPixel = Math.min(this.bpPerPixel * scaleFactor, bppThreshold);
          }

          // update start and end
          const widthBP = this.bpPerPixel * viewportWidth;
          this.start = centerBP - 0.5 * widthBP;
          this.clampStart(viewportWidth);

          this.end = this.start + widthBP;

          const viewChanged = start !== this.start || bpPerPixel !== this.bpPerPixel;
          if (viewChanged) {
              await browser.updateViews(true);
          }

      }

      getChromosome() {
          return this.genome.getChromosome(this.chr)
      }

      getMultiLocusLabelBPLengthOnly(pixels) {
          const margin = '&nbsp';
          const ss = Math.floor(this.start) + 1;
          const ee = Math.round(this.start + this.bpPerPixel * pixels);
          return `${margin}${this.chr}${margin}${prettyBasePairNumber(ee - ss)}${margin}`
      }

      getMultiLocusLabelLocusOnly(pixels) {
          const margin = '&nbsp';
          const {chr, start, end } = this.getPresentationLocusComponents(pixels);
          return `${margin}${chr}:${start}-${end}${margin}`
      }

      getMultiLocusLabel(pixels) {
          const margin = '&nbsp';
          const {chr, start, end } = this.getPresentationLocusComponents(pixels);
          const ss = Math.floor(this.start) + 1;
          const ee = Math.round(this.start + this.bpPerPixel * pixels);
          return `${margin}${chr}:${start}-${end}${margin}${margin}(${prettyBasePairNumber(ee - ss)})${margin}`
      }

      getPresentationLocusComponents(pixels) {

          if ('all' === this.chr) {
              return {chr: this.chr}
          } else {
              const ss = numberFormatter$1(Math.floor(this.start) + 1);
              const ee = numberFormatter$1(Math.round(this.start + this.bpPerPixel * pixels));

              return {chr: this.chr, start: ss, end: ee}
          }

      }

      getLocusString() {
          if ('all' === this.chr) {
              return 'all'
          } else {
              const ss = numberFormatter$1(Math.floor(this.start) + 1);
              const ee = numberFormatter$1(Math.round(this.end));
              return `${this.chr}:${ss}-${ee}`
          }
      }

      description(blurb) {
      }
  }

  function createReferenceFrameList(loci, genome, browserFlanking, minimumBases, viewportWidth, isSoftclipped) {

      return loci.map(locus => {

          // If a flanking region is defined, and the search object is a symbol ("gene") type, adjust start and end
          if (browserFlanking && locus.gene) {
              locus.start = Math.max(0, locus.start - browserFlanking);
              locus.end += browserFlanking;
          }

          // Validate the range.  This potentionally modifies start & end of locus.
          if(!isSoftclipped) {
              const chromosome = genome.getChromosome(locus.chr);
              validateGenomicExtent(chromosome.bpLength, locus, minimumBases);
          }

          const referenceFrame = new ReferenceFrame(genome,
              locus.chr,
              locus.start,
              locus.end,
              (locus.end - locus.start) / viewportWidth);

          referenceFrame.locusSearchString = locus.locusSearchString;

          // GTEX hack
          if (locus.gene || locus.snp) {
              referenceFrame.selection = new GtexSelection(locus.gene, locus.snp);
          }

          return referenceFrame
      })
  }

  const DEFAULT_SEARCH_CONFIG = {
      timeout: 5000,
      type: "plain",   // Legacy plain text support -- deprecated
      url: 'https://igv.org/genomes/locus.php?genome=$GENOME$&name=$FEATURE$',
      coords: 0,
      chromosomeField: "chromosome",
      startField: "start",
      endField: "end",
      geneField: "gene",
      snpField: "snp"
  };

  /**
   * Return an object representing the locus of the given string.  Object is of the form
   * {
   *   chr,
   *   start,
   *   end,
   *   locusSearchString,
   *   gene,
   *   snp
   * }
   * @param browser
   * @param string
   * @returns {Promise<*>}
   */
  async function search(browser, string) {

      if (undefined === string || '' === string.trim()) {
          return
      }

      if (string && string.trim().toLowerCase() === "all" || string === "*") {
          string = "all";
      }

      const loci = string.split(' ');

      let searchConfig = browser.searchConfig || DEFAULT_SEARCH_CONFIG;
      let list = [];

      const searchLocus = async (locus) => {
          let locusObject = parseLocusString(browser, locus);

          if (!locusObject) {
              const feature = browser.genome.featureDB[locus.toUpperCase()];
              if (feature) {
                  locusObject = {
                      chr: feature.chr,
                      start: feature.start,
                      end: feature.end,
                      gene: feature.name,
                      locusSearchString: string
                  };
              }
          }

          if (!locusObject && (browser.config && false !== browser.config.search)) {
              try {
                  locusObject = await searchWebService(browser, locus, searchConfig);
              } catch (error) {
                  console.error(error);
                  throw Error("Search service currently unavailable.")
              }
          }
          return locusObject
      };

      for (let locus of loci) {
          const locusObject = await searchLocus(locus);
          if (locusObject) {
              locusObject.locusSearchString = locus;
              list.push(locusObject);
          }
      }

      // If nothing is found, consider possibility that loci name itself has spaces
      if (list.length === 0) {
          const locusObject = await searchLocus(string);
          if (locusObject) {
              locusObject.locusSearchString = string;
              list.push(locusObject);
          }
      }


      return 0 === list.length ? undefined : list
  }

  function parseLocusString(browser, locus) {

      // Check for tab delimited locus string
      const tabTokens = locus.split('\t');
      if (tabTokens.length >= 3) {
          // Possibly a tab-delimited locus
          try {
              const chr = browser.genome.getChromosomeName(tabTokens[0]);
              const start = parseInt(tabTokens[1].replace(/,/g, ''), 10) - 1;
              const end = parseInt(tabTokens[2].replace(/,/g, ''), 10);
              if (!isNaN(start) && !isNaN(end)) {
                  return {chr, start, end}
              }
          } catch (e) {
              // Not a tab delimited locus, apparently, but not really an error as that was a guess
          }

      }

      const a = locus.split(':');
      const chr = a[0];
      if ('all' === chr && browser.genome.getChromosome(chr)) {
          return {chr, start: 0, end: browser.genome.getChromosome(chr).bpLength}

      } else if (undefined === browser.genome.getChromosome(chr)) {
          return undefined

      } else {
          const queryChr = browser.genome.getChromosomeName(chr);
          const extent = {
              chr: queryChr,
              start: 0,
              end: browser.genome.getChromosome(chr).bpLength
          };

          if (a.length > 1) {

              let b = a[1].split('-');
              if (b.length > 2) {
                  // Allow for negative coordinates, which is possible if showing alignment soft clips
                  if (a[1].startsWith('-')) {
                      const i = a[1].indexOf('-', 1);
                      if (i > 0) {
                          const t1 = a[1].substring(0, i);
                          const t2 = a[1].substring(i + 1);
                          b = [t1, t2];
                      }
                  } else {
                      return undefined
                  }

              }

              let numeric;
              numeric = b[0].replace(/,/g, '');
              if (isNaN(numeric)) {
                  return undefined
              }

              extent.start = parseInt(numeric, 10) - 1;
              extent.end = extent.start + 1;

              if (1 === b.length) {
                  // Don't clamp coordinates if single coordinate is supplied.
                  extent.start -= 20;
                  extent.end += 20;
              }

              if (2 === b.length) {
                  numeric = b[1].replace(/,/g, '');
                  if (isNaN(numeric)) {
                      return undefined
                  } else {
                      extent.end = parseInt(numeric, 10);
                  }

                  // Allow negative coordinates only if browser is softclipped, i.e. there is at least alignment track with softclipping on
                  if (extent.start < 0 && !browser.isSoftclipped()) {
                      const delta = -extent.start;
                      extent.start += delta;
                      extent.end += delta;
                  }
              }
          }

          return extent
      }
  }

  async function searchWebService(browser, locus, searchConfig) {

      let path = searchConfig.url.replace("$FEATURE$", locus.toUpperCase());
      if (path.indexOf("$GENOME$") > -1) {
          path = path.replace("$GENOME$", (browser.genome.id ? browser.genome.id : "hg19"));
      }
      const options = searchConfig.timeout ? {timeout: searchConfig.timeout} : undefined;
      const result = await igvxhr$1.loadString(path, options);

      const locusObject = processSearchResult(browser, result, searchConfig);
      if (locusObject) {
          locusObject.locusSearchString = locus;
      }
      return locusObject
  }

  function processSearchResult(browser, result, searchConfig) {

      let results;

      if ('plain' === searchConfig.type) {
          results = parseSearchResults(browser, result);
      } else {
          results = JSON.parse(result);
      }

      if (searchConfig.resultsField) {
          results = results[searchConfig.resultsField];
      }

      if (!results || 0 === results.length) {
          return undefined

      } else {

          const chromosomeField = searchConfig.chromosomeField || "chromosome";
          const startField = searchConfig.startField || "start";
          const endField = searchConfig.endField || "end";
          const coords = searchConfig.coords || 1;


          let result;
          if (Array.isArray(results)) {
              // Ignoring all but first result for now
              // TODO -- present all and let user select if results.length > 1
              result = results[0];
          } else {
              // When processing search results from Ensembl REST API
              // Example: https://rest.ensembl.org/lookup/symbol/macaca_fascicularis/BRCA2?content-type=application/json
              result = results;
          }

          if (!(result.hasOwnProperty(chromosomeField) && (result.hasOwnProperty(startField)))) {
              console.error("Search service results must include chromosome and start fields: " + result);
          }

          const chrResult = result[chromosomeField];
          const chromosome = browser.genome.getChromosome(chrResult);
          if (!chromosome) {
              return undefined
          }
          const chr = chromosome.name;

          let start = result[startField] - coords;
          let end = result[endField];
          if (undefined === end) {
              end = start + 1;
          }

          const locusObject = {chr, start, end};

          // Some GTEX hacks
          const type = result.type ? result.type : "gene";
          if (searchConfig.geneField && type === "gene") {
              locusObject.gene = result[searchConfig.geneField];
          }
          if (searchConfig.snpField && type === "snp") {
              locusObject.snp = result[searchConfig.snpField];
          }

          return locusObject
      }
  }

  /**
   * Parse the igv line-oriented (non json) search results.
   * Example
   *    EGFR    chr7:55,086,724-55,275,031    refseq
   *
   */
  function parseSearchResults(browser, data) {

      const linesTrimmed = [];
      const results = [];
      const lines = splitLines$5(data);

      lines.forEach(function (item) {
          if ("" === item) ; else {
              linesTrimmed.push(item);
          }
      });

      linesTrimmed.forEach(function (line) {

          var tokens = line.split("\t"),
              source,
              locusTokens,
              rangeTokens,
              obj;

          if (tokens.length >= 3) {

              locusTokens = tokens[1].split(":");
              rangeTokens = locusTokens[1].split("-");
              source = tokens[2].trim();

              obj =
                  {
                      gene: tokens[0],
                      chromosome: browser.genome.getChromosomeName(locusTokens[0].trim()),
                      start: parseInt(rangeTokens[0].replace(/,/g, '')),
                      end: parseInt(rangeTokens[1].replace(/,/g, '')),
                      type: ("gtex" === source ? "snp" : "gene")
                  };

              results.push(obj);

          }

      });

      return results

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class NavbarManager {

      constructor(browser) {
          this.browser = browser;
      }

      navbarDidResize(width) {
          this.updateNavbar(this.createResponsiveClassSchedule(width));
      }

      updateNavbar(responsiveClassSchedule) {

          this.browser.$toggle_button_container.removeClass();
          this.browser.$toggle_button_container.addClass(responsiveClassSchedule.$toggle_button_container);

          $$1(this.browser.zoomWidget.zoomContainer).removeClass();
          $$1(this.browser.zoomWidget.zoomContainer).addClass(responsiveClassSchedule.zoomContainer);
      }

      createResponsiveClassSchedule(navbarWidth) {

          let candidates = {};

          const isWGV = this.browser.isMultiLocusWholeGenomeView() ||
              (this.browser.referenceFrameList &&
                  GenomeUtils.isWholeGenomeView(this.browser.referenceFrameList[0].chr));


          if (isWGV) {
              this.browser.windowSizePanel.hide();
          } else {
              this.browser.windowSizePanel.show();
          }

          if (navbarWidth > 990) {
              candidates.$toggle_button_container = 'igv-navbar-toggle-button-container';
              candidates.zoomContainer = 'igv-zoom-widget';
          } else if (navbarWidth > 860) {
              candidates.$toggle_button_container = 'igv-navbar-toggle-button-container';
              candidates.zoomContainer = 'igv-zoom-widget-900';
          } else if (navbarWidth > 540) {
              candidates.$toggle_button_container = 'igv-navbar-toggle-button-container-750';
              candidates.zoomContainer = 'igv-zoom-widget-900';
          } else {
              candidates.$toggle_button_container = 'igv-navbar-toggle-button-container-750';
              candidates.zoomContainer = 'igv-zoom-widget-900';
              this.browser.windowSizePanel.hide();
          }

          if (isWGV) {
              candidates['zoomContainer'] = 'igv-zoom-widget-hidden';
          }

          return candidates
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const ChromosomeSelectWidget = function (browser, parent) {

      this.container = domUtils.div({class: 'igv-chromosome-select-widget-container'});
      parent.appendChild(this.container);

      this.select = document.createElement('select');
      this.select.setAttribute('name', 'chromosome-select-widget');
      this.container.appendChild(this.select);

      this.select.addEventListener('change', () => {
          this.select.blur();
          if (this.select.value !== '') {
              browser.search(this.select.value);
          }
      });

      this.showAllChromosomes = browser.config.showAllChromosomes !== false;   // i.e. default to true

  };

  ChromosomeSelectWidget.prototype.show = function () {
      this.container.style.display = 'flex';
  };

  ChromosomeSelectWidget.prototype.hide = function () {
      this.container.style.display = 'none';
  };

  ChromosomeSelectWidget.prototype.update = function (genome) {

      const list = this.showAllChromosomes ? genome.chromosomeNames.slice() : genome.wgChromosomeNames.slice();
      // console.log(`${ this.showAllChromosomes ? 'Do' : 'Do not'} show all chromosomes. List ${ list }`)

      if (genome.showWholeGenomeView()) {
          list.unshift('all');
          list.unshift('');
      }

      this.select.innerHTML = '';

      for (let name of list) {
          const option = document.createElement('option');
          option.setAttribute('value', name);
          option.innerText = name;
          this.select.appendChild(option);
      }

  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class WindowSizePanel {
      constructor(parent, browser) {

          this.container = domUtils.div({class: 'igv-windowsize-panel-container'});
          parent.appendChild(this.container);

          browser.on('locuschange', (referenceFrameList) => {
              this.updatePanel(referenceFrameList);
          });

          this.browser = browser;

      }

      show() {
          this.container.style.display = 'block';
      }

      hide() {
          this.container.style.display = 'none';
      }

      updatePanel(referenceFrameList) {
          const width = this.browser.calculateViewportWidth(this.browser.referenceFrameList.length);
          this.container.innerText = 1 === referenceFrameList.length ? prettyBasePairNumber(Math.round(width * referenceFrameList[0].bpPerPixel)) : '';
      }
  }

  class CursorGuide {

      constructor(columnContainer, browser) {
          this.browser = browser;
          this.columnContainer = columnContainer;

          this.horizontalGuide = domUtils.div({class: 'igv-cursor-guide-horizontal'});
          columnContainer.appendChild(this.horizontalGuide);

          this.verticalGuide = domUtils.div({class: 'igv-cursor-guide-vertical'});
          columnContainer.appendChild(this.verticalGuide);

          this.addMouseHandler(browser);

          this.setVisibility(browser.config.showCursorGuide);

      }

      addMouseHandler(browser) {

          this.boundMouseMoveHandler = mouseMoveHandler.bind(this);
          this.columnContainer.addEventListener('mousemove', this.boundMouseMoveHandler);

          function mouseMoveHandler(event) {

              const {x, y} = domUtils.translateMouseCoordinates(event, this.columnContainer);
              this.horizontalGuide.style.top = `${y}px`;

              const target = document.elementFromPoint(event.clientX, event.clientY);

              const viewport = findAncestorOfClass(target, 'igv-viewport');

              if (viewport && browser.getRulerTrackView()) {

                  this.verticalGuide.style.left = `${x}px`;

                  const columns = browser.root.querySelectorAll('.igv-column');
                  let index = undefined;
                  const viewportParent = viewport.parentElement;
                  for (let i = 0; i < columns.length; i++) {
                      if (undefined === index && viewportParent === columns[i]) {
                          index = i;
                      }
                  }

                  const rulerViewport = browser.getRulerTrackView().viewports[index];
                  const result = rulerViewport.mouseMove(event);

                  if (result) {

                      const {start, bp, end} = result;
                      const interpolant = (bp - start) / (end - start);

                      if (this.customMouseHandler) {
                          this.customMouseHandler({start, bp, end, interpolant});
                      }
                  }
              }

          }
      }

      removeMouseHandler() {
          this.columnContainer.removeEventListener('mousemove', this.boundMouseMoveHandler);
      }

      setVisibility(showCursorGuide) {
          if (true === showCursorGuide) {
              this.show();
          } else {
              this.hide();
          }
      }

      show() {
          this.verticalGuide.style.display = 'block';
          this.horizontalGuide.style.display = 'block';

      }

      hide() {

          this.verticalGuide.style.display = 'none';
          this.horizontalGuide.style.display = 'none';

          if (this.browser.getRulerTrackView()) {
              for (let viewport of this.browser.getRulerTrackView().viewports) {
                  viewport.$tooltip.hide();
              }
          }

      }

  }

  /**
   * Walk up the tree until a parent is found with the given classname.  If no ancestor is found return undefined.
   * @param target
   * @param classname
   * @returns {*}
   */
  function findAncestorOfClass(target, classname) {

      while (target.parentElement) {
          if (target.parentElement.classList.contains(classname)) {
              return target.parentElement
          } else {
              target = target.parentElement;
          }
      }
      return undefined

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class CursorGuideButton {

      constructor(browser, parent) {

          this.browser = browser;

          this.button = domUtils.div({class: 'igv-navbar-button'});
          parent.appendChild(this.button);

          this.button.textContent = 'cursor guide';

          this.button.addEventListener('click', () => {
              browser.cursorGuideVisible = !browser.cursorGuideVisible;
              browser.setCursorGuideVisibility(browser.cursorGuideVisible);
              this.setButtonState(browser.cursorGuideVisible);
          });

          this.setButtonState(browser.cursorGuideVisible);

          if (browser.config.showCursorTrackingGuideButton) {
              this.show();
          } else {
              this.hide();
          }

      }

      setButtonState(cursorGuideVisible) {
          if (true === cursorGuideVisible) {
              this.button.classList.add('igv-navbar-button-clicked');
          } else {
              this.button.classList.remove('igv-navbar-button-clicked');
          }
      }

      show() {
          this.button.style.display = 'block';
          this.setButtonState(this.browser.cursorGuideVisible);
      }

      hide() {
          this.button.style.display = 'none';
      }
  }

  class CenterLineButton {

      constructor(browser, parent) {

          this.browser = browser;

          this.button = domUtils.div({class: 'igv-navbar-button'});
          parent.appendChild(this.button);

          this.button.textContent = 'center line';

          this.button.addEventListener('click', () => {
              browser.isCenterLineVisible = !browser.isCenterLineVisible;
              browser.setCenterLineVisibility(browser.isCenterLineVisible);
              this.setButtonState(browser.isCenterLineVisible);
          });

          this.setButtonState(browser.isCenterLineVisible);

          if (browser.config.showCenterGuideButton) {
              this.show();
          } else {
              this.hide();
          }
      }

      setButtonState(isCenterLineVisible) {
          if (true === isCenterLineVisible) {
              this.button.classList.add('igv-navbar-button-clicked');
          } else {
              this.button.classList.remove('igv-navbar-button-clicked');
          }
      }

      show() {
          this.isVisible = true;
          this.button.style.display = 'block';
          this.setButtonState(this.browser.isCenterLineVisible);
      }

      hide() {
          this.isVisible = false;
          this.button.style.display = 'none';
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class TrackLabelControl {

      constructor(parent, browser) {

          this.button = domUtils.div({class: 'igv-navbar-button'});
          parent.appendChild(this.button);
          this.button.textContent = 'track labels';

          this.button.addEventListener('click', () => {
              browser.trackLabelsVisible = !browser.trackLabelsVisible;
              this.setState(browser.trackLabelsVisible);
              browser.setTrackLabelVisibility(browser.trackLabelsVisible);
          });

          this.browser = browser;

          this.setVisibility(browser.config.showTrackLabelButton);

          this.setState(browser.trackLabelsVisible);
      }

      setVisibility(showTrackLabelButton) {
          if (true === showTrackLabelButton) {
              this.show();
          } else {
              this.hide();
          }
      }

      setState(trackLabelsVisible) {
          if (true === trackLabelsVisible) {
              this.button.classList.add('igv-navbar-button-clicked');
          } else {
              this.button.classList.remove('igv-navbar-button-clicked');
          }
      }

      show() {
          this.button.style.display = 'block';
          this.setState(this.browser.trackLabelsVisible);
      }

      hide() {
          this.button.style.display = 'none';
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class SampleNameControl {

      constructor(parent, browser) {

          this.button = domUtils.div({class: 'igv-navbar-button'});
          parent.appendChild(this.button);

          this.button.innerText = 'Sample Names';

          this.setState(browser.showSampleNames);

          this.setVisibility(browser.showSampleNameButton);

          this.button.addEventListener('click', () => {

              browser.showSampleNames = !browser.showSampleNames;

              this.setState(browser.showSampleNames);

              for (let {sampleNameViewport} of browser.trackViews) {
                  if (false === browser.showSampleNames) {
                      sampleNameViewport.hide();
                  } else {
                      sampleNameViewport.show();
                  }
              }

              browser.layoutChange();


          });

      }

      setVisibility(showSampleNameButton) {

          if (true === showSampleNameButton) {
              this.show();
          } else {
              this.hide();
          }
      }

      setState(showSampleNames) {
          if (true === showSampleNames) {
              this.button.classList.add('igv-navbar-button-clicked');
          } else {
              this.button.classList.remove('igv-navbar-button-clicked');
          }
      }

      hide() {
          this.button.style.display = 'none';
      }

      show() {
          this.button.style.display = 'block';
      }

  }

  const sliderMin = 0;
  let sliderMax = 23;
  let sliderValueRaw = 0;

  const ZoomWidget = function (browser, parent) {

      this.browser = browser;

      this.zoomContainer = domUtils.div({class: 'igv-zoom-widget'});
      parent.appendChild(this.zoomContainer);

      // zoom out
      this.zoomOutButton = domUtils.div();
      this.zoomContainer.appendChild(this.zoomOutButton);
      this.zoomOutButton.appendChild(icons$1$1.createIcon('minus-circle'));
      this.zoomOutButton.addEventListener('click', () => {
          // browser.zoomWithScaleFactor(2.0)
          browser.zoomOut();
      });

      // Range slider
      const el = domUtils.div();
      this.zoomContainer.appendChild(el);
      this.slider = document.createElement('input');
      this.slider.type = 'range';

      this.slider.min = `${sliderMin}`;
      this.slider.max = `${sliderMax}`;

      el.appendChild(this.slider);

      this.slider.addEventListener('change', e => {

          e.preventDefault();
          e.stopPropagation();

          const referenceFrame = browser.referenceFrameList[0];
          const {bpLength} = referenceFrame.genome.getChromosome(referenceFrame.chr);
          const {end, start} = referenceFrame;

          const extent = end - start;

          // bpLength/(end - start)
          const scaleFactor = Math.pow(2, e.target.valueAsNumber);

          // (end - start) = bpLength/scaleFactor
          const zoomedExtent = bpLength / scaleFactor;

          // console.log(`zoom-widget - slider ${ e.target.value } scaleFactor ${ scaleFactor } extent-zoomed ${ StringUtils.numberFormatter(Math.round(zoomedExtent)) }`)

          browser.zoomWithScaleFactor(zoomedExtent / extent);

      });

      // zoom in
      this.zoomInButton = domUtils.div();
      this.zoomContainer.appendChild(this.zoomInButton);
      this.zoomInButton.appendChild(icons$1$1.createIcon('plus-circle'));
      this.zoomInButton.addEventListener('click', () => {
          // browser.zoomWithScaleFactor(0.5)
          browser.zoomIn();
      });

      browser.on('locuschange', (referenceFrameList) => {

          if (this.browser.isMultiLocusMode()) {
              this.disable();
          } else {
              this.enable();
              this.update(referenceFrameList);
          }

      });

  };

  ZoomWidget.prototype.update = function (referenceFrameList) {

      const referenceFrame = referenceFrameList[0];
      const {bpLength} = referenceFrame.genome.getChromosome(referenceFrame.chr);
      const {start, end} = referenceFrame;

      sliderMax = Math.ceil(Math.log2(bpLength / this.browser.minimumBases()));

      this.slider.max = `${sliderMax}`;

      const scaleFactor = bpLength / (end - start);
      sliderValueRaw = Math.log2(scaleFactor);
      this.slider.value = `${Math.round(sliderValueRaw)}`;

      // referenceFrame.description('zoom.update')

      // console.log(`${ Date.now() } update - slider ${ this.slider.value } scaleFactor ${ Math.round(scaleFactor) } extent ${ StringUtils.numberFormatter(Math.round(extent)) }`)

      // console.log(`update - sliderMin ${ sliderMin } sliderValue ${ this.slider.value } sliderMax ${ sliderMax } scaleFactor ${ scaleFactor.toFixed(3) } derived-scaleFactor ${ derivedScalefactor.toFixed(3) }`)

  };

  ZoomWidget.prototype.enable = function () {

      // this.zoomInButton.style.color = appleCrayonPalette[ 'steel' ];
      // this.zoomInButton.style.pointerEvents = 'auto';
      //
      // this.zoomOutButton.style.color = appleCrayonPalette[ 'steel' ];
      // this.zoomOutButton.style.pointerEvents = 'auto';

      this.slider.disabled = false;
  };

  ZoomWidget.prototype.disable = function () {

      // this.zoomInButton.style.color = appleCrayonPalette[ 'silver' ];
      // this.zoomInButton.style.pointerEvents = 'none';
      //
      // this.zoomOutButton.style.color = appleCrayonPalette[ 'silver' ];
      // this.zoomOutButton.style.pointerEvents = 'none';

      this.slider.disabled = true;
  };

  ZoomWidget.prototype.hide = function () {
      this.zoomContainer.style.display = 'none';
  };

  ZoomWidget.prototype.show = function () {
      this.zoomContainer.style.display = 'block';
  };

  ZoomWidget.prototype.hideSlider = function () {
      this.slider.style.display = 'none';
  };

  ZoomWidget.prototype.showSlider = function () {
      this.slider.style.display = 'block';
  };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const SVGSaveControl = function (parent, browser) {
      const button = domUtils.div({class: 'igv-navbar-button'});
      parent.append(button);

      button.textContent = 'Save SVG';
      button.addEventListener('click', () => browser.saveSVGtoFile({}));
  };

  const viewportColumnManager =
      {
          createColumns: (columnContainer, count) => {

              for (let i = 0; i < count; i++) {
                  if (0 === i) {
                      createColumn(columnContainer, 'igv-column');
                  } else {
                      columnContainer.appendChild(domUtils.div({class: 'igv-column-shim'}));
                      createColumn(columnContainer, 'igv-column');
                  }
              }

          },

          removeColumnAtIndex: (i, column) => {
              const shim = 0 === i ? column.nextElementSibling : column.previousElementSibling;
              column.remove();
              shim.remove();
          },

          insertAfter: referenceElement => {

              const shim = domUtils.div({class: 'igv-column-shim'});
              insertElementAfter(shim, referenceElement);

              const column = domUtils.div({class: 'igv-column'});
              insertElementAfter(column, shim);

              return column
          },

          insertBefore: (referenceElement, count) => {

              for (let i = 0; i < count; i++) {

                  const column = domUtils.div({class: 'igv-column'});
                  insertElementBefore(column, referenceElement);

                  if (count > 1 && i > 0) {
                      const columnShim = domUtils.div({class: 'igv-column-shim'});
                      insertElementBefore(columnShim, column);
                  }

              }

          },

          indexOfColumn: (columnContainer, column) => {

              const allColumns = columnContainer.querySelectorAll('.igv-column');

              for (let i = 0; i < allColumns.length; i++) {
                  const c = allColumns[ i ];
                  if (c === column) {
                      return i
                  }
              }

              return undefined
          },
      };

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class ViewportCenterLine {

      constructor(browser, referenceFrame, column) {

          this.browser = browser;
          this.referenceFrame = referenceFrame;
          this.column = column;

          this.container = domUtils.div({class: 'igv-center-line'});
          column.appendChild(this.container);

          if (browser.isCenterLineVisible) {
              this.show();
          } else {
              this.hide();
          }
      }

      repaint() {

          if (this.referenceFrame) {

              const ppb = 1.0 / this.referenceFrame.bpPerPixel;
              if (ppb > 1) {
                  const width = Math.floor(this.referenceFrame.toPixels(1));
                  this.container.style.width = `${width}px`;
                  this.container.classList.remove('igv-center-line-thin');
                  this.container.classList.add('igv-center-line-wide');
              } else {
                  this.container.style.width = '1px';
                  this.container.classList.remove('igv-center-line-wide');
                  this.container.classList.add('igv-center-line-thin');
              }
          }
      }

      show() {
          this.isVisible = true;
          this.container.style.display = 'block';
          this.repaint();
      }

      hide() {
          this.isVisible = false;
          this.container.style.display = 'none';
      }

      resize() {
          this.repaint();
      }
  }

  class RulerTrack {
      constructor(browser) {

          this.browser = browser;
          this.height = 40;
          this.name = "";
          this.id = "ruler";
          this.disableButtons = true;
          this.ignoreTrackMenu = true;
          this.order = Number.MIN_SAFE_INTEGER * 1e-2;
          this.removable = false;
          this.type = 'ruler';
      }

      async getFeatures(chr, start, end) {
          return []
      };

      computePixelHeight(ignore) {
          return this.height
      };

      draw({context, referenceFrame, pixelWidth, pixelHeight, bpPerPixel, bpStart}) {

          if (GenomeUtils.isWholeGenomeView(referenceFrame.chr)) {
              this.drawWholeGenome({context, pixelWidth, pixelHeight, bpPerPixel});
          } else {
              this.doDraw({context, referenceFrame, pixelWidth, pixelHeight, bpStart});
          }
      }

      drawWholeGenome({context, pixelWidth, pixelHeight, bpPerPixel}) {

          context.save();

          IGVGraphics.fillRect(context, 0, 0, pixelWidth, pixelHeight, {'fillStyle': 'white'});

          for (let name of this.browser.genome.wgChromosomeNames) {

              let xBP = this.browser.genome.getCumulativeOffset(name);
              let wBP = this.browser.genome.getChromosome(name).bpLength;

              let x = Math.round(xBP / bpPerPixel);
              let w = Math.round(wBP / bpPerPixel);

              this.renderChromosomeRect(context, x, 0, w, pixelHeight, name);
          }

          context.restore();

      }

      doDraw({context, referenceFrame, pixelWidth, pixelHeight, bpStart}) {

          context.clearRect(0, 0, pixelWidth, pixelHeight);

          const tickHeight = 6;
          const shim = 2;

          const bpLength = Math.floor(referenceFrame.toBP(pixelWidth));
          const tick = findSpacing(bpLength, context.isSVG);

          let nTick = Math.floor(bpStart / tick.majorTick) - 1;

          const {tickDelta, labelLength} = calculateDeltas(context, referenceFrame, bpStart, nTick, tick);

          this.browser.referenceFrameList.indexOf(referenceFrame);
          // console.log(`ruler(${ index }) label-length ${ labelLength > tickDelta ? 'clobbers' : 'less than' } tick-delta ${ StringUtils.numberFormatter(tickDelta)} `)

          let xTick;
          let bp;
          let accumulatedTickDelta = tickDelta;
          const labelLengthShim = 0.25 * labelLength;
          do {

              bp = Math.floor(nTick * tick.majorTick);
              const rulerLabel = `${numberFormatter$1(Math.floor(bp / tick.unitMultiplier))} ${tick.majorUnit}`;

              xTick = Math.round(referenceFrame.toPixels((bp - 1) - bpStart + 0.5));
              const xLabel = Math.round(xTick - context.measureText(rulerLabel).width / 2);

              if (xLabel > 0 && (labelLengthShim + labelLength) <= accumulatedTickDelta) {
                  IGVGraphics.fillText(context, rulerLabel, xLabel, this.height - (tickHeight / 0.75));
                  accumulatedTickDelta = 0;
              }

              if (xTick > 0) {
                  IGVGraphics.strokeLine(context, xTick, this.height - tickHeight, xTick, this.height - shim);
              }

              bp = Math.floor((1 + nTick) * tick.majorTick);
              let pixel = Math.round(referenceFrame.toPixels((bp - 1) - bpStart + 0.5));
              let delta = (pixel - xTick) / 2;
              let xx = xTick + delta;
              if (xx > 0) {
                  IGVGraphics.strokeLine(context, xx, this.height - tickHeight, xx, this.height - shim);
              }

              ++nTick;
              accumulatedTickDelta += tickDelta;

          } while (xTick < pixelWidth)

          IGVGraphics.strokeLine(context, 0, this.height - shim, pixelWidth, this.height - shim);

      }

      renderChromosomeRect(ctx, x, y, w, h, name) {

          ctx.textAlign = 'center';
          ctx.textBaseline = 'middle';
          ctx.font = '12px sans-serif';

          IGVGraphics.strokeLine(ctx, x + w, y, x + w, y + h, {strokeStyle: IGVColor.greyScale(191)});

          const shortName = (name.startsWith("chr")) ? name.substring(3) : name;

          if (w > ctx.measureText(shortName).width) {
              IGVGraphics.fillText(ctx, shortName, (x + (w / 2)), (y + (h / 2)), {fillStyle: IGVColor.greyScale(68)});
          }
      }

      get supportsWholeGenome() {
          return true
      };

      dispose() {
          // do stuff
      }
  }

  function findSpacing(bpLength, isSVG) {

      if (bpLength < 10) {
          return new Tick(1, 'bp', 1)
      }

      const nZeroes = Math.floor(Math.log10(bpLength));

      let majorUnit = 'bp';
      let unitMultiplier = 1;

      if (nZeroes > 9) {
          majorUnit = 'gb';
          unitMultiplier = 1e9;
      } else if (nZeroes > 6) {
          majorUnit = 'mb';
          unitMultiplier = 1e6;
      } else if (nZeroes > 3) {
          majorUnit = 'kb';
          unitMultiplier = 1e3;
      }

      const denom = Math.pow(10, nZeroes - 1);
      const nMajorTicks = bpLength / denom;

      // const threshold = 25
      const threshold = 3 * 25;

      const belowThresholdTick = Math.pow(10, nZeroes - 1);
      const aboveThresholdTick = Math.pow(10, nZeroes) / 2;

      // console.log(`zeros ${ nZeroes } tick-threshold ${ threshold } ticks ${ nMajorTicks } belowTick ${ StringUtils.numberFormatter(belowThresholdTick) } aboveTick ${ StringUtils.numberFormatter(aboveThresholdTick) }`)

      const majorTick = (nMajorTicks < threshold && isSVG !== true) ? belowThresholdTick : aboveThresholdTick;

      return new Tick(majorTick, majorUnit, unitMultiplier)
  }

  function calculateDeltas(context, referenceFrame, bpStart, nTick, tick) {

      const tickDelta = getX(referenceFrame, getBP(1 + nTick, tick), bpStart) - getX(referenceFrame, getBP(nTick, tick), bpStart);

      const label = `${numberFormatter$1(Math.floor(getBP(nTick, tick) / tick.unitMultiplier))} ${tick.majorUnit}`;
      const labelLength = Math.floor(context.measureText(label).width);

      return {tickDelta, labelLength}

      function getBP(nTick, tick) {
          return Math.floor(nTick * tick.majorTick)
      }

      function getX(referenceFrame, bp, bpStart) {
          return Math.round(referenceFrame.toPixels((bp - 1) - bpStart + 0.5))
      }
  }

  class Tick {

      constructor(majorTick, majorUnit, unitMultiplier) {
          this.majorTick = majorTick;
          this.minorTick = majorTick / 10.0;
          this.majorUnit = majorUnit;
          this.unitMultiplier = unitMultiplier;
      }

      description(blurb) {
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const CircularViewControl = function (parent, browser) {

      this.button = domUtils.div({class: 'igv-navbar-button'});
      parent.appendChild(this.button);
      this.button.textContent = 'circular view';

      this.button.addEventListener('click', () => {
          browser.circularViewVisible = !browser.circularViewVisible;
          //this.setState(browser.circularViewVisible)
      });

      this.browser = browser;

      this.setVisibility(browser.config.showCircularViewButton);

      this.setState(browser.circularViewVisible);

  };

  CircularViewControl.prototype.setVisibility = function (showCircularViewButton) {
      if (true === showCircularViewButton) {
          this.show();
      } else {
          this.hide();
      }
  };

  CircularViewControl.prototype.setState = function (circularViewVisible) {
      if (true === circularViewVisible) {
          this.button.classList.add('igv-navbar-button-clicked');
      } else {
          this.button.classList.remove('igv-navbar-button-clicked');
      }
  };

  CircularViewControl.prototype.show = function () {
      this.button.style.display = 'block';
      this.setState(this.browser.circularViewVisible);
  };

  CircularViewControl.prototype.hide = function () {
      this.button.style.display = 'none';
  };

  /**
   * User supplied button for the navbar
   */

  const CustomButton = function (parent, browser, b) {

      const button = domUtils.div({class: 'igv-navbar-button'});
      parent.append(button);
      button.textContent = b.label;
      button.addEventListener('click', () => b.callback(browser));
  };

  class ROIManager {

      constructor(browser, roiMenu, roiTable, top, roiSets) {

          this.browser = browser;
          this.roiMenu = roiMenu;
          this.roiTable = roiTable;
          this.top = top;
          this.roiSets = roiSets || [];
          this.boundLocusChangeHandler = locusChangeHandler.bind(this);
          browser.on('locuschange', this.boundLocusChangeHandler);

      }

      async initialize() {

          if (this.roiSets.length > 0) {
              this.browser.showROITableButton = true;
              this.browser.roiTableControl.setVisibility(this.browser.showROITableButton);
          }

          const promises = this.roiSets.map(roiSet => this.renderROISet({
              browser: this.browser,
              pixelTop: this.top,
              roiSet
          }));

          if (promises.length > 0) {
              await Promise.all(promises);
          }

          const records = await this.getTableRecords();
          this.roiTable.renderTable(records);

      }

      async loadROI(config, genome) {

          const configs = Array.isArray(config) ? config : [config];

          for (let c of configs) {
              this.roiSets.push(new ROISet(c, genome));
          }

          await this.initialize();

      }

      clearROIs() {

          this.roiTable.clearTable();

          const elements = this.browser.columnContainer.querySelectorAll('.igv-roi-region');
          for (let el of elements) {
              el.remove();
          }

          for (let roiSet of this.roiSets) {
              roiSet.dispose();
          }

          this.roiSets = [];

      }

      async getTableRecords() {

          const records = [];

          for (let roiSet of this.roiSets) {
              const setName = roiSet.isUserDefined ? '' : (roiSet.name || '');
              const allFeatures = await roiSet.getAllFeatures();
              for (let chr of Object.keys(allFeatures)) {
                  for (let feature of allFeatures[chr]) {
                      records.push({setName, feature});
                  }
              }
          }

          return records
      }

      presentTable() {
          this.roiTable.present();
      }

      async repaintTable() {
          const records = await this.getTableRecords();
          this.roiTable.renderTable(records);
      }

      dismissTable() {
          this.roiTable.dismiss();
      }

      async updateUserDefinedROISet(feature) {

          let userDefinedROISet = await this.getUserDefinedROISet();

          if (undefined === userDefinedROISet) {
              userDefinedROISet = this.initializeUserDefinedROISet();
          }

          userDefinedROISet.addFeature(feature);

          if (false === this.browser.showROITableButton) {
              this.setROITableButtonVisibility(true);
          }

          await this.renderROISet({browser: this.browser, pixelTop: this.top, roiSet: userDefinedROISet});

          const records = await this.getTableRecords();
          this.roiTable.renderTable(records);
      }

      setROITableButtonVisibility(isVisible) {
          this.browser.showROITableButton = isVisible;
          this.browser.roiTableControl.setVisibility(this.browser.showROITableButton);
      }

      async renderAllROISets() {

          for (let roiSet of this.roiSets) {
              await this.renderROISet({browser: this.browser, pixelTop: this.top, roiSet});
          }
      }

      async renderROISet({browser, pixelTop, roiSet}) {

          const columns = browser.columnContainer.querySelectorAll('.igv-column');

          for (let i = 0; i < columns.length; i++) {

              let {chr, start: viewStart, end: viewEnd, bpPerPixel} = browser.referenceFrameList[i];

              const elements = columns[i].querySelectorAll('.igv-roi-region');
              for (let el of elements) {
                  const regionKey = el.dataset.region;
                  const {chr: regionChr, start: regionStart, end: regionEnd} = parseRegionKey(regionKey);
                  if (regionChr !== chr || regionEnd < viewStart || regionStart > viewEnd) {
                      el.remove();
                  }
              }

              const features = await roiSet.getFeatures(chr, viewStart, viewEnd);

              if (features) {

                  for (let feature of features) {

                      const regionKey = createRegionKey(chr, feature.start, feature.end);

                      const {
                          x: pixelX,
                          width: pixelWidth
                      } = screenCoordinates(Math.max(viewStart, feature.start), Math.min(viewEnd, feature.end), viewStart, bpPerPixel);


                      const el = columns[i].querySelector(createSelector(regionKey));

                      if (el) {
                          el.style.left = `${pixelX}px`;
                          el.style.width = `${pixelWidth}px`;

                      } else {
                          const element = this.createRegionElement(browser.columnContainer, pixelTop, pixelX, pixelWidth, roiSet, regionKey, feature.name);
                          columns[i].appendChild(element);
                      }
                  }
              }
          }
      }

      createRegionElement(columnContainer, pixelTop, pixelX, pixelWidth, roiSet, regionKey, name) {

          const regionElement = domUtils.div({class: 'igv-roi-region'});

          regionElement.style.top = `${pixelTop}px`;
          regionElement.style.left = `${pixelX}px`;
          regionElement.style.width = `${pixelWidth}px`;
          regionElement.style.backgroundColor = roiSet.color;
          regionElement.dataset.region = regionKey;

          const header = domUtils.div();
          regionElement.appendChild(header);

          header.style.backgroundColor = roiSet.headerColor;

          if (true === roiSet.isUserDefined) {
              header.addEventListener('click', event => {
                  event.preventDefault();
                  event.stopPropagation();

                  const {x, y} = domUtils.translateMouseCoordinates(event, columnContainer);
                  this.roiMenu.present(x, y, this, columnContainer, regionElement);
              });
          } else if (name) {
              header.addEventListener('click', event => {
                  event.preventDefault();
                  event.stopPropagation();
                  if (this.popover) {
                      this.popover.dispose();
                  }
                  this.popover = new Popover(columnContainer, roiSet.name);
                  this.popover.presentContentWithEvent(event, name);
              });
          } else {
              header.style.pointerEvents = 'none';
          }

          return regionElement
      }

      async getUserDefinedROISet() {
          return this.roiSets.find(roiSet => true === roiSet.isUserDefined)
      }

      initializeUserDefinedROISet() {

          const config =
              {
                  isUserDefined: true,
                  features: []
              };
          const userDefinedROISet = new ROISet(config, this.browser.genome);
          this.roiSets.push(userDefinedROISet);

          return userDefinedROISet
      }

      async deleteUserDefinedRegionWithKey(regionKey, columnContainer) {

          columnContainer.querySelectorAll(createSelector(regionKey)).forEach(node => node.remove());

          const feature = await this.findUserDefinedRegionWithKey(regionKey);

          const set = await this.getUserDefinedROISet();

          if (set) {
              set.removeFeature(feature);
          }

          const records = await this.getTableRecords();

          if (0 === records.length) {
              this.browser.roiTableControl.buttonHandler(false);
              this.setROITableButtonVisibility(false);
          }

      }

      async findUserDefinedRegionWithKey(regionKey) {

          const {chr, start, end} = parseRegionKey(regionKey);
          const set = await this.getUserDefinedROISet();

          if (set) {
              const features = await set.getFeatures(chr, start, end);

              for (let feature of features) {
                  if (feature.chr === chr && feature.start >= start && feature.end <= end) {
                      return feature
                  }
              }
          }

          return undefined
      }

      toJSON() {
          return this.roiSets.map(roiSet => roiSet.toJSON())
      }

      dispose() {

          this.browser.off('locuschange', this.boundLocusChangeHandler);

          const removable = this.browser.columnContainer.querySelectorAll('.igv-roi-region');

          for (let el of removable) {
              el.remove();
          }

          if (this.roiMenu) {
              this.roiMenu.dispose();
          }

          if (this.roiTable) {
              this.roiTable.dispose();
          }

          for (let roiSet of this.roiSets) {
              roiSet.dispose();
          }

          for (let key of Object.keys(this)) {
              this[key] = undefined;
          }

      }
  }

  function locusChangeHandler() {
      this.renderAllROISets();
  }

  function createRegionKey(chr, start, end) {
      return `${chr}-${start}-${end}`
  }

  function createSelector(regionKey) {
      return `[data-region="${regionKey}"]`
  }

  function parseRegionKey(regionKey) {
      let [chr, ss, ee] = regionKey.split('-');
      ss = parseInt(ss);
      ee = parseInt(ee);

      return {chr, start: ss, end: ee, locus: `${chr}:${ss}-${ee}`, bedRecord: `${chr}\t${ss}\t${ee}`}
  }

  class ROITable extends RegionTableBase {
      constructor(config) {

          const cooked = Object.assign({ 'width':'512px' }, config);
          super(cooked);
      }

      tableRowDOM(record) {

          const dom = domUtils.div({ class: 'igv-roi-table-row' });

          const { setName, feature } = record;
          dom.dataset.region = createRegionKey(feature.chr, feature.start, feature.end);

          let strings =
              [
                  feature.chr,
                  numberFormatter$1(feature.start),
                  numberFormatter$1(feature.end),
                  feature.name || '',
                  setName
              ];

          if (4 === this.columnFormat.length) {
              strings = strings.slice(0, 4);
          }

          for (let i = 0; i < strings.length; i++) {
              const el = domUtils.div();
              dom.appendChild(el);
              el.style.width = this.columnFormat[ i ].width;
              el.innerText = strings[ i ];
          }

          this.tableRowDOMHelper(dom);

          return dom
      }

      renderTable(records) {

          Array.from(this.rowContainerDOM.querySelectorAll('.igv-roi-table-row')).forEach(el => el.remove());

          if (records.length > 0) {

              const sortedRecords = records.sort((a, b) => (a.feature.chr.localeCompare(b.feature.chr) || a.feature.start - b.feature.start || a.feature.end - b.feature.end));

              for (let record of sortedRecords) {
                  const row = this.tableRowDOM(record);
                  this.rowContainerDOM.appendChild(row);
              }

          }
      }

      dispose() {

          document.removeEventListener('click', this.boundGotoButtonHandler);

          this.browser.roiTableControl.buttonHandler(false);
          super.dispose();
      }

      static getColumnFormatConfiguration(doIncludeROISetNames) {

          if (true === doIncludeROISetNames) {

              return [
                      { label: 'Chr', width: '20%' },
                      { label: 'Start', width: '15%' },
                      { label: 'End', width: '15%' },
                      { label: 'Description', width: '30%' },
                      { label: 'ROI Set', width: '20%' }
                  ]
          } else {
              return [
                      { label: 'Chr', width: '25%' },
                      { label: 'Start', width: '20%' },
                      { label: 'End', width: '20%' },
                      { label: 'Description', width: '35%' }
                  ]
          }

      }

      static gotoButtonHandler (event) {

          event.stopPropagation();

          const selected = this.container.querySelectorAll('.igv-roi-table-row-selected');
          const loci = [];
          for (let el of selected) {
              const { locus } = parseRegionKey(el.dataset.region);
              loci.push(locus);
          }

          for (let el of this.container.querySelectorAll('.igv-roi-table-row')) {
              el.classList.remove('igv-roi-table-row-selected');
          }

          this.setTableRowSelectionState(false);

          if (loci.length > 0) {
              this.browser.search(loci.join(' '));
          }

      }

  }

  class ROIMenu {
      constructor(browser, parent) {

          this.browser = browser;

          // container
          this.container = domUtils.div({ class: 'igv-roi-menu-next-gen' });
          parent.appendChild(this.container);

          // header
          const header = domUtils.div();
          this.container.appendChild(header);

          uiUtils.attachDialogCloseHandlerWithParent(header, () => this.container.style.display = 'none');

          // body
          this.body = domUtils.div();
          this.container.appendChild(this.body);

          this.container.style.display = 'none';

      }

      async present(x, y, roiManager, columnContainer, regionElement) {

          removeAllChildNodes(this.body);

          const feature = await this.browser.roiManager.findUserDefinedRegionWithKey(regionElement.dataset.region);

          // Description Copy
          const _description_copy_ = domUtils.div();
          this.body.appendChild(_description_copy_);

          const placeholder = 'Description';
          const str = (feature.name || placeholder);

          _description_copy_.innerText = str;
          _description_copy_.setAttribute('title', str);
          placeholder === str ? _description_copy_.classList.add('igv-roi-placeholder') : _description_copy_.classList.remove('igv-roi-placeholder');


          // Set Description
          const description = domUtils.div();
          this.body.appendChild(description);
          description.innerText = 'Set Description';

          description.addEventListener('click', event => {

              event.stopPropagation();

              this.container.style.display = 'none';

              const callback = () => {

                  const value = this.browser.inputDialog.input.value || '';
                  feature.name = value.trim();

                  this.container.style.display = 'none';

                  this.browser.roiManager.repaintTable();
              };

              const config =
                  {
                      label: 'Description',
                      value: (feature.name || ''),
                      callback
                  };

              this.browser.inputDialog.present(config, event);

          });


          // Delete Region
          const _delete_ = domUtils.div();
          this.body.appendChild(_delete_);
          _delete_.innerText = 'Delete Region';

          _delete_.addEventListener('click', event => {
              event.stopPropagation();
              this.container.style.display = 'none';
              this.browser.roiManager.deleteUserDefinedRegionWithKey(regionElement.dataset.region, this.browser.columnContainer);
          });







          // columnContainer.addEventListener('click', event => {
          //     event.stopPropagation()
          //     this.container.style.display = 'none'
          // })

          this.container.style.left = `${ x }px`;
          this.container.style.top  = `${ y }px`;
          this.container.style.display = 'flex';

      }

      async __present(x, y, roiManager, columnContainer, regionElement) {

          removeAllChildNodes(this.container);

          const feature = await this.browser.roiManager.findUserDefinedRegionWithKey(regionElement.dataset.region);

          let row;

          // Go To
          // row = DOMUtils.div({ class: 'igv-roi-menu-row' })
          // row.innerText = 'Go To'
          // this.container.appendChild(row)
          //
          // row.addEventListener('click', event => {
          //     event.stopPropagation()
          //     this.container.style.display = 'none'
          //
          //     const { locus } = parseRegionKey(regionElement.dataset.region)
          //     this.browser.search(locus)
          // })

          // Description:
          row = domUtils.div({ class: 'igv-roi-menu-row-edit-description' });
          this.container.appendChild(row);

          row.addEventListener('click', e => {
              e.stopPropagation();
          });

          const str = 'description-input';

          const label = document.createElement('label');
          row.appendChild(label);

          label.setAttribute('for', str);
          label.innerText = 'Description:';

          const input = document.createElement('input');
          row.appendChild(input);

          input.setAttribute('type', 'text');
          input.setAttribute('name', str);
          // input.setAttribute('placeholder', feature.name || 'Edit Description')
          input.setAttribute('placeholder', '');
          input.value = feature.name || '';

          input.addEventListener('change', async e => {

              e.stopPropagation();

              const feature = await this.browser.roiManager.findUserDefinedRegionWithKey(regionElement.dataset.region);
              feature.name = input.value;

              input.blur();
              this.container.style.display = 'none';

              await this.browser.roiManager.repaintTable();
          });


          // Delete
          row = domUtils.div({ class: 'igv-roi-menu-row' });
          row.innerText = 'Delete region';
          this.container.appendChild(row);

          row.addEventListener('click', event => {
              event.stopPropagation();
              this.container.style.display = 'none';
              this.browser.roiManager.deleteUserDefinedRegionWithKey(regionElement.dataset.region, this.browser.columnContainer);
          });

          this.container.style.left = `${ x }px`;
          this.container.style.top  = `${ y }px`;
          this.container.style.display = 'flex';

          columnContainer.addEventListener('click', event => {
              event.stopPropagation();
              this.container.style.display = 'none';
          });

      }

      dispose() {
          this.container.innerHTML = '';
      }

  }

  function removeAllChildNodes(parent) {
      while (parent.firstChild) {
          parent.removeChild(parent.firstChild);
      }
  }

  class TrackROISet {

      constructor(config, genome) {
          this.name = config.name;
          this.featureSource = config.featureSource || FeatureSource(config, genome);
          this.color = config.color || ROI_DEFAULT_COLOR;
      }

      async getFeatures(chr, start, end) {
          return this.featureSource.getFeatures({chr, start, end})
      }

      draw(drawConfiguration) {

          const { context, bpPerPixel, bpStart, pixelTop, pixelHeight, pixelWidth, features, } = drawConfiguration;

          if (!features) {
              return
          }

          const bpEnd = bpStart + (pixelWidth * bpPerPixel) + 1;
          for (let { start:regionStartBP, end:regionEndBP } of features) {

              if (regionEndBP < bpStart) {
                  continue
              }

              if (regionStartBP > bpEnd) {
                  break
              }

              const { x, width } = screenCoordinates(regionStartBP, regionEndBP, bpStart, bpPerPixel);
              IGVGraphics.fillRect(context, x, pixelTop, width, pixelHeight, { fillStyle: this.color });
          }
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016 University of California San Diego
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class ROITableControl {

      constructor(parent, browser) {
          this.browser = browser;
          this.button = domUtils.div({class: 'igv-navbar-button'});
          parent.appendChild(this.button);
          this.button.textContent = 'ROI Table';

          this.button.addEventListener('click', () => {
              this.buttonHandler(!browser.roiTableVisible);
          });

          this.browser = browser;

          this.setVisibility(browser.showROITableButton);

          this.setState(browser.roiTableVisible);
      }

      buttonHandler(status) {
          this.browser.roiTableVisible = status;
          this.setState(this.browser.roiTableVisible);
          this.browser.setROITableVisibility(this.browser.roiTableVisible);
      }

      setVisibility(doShowROITablelButton) {
          if (true === doShowROITablelButton) {
              this.show();
          } else {
              this.hide();
          }
      }

      setState(roiTableVisible) {
          if (true === roiTableVisible) {
              this.button.classList.add('igv-navbar-button-clicked');
          } else {
              this.button.classList.remove('igv-navbar-button-clicked');
          }
      }

      show() {
          this.button.style.display = 'block';
          this.setState(this.browser.roiTableVisible);
      }

      hide() {
          this.button.style.display = 'none';
      }
  }

  // css - $igv-scrollbar-outer-width: 14px;
  const igv_scrollbar_outer_width = 14;

  // css - $igv-track-drag-column-width: 12px;
  const igv_track_manipulation_handle_width = 12;

  // css - $igv-track-gear-menu-column-width: 28px;
  const igv_track_gear_menu_column_width = 28;

  // $igv-column-shim-width: 1px;
  // $igv-column-shim-margin: 2px;
  const column_multi_locus_shim_width = 2 + 1 + 2;

  const defaultSampleNameViewportWidth = 200;

  class Browser {

      constructor(config, parentDiv) {

          this.config = config;
          this.guid = domUtils.guid();
          this.namespace = '.browser_' + this.guid;

          this.parent = parentDiv;

          this.root = domUtils.div({class: 'igv-container'});
          parentDiv.appendChild(this.root);

          this.alert = new Alert(this.root);

          this.columnContainer = domUtils.div({class: 'igv-column-container'});
          this.root.appendChild(this.columnContainer);

          this.menuPopup = new MenuPopup(this.columnContainer);

          this.initialize(config);

          this.trackViews = [];

          this.constants = {
              dragThreshold: 3,
              scrollThreshold: 5,
              defaultColor: "rgb(0,0,150)",
              doubleClickDelay: config.doubleClickDelay || 500
          };

          // Map of event name -> [ handlerFn, ... ]
          this.eventHandlers = {};

          this.addMouseHandlers();

          this.setControls(config);
      }

      initialize(config) {

          if (config.gtex) {
              GtexUtils$1.gtexLoaded = true;
          }
          this.flanking = config.flanking;
          this.crossDomainProxy = config.crossDomainProxy;
          this.formats = config.formats;
          this.trackDefaults = config.trackDefaults;
          this.nucleotideColors = config.nucleotideColors || defaultNucleotideColors;
          for (let key of Object.keys(this.nucleotideColors)) {
              this.nucleotideColors[key.toLowerCase()] = this.nucleotideColors[key];
          }

          this.trackLabelsVisible = config.showTrackLabels;

          this.roiTableVisible = config.showROITable;
          this.showROITableButton = config.showROITableButton;

          this.isCenterLineVisible = config.showCenterGuide;

          this.cursorGuideVisible = config.showCursorGuide;

          this.showSampleNames = config.showSampleNames;
          this.showSampleNameButton = config.showSampleNameButton;
          this.sampleNameViewportWidth = config.sampleNameViewportWidth || defaultSampleNameViewportWidth;

          if (config.search) {
              this.searchConfig = {
                  type: "json",
                  url: config.search.url,
                  coords: config.search.coords === undefined ? 1 : config.search.coords,
                  chromosomeField: config.search.chromosomeField || "chromosome",
                  startField: config.search.startField || "start",
                  endField: config.search.endField || "end",
                  geneField: config.search.geneField || "gene",
                  snpField: config.search.snpField || "snp",
                  resultsField: config.search.resultsField
              };
          }
      }

      setControls(config) {

          const $navBar = this.createStandardControls(config);
          $navBar.insertBefore($$1(this.columnContainer));
          this.$navigation = $navBar;

          if (false === config.showControls) {
              $navBar.hide();
          }

      }

      createStandardControls(config) {

          this.navbarManager = new NavbarManager(this);

          const $navBar = $$1('<div>', {class: 'igv-navbar'});
          this.$navigation = $navBar;

          const $navbarLeftContainer = $$1('<div>', {class: 'igv-navbar-left-container'});
          $navBar.append($navbarLeftContainer);

          // IGV logo
          const $logo = $$1('<div>', {class: 'igv-logo'});
          $navbarLeftContainer.append($logo);

          const logoSvg = logo();
          logoSvg.css("width", "34px");
          logoSvg.css("height", "32px");
          $logo.append(logoSvg);

          this.$current_genome = $$1('<div>', {class: 'igv-current-genome'});
          $navbarLeftContainer.append(this.$current_genome);
          this.$current_genome.text('');

          const $genomicLocation = $$1('<div>', {class: 'igv-navbar-genomic-location'});
          $navbarLeftContainer.append($genomicLocation);

          // chromosome select widget
          this.chromosomeSelectWidget = new ChromosomeSelectWidget(this, $genomicLocation.get(0));
          if (undefined === config.showChromosomeWidget) {
              config.showChromosomeWidget = true;   // Default to true
          }
          if (true === config.showChromosomeWidget) {
              this.chromosomeSelectWidget.show();
          } else {
              this.chromosomeSelectWidget.hide();
          }

          const $locusSizeGroup = $$1('<div>', {class: 'igv-locus-size-group'});
          $genomicLocation.append($locusSizeGroup);

          const $searchContainer = $$1('<div>', {class: 'igv-search-container'});
          $locusSizeGroup.append($searchContainer);

          // browser.$searchInput = $('<input type="text" placeholder="Locus Search">');
          this.$searchInput = $$1('<input>', {class: 'igv-search-input', type: 'text', placeholder: 'Locus Search'});
          $searchContainer.append(this.$searchInput);

          this.$searchInput.change(() => this.doSearch(this.$searchInput.val()));

          const searchIconContainer = domUtils.div({class: 'igv-search-icon-container'});
          $searchContainer.append($$1(searchIconContainer));

          searchIconContainer.appendChild(icons$1$1.createIcon("search"));

          searchIconContainer.addEventListener('click', () => this.doSearch(this.$searchInput.val()));

          this.windowSizePanel = new WindowSizePanel($locusSizeGroup.get(0), this);

          const $navbarRightContainer = $$1('<div>', {class: 'igv-navbar-right-container'});
          $navBar.append($navbarRightContainer);

          const $toggle_button_container = $$1('<div class="igv-navbar-toggle-button-container">');
          $navbarRightContainer.append($toggle_button_container);
          this.$toggle_button_container = $toggle_button_container;

          this.cursorGuide = new CursorGuide(this.columnContainer, this);

          this.cursorGuideButton = new CursorGuideButton(this, $toggle_button_container.get(0));

          this.centerLineButton = new CenterLineButton(this, $toggle_button_container.get(0));

          this.setTrackLabelVisibility(config.showTrackLabels);
          this.trackLabelControl = new TrackLabelControl($toggle_button_container.get(0), this);

          // ROI Control
          this.roiTableControl = new ROITableControl($toggle_button_container.get(0), this);

          this.sampleNameControl = new SampleNameControl($toggle_button_container.get(0), this);

          if (true === config.showSVGButton) {
              this.svgSaveControl = new SVGSaveControl($toggle_button_container.get(0), this);
          }

          if (config.customButtons) {
              for (let b of config.customButtons) {
                  new CustomButton($toggle_button_container.get(0), this, b);
              }
          }

          this.zoomWidget = new ZoomWidget(this, $navbarRightContainer.get(0));

          if (false === config.showNavigation) {
              this.$navigation.hide();
          }

          this.inputDialog = new InputDialog(this.root);
          this.inputDialog.container.id = `igv-input-dialog-${domUtils.guid()}`;

          this.dataRangeDialog = new DataRangeDialog(this, $$1(this.root));
          this.dataRangeDialog.$container.get(0).id = `igv-data-range-dialog-${domUtils.guid()}`;

          this.genericColorPicker = new GenericColorPicker({parent: this.columnContainer, width: 432});
          this.genericColorPicker.container.id = `igv-track-color-picker-${domUtils.guid()}`;

          return $navBar

      }

      getSampleNameViewportWidth() {
          return false === this.showSampleNames ? 0 : this.sampleNameViewportWidth
      }

      isMultiLocusMode() {
          return this.referenceFrameList && this.referenceFrameList.length > 1
      };

      addTrackToFactory(name, track) {
          TrackFactory.addTrack(name, track);
      }

      isMultiLocusWholeGenomeView() {

          if (undefined === this.referenceFrameList || 1 === this.referenceFrameList.length) {
              return false
          }

          for (let referenceFrame of this.referenceFrameList) {
              if ('all' === referenceFrame.chr.toLowerCase()) {
                  return true
              }
          }

          return false
      };

      /**
       * PUBLIC API FUNCTION
       *
       * Return the current genomic region as a locus string, or array of locus strings if in multi-locus view
       * @returns {string|*[]|*}
       */
      currentLoci() {
          const noCommaLocusString = (rf) => `${rf.chr}:${rf.start + 1}-${rf.end}`;
          if (undefined === this.referenceFrameList || 0 === this.referenceFrameList.length) {
              return ""
          } else if (1 === this.referenceFrameList.length) {
              return noCommaLocusString(this.referenceFrameList[0])
          } else {
              return this.referenceFrameList.map(rf => noCommaLocusString(rf))
          }
      }

      /**
       * Render browse display as SVG
       * @returns {string}
       */
      toSVG() {

          const {y, width, height} = this.columnContainer.getBoundingClientRect();

          const h_render = 8000;

          const config =
              {

                  width,
                  height: h_render,

                  backdropColor: 'white',

                  multiLocusGap: 0,

                  viewbox:
                      {
                          x: 0,
                          y: 0,
                          width,
                          height: h_render
                      }

              };

          const context = new ctx(config);

          // tracks -> SVG
          for (let trackView of this.trackViews) {
              trackView.renderSVGContext(context, {deltaX: 0, deltaY: -y});
          }
          // reset height to trim away unneeded svg canvas real estate. Yes, a bit of a hack.
          context.setHeight(height);

          return context.getSerializedSvg(true)

      }

      renderSVG($container) {
          const svg = this.toSVG();
          $container.empty();
          $container.append(svg);

          return svg
      }

      saveSVGtoFile(config) {

          let svg = this.toSVG();

          if (config.$container) {
              config.$container.empty();
              config.$container.append(svg);
          }

          const path = config.filename || 'igvjs.svg';
          const data = URL.createObjectURL(new Blob([svg], {type: "application/octet-stream"}));
          download$1(path, data);
      }

      /**
       * Initialize a session from an object, json, or by loading from a file.
       *
       * TODO Really should be split into at least 2 functions, load from file and load from object/json
       *
       * @param options
       * @returns {*}
       */
      async loadSession(options) {

          // TODO: depricated
          this.roiSets = [];

          let session;
          if (options.url || options.file) {
              session = await loadSessionFile(options);
          } else {
              session = options;
          }
          return this.loadSessionObject(session)


          async function loadSessionFile(options) {

              const urlOrFile = options.url || options.file;

              if (options.url && (options.url.startsWith("blob:") || options.url.startsWith("data:"))) {
                  const json = Browser.uncompressSession(options.url);
                  return JSON.parse(json)

              } else {
                  let filename = options.filename;
                  if (!filename) {
                      filename = (options.url ? await getFilename$1(options.url) : options.file.name);
                  }

                  if (filename.endsWith(".xml")) {

                      const knownGenomes = GenomeUtils.KNOWN_GENOMES;
                      const string = await igvxhr$1.loadString(urlOrFile);
                      return new XMLSession(string, knownGenomes)

                  } else if (filename.endsWith(".json")) {
                      return igvxhr$1.loadJson(urlOrFile)
                  } else {
                      return undefined
                  }
              }
          }
      }


      /**
       * Note:  public API function
       * @param session
       * @returns {Promise<void>}
       */
      async loadSessionObject(session) {

          // prepare to load a new session, discarding DOM and state
          this.cleanHouseForSession();

          this.showSampleNames = session.showSampleNames || false;
          this.sampleNameControl.setState(this.showSampleNames === true);

          if (session.sampleNameViewportWidth) {
              this.sampleNameViewportWidth = session.sampleNameViewportWidth;
          }

          // axis column
          createColumn(this.columnContainer, 'igv-axis-column');

          // SampleName column
          createColumn(this.columnContainer, 'igv-sample-name-column');

          // Track scrollbar column
          createColumn(this.columnContainer, 'igv-scrollbar-column');

          // Track drag/reorder column
          createColumn(this.columnContainer, 'igv-track-drag-column');

          // Track gear column
          createColumn(this.columnContainer, 'igv-gear-menu-column');

          const genomeOrReference = session.reference || session.genome;
          if(!genomeOrReference) {
              console.warn("No genome or reference object specified");
              return;
          }
          const genomeConfig = await GenomeUtils.expandReference(this.alert, genomeOrReference);


          await this.loadReference(genomeConfig, session.locus);

          this.centerLineList = this.createCenterLineList(this.columnContainer);

          // Create ideogram and ruler track.  Really this belongs in browser initialization, but creation is
          // deferred because ideogram and ruler are treated as "tracks", and tracks require a reference frame
          let ideogramHeight = 0;
          if (false !== session.showIdeogram) {

              const track = new IdeogramTrack(this);
              track.id = 'ideogram';

              const trackView = new TrackView(this, this.columnContainer, track);
              const {$viewport} = trackView.viewports[0];
              ideogramHeight = getElementAbsoluteHeight($viewport.get(0));

              this.trackViews.push(trackView);
          }

          if (false !== session.showRuler) {
              this.trackViews.push(new TrackView(this, this.columnContainer, new RulerTrack(this)));
          }

          // Restore gtex selections.
          if (session.gtexSelections) {
              for (let referenceFrame of this.referenceFrameList) {
                  for (let s of Object.keys(session.gtexSelections)) {
                      const gene = session.gtexSelections[s].gene;
                      const snp = session.gtexSelections[s].snp;
                      referenceFrame.selection = new GtexSelection(gene, snp);
                  }
              }
          }

          if (this.roiManager) {
              this.roiManager.dispose();
          }

          const roiMenu = new ROIMenu(this, this.columnContainer);
          const roiTableConfig =
              {
                  browser: this,
                  parent: this.columnContainer,
                  headerTitle: 'Regions of Interest',
                  dismissHandler: () => this.roiTableControl.buttonHandler(false),
                  gotoButtonHandler: ROITable.gotoButtonHandler
              };
          if (session.roi) {

              const roiSetList = session.roi.map(c => new ROISet(c, this.genome));

              const named = roiSetList.filter(({name}) => name !== undefined && name.length > 0);

              roiTableConfig.columnFormat = ROITable.getColumnFormatConfiguration(named.length > 0);

              const roiTable = new ROITable(roiTableConfig);

              this.roiManager = new ROIManager(this, roiMenu, roiTable, ideogramHeight, roiSetList);
          } else {

              roiTableConfig.columnFormat = ROITable.getColumnFormatConfiguration(false);

              const roiTable = new ROITable(roiTableConfig);

              this.roiManager = new ROIManager(this, roiMenu, roiTable, ideogramHeight, undefined);
          }

          await this.roiManager.initialize();

          // Tracks.  Start with genome tracks, if any, then append session tracks
          const genomeTracks = genomeConfig.tracks || [];
          const trackConfigurations = session.tracks ? genomeTracks.concat(session.tracks) : genomeTracks;

          // Ensure that we always have a sequence track with no explicit URL (=> the reference genome sequence track)
          const pushSequenceTrack = trackConfigurations.filter(track => 'sequence' === track.type && !track.url && !track.fastaURL).length === 0;
          if (pushSequenceTrack /*&& false !== this.config.showSequence*/) {
              trackConfigurations.push({type: "sequence", order: defaultSequenceTrackOrder});
          }

          // Maintain track order unless explicitly set
          let trackOrder = 1;
          for (let t of trackConfigurations) {
              if (undefined === t.order) {
                  t.order = trackOrder++;
              }
          }

          await this.loadTrackList(trackConfigurations);

          // The ruler and ideogram tracks are not explicitly loaded, but needs updated nonetheless.
          for (let rtv of this.trackViews.filter((tv) => tv.track.type === 'ruler' || tv.track.type === 'ideogram')) {
              rtv.updateViews();
          }

          this.updateUIWithReferenceFrameList();

      }

      createCenterLineList(columnContainer) {

          const centerLines = columnContainer.querySelectorAll('.igv-center-line');
          for (let i = 0; i < centerLines.length; i++) {
              centerLines[i].remove();
          }

          const centerLineList = [];
          const viewportColumns = columnContainer.querySelectorAll('.igv-column');
          for (let i = 0; i < viewportColumns.length; i++) {
              centerLineList.push(new ViewportCenterLine(this, this.referenceFrameList[i], viewportColumns[i]));
          }

          return centerLineList
      }

      /**
       * Load a reference genome object.  This includes the fasta, and optional cytoband, but no tracks.  This method
       * is used by loadGenome and loadSession.
       *
       * @param genomeConfig
       * @param initialLocus
       */
      async loadReference(genomeConfig, initialLocus) {

          const genome = await GenomeUtils.loadGenome(genomeConfig);

          const genomeChange = undefined === this.genome || (this.genome.id !== genome.id);

          this.genome = genome;

          this.updateNavbarDOMWithGenome(genome);

          if (genomeChange) {
              this.removeAllTracks();
          }

          let locus = getInitialLocus(initialLocus, genome);
          const locusFound = await this.search(locus, true);
          if (!locusFound) {
              locus = genome.getHomeChromosomeName();
              const locusFound = await this.search(locus, true);
              if (!locusFound) {
                  throw new Error("Cannot set initial locus")
              }
          }

          if (genomeChange && this.circularView) {
              this.circularView.setAssembly({
                  name: this.genome.id,
                  id: this.genome.id,
                  chromosomes: makeCircViewChromosomes(this.genome)
              });
          }
      }

      cleanHouseForSession() {

          for (let trackView of this.trackViews) {
              // empty axis column, viewport columns, sampleName column, scroll column, drag column, gear column
              trackView.removeDOMFromColumnContainer();
          }

          // discard all columns
          const elements = this.columnContainer.querySelectorAll('.igv-axis-column, .igv-column-shim, .igv-column, .igv-sample-name-column, .igv-scrollbar-column, .igv-track-drag-column, .igv-gear-menu-column');
          elements.forEach(column => column.remove());

          this.trackViews = [];

          if (this.circularView) {
              this.circularView.clearChords();
          }

      }

      updateNavbarDOMWithGenome(genome) {

          // If the genome is defined directly from a fasta file or data url the "id" will be the full url.  Don't display
          // this.
          let genomeLabel = (genome.id && genome.id.length < 10 ? genome.id : '');
          this.$current_genome.text(genomeLabel);
          this.$current_genome.attr('title', genome.id || '');
          this.chromosomeSelectWidget.update(genome);
      }

      /**
       * Load a genome, defined by a string ID or a json-like configuration object. This includes a fasta reference
       * as well as optional cytoband and annotation tracks.
       *
       * @param idOrConfig
       * @returns genome
       */
      async loadGenome(idOrConfig) {

          const genomeConfig = await GenomeUtils.expandReference(this.alert, idOrConfig);
          await this.loadReference(genomeConfig, undefined);

          const tracks = genomeConfig.tracks || [];

          // Insure that we always have a sequence track
          const pushSequenceTrack = tracks.filter(track => track.type === 'sequence').length === 0;
          if (pushSequenceTrack) {
              tracks.push({type: "sequence", order: defaultSequenceTrackOrder});
          }

          await this.loadTrackList(tracks);

          await this.updateViews();

          return this.genome
      }

      /**
       * Called after a session load, search, pan (horizontal drag), or resize
       *
       * @param referenceFrameList
       */
      updateUIWithReferenceFrameList() {

          const referenceFrameList = this.referenceFrameList;

          this.updateLocusSearchWidget();

          const isWGV = (this.isMultiLocusWholeGenomeView() || GenomeUtils.isWholeGenomeView(referenceFrameList[0].chr));

          this.navbarManager.navbarDidResize(this.$navigation.width(), isWGV);

          toggleTrackLabels(this.trackViews, this.trackLabelsVisible);

          this.setCenterLineAndCenterLineButtonVisibility(!GenomeUtils.isWholeGenomeView(referenceFrameList[0].chr));

      }

      setTrackLabelVisibility(isVisible) {
          toggleTrackLabels(this.trackViews, isVisible);
      }

      setROITableVisibility(isVisible) {
          true === isVisible ? this.roiManager.presentTable() : this.roiManager.dismissTable();
      }

      // cursor guide
      setCursorGuideVisibility(cursorGuideVisible) {

          if (cursorGuideVisible) {
              this.cursorGuide.show();
          } else {
              this.cursorGuide.hide();
          }
      }

      setCustomCursorGuideMouseHandler(mouseHandler) {
          this.cursorGuide.customMouseHandler = mouseHandler;
      }

      // center line
      setCenterLineVisibility(isCenterLineVisible) {
          for (let centerLine of this.centerLineList) {
              if (true === isCenterLineVisible) {
                  centerLine.show();
                  centerLine.repaint();
              } else {
                  centerLine.hide();
              }
          }
      }

      setCenterLineAndCenterLineButtonVisibility(isCenterLineVisible) {

          for (let centerLine of this.centerLineList) {
              const isShown = isCenterLineVisible && centerLine.isVisible;
              isShown ? centerLine.show() : centerLine.container.style.display = 'none';
          }

          const isShown = isCenterLineVisible && this.centerLineButton.isVisible;
          isShown ? this.centerLineButton.show() : this.centerLineButton.button.style.display = 'none';

      }

      /**
       * Public API function. Load a list of tracks.
       *
       * @param configList  Array of track configurations
       * @returns {Promise<*>}  Promise for track objects
       */
      async loadTrackList(configList) {

          const promises = [];
          for (let config of configList) {
              promises.push(this._loadTrack(config));
          }

          const loadedTracks = await Promise.all(promises);
          const groupAutoscaleViews = this.trackViews.filter(function (trackView) {
              return trackView.track.autoscaleGroup
          });
          if (groupAutoscaleViews.length > 0) {
              this.updateViews();
          }
          return loadedTracks
      }

      /**
       * Public API function
       *
       * Load an individual track.  If part of an autoscale group force a general update
       *
       * @param config  A track configuration
       * @returns {Promise<*>}  Promise for track object
       */
      async loadTrack(config) {

          const newTrack = this._loadTrack(config);

          if (config.autoscaleGroup) {
              // Await newTrack load and update all views
              await newTrack;
              this.updateViews();
          }

          return newTrack
      }

      /**
       * Return a promise to load a track.   Private function used by loadTrack() and loadTrackList()
       *
       * @param config
       * @returns {*}
       */

      async _loadTrack(config) {

          // config might be json
          if (isString$2(config)) {
              config = JSON.parse(config);
          }

          try {

              const newTrack = await this.createTrack(config);

              if (undefined === newTrack) {
                  return
              }

              // Set order field of track here.  Otherwise track order might get shuffled during asynchronous load
              if (undefined === newTrack.order) {
                  newTrack.order = this.trackViews.length;
              }

              const trackView = new TrackView(this, this.columnContainer, newTrack);
              this.trackViews.push(trackView);
              toggleTrackLabels(this.trackViews, this.trackLabelsVisible);
              this.reorderTracks();
              this.fireEvent('trackorderchanged', [this.getTrackOrder()]);

              if (typeof newTrack.postInit === 'function') {
                  try {
                      trackView.startSpinner();
                      await newTrack.postInit();
                  } finally {
                      trackView.stopSpinner();
                  }
              }

              if (!newTrack.autoscaleGroup) {
                  // Group autoscale will get updated later (as a group)
                  if (config.sync) {
                      await trackView.updateViews();
                  } else {
                      trackView.updateViews();
                  }
              }

              if (typeof newTrack.hasSamples === 'function' && newTrack.hasSamples()) {
                  if (this.config.showSampleNameButton !== false) {
                      this.sampleNameControl.show();   // If not explicitly set
                  }
              }

              return newTrack

          } catch (error) {
              const httpMessages =
                  {
                      "401": "Access unauthorized",
                      "403": "Access forbidden",
                      "404": "Not found"
                  };
              console.error(error);
              let msg = error.message || error.error || error.toString();
              if (httpMessages.hasOwnProperty(msg)) {
                  msg = httpMessages[msg];
              }
              msg += (": " + config.url);
              this.alert.present(new Error(msg), undefined);
          }
      }

      /**
       * Public API function - load a region of interest
       *
       * @param config  A "track" configuration object, or array of objects,  of type == "annotation" (bed, gff, etc)
       *
       * @returns {Promise<void>}
       */
      async loadROI(config) {
          await this.roiManager.loadROI(config, this.genome);
      }

      /**
       * Public API function - clear all regions of interest (ROI), including preloaded and user-defined ROIs
       */
      clearROIs() {
          this.roiManager.clearROIs();
      }

      /**
       * Public API function. Return a promise for the list of user-defined regions-of-interest
       */
      async getUserDefinedROIs() {

          if (this.roiManager) {

              const set = await this.roiManager.getUserDefinedROISet();
              if (undefined === set) {
                  return []
              }

              const featureHash = await set.getAllFeatures();
              const featureList = [];
              for (let value of Object.values(featureHash)) {
                  featureList.push(...value);
              }

              return featureList

          } else {
              return []
          }
      }

      getRulerTrackView() {
          const list = this.trackViews.filter(({track}) => 'ruler' === track.id);
          return list.length > 0 ? list[0] : undefined
      }

      /**
       * Create a Track object.
       * @param config
       * @returns {Promise<*>}
       */
      async createTrack(config) {

          // Resolve function and promise urls
          let url = await resolveURL(config.url || config.fastaURL);
          if (isString$2(url)) {
              url = url.trim();
          }

          if (url) {
              if (config.format) {
                  config.format = config.format.toLowerCase();
              } else if (config.fastaURL) {
                  config.format = "fasta";  // by definition
              } else {
                  let filename = config.filename;
                  if (!filename) {
                      filename = await getFilename$1(url);
                  }

                  const format = inferFileFormat(filename);

                  if ("tsv" === format) {
                      config.format = await inferFileFormatFromHeader(config);
                  } else if (format) {
                      config.format = format;
                  } else {
                      if (config.sourceType === "htsget") {
                          // Check for htsget URL.  This is a longshot
                          await HtsgetReader.inferFormat(config);
                      }
                  }
              }
          }


          let type = config.type ? config.type.toLowerCase() : undefined;

          if (!type) {
              type = inferTrackType(config);
              if ("bedtype" === type) {
                  // Bed files must be read to determine track type
                  const featureSource = FeatureSource(config, this.genome);
                  config._featureSource = featureSource;    // This is a temp variable, bit of a hack
                  const trackType = await featureSource.trackType();
                  if (trackType) {
                      type = trackType;
                  } else {
                      type = "annotation";
                  }
              }
              // Record in config to make type persistent in session
              config.type = type;
          }

          // Set defaults if specified
          if (this.trackDefaults && type) {
              const settings = this.trackDefaults[type];
              if (settings) {
                  for (let property in settings) {
                      if (settings.hasOwnProperty(property) && config[property] === undefined) {
                          config[property] = settings[property];
                      }
                  }
              }
          }

          const track = TrackFactory.getTrack(type, config, this);
          if (undefined === track) {
              this.alert.present(new Error(`Error creating track.  Could not determine track type for file: ${config.url || config}`), undefined);
          } else {

              if (config.roi && config.roi.length > 0) {
                  track.roiSets = config.roi.map(r => new TrackROISet(r, this.genome));
              }

              return track
          }
      }


      reorderTracks() {

          this.trackViews.sort(function (a, b) {

              const firstSortOrder = tv => {
                  return 'ideogram' === tv.track.id ? 1 :
                      'ruler' === tv.track.id ? 2 :
                          3
              };

              const aOrder1 = firstSortOrder(a);
              const bOrder1 = firstSortOrder(b);
              if (aOrder1 === bOrder1) {
                  const aOrder2 = a.track.order || 0;
                  const bOrder2 = b.track.order || 0;
                  return aOrder2 - bOrder2
              } else {
                  return aOrder1 - bOrder1
              }
          });

          // discard current track order
          for (let {axis, viewports, sampleNameViewport, outerScroll, dragHandle, gearContainer} of this.trackViews) {

              axis.remove();

              for (let {$viewport} of viewports) {
                  $viewport.detach();
              }

              sampleNameViewport.viewport.remove();

              outerScroll.remove();
              dragHandle.remove();
              gearContainer.remove();
          }

          // Reattach the divs to the dom in the correct order
          const viewportColumns = this.columnContainer.querySelectorAll('.igv-column');

          for (let {axis, viewports, sampleNameViewport, outerScroll, dragHandle, gearContainer} of this.trackViews) {

              this.columnContainer.querySelector('.igv-axis-column').appendChild(axis);

              for (let i = 0; i < viewportColumns.length; i++) {
                  const {$viewport} = viewports[i];
                  viewportColumns[i].appendChild($viewport.get(0));
              }

              this.columnContainer.querySelector('.igv-sample-name-column').appendChild(sampleNameViewport.viewport);

              this.columnContainer.querySelector('.igv-scrollbar-column').appendChild(outerScroll);

              this.columnContainer.querySelector('.igv-track-drag-column').appendChild(dragHandle);

              this.columnContainer.querySelector('.igv-gear-menu-column').appendChild(gearContainer);
          }

      }

      getTrackOrder() {
          return this.trackViews.filter(tv => tv.track && tv.track.name).map(tv => tv.track.name)
      }

      /**
       * NOTE: Public API function
       *
       * Remove all tracks matching the given name.  Usually this will be a single track, but there is no
       * guarantee names are unique
       *
       * @param name
       */
      removeTrackByName(name) {
          const copy = this.trackViews.slice();
          for (let trackView of copy) {
              if (name === trackView.track.name) {
                  this.removeTrack(trackView.track);
              }
          }
      }

      /**
       * NOTE: Public API function
       *
       * Remove the given track.  If it has already been removed this is a no-op.
       *
       * @param track
       */
      removeTrack(track) {
          for (let trackView of this.trackViews) {
              if (track === trackView.track) {
                  this._removeTrack(trackView.track);
                  break
              }
          }
      }

      _removeTrack(track) {
          if (track.disposed) return
          this.trackViews.splice(this.trackViews.indexOf(track.trackView), 1);
          this.fireEvent('trackremoved', [track]);
          this.fireEvent('trackorderchanged', [this.getTrackOrder()]);
          if (track.trackView) {
              track.trackView.dispose();
          }
      }

      /**
       * API function
       */
      removeAllTracks() {

          const remainingTrackViews = [];

          for (let trackView of this.trackViews) {

              if (trackView.track.id !== 'ruler' && trackView.track.id !== 'ideogram') {
                  this.fireEvent('trackremoved', [trackView.track]);
                  trackView.dispose();
              } else {
                  remainingTrackViews.push(trackView);
              }
          }

          this.trackViews = remainingTrackViews;
      }

      /**
       *
       * @param property
       * @param value
       * @returns {Array}  tracks with given property value.  e.g. findTracks("type", "annotation")
       */
      findTracks(property, value) {

          let f = typeof property === 'function' ?
              trackView => property(trackView.track) :
              trackView => value === trackView.track[property];

          return this.trackViews.filter(f).map(tv => tv.track)
      }

      /**
       * Set the track height globally for all tracks.  (Note: Its not clear why this is useful).
       * @param newHeight
       */
      setTrackHeight(newHeight) {

          this.trackHeight = newHeight;

          this.trackViews.forEach(function (trackView) {
              trackView.setTrackHeight(newHeight);
          });

      }

      /**
       * API function to signal that this browser visibility has changed, e.g. from hiding/showing in a tab interface.
       *
       * @returns {Promise<void>}
       */
      async visibilityChange() {
          this.layoutChange();
      }

      async layoutChange() {

          const status = this.referenceFrameList.find(referenceFrame => referenceFrame.bpPerPixel < 0);

          if (status) {
              const viewportWidth = this.calculateViewportWidth(this.referenceFrameList.length);
              for (let referenceFrame of this.referenceFrameList) {
                  referenceFrame.bpPerPixel = (referenceFrame.end - referenceFrame.start) / viewportWidth;
              }
          }

          if (this.referenceFrameList) {
              const isWGV = this.isMultiLocusWholeGenomeView() || GenomeUtils.isWholeGenomeView(this.referenceFrameList[0].chr);
              this.navbarManager.navbarDidResize(this.$navigation.width(), isWGV);
          }

          resize.call(this);
          await this.updateViews();
      }

      async updateViews() {

          const trackViews = this.trackViews;

          this.updateLocusSearchWidget();

          for (let centerGuide of this.centerLineList) {
              centerGuide.repaint();
          }

          // Don't autoscale while dragging.
          if (this.dragObject) {
              for (let trackView of trackViews) {
                  await trackView.updateViews();
              }
          } else {
              // Group autoscale
              const groupAutoscaleTracks = {};
              const otherTracks = [];
              for (let trackView of trackViews) {
                  const group = trackView.track.autoscaleGroup;
                  if (group) {
                      var l = groupAutoscaleTracks[group];
                      if (!l) {
                          l = [];
                          groupAutoscaleTracks[group] = l;
                      }
                      l.push(trackView);
                  } else {
                      otherTracks.push(trackView);
                  }
              }

              if (Object.entries(groupAutoscaleTracks).length > 0) {

                  const keys = Object.keys(groupAutoscaleTracks);
                  for (let group of keys) {

                      const groupTrackViews = groupAutoscaleTracks[group];
                      const promises = [];

                      for (let trackView of groupTrackViews) {
                          promises.push(trackView.getInViewFeatures());
                      }

                      const featureArray = await Promise.all(promises);

                      var allFeatures = [], dataRange;

                      for (let features of featureArray) {
                          allFeatures = allFeatures.concat(features);
                      }
                      dataRange = doAutoscale(allFeatures);

                      const p = [];
                      for (let trackView of groupTrackViews) {
                          trackView.track.dataRange = dataRange;
                          trackView.track.autoscale = false;
                          p.push(trackView.updateViews());
                      }
                      await Promise.all(p);
                  }

              }

              await Promise.all(otherTracks.map(tv => tv.updateViews()));
              // for (let trackView of otherTracks) {
              //     await trackView.updateViews(force);
              // }
          }

      }

      repaintViews() {
          for (let trackView of this.trackViews) {
              trackView.repaintViews();
          }
      }

      updateLocusSearchWidget() {

          if(!this.referenceFrameList) return
          const referenceFrameList = this.referenceFrameList;

          // Update end position of reference frames based on pixel widths.  This is hacky, but its been done here
          // for a long time, although indirectly.
          const width = this.calculateViewportWidth(this.referenceFrameList.length);
          for (let referenceFrame of referenceFrameList) {
              referenceFrame.end = referenceFrame.start + referenceFrame.bpPerPixel * width;
          }

          this.chromosomeSelectWidget.select.value = referenceFrameList.length === 1 ? this.referenceFrameList[0].chr : '';

          const loc = this.referenceFrameList.map(rf => rf.getLocusString()).join(' ');
          //const loc = this.referenceFrameList.length === 1 ?   this.referenceFrameList[0].getLocusString() : '';
          this.$searchInput.val(loc);

          this.fireEvent('locuschange', [this.referenceFrameList]);
      }

      calculateViewportWidth(columnCount) {

          let {width} = this.columnContainer.getBoundingClientRect();

          const sampleNameViewportWidth = this.getSampleNameViewportWidth();

          width -= igv_axis_column_width + sampleNameViewportWidth + igv_scrollbar_outer_width + igv_track_manipulation_handle_width + igv_track_gear_menu_column_width;

          width -= column_multi_locus_shim_width * (columnCount - 1);

          return Math.floor(width / columnCount)
      }

      getCenterLineXOffset() {
          let {width: columnContainerWidth} = this.columnContainer.getBoundingClientRect();
          columnContainerWidth -= igv_axis_column_width + this.getSampleNameViewportWidth() + igv_scrollbar_outer_width + igv_track_manipulation_handle_width + igv_track_gear_menu_column_width;
          return Math.floor(columnContainerWidth / 2 + igv_axis_column_width)
      }

      minimumBases() {
          return this.config.minimumBases
      }

      // Zoom in by a factor of 2, keeping the same center location
      zoomIn() {
          this.zoomWithScaleFactor(0.5);
      };

      // Zoom out by a factor of 2, keeping the same center location if possible
      zoomOut() {
          this.zoomWithScaleFactor(2.0);
      };

      async zoomWithScaleFactor(scaleFactor, centerBPOrUndefined, referenceFrameOrUndefined) {

          if(!this.referenceFrameList) return

          const viewportWidth = this.calculateViewportWidth(this.referenceFrameList.length);

          let referenceFrames = referenceFrameOrUndefined ? [referenceFrameOrUndefined] : this.referenceFrameList;

          for (let referenceFrame of referenceFrames) {
              referenceFrame.zoomWithScaleFactor(this, scaleFactor, viewportWidth, centerBPOrUndefined);
          }
      }

      /**
       * Add a new multi-locus panel for the specified region
       * @param chr
       * @param start
       * @param end
       * @param referenceFrameLeft - optional, if supplied new panel should be placed to the immediate right
       */
      async addMultiLocusPanel(chr, start, end, referenceFrameLeft) {

          if(!this.referenceFrameList) return

          // account for reduced viewport width as a result of adding right mate pair panel
          const viewportWidth = this.calculateViewportWidth(1 + this.referenceFrameList.length);
          const scaleFactor = this.calculateViewportWidth(this.referenceFrameList.length) / this.calculateViewportWidth(1 + this.referenceFrameList.length);
          for (let refFrame of this.referenceFrameList) {
              refFrame.bpPerPixel *= scaleFactor;
          }

          const bpp = (end - start) / viewportWidth;
          const newReferenceFrame = new ReferenceFrame(this.genome, chr, start, end, bpp);
          const indexLeft = referenceFrameLeft ? this.referenceFrameList.indexOf(referenceFrameLeft) : this.referenceFrameList.length - 1;
          const indexRight = 1 + indexLeft;

          // TODO -- this is really ugly
          const {$viewport} = this.trackViews[0].viewports[indexLeft];
          const viewportColumn = viewportColumnManager.insertAfter($viewport.get(0).parentElement);

          if (indexRight === this.referenceFrameList.length) {
              this.referenceFrameList.push(newReferenceFrame);
              for (let trackView of this.trackViews) {
                  const viewport = createViewport(trackView, viewportColumn, newReferenceFrame);
                  trackView.viewports.push(viewport);
              }
          } else {
              this.referenceFrameList.splice(indexRight, 0, newReferenceFrame);
              for (let trackView of this.trackViews) {
                  const viewport = createViewport(trackView, viewportColumn, newReferenceFrame);
                  trackView.viewports.splice(indexRight, 0, viewport);
              }
          }


          this.centerLineList = this.createCenterLineList(this.columnContainer);

          resize.call(this);
          await this.updateViews(true);
      }

      async removeMultiLocusPanel(referenceFrame) {

          // find the $column corresponding to this referenceFrame and remove it
          const index = this.referenceFrameList.indexOf(referenceFrame);
          const {$viewport} = this.trackViews[0].viewports[index];
          viewportColumnManager.removeColumnAtIndex(index, $viewport.parent().get(0));

          for (let {viewports} of this.trackViews) {
              viewports[index].dispose();
              viewports.splice(index, 1);
          }

          this.referenceFrameList.splice(index, 1);

          if (1 === this.referenceFrameList.length && this.getRulerTrackView()) {
              for (let rulerViewport of this.getRulerTrackView().viewports) {
                  rulerViewport.dismissLocusLabel();
              }
          }

          const scaleFactor = this.calculateViewportWidth(1 + this.referenceFrameList.length) / this.calculateViewportWidth(this.referenceFrameList.length);

          await this.rescaleForMultiLocus(scaleFactor);

      }

      /**
       * Goto the locus represented by the selected referenceFrame, discarding all other panels
       *
       * @param referenceFrame
       * @returns {Promise<void>}
       */
      async gotoMultilocusPanel(referenceFrame) {

          const referenceFrameIndex = this.referenceFrameList.indexOf(referenceFrame);

          // Remove columns for unselected panels
          this.columnContainer.querySelectorAll('.igv-column').forEach((column, c) => {
              if (c === referenceFrameIndex) ; else {
                  column.remove();
              }
          });

          // Remove all column shims
          this.columnContainer.querySelectorAll('.igv-column-shim').forEach(shim => shim.remove());

          // Discard viewports
          for (let trackView of this.trackViews) {
              const retain = trackView.viewports[referenceFrameIndex];
              trackView.viewports.filter((viewport, i) => i !== referenceFrameIndex).forEach(viewport => viewport.dispose());
              trackView.viewports = [retain];
          }

          const viewportWidth = this.calculateViewportWidth(1);
          referenceFrame.bpPerPixel = (referenceFrame.end - referenceFrame.start) / viewportWidth;
          this.referenceFrameList = [referenceFrame];

          this.trackViews.forEach(({viewports}) => viewports.forEach(viewport => viewport.setWidth(viewportWidth)));

          this.centerLineList = this.createCenterLineList(this.columnContainer);

          this.updateUIWithReferenceFrameList();

          await this.updateViews(true);

      }

      async rescaleForMultiLocus(scaleFactor) {

          const viewportWidth = this.calculateViewportWidth(this.referenceFrameList.length);

          for (let referenceFrame of this.referenceFrameList) {
              referenceFrame.bpPerPixel *= scaleFactor;
          }

          for (let {viewports} of this.trackViews) {

              for (let viewport of viewports) {
                  viewport.setWidth(viewportWidth);
              }
          }

          this.centerLineList = this.createCenterLineList(this.columnContainer);

          this.updateUIWithReferenceFrameList();

          await this.updateViews();

      }

      /**
       * @deprecated  This is a deprecated method with no known usages.  To be removed in a future release.
       */
      async goto(chr, start, end) {
          await this.search(chr + ":" + start + "-" + end);
      }

      /**

       * Search for the locus string -- this function is called from various igv.js GUI elements, and is not part of the
       * API.  Wraps ```search``` and presents an error dialog if false.
       *
       * @param string
       * @param init
       * @returns {Promise<void>}
       */
      async doSearch(string, init) {
          const success = await this.search(string, init);
          if (!success) {
              this.alert.present(new Error(`Unrecognized locus: <b> ${string} </b>`));
          }
          return success
      }


      /**
       * Search for the locus string
       * NOTE: This is part of the API
       * @param string
       * @param init  true if called during browser initialization
       * @returns {Promise<boolean>}  true if found, false if not
       */
      async search(string, init) {

          const loci = await search(this, string);

          if (loci && loci.length > 0) {

              // create reference frame list based on search loci
              this.referenceFrameList = createReferenceFrameList(loci, this.genome, this.flanking, this.minimumBases(), this.calculateViewportWidth(loci.length), this.isSoftclipped());

              // discard viewport DOM elements
              for (let trackView of this.trackViews) {
                  // empty axis column, viewport columns, sampleName column, scroll column, drag column, gear column
                  trackView.removeDOMFromColumnContainer();
              }

              // discard ONLY viewport columns
              this.columnContainer.querySelectorAll('.igv-column-shim, .igv-column').forEach(el => el.remove());

              // Insert viewport columns preceding the sample-name column
              viewportColumnManager.insertBefore(this.columnContainer.querySelector('.igv-sample-name-column'), this.referenceFrameList.length);

              this.centerLineList = this.createCenterLineList(this.columnContainer);

              // Populate the columns
              for (let trackView of this.trackViews) {
                  trackView.addDOMToColumnContainer(this, this.columnContainer, this.referenceFrameList);
              }

              this.updateUIWithReferenceFrameList();

              if (!init) {
                  await this.updateViews();
              }
              return true
          } else {
              return false
          }
      }

      async loadSampleInformation(url) {
          var name = url;
          if (isFile$2(url)) {
              name = url.name;
          }
          var ext = name.substr(name.lastIndexOf('.') + 1);
          if (ext === 'fam') {
              this.sampleInformation = await loadPlinkFile(url);
          }
      };

  // EVENTS

      on(eventName, fn) {
          if (!this.eventHandlers[eventName]) {
              this.eventHandlers[eventName] = [];
          }
          this.eventHandlers[eventName].push(fn);
      };

      /**
       * @deprecated use off()
       * @param eventName
       * @param fn
       */
      un(eventName, fn) {
          this.off(eventName, fn);
      };

      off(eventName, fn) {

          if (!eventName) {
              this.eventHandlers = {};   // Remove all event handlers
          } else if (!fn) {
              this.eventHandlers[eventName] = []; // Remove all eventhandlers matching name
          } else {
              // Remove specific event handler
              const handlers = this.eventHandlers[eventName];
              if (!handlers || handlers.length === 0) {
                  console.warn("No handlers to remove for event: " + eventName);
              } else {
                  const callbackIndex = handlers.indexOf(fn);
                  if (callbackIndex !== -1) {
                      this.eventHandlers[eventName].splice(callbackIndex, 1);
                  }
              }
          }
      }

      fireEvent(eventName, args, thisObj) {

          const handlers = this.eventHandlers[eventName];
          if (undefined === handlers || handlers.length === 0) {
              return undefined
          }

          const scope = thisObj || window;
          const results = handlers.map(function (event) {
              return event.apply(scope, args)
          });

          return results[0]
      }

      dispose() {
          this.removeMouseHandlers();
          for (let trackView of this.trackViews) {
              trackView.dispose();
          }
      }

      /**
       * Return a json-like object (note not a json string) representing the current state.
       *
       */
      toJSON() {

          const json = {
              "version": version$2()
          };

          if (this.showSampleNames !== undefined) {
              json['showSampleNames'] = this.showSampleNames;
          }
          if (this.sampleNameViewportWidth !== defaultSampleNameViewportWidth) {
              json['sampleNameViewportWidth'] = this.sampleNameViewportWidth;
          }

          json["reference"] = this.genome.toJSON();
          if (json.reference.fastaURL instanceof File) {   // Test specifically for File.  Other types of File-like objects might be savable) {
              throw new Error(`Error. Sessions cannot include local file references ${json.reference.fastaURL.name}.`)
          } else if (json.reference.indexURL instanceof File) {   // Test specifically for File.  Other types of File-like objects might be savable) {
              throw new Error(`Error. Sessions cannot include local file references ${json.reference.indexURL.name}.`)
          }

          // Build locus array (multi-locus view).  Use the first track to extract the loci, any track could be used.
          const locus = [];
          const gtexSelections = {};
          let hasGtexSelections = false;
          let anyTrackView = this.trackViews[0];
          for (let {referenceFrame} of anyTrackView.viewports) {
              const locusString = referenceFrame.getLocusString();
              locus.push(locusString);
              if (referenceFrame.selection) {
                  const selection = {
                      gene: referenceFrame.selection.gene,
                      snp: referenceFrame.selection.snp
                  };
                  gtexSelections[locusString] = selection;
                  hasGtexSelections = true;
              }
          }
          json["locus"] = locus.length === 1 ? locus[0] : locus;
          if (hasGtexSelections) {
              json["gtexSelections"] = gtexSelections;
          }

          json["roi"] = this.roiManager.toJSON();

          const trackJson = [];
          const errors = [];
          for (let {track} of this.trackViews) {
              try {
                  let config;
                  if (typeof track.getState === "function") {
                      config = track.getState();
                  } else {
                      config = track.config;
                  }

                  if (config) {
                      // null backpointer to browser
                      if (config.browser) {
                          delete config.browser;
                      }
                      config.order = track.order; //order++;
                      trackJson.push(config);
                  }
              } catch (e) {
                  console.error(`Track: ${track.name}: ${e}`);
                  errors.push(`Track: ${track.name}: ${e}`);
              }
          }

          if (errors.length > 0) {
              let n = 1;
              let message = 'Errors encountered saving session: </br>';
              for (let e of errors) {
                  message += ` (${n++}) ${e.toString()} <br/>`;
              }
              throw Error(message)
          }


          json["tracks"] = trackJson;

          return json        // This is an object, not a json string

      }

      compressedSession() {
          const json = JSON.stringify(this.toJSON());
          return compressString(json)
      }

      sessionURL() {
          const path = window.location.href.slice();
          const idx = path.indexOf("?");
          const surl = (idx > 0 ? path.substring(0, idx) : path) + "?sessionURL=blob:" + this.compressedSession();
          return surl
      }

      /**
       * Record a mouse click on a specific viewport.   This might be the start of a drag operation.   Dragging
       * (panning) is handled here so that the mouse can move out of a specific viewport (e.g. stray into another
       * track) without halting the drag.
       *
       * @param e
       * @param viewport
       */
      mouseDownOnViewport(e, viewport) {

          var coords;
          coords = domUtils.pageCoordinates(e);
          this.vpMouseDown = {
              viewport,
              lastMouseX: coords.x,
              mouseDownX: coords.x,
              lastMouseY: coords.y,
              mouseDownY: coords.y,
              referenceFrame: viewport.referenceFrame
          };
      };

      cancelTrackPan() {

          const dragObject = this.dragObject;
          this.dragObject = undefined;
          this.isScrolling = false;
          this.vpMouseDown = undefined;

          if (dragObject && dragObject.viewport.referenceFrame.start !== dragObject.start) {
              this.updateViews();
              this.fireEvent('trackdragend');
          }
      }

      isTrackPanning() {
          return this.dragObject
      }

      isSoftclipped() {
          const result = this.trackViews.find(tv => tv.track.showSoftClips === true);
          return result !== undefined
      }


      /**
       * Track drag here refers to vertical dragging to reorder tracks, not horizontal panning.
       *
       * @param trackView
       */
      startTrackDrag(trackView) {

          this.dragTrack = trackView;

      }

      /**
       * Track drag here refers to vertical dragging to reorder tracks, not horizontal panning.
       *
       * @param dragDestination
       */
      updateTrackDrag(dragDestination) {

          if (dragDestination && this.dragTrack) {

              const dragged = this.dragTrack;
              const indexDestination = this.trackViews.indexOf(dragDestination);
              const indexDragged = this.trackViews.indexOf(dragged);
              const trackViews = this.trackViews;

              trackViews[indexDestination] = dragged;
              trackViews[indexDragged] = dragDestination;

              const newOrder = this.trackViews[indexDestination].track.order;
              this.trackViews[indexDragged].track.order = newOrder;

              const nTracks = trackViews.length;
              let lastOrder = newOrder;

              if (indexDestination < indexDragged) {
                  // Displace tracks below

                  for (let i = indexDestination + 1; i < nTracks; i++) {
                      const track = trackViews[i].track;
                      if (track.order <= lastOrder) {
                          track.order = Math.min(Number.MAX_SAFE_INTEGER, lastOrder + 1);
                          lastOrder = track.order;
                      } else {
                          break
                      }
                  }
              } else {
                  // Displace tracks above.  First track (index 0) is "ruler"
                  for (let i = indexDestination - 1; i > 0; i--) {
                      const track = trackViews[i].track;
                      if (track.order >= lastOrder) {
                          track.order = Math.max(-Number.MAX_SAFE_INTEGER, lastOrder - 1);
                          lastOrder = track.order;
                      } else {
                          break
                      }
                  }
              }
              this.reorderTracks();
          }
      }

      /**
       * End vertical dragging of tracks (i.e. track re-order, not horizontal panning of data)
       */
      endTrackDrag() {
          if (this.dragTrack) {
              // this.dragTrack.$trackDragScrim.hide();
              this.dragTrack = undefined;
              this.fireEvent('trackorderchanged', [this.getTrackOrder()]);
          } else {
              this.dragTrack = undefined;
          }
      }

      /**
       * Mouse handlers to support drag (pan)
       */
      addMouseHandlers() {
          this.addWindowResizeHandler();
          this.addRootMouseUpHandler();
          this.addRootMouseLeaveHandler();
          this.addColumnContainerEventHandlers();
      }

      removeMouseHandlers() {
          this.removeWindowResizeHandler();
          this.removeRootMouseUpHandler();
          this.removeRootMouseLeaveHandler();
          this.removeColumnContainerEventHandlers();
      }

      addWindowResizeHandler() {
          // Create a copy of the prototype "resize" function bound to this instance.  Neccessary to support removing.
          this.boundWindowResizeHandler = resize.bind(this);
          window.addEventListener('resize', this.boundWindowResizeHandler);
      }

      removeWindowResizeHandler() {
          window.removeEventListener('resize', this.boundWindowResizeHandler);
      }

      addRootMouseUpHandler() {
          this.boundRootMouseUpHandler = mouseUpOrLeave.bind(this);
          this.root.addEventListener('mouseup', this.boundRootMouseUpHandler);
      }

      removeRootMouseUpHandler() {
          this.root.removeEventListener('mouseup', this.boundRootMouseUpHandler);
      }

      addRootMouseLeaveHandler() {
          this.boundRootMouseLeaveHandler = mouseUpOrLeave.bind(this);
          this.root.addEventListener('mouseleave', this.boundRootMouseLeaveHandler);
      }

      removeRootMouseLeaveHandler() {
          this.root.removeEventListener('mouseleave', this.boundRootMouseLeaveHandler);
      }

      addColumnContainerEventHandlers() {
          this.boundColumnContainerMouseMoveHandler = handleMouseMove.bind(this);
          this.boundColumnContainerTouchMoveHandler = handleMouseMove.bind(this);
          this.boundColumnContainerMouseLeaveHandler = mouseUpOrLeave.bind(this);
          this.boundColumnContainerMouseUpHandler = mouseUpOrLeave.bind(this);
          this.boundColumnContainerTouchEndHandler = mouseUpOrLeave.bind(this);

          this.columnContainer.addEventListener('mousemove', this.boundColumnContainerMouseMoveHandler);
          this.columnContainer.addEventListener('touchmove', this.boundColumnContainerTouchMoveHandler);

          this.columnContainer.addEventListener('mouseleave', this.boundColumnContainerMouseLeaveHandler);

          this.columnContainer.addEventListener('mouseup', this.boundColumnContainerMouseUpHandler);
          this.columnContainer.addEventListener('touchend', this.boundColumnContainerTouchEndHandler);
      }

      removeColumnContainerEventHandlers() {
          this.columnContainer.removeEventListener('mousemove', this.boundColumnContainerMouseMoveHandler);
          this.columnContainer.removeEventListener('touchmove', this.boundColumnContainerTouchMoveHandler);

          this.columnContainer.removeEventListener('mouseleave', this.boundColumnContainerMouseLeaveHandler);

          this.columnContainer.removeEventListener('mouseup', this.boundColumnContainerMouseUpHandler);
          this.columnContainer.removeEventListener('touchend', this.boundColumnContainerTouchEndHandler);
      }

      static uncompressSession(url) {

          let bytes;
          if (url.indexOf('/gzip;base64') > 0) {
              //Proper dataURI
              bytes = decodeDataURI$1(url);
              let json = '';
              for (let b of bytes) {
                  json += String.fromCharCode(b);
              }
              return json
          } else {

              let enc = url.substring(5);
              return uncompressString(enc)
          }
      }

      createCircularView(container, show) {
          show = show === true;   // convert undefined to boolean
          this.circularView = createCircularView(container, this);
          this.circularViewControl = new CircularViewControl(this.$toggle_button_container.get(0), this);
          this.circularView.setAssembly({
              name: this.genome.id,
              id: this.genome.id,
              chromosomes: makeCircViewChromosomes(this.genome)
          });
          this.circularViewVisible = show;
          return this.circularView
      }

      get circularViewVisible() {
          return this.circularView !== undefined && this.circularView.visible
      }

      set circularViewVisible(isVisible) {
          if (this.circularView) {
              this.circularView.visible = isVisible;
              this.circularViewControl.setState(isVisible);
          }
      }
  }

  /**
   * Function called win window is resized, or visibility changed (e.g. "show" from a tab).  This is a function rather
   * than class method because it needs to be copied and bound to specific instances of browser to support listener
   * removal
   *
   * @returns {Promise<void>}
   */
  async function resize() {

      if(!this.referenceFrameList) return

      const viewportWidth = this.calculateViewportWidth(this.referenceFrameList.length);

      for (let referenceFrame of this.referenceFrameList) {

          const index = this.referenceFrameList.indexOf(referenceFrame);

          const {chr, genome} = referenceFrame;

          const {bpLength} = genome.getChromosome(referenceFrame.chr);

          const viewportWidthBP = referenceFrame.toBP(viewportWidth);

          // viewportWidthBP > bpLength occurs when locus is full chromosome and user widens browser
          if (GenomeUtils.isWholeGenomeView(chr) || viewportWidthBP > bpLength) {
              // console.log(`${ Date.now() } Recalc referenceFrame(${ index }) bpp. viewport ${ StringUtils.numberFormatter(viewportWidthBP) } > ${ StringUtils.numberFormatter(bpLength) }.`)
              referenceFrame.bpPerPixel = bpLength / viewportWidth;
          } else {
              // console.log(`${ Date.now() } Recalc referenceFrame(${ index }) end.`)
              referenceFrame.end = referenceFrame.start + referenceFrame.toBP(viewportWidth);
          }

          for (let {viewports} of this.trackViews) {
              viewports[index].setWidth(viewportWidth);
          }

      }

      this.updateUIWithReferenceFrameList();

      //TODO -- update view only if needed.  Reducing size never needed.  Increasing size maybe

      await this.updateViews(true);
  }


  function handleMouseMove(e) {

      e.preventDefault();

      const {x, y} = domUtils.pageCoordinates(e);

      if (this.vpMouseDown) {

          const {viewport, referenceFrame} = this.vpMouseDown;

          // Determine direction,  true == horizontal
          const horizontal = Math.abs((x - this.vpMouseDown.mouseDownX)) > Math.abs((y - this.vpMouseDown.mouseDownY));

          if (!this.dragObject && !this.isScrolling) {
              if (horizontal) {
                  if (this.vpMouseDown.mouseDownX && Math.abs(x - this.vpMouseDown.mouseDownX) > this.constants.dragThreshold) {
                      this.dragObject = {viewport, start: referenceFrame.start};
                  }
              } else {
                  if (this.vpMouseDown.mouseDownY &&
                      Math.abs(y - this.vpMouseDown.mouseDownY) > this.constants.scrollThreshold) {
                      // Scrolling => dragging track vertically
                      this.isScrolling = true;
                      const viewportHeight = viewport.$viewport.height();
                      const contentHeight = viewport.trackView.maxViewportContentHeight();
                      this.vpMouseDown.r = viewportHeight / contentHeight;
                  }
              }
          }

          if (this.dragObject) {
              const clampDrag = !this.isSoftclipped();
              let deltaX = this.vpMouseDown.lastMouseX - x;
              const viewChanged = referenceFrame.shiftPixels(deltaX, viewport.$viewport.width(), clampDrag);
              if (viewChanged) {
                  this.updateViews();
              }
              this.fireEvent('trackdrag');
          }


          if (this.isScrolling) {
              const delta = this.vpMouseDown.r * (this.vpMouseDown.lastMouseY - y);
              viewport.trackView.moveScroller(delta);
          }


          this.vpMouseDown.lastMouseX = x;
          this.vpMouseDown.lastMouseY = y;
      }
  }

  function mouseUpOrLeave(e) {
      this.cancelTrackPan();
      this.endTrackDrag();
  }


  function getInitialLocus(locus, genome) {
      if (locus) {
          return Array.isArray(locus) ? locus.join(' ') : locus
      } else {
          return genome.getHomeChromosomeName()
      }
  }

  function logo() {

      return $$1(
          '<svg width="690px" height="324px" viewBox="0 0 690 324" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">' +
          '<title>IGV</title>' +
          '<g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">' +
          '<g id="IGV" fill="#666666">' +
          '<polygon id="Path" points="379.54574 8.00169252 455.581247 8.00169252 515.564813 188.87244 532.884012 253.529506 537.108207 253.529506 554.849825 188.87244 614.833392 8.00169252 689.60164 8.00169252 582.729511 320.722144 486.840288 320.722144"></polygon>' +
          '<path d="M261.482414,323.793286 C207.975678,323.793286 168.339046,310.552102 142.571329,284.069337 C116.803612,257.586572 103.919946,217.158702 103.919946,162.784513 C103.919946,108.410325 117.437235,67.8415913 144.472217,41.0770945 C171.507199,14.3125977 212.903894,0.930550071 268.663545,0.930550071 C283.025879,0.930550071 298.232828,1.84616386 314.284849,3.6774189 C330.33687,5.50867394 344.839793,7.97378798 357.794056,11.072835 L357.794056,68.968378 C339.48912,65.869331 323.578145,63.5450806 310.060654,61.9955571 C296.543163,60.4460336 284.574731,59.6712835 274.154998,59.6712835 C255.850062,59.6712835 240.502308,61.4320792 228.111274,64.9537236 C215.720241,68.4753679 205.793482,74.2507779 198.330701,82.2801269 C190.867919,90.309476 185.587729,100.87425 182.48997,113.974767 C179.392212,127.075284 177.843356,143.345037 177.843356,162.784513 C177.843356,181.942258 179.251407,198.000716 182.067551,210.960367 C184.883695,223.920018 189.671068,234.41436 196.429813,242.443709 C203.188559,250.473058 212.059279,256.178037 223.042241,259.558815 C234.025202,262.939594 247.683295,264.629958 264.01693,264.629958 C268.241146,264.629958 273.098922,264.489094 278.590403,264.207362 C284.081883,263.925631 289.643684,263.50304 295.275972,262.939577 L295.275972,159.826347 L361.595831,159.826347 L361.595831,308.579859 C344.698967,313.087564 327.239137,316.750019 309.215815,319.567334 C291.192494,322.38465 275.281519,323.793286 261.482414,323.793286 L261.482414,323.793286 L261.482414,323.793286 Z" id="Path"></path>;' +
          '<polygon id="Path" points="0.81355666 5.00169252 73.0472883 5.00169252 73.0472883 317.722144 0.81355666 317.722144"></polygon>' +
          '</g> </g> </svg>'
      )
  }

  function toggleTrackLabels(trackViews, isVisible) {

      for (let {viewports} of trackViews) {
          for (let viewport of viewports) {
              if (viewport.$trackLabel) {
                  if (0 === viewports.indexOf(viewport) && true === isVisible) {
                      viewport.$trackLabel.show();
                  } else {
                      viewport.$trackLabel.hide();
                  }
              }
          }
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  let allBrowsers = [];

  /**
   * Create an igv.browser instance.  This object defines the public API for interacting with the genome browser.
   *
   * @param parentDiv - DOM tree root
   * @param config - configuration options.
   *
   */
  async function createBrowser(parentDiv, config) {

      if (undefined === config) config = {};

      // Initialize pre-defined genomes.  The genome list is shared among all browser instances
      if (!GenomeUtils.KNOWN_GENOMES) {
          await GenomeUtils.initializeGenomes(config);
      }

      setDefaults(config);

      if (config.queryParametersSupported) {
          extractQuery(config);
      }
      if (config.apiKey) {
          igvxhr$1.setApiKey(config.apiKey);
      }
      if (config.oauthToken) {
          igvxhr$1.setOauthToken(config.oauthToken);
      }
      if (config.clientId && (!isInitialized$2())) {
          await init$1$1({
              clientId: config.clientId,
              apiKey: config.apiKey,
              scope: 'https://www.googleapis.com/auth/userinfo.profile'
          });
      }

      // Create browser
      const browser = new Browser(config, parentDiv);
      allBrowsers.push(browser);

      // Load initial session
      if (config.sessionURL) {
          await browser.loadSession({
              url: config.sessionURL
          });
      } else {
          await browser.loadSessionObject(config);
      }

      browser.navbarManager.navbarDidResize(browser.$navigation.width());

      return browser

  }

  function removeBrowser(browser) {
      browser.dispose();
      browser.root.remove();
      allBrowsers = allBrowsers.filter(item => item !== browser);
  }

  function removeAllBrowsers() {
      for (let browser of allBrowsers) {
          browser.dispose();
          browser.root.remove();
      }
      allBrowsers = [];
  }

  /**
   * This function provided so clients can inform igv of a visibility change, typically when an igv instance is
   * made visible from a tab, accordion, or similar widget.
   */
  async function visibilityChange() {
      for (let browser of allBrowsers) {
          await browser.visibilityChange();
      }
  }

  function setDefaults(config) {

      if (undefined === config.minimumBases) {
          config.minimumBases = 40;
      }

      if (undefined === config.showIdeogram) {
          config.showIdeogram = true;
      }

      if (undefined === config.showCircularView) {
          config.showCircularView = false;
      }

      if (undefined === config.showCircularViewButton) {
          config.showCircularViewButton = false;
      }

      if (undefined === config.showTrackLabelButton) {
          config.showTrackLabelButton = true;
      }

      if (undefined === config.showTrackLabels) {
          config.showTrackLabels = true;
      }

      if (undefined === config.showROITableButton) {
          config.showROITableButton = false;
      }

      if (undefined === config.showROITable) {
          config.showROITable = false;
      }

      if (undefined === config.showCursorTrackingGuideButton) {
          config.showCursorTrackingGuideButton = true;
      }


      if (undefined === config.showCursorGuide) {
          config.showCursorGuide = config.showCursorTrackingGuide || false;   // showCursorTrackingGuide is a synonym
      }

      if (undefined === config.showCenterGuideButton) {
          config.showCenterGuideButton = true;
      }

      if (undefined === config.showCenterGuide) {
          config.showCenterGuide = false;
      }

      if (undefined === config.showSampleNames) {
          config.showSampleNames = false;
      }

      if (undefined === config.showSVGButton) {
          config.showSVGButton = true;
      }

      if (config.showControls === undefined) {
          config.showControls = true;
      }

      if (config.showNavigation === undefined) {
          config.showNavigation = true;
      }

      if (config.showRuler === undefined) {
          config.showRuler = true;
      }

      if (config.flanking === undefined) {
          config.flanking = 1000;
      }

      if (config.pairsSupported === undefined) {
          config.pairsSupported = true;
      }

      if (!config.tracks) {
          config.tracks = [];
      }

  }


  function extractQuery(config) {

      var i1, i2, i, j, s, query, tokens, uri, key, value;

      uri = window.location.href;

      query = {};
      i1 = uri.indexOf("?");
      i2 = uri.lastIndexOf("#");

      let files;
      let indexURLs;
      let names;
      if (i1 >= 0) {
          if (i2 < 0) i2 = uri.length;
          for (i = i1 + 1; i < i2;) {
              j = uri.indexOf("&", i);
              if (j < 0) j = i2;

              s = uri.substring(i, j);
              tokens = s.split("=", 2);

              if (tokens.length === 2) {
                  key = tokens[0];
                  value = decodeURIComponent(tokens[1]);

                  if ('file' === key) {
                      // IGV desktop style file parameter
                      files = value.split(',');
                  } else if ('index' === key) {
                      // IGV desktop style index parameter
                      indexURLs = value.split(',');
                  } else if ('name' === key) {
                      // IGV desktop style index parameter
                      names = value.split(',');
                  } else if ('genome' === key && ((value.startsWith("https://") || value.startsWith("http://")) && !value.endsWith(".json"))) {
                      // IGV desktop compatibility -- assuming url to fasta
                      config['reference'] = {
                          fastaURL: value,
                          indexURL: value + ".fai"
                      };
                  } else {
                      config[key] = value;
                  }
                  i = j + 1;
              } else {
                  i++;
              }
          }
      }

      if (files) {

          if (!config.tracks)
              config.tracks = [];
          for (let i = 0; i < files.length; i++) {

              if (files[i].endsWith(".xml") || files[i].endsWith(".json")) {
                  config.sessionURL = files[i];
                  break
              }

              const trackConfig = {url: files[i]};
              if (indexURLs && indexURLs.length > i) {
                  trackConfig.indexURL = indexURLs[i];
              }
              if (names && names.length > i) {
                  trackConfig.name = names[i];
              }
              config.tracks.push(trackConfig);
          }
      }

      return query
  }


  async function createTrack(config, browser) {
      return await Browser.prototype.createTrack.call(browser, config)
  }

  function embedCSS$3() {

      var css = '.igv-navbar {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center;\n  box-sizing: border-box;\n  width: 100%;\n  color: #444;\n  font-size: 12px;\n  font-family: \"Open Sans\", sans-serif;\n  font-weight: 400;\n  line-height: 32px;\n  padding-left: 8px;\n  padding-right: 8px;\n  margin-top: 2px;\n  margin-bottom: 6px;\n  height: 32px;\n  border-style: solid;\n  border-radius: 3px;\n  border-width: thin;\n  border-color: #bfbfbf;\n  background-color: #f3f3f3;\n}\n.igv-navbar .igv-navbar-left-container {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center;\n  height: 32px;\n  line-height: 32px;\n}\n.igv-navbar .igv-navbar-left-container .igv-logo {\n  width: 34px;\n  height: 32px;\n  margin-right: 8px;\n}\n.igv-navbar .igv-navbar-left-container .igv-current-genome {\n  height: 32px;\n  margin-left: 4px;\n  margin-right: 4px;\n  user-select: none;\n  line-height: 32px;\n  vertical-align: middle;\n  text-align: center;\n}\n.igv-navbar .igv-navbar-left-container .igv-navbar-genomic-location {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center;\n  height: 100%;\n}\n.igv-navbar .igv-navbar-left-container .igv-navbar-genomic-location .igv-chromosome-select-widget-container {\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: space-around;\n  align-items: center;\n  height: 100%;\n  width: 125px;\n  margin-right: 4px;\n}\n.igv-navbar .igv-navbar-left-container .igv-navbar-genomic-location .igv-chromosome-select-widget-container select {\n  display: block;\n  cursor: pointer;\n  width: 100px;\n  height: 75%;\n  outline: none;\n  font-size: 12px;\n  font-family: \"Open Sans\", sans-serif;\n  font-weight: 400;\n}\n.igv-navbar .igv-navbar-left-container .igv-navbar-genomic-location .igv-locus-size-group {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center;\n  margin-left: 8px;\n  height: 22px;\n}\n.igv-navbar .igv-navbar-left-container .igv-navbar-genomic-location .igv-locus-size-group .igv-search-container {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n  width: 210px;\n  height: 22px;\n  line-height: 22px;\n}\n.igv-navbar .igv-navbar-left-container .igv-navbar-genomic-location .igv-locus-size-group .igv-search-container input.igv-search-input {\n  cursor: text;\n  width: 85%;\n  height: 22px;\n  line-height: 22px;\n  font-size: 12px;\n  font-family: \"Open Sans\", sans-serif;\n  font-weight: 400;\n  text-align: left;\n  padding-left: 8px;\n  margin-right: 8px;\n  outline: none;\n  border-style: solid;\n  border-radius: 3px;\n  border-width: thin;\n  border-color: #bfbfbf;\n  background-color: white;\n}\n.igv-navbar .igv-navbar-left-container .igv-navbar-genomic-location .igv-locus-size-group .igv-search-container .igv-search-icon-container {\n  cursor: pointer;\n  height: 16px;\n  width: 16px;\n}\n.igv-navbar .igv-navbar-left-container .igv-navbar-genomic-location .igv-locus-size-group .igv-windowsize-panel-container {\n  margin-left: 4px;\n  user-select: none;\n}\n.igv-navbar .igv-navbar-right-container {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center;\n  height: 32px;\n  line-height: 32px;\n}\n.igv-navbar .igv-navbar-right-container .igv-navbar-toggle-button-container {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center;\n  height: 100%;\n}\n.igv-navbar .igv-navbar-right-container .igv-navbar-toggle-button-container div {\n  margin-left: 0;\n  margin-right: 4px;\n}\n.igv-navbar .igv-navbar-right-container .igv-navbar-toggle-button-container div:last-child {\n  margin-left: 0;\n  margin-right: 0;\n}\n.igv-navbar .igv-navbar-right-container .igv-navbar-toggle-button-container-750 {\n  display: none;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget {\n  color: #737373;\n  font-size: 18px;\n  height: 32px;\n  line-height: 32px;\n  margin-left: 8px;\n  user-select: none;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-end;\n  align-items: center;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget div {\n  cursor: pointer;\n  margin-left: unset;\n  margin-right: unset;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget div:first-child {\n  height: 24px;\n  width: 24px;\n  margin-left: unset;\n  margin-right: 8px;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget div:last-child {\n  height: 24px;\n  width: 24px;\n  margin-left: 8px;\n  margin-right: unset;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget div:nth-child(even) {\n  display: block;\n  height: fit-content;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget input {\n  display: block;\n  width: 125px;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget svg {\n  display: block;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget-900 {\n  color: #737373;\n  font-size: 18px;\n  height: 32px;\n  line-height: 32px;\n  margin-left: 8px;\n  user-select: none;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-end;\n  align-items: center;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget-900 div {\n  cursor: pointer;\n  margin-left: unset;\n  margin-right: unset;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget-900 div:first-child {\n  height: 24px;\n  width: 24px;\n  margin-left: unset;\n  margin-right: 8px;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget-900 div:last-child {\n  height: 24px;\n  width: 24px;\n  margin-left: 8px;\n  margin-right: unset;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget-900 div:nth-child(even) {\n  width: 0;\n  height: 0;\n  display: none;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget-900 input {\n  width: 0;\n  height: 0;\n  display: none;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget-900 svg {\n  display: block;\n}\n.igv-navbar .igv-navbar-right-container .igv-zoom-widget-hidden {\n  display: none;\n}\n\n.igv-navbar-button {\n  display: block;\n  box-sizing: unset;\n  padding-left: 6px;\n  padding-right: 6px;\n  height: 18px;\n  text-transform: capitalize;\n  user-select: none;\n  line-height: 18px;\n  text-align: center;\n  vertical-align: middle;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 11px;\n  font-weight: 200;\n  color: #737373;\n  background-color: #f3f3f3;\n  border-color: #737373;\n  border-style: solid;\n  border-width: thin;\n  border-radius: 6px;\n}\n\n.igv-navbar-button-clicked {\n  color: white;\n  background-color: #737373;\n}\n\n.igv-navbar-button:hover {\n  cursor: pointer;\n}\n\n.igv-zoom-in-notice-container {\n  z-index: 1024;\n  position: absolute;\n  top: 8px;\n  left: 50%;\n  transform: translate(-50%, 0%);\n  display: flex;\n  flex-direction: row;\n  flex-wrap: nowrap;\n  justify-content: center;\n  align-items: center;\n  background-color: white;\n}\n.igv-zoom-in-notice-container > div {\n  padding-left: 4px;\n  padding-right: 4px;\n  padding-top: 2px;\n  padding-bottom: 2px;\n  width: 100%;\n  height: 100%;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 14px;\n  font-weight: 400;\n  color: #3f3f3f;\n}\n\n.igv-zoom-in-notice {\n  position: absolute;\n  top: 10px;\n  left: 50%;\n}\n.igv-zoom-in-notice div {\n  position: relative;\n  left: -50%;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: medium;\n  font-weight: 400;\n  color: #3f3f3f;\n  background-color: rgba(255, 255, 255, 0.51);\n  z-index: 64;\n}\n\n.igv-container-spinner {\n  position: absolute;\n  top: 90%;\n  left: 50%;\n  transform: translate(-50%, -50%);\n  z-index: 1024;\n  width: 24px;\n  height: 24px;\n  pointer-events: none;\n  color: #737373;\n}\n\n.igv-multi-locus-close-button {\n  position: absolute;\n  top: 2px;\n  right: 0;\n  padding-left: 2px;\n  padding-right: 2px;\n  width: 12px;\n  height: 12px;\n  color: #666666;\n  background-color: white;\n  z-index: 1000;\n}\n.igv-multi-locus-close-button > svg {\n  vertical-align: top;\n}\n\n.igv-multi-locus-close-button:hover {\n  cursor: pointer;\n  color: #434343;\n}\n\n.igv-multi-locus-ruler-label {\n  z-index: 64;\n  position: absolute;\n  top: 2px;\n  left: 0;\n  width: 100%;\n  height: 12px;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: center;\n  align-items: center;\n}\n.igv-multi-locus-ruler-label > div {\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 12px;\n  color: rgb(16, 16, 16);\n  background-color: white;\n}\n.igv-multi-locus-ruler-label > div {\n  cursor: pointer;\n}\n\n.igv-multi-locus-ruler-label-square-dot {\n  z-index: 64;\n  position: absolute;\n  left: 50%;\n  top: 5%;\n  transform: translate(-50%, 0%);\n  background-color: white;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-multi-locus-ruler-label-square-dot > div:first-child {\n  width: 14px;\n  height: 14px;\n}\n.igv-multi-locus-ruler-label-square-dot > div:last-child {\n  margin-left: 16px;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 14px;\n  font-weight: 400;\n  color: rgb(16, 16, 16);\n}\n\n.igv-ruler-sweeper {\n  display: none;\n  pointer-events: none;\n  position: absolute;\n  top: 26px;\n  bottom: 0;\n  left: 0;\n  width: 0;\n  z-index: 99999;\n  background-color: rgba(68, 134, 247, 0.25);\n}\n\n.igv-ruler-tooltip {\n  pointer-events: none;\n  z-index: 128;\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 1px;\n  height: 32px;\n  background-color: transparent;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-ruler-tooltip > div {\n  pointer-events: none;\n  width: 128px;\n  height: auto;\n  padding: 1px;\n  color: #373737;\n  font-size: 10px;\n  font-family: \"Open Sans\", sans-serif;\n  font-weight: 400;\n  background-color: white;\n  border-style: solid;\n  border-width: thin;\n  border-color: #373737;\n}\n\n.igv-track-label {\n  position: absolute;\n  left: 8px;\n  top: 8px;\n  width: auto;\n  height: auto;\n  max-width: 50%;\n  padding-left: 4px;\n  padding-right: 4px;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: small;\n  font-weight: 400;\n  text-align: center;\n  user-select: none;\n  -moz-user-select: none;\n  -webkit-user-select: none;\n  border-color: #444;\n  border-radius: 2px;\n  border-style: solid;\n  border-width: thin;\n  background-color: white;\n  z-index: 128;\n  cursor: pointer;\n}\n\n.igv-track-label:hover,\n.igv-track-label:focus,\n.igv-track-label:active {\n  background-color: #e8e8e8;\n}\n\n.igv-track-label-popup-shim {\n  padding-left: 8px;\n  padding-right: 8px;\n  padding-top: 4px;\n}\n\n.igv-center-line {\n  display: none;\n  pointer-events: none;\n  position: absolute;\n  top: 0;\n  bottom: 0;\n  left: 50%;\n  transform: translateX(-50%);\n  z-index: 8;\n  user-select: none;\n  -moz-user-select: none;\n  -webkit-user-select: none;\n  border-left-style: dashed;\n  border-left-width: thin;\n  border-right-style: dashed;\n  border-right-width: thin;\n}\n\n.igv-center-line-wide {\n  background-color: rgba(0, 0, 0, 0);\n  border-left-color: rgba(127, 127, 127, 0.51);\n  border-right-color: rgba(127, 127, 127, 0.51);\n}\n\n.igv-center-line-thin {\n  background-color: rgba(0, 0, 0, 0);\n  border-left-color: rgba(127, 127, 127, 0.51);\n  border-right-color: rgba(0, 0, 0, 0);\n}\n\n.igv-cursor-guide-horizontal {\n  display: none;\n  pointer-events: none;\n  user-select: none;\n  -moz-user-select: none;\n  -webkit-user-select: none;\n  position: absolute;\n  left: 0;\n  right: 0;\n  top: 50%;\n  height: 1px;\n  z-index: 1;\n  margin-left: 50px;\n  margin-right: 54px;\n  border-top-style: dotted;\n  border-top-width: thin;\n  border-top-color: rgba(127, 127, 127, 0.76);\n}\n\n.igv-cursor-guide-vertical {\n  pointer-events: none;\n  user-select: none;\n  -moz-user-select: none;\n  -webkit-user-select: none;\n  position: absolute;\n  top: 0;\n  bottom: 0;\n  left: 50%;\n  width: 1px;\n  z-index: 1;\n  border-left-style: dotted;\n  border-left-width: thin;\n  border-left-color: rgba(127, 127, 127, 0.76);\n  display: none;\n}\n\n.igv-user-feedback {\n  position: fixed;\n  top: 50%;\n  left: 50%;\n  transform: translate(-50%, -50%);\n  width: 512px;\n  height: 360px;\n  z-index: 2048;\n  background-color: white;\n  border-color: #a2a2a2;\n  border-style: solid;\n  border-width: thin;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: medium;\n  font-weight: 400;\n  color: #444;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-user-feedback div:first-child {\n  position: relative;\n  height: 24px;\n  width: 100%;\n  background-color: white;\n  border-bottom-color: #a2a2a2;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n}\n.igv-user-feedback div:first-child div {\n  position: absolute;\n  top: 2px;\n  width: 16px;\n  height: 16px;\n  background-color: transparent;\n}\n.igv-user-feedback div:first-child div:first-child {\n  left: 8px;\n}\n.igv-user-feedback div:first-child div:last-child {\n  cursor: pointer;\n  right: 8px;\n}\n.igv-user-feedback div:last-child {\n  width: 100%;\n  height: calc(100% - 24px);\n  border-width: 0;\n}\n.igv-user-feedback div:last-child div {\n  width: auto;\n  height: auto;\n  margin: 8px;\n}\n\n.igv-generic-dialog-container {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 300px;\n  height: 200px;\n  border-color: #7F7F7F;\n  border-radius: 4px;\n  border-style: solid;\n  border-width: thin;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: medium;\n  font-weight: 400;\n  z-index: 2048;\n  background-color: white;\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-generic-dialog-container .igv-generic-dialog-header {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-end;\n  align-items: center;\n  width: 100%;\n  height: 24px;\n  cursor: move;\n  border-top-left-radius: 4px;\n  border-top-right-radius: 4px;\n  border-bottom-color: #7F7F7F;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n  background-color: #eee;\n}\n.igv-generic-dialog-container .igv-generic-dialog-header div {\n  margin-right: 4px;\n  margin-bottom: 2px;\n  height: 12px;\n  width: 12px;\n  color: #7F7F7F;\n}\n.igv-generic-dialog-container .igv-generic-dialog-header div:hover {\n  cursor: pointer;\n  color: #444;\n}\n.igv-generic-dialog-container .igv-generic-dialog-one-liner {\n  color: #373737;\n  width: 95%;\n  height: 24px;\n  line-height: 24px;\n  text-align: left;\n  margin-top: 8px;\n  padding-left: 8px;\n  overflow-wrap: break-word;\n  background-color: white;\n}\n.igv-generic-dialog-container .igv-generic-dialog-label-input {\n  margin-top: 8px;\n  width: 95%;\n  height: 24px;\n  color: #373737;\n  line-height: 24px;\n  padding-left: 8px;\n  background-color: white;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-generic-dialog-container .igv-generic-dialog-label-input div {\n  width: 30%;\n  height: 100%;\n  font-size: 16px;\n  text-align: right;\n  padding-right: 8px;\n  background-color: white;\n}\n.igv-generic-dialog-container .igv-generic-dialog-label-input input {\n  display: block;\n  height: 100%;\n  width: 100%;\n  padding-left: 4px;\n  font-family: \"Open Sans\", sans-serif;\n  font-weight: 400;\n  color: #373737;\n  text-align: left;\n  outline: none;\n  border-style: solid;\n  border-width: thin;\n  border-color: #7F7F7F;\n  background-color: white;\n}\n.igv-generic-dialog-container .igv-generic-dialog-label-input input {\n  width: 50%;\n  font-size: 16px;\n}\n.igv-generic-dialog-container .igv-generic-dialog-input {\n  margin-top: 8px;\n  width: calc(100% - 16px);\n  height: 24px;\n  color: #373737;\n  line-height: 24px;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-around;\n  align-items: center;\n}\n.igv-generic-dialog-container .igv-generic-dialog-input input {\n  display: block;\n  height: 100%;\n  width: 100%;\n  padding-left: 4px;\n  font-family: \"Open Sans\", sans-serif;\n  font-weight: 400;\n  color: #373737;\n  text-align: left;\n  outline: none;\n  border-style: solid;\n  border-width: thin;\n  border-color: #7F7F7F;\n  background-color: white;\n}\n.igv-generic-dialog-container .igv-generic-dialog-input input {\n  font-size: 16px;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok-cancel {\n  width: 100%;\n  height: 28px;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-around;\n  align-items: center;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok-cancel div {\n  margin-top: 32px;\n  color: white;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 14px;\n  font-weight: 400;\n  width: 75px;\n  height: 28px;\n  line-height: 28px;\n  text-align: center;\n  border-color: transparent;\n  border-style: solid;\n  border-width: thin;\n  border-radius: 2px;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok-cancel div:first-child {\n  margin-left: 32px;\n  margin-right: 0;\n  background-color: #5ea4e0;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok-cancel div:last-child {\n  margin-left: 0;\n  margin-right: 32px;\n  background-color: #c4c4c4;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok-cancel div:first-child:hover {\n  cursor: pointer;\n  background-color: #3b5c7f;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok-cancel div:last-child:hover {\n  cursor: pointer;\n  background-color: #7f7f7f;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok {\n  width: 100%;\n  height: 36px;\n  margin-top: 32px;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-around;\n  align-items: center;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok div {\n  width: 98px;\n  height: 36px;\n  line-height: 36px;\n  text-align: center;\n  color: white;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: medium;\n  font-weight: 400;\n  border-color: white;\n  border-style: solid;\n  border-width: thin;\n  border-radius: 4px;\n  background-color: #2B81AF;\n}\n.igv-generic-dialog-container .igv-generic-dialog-ok div:hover {\n  cursor: pointer;\n  background-color: #25597f;\n}\n\n.igv-generic-container {\n  position: absolute;\n  top: 0;\n  left: 0;\n  z-index: 2048;\n  background-color: white;\n  cursor: pointer;\n  display: flex;\n  flex-direction: row;\n  flex-wrap: wrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-generic-container div:first-child {\n  cursor: move;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-end;\n  align-items: center;\n  height: 24px;\n  width: 100%;\n  background-color: #dddddd;\n}\n.igv-generic-container div:first-child i {\n  display: block;\n  color: #5f5f5f;\n  cursor: pointer;\n  width: 14px;\n  height: 14px;\n  margin-right: 8px;\n  margin-bottom: 4px;\n}\n\n.igv-menu-popup {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: max-content;\n  z-index: 4096;\n  cursor: pointer;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: small;\n  font-weight: 400;\n  color: #4b4b4b;\n  background: white;\n  border-radius: 4px;\n  border-color: #7F7F7F;\n  border-style: solid;\n  border-width: thin;\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-end;\n  text-align: left;\n}\n.igv-menu-popup > div:not(:first-child) {\n  width: 100%;\n}\n.igv-menu-popup > div:not(:first-child) > div {\n  background: white;\n}\n.igv-menu-popup > div:not(:first-child) > div.context-menu {\n  padding-left: 4px;\n  padding-right: 4px;\n}\n.igv-menu-popup > div:not(:first-child) > div:last-child {\n  border-bottom-left-radius: 4px;\n  border-bottom-right-radius: 4px;\n  border-bottom-color: transparent;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n}\n.igv-menu-popup > div:not(:first-child) > div:hover {\n  background: #efefef;\n}\n\n.igv-menu-popup-shim {\n  padding-left: 8px;\n  padding-right: 8px;\n  padding-bottom: 1px;\n  padding-top: 1px;\n}\n\n.igv-menu-popup-header {\n  position: relative;\n  width: 100%;\n  height: 24px;\n  cursor: move;\n  border-top-color: transparent;\n  border-top-left-radius: 4px;\n  border-top-right-radius: 4px;\n  border-bottom-color: #7F7F7F;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n  background-color: #eee;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-end;\n  align-items: center;\n}\n.igv-menu-popup-header div {\n  margin-right: 4px;\n  height: 12px;\n  width: 12px;\n  color: #7F7F7F;\n}\n.igv-menu-popup-header div:hover {\n  cursor: pointer;\n  color: #444;\n}\n\n.igv-menu-popup-check-container {\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n  width: 100%;\n  height: 20px;\n  margin-right: 4px;\n  background-color: transparent;\n}\n.igv-menu-popup-check-container div {\n  padding-top: 2px;\n  padding-left: 8px;\n}\n.igv-menu-popup-check-container div:first-child {\n  position: relative;\n  width: 12px;\n  height: 12px;\n}\n.igv-menu-popup-check-container div:first-child svg {\n  position: absolute;\n  width: 12px;\n  height: 12px;\n}\n\n.igv-user-feedback {\n  position: fixed;\n  top: 50%;\n  left: 50%;\n  transform: translate(-50%, -50%);\n  width: 512px;\n  height: 360px;\n  z-index: 2048;\n  background-color: white;\n  border-color: #a2a2a2;\n  border-style: solid;\n  border-width: thin;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: medium;\n  font-weight: 400;\n  color: #444;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-user-feedback div:first-child {\n  position: relative;\n  height: 24px;\n  width: 100%;\n  background-color: white;\n  border-bottom-color: #a2a2a2;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n}\n.igv-user-feedback div:first-child div {\n  position: absolute;\n  top: 2px;\n  width: 16px;\n  height: 16px;\n  background-color: transparent;\n}\n.igv-user-feedback div:first-child div:first-child {\n  left: 8px;\n}\n.igv-user-feedback div:first-child div:last-child {\n  cursor: pointer;\n  right: 8px;\n}\n.igv-user-feedback div:last-child {\n  width: 100%;\n  height: calc(100% - 24px);\n  border-width: 0;\n}\n.igv-user-feedback div:last-child div {\n  width: auto;\n  height: auto;\n  margin: 8px;\n}\n\n.igv-loading-spinner-container {\n  z-index: 1024;\n  position: absolute;\n  top: 50%;\n  left: 50%;\n  transform: translate(-50%, -50%);\n  width: 32px;\n  height: 32px;\n  display: flex;\n  flex-direction: row;\n  flex-wrap: nowrap;\n  justify-content: center;\n  align-items: center;\n}\n.igv-loading-spinner-container > div {\n  box-sizing: border-box;\n  width: 100%;\n  height: 100%;\n  border-radius: 50%;\n  border: 4px solid rgba(128, 128, 128, 0.5);\n  border-top-color: rgb(255, 255, 255);\n  animation: spin 1s ease-in-out infinite;\n  -webkit-animation: spin 1s ease-in-out infinite;\n}\n\n@keyframes spin {\n  to {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n@-webkit-keyframes spin {\n  to {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n.igv-roi-menu-next-gen {\n  position: absolute;\n  z-index: 512;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: small;\n  font-weight: 400;\n  color: #4b4b4b;\n  background-color: white;\n  width: 192px;\n  border-radius: 4px;\n  border-color: #7F7F7F;\n  border-style: solid;\n  border-width: thin;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: stretch;\n}\n.igv-roi-menu-next-gen > div:first-child {\n  height: 24px;\n  border-top-color: transparent;\n  border-top-left-radius: 4px;\n  border-top-right-radius: 4px;\n  border-bottom-color: #7F7F7F;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n  background-color: #eee;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-end;\n  align-items: center;\n}\n.igv-roi-menu-next-gen > div:first-child > div {\n  margin-right: 4px;\n  height: 12px;\n  width: 12px;\n  color: #7F7F7F;\n}\n.igv-roi-menu-next-gen > div:first-child > div:hover {\n  cursor: pointer;\n  color: #444;\n}\n.igv-roi-menu-next-gen > div:last-child {\n  background-color: white;\n  border-bottom-left-radius: 4px;\n  border-bottom-right-radius: 4px;\n  border-bottom-color: transparent;\n  border-bottom-style: solid;\n  border-bottom-width: 0;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: stretch;\n  text-align: start;\n  vertical-align: middle;\n}\n.igv-roi-menu-next-gen > div:last-child > div {\n  height: 24px;\n  padding-left: 4px;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n  border-bottom-color: #7f7f7f;\n}\n.igv-roi-menu-next-gen > div:last-child > div:not(:first-child):hover {\n  background-color: rgba(127, 127, 127, 0.1);\n}\n.igv-roi-menu-next-gen > div:last-child div:first-child {\n  font-style: italic;\n  text-align: center;\n  padding-right: 4px;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n.igv-roi-menu-next-gen > div:last-child > div:last-child {\n  border-bottom-width: 0;\n  border-bottom-color: transparent;\n}\n\n.igv-roi-placeholder {\n  font-style: normal;\n  color: rgba(75, 75, 75, 0.6);\n}\n\n.igv-roi-table {\n  position: absolute;\n  z-index: 1024;\n  width: fit-content;\n  border-color: #7f7f7f;\n  border-radius: 4px;\n  border-style: solid;\n  border-width: thin;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 12px;\n  font-weight: 400;\n  background-color: white;\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: stretch;\n  cursor: default;\n}\n.igv-roi-table > div {\n  height: 24px;\n  font-size: 14px;\n  text-align: start;\n  vertical-align: middle;\n  line-height: 24px;\n}\n.igv-roi-table > div:first-child {\n  border-color: transparent;\n  border-top-left-radius: 4px;\n  border-top-right-radius: 4px;\n  border-top-width: 0;\n  border-bottom-color: #7f7f7f;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n  background-color: #eee;\n  cursor: move;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center;\n}\n.igv-roi-table > div:first-child > div:first-child {\n  text-align: center;\n  width: calc(100% - 4px - 12px);\n}\n.igv-roi-table > div:first-child > div:last-child {\n  margin-right: 4px;\n  margin-bottom: 2px;\n  height: 12px;\n  width: 12px;\n  color: #7f7f7f;\n}\n.igv-roi-table > div:first-child > div:last-child > svg {\n  display: block;\n}\n.igv-roi-table > div:first-child > div:last-child:hover {\n  cursor: pointer;\n  color: #444;\n}\n.igv-roi-table > .igv-roi-table-description {\n  height: fit-content;\n  padding: 4px;\n  margin-left: 4px;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n}\n.igv-roi-table > .igv-roi-table-goto-explainer {\n  margin-left: 4px;\n  color: #7F7F7F;\n  font-style: italic;\n}\n.igv-roi-table > .igv-roi-table-column-titles {\n  height: 24px;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: stretch;\n  align-items: stretch;\n  padding-right: 16px;\n  background-color: white;\n  border-top-color: #7f7f7f;\n  border-top-style: solid;\n  border-top-width: thin;\n  border-bottom-color: #7f7f7f;\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n}\n.igv-roi-table > .igv-roi-table-column-titles > div {\n  font-size: 14px;\n  vertical-align: middle;\n  line-height: 24px;\n  text-align: left;\n  margin-left: 4px;\n  height: 24px;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  border-right-color: #7f7f7f;\n  border-right-style: solid;\n  border-right-width: thin;\n}\n.igv-roi-table > .igv-roi-table-column-titles > div:last-child {\n  border-right: unset;\n}\n.igv-roi-table > .igv-roi-table-row-container {\n  resize: both;\n  overflow: scroll;\n  min-height: 72px;\n  height: 144px;\n  max-height: 480px;\n  background-color: white;\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: stretch;\n}\n.igv-roi-table > .igv-roi-table-row-container > .igv-roi-table-row {\n  height: 24px;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: stretch;\n  align-items: stretch;\n}\n.igv-roi-table > .igv-roi-table-row-container > .igv-roi-table-row > div {\n  font-size: 14px;\n  vertical-align: middle;\n  line-height: 24px;\n  text-align: left;\n  margin-left: 4px;\n  height: 24px;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  border-right-color: transparent;\n  border-right-style: solid;\n  border-right-width: thin;\n}\n.igv-roi-table > .igv-roi-table-row-container > .igv-roi-table-row > div:last-child {\n  border-right: unset;\n}\n.igv-roi-table > .igv-roi-table-row-container > .igv-roi-table-row-hover {\n  background-color: rgba(0, 0, 0, 0.04);\n}\n.igv-roi-table > div:last-child {\n  height: 32px;\n  line-height: 32px;\n  border-top-color: #7f7f7f;\n  border-top-style: solid;\n  border-top-width: thin;\n  border-bottom-color: transparent;\n  border-bottom-left-radius: 4px;\n  border-bottom-right-radius: 4px;\n  border-bottom-width: 0;\n  display: flex;\n  flex-flow: row;\n  flex-wrap: nowrap;\n  justify-content: space-around;\n  align-items: center;\n}\n\n.igv-roi-table-row-selected {\n  background-color: rgba(0, 0, 0, 0.125);\n}\n\n.igv-roi-table-button {\n  cursor: pointer;\n  height: 20px;\n  user-select: none;\n  line-height: 20px;\n  text-align: center;\n  vertical-align: middle;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 13px;\n  font-weight: 400;\n  color: black;\n  padding-left: 6px;\n  padding-right: 6px;\n  background-color: rgb(239, 239, 239);\n  border-color: black;\n  border-style: solid;\n  border-width: thin;\n  border-radius: 3px;\n}\n\n.igv-roi-table-button:hover {\n  font-weight: 400;\n  background-color: rgba(0, 0, 0, 0.13);\n}\n\n.igv-roi-region {\n  z-index: 64;\n  position: absolute;\n  top: 0;\n  bottom: 0;\n  pointer-events: none;\n  overflow: visible;\n  margin-top: 44px;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: stretch;\n}\n.igv-roi-region > div {\n  position: relative;\n  width: 100%;\n  height: 8px;\n  pointer-events: auto;\n}\n\n.igv-roi-menu {\n  position: absolute;\n  z-index: 1024;\n  width: 144px;\n  border-color: #7f7f7f;\n  border-radius: 4px;\n  border-style: solid;\n  border-width: thin;\n  font-family: \"Open Sans\", sans-serif;\n  background-color: white;\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: stretch;\n}\n.igv-roi-menu > div:not(:last-child) {\n  border-bottom-color: rgba(128, 128, 128, 0.5);\n  border-bottom-style: solid;\n  border-bottom-width: thin;\n}\n.igv-roi-menu > div:first-child {\n  border-top-left-radius: 4px;\n  border-top-right-radius: 4px;\n  border-top-color: transparent;\n  border-top-style: solid;\n  border-top-width: 0;\n}\n.igv-roi-menu > div:last-child {\n  border-bottom-left-radius: 4px;\n  border-bottom-right-radius: 4px;\n  border-bottom-color: transparent;\n  border-bottom-style: solid;\n  border-bottom-width: 0;\n}\n\n.igv-roi-menu-row {\n  height: 24px;\n  padding-left: 8px;\n  font-size: small;\n  text-align: start;\n  vertical-align: middle;\n  line-height: 24px;\n  background-color: white;\n}\n\n.igv-roi-menu-row-edit-description {\n  width: -webkit-fill-available;\n  font-size: small;\n  text-align: start;\n  vertical-align: middle;\n  background-color: white;\n  padding-left: 4px;\n  padding-right: 4px;\n  padding-bottom: 4px;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: stretch;\n  align-items: stretch;\n}\n.igv-roi-menu-row-edit-description > label {\n  margin-left: 2px;\n  margin-bottom: 0;\n  display: block;\n  width: -webkit-fill-available;\n}\n.igv-roi-menu-row-edit-description > input {\n  display: block;\n  margin-left: 2px;\n  margin-right: 2px;\n  margin-bottom: 1px;\n  width: -webkit-fill-available;\n}\n\n.igv-container {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n  padding-top: 4px;\n  user-select: none;\n  -webkit-user-select: none;\n  -ms-user-select: none;\n}\n\n.igv-viewport {\n  position: relative;\n  margin-top: 5px;\n  line-height: 1;\n  overflow-x: hidden;\n  overflow-y: hidden;\n}\n\n.igv-viewport-content {\n  position: relative;\n  width: 100%;\n}\n.igv-viewport-content > canvas {\n  position: relative;\n  display: block;\n}\n\n.igv-column-container {\n  position: relative;\n  display: flex;\n  flex-direction: row;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: stretch;\n  width: 100%;\n}\n\n.igv-column-shim {\n  width: 1px;\n  margin-left: 2px;\n  margin-right: 2px;\n  background-color: #545453;\n}\n\n.igv-column {\n  position: relative;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n  box-sizing: border-box;\n  height: 100%;\n}\n\n.igv-axis-column {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n  box-sizing: border-box;\n  height: 100%;\n  width: 50px;\n}\n.igv-axis-column > div {\n  margin-top: 5px;\n  width: 100%;\n}\n\n.igv-sample-name-column {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n  box-sizing: border-box;\n  height: 100%;\n}\n\n.igv-scrollbar-column {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n  box-sizing: border-box;\n  height: 100%;\n  width: 14px;\n}\n.igv-scrollbar-column > div {\n  position: relative;\n  margin-top: 5px;\n  width: 14px;\n}\n.igv-scrollbar-column > div > div {\n  cursor: pointer;\n  position: absolute;\n  top: 0;\n  left: 2px;\n  width: 8px;\n  border-width: 1px;\n  border-style: solid;\n  border-color: #c4c4c4;\n  border-top-left-radius: 4px;\n  border-top-right-radius: 4px;\n  border-bottom-left-radius: 4px;\n  border-bottom-right-radius: 4px;\n}\n.igv-scrollbar-column > div > div:hover {\n  background-color: #c4c4c4;\n}\n\n.igv-track-drag-column {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n  box-sizing: border-box;\n  height: 100%;\n  width: 12px;\n  background-color: white;\n}\n.igv-track-drag-column > .igv-track-drag-handle {\n  z-index: 512;\n  position: relative;\n  cursor: pointer;\n  margin-top: 5px;\n  width: 100%;\n  border-style: solid;\n  border-width: 0;\n  border-top-right-radius: 6px;\n  border-bottom-right-radius: 6px;\n  background-color: #c4c4c4;\n}\n.igv-track-drag-column .igv-track-drag-handle-hover {\n  background-color: #787878;\n}\n.igv-track-drag-column > .igv-track-drag-shim {\n  position: relative;\n  margin-top: 5px;\n  width: 100%;\n  border-style: solid;\n  border-width: 0;\n}\n\n.igv-gear-menu-column {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: flex-start;\n  box-sizing: border-box;\n  height: 100%;\n  width: 28px;\n}\n.igv-gear-menu-column > div {\n  display: flex;\n  flex-direction: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center;\n  margin-top: 5px;\n  width: 100%;\n  background: white;\n}\n.igv-gear-menu-column > div > div {\n  position: relative;\n  margin-top: 4px;\n  width: 16px;\n  height: 16px;\n  color: #7F7F7F;\n}\n.igv-gear-menu-column > div > div:hover {\n  cursor: pointer;\n  color: #444;\n}\n\n/*# sourceMappingURL=dom.css.map */\n';

      var style = document.createElement('style');
      style.setAttribute('type', 'text/css');
      style.innerHTML = css;

      document.head.append(style);

  }

  // Defines the top-level API for the igv module

  const setApiKey = igvxhr$1.setApiKey;

  embedCSS$3();

  function setGoogleOauthToken(accessToken) {
      return igvxhr$1.setOauthToken(accessToken)
  }

  function setOauthToken(accessToken, host) {
      return igvxhr$1.setOauthToken(accessToken, host)
  }

  // Backward compatibility
  const oauth = igvxhr$1.oauth;

  var index = {
      TrackUtils,
      IGVGraphics,
      MenuUtils,
      DataRangeDialog,
      createTrack,
      createBrowser,
      removeBrowser,
      removeAllBrowsers,
      visibilityChange,
      setGoogleOauthToken,
      setOauthToken,
      oauth,
      version: version$2,
      setApiKey
  };

  //	%23	%24	%25	%26	%27	%28	%29	%2A	%2B	%2C	%2F	%3A	%3B	%3D	%3F	%40	%5B	%5D
  const encodings$1 = new Map();
  encodings$1.set("!", "%21");
  encodings$1.set("#", "%23");
  encodings$1.set("$", "%24");
  encodings$1.set("%", "%25");
  encodings$1.set("&", "%26");
  encodings$1.set("'", "%27");
  encodings$1.set("(", "%28");
  encodings$1.set(")", "%29");
  encodings$1.set("*", "%2A");
  encodings$1.set("+", "%2B");
  encodings$1.set(",", "%2C");
  encodings$1.set("/", "%2F");
  encodings$1.set(":", "%3A");
  encodings$1.set(";", "%3B");
  encodings$1.set("=", "%3D");
  encodings$1.set("?", "%3F");
  encodings$1.set("@", "%40");
  encodings$1.set("[", "%5B");
  encodings$1.set("]", "%5D");
  encodings$1.set(" ", "%20");

  // Convenience functions for the gapi oAuth library.

  async function init$2(config) {

      if (!(google.accounts.oauth2.initTokenClient)) {
          throw new Error("Google accounts token client not loaded (https://accounts.google.com/gsi/client)")
      }

      if (isInitialized$1()) {
          throw new Error("Google client is already initialized")
      }

      // Note: callback is added when accessToken is requested
      const codeClientConfig = {
          client_id: config.client_id,
          scope: config.scope || 'https://www.googleapis.com/auth/userinfo.profile',
          state: config.state || 'igv',
          error: (err) => {
              throw new Error(err.type)
          },
          hint: config.hint,     // Optional
          hosted_domain: config.hosted_domain  // Optional
      };

      const tokenClient = google.accounts.oauth2.initTokenClient(codeClientConfig);

      // Attach an object to keep igv state
      google.igv = {
          tokenClient: tokenClient,
          apiKey: config.apiKey
      };
  }

  function isInitialized$1() {
      return window.google && window.google.igv
  }

  /**
   * Return the current access token if the user is signed in, or undefined otherwise.  This function does not
   * attempt a signIn or request any specfic scopes.
   *
   * @returns access_token || undefined
   */
  function getCurrentAccessToken$1() {
      return (isInitialized$1() && google.igv.tokenResponse && Date.now() < google.igv.tokenExpiresAt) ?
          google.igv.tokenResponse.access_token :
          undefined
  }

  /**
   * Return the of the currently logged in user, if any, as represented by the current access token.  This does not force a login.*
   * @returns {Promise<any>}
   */
  async function getCurrentUserProfile() {
      const access_token = getCurrentAccessToken$1();
      if (access_token) {
          const endPoint = "https://www.googleapis.com/oauth2/v1/userinfo?alt=json";
          const response = await fetch(endPoint, {
              headers: {
                  'Authorization': `Bearer ${access_token}`
              }
          });
          return response.json()
      } else {
          return undefined
      }
  }


  /**
   * Return a promise for an access token for the given scope.  If the user hasn't authorized the scope request it
   *
   * @param scope
   * @returns {Promise<unknown>}
   */
  async function getAccessToken$1(scope) {

      if (!isInitialized$1()) {
          throw Error("Google oAuth has not been initialized")
      }

      if (google.igv.tokenResponse &&
          Date.now() < google.igv.tokenExpiresAt &&
          google.accounts.oauth2.hasGrantedAllScopes(google.igv.tokenResponse, scope)) {
          return google.igv.tokenResponse.access_token
      } else {
          const tokenClient = google.igv.tokenClient;
          return new Promise((resolve, reject) => {
              try {
                  // Settle this promise in the response callback for requestAccessToken()
                  tokenClient.callback = (tokenResponse) => {
                      if (tokenResponse.error !== undefined) {
                          reject(tokenResponse);
                      }
                      google.igv.tokenResponse = tokenResponse;
                      google.igv.tokenExpiresAt = Date.now() + tokenResponse.expires_in * 1000;
                      resolve(tokenResponse.access_token);
                  };
                  tokenClient.requestAccessToken({scope});
              } catch (err) {
              }
          })
      }
  }

  async function signIn(scope) {

      if (!isInitialized$1()) {
          throw Error("Google oAuth has not been initialized")
      }

      scope = scope || 'https://www.googleapis.com/auth/userinfo.profile';
      await getAccessToken$1(scope);

      if (typeof google.igv.signInListener === 'function') {
          google.igv.signInListener(undefined !== google.igv.tokenResponse);

      }

      return google.igv.tokenResponse

  }

  async function signOut() {

      if (!isInitialized$1()) {
          throw Error("Google oAuth has not been initialized")
      }

      if (google.igv && google.igv.tokenResponse) {
          google.igv.tokenResponse = undefined;
      }

      if (typeof google.igv.signInListener === 'function') {
          google.igv.signInListener(false);
      }
  }

  /**
   * Make the target element movable by clicking and dragging on the handle.  This is not a general purprose function,
   * it makes several options specific to igv dialogs, the primary one being that the
   * target is absolutely positioned in pixel coordinates

   */

  let _dragData;  // Its assumed we are only dragging one element at a time.

  function makeDraggable$1(target, handle, constraint) {

      handle.addEventListener('mousedown', dragStart.bind(target));

      function dragStart(event) {

          event.stopPropagation();
          event.preventDefault();

          const dragFunction = drag$1.bind(this);
          const dragEndFunction = dragEnd$1.bind(this);
          const computedStyle = getComputedStyle(this);

          _dragData =
              {
                  constraint,
                  dragFunction,
                  dragEndFunction,
                  screenX: event.screenX,
                  screenY: event.screenY,
                  top: parseInt(computedStyle.top.replace("px", "")),
                  left: parseInt(computedStyle.left.replace("px", ""))
              };

          document.addEventListener('mousemove', dragFunction);
          document.addEventListener('mouseup', dragEndFunction);
          document.addEventListener('mouseleave', dragEndFunction);
          document.addEventListener('mouseexit', dragEndFunction);
      }
  }

  function drag$1(event) {

      if (!_dragData) {
          console.error("No drag data!");
          return
      }
      event.stopPropagation();
      event.preventDefault();
      const dx = event.screenX - _dragData.screenX;
      const dy = event.screenY - _dragData.screenY;

      const left = _dragData.left + dx;
      const top = _dragData.constraint ? Math.max(_dragData.constraint.minY, _dragData.top + dy) : _dragData.top + dy;

      this.style.left = `${left}px`;
      this.style.top = `${top}px`;
  }

  function dragEnd$1(event) {

      if (!_dragData) {
          console.error("No drag data!");
          return
      }
      event.stopPropagation();
      event.preventDefault();

      const dragFunction = _dragData.dragFunction;
      const dragEndFunction = _dragData.dragEndFunction;
      document.removeEventListener('mousemove', dragFunction);
      document.removeEventListener('mouseup', dragEndFunction);
      document.removeEventListener('mouseleave', dragEndFunction);
      document.removeEventListener('mouseexit', dragEndFunction);
      _dragData = undefined;
  }

  let subscribers = {};

  class EventBus {
      constructor() {

      }

      subscribe (eventType, object) {

          let subscriberList = subscribers[ eventType ];
          if (undefined === subscriberList) {
              subscriberList = [];
              subscribers[ eventType ] = subscriberList;
          }
          subscriberList.push(object);
      }

      post (event) {

          const subscriberList = subscribers[ event.type ];
          if (subscriberList) {

              for (let subscriber of subscriberList) {

                  if ("function" === typeof subscriber.receiveEvent) {
                      subscriber.receiveEvent(event);
                  } else if ("function" === typeof subscriber) {
                      subscriber(event);
                  }
              }
          }
      }

      static createEvent (type, data, propogate) {
          return { type: type, data: data || {}, propogate: propogate !== undefined ? propogate : true }
      }

  }

  // Global event bus
  EventBus.globalBus = new EventBus();

  /**
   * @fileoverview
   * - Using the 'QRCode for Javascript library'
   * - Fixed dataset of 'QRCode for Javascript library' for support full-spec.
   * - this library has no dependencies.
   *
   * @author davidshimjs
   * @see <a href="http://www.d-project.com/" target="_blank">http://www.d-project.com/</a>
   * @see <a href="http://jeromeetienne.github.com/jquery-qrcode/" target="_blank">http://jeromeetienne.github.com/jquery-qrcode/</a>
   */


  //---------------------------------------------------------------------
  // QRCode for JavaScript
  //
  // Copyright (c) 2009 Kazuhiko Arase
  //
  // URL: http://www.d-project.com/
  //
  // Licensed under the MIT license:
  //   http://www.opensource.org/licenses/mit-license.php
  //
  // The word "QR Code" is registered trademark of
  // DENSO WAVE INCORPORATED
  //   http://www.denso-wave.com/qrcode/faqpatent-e.html
  //
  //---------------------------------------------------------------------
  function QR8bitByte(data) {
      this.mode = QRMode.MODE_8BIT_BYTE;
      this.data = data;
      this.parsedData = [];

      // Added to support UTF-8 Characters
      for (var i = 0, l = this.data.length; i < l; i++) {
          var byteArray = [];
          var code = this.data.charCodeAt(i);

          if (code > 0x10000) {
              byteArray[0] = 0xF0 | ((code & 0x1C0000) >>> 18);
              byteArray[1] = 0x80 | ((code & 0x3F000) >>> 12);
              byteArray[2] = 0x80 | ((code & 0xFC0) >>> 6);
              byteArray[3] = 0x80 | (code & 0x3F);
          } else if (code > 0x800) {
              byteArray[0] = 0xE0 | ((code & 0xF000) >>> 12);
              byteArray[1] = 0x80 | ((code & 0xFC0) >>> 6);
              byteArray[2] = 0x80 | (code & 0x3F);
          } else if (code > 0x80) {
              byteArray[0] = 0xC0 | ((code & 0x7C0) >>> 6);
              byteArray[1] = 0x80 | (code & 0x3F);
          } else {
              byteArray[0] = code;
          }

          this.parsedData.push(byteArray);
      }

      this.parsedData = Array.prototype.concat.apply([], this.parsedData);

      if (this.parsedData.length != this.data.length) {
          this.parsedData.unshift(191);
          this.parsedData.unshift(187);
          this.parsedData.unshift(239);
      }
  }

  QR8bitByte.prototype = {
      getLength: function (buffer) {
          return this.parsedData.length;
      },
      write: function (buffer) {
          for (var i = 0, l = this.parsedData.length; i < l; i++) {
              buffer.put(this.parsedData[i], 8);
          }
      }
  };

  function QRCodeModel(typeNumber, errorCorrectLevel) {
      this.typeNumber = typeNumber;
      this.errorCorrectLevel = errorCorrectLevel;
      this.modules = null;
      this.moduleCount = 0;
      this.dataCache = null;
      this.dataList = [];
  }

  QRCodeModel.prototype = {
      addData: function (data) {
          var newData = new QR8bitByte(data);
          this.dataList.push(newData);
          this.dataCache = null;
      }, isDark: function (row, col) {
          if (row < 0 || this.moduleCount <= row || col < 0 || this.moduleCount <= col) {
              throw new Error(row + "," + col);
          }
          return this.modules[row][col];
      }, getModuleCount: function () {
          return this.moduleCount;
      }, make: function () {
          this.makeImpl(false, this.getBestMaskPattern());
      }, makeImpl: function (test, maskPattern) {
          this.moduleCount = this.typeNumber * 4 + 17;
          this.modules = new Array(this.moduleCount);
          for (var row = 0; row < this.moduleCount; row++) {
              this.modules[row] = new Array(this.moduleCount);
              for (var col = 0; col < this.moduleCount; col++) {
                  this.modules[row][col] = null;
              }
          }
          this.setupPositionProbePattern(0, 0);
          this.setupPositionProbePattern(this.moduleCount - 7, 0);
          this.setupPositionProbePattern(0, this.moduleCount - 7);
          this.setupPositionAdjustPattern();
          this.setupTimingPattern();
          this.setupTypeInfo(test, maskPattern);
          if (this.typeNumber >= 7) {
              this.setupTypeNumber(test);
          }
          if (this.dataCache == null) {
              this.dataCache = QRCodeModel.createData(this.typeNumber, this.errorCorrectLevel, this.dataList);
          }
          this.mapData(this.dataCache, maskPattern);
      }, setupPositionProbePattern: function (row, col) {
          for (var r = -1; r <= 7; r++) {
              if (row + r <= -1 || this.moduleCount <= row + r) continue;
              for (var c = -1; c <= 7; c++) {
                  if (col + c <= -1 || this.moduleCount <= col + c) continue;
                  if ((0 <= r && r <= 6 && (c == 0 || c == 6)) || (0 <= c && c <= 6 && (r == 0 || r == 6)) || (2 <= r && r <= 4 && 2 <= c && c <= 4)) {
                      this.modules[row + r][col + c] = true;
                  } else {
                      this.modules[row + r][col + c] = false;
                  }
              }
          }
      }, getBestMaskPattern: function () {
          var minLostPoint = 0;
          var pattern = 0;
          for (var i = 0; i < 8; i++) {
              this.makeImpl(true, i);
              var lostPoint = QRUtil.getLostPoint(this);
              if (i == 0 || minLostPoint > lostPoint) {
                  minLostPoint = lostPoint;
                  pattern = i;
              }
          }
          return pattern;
      }, createMovieClip: function (target_mc, instance_name, depth) {
          var qr_mc = target_mc.createEmptyMovieClip(instance_name, depth);
          var cs = 1;
          this.make();
          for (var row = 0; row < this.modules.length; row++) {
              var y = row * cs;
              for (var col = 0; col < this.modules[row].length; col++) {
                  var x = col * cs;
                  var dark = this.modules[row][col];
                  if (dark) {
                      qr_mc.beginFill(0, 100);
                      qr_mc.moveTo(x, y);
                      qr_mc.lineTo(x + cs, y);
                      qr_mc.lineTo(x + cs, y + cs);
                      qr_mc.lineTo(x, y + cs);
                      qr_mc.endFill();
                  }
              }
          }
          return qr_mc;
      }, setupTimingPattern: function () {
          for (var r = 8; r < this.moduleCount - 8; r++) {
              if (this.modules[r][6] != null) {
                  continue;
              }
              this.modules[r][6] = (r % 2 == 0);
          }
          for (var c = 8; c < this.moduleCount - 8; c++) {
              if (this.modules[6][c] != null) {
                  continue;
              }
              this.modules[6][c] = (c % 2 == 0);
          }
      }, setupPositionAdjustPattern: function () {
          var pos = QRUtil.getPatternPosition(this.typeNumber);
          for (var i = 0; i < pos.length; i++) {
              for (var j = 0; j < pos.length; j++) {
                  var row = pos[i];
                  var col = pos[j];
                  if (this.modules[row][col] != null) {
                      continue;
                  }
                  for (var r = -2; r <= 2; r++) {
                      for (var c = -2; c <= 2; c++) {
                          if (r == -2 || r == 2 || c == -2 || c == 2 || (r == 0 && c == 0)) {
                              this.modules[row + r][col + c] = true;
                          } else {
                              this.modules[row + r][col + c] = false;
                          }
                      }
                  }
              }
          }
      }, setupTypeNumber: function (test) {
          var bits = QRUtil.getBCHTypeNumber(this.typeNumber);
          for (var i = 0; i < 18; i++) {
              var mod = (!test && ((bits >> i) & 1) == 1);
              this.modules[Math.floor(i / 3)][i % 3 + this.moduleCount - 8 - 3] = mod;
          }
          for (var i = 0; i < 18; i++) {
              var mod = (!test && ((bits >> i) & 1) == 1);
              this.modules[i % 3 + this.moduleCount - 8 - 3][Math.floor(i / 3)] = mod;
          }
      }, setupTypeInfo: function (test, maskPattern) {
          var data = (this.errorCorrectLevel << 3) | maskPattern;
          var bits = QRUtil.getBCHTypeInfo(data);
          for (var i = 0; i < 15; i++) {
              var mod = (!test && ((bits >> i) & 1) == 1);
              if (i < 6) {
                  this.modules[i][8] = mod;
              } else if (i < 8) {
                  this.modules[i + 1][8] = mod;
              } else {
                  this.modules[this.moduleCount - 15 + i][8] = mod;
              }
          }
          for (var i = 0; i < 15; i++) {
              var mod = (!test && ((bits >> i) & 1) == 1);
              if (i < 8) {
                  this.modules[8][this.moduleCount - i - 1] = mod;
              } else if (i < 9) {
                  this.modules[8][15 - i - 1 + 1] = mod;
              } else {
                  this.modules[8][15 - i - 1] = mod;
              }
          }
          this.modules[this.moduleCount - 8][8] = (!test);
      }, mapData: function (data, maskPattern) {
          var inc = -1;
          var row = this.moduleCount - 1;
          var bitIndex = 7;
          var byteIndex = 0;
          for (var col = this.moduleCount - 1; col > 0; col -= 2) {
              if (col == 6) col--;
              while (true) {
                  for (var c = 0; c < 2; c++) {
                      if (this.modules[row][col - c] == null) {
                          var dark = false;
                          if (byteIndex < data.length) {
                              dark = (((data[byteIndex] >>> bitIndex) & 1) == 1);
                          }
                          var mask = QRUtil.getMask(maskPattern, row, col - c);
                          if (mask) {
                              dark = !dark;
                          }
                          this.modules[row][col - c] = dark;
                          bitIndex--;
                          if (bitIndex == -1) {
                              byteIndex++;
                              bitIndex = 7;
                          }
                      }
                  }
                  row += inc;
                  if (row < 0 || this.moduleCount <= row) {
                      row -= inc;
                      inc = -inc;
                      break;
                  }
              }
          }
      }
  };
  QRCodeModel.PAD0 = 0xEC;
  QRCodeModel.PAD1 = 0x11;
  QRCodeModel.createData = function (typeNumber, errorCorrectLevel, dataList) {
      var rsBlocks = QRRSBlock.getRSBlocks(typeNumber, errorCorrectLevel);
      var buffer = new QRBitBuffer();
      for (var i = 0; i < dataList.length; i++) {
          var data = dataList[i];
          buffer.put(data.mode, 4);
          buffer.put(data.getLength(), QRUtil.getLengthInBits(data.mode, typeNumber));
          data.write(buffer);
      }
      var totalDataCount = 0;
      for (var i = 0; i < rsBlocks.length; i++) {
          totalDataCount += rsBlocks[i].dataCount;
      }
      if (buffer.getLengthInBits() > totalDataCount * 8) {
          throw new Error("code length overflow. ("
              + buffer.getLengthInBits()
              + ">"
              + totalDataCount * 8
              + ")");
      }
      if (buffer.getLengthInBits() + 4 <= totalDataCount * 8) {
          buffer.put(0, 4);
      }
      while (buffer.getLengthInBits() % 8 != 0) {
          buffer.putBit(false);
      }
      while (true) {
          if (buffer.getLengthInBits() >= totalDataCount * 8) {
              break;
          }
          buffer.put(QRCodeModel.PAD0, 8);
          if (buffer.getLengthInBits() >= totalDataCount * 8) {
              break;
          }
          buffer.put(QRCodeModel.PAD1, 8);
      }
      return QRCodeModel.createBytes(buffer, rsBlocks);
  };
  QRCodeModel.createBytes = function (buffer, rsBlocks) {
      var offset = 0;
      var maxDcCount = 0;
      var maxEcCount = 0;
      var dcdata = new Array(rsBlocks.length);
      var ecdata = new Array(rsBlocks.length);
      for (var r = 0; r < rsBlocks.length; r++) {
          var dcCount = rsBlocks[r].dataCount;
          var ecCount = rsBlocks[r].totalCount - dcCount;
          maxDcCount = Math.max(maxDcCount, dcCount);
          maxEcCount = Math.max(maxEcCount, ecCount);
          dcdata[r] = new Array(dcCount);
          for (var i = 0; i < dcdata[r].length; i++) {
              dcdata[r][i] = 0xff & buffer.buffer[i + offset];
          }
          offset += dcCount;
          var rsPoly = QRUtil.getErrorCorrectPolynomial(ecCount);
          var rawPoly = new QRPolynomial(dcdata[r], rsPoly.getLength() - 1);
          var modPoly = rawPoly.mod(rsPoly);
          ecdata[r] = new Array(rsPoly.getLength() - 1);
          for (var i = 0; i < ecdata[r].length; i++) {
              var modIndex = i + modPoly.getLength() - ecdata[r].length;
              ecdata[r][i] = (modIndex >= 0) ? modPoly.get(modIndex) : 0;
          }
      }
      var totalCodeCount = 0;
      for (var i = 0; i < rsBlocks.length; i++) {
          totalCodeCount += rsBlocks[i].totalCount;
      }
      var data = new Array(totalCodeCount);
      var index = 0;
      for (var i = 0; i < maxDcCount; i++) {
          for (var r = 0; r < rsBlocks.length; r++) {
              if (i < dcdata[r].length) {
                  data[index++] = dcdata[r][i];
              }
          }
      }
      for (var i = 0; i < maxEcCount; i++) {
          for (var r = 0; r < rsBlocks.length; r++) {
              if (i < ecdata[r].length) {
                  data[index++] = ecdata[r][i];
              }
          }
      }
      return data;
  };
  var QRMode = {MODE_NUMBER: 1 << 0, MODE_ALPHA_NUM: 1 << 1, MODE_8BIT_BYTE: 1 << 2, MODE_KANJI: 1 << 3};
  var QRErrorCorrectLevel = {L: 1, M: 0, Q: 3, H: 2};
  var QRMaskPattern = {
      PATTERN000: 0,
      PATTERN001: 1,
      PATTERN010: 2,
      PATTERN011: 3,
      PATTERN100: 4,
      PATTERN101: 5,
      PATTERN110: 6,
      PATTERN111: 7
  };
  var QRUtil = {
      PATTERN_POSITION_TABLE: [[], [6, 18], [6, 22], [6, 26], [6, 30], [6, 34], [6, 22, 38], [6, 24, 42], [6, 26, 46], [6, 28, 50], [6, 30, 54], [6, 32, 58], [6, 34, 62], [6, 26, 46, 66], [6, 26, 48, 70], [6, 26, 50, 74], [6, 30, 54, 78], [6, 30, 56, 82], [6, 30, 58, 86], [6, 34, 62, 90], [6, 28, 50, 72, 94], [6, 26, 50, 74, 98], [6, 30, 54, 78, 102], [6, 28, 54, 80, 106], [6, 32, 58, 84, 110], [6, 30, 58, 86, 114], [6, 34, 62, 90, 118], [6, 26, 50, 74, 98, 122], [6, 30, 54, 78, 102, 126], [6, 26, 52, 78, 104, 130], [6, 30, 56, 82, 108, 134], [6, 34, 60, 86, 112, 138], [6, 30, 58, 86, 114, 142], [6, 34, 62, 90, 118, 146], [6, 30, 54, 78, 102, 126, 150], [6, 24, 50, 76, 102, 128, 154], [6, 28, 54, 80, 106, 132, 158], [6, 32, 58, 84, 110, 136, 162], [6, 26, 54, 82, 110, 138, 166], [6, 30, 58, 86, 114, 142, 170]],
      G15: (1 << 10) | (1 << 8) | (1 << 5) | (1 << 4) | (1 << 2) | (1 << 1) | (1 << 0),
      G18: (1 << 12) | (1 << 11) | (1 << 10) | (1 << 9) | (1 << 8) | (1 << 5) | (1 << 2) | (1 << 0),
      G15_MASK: (1 << 14) | (1 << 12) | (1 << 10) | (1 << 4) | (1 << 1),
      getBCHTypeInfo: function (data) {
          var d = data << 10;
          while (QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G15) >= 0) {
              d ^= (QRUtil.G15 << (QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G15)));
          }
          return ((data << 10) | d) ^ QRUtil.G15_MASK;
      },
      getBCHTypeNumber: function (data) {
          var d = data << 12;
          while (QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G18) >= 0) {
              d ^= (QRUtil.G18 << (QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G18)));
          }
          return (data << 12) | d;
      },
      getBCHDigit: function (data) {
          var digit = 0;
          while (data != 0) {
              digit++;
              data >>>= 1;
          }
          return digit;
      },
      getPatternPosition: function (typeNumber) {
          return QRUtil.PATTERN_POSITION_TABLE[typeNumber - 1];
      },
      getMask: function (maskPattern, i, j) {
          switch (maskPattern) {
              case QRMaskPattern.PATTERN000:
                  return (i + j) % 2 == 0;
              case QRMaskPattern.PATTERN001:
                  return i % 2 == 0;
              case QRMaskPattern.PATTERN010:
                  return j % 3 == 0;
              case QRMaskPattern.PATTERN011:
                  return (i + j) % 3 == 0;
              case QRMaskPattern.PATTERN100:
                  return (Math.floor(i / 2) + Math.floor(j / 3)) % 2 == 0;
              case QRMaskPattern.PATTERN101:
                  return (i * j) % 2 + (i * j) % 3 == 0;
              case QRMaskPattern.PATTERN110:
                  return ((i * j) % 2 + (i * j) % 3) % 2 == 0;
              case QRMaskPattern.PATTERN111:
                  return ((i * j) % 3 + (i + j) % 2) % 2 == 0;
              default:
                  throw new Error("bad maskPattern:" + maskPattern);
          }
      },
      getErrorCorrectPolynomial: function (errorCorrectLength) {
          var a = new QRPolynomial([1], 0);
          for (var i = 0; i < errorCorrectLength; i++) {
              a = a.multiply(new QRPolynomial([1, QRMath.gexp(i)], 0));
          }
          return a;
      },
      getLengthInBits: function (mode, type) {
          if (1 <= type && type < 10) {
              switch (mode) {
                  case QRMode.MODE_NUMBER:
                      return 10;
                  case QRMode.MODE_ALPHA_NUM:
                      return 9;
                  case QRMode.MODE_8BIT_BYTE:
                      return 8;
                  case QRMode.MODE_KANJI:
                      return 8;
                  default:
                      throw new Error("mode:" + mode);
              }
          } else if (type < 27) {
              switch (mode) {
                  case QRMode.MODE_NUMBER:
                      return 12;
                  case QRMode.MODE_ALPHA_NUM:
                      return 11;
                  case QRMode.MODE_8BIT_BYTE:
                      return 16;
                  case QRMode.MODE_KANJI:
                      return 10;
                  default:
                      throw new Error("mode:" + mode);
              }
          } else if (type < 41) {
              switch (mode) {
                  case QRMode.MODE_NUMBER:
                      return 14;
                  case QRMode.MODE_ALPHA_NUM:
                      return 13;
                  case QRMode.MODE_8BIT_BYTE:
                      return 16;
                  case QRMode.MODE_KANJI:
                      return 12;
                  default:
                      throw new Error("mode:" + mode);
              }
          } else {
              throw new Error("type:" + type);
          }
      },
      getLostPoint: function (qrCode) {
          var moduleCount = qrCode.getModuleCount();
          var lostPoint = 0;
          for (var row = 0; row < moduleCount; row++) {
              for (var col = 0; col < moduleCount; col++) {
                  var sameCount = 0;
                  var dark = qrCode.isDark(row, col);
                  for (var r = -1; r <= 1; r++) {
                      if (row + r < 0 || moduleCount <= row + r) {
                          continue;
                      }
                      for (var c = -1; c <= 1; c++) {
                          if (col + c < 0 || moduleCount <= col + c) {
                              continue;
                          }
                          if (r == 0 && c == 0) {
                              continue;
                          }
                          if (dark == qrCode.isDark(row + r, col + c)) {
                              sameCount++;
                          }
                      }
                  }
                  if (sameCount > 5) {
                      lostPoint += (3 + sameCount - 5);
                  }
              }
          }
          for (var row = 0; row < moduleCount - 1; row++) {
              for (var col = 0; col < moduleCount - 1; col++) {
                  var count = 0;
                  if (qrCode.isDark(row, col)) count++;
                  if (qrCode.isDark(row + 1, col)) count++;
                  if (qrCode.isDark(row, col + 1)) count++;
                  if (qrCode.isDark(row + 1, col + 1)) count++;
                  if (count == 0 || count == 4) {
                      lostPoint += 3;
                  }
              }
          }
          for (var row = 0; row < moduleCount; row++) {
              for (var col = 0; col < moduleCount - 6; col++) {
                  if (qrCode.isDark(row, col) && !qrCode.isDark(row, col + 1) && qrCode.isDark(row, col + 2) && qrCode.isDark(row, col + 3) && qrCode.isDark(row, col + 4) && !qrCode.isDark(row, col + 5) && qrCode.isDark(row, col + 6)) {
                      lostPoint += 40;
                  }
              }
          }
          for (var col = 0; col < moduleCount; col++) {
              for (var row = 0; row < moduleCount - 6; row++) {
                  if (qrCode.isDark(row, col) && !qrCode.isDark(row + 1, col) && qrCode.isDark(row + 2, col) && qrCode.isDark(row + 3, col) && qrCode.isDark(row + 4, col) && !qrCode.isDark(row + 5, col) && qrCode.isDark(row + 6, col)) {
                      lostPoint += 40;
                  }
              }
          }
          var darkCount = 0;
          for (var col = 0; col < moduleCount; col++) {
              for (var row = 0; row < moduleCount; row++) {
                  if (qrCode.isDark(row, col)) {
                      darkCount++;
                  }
              }
          }
          var ratio = Math.abs(100 * darkCount / moduleCount / moduleCount - 50) / 5;
          lostPoint += ratio * 10;
          return lostPoint;
      }
  };
  var QRMath = {
      glog: function (n) {
          if (n < 1) {
              throw new Error("glog(" + n + ")");
          }
          return QRMath.LOG_TABLE[n];
      }, gexp: function (n) {
          while (n < 0) {
              n += 255;
          }
          while (n >= 256) {
              n -= 255;
          }
          return QRMath.EXP_TABLE[n];
      }, EXP_TABLE: new Array(256), LOG_TABLE: new Array(256)
  };
  for (var i = 0; i < 8; i++) {
      QRMath.EXP_TABLE[i] = 1 << i;
  }
  for (var i = 8; i < 256; i++) {
      QRMath.EXP_TABLE[i] = QRMath.EXP_TABLE[i - 4] ^ QRMath.EXP_TABLE[i - 5] ^ QRMath.EXP_TABLE[i - 6] ^ QRMath.EXP_TABLE[i - 8];
  }
  for (var i = 0; i < 255; i++) {
      QRMath.LOG_TABLE[QRMath.EXP_TABLE[i]] = i;
  }

  function QRPolynomial(num, shift) {
      if (num.length == undefined) {
          throw new Error(num.length + "/" + shift);
      }
      var offset = 0;
      while (offset < num.length && num[offset] == 0) {
          offset++;
      }
      this.num = new Array(num.length - offset + shift);
      for (var i = 0; i < num.length - offset; i++) {
          this.num[i] = num[i + offset];
      }
  }

  QRPolynomial.prototype = {
      get: function (index) {
          return this.num[index];
      }, getLength: function () {
          return this.num.length;
      }, multiply: function (e) {
          var num = new Array(this.getLength() + e.getLength() - 1);
          for (var i = 0; i < this.getLength(); i++) {
              for (var j = 0; j < e.getLength(); j++) {
                  num[i + j] ^= QRMath.gexp(QRMath.glog(this.get(i)) + QRMath.glog(e.get(j)));
              }
          }
          return new QRPolynomial(num, 0);
      }, mod: function (e) {
          if (this.getLength() - e.getLength() < 0) {
              return this;
          }
          var ratio = QRMath.glog(this.get(0)) - QRMath.glog(e.get(0));
          var num = new Array(this.getLength());
          for (var i = 0; i < this.getLength(); i++) {
              num[i] = this.get(i);
          }
          for (var i = 0; i < e.getLength(); i++) {
              num[i] ^= QRMath.gexp(QRMath.glog(e.get(i)) + ratio);
          }
          return new QRPolynomial(num, 0).mod(e);
      }
  };

  function QRRSBlock(totalCount, dataCount) {
      this.totalCount = totalCount;
      this.dataCount = dataCount;
  }

  QRRSBlock.RS_BLOCK_TABLE = [[1, 26, 19], [1, 26, 16], [1, 26, 13], [1, 26, 9], [1, 44, 34], [1, 44, 28], [1, 44, 22], [1, 44, 16], [1, 70, 55], [1, 70, 44], [2, 35, 17], [2, 35, 13], [1, 100, 80], [2, 50, 32], [2, 50, 24], [4, 25, 9], [1, 134, 108], [2, 67, 43], [2, 33, 15, 2, 34, 16], [2, 33, 11, 2, 34, 12], [2, 86, 68], [4, 43, 27], [4, 43, 19], [4, 43, 15], [2, 98, 78], [4, 49, 31], [2, 32, 14, 4, 33, 15], [4, 39, 13, 1, 40, 14], [2, 121, 97], [2, 60, 38, 2, 61, 39], [4, 40, 18, 2, 41, 19], [4, 40, 14, 2, 41, 15], [2, 146, 116], [3, 58, 36, 2, 59, 37], [4, 36, 16, 4, 37, 17], [4, 36, 12, 4, 37, 13], [2, 86, 68, 2, 87, 69], [4, 69, 43, 1, 70, 44], [6, 43, 19, 2, 44, 20], [6, 43, 15, 2, 44, 16], [4, 101, 81], [1, 80, 50, 4, 81, 51], [4, 50, 22, 4, 51, 23], [3, 36, 12, 8, 37, 13], [2, 116, 92, 2, 117, 93], [6, 58, 36, 2, 59, 37], [4, 46, 20, 6, 47, 21], [7, 42, 14, 4, 43, 15], [4, 133, 107], [8, 59, 37, 1, 60, 38], [8, 44, 20, 4, 45, 21], [12, 33, 11, 4, 34, 12], [3, 145, 115, 1, 146, 116], [4, 64, 40, 5, 65, 41], [11, 36, 16, 5, 37, 17], [11, 36, 12, 5, 37, 13], [5, 109, 87, 1, 110, 88], [5, 65, 41, 5, 66, 42], [5, 54, 24, 7, 55, 25], [11, 36, 12], [5, 122, 98, 1, 123, 99], [7, 73, 45, 3, 74, 46], [15, 43, 19, 2, 44, 20], [3, 45, 15, 13, 46, 16], [1, 135, 107, 5, 136, 108], [10, 74, 46, 1, 75, 47], [1, 50, 22, 15, 51, 23], [2, 42, 14, 17, 43, 15], [5, 150, 120, 1, 151, 121], [9, 69, 43, 4, 70, 44], [17, 50, 22, 1, 51, 23], [2, 42, 14, 19, 43, 15], [3, 141, 113, 4, 142, 114], [3, 70, 44, 11, 71, 45], [17, 47, 21, 4, 48, 22], [9, 39, 13, 16, 40, 14], [3, 135, 107, 5, 136, 108], [3, 67, 41, 13, 68, 42], [15, 54, 24, 5, 55, 25], [15, 43, 15, 10, 44, 16], [4, 144, 116, 4, 145, 117], [17, 68, 42], [17, 50, 22, 6, 51, 23], [19, 46, 16, 6, 47, 17], [2, 139, 111, 7, 140, 112], [17, 74, 46], [7, 54, 24, 16, 55, 25], [34, 37, 13], [4, 151, 121, 5, 152, 122], [4, 75, 47, 14, 76, 48], [11, 54, 24, 14, 55, 25], [16, 45, 15, 14, 46, 16], [6, 147, 117, 4, 148, 118], [6, 73, 45, 14, 74, 46], [11, 54, 24, 16, 55, 25], [30, 46, 16, 2, 47, 17], [8, 132, 106, 4, 133, 107], [8, 75, 47, 13, 76, 48], [7, 54, 24, 22, 55, 25], [22, 45, 15, 13, 46, 16], [10, 142, 114, 2, 143, 115], [19, 74, 46, 4, 75, 47], [28, 50, 22, 6, 51, 23], [33, 46, 16, 4, 47, 17], [8, 152, 122, 4, 153, 123], [22, 73, 45, 3, 74, 46], [8, 53, 23, 26, 54, 24], [12, 45, 15, 28, 46, 16], [3, 147, 117, 10, 148, 118], [3, 73, 45, 23, 74, 46], [4, 54, 24, 31, 55, 25], [11, 45, 15, 31, 46, 16], [7, 146, 116, 7, 147, 117], [21, 73, 45, 7, 74, 46], [1, 53, 23, 37, 54, 24], [19, 45, 15, 26, 46, 16], [5, 145, 115, 10, 146, 116], [19, 75, 47, 10, 76, 48], [15, 54, 24, 25, 55, 25], [23, 45, 15, 25, 46, 16], [13, 145, 115, 3, 146, 116], [2, 74, 46, 29, 75, 47], [42, 54, 24, 1, 55, 25], [23, 45, 15, 28, 46, 16], [17, 145, 115], [10, 74, 46, 23, 75, 47], [10, 54, 24, 35, 55, 25], [19, 45, 15, 35, 46, 16], [17, 145, 115, 1, 146, 116], [14, 74, 46, 21, 75, 47], [29, 54, 24, 19, 55, 25], [11, 45, 15, 46, 46, 16], [13, 145, 115, 6, 146, 116], [14, 74, 46, 23, 75, 47], [44, 54, 24, 7, 55, 25], [59, 46, 16, 1, 47, 17], [12, 151, 121, 7, 152, 122], [12, 75, 47, 26, 76, 48], [39, 54, 24, 14, 55, 25], [22, 45, 15, 41, 46, 16], [6, 151, 121, 14, 152, 122], [6, 75, 47, 34, 76, 48], [46, 54, 24, 10, 55, 25], [2, 45, 15, 64, 46, 16], [17, 152, 122, 4, 153, 123], [29, 74, 46, 14, 75, 47], [49, 54, 24, 10, 55, 25], [24, 45, 15, 46, 46, 16], [4, 152, 122, 18, 153, 123], [13, 74, 46, 32, 75, 47], [48, 54, 24, 14, 55, 25], [42, 45, 15, 32, 46, 16], [20, 147, 117, 4, 148, 118], [40, 75, 47, 7, 76, 48], [43, 54, 24, 22, 55, 25], [10, 45, 15, 67, 46, 16], [19, 148, 118, 6, 149, 119], [18, 75, 47, 31, 76, 48], [34, 54, 24, 34, 55, 25], [20, 45, 15, 61, 46, 16]];
  QRRSBlock.getRSBlocks = function (typeNumber, errorCorrectLevel) {
      var rsBlock = QRRSBlock.getRsBlockTable(typeNumber, errorCorrectLevel);
      if (rsBlock == undefined) {
          throw new Error("bad rs block @ typeNumber:" + typeNumber + "/errorCorrectLevel:" + errorCorrectLevel);
      }
      var length = rsBlock.length / 3;
      var list = [];
      for (var i = 0; i < length; i++) {
          var count = rsBlock[i * 3 + 0];
          var totalCount = rsBlock[i * 3 + 1];
          var dataCount = rsBlock[i * 3 + 2];
          for (var j = 0; j < count; j++) {
              list.push(new QRRSBlock(totalCount, dataCount));
          }
      }
      return list;
  };
  QRRSBlock.getRsBlockTable = function (typeNumber, errorCorrectLevel) {
      switch (errorCorrectLevel) {
          case QRErrorCorrectLevel.L:
              return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 0];
          case QRErrorCorrectLevel.M:
              return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 1];
          case QRErrorCorrectLevel.Q:
              return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 2];
          case QRErrorCorrectLevel.H:
              return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 3];
          default:
              return undefined;
      }
  };

  function QRBitBuffer() {
      this.buffer = [];
      this.length = 0;
  }

  QRBitBuffer.prototype = {
      get: function (index) {
          var bufIndex = Math.floor(index / 8);
          return ((this.buffer[bufIndex] >>> (7 - index % 8)) & 1) == 1;
      }, put: function (num, length) {
          for (var i = 0; i < length; i++) {
              this.putBit(((num >>> (length - i - 1)) & 1) == 1);
          }
      }, getLengthInBits: function () {
          return this.length;
      }, putBit: function (bit) {
          var bufIndex = Math.floor(this.length / 8);
          if (this.buffer.length <= bufIndex) {
              this.buffer.push(0);
          }
          if (bit) {
              this.buffer[bufIndex] |= (0x80 >>> (this.length % 8));
          }
          this.length++;
      }
  };
  var QRCodeLimitLength = [[17, 14, 11, 7], [32, 26, 20, 14], [53, 42, 32, 24], [78, 62, 46, 34], [106, 84, 60, 44], [134, 106, 74, 58], [154, 122, 86, 64], [192, 152, 108, 84], [230, 180, 130, 98], [271, 213, 151, 119], [321, 251, 177, 137], [367, 287, 203, 155], [425, 331, 241, 177], [458, 362, 258, 194], [520, 412, 292, 220], [586, 450, 322, 250], [644, 504, 364, 280], [718, 560, 394, 310], [792, 624, 442, 338], [858, 666, 482, 382], [929, 711, 509, 403], [1003, 779, 565, 439], [1091, 857, 611, 461], [1171, 911, 661, 511], [1273, 997, 715, 535], [1367, 1059, 751, 593], [1465, 1125, 805, 625], [1528, 1190, 868, 658], [1628, 1264, 908, 698], [1732, 1370, 982, 742], [1840, 1452, 1030, 790], [1952, 1538, 1112, 842], [2068, 1628, 1168, 898], [2188, 1722, 1228, 958], [2303, 1809, 1283, 983], [2431, 1911, 1351, 1051], [2563, 1989, 1423, 1093], [2699, 2099, 1499, 1139], [2809, 2213, 1579, 1219], [2953, 2331, 1663, 1273]];

  var useSVG = document.documentElement.tagName.toLowerCase() === "svg";

  let Drawing;

  if (useSVG) {

      Drawing = function (el, htOption) {
          this._el = el;
          this._htOption = htOption;
      };

      Drawing.prototype.draw = function (oQRCode) {
          var _htOption = this._htOption;
          var _el = this._el;
          var nCount = oQRCode.getModuleCount();
          Math.floor(_htOption.width / nCount);
          Math.floor(_htOption.height / nCount);

          this.clear();

          function makeSVG(tag, attrs) {
              var el = document.createElementNS('http://www.w3.org/2000/svg', tag);
              for (var k in attrs)
                  if (attrs.hasOwnProperty(k)) el.setAttribute(k, attrs[k]);
              return el;
          }

          var svg = makeSVG("svg", {
              'viewBox': '0 0 ' + String(nCount) + " " + String(nCount),
              'width': '100%',
              'height': '100%',
              'fill': _htOption.colorLight
          });
          svg.setAttributeNS("http://www.w3.org/2000/xmlns/", "xmlns:xlink", "http://www.w3.org/1999/xlink");
          _el.appendChild(svg);

          svg.appendChild(makeSVG("rect", {"fill": _htOption.colorLight, "width": "100%", "height": "100%"}));
          svg.appendChild(makeSVG("rect", {
              "fill": _htOption.colorDark,
              "width": "1",
              "height": "1",
              "id": "template"
          }));

          for (var row = 0; row < nCount; row++) {
              for (var col = 0; col < nCount; col++) {
                  if (oQRCode.isDark(row, col)) {
                      var child = makeSVG("use", {"x": String(col), "y": String(row)});
                      child.setAttributeNS("http://www.w3.org/1999/xlink", "href", "#template");
                      svg.appendChild(child);
                  }
              }
          }
      };
      Drawing.prototype.clear = function () {
          while (this._el.hasChildNodes())
              this._el.removeChild(this._el.lastChild);
      };
  }
  else {

      /**
       * Drawing QRCode by using canvas
       *
       * @constructor
       * @param {HTMLElement} el
       * @param {Object} htOption QRCode Options
       */
       Drawing = function (el, htOption) {
          this._bIsPainted = false;
          this._htOption = htOption;
          this._elCanvas = document.createElement("canvas");
          this._elCanvas.width = htOption.width;
          this._elCanvas.height = htOption.height;
          el.appendChild(this._elCanvas);
          this._el = el;
          this._oContext = this._elCanvas.getContext("2d");
          this._bIsPainted = false;
          this._elImage = document.createElement("img");
          this._elImage.alt = "Scan me!";
          this._elImage.style.display = "none";
          this._el.appendChild(this._elImage);
          this._bSupportDataURI = null;
      };

      /**
       * Draw the QRCode
       *
       * @param {QRCode} oQRCode
       */
      Drawing.prototype.draw = function (oQRCode) {
          var _elImage = this._elImage;
          var _oContext = this._oContext;
          var _htOption = this._htOption;

          var nCount = oQRCode.getModuleCount();
          var nWidth = _htOption.width / nCount;
          var nHeight = _htOption.height / nCount;
          var nRoundedWidth = Math.round(nWidth);
          var nRoundedHeight = Math.round(nHeight);

          _elImage.style.display = "none";
          this.clear();

          for (var row = 0; row < nCount; row++) {
              for (var col = 0; col < nCount; col++) {
                  var bIsDark = oQRCode.isDark(row, col);
                  var nLeft = col * nWidth;
                  var nTop = row * nHeight;
                  _oContext.strokeStyle = bIsDark ? _htOption.colorDark : _htOption.colorLight;
                  _oContext.lineWidth = 1;
                  _oContext.fillStyle = bIsDark ? _htOption.colorDark : _htOption.colorLight;
                  _oContext.fillRect(nLeft, nTop, nWidth, nHeight);

                  // 안티 앨리어싱 방지 처리
                  _oContext.strokeRect(
                      Math.floor(nLeft) + 0.5,
                      Math.floor(nTop) + 0.5,
                      nRoundedWidth,
                      nRoundedHeight
                  );

                  _oContext.strokeRect(
                      Math.ceil(nLeft) - 0.5,
                      Math.ceil(nTop) - 0.5,
                      nRoundedWidth,
                      nRoundedHeight
                  );
              }
          }

          this._bIsPainted = true;
      };

      /**
       * Make the image from Canvas if the browser supports Data URI.
       */
      Drawing.prototype.makeImage = function () {
          if (this._bIsPainted) {
              this._elImage.src = this._elCanvas.toDataURL("image/png");
              this._elImage.style.display = "block";
              this._elCanvas.style.display = "none";
          }
      };

      /**
       * Return whether the QRCode is painted or not
       *
       * @return {Boolean}
       */
      Drawing.prototype.isPainted = function () {
          return this._bIsPainted;
      };

      /**
       * Clear the QRCode
       */
      Drawing.prototype.clear = function () {
          this._oContext.clearRect(0, 0, this._elCanvas.width, this._elCanvas.height);
          this._bIsPainted = false;
      };

      /**
       * @private
       * @param {Number} nNumber
       */
      Drawing.prototype.round = function (nNumber) {
          if (!nNumber) {
              return nNumber;
          }

          return Math.floor(nNumber * 1000) / 1000;
      };
  }

  /**
   * Get the type by string length
   *
   * @private
   * @param {String} sText
   * @param {Number} nCorrectLevel
   * @return {Number} type
   */
  function _getTypeNumber(sText, nCorrectLevel) {
      var nType = 1;
      var length = _getUTF8Length(sText);

      for (var i = 0, len = QRCodeLimitLength.length; i <= len; i++) {
          var nLimit = 0;

          switch (nCorrectLevel) {
              case QRErrorCorrectLevel.L :
                  nLimit = QRCodeLimitLength[i][0];
                  break;
              case QRErrorCorrectLevel.M :
                  nLimit = QRCodeLimitLength[i][1];
                  break;
              case QRErrorCorrectLevel.Q :
                  nLimit = QRCodeLimitLength[i][2];
                  break;
              case QRErrorCorrectLevel.H :
                  nLimit = QRCodeLimitLength[i][3];
                  break;
          }

          if (length <= nLimit) {
              break;
          } else {
              nType++;
          }
      }

      if (nType > QRCodeLimitLength.length) {
          throw new Error("Too long data");
      }

      return nType;
  }

  function _getUTF8Length(sText) {
      var replacedText = encodeURI(sText).toString().replace(/\%[0-9a-fA-F]{2}/g, 'a');
      return replacedText.length + (replacedText.length != sText ? 3 : 0);
  }

  /**
   * @class QRCode
   * @constructor
   * @example
   * new QRCode(document.getElementById("test"), "http://jindo.dev.naver.com/collie");
   *
   * @example
   * var oQRCode = new QRCode("test", {
   *    text : "http://naver.com",
   *    width : 128,
   *    height : 128
   * });
   *
   * oQRCode.clear(); // Clear the QRCode.
   * oQRCode.makeCode("http://map.naver.com"); // Re-create the QRCode.
   *
   * @param {HTMLElement|String} el target element or 'id' attribute of element.
   * @param {Object|String} vOption
   * @param {String} vOption.text QRCode link data
   * @param {Number} [vOption.width=256]
   * @param {Number} [vOption.height=256]
   * @param {String} [vOption.colorDark="#000000"]
   * @param {String} [vOption.colorLight="#ffffff"]
   * @param {QRCode.CorrectLevel} [vOption.correctLevel=QRCode.CorrectLevel.H] [L|M|Q|H]
   */
  const QRCode = function (el, vOption) {
      this._htOption = {
          width: 256,
          height: 256,
          typeNumber: 4,
          colorDark: "#000000",
          colorLight: "#ffffff",
          correctLevel: QRErrorCorrectLevel.H
      };

      if (typeof vOption === 'string') {
          vOption = {
              text: vOption
          };
      }

      // Overwrites options
      if (vOption) {
          for (var i in vOption) {
              this._htOption[i] = vOption[i];
          }
      }

      if (typeof el == "string") {
          el = document.getElementById(el);
      }

      if (this._htOption.useSVG) {
          Drawing = svgDrawer;
      }

      this._el = el;
      this._oQRCode = null;
      this._oDrawing = new Drawing(this._el, this._htOption);

      if (this._htOption.text) {
          this.makeCode(this._htOption.text);
      }
  };

  /**
   * Make the QRCode
   *
   * @param {String} sText link data
   */
  QRCode.prototype.makeCode = function (sText) {
      this._oQRCode = new QRCodeModel(_getTypeNumber(sText, this._htOption.correctLevel), this._htOption.correctLevel);
      this._oQRCode.addData(sText);
      this._oQRCode.make();
      this._el.title = sText;
      this._oDrawing.draw(this._oQRCode);
      this.makeImage();
  };

  /**
   * Make the Image from Canvas element
   * - It occurs automatically
   * - Android below 3 doesn't support Data-URI spec.
   *
   * @private
   */
  QRCode.prototype.makeImage = function () {
      if (typeof this._oDrawing.makeImage == "function") {
          this._oDrawing.makeImage();
      }
  };

  /**
   * Clear the QRCode
   */
  QRCode.prototype.clear = function () {
      this._oDrawing.clear();
  };

  /**
   * @name QRCode.CorrectLevel
   */
  QRCode.CorrectLevel = QRErrorCorrectLevel;

  function div(options) {
      return create("div", options);
  }

  function create(tag, options) {
      const elem = document.createElement(tag);
      if (options) {
          if (options.class) {
              elem.classList.add(options.class);
          }
          if (options.id) {
              elem.id = options.id;
          }
          if(options.style) {
              applyStyle(elem, options.style);
          }
      }
      return elem;
  }

  function hide(elem) {
      const cssStyle = getComputedStyle(elem);
      if(cssStyle.display !== "none") {
          elem._initialDisplay = cssStyle.display;
      }
      elem.style.display = "none";
  }

  function show(elem) {
      const currentDisplay = getComputedStyle(elem).display;
      if (currentDisplay === "none") {
          const d = elem._initialDisplay || "block";
          elem.style.display = d;
      }
  }

  function applyStyle(elem, style) {
      for (let key of Object.keys(style)) {
          elem.style[key] = style[key];
      }
  }

  function guid$1  () {
      return ("0000" + (Math.random() * Math.pow(36, 4) << 0).toString(36)).slice(-4);
  }

  /**
   * Make the target element movable by clicking and dragging on the handle.  This is not a general purprose function,
   * it makes several options specific to igv dialogs, the primary one being that the
   * target is absolutely positioned in pixel coordinates

   */

  let dragData;  // Its assumed we are only dragging one element at a time.

  function makeDraggable(target, handle, constraint) {

      handle.addEventListener('mousedown', dragStart.bind(target));

      function dragStart(event) {

          event.stopPropagation();
          event.preventDefault();

          const dragFunction = drag.bind(this);
          const dragEndFunction = dragEnd.bind(this);
          const computedStyle = getComputedStyle(this);

          dragData =
              {
                  constraint,
                  dragFunction,
                  dragEndFunction,
                  screenX: event.screenX,
                  screenY: event.screenY,
                  top: parseInt(computedStyle.top.replace("px", "")),
                  left: parseInt(computedStyle.left.replace("px", ""))
              };

          document.addEventListener('mousemove', dragFunction);
          document.addEventListener('mouseup', dragEndFunction);
          document.addEventListener('mouseleave', dragEndFunction);
          document.addEventListener('mouseexit', dragEndFunction);
      }
  }

  function drag(event) {

      if (!dragData) {
          console.error("No drag data!");
          return;
      }
      event.stopPropagation();
      event.preventDefault();
      const dx = event.screenX - dragData.screenX;
      const dy = event.screenY - dragData.screenY;

      const left = dragData.left + dx;
      const  top = dragData.constraint ? Math.max(dragData.constraint.minY, dragData.top  + dy) : dragData.top  + dy;

      this.style.left = `${ left }px`;
      this.style.top  = `${  top }px`;
  }

  function dragEnd(event) {

      if (!dragData) {
          console.error("No drag data!");
          return;
      }
      event.stopPropagation();
      event.preventDefault();

      const dragFunction = dragData.dragFunction;
      const dragEndFunction = dragData.dragEndFunction;
      document.removeEventListener('mousemove', dragFunction);
      document.removeEventListener('mouseup', dragEndFunction);
      document.removeEventListener('mouseleave', dragEndFunction);
      document.removeEventListener('mouseexit', dragEndFunction);
      dragData = undefined;
  }

  const httpMessages =
      {
          "401": "Access unauthorized",
          "403": "Access forbidden",
          "404": "Not found"
      };


  class AlertDialog {
      constructor(parent) {

          // container
          this.container = div({class: "igv-widgets-alert-dialog-container"});
          parent.appendChild(this.container);
          this.container.setAttribute('tabIndex', '-1');

          // header
          const header = div();
          this.container.appendChild(header);

          this.errorHeadline = div();
          header.appendChild(this.errorHeadline);
          this.errorHeadline.textContent = '';

          // body container
          let bodyContainer = div({id: 'igv-widgets-alert-dialog-body'});
          this.container.appendChild(bodyContainer);

          // body copy
          this.body = div({id: 'igv-widgets-alert-dialog-body-copy'});
          bodyContainer.appendChild(this.body);

          // ok container
          let ok_container = div();
          this.container.appendChild(ok_container);

          // ok
          this.ok = div();
          ok_container.appendChild(this.ok);
          this.ok.textContent = 'OK';

          const okHandler = () => {

              if (typeof this.callback === 'function') {
                  this.callback("OK");
                  this.callback = undefined;
              }
              this.body.innerHTML = '';
              hide(this.container);
          };

          this.ok.addEventListener('click', event => {

              event.stopPropagation();

              okHandler();
          });

          this.container.addEventListener('keypress', event => {

              event.stopPropagation();

              if ('Enter' === event.key) {
                  okHandler();
              }
          });

          makeDraggable(this.container, header);

          hide(this.container);
      }

      present(alert, callback) {

          this.errorHeadline.textContent = alert.message ? 'ERROR' : '';
          let string = alert.message || alert;

          if (httpMessages.hasOwnProperty(string)) {
              string = httpMessages[string];
          }

          this.body.innerHTML = string;
          this.callback = callback;
          show(this.container);
          this.container.focus();
      }
  }

  class AlertSingleton {
      constructor(root) {

          if (root) {
              this.alertDialog = undefined;
          }
      }

      init(root) {
          this.alertDialog = new AlertDialog(root);
      }

      present(alert, callback) {
          this.alertDialog.present(alert, callback);
      }

  }

  var AlertSingleton$1 = new AlertSingleton();

  function getExtension(url) {

      if (undefined === url) {
          return undefined
      }

      let path = (isFilePath(url) || url.google_url) ? url.name : url;
      let filename = path.toLowerCase();

      //Strip parameters -- handle local files later
      let index = filename.indexOf("?");
      if (index > 0) {
          filename = filename.substr(0, index);
      }

      //Strip aux extensions .gz, .tab, and .txt
      if (filename.endsWith(".gz")) {
          filename = filename.substr(0, filename.length - 3);
      } else if (filename.endsWith(".txt") || filename.endsWith(".tab") || filename.endsWith(".bgz")) {
          filename = filename.substr(0, filename.length - 4);
      }

      index = filename.lastIndexOf(".");

      return index < 0 ? filename : filename.substr(1 + index)
  }


  /**
   * Test if object is a File or File-like object.
   *
   * @param object
   */
  function isFile$1(object) {
      if(!object) {
          return false;
      }
      return typeof object !== 'function' &&
          (object instanceof File ||
              (object.hasOwnProperty("name") && typeof object.slice === 'function' && typeof object.arrayBuffer === 'function'))
  }

  const isFilePath = isFile$1;    // deprecated

  function download(filename, data) {

      const element = document.createElement('a');
      element.setAttribute('href', data);
      element.setAttribute('download', filename);
      element.style.display = 'none';
      document.body.appendChild(element);
      element.click();
      document.body.removeChild(element);
  }

  if (typeof process === 'object' && typeof window === 'undefined') {
      global.atob = function (str) {
          return Buffer.from(str, 'base64').toString('binary');
      };
  }


  function parseUri(str) {

      var o = options,
          m = o.parser["loose"].exec(str),
          uri = {},
          i = 14;

      while (i--) uri[o.key[i]] = m[i] || "";

      uri[o.q.name] = {};
      uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
          if ($1) uri[o.q.name][$1] = $2;
      });

      return uri;
  }

  const options = {
      strictMode: false,
      key: ["source", "protocol", "authority", "userInfo", "user", "password", "host", "port", "relative", "path", "directory", "file", "query", "anchor"],
      q: {
          name: "queryKey",
          parser: /(?:^|&)([^&=]*)=?([^&]*)/g
      },
      parser: {
          strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
          loose: /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
      }
  };

  /*============================================================================*/


  function zero$1(buf) { let len = buf.length; while (--len >= 0) { buf[len] = 0; } }
  /* The three kinds of block type */

  const MIN_MATCH$1    = 3;
  const MAX_MATCH$1    = 258;
  /* The minimum and maximum match lengths */

  // From deflate.h
  /* ===========================================================================
   * Internal compression state.
   */

  const LENGTH_CODES$1  = 29;
  /* number of length codes, not counting the special END_BLOCK code */

  const LITERALS$1      = 256;
  /* number of literal bytes 0..255 */

  const L_CODES$1       = LITERALS$1 + 1 + LENGTH_CODES$1;
  /* number of Literal or Length codes, including the END_BLOCK code */

  const D_CODES$1       = 30;
  /* eslint-enable comma-spacing,array-bracket-spacing */

  /* The lengths of the bit length codes are sent in order of decreasing
   * probability, to avoid transmitting the lengths for unused bit length codes.
   */

  /* ===========================================================================
   * Local data. These are initialized only once.
   */

  // We pre-fill arrays with 0 to avoid uninitialized gaps

  const DIST_CODE_LEN = 512; /* see definition of array dist_code below */

  // !!!! Use flat array instead of structure, Freq = i*2, Len = i*2+1
  const static_ltree  = new Array((L_CODES$1 + 2) * 2);
  zero$1(static_ltree);
  /* The static literal tree. Since the bit lengths are imposed, there is no
   * need for the L_CODES extra codes used during heap construction. However
   * The codes 286 and 287 are needed to build a canonical tree (see _tr_init
   * below).
   */

  const static_dtree  = new Array(D_CODES$1 * 2);
  zero$1(static_dtree);
  /* The static distance tree. (Actually a trivial tree since all codes use
   * 5 bits.)
   */

  const _dist_code    = new Array(DIST_CODE_LEN);
  zero$1(_dist_code);
  /* Distance codes. The first 256 values correspond to the distances
   * 3 .. 258, the last 256 values correspond to the top 8 bits of
   * the 15 bit distances.
   */

  const _length_code  = new Array(MAX_MATCH$1 - MIN_MATCH$1 + 1);
  zero$1(_length_code);
  /* length code for each normalized match length (0 == MIN_MATCH) */

  const base_length   = new Array(LENGTH_CODES$1);
  zero$1(base_length);
  /* First normalized length for each code (0 = MIN_MATCH) */

  const base_dist     = new Array(D_CODES$1);
  zero$1(base_dist);

  // Note: adler32 takes 12% for level 0 and 2% for level 6.
  // It isn't worth it to make additional optimizations as in original.
  // Small size is preferable.

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  const adler32 = (adler, buf, len, pos) => {
    let s1 = (adler & 0xffff) |0,
        s2 = ((adler >>> 16) & 0xffff) |0,
        n = 0;

    while (len !== 0) {
      // Set limit ~ twice less than 5552, to keep
      // s2 in 31-bits, because we force signed ints.
      // in other case %= will fail.
      n = len > 2000 ? 2000 : len;
      len -= n;

      do {
        s1 = (s1 + buf[pos++]) |0;
        s2 = (s2 + s1) |0;
      } while (--n);

      s1 %= 65521;
      s2 %= 65521;
    }

    return (s1 | (s2 << 16)) |0;
  };


  var adler32_1 = adler32;

  // Note: we can't get significant speed boost here.
  // So write code to minimize size - no pregenerated tables
  // and array tools dependencies.

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  // Use ordinary array, since untyped makes no boost here
  const makeTable = () => {
    let c, table = [];

    for (var n = 0; n < 256; n++) {
      c = n;
      for (var k = 0; k < 8; k++) {
        c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
      }
      table[n] = c;
    }

    return table;
  };

  // Create table on load. Just 255 signed longs. Not a problem.
  const crcTable = new Uint32Array(makeTable());


  const crc32 = (crc, buf, len, pos) => {
    const t = crcTable;
    const end = pos + len;

    crc ^= -1;

    for (let i = pos; i < end; i++) {
      crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
    }

    return (crc ^ (-1)); // >>> 0;
  };


  var crc32_1 = crc32;

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  var messages = {
    2:      'need dictionary',     /* Z_NEED_DICT       2  */
    1:      'stream end',          /* Z_STREAM_END      1  */
    0:      '',                    /* Z_OK              0  */
    '-1':   'file error',          /* Z_ERRNO         (-1) */
    '-2':   'stream error',        /* Z_STREAM_ERROR  (-2) */
    '-3':   'data error',          /* Z_DATA_ERROR    (-3) */
    '-4':   'insufficient memory', /* Z_MEM_ERROR     (-4) */
    '-5':   'buffer error',        /* Z_BUF_ERROR     (-5) */
    '-6':   'incompatible version' /* Z_VERSION_ERROR (-6) */
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  var constants$2 = {

    /* Allowed flush values; see deflate() and inflate() below for details */
    Z_NO_FLUSH:         0,
    Z_PARTIAL_FLUSH:    1,
    Z_SYNC_FLUSH:       2,
    Z_FULL_FLUSH:       3,
    Z_FINISH:           4,
    Z_BLOCK:            5,
    Z_TREES:            6,

    /* Return codes for the compression/decompression functions. Negative values
    * are errors, positive values are used for special but normal events.
    */
    Z_OK:               0,
    Z_STREAM_END:       1,
    Z_NEED_DICT:        2,
    Z_ERRNO:           -1,
    Z_STREAM_ERROR:    -2,
    Z_DATA_ERROR:      -3,
    Z_MEM_ERROR:       -4,
    Z_BUF_ERROR:       -5,
    //Z_VERSION_ERROR: -6,

    /* compression levels */
    Z_NO_COMPRESSION:         0,
    Z_BEST_SPEED:             1,
    Z_BEST_COMPRESSION:       9,
    Z_DEFAULT_COMPRESSION:   -1,


    Z_FILTERED:               1,
    Z_HUFFMAN_ONLY:           2,
    Z_RLE:                    3,
    Z_FIXED:                  4,
    Z_DEFAULT_STRATEGY:       0,

    /* Possible values of the data_type field (though see inflate()) */
    Z_BINARY:                 0,
    Z_TEXT:                   1,
    //Z_ASCII:                1, // = Z_TEXT (deprecated)
    Z_UNKNOWN:                2,

    /* The deflate compression method */
    Z_DEFLATED:               8
    //Z_NULL:                 null // Use -1 or null inline, depending on var type
  };

  const _has = (obj, key) => {
    return Object.prototype.hasOwnProperty.call(obj, key);
  };

  var assign = function (obj /*from1, from2, from3, ...*/) {
    const sources = Array.prototype.slice.call(arguments, 1);
    while (sources.length) {
      const source = sources.shift();
      if (!source) { continue; }

      if (typeof source !== 'object') {
        throw new TypeError(source + 'must be non-object');
      }

      for (const p in source) {
        if (_has(source, p)) {
          obj[p] = source[p];
        }
      }
    }

    return obj;
  };


  // Join array of chunks to single array.
  var flattenChunks = (chunks) => {
    // calculate data length
    let len = 0;

    for (let i = 0, l = chunks.length; i < l; i++) {
      len += chunks[i].length;
    }

    // join chunks
    const result = new Uint8Array(len);

    for (let i = 0, pos = 0, l = chunks.length; i < l; i++) {
      let chunk = chunks[i];
      result.set(chunk, pos);
      pos += chunk.length;
    }

    return result;
  };

  var common = {
  	assign: assign,
  	flattenChunks: flattenChunks
  };

  // String encode/decode helpers


  // Quick check if we can use fast array to bin string conversion
  //
  // - apply(Array) can fail on Android 2.2
  // - apply(Uint8Array) can fail on iOS 5.1 Safari
  //
  let STR_APPLY_UIA_OK = true;

  try { String.fromCharCode.apply(null, new Uint8Array(1)); } catch (__) { STR_APPLY_UIA_OK = false; }


  // Table with utf8 lengths (calculated by first byte of sequence)
  // Note, that 5 & 6-byte values and some 4-byte values can not be represented in JS,
  // because max possible codepoint is 0x10ffff
  const _utf8len = new Uint8Array(256);
  for (let q = 0; q < 256; q++) {
    _utf8len[q] = (q >= 252 ? 6 : q >= 248 ? 5 : q >= 240 ? 4 : q >= 224 ? 3 : q >= 192 ? 2 : 1);
  }
  _utf8len[254] = _utf8len[254] = 1; // Invalid sequence start


  // convert string to array (typed, when possible)
  var string2buf = (str) => {
    if (typeof TextEncoder === 'function' && TextEncoder.prototype.encode) {
      return new TextEncoder().encode(str);
    }

    let buf, c, c2, m_pos, i, str_len = str.length, buf_len = 0;

    // count binary size
    for (m_pos = 0; m_pos < str_len; m_pos++) {
      c = str.charCodeAt(m_pos);
      if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
        c2 = str.charCodeAt(m_pos + 1);
        if ((c2 & 0xfc00) === 0xdc00) {
          c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
          m_pos++;
        }
      }
      buf_len += c < 0x80 ? 1 : c < 0x800 ? 2 : c < 0x10000 ? 3 : 4;
    }

    // allocate buffer
    buf = new Uint8Array(buf_len);

    // convert
    for (i = 0, m_pos = 0; i < buf_len; m_pos++) {
      c = str.charCodeAt(m_pos);
      if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
        c2 = str.charCodeAt(m_pos + 1);
        if ((c2 & 0xfc00) === 0xdc00) {
          c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
          m_pos++;
        }
      }
      if (c < 0x80) {
        /* one byte */
        buf[i++] = c;
      } else if (c < 0x800) {
        /* two bytes */
        buf[i++] = 0xC0 | (c >>> 6);
        buf[i++] = 0x80 | (c & 0x3f);
      } else if (c < 0x10000) {
        /* three bytes */
        buf[i++] = 0xE0 | (c >>> 12);
        buf[i++] = 0x80 | (c >>> 6 & 0x3f);
        buf[i++] = 0x80 | (c & 0x3f);
      } else {
        /* four bytes */
        buf[i++] = 0xf0 | (c >>> 18);
        buf[i++] = 0x80 | (c >>> 12 & 0x3f);
        buf[i++] = 0x80 | (c >>> 6 & 0x3f);
        buf[i++] = 0x80 | (c & 0x3f);
      }
    }

    return buf;
  };

  // Helper
  const buf2binstring = (buf, len) => {
    // On Chrome, the arguments in a function call that are allowed is `65534`.
    // If the length of the buffer is smaller than that, we can use this optimization,
    // otherwise we will take a slower path.
    if (len < 65534) {
      if (buf.subarray && STR_APPLY_UIA_OK) {
        return String.fromCharCode.apply(null, buf.length === len ? buf : buf.subarray(0, len));
      }
    }

    let result = '';
    for (let i = 0; i < len; i++) {
      result += String.fromCharCode(buf[i]);
    }
    return result;
  };


  // convert array to string
  var buf2string = (buf, max) => {
    const len = max || buf.length;

    if (typeof TextDecoder === 'function' && TextDecoder.prototype.decode) {
      return new TextDecoder().decode(buf.subarray(0, max));
    }

    let i, out;

    // Reserve max possible length (2 words per char)
    // NB: by unknown reasons, Array is significantly faster for
    //     String.fromCharCode.apply than Uint16Array.
    const utf16buf = new Array(len * 2);

    for (out = 0, i = 0; i < len;) {
      let c = buf[i++];
      // quick process ascii
      if (c < 0x80) { utf16buf[out++] = c; continue; }

      let c_len = _utf8len[c];
      // skip 5 & 6 byte codes
      if (c_len > 4) { utf16buf[out++] = 0xfffd; i += c_len - 1; continue; }

      // apply mask on first byte
      c &= c_len === 2 ? 0x1f : c_len === 3 ? 0x0f : 0x07;
      // join the rest
      while (c_len > 1 && i < len) {
        c = (c << 6) | (buf[i++] & 0x3f);
        c_len--;
      }

      // terminated by end of string?
      if (c_len > 1) { utf16buf[out++] = 0xfffd; continue; }

      if (c < 0x10000) {
        utf16buf[out++] = c;
      } else {
        c -= 0x10000;
        utf16buf[out++] = 0xd800 | ((c >> 10) & 0x3ff);
        utf16buf[out++] = 0xdc00 | (c & 0x3ff);
      }
    }

    return buf2binstring(utf16buf, out);
  };


  // Calculate max possible position in utf8 buffer,
  // that will not break sequence. If that's not possible
  // - (very small limits) return max size as is.
  //
  // buf[] - utf8 bytes array
  // max   - length limit (mandatory);
  var utf8border = (buf, max) => {

    max = max || buf.length;
    if (max > buf.length) { max = buf.length; }

    // go back from last position, until start of sequence found
    let pos = max - 1;
    while (pos >= 0 && (buf[pos] & 0xC0) === 0x80) { pos--; }

    // Very small and broken sequence,
    // return max, because we should return something anyway.
    if (pos < 0) { return max; }

    // If we came to start of buffer - that means buffer is too small,
    // return max too.
    if (pos === 0) { return max; }

    return (pos + _utf8len[buf[pos]] > max) ? pos : max;
  };

  var strings = {
  	string2buf: string2buf,
  	buf2string: buf2string,
  	utf8border: utf8border
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  function ZStream() {
    /* next input byte */
    this.input = null; // JS specific, because we have no pointers
    this.next_in = 0;
    /* number of bytes available at input */
    this.avail_in = 0;
    /* total number of input bytes read so far */
    this.total_in = 0;
    /* next output byte should be put there */
    this.output = null; // JS specific, because we have no pointers
    this.next_out = 0;
    /* remaining free space at output */
    this.avail_out = 0;
    /* total number of bytes output so far */
    this.total_out = 0;
    /* last error message, NULL if no error */
    this.msg = ''/*Z_NULL*/;
    /* not visible by applications */
    this.state = null;
    /* best guess about the data type: binary or text */
    this.data_type = 2/*Z_UNKNOWN*/;
    /* adler32 value of the uncompressed data */
    this.adler = 0;
  }

  var zstream = ZStream;

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  // See state defs from inflate.js
  const BAD$1 = 16209;       /* got a data error -- remain here until reset */
  const TYPE$1 = 16191;      /* i: waiting for type bits, including last-flag bit */

  /*
     Decode literal, length, and distance codes and write out the resulting
     literal and match bytes until either not enough input or output is
     available, an end-of-block is encountered, or a data error is encountered.
     When large enough input and output buffers are supplied to inflate(), for
     example, a 16K input buffer and a 64K output buffer, more than 95% of the
     inflate execution time is spent in this routine.

     Entry assumptions:

          state.mode === LEN
          strm.avail_in >= 6
          strm.avail_out >= 258
          start >= strm.avail_out
          state.bits < 8

     On return, state.mode is one of:

          LEN -- ran out of enough output space or enough available input
          TYPE -- reached end of block code, inflate() to interpret next block
          BAD -- error in block data

     Notes:

      - The maximum input bits used by a length/distance pair is 15 bits for the
        length code, 5 bits for the length extra, 15 bits for the distance code,
        and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
        Therefore if strm.avail_in >= 6, then there is enough input to avoid
        checking for available input while decoding.

      - The maximum bytes that a single length/distance pair can output is 258
        bytes, which is the maximum length that can be coded.  inflate_fast()
        requires strm.avail_out >= 258 for each loop to avoid checking for
        output space.
   */
  var inffast = function inflate_fast(strm, start) {
    let _in;                    /* local strm.input */
    let last;                   /* have enough input while in < last */
    let _out;                   /* local strm.output */
    let beg;                    /* inflate()'s initial strm.output */
    let end;                    /* while out < end, enough space available */
  //#ifdef INFLATE_STRICT
    let dmax;                   /* maximum distance from zlib header */
  //#endif
    let wsize;                  /* window size or zero if not using window */
    let whave;                  /* valid bytes in the window */
    let wnext;                  /* window write index */
    // Use `s_window` instead `window`, avoid conflict with instrumentation tools
    let s_window;               /* allocated sliding window, if wsize != 0 */
    let hold;                   /* local strm.hold */
    let bits;                   /* local strm.bits */
    let lcode;                  /* local strm.lencode */
    let dcode;                  /* local strm.distcode */
    let lmask;                  /* mask for first level of length codes */
    let dmask;                  /* mask for first level of distance codes */
    let here;                   /* retrieved table entry */
    let op;                     /* code bits, operation, extra bits, or */
                                /*  window position, window bytes to copy */
    let len;                    /* match length, unused bytes */
    let dist;                   /* match distance */
    let from;                   /* where to copy match from */
    let from_source;


    let input, output; // JS specific, because we have no pointers

    /* copy state to local variables */
    const state = strm.state;
    //here = state.here;
    _in = strm.next_in;
    input = strm.input;
    last = _in + (strm.avail_in - 5);
    _out = strm.next_out;
    output = strm.output;
    beg = _out - (start - strm.avail_out);
    end = _out + (strm.avail_out - 257);
  //#ifdef INFLATE_STRICT
    dmax = state.dmax;
  //#endif
    wsize = state.wsize;
    whave = state.whave;
    wnext = state.wnext;
    s_window = state.window;
    hold = state.hold;
    bits = state.bits;
    lcode = state.lencode;
    dcode = state.distcode;
    lmask = (1 << state.lenbits) - 1;
    dmask = (1 << state.distbits) - 1;


    /* decode literals and length/distances until end-of-block or not enough
       input data or output space */

    top:
    do {
      if (bits < 15) {
        hold += input[_in++] << bits;
        bits += 8;
        hold += input[_in++] << bits;
        bits += 8;
      }

      here = lcode[hold & lmask];

      dolen:
      for (;;) { // Goto emulation
        op = here >>> 24/*here.bits*/;
        hold >>>= op;
        bits -= op;
        op = (here >>> 16) & 0xff/*here.op*/;
        if (op === 0) {                          /* literal */
          //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
          //        "inflate:         literal '%c'\n" :
          //        "inflate:         literal 0x%02x\n", here.val));
          output[_out++] = here & 0xffff/*here.val*/;
        }
        else if (op & 16) {                     /* length base */
          len = here & 0xffff/*here.val*/;
          op &= 15;                           /* number of extra bits */
          if (op) {
            if (bits < op) {
              hold += input[_in++] << bits;
              bits += 8;
            }
            len += hold & ((1 << op) - 1);
            hold >>>= op;
            bits -= op;
          }
          //Tracevv((stderr, "inflate:         length %u\n", len));
          if (bits < 15) {
            hold += input[_in++] << bits;
            bits += 8;
            hold += input[_in++] << bits;
            bits += 8;
          }
          here = dcode[hold & dmask];

          dodist:
          for (;;) { // goto emulation
            op = here >>> 24/*here.bits*/;
            hold >>>= op;
            bits -= op;
            op = (here >>> 16) & 0xff/*here.op*/;

            if (op & 16) {                      /* distance base */
              dist = here & 0xffff/*here.val*/;
              op &= 15;                       /* number of extra bits */
              if (bits < op) {
                hold += input[_in++] << bits;
                bits += 8;
                if (bits < op) {
                  hold += input[_in++] << bits;
                  bits += 8;
                }
              }
              dist += hold & ((1 << op) - 1);
  //#ifdef INFLATE_STRICT
              if (dist > dmax) {
                strm.msg = 'invalid distance too far back';
                state.mode = BAD$1;
                break top;
              }
  //#endif
              hold >>>= op;
              bits -= op;
              //Tracevv((stderr, "inflate:         distance %u\n", dist));
              op = _out - beg;                /* max distance in output */
              if (dist > op) {                /* see if copy from window */
                op = dist - op;               /* distance back in window */
                if (op > whave) {
                  if (state.sane) {
                    strm.msg = 'invalid distance too far back';
                    state.mode = BAD$1;
                    break top;
                  }

  // (!) This block is disabled in zlib defaults,
  // don't enable it for binary compatibility
  //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
  //                if (len <= op - whave) {
  //                  do {
  //                    output[_out++] = 0;
  //                  } while (--len);
  //                  continue top;
  //                }
  //                len -= op - whave;
  //                do {
  //                  output[_out++] = 0;
  //                } while (--op > whave);
  //                if (op === 0) {
  //                  from = _out - dist;
  //                  do {
  //                    output[_out++] = output[from++];
  //                  } while (--len);
  //                  continue top;
  //                }
  //#endif
                }
                from = 0; // window index
                from_source = s_window;
                if (wnext === 0) {           /* very common case */
                  from += wsize - op;
                  if (op < len) {         /* some from window */
                    len -= op;
                    do {
                      output[_out++] = s_window[from++];
                    } while (--op);
                    from = _out - dist;  /* rest from output */
                    from_source = output;
                  }
                }
                else if (wnext < op) {      /* wrap around window */
                  from += wsize + wnext - op;
                  op -= wnext;
                  if (op < len) {         /* some from end of window */
                    len -= op;
                    do {
                      output[_out++] = s_window[from++];
                    } while (--op);
                    from = 0;
                    if (wnext < len) {  /* some from start of window */
                      op = wnext;
                      len -= op;
                      do {
                        output[_out++] = s_window[from++];
                      } while (--op);
                      from = _out - dist;      /* rest from output */
                      from_source = output;
                    }
                  }
                }
                else {                      /* contiguous in window */
                  from += wnext - op;
                  if (op < len) {         /* some from window */
                    len -= op;
                    do {
                      output[_out++] = s_window[from++];
                    } while (--op);
                    from = _out - dist;  /* rest from output */
                    from_source = output;
                  }
                }
                while (len > 2) {
                  output[_out++] = from_source[from++];
                  output[_out++] = from_source[from++];
                  output[_out++] = from_source[from++];
                  len -= 3;
                }
                if (len) {
                  output[_out++] = from_source[from++];
                  if (len > 1) {
                    output[_out++] = from_source[from++];
                  }
                }
              }
              else {
                from = _out - dist;          /* copy direct from output */
                do {                        /* minimum length is three */
                  output[_out++] = output[from++];
                  output[_out++] = output[from++];
                  output[_out++] = output[from++];
                  len -= 3;
                } while (len > 2);
                if (len) {
                  output[_out++] = output[from++];
                  if (len > 1) {
                    output[_out++] = output[from++];
                  }
                }
              }
            }
            else if ((op & 64) === 0) {          /* 2nd level distance code */
              here = dcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
              continue dodist;
            }
            else {
              strm.msg = 'invalid distance code';
              state.mode = BAD$1;
              break top;
            }

            break; // need to emulate goto via "continue"
          }
        }
        else if ((op & 64) === 0) {              /* 2nd level length code */
          here = lcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
          continue dolen;
        }
        else if (op & 32) {                     /* end-of-block */
          //Tracevv((stderr, "inflate:         end of block\n"));
          state.mode = TYPE$1;
          break top;
        }
        else {
          strm.msg = 'invalid literal/length code';
          state.mode = BAD$1;
          break top;
        }

        break; // need to emulate goto via "continue"
      }
    } while (_in < last && _out < end);

    /* return unused bytes (on entry, bits < 8, so in won't go too far back) */
    len = bits >> 3;
    _in -= len;
    bits -= len << 3;
    hold &= (1 << bits) - 1;

    /* update state and return */
    strm.next_in = _in;
    strm.next_out = _out;
    strm.avail_in = (_in < last ? 5 + (last - _in) : 5 - (_in - last));
    strm.avail_out = (_out < end ? 257 + (end - _out) : 257 - (_out - end));
    state.hold = hold;
    state.bits = bits;
    return;
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  const MAXBITS = 15;
  const ENOUGH_LENS$1 = 852;
  const ENOUGH_DISTS$1 = 592;
  //const ENOUGH = (ENOUGH_LENS+ENOUGH_DISTS);

  const CODES$1 = 0;
  const LENS$1 = 1;
  const DISTS$1 = 2;

  const lbase = new Uint16Array([ /* Length codes 257..285 base */
    3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
    35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0
  ]);

  const lext = new Uint8Array([ /* Length codes 257..285 extra */
    16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
    19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78
  ]);

  const dbase = new Uint16Array([ /* Distance codes 0..29 base */
    1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
    257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
    8193, 12289, 16385, 24577, 0, 0
  ]);

  const dext = new Uint8Array([ /* Distance codes 0..29 extra */
    16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
    23, 23, 24, 24, 25, 25, 26, 26, 27, 27,
    28, 28, 29, 29, 64, 64
  ]);

  const inflate_table = (type, lens, lens_index, codes, table, table_index, work, opts) =>
  {
    const bits = opts.bits;
        //here = opts.here; /* table entry for duplication */

    let len = 0;               /* a code's length in bits */
    let sym = 0;               /* index of code symbols */
    let min = 0, max = 0;          /* minimum and maximum code lengths */
    let root = 0;              /* number of index bits for root table */
    let curr = 0;              /* number of index bits for current table */
    let drop = 0;              /* code bits to drop for sub-table */
    let left = 0;                   /* number of prefix codes available */
    let used = 0;              /* code entries in table used */
    let huff = 0;              /* Huffman code */
    let incr;              /* for incrementing code, index */
    let fill;              /* index for replicating entries */
    let low;               /* low bits for current root entry */
    let mask;              /* mask for low root bits */
    let next;             /* next available space in table */
    let base = null;     /* base value table to use */
  //  let shoextra;    /* extra bits table to use */
    let match;                  /* use base and extra for symbol >= match */
    const count = new Uint16Array(MAXBITS + 1); //[MAXBITS+1];    /* number of codes of each length */
    const offs = new Uint16Array(MAXBITS + 1); //[MAXBITS+1];     /* offsets in table for each length */
    let extra = null;

    let here_bits, here_op, here_val;

    /*
     Process a set of code lengths to create a canonical Huffman code.  The
     code lengths are lens[0..codes-1].  Each length corresponds to the
     symbols 0..codes-1.  The Huffman code is generated by first sorting the
     symbols by length from short to long, and retaining the symbol order
     for codes with equal lengths.  Then the code starts with all zero bits
     for the first code of the shortest length, and the codes are integer
     increments for the same length, and zeros are appended as the length
     increases.  For the deflate format, these bits are stored backwards
     from their more natural integer increment ordering, and so when the
     decoding tables are built in the large loop below, the integer codes
     are incremented backwards.

     This routine assumes, but does not check, that all of the entries in
     lens[] are in the range 0..MAXBITS.  The caller must assure this.
     1..MAXBITS is interpreted as that code length.  zero means that that
     symbol does not occur in this code.

     The codes are sorted by computing a count of codes for each length,
     creating from that a table of starting indices for each length in the
     sorted table, and then entering the symbols in order in the sorted
     table.  The sorted table is work[], with that space being provided by
     the caller.

     The length counts are used for other purposes as well, i.e. finding
     the minimum and maximum length codes, determining if there are any
     codes at all, checking for a valid set of lengths, and looking ahead
     at length counts to determine sub-table sizes when building the
     decoding tables.
     */

    /* accumulate lengths for codes (assumes lens[] all in 0..MAXBITS) */
    for (len = 0; len <= MAXBITS; len++) {
      count[len] = 0;
    }
    for (sym = 0; sym < codes; sym++) {
      count[lens[lens_index + sym]]++;
    }

    /* bound code lengths, force root to be within code lengths */
    root = bits;
    for (max = MAXBITS; max >= 1; max--) {
      if (count[max] !== 0) { break; }
    }
    if (root > max) {
      root = max;
    }
    if (max === 0) {                     /* no symbols to code at all */
      //table.op[opts.table_index] = 64;  //here.op = (var char)64;    /* invalid code marker */
      //table.bits[opts.table_index] = 1;   //here.bits = (var char)1;
      //table.val[opts.table_index++] = 0;   //here.val = (var short)0;
      table[table_index++] = (1 << 24) | (64 << 16) | 0;


      //table.op[opts.table_index] = 64;
      //table.bits[opts.table_index] = 1;
      //table.val[opts.table_index++] = 0;
      table[table_index++] = (1 << 24) | (64 << 16) | 0;

      opts.bits = 1;
      return 0;     /* no symbols, but wait for decoding to report error */
    }
    for (min = 1; min < max; min++) {
      if (count[min] !== 0) { break; }
    }
    if (root < min) {
      root = min;
    }

    /* check for an over-subscribed or incomplete set of lengths */
    left = 1;
    for (len = 1; len <= MAXBITS; len++) {
      left <<= 1;
      left -= count[len];
      if (left < 0) {
        return -1;
      }        /* over-subscribed */
    }
    if (left > 0 && (type === CODES$1 || max !== 1)) {
      return -1;                      /* incomplete set */
    }

    /* generate offsets into symbol table for each length for sorting */
    offs[1] = 0;
    for (len = 1; len < MAXBITS; len++) {
      offs[len + 1] = offs[len] + count[len];
    }

    /* sort symbols by length, by symbol order within each length */
    for (sym = 0; sym < codes; sym++) {
      if (lens[lens_index + sym] !== 0) {
        work[offs[lens[lens_index + sym]]++] = sym;
      }
    }

    /*
     Create and fill in decoding tables.  In this loop, the table being
     filled is at next and has curr index bits.  The code being used is huff
     with length len.  That code is converted to an index by dropping drop
     bits off of the bottom.  For codes where len is less than drop + curr,
     those top drop + curr - len bits are incremented through all values to
     fill the table with replicated entries.

     root is the number of index bits for the root table.  When len exceeds
     root, sub-tables are created pointed to by the root entry with an index
     of the low root bits of huff.  This is saved in low to check for when a
     new sub-table should be started.  drop is zero when the root table is
     being filled, and drop is root when sub-tables are being filled.

     When a new sub-table is needed, it is necessary to look ahead in the
     code lengths to determine what size sub-table is needed.  The length
     counts are used for this, and so count[] is decremented as codes are
     entered in the tables.

     used keeps track of how many table entries have been allocated from the
     provided *table space.  It is checked for LENS and DIST tables against
     the constants ENOUGH_LENS and ENOUGH_DISTS to guard against changes in
     the initial root table size constants.  See the comments in inftrees.h
     for more information.

     sym increments through all symbols, and the loop terminates when
     all codes of length max, i.e. all codes, have been processed.  This
     routine permits incomplete codes, so another loop after this one fills
     in the rest of the decoding tables with invalid code markers.
     */

    /* set up for code type */
    // poor man optimization - use if-else instead of switch,
    // to avoid deopts in old v8
    if (type === CODES$1) {
      base = extra = work;    /* dummy value--not used */
      match = 20;

    } else if (type === LENS$1) {
      base = lbase;
      extra = lext;
      match = 257;

    } else {                    /* DISTS */
      base = dbase;
      extra = dext;
      match = 0;
    }

    /* initialize opts for loop */
    huff = 0;                   /* starting code */
    sym = 0;                    /* starting code symbol */
    len = min;                  /* starting code length */
    next = table_index;              /* current table to fill in */
    curr = root;                /* current table index bits */
    drop = 0;                   /* current bits to drop from code for index */
    low = -1;                   /* trigger new sub-table when len > root */
    used = 1 << root;          /* use root table entries */
    mask = used - 1;            /* mask for comparing low */

    /* check available table space */
    if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
      (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
      return 1;
    }

    /* process all codes and make table entries */
    for (;;) {
      /* create table entry */
      here_bits = len - drop;
      if (work[sym] + 1 < match) {
        here_op = 0;
        here_val = work[sym];
      }
      else if (work[sym] >= match) {
        here_op = extra[work[sym] - match];
        here_val = base[work[sym] - match];
      }
      else {
        here_op = 32 + 64;         /* end of block */
        here_val = 0;
      }

      /* replicate for those indices with low len bits equal to huff */
      incr = 1 << (len - drop);
      fill = 1 << curr;
      min = fill;                 /* save offset to next table */
      do {
        fill -= incr;
        table[next + (huff >> drop) + fill] = (here_bits << 24) | (here_op << 16) | here_val |0;
      } while (fill !== 0);

      /* backwards increment the len-bit code huff */
      incr = 1 << (len - 1);
      while (huff & incr) {
        incr >>= 1;
      }
      if (incr !== 0) {
        huff &= incr - 1;
        huff += incr;
      } else {
        huff = 0;
      }

      /* go to next symbol, update count, len */
      sym++;
      if (--count[len] === 0) {
        if (len === max) { break; }
        len = lens[lens_index + work[sym]];
      }

      /* create new sub-table if needed */
      if (len > root && (huff & mask) !== low) {
        /* if first time, transition to sub-tables */
        if (drop === 0) {
          drop = root;
        }

        /* increment past last table */
        next += min;            /* here min is 1 << curr */

        /* determine length of next table */
        curr = len - drop;
        left = 1 << curr;
        while (curr + drop < max) {
          left -= count[curr + drop];
          if (left <= 0) { break; }
          curr++;
          left <<= 1;
        }

        /* check for enough space */
        used += 1 << curr;
        if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
          (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
          return 1;
        }

        /* point entry in root table to sub-table */
        low = huff & mask;
        /*table.op[low] = curr;
        table.bits[low] = root;
        table.val[low] = next - opts.table_index;*/
        table[low] = (root << 24) | (curr << 16) | (next - table_index) |0;
      }
    }

    /* fill in remaining table entry if code is incomplete (guaranteed to have
     at most one remaining entry, since if the code is incomplete, the
     maximum code length that was allowed to get this far is one bit) */
    if (huff !== 0) {
      //table.op[next + huff] = 64;            /* invalid code marker */
      //table.bits[next + huff] = len - drop;
      //table.val[next + huff] = 0;
      table[next + huff] = ((len - drop) << 24) | (64 << 16) |0;
    }

    /* set return parameters */
    //opts.table_index += used;
    opts.bits = root;
    return 0;
  };


  var inftrees = inflate_table;

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.






  const CODES = 0;
  const LENS = 1;
  const DISTS = 2;

  /* Public constants ==========================================================*/
  /* ===========================================================================*/

  const {
    Z_FINISH: Z_FINISH$1, Z_BLOCK, Z_TREES,
    Z_OK: Z_OK$1, Z_STREAM_END: Z_STREAM_END$1, Z_NEED_DICT: Z_NEED_DICT$1, Z_STREAM_ERROR: Z_STREAM_ERROR$1, Z_DATA_ERROR: Z_DATA_ERROR$1, Z_MEM_ERROR: Z_MEM_ERROR$1, Z_BUF_ERROR,
    Z_DEFLATED
  } = constants$2;


  /* STATES ====================================================================*/
  /* ===========================================================================*/


  const    HEAD = 16180;       /* i: waiting for magic header */
  const    FLAGS = 16181;      /* i: waiting for method and flags (gzip) */
  const    TIME = 16182;       /* i: waiting for modification time (gzip) */
  const    OS = 16183;         /* i: waiting for extra flags and operating system (gzip) */
  const    EXLEN = 16184;      /* i: waiting for extra length (gzip) */
  const    EXTRA = 16185;      /* i: waiting for extra bytes (gzip) */
  const    NAME = 16186;       /* i: waiting for end of file name (gzip) */
  const    COMMENT = 16187;    /* i: waiting for end of comment (gzip) */
  const    HCRC = 16188;       /* i: waiting for header crc (gzip) */
  const    DICTID = 16189;    /* i: waiting for dictionary check value */
  const    DICT = 16190;      /* waiting for inflateSetDictionary() call */
  const        TYPE = 16191;      /* i: waiting for type bits, including last-flag bit */
  const        TYPEDO = 16192;    /* i: same, but skip check to exit inflate on new block */
  const        STORED = 16193;    /* i: waiting for stored size (length and complement) */
  const        COPY_ = 16194;     /* i/o: same as COPY below, but only first time in */
  const        COPY = 16195;      /* i/o: waiting for input or output to copy stored block */
  const        TABLE = 16196;     /* i: waiting for dynamic block table lengths */
  const        LENLENS = 16197;   /* i: waiting for code length code lengths */
  const        CODELENS = 16198;  /* i: waiting for length/lit and distance code lengths */
  const            LEN_ = 16199;      /* i: same as LEN below, but only first time in */
  const            LEN = 16200;       /* i: waiting for length/lit/eob code */
  const            LENEXT = 16201;    /* i: waiting for length extra bits */
  const            DIST = 16202;      /* i: waiting for distance code */
  const            DISTEXT = 16203;   /* i: waiting for distance extra bits */
  const            MATCH = 16204;     /* o: waiting for output space to copy string */
  const            LIT = 16205;       /* o: waiting for output space to write literal */
  const    CHECK = 16206;     /* i: waiting for 32-bit check value */
  const    LENGTH = 16207;    /* i: waiting for 32-bit length (gzip) */
  const    DONE = 16208;      /* finished check, done -- remain here until reset */
  const    BAD = 16209;       /* got a data error -- remain here until reset */
  const    MEM = 16210;       /* got an inflate() memory error -- remain here until reset */
  const    SYNC = 16211;      /* looking for synchronization bytes to restart inflate() */

  /* ===========================================================================*/



  const ENOUGH_LENS = 852;
  const ENOUGH_DISTS = 592;
  //const ENOUGH =  (ENOUGH_LENS+ENOUGH_DISTS);

  const MAX_WBITS = 15;
  /* 32K LZ77 window */
  const DEF_WBITS = MAX_WBITS;


  const zswap32 = (q) => {

    return  (((q >>> 24) & 0xff) +
            ((q >>> 8) & 0xff00) +
            ((q & 0xff00) << 8) +
            ((q & 0xff) << 24));
  };


  function InflateState() {
    this.strm = null;           /* pointer back to this zlib stream */
    this.mode = 0;              /* current inflate mode */
    this.last = false;          /* true if processing last block */
    this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip,
                                   bit 2 true to validate check value */
    this.havedict = false;      /* true if dictionary provided */
    this.flags = 0;             /* gzip header method and flags (0 if zlib), or
                                   -1 if raw or no header yet */
    this.dmax = 0;              /* zlib header max distance (INFLATE_STRICT) */
    this.check = 0;             /* protected copy of check value */
    this.total = 0;             /* protected copy of output count */
    // TODO: may be {}
    this.head = null;           /* where to save gzip header information */

    /* sliding window */
    this.wbits = 0;             /* log base 2 of requested window size */
    this.wsize = 0;             /* window size or zero if not using window */
    this.whave = 0;             /* valid bytes in the window */
    this.wnext = 0;             /* window write index */
    this.window = null;         /* allocated sliding window, if needed */

    /* bit accumulator */
    this.hold = 0;              /* input bit accumulator */
    this.bits = 0;              /* number of bits in "in" */

    /* for string and stored block copying */
    this.length = 0;            /* literal or length of data to copy */
    this.offset = 0;            /* distance back to copy string from */

    /* for table and code decoding */
    this.extra = 0;             /* extra bits needed */

    /* fixed and dynamic code tables */
    this.lencode = null;          /* starting table for length/literal codes */
    this.distcode = null;         /* starting table for distance codes */
    this.lenbits = 0;           /* index bits for lencode */
    this.distbits = 0;          /* index bits for distcode */

    /* dynamic table building */
    this.ncode = 0;             /* number of code length code lengths */
    this.nlen = 0;              /* number of length code lengths */
    this.ndist = 0;             /* number of distance code lengths */
    this.have = 0;              /* number of code lengths in lens[] */
    this.next = null;              /* next available space in codes[] */

    this.lens = new Uint16Array(320); /* temporary storage for code lengths */
    this.work = new Uint16Array(288); /* work area for code table building */

    /*
     because we don't have pointers in js, we use lencode and distcode directly
     as buffers so we don't need codes
    */
    //this.codes = new Int32Array(ENOUGH);       /* space for code tables */
    this.lendyn = null;              /* dynamic table for length/literal codes (JS specific) */
    this.distdyn = null;             /* dynamic table for distance codes (JS specific) */
    this.sane = 0;                   /* if false, allow invalid distance too far */
    this.back = 0;                   /* bits back of last unprocessed length/lit */
    this.was = 0;                    /* initial length of match */
  }


  const inflateStateCheck = (strm) => {

    if (!strm) {
      return 1;
    }
    const state = strm.state;
    if (!state || state.strm !== strm ||
      state.mode < HEAD || state.mode > SYNC) {
      return 1;
    }
    return 0;
  };


  const inflateResetKeep = (strm) => {

    if (inflateStateCheck(strm)) { return Z_STREAM_ERROR$1; }
    const state = strm.state;
    strm.total_in = strm.total_out = state.total = 0;
    strm.msg = ''; /*Z_NULL*/
    if (state.wrap) {       /* to support ill-conceived Java test suite */
      strm.adler = state.wrap & 1;
    }
    state.mode = HEAD;
    state.last = 0;
    state.havedict = 0;
    state.flags = -1;
    state.dmax = 32768;
    state.head = null/*Z_NULL*/;
    state.hold = 0;
    state.bits = 0;
    //state.lencode = state.distcode = state.next = state.codes;
    state.lencode = state.lendyn = new Int32Array(ENOUGH_LENS);
    state.distcode = state.distdyn = new Int32Array(ENOUGH_DISTS);

    state.sane = 1;
    state.back = -1;
    //Tracev((stderr, "inflate: reset\n"));
    return Z_OK$1;
  };


  const inflateReset = (strm) => {

    if (inflateStateCheck(strm)) { return Z_STREAM_ERROR$1; }
    const state = strm.state;
    state.wsize = 0;
    state.whave = 0;
    state.wnext = 0;
    return inflateResetKeep(strm);

  };


  const inflateReset2 = (strm, windowBits) => {
    let wrap;

    /* get the state */
    if (inflateStateCheck(strm)) { return Z_STREAM_ERROR$1; }
    const state = strm.state;

    /* extract wrap request from windowBits parameter */
    if (windowBits < 0) {
      wrap = 0;
      windowBits = -windowBits;
    }
    else {
      wrap = (windowBits >> 4) + 5;
      if (windowBits < 48) {
        windowBits &= 15;
      }
    }

    /* set number of window bits, free window if different */
    if (windowBits && (windowBits < 8 || windowBits > 15)) {
      return Z_STREAM_ERROR$1;
    }
    if (state.window !== null && state.wbits !== windowBits) {
      state.window = null;
    }

    /* update state and reset the rest of it */
    state.wrap = wrap;
    state.wbits = windowBits;
    return inflateReset(strm);
  };


  const inflateInit2 = (strm, windowBits) => {

    if (!strm) { return Z_STREAM_ERROR$1; }
    //strm.msg = Z_NULL;                 /* in case we return an error */

    const state = new InflateState();

    //if (state === Z_NULL) return Z_MEM_ERROR;
    //Tracev((stderr, "inflate: allocated\n"));
    strm.state = state;
    state.strm = strm;
    state.window = null/*Z_NULL*/;
    state.mode = HEAD;     /* to pass state test in inflateReset2() */
    const ret = inflateReset2(strm, windowBits);
    if (ret !== Z_OK$1) {
      strm.state = null/*Z_NULL*/;
    }
    return ret;
  };


  const inflateInit = (strm) => {

    return inflateInit2(strm, DEF_WBITS);
  };


  /*
   Return state with length and distance decoding tables and index sizes set to
   fixed code decoding.  Normally this returns fixed tables from inffixed.h.
   If BUILDFIXED is defined, then instead this routine builds the tables the
   first time it's called, and returns those tables the first time and
   thereafter.  This reduces the size of the code by about 2K bytes, in
   exchange for a little execution time.  However, BUILDFIXED should not be
   used for threaded applications, since the rewriting of the tables and virgin
   may not be thread-safe.
   */
  let virgin = true;

  let lenfix, distfix; // We have no pointers in JS, so keep tables separate


  const fixedtables = (state) => {

    /* build fixed huffman tables if first call (may not be thread safe) */
    if (virgin) {
      lenfix = new Int32Array(512);
      distfix = new Int32Array(32);

      /* literal/length table */
      let sym = 0;
      while (sym < 144) { state.lens[sym++] = 8; }
      while (sym < 256) { state.lens[sym++] = 9; }
      while (sym < 280) { state.lens[sym++] = 7; }
      while (sym < 288) { state.lens[sym++] = 8; }

      inftrees(LENS,  state.lens, 0, 288, lenfix,   0, state.work, { bits: 9 });

      /* distance table */
      sym = 0;
      while (sym < 32) { state.lens[sym++] = 5; }

      inftrees(DISTS, state.lens, 0, 32,   distfix, 0, state.work, { bits: 5 });

      /* do this just once */
      virgin = false;
    }

    state.lencode = lenfix;
    state.lenbits = 9;
    state.distcode = distfix;
    state.distbits = 5;
  };


  /*
   Update the window with the last wsize (normally 32K) bytes written before
   returning.  If window does not exist yet, create it.  This is only called
   when a window is already in use, or when output has been written during this
   inflate call, but the end of the deflate stream has not been reached yet.
   It is also called to create a window for dictionary data when a dictionary
   is loaded.

   Providing output buffers larger than 32K to inflate() should provide a speed
   advantage, since only the last 32K of output is copied to the sliding window
   upon return from inflate(), and since all distances after the first 32K of
   output will fall in the output data, making match copies simpler and faster.
   The advantage may be dependent on the size of the processor's data caches.
   */
  const updatewindow = (strm, src, end, copy) => {

    let dist;
    const state = strm.state;

    /* if it hasn't been done already, allocate space for the window */
    if (state.window === null) {
      state.wsize = 1 << state.wbits;
      state.wnext = 0;
      state.whave = 0;

      state.window = new Uint8Array(state.wsize);
    }

    /* copy state->wsize or less output bytes into the circular window */
    if (copy >= state.wsize) {
      state.window.set(src.subarray(end - state.wsize, end), 0);
      state.wnext = 0;
      state.whave = state.wsize;
    }
    else {
      dist = state.wsize - state.wnext;
      if (dist > copy) {
        dist = copy;
      }
      //zmemcpy(state->window + state->wnext, end - copy, dist);
      state.window.set(src.subarray(end - copy, end - copy + dist), state.wnext);
      copy -= dist;
      if (copy) {
        //zmemcpy(state->window, end - copy, copy);
        state.window.set(src.subarray(end - copy, end), 0);
        state.wnext = copy;
        state.whave = state.wsize;
      }
      else {
        state.wnext += dist;
        if (state.wnext === state.wsize) { state.wnext = 0; }
        if (state.whave < state.wsize) { state.whave += dist; }
      }
    }
    return 0;
  };


  const inflate$2 = (strm, flush) => {

    let state;
    let input, output;          // input/output buffers
    let next;                   /* next input INDEX */
    let put;                    /* next output INDEX */
    let have, left;             /* available input and output */
    let hold;                   /* bit buffer */
    let bits;                   /* bits in bit buffer */
    let _in, _out;              /* save starting available input and output */
    let copy;                   /* number of stored or match bytes to copy */
    let from;                   /* where to copy match bytes from */
    let from_source;
    let here = 0;               /* current decoding table entry */
    let here_bits, here_op, here_val; // paked "here" denormalized (JS specific)
    //let last;                   /* parent table entry */
    let last_bits, last_op, last_val; // paked "last" denormalized (JS specific)
    let len;                    /* length to copy for repeats, bits to drop */
    let ret;                    /* return code */
    const hbuf = new Uint8Array(4);    /* buffer for gzip header crc calculation */
    let opts;

    let n; // temporary variable for NEED_BITS

    const order = /* permutation of code lengths */
      new Uint8Array([ 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15 ]);


    if (inflateStateCheck(strm) || !strm.output ||
        (!strm.input && strm.avail_in !== 0)) {
      return Z_STREAM_ERROR$1;
    }

    state = strm.state;
    if (state.mode === TYPE) { state.mode = TYPEDO; }    /* skip check */


    //--- LOAD() ---
    put = strm.next_out;
    output = strm.output;
    left = strm.avail_out;
    next = strm.next_in;
    input = strm.input;
    have = strm.avail_in;
    hold = state.hold;
    bits = state.bits;
    //---

    _in = have;
    _out = left;
    ret = Z_OK$1;

    inf_leave: // goto emulation
    for (;;) {
      switch (state.mode) {
        case HEAD:
          if (state.wrap === 0) {
            state.mode = TYPEDO;
            break;
          }
          //=== NEEDBITS(16);
          while (bits < 16) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if ((state.wrap & 2) && hold === 0x8b1f) {  /* gzip header */
            if (state.wbits === 0) {
              state.wbits = 15;
            }
            state.check = 0/*crc32(0L, Z_NULL, 0)*/;
            //=== CRC2(state.check, hold);
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            state.check = crc32_1(state.check, hbuf, 2, 0);
            //===//

            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = FLAGS;
            break;
          }
          if (state.head) {
            state.head.done = false;
          }
          if (!(state.wrap & 1) ||   /* check if zlib header allowed */
            (((hold & 0xff)/*BITS(8)*/ << 8) + (hold >> 8)) % 31) {
            strm.msg = 'incorrect header check';
            state.mode = BAD;
            break;
          }
          if ((hold & 0x0f)/*BITS(4)*/ !== Z_DEFLATED) {
            strm.msg = 'unknown compression method';
            state.mode = BAD;
            break;
          }
          //--- DROPBITS(4) ---//
          hold >>>= 4;
          bits -= 4;
          //---//
          len = (hold & 0x0f)/*BITS(4)*/ + 8;
          if (state.wbits === 0) {
            state.wbits = len;
          }
          if (len > 15 || len > state.wbits) {
            strm.msg = 'invalid window size';
            state.mode = BAD;
            break;
          }

          // !!! pako patch. Force use `options.windowBits` if passed.
          // Required to always use max window size by default.
          state.dmax = 1 << state.wbits;
          //state.dmax = 1 << len;

          state.flags = 0;               /* indicate zlib header */
          //Tracev((stderr, "inflate:   zlib header ok\n"));
          strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
          state.mode = hold & 0x200 ? DICTID : TYPE;
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          break;
        case FLAGS:
          //=== NEEDBITS(16); */
          while (bits < 16) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.flags = hold;
          if ((state.flags & 0xff) !== Z_DEFLATED) {
            strm.msg = 'unknown compression method';
            state.mode = BAD;
            break;
          }
          if (state.flags & 0xe000) {
            strm.msg = 'unknown header flags set';
            state.mode = BAD;
            break;
          }
          if (state.head) {
            state.head.text = ((hold >> 8) & 1);
          }
          if ((state.flags & 0x0200) && (state.wrap & 4)) {
            //=== CRC2(state.check, hold);
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            state.check = crc32_1(state.check, hbuf, 2, 0);
            //===//
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = TIME;
          /* falls through */
        case TIME:
          //=== NEEDBITS(32); */
          while (bits < 32) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if (state.head) {
            state.head.time = hold;
          }
          if ((state.flags & 0x0200) && (state.wrap & 4)) {
            //=== CRC4(state.check, hold)
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            hbuf[2] = (hold >>> 16) & 0xff;
            hbuf[3] = (hold >>> 24) & 0xff;
            state.check = crc32_1(state.check, hbuf, 4, 0);
            //===
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = OS;
          /* falls through */
        case OS:
          //=== NEEDBITS(16); */
          while (bits < 16) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if (state.head) {
            state.head.xflags = (hold & 0xff);
            state.head.os = (hold >> 8);
          }
          if ((state.flags & 0x0200) && (state.wrap & 4)) {
            //=== CRC2(state.check, hold);
            hbuf[0] = hold & 0xff;
            hbuf[1] = (hold >>> 8) & 0xff;
            state.check = crc32_1(state.check, hbuf, 2, 0);
            //===//
          }
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = EXLEN;
          /* falls through */
        case EXLEN:
          if (state.flags & 0x0400) {
            //=== NEEDBITS(16); */
            while (bits < 16) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.length = hold;
            if (state.head) {
              state.head.extra_len = hold;
            }
            if ((state.flags & 0x0200) && (state.wrap & 4)) {
              //=== CRC2(state.check, hold);
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              state.check = crc32_1(state.check, hbuf, 2, 0);
              //===//
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
          }
          else if (state.head) {
            state.head.extra = null/*Z_NULL*/;
          }
          state.mode = EXTRA;
          /* falls through */
        case EXTRA:
          if (state.flags & 0x0400) {
            copy = state.length;
            if (copy > have) { copy = have; }
            if (copy) {
              if (state.head) {
                len = state.head.extra_len - state.length;
                if (!state.head.extra) {
                  // Use untyped array for more convenient processing later
                  state.head.extra = new Uint8Array(state.head.extra_len);
                }
                state.head.extra.set(
                  input.subarray(
                    next,
                    // extra field is limited to 65536 bytes
                    // - no need for additional size check
                    next + copy
                  ),
                  /*len + copy > state.head.extra_max - len ? state.head.extra_max : copy,*/
                  len
                );
                //zmemcpy(state.head.extra + len, next,
                //        len + copy > state.head.extra_max ?
                //        state.head.extra_max - len : copy);
              }
              if ((state.flags & 0x0200) && (state.wrap & 4)) {
                state.check = crc32_1(state.check, input, copy, next);
              }
              have -= copy;
              next += copy;
              state.length -= copy;
            }
            if (state.length) { break inf_leave; }
          }
          state.length = 0;
          state.mode = NAME;
          /* falls through */
        case NAME:
          if (state.flags & 0x0800) {
            if (have === 0) { break inf_leave; }
            copy = 0;
            do {
              // TODO: 2 or 1 bytes?
              len = input[next + copy++];
              /* use constant limit because in js we should not preallocate memory */
              if (state.head && len &&
                  (state.length < 65536 /*state.head.name_max*/)) {
                state.head.name += String.fromCharCode(len);
              }
            } while (len && copy < have);

            if ((state.flags & 0x0200) && (state.wrap & 4)) {
              state.check = crc32_1(state.check, input, copy, next);
            }
            have -= copy;
            next += copy;
            if (len) { break inf_leave; }
          }
          else if (state.head) {
            state.head.name = null;
          }
          state.length = 0;
          state.mode = COMMENT;
          /* falls through */
        case COMMENT:
          if (state.flags & 0x1000) {
            if (have === 0) { break inf_leave; }
            copy = 0;
            do {
              len = input[next + copy++];
              /* use constant limit because in js we should not preallocate memory */
              if (state.head && len &&
                  (state.length < 65536 /*state.head.comm_max*/)) {
                state.head.comment += String.fromCharCode(len);
              }
            } while (len && copy < have);
            if ((state.flags & 0x0200) && (state.wrap & 4)) {
              state.check = crc32_1(state.check, input, copy, next);
            }
            have -= copy;
            next += copy;
            if (len) { break inf_leave; }
          }
          else if (state.head) {
            state.head.comment = null;
          }
          state.mode = HCRC;
          /* falls through */
        case HCRC:
          if (state.flags & 0x0200) {
            //=== NEEDBITS(16); */
            while (bits < 16) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if ((state.wrap & 4) && hold !== (state.check & 0xffff)) {
              strm.msg = 'header crc mismatch';
              state.mode = BAD;
              break;
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
          }
          if (state.head) {
            state.head.hcrc = ((state.flags >> 9) & 1);
            state.head.done = true;
          }
          strm.adler = state.check = 0;
          state.mode = TYPE;
          break;
        case DICTID:
          //=== NEEDBITS(32); */
          while (bits < 32) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          strm.adler = state.check = zswap32(hold);
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = DICT;
          /* falls through */
        case DICT:
          if (state.havedict === 0) {
            //--- RESTORE() ---
            strm.next_out = put;
            strm.avail_out = left;
            strm.next_in = next;
            strm.avail_in = have;
            state.hold = hold;
            state.bits = bits;
            //---
            return Z_NEED_DICT$1;
          }
          strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
          state.mode = TYPE;
          /* falls through */
        case TYPE:
          if (flush === Z_BLOCK || flush === Z_TREES) { break inf_leave; }
          /* falls through */
        case TYPEDO:
          if (state.last) {
            //--- BYTEBITS() ---//
            hold >>>= bits & 7;
            bits -= bits & 7;
            //---//
            state.mode = CHECK;
            break;
          }
          //=== NEEDBITS(3); */
          while (bits < 3) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.last = (hold & 0x01)/*BITS(1)*/;
          //--- DROPBITS(1) ---//
          hold >>>= 1;
          bits -= 1;
          //---//

          switch ((hold & 0x03)/*BITS(2)*/) {
            case 0:                             /* stored block */
              //Tracev((stderr, "inflate:     stored block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = STORED;
              break;
            case 1:                             /* fixed block */
              fixedtables(state);
              //Tracev((stderr, "inflate:     fixed codes block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = LEN_;             /* decode codes */
              if (flush === Z_TREES) {
                //--- DROPBITS(2) ---//
                hold >>>= 2;
                bits -= 2;
                //---//
                break inf_leave;
              }
              break;
            case 2:                             /* dynamic block */
              //Tracev((stderr, "inflate:     dynamic codes block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = TABLE;
              break;
            case 3:
              strm.msg = 'invalid block type';
              state.mode = BAD;
          }
          //--- DROPBITS(2) ---//
          hold >>>= 2;
          bits -= 2;
          //---//
          break;
        case STORED:
          //--- BYTEBITS() ---// /* go to byte boundary */
          hold >>>= bits & 7;
          bits -= bits & 7;
          //---//
          //=== NEEDBITS(32); */
          while (bits < 32) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          if ((hold & 0xffff) !== ((hold >>> 16) ^ 0xffff)) {
            strm.msg = 'invalid stored block lengths';
            state.mode = BAD;
            break;
          }
          state.length = hold & 0xffff;
          //Tracev((stderr, "inflate:       stored length %u\n",
          //        state.length));
          //=== INITBITS();
          hold = 0;
          bits = 0;
          //===//
          state.mode = COPY_;
          if (flush === Z_TREES) { break inf_leave; }
          /* falls through */
        case COPY_:
          state.mode = COPY;
          /* falls through */
        case COPY:
          copy = state.length;
          if (copy) {
            if (copy > have) { copy = have; }
            if (copy > left) { copy = left; }
            if (copy === 0) { break inf_leave; }
            //--- zmemcpy(put, next, copy); ---
            output.set(input.subarray(next, next + copy), put);
            //---//
            have -= copy;
            next += copy;
            left -= copy;
            put += copy;
            state.length -= copy;
            break;
          }
          //Tracev((stderr, "inflate:       stored end\n"));
          state.mode = TYPE;
          break;
        case TABLE:
          //=== NEEDBITS(14); */
          while (bits < 14) {
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
          }
          //===//
          state.nlen = (hold & 0x1f)/*BITS(5)*/ + 257;
          //--- DROPBITS(5) ---//
          hold >>>= 5;
          bits -= 5;
          //---//
          state.ndist = (hold & 0x1f)/*BITS(5)*/ + 1;
          //--- DROPBITS(5) ---//
          hold >>>= 5;
          bits -= 5;
          //---//
          state.ncode = (hold & 0x0f)/*BITS(4)*/ + 4;
          //--- DROPBITS(4) ---//
          hold >>>= 4;
          bits -= 4;
          //---//
  //#ifndef PKZIP_BUG_WORKAROUND
          if (state.nlen > 286 || state.ndist > 30) {
            strm.msg = 'too many length or distance symbols';
            state.mode = BAD;
            break;
          }
  //#endif
          //Tracev((stderr, "inflate:       table sizes ok\n"));
          state.have = 0;
          state.mode = LENLENS;
          /* falls through */
        case LENLENS:
          while (state.have < state.ncode) {
            //=== NEEDBITS(3);
            while (bits < 3) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.lens[order[state.have++]] = (hold & 0x07);//BITS(3);
            //--- DROPBITS(3) ---//
            hold >>>= 3;
            bits -= 3;
            //---//
          }
          while (state.have < 19) {
            state.lens[order[state.have++]] = 0;
          }
          // We have separate tables & no pointers. 2 commented lines below not needed.
          //state.next = state.codes;
          //state.lencode = state.next;
          // Switch to use dynamic table
          state.lencode = state.lendyn;
          state.lenbits = 7;

          opts = { bits: state.lenbits };
          ret = inftrees(CODES, state.lens, 0, 19, state.lencode, 0, state.work, opts);
          state.lenbits = opts.bits;

          if (ret) {
            strm.msg = 'invalid code lengths set';
            state.mode = BAD;
            break;
          }
          //Tracev((stderr, "inflate:       code lengths ok\n"));
          state.have = 0;
          state.mode = CODELENS;
          /* falls through */
        case CODELENS:
          while (state.have < state.nlen + state.ndist) {
            for (;;) {
              here = state.lencode[hold & ((1 << state.lenbits) - 1)];/*BITS(state.lenbits)*/
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if ((here_bits) <= bits) { break; }
              //--- PULLBYTE() ---//
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            if (here_val < 16) {
              //--- DROPBITS(here.bits) ---//
              hold >>>= here_bits;
              bits -= here_bits;
              //---//
              state.lens[state.have++] = here_val;
            }
            else {
              if (here_val === 16) {
                //=== NEEDBITS(here.bits + 2);
                n = here_bits + 2;
                while (bits < n) {
                  if (have === 0) { break inf_leave; }
                  have--;
                  hold += input[next++] << bits;
                  bits += 8;
                }
                //===//
                //--- DROPBITS(here.bits) ---//
                hold >>>= here_bits;
                bits -= here_bits;
                //---//
                if (state.have === 0) {
                  strm.msg = 'invalid bit length repeat';
                  state.mode = BAD;
                  break;
                }
                len = state.lens[state.have - 1];
                copy = 3 + (hold & 0x03);//BITS(2);
                //--- DROPBITS(2) ---//
                hold >>>= 2;
                bits -= 2;
                //---//
              }
              else if (here_val === 17) {
                //=== NEEDBITS(here.bits + 3);
                n = here_bits + 3;
                while (bits < n) {
                  if (have === 0) { break inf_leave; }
                  have--;
                  hold += input[next++] << bits;
                  bits += 8;
                }
                //===//
                //--- DROPBITS(here.bits) ---//
                hold >>>= here_bits;
                bits -= here_bits;
                //---//
                len = 0;
                copy = 3 + (hold & 0x07);//BITS(3);
                //--- DROPBITS(3) ---//
                hold >>>= 3;
                bits -= 3;
                //---//
              }
              else {
                //=== NEEDBITS(here.bits + 7);
                n = here_bits + 7;
                while (bits < n) {
                  if (have === 0) { break inf_leave; }
                  have--;
                  hold += input[next++] << bits;
                  bits += 8;
                }
                //===//
                //--- DROPBITS(here.bits) ---//
                hold >>>= here_bits;
                bits -= here_bits;
                //---//
                len = 0;
                copy = 11 + (hold & 0x7f);//BITS(7);
                //--- DROPBITS(7) ---//
                hold >>>= 7;
                bits -= 7;
                //---//
              }
              if (state.have + copy > state.nlen + state.ndist) {
                strm.msg = 'invalid bit length repeat';
                state.mode = BAD;
                break;
              }
              while (copy--) {
                state.lens[state.have++] = len;
              }
            }
          }

          /* handle error breaks in while */
          if (state.mode === BAD) { break; }

          /* check for end-of-block code (better have one) */
          if (state.lens[256] === 0) {
            strm.msg = 'invalid code -- missing end-of-block';
            state.mode = BAD;
            break;
          }

          /* build code tables -- note: do not change the lenbits or distbits
             values here (9 and 6) without reading the comments in inftrees.h
             concerning the ENOUGH constants, which depend on those values */
          state.lenbits = 9;

          opts = { bits: state.lenbits };
          ret = inftrees(LENS, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
          // We have separate tables & no pointers. 2 commented lines below not needed.
          // state.next_index = opts.table_index;
          state.lenbits = opts.bits;
          // state.lencode = state.next;

          if (ret) {
            strm.msg = 'invalid literal/lengths set';
            state.mode = BAD;
            break;
          }

          state.distbits = 6;
          //state.distcode.copy(state.codes);
          // Switch to use dynamic table
          state.distcode = state.distdyn;
          opts = { bits: state.distbits };
          ret = inftrees(DISTS, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
          // We have separate tables & no pointers. 2 commented lines below not needed.
          // state.next_index = opts.table_index;
          state.distbits = opts.bits;
          // state.distcode = state.next;

          if (ret) {
            strm.msg = 'invalid distances set';
            state.mode = BAD;
            break;
          }
          //Tracev((stderr, 'inflate:       codes ok\n'));
          state.mode = LEN_;
          if (flush === Z_TREES) { break inf_leave; }
          /* falls through */
        case LEN_:
          state.mode = LEN;
          /* falls through */
        case LEN:
          if (have >= 6 && left >= 258) {
            //--- RESTORE() ---
            strm.next_out = put;
            strm.avail_out = left;
            strm.next_in = next;
            strm.avail_in = have;
            state.hold = hold;
            state.bits = bits;
            //---
            inffast(strm, _out);
            //--- LOAD() ---
            put = strm.next_out;
            output = strm.output;
            left = strm.avail_out;
            next = strm.next_in;
            input = strm.input;
            have = strm.avail_in;
            hold = state.hold;
            bits = state.bits;
            //---

            if (state.mode === TYPE) {
              state.back = -1;
            }
            break;
          }
          state.back = 0;
          for (;;) {
            here = state.lencode[hold & ((1 << state.lenbits) - 1)];  /*BITS(state.lenbits)*/
            here_bits = here >>> 24;
            here_op = (here >>> 16) & 0xff;
            here_val = here & 0xffff;

            if (here_bits <= bits) { break; }
            //--- PULLBYTE() ---//
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
            //---//
          }
          if (here_op && (here_op & 0xf0) === 0) {
            last_bits = here_bits;
            last_op = here_op;
            last_val = here_val;
            for (;;) {
              here = state.lencode[last_val +
                      ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if ((last_bits + here_bits) <= bits) { break; }
              //--- PULLBYTE() ---//
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            //--- DROPBITS(last.bits) ---//
            hold >>>= last_bits;
            bits -= last_bits;
            //---//
            state.back += last_bits;
          }
          //--- DROPBITS(here.bits) ---//
          hold >>>= here_bits;
          bits -= here_bits;
          //---//
          state.back += here_bits;
          state.length = here_val;
          if (here_op === 0) {
            //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
            //        "inflate:         literal '%c'\n" :
            //        "inflate:         literal 0x%02x\n", here.val));
            state.mode = LIT;
            break;
          }
          if (here_op & 32) {
            //Tracevv((stderr, "inflate:         end of block\n"));
            state.back = -1;
            state.mode = TYPE;
            break;
          }
          if (here_op & 64) {
            strm.msg = 'invalid literal/length code';
            state.mode = BAD;
            break;
          }
          state.extra = here_op & 15;
          state.mode = LENEXT;
          /* falls through */
        case LENEXT:
          if (state.extra) {
            //=== NEEDBITS(state.extra);
            n = state.extra;
            while (bits < n) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.length += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
            //--- DROPBITS(state.extra) ---//
            hold >>>= state.extra;
            bits -= state.extra;
            //---//
            state.back += state.extra;
          }
          //Tracevv((stderr, "inflate:         length %u\n", state.length));
          state.was = state.length;
          state.mode = DIST;
          /* falls through */
        case DIST:
          for (;;) {
            here = state.distcode[hold & ((1 << state.distbits) - 1)];/*BITS(state.distbits)*/
            here_bits = here >>> 24;
            here_op = (here >>> 16) & 0xff;
            here_val = here & 0xffff;

            if ((here_bits) <= bits) { break; }
            //--- PULLBYTE() ---//
            if (have === 0) { break inf_leave; }
            have--;
            hold += input[next++] << bits;
            bits += 8;
            //---//
          }
          if ((here_op & 0xf0) === 0) {
            last_bits = here_bits;
            last_op = here_op;
            last_val = here_val;
            for (;;) {
              here = state.distcode[last_val +
                      ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if ((last_bits + here_bits) <= bits) { break; }
              //--- PULLBYTE() ---//
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            //--- DROPBITS(last.bits) ---//
            hold >>>= last_bits;
            bits -= last_bits;
            //---//
            state.back += last_bits;
          }
          //--- DROPBITS(here.bits) ---//
          hold >>>= here_bits;
          bits -= here_bits;
          //---//
          state.back += here_bits;
          if (here_op & 64) {
            strm.msg = 'invalid distance code';
            state.mode = BAD;
            break;
          }
          state.offset = here_val;
          state.extra = (here_op) & 15;
          state.mode = DISTEXT;
          /* falls through */
        case DISTEXT:
          if (state.extra) {
            //=== NEEDBITS(state.extra);
            n = state.extra;
            while (bits < n) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.offset += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
            //--- DROPBITS(state.extra) ---//
            hold >>>= state.extra;
            bits -= state.extra;
            //---//
            state.back += state.extra;
          }
  //#ifdef INFLATE_STRICT
          if (state.offset > state.dmax) {
            strm.msg = 'invalid distance too far back';
            state.mode = BAD;
            break;
          }
  //#endif
          //Tracevv((stderr, "inflate:         distance %u\n", state.offset));
          state.mode = MATCH;
          /* falls through */
        case MATCH:
          if (left === 0) { break inf_leave; }
          copy = _out - left;
          if (state.offset > copy) {         /* copy from window */
            copy = state.offset - copy;
            if (copy > state.whave) {
              if (state.sane) {
                strm.msg = 'invalid distance too far back';
                state.mode = BAD;
                break;
              }
  // (!) This block is disabled in zlib defaults,
  // don't enable it for binary compatibility
  //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
  //          Trace((stderr, "inflate.c too far\n"));
  //          copy -= state.whave;
  //          if (copy > state.length) { copy = state.length; }
  //          if (copy > left) { copy = left; }
  //          left -= copy;
  //          state.length -= copy;
  //          do {
  //            output[put++] = 0;
  //          } while (--copy);
  //          if (state.length === 0) { state.mode = LEN; }
  //          break;
  //#endif
            }
            if (copy > state.wnext) {
              copy -= state.wnext;
              from = state.wsize - copy;
            }
            else {
              from = state.wnext - copy;
            }
            if (copy > state.length) { copy = state.length; }
            from_source = state.window;
          }
          else {                              /* copy from output */
            from_source = output;
            from = put - state.offset;
            copy = state.length;
          }
          if (copy > left) { copy = left; }
          left -= copy;
          state.length -= copy;
          do {
            output[put++] = from_source[from++];
          } while (--copy);
          if (state.length === 0) { state.mode = LEN; }
          break;
        case LIT:
          if (left === 0) { break inf_leave; }
          output[put++] = state.length;
          left--;
          state.mode = LEN;
          break;
        case CHECK:
          if (state.wrap) {
            //=== NEEDBITS(32);
            while (bits < 32) {
              if (have === 0) { break inf_leave; }
              have--;
              // Use '|' instead of '+' to make sure that result is signed
              hold |= input[next++] << bits;
              bits += 8;
            }
            //===//
            _out -= left;
            strm.total_out += _out;
            state.total += _out;
            if ((state.wrap & 4) && _out) {
              strm.adler = state.check =
                  /*UPDATE_CHECK(state.check, put - _out, _out);*/
                  (state.flags ? crc32_1(state.check, output, _out, put - _out) : adler32_1(state.check, output, _out, put - _out));

            }
            _out = left;
            // NB: crc32 stored as signed 32-bit int, zswap32 returns signed too
            if ((state.wrap & 4) && (state.flags ? hold : zswap32(hold)) !== state.check) {
              strm.msg = 'incorrect data check';
              state.mode = BAD;
              break;
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            //Tracev((stderr, "inflate:   check matches trailer\n"));
          }
          state.mode = LENGTH;
          /* falls through */
        case LENGTH:
          if (state.wrap && state.flags) {
            //=== NEEDBITS(32);
            while (bits < 32) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if ((state.wrap & 4) && hold !== (state.total & 0xffffffff)) {
              strm.msg = 'incorrect length check';
              state.mode = BAD;
              break;
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            //Tracev((stderr, "inflate:   length matches trailer\n"));
          }
          state.mode = DONE;
          /* falls through */
        case DONE:
          ret = Z_STREAM_END$1;
          break inf_leave;
        case BAD:
          ret = Z_DATA_ERROR$1;
          break inf_leave;
        case MEM:
          return Z_MEM_ERROR$1;
        case SYNC:
          /* falls through */
        default:
          return Z_STREAM_ERROR$1;
      }
    }

    // inf_leave <- here is real place for "goto inf_leave", emulated via "break inf_leave"

    /*
       Return from inflate(), updating the total counts and the check value.
       If there was no progress during the inflate() call, return a buffer
       error.  Call updatewindow() to create and/or update the window state.
       Note: a memory error from inflate() is non-recoverable.
     */

    //--- RESTORE() ---
    strm.next_out = put;
    strm.avail_out = left;
    strm.next_in = next;
    strm.avail_in = have;
    state.hold = hold;
    state.bits = bits;
    //---

    if (state.wsize || (_out !== strm.avail_out && state.mode < BAD &&
                        (state.mode < CHECK || flush !== Z_FINISH$1))) {
      if (updatewindow(strm, strm.output, strm.next_out, _out - strm.avail_out)) ;
    }
    _in -= strm.avail_in;
    _out -= strm.avail_out;
    strm.total_in += _in;
    strm.total_out += _out;
    state.total += _out;
    if ((state.wrap & 4) && _out) {
      strm.adler = state.check = /*UPDATE_CHECK(state.check, strm.next_out - _out, _out);*/
        (state.flags ? crc32_1(state.check, output, _out, strm.next_out - _out) : adler32_1(state.check, output, _out, strm.next_out - _out));
    }
    strm.data_type = state.bits + (state.last ? 64 : 0) +
                      (state.mode === TYPE ? 128 : 0) +
                      (state.mode === LEN_ || state.mode === COPY_ ? 256 : 0);
    if (((_in === 0 && _out === 0) || flush === Z_FINISH$1) && ret === Z_OK$1) {
      ret = Z_BUF_ERROR;
    }
    return ret;
  };


  const inflateEnd = (strm) => {

    if (inflateStateCheck(strm)) {
      return Z_STREAM_ERROR$1;
    }

    let state = strm.state;
    if (state.window) {
      state.window = null;
    }
    strm.state = null;
    return Z_OK$1;
  };


  const inflateGetHeader = (strm, head) => {

    /* check state */
    if (inflateStateCheck(strm)) { return Z_STREAM_ERROR$1; }
    const state = strm.state;
    if ((state.wrap & 2) === 0) { return Z_STREAM_ERROR$1; }

    /* save header structure */
    state.head = head;
    head.done = false;
    return Z_OK$1;
  };


  const inflateSetDictionary = (strm, dictionary) => {
    const dictLength = dictionary.length;

    let state;
    let dictid;
    let ret;

    /* check state */
    if (inflateStateCheck(strm)) { return Z_STREAM_ERROR$1; }
    state = strm.state;

    if (state.wrap !== 0 && state.mode !== DICT) {
      return Z_STREAM_ERROR$1;
    }

    /* check for correct dictionary identifier */
    if (state.mode === DICT) {
      dictid = 1; /* adler32(0, null, 0)*/
      /* dictid = adler32(dictid, dictionary, dictLength); */
      dictid = adler32_1(dictid, dictionary, dictLength, 0);
      if (dictid !== state.check) {
        return Z_DATA_ERROR$1;
      }
    }
    /* copy dictionary to window using updatewindow(), which will amend the
     existing dictionary if appropriate */
    ret = updatewindow(strm, dictionary, dictLength, dictLength);
    if (ret) {
      state.mode = MEM;
      return Z_MEM_ERROR$1;
    }
    state.havedict = 1;
    // Tracev((stderr, "inflate:   dictionary set\n"));
    return Z_OK$1;
  };


  var inflateReset_1 = inflateReset;
  var inflateReset2_1 = inflateReset2;
  var inflateResetKeep_1 = inflateResetKeep;
  var inflateInit_1 = inflateInit;
  var inflateInit2_1 = inflateInit2;
  var inflate_2$1 = inflate$2;
  var inflateEnd_1 = inflateEnd;
  var inflateGetHeader_1 = inflateGetHeader;
  var inflateSetDictionary_1 = inflateSetDictionary;
  var inflateInfo = 'pako inflate (from Nodeca project)';

  /* Not implemented
  module.exports.inflateCodesUsed = inflateCodesUsed;
  module.exports.inflateCopy = inflateCopy;
  module.exports.inflateGetDictionary = inflateGetDictionary;
  module.exports.inflateMark = inflateMark;
  module.exports.inflatePrime = inflatePrime;
  module.exports.inflateSync = inflateSync;
  module.exports.inflateSyncPoint = inflateSyncPoint;
  module.exports.inflateUndermine = inflateUndermine;
  module.exports.inflateValidate = inflateValidate;
  */

  var inflate_1$2 = {
  	inflateReset: inflateReset_1,
  	inflateReset2: inflateReset2_1,
  	inflateResetKeep: inflateResetKeep_1,
  	inflateInit: inflateInit_1,
  	inflateInit2: inflateInit2_1,
  	inflate: inflate_2$1,
  	inflateEnd: inflateEnd_1,
  	inflateGetHeader: inflateGetHeader_1,
  	inflateSetDictionary: inflateSetDictionary_1,
  	inflateInfo: inflateInfo
  };

  // (C) 1995-2013 Jean-loup Gailly and Mark Adler
  // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
  //
  // This software is provided 'as-is', without any express or implied
  // warranty. In no event will the authors be held liable for any damages
  // arising from the use of this software.
  //
  // Permission is granted to anyone to use this software for any purpose,
  // including commercial applications, and to alter it and redistribute it
  // freely, subject to the following restrictions:
  //
  // 1. The origin of this software must not be misrepresented; you must not
  //   claim that you wrote the original software. If you use this software
  //   in a product, an acknowledgment in the product documentation would be
  //   appreciated but is not required.
  // 2. Altered source versions must be plainly marked as such, and must not be
  //   misrepresented as being the original software.
  // 3. This notice may not be removed or altered from any source distribution.

  function GZheader() {
    /* true if compressed data believed to be text */
    this.text       = 0;
    /* modification time */
    this.time       = 0;
    /* extra flags (not used when writing a gzip file) */
    this.xflags     = 0;
    /* operating system */
    this.os         = 0;
    /* pointer to extra field or Z_NULL if none */
    this.extra      = null;
    /* extra field length (valid if extra != Z_NULL) */
    this.extra_len  = 0; // Actually, we don't need it in JS,
                         // but leave for few code modifications

    //
    // Setup limits is not necessary because in js we should not preallocate memory
    // for inflate use constant limit in 65536 bytes
    //

    /* space at extra (only when reading header) */
    // this.extra_max  = 0;
    /* pointer to zero-terminated file name or Z_NULL */
    this.name       = '';
    /* space at name (only when reading header) */
    // this.name_max   = 0;
    /* pointer to zero-terminated comment or Z_NULL */
    this.comment    = '';
    /* space at comment (only when reading header) */
    // this.comm_max   = 0;
    /* true if there was or will be a header crc */
    this.hcrc       = 0;
    /* true when done reading gzip header (not used when writing a gzip file) */
    this.done       = false;
  }

  var gzheader = GZheader;

  const toString = Object.prototype.toString;

  /* Public constants ==========================================================*/
  /* ===========================================================================*/

  const {
    Z_NO_FLUSH, Z_FINISH,
    Z_OK, Z_STREAM_END, Z_NEED_DICT, Z_STREAM_ERROR, Z_DATA_ERROR, Z_MEM_ERROR
  } = constants$2;

  /* ===========================================================================*/


  /**
   * class Inflate
   *
   * Generic JS-style wrapper for zlib calls. If you don't need
   * streaming behaviour - use more simple functions: [[inflate]]
   * and [[inflateRaw]].
   **/

  /* internal
   * inflate.chunks -> Array
   *
   * Chunks of output data, if [[Inflate#onData]] not overridden.
   **/

  /**
   * Inflate.result -> Uint8Array|String
   *
   * Uncompressed result, generated by default [[Inflate#onData]]
   * and [[Inflate#onEnd]] handlers. Filled after you push last chunk
   * (call [[Inflate#push]] with `Z_FINISH` / `true` param).
   **/

  /**
   * Inflate.err -> Number
   *
   * Error code after inflate finished. 0 (Z_OK) on success.
   * Should be checked if broken data possible.
   **/

  /**
   * Inflate.msg -> String
   *
   * Error message, if [[Inflate.err]] != 0
   **/


  /**
   * new Inflate(options)
   * - options (Object): zlib inflate options.
   *
   * Creates new inflator instance with specified params. Throws exception
   * on bad params. Supported options:
   *
   * - `windowBits`
   * - `dictionary`
   *
   * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
   * for more information on these.
   *
   * Additional options, for internal needs:
   *
   * - `chunkSize` - size of generated data chunks (16K by default)
   * - `raw` (Boolean) - do raw inflate
   * - `to` (String) - if equal to 'string', then result will be converted
   *   from utf8 to utf16 (javascript) string. When string output requested,
   *   chunk length can differ from `chunkSize`, depending on content.
   *
   * By default, when no options set, autodetect deflate/gzip data format via
   * wrapper header.
   *
   * ##### Example:
   *
   * ```javascript
   * const pako = require('pako')
   * const chunk1 = new Uint8Array([1,2,3,4,5,6,7,8,9])
   * const chunk2 = new Uint8Array([10,11,12,13,14,15,16,17,18,19]);
   *
   * const inflate = new pako.Inflate({ level: 3});
   *
   * inflate.push(chunk1, false);
   * inflate.push(chunk2, true);  // true -> last chunk
   *
   * if (inflate.err) { throw new Error(inflate.err); }
   *
   * console.log(inflate.result);
   * ```
   **/
  function Inflate$1(options) {
    this.options = common.assign({
      chunkSize: 1024 * 64,
      windowBits: 15,
      to: ''
    }, options || {});

    const opt = this.options;

    // Force window size for `raw` data, if not set directly,
    // because we have no header for autodetect.
    if (opt.raw && (opt.windowBits >= 0) && (opt.windowBits < 16)) {
      opt.windowBits = -opt.windowBits;
      if (opt.windowBits === 0) { opt.windowBits = -15; }
    }

    // If `windowBits` not defined (and mode not raw) - set autodetect flag for gzip/deflate
    if ((opt.windowBits >= 0) && (opt.windowBits < 16) &&
        !(options && options.windowBits)) {
      opt.windowBits += 32;
    }

    // Gzip header has no info about windows size, we can do autodetect only
    // for deflate. So, if window size not set, force it to max when gzip possible
    if ((opt.windowBits > 15) && (opt.windowBits < 48)) {
      // bit 3 (16) -> gzipped data
      // bit 4 (32) -> autodetect gzip/deflate
      if ((opt.windowBits & 15) === 0) {
        opt.windowBits |= 15;
      }
    }

    this.err    = 0;      // error code, if happens (0 = Z_OK)
    this.msg    = '';     // error message
    this.ended  = false;  // used to avoid multiple onEnd() calls
    this.chunks = [];     // chunks of compressed data

    this.strm   = new zstream();
    this.strm.avail_out = 0;

    let status  = inflate_1$2.inflateInit2(
      this.strm,
      opt.windowBits
    );

    if (status !== Z_OK) {
      throw new Error(messages[status]);
    }

    this.header = new gzheader();

    inflate_1$2.inflateGetHeader(this.strm, this.header);

    // Setup dictionary
    if (opt.dictionary) {
      // Convert data if needed
      if (typeof opt.dictionary === 'string') {
        opt.dictionary = strings.string2buf(opt.dictionary);
      } else if (toString.call(opt.dictionary) === '[object ArrayBuffer]') {
        opt.dictionary = new Uint8Array(opt.dictionary);
      }
      if (opt.raw) { //In raw mode we need to set the dictionary early
        status = inflate_1$2.inflateSetDictionary(this.strm, opt.dictionary);
        if (status !== Z_OK) {
          throw new Error(messages[status]);
        }
      }
    }
  }

  /**
   * Inflate#push(data[, flush_mode]) -> Boolean
   * - data (Uint8Array|ArrayBuffer): input data
   * - flush_mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE
   *   flush modes. See constants. Skipped or `false` means Z_NO_FLUSH,
   *   `true` means Z_FINISH.
   *
   * Sends input data to inflate pipe, generating [[Inflate#onData]] calls with
   * new output chunks. Returns `true` on success. If end of stream detected,
   * [[Inflate#onEnd]] will be called.
   *
   * `flush_mode` is not needed for normal operation, because end of stream
   * detected automatically. You may try to use it for advanced things, but
   * this functionality was not tested.
   *
   * On fail call [[Inflate#onEnd]] with error code and return false.
   *
   * ##### Example
   *
   * ```javascript
   * push(chunk, false); // push one of data chunks
   * ...
   * push(chunk, true);  // push last chunk
   * ```
   **/
  Inflate$1.prototype.push = function (data, flush_mode) {
    const strm = this.strm;
    const chunkSize = this.options.chunkSize;
    const dictionary = this.options.dictionary;
    let status, _flush_mode, last_avail_out;

    if (this.ended) return false;

    if (flush_mode === ~~flush_mode) _flush_mode = flush_mode;
    else _flush_mode = flush_mode === true ? Z_FINISH : Z_NO_FLUSH;

    // Convert data if needed
    if (toString.call(data) === '[object ArrayBuffer]') {
      strm.input = new Uint8Array(data);
    } else {
      strm.input = data;
    }

    strm.next_in = 0;
    strm.avail_in = strm.input.length;

    for (;;) {
      if (strm.avail_out === 0) {
        strm.output = new Uint8Array(chunkSize);
        strm.next_out = 0;
        strm.avail_out = chunkSize;
      }

      status = inflate_1$2.inflate(strm, _flush_mode);

      if (status === Z_NEED_DICT && dictionary) {
        status = inflate_1$2.inflateSetDictionary(strm, dictionary);

        if (status === Z_OK) {
          status = inflate_1$2.inflate(strm, _flush_mode);
        } else if (status === Z_DATA_ERROR) {
          // Replace code with more verbose
          status = Z_NEED_DICT;
        }
      }

      // Skip snyc markers if more data follows and not raw mode
      while (strm.avail_in > 0 &&
             status === Z_STREAM_END &&
             strm.state.wrap > 0 &&
             data[strm.next_in] !== 0)
      {
        inflate_1$2.inflateReset(strm);
        status = inflate_1$2.inflate(strm, _flush_mode);
      }

      switch (status) {
        case Z_STREAM_ERROR:
        case Z_DATA_ERROR:
        case Z_NEED_DICT:
        case Z_MEM_ERROR:
          this.onEnd(status);
          this.ended = true;
          return false;
      }

      // Remember real `avail_out` value, because we may patch out buffer content
      // to align utf8 strings boundaries.
      last_avail_out = strm.avail_out;

      if (strm.next_out) {
        if (strm.avail_out === 0 || status === Z_STREAM_END) {

          if (this.options.to === 'string') {

            let next_out_utf8 = strings.utf8border(strm.output, strm.next_out);

            let tail = strm.next_out - next_out_utf8;
            let utf8str = strings.buf2string(strm.output, next_out_utf8);

            // move tail & realign counters
            strm.next_out = tail;
            strm.avail_out = chunkSize - tail;
            if (tail) strm.output.set(strm.output.subarray(next_out_utf8, next_out_utf8 + tail), 0);

            this.onData(utf8str);

          } else {
            this.onData(strm.output.length === strm.next_out ? strm.output : strm.output.subarray(0, strm.next_out));
          }
        }
      }

      // Must repeat iteration if out buffer is full
      if (status === Z_OK && last_avail_out === 0) continue;

      // Finalize if end of stream reached.
      if (status === Z_STREAM_END) {
        status = inflate_1$2.inflateEnd(this.strm);
        this.onEnd(status);
        this.ended = true;
        return true;
      }

      if (strm.avail_in === 0) break;
    }

    return true;
  };


  /**
   * Inflate#onData(chunk) -> Void
   * - chunk (Uint8Array|String): output data. When string output requested,
   *   each chunk will be string.
   *
   * By default, stores data blocks in `chunks[]` property and glue
   * those in `onEnd`. Override this handler, if you need another behaviour.
   **/
  Inflate$1.prototype.onData = function (chunk) {
    this.chunks.push(chunk);
  };


  /**
   * Inflate#onEnd(status) -> Void
   * - status (Number): inflate status. 0 (Z_OK) on success,
   *   other if not.
   *
   * Called either after you tell inflate that the input stream is
   * complete (Z_FINISH). By default - join collected chunks,
   * free memory and fill `results` / `err` properties.
   **/
  Inflate$1.prototype.onEnd = function (status) {
    // On success - join
    if (status === Z_OK) {
      if (this.options.to === 'string') {
        this.result = this.chunks.join('');
      } else {
        this.result = common.flattenChunks(this.chunks);
      }
    }
    this.chunks = [];
    this.err = status;
    this.msg = this.strm.msg;
  };


  /**
   * inflate(data[, options]) -> Uint8Array|String
   * - data (Uint8Array|ArrayBuffer): input data to decompress.
   * - options (Object): zlib inflate options.
   *
   * Decompress `data` with inflate/ungzip and `options`. Autodetect
   * format via wrapper header by default. That's why we don't provide
   * separate `ungzip` method.
   *
   * Supported options are:
   *
   * - windowBits
   *
   * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
   * for more information.
   *
   * Sugar (options):
   *
   * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
   *   negative windowBits implicitly.
   * - `to` (String) - if equal to 'string', then result will be converted
   *   from utf8 to utf16 (javascript) string. When string output requested,
   *   chunk length can differ from `chunkSize`, depending on content.
   *
   *
   * ##### Example:
   *
   * ```javascript
   * const pako = require('pako');
   * const input = pako.deflate(new Uint8Array([1,2,3,4,5,6,7,8,9]));
   * let output;
   *
   * try {
   *   output = pako.inflate(input);
   * } catch (err) {
   *   console.log(err);
   * }
   * ```
   **/
  function inflate$1(input, options) {
    const inflator = new Inflate$1(options);

    inflator.push(input);

    // That will never happens, if you don't cheat with options :)
    if (inflator.err) throw inflator.msg || messages[inflator.err];

    return inflator.result;
  }


  /**
   * inflateRaw(data[, options]) -> Uint8Array|String
   * - data (Uint8Array|ArrayBuffer): input data to decompress.
   * - options (Object): zlib inflate options.
   *
   * The same as [[inflate]], but creates raw data, without wrapper
   * (header and adler32 crc).
   **/
  function inflateRaw$1(input, options) {
    options = options || {};
    options.raw = true;
    return inflate$1(input, options);
  }


  /**
   * ungzip(data[, options]) -> Uint8Array|String
   * - data (Uint8Array|ArrayBuffer): input data to decompress.
   * - options (Object): zlib inflate options.
   *
   * Just shortcut to [[inflate]], because it autodetects format
   * by header.content. Done for convenience.
   **/


  var Inflate_1$1 = Inflate$1;
  var inflate_2 = inflate$1;
  var inflateRaw_1$1 = inflateRaw$1;
  var ungzip$1 = inflate$1;
  var constants = constants$2;

  var inflate_1$1 = {
  	Inflate: Inflate_1$1,
  	inflate: inflate_2,
  	inflateRaw: inflateRaw_1$1,
  	ungzip: ungzip$1,
  	constants: constants
  };

  const { Inflate, inflate, inflateRaw, ungzip } = inflate_1$1;
  var inflateRaw_1 = inflateRaw;
  var ungzip_1 = ungzip;

  const FEXTRA = 4;  // gzip spec F.EXTRA flag

  function isgzipped(data) {
      const b = ArrayBuffer.isView(data) ? data : new Uint8Array(data);
      return b[0] ===31 && b[1] === 139;
  }

  /**
   * Pako does not properly ungzip block compressed files if > 1 block is present.  Test for bgzip and use wrapper.
   */
  function ungzip_blocks(data) {
      const ba = ArrayBuffer.isView(data) ? data : new Uint8Array(data);
      const b = ba[3] & FEXTRA;
      if (b !== 0 && ba[12] === 66 && ba[13] === 67) {
          return unbgzf(ba.buffer);
      } else {
          return ungzip_1(ba);
      }
  }

  // Uncompress data,  assumed to be series of bgzipped blocks
  function unbgzf(data, lim) {

      const oBlockList = [];
      let ptr = 0;
      let totalSize = 0;

      lim = lim || data.byteLength - 18;

      while (ptr < lim) {
          try {
              const ba = ArrayBuffer.isView(data) ? data : new Uint8Array(data, ptr, 18);
              const xlen = (ba[11] << 8) | (ba[10]);
              const flg = ba[3];
              const fextra = flg & FEXTRA;
              const si1 = ba[12];
              const si2 = ba[13];
              const slen = (ba[15] << 8) | (ba[14]);
              const bsize = ((ba[17] << 8) | (ba[16])) + 1;
              const start = 12 + xlen + ptr;    // Start of CDATA
              const bytesLeft = data.byteLength - start;
              const cDataSize = bsize - xlen - 19;
              if (bytesLeft < cDataSize || cDataSize <= 0) break;

              const a = new Uint8Array(data, start, cDataSize);
              const unc = inflateRaw_1(a);

              // const inflate = new Zlib.RawInflate(a);
              // const unc = inflate.decompress();

              ptr += (cDataSize - 1) + 26; //inflate.ip + 26
              totalSize += unc.byteLength;
              oBlockList.push(unc);
          } catch (e) {
              console.error(e);
              break;
          }
      }

      // Concatenate decompressed blocks
      if (oBlockList.length === 1) {
          return oBlockList[0];
      } else {
          const out = new Uint8Array(totalSize);
          let cursor = 0;
          for (let i = 0; i < oBlockList.length; ++i) {
              var b = new Uint8Array(oBlockList[i]);
              arrayCopy(b, 0, out, cursor, b.length);
              cursor += b.length;
          }
          return out;
      }
  }

  // From Thomas Down's zlib implementation

  const testArray = new Uint8Array(1);
  const hasSubarray = (typeof testArray.subarray === 'function');

  function arrayCopy(src, srcOffset, dest, destOffset, count) {
      if (count === 0) {
          return;
      }
      if (!src) {
          throw "Undef src";
      } else if (!dest) {
          throw "Undef dest";
      }
      if (srcOffset === 0 && count === src.length) {
          arrayCopy_fast(src, dest, destOffset);
      } else if (hasSubarray) {
          arrayCopy_fast(src.subarray(srcOffset, srcOffset + count), dest, destOffset);
      } else if (src.BYTES_PER_ELEMENT === 1 && count > 100) {
          arrayCopy_fast(new Uint8Array(src.buffer, src.byteOffset + srcOffset, count), dest, destOffset);
      } else {
          arrayCopy_slow(src, srcOffset, dest, destOffset, count);
      }
  }

  function arrayCopy_slow(src, srcOffset, dest, destOffset, count) {
      for (let i = 0; i < count; ++i) {
          dest[destOffset + i] = src[srcOffset + i];
      }
  }

  function arrayCopy_fast(src, dest, destOffset) {
      dest.set(src, destOffset);
  }


  /**
   * @param dataURI
   * @returns {Array<number>|Uint8Array}
   */
  function decodeDataURI(dataURI, gzip) {

      const split = dataURI.split(',');
      const info = split[0].split(':')[1];
      let dataString = split[1];

      if (info.indexOf('base64') >= 0) {
          dataString = atob(dataString);

          const bytes = new Uint8Array(dataString.length);
          for (let i = 0; i < dataString.length; i++) {
              bytes[i] = dataString.charCodeAt(i);
          }

          let plain;
          if (gzip || info.indexOf('gzip') > 0) {
              plain = ungzip_1(bytes);
          } else {
              plain = bytes;
          }
          return plain
      } else {
          return decodeURIComponent(dataString);      // URL encoded string -- not currently used or tested
      }
  }

  // Support for oauth token based authorization
  // This class supports explicit setting of an oauth token either globally or for specific hosts.
  //
  // The variable oauth.google.access_token, which becomes igv.oauth.google.access_token on ES5 conversion is
  // supported for backward compatibility

  const DEFAULT_HOST = "googleapis";

  class Oauth {

      constructor() {
          this.oauthTokens = {};
      }


      setToken(token, host) {
          host = host || DEFAULT_HOST;
          this.oauthTokens[host] = token;
      }

      getToken(host) {
          host = host || DEFAULT_HOST;
          let token;
          for (let key of Object.keys(this.oauthTokens)) {
              const regex = wildcardToRegExp(key);
              if (regex.test(host)) {
                  token = this.oauthTokens[key];
                  break
              }
          }
          return token
      }

      removeToken(host) {
          host = host || DEFAULT_HOST;
          for (let key of Object.keys(this.oauthTokens)) {
              const regex = wildcardToRegExp(key);
              if (regex.test(host)) {
                  this.oauthTokens[key] = undefined;
              }
          }
      }

      // Special object for google -- legacy support
      // google: {
      //     setToken: function (token) {
      //         oauth.setToken(token);
      //     }
      // }
  }


  /**
   * Creates a RegExp from the given string, converting asterisks to .* expressions,
   * and escaping all other characters.
   *
   * credit https://gist.github.com/donmccurdy/6d073ce2c6f3951312dfa45da14a420f
   */
  function wildcardToRegExp(s) {
      return new RegExp('^' + s.split(/\*+/).map(regExpEscape).join('.*') + '$')
  }

  /**
   * RegExp-escapes all characters in the given string.
   *
   * credit https://gist.github.com/donmccurdy/6d073ce2c6f3951312dfa45da14a420f
   */
  function regExpEscape(s) {
      return s.replace(/[|\\{}()[\]^$+*?.]/g, '\\$&')
  }

  function isGoogleURL(url) {
      return (url.includes("googleapis") && !url.includes("urlshortener")) ||
          isGoogleStorageURL(url) ||
          isGoogleDriveURL(url)
  }

  function isGoogleStorageURL(url) {
      return url.startsWith("gs://") ||
          url.startsWith("https://www.googleapis.com/storage") ||
          url.startsWith("https://storage.cloud.google.com") ||
          url.startsWith("https://storage.googleapis.com");
  }

  function isGoogleDriveURL(url) {
      return url.indexOf("drive.google.com") >= 0 || url.indexOf("www.googleapis.com/drive") > 0
  }

  /**
   * Translate gs:// urls to https
   * See https://cloud.google.com/storage/docs/json_api/v1
   * @param gsUrl
   * @returns {string|*}
   */
  function translateGoogleCloudURL(gsUrl) {

      let {bucket, object} = parseBucketName(gsUrl);
      object = encode(object);

      const qIdx = gsUrl.indexOf('?');
      const paramString = (qIdx > 0) ? gsUrl.substring(qIdx) + "&alt=media" : "?alt=media";

      return `https://storage.googleapis.com/storage/v1/b/${bucket}/o/${object}${paramString}`
  }

  /**
   * Parse a google bucket and object name from a google storage URL.  Known forms include
   *
   * gs://BUCKET_NAME/OBJECT_NAME
   * https://storage.googleapis.com/BUCKET_NAME/OBJECT_NAME
   * https://storage.googleapis.com/storage/v1/b/BUCKET_NAME/o/OBJECT_NAME
   * https://www.googleapis.com/storage/v1/b/BUCKET_NAME/o/OBJECT_NAME"
   * https://storage.googleapis.com/download/storage/v1/b/BUCKET_NAME/o/OBJECT_NAME
   *
   * @param url
   */
  function parseBucketName(url) {

      let bucket;
      let object;

      if (url.startsWith("gs://")) {
          const i = url.indexOf('/', 5);
          if (i >= 0) {
              bucket = url.substring(5, i);
              const qIdx = url.indexOf('?');
              object = (qIdx < 0) ? url.substring(i + 1) : url.substring(i + 1, qIdx);
          }

      } else if (url.startsWith("https://storage.googleapis.com") || url.startsWith("https://storage.cloud.google.com")) {
          const bucketIdx = url.indexOf("/v1/b/", 8);
          if (bucketIdx > 0) {
              const objIdx = url.indexOf("/o/", bucketIdx);
              if (objIdx > 0) {
                  const queryIdx = url.indexOf("?", objIdx);
                  bucket = url.substring(bucketIdx + 6, objIdx);
                  object = queryIdx > 0 ? url.substring(objIdx + 3, queryIdx) : url.substring(objIdx + 3);
              }

          } else {
              const idx1 = url.indexOf("/", 8);
              const idx2 = url.indexOf("/", idx1+1);
              const idx3 = url.indexOf("?", idx2);
              if (idx2 > 0) {
                  bucket = url.substring(idx1+1, idx2);
                  object = idx3 < 0 ? url.substring(idx2+1) : url.substring(idx2+1, idx3);
              }
          }

      } else if (url.startsWith("https://www.googleapis.com/storage/v1/b")) {
          const bucketIdx = url.indexOf("/v1/b/", 8);
          const objIdx = url.indexOf("/o/", bucketIdx);
          if (objIdx > 0) {
              const queryIdx = url.indexOf("?", objIdx);
              bucket = url.substring(bucketIdx + 6, objIdx);
              object = queryIdx > 0 ? url.substring(objIdx + 3, queryIdx) : url.substring(objIdx + 3);
          }
      }

      if (bucket && object) {
          return {
              bucket, object
          }
      } else {
          throw Error(`Unrecognized Google Storage URI: ${url}`)
      }

  }

  /**
   * Percent a GCS object name.  See https://cloud.google.com/storage/docs/request-endpoints
   * Specific characters to encode:
   *   !, #, $, &, ', (, ), *, +, ,, /, :, ;, =, ?, @, [, ], and space characters.
   * @param obj
   */

  function encode(objectName) {

      let result = '';
      objectName.split('').forEach(function(letter) {
          if(encodings.has(letter)) {
              result += encodings.get(letter);
          } else {
              result += letter;
          }
      });
      return result;
  }

  //	%23	%24	%25	%26	%27	%28	%29	%2A	%2B	%2C	%2F	%3A	%3B	%3D	%3F	%40	%5B	%5D
  const encodings = new Map();
  encodings.set("!", "%21");
  encodings.set("#", "%23");
  encodings.set("$", "%24");
  encodings.set("%", "%25");
  encodings.set("&", "%26");
  encodings.set("'", "%27");
  encodings.set("(", "%28");
  encodings.set(")", "%29");
  encodings.set("*", "%2A");
  encodings.set("+", "%2B");
  encodings.set(",", "%2C");
  encodings.set("/", "%2F");
  encodings.set(":", "%3A");
  encodings.set(";", "%3B");
  encodings.set("=", "%3D");
  encodings.set("?", "%3F");
  encodings.set("@", "%40");
  encodings.set("[", "%5B");
  encodings.set("]", "%5D");
  encodings.set(" ", "%20");

  // Convenience functions for the gapi oAuth library.

  function isInitialized() {
      return window.google && window.google.igv
  }

  /**
   * Return the current access token if the user is signed in, or undefined otherwise.  This function does not
   * attempt a signIn or request any specfic scopes.
   *
   * @returns access_token || undefined
   */
  function getCurrentAccessToken() {
      return (isInitialized() && google.igv.tokenResponse && Date.now() < google.igv.tokenExpiresAt) ?
          google.igv.tokenResponse.access_token :
          undefined
  }


  /**
   * Return a promise for an access token for the given scope.  If the user hasn't authorized the scope request it
   *
   * @param scope
   * @returns {Promise<unknown>}
   */
  async function getAccessToken(scope) {

      if (!isInitialized()) {
          throw Error("Google oAuth has not been initialized")
      }

      if (google.igv.tokenResponse &&
          Date.now() < google.igv.tokenExpiresAt &&
          google.accounts.oauth2.hasGrantedAllScopes(google.igv.tokenResponse, scope)) {
          return google.igv.tokenResponse.access_token
      } else {
          const tokenClient = google.igv.tokenClient;
          return new Promise((resolve, reject) => {
              try {
                  // Settle this promise in the response callback for requestAccessToken()
                  tokenClient.callback = (tokenResponse) => {
                      if (tokenResponse.error !== undefined) {
                          reject(tokenResponse);
                      }
                      google.igv.tokenResponse = tokenResponse;
                      google.igv.tokenExpiresAt = Date.now() + tokenResponse.expires_in * 1000;
                      resolve(tokenResponse.access_token);
                  };
                  tokenClient.requestAccessToken({scope});
              } catch (err) {
              }
          })
      }
  }

  // gapi.auth2.getAuthInstance().isSignedIn.listen(status => {
  //     const user = gapi.auth2.getAuthInstance().currentUser.get()
  //     queryGoogleAuthenticationStatus(user, status)
  // })

  function getScopeForURL(url) {
      if (isGoogleDriveURL(url)) {
          return "https://www.googleapis.com/auth/drive.readonly"
      } else if (isGoogleStorageURL(url)) {
          return "https://www.googleapis.com/auth/devstorage.read_only"
      } else {
          return 'https://www.googleapis.com/auth/userinfo.profile'
      }
  }

  function getApiKey() {
      return google.igv.apiKey
  }

  /**
   * Return information about a specific google drive URL
   *
   * @param googleDriveURL
   * @returns {Promise<any>}
   */
  async function getDriveFileInfo(googleDriveURL) {

      const id = getGoogleDriveFileID(googleDriveURL);
      let endPoint = "https://www.googleapis.com/drive/v3/files/" + id + "?supportsTeamDrives=true";
      const apiKey = getApiKey();
      if (apiKey) {
          endPoint += "&key=" + apiKey;
      }
      const response = await fetch(endPoint);
      let json = await response.json();
      if (json.error && json.error.code === 404) {
          let scope = "https://www.googleapis.com/auth/drive.readonly";
          const access_token = await getAccessToken(scope);
          if (access_token) {
              const response = await fetch(endPoint, {
                  headers: {
                      'Authorization': `Bearer ${access_token}`
                  }
              });
              json = await response.json();
              if (json.error) {
                  throw Error(json.error);
              }
          } else {
              throw Error(json.error);
          }
      }
      return json;
  }


  function getDriveDownloadURL(link) {
      // Return a google drive download url for the sharable link
      //https://drive.google.com/open?id=0B-lleX9c2pZFbDJ4VVRxakJzVGM
      //https://drive.google.com/file/d/1_FC4kCeO8E3V4dJ1yIW7A0sn1yURKIX-/view?usp=sharing
      var id = getGoogleDriveFileID(link);
      return id ? "https://www.googleapis.com/drive/v3/files/" + id + "?alt=media&supportsTeamDrives=true" : link;
  }

  function getGoogleDriveFileID(link) {

      //https://drive.google.com/file/d/1_FC4kCeO8E3V4dJ1yIW7A0sn1yURKIX-/view?usp=sharing
      //https://www.googleapis.com/drive/v3/files/1w-tvo6p1SH4p1OaQSVxpkV_EJgGIstWF?alt=media&supportsTeamDrives=true"

      if (link.includes("/open?id=")) {
          const i1 = link.indexOf("/open?id=") + 9;
          const i2 = link.indexOf("&");
          if (i1 > 0 && i2 > i1) {
              return link.substring(i1, i2)
          } else if (i1 > 0) {
              return link.substring(i1);
          }

      } else if (link.includes("/file/d/")) {
          const i1 = link.indexOf("/file/d/") + 8;
          const i2 = link.lastIndexOf("/");
          return link.substring(i1, i2);

      } else if (link.startsWith("https://www.googleapis.com/drive")) {
          let i1 = link.indexOf("/files/");
          const i2 = link.indexOf("?");
          if (i1 > 0) {
              i1 += 7;
              return i2 > 0 ?
                  link.substring(i1, i2) :
                  link.substring(i1)
          }
      }

      throw Error("Unknown Google Drive url format: " + link);


  }

  // The MIT License (MIT)

  /**
   * @constructor
   * @param {Object} options A set op options to pass to the throttle function
   *        @param {number} requestsPerSecond The amount of requests per second
   *                                          the library will limit to
   */
  class Throttle {
      constructor(options) {
          this.requestsPerSecond = options.requestsPerSecond || 10;
          this.lastStartTime = 0;
          this.queued = [];
      }

      /**
       * Adds a promise
       * @param {Function} async function to be executed
       * @param {Object} options A set of options.
       * @return {Promise} A promise
       */
      add(asyncFunction, options) {

          var self = this;
          return new Promise(function (resolve, reject) {
              self.queued.push({
                  resolve: resolve,
                  reject: reject,
                  asyncFunction: asyncFunction,
              });
              self.dequeue();
          });
      }

      /**
       * Adds all the promises passed as parameters
       * @param {Function} promises An array of functions that return a promise
       * @param {Object} options A set of options.
       * @param {number} options.signal An AbortSignal object that can be used to abort the returned promise
       * @param {number} options.weight A "weight" of each operation resolving by array of promises
       * @return {Promise} A promise that succeeds when all the promises passed as options do
       */
      addAll(promises, options) {
          var addedPromises = promises.map(function (promise) {
              return this.add(promise, options);
          }.bind(this));

          return Promise.all(addedPromises);
      };

      /**
       * Dequeues a promise
       * @return {void}
       */
      dequeue() {
          if (this.queued.length > 0) {
              var now = new Date(),
                  inc = (1000 / this.requestsPerSecond) + 1,
                  elapsed = now - this.lastStartTime;

              if (elapsed >= inc) {
                  this._execute();
              } else {
                  // we have reached the limit, schedule a dequeue operation
                  setTimeout(function () {
                      this.dequeue();
                  }.bind(this), inc - elapsed);
              }
          }
      }

      /**
       * Executes the promise
       * @private
       * @return {void}
       */
      async _execute() {
          this.lastStartTime = new Date();
          var candidate = this.queued.shift();
          const f = candidate.asyncFunction;
          try {
              const r = await f();
              candidate.resolve(r);
          } catch (e) {
              candidate.reject(e);
          }

      }


  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class IGVXhr {

      constructor() {
          this.apiKey = undefined;
          this.googleThrottle = new Throttle({
              requestsPerSecond: 8
          });
          this.RANGE_WARNING_GIVEN = false;
          this.oauth = new Oauth();
      }

      setApiKey(key) {
          this.apiKey = key;
      }

      async loadArrayBuffer(url, options) {
          options = options || {};
          if (!options.responseType) {
              options.responseType = "arraybuffer";
          }
          if (isFile$1(url)) {
              return this._loadFileSlice(url, options)
          } else {
              return this.load(url, options)
          }
      }

      async loadJson(url, options) {
          options = options || {};
          const method = options.method || (options.sendData ? "POST" : "GET");
          if (method === "POST") {
              options.contentType = "application/json";
          }
          const result = await this.loadString(url, options);
          if (result) {
              return JSON.parse(result)
          } else {
              return result
          }
      }

      async loadString(path, options) {
          options = options || {};
          if (path instanceof File) {
              return this._loadStringFromFile(path, options)
          } else {
              return this._loadStringFromUrl(path, options)
          }
      }

      async load(url, options) {

          options = options || {};
          const urlType = typeof url;

          // Resolve functions, promises, and functions that return promises
          url = await (typeof url === 'function' ? url() : url);

          if (isFile$1(url)) {
              return this._loadFileSlice(url, options)
          } else if (typeof url.startsWith === 'function') {   // Test for string
              if (url.startsWith("data:")) {
                  const buffer = decodeDataURI(url).buffer;
                  if (options.range) {
                      const rangeEnd = options.range.size ? options.range.start + options.range.size : buffer.byteLength;
                      return buffer.slice(options.range.start, rangeEnd)
                  } else {
                      return buffer
                  }
              } else {
                  if (url.startsWith("https://drive.google.com")) {
                      url = getDriveDownloadURL(url);
                  }
                  if (isGoogleDriveURL(url) || url.startsWith("https://www.dropbox.com")) {
                      return this.googleThrottle.add(async () => {
                          return this._loadURL(url, options)
                      })
                  } else {
                      return this._loadURL(url, options)
                  }
              }
          } else {
              throw Error(`url must be either a 'File', 'string', 'function', or 'Promise'.  Actual type: ${urlType}`)
          }
      }

      async _loadURL(url, options) {

          const self = this;

          //console.log(`${Date.now()}   ${url}`)
          url = mapUrl(url);

          options = options || {};

          let oauthToken = options.oauthToken || this.getOauthToken(url);
          if (oauthToken) {
              oauthToken = await (typeof oauthToken === 'function' ? oauthToken() : oauthToken);
          }

          return new Promise(function (resolve, reject) {

              // Various Google tansformations
              if (isGoogleURL(url) && !isGoogleStorageSigned(url)) {
                  if (isGoogleStorageURL(url)) {
                      url = translateGoogleCloudURL(url);
                  }
                  url = addApiKey(url);

                  if (isGoogleDriveURL(url)) {
                      addTeamDrive(url);
                  }

                  // If we have an access token try it, but don't force a signIn or request for scopes yet
                  if (!oauthToken) {
                      oauthToken = getCurrentGoogleAccessToken();
                  }
              }

              const headers = options.headers || {};
              if (oauthToken) {
                  addOauthHeaders(headers, oauthToken);
              }
              const range = options.range;

              // const isChrome = navigator.userAgent.indexOf('Chrome') > -1
              // const isSafari = navigator.vendor.indexOf("Apple") === 0 && /\sSafari\//.test(navigator.userAgent)
              // if (range && isChrome && !isAmazonV4Signed(url) && !isGoogleStorageSigned(url)) {
              //     // Hack to prevent caching for byte-ranges. Attempt to fix net:err-cache errors in Chrome
              //     url += url.includes("?") ? "&" : "?"
              //     url += "someRandomSeed=" + Math.random().toString(36)
              // }

              const xhr = new XMLHttpRequest();
              const sendData = options.sendData || options.body;
              const method = options.method || (sendData ? "POST" : "GET");
              const responseType = options.responseType;
              const contentType = options.contentType;
              const mimeType = options.mimeType;

              xhr.open(method, url);

              if (options.timeout) {
                  xhr.timeout = options.timeout;
              }

              if (range) {
                  var rangeEnd = range.size ? range.start + range.size - 1 : "";
                  xhr.setRequestHeader("Range", "bytes=" + range.start + "-" + rangeEnd);
                  //      xhr.setRequestHeader("Cache-Control", "no-cache");    <= This can cause CORS issues, disabled for now
              }
              if (contentType) {
                  xhr.setRequestHeader("Content-Type", contentType);
              }
              if (mimeType) {
                  xhr.overrideMimeType(mimeType);
              }
              if (responseType) {
                  xhr.responseType = responseType;
              }
              if (headers) {
                  for (let key of Object.keys(headers)) {
                      const value = headers[key];
                      xhr.setRequestHeader(key, value);
                  }
              }

              // NOTE: using withCredentials with servers that return "*" for access-allowed-origin will fail
              if (options.withCredentials === true) {
                  xhr.withCredentials = true;
              }

              xhr.onload = async function (event) {
                  // when the url points to a local file, the status is 0 but that is not an error
                  if (xhr.status === 0 || (xhr.status >= 200 && xhr.status <= 300)) {
                      if (range && xhr.status !== 206 && range.start !== 0) {
                          // For small files a range starting at 0 can return the whole file => 200
                          // Provide just the slice we asked for, throw out the rest quietly
                          // If file is large warn user
                          if (xhr.response.length > 100000 && !self.RANGE_WARNING_GIVEN) {
                              alert(`Warning: Range header ignored for URL: ${url}.  This can have severe performance impacts.`);
                          }
                          resolve(xhr.response.slice(range.start, range.start + range.size));

                      } else {
                          resolve(xhr.response);
                      }
                  } else if ((typeof gapi !== "undefined") &&
                      ((xhr.status === 404 || xhr.status === 401 || xhr.status === 403) &&
                          isGoogleURL(url)) &&
                      !options.retries) {
                      tryGoogleAuth();

                  } else {
                      if (xhr.status === 403) {
                          handleError("Access forbidden: " + url);
                      } else if (xhr.status === 416) {
                          //  Tried to read off the end of the file.   This shouldn't happen, but if it does return an
                          handleError("Unsatisfiable range");
                      } else {
                          handleError(xhr.status);
                      }
                  }
              };

              xhr.onerror = function (event) {
                  if (isGoogleURL(url) && !options.retries) {
                      tryGoogleAuth();
                  } else {
                      handleError("Error accessing resource: " + url + " Status: " + xhr.status);
                  }
              };

              xhr.ontimeout = function (event) {
                  handleError("Timed out");
              };

              xhr.onabort = function (event) {
                  reject(event);
              };

              try {
                  xhr.send(sendData);
              } catch (e) {
                  if (isGoogleURL(url) && !options.retries) {
                      tryGoogleAuth();
                  } else {
                      handleError(e);
                  }
              }


              function handleError(error) {
                  if (reject) {
                      reject(error);
                  } else {
                      throw error
                  }
              }

              async function tryGoogleAuth() {
                  try {
                      const accessToken = await fetchGoogleAccessToken(url);
                      options.retries = 1;
                      options.oauthToken = accessToken;
                      const response = await self.load(url, options);
                      resolve(response);
                  } catch (e) {
                      if (e.error) {
                          const msg = e.error.startsWith("popup_blocked") ?
                              "Google login popup blocked by browser." :
                              e.error;
                          alert(msg);
                      } else {
                          handleError(e);
                      }
                  }
              }
          })

      }

      async _loadFileSlice(localfile, options) {

          let blob = (options && options.range) ?
              localfile.slice(options.range.start, options.range.start + options.range.size) :
              localfile;

          const arrayBuffer = await blob.arrayBuffer();

          if ("arraybuffer" === options.responseType) {
              return arrayBuffer
          } else {
              return arrayBufferToString(arrayBuffer)
          }
      }

      async _loadStringFromFile(localfile, options) {

          const blob = options.range ? localfile.slice(options.range.start, options.range.start + options.range.size) : localfile;
          const arrayBuffer = await blob.arrayBuffer();
          return arrayBufferToString(arrayBuffer)
      }

      async _loadStringFromUrl(url, options) {

          options = options || {};
          options.responseType = "arraybuffer";
          const data = await this.load(url, options);
          return arrayBufferToString(data)
      }

      /**
       * Explicity set an oAuth token for use with given host.  If host is undefined token is used for google api access*
       * @param token
       * @param host
       */
      setOauthToken(token, host) {
          this.oauth.setToken(token, host);
      }

      /**
       * Return an oauth token for the URL if we have one.  This method does not force sign-in, and the token may
       * or may not be valid.  Sign-in is triggered on request failure.
       * *
       * @param url
       * @returns {*}
       */
      getOauthToken(url) {

          // Google is the default provider, don't try to parse host for google URLs
          const host = isGoogleURL(url) ?
              undefined :
              parseUri(url).host;

          // First check the explicit settings (i.e. token set through the API)
          let token = this.oauth.getToken(host);
          if (token) {
              return token
          } else if (host === undefined) {
              // Now try Google oauth tokens previously obtained.  This will return undefined if google oauth is not
              // configured.
              const googleToken = getCurrentGoogleAccessToken();
              if (googleToken && googleToken.expires_at > Date.now()) {
                  return googleToken.access_token
              }
          }
      }
  }

  function isGoogleStorageSigned(url) {
      return url.indexOf("X-Goog-Signature") > -1
  }



  /**
   * Return a Google oAuth token, triggering a sign in if required.   This method should not be called until we know
   * a token is required, that is until we've tried the url and received a 401, 403, or 404.
   *
   * @param url
   * @returns the oauth token
   */
  async function fetchGoogleAccessToken(url) {
      if (isInitialized()) {
          const scope = getScopeForURL(url);
          const access_token = await getAccessToken(scope);
          return access_token
      } else {
          throw Error(
              `Authorization is required, but Google oAuth has not been initalized. Contact your site administrator for assistance.`)
      }
  }

  /**
   * Return the current google access token, if one exists.  Do not triger signOn or request additional scopes.
   * @returns {undefined|access_token}
   */
  function getCurrentGoogleAccessToken() {
      if (isInitialized()) {
          const access_token = getCurrentAccessToken();
          return access_token
      } else {
          return undefined
      }
  }

  function addOauthHeaders(headers, acToken) {
      if (acToken) {
          headers["Cache-Control"] = "no-cache";
          headers["Authorization"] = "Bearer " + acToken;
      }
      return headers
  }


  function addApiKey(url) {
      let apiKey = igvxhr.apiKey;
      if (!apiKey && typeof gapi !== "undefined") {
          apiKey = gapi.apiKey;
      }
      if (apiKey !== undefined && !url.includes("key=")) {
          const paramSeparator = url.includes("?") ? "&" : "?";
          url = url + paramSeparator + "key=" + apiKey;
      }
      return url
  }

  function addTeamDrive(url) {
      if (url.includes("supportsTeamDrive")) {
          return url
      } else {
          const paramSeparator = url.includes("?") ? "&" : "?";
          url = url + paramSeparator + "supportsTeamDrive=true";
      }
  }

  /**
   * Perform some well-known url mappings.
   * @param url
   */
  function mapUrl(url) {

      if (url.startsWith("https://www.dropbox.com")) {
          return url.replace("//www.dropbox.com", "//dl.dropboxusercontent.com")
      } else if (url.startsWith("https://drive.google.com")) {
          return getDriveDownloadURL(url)
      } else if (url.includes("//www.broadinstitute.org/igvdata")) {
          return url.replace("//www.broadinstitute.org/igvdata", "//data.broadinstitute.org/igvdata")
      } else if (url.includes("//igvdata.broadinstitute.org")) {
          return url.replace("//igvdata.broadinstitute.org", "//s3.amazonaws.com/igv.broadinstitute.org")
      } else if (url.includes("//igv.genepattern.org")) {
          return url.replace("//igv.genepattern.org", "//igv-genepattern-org.s3.amazonaws.com")
      } else if (url.startsWith("ftp://ftp.ncbi.nlm.nih.gov/geo")) {
          return url.replace("ftp://", "https://")
      } else {
          return url
      }
  }


  function arrayBufferToString(arraybuffer) {

      let plain;
      if (isgzipped(arraybuffer)) {
          plain = ungzip_blocks(arraybuffer);
      } else {
          plain = new Uint8Array(arraybuffer);
      }

      if ('TextDecoder' in getGlobalObject()) {
          return new TextDecoder().decode(plain)
      } else {
          return decodeUTF8(plain)
      }
  }

  /**
   * Use when TextDecoder is not available (primarily IE).
   *
   * From: https://gist.github.com/Yaffle/5458286
   *
   * @param octets
   * @returns {string}
   */
  function decodeUTF8(octets) {
      var string = "";
      var i = 0;
      while (i < octets.length) {
          var octet = octets[i];
          var bytesNeeded = 0;
          var codePoint = 0;
          if (octet <= 0x7F) {
              bytesNeeded = 0;
              codePoint = octet & 0xFF;
          } else if (octet <= 0xDF) {
              bytesNeeded = 1;
              codePoint = octet & 0x1F;
          } else if (octet <= 0xEF) {
              bytesNeeded = 2;
              codePoint = octet & 0x0F;
          } else if (octet <= 0xF4) {
              bytesNeeded = 3;
              codePoint = octet & 0x07;
          }
          if (octets.length - i - bytesNeeded > 0) {
              var k = 0;
              while (k < bytesNeeded) {
                  octet = octets[i + k + 1];
                  codePoint = (codePoint << 6) | (octet & 0x3F);
                  k += 1;
              }
          } else {
              codePoint = 0xFFFD;
              bytesNeeded = octets.length - i;
          }
          string += String.fromCodePoint(codePoint);
          i += bytesNeeded + 1;
      }
      return string
  }


  function getGlobalObject() {
      if (typeof self !== 'undefined') {
          return self
      }
      if (typeof global !== 'undefined') {
          return global
      } else {
          return window
      }
  }

  const igvxhr = new IGVXhr();

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2014 Broad Institute
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  /** An implementation of an interval tree, following the explanation.
   * from CLR.
   *
   * Public interface:
   *   Constructor  IntervalTree
   *   Insertion    insert
   *   Search       findOverlapping
   */

  var BLACK = 1;

  var NIL = {};
  NIL.color = BLACK;
  NIL.parent = NIL;
  NIL.left = NIL;
  NIL.right = NIL;

  /*
   *  Author: Jim Robinson, 2020
   *
   * Wrapper functions for the Google picker API
   *
   * PREQUISITES
   *    gapi loaded
   *    oauth2 loaded and initialized
   *
   * This wrapper is stateless -- this is important as multiple copies of igv-utils might be present
   * in an application.  All state is held in the gapi library itself.
   */

  async function init$1() {
      return new Promise(function (resolve, reject) {
          gapi.load("picker", {
              callback: resolve,
              onerror: reject
          });
      })
  }

  async function createDropdownButtonPicker(multipleFileSelection, filePickerHandler) {


      if(typeof gapi === "undefined") {
          throw Error("Google authentication requires the 'gapi' library")
      }

      if(typeof google === "undefined" || !google.picker) {
          await init$1();
      }

      // We fetch the "drive.readonly" scope because it is neccessary to enable downloading the file
      const access_token = await getAccessToken('https://www.googleapis.com/auth/drive.readonly');
      if (access_token) {

          const view = new google.picker.DocsView(google.picker.ViewId.DOCS);
          view.setIncludeFolders(true);

          const teamView = new google.picker.DocsView(google.picker.ViewId.DOCS);
          teamView.setEnableTeamDrives(true);
          teamView.setIncludeFolders(true);

          let picker;
          if (multipleFileSelection) {
              picker = new google.picker.PickerBuilder()
                  .enableFeature(google.picker.Feature.MULTISELECT_ENABLED)
                  .setOAuthToken(access_token)
                  .addView(view)
                  .addView(teamView)
                  .enableFeature(google.picker.Feature.SUPPORT_TEAM_DRIVES)
                  .setCallback(function (data) {
                      if (data[google.picker.Response.ACTION] === google.picker.Action.PICKED) {
                          filePickerHandler(data[google.picker.Response.DOCUMENTS]);
                      }
                  })
                  .build();

          } else {
              picker = new google.picker.PickerBuilder()
                  .disableFeature(google.picker.Feature.MULTISELECT_ENABLED)
                  .setOAuthToken(access_token)
                  .addView(view)
                  .addView(teamView)
                  .enableFeature(google.picker.Feature.SUPPORT_TEAM_DRIVES)
                  .setCallback(function (data) {
                      if (data[google.picker.Response.ACTION] === google.picker.Action.PICKED) {
                          filePickerHandler(data[google.picker.Response.DOCUMENTS]);
                      }
                  })
                  .build();

          }

          picker.setVisible(true);

      } else {
          throw Error("Sign into Google before using picker");
      }
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class FileLoadManager {

      constructor () {
          this.dictionary = {};
      }

      inputHandler (path, isIndexFile) {
          this.ingestPath(path, isIndexFile);
      }

      ingestPath (path, isIndexFile) {
          let key = true === isIndexFile ? 'index' : 'data';

          this.dictionary[ key ] = path.trim();
      }

      didDragDrop (dataTransfer) {
          var files;

          files = dataTransfer.files;

          return (files && files.length > 0);
      }

      dragDropHandler (dataTransfer, isIndexFile) {
          var url,
              files;

          url = dataTransfer.getData('text/uri-list');
          files = dataTransfer.files;

          if (files && files.length > 0) {
              this.ingestPath(files[ 0 ], isIndexFile);
          } else if (url && '' !== url) {
              this.ingestPath(url, isIndexFile);
          }

      }

      indexName () {
          return itemName(this.dictionary.index);
      }

      dataName () {
          return itemName(this.dictionary.data);
      }

      reset () {
          this.dictionary = {};
      }

  }

  function itemName (item) {
      return isFilePath(item) ? item.name : item;
  }

  function createIcon(name, color) {
      return iconMarkup(name, color);
  }

  function iconMarkup(name, color) {
      color = color || "currentColor";
      let icon = icons[name];
      if (!icon) {
          console.error(`No icon named: ${name}`);
          icon = icons["question"];
      }

      const svg = document.createElementNS("http://www.w3.org/2000/svg", "svg");
      svg.setAttributeNS(null,'viewBox', '0 0 ' + icon[0] + ' ' + icon[1]);
      const path = document.createElementNS("http://www.w3.org/2000/svg", "path");
      path.setAttributeNS(null,'fill',  color );
      path.setAttributeNS(null,'d', icon[4]);
      svg.appendChild(path);
      return svg;
  }

  const icons = {
      "check": [512, 512, [], "f00c", "M173.898 439.404l-166.4-166.4c-9.997-9.997-9.997-26.206 0-36.204l36.203-36.204c9.997-9.998 26.207-9.998 36.204 0L192 312.69 432.095 72.596c9.997-9.997 26.207-9.997 36.204 0l36.203 36.204c9.997 9.997 9.997 26.206 0 36.204l-294.4 294.401c-9.998 9.997-26.207 9.997-36.204-.001z"],
      "cog": [512, 512, [], "f013", "M444.788 291.1l42.616 24.599c4.867 2.809 7.126 8.618 5.459 13.985-11.07 35.642-29.97 67.842-54.689 94.586a12.016 12.016 0 0 1-14.832 2.254l-42.584-24.595a191.577 191.577 0 0 1-60.759 35.13v49.182a12.01 12.01 0 0 1-9.377 11.718c-34.956 7.85-72.499 8.256-109.219.007-5.49-1.233-9.403-6.096-9.403-11.723v-49.184a191.555 191.555 0 0 1-60.759-35.13l-42.584 24.595a12.016 12.016 0 0 1-14.832-2.254c-24.718-26.744-43.619-58.944-54.689-94.586-1.667-5.366.592-11.175 5.459-13.985L67.212 291.1a193.48 193.48 0 0 1 0-70.199l-42.616-24.599c-4.867-2.809-7.126-8.618-5.459-13.985 11.07-35.642 29.97-67.842 54.689-94.586a12.016 12.016 0 0 1 14.832-2.254l42.584 24.595a191.577 191.577 0 0 1 60.759-35.13V25.759a12.01 12.01 0 0 1 9.377-11.718c34.956-7.85 72.499-8.256 109.219-.007 5.49 1.233 9.403 6.096 9.403 11.723v49.184a191.555 191.555 0 0 1 60.759 35.13l42.584-24.595a12.016 12.016 0 0 1 14.832 2.254c24.718 26.744 43.619 58.944 54.689 94.586 1.667 5.366-.592 11.175-5.459 13.985L444.788 220.9a193.485 193.485 0 0 1 0 70.2zM336 256c0-44.112-35.888-80-80-80s-80 35.888-80 80 35.888 80 80 80 80-35.888 80-80z"],
      "exclamation": [192, 512, [], "f12a", "M176 432c0 44.112-35.888 80-80 80s-80-35.888-80-80 35.888-80 80-80 80 35.888 80 80zM25.26 25.199l13.6 272C39.499 309.972 50.041 320 62.83 320h66.34c12.789 0 23.331-10.028 23.97-22.801l13.6-272C167.425 11.49 156.496 0 142.77 0H49.23C35.504 0 24.575 11.49 25.26 25.199z"],
      "exclamation-circle": [512, 512, [], "f06a", "M504 256c0 136.997-111.043 248-248 248S8 392.997 8 256C8 119.083 119.043 8 256 8s248 111.083 248 248zm-248 50c-25.405 0-46 20.595-46 46s20.595 46 46 46 46-20.595 46-46-20.595-46-46-46zm-43.673-165.346l7.418 136c.347 6.364 5.609 11.346 11.982 11.346h48.546c6.373 0 11.635-4.982 11.982-11.346l7.418-136c.375-6.874-5.098-12.654-11.982-12.654h-63.383c-6.884 0-12.356 5.78-11.981 12.654z"],
      "exclamation-triangle": [576, 512, [], "f071", "M569.517 440.013C587.975 472.007 564.806 512 527.94 512H48.054c-36.937 0-59.999-40.055-41.577-71.987L246.423 23.985c18.467-32.009 64.72-31.951 83.154 0l239.94 416.028zM288 354c-25.405 0-46 20.595-46 46s20.595 46 46 46 46-20.595 46-46-20.595-46-46-46zm-43.673-165.346l7.418 136c.347 6.364 5.609 11.346 11.982 11.346h48.546c6.373 0 11.635-4.982 11.982-11.346l7.418-136c.375-6.874-5.098-12.654-11.982-12.654h-63.383c-6.884 0-12.356 5.78-11.981 12.654z"],
      "minus": [448, 512, [], "f068", "M424 318.2c13.3 0 24-10.7 24-24v-76.4c0-13.3-10.7-24-24-24H24c-13.3 0-24 10.7-24 24v76.4c0 13.3 10.7 24 24 24h400z"],
      "minus-circle": [512, 512, [], "f056", "M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zM124 296c-6.6 0-12-5.4-12-12v-56c0-6.6 5.4-12 12-12h264c6.6 0 12 5.4 12 12v56c0 6.6-5.4 12-12 12H124z"],
      "minus-square": [448, 512, [], "f146", "M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48zM92 296c-6.6 0-12-5.4-12-12v-56c0-6.6 5.4-12 12-12h264c6.6 0 12 5.4 12 12v56c0 6.6-5.4 12-12 12H92z"],
      "plus": [448, 512, [], "f067", "M448 294.2v-76.4c0-13.3-10.7-24-24-24H286.2V56c0-13.3-10.7-24-24-24h-76.4c-13.3 0-24 10.7-24 24v137.8H24c-13.3 0-24 10.7-24 24v76.4c0 13.3 10.7 24 24 24h137.8V456c0 13.3 10.7 24 24 24h76.4c13.3 0 24-10.7 24-24V318.2H424c13.3 0 24-10.7 24-24z"],
      "plus-circle": [512, 512, [], "f055", "M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zm144 276c0 6.6-5.4 12-12 12h-92v92c0 6.6-5.4 12-12 12h-56c-6.6 0-12-5.4-12-12v-92h-92c-6.6 0-12-5.4-12-12v-56c0-6.6 5.4-12 12-12h92v-92c0-6.6 5.4-12 12-12h56c6.6 0 12 5.4 12 12v92h92c6.6 0 12 5.4 12 12v56z"],
      "plus-square": [448, 512, [], "f0fe", "M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48zm-32 252c0 6.6-5.4 12-12 12h-92v92c0 6.6-5.4 12-12 12h-56c-6.6 0-12-5.4-12-12v-92H92c-6.6 0-12-5.4-12-12v-56c0-6.6 5.4-12 12-12h92v-92c0-6.6 5.4-12 12-12h56c6.6 0 12 5.4 12 12v92h92c6.6 0 12 5.4 12 12v56z"],
      "question": [384, 512, [], "f128", "M202.021 0C122.202 0 70.503 32.703 29.914 91.026c-7.363 10.58-5.093 25.086 5.178 32.874l43.138 32.709c10.373 7.865 25.132 6.026 33.253-4.148 25.049-31.381 43.63-49.449 82.757-49.449 30.764 0 68.816 19.799 68.816 49.631 0 22.552-18.617 34.134-48.993 51.164-35.423 19.86-82.299 44.576-82.299 106.405V320c0 13.255 10.745 24 24 24h72.471c13.255 0 24-10.745 24-24v-5.773c0-42.86 125.268-44.645 125.268-160.627C377.504 66.256 286.902 0 202.021 0zM192 373.459c-38.196 0-69.271 31.075-69.271 69.271 0 38.195 31.075 69.27 69.271 69.27s69.271-31.075 69.271-69.271-31.075-69.27-69.271-69.27z"],
      "save": [448, 512, [], "f0c7", "M433.941 129.941l-83.882-83.882A48 48 0 0 0 316.118 32H48C21.49 32 0 53.49 0 80v352c0 26.51 21.49 48 48 48h352c26.51 0 48-21.49 48-48V163.882a48 48 0 0 0-14.059-33.941zM224 416c-35.346 0-64-28.654-64-64 0-35.346 28.654-64 64-64s64 28.654 64 64c0 35.346-28.654 64-64 64zm96-304.52V212c0 6.627-5.373 12-12 12H76c-6.627 0-12-5.373-12-12V108c0-6.627 5.373-12 12-12h228.52c3.183 0 6.235 1.264 8.485 3.515l3.48 3.48A11.996 11.996 0 0 1 320 111.48z"],
      "search": [512, 512, [], "f002", "M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z"],
      "share": [512, 512, [], "f064", "M503.691 189.836L327.687 37.851C312.281 24.546 288 35.347 288 56.015v80.053C127.371 137.907 0 170.1 0 322.326c0 61.441 39.581 122.309 83.333 154.132 13.653 9.931 33.111-2.533 28.077-18.631C66.066 312.814 132.917 274.316 288 272.085V360c0 20.7 24.3 31.453 39.687 18.164l176.004-152c11.071-9.562 11.086-26.753 0-36.328z"],
      "spinner": [512, 512, [], "f110", "M304 48c0 26.51-21.49 48-48 48s-48-21.49-48-48 21.49-48 48-48 48 21.49 48 48zm-48 368c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.49-48-48-48zm208-208c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.49-48-48-48zM96 256c0-26.51-21.49-48-48-48S0 229.49 0 256s21.49 48 48 48 48-21.49 48-48zm12.922 99.078c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48c0-26.509-21.491-48-48-48zm294.156 0c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48c0-26.509-21.49-48-48-48zM108.922 60.922c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.491-48-48-48z"],
      "square": [448, 512, [], "f0c8", "M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48z"],
      "square-full": [512, 512, [], "f45c", "M512 512H0V0h512v512z"],
      "times": [384, 512, [], "f00d", "M323.1 441l53.9-53.9c9.4-9.4 9.4-24.5 0-33.9L279.8 256l97.2-97.2c9.4-9.4 9.4-24.5 0-33.9L323.1 71c-9.4-9.4-24.5-9.4-33.9 0L192 168.2 94.8 71c-9.4-9.4-24.5-9.4-33.9 0L7 124.9c-9.4 9.4-9.4 24.5 0 33.9l97.2 97.2L7 353.2c-9.4 9.4-9.4 24.5 0 33.9L60.9 441c9.4 9.4 24.5 9.4 33.9 0l97.2-97.2 97.2 97.2c9.3 9.3 24.5 9.3 33.9 0z"],
      "times-circle": [512, 512, [], "f057", "M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zm121.6 313.1c4.7 4.7 4.7 12.3 0 17L338 377.6c-4.7 4.7-12.3 4.7-17 0L256 312l-65.1 65.6c-4.7 4.7-12.3 4.7-17 0L134.4 338c-4.7-4.7-4.7-12.3 0-17l65.6-65-65.6-65.1c-4.7-4.7-4.7-12.3 0-17l39.6-39.6c4.7-4.7 12.3-4.7 17 0l65 65.7 65.1-65.6c4.7-4.7 12.3-4.7 17 0l39.6 39.6c4.7 4.7 4.7 12.3 0 17L312 256l65.6 65.1z"],
      "wrench": [512, 512, [], "f0ad", "M481.156 200c9.3 0 15.12 10.155 10.325 18.124C466.295 259.992 420.419 288 368 288c-79.222 0-143.501-63.974-143.997-143.079C223.505 65.469 288.548-.001 368.002 0c52.362.001 98.196 27.949 123.4 69.743C496.24 77.766 490.523 88 481.154 88H376l-40 56 40 56h105.156zm-171.649 93.003L109.255 493.255c-24.994 24.993-65.515 24.994-90.51 0-24.993-24.994-24.993-65.516 0-90.51L218.991 202.5c16.16 41.197 49.303 74.335 90.516 90.503zM104 432c0-13.255-10.745-24-24-24s-24 10.745-24 24 10.745 24 24 24 24-10.745 24-24z"],
  };

  function attachDialogCloseHandlerWithParent(parent, closeHandler) {

      var container = document.createElement("div");
      parent.appendChild(container);
      container.appendChild(createIcon("times"));
      container.addEventListener('click', function (e) {
          e.preventDefault();
          e.stopPropagation();
          closeHandler();
      });
  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  class FileLoadWidget {

      constructor({ widgetParent, dataTitle, indexTitle, mode, fileLoadManager, dataOnly, doURL }) {

          dataTitle = dataTitle || 'Data';

          indexTitle = indexTitle || 'Index';

          this.fileLoadManager = fileLoadManager;

          dataOnly = dataOnly || false;

          // TODO: Remove?
          doURL = doURL || false;

          // file load widget
          this.container = div({ class: 'igv-file-load-widget-container'});
          widgetParent.appendChild(this.container);

          let config;
          if ('localFile' === mode) {
              // local data/index
              config =
                  {
                      parent: this.container,
                      doURL: false,
                      dataTitle: dataTitle + ' file',
                      indexTitle: indexTitle + ' file',
                      dataOnly
                  };
          } else {

              // url data/index
              config =
                  {
                      parent: this.container,
                      doURL: true,
                      dataTitle: dataTitle + ' URL',
                      indexTitle: indexTitle + ' URL',
                      dataOnly
                  };
          }

          this.createInputContainer(config);

          // error message container
          this.error_message = div({ class: 'igv-flw-error-message-container'});
          this.container.appendChild(this.error_message);

          // error message
          this.error_message.appendChild(div({ class: 'igv-flw-error-message'}));

          // error dismiss button
          attachDialogCloseHandlerWithParent(this.error_message, () => {
              this.dismissErrorMessage();
          });

          this.dismissErrorMessage();

      }

      retrievePaths() {

          this.fileLoadManager.ingestPath(this.inputData.value, false);
          if (this.inputIndex) {
              this.fileLoadManager.ingestPath(this.inputIndex.value, true);
          }

          let paths = [];
          if (this.fileLoadManager.dictionary) {

              if (this.fileLoadManager.dictionary.data) {
                  paths.push(this.fileLoadManager.dictionary.data);
              }
              if (this.fileLoadManager.dictionary.index) {
                  paths.push(this.fileLoadManager.dictionary.index);
              }
          }

          // clear input elements
          this.container.querySelectorAll('.igv-flw-input-row').forEach(div => {
              div.querySelector('input').value = '';
          });

          return paths;

      }

      presentErrorMessage(message) {
          this.error_message.querySelector('.igv-flw-error-message').textContent = message;
          show(this.error_message);
      }

      dismissErrorMessage() {
          hide(this.error_message);
          this.error_message.querySelector('.igv-flw-error-message').textContent = '';
      }

      present() {
          show(this.container);
      }

      dismiss() {

          this.dismissErrorMessage();

          // const e = this.container.querySelector('.igv-flw-local-file-name-container');
          // if (e) {
          //     DOMUtils.hide(e);
          // }

          // clear input elements
          this.container.querySelectorAll('.igv-flw-input-row').forEach(div => {
              div.querySelector('input').value = '';
          });

          this.fileLoadManager.reset();

      }

      createInputContainer({ parent, doURL, dataTitle, indexTitle, dataOnly }) {

          // container
          const container = div({ class: 'igv-flw-input-container' });
          parent.appendChild(container);

          // data
          const input_data_row = div({ class: 'igv-flw-input-row' });
          container.appendChild(input_data_row);

          let label;

          // label
          label = div({ class: 'igv-flw-input-label' });
          input_data_row.appendChild(label);
          label.textContent = dataTitle;

          if (true === doURL) {
              this.createURLContainer(input_data_row, 'igv-flw-data-url', false);
          } else {
              this.createLocalFileContainer(input_data_row, 'igv-flw-local-data-file', false);
          }

          if (true === dataOnly) {
              return;
          }

          // index
          const input_index_row = div({ class: 'igv-flw-input-row' });
          container.appendChild(input_index_row);

          // label
          label = div({ class: 'igv-flw-input-label' });
          input_index_row.appendChild(label);
          label.textContent = indexTitle;

          if (true === doURL) {
              this.createURLContainer(input_index_row, 'igv-flw-index-url', true);
          } else {
              this.createLocalFileContainer(input_index_row, 'igv-flw-local-index-file', true);
          }

      }

      createURLContainer(parent, id, isIndexFile) {

          const input = create('input');
          input.setAttribute('type', 'text');
          // input.setAttribute('placeholder', (true === isIndexFile ? 'Enter index URL' : 'Enter data URL'));
          parent.appendChild(input);

          if (isIndexFile) {
              this.inputIndex = input;
          } else {
              this.inputData = input;
          }

      }

      createLocalFileContainer(parent, id, isIndexFile) {

          const file_chooser_container = div({ class: 'igv-flw-file-chooser-container'});
          parent.appendChild(file_chooser_container);

          const str = `${ id }${ guid$1() }`;

          const label = create('label');
          label.setAttribute('for', str);

          file_chooser_container.appendChild(label);
          label.textContent = 'Choose file';

          const input = create('input', { class: 'igv-flw-file-chooser-input'});
          input.setAttribute('id', str);
          input.setAttribute('name', str);
          input.setAttribute('type', 'file');
          file_chooser_container.appendChild(input);

          const file_name = div({ class: 'igv-flw-local-file-name-container' });
          parent.appendChild(file_name);

          hide(file_name);

          input.addEventListener('change', e => {

              this.dismissErrorMessage();

              const file = e.target.files[ 0 ];
              this.fileLoadManager.inputHandler(file, isIndexFile);

              const { name } = file;
              file_name.textContent = name;
              file_name.setAttribute('title', name);
              show(file_name);
          });

      }

  }

  class FileLoad {

      constructor({ localFileInput, initializeDropbox, dropboxButton, googleEnabled, googleDriveButton }) {

          localFileInput.addEventListener('change', async () => {

              if (true === FileLoad.isValidLocalFileInput(localFileInput)) {

                  try {
                      await this.loadPaths( Array.from(localFileInput.files) );
                  } catch (e) {
                      console.error(e);
                      AlertSingleton$1.present(e);
                  }
                  localFileInput.value = '';
              }

          });

          if (dropboxButton) dropboxButton.addEventListener('click', async () => {

              const result = await initializeDropbox();

              if (true === result) {

                  const config =
                      {
                          success: async dbFiles => {
                              try {
                                  await this.loadPaths( dbFiles.map(dbFile => dbFile.link) );
                              } catch (e) {
                                  console.error(e);
                                  AlertSingleton$1.present(e);
                              }
                          },
                          cancel: () => {},
                          linkType: 'preview',
                          multiselect: true,
                          folderselect: false,
                      };

                  Dropbox.choose( config );

              } else {
                  AlertSingleton$1.present('Cannot connect to Dropbox');
              }

          });


          if (false === googleEnabled) {
              hide(googleDriveButton.parentElement);
          }

          if (true === googleEnabled && googleDriveButton) {

              googleDriveButton.addEventListener('click', () => {
                  createDropdownButtonPicker(true, async responses => {

                      try {
                          await this.loadPaths(responses.map(({ url }) => url));
                      } catch (e) {
                          console.error(e);
                          AlertSingleton$1.present(e);
                      }
                  });
              });

          }

      }

      async loadPaths(paths) {
          //console.log('FileLoad: loadPaths(...)');
      }

      static isValidLocalFileInput(input) {
          return (input.files && input.files.length > 0);
      }

  }

  /*
   *  The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
   * associated documentation files (the "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
   * following conditions:
   *
   * The above copyright notice and this permission notice shall be included in all copies or substantial
   * portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
   * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND
   * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
   * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   *
   */

  class MultipleTrackFileLoad {

      constructor({
                      $localFileInput,
                      initializeDropbox,
                      $dropboxButton,
                      $googleDriveButton,
                      fileLoadHandler,
                      multipleFileSelection
                  }) {

          this.fileLoadHandler = fileLoadHandler;

          const localFileInput = $localFileInput.get(0);
          const dropboxButton = $dropboxButton ? $dropboxButton.get(0) : undefined;
          const googleDriveButton = $googleDriveButton ? $googleDriveButton.get(0) : undefined;

          localFileInput.addEventListener('change', async () => {

              if (true === MultipleTrackFileLoad.isValidLocalFileInput(localFileInput)) {
                  const {files} = localFileInput;
                  const paths = Array.from(files);
                  localFileInput.value = '';
                  await this.loadPaths(paths);
              }

          });

          if (dropboxButton) dropboxButton.addEventListener('click', async () => {

              const result = await initializeDropbox();

              if (true === result) {

                  const obj =
                      {
                          success: dbFiles => this.loadPaths(dbFiles.map(({link}) => link)),
                          cancel: () => {
                          },
                          linkType: "preview",
                          multiselect: multipleFileSelection,
                          folderselect: false,
                      };

                  Dropbox.choose(obj);

              } else {
                  AlertSingleton$1.present('Cannot connect to Dropbox');
              }
          });


          if (googleDriveButton) {

              googleDriveButton.addEventListener('click', () => {
                  createDropdownButtonPicker(multipleFileSelection,
                      async responses => await this.loadPaths(responses.map(({
                                                                                 name,
                                                                                 url
                                                                             }) => url)));
              });

          }

      }

      async loadPaths(paths) {
          await ingestPaths({paths, fileLoadHandler: this.fileLoadHandler});
      }

      static isValidLocalFileInput(input) {
          return (input.files && input.files.length > 0)
      }

      static async getFilename(path) {

          if (path instanceof File) {
              return path.name
          } else if (isGoogleDriveURL(path)) {
              const info = await getDriveFileInfo(path);
              return info.name || info.originalFileName
          } else {
              const result = parseUri(path);
              return result.file
          }

      }

      static isGoogleDrivePath(path) {
          return path instanceof File ? false : isGoogleDriveURL(path)
      }

  }

  async function ingestPaths({paths, fileLoadHandler}) {
      try {
          // Search for index files  (.bai, .csi, .tbi, .idx)
          const indexLUT = new Map();

          const dataPaths = [];
          for (let path of paths) {

              const name = await MultipleTrackFileLoad.getFilename(path);
              const extension = getExtension(name);

              if (indexExtensions.has(extension)) {

                  // key is the data file name
                  const key = createIndexLUTKey(name, extension);
                  indexLUT.set(key, {
                      indexURL: path,
                      indexFilename: MultipleTrackFileLoad.isGoogleDrivePath(path) ? name : undefined
                  });
              } else {
                  dataPaths.push(path);
              }

          }

          const configurations = [];

          for (let dataPath of dataPaths) {

              const filename = await MultipleTrackFileLoad.getFilename(dataPath);

              if (indexLUT.has(filename)) {

                  const {indexURL, indexFilename} = indexLUT.get(filename);
                  configurations.push({url: dataPath, filename, indexURL, indexFilename, name: filename,  _derivedName: true});

              } else if (requireIndex.has(getExtension(filename))) {
                  throw new Error(`Unable to load track file ${filename} - you must select both ${filename} and its corresponding index file`)
              } else {
                  configurations.push({url: dataPath, filename, name: filename,  _derivedName: true});
              }

          }

          if (configurations) {
              fileLoadHandler(configurations);
          }

      } catch (e) {
          console.error(e);
          AlertSingleton$1.present(e.message);
      }
  }

  const indexExtensions = new Set(['bai', 'csi', 'tbi', 'idx', 'crai', 'fai']);

  const requireIndex = new Set(['bam', 'cram', 'fa', 'fasta']);

  const createIndexLUTKey = (name, extension) => {

      let key = name.substring(0, name.length - (extension.length + 1));

      // bam and cram files (.bai, .crai) have 2 conventions:
      // <data>.bam.bai
      // <data>.bai - we will support this one

      if ('bai' === extension && !key.endsWith('bam')) {
          return `${key}.bam`
      } else if ('crai' === extension && !key.endsWith('cram')) {
          return `${key}.cram`
      } else {
          return key
      }

  };

  const singleSet = new Set([ 'json' ]);
  const indexSet = new Set(['fai']);

  class GenomeFileLoad extends FileLoad {

      constructor({ localFileInput, initializeDropbox, dropboxButton, googleEnabled, googleDriveButton, loadHandler }) {
          super({ localFileInput, initializeDropbox, dropboxButton, googleEnabled, googleDriveButton });
          this.loadHandler = loadHandler;
      }

      async loadPaths(paths) {

          const status = await GenomeFileLoad.isGZip(paths);

          if (true === status) {
              throw new Error('Genome did not load - gzip file is not allowed')
          } else {

              // If one of the paths is .json, unpack and send to loader
              const single = paths.filter(path => singleSet.has( getExtension(path) ));

              let configuration = undefined;

              if (single.length >= 1) {
                  configuration = await igvxhr.loadJson(single[ 0 ]);
              } else if (2 === paths.length) {
                  const [ _0, _1 ] = await GenomeFileLoad.getExtension(paths);
                  if (indexSet.has(_0)) {
                      configuration = { fastaURL: paths[ 1 ], indexURL: paths[ 0 ] };
                  } else if (indexSet.has(_1)) {
                      configuration = { fastaURL: paths[ 0 ], indexURL: paths[ 1 ] };
                  }
              }

              if (undefined === configuration) {
                  throw new Error('Genome requires either a single JSON file or a FASTA file & index file')
              } else {
                  this.loadHandler(configuration);
              }


          }

      }

      static async isGZip(paths) {

          for (let path of paths) {
              const filename = await MultipleTrackFileLoad.getFilename(path);
              if (true === filename.endsWith('.gz')) {
                  return true
              }
          }

          return false
      }

      static async getExtension(paths) {

          const a = await MultipleTrackFileLoad.getFilename(paths[ 0 ]);
          const b = await MultipleTrackFileLoad.getFilename(paths[ 1 ]);

          return [a, b].map(name => getExtension(name))

      }


  }

  class SessionFileLoad extends FileLoad {

      constructor({ localFileInput, initializeDropbox, dropboxButton, googleEnabled, googleDriveButton, loadHandler }) {
          super({ localFileInput, initializeDropbox, dropboxButton, googleEnabled, googleDriveButton });
          this.loadHandler = loadHandler;
      }

      async loadPaths(paths) {

          const path = paths[ 0 ];

          if ('json' === getExtension(path)) {

              const json = await igvxhr.loadJson((path.google_url || path));
              this.loadHandler(json);
          } else if (true === isGoogleURL(path)) {

              this.loadHandler({ url: path });
          } else if ('xml' === getExtension(path)) {

              const key = true === isFilePath(path) ? 'file' : 'url';
              const o = {};
              o[ key ] = path;

              this.loadHandler(o);
          } else {
              throw new Error('Session file did not load - invalid format')
          }

      };

  }

  /*
   *  The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
   * associated documentation files (the "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
   * following conditions:
   *
   * The above copyright notice and this permission notice shall be included in all copies or substantial
   * portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
   * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND
   * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
   * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   *
   */

  function configureModal  (fileLoadWidget, modal, okHandler) {

      const doDismiss = () => {
          fileLoadWidget.dismiss();
          $(modal).modal('hide');
      };

      const doOK = async () => {

          const result = await okHandler(fileLoadWidget);

          if (true === result) {
              fileLoadWidget.dismiss();
              $(modal).modal('hide');
          }
      };

      let dismiss;

      // upper dismiss - x - button
      dismiss = modal.querySelector('.modal-header button');
      dismiss.addEventListener('click', doDismiss);

      // lower dismiss - close - button
      dismiss = modal.querySelector('.modal-footer button:nth-child(1)');
      dismiss.addEventListener('click', doDismiss);

      // ok - button
      const ok = modal.querySelector('.modal-footer button:nth-child(2)');

      ok.addEventListener('click', doOK);

      modal.addEventListener('keypress', event => {
          if ('Enter' === event.key) {
              doOK();
          }
      });
  }

  var utils = /*#__PURE__*/Object.freeze({
      __proto__: null,
      configureModal: configureModal
  });

  function createURLModal(id, title){

      const html =
          `<div id="${ id }" class="modal">

            <div class="modal-dialog modal-lg">
    
                <div class="modal-content">
    
                    <div class="modal-header">
                        <div class="modal-title">${ title }</div>
    
                        <button type="button" class="close" data-dismiss="modal">
                            <span>&times;</span>
                        </button>
    
                    </div>
    
                    <div class="modal-body">
                    </div>
    
                    <div class="modal-footer">
                        <button type="button" class="btn btn-sm btn-outline-secondary" data-dismiss="modal">Cancel</button>
                        <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">OK</button>
                    </div>
    
                </div>
    
            </div>

        </div>`;

      const fragment = document.createRange().createContextualFragment(html);

      return fragment.firstChild;
  }

  let fileLoadWidget$1;

  function createSessionWidgets($rootContainer,
                                prefix,
                                localFileInputId,
                                initializeDropbox,
                                dropboxButtonId,
                                googleDriveButtonId,
                                urlModalId,
                                sessionSaveModalId,
                                googleEnabled,
                                loadHandler,
                                JSONProvider) {

      const urlModal = createURLModal(urlModalId, 'Session URL');
      $rootContainer.get(0).appendChild(urlModal);

      if (!googleEnabled) {
          $(`#${googleDriveButtonId}`).parent().hide();
      }

      const fileLoadWidgetConfig =
          {
              widgetParent: urlModal.querySelector('.modal-body'),
              dataTitle: 'Session',
              indexTitle: undefined,
              mode: 'url',
              fileLoadManager: new FileLoadManager(),
              dataOnly: true,
              doURL: undefined
          };

      fileLoadWidget$1 = new FileLoadWidget(fileLoadWidgetConfig);

      const sessionFileLoadConfig =
          {
              localFileInput: document.querySelector(`#${localFileInputId}`),
              initializeDropbox,
              dropboxButton: dropboxButtonId ? document.querySelector(`#${dropboxButtonId}`) : undefined,
              googleEnabled,
              googleDriveButton: document.querySelector(`#${googleDriveButtonId}`),
              loadHandler
          };

      const sessionFileLoad = new SessionFileLoad(sessionFileLoadConfig);

      configureModal(fileLoadWidget$1, urlModal, async fileLoadWidget => {
          await sessionFileLoad.loadPaths(fileLoadWidget.retrievePaths());
          return true;
      });

      configureSaveSessionModal($rootContainer, prefix, JSONProvider, sessionSaveModalId);

  }

  function configureSaveSessionModal($rootContainer, prefix, JSONProvider, sessionSaveModalId) {

      const modal =
          `<div id="${sessionSaveModalId}" class="modal fade igv-app-file-save-modal">

            <div class="modal-dialog modal-lg">
    
                <div class="modal-content">
    
                    <div class="modal-header">
    
                        <div class="modal-title">
                            <div>
                                Save Session File
                            </div>
                        </div>
    
                        <button type="button" class="close" data-dismiss="modal">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
    
                    <div class="modal-body">
                        <input class="form-control" type="text" placeholder="igv-app-session.json">
    
                        <div>
                            Enter session filename with .json suffix
                        </div>
    
                    </div>
    
                    <div class="modal-footer">
                        <button type="button" class="btn btn-sm btn-outline-secondary" data-dismiss="modal">Cancel</button>
                        <button type="button" class="btn btn-sm btn-secondary">OK</button>
                    </div>
    
                </div>
    
            </div>
    
        </div>`;

      const $modal = $(modal);
      $rootContainer.append($modal);

      let $input = $modal.find('input');

      let okHandler = () => {

          const extensions = new Set(['json', 'xml']);

          let filename = $input.val();

          if (undefined === filename || '' === filename) {
              filename = $input.attr('placeholder');
          } else if (false === extensions.has(getExtension(filename))) {
              filename = filename + '.json';
          }

          const json = JSONProvider();

          if (json) {
              const jsonString = JSON.stringify(json, null, '\t');
              const data = URL.createObjectURL(new Blob([jsonString], {type: "application/octet-stream"}));
              download(filename, data);
          }

          $modal.modal('hide');
      };

      const $ok = $modal.find('.modal-footer button:nth-child(2)');
      $ok.on('click', okHandler);

      $modal.on('show.bs.modal', (e) => {
          $input.val(`${prefix}-session.json`);
      });

      $input.on('keyup', e => {

          // enter key
          if (13 === e.keyCode) {
              okHandler();
          }
      });

  }

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  const getDataWrapper = function (data) {

      if (typeof(data) == 'string' || data instanceof String) {
          return new StringDataWrapper(data);
      } else {
          return new ByteArrayDataWrapper(data);
      }
  };


  // Data might be a string, or an UInt8Array
  var StringDataWrapper = function (string) {
      this.data = string;
      this.ptr = 0;
  };

  StringDataWrapper.prototype.nextLine = function () {
      //return this.split(/\r\n|\n|\r/gm);
      var start = this.ptr,
          idx = this.data.indexOf('\n', start);

      if (idx > 0) {
          this.ptr = idx + 1;   // Advance pointer for next line
          return idx === start ? undefined : this.data.substring(start, idx).trim();
      }
      else {
          // Last line
          this.ptr = this.data.length;
          return (start >= this.data.length) ? undefined : this.data.substring(start).trim();
      }
  };

  // For use in applications where whitespace carries meaning
  // Returns "" for an empty row (not undefined like nextLine), since this is needed in AED
  StringDataWrapper.prototype.nextLineNoTrim = function () {
      var start = this.ptr,
          idx = this.data.indexOf('\n', start),
          data = this.data;

      if (idx > 0) {
          this.ptr = idx + 1;   // Advance pointer for next line
          if (idx > start && data.charAt(idx - 1) === '\r') {
              // Trim CR manually in CR/LF sequence
              return data.substring(start, idx - 1);
          }
          return data.substring(start, idx);
      }
      else {
          var length = data.length;
          this.ptr = length;
          // Return undefined only at the very end of the data
          return (start >= length) ? undefined : data.substring(start);
      }
  };

  var ByteArrayDataWrapper = function (array) {
      this.data = array;
      this.length = this.data.length;
      this.ptr = 0;
  };

  ByteArrayDataWrapper.prototype.nextLine = function () {

      var c, result;
      result = "";

      if (this.ptr >= this.length) return undefined;

      for (var i = this.ptr; i < this.length; i++) {
          c = String.fromCharCode(this.data[i]);
          if (c === '\r') continue;
          if (c === '\n') break;
          result = result + c;
      }

      this.ptr = i + 1;
      return result;
  };

  // The ByteArrayDataWrapper does not do any trimming by default, can reuse the function
  ByteArrayDataWrapper.prototype.nextLineNoTrim = ByteArrayDataWrapper.prototype.nextLine;

  // Default string loader implementation

  var stringLoader = {
      loadString: async (path, options) => {
              options = options || {};
              if (path instanceof File) {
                  const blob = options.range ? path.slice(options.range.start, options.range.start + options.range.size) : path;
                  return blob.text()
              } else {
                  const response = await fetch(path);
                  return response.text()
              }
      },

      loadJson: async function (url, options) {
          const result = await this.loadString(url, options);
          if (result) {
              return JSON.parse(result)
          } else {
              return result
          }
      }
  };

  const delimiters = new Set(['\t', ',']);

  class GenericDataSource {

      constructor(config) {

          this.stringLoader = config.igvxhr ? config.igvxhr : stringLoader;
          this.columns = config.columns;   // Required for now, could default to all columns
          this.columnDefs = config.columnDefs;       // optional
          this.rowHandler = config.rowHandler;// optional

          this.delimiter = undefined;
          if (config.delimiter) {
              this.delimiter = config.delimiter;
          }

          if (config.data) {
              this.data = config.data;  // Explcitly set table rows as array of json objects
          } else {
              this.url = config.url;     // URL to data source -- required
              this.isJSON = config.isJSON || false;   // optional, defaults to false (tab delimited)
              this.parser = config.parser;                   // optional
              this.filter = config.filter;             // optional
              this.sort = config.sort;                // optional
          }
      }

      async tableColumns() {
          return this.columns
      }

      async tableData() {

          if (undefined === this.data) {

              let str = undefined;
              try {
                  str = await this.stringLoader.loadString(this.url);
              } catch (e) {
                  console.error(e);
                  return undefined
              }

              if (str) {

                  let records;
                  if (this.parser) {
                      records = this.parser.parse(str);
                  } else if (this.isJSON) {
                      records = JSON.parse(str);
                      if (typeof this.filter === 'function') {
                          records = records.filter(this.filter);
                      }
                  } else {
                      records = this.parseTabData(str, this.filter);
                  }

                  if (typeof this.sort === 'function') {
                      records.sort(this.sort);
                  }

                  // this.data = records
                  return records
              }
          } else if (Array.isArray(this.data)) {
              return this.data
          } else if ('json' === GenericDataSource.getExtension(this.data) || delimiters.has(getDelimiter(this.data, this.delimiter))) {

              const extension = GenericDataSource.getExtension(this.data);
              const delimiter = getDelimiter(this.data, this.delimiter);

              let result;
              try {
                  result = 'json' === extension ? await this.stringLoader.loadJson(this.data) : await this.stringLoader.loadString(this.data);
              } catch (e) {
                  console.error(e);
                  return undefined
              }

              if (result) {

                  if ('json' === extension) {
                      return result
                  } else if (delimiter) {

                      switch (delimiter) {
                          case '\t'   :
                              return this.parseTabData(result)
                          case ','    :
                              return parseCSV(result)
                      }
                  }

              }

          }

          return undefined
      }

      parseTabData(str, filter) {

          const dataWrapper = getDataWrapper(str);

          const headerLine = dataWrapper.nextLine();  // Skip header
          const headers = headerLine.split('\t');

          const records = [];
          let line;

          while (line = dataWrapper.nextLine()) {

              const record = {};

              const tokens = line.split(`\t`);
              if (tokens.length !== headers.length) {
                  throw Error("Number of values must equal number of headers in file " + this.url)
              }

              for (let i = 0; i < headers.length; i++) {
                  record[headers[i]] = tokens[i];
              }

              if (undefined === filter || filter(record)) {
                  records.push(record);
              }

          } // while(line)

          return records
      }

      static getExtension(url) {

          const path = (url instanceof File) ? url.name : url;

          // Strip parameters (handles Dropbox URLs)
          let filename = path.toLowerCase();

          let index;

          index = filename.indexOf('?');
          if (index > 0) {
              filename = filename.substr(0, index);
          }

          index = filename.lastIndexOf(".");
          return index < 0 ? filename : filename.substr(1 + index)
      }

  }

  function getDelimiter(data, delimiter) {
      return delimiter || getDelimiterForExtension(GenericDataSource.getExtension(data))

  }

  function getDelimiterForExtension(extension) {
      switch (extension) {
          case 'tab' :
              return '\t'
          case 'csv' :
              return ','
          default:
              return undefined
      }
  }

  function parseCSV(str) {

      const list = str.split('\n');
      const keys = list.shift().split(',').map(key => key.trim());

      return list.map(line => {
          const keyValues = line.split(',').map((value, index) => [keys[index], value.trim()]);
          return Object.fromEntries(new Map(keyValues))
      })

  }

  class ModalTable {

      constructor(args) {

          this.datasource = args.datasource;
          this.okHandler = args.okHandler;

          this.pageLength = args.pageLength || 10;

          if (args.selectionStyle) {
              this.select = {style: args.selectionStyle};
          } else {
              this.select = true;
          }

          const id = args.id;
          const title = args.title || '';
          const parent = args.parent ? $(args.parent) : $('body');
          const html = `
        <div id="${id}" class="modal fade">
        
            <div class="modal-dialog modal-xl">
        
                <div class="modal-content">
        
                    <div class="modal-header">
                        <div class="modal-title">${title}</div>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
        
                    <div class="modal-body">
        
                        <div id="${id}-spinner" class="spinner-border" style="display: none;">
                            <!-- spinner -->
                        </div>
        
                        <div id="${id}-datatable-container">
        
                        </div>
                        
                        <!-- description -->
                        <div>
                        </div>
                    </div>
        
                    <div class="modal-footer">
                        <button type="button" class="btn btn-sm btn-outline-secondary" data-dismiss="modal">Cancel</button>
                        <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">OK</button>
                    </div>
        
                </div>
        
            </div>
        
        </div>
    `;
          const $m = $(html);
          parent.append($m);

          this.$modal = $m;
          this.$datatableContainer = $m.find(`#${id}-datatable-container`);
          this.$spinner = $m.find(`#${id}-spinner`);
          const $okButton = $m.find('.modal-footer button:nth-child(2)');

          $m.on('shown.bs.modal', (e) => {
              this.buildTable();
          });

          $m.on('hidden.bs.modal', (e) => {
              $(e.relatedTarget).find('tr.selected').removeClass('selected');
          });

          $okButton.on('click', (e) => {
              const selected = this.getSelectedTableRowsData.call(this, this.$dataTable.$('tr.selected'));
              if (selected && this.okHandler) {
                  this.okHandler(selected);
              }
          });
      }

      setTitle(title) {
          this.$modal.find('.modal-title').text(`${ title }`);
      }

      setDescription(description) {
          this.$modal.find('.modal-body').children().last().html(`${ description }`);
      }

      remove() {
          this.$modal.remove();
      }

      setDatasource(datasource) {
          this.datasource = datasource;
          this.$datatableContainer.empty();
          this.$table = undefined;
      }

      async buildTable() {

          if (!this.$table && this.datasource) {

              this.$table = $('<table class="display"></table>');
              this.$datatableContainer.append(this.$table);

              try {
                  this.startSpinner();

                  const tableData = await this.datasource.tableData();
                  const tableColumns = await this.datasource.tableColumns();
                  const columnDefs = this.datasource.columnDefs;
                  const config =
                      {
                          data: tableData,
                          columns: tableColumns.map(c => {
                              if (columnDefs && columnDefs[c]) {
                                  return Object.assign({}, columnDefs[c], {data: c});
                              } else {
                                  return {title: c, data: c}
                              }
                          }),
                          pageLength: this.pageLength,
                          select: this.select,
                          autoWidth: false,
                          paging: true,
                          scrollX: true,
                          scrollY: '400px',
                      };


                  // API object
                  this.api = this.$table.DataTable(config);

                  // Preserve sort order. For some reason it gets garbled by default
                  // this.api.column( 0 ).data().sort().draw();

                  // Adjust column widths
                  this.api.columns.adjust().draw();

                  // jQuery object
                  this.$dataTable = this.$table.dataTable();

                  this.tableData = tableData;


              } catch (e) {

              } finally {
                  this.stopSpinner();
              }
          }
      }

      getSelectedTableRowsData($rows) {
          const tableData = this.tableData;
          const result = [];
          if ($rows.length > 0) {
              $rows.removeClass('selected');
              const api = this.$table.api();
              $rows.each(function () {
                  const index = api.row(this).index();
                  result.push(tableData[index]);
              });
              if (typeof this.datasource.rowHandler === 'function') {

                  const config = result.map(row => {
                      const thang = this.datasource.rowHandler(row);
                      const filteredKeys = Object.keys(row).filter(key => this.datasource.columns.includes(key));
                      thang.metadata = {};
                      for (let key of filteredKeys) {
                          thang.metadata[ key ] = row[ key ];
                      }
                      return thang
                  });

                  return config
              } else {
                  return result;
              }
          } else {
              return undefined;
          }
      }

      startSpinner() {
          if (this.$spinner)
              this.$spinner.show();
      }

      stopSpinner() {
          if (this.$spinner)
              this.$spinner.hide();
      }

  }

  /**
   * Factory function to create a configuration object for the EncodeTrackDatasource given a genomicId and type
   * @param genomeId
   * @param type - 'signals' | 'other
   * @returns {{genomeId: *, selectionHandler: (function(*): *|Uint8Array|BigInt64Array|{color, name, url}[]|Float64Array|Int8Array|Float32Array|Int32Array|Uint32Array|Uint8ClampedArray|BigUint64Array|Int16Array|Uint16Array), hiddenColumns: [string, string, string], addIndexColumn: boolean, parser: undefined, isJSON: boolean, urlPrefix: string, columns: string[], dataSetPath: undefined, titles: {AssayType: string, BioRep: string, OutputType: string, TechRep: string}, suffix: *, dataSetPathPrefix: string}}
   */
  function encodeTrackDatasourceConfigurator(genomeId, type) {

      const root = 'https://s3.amazonaws.com/igv.org.app/encode/';
      let url;

      switch (type) {
          case 'signals-chip':
              url = `${root}${canonicalId(genomeId)}.signals.chip.txt`;
              break
          case 'signals-other':
              url = `${root}${canonicalId(genomeId)}.signals.other.txt`;
              break
          case 'other':
              url = `${root}${canonicalId(genomeId)}.other.txt`;
              break

      }

      return {
          isJSON: false,
          url,
          sort: encodeSort,
          columns:
              [
                  //'ID',           // hide
                  //'Assembly',     // hide
                  'Biosample',
                  'AssayType',
                  'Target',
                  'BioRep',
                  'TechRep',
                  'OutputType',
                  'Format',
                  'Lab',
                  //'HREF',         // hide
                  'Accession',
                  'Experiment'
              ],
          columnDefs:
              {
                  AssayType: {title: 'Assay Type'},
                  OutputType: {title: 'Output Type'},
                  BioRep: {title: 'Bio Rep'},
                  TechRep: {title: 'Tech Rep'}
              },

          rowHandler: row => {
              const name = constructName(row);
              const url = `https://www.encodeproject.org${row['HREF']}`;
              const color = colorForTarget(row['Target']);
              return {name, url, color}
          }

      }
  }


  function supportsGenome(genomeId) {
      const knownGenomes = new Set(["ce10", "ce11", "dm3", "dm6", "GRCh38", "hg19", "mm9", "mm10"]);
      const id = canonicalId(genomeId);
      return knownGenomes.has(id)
  }


  function canonicalId(genomeId) {

      switch (genomeId) {
          case "hg38":
              return "GRCh38"
          case "CRCh37":
              return "hg19"
          case "GRCm38":
              return "mm10"
          case "NCBI37":
              return "mm9"
          case "WBcel235":
              return "ce11"
          case "WS220":
              return "ce10"
          default:
              return genomeId
      }
  }

  function constructName(record) {

      let name = record["Biosample"] || "";

      if (record["Target"]) {
          name += " " + record["Target"];
      }
      if (record["AssayType"].toLowerCase() !== "chip-seq") {
          name += " " + record["AssayType"];
      }


      return name

  }


  function encodeSort(a, b) {
      var aa1,
          aa2,
          cc1,
          cc2,
          tt1,
          tt2;

      aa1 = a['Assay Type'];
      aa2 = b['Assay Type'];
      cc1 = a['Biosample'];
      cc2 = b['Biosample'];
      tt1 = a['Target'];
      tt2 = b['Target'];

      if (aa1 === aa2) {
          if (cc1 === cc2) {
              if (tt1 === tt2) {
                  return 0;
              } else if (tt1 < tt2) {
                  return -1;
              } else {
                  return 1;
              }
          } else if (cc1 < cc2) {
              return -1;
          } else {
              return 1;
          }
      } else {
          if (aa1 < aa2) {
              return -1;
          } else {
              return 1;
          }
      }
  }

  function colorForTarget(target) {

      const t = target.toLowerCase();
      if (t.startsWith("h3k4")) {
          return "rgb(0,150,0)"
      } else if (t.startsWith("h3k27")) {
          return "rgb(200,0,0)"
      } else if (t.startsWith("h3k36")) {
          return "rgb(0,0,150)"
      } else if (t.startsWith("h3k9")) {
          return "rgb(100,0,0)"
      } else if (t === "ctcf") {
          return "black"
      } else {
          return undefined;
      }
  }

  function createGenericSelectModal(id, select_id) {

      return `<div id="${id}" class="modal">

                <div class="modal-dialog modal-lg">
    
                    <div class="modal-content">
    
                        <div class="modal-header">
                            <div class="modal-title"></div>
                            <button type="button" class="close" data-dismiss="modal">
                                <span>&times;</span>
                            </button>
                        </div>
            
                        <div class="modal-body">
                            <div class="form-group">
                                <select id="${select_id}" class="form-control" multiple></select>
                            </div>
                            <div id="igv-widgets-generic-select-modal-footnotes"></div>
                        </div>
                        
                        <div class="modal-footer">
                            <button type="button" class="btn btn-sm btn-outline-secondary" data-dismiss="modal">Cancel</button>
                            <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">OK</button>
                        </div>
    
                    </div>
    
                </div>

            </div>`;

  }

  const createTrackURLModal = id => {

      const html =
          `<div id="${ id }" class="modal">

            <div class="modal-dialog modal-lg">
    
                <div class="modal-content">
    
                    <div class="modal-header">
                        <div class="modal-title">Track URL</div>
    
                        <button type="button" class="close" data-dismiss="modal">
                            <span>&times;</span>
                        </button>
    
                    </div>
    
                    <div class="modal-body">
                    </div>
    
                    <div class="modal-footer">
                        <button type="button" class="btn btn-sm btn-outline-secondary" data-dismiss="modal">Cancel</button>
                        <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">OK</button>
                    </div>
    
                </div>
    
            </div>

        </div>`;

      const fragment = document.createRange().createContextualFragment(html);

      return fragment.firstChild;

  };

  let fileLoadWidget$2;
  let multipleTrackFileLoad;
  let encodeModalTables = [];
  let customModalTable;
  let $genericSelectModal = undefined;

  const defaultCustomModalTableConfig =
      {
          // id: modalID,
          // title: 'ENCODE',
          selectionStyle: 'multi',
          pageLength: 100
      };

  function createTrackWidgetsWithTrackRegistry($igvMain,
                                               $dropdownMenu,
                                               $localFileInput,
                                               initializeDropbox,
                                               $dropboxButton,
                                               googleEnabled,
                                               $googleDriveButton,
                                               encodeTrackModalIds,
                                               urlModalId,
                                               selectModalIdOrUndefined,
                                               GtexUtilsOrUndefined,
                                               trackRegistryFile,
                                               trackLoadHandler) {

      const urlModal = createTrackURLModal(urlModalId);
      $igvMain.get(0).appendChild(urlModal);

      let fileLoadWidgetConfig =
          {
              widgetParent: urlModal.querySelector('.modal-body'),
              dataTitle: 'Track',
              indexTitle: 'Index',
              mode: 'url',
              fileLoadManager: new FileLoadManager(),
              dataOnly: false,
              doURL: true
          };

      fileLoadWidget$2 = new FileLoadWidget(fileLoadWidgetConfig);

      configureModal(fileLoadWidget$2, urlModal, async fileLoadWidget => {
          const paths = fileLoadWidget.retrievePaths();
          await multipleTrackFileLoad.loadPaths(paths);
          return true;
      });

      if ($googleDriveButton && !googleEnabled) {
          $googleDriveButton.parent().hide();
      }

      const multipleTrackFileLoadConfig =
          {
              $localFileInput,
              initializeDropbox,
              $dropboxButton,
              $googleDriveButton: googleEnabled ? $googleDriveButton : undefined,
              fileLoadHandler: trackLoadHandler,
              multipleFileSelection: true
          };

      multipleTrackFileLoad = new MultipleTrackFileLoad(multipleTrackFileLoadConfig);

      for (let modalID of encodeTrackModalIds) {

          const encodeModalTableConfig =
              {
                  id: modalID,
                  title: 'ENCODE',
                  selectionStyle: 'multi',
                  pageLength: 100,
                  okHandler: trackLoadHandler
              };

          encodeModalTables.push(new ModalTable(encodeModalTableConfig));

      }

      customModalTable = new ModalTable({ id: 'igv-custom-modal', title: 'UNTITLED', okHandler: trackLoadHandler, ...defaultCustomModalTableConfig });

      if (selectModalIdOrUndefined) {

          $genericSelectModal = $(createGenericSelectModal(selectModalIdOrUndefined, `${selectModalIdOrUndefined}-select`));

          $igvMain.append($genericSelectModal);
          const $select = $genericSelectModal.find('select');

          const $dismiss = $genericSelectModal.find('.modal-footer button:nth-child(1)');
          $dismiss.on('click', () => $genericSelectModal.modal('hide'));

          const $ok = $genericSelectModal.find('.modal-footer button:nth-child(2)');

          const okHandler = () => {

              const configurations = [];
              const $selectedOptions = $select.find('option:selected');
              $selectedOptions.each(function () {
                  //console.log(`You selected ${$(this).val()}`);
                  configurations.push($(this).data('track'));
                  $(this).removeAttr('selected');
              });

              if (configurations.length > 0) {
                  trackLoadHandler(configurations);
              }

              $genericSelectModal.modal('hide');

          };

          $ok.on('click', okHandler);

          $genericSelectModal.get(0).addEventListener('keypress', event => {
              if ('Enter' === event.key) {
                  okHandler();
              }
          });

      }

  }

  async function updateTrackMenus(genomeID, GtexUtilsOrUndefined, trackRegistryFile, $dropdownMenu) {

      const id_prefix = 'genome_specific_';

      const $divider = $dropdownMenu.find('.dropdown-divider');

      const searchString = '[id^=' + id_prefix + ']';
      const $found = $dropdownMenu.find(searchString);
      $found.remove();

      const paths = await getPathsWithTrackRegistryFile(genomeID, trackRegistryFile);

      if (undefined === paths) {
          console.warn(`There are no tracks in the track registry for genome ${genomeID}`);
          return;
      }

      let responses = [];
      try {
          responses = await Promise.all(paths.map(path => fetch(path)));
      } catch (e) {
          AlertSingleton$1.present(e.message);
      }

      let jsons = [];
      try {
          jsons = await Promise.all(responses.map(response => response.json()));
      } catch (e) {
          AlertSingleton$1.present(e.message);
      }

      let buttonConfigurations = [];

      for (let json of jsons) {

          if (true === supportsGenome(genomeID) && 'ENCODE' === json.type) {
              encodeModalTables[0].setDatasource(new GenericDataSource(encodeTrackDatasourceConfigurator(genomeID, 'signals-chip')));
              encodeModalTables[1].setDatasource(new GenericDataSource(encodeTrackDatasourceConfigurator(genomeID, 'signals-other')));
              encodeModalTables[2].setDatasource(new GenericDataSource(encodeTrackDatasourceConfigurator(genomeID, 'other')));
          } else if (GtexUtilsOrUndefined && 'GTEX' === json.type) {

              let info = undefined;
              try {
                  info = await GtexUtilsOrUndefined.getTissueInfo(json.datasetId);
              } catch (e) {
                  AlertSingleton$1.present(e.message);
              }

              if (info) {
                  json.tracks = info.tissueInfo.map(tissue => GtexUtilsOrUndefined.trackConfiguration(tissue));
              }

          }

          buttonConfigurations.push(json);

      } // for(jsons)

      for (let buttonConfiguration of buttonConfigurations.reverse()) {

          if (buttonConfiguration.type && 'custom-data-modal' === buttonConfiguration.type) {

              if (buttonConfiguration.description) {
                  customModalTable.setDescription(buttonConfiguration.description);
              }

              createDropdownButton($divider, buttonConfiguration.label, id_prefix)
                  .on('click', () => {
                      customModalTable.setDatasource(new GenericDataSource(buttonConfiguration));
                      customModalTable.setTitle(buttonConfiguration.label);
                      customModalTable.$modal.modal('show');
                  });

          } else if (buttonConfiguration.type && 'ENCODE' === buttonConfiguration.type) {

              if (true === supportsGenome(genomeID)) {

                  if (buttonConfiguration.description) {
                      encodeModalTables[0].setDescription(buttonConfiguration.description);
                      encodeModalTables[1].setDescription(buttonConfiguration.description);
                      encodeModalTables[2].setDescription(buttonConfiguration.description);
                  }

                  createDropdownButton($divider, 'ENCODE Other', id_prefix)
                      .on('click', () => encodeModalTables[2].$modal.modal('show'));

                  createDropdownButton($divider, 'ENCODE Signals - Other', id_prefix)
                      .on('click', () => encodeModalTables[1].$modal.modal('show'));

                  createDropdownButton($divider, 'ENCODE Signals - ChIP', id_prefix)
                      .on('click', () => encodeModalTables[0].$modal.modal('show'));

              }

          } else if ($genericSelectModal) {

              createDropdownButton($divider, buttonConfiguration.label, id_prefix)
                  .on('click', () => {
                      configureSelectModal($genericSelectModal, buttonConfiguration);
                      $genericSelectModal.modal('show');
                  });

          }
      } // for (buttonConfigurations)

  }

  function createDropdownButton($divider, buttonText, id_prefix) {
      const $button = $('<button>', {class: 'dropdown-item', type: 'button'});
      $button.text(`${buttonText} ...`);
      $button.attr('id', `${id_prefix}${buttonText.toLowerCase().split(' ').join('_')}`);
      $button.insertAfter($divider);
      return $button
  }

  function configureSelectModal($genericSelectModal, buttonConfiguration) {

      $genericSelectModal.find('.modal-title').text(`${buttonConfiguration.label}`);

      let $select = $genericSelectModal.find('select');
      $select.empty();

      buttonConfiguration.tracks.reduce(($accumulator, configuration) => {

          const $option = $('<option>', {value: configuration.name, text: configuration.name});
          $select.append($option);

          $option.data('track', configuration);

          $accumulator.append($option);

          return $accumulator;
      }, $select);

      if (buttonConfiguration.description) {
          $genericSelectModal.find('#igv-widgets-generic-select-modal-footnotes').html(buttonConfiguration.description);
      }

  }

  async function getPathsWithTrackRegistryFile(genomeID, trackRegistryFile) {

      let response = undefined;
      try {
          response = await fetch(trackRegistryFile);
      } catch (e) {
          console.error(e);
      }

      let trackRegistry = undefined;
      if (response) {
          trackRegistry = await response.json();
      } else {
          const e = new Error("Error retrieving registry via getPathsWithTrackRegistryFile()");
          AlertSingleton$1.present(e.message);
          throw e;
      }

      return trackRegistry[genomeID]

  }

  const dropboxButtonImageLiteral =
      `<svg width="75px" height="64px" viewBox="0 0 75 64" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
        <title>Shape</title>
        <desc>Created with Sketch.</desc>
        <defs></defs>
        <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
            <g id="dropbox" fill="#0061FF" fill-rule="nonzero">
                <path d="M37.6,12 L18.8,24 L37.6,36 L18.8,48 L1.42108547e-14,35.9 L18.8,23.9 L1.42108547e-14,12 L18.8,0 L37.6,12 Z M18.7,51.8 L37.5,39.8 L56.3,51.8 L37.5,63.8 L18.7,51.8 Z M37.6,35.9 L56.4,23.9 L37.6,12 L56.3,0 L75.1,12 L56.3,24 L75.1,36 L56.3,48 L37.6,35.9 Z" id="Shape"></path>
            </g>
        </g>
    </svg>`;

  const googleDriveImageLiteral =
      `<svg viewBox="0 0 139 120.4" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><radialGradient id="a" cx="-254.81979" cy="705.83588" gradientTransform="matrix(2.827 1.6322 -1.6322 2.827 2092.1199 -1494.5786)" gradientUnits="userSpaceOnUse" r="82.978401"><stop offset="0" stop-color="#4387fd"/><stop offset=".65" stop-color="#3078f0"/><stop offset=".9099" stop-color="#2b72ea"/><stop offset="1" stop-color="#286ee6"/></radialGradient><radialGradient id="b" cx="-254.8174" cy="705.83691" gradientTransform="matrix(2.827 1.6322 -1.6322 2.827 2092.1199 -1494.5786)" gradientUnits="userSpaceOnUse" r="82.973"><stop offset="0" stop-color="#ffd24d"/><stop offset="1" stop-color="#f6c338"/></radialGradient><path d="m24.2 120.4-24.2-41.9 45.3-78.5 24.2 41.9z" fill="#0da960"/><path d="m24.2 120.4 24.2-41.9h90.6l-24.2 41.9z" fill="url(#a)"/><path d="m139 78.5h-48.4l-45.3-78.5h48.4z" fill="url(#b)"/><path d="m69.5 78.5h-21.1l10.5-18.3-34.7 60.2z" fill="#2d6fdd"/><path d="m90.6 78.5h48.4l-58.9-18.3z" fill="#e5b93c"/><path d="m58.9 60.2 10.6-18.3-24.2-41.9z" fill="#0c9b57"/></svg>`;

  const dropboxButtonImageBase64 = () => window.btoa(dropboxButtonImageLiteral);

  const googleDriveButtonImageBase64 = () => window.btoa(googleDriveImageLiteral);

  const dropboxDropdownItem = id => {

      return `<div class="dropdown-item">
                <div id="${ id }" class="igv-app-dropdown-item-cloud-storage">
                    <div>Dropbox File</div>
                    <div>
                        <img src="data:image/svg+xml;base64,${ dropboxButtonImageBase64() }" width="18" height="18">
                    </div>
                </div>
            </div>`
  };

  const googleDriveDropdownItem = id => {

      return `<div class="dropdown-item">
                <div id="${ id }" class="igv-app-dropdown-item-cloud-storage">
                    <div>Google Drive File</div>
                    <div>
                        <img src="data:image/svg+xml;base64,${ googleDriveButtonImageBase64() }" width="18" height="18">
                    </div>
                </div>
            </div>`
  };

  function embedCSS() {

      var css =  '.igv-widgets-alert-dialog-container {\n  box-sizing: content-box;\n  position: absolute;\n  z-index: 2048;\n  top: 50%;\n  left: 50%;\n  width: 400px;\n  height: 200px;\n  border-color: #7F7F7F;\n  border-radius: 4px;\n  border-style: solid;\n  border-width: thin;\n  outline: none;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 15px;\n  font-weight: 400;\n  background-color: white;\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: space-between;\n  align-items: center; }\n  .igv-widgets-alert-dialog-container > div:first-child {\n    display: flex;\n    flex-flow: row;\n    flex-wrap: nowrap;\n    justify-content: flex-start;\n    align-items: center;\n    width: 100%;\n    height: 24px;\n    cursor: move;\n    border-top-left-radius: 4px;\n    border-top-right-radius: 4px;\n    border-bottom-color: #7F7F7F;\n    border-bottom-style: solid;\n    border-bottom-width: thin;\n    background-color: #eee; }\n    .igv-widgets-alert-dialog-container > div:first-child div:first-child {\n      padding-left: 8px; }\n  .igv-widgets-alert-dialog-container #igv-widgets-alert-dialog-body {\n    color: #373737;\n    width: 100%;\n    height: calc(100% - 24px - 64px);\n    overflow-y: scroll; }\n    .igv-widgets-alert-dialog-container #igv-widgets-alert-dialog-body #igv-widgets-alert-dialog-body-copy {\n      cursor: pointer;\n      margin: 16px;\n      width: auto;\n      height: auto;\n      overflow-wrap: break-word;\n      word-break: break-word;\n      background-color: white;\n      border: unset; }\n  .igv-widgets-alert-dialog-container > div:last-child {\n    width: 100%;\n    margin-bottom: 10px;\n    background-color: white;\n    display: flex;\n    flex-flow: row;\n    flex-wrap: nowrap;\n    justify-content: center;\n    align-items: center; }\n    .igv-widgets-alert-dialog-container > div:last-child div {\n      margin: unset;\n      width: 40px;\n      height: 30px;\n      line-height: 30px;\n      text-align: center;\n      color: white;\n      font-family: \"Open Sans\", sans-serif;\n      font-size: small;\n      font-weight: 400;\n      border-color: #2B81AF;\n      border-style: solid;\n      border-width: thin;\n      border-radius: 4px;\n      background-color: #2B81AF; }\n    .igv-widgets-alert-dialog-container > div:last-child div:hover {\n      cursor: pointer;\n      border-color: #25597f;\n      background-color: #25597f; }\n\n.igv-file-load-widget-container {\n  position: relative;\n  border-color: transparent;\n  width: 100%;\n  color: #7F7F7F;\n  font-family: \"Open Sans\", sans-serif;\n  font-size: 0.875rem;\n  font-weight: 200;\n  border-style: solid;\n  border-width: thin;\n  background-color: white;\n  display: flex;\n  flex-flow: column;\n  flex-wrap: nowrap;\n  justify-content: flex-start;\n  align-items: center; }\n  .igv-file-load-widget-container .igv-file-load-widget-header {\n    width: 100%;\n    height: 24px;\n    background-color: #bfbfbf;\n    display: flex;\n    flex-flow: row;\n    flex-wrap: nowrap;\n    justify-content: flex-end;\n    align-items: center; }\n    .igv-file-load-widget-container .igv-file-load-widget-header div {\n      height: 24px;\n      width: 16px;\n      margin-right: 6px;\n      text-align: center;\n      line-height: 24px;\n      color: #373737; }\n    .igv-file-load-widget-container .igv-file-load-widget-header div:hover {\n      cursor: pointer; }\n  .igv-file-load-widget-container .igv-flw-input-container {\n    width: 95%;\n    margin-top: 24px;\n    margin-bottom: 0;\n    display: flex;\n    flex-flow: column;\n    flex-wrap: nowrap;\n    justify-content: flex-start;\n    align-items: center; }\n    .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row {\n      height: 36px;\n      width: 100%;\n      margin-top: 8px;\n      padding-top: 4px;\n      padding-bottom: 4px;\n      display: flex;\n      flex-flow: row;\n      flex-wrap: nowrap;\n      justify-content: flex-start;\n      align-items: center;\n      border-color: white;\n      border-style: solid;\n      border-width: thin;\n      border-radius: calc(2 * 2px); }\n      .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-input-label {\n        color: #6c757c;\n        font-weight: 400;\n        width: 136px;\n        height: 36px;\n        line-height: 36px;\n        text-align: left; }\n      .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row input {\n        display: block;\n        height: 100%;\n        width: 100%;\n        padding-left: 4px;\n        color: #373737;\n        font-size: 0.875rem;\n        font-family: \"Open Sans\", sans-serif;\n        font-weight: 400;\n        text-align: left;\n        outline: none;\n        border-style: solid;\n        border-width: thin;\n        border-color: #dee2e6;\n        border-radius: .25rem;\n        background-color: white; }\n      .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row input {\n        height: calc(36px - 12px); }\n      .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-file-chooser-container {\n        display: flex;\n        flex-flow: row;\n        justify-content: center;\n        align-items: center;\n        width: 130px;\n        height: calc(36px - 8px);\n        border-color: #6c757c;\n        border-style: solid;\n        border-width: thin;\n        border-radius: calc(2 * 2px);\n        background-color: white; }\n        .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-file-chooser-container label {\n          display: block;\n          margin: unset; }\n        .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-file-chooser-container label.igv-flw-label-color {\n          color: #6c757c; }\n        .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-file-chooser-container label.igv-flw-label-color-hover {\n          cursor: pointer; }\n        .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-file-chooser-container input.igv-flw-file-chooser-input {\n          width: 0.1px;\n          height: 0.1px;\n          opacity: 0;\n          overflow: hidden;\n          position: absolute;\n          z-index: -1; }\n      .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-file-chooser-container:hover {\n        cursor: pointer;\n        background-color: #6c757c; }\n      .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-drag-drop-target {\n        cursor: default;\n        margin-left: 8px;\n        width: 120px;\n        height: calc(36px - 8px);\n        line-height: calc(36px - 8px);\n        text-align: center;\n        border-color: #7F7F7F;\n        border-style: dashed;\n        border-width: thin;\n        border-radius: calc(2 * 2px); }\n      .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row .igv-flw-local-file-name-container {\n        max-width: 400px;\n        height: 36px;\n        color: #373737;\n        line-height: 36px;\n        text-align: left;\n        font-weight: 400;\n        margin-left: 8px;\n        white-space: nowrap;\n        overflow: hidden;\n        text-overflow: ellipsis; }\n    .igv-file-load-widget-container .igv-flw-input-container .igv-flw-input-row-hover-state {\n      background-color: #efefef;\n      border-color: #7F7F7F; }\n  .igv-file-load-widget-container .igv-flw-error-message-container {\n    margin-top: 8px;\n    width: 95%;\n    height: 24px;\n    padding-left: 8px;\n    color: white;\n    font-size: 0.875rem;\n    background-color: rgba(59, 92, 127, 0.5);\n    display: flex;\n    flex-flow: row;\n    flex-wrap: nowrap;\n    justify-content: space-between;\n    align-items: center; }\n    .igv-file-load-widget-container .igv-flw-error-message-container div:first-child.igv-flw-error-message {\n      height: 24px;\n      width: 600px;\n      font-style: italic;\n      line-height: 24px;\n      text-align: left; }\n    .igv-file-load-widget-container .igv-flw-error-message-container div:last-child {\n      height: 24px;\n      width: 16px;\n      margin-right: 6px;\n      text-align: center;\n      line-height: 24px;\n      color: #373737; }\n    .igv-file-load-widget-container .igv-flw-error-message-container div:hover {\n      cursor: pointer; }\n  .igv-file-load-widget-container .igv-file-load-widget-ok-cancel {\n    width: 100%;\n    height: 28px;\n    margin-top: 32px;\n    color: white;\n    font-size: 0.875rem;\n    display: flex;\n    flex-flow: row;\n    flex-wrap: nowrap;\n    justify-content: flex-end;\n    align-items: center; }\n    .igv-file-load-widget-container .igv-file-load-widget-ok-cancel div {\n      width: 75px;\n      height: 28px;\n      line-height: 28px;\n      text-align: center;\n      border-color: transparent;\n      border-style: solid;\n      border-width: thin;\n      border-radius: 2px;\n      margin-right: 16px; }\n    .igv-file-load-widget-container .igv-file-load-widget-ok-cancel div:first-child {\n      margin-right: 22px;\n      background-color: #c4c4c4; }\n    .igv-file-load-widget-container .igv-file-load-widget-ok-cancel div:first-child:hover {\n      cursor: pointer;\n      background-color: #7f7f7f; }\n    .igv-file-load-widget-container .igv-file-load-widget-ok-cancel div:last-child {\n      background-color: #5ea4e0; }\n    .igv-file-load-widget-container .igv-file-load-widget-ok-cancel div:last-child:hover {\n      cursor: pointer;\n      background-color: #3b5c7f; }\n\n/*# sourceMappingURL=igv-widgets.css.map */\n';

      var style = document.createElement('style');
      style.setAttribute('type', 'text/css');
      style.innerHTML = css;

      document.head.insertBefore(style, document.head.childNodes[ document.head.childNodes.length - 1 ]);

  }

  if(typeof document !== 'undefined') {
      if (!stylesheetExists("igv-widgets.css")) {
          //console.log('igv-widgets. will call embedCSS(igv-widgets.css) ...');
          embedCSS();
          //console.log('... done.');
      }
      function stylesheetExists(stylesheetName) {
          for (let ss of document.styleSheets) {
              ss = ss.href ? ss.href.replace(/^.*[\\\/]/, '') : '';
              if (ss === stylesheetName) {
                  return true;
              }
          }
          return false;
      }
  }

  const Globals = {};

  /*
   * The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   * Author: Jim Robinson
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   *
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   *
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   */

  let fileLoadWidget;

  function createGenomeWidgets({$igvMain, urlModalId, genomeFileLoad}) {

      const $urlModal = $(createURLModal(urlModalId, 'Genome URL'));
      $igvMain.append($urlModal);

      let config =
          {
              widgetParent: $urlModal.find('.modal-body').get(0),
              dataTitle: 'Genome',
              indexTitle: 'Index',
              mode: 'url',
              fileLoadManager: new FileLoadManager(),
              dataOnly: false,
              doURL: true
          };

      fileLoadWidget = new FileLoadWidget(config);

      utils.configureModal(fileLoadWidget, $urlModal.get(0), async fileLoadWidget => {

          try {
              await genomeFileLoad.loadPaths( fileLoadWidget.retrievePaths() );
          } catch (e) {
              console.error(e);
              AlertSingleton$1.present(e);
          }

      });
  }

  async function initializeGenomeWidgets(browser, genomes, $dropdown_menu) {
      try {

          const genomeMap = await getAppLaunchGenomes(genomes);

          if (genomeMap) {
              genomeDropdownLayout({ browser, genomeMap, $dropdown_menu });
          }

      } catch (e) {
          AlertSingleton$1.present(e.message);
      }
  }

  async function getAppLaunchGenomes(genomes) {

      if (undefined === genomes) {
          return undefined;
      }

      if (Array.isArray(genomes)) {
          return buildMap(genomes);
      } else {

          let response = undefined;
          try {
              response = await fetch(genomes);
          } catch (e) {
              AlertSingleton$1.present(e.message);
          }

          if (response) {
              let json = await response.json();
              return buildMap(json);
          }

      }
  }

  function buildMap(arrayOrJson) {

      const map = new Map();

      if (true === Array.isArray(arrayOrJson)) {

          for (let json of arrayOrJson.reverse()) {
              map.set(json.id, json);
          }

      } else {
          map.set(arrayOrJson.id, arrayOrJson);
      }

      return map
  }

  function genomeDropdownLayout({browser, genomeMap, $dropdown_menu}) {

      // discard all buttons preceeding the divider div
      let $divider = $dropdown_menu.find('.dropdown-divider');
      $divider.nextAll().remove();

      for (let [ key, value ] of genomeMap) {

          const $button = createButton(value.name);
          $button.insertAfter($divider);

          $button.data('id', key);

          const str = `click.genome-dropdown.${ key }`;

          $button.on(str, async () => {

              const id = $button.data('id');

              if (id !== browser.genome.id) {
                  await loadGenome(value);
              }

          });

      } // for (...)

      function createButton(title) {

          let $button = $('<button>', {class: 'dropdown-item', type: 'button'});
          $button.text(title);

          return $button;
      }

  }

  async function loadGenome(genomeConfiguration) {

      let g = undefined;
      try {
          g = await Globals.browser.loadGenome(genomeConfiguration);
          if(g.id) {
              try {
                  localStorage.setItem("genomeID", g.id);
              } catch (e) {
                  console.error(e);
              }
          }

      } catch (e) {
          console.error(e);
          AlertSingleton$1.present(e);
      }

      if (g) {
          EventBus.globalBus.post({type: "DidChangeGenome", data: g.id});
      }
  }

  /**
   * Object mimics two methods from the igvxhr interface, purpose is to break dependency on igvxhr.
   * Widgets do not need the services provided by that object *
   */

  var StringLoader = {
      loadString: async (path, options) => {
          options = options || {};
          if (path instanceof File) {
              const blob = options.range ? path.slice(options.range.start, options.range.start + options.range.size) : path;
              return blob.text()
          } else {
              const response = await fetch(path);
              return response.text()
          }
      },

      loadJson: async function (url, options) {
          const result = await this.loadString(url, options);
          if (result) {
              return JSON.parse(result)
          } else {
              return result
          }
      }
  };

  function bitlyShortener(accessToken) {

      if (!accessToken || accessToken === "BITLY_TOKEN") {
          return undefined
      } else {
          return async function (url) {
              const api = "https://api-ssl.bitly.com/v3/shorten";
              const devIP = "192.168.1.11";
              if (url.startsWith("http://localhost")) {
                  url = url.replace("localhost", devIP);
              }  // Dev hack
              let endpoint = api + "?access_token=" + accessToken + "&longUrl=" + encodeURIComponent(url);
              return StringLoader.loadJson(endpoint, {})
                  .then(function (json) {
                      return json.data.url
                  })
          }
      }

  }

  function googleShortener(apiKey) {
      if (!apiKey || apiKey === "API_KEY") {
          return undefined
      } else {
          return async function (url) {
              const api = "https://www.googleapis.com/urlshortener/v1/url";
              const endpoint = api + "?key=" + apiKey;
              return StringLoader
                  .loadJson(endpoint, {sendData: JSON.stringify({"longUrl": url}), contentType: "application/json"})
                  .then(function (json) {
                      return json.id
                  })
          }
      }
  }

  function tinyURLShortener({endpoint}) {
      endpoint = endpoint || "https://2et6uxfezb.execute-api.us-east-1.amazonaws.com/dev/tinyurl/";
      return async function (url) {
          const enc = encodeURIComponent(url);
          const response = await fetch(`${endpoint}${enc}`);
          if (response.ok) {
              return response.text()
          } else {
              throw new Error(response.statusText)
          }
      }
  }

  /*
   *  The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
   * associated documentation files (the "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
   * following conditions:
   *
   * The above copyright notice and this permission notice shall be included in all copies or substantial
   * portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
   * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND
   * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
   * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   *
   */

  let urlShortener;

  function setURLShortener(obj) {

      let fn;
      if (typeof obj === "function") {
          fn = obj;

      } else if (obj.provider) {
          if ("tinyURL" === obj.provider) {
              fn = tinyURLShortener(obj);
          } else if ("bitly" === obj.provider && obj.apiKey) {
              fn = bitlyShortener(obj.apiKey);
          } else if ("google" === obj.provider && obj.apiKey) {
              fn = googleShortener(obj.apiKey);
          } else {
              AlertSingleton$1.present(new Error(`Unknown URL shortener provider: ${obj.provider}`));
          }
      } else {
          AlertSingleton$1.present(new Error('URL shortener object must either be an object specifying a provider and apiKey, or a function'));
      }

      if (fn) {
          urlShortener =
              {
                  shortenURL: fn
              };
      }

      return fn;

  }

  function sessionURL() {

      let surl,
          path,
          idx;

      path = window.location.href.slice();
      idx = path.indexOf("?");

      surl = (idx > 0 ? path.substring(0, idx) : path) + "?sessionURL=blob:" + Globals.browser.compressedSession();

      return surl;
  }

  function shortSessionURL(base, session) {

      const url = base + "?sessionURL=blob:" + session;

      return shortenURL(url)

  }

  function shortenURL(url) {
      if (urlShortener) {
          return urlShortener.shortenURL(url);
      } else {
          return Promise.resolve(url);
      }
  }

  /*
   *  The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
   * associated documentation files (the "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
   * following conditions:
   *
   * The above copyright notice and this permission notice shall be included in all copies or substantial
   * portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
   * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND
   * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
   * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   *
   */

  function createShareWidgets({browser, container, modal, share_input, copy_link_button, tweet_button_container, email_button, qrcode_button, qrcode_image, embed_container, embed_button, embedTarget}) {

      if (undefined === embedTarget) {
          embedTarget = `https://igv.org/web/release/${index.version()}/embed.html`;
      }

      $(modal).on('shown.bs.modal', async () => {

          let href = window.location.href.slice();
          const idx = href.indexOf("?");
          if (idx > 0) {
              href = href.substring(0, idx);
          }

          let session = undefined;
          try {
              session = browser.compressedSession();
          } catch (e) {
              AlertSingleton$1.present(e.message);
          }

          if (session) {

              if (embedTarget) {
                  const snippet = getEmbeddableSnippet(container, embedTarget, session);
                  const textArea = embed_container.querySelector('textarea');
                  textArea.value = snippet;
                  textArea.select();
              }

              const shortURL = await shortSessionURL(href, session);

              share_input.value = shortURL;
              share_input.select();
              email_button.setAttribute('href', `mailto:?body=${ shortURL }`);

              qrcode_image.innerHTML = '';
              const qrcode = new QRCode(qrcode_image, { width: 128, height: 128, correctLevel: QRCode.CorrectLevel.H });
              qrcode.makeCode(shortURL);

              if (tweet_button_container) {
                  tweet_button_container.innerHTML = '';
                  window.twttr.widgets.createShareButton(shortURL, tweet_button_container, { text: '' });
              }
          } else {
              $(modal).modal('hide');
          }

      });

      $(modal).on('hidden.bs.modal', () => {
          embed_container.style.display = 'none';
          qrcode_image.style.display = 'none';
      });

      copy_link_button.addEventListener('click', () => {
          share_input.select();
          const success = document.execCommand('copy');
          if (success) {
              $(modal).modal('hide');
          } else {
              console.error('fail!');
          }
      });


      if (undefined === embedTarget) {
          embed_button.style.display = 'none';
      } else {
          const button = embed_container.querySelector('button');
          button.addEventListener('click', () => {

              const textArea = embed_container.querySelector('textarea');
              textArea.select();

              const success = document.execCommand('copy');

              if (success) {
                  $(modal).modal('hide');
              } else {
                  console.error('fail!');
              }
          });

          embed_button.addEventListener('click', () => {

              qrcode_image.style.display = 'none';

              if ('block' === embed_container.style.display) {
                  embed_container.style.display = 'none';
              } else {
                  embed_container.style.display = 'block';
              }

          });
      }

      qrcode_button.addEventListener('click', () => {

          embed_container.style.display = 'none';

          if ('block' === qrcode_image.style.display) {
              qrcode_image.style.display = 'none';
          } else {
              qrcode_image.style.display = 'block';
          }

      });

  }

  function getEmbeddableSnippet(container, embedTarget, session) {
      const embedUrl = `${ embedTarget }?sessionURL=blob:${ session }`;
      const height = container.clientHeight + 50;
      return '<iframe src="' + embedUrl + '" style="width:100%; height:' + height + 'px"  allowfullscreen></iframe>';
  }

  function shareWidgetConfigurator(browser, container, {urlShortener, embedTarget}) {

      let urlShortenerFn;

      if (urlShortener) {
          urlShortenerFn = setURLShortener(urlShortener) !== undefined;
      }

      let igv_app_tweet_button_container = document.getElementById('igv-app-tweet-button-container');
      if (!urlShortenerFn) {
          igv_app_tweet_button_container.style.display = 'none';
      }

      return {
          browser,
          container,
          modal: document.getElementById('igv-app-share-modal'),
          share_input: document.getElementById('igv-app-share-input'),
          copy_link_button: document.getElementById('igv-app-copy-link-button'),
          tweet_button_container: urlShortenerFn ? igv_app_tweet_button_container : undefined,
          email_button: document.getElementById('igv-app-email-button'),
          qrcode_button: document.getElementById('igv-app-qrcode-button'),
          qrcode_image: document.getElementById('igv-app-qrcode-image'),
          embed_container: document.getElementById('igv-app-embed-container'),
          embed_button: document.getElementById('igv-app-embed-button'),
          embedTarget
      };

  }

  /*
   *  The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
   * associated documentation files (the "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
   * following conditions:
   *
   * The above copyright notice and this permission notice shall be included in all copies or substantial
   * portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
   * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND
   * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
   * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   *
   */


  function createSVGWidget ({ browser, saveModal }) {

      const input_default_value = 'igv-app.svg';

      const input = saveModal.querySelector('input');

      $(saveModal).on('show.bs.modal', () => input.value = input_default_value);

      $(saveModal).on('hidden.bs.modal', () => input.value = input_default_value);

      const okHandler = () => {

          let filename = input.value;

          if (undefined === filename || '' === filename) {
              filename = input.getAttribute('placeholder');
          } else if (!filename.endsWith(".svg")) {
              filename = filename + '.svg';
          }

          // dismiss modal
          $(saveModal).modal('hide');

          browser.saveSVGtoFile({ filename });
      };

      // ok - button
      const ok = saveModal.querySelector('.modal-footer button:nth-child(2)');

      ok.addEventListener('click', okHandler);

      input.addEventListener('keyup', (e) => {
          if (13 === e.keyCode) {
              okHandler();
          }
      });

      // upper dismiss - x - button
      let dismiss = saveModal.querySelector('.modal-header button');
      dismiss.addEventListener('click', () => $(saveModal).modal('hide'));

      // lower dismiss - close - button
      dismiss = saveModal.querySelector('.modal-footer button:nth-child(1)');
      dismiss.addEventListener('click', () => $(saveModal).modal('hide'));

  }

  const GtexUtils = {

      getTissueInfo: function (datasetId, baseURL) {
          datasetId = datasetId || 'gtex_v8';
          baseURL = baseURL || 'https://gtexportal.org/rest/v1';
          let url = baseURL + '/dataset/tissueInfo?datasetId=' + datasetId;
          return StringLoader.loadJson(url, {})
      },

      //https://gtexportal.org/rest/v1/association/singleTissueEqtlByLocation?chromosome=7&start=98358766&end=101523798&tissueName=Liver&datasetId=gtex_v7
      //https://gtexportal.org/rest/v1/association/singleTissueEqtlByLocation?chromosome=7&start=98358766&end=101523798&tissueSiteDetailId=Liver&datasetId=gtex_v8
      trackConfiguration: function (tissueSummary, baseURL) {
          baseURL = baseURL || 'https://gtexportal.org/rest/v1';
          return {
              type: "eqtl",
              sourceType: "gtex-ws",
              url: baseURL + '/association/singleTissueEqtlByLocation',
              tissueSiteDetailId: tissueSummary.tissueSiteDetailId,
              name: (tissueSummary.tissueSiteDetailId.split('_').join(' ')),
              visibilityWindow: 250000
          }
      }
  };

  const _version = "1.13.2-b";
  function version() {
      return _version;
  }

  function createCircularViewResizeModal(id, title){

      const str = 'igv-app-circular-view-resize-modal';

      const html =
          `<div id="${ id }" class="modal">

            <div class="modal-dialog modal-sm">
    
                <div class="modal-content">
    
                    <div class="modal-header">
                        <div class="modal-title">${ title }</div>
    
                        <button type="button" class="close" data-dismiss="modal">
                            <span>&times;</span>
                        </button>
    
                    </div>
    
                    <div class="modal-body">
                          <div class="form-group">
                            <input id="${ str }-input" type="text" class="form-control">
                          </div>
                    </div>
        
                </div>
    
            </div>

        </div>`;

      const fragment = document.createRange().createContextualFragment(html);

      return fragment.firstChild
  }

  /*
   *  The MIT License (MIT)
   *
   * Copyright (c) 2016-2017 The Regents of the University of California
   *
   * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
   * associated documentation files (the "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
   * following conditions:
   *
   * The above copyright notice and this permission notice shall be included in all copies or substantial
   * portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
   * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND
   * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
   * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
   * THE SOFTWARE.
   *
   */

  document.addEventListener("DOMContentLoaded", async (event) => await main(document.getElementById('igv-app-container'), igvwebConfig));

  let isDropboxEnabled = false;
  let isGoogleEnabled = false;
  let currentGenomeId;
  const googleWarningFlag = "googleWarningShown";

  async function main(container, config) {

      AlertSingleton$1.init(container);

      $('#igv-app-version').text(`IGV-Web app version ${version()}`);
      $('#igv-igvjs-version').text(`igv.js version ${index.version()}`);

      const doEnableGoogle = undefined === config.clientId ? false : true;

      if (doEnableGoogle) {

          try {
              await init$2({
                  client_id: config.clientId,
                  apiKey: config.apiKey,
                  scope: 'https://www.googleapis.com/auth/userinfo.profile',
              });
              isGoogleEnabled = true;

              // Reset google warning flag on success
              localStorage.removeItem(googleWarningFlag);

          } catch (e) {
              const str = `Error initializing Google Drive: ${e.message || e.details}`;
              console.error(str);
              const googleWarning = "true" === localStorage.getItem(googleWarningFlag);
              //AlertSingleton.present(str)
              if(!googleWarning) {
                  localStorage.setItem(googleWarningFlag, "true");
                  alert(str);
              }
          }
      }

      // Load genomes for use by igv.js and webapp
      if (config.genomes) {
          config.genomes = await getGenomesArray(config.genomes);
          config.igvConfig.genomes = config.genomes;
      }

      const igvConfig = config.igvConfig;

      if (config.restoreLastGenome) {
          try {
              const lastGenomeId = localStorage.getItem("genomeID");
              if (lastGenomeId && lastGenomeId !== igvConfig.genome && config.genomes.find(elem => elem.id === lastGenomeId)) {
                  igvConfig.genome = lastGenomeId;
                  igvConfig.tracks = [];
              }
          } catch (e) {
              console.error(e);
          }
      }

      const browser = await index.createBrowser(container, igvConfig);

      if (browser) {
          Globals.browser = browser;
          await initializationHelper(browser, container, config);
      }
  }

  async function initializationHelper(browser, container, options) {

      ['track', 'genome'].forEach(str => {
          let imgElement;

          imgElement = document.querySelector(`img#igv-app-${str}-dropbox-button-image`);
          if (options.dropboxAPIKey) {
              imgElement.src = `data:image/svg+xml;base64,${dropboxButtonImageBase64()}`;
          } else {
              imgElement = document.querySelector(`#igv-app-dropdown-dropbox-${str}-file-button`);
              imgElement.parentElement.style.display = 'none';
          }

          imgElement = document.querySelector(`img#igv-app-${str}-google-drive-button-image`);
          imgElement.src = `data:image/svg+xml;base64,${googleDriveButtonImageBase64()}`;
      });

      configureGoogleSignInButton();

      if (options.dropboxAPIKey) {
          $('div#igv-session-dropdown-menu > :nth-child(1)').after(dropboxDropdownItem('igv-app-dropdown-dropbox-session-file-button'));
      }

      $('div#igv-session-dropdown-menu > :nth-child(2)').after(googleDriveDropdownItem('igv-app-dropdown-google-drive-session-file-button'));

      const $igvMain = $('#igv-main');

      const genomeFileLoadConfig =
          {
              localFileInput: document.getElementById('igv-app-dropdown-local-genome-file-input'),
              initializeDropbox,
              dropboxButton: options.dropboxAPIKey ? document.getElementById('igv-app-dropdown-dropbox-genome-file-button') : undefined,
              googleEnabled: isGoogleEnabled,
              googleDriveButton: document.getElementById('igv-app-dropdown-google-drive-genome-file-button'),
              loadHandler: async configuration => {

                  if (configuration.id !== browser.genome.id) {
                      await loadGenome(configuration);
                  }

              }
          };

      createGenomeWidgets({
          $igvMain,
          urlModalId: 'igv-app-genome-from-url-modal',
          genomeFileLoad: new GenomeFileLoad(genomeFileLoadConfig)
      });

      await initializeGenomeWidgets(browser, options.genomes, $('#igv-app-genome-dropdown-menu'));

      const trackLoader = async configurations => {
          try {
              await browser.loadTrackList(configurations);
          } catch (e) {
              console.error(e);
              AlertSingleton$1.present(e);
          }
      };

      createTrackWidgetsWithTrackRegistry($igvMain,
          $('#igv-app-track-dropdown-menu'),
          $('#igv-app-dropdown-local-track-file-input'),
          initializeDropbox,
          options.dropboxAPIKey ? $('#igv-app-dropdown-dropbox-track-file-button') : undefined,
          isGoogleEnabled,
          $('#igv-app-dropdown-google-drive-track-file-button'),
          ['igv-app-encode-signals-chip-modal', 'igv-app-encode-signals-other-modal', 'igv-app-encode-others-modal'],
          'igv-app-track-from-url-modal',
          'igv-app-track-select-modal',
          GtexUtils,
          options.trackRegistryFile,
          trackLoader);

      const sessionSaver = () => {
          try {
              return browser.toJSON()
          } catch (e) {
              console.error(e);
              AlertSingleton$1.present(e);
              return undefined
          }
      };

      const sessionLoader = async config => {
          try {
              await browser.loadSession(config);
          } catch (e) {
              console.error(e);
              AlertSingleton$1.present(e);
          }
      };

      createSessionWidgets($igvMain,
          'igv-webapp',
          'igv-app-dropdown-local-session-file-input',
          initializeDropbox,
          options.dropboxAPIKey ? 'igv-app-dropdown-dropbox-session-file-button' : undefined,
          'igv-app-dropdown-google-drive-session-file-button',
          'igv-app-session-url-modal',
          'igv-app-session-save-modal',
          isGoogleEnabled,
          sessionLoader,
          sessionSaver);

      if (options.sessionRegistryFile) {
          await createSessionMenu('igv-session-list-divider', options.sessionRegistryFile, sessionLoader);
      } else {
          document.querySelector('#igv-session-list-divider').style.display = 'none';
      }

      createSVGWidget({browser, saveModal: document.getElementById('igv-app-svg-save-modal')});

      createShareWidgets(shareWidgetConfigurator(browser, container, options));

      createAppBookmarkHandler($('#igv-app-bookmark-button'));

      const genomeChangeListener = async event => {

          const {data: genomeID} = event;

          if (currentGenomeId !== genomeID) {

              currentGenomeId = genomeID;

              await updateTrackMenus(genomeID, undefined, options.trackRegistryFile, $('#igv-app-track-dropdown-menu'));

          }
      };

      if (true === options.enableCircularView) {

          const {x: minX, y: minY} = document.querySelector('#igv-main').getBoundingClientRect();

          const circularViewContainer = document.getElementById('igv-circular-view-container');

          browser.createCircularView(circularViewContainer, false);

          makeDraggable$1(circularViewContainer, browser.circularView.toolbar, {minX, minY});

          browser.circularView.setSize(512);

          document.getElementById('igv-app-circular-view-nav-item').style.display = 'block';

          const dropdownButton = document.getElementById('igv-app-circular-view-dropdown-button');
          dropdownButton.addEventListener('click', e => {

              document.getElementById('igv-app-circular-view-presentation-button').innerText = browser.circularViewVisible ? 'Hide' : 'Show';

              if (browser.circularViewVisible) {
                  document.getElementById('igv-app-circular-view-resize-button').removeAttribute('disabled');
                  document.getElementById('igv-app-circular-view-clear-chords-button').removeAttribute('disabled');
              } else {
                  document.getElementById('igv-app-circular-view-resize-button').setAttribute('disabled', '');
                  document.getElementById('igv-app-circular-view-clear-chords-button').setAttribute('disabled', '');
              }


          });

          document.getElementById('igv-app-circular-view-presentation-button').addEventListener('click', e => {
              browser.circularViewVisible = !browser.circularViewVisible;
              const str = e.target.innerText;
              e.target.innerText = 'Show' === str ? 'Hide' : 'Show';
          });

          document.getElementById('igv-app-circular-view-clear-chords-button').addEventListener('click', () => browser.circularView.clearChords());

          document.getElementById('igv-main').appendChild(createCircularViewResizeModal('igv-app-circular-view-resize-modal', 'Resize Circular View'));

          document.getElementById('igv-app-circular-view-resize-modal-input').addEventListener('keyup', (event) => {
              event.preventDefault();
              event.stopPropagation();
              if (13 === event.keyCode) {
                  browser.circularView.setSize(Number.parseInt(event.target.value));
              }
          });

          $('#igv-app-circular-view-resize-modal').on('shown.bs.modal', () => document.getElementById('igv-app-circular-view-resize-modal-input').value = circularViewContainer.clientWidth.toString());

      }


      EventBus.globalBus.subscribe("DidChangeGenome", genomeChangeListener);

      EventBus.globalBus.post({type: "DidChangeGenome", data: browser.genome.id});
  }

  function configureGoogleSignInButton() {

      if (true === isGoogleEnabled) {

          const dropdownToggle = document.querySelector('#igv-google-drive-dropdown-toggle');
          dropdownToggle.style.display = 'block';

          const signInOutButton = document.querySelector('#igv-google-drive-sign-out-button');

          let currentUserProfile = undefined;

          $('#igv-google-drive-dropdown').on('show.bs.dropdown', async () => {

              currentUserProfile = await getCurrentUserProfile();

              if (currentUserProfile) {
                  const name = currentUserProfile.email || currentUserProfile.name || '';
                  signInOutButton.innerText = `Sign Out ${ name }`;
              } else {
                  signInOutButton.innerText = 'Sign In';
              }

          });

          signInOutButton.addEventListener('click', async () => {

              if (currentUserProfile) {
                  await signOut();
              } else {
                  await signIn();
              }

          });

      }

  }

  async function createSessionMenu(sessionListDivider, sessionRegistryFile, sessionLoader) {

      let response = undefined;
      try {
          response = await fetch(sessionRegistryFile);
      } catch (e) {
          console.error(e);
      }

      let sessionJSON = undefined;
      if (response) {
          sessionJSON = await response.json();
      } else {
          const e = new Error("Error retrieving session registry");
          AlertSingleton$1.present(e.message);
          throw e
      }

      const id_prefix = 'session_file';

      const searchString = `[id^=${id_prefix}]`;
      const elements = document.querySelectorAll(searchString);
      if (elements.length > 0) {
          for (let i = 0; i < elements.length; i++) {
              elements[i].remove();
          }
      }

      if (sessionJSON) {

          const sessions = sessionJSON['sessions'];

          for (let {name, url} of sessions.reverse()) {

              const referenceNode = document.getElementById(sessionListDivider);

              const button_id = `${id_prefix}_${guid()}`;
              const html = `<button id="${button_id}" class="dropdown-item" type="button">${name}</button>`;
              const fragment = document.createRange().createContextualFragment(html);

              referenceNode.after(fragment.firstChild);

              const button = document.getElementById(button_id);
              button.addEventListener('click', () => {

                  const config = {};
                  const key = true === isFile(url) ? 'file' : 'url';
                  config[key] = url;

                  sessionLoader(config);

              });
          }

      }

  }

  function createAppBookmarkHandler($bookmark_button) {

      $bookmark_button.on('click', (e) => {

          let url = undefined;
          try {
              url = sessionURL();
          } catch (e) {
              AlertSingleton$1.present(e.message);
          }

          if (url) {
              window.history.pushState({}, "IGV", url);

              const str = (/Mac/i.test(navigator.userAgent) ? 'Cmd' : 'Ctrl');
              const blurb = 'A bookmark URL has been created. Press ' + str + '+D to save.';
              alert(blurb);
          }
      });
  }

  async function getGenomesArray(genomes) {

      if (undefined === genomes) {
          return undefined
      }
      if (Array.isArray(genomes)) {
          return genomes
      } else {

          let response = undefined;
          try {
              response = await fetch(genomes);
              return response.json()
          } catch (e) {
              AlertSingleton$1.present(e.message);
          }
      }
  }

  let didCompleteOneAttempt = false;

  async function initializeDropbox() {

      if (true === didCompleteOneAttempt && false === isDropboxEnabled) {
          return Promise.resolve(false)
      } else if (true === isDropboxEnabled) {
          return Promise.resolve(true)
      } else {
          return new Promise((resolve, reject) => {

              didCompleteOneAttempt = true;

              const dropbox = document.createElement('script');

              // dropbox.setAttribute('src', 'http://localhost:9999');
              dropbox.setAttribute('src', 'https://www.dropbox.com/static/api/2/dropins.js');
              dropbox.setAttribute('id', 'dropboxjs');
              dropbox.dataset.appKey = igvwebConfig.dropboxAPIKey;
              dropbox.setAttribute('type', "text/javascript");

              document.head.appendChild(dropbox);

              dropbox.addEventListener('load', () => {
                  isDropboxEnabled = true;
                  resolve(true);
              });

          })
      }
  }


  function guid  () {
      return ("0000" + (Math.random() * Math.pow(36, 4) << 0).toString(36)).slice(-4);
  }

  function isFile(object) {
      if(!object) {
          return false;
      }
      return typeof object !== 'function' &&
          (object instanceof File ||
              (object.hasOwnProperty("name") && typeof object.slice === 'function' && typeof object.arrayBuffer === 'function'))
  }

  exports.main = main;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
